/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/errors","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/path","vs/platform/files/common/files","vs/platform/environment/common/environment","vs/base/common/types","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/arrays","vs/base/common/resources","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/base/common/cancellation","vs/base/common/network","vs/platform/telemetry/common/telemetry","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/uuid","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/map","vs/base/common/json","os","vs/base/common/process","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/stream","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/request/common/request","vs/base/common/jsonFormatter","vs/base/common/extpath","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/base/common/codicons","vs/base/common/iterator","fs","child_process","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/ipc/electron-sandbox/services","vs/platform/native/electron-sandbox/native","vs/platform/policy/common/policy","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncProfilesStorageService","vs/base/common/decorators","vs/base/common/date","vs/base/common/hash","vs/base/common/marshalling","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/functional","vs/base/common/jsonEdit","net","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/normalization","vs/base/common/severity","vs/base/common/glob","vs/base/node/powershell","vs/base/node/processes","vs/base/parts/ipc/common/ipc.net","electron","vs/platform/environment/common/environmentService","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/skipList","vs/base/node/macAddress","vs/base/node/ports","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/ipc/node/ipc.net","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policyIpc","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/languagePacks/node/languagePacks","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/request/common/requestIpc","vs/platform/request/electron-browser/sharedProcessRequestService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/electron-browser/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/storage/electron-sandbox/storageService","vs/platform/userDataProfile/electron-sandbox/userDataProfile","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/userDataSync/electron-sandbox/userDataSyncProfilesStorageService","vs/platform/workspaces/node/workspaces","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","util","minimist","assert","path","graceful-fs","https","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain"],re=function(Q){for(var e=[],D=0,r=Q.length;D<r;D++)e[D]=ne[Q[D]];return e};define(ne[51],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function D(T){return T?T.replace(/\$\((.*?)\)/g,(P,w)=>` ${w} `).trim():""}e.getCodiconAriaLabel=D;class r{constructor(P,w,E){this.id=P,this.definition=w,this.description=E,r._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return r._allCodicons}}e.Codicon=r,r._allCodicons=[],r.add=new r("add",{fontCharacter:"\\ea60"}),r.plus=new r("plus",r.add.definition),r.gistNew=new r("gist-new",r.add.definition),r.repoCreate=new r("repo-create",r.add.definition),r.lightbulb=new r("lightbulb",{fontCharacter:"\\ea61"}),r.lightBulb=new r("light-bulb",{fontCharacter:"\\ea61"}),r.repo=new r("repo",{fontCharacter:"\\ea62"}),r.repoDelete=new r("repo-delete",{fontCharacter:"\\ea62"}),r.gistFork=new r("gist-fork",{fontCharacter:"\\ea63"}),r.repoForked=new r("repo-forked",{fontCharacter:"\\ea63"}),r.gitPullRequest=new r("git-pull-request",{fontCharacter:"\\ea64"}),r.gitPullRequestAbandoned=new r("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),r.recordKeys=new r("record-keys",{fontCharacter:"\\ea65"}),r.keyboard=new r("keyboard",{fontCharacter:"\\ea65"}),r.tag=new r("tag",{fontCharacter:"\\ea66"}),r.tagAdd=new r("tag-add",{fontCharacter:"\\ea66"}),r.tagRemove=new r("tag-remove",{fontCharacter:"\\ea66"}),r.person=new r("person",{fontCharacter:"\\ea67"}),r.personFollow=new r("person-follow",{fontCharacter:"\\ea67"}),r.personOutline=new r("person-outline",{fontCharacter:"\\ea67"}),r.personFilled=new r("person-filled",{fontCharacter:"\\ea67"}),r.gitBranch=new r("git-branch",{fontCharacter:"\\ea68"}),r.gitBranchCreate=new r("git-branch-create",{fontCharacter:"\\ea68"}),r.gitBranchDelete=new r("git-branch-delete",{fontCharacter:"\\ea68"}),r.sourceControl=new r("source-control",{fontCharacter:"\\ea68"}),r.mirror=new r("mirror",{fontCharacter:"\\ea69"}),r.mirrorPublic=new r("mirror-public",{fontCharacter:"\\ea69"}),r.star=new r("star",{fontCharacter:"\\ea6a"}),r.starAdd=new r("star-add",{fontCharacter:"\\ea6a"}),r.starDelete=new r("star-delete",{fontCharacter:"\\ea6a"}),r.starEmpty=new r("star-empty",{fontCharacter:"\\ea6a"}),r.comment=new r("comment",{fontCharacter:"\\ea6b"}),r.commentAdd=new r("comment-add",{fontCharacter:"\\ea6b"}),r.alert=new r("alert",{fontCharacter:"\\ea6c"}),r.warning=new r("warning",{fontCharacter:"\\ea6c"}),r.search=new r("search",{fontCharacter:"\\ea6d"}),r.searchSave=new r("search-save",{fontCharacter:"\\ea6d"}),r.logOut=new r("log-out",{fontCharacter:"\\ea6e"}),r.signOut=new r("sign-out",{fontCharacter:"\\ea6e"}),r.logIn=new r("log-in",{fontCharacter:"\\ea6f"}),r.signIn=new r("sign-in",{fontCharacter:"\\ea6f"}),r.eye=new r("eye",{fontCharacter:"\\ea70"}),r.eyeUnwatch=new r("eye-unwatch",{fontCharacter:"\\ea70"}),r.eyeWatch=new r("eye-watch",{fontCharacter:"\\ea70"}),r.circleFilled=new r("circle-filled",{fontCharacter:"\\ea71"}),r.primitiveDot=new r("primitive-dot",r.circleFilled.definition),r.closeDirty=new r("close-dirty",r.circleFilled.definition),r.debugBreakpoint=new r("debug-breakpoint",r.circleFilled.definition),r.debugBreakpointDisabled=new r("debug-breakpoint-disabled",r.circleFilled.definition),r.debugHint=new r("debug-hint",r.circleFilled.definition),r.primitiveSquare=new r("primitive-square",{fontCharacter:"\\ea72"}),r.edit=new r("edit",{fontCharacter:"\\ea73"}),r.pencil=new r("pencil",{fontCharacter:"\\ea73"}),r.info=new r("info",{fontCharacter:"\\ea74"}),r.issueOpened=new r("issue-opened",{fontCharacter:"\\ea74"}),r.gistPrivate=new r("gist-private",{fontCharacter:"\\ea75"}),r.gitForkPrivate=new r("git-fork-private",{fontCharacter:"\\ea75"}),r.lock=new r("lock",{fontCharacter:"\\ea75"}),r.mirrorPrivate=new r("mirror-private",{fontCharacter:"\\ea75"}),r.close=new r("close",{fontCharacter:"\\ea76"}),r.removeClose=new r("remove-close",{fontCharacter:"\\ea76"}),r.x=new r("x",{fontCharacter:"\\ea76"}),r.repoSync=new r("repo-sync",{fontCharacter:"\\ea77"}),r.sync=new r("sync",{fontCharacter:"\\ea77"}),r.clone=new r("clone",{fontCharacter:"\\ea78"}),r.desktopDownload=new r("desktop-download",{fontCharacter:"\\ea78"}),r.beaker=new r("beaker",{fontCharacter:"\\ea79"}),r.microscope=new r("microscope",{fontCharacter:"\\ea79"}),r.vm=new r("vm",{fontCharacter:"\\ea7a"}),r.deviceDesktop=new r("device-desktop",{fontCharacter:"\\ea7a"}),r.file=new r("file",{fontCharacter:"\\ea7b"}),r.fileText=new r("file-text",{fontCharacter:"\\ea7b"}),r.more=new r("more",{fontCharacter:"\\ea7c"}),r.ellipsis=new r("ellipsis",{fontCharacter:"\\ea7c"}),r.kebabHorizontal=new r("kebab-horizontal",{fontCharacter:"\\ea7c"}),r.mailReply=new r("mail-reply",{fontCharacter:"\\ea7d"}),r.reply=new r("reply",{fontCharacter:"\\ea7d"}),r.organization=new r("organization",{fontCharacter:"\\ea7e"}),r.organizationFilled=new r("organization-filled",{fontCharacter:"\\ea7e"}),r.organizationOutline=new r("organization-outline",{fontCharacter:"\\ea7e"}),r.newFile=new r("new-file",{fontCharacter:"\\ea7f"}),r.fileAdd=new r("file-add",{fontCharacter:"\\ea7f"}),r.newFolder=new r("new-folder",{fontCharacter:"\\ea80"}),r.fileDirectoryCreate=new r("file-directory-create",{fontCharacter:"\\ea80"}),r.trash=new r("trash",{fontCharacter:"\\ea81"}),r.trashcan=new r("trashcan",{fontCharacter:"\\ea81"}),r.history=new r("history",{fontCharacter:"\\ea82"}),r.clock=new r("clock",{fontCharacter:"\\ea82"}),r.folder=new r("folder",{fontCharacter:"\\ea83"}),r.fileDirectory=new r("file-directory",{fontCharacter:"\\ea83"}),r.symbolFolder=new r("symbol-folder",{fontCharacter:"\\ea83"}),r.logoGithub=new r("logo-github",{fontCharacter:"\\ea84"}),r.markGithub=new r("mark-github",{fontCharacter:"\\ea84"}),r.github=new r("github",{fontCharacter:"\\ea84"}),r.terminal=new r("terminal",{fontCharacter:"\\ea85"}),r.console=new r("console",{fontCharacter:"\\ea85"}),r.repl=new r("repl",{fontCharacter:"\\ea85"}),r.zap=new r("zap",{fontCharacter:"\\ea86"}),r.symbolEvent=new r("symbol-event",{fontCharacter:"\\ea86"}),r.error=new r("error",{fontCharacter:"\\ea87"}),r.stop=new r("stop",{fontCharacter:"\\ea87"}),r.variable=new r("variable",{fontCharacter:"\\ea88"}),r.symbolVariable=new r("symbol-variable",{fontCharacter:"\\ea88"}),r.array=new r("array",{fontCharacter:"\\ea8a"}),r.symbolArray=new r("symbol-array",{fontCharacter:"\\ea8a"}),r.symbolModule=new r("symbol-module",{fontCharacter:"\\ea8b"}),r.symbolPackage=new r("symbol-package",{fontCharacter:"\\ea8b"}),r.symbolNamespace=new r("symbol-namespace",{fontCharacter:"\\ea8b"}),r.symbolObject=new r("symbol-object",{fontCharacter:"\\ea8b"}),r.symbolMethod=new r("symbol-method",{fontCharacter:"\\ea8c"}),r.symbolFunction=new r("symbol-function",{fontCharacter:"\\ea8c"}),r.symbolConstructor=new r("symbol-constructor",{fontCharacter:"\\ea8c"}),r.symbolBoolean=new r("symbol-boolean",{fontCharacter:"\\ea8f"}),r.symbolNull=new r("symbol-null",{fontCharacter:"\\ea8f"}),r.symbolNumeric=new r("symbol-numeric",{fontCharacter:"\\ea90"}),r.symbolNumber=new r("symbol-number",{fontCharacter:"\\ea90"}),r.symbolStructure=new r("symbol-structure",{fontCharacter:"\\ea91"}),r.symbolStruct=new r("symbol-struct",{fontCharacter:"\\ea91"}),r.symbolParameter=new r("symbol-parameter",{fontCharacter:"\\ea92"}),r.symbolTypeParameter=new r("symbol-type-parameter",{fontCharacter:"\\ea92"}),r.symbolKey=new r("symbol-key",{fontCharacter:"\\ea93"}),r.symbolText=new r("symbol-text",{fontCharacter:"\\ea93"}),r.symbolReference=new r("symbol-reference",{fontCharacter:"\\ea94"}),r.goToFile=new r("go-to-file",{fontCharacter:"\\ea94"}),r.symbolEnum=new r("symbol-enum",{fontCharacter:"\\ea95"}),r.symbolValue=new r("symbol-value",{fontCharacter:"\\ea95"}),r.symbolRuler=new r("symbol-ruler",{fontCharacter:"\\ea96"}),r.symbolUnit=new r("symbol-unit",{fontCharacter:"\\ea96"}),r.activateBreakpoints=new r("activate-breakpoints",{fontCharacter:"\\ea97"}),r.archive=new r("archive",{fontCharacter:"\\ea98"}),r.arrowBoth=new r("arrow-both",{fontCharacter:"\\ea99"}),r.arrowDown=new r("arrow-down",{fontCharacter:"\\ea9a"}),r.arrowLeft=new r("arrow-left",{fontCharacter:"\\ea9b"}),r.arrowRight=new r("arrow-right",{fontCharacter:"\\ea9c"}),r.arrowSmallDown=new r("arrow-small-down",{fontCharacter:"\\ea9d"}),r.arrowSmallLeft=new r("arrow-small-left",{fontCharacter:"\\ea9e"}),r.arrowSmallRight=new r("arrow-small-right",{fontCharacter:"\\ea9f"}),r.arrowSmallUp=new r("arrow-small-up",{fontCharacter:"\\eaa0"}),r.arrowUp=new r("arrow-up",{fontCharacter:"\\eaa1"}),r.bell=new r("bell",{fontCharacter:"\\eaa2"}),r.bold=new r("bold",{fontCharacter:"\\eaa3"}),r.book=new r("book",{fontCharacter:"\\eaa4"}),r.bookmark=new r("bookmark",{fontCharacter:"\\eaa5"}),r.debugBreakpointConditionalUnverified=new r("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),r.debugBreakpointConditional=new r("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),r.debugBreakpointConditionalDisabled=new r("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),r.debugBreakpointDataUnverified=new r("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),r.debugBreakpointData=new r("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),r.debugBreakpointDataDisabled=new r("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),r.debugBreakpointLogUnverified=new r("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),r.debugBreakpointLog=new r("debug-breakpoint-log",{fontCharacter:"\\eaab"}),r.debugBreakpointLogDisabled=new r("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),r.briefcase=new r("briefcase",{fontCharacter:"\\eaac"}),r.broadcast=new r("broadcast",{fontCharacter:"\\eaad"}),r.browser=new r("browser",{fontCharacter:"\\eaae"}),r.bug=new r("bug",{fontCharacter:"\\eaaf"}),r.calendar=new r("calendar",{fontCharacter:"\\eab0"}),r.caseSensitive=new r("case-sensitive",{fontCharacter:"\\eab1"}),r.check=new r("check",{fontCharacter:"\\eab2"}),r.checklist=new r("checklist",{fontCharacter:"\\eab3"}),r.chevronDown=new r("chevron-down",{fontCharacter:"\\eab4"}),r.dropDownButton=new r("drop-down-button",r.chevronDown.definition),r.chevronLeft=new r("chevron-left",{fontCharacter:"\\eab5"}),r.chevronRight=new r("chevron-right",{fontCharacter:"\\eab6"}),r.chevronUp=new r("chevron-up",{fontCharacter:"\\eab7"}),r.chromeClose=new r("chrome-close",{fontCharacter:"\\eab8"}),r.chromeMaximize=new r("chrome-maximize",{fontCharacter:"\\eab9"}),r.chromeMinimize=new r("chrome-minimize",{fontCharacter:"\\eaba"}),r.chromeRestore=new r("chrome-restore",{fontCharacter:"\\eabb"}),r.circle=new r("circle",{fontCharacter:"\\eabc"}),r.circleOutline=new r("circle-outline",r.circle.definition),r.debugBreakpointUnverified=new r("debug-breakpoint-unverified",r.circle.definition),r.circleSlash=new r("circle-slash",{fontCharacter:"\\eabd"}),r.circuitBoard=new r("circuit-board",{fontCharacter:"\\eabe"}),r.clearAll=new r("clear-all",{fontCharacter:"\\eabf"}),r.clippy=new r("clippy",{fontCharacter:"\\eac0"}),r.closeAll=new r("close-all",{fontCharacter:"\\eac1"}),r.cloudDownload=new r("cloud-download",{fontCharacter:"\\eac2"}),r.cloudUpload=new r("cloud-upload",{fontCharacter:"\\eac3"}),r.code=new r("code",{fontCharacter:"\\eac4"}),r.collapseAll=new r("collapse-all",{fontCharacter:"\\eac5"}),r.colorMode=new r("color-mode",{fontCharacter:"\\eac6"}),r.commentDiscussion=new r("comment-discussion",{fontCharacter:"\\eac7"}),r.compareChanges=new r("compare-changes",{fontCharacter:"\\eafd"}),r.creditCard=new r("credit-card",{fontCharacter:"\\eac9"}),r.dash=new r("dash",{fontCharacter:"\\eacc"}),r.dashboard=new r("dashboard",{fontCharacter:"\\eacd"}),r.database=new r("database",{fontCharacter:"\\eace"}),r.debugContinue=new r("debug-continue",{fontCharacter:"\\eacf"}),r.debugDisconnect=new r("debug-disconnect",{fontCharacter:"\\ead0"}),r.debugPause=new r("debug-pause",{fontCharacter:"\\ead1"}),r.debugRestart=new r("debug-restart",{fontCharacter:"\\ead2"}),r.debugStart=new r("debug-start",{fontCharacter:"\\ead3"}),r.debugStepInto=new r("debug-step-into",{fontCharacter:"\\ead4"}),r.debugStepOut=new r("debug-step-out",{fontCharacter:"\\ead5"}),r.debugStepOver=new r("debug-step-over",{fontCharacter:"\\ead6"}),r.debugStop=new r("debug-stop",{fontCharacter:"\\ead7"}),r.debug=new r("debug",{fontCharacter:"\\ead8"}),r.deviceCameraVideo=new r("device-camera-video",{fontCharacter:"\\ead9"}),r.deviceCamera=new r("device-camera",{fontCharacter:"\\eada"}),r.deviceMobile=new r("device-mobile",{fontCharacter:"\\eadb"}),r.diffAdded=new r("diff-added",{fontCharacter:"\\eadc"}),r.diffIgnored=new r("diff-ignored",{fontCharacter:"\\eadd"}),r.diffModified=new r("diff-modified",{fontCharacter:"\\eade"}),r.diffRemoved=new r("diff-removed",{fontCharacter:"\\eadf"}),r.diffRenamed=new r("diff-renamed",{fontCharacter:"\\eae0"}),r.diff=new r("diff",{fontCharacter:"\\eae1"}),r.discard=new r("discard",{fontCharacter:"\\eae2"}),r.editorLayout=new r("editor-layout",{fontCharacter:"\\eae3"}),r.emptyWindow=new r("empty-window",{fontCharacter:"\\eae4"}),r.exclude=new r("exclude",{fontCharacter:"\\eae5"}),r.extensions=new r("extensions",{fontCharacter:"\\eae6"}),r.eyeClosed=new r("eye-closed",{fontCharacter:"\\eae7"}),r.fileBinary=new r("file-binary",{fontCharacter:"\\eae8"}),r.fileCode=new r("file-code",{fontCharacter:"\\eae9"}),r.fileMedia=new r("file-media",{fontCharacter:"\\eaea"}),r.filePdf=new r("file-pdf",{fontCharacter:"\\eaeb"}),r.fileSubmodule=new r("file-submodule",{fontCharacter:"\\eaec"}),r.fileSymlinkDirectory=new r("file-symlink-directory",{fontCharacter:"\\eaed"}),r.fileSymlinkFile=new r("file-symlink-file",{fontCharacter:"\\eaee"}),r.fileZip=new r("file-zip",{fontCharacter:"\\eaef"}),r.files=new r("files",{fontCharacter:"\\eaf0"}),r.filter=new r("filter",{fontCharacter:"\\eaf1"}),r.flame=new r("flame",{fontCharacter:"\\eaf2"}),r.foldDown=new r("fold-down",{fontCharacter:"\\eaf3"}),r.foldUp=new r("fold-up",{fontCharacter:"\\eaf4"}),r.fold=new r("fold",{fontCharacter:"\\eaf5"}),r.folderActive=new r("folder-active",{fontCharacter:"\\eaf6"}),r.folderOpened=new r("folder-opened",{fontCharacter:"\\eaf7"}),r.gear=new r("gear",{fontCharacter:"\\eaf8"}),r.gift=new r("gift",{fontCharacter:"\\eaf9"}),r.gistSecret=new r("gist-secret",{fontCharacter:"\\eafa"}),r.gist=new r("gist",{fontCharacter:"\\eafb"}),r.gitCommit=new r("git-commit",{fontCharacter:"\\eafc"}),r.gitCompare=new r("git-compare",{fontCharacter:"\\eafd"}),r.gitMerge=new r("git-merge",{fontCharacter:"\\eafe"}),r.githubAction=new r("github-action",{fontCharacter:"\\eaff"}),r.githubAlt=new r("github-alt",{fontCharacter:"\\eb00"}),r.globe=new r("globe",{fontCharacter:"\\eb01"}),r.grabber=new r("grabber",{fontCharacter:"\\eb02"}),r.graph=new r("graph",{fontCharacter:"\\eb03"}),r.gripper=new r("gripper",{fontCharacter:"\\eb04"}),r.heart=new r("heart",{fontCharacter:"\\eb05"}),r.home=new r("home",{fontCharacter:"\\eb06"}),r.horizontalRule=new r("horizontal-rule",{fontCharacter:"\\eb07"}),r.hubot=new r("hubot",{fontCharacter:"\\eb08"}),r.inbox=new r("inbox",{fontCharacter:"\\eb09"}),r.issueClosed=new r("issue-closed",{fontCharacter:"\\eba4"}),r.issueReopened=new r("issue-reopened",{fontCharacter:"\\eb0b"}),r.issues=new r("issues",{fontCharacter:"\\eb0c"}),r.italic=new r("italic",{fontCharacter:"\\eb0d"}),r.jersey=new r("jersey",{fontCharacter:"\\eb0e"}),r.json=new r("json",{fontCharacter:"\\eb0f"}),r.kebabVertical=new r("kebab-vertical",{fontCharacter:"\\eb10"}),r.key=new r("key",{fontCharacter:"\\eb11"}),r.law=new r("law",{fontCharacter:"\\eb12"}),r.lightbulbAutofix=new r("lightbulb-autofix",{fontCharacter:"\\eb13"}),r.linkExternal=new r("link-external",{fontCharacter:"\\eb14"}),r.link=new r("link",{fontCharacter:"\\eb15"}),r.listOrdered=new r("list-ordered",{fontCharacter:"\\eb16"}),r.listUnordered=new r("list-unordered",{fontCharacter:"\\eb17"}),r.liveShare=new r("live-share",{fontCharacter:"\\eb18"}),r.loading=new r("loading",{fontCharacter:"\\eb19"}),r.location=new r("location",{fontCharacter:"\\eb1a"}),r.mailRead=new r("mail-read",{fontCharacter:"\\eb1b"}),r.mail=new r("mail",{fontCharacter:"\\eb1c"}),r.markdown=new r("markdown",{fontCharacter:"\\eb1d"}),r.megaphone=new r("megaphone",{fontCharacter:"\\eb1e"}),r.mention=new r("mention",{fontCharacter:"\\eb1f"}),r.milestone=new r("milestone",{fontCharacter:"\\eb20"}),r.mortarBoard=new r("mortar-board",{fontCharacter:"\\eb21"}),r.move=new r("move",{fontCharacter:"\\eb22"}),r.multipleWindows=new r("multiple-windows",{fontCharacter:"\\eb23"}),r.mute=new r("mute",{fontCharacter:"\\eb24"}),r.noNewline=new r("no-newline",{fontCharacter:"\\eb25"}),r.note=new r("note",{fontCharacter:"\\eb26"}),r.octoface=new r("octoface",{fontCharacter:"\\eb27"}),r.openPreview=new r("open-preview",{fontCharacter:"\\eb28"}),r.package_=new r("package",{fontCharacter:"\\eb29"}),r.paintcan=new r("paintcan",{fontCharacter:"\\eb2a"}),r.pin=new r("pin",{fontCharacter:"\\eb2b"}),r.play=new r("play",{fontCharacter:"\\eb2c"}),r.run=new r("run",{fontCharacter:"\\eb2c"}),r.plug=new r("plug",{fontCharacter:"\\eb2d"}),r.preserveCase=new r("preserve-case",{fontCharacter:"\\eb2e"}),r.preview=new r("preview",{fontCharacter:"\\eb2f"}),r.project=new r("project",{fontCharacter:"\\eb30"}),r.pulse=new r("pulse",{fontCharacter:"\\eb31"}),r.question=new r("question",{fontCharacter:"\\eb32"}),r.quote=new r("quote",{fontCharacter:"\\eb33"}),r.radioTower=new r("radio-tower",{fontCharacter:"\\eb34"}),r.reactions=new r("reactions",{fontCharacter:"\\eb35"}),r.references=new r("references",{fontCharacter:"\\eb36"}),r.refresh=new r("refresh",{fontCharacter:"\\eb37"}),r.regex=new r("regex",{fontCharacter:"\\eb38"}),r.remoteExplorer=new r("remote-explorer",{fontCharacter:"\\eb39"}),r.remote=new r("remote",{fontCharacter:"\\eb3a"}),r.remove=new r("remove",{fontCharacter:"\\eb3b"}),r.replaceAll=new r("replace-all",{fontCharacter:"\\eb3c"}),r.replace=new r("replace",{fontCharacter:"\\eb3d"}),r.repoClone=new r("repo-clone",{fontCharacter:"\\eb3e"}),r.repoForcePush=new r("repo-force-push",{fontCharacter:"\\eb3f"}),r.repoPull=new r("repo-pull",{fontCharacter:"\\eb40"}),r.repoPush=new r("repo-push",{fontCharacter:"\\eb41"}),r.report=new r("report",{fontCharacter:"\\eb42"}),r.requestChanges=new r("request-changes",{fontCharacter:"\\eb43"}),r.rocket=new r("rocket",{fontCharacter:"\\eb44"}),r.rootFolderOpened=new r("root-folder-opened",{fontCharacter:"\\eb45"}),r.rootFolder=new r("root-folder",{fontCharacter:"\\eb46"}),r.rss=new r("rss",{fontCharacter:"\\eb47"}),r.ruby=new r("ruby",{fontCharacter:"\\eb48"}),r.saveAll=new r("save-all",{fontCharacter:"\\eb49"}),r.saveAs=new r("save-as",{fontCharacter:"\\eb4a"}),r.save=new r("save",{fontCharacter:"\\eb4b"}),r.screenFull=new r("screen-full",{fontCharacter:"\\eb4c"}),r.screenNormal=new r("screen-normal",{fontCharacter:"\\eb4d"}),r.searchStop=new r("search-stop",{fontCharacter:"\\eb4e"}),r.server=new r("server",{fontCharacter:"\\eb50"}),r.settingsGear=new r("settings-gear",{fontCharacter:"\\eb51"}),r.settings=new r("settings",{fontCharacter:"\\eb52"}),r.shield=new r("shield",{fontCharacter:"\\eb53"}),r.smiley=new r("smiley",{fontCharacter:"\\eb54"}),r.sortPrecedence=new r("sort-precedence",{fontCharacter:"\\eb55"}),r.splitHorizontal=new r("split-horizontal",{fontCharacter:"\\eb56"}),r.splitVertical=new r("split-vertical",{fontCharacter:"\\eb57"}),r.squirrel=new r("squirrel",{fontCharacter:"\\eb58"}),r.starFull=new r("star-full",{fontCharacter:"\\eb59"}),r.starHalf=new r("star-half",{fontCharacter:"\\eb5a"}),r.symbolClass=new r("symbol-class",{fontCharacter:"\\eb5b"}),r.symbolColor=new r("symbol-color",{fontCharacter:"\\eb5c"}),r.symbolCustomColor=new r("symbol-customcolor",{fontCharacter:"\\eb5c"}),r.symbolConstant=new r("symbol-constant",{fontCharacter:"\\eb5d"}),r.symbolEnumMember=new r("symbol-enum-member",{fontCharacter:"\\eb5e"}),r.symbolField=new r("symbol-field",{fontCharacter:"\\eb5f"}),r.symbolFile=new r("symbol-file",{fontCharacter:"\\eb60"}),r.symbolInterface=new r("symbol-interface",{fontCharacter:"\\eb61"}),r.symbolKeyword=new r("symbol-keyword",{fontCharacter:"\\eb62"}),r.symbolMisc=new r("symbol-misc",{fontCharacter:"\\eb63"}),r.symbolOperator=new r("symbol-operator",{fontCharacter:"\\eb64"}),r.symbolProperty=new r("symbol-property",{fontCharacter:"\\eb65"}),r.wrench=new r("wrench",{fontCharacter:"\\eb65"}),r.wrenchSubaction=new r("wrench-subaction",{fontCharacter:"\\eb65"}),r.symbolSnippet=new r("symbol-snippet",{fontCharacter:"\\eb66"}),r.tasklist=new r("tasklist",{fontCharacter:"\\eb67"}),r.telescope=new r("telescope",{fontCharacter:"\\eb68"}),r.textSize=new r("text-size",{fontCharacter:"\\eb69"}),r.threeBars=new r("three-bars",{fontCharacter:"\\eb6a"}),r.thumbsdown=new r("thumbsdown",{fontCharacter:"\\eb6b"}),r.thumbsup=new r("thumbsup",{fontCharacter:"\\eb6c"}),r.tools=new r("tools",{fontCharacter:"\\eb6d"}),r.triangleDown=new r("triangle-down",{fontCharacter:"\\eb6e"}),r.triangleLeft=new r("triangle-left",{fontCharacter:"\\eb6f"}),r.triangleRight=new r("triangle-right",{fontCharacter:"\\eb70"}),r.triangleUp=new r("triangle-up",{fontCharacter:"\\eb71"}),r.twitter=new r("twitter",{fontCharacter:"\\eb72"}),r.unfold=new r("unfold",{fontCharacter:"\\eb73"}),r.unlock=new r("unlock",{fontCharacter:"\\eb74"}),r.unmute=new r("unmute",{fontCharacter:"\\eb75"}),r.unverified=new r("unverified",{fontCharacter:"\\eb76"}),r.verified=new r("verified",{fontCharacter:"\\eb77"}),r.versions=new r("versions",{fontCharacter:"\\eb78"}),r.vmActive=new r("vm-active",{fontCharacter:"\\eb79"}),r.vmOutline=new r("vm-outline",{fontCharacter:"\\eb7a"}),r.vmRunning=new r("vm-running",{fontCharacter:"\\eb7b"}),r.watch=new r("watch",{fontCharacter:"\\eb7c"}),r.whitespace=new r("whitespace",{fontCharacter:"\\eb7d"}),r.wholeWord=new r("whole-word",{fontCharacter:"\\eb7e"}),r.window=new r("window",{fontCharacter:"\\eb7f"}),r.wordWrap=new r("word-wrap",{fontCharacter:"\\eb80"}),r.zoomIn=new r("zoom-in",{fontCharacter:"\\eb81"}),r.zoomOut=new r("zoom-out",{fontCharacter:"\\eb82"}),r.listFilter=new r("list-filter",{fontCharacter:"\\eb83"}),r.listFlat=new r("list-flat",{fontCharacter:"\\eb84"}),r.listSelection=new r("list-selection",{fontCharacter:"\\eb85"}),r.selection=new r("selection",{fontCharacter:"\\eb85"}),r.listTree=new r("list-tree",{fontCharacter:"\\eb86"}),r.debugBreakpointFunctionUnverified=new r("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),r.debugBreakpointFunction=new r("debug-breakpoint-function",{fontCharacter:"\\eb88"}),r.debugBreakpointFunctionDisabled=new r("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),r.debugStackframeActive=new r("debug-stackframe-active",{fontCharacter:"\\eb89"}),r.circleSmallFilled=new r("circle-small-filled",{fontCharacter:"\\eb8a"}),r.debugStackframeDot=new r("debug-stackframe-dot",r.circleSmallFilled.definition),r.debugStackframe=new r("debug-stackframe",{fontCharacter:"\\eb8b"}),r.debugStackframeFocused=new r("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),r.debugBreakpointUnsupported=new r("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),r.symbolString=new r("symbol-string",{fontCharacter:"\\eb8d"}),r.debugReverseContinue=new r("debug-reverse-continue",{fontCharacter:"\\eb8e"}),r.debugStepBack=new r("debug-step-back",{fontCharacter:"\\eb8f"}),r.debugRestartFrame=new r("debug-restart-frame",{fontCharacter:"\\eb90"}),r.callIncoming=new r("call-incoming",{fontCharacter:"\\eb92"}),r.callOutgoing=new r("call-outgoing",{fontCharacter:"\\eb93"}),r.menu=new r("menu",{fontCharacter:"\\eb94"}),r.expandAll=new r("expand-all",{fontCharacter:"\\eb95"}),r.feedback=new r("feedback",{fontCharacter:"\\eb96"}),r.groupByRefType=new r("group-by-ref-type",{fontCharacter:"\\eb97"}),r.ungroupByRefType=new r("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),r.account=new r("account",{fontCharacter:"\\eb99"}),r.bellDot=new r("bell-dot",{fontCharacter:"\\eb9a"}),r.debugConsole=new r("debug-console",{fontCharacter:"\\eb9b"}),r.library=new r("library",{fontCharacter:"\\eb9c"}),r.output=new r("output",{fontCharacter:"\\eb9d"}),r.runAll=new r("run-all",{fontCharacter:"\\eb9e"}),r.syncIgnored=new r("sync-ignored",{fontCharacter:"\\eb9f"}),r.pinned=new r("pinned",{fontCharacter:"\\eba0"}),r.githubInverted=new r("github-inverted",{fontCharacter:"\\eba1"}),r.debugAlt=new r("debug-alt",{fontCharacter:"\\eb91"}),r.serverProcess=new r("server-process",{fontCharacter:"\\eba2"}),r.serverEnvironment=new r("server-environment",{fontCharacter:"\\eba3"}),r.pass=new r("pass",{fontCharacter:"\\eba4"}),r.stopCircle=new r("stop-circle",{fontCharacter:"\\eba5"}),r.playCircle=new r("play-circle",{fontCharacter:"\\eba6"}),r.record=new r("record",{fontCharacter:"\\eba7"}),r.debugAltSmall=new r("debug-alt-small",{fontCharacter:"\\eba8"}),r.vmConnect=new r("vm-connect",{fontCharacter:"\\eba9"}),r.cloud=new r("cloud",{fontCharacter:"\\ebaa"}),r.merge=new r("merge",{fontCharacter:"\\ebab"}),r.exportIcon=new r("export",{fontCharacter:"\\ebac"}),r.graphLeft=new r("graph-left",{fontCharacter:"\\ebad"}),r.magnet=new r("magnet",{fontCharacter:"\\ebae"}),r.notebook=new r("notebook",{fontCharacter:"\\ebaf"}),r.redo=new r("redo",{fontCharacter:"\\ebb0"}),r.checkAll=new r("check-all",{fontCharacter:"\\ebb1"}),r.pinnedDirty=new r("pinned-dirty",{fontCharacter:"\\ebb2"}),r.passFilled=new r("pass-filled",{fontCharacter:"\\ebb3"}),r.circleLargeFilled=new r("circle-large-filled",{fontCharacter:"\\ebb4"}),r.circleLarge=new r("circle-large",{fontCharacter:"\\ebb5"}),r.circleLargeOutline=new r("circle-large-outline",r.circleLarge.definition),r.combine=new r("combine",{fontCharacter:"\\ebb6"}),r.gather=new r("gather",{fontCharacter:"\\ebb6"}),r.table=new r("table",{fontCharacter:"\\ebb7"}),r.variableGroup=new r("variable-group",{fontCharacter:"\\ebb8"}),r.typeHierarchy=new r("type-hierarchy",{fontCharacter:"\\ebb9"}),r.typeHierarchySub=new r("type-hierarchy-sub",{fontCharacter:"\\ebba"}),r.typeHierarchySuper=new r("type-hierarchy-super",{fontCharacter:"\\ebbb"}),r.gitPullRequestCreate=new r("git-pull-request-create",{fontCharacter:"\\ebbc"}),r.runAbove=new r("run-above",{fontCharacter:"\\ebbd"}),r.runBelow=new r("run-below",{fontCharacter:"\\ebbe"}),r.notebookTemplate=new r("notebook-template",{fontCharacter:"\\ebbf"}),r.debugRerun=new r("debug-rerun",{fontCharacter:"\\ebc0"}),r.workspaceTrusted=new r("workspace-trusted",{fontCharacter:"\\ebc1"}),r.workspaceUntrusted=new r("workspace-untrusted",{fontCharacter:"\\ebc2"}),r.workspaceUnspecified=new r("workspace-unspecified",{fontCharacter:"\\ebc3"}),r.terminalCmd=new r("terminal-cmd",{fontCharacter:"\\ebc4"}),r.terminalDebian=new r("terminal-debian",{fontCharacter:"\\ebc5"}),r.terminalLinux=new r("terminal-linux",{fontCharacter:"\\ebc6"}),r.terminalPowershell=new r("terminal-powershell",{fontCharacter:"\\ebc7"}),r.terminalTmux=new r("terminal-tmux",{fontCharacter:"\\ebc8"}),r.terminalUbuntu=new r("terminal-ubuntu",{fontCharacter:"\\ebc9"}),r.terminalBash=new r("terminal-bash",{fontCharacter:"\\ebca"}),r.arrowSwap=new r("arrow-swap",{fontCharacter:"\\ebcb"}),r.copy=new r("copy",{fontCharacter:"\\ebcc"}),r.personAdd=new r("person-add",{fontCharacter:"\\ebcd"}),r.filterFilled=new r("filter-filled",{fontCharacter:"\\ebce"}),r.wand=new r("wand",{fontCharacter:"\\ebcf"}),r.debugLineByLine=new r("debug-line-by-line",{fontCharacter:"\\ebd0"}),r.inspect=new r("inspect",{fontCharacter:"\\ebd1"}),r.layers=new r("layers",{fontCharacter:"\\ebd2"}),r.layersDot=new r("layers-dot",{fontCharacter:"\\ebd3"}),r.layersActive=new r("layers-active",{fontCharacter:"\\ebd4"}),r.compass=new r("compass",{fontCharacter:"\\ebd5"}),r.compassDot=new r("compass-dot",{fontCharacter:"\\ebd6"}),r.compassActive=new r("compass-active",{fontCharacter:"\\ebd7"}),r.azure=new r("azure",{fontCharacter:"\\ebd8"}),r.issueDraft=new r("issue-draft",{fontCharacter:"\\ebd9"}),r.gitPullRequestClosed=new r("git-pull-request-closed",{fontCharacter:"\\ebda"}),r.gitPullRequestDraft=new r("git-pull-request-draft",{fontCharacter:"\\ebdb"}),r.debugAll=new r("debug-all",{fontCharacter:"\\ebdc"}),r.debugCoverage=new r("debug-coverage",{fontCharacter:"\\ebdd"}),r.runErrors=new r("run-errors",{fontCharacter:"\\ebde"}),r.folderLibrary=new r("folder-library",{fontCharacter:"\\ebdf"}),r.debugContinueSmall=new r("debug-continue-small",{fontCharacter:"\\ebe0"}),r.beakerStop=new r("beaker-stop",{fontCharacter:"\\ebe1"}),r.graphLine=new r("graph-line",{fontCharacter:"\\ebe2"}),r.graphScatter=new r("graph-scatter",{fontCharacter:"\\ebe3"}),r.pieChart=new r("pie-chart",{fontCharacter:"\\ebe4"}),r.bracket=new r("bracket",r.json.definition),r.bracketDot=new r("bracket-dot",{fontCharacter:"\\ebe5"}),r.bracketError=new r("bracket-error",{fontCharacter:"\\ebe6"}),r.lockSmall=new r("lock-small",{fontCharacter:"\\ebe7"}),r.azureDevops=new r("azure-devops",{fontCharacter:"\\ebe8"}),r.verifiedFilled=new r("verified-filled",{fontCharacter:"\\ebe9"}),r.newLine=new r("newline",{fontCharacter:"\\ebea"}),r.layout=new r("layout",{fontCharacter:"\\ebeb"}),r.layoutActivitybarLeft=new r("layout-activitybar-left",{fontCharacter:"\\ebec"}),r.layoutActivitybarRight=new r("layout-activitybar-right",{fontCharacter:"\\ebed"}),r.layoutPanelLeft=new r("layout-panel-left",{fontCharacter:"\\ebee"}),r.layoutPanelCenter=new r("layout-panel-center",{fontCharacter:"\\ebef"}),r.layoutPanelJustify=new r("layout-panel-justify",{fontCharacter:"\\ebf0"}),r.layoutPanelRight=new r("layout-panel-right",{fontCharacter:"\\ebf1"}),r.layoutPanel=new r("layout-panel",{fontCharacter:"\\ebf2"}),r.layoutSidebarLeft=new r("layout-sidebar-left",{fontCharacter:"\\ebf3"}),r.layoutSidebarRight=new r("layout-sidebar-right",{fontCharacter:"\\ebf4"}),r.layoutStatusbar=new r("layout-statusbar",{fontCharacter:"\\ebf5"}),r.layoutMenubar=new r("layout-menubar",{fontCharacter:"\\ebf6"}),r.layoutCentered=new r("layout-centered",{fontCharacter:"\\ebf7"}),r.layoutSidebarRightOff=new r("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),r.layoutPanelOff=new r("layout-panel-off",{fontCharacter:"\\ec01"}),r.layoutSidebarLeftOff=new r("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),r.target=new r("target",{fontCharacter:"\\ebf8"}),r.indent=new r("indent",{fontCharacter:"\\ebf9"}),r.recordSmall=new r("record-small",{fontCharacter:"\\ebfa"}),r.errorSmall=new r("error-small",{fontCharacter:"\\ebfb"}),r.arrowCircleDown=new r("arrow-circle-down",{fontCharacter:"\\ebfc"}),r.arrowCircleLeft=new r("arrow-circle-left",{fontCharacter:"\\ebfd"}),r.arrowCircleRight=new r("arrow-circle-right",{fontCharacter:"\\ebfe"}),r.arrowCircleUp=new r("arrow-circle-up",{fontCharacter:"\\ebff"}),r.heartFilled=new r("heart-filled",{fontCharacter:"\\ec04"}),r.map=new r("map",{fontCharacter:"\\ec05"}),r.mapFilled=new r("map-filled",{fontCharacter:"\\ec06"}),r.circleSmall=new r("circle-small",{fontCharacter:"\\ec07"}),r.bellSlash=new r("bell-slash",{fontCharacter:"\\ec08"}),r.bellSlashDot=new r("bell-slash-dot",{fontCharacter:"\\ec09"}),r.commentUnresolved=new r("comment-unresolved",{fontCharacter:"\\ec0a"}),r.gitPullRequestGoToChanges=new r("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),r.gitPullRequestNewChanges=new r("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),r.searchFuzzy=new r("search-fuzzy",{fontCharacter:"\\ec0d"}),r.dialogError=new r("dialog-error",r.error.definition),r.dialogWarning=new r("dialog-warning",r.warning.definition),r.dialogInfo=new r("dialog-info",r.info.definition),r.dialogClose=new r("dialog-close",r.close.definition),r.treeItemExpanded=new r("tree-item-expanded",r.chevronDown.definition),r.treeFilterOnTypeOn=new r("tree-filter-on-type-on",r.listFilter.definition),r.treeFilterOnTypeOff=new r("tree-filter-on-type-off",r.listSelection.definition),r.treeFilterClear=new r("tree-filter-clear",r.close.definition),r.treeItemLoading=new r("tree-item-loading",r.loading.definition),r.menuSelection=new r("menu-selection",r.check.definition),r.menuSubmenu=new r("menu-submenu",r.chevronRight.definition),r.menuBarMore=new r("menubar-more",r.more.definition),r.scrollbarButtonLeft=new r("scrollbar-button-left",r.triangleLeft.definition),r.scrollbarButtonRight=new r("scrollbar-button-right",r.triangleRight.definition),r.scrollbarButtonUp=new r("scrollbar-button-up",r.triangleUp.definition),r.scrollbarButtonDown=new r("scrollbar-button-down",r.triangleDown.definition),r.toolBarMore=new r("toolbar-more",r.more.definition),r.quickInputBack=new r("quick-input-back",r.arrowLeft.definition);function R(T,P){const w=["codicon","codicon-"+T];return P&&w.push("codicon-modifier-"+P),w}e.getClassNamesArray=R;var L;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function w(b){if(b instanceof r)return["codicon","codicon-"+b.id];const p=P.exec(b.id);if(!p)return w(r.error);const[,v,h]=p,S=["codicon","codicon-"+v];return h&&S.push("codicon-modifier-"+h.substr(1)),S}T.asClassNameArray=w;function E(b){return w(b).join(" ")}T.asClassName=E;function I(b){return"."+w(b).join(".")}T.asCSSSelector=I})(L=e.CSSIcon||(e.CSSIcon={}))}),define(ne[63],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function D(T){return(P,w,E)=>{let I=null,b=null;if(typeof E.value=="function"?(I="value",b=E.value):typeof E.get=="function"&&(I="get",b=E.get),!b)throw new Error("not supported");E[I]=T(b,w)}}e.createDecorator=D;function r(T,P,w){let E=null,I=null;if(typeof w.value=="function"?(E="value",I=w.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(E="get",I=w.get),!I)throw new Error("not supported");const b=`$memoize$${P}`;w[E]=function(...p){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,p)}),this[b]}}e.memoize=r;function R(T,P,w){return D((E,I)=>{const b=`$debounce$${I}`,p=`$debounce$result$${I}`;return function(...v){this[p]||(this[p]=w?w():void 0),clearTimeout(this[b]),P&&(this[p]=P(this[p],...v),v=[this[p]]),this[b]=setTimeout(()=>{E.apply(this,v),this[p]=w?w():void 0},T)}})}e.debounce=R;function L(T,P,w){return D((E,I)=>{const b=`$throttle$timer$${I}`,p=`$throttle$result$${I}`,v=`$throttle$lastRun$${I}`,h=`$throttle$pending$${I}`;return function(...S){if(this[p]||(this[p]=w?w():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),P&&(this[p]=P(this[p],...S)),this[h])return;const C=this[v]+T;C<=Date.now()?(this[v]=Date.now(),E.apply(this,[this[p]]),this[p]=w?w():void 0):(this[h]=!0,this[b]=setTimeout(()=>{this[h]=!1,this[v]=Date.now(),E.apply(this,[this[p]]),this[p]=w?w():void 0},C-Date.now()))}})}e.throttle=L}),define(ne[9],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?a.isErrorNoTelemetry(i)?new a(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(o=>{o(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=D,e.errorHandler=new D;function r(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=r;function R(c){w(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=R;function L(c){w(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=L;function T(c){if(c instanceof Error){const{name:i,message:o}=c,t=c.stacktrace||c.stack;return{$isError:!0,name:i,message:o,stack:t,noTelemetry:a.isErrorNoTelemetry(c)}}return c}e.transformErrorForSerialization=T;const P="Canceled";function w(c){return c instanceof E?!0:c instanceof Error&&c.name===P&&c.message===P}e.isCancellationError=w;class E extends Error{constructor(){super(P),this.name=this.message}}e.CancellationError=E;function I(){const c=new Error(P);return c.name=c.message,c}e.canceled=I;function b(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=b;function p(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=p;function v(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=v;function h(c){const i=new Error(`${c} has been disposed`);return i.name="DISPOSED",i}e.disposed=h;function S(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=S;class C extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=C;class g extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=g;class f extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=f;class a extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof a)return i;const o=new a;return o.message=i.message,o.stack=i.stack,o}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=a;class d extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,d.prototype);debugger}}e.BugIndicatingError=d}),define(ne[18],re([0,1,9]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function r(Z,ie=0){return Z[Z.length-(1+ie)]}e.tail=r;function R(Z){if(Z.length===0)throw new Error("Invalid tail call");return[Z.slice(0,Z.length-1),Z[Z.length-1]]}e.tail2=R;function L(Z,ie,se=(ue,de)=>ue===de){if(Z===ie)return!0;if(!Z||!ie||Z.length!==ie.length)return!1;for(let ue=0,de=Z.length;ue<de;ue++)if(!se(Z[ue],ie[ue]))return!1;return!0}e.equals=L;function T(Z,ie){const se=Z.length-1;ie<se&&(Z[ie]=Z[se]),Z.pop()}e.removeFastWithoutKeepingOrder=T;function P(Z,ie,se){return w(Z.length,ue=>se(Z[ue],ie))}e.binarySearch=P;function w(Z,ie){let se=0,ue=Z-1;for(;se<=ue;){const de=(se+ue)/2|0,ve=ie(de);if(ve<0)se=de+1;else if(ve>0)ue=de-1;else return de}return-(se+1)}e.binarySearch2=w;function E(Z,ie){let se=0,ue=Z.length;if(ue===0)return 0;for(;se<ue;){const de=Math.floor((se+ue)/2);ie(Z[de])?ue=de:se=de+1}return se}e.findFirstInSorted=E;function I(Z,ie,se){if(Z=Z|0,Z>=ie.length)throw new TypeError("invalid index");const ue=ie[Math.floor(ie.length*Math.random())],de=[],ve=[],we=[];for(const Ee of ie){const Ce=se(Ee,ue);Ce<0?de.push(Ee):Ce>0?ve.push(Ee):we.push(Ee)}return Z<de.length?I(Z,de,se):Z<de.length+we.length?we[0]:I(Z-(de.length+we.length),ve,se)}e.quickSelect=I;function b(Z,ie){const se=[];let ue;for(const de of Z.slice(0).sort(ie))!ue||ie(ue[0],de)!==0?(ue=[de],se.push(ue)):ue.push(de);return se}e.groupBy=b;function p(Z,ie,se){const ue=[];function de(Ee,Ce,Ue){if(Ce===0&&Ue.length===0)return;const $e=ue[ue.length-1];$e&&$e.start+$e.deleteCount===Ee?($e.deleteCount+=Ce,$e.toInsert.push(...Ue)):ue.push({start:Ee,deleteCount:Ce,toInsert:Ue})}let ve=0,we=0;for(;;){if(ve===Z.length){de(ve,0,ie.slice(we));break}if(we===ie.length){de(ve,Z.length-ve,[]);break}const Ee=Z[ve],Ce=ie[we],Ue=se(Ee,Ce);Ue===0?(ve+=1,we+=1):Ue<0?(de(ve,1,[]),ve+=1):Ue>0&&(de(ve,0,[Ce]),we+=1)}return ue}e.sortedDiff=p;function v(Z,ie,se){const ue=p(Z,ie,se),de=[],ve=[];for(const we of ue)de.push(...Z.slice(we.start,we.start+we.deleteCount)),ve.push(...we.toInsert);return{removed:de,added:ve}}e.delta=v;function h(Z,ie,se){if(se===0)return[];const ue=Z.slice(0,se).sort(ie);return C(Z,ie,ue,se,Z.length),ue}e.top=h;function S(Z,ie,se,ue,de){return se===0?Promise.resolve([]):new Promise((ve,we)=>{(async()=>{const Ee=Z.length,Ce=Z.slice(0,se).sort(ie);for(let Ue=se,$e=Math.min(se+ue,Ee);Ue<Ee;Ue=$e,$e=Math.min($e+ue,Ee)){if(Ue>se&&await new Promise(He=>setTimeout(He)),de&&de.isCancellationRequested)throw new D.CancellationError;C(Z,ie,Ce,Ue,$e)}return Ce})().then(ve,we)})}e.topAsync=S;function C(Z,ie,se,ue,de){for(const ve=se.length;ue<de;ue++){const we=Z[ue];if(ie(we,se[ve-1])<0){se.pop();const Ee=E(se,Ce=>ie(we,Ce)<0);se.splice(Ee,0,we)}}}function g(Z){return Z.filter(ie=>!!ie)}e.coalesce=g;function f(Z){let ie=0;for(let se=0;se<Z.length;se++)Z[se]&&(Z[ie]=Z[se],ie+=1);Z.length=ie}e.coalesceInPlace=f;function a(Z,ie,se){Z.splice(se,0,Z.splice(ie,1)[0])}e.move=a;function d(Z){return!Array.isArray(Z)||Z.length===0}e.isFalsyOrEmpty=d;function c(Z){return Array.isArray(Z)&&Z.length>0}e.isNonEmptyArray=c;function i(Z,ie=se=>se){const se=new Set;return Z.filter(ue=>{const de=ie(ue);return se.has(de)?!1:(se.add(de),!0)})}e.distinct=i;function o(Z){const ie=new Set;return se=>{const ue=Z(se);return ie.has(ue)?!1:(ie.add(ue),!0)}}e.uniqueFilter=o;function t(Z,ie){const se=n(Z,ie);if(se!==-1)return Z[se]}e.findLast=t;function n(Z,ie){for(let se=Z.length-1;se>=0;se--){const ue=Z[se];if(ie(ue))return se}return-1}e.lastIndex=n;function s(Z,ie){return Z.length>0?Z[0]:ie}e.firstOrDefault=s;function u(Z,ie){return Z.length>0?Z[Z.length-1]:ie}e.lastOrDefault=u;function l(Z,ie,se=(ue,de)=>ue===de){let ue=0;for(let de=0,ve=Math.min(Z.length,ie.length);de<ve&&se(Z[de],ie[de]);de++)ue++;return ue}e.commonPrefixLength=l;function m(Z){return[].concat(...Z)}e.flatten=m;function y(Z,ie){let se=typeof ie=="number"?Z:0;typeof ie=="number"?se=Z:(se=0,ie=Z);const ue=[];if(se<=ie)for(let de=se;de<ie;de++)ue.push(de);else for(let de=se;de>ie;de--)ue.push(de);return ue}e.range=y;function _(Z,ie,se){return Z.reduce((ue,de)=>(ue[ie(de)]=se?se(de):de,ue),Object.create(null))}e.index=_;function $(Z,ie){return Z.push(ie),()=>A(Z,ie)}e.insert=$;function A(Z,ie){const se=Z.indexOf(ie);if(se>-1)return Z.splice(se,1),ie}e.remove=A;function U(Z,ie,se){const ue=Z.slice(0,ie),de=Z.slice(ie);return ue.concat(se,de)}e.arrayInsert=U;function k(Z,ie){let se;if(typeof ie=="number"){let ue=ie;se=()=>{const de=Math.sin(ue++)*179426549;return de-Math.floor(de)}}else se=Math.random;for(let ue=Z.length-1;ue>0;ue-=1){const de=Math.floor(se()*(ue+1)),ve=Z[ue];Z[ue]=Z[de],Z[de]=ve}}e.shuffle=k;function N(Z,ie){const se=Z.indexOf(ie);se>-1&&(Z.splice(se,1),Z.unshift(ie))}e.pushToStart=N;function F(Z,ie){const se=Z.indexOf(ie);se>-1&&(Z.splice(se,1),Z.push(ie))}e.pushToEnd=F;function q(Z,ie){for(const se of ie)Z.push(se)}e.pushMany=q;function J(Z,ie){return Array.isArray(Z)?Z.map(ie):ie(Z)}e.mapArrayOrNot=J;function j(Z){return Array.isArray(Z)?Z:[Z]}e.asArray=j;function H(Z){return Z[Math.floor(Math.random()*Z.length)]}e.getRandomElement=H;function W(Z,ie){for(const se of Z){const ue=ie(se);if(ue!==void 0)return ue}}e.mapFind=W;function z(Z,ie,se){const ue=X(Z,ie),de=Z.length,ve=se.length;Z.length=de+ve;for(let we=de-1;we>=ue;we--)Z[we+ve]=Z[we];for(let we=0;we<ve;we++)Z[we+ue]=se[we]}e.insertInto=z;function K(Z,ie,se,ue){const de=X(Z,ie),ve=Z.splice(de,se);return z(Z,de,ue),ve}e.splice=K;function X(Z,ie){return ie<0?Math.max(ie+Z.length,0):Math.min(ie,Z.length)}var ce;(function(Z){function ie(de){return de<0}Z.isLessThan=ie;function se(de){return de>0}Z.isGreaterThan=se;function ue(de){return de===0}Z.isNeitherLessOrGreaterThan=ue,Z.greaterThan=1,Z.lessThan=-1,Z.neitherLessOrGreaterThan=0})(ce=e.CompareResult||(e.CompareResult={}));function B(Z,ie){return(se,ue)=>ie(Z(se),Z(ue))}e.compareBy=B;function G(...Z){return(ie,se)=>{for(const ue of Z){const de=ue(ie,se);if(!ce.isNeitherLessOrGreaterThan(de))return de}return ce.neitherLessOrGreaterThan}}e.tieBreakComparators=G;const O=(Z,ie)=>Z-ie;e.numberComparator=O;function M(Z,ie){if(Z.length===0)return;let se=Z[0];for(let ue=1;ue<Z.length;ue++){const de=Z[ue];ie(de,se)>0&&(se=de)}return se}e.findMaxBy=M;function x(Z,ie){if(Z.length===0)return;let se=Z[0];for(let ue=1;ue<Z.length;ue++){const de=Z[ue];ie(de,se)>=0&&(se=de)}return se}e.findLastMaxBy=x;function V(Z,ie){return M(Z,(se,ue)=>-ie(se,ue))}e.findMinBy=V;class ee{constructor(ie){this.items=ie,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ie){let se=this.firstIdx;for(;se<this.items.length&&ie(this.items[se]);)se++;const ue=se===this.firstIdx?null:this.items.slice(this.firstIdx,se);return this.firstIdx=se,ue}takeFromEndWhile(ie){let se=this.lastIdx;for(;se>=0&&ie(this.items[se]);)se--;const ue=se===this.lastIdx?null:this.items.slice(se+1,this.lastIdx+1);return this.lastIdx=se,ue}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const ie=this.items[this.firstIdx];return this.firstIdx++,ie}removeLast(){const ie=this.items[this.lastIdx];return this.lastIdx--,ie}takeCount(ie){const se=this.items.slice(this.firstIdx,this.firstIdx+ie);return this.firstIdx+=ie,se}}e.ArrayQueue=ee;class oe{constructor(ie){this.iterate=ie}forEach(ie){this.iterate(se=>(ie(se),!0))}toArray(){const ie=[];return this.iterate(se=>(ie.push(se),!0)),ie}filter(ie){return new oe(se=>this.iterate(ue=>ie(ue)?se(ue):!0))}map(ie){return new oe(se=>this.iterate(ue=>se(ie(ue))))}some(ie){let se=!1;return this.iterate(ue=>(se=ie(ue),!se)),se}findFirst(ie){let se;return this.iterate(ue=>ie(ue)?(se=ue,!1):!0),se}findLast(ie){let se;return this.iterate(ue=>(ie(ue)&&(se=ue),!0)),se}findLastMaxBy(ie){let se,ue=!0;return this.iterate(de=>((ue||ce.isGreaterThan(ie(de,se)))&&(ue=!1,se=de),!0)),se}}e.CallbackIterable=oe,oe.empty=new oe(Z=>{})}),define(ne[115],re([0,1,9]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function r(w,E){if(!w)throw new Error(E?`Assertion failed (${E})`:"Assertion Failed")}e.ok=r;function R(w,E="Unreachable"){throw new Error(E)}e.assertNever=R;function L(w){if(!w)throw new D.BugIndicatingError("Assertion Failed")}e.assert=L;function T(w){if(!w()){debugger;w(),(0,D.onUnexpectedError)(new D.BugIndicatingError("Assertion Failed"))}}e.assertFn=T;function P(w,E){let I=0;for(;I<w.length-1;){const b=w[I],p=w[I+1];if(!E(b,p))return!1;I++}return!0}e.checkAdjacentItems=P}),define(ne[79],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function D(r){const R=this;let L=!1,T;return function(){return L||(L=!0,T=r.apply(R,arguments)),T}}e.once=D}),define(ne[52],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(r){function R(o){return o&&typeof o=="object"&&typeof o[Symbol.iterator]=="function"}r.is=R;const L=Object.freeze([]);function T(){return L}r.empty=T;function*P(o){yield o}r.single=P;function w(o){return o||L}r.from=w;function E(o){return!o||o[Symbol.iterator]().next().done===!0}r.isEmpty=E;function I(o){return o[Symbol.iterator]().next().value}r.first=I;function b(o,t){for(const n of o)if(t(n))return!0;return!1}r.some=b;function p(o,t){for(const n of o)if(t(n))return n}r.find=p;function*v(o,t){for(const n of o)t(n)&&(yield n)}r.filter=v;function*h(o,t){let n=0;for(const s of o)yield t(s,n++)}r.map=h;function*S(...o){for(const t of o)for(const n of t)yield n}r.concat=S;function*C(o){for(const t of o)for(const n of t)yield n}r.concatNested=C;function g(o,t,n){let s=n;for(const u of o)s=t(s,u);return s}r.reduce=g;function f(o,t){let n=0;for(const s of o)t(s,n++)}r.forEach=f;function*a(o,t,n=o.length){for(t<0&&(t+=o.length),n<0?n+=o.length:n>o.length&&(n=o.length);t<n;t++)yield o[t]}r.slice=a;function d(o,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,o];const s=o[Symbol.iterator]();for(let u=0;u<t;u++){const l=s.next();if(l.done)return[n,r.empty()];n.push(l.value)}return[n,{[Symbol.iterator](){return s}}]}r.consume=d;function c(o){return d(o)[0]}r.collect=c;function i(o,t,n=(s,u)=>s===u){const s=o[Symbol.iterator](),u=t[Symbol.iterator]();for(;;){const l=s.next(),m=u.next();if(l.done!==m.done)return!1;if(l.done)return!0;if(!n(l.value,m.value))return!1}}r.equals=i})(D=e.Iterable||(e.Iterable={}))}),define(ne[35],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(D=e.ScanError||(e.ScanError={}));var r;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(r=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(i){i.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function T(i,o=!1){let t=0;const n=i.length;let s="",u=0,l=16,m=0;function y(F){let q=0,J=0;for(;q<F;){const j=i.charCodeAt(t);if(j>=48&&j<=57)J=J*16+j-48;else if(j>=65&&j<=70)J=J*16+j-65+10;else if(j>=97&&j<=102)J=J*16+j-97+10;else break;t++,q++}return q<F&&(J=-1),J}function _(F){t=F,s="",u=0,l=16,m=0}function $(){const F=t;if(i.charCodeAt(t)===48)t++;else for(t++;t<i.length&&E(i.charCodeAt(t));)t++;if(t<i.length&&i.charCodeAt(t)===46)if(t++,t<i.length&&E(i.charCodeAt(t)))for(t++;t<i.length&&E(i.charCodeAt(t));)t++;else return m=3,i.substring(F,t);let q=t;if(t<i.length&&(i.charCodeAt(t)===69||i.charCodeAt(t)===101))if(t++,(t<i.length&&i.charCodeAt(t)===43||i.charCodeAt(t)===45)&&t++,t<i.length&&E(i.charCodeAt(t))){for(t++;t<i.length&&E(i.charCodeAt(t));)t++;q=t}else m=3;return i.substring(F,q)}function A(){let F="",q=t;for(;;){if(t>=n){F+=i.substring(q,t),m=2;break}const J=i.charCodeAt(t);if(J===34){F+=i.substring(q,t),t++;break}if(J===92){if(F+=i.substring(q,t),t++,t>=n){m=2;break}switch(i.charCodeAt(t++)){case 34:F+='"';break;case 92:F+="\\";break;case 47:F+="/";break;case 98:F+="\b";break;case 102:F+="\f";break;case 110:F+=`
`;break;case 114:F+="\r";break;case 116:F+="	";break;case 117:{const H=y(4);H>=0?F+=String.fromCharCode(H):m=4;break}default:m=5}q=t;continue}if(J>=0&&J<=31)if(w(J)){F+=i.substring(q,t),m=2;break}else m=6;t++}return F}function U(){if(s="",m=0,u=t,t>=n)return u=n,l=17;let F=i.charCodeAt(t);if(P(F)){do t++,s+=String.fromCharCode(F),F=i.charCodeAt(t);while(P(F));return l=15}if(w(F))return t++,s+=String.fromCharCode(F),F===13&&i.charCodeAt(t)===10&&(t++,s+=`
`),l=14;switch(F){case 123:return t++,l=1;case 125:return t++,l=2;case 91:return t++,l=3;case 93:return t++,l=4;case 58:return t++,l=6;case 44:return t++,l=5;case 34:return t++,s=A(),l=10;case 47:{const q=t-1;if(i.charCodeAt(t+1)===47){for(t+=2;t<n&&!w(i.charCodeAt(t));)t++;return s=i.substring(q,t),l=12}if(i.charCodeAt(t+1)===42){t+=2;const J=n-1;let j=!1;for(;t<J;){if(i.charCodeAt(t)===42&&i.charCodeAt(t+1)===47){t+=2,j=!0;break}t++}return j||(t++,m=1),s=i.substring(q,t),l=13}return s+=String.fromCharCode(F),t++,l=16}case 45:if(s+=String.fromCharCode(F),t++,t===n||!E(i.charCodeAt(t)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=$(),l=11;default:for(;t<n&&k(F);)t++,F=i.charCodeAt(t);if(u!==t){switch(s=i.substring(u,t),s){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return s+=String.fromCharCode(F),t++,l=16}}function k(F){if(P(F)||w(F))return!1;switch(F){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function N(){let F;do F=U();while(F>=12&&F<=15);return F}return{setPosition:_,getPosition:()=>t,scan:o?N:U,getToken:()=>l,getTokenValue:()=>s,getTokenOffset:()=>u,getTokenLength:()=>t-u,getTokenError:()=>m}}e.createScanner=T;function P(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function w(i){return i===10||i===13||i===8232||i===8233}function E(i){return i>=48&&i<=57}var I;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(I||(I={}));function b(i,o){const t=[],n=new Object;let s;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function m(y,_,$,A){u.value=y,u.offset=_,u.length=$,u.type=A,u.colonOffset=void 0,s=u}try{a(i,{onObjectBegin:(y,_)=>{if(o<=y)throw n;s=void 0,l=o>y,t.push("")},onObjectProperty:(y,_,$)=>{if(o<_||(m(y,_,$,"property"),t[t.length-1]=y,o<=_+$))throw n},onObjectEnd:(y,_)=>{if(o<=y)throw n;s=void 0,t.pop()},onArrayBegin:(y,_)=>{if(o<=y)throw n;s=void 0,t.push(0)},onArrayEnd:(y,_)=>{if(o<=y)throw n;s=void 0,t.pop()},onLiteralValue:(y,_,$)=>{if(o<_||(m(y,_,$,c(y)),o<=_+$))throw n},onSeparator:(y,_,$)=>{if(o<=_)throw n;if(y===":"&&s&&s.type==="property")s.colonOffset=_,l=!1,s=void 0;else if(y===","){const A=t[t.length-1];typeof A=="number"?t[t.length-1]=A+1:(l=!0,t[t.length-1]=""),s=void 0}}})}catch(y){if(y!==n)throw y}return{path:t,previousNode:s,isAtPropertyKey:l,matches:y=>{let _=0;for(let $=0;_<y.length&&$<t.length;$++)if(y[_]===t[$]||y[_]==="*")_++;else if(y[_]!=="**")return!1;return _===y.length}}}e.getLocation=b;function p(i,o=[],t=L.DEFAULT){let n=null,s=[];const u=[];function l(y){Array.isArray(s)?s.push(y):n!==null&&(s[n]=y)}return a(i,{onObjectBegin:()=>{const y={};l(y),u.push(s),s=y,n=null},onObjectProperty:y=>{n=y},onObjectEnd:()=>{s=u.pop()},onArrayBegin:()=>{const y=[];l(y),u.push(s),s=y,n=null},onArrayEnd:()=>{s=u.pop()},onLiteralValue:l,onError:(y,_,$)=>{o.push({error:y,offset:_,length:$})}},t),s[0]}e.parse=p;function v(i,o=[],t=L.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(y){n.type==="property"&&(n.length=y-n.offset,n=n.parent)}function u(y){return n.children.push(y),y}a(i,{onObjectBegin:y=>{n=u({type:"object",offset:y,length:-1,parent:n,children:[]})},onObjectProperty:(y,_,$)=>{n=u({type:"property",offset:_,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:y,offset:_,length:$,parent:n})},onObjectEnd:(y,_)=>{n.length=y+_-n.offset,n=n.parent,s(y+_)},onArrayBegin:(y,_)=>{n=u({type:"array",offset:y,length:-1,parent:n,children:[]})},onArrayEnd:(y,_)=>{n.length=y+_-n.offset,n=n.parent,s(y+_)},onLiteralValue:(y,_,$)=>{u({type:c(y),offset:_,length:$,parent:n,value:y}),s(_+$)},onSeparator:(y,_,$)=>{n.type==="property"&&(y===":"?n.colonOffset=_:y===","&&s(_))},onError:(y,_,$)=>{o.push({error:y,offset:_,length:$})}},t);const m=n.children[0];return m&&delete m.parent,m}e.parseTree=v;function h(i,o){if(!i)return;let t=i;for(const n of o)if(typeof n=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let s=!1;for(const u of t.children)if(Array.isArray(u.children)&&u.children[0].value===n){t=u.children[1],s=!0;break}if(!s)return}else{const s=n;if(t.type!=="array"||s<0||!Array.isArray(t.children)||s>=t.children.length)return;t=t.children[s]}return t}e.findNodeAtLocation=h;function S(i){if(!i.parent||!i.parent.children)return[];const o=S(i.parent);if(i.parent.type==="property"){const t=i.parent.children[0].value;o.push(t)}else if(i.parent.type==="array"){const t=i.parent.children.indexOf(i);t!==-1&&o.push(t)}return o}e.getNodePath=S;function C(i){switch(i.type){case"array":return i.children.map(C);case"object":{const o=Object.create(null);for(const t of i.children){const n=t.children[1];n&&(o[t.children[0].value]=C(n))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=C;function g(i,o,t=!1){return o>=i.offset&&o<i.offset+i.length||t&&o===i.offset+i.length}e.contains=g;function f(i,o,t=!1){if(g(i,o,t)){const n=i.children;if(Array.isArray(n))for(let s=0;s<n.length&&n[s].offset<=o;s++){const u=f(n[s],o,t);if(u)return u}return i}}e.findNodeAtOffset=f;function a(i,o,t=L.DEFAULT){const n=T(i,!1);function s(B){return B?()=>B(n.getTokenOffset(),n.getTokenLength()):()=>!0}function u(B){return B?G=>B(G,n.getTokenOffset(),n.getTokenLength()):()=>!0}const l=s(o.onObjectBegin),m=u(o.onObjectProperty),y=s(o.onObjectEnd),_=s(o.onArrayBegin),$=s(o.onArrayEnd),A=u(o.onLiteralValue),U=u(o.onSeparator),k=s(o.onComment),N=u(o.onError),F=t&&t.disallowComments,q=t&&t.allowTrailingComma;function J(){for(;;){const B=n.scan();switch(n.getTokenError()){case 4:j(14);break;case 5:j(15);break;case 3:j(13);break;case 1:F||j(11);break;case 2:j(12);break;case 6:j(16);break}switch(B){case 12:case 13:F?j(10):k();break;case 16:j(1);break;case 15:case 14:break;default:return B}}}function j(B,G=[],O=[]){if(N(B),G.length+O.length>0){let M=n.getToken();for(;M!==17;){if(G.indexOf(M)!==-1){J();break}else if(O.indexOf(M)!==-1)break;M=J()}}}function H(B){const G=n.getTokenValue();return B?A(G):m(G),J(),!0}function W(){switch(n.getToken()){case 11:{let B=0;try{B=JSON.parse(n.getTokenValue()),typeof B!="number"&&(j(2),B=0)}catch{j(2)}A(B);break}case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return J(),!0}function z(){return n.getToken()!==10?(j(3,[],[2,5]),!1):(H(!1),n.getToken()===6?(U(":"),J(),ce()||j(4,[],[2,5])):j(5,[],[2,5]),!0)}function K(){l(),J();let B=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(B||j(4,[],[]),U(","),J(),n.getToken()===2&&q)break}else B&&j(6,[],[]);z()||j(4,[],[2,5]),B=!0}return y(),n.getToken()!==2?j(7,[2],[]):J(),!0}function X(){_(),J();let B=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(B||j(4,[],[]),U(","),J(),n.getToken()===4&&q)break}else B&&j(6,[],[]);ce()||j(4,[],[4,5]),B=!0}return $(),n.getToken()!==4?j(8,[4],[]):J(),!0}function ce(){switch(n.getToken()){case 3:return X();case 1:return K();case 10:return H(!0);default:return W()}}return J(),n.getToken()===17?t.allowEmptyContent?!0:(j(4,[],[]),!1):ce()?(n.getToken()!==17&&j(9,[],[]),!0):(j(4,[],[]),!1)}e.visit=a;function d(i,o){const t=T(i),n=[];let s,u=0,l;do switch(l=t.getPosition(),s=t.scan(),s){case 12:case 13:case 17:u!==l&&n.push(i.substring(u,l)),o!==void 0&&n.push(t.getTokenValue().replace(/[^\r\n]/g,o)),u=t.getPosition();break}while(s!==17);return n.join("")}e.stripComments=d;function c(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(ne[46],re([0,1,35]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function r(E,I,b){let p,v,h,S,C;if(I){for(S=I.offset,C=S+I.length,h=S;h>0&&!w(E,h-1);)h--;let l=C;for(;l<E.length&&!w(E,l);)l++;v=E.substring(h,l),p=T(v,b)}else v=E,p=0,h=0,S=0,C=E.length;const g=P(b,E);let f=!1,a=0,d;b.insertSpaces?d=L(" ",b.tabSize||4):d="	";const c=(0,D.createScanner)(v,!1);let i=!1;function o(){return g+L(d,p+a)}function t(){let l=c.scan();for(f=!1;l===15||l===14;)f=f||l===14,l=c.scan();return i=l===16||c.getTokenError()!==0,l}const n=[];function s(l,m,y){!i&&m<C&&y>S&&E.substring(m,y)!==l&&n.push({offset:m,length:y-m,content:l})}let u=t();if(u!==17){const l=c.getTokenOffset()+h,m=L(d,p);s(m,h,l)}for(;u!==17;){let l=c.getTokenOffset()+c.getTokenLength()+h,m=t(),y="";for(;!f&&(m===12||m===13);){const $=c.getTokenOffset()+h;s(" ",l,$),l=c.getTokenOffset()+c.getTokenLength()+h,y=m===12?o():"",m=t()}if(m===2)u!==1&&(a--,y=o());else if(m===4)u!==3&&(a--,y=o());else{switch(u){case 3:case 1:a++,y=o();break;case 5:case 12:y=o();break;case 13:f?y=o():y=" ";break;case 6:y=" ";break;case 10:if(m===6){y="";break}case 7:case 8:case 9:case 11:case 2:case 4:m===12||m===13?y=" ":m!==5&&m!==17&&(i=!0);break;case 16:i=!0;break}f&&(m===12||m===13)&&(y=o())}const _=c.getTokenOffset()+h;s(y,l,_),u=m}return n}e.format=r;function R(E,I){const b=JSON.stringify(E,void 0,I.insertSpaces?I.tabSize||4:"	");return I.eol!==void 0?b.replace(/\r\n|\r|\n/g,I.eol):b}e.toFormattedString=R;function L(E,I){let b="";for(let p=0;p<I;p++)b+=E;return b}function T(E,I){let b=0,p=0;const v=I.tabSize||4;for(;b<E.length;){const h=E.charAt(b);if(h===" ")p++;else if(h==="	")p+=v;else break;b++}return Math.floor(p/v)}function P(E,I){for(let b=0;b<I.length;b++){const p=I.charAt(b);if(p==="\r")return b+1<I.length&&I.charAt(b+1)===`
`?`\r
`:"\r";if(p===`
`)return`
`}return E&&E.eol||`
`}e.getEOL=P;function w(E,I){return`\r
`.indexOf(E.charAt(I))!==-1}e.isEOL=w}),define(ne[80],re([0,1,35,46]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function R(E,I,b){return L(E,I,void 0,b)}e.removeProperty=R;function L(E,I,b,p,v){const h=I.slice(),S=[],C=(0,D.parseTree)(E,S);let g,f;for(;h.length>0&&(f=h.pop(),g=(0,D.findNodeAtLocation)(C,h),g===void 0&&b!==void 0);)typeof f=="string"?b={[f]:b}:b=[b];if(g)if(g.type==="object"&&typeof f=="string"&&Array.isArray(g.children)){const a=(0,D.findNodeAtLocation)(g,[f]);if(a!==void 0)if(b===void 0){if(!a.parent)throw new Error("Malformed AST");const d=g.children.indexOf(a.parent);let c,i=a.parent.offset+a.parent.length;if(d>0){const o=g.children[d-1];c=o.offset+o.length}else c=g.offset+1,g.children.length>1&&(i=g.children[1].offset);return T(E,{offset:c,length:i-c,content:""},p)}else return T(E,{offset:a.offset,length:a.length,content:JSON.stringify(b)},p);else{if(b===void 0)return[];const d=`${JSON.stringify(f)}: ${JSON.stringify(b)}`,c=v?v(g.children.map(o=>o.children[0].value)):g.children.length;let i;if(c>0){const o=g.children[c-1];i={offset:o.offset+o.length,length:0,content:","+d}}else g.children.length===0?i={offset:g.offset+1,length:0,content:d}:i={offset:g.offset+1,length:0,content:d+","};return T(E,i,p)}}else if(g.type==="array"&&typeof f=="number"&&Array.isArray(g.children))if(b!==void 0){const a=`${JSON.stringify(b)}`;let d;if(g.children.length===0||f===0)d={offset:g.offset+1,length:0,content:g.children.length===0?a:a+","};else{const c=f===-1||f>g.children.length?g.children.length:f,i=g.children[c-1];d={offset:i.offset+i.length,length:0,content:","+a}}return T(E,d,p)}else{const a=f,d=g.children[a];let c;if(g.children.length===1)c={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===a){const i=g.children[a-1],o=i.offset+i.length,t=g.offset+g.length;c={offset:o,length:t-2-o,content:""}}else c={offset:d.offset,length:g.children[a+1].offset-d.offset,content:""};return T(E,c,p)}else throw new Error(`Can not add ${typeof f!="number"?"index":"property"} to parent of type ${g.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return T(E,{offset:C?C.offset:0,length:C?C.length:0,content:JSON.stringify(b)},p)}}e.setProperty=L;function T(E,I,b){let p=P(E,I),v=I.offset,h=I.offset+I.content.length;if(I.length===0||I.content.length===0){for(;v>0&&!(0,r.isEOL)(p,v-1);)v--;for(;h<p.length&&!(0,r.isEOL)(p,h);)h++}const S=(0,r.format)(p,{offset:v,length:h-v},b);for(let g=S.length-1;g>=0;g--){const f=S[g];p=P(p,f),v=Math.min(v,f.offset),h=Math.max(h,f.offset+f.length),h+=f.content.length-f.length}const C=E.length-(p.length-h)-v;return[{offset:v,length:C,content:p.substring(v,h)}]}e.withFormatting=T;function P(E,I){return E.substring(0,I.offset)+I.content+E.substring(I.offset+I.length)}e.applyEdit=P;function w(E,I){const b=I.slice(0).sort((v,h)=>{const S=v.offset-h.offset;return S===0?v.length-h.length:S});let p=E.length;for(let v=b.length-1;v>=0;v--){const h=b[v];if(h.offset+h.length<=p)E=P(E,h);else throw new Error("Overlapping edit");p=h.offset}return E}e.applyEdits=w}),define(ne[116],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class D{constructor(R){this.executor=R,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(R){this._error=R}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(R){return new D(()=>R(this.getValue()))}}e.Lazy=D}),define(ne[2],re([0,1,79,52]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const R=!1;let L=null;function T(s){L=s}if(e.setDisposableTracker=T,R){const s="__is_disposable_tracked__";T(new class{trackDisposable(u){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{u[s]||console.log(l)},3e3)}setParent(u,l){if(u&&u!==f.None)try{u[s]=!0}catch{}}markAsDisposed(u){if(u&&u!==f.None)try{u[s]=!0}catch{}}markAsSingleton(u){}})}function P(s){return L?.trackDisposable(s),s}function w(s){L?.markAsDisposed(s)}function E(s,u){L?.setParent(s,u)}function I(s,u){if(!!L)for(const l of s)L.setParent(l,u)}function b(s){return L?.markAsSingleton(s),s}e.markAsSingleton=b;function p(s){return typeof s.dispose=="function"&&s.dispose.length===0}e.isDisposable=p;function v(s){if(r.Iterable.is(s)){const u=[];for(const l of s)if(l)try{l.dispose()}catch(m){u.push(m)}if(u.length===1)throw u[0];if(u.length>1)throw new AggregateError(u,"Encountered errors while disposing of store");return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}e.dispose=v;function h(s){for(const u of s)p(u)&&u.dispose();return[]}e.disposeIfDisposable=h;function S(...s){const u=C(()=>v(s));return I(s,u),u}e.combinedDisposable=S;function C(s){const u=P({dispose:(0,D.once)(()=>{w(u),s()})});return u}e.toDisposable=C;class g{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(w(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{v(this._toDispose.values())}finally{this._toDispose.clear()}}add(u){if(!u)return u;if(u===this)throw new Error("Cannot register a disposable on itself!");return E(u,this),this._isDisposed?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(u),u}}e.DisposableStore=g,g.DISABLE_DISPOSED_WARNING=!1;class f{constructor(){this._store=new g,P(this),E(this._store,this)}dispose(){w(this),this._store.dispose()}_register(u){if(u===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(u)}}e.Disposable=f,f.None=Object.freeze({dispose(){}});class a{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(u){this._isDisposed||u===this._value||(this._value?.dispose(),u&&E(u,this),this._value=u)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,w(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const u=this._value;return this._value=void 0,u&&E(u,null),u}}e.MutableDisposable=a;class d{constructor(u){this._disposable=u,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=d;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(u){let l=u;return this.unset=()=>l=void 0,this.isset=()=>l!==void 0,this.dispose=()=>{l&&(l(),l=void 0,w(this))},this}}e.SafeDisposable=c;class i{constructor(){this.references=new Map}acquire(u,...l){let m=this.references.get(u);m||(m={counter:0,object:this.createReferencedObject(u,...l)},this.references.set(u,m));const{object:y}=m,_=(0,D.once)(()=>{--m.counter===0&&(this.destroyReferencedObject(u,m.object),this.references.delete(u))});return m.counter++,{object:y,dispose:_}}}e.ReferenceCollection=i;class o{constructor(u){this.referenceCollection=u}async acquire(u,...l){const m=this.referenceCollection.acquire(u,...l);try{return{object:await m.object,dispose:()=>m.dispose()}}catch(y){throw m.dispose(),y}}}e.AsyncReferenceCollection=o;class t{constructor(u){this.object=u}dispose(){}}e.ImmortalReference=t;function n(s){const u=new g;try{s(u)}finally{u.dispose()}}e.disposeOnReturn=n}),define(ne[117],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{constructor(L){this.element=L,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class r{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let L=this._first;for(;L!==D.Undefined;){const T=L.next;L.prev=D.Undefined,L.next=D.Undefined,L=T}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(L){return this._insert(L,!1)}push(L){return this._insert(L,!0)}_insert(L,T){const P=new D(L);if(this._first===D.Undefined)this._first=P,this._last=P;else if(T){const E=this._last;this._last=P,P.prev=E,E.next=P}else{const E=this._first;this._first=P,P.next=E,E.prev=P}this._size+=1;let w=!1;return()=>{w||(w=!0,this._remove(P))}}shift(){if(this._first!==D.Undefined){const L=this._first.element;return this._remove(this._first),L}}pop(){if(this._last!==D.Undefined){const L=this._last.element;return this._remove(this._last),L}}_remove(L){if(L.prev!==D.Undefined&&L.next!==D.Undefined){const T=L.prev;T.next=L.next,L.next.prev=T}else L.prev===D.Undefined&&L.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):L.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):L.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let L=this._first;for(;L!==D.Undefined;)yield L.element,L=L.next}}e.LinkedList=r}),function(){function Q(R){const L=[];typeof R=="number"&&L.push("code/timeOrigin",R);function T(w){L.push(w,Date.now())}function P(){const w=[];for(let E=0;E<L.length;E+=2)w.push({name:L[E],startTime:L[E+1]});return w}return{mark:T,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const T of performance.getEntriesByType("mark"))L.push({name:T.name,startTime:Math.round(R+T.startTime)});return L}};if(typeof process=="object"){const R=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function D(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var r;typeof global=="object"?r=global:typeof self=="object"?r=self:r={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(r)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(r):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),r.perf=D(r))}(),function(Q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var r in D)(typeof exports=="object"?exports:Q)[r]=D[r]}}(typeof self<"u"?self:this,function(){return function(Q){var e={};function D(r){if(e[r])return e[r].exports;var R=e[r]={i:r,l:!1,exports:{}};return Q[r].call(R.exports,R,R.exports,D),R.l=!0,R.exports}return D.m=Q,D.c=e,D.d=function(r,R,L){D.o(r,R)||Object.defineProperty(r,R,{enumerable:!0,get:L})},D.r=function(r){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(r,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(r,"__esModule",{value:!0})},D.t=function(r,R){if(1&R&&(r=D(r)),8&R||4&R&&typeof r=="object"&&r&&r.__esModule)return r;var L=Object.create(null);if(D.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:r}),2&R&&typeof r!="string")for(var T in r)D.d(L,T,function(P){return r[P]}.bind(null,T));return L},D.n=function(r){var R=r&&r.__esModule?function(){return r.default}:function(){return r};return D.d(R,"a",R),R},D.o=function(r,R){return Object.prototype.hasOwnProperty.call(r,R)},D.p="",D(D.s=0)}([function(Q,e,D){(function(r){var R;e=Q.exports=O,R=typeof r=="object"&&r.env&&r.env.NODE_DEBUG&&/\bsemver\b/i.test(r.env.NODE_DEBUG)?function(){var ae=Array.prototype.slice.call(arguments,0);ae.unshift("SEMVER"),console.log.apply(console,ae)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],w=e.src=[],E=0,I=E++;w[I]="0|[1-9]\\d*";var b=E++;w[b]="[0-9]+";var p=E++;w[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=E++;w[v]="("+w[I]+")\\.("+w[I]+")\\.("+w[I]+")";var h=E++;w[h]="("+w[b]+")\\.("+w[b]+")\\.("+w[b]+")";var S=E++;w[S]="(?:"+w[I]+"|"+w[p]+")";var C=E++;w[C]="(?:"+w[b]+"|"+w[p]+")";var g=E++;w[g]="(?:-("+w[S]+"(?:\\."+w[S]+")*))";var f=E++;w[f]="(?:-?("+w[C]+"(?:\\."+w[C]+")*))";var a=E++;w[a]="[0-9A-Za-z-]+";var d=E++;w[d]="(?:\\+("+w[a]+"(?:\\."+w[a]+")*))";var c=E++,i="v?"+w[v]+w[g]+"?"+w[d]+"?";w[c]="^"+i+"$";var o="[v=\\s]*"+w[h]+w[f]+"?"+w[d]+"?",t=E++;w[t]="^"+o+"$";var n=E++;w[n]="((?:<|>)?=?)";var s=E++;w[s]=w[b]+"|x|X|\\*";var u=E++;w[u]=w[I]+"|x|X|\\*";var l=E++;w[l]="[v=\\s]*("+w[u]+")(?:\\.("+w[u]+")(?:\\.("+w[u]+")(?:"+w[g]+")?"+w[d]+"?)?)?";var m=E++;w[m]="[v=\\s]*("+w[s]+")(?:\\.("+w[s]+")(?:\\.("+w[s]+")(?:"+w[f]+")?"+w[d]+"?)?)?";var y=E++;w[y]="^"+w[n]+"\\s*"+w[l]+"$";var _=E++;w[_]="^"+w[n]+"\\s*"+w[m]+"$";var $=E++;w[$]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var A=E++;w[A]="(?:~>?)";var U=E++;w[U]="(\\s*)"+w[A]+"\\s+",P[U]=new RegExp(w[U],"g");var k=E++;w[k]="^"+w[A]+w[l]+"$";var N=E++;w[N]="^"+w[A]+w[m]+"$";var F=E++;w[F]="(?:\\^)";var q=E++;w[q]="(\\s*)"+w[F]+"\\s+",P[q]=new RegExp(w[q],"g");var J=E++;w[J]="^"+w[F]+w[l]+"$";var j=E++;w[j]="^"+w[F]+w[m]+"$";var H=E++;w[H]="^"+w[n]+"\\s*("+o+")$|^$";var W=E++;w[W]="^"+w[n]+"\\s*("+i+")$|^$";var z=E++;w[z]="(\\s*)"+w[n]+"\\s*("+o+"|"+w[l]+")",P[z]=new RegExp(w[z],"g");var K=E++;w[K]="^\\s*("+w[l]+")\\s+-\\s+("+w[l]+")\\s*$";var X=E++;w[X]="^\\s*("+w[m]+")\\s+-\\s+("+w[m]+")\\s*$";var ce=E++;w[ce]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)R(B,w[B]),P[B]||(P[B]=new RegExp(w[B]));function G(ae,fe){if(ae instanceof O)return ae;if(typeof ae!="string"||ae.length>L||!(fe?P[t]:P[c]).test(ae))return null;try{return new O(ae,fe)}catch{return null}}function O(ae,fe){if(ae instanceof O){if(ae.loose===fe)return ae;ae=ae.version}else if(typeof ae!="string")throw new TypeError("Invalid Version: "+ae);if(ae.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof O))return new O(ae,fe);R("SemVer",ae,fe),this.loose=fe;var ge=ae.trim().match(fe?P[t]:P[c]);if(!ge)throw new TypeError("Invalid Version: "+ae);if(this.raw=ae,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(be){if(/^[0-9]+$/.test(be)){var Ie=+be;if(Ie>=0&&Ie<T)return Ie}return be}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=G,e.valid=function(ae,fe){var ge=G(ae,fe);return ge?ge.version:null},e.clean=function(ae,fe){var ge=G(ae.trim().replace(/^[=v]+/,""),fe);return ge?ge.version:null},e.SemVer=O,O.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},O.prototype.toString=function(){return this.version},O.prototype.compare=function(ae){return R("SemVer.compare",this.version,this.loose,ae),ae instanceof O||(ae=new O(ae,this.loose)),this.compareMain(ae)||this.comparePre(ae)},O.prototype.compareMain=function(ae){return ae instanceof O||(ae=new O(ae,this.loose)),x(this.major,ae.major)||x(this.minor,ae.minor)||x(this.patch,ae.patch)},O.prototype.comparePre=function(ae){if(ae instanceof O||(ae=new O(ae,this.loose)),this.prerelease.length&&!ae.prerelease.length)return-1;if(!this.prerelease.length&&ae.prerelease.length)return 1;if(!this.prerelease.length&&!ae.prerelease.length)return 0;var fe=0;do{var ge=this.prerelease[fe],be=ae.prerelease[fe];if(R("prerelease compare",fe,ge,be),ge===void 0&&be===void 0)return 0;if(be===void 0)return 1;if(ge===void 0)return-1;if(ge!==be)return x(ge,be)}while(++fe)},O.prototype.inc=function(ae,fe){switch(ae){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+ae)}return this.format(),this.raw=this.version,this},e.inc=function(ae,fe,ge,be){typeof ge=="string"&&(be=ge,ge=void 0);try{return new O(ae,ge).inc(fe,be).version}catch{return null}},e.diff=function(ae,fe){if(Z(ae,fe))return null;var ge=G(ae),be=G(fe);if(ge.prerelease.length||be.prerelease.length){for(var Ie in ge)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&ge[Ie]!==be[Ie])return"pre"+Ie;return"prerelease"}for(var Ie in ge)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&ge[Ie]!==be[Ie])return Ie},e.compareIdentifiers=x;var M=/^[0-9]+$/;function x(ae,fe){var ge=M.test(ae),be=M.test(fe);return ge&&be&&(ae=+ae,fe=+fe),ge&&!be?-1:be&&!ge?1:ae<fe?-1:ae>fe?1:0}function V(ae,fe,ge){return new O(ae,ge).compare(new O(fe,ge))}function ee(ae,fe,ge){return V(ae,fe,ge)>0}function oe(ae,fe,ge){return V(ae,fe,ge)<0}function Z(ae,fe,ge){return V(ae,fe,ge)===0}function ie(ae,fe,ge){return V(ae,fe,ge)!==0}function se(ae,fe,ge){return V(ae,fe,ge)>=0}function ue(ae,fe,ge){return V(ae,fe,ge)<=0}function de(ae,fe,ge,be){var Ie;switch(fe){case"===":typeof ae=="object"&&(ae=ae.version),typeof ge=="object"&&(ge=ge.version),Ie=ae===ge;break;case"!==":typeof ae=="object"&&(ae=ae.version),typeof ge=="object"&&(ge=ge.version),Ie=ae!==ge;break;case"":case"=":case"==":Ie=Z(ae,ge,be);break;case"!=":Ie=ie(ae,ge,be);break;case">":Ie=ee(ae,ge,be);break;case">=":Ie=se(ae,ge,be);break;case"<":Ie=oe(ae,ge,be);break;case"<=":Ie=ue(ae,ge,be);break;default:throw new TypeError("Invalid operator: "+fe)}return Ie}function ve(ae,fe){if(ae instanceof ve){if(ae.loose===fe)return ae;ae=ae.value}if(!(this instanceof ve))return new ve(ae,fe);R("comparator",ae,fe),this.loose=fe,this.parse(ae),this.semver===we?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(ae,fe){return x(fe,ae)},e.major=function(ae,fe){return new O(ae,fe).major},e.minor=function(ae,fe){return new O(ae,fe).minor},e.patch=function(ae,fe){return new O(ae,fe).patch},e.compare=V,e.compareLoose=function(ae,fe){return V(ae,fe,!0)},e.rcompare=function(ae,fe,ge){return V(fe,ae,ge)},e.sort=function(ae,fe){return ae.sort(function(ge,be){return e.compare(ge,be,fe)})},e.rsort=function(ae,fe){return ae.sort(function(ge,be){return e.rcompare(ge,be,fe)})},e.gt=ee,e.lt=oe,e.eq=Z,e.neq=ie,e.gte=se,e.lte=ue,e.cmp=de,e.Comparator=ve;var we={};function Ee(ae,fe){if(ae instanceof Ee)return ae.loose===fe?ae:new Ee(ae.raw,fe);if(ae instanceof ve)return new Ee(ae.value,fe);if(!(this instanceof Ee))return new Ee(ae,fe);if(this.loose=fe,this.raw=ae,this.set=ae.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ae);this.format()}function Ce(ae){return!ae||ae.toLowerCase()==="x"||ae==="*"}function Ue(ae,fe,ge,be,Ie,Le,Re,Ne,Ae,Me,ze,ke,_e){return((fe=Ce(ge)?"":Ce(be)?">="+ge+".0.0":Ce(Ie)?">="+ge+"."+be+".0":">="+fe)+" "+(Ne=Ce(Ae)?"":Ce(Me)?"<"+(+Ae+1)+".0.0":Ce(ze)?"<"+Ae+"."+(+Me+1)+".0":ke?"<="+Ae+"."+Me+"."+ze+"-"+ke:"<="+Ne)).trim()}function $e(ae,fe){for(var ge=0;ge<ae.length;ge++)if(!ae[ge].test(fe))return!1;if(fe.prerelease.length){for(ge=0;ge<ae.length;ge++)if(R(ae[ge].semver),ae[ge].semver!==we&&ae[ge].semver.prerelease.length>0){var be=ae[ge].semver;if(be.major===fe.major&&be.minor===fe.minor&&be.patch===fe.patch)return!0}return!1}return!0}function He(ae,fe,ge){try{fe=new Ee(fe,ge)}catch{return!1}return fe.test(ae)}function We(ae,fe,ge,be){var Ie,Le,Re,Ne,Ae;switch(ae=new O(ae,be),fe=new Ee(fe,be),ge){case">":Ie=ee,Le=ue,Re=oe,Ne=">",Ae=">=";break;case"<":Ie=oe,Le=se,Re=ee,Ne="<",Ae="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(He(ae,fe,be))return!1;for(var Me=0;Me<fe.set.length;++Me){var ze=fe.set[Me],ke=null,_e=null;if(ze.forEach(function(te){te.semver===we&&(te=new ve(">=0.0.0")),ke=ke||te,_e=_e||te,Ie(te.semver,ke.semver,be)?ke=te:Re(te.semver,_e.semver,be)&&(_e=te)}),ke.operator===Ne||ke.operator===Ae||(!_e.operator||_e.operator===Ne)&&Le(ae,_e.semver)||_e.operator===Ae&&Re(ae,_e.semver))return!1}return!0}ve.prototype.parse=function(ae){var fe=this.loose?P[H]:P[W],ge=ae.match(fe);if(!ge)throw new TypeError("Invalid comparator: "+ae);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new O(ge[2],this.loose):this.semver=we},ve.prototype.toString=function(){return this.value},ve.prototype.test=function(ae){return R("Comparator.test",ae,this.loose),this.semver===we||(typeof ae=="string"&&(ae=new O(ae,this.loose)),de(ae,this.operator,this.semver,this.loose))},ve.prototype.intersects=function(ae,fe){if(!(ae instanceof ve))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new Ee(ae.value,fe),He(this.value,ge,fe);if(ae.operator==="")return ge=new Ee(this.value,fe),He(ae.semver,ge,fe);var be=!(this.operator!==">="&&this.operator!==">"||ae.operator!==">="&&ae.operator!==">"),Ie=!(this.operator!=="<="&&this.operator!=="<"||ae.operator!=="<="&&ae.operator!=="<"),Le=this.semver.version===ae.semver.version,Re=!(this.operator!==">="&&this.operator!=="<="||ae.operator!==">="&&ae.operator!=="<="),Ne=de(this.semver,"<",ae.semver,fe)&&(this.operator===">="||this.operator===">")&&(ae.operator==="<="||ae.operator==="<"),Ae=de(this.semver,">",ae.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(ae.operator===">="||ae.operator===">");return be||Ie||Le&&Re||Ne||Ae},e.Range=Ee,Ee.prototype.format=function(){return this.range=this.set.map(function(ae){return ae.join(" ").trim()}).join("||").trim(),this.range},Ee.prototype.toString=function(){return this.range},Ee.prototype.parseRange=function(ae){var fe=this.loose;ae=ae.trim(),R("range",ae,fe);var ge=fe?P[X]:P[K];ae=ae.replace(ge,Ue),R("hyphen replace",ae),ae=ae.replace(P[z],"$1$2$3"),R("comparator trim",ae,P[z]),ae=(ae=(ae=ae.replace(P[U],"$1~")).replace(P[q],"$1^")).split(/\s+/).join(" ");var be=fe?P[H]:P[W],Ie=ae.split(" ").map(function(Le){return function(Re,Ne){return R("comp",Re),Re=function(Ae,Me){return Ae.trim().split(/\s+/).map(function(ze){return function(ke,_e){R("caret",ke,_e);var te=_e?P[j]:P[J];return ke.replace(te,function(le,he,me,Se,Pe){var De;return R("caret",ke,le,he,me,Se,Pe),Ce(he)?De="":Ce(me)?De=">="+he+".0.0 <"+(+he+1)+".0.0":Ce(Se)?De=he==="0"?">="+he+"."+me+".0 <"+he+"."+(+me+1)+".0":">="+he+"."+me+".0 <"+(+he+1)+".0.0":Pe?(R("replaceCaret pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),De=he==="0"?me==="0"?">="+he+"."+me+"."+Se+Pe+" <"+he+"."+me+"."+(+Se+1):">="+he+"."+me+"."+Se+Pe+" <"+he+"."+(+me+1)+".0":">="+he+"."+me+"."+Se+Pe+" <"+(+he+1)+".0.0"):(R("no pr"),De=he==="0"?me==="0"?">="+he+"."+me+"."+Se+" <"+he+"."+me+"."+(+Se+1):">="+he+"."+me+"."+Se+" <"+he+"."+(+me+1)+".0":">="+he+"."+me+"."+Se+" <"+(+he+1)+".0.0"),R("caret return",De),De})}(ze,Me)}).join(" ")}(Re,Ne),R("caret",Re),Re=function(Ae,Me){return Ae.trim().split(/\s+/).map(function(ze){return function(ke,_e){var te=_e?P[N]:P[k];return ke.replace(te,function(le,he,me,Se,Pe){var De;return R("tilde",ke,le,he,me,Se,Pe),Ce(he)?De="":Ce(me)?De=">="+he+".0.0 <"+(+he+1)+".0.0":Ce(Se)?De=">="+he+"."+me+".0 <"+he+"."+(+me+1)+".0":Pe?(R("replaceTilde pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),De=">="+he+"."+me+"."+Se+Pe+" <"+he+"."+(+me+1)+".0"):De=">="+he+"."+me+"."+Se+" <"+he+"."+(+me+1)+".0",R("tilde return",De),De})}(ze,Me)}).join(" ")}(Re,Ne),R("tildes",Re),Re=function(Ae,Me){return R("replaceXRanges",Ae,Me),Ae.split(/\s+/).map(function(ze){return function(ke,_e){ke=ke.trim();var te=_e?P[_]:P[y];return ke.replace(te,function(le,he,me,Se,Pe,De){R("xRange",ke,le,he,me,Se,Pe,De);var Be=Ce(me),Fe=Be||Ce(Se),Te=Fe||Ce(Pe);return he==="="&&Te&&(he=""),Be?le=he===">"||he==="<"?"<0.0.0":"*":he&&Te?(Fe&&(Se=0),Te&&(Pe=0),he===">"?(he=">=",Fe?(me=+me+1,Se=0,Pe=0):Te&&(Se=+Se+1,Pe=0)):he==="<="&&(he="<",Fe?me=+me+1:Se=+Se+1),le=he+me+"."+Se+"."+Pe):Fe?le=">="+me+".0.0 <"+(+me+1)+".0.0":Te&&(le=">="+me+"."+Se+".0 <"+me+"."+(+Se+1)+".0"),R("xRange return",le),le})}(ze,Me)}).join(" ")}(Re,Ne),R("xrange",Re),Re=function(Ae,Me){return R("replaceStars",Ae,Me),Ae.trim().replace(P[ce],"")}(Re,Ne),R("stars",Re),Re}(Le,fe)}).join(" ").split(/\s+/);return this.loose&&(Ie=Ie.filter(function(Le){return!!Le.match(be)})),Ie=Ie.map(function(Le){return new ve(Le,fe)})},Ee.prototype.intersects=function(ae,fe){if(!(ae instanceof Ee))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(be){return ae.set.some(function(Ie){return Ie.every(function(Le){return be.intersects(Le,fe)})})})})},e.toComparators=function(ae,fe){return new Ee(ae,fe).set.map(function(ge){return ge.map(function(be){return be.value}).join(" ").trim().split(" ")})},Ee.prototype.test=function(ae){if(!ae)return!1;typeof ae=="string"&&(ae=new O(ae,this.loose));for(var fe=0;fe<this.set.length;fe++)if($e(this.set[fe],ae))return!0;return!1},e.satisfies=He,e.maxSatisfying=function(ae,fe,ge){var be=null,Ie=null;try{var Le=new Ee(fe,ge)}catch{return null}return ae.forEach(function(Re){Le.test(Re)&&(be&&Ie.compare(Re)!==-1||(Ie=new O(be=Re,ge)))}),be},e.minSatisfying=function(ae,fe,ge){var be=null,Ie=null;try{var Le=new Ee(fe,ge)}catch{return null}return ae.forEach(function(Re){Le.test(Re)&&(be&&Ie.compare(Re)!==1||(Ie=new O(be=Re,ge)))}),be},e.validRange=function(ae,fe){try{return new Ee(ae,fe).range||"*"}catch{return null}},e.ltr=function(ae,fe,ge){return We(ae,fe,"<",ge)},e.gtr=function(ae,fe,ge){return We(ae,fe,">",ge)},e.outside=We,e.prerelease=function(ae,fe){var ge=G(ae,fe);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(ae,fe,ge){return ae=new Ee(ae,ge),fe=new Ee(fe,ge),ae.intersects(fe)},e.coerce=function(ae){if(ae instanceof O)return ae;if(typeof ae!="string")return null;var fe=ae.match(P[$]);return fe==null?null:G((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,D(1))},function(Q,e){var D,r,R=Q.exports={};function L(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function P(C){if(D===setTimeout)return setTimeout(C,0);if((D===L||!D)&&setTimeout)return D=setTimeout,setTimeout(C,0);try{return D(C,0)}catch{try{return D.call(null,C,0)}catch{return D.call(this,C,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:L}catch{D=L}try{r=typeof clearTimeout=="function"?clearTimeout:T}catch{r=T}})();var w,E=[],I=!1,b=-1;function p(){I&&w&&(I=!1,w.length?E=w.concat(E):b=-1,E.length&&v())}function v(){if(!I){var C=P(p);I=!0;for(var g=E.length;g;){for(w=E,E=[];++b<g;)w&&w[b].run();b=-1,g=E.length}w=null,I=!1,function(f){if(r===clearTimeout)return clearTimeout(f);if((r===T||!r)&&clearTimeout)return r=clearTimeout,clearTimeout(f);try{r(f)}catch{try{return r.call(null,f)}catch{return r.call(this,f)}}}(C)}}function h(C,g){this.fun=C,this.array=g}function S(){}R.nextTick=function(C){var g=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)g[f-1]=arguments[f];E.push(new h(C,g)),E.length!==1||I||P(v)},h.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=S,R.addListener=S,R.once=S,R.off=S,R.removeListener=S,R.removeAllListeners=S,R.emit=S,R.prependListener=S,R.prependOnceListener=S,R.listeners=function(C){return[]},R.binding=function(C){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(C){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(ne[118],re([0,1]),function(Q,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class r{constructor(P,w,E){this.level=P,this.key=w,this.value=E,this.forward=[]}}const R=void 0;class L{constructor(P,w=2**16){this.comparator=P,this[D]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(w)|0),this._header=new r(this._maxLevel,R,R)}get size(){return this._size}clear(){this._header=new r(this._maxLevel,R,R)}has(P){return Boolean(L._search(this,P,this.comparator))}get(P){return L._search(this,P,this.comparator)?.value}set(P,w){return L._insert(this,P,w,this.comparator)&&(this._size+=1),this}delete(P){const w=L._delete(this,P,this.comparator);return w&&(this._size-=1),w}forEach(P,w){let E=this._header.forward[0];for(;E;)P.call(w,E.value,E.key,this),E=E.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this._header.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this._header.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this._header.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",w=this._header.forward[0];for(;w;)P+=`node(${w.key}, ${w.value}, lvl:${w.level})`,w=w.forward[0];return P}static _search(P,w,E){let I=P._header;for(let b=P._level-1;b>=0;b--)for(;I.forward[b]&&E(I.forward[b].key,w)<0;)I=I.forward[b];if(I=I.forward[0],I&&E(I.key,w)===0)return I}static _insert(P,w,E,I){const b=[];let p=P._header;for(let v=P._level-1;v>=0;v--){for(;p.forward[v]&&I(p.forward[v].key,w)<0;)p=p.forward[v];b[v]=p}if(p=p.forward[0],p&&I(p.key,w)===0)return p.value=E,!1;{const v=L._randomLevel(P);if(v>P._level){for(let h=P._level;h<v;h++)b[h]=P._header;P._level=v}p=new r(v,w,E);for(let h=0;h<v;h++)p.forward[h]=b[h].forward[h],b[h].forward[h]=p;return!0}}static _randomLevel(P,w=.5){let E=1;for(;Math.random()<w&&E<P._maxLevel;)E+=1;return E}static _delete(P,w,E){const I=[];let b=P._header;for(let p=P._level-1;p>=0;p--){for(;b.forward[p]&&E(b.forward[p].key,w)<0;)b=b.forward[p];I[p]=b}if(b=b.forward[0],!b||E(b.key,w)!==0)return!1;for(let p=0;p<P._level&&I[p].forward[p]===b;p++)I[p].forward[p]=b.forward[p];for(;P._level>0&&P._header.forward[P._level-1]===R;)P._level-=1;return!0}}e.SkipList=L}),define(ne[42],re([0,1,9,2]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function R(d){const c=d;return c?typeof c.read=="function":!1}e.isReadable=R;function L(d){const c=d;return c?[c.on,c.pause,c.resume,c.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=L;function T(d){const c=d;return c?L(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=T;function P(d,c){return new w(d,c)}e.newWriteableStream=P;class w{constructor(c,i){this.reducer=c,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c<"u"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(i=>i(c))}emitError(c){this.listeners.error.length===0?(0,D.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(i=>i(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,i){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(c,i){if(this.state.destroyed)return;let o;switch(c){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const t=o.indexOf(i);t>=0&&o.splice(t,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function E(d,c){const i=[];let o;for(;(o=d.read())!==null;)i.push(o);return c(i)}e.consumeReadable=E;function I(d,c,i){const o=[];let t;for(;(t=d.read())!==null&&o.length<i;)o.push(t);return t===null&&o.length>0?c(o):{read:()=>{if(o.length>0)return o.shift();if(typeof t<"u"){const n=t;return t=void 0,n}return d.read()}}}e.peekReadable=I;function b(d,c){return new Promise((i,o)=>{const t=[];p(d,{onData:n=>{c&&t.push(n)},onError:n=>{c?o(n):i(void 0)},onEnd:()=>{i(c?c(t):void 0)}})})}e.consumeStream=b;function p(d,c){let i=!1;return d.on("error",o=>{i||c.onError(o)}),d.on("end",()=>{i||c.onEnd()}),d.on("data",o=>{i||c.onData(o)}),(0,r.toDisposable)(()=>i=!0)}e.listenStream=p;function v(d,c){return new Promise((i,o)=>{const t=new r.DisposableStore,n=[],s=m=>{if(n.push(m),n.length>c)return t.dispose(),d.pause(),i({stream:d,buffer:n,ended:!1})},u=m=>o(m),l=()=>i({stream:d,buffer:n,ended:!0});t.add((0,r.toDisposable)(()=>d.removeListener("error",u))),d.on("error",u),t.add((0,r.toDisposable)(()=>d.removeListener("end",l))),d.on("end",l),t.add((0,r.toDisposable)(()=>d.removeListener("data",s))),d.on("data",s)})}e.peekStream=v;function h(d,c){const i=P(c);return i.end(d),i}e.toStream=h;function S(){const d=P(()=>{throw new Error("not supported")});return d.end(),d}e.emptyStream=S;function C(d){let c=!1;return{read:()=>c?null:(c=!0,d)}}e.toReadable=C;function g(d,c,i){const o=P(i);return p(d,{onData:t=>o.write(c.data(t)),onError:t=>o.error(c.error?c.error(t):t),onEnd:()=>o.end()}),o}e.transform=g;function f(d,c,i){let o=!1;return{read:()=>{const t=c.read();return o?t:(o=!0,t!==null?i([d,t]):d)}}}e.prefixedReadable=f;function a(d,c,i){let o=!1;const t=P(i);return p(c,{onData:n=>o?t.write(n):(o=!0,t.write(i([d,n]))),onError:n=>t.error(n),onEnd:()=>{o||(o=!0,t.write(d)),t.end()}}),t}e.prefixedStream=a}),define(ne[16],re([0,1,42]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const r=typeof Buffer<"u";let R,L;class T{static alloc(m){return r?new T(Buffer.allocUnsafe(m)):new T(new Uint8Array(m))}static wrap(m){return r&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new T(m)}static fromString(m,y){return!(y?.dontUseNodeBuffer||!1)&&r?new T(Buffer.from(m)):(R||(R=new TextEncoder),new T(R.encode(m)))}static fromByteArray(m){const y=T.alloc(m.length);for(let _=0,$=m.length;_<$;_++)y.buffer[_]=m[_];return y}static concat(m,y){if(typeof y>"u"){y=0;for(let A=0,U=m.length;A<U;A++)y+=m[A].byteLength}const _=T.alloc(y);let $=0;for(let A=0,U=m.length;A<U;A++){const k=m[A];_.set(k,$),$+=k.byteLength}return _}constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}clone(){const m=T.alloc(this.byteLength);return m.set(this),m}toString(){return r?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(m,y){return new T(this.buffer.subarray(m,y))}set(m,y){if(m instanceof T)this.buffer.set(m.buffer,y);else if(m instanceof Uint8Array)this.buffer.set(m,y);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),y);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),y);else throw new Error("Unknown argument 'array'")}readUInt32BE(m){return E(this.buffer,m)}writeUInt32BE(m,y){I(this.buffer,m,y)}readUInt32LE(m){return b(this.buffer,m)}writeUInt32LE(m,y){p(this.buffer,m,y)}readUInt8(m){return v(this.buffer,m)}writeUInt8(m,y){h(this.buffer,m,y)}}e.VSBuffer=T;function P(l,m){return l[m+0]<<0>>>0|l[m+1]<<8>>>0}e.readUInt16LE=P;function w(l,m,y){l[y+0]=m&255,m=m>>>8,l[y+1]=m&255}e.writeUInt16LE=w;function E(l,m){return l[m]*2**24+l[m+1]*2**16+l[m+2]*2**8+l[m+3]}e.readUInt32BE=E;function I(l,m,y){l[y+3]=m,m=m>>>8,l[y+2]=m,m=m>>>8,l[y+1]=m,m=m>>>8,l[y]=m}e.writeUInt32BE=I;function b(l,m){return l[m+0]<<0>>>0|l[m+1]<<8>>>0|l[m+2]<<16>>>0|l[m+3]<<24>>>0}e.readUInt32LE=b;function p(l,m,y){l[y+0]=m&255,m=m>>>8,l[y+1]=m&255,m=m>>>8,l[y+2]=m&255,m=m>>>8,l[y+3]=m&255}e.writeUInt32LE=p;function v(l,m){return l[m]}e.readUInt8=v;function h(l,m,y){l[y]=m}e.writeUInt8=h;function S(l){return D.consumeReadable(l,m=>T.concat(m))}e.readableToBuffer=S;function C(l){return D.toReadable(l)}e.bufferToReadable=C;function g(l){return D.consumeStream(l,m=>T.concat(m))}e.streamToBuffer=g;async function f(l){return l.ended?T.concat(l.buffer):T.concat([...l.buffer,await g(l.stream)])}e.bufferedStreamToBuffer=f;function a(l){return D.toStream(l,m=>T.concat(m))}e.bufferToStream=a;function d(l){return D.transform(l,{data:m=>typeof m=="string"?T.fromString(m):T.wrap(m)},m=>T.concat(m))}e.streamToBufferReadableStream=d;function c(l){return D.newWriteableStream(m=>T.concat(m),l)}e.newWriteableBufferStream=c;function i(l,m){return D.prefixedReadable(l,m,y=>T.concat(y))}e.prefixedBufferReadable=i;function o(l,m){return D.prefixedStream(l,m,y=>T.concat(y))}e.prefixedBufferStream=o;function t(l){let m=0,y=0,_=0;const $=new Uint8Array(Math.floor(l.length/4*3)),A=k=>{switch(y){case 3:$[_++]=m|k,y=0;break;case 2:$[_++]=m|k>>>2,m=k<<6,y=3;break;case 1:$[_++]=m|k>>>4,m=k<<4,y=2;break;default:m=k<<2,y=1}};for(let k=0;k<l.length;k++){const N=l.charCodeAt(k);if(N>=65&&N<=90)A(N-65);else if(N>=97&&N<=122)A(N-97+26);else if(N>=48&&N<=57)A(N-48+52);else if(N===43||N===45)A(62);else if(N===47||N===95)A(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${l[k]}`)}}const U=_;for(;y>0;)A(0);return T.wrap($).slice(0,U)}e.decodeBase64=t;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:l},m=!0,y=!1){const _=y?s:n;let $="";const A=l.byteLength%3;let U=0;for(;U<l.byteLength-A;U+=3){const k=l[U+0],N=l[U+1],F=l[U+2];$+=_[k>>>2],$+=_[(k<<4|N>>>4)&63],$+=_[(N<<2|F>>>6)&63],$+=_[F&63]}if(A===1){const k=l[U+0];$+=_[k>>>2],$+=_[k<<4&63],m&&($+="==")}else if(A===2){const k=l[U+0],N=l[U+1];$+=_[k>>>2],$+=_[(k<<4|N>>>4)&63],$+=_[N<<2&63],m&&($+="=")}return $}e.encodeBase64=u}),define(ne[15],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function D(o){return typeof o=="string"}e.isString=D;function r(o){return Array.isArray(o)&&o.every(t=>D(t))}e.isStringArray=r;function R(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=R;function L(o){const t=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof t}e.isTypedArray=L;function T(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=T;function P(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=P;function w(o){return o===!0||o===!1}e.isBoolean=w;function E(o){return typeof o>"u"}e.isUndefined=E;function I(o){return!b(o)}e.isDefined=I;function b(o){return E(o)||o===null}e.isUndefinedOrNull=b;function p(o,t){if(!o)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=p;function v(o){if(b(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=v;function h(...o){const t=[];for(let n=0;n<o.length;n++){const s=o[n];if(b(s))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);t.push(s)}return t}e.assertAllDefined=h;const S=Object.prototype.hasOwnProperty;function C(o){if(!R(o))return!1;for(const t in o)if(S.call(o,t))return!1;return!0}e.isEmptyObject=C;function g(o){return typeof o=="function"}e.isFunction=g;function f(...o){return o.length>0&&o.every(g)}e.areFunctions=f;function a(o,t){const n=Math.min(o.length,t.length);for(let s=0;s<n;s++)d(o[s],t[s])}e.validateConstraints=a;function d(o,t){if(D(t)){if(typeof o!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(g(t)){try{if(o instanceof t)return}catch{}if(!b(o)&&o.constructor===t||t.length===1&&t.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=d;function c(o){return o===null?void 0:o}e.withNullAsUndefined=c;function i(o){return typeof o>"u"?null:o}e.withUndefinedAsNull=i}),define(ne[32],re([0,1,15]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function r(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const f=Array.isArray(g)?[]:{};return Object.keys(g).forEach(a=>{g[a]&&typeof g[a]=="object"?f[a]=r(g[a]):f[a]=g[a]}),f}e.deepClone=r;function R(g){if(!g||typeof g!="object")return g;const f=[g];for(;f.length>0;){const a=f.shift();Object.freeze(a);for(const d in a)if(L.call(a,d)){const c=a[d];typeof c=="object"&&!Object.isFrozen(c)&&!(0,D.isTypedArray)(c)&&f.push(c)}}return g}e.deepFreeze=R;const L=Object.prototype.hasOwnProperty;function T(g,f){return P(g,f,new Set)}e.cloneAndChange=T;function P(g,f,a){if((0,D.isUndefinedOrNull)(g))return g;const d=f(g);if(typeof d<"u")return d;if(Array.isArray(g)){const c=[];for(const i of g)c.push(P(i,f,a));return c}if((0,D.isObject)(g)){if(a.has(g))throw new Error("Cannot clone recursive data-structure");a.add(g);const c={};for(const i in g)L.call(g,i)&&(c[i]=P(g[i],f,a));return a.delete(g),c}return g}function w(g,f,a=!0){return(0,D.isObject)(g)?((0,D.isObject)(f)&&Object.keys(f).forEach(d=>{d in g?a&&((0,D.isObject)(g[d])&&(0,D.isObject)(f[d])?w(g[d],f[d],a):g[d]=f[d]):g[d]=f[d]}),g):f}e.mixin=w;function E(g,f){if(g===f)return!0;if(g==null||f===null||f===void 0||typeof g!=typeof f||typeof g!="object"||Array.isArray(g)!==Array.isArray(f))return!1;let a,d;if(Array.isArray(g)){if(g.length!==f.length)return!1;for(a=0;a<g.length;a++)if(!E(g[a],f[a]))return!1}else{const c=[];for(d in g)c.push(d);c.sort();const i=[];for(d in f)i.push(d);if(i.sort(),!E(c,i))return!1;for(a=0;a<c.length;a++)if(!E(g[c[a]],f[c[a]]))return!1}return!0}e.equals=E;function I(g){const f=new Set;return JSON.stringify(g,(a,d)=>{if((0,D.isObject)(d)||Array.isArray(d)){if(f.has(d))return"[Circular]";f.add(d)}return d})}e.safeStringify=I;function b(g,f){const a=Object.create(null);return!g||!f||Object.keys(f).forEach(c=>{const i=g[c],o=f[c];E(i,o)||(a[c]=o)}),a}e.distinct=b;function p(g,f){const a=f.toLowerCase(),d=Object.keys(g).find(c=>c.toLowerCase()===a);return d?g[d]:g[f]}e.getCaseInsensitive=p;function v(g,f){const a=Object.create(null);for(const[d,c]of Object.entries(g))f(d,c)&&(a[d]=c);return a}e.filter=v;function h(g){let f=[],a=Object.getPrototypeOf(g);for(;Object.prototype!==a;)f=f.concat(Object.getOwnPropertyNames(a)),a=Object.getPrototypeOf(a);return f}e.getAllPropertyNames=h;function S(g){const f=[];for(const a of h(g))typeof g[a]=="function"&&f.push(a);return f}e.getAllMethodNames=S;function C(g,f){const a=c=>function(){const i=Array.prototype.slice.call(arguments,0);return f(c,i)},d={};for(const c of g)d[c]=a(c);return d}e.createProxyObject=C}),define(ne[30],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function r(R){return D.test(R)}e.isUUID=r,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(P){for(let w=0;w<P.length;w++)P[w]=Math.floor(Math.random()*256);return P};const L=new Uint8Array(16),T=[];for(let P=0;P<256;P++)T.push(P.toString(16).padStart(2,"0"));return function(){R(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let w=0,E="";return E+=T[L[w++]],E+=T[L[w++]],E+=T[L[w++]],E+=T[L[w++]],E+="-",E+=T[L[w++]],E+=T[L[w++]],E+="-",E+=T[L[w++]],E+=T[L[w++]],E+="-",E+=T[L[w++]],E+=T[L[w++]],E+="-",E+=T[L[w++]],E+=T[L[w++]],E+=T[L[w++]],E+=T[L[w++]],E+=T[L[w++]],E+=T[L[w++]],E}}()}),define(ne[119],re([0,1,36]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const r=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(T){const P=T.replace(/\-/g,":").toLowerCase();return!r.has(P)}function L(){const T=(0,D.networkInterfaces)();for(const P in T){const w=T[P];if(w){for(const{mac:E}of w)if(R(E))return E}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=L}),define(ne[120],re([0,1,81]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function r(P,w,E,I=1){let b=!1;return new Promise(p=>{const v=setTimeout(()=>{if(!b)return b=!0,p(0)},E);R(P,w,I,h=>{if(!b)return b=!0,clearTimeout(v),p(h)})})}e.findFreePort=r;function R(P,w,E,I){if(w===0)return I(0);const b=new D.Socket;b.once("connect",()=>(T(b),R(P+E,w-1,E,I))),b.once("data",()=>{}),b.once("error",p=>(T(b),p.code!=="ECONNREFUSED"?R(P+E,w-1,E,I):I(P))),b.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(P,w,E){let I=!1,b,p=1;const v=D.createServer({pauseOnConnect:!0});function h(S,C){I||(I=!0,v.removeAllListeners(),v.close(),b&&clearTimeout(b),C(S))}return new Promise(S=>{b=setTimeout(()=>{h(0,S)},E),v.on("listening",()=>{h(P,S)}),v.on("error",C=>{C&&(C.code==="EADDRINUSE"||C.code==="EACCES")&&p<w?(P++,p++,v.listen(P,"127.0.0.1")):h(0,S)}),v.on("close",()=>{h(0,S)}),v.listen(P,"127.0.0.1")})}e.findFreePortFaster=L;function T(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(w){console.error(w)}}}),define(ne[121],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const D="Offline";function r(L){return L instanceof R?!0:L instanceof Error&&L.name===D&&L.message===D}e.isOfflineError=r;class R extends Error{constructor(){super(D),this.name=this.message}}e.OfflineError=R}),define(ne[122],re([0,1,16,9,121]),function(Q,e,D,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function L(w,E){if(!navigator.onLine)throw new R.OfflineError;w.proxyAuthorization&&(w.headers={...w.headers||{},"Proxy-Authorization":w.proxyAuthorization});const I=new XMLHttpRequest;return new Promise((b,p)=>{I.open(w.type||"GET",w.url||"",!0,w.user,w.password),T(I,w),I.responseType="arraybuffer",I.onerror=v=>p(new Error(I.statusText&&"XHR failed: "+I.statusText||"XHR failed")),I.onload=v=>{b({res:{statusCode:I.status,headers:P(I)},stream:(0,D.bufferToStream)(D.VSBuffer.wrap(new Uint8Array(I.response)))})},I.ontimeout=v=>p(new Error(`XHR timeout: ${w.timeout}ms`)),w.timeout&&(I.timeout=w.timeout),I.send(w.data),E.onCancellationRequested(()=>{I.abort(),p((0,r.canceled)())})})}e.request=L;function T(w,E){if(E.headers){e:for(const I in E.headers){switch(I){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}w.setRequestHeader(I,E.headers[I])}}}function P(w){const E=Object.create(null);for(const I of w.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(I){const b=I.indexOf(":");E[I.substr(0,b).trim().toLowerCase()]=I.substr(b+1).trim()}return E}}),define(ne[123],re([10,11]),function(Q,e){return Q.create("vs/base/common/date",e)}),define(ne[64],re([0,1,123]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const r=60,R=r*60,L=R*24,T=L*7,P=L*30,w=L*365;function E(b,p,v){typeof b!="number"&&(b=b.getTime());const h=Math.round((new Date().getTime()-b)/1e3);if(h<-30)return(0,D.localize)(0,null,E(new Date().getTime()+h*1e3,!1));if(h<30)return(0,D.localize)(1,null);let S;return h<r?(S=h,p?S===1?v?(0,D.localize)(2,null,S):(0,D.localize)(3,null,S):v?(0,D.localize)(4,null,S):(0,D.localize)(5,null,S):S===1?v?(0,D.localize)(6,null,S):(0,D.localize)(7,null,S):v?(0,D.localize)(8,null,S):(0,D.localize)(9,null,S)):h<R?(S=Math.floor(h/r),p?S===1?v?(0,D.localize)(10,null,S):(0,D.localize)(11,null,S):v?(0,D.localize)(12,null,S):(0,D.localize)(13,null,S):S===1?v?(0,D.localize)(14,null,S):(0,D.localize)(15,null,S):v?(0,D.localize)(16,null,S):(0,D.localize)(17,null,S)):h<L?(S=Math.floor(h/R),p?S===1?v?(0,D.localize)(18,null,S):(0,D.localize)(19,null,S):v?(0,D.localize)(20,null,S):(0,D.localize)(21,null,S):S===1?v?(0,D.localize)(22,null,S):(0,D.localize)(23,null,S):v?(0,D.localize)(24,null,S):(0,D.localize)(25,null,S)):h<T?(S=Math.floor(h/L),p?S===1?(0,D.localize)(26,null,S):(0,D.localize)(27,null,S):S===1?(0,D.localize)(28,null,S):(0,D.localize)(29,null,S)):h<P?(S=Math.floor(h/T),p?S===1?v?(0,D.localize)(30,null,S):(0,D.localize)(31,null,S):v?(0,D.localize)(32,null,S):(0,D.localize)(33,null,S):S===1?v?(0,D.localize)(34,null,S):(0,D.localize)(35,null,S):v?(0,D.localize)(36,null,S):(0,D.localize)(37,null,S)):h<w?(S=Math.floor(h/P),p?S===1?v?(0,D.localize)(38,null,S):(0,D.localize)(39,null,S):v?(0,D.localize)(40,null,S):(0,D.localize)(41,null,S):S===1?v?(0,D.localize)(42,null,S):(0,D.localize)(43,null,S):v?(0,D.localize)(44,null,S):(0,D.localize)(45,null,S)):(S=Math.floor(h/w),p?S===1?v?(0,D.localize)(46,null,S):(0,D.localize)(47,null,S):v?(0,D.localize)(48,null,S):(0,D.localize)(49,null,S):S===1?v?(0,D.localize)(50,null,S):(0,D.localize)(51,null,S):v?(0,D.localize)(52,null,S):(0,D.localize)(53,null,S))}e.fromNow=E;function I(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=I}),define(ne[124],re([10,11]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(ne[38],re([0,1,18,15,124]),function(Q,e,D,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(b,p){return p&&(b.stack||b.stacktrace)?R.localize(0,null,P(b),T(b.stack)||T(b.stacktrace)):P(b)}function T(b){return Array.isArray(b)?b.join(`
`):b}function P(b){return typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?R.localize(1,null,b.message):b.message||R.localize(2,null)}function w(b=null,p=!1){if(!b)return R.localize(3,null);if(Array.isArray(b)){const v=D.coalesce(b),h=w(v[0],p);return v.length>1?R.localize(4,null,h,v.length):h}if(r.isString(b))return b;if(b.detail){const v=b.detail;if(v.error)return L(v.error,p);if(v.exception)return L(v.exception,p)}return b.stack?L(b,p):b.message?b.message:R.localize(5,null)}e.toErrorMessage=w;function E(b){const p=b;return p instanceof Error&&Array.isArray(p.actions)}e.isErrorWithActions=E;function I(b,p){let v;return typeof b=="string"?v=new Error(b):v=b,v.actions=p,v}e.createErrorWithActions=I}),define(ne[125],re([10,11]),function(Q,e){return Q.create("vs/base/common/jsonErrorMessages",e)}),define(ne[126],re([0,1,125]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function r(R){switch(R){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}e.getParseErrorMessage=r}),define(ne[127],re([10,11]),function(Q,e){return Q.create("vs/base/common/platform",e)}),define(ne[4],re([0,1,127]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let r=!1,R=!1,L=!1,T=!1,P=!1,w=!1,E=!1,I=!1,b=!1,p=!1,v,h=e.LANGUAGE_DEFAULT,S,C;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let g;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?g=e.globals.vscode.process:typeof process<"u"&&(g=process);const f=typeof g?.versions?.electron=="string",a=f&&g?.type==="renderer";if(typeof navigator=="object"&&!a)C=navigator.userAgent,r=C.indexOf("Windows")>=0,R=C.indexOf("Macintosh")>=0,I=(C.indexOf("Macintosh")>=0||C.indexOf("iPad")>=0||C.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=C.indexOf("Linux")>=0,p=C?.indexOf("Mobi")>=0,w=!0,v=D.getConfiguredDefaultLocale(D.localize(0,null))||e.LANGUAGE_DEFAULT,h=v;else if(typeof g=="object"){r=g.platform==="win32",R=g.platform==="darwin",L=g.platform==="linux",T=L&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,E=f,b=!!g.env.CI||!!g.env.BUILD_ARTIFACTSTAGINGDIRECTORY,v=e.LANGUAGE_DEFAULT,h=e.LANGUAGE_DEFAULT;const l=g.env.VSCODE_NLS_CONFIG;if(l)try{const m=JSON.parse(l),y=m.availableLanguages["*"];v=m.locale,h=y||e.LANGUAGE_DEFAULT,S=m._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var d;(function(l){l[l.Web=0]="Web",l[l.Mac=1]="Mac",l[l.Linux=2]="Linux",l[l.Windows=3]="Windows"})(d=e.Platform||(e.Platform={}));function c(l){switch(l){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=c;let i=0;R?i=1:r?i=3:L&&(i=2),e.isWindows=r,e.isMacintosh=R,e.isLinux=L,e.isLinuxSnap=T,e.isNative=P,e.isElectron=E,e.isWeb=w,e.isWebWorker=w&&typeof e.globals.importScripts=="function",e.isIOS=I,e.isMobile=p,e.isCI=b,e.platform=i,e.userAgent=C,e.language=h;var o;(function(l){function m(){return e.language}l.value=m;function y(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}l.isDefaultVariant=y;function _(){return e.language==="en"}l.isDefault=_})(o=e.Language||(e.Language={})),e.locale=v,e.translationsConfigFile=S,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const l=[];e.globals.addEventListener("message",y=>{if(y.data&&y.data.vscodeScheduleAsyncWork)for(let _=0,$=l.length;_<$;_++){const A=l[_];if(A.id===y.data.vscodeScheduleAsyncWork){l.splice(_,1),A.callback();return}}});let m=0;return y=>{const _=++m;l.push({id:_,callback:y}),e.globals.postMessage({vscodeScheduleAsyncWork:_},"*")}}return l=>setTimeout(l)})();var t;(function(l){l[l.Windows=1]="Windows",l[l.Macintosh=2]="Macintosh",l[l.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||I?2:r?1:3;let n=!0,s=!1;function u(){if(!s){s=!0;const l=new Uint8Array(2);l[0]=1,l[1]=2,n=new Uint16Array(l.buffer)[0]===(2<<8)+1}return n}e.isLittleEndian=u,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ne[37],re([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let r;if(typeof D.globals.vscode<"u"&&typeof D.globals.vscode.process<"u"){const R=D.globals.vscode.process;r={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?r={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:r={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=r.cwd,e.env=r.env,e.platform=r.platform,e.arch=r.arch}),define(ne[12],re([0,1,37]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const r=65,R=97,L=90,T=122,P=46,w=47,E=92,I=58,b=63;class p extends Error{constructor(d,c,i){let o;typeof c=="string"&&c.indexOf("not ")===0?(o="must not be",c=c.replace(/^not /,"")):o="must be";const t=d.indexOf(".")!==-1?"property":"argument";let n=`The "${d}" ${t} ${o} of type ${c}`;n+=`. Received type ${typeof i}`,super(n),this.code="ERR_INVALID_ARG_TYPE"}}function v(a,d){if(typeof a!="string")throw new p(d,"string",a)}function h(a){return a===w||a===E}function S(a){return a===w}function C(a){return a>=r&&a<=L||a>=R&&a<=T}function g(a,d,c,i){let o="",t=0,n=-1,s=0,u=0;for(let l=0;l<=a.length;++l){if(l<a.length)u=a.charCodeAt(l);else{if(i(u))break;u=w}if(i(u)){if(!(n===l-1||s===1))if(s===2){if(o.length<2||t!==2||o.charCodeAt(o.length-1)!==P||o.charCodeAt(o.length-2)!==P){if(o.length>2){const m=o.lastIndexOf(c);m===-1?(o="",t=0):(o=o.slice(0,m),t=o.length-1-o.lastIndexOf(c)),n=l,s=0;continue}else if(o.length!==0){o="",t=0,n=l,s=0;continue}}d&&(o+=o.length>0?`${c}..`:"..",t=2)}else o.length>0?o+=`${c}${a.slice(n+1,l)}`:o=a.slice(n+1,l),t=l-n-1;n=l,s=0}else u===P&&s!==-1?++s:s=-1}return o}function f(a,d){if(d===null||typeof d!="object")throw new p("pathObject","Object",d);const c=d.dir||d.root,i=d.base||`${d.name||""}${d.ext||""}`;return c?c===d.root?`${c}${i}`:`${c}${a}${i}`:i}e.win32={resolve(...a){let d="",c="",i=!1;for(let o=a.length-1;o>=-1;o--){let t;if(o>=0){if(t=a[o],v(t,"path"),t.length===0)continue}else d.length===0?t=D.cwd():(t=D.env[`=${d}`]||D.cwd(),(t===void 0||t.slice(0,2).toLowerCase()!==d.toLowerCase()&&t.charCodeAt(2)===E)&&(t=`${d}\\`));const n=t.length;let s=0,u="",l=!1;const m=t.charCodeAt(0);if(n===1)h(m)&&(s=1,l=!0);else if(h(m))if(l=!0,h(t.charCodeAt(1))){let y=2,_=y;for(;y<n&&!h(t.charCodeAt(y));)y++;if(y<n&&y!==_){const $=t.slice(_,y);for(_=y;y<n&&h(t.charCodeAt(y));)y++;if(y<n&&y!==_){for(_=y;y<n&&!h(t.charCodeAt(y));)y++;(y===n||y!==_)&&(u=`\\\\${$}\\${t.slice(_,y)}`,s=y)}}}else s=1;else C(m)&&t.charCodeAt(1)===I&&(u=t.slice(0,2),s=2,n>2&&h(t.charCodeAt(2))&&(l=!0,s=3));if(u.length>0)if(d.length>0){if(u.toLowerCase()!==d.toLowerCase())continue}else d=u;if(i){if(d.length>0)break}else if(c=`${t.slice(s)}\\${c}`,i=l,l&&d.length>0)break}return c=g(c,!i,"\\",h),i?`${d}\\${c}`:`${d}${c}`||"."},normalize(a){v(a,"path");const d=a.length;if(d===0)return".";let c=0,i,o=!1;const t=a.charCodeAt(0);if(d===1)return S(t)?"\\":a;if(h(t))if(o=!0,h(a.charCodeAt(1))){let s=2,u=s;for(;s<d&&!h(a.charCodeAt(s));)s++;if(s<d&&s!==u){const l=a.slice(u,s);for(u=s;s<d&&h(a.charCodeAt(s));)s++;if(s<d&&s!==u){for(u=s;s<d&&!h(a.charCodeAt(s));)s++;if(s===d)return`\\\\${l}\\${a.slice(u)}\\`;s!==u&&(i=`\\\\${l}\\${a.slice(u,s)}`,c=s)}}}else c=1;else C(t)&&a.charCodeAt(1)===I&&(i=a.slice(0,2),c=2,d>2&&h(a.charCodeAt(2))&&(o=!0,c=3));let n=c<d?g(a.slice(c),!o,"\\",h):"";return n.length===0&&!o&&(n="."),n.length>0&&h(a.charCodeAt(d-1))&&(n+="\\"),i===void 0?o?`\\${n}`:n:o?`${i}\\${n}`:`${i}${n}`},isAbsolute(a){v(a,"path");const d=a.length;if(d===0)return!1;const c=a.charCodeAt(0);return h(c)||d>2&&C(c)&&a.charCodeAt(1)===I&&h(a.charCodeAt(2))},join(...a){if(a.length===0)return".";let d,c;for(let t=0;t<a.length;++t){const n=a[t];v(n,"path"),n.length>0&&(d===void 0?d=c=n:d+=`\\${n}`)}if(d===void 0)return".";let i=!0,o=0;if(typeof c=="string"&&h(c.charCodeAt(0))){++o;const t=c.length;t>1&&h(c.charCodeAt(1))&&(++o,t>2&&(h(c.charCodeAt(2))?++o:i=!1))}if(i){for(;o<d.length&&h(d.charCodeAt(o));)o++;o>=2&&(d=`\\${d.slice(o)}`)}return e.win32.normalize(d)},relative(a,d){if(v(a,"from"),v(d,"to"),a===d)return"";const c=e.win32.resolve(a),i=e.win32.resolve(d);if(c===i||(a=c.toLowerCase(),d=i.toLowerCase(),a===d))return"";let o=0;for(;o<a.length&&a.charCodeAt(o)===E;)o++;let t=a.length;for(;t-1>o&&a.charCodeAt(t-1)===E;)t--;const n=t-o;let s=0;for(;s<d.length&&d.charCodeAt(s)===E;)s++;let u=d.length;for(;u-1>s&&d.charCodeAt(u-1)===E;)u--;const l=u-s,m=n<l?n:l;let y=-1,_=0;for(;_<m;_++){const A=a.charCodeAt(o+_);if(A!==d.charCodeAt(s+_))break;A===E&&(y=_)}if(_!==m){if(y===-1)return i}else{if(l>m){if(d.charCodeAt(s+_)===E)return i.slice(s+_+1);if(_===2)return i.slice(s+_)}n>m&&(a.charCodeAt(o+_)===E?y=_:_===2&&(y=3)),y===-1&&(y=0)}let $="";for(_=o+y+1;_<=t;++_)(_===t||a.charCodeAt(_)===E)&&($+=$.length===0?"..":"\\..");return s+=y,$.length>0?`${$}${i.slice(s,u)}`:(i.charCodeAt(s)===E&&++s,i.slice(s,u))},toNamespacedPath(a){if(typeof a!="string")return a;if(a.length===0)return"";const d=e.win32.resolve(a);if(d.length<=2)return a;if(d.charCodeAt(0)===E){if(d.charCodeAt(1)===E){const c=d.charCodeAt(2);if(c!==b&&c!==P)return`\\\\?\\UNC\\${d.slice(2)}`}}else if(C(d.charCodeAt(0))&&d.charCodeAt(1)===I&&d.charCodeAt(2)===E)return`\\\\?\\${d}`;return a},dirname(a){v(a,"path");const d=a.length;if(d===0)return".";let c=-1,i=0;const o=a.charCodeAt(0);if(d===1)return h(o)?a:".";if(h(o)){if(c=i=1,h(a.charCodeAt(1))){let s=2,u=s;for(;s<d&&!h(a.charCodeAt(s));)s++;if(s<d&&s!==u){for(u=s;s<d&&h(a.charCodeAt(s));)s++;if(s<d&&s!==u){for(u=s;s<d&&!h(a.charCodeAt(s));)s++;if(s===d)return a;s!==u&&(c=i=s+1)}}}}else C(o)&&a.charCodeAt(1)===I&&(c=d>2&&h(a.charCodeAt(2))?3:2,i=c);let t=-1,n=!0;for(let s=d-1;s>=i;--s)if(h(a.charCodeAt(s))){if(!n){t=s;break}}else n=!1;if(t===-1){if(c===-1)return".";t=c}return a.slice(0,t)},basename(a,d){d!==void 0&&v(d,"ext"),v(a,"path");let c=0,i=-1,o=!0,t;if(a.length>=2&&C(a.charCodeAt(0))&&a.charCodeAt(1)===I&&(c=2),d!==void 0&&d.length>0&&d.length<=a.length){if(d===a)return"";let n=d.length-1,s=-1;for(t=a.length-1;t>=c;--t){const u=a.charCodeAt(t);if(h(u)){if(!o){c=t+1;break}}else s===-1&&(o=!1,s=t+1),n>=0&&(u===d.charCodeAt(n)?--n===-1&&(i=t):(n=-1,i=s))}return c===i?i=s:i===-1&&(i=a.length),a.slice(c,i)}for(t=a.length-1;t>=c;--t)if(h(a.charCodeAt(t))){if(!o){c=t+1;break}}else i===-1&&(o=!1,i=t+1);return i===-1?"":a.slice(c,i)},extname(a){v(a,"path");let d=0,c=-1,i=0,o=-1,t=!0,n=0;a.length>=2&&a.charCodeAt(1)===I&&C(a.charCodeAt(0))&&(d=i=2);for(let s=a.length-1;s>=d;--s){const u=a.charCodeAt(s);if(h(u)){if(!t){i=s+1;break}continue}o===-1&&(t=!1,o=s+1),u===P?c===-1?c=s:n!==1&&(n=1):c!==-1&&(n=-1)}return c===-1||o===-1||n===0||n===1&&c===o-1&&c===i+1?"":a.slice(c,o)},format:f.bind(null,"\\"),parse(a){v(a,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return d;const c=a.length;let i=0,o=a.charCodeAt(0);if(c===1)return h(o)?(d.root=d.dir=a,d):(d.base=d.name=a,d);if(h(o)){if(i=1,h(a.charCodeAt(1))){let y=2,_=y;for(;y<c&&!h(a.charCodeAt(y));)y++;if(y<c&&y!==_){for(_=y;y<c&&h(a.charCodeAt(y));)y++;if(y<c&&y!==_){for(_=y;y<c&&!h(a.charCodeAt(y));)y++;y===c?i=y:y!==_&&(i=y+1)}}}}else if(C(o)&&a.charCodeAt(1)===I){if(c<=2)return d.root=d.dir=a,d;if(i=2,h(a.charCodeAt(2))){if(c===3)return d.root=d.dir=a,d;i=3}}i>0&&(d.root=a.slice(0,i));let t=-1,n=i,s=-1,u=!0,l=a.length-1,m=0;for(;l>=i;--l){if(o=a.charCodeAt(l),h(o)){if(!u){n=l+1;break}continue}s===-1&&(u=!1,s=l+1),o===P?t===-1?t=l:m!==1&&(m=1):t!==-1&&(m=-1)}return s!==-1&&(t===-1||m===0||m===1&&t===s-1&&t===n+1?d.base=d.name=a.slice(n,s):(d.name=a.slice(n,t),d.base=a.slice(n,s),d.ext=a.slice(t,s))),n>0&&n!==i?d.dir=a.slice(0,n-1):d.dir=d.root,d},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...a){let d="",c=!1;for(let i=a.length-1;i>=-1&&!c;i--){const o=i>=0?a[i]:D.cwd();v(o,"path"),o.length!==0&&(d=`${o}/${d}`,c=o.charCodeAt(0)===w)}return d=g(d,!c,"/",S),c?`/${d}`:d.length>0?d:"."},normalize(a){if(v(a,"path"),a.length===0)return".";const d=a.charCodeAt(0)===w,c=a.charCodeAt(a.length-1)===w;return a=g(a,!d,"/",S),a.length===0?d?"/":c?"./":".":(c&&(a+="/"),d?`/${a}`:a)},isAbsolute(a){return v(a,"path"),a.length>0&&a.charCodeAt(0)===w},join(...a){if(a.length===0)return".";let d;for(let c=0;c<a.length;++c){const i=a[c];v(i,"path"),i.length>0&&(d===void 0?d=i:d+=`/${i}`)}return d===void 0?".":e.posix.normalize(d)},relative(a,d){if(v(a,"from"),v(d,"to"),a===d||(a=e.posix.resolve(a),d=e.posix.resolve(d),a===d))return"";const c=1,i=a.length,o=i-c,t=1,n=d.length-t,s=o<n?o:n;let u=-1,l=0;for(;l<s;l++){const y=a.charCodeAt(c+l);if(y!==d.charCodeAt(t+l))break;y===w&&(u=l)}if(l===s)if(n>s){if(d.charCodeAt(t+l)===w)return d.slice(t+l+1);if(l===0)return d.slice(t+l)}else o>s&&(a.charCodeAt(c+l)===w?u=l:l===0&&(u=0));let m="";for(l=c+u+1;l<=i;++l)(l===i||a.charCodeAt(l)===w)&&(m+=m.length===0?"..":"/..");return`${m}${d.slice(t+u)}`},toNamespacedPath(a){return a},dirname(a){if(v(a,"path"),a.length===0)return".";const d=a.charCodeAt(0)===w;let c=-1,i=!0;for(let o=a.length-1;o>=1;--o)if(a.charCodeAt(o)===w){if(!i){c=o;break}}else i=!1;return c===-1?d?"/":".":d&&c===1?"//":a.slice(0,c)},basename(a,d){d!==void 0&&v(d,"ext"),v(a,"path");let c=0,i=-1,o=!0,t;if(d!==void 0&&d.length>0&&d.length<=a.length){if(d===a)return"";let n=d.length-1,s=-1;for(t=a.length-1;t>=0;--t){const u=a.charCodeAt(t);if(u===w){if(!o){c=t+1;break}}else s===-1&&(o=!1,s=t+1),n>=0&&(u===d.charCodeAt(n)?--n===-1&&(i=t):(n=-1,i=s))}return c===i?i=s:i===-1&&(i=a.length),a.slice(c,i)}for(t=a.length-1;t>=0;--t)if(a.charCodeAt(t)===w){if(!o){c=t+1;break}}else i===-1&&(o=!1,i=t+1);return i===-1?"":a.slice(c,i)},extname(a){v(a,"path");let d=-1,c=0,i=-1,o=!0,t=0;for(let n=a.length-1;n>=0;--n){const s=a.charCodeAt(n);if(s===w){if(!o){c=n+1;break}continue}i===-1&&(o=!1,i=n+1),s===P?d===-1?d=n:t!==1&&(t=1):d!==-1&&(t=-1)}return d===-1||i===-1||t===0||t===1&&d===i-1&&d===c+1?"":a.slice(d,i)},format:f.bind(null,"/"),parse(a){v(a,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return d;const c=a.charCodeAt(0)===w;let i;c?(d.root="/",i=1):i=0;let o=-1,t=0,n=-1,s=!0,u=a.length-1,l=0;for(;u>=i;--u){const m=a.charCodeAt(u);if(m===w){if(!s){t=u+1;break}continue}n===-1&&(s=!1,n=u+1),m===P?o===-1?o=u:l!==1&&(l=1):o!==-1&&(l=-1)}if(n!==-1){const m=t===0&&c?1:t;o===-1||l===0||l===1&&o===n-1&&o===t+1?d.base=d.name=a.slice(m,n):(d.name=a.slice(m,o),d.base=a.slice(m,n),d.ext=a.slice(o,n))}return t>0?d.dir=a.slice(0,t-1):c&&(d.dir="/"),d},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=D.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=D.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=D.platform==="win32"?e.win32.join:e.posix.join,e.resolve=D.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=D.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=D.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=D.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=D.platform==="win32"?e.win32.extname:e.posix.extname,e.format=D.platform==="win32"?e.win32.format:e.posix.format,e.parse=D.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=D.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=D.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=D.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ne[128],re([0,1,12]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const r={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},R={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(I){const b=(0,D.extname)(I),p=r[b.toLowerCase()];return p!==void 0?p:T(I)}e.getMediaOrTextMime=L;function T(I){const b=(0,D.extname)(I);return R[b.toLowerCase()]}e.getMediaMime=T;function P(I){for(const b in R)if(R[b]===I)return b}e.getExtensionForMimeType=P;const w=/^(.+)\/(.+?)(;.+)?$/;function E(I,b){const p=w.exec(I);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:b?void 0:I}e.normalizeMimeType=E}),define(ne[82],re([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var r;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(r=e.Source||(e.Source={}));var R;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(R=e.TerminateResponseCode||(e.TerminateResponseCode={}));function L(P,...w){const E=w.reduce((p,v)=>(p[v]=!0,p),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(p=>!E[p]).forEach(p=>{for(let v=0;v<I.length;v++)if(p.search(I[v])!==-1){delete P[p];break}})}e.sanitizeProcessEnvironment=L;function T(P){!P||(delete P.DEBUG,D.isMacintosh&&delete P.DYLD_LIBRARY_PATH,D.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=T}),define(ne[129],re([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const r=D.globals.performance&&typeof D.globals.performance.now=="function";class R{static create(T=!0){return new R(T)}constructor(T){this._highResolution=r&&T,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?D.globals.performance.now():Date.now()}}e.StopWatch=R}),define(ne[3],re([0,1,9,79,2,117,129]),function(Q,e,D,r,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,w=!1;var E;(function(u){u.None=()=>R.Disposable.None;function l(M){if(w){const{onListenerDidAdd:x}=M,V=h.create();let ee=0;M.onListenerDidAdd=()=>{++ee===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),V.print()),x?.()}}}function m(M){return(x,V=null,ee)=>{let oe=!1,Z;return Z=M(ie=>{if(!oe)return Z?Z.dispose():oe=!0,x.call(V,ie)},null,ee),oe&&Z.dispose(),Z}}u.once=m;function y(M,x,V){return N((ee,oe=null,Z)=>M(ie=>ee.call(oe,x(ie)),null,Z),V)}u.map=y;function _(M,x,V){return N((ee,oe=null,Z)=>M(ie=>{x(ie),ee.call(oe,ie)},null,Z),V)}u.forEach=_;function $(M,x,V){return N((ee,oe=null,Z)=>M(ie=>x(ie)&&ee.call(oe,ie),null,Z),V)}u.filter=$;function A(M){return M}u.signal=A;function U(...M){return(x,V=null,ee)=>(0,R.combinedDisposable)(...M.map(oe=>oe(Z=>x.call(V,Z),null,ee)))}u.any=U;function k(M,x,V,ee){let oe=V;return y(M,Z=>(oe=x(oe,Z),oe),ee)}u.reduce=k;function N(M,x){let V;const ee={onFirstListenerAdd(){V=M(oe.fire,oe)},onLastListenerRemove(){V?.dispose()}};x||l(ee);const oe=new C(ee);return x?.add(oe),oe.event}function F(M,x,V=100,ee=!1,oe,Z){let ie,se,ue,de=0;const ve={leakWarningThreshold:oe,onFirstListenerAdd(){ie=M(Ee=>{de++,se=x(se,Ee),ee&&!ue&&(we.fire(se),se=void 0),clearTimeout(ue),ue=setTimeout(()=>{const Ce=se;se=void 0,ue=void 0,(!ee||de>1)&&we.fire(Ce),de=0},V)})},onLastListenerRemove(){ie.dispose()}};Z||l(ve);const we=new C(ve);return Z?.add(we),we.event}u.debounce=F;function q(M,x=(ee,oe)=>ee===oe,V){let ee=!0,oe;return $(M,Z=>{const ie=ee||!x(Z,oe);return ee=!1,oe=Z,ie},V)}u.latch=q;function J(M,x,V){return[u.filter(M,x,V),u.filter(M,ee=>!x(ee),V)]}u.split=J;function j(M,x=!1,V=[]){let ee=V.slice(),oe=M(se=>{ee?ee.push(se):ie.fire(se)});const Z=()=>{ee?.forEach(se=>ie.fire(se)),ee=null},ie=new C({onFirstListenerAdd(){oe||(oe=M(se=>ie.fire(se)))},onFirstListenerDidAdd(){ee&&(x?setTimeout(Z):Z())},onLastListenerRemove(){oe&&oe.dispose(),oe=null}});return ie.event}u.buffer=j;class H{constructor(x){this.event=x,this.disposables=new R.DisposableStore}map(x){return new H(y(this.event,x,this.disposables))}forEach(x){return new H(_(this.event,x,this.disposables))}filter(x){return new H($(this.event,x,this.disposables))}reduce(x,V){return new H(k(this.event,x,V,this.disposables))}latch(){return new H(q(this.event,void 0,this.disposables))}debounce(x,V=100,ee=!1,oe){return new H(F(this.event,x,V,ee,oe,this.disposables))}on(x,V,ee){return this.event(x,V,ee)}once(x,V,ee){return m(this.event)(x,V,ee)}dispose(){this.disposables.dispose()}}function W(M){return new H(M)}u.chain=W;function z(M,x,V=ee=>ee){const ee=(...se)=>ie.fire(V(...se)),oe=()=>M.on(x,ee),Z=()=>M.removeListener(x,ee),ie=new C({onFirstListenerAdd:oe,onLastListenerRemove:Z});return ie.event}u.fromNodeEventEmitter=z;function K(M,x,V=ee=>ee){const ee=(...se)=>ie.fire(V(...se)),oe=()=>M.addEventListener(x,ee),Z=()=>M.removeEventListener(x,ee),ie=new C({onFirstListenerAdd:oe,onLastListenerRemove:Z});return ie.event}u.fromDOMEventEmitter=K;function X(M){return new Promise(x=>m(M)(x))}u.toPromise=X;function ce(M,x){return x(void 0),M(V=>x(V))}u.runAndSubscribe=ce;function B(M,x){let V=null;function ee(Z){V?.dispose(),V=new R.DisposableStore,x(Z,V)}ee(void 0);const oe=M(Z=>ee(Z));return(0,R.toDisposable)(()=>{oe.dispose(),V?.dispose()})}u.runAndSubscribeWithStore=B;class G{constructor(x,V){this.obs=x,this._counter=0,this._hasChanged=!1;const ee={onFirstListenerAdd:()=>{x.addObserver(this)},onLastListenerRemove:()=>{x.removeObserver(this)}};V||l(ee),this.emitter=new C(ee),V&&V.add(this.emitter)}beginUpdate(x){this._counter++}handleChange(x,V){this._hasChanged=!0}endUpdate(x){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function O(M,x){return new G(M,x).emitter.event}u.fromObservable=O})(E=e.Event||(e.Event={}));class I{constructor(l){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${l}_${I._idPool++}`,I.all.add(this)}start(l){this._stopWatch=new T.StopWatch(!0),this.listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this.durations.push(l),this.elapsedOverall+=l,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=I,I.all=new Set,I._idPool=0;let b=-1;function p(u){const l=b;return b=u,{dispose(){b=l}}}e.setGlobalLeakWarningThreshold=p;class v{constructor(l,m=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=m,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l,m){let y=b;if(typeof this.customThreshold=="number"&&(y=this.customThreshold),y<=0||m<y)return;this._stacks||(this._stacks=new Map);const _=this._stacks.get(l.value)||0;if(this._stacks.set(l.value,_+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=y*.5;let $,A=0;for(const[U,k]of this._stacks)(!$||A<k)&&($=U,A=k);console.warn(`[${this.name}] potential listener LEAK detected, having ${m} listeners already. MOST frequent listener (${A}):`),console.warn($)}return()=>{const $=this._stacks.get(l.value)||0;this._stacks.set(l.value,$-1)}}}class h{static create(){return new h(new Error().stack??"")}constructor(l){this.value=l}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class S{constructor(l,m,y){this.callback=l,this.callbackThis=m,this.stack=y,this.subscription=new R.SafeDisposable}invoke(l){this.callback.call(this.callbackThis,l)}}class C{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=b>0?new v(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new I(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(P){const l=Array.from(this._listeners);queueMicrotask(()=>{for(const m of l)m.subscription.isset()&&(m.subscription.unset(),m.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(l,m,y)=>{this._listeners||(this._listeners=new L.LinkedList);const _=this._listeners.isEmpty();_&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let $,A;this._leakageMon&&this._listeners.size>=30&&(A=h.create(),$=this._leakageMon.check(A,this._listeners.size+1)),P&&(A=A??h.create());const U=new S(l,m,A),k=this._listeners.push(U);_&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,m);const N=U.subscription.set(()=>{$?.(),this._disposed||(k(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return y instanceof R.DisposableStore?y.add(N):Array.isArray(y)&&y.push(N),N}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new f);for(const m of this._listeners)this._deliveryQueue.push(this,m,l);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=C;class g{constructor(){this._queue=new L.LinkedList}get size(){return this._queue.size}push(l,m,y){this._queue.push(new a(l,m,y))}clear(l){const m=new L.LinkedList;for(const y of this._queue)y.emitter!==l&&m.push(y);this._queue=m}deliver(){for(;this._queue.size>0;){const l=this._queue.shift();try{l.listener.invoke(l.event)}catch(m){(0,D.onUnexpectedError)(m)}}}}e.EventDeliveryQueue=g;class f extends g{clear(l){this._queue.clear()}}class a{constructor(l,m,y){this.emitter=l,this.listener=m,this.event=y}}class d extends C{async fireAsync(l,m,y){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new L.LinkedList);for(const _ of this._listeners)this._asyncDeliveryQueue.push([_,l]);for(;this._asyncDeliveryQueue.size>0&&!m.isCancellationRequested;){const[_,$]=this._asyncDeliveryQueue.shift(),A=[],U={...$,token:m,waitUntil:k=>{if(Object.isFrozen(A))throw new Error("waitUntil can NOT be called asynchronous");y&&(k=y(k,_.callback)),A.push(k)}};try{_.invoke(U)}catch(k){(0,D.onUnexpectedError)(k);continue}Object.freeze(A),await Promise.allSettled(A).then(k=>{for(const N of k)N.status==="rejected"&&(0,D.onUnexpectedError)(N.reason)})}}}}e.AsyncEmitter=d;class c extends C{constructor(l){super(l),this._isPaused=0,this._eventQueue=new L.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=c;class i extends c{constructor(l){super(l),this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=i;class o extends C{constructor(l){super(l),this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){!this.hasListeners()||(this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(m=>super.fire(m)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=o;class t{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new C({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const m={event:l,listener:null};this.events.push(m),this.hasListeners&&this.hook(m);const y=()=>{this.hasListeners&&this.unhook(m);const _=this.events.indexOf(m);this.events.splice(_,1)};return(0,R.toDisposable)((0,r.once)(y))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(m=>this.emitter.fire(m))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=t;class n{constructor(){this.buffers=[]}wrapEvent(l){return(m,y,_)=>l($=>{const A=this.buffers[this.buffers.length-1];A?A.push(()=>m.call(y,$)):m.call(y,$)},void 0,_)}bufferEvents(l){const m=[];this.buffers.push(m);const y=l();return this.buffers.pop(),m.forEach(_=>_()),y}}e.EventBufferer=n;class s{constructor(){this.listening=!1,this.inputEvent=E.None,this.inputEventListener=R.Disposable.None,this.emitter=new C({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=s}),define(ne[22],re([0,1,3]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const r=Object.freeze(function(P,w){const E=setTimeout(P.bind(w),0);return{dispose(){clearTimeout(E)}}});var R;(function(P){function w(E){return E===P.None||E===P.Cancelled||E instanceof L?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}P.isCancellationToken=w,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:r})})(R=e.CancellationToken||(e.CancellationToken={}));class L{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?r:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(w){this._token=void 0,this._parentListener=void 0,this._parentListener=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new L),this._token}cancel(){this._token?this._token instanceof L&&this._token.cancel():this._token=R.Cancelled}dispose(w=!1){w&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof L&&this._token.dispose():this._token=R.None}}e.CancellationTokenSource=T}),define(ne[130],re([0,1,22]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class r{constructor(P){this.task=P,this.result=null}get(){if(this.result)return this.result;const P=new D.CancellationTokenSource,w=this.task(P.token);return this.result={promise:w,dispose:()=>{this.result=null,P.cancel(),P.dispose()}},this.result}}e.Cache=r;class R{constructor(P){this.fn=P,this.lastCache=void 0,this.lastArgKey=void 0}get(P){const w=JSON.stringify(P);return this.lastArgKey!==w&&(this.lastArgKey=w,this.lastCache=this.fn(P)),this.lastCache}}e.LRUCachedFunction=R;class L{get cachedValues(){return this._map}constructor(P){this.fn=P,this._map=new Map}get(P){if(this._map.has(P))return this._map.get(P);const w=this.fn(P);return this._map.set(P,w),w}}e.CachedFunction=L}),define(ne[83],re([0,1,3,2]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const R=T=>({onDidChange:D.Event.None,value:T});e.staticObservableValue=R;class L extends r.Disposable{get value(){return this._value}set value(P){P!==this._value&&(this._value=P,this.changeEmitter.fire(P))}constructor(P){super(),this._value=P,this.changeEmitter=this._register(new D.Emitter),this.onDidChange=this.changeEmitter.event}}e.MutableObservableValue=L}),define(ne[27],re([0,1,130,116]),function(Q,e,D,r){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function L(te){return!te||typeof te!="string"?!0:te.trim().length===0}e.isFalsyOrWhitespace=L;const T=/{(\d+)}/g;function P(te,...le){return le.length===0?te:te.replace(T,function(he,me){const Se=parseInt(me,10);return isNaN(Se)||Se<0||Se>=le.length?he:le[Se]})}e.format=P;const w=/{([^}]+)}/g;function E(te,le){return te.replace(w,(he,me)=>le[me]??he)}e.format2=E;function I(te){return te.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}e.escape=I;function b(te){return te.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=b;function p(te,le){let he=0;const me=le.charCodeAt(0);for(let Se=te.length-1;Se>=0;Se--)te.charCodeAt(Se)===me&&he++;return he}e.count=p;function v(te,le,he="\u2026"){return te.length<=le?te:`${te.substr(0,le)}${he}`}e.truncate=v;function h(te,le=" "){const he=S(te,le);return C(he,le)}e.trim=h;function S(te,le){if(!te||!le)return te;const he=le.length;if(he===0||te.length===0)return te;let me=0;for(;te.indexOf(le,me)===me;)me=me+he;return te.substring(me)}e.ltrim=S;function C(te,le){if(!te||!le)return te;const he=le.length,me=te.length;if(he===0||me===0)return te;let Se=me,Pe=-1;for(;Pe=te.lastIndexOf(le,Se-1),!(Pe===-1||Pe+he!==Se);){if(Pe===0)return"";Se=Pe}return te.substring(0,Se)}e.rtrim=C;function g(te){return te.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=g;function f(te){return te.replace(/\*/g,"")}e.stripWildcards=f;function a(te,le,he={}){if(!te)throw new Error("Cannot create regex from empty string");le||(te=b(te)),he.wholeWord&&(/\B/.test(te.charAt(0))||(te="\\b"+te),/\B/.test(te.charAt(te.length-1))||(te=te+"\\b"));let me="";return he.global&&(me+="g"),he.matchCase||(me+="i"),he.multiline&&(me+="m"),he.unicode&&(me+="u"),new RegExp(te,me)}e.createRegExp=a;function d(te){return te.source==="^"||te.source==="^$"||te.source==="$"||te.source==="^\\s*$"?!1:!!(te.exec("")&&te.lastIndex===0)}e.regExpLeadsToEndlessLoop=d;function c(te){return!!te.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function i(te){return(te.global?"g":"")+(te.ignoreCase?"i":"")+(te.multiline?"m":"")+(te.unicode?"u":"")}e.regExpFlags=i;function o(te){return te.split(/\r\n|\r|\n/)}e.splitLines=o;function t(te){for(let le=0,he=te.length;le<he;le++){const me=te.charCodeAt(le);if(me!==32&&me!==9)return le}return-1}e.firstNonWhitespaceIndex=t;function n(te,le=0,he=te.length){for(let me=le;me<he;me++){const Se=te.charCodeAt(me);if(Se!==32&&Se!==9)return te.substring(le,me)}return te.substring(le,he)}e.getLeadingWhitespace=n;function s(te,le=te.length-1){for(let he=le;he>=0;he--){const me=te.charCodeAt(he);if(me!==32&&me!==9)return he}return-1}e.lastNonWhitespaceIndex=s;function u(te,le,he){const me=[];let Se=0;for(const Pe of te.matchAll(le)){if(me.push(te.slice(Se,Pe.index)),Pe.index===void 0)throw new Error("match.index should be defined");Se=Pe.index+Pe[0].length,me.push(he(Pe[0],...Pe.slice(1),Pe.index,te,Pe.groups))}return me.push(te.slice(Se)),Promise.all(me).then(Pe=>Pe.join(""))}e.replaceAsync=u;function l(te,le){return te<le?-1:te>le?1:0}e.compare=l;function m(te,le,he=0,me=te.length,Se=0,Pe=le.length){for(;he<me&&Se<Pe;he++,Se++){const Fe=te.charCodeAt(he),Te=le.charCodeAt(Se);if(Fe<Te)return-1;if(Fe>Te)return 1}const De=me-he,Be=Pe-Se;return De<Be?-1:De>Be?1:0}e.compareSubstring=m;function y(te,le){return _(te,le,0,te.length,0,le.length)}e.compareIgnoreCase=y;function _(te,le,he=0,me=te.length,Se=0,Pe=le.length){for(;he<me&&Se<Pe;he++,Se++){let Fe=te.charCodeAt(he),Te=le.charCodeAt(Se);if(Fe===Te)continue;if(Fe>=128||Te>=128)return m(te.toLowerCase(),le.toLowerCase(),he,me,Se,Pe);A(Fe)&&(Fe-=32),A(Te)&&(Te-=32);const qe=Fe-Te;if(qe!==0)return qe}const De=me-he,Be=Pe-Se;return De<Be?-1:De>Be?1:0}e.compareSubstringIgnoreCase=_;function $(te){return te>=48&&te<=57}e.isAsciiDigit=$;function A(te){return te>=97&&te<=122}e.isLowerAsciiLetter=A;function U(te){return te>=65&&te<=90}e.isUpperAsciiLetter=U;function k(te,le){return te.length===le.length&&_(te,le)===0}e.equalsIgnoreCase=k;function N(te,le){const he=le.length;return le.length>te.length?!1:_(te,le,0,he)===0}e.startsWithIgnoreCase=N;function F(te,le){const he=Math.min(te.length,le.length);let me;for(me=0;me<he;me++)if(te.charCodeAt(me)!==le.charCodeAt(me))return me;return he}e.commonPrefixLength=F;function q(te,le){const he=Math.min(te.length,le.length);let me;const Se=te.length-1,Pe=le.length-1;for(me=0;me<he;me++)if(te.charCodeAt(Se-me)!==le.charCodeAt(Pe-me))return me;return he}e.commonSuffixLength=q;function J(te){return 55296<=te&&te<=56319}e.isHighSurrogate=J;function j(te){return 56320<=te&&te<=57343}e.isLowSurrogate=j;function H(te,le){return(te-55296<<10)+(le-56320)+65536}e.computeCodePoint=H;function W(te,le,he){const me=te.charCodeAt(he);if(J(me)&&he+1<le){const Se=te.charCodeAt(he+1);if(j(Se))return H(me,Se)}return me}e.getNextCodePoint=W;function z(te,le){const he=te.charCodeAt(le-1);if(j(he)&&le>1){const me=te.charCodeAt(le-2);if(J(me))return H(me,he)}return he}class K{get offset(){return this._offset}constructor(le,he=0){this._str=le,this._len=le.length,this._offset=he}setOffset(le){this._offset=le}prevCodePoint(){const le=z(this._str,this._offset);return this._offset-=le>=65536?2:1,le}nextCodePoint(){const le=W(this._str,this._len,this._offset);return this._offset+=le>=65536?2:1,le}eol(){return this._offset>=this._len}}e.CodePointIterator=K;class X{get offset(){return this._iterator.offset}constructor(le,he=0){this._iterator=new K(le,he)}nextGraphemeLength(){const le=Le.getInstance(),he=this._iterator,me=he.offset;let Se=le.getGraphemeBreakType(he.nextCodePoint());for(;!he.eol();){const Pe=he.offset,De=le.getGraphemeBreakType(he.nextCodePoint());if(be(Se,De)){he.setOffset(Pe);break}Se=De}return he.offset-me}prevGraphemeLength(){const le=Le.getInstance(),he=this._iterator,me=he.offset;let Se=le.getGraphemeBreakType(he.prevCodePoint());for(;he.offset>0;){const Pe=he.offset,De=le.getGraphemeBreakType(he.prevCodePoint());if(be(De,Se)){he.setOffset(Pe);break}Se=De}return me-he.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=X;function ce(te,le){return new X(te,le).nextGraphemeLength()}e.nextCharLength=ce;function B(te,le){return new X(te,le).prevGraphemeLength()}e.prevCharLength=B;function G(te,le){le>0&&j(te.charCodeAt(le))&&le--;const he=le+ce(te,le);return[he-B(te,he),he]}e.getCharContainingOffset=G;function O(te){const le=new X(te);let he=0;for(;!le.eol();)he++,le.nextGraphemeLength();return he}e.charCount=O;let M;function x(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function V(te){return M||(M=x()),M.test(te)}e.containsRTL=V;const ee=/^[\t\n\r\x20-\x7E]*$/;function oe(te){return ee.test(te)}e.isBasicASCII=oe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Z(te){return e.UNUSUAL_LINE_TERMINATORS.test(te)}e.containsUnusualLineTerminators=Z;function ie(te){return te>=11904&&te<=55215||te>=63744&&te<=64255||te>=65281&&te<=65374}e.isFullWidthCharacter=ie;function se(te){return te>=127462&&te<=127487||te===8986||te===8987||te===9200||te===9203||te>=9728&&te<=10175||te===11088||te===11093||te>=127744&&te<=128591||te>=128640&&te<=128764||te>=128992&&te<=129008||te>=129280&&te<=129535||te>=129648&&te<=129782}e.isEmojiImprecise=se;function ue(te,le){if(te.length<le)return te;const he=/\b/g;let me=0;for(;he.test(te)&&!(te.length-he.lastIndex<le);)me=he.lastIndex,he.lastIndex+=1;return te.substring(me).replace(/^\s/,"")}e.lcut=ue;const de=/\x1B\x5B[12]?K/g,ve=/\x1b\[\d+m/g,we=/\x1b\[0?m/g;function Ee(te){return te&&(te=te.replace(de,""),te=te.replace(ve,""),te=te.replace(we,"")),te}e.removeAnsiEscapeCodes=Ee,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ce(te){return!!(te&&te.length>0&&te.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ce;function Ue(te){return Ce(te)?te.substr(1):te}e.stripUTF8BOM=Ue;function $e(te,le){if(!te||!le||te.length<le.length)return!1;const he=le.length,me=te.toLowerCase();let Se=0,Pe=-1;for(;Se<he;){const De=me.indexOf(le[Se],Pe+1);if(De<0)return!1;Pe=De,Se++}return!0}e.fuzzyContains=$e;function He(te,le=!1){return te?(le&&(te=te.replace(/\\./g,"")),te.toLowerCase()!==te):!1}e.containsUppercaseCharacter=He;function We(te){return te.charAt(0).toUpperCase()+te.slice(1)}e.uppercaseFirstLetter=We;function ae(te,le=1){if(le===0)return"";let he=-1;do he=te.indexOf(`
`,he+1),le--;while(le>0&&he>=0);return he===-1?te:(te[he-1]==="\r"&&he--,te.substr(0,he))}e.getNLines=ae;function fe(te){return te=te%(2*26),te<26?String.fromCharCode(97+te):String.fromCharCode(65+te-26)}e.singleLetterHash=fe;function ge(te){return Le.getInstance().getGraphemeBreakType(te)}e.getGraphemeBreakType=ge;function be(te,le){return te===0?le!==5&&le!==7:te===2&&le===3?!1:te===4||te===2||te===3||le===4||le===2||le===3?!0:!(te===8&&(le===8||le===9||le===11||le===12)||(te===11||te===9)&&(le===9||le===10)||(te===12||te===10)&&le===10||le===5||le===13||le===7||te===1||te===13&&le===14||te===6&&le===6)}var Ie;(function(te){te[te.Other=0]="Other",te[te.Prepend=1]="Prepend",te[te.CR=2]="CR",te[te.LF=3]="LF",te[te.Control=4]="Control",te[te.Extend=5]="Extend",te[te.Regional_Indicator=6]="Regional_Indicator",te[te.SpacingMark=7]="SpacingMark",te[te.L=8]="L",te[te.V=9]="V",te[te.T=10]="T",te[te.LV=11]="LV",te[te.LVT=12]="LVT",te[te.ZWJ=13]="ZWJ",te[te.Extended_Pictographic=14]="Extended_Pictographic"})(Ie=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Le{static getInstance(){return Le._INSTANCE||(Le._INSTANCE=new Le),Le._INSTANCE}constructor(){this._data=Re()}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const he=this._data,me=he.length/3;let Se=1;for(;Se<=me;)if(le<he[3*Se])Se=2*Se;else if(le>he[3*Se+1])Se=2*Se+1;else return he[3*Se+2];return 0}}Le._INSTANCE=null;function Re(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ne(te,le){if(te===0)return 0;const he=Ae(te,le);if(he!==void 0)return he;const me=new K(le,te);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=Ne;function Ae(te,le){const he=new K(le,te);let me=he.prevCodePoint();for(;Me(me)||me===65039||me===8419;){if(he.offset===0)return;me=he.prevCodePoint()}if(!se(me))return;let Se=he.offset;return Se>0&&he.prevCodePoint()===8205&&(Se=he.offset),Se}function Me(te){return 127995<=te&&te<=127999}var ze;(function(te){te[te.zwj=8205]="zwj",te[te.emojiVariantSelector=65039]="emojiVariantSelector",te[te.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.noBreakWhitespace="\xA0";class ke{static getInstance(le){return ke.cache.get(Array.from(le))}static getLocales(){return ke._locales.getValue()}constructor(le){this.confusableDictionary=le}isAmbiguous(le){return this.confusableDictionary.has(le)}getPrimaryConfusable(le){return this.confusableDictionary.get(le)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=ke,R=ke,ke.ambiguousCharacterData=new r.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ke.cache=new D.LRUCachedFunction(te=>{function le(Te){const qe=new Map;for(let xe=0;xe<Te.length;xe+=2)qe.set(Te[xe],Te[xe+1]);return qe}function he(Te,qe){const xe=new Map(Te);for(const[Ze,rt]of qe)xe.set(Ze,rt);return xe}function me(Te,qe){if(!Te)return qe;const xe=new Map;for(const[Ze,rt]of Te)qe.has(Ze)&&xe.set(Ze,rt);return xe}const Se=R.ambiguousCharacterData.getValue();let Pe=te.filter(Te=>!Te.startsWith("_")&&Te in Se);Pe.length===0&&(Pe=["_default"]);let De;for(const Te of Pe){const qe=le(Se[Te]);De=me(De,qe)}const Be=le(Se._common),Fe=he(Be,De);return new ke(Fe)}),ke._locales=new r.Lazy(()=>Object.keys(ke.ambiguousCharacterData.getValue()).filter(te=>!te.startsWith("_")));class _e{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(_e.getRawData())),this._data}static isInvisibleCharacter(le){return _e.getData().has(le)}static get codePoints(){return _e.getData()}}e.InvisibleCharacters=_e,_e._data=void 0}),define(ne[47],re([0,1,12,4,27,15]),function(Q,e,D,r,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(s){return s===47||s===92}e.isPathSeparator=T;function P(s){return s.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=P;function w(s){return s.indexOf("/")===-1&&(s=P(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=w;function E(s,u=D.posix.sep){if(!s)return"";const l=s.length,m=s.charCodeAt(0);if(T(m)){if(T(s.charCodeAt(1))&&!T(s.charCodeAt(2))){let _=3;const $=_;for(;_<l&&!T(s.charCodeAt(_));_++);if($!==_&&!T(s.charCodeAt(_+1))){for(_+=1;_<l;_++)if(T(s.charCodeAt(_)))return s.slice(0,_+1).replace(/[\\/]/g,u)}}return u}else if(g(m)&&s.charCodeAt(1)===58)return T(s.charCodeAt(2))?s.slice(0,2)+u:s.slice(0,2);let y=s.indexOf("://");if(y!==-1){for(y+=3;y<l;y++)if(T(s.charCodeAt(y)))return s.slice(0,y+1)}return""}e.getRoot=E;function I(s){if(!r.isWindows||!s||s.length<5)return!1;let u=s.charCodeAt(0);if(u!==92||(u=s.charCodeAt(1),u!==92))return!1;let l=2;const m=l;for(;l<s.length&&(u=s.charCodeAt(l),u!==92);l++);return!(m===l||(u=s.charCodeAt(l+1),isNaN(u)||u===92))}e.isUNC=I;const b=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(s,u=r.isWindows){const l=u?b:p;return!(!s||s.length===0||/^\s+$/.test(s)||(l.lastIndex=0,l.test(s))||u&&v.test(s)||s==="."||s===".."||u&&s[s.length-1]==="."||u&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=h;function S(s,u,l){const m=s===u;return!l||m?m:!s||!u?!1:(0,R.equalsIgnoreCase)(s,u)}e.isEqual=S;function C(s,u,l,m=D.sep){if(s===u)return!0;if(!s||!u||u.length>s.length)return!1;if(l){if(!(0,R.startsWithIgnoreCase)(s,u))return!1;if(u.length===s.length)return!0;let _=u.length;return u.charAt(u.length-1)===m&&_--,s.charAt(_)===m}return u.charAt(u.length-1)!==m&&(u+=m),s.indexOf(u)===0}e.isEqualOrParent=C;function g(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=g;function f(s,u){return r.isWindows&&s.endsWith(":")&&(s+=D.sep),(0,D.isAbsolute)(s)||(s=(0,D.join)(u,s)),s=(0,D.normalize)(s),r.isWindows?(s=(0,R.rtrim)(s,D.sep),s.endsWith(":")&&(s+=D.sep)):(s=(0,R.rtrim)(s,D.sep),s||(s=D.sep)),s}e.sanitizeFilePath=f;function a(s){const u=(0,D.normalize)(s);return r.isWindows?s.length>3?!1:d(u)&&(s.length===2||u.charCodeAt(2)===92):u===D.posix.sep}e.isRootOrDriveLetter=a;function d(s,u=r.isWindows){return u?g(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=d;function c(s){return d(s)?s[0]:void 0}e.getDriveLetter=c;function i(s,u,l){return u.length>s.length?-1:s===u?0:(l&&(s=s.toLowerCase(),u=u.toLowerCase()),s.indexOf(u))}e.indexOfPath=i;function o(s){const u=s.split(":");let l,m,y;for(const _ of u){const $=Number(_);(0,L.isNumber)($)?m===void 0?m=$:y===void 0&&(y=$):l=l?[l,_].join(":"):_}if(!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:m!==void 0?m:void 0,column:y!==void 0?y:m!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(s,u,l=8){let m="";for(let _=0;_<l;_++)m+=t.charAt(Math.floor(Math.random()*t.length));let y;return u?y=`${u}-${m}`:y=m,s?(0,D.join)(s,y):y}e.randomPath=n}),define(ne[65],re([0,1,27]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function r(g){return R(g,0)}e.hash=r;function R(g,f){switch(typeof g){case"object":return g===null?L(349,f):Array.isArray(g)?w(g,f):E(g,f);case"string":return P(g,f);case"boolean":return T(g,f);case"number":return L(g,f);case"undefined":return L(937,f);default:return L(617,f)}}e.doHash=R;function L(g,f){return(f<<5)-f+g|0}e.numberHash=L;function T(g,f){return L(g?433:863,f)}function P(g,f){f=L(149417,f);for(let a=0,d=g.length;a<d;a++)f=L(g.charCodeAt(a),f);return f}e.stringHash=P;function w(g,f){return f=L(104579,f),g.reduce((a,d)=>R(d,a),f)}function E(g,f){return f=L(181387,f),Object.keys(g).sort().reduce((a,d)=>(a=P(d,a),R(g[d],a)),f)}class I{constructor(){this._value=0}get value(){return this._value}hash(f){return this._value=R(f,this._value),this._value}}e.Hasher=I;var b;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function p(g,f,a=32){const d=a-f,c=~((1<<d)-1);return(g<<f|(c&g)>>>d)>>>0}function v(g,f=0,a=g.byteLength,d=0){for(let c=0;c<a;c++)g[f+c]=d}function h(g,f,a="0"){for(;g.length<f;)g=a+g;return g}function S(g,f=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(a=>a.toString(16).padStart(2,"0")).join(""):h((g>>>0).toString(16),f/4)}e.toHexString=S;class C{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(f){const a=f.length;if(a===0)return;const d=this._buff;let c=this._buffLen,i=this._leftoverHighSurrogate,o,t;for(i!==0?(o=i,t=-1,i=0):(o=f.charCodeAt(0),t=0);;){let n=o;if(D.isHighSurrogate(o))if(t+1<a){const s=f.charCodeAt(t+1);D.isLowSurrogate(s)?(t++,n=D.computeCodePoint(o,s)):n=65533}else{i=o;break}else D.isLowSurrogate(o)&&(n=65533);if(c=this._push(d,c,n),t++,t<a)o=f.charCodeAt(t);else break}this._buffLen=c,this._leftoverHighSurrogate=i}_push(f,a,d){return d<128?f[a++]=d:d<2048?(f[a++]=192|(d&1984)>>>6,f[a++]=128|(d&63)>>>0):d<65536?(f[a++]=224|(d&61440)>>>12,f[a++]=128|(d&4032)>>>6,f[a++]=128|(d&63)>>>0):(f[a++]=240|(d&1835008)>>>18,f[a++]=128|(d&258048)>>>12,f[a++]=128|(d&4032)>>>6,f[a++]=128|(d&63)>>>0),a>=64&&(this._step(),a-=64,this._totalLen+=64,f[0]=f[64+0],f[1]=f[64+1],f[2]=f[64+2]),a}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),S(this._h0)+S(this._h1)+S(this._h2)+S(this._h3)+S(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,v(this._buff,this._buffLen),this._buffLen>56&&(this._step(),v(this._buff));const f=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(f/4294967296),!1),this._buffDV.setUint32(60,f%4294967296,!1),this._step()}_step(){const f=C._bigBlock32,a=this._buffDV;for(let l=0;l<64;l+=4)f.setUint32(l,a.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)f.setUint32(l,p(f.getUint32(l-12,!1)^f.getUint32(l-32,!1)^f.getUint32(l-56,!1)^f.getUint32(l-64,!1),1),!1);let d=this._h0,c=this._h1,i=this._h2,o=this._h3,t=this._h4,n,s,u;for(let l=0;l<80;l++)l<20?(n=c&i|~c&o,s=1518500249):l<40?(n=c^i^o,s=1859775393):l<60?(n=c&i|c&o|i&o,s=2400959708):(n=c^i^o,s=3395469782),u=p(d,5)+n+t+s+f.getUint32(l*4,!1)&4294967295,t=o,o=i,i=p(c,30),c=d,d=u;this._h0=this._h0+d&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+t&4294967295}}e.StringSHA1=C,C._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ne[34],re([0,1,18,27]),function(Q,e,D,r){"use strict";var R,L,T;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(t,n,s){let u=t.get(n);return u===void 0&&(u=s,t.set(n,u)),u}e.getOrSet=P;function w(t){const n=[];return t.forEach((s,u)=>{n.push(`${u} => ${s}`)}),`Map(${t.size}) {${n.join(", ")}}`}e.mapToString=w;function E(t){const n=[];return t.forEach(s=>{n.push(s)}),`Set(${t.size}) {${n.join(", ")}}`}e.setToString=E;class I{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const s=n.charCodeAt(0),u=this._value.charCodeAt(this._pos);return s-u}value(){return this._value[this._pos]}}e.StringIterator=I;class b{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,r.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,r.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=b;class p{constructor(n=!0,s=!0){this._splitOnBackslash=n,this._caseSensitive=s}reset(n){this._from=0,this._to=0,this._value=n,this._valueLen=n.length;for(let s=n.length-1;s>=0;s--,this._valueLen--){const u=this._value.charCodeAt(s);if(!(u===47||this._splitOnBackslash&&u===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let n=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,r.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,r.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=p;var v;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(v||(v={}));class h{constructor(n,s){this._ignorePathCasing=n,this._ignoreQueryAndFragment=s,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new p(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(n)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,r.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,r.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,r.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,r.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(t){t[t.Left=-1]="Left",t[t.Mid=0]="Mid",t[t.Right=1]="Right"})(C||(C={}));class g{static forUris(n=()=>!1,s=()=>!1){return new g(new h(n,s))}static forPaths(n=!1){return new g(new p(void 0,!n))}static forStrings(){return new g(new I)}static forConfigKeys(){return new g(new b)}constructor(n){this._iter=n}clear(){this._root=void 0}fill(n,s){if(s){const u=s.slice(0);(0,D.shuffle)(u);for(const l of u)this.set(l,n)}else{const u=n.slice(0);(0,D.shuffle)(u);for(const l of u)this.set(l[0],l[1])}}set(n,s){const u=this._iter.reset(n);let l;this._root||(this._root=new S,this._root.segment=u.value());const m=[];for(l=this._root;;){const _=u.cmp(l.segment);if(_>0)l.left||(l.left=new S,l.left.segment=u.value()),m.push([-1,l]),l=l.left;else if(_<0)l.right||(l.right=new S,l.right.segment=u.value()),m.push([1,l]),l=l.right;else if(u.hasNext())u.next(),l.mid||(l.mid=new S,l.mid.segment=u.value()),m.push([0,l]),l=l.mid;else break}const y=l.value;l.value=s,l.key=n;for(let _=m.length-1;_>=0;_--){const $=m[_][1];$.updateHeight();const A=$.balanceFactor();if(A<-1||A>1){const U=m[_][0],k=m[_+1][0];if(U===1&&k===1)m[_][1]=$.rotateLeft();else if(U===-1&&k===-1)m[_][1]=$.rotateRight();else if(U===1&&k===-1)$.right=m[_+1][1]=m[_+1][1].rotateRight(),m[_][1]=$.rotateLeft();else if(U===-1&&k===1)$.left=m[_+1][1]=m[_+1][1].rotateLeft(),m[_][1]=$.rotateRight();else throw new Error;if(_>0)switch(m[_-1][0]){case-1:m[_-1][1].left=m[_][1];break;case 1:m[_-1][1].right=m[_][1];break;case 0:m[_-1][1].mid=m[_][1];break}else this._root=m[0][1]}}return y}get(n){return this._getNode(n)?.value}_getNode(n){const s=this._iter.reset(n);let u=this._root;for(;u;){const l=s.cmp(u.segment);if(l>0)u=u.left;else if(l<0)u=u.right;else if(s.hasNext())s.next(),u=u.mid;else break}return u}has(n){const s=this._getNode(n);return!(s?.value===void 0&&s?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,s){const u=this._iter.reset(n),l=[];let m=this._root;for(;m;){const y=u.cmp(m.segment);if(y>0)l.push([-1,m]),m=m.left;else if(y<0)l.push([1,m]),m=m.right;else if(u.hasNext())u.next(),l.push([0,m]),m=m.mid;else break}if(!!m){if(s?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const y=this._min(m.right);if(y.key){const{key:_,value:$,segment:A}=y;this._delete(y.key,!1),m.key=_,m.value=$,m.segment=A}}else{const y=m.left??m.right;if(l.length>0){const[_,$]=l[l.length-1];switch(_){case-1:$.left=y;break;case 0:$.mid=y;break;case 1:$.right=y;break}}else this._root=y}for(let y=l.length-1;y>=0;y--){const _=l[y][1];_.updateHeight();const $=_.balanceFactor();if($>1?(_.right.balanceFactor()>=0||(_.right=_.right.rotateRight()),l[y][1]=_.rotateLeft()):$<-1&&(_.left.balanceFactor()<=0||(_.left=_.left.rotateLeft()),l[y][1]=_.rotateRight()),y>0)switch(l[y-1][0]){case-1:l[y-1][1].left=l[y][1];break;case 1:l[y-1][1].right=l[y][1];break;case 0:l[y-1][1].mid=l[y][1];break}else this._root=l[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const s=this._iter.reset(n);let u=this._root,l;for(;u;){const m=s.cmp(u.segment);if(m>0)u=u.left;else if(m<0)u=u.right;else if(s.hasNext())s.next(),l=u.value||l,u=u.mid;else break}return u&&u.value||l}findSuperstr(n){const s=this._iter.reset(n);let u=this._root;for(;u;){const l=s.cmp(u.segment);if(l>0)u=u.left;else if(l<0)u=u.right;else if(s.hasNext())s.next(),u=u.mid;else return u.mid?this._entries(u.mid):void 0}}forEach(n){for(const[s,u]of this)n(u,s)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(n){const s=[];return this._dfsEntries(n,s),s[Symbol.iterator]()}_dfsEntries(n,s){!n||(n.left&&this._dfsEntries(n.left,s),n.value&&s.push([n.key,n.value]),n.mid&&this._dfsEntries(n.mid,s),n.right&&this._dfsEntries(n.right,s))}_isBalanced(){const n=s=>{if(!s)return!0;const u=s.balanceFactor();return u<-1||u>1?!1:n(s.left)&&n(s.right)};return n(this._root)}}e.TernarySearchTree=g;class f{constructor(n,s){this.uri=n,this.value=s}}class a{constructor(n,s){this[R]="ResourceMap",n instanceof a?(this.map=new Map(n.map),this.toKey=s??a.defaultToKey):(this.map=new Map,this.toKey=n??a.defaultToKey)}set(n,s){return this.map.set(this.toKey(n),new f(n,s)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,s){typeof s<"u"&&(n=n.bind(s));for(const[u,l]of this.map)n(l.value,l.uri,this)}*values(){for(const n of this.map.values())yield n.value}*keys(){for(const n of this.map.values())yield n.uri}*entries(){for(const n of this.map.values())yield[n.uri,n.value]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=a,a.defaultToKey=t=>t.toString();class d{constructor(n,s){this[L]="ResourceSet",!n||typeof n=="function"?this._map=new a(n):(this._map=new a(s),n.forEach(this.add,this))}get size(){return this._map.size}add(n){return this._map.set(n,n),this}clear(){this._map.clear()}delete(n){return this._map.delete(n)}forEach(n,s){this._map.forEach((u,l)=>n.call(s,l,l,this))}has(n){return this._map.has(n)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=d;var c;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(c=e.Touch||(e.Touch={}));class i{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,s=0){const u=this._map.get(n);if(!!u)return s!==0&&this.touch(u,s),u.value}set(n,s,u=0){let l=this._map.get(n);if(l)l.value=s,u!==0&&this.touch(l,u);else{switch(l={key:n,value:s,next:void 0,previous:void 0},u){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(n,l),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const s=this._map.get(n);if(!!s)return this._map.delete(n),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,s){const u=this._state;let l=this._head;for(;l;){if(s?n.bind(s)(l.value,l.key,this):n(l.value,l.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const n=this,s=this._state;let u=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const m={value:u.key,done:!1};return u=u.next,m}else return{value:void 0,done:!0}}};return l}values(){const n=this,s=this._state;let u=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const m={value:u.value,done:!1};return u=u.next,m}else return{value:void 0,done:!0}}};return l}entries(){const n=this,s=this._state;let u=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const m={value:[u.key,u.value],done:!1};return u=u.next,m}else return{value:void 0,done:!0}}};return l}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let s=this._head,u=this.size;for(;s&&u>n;)this._map.delete(s.key),s=s.next,u--;this._head=s,this._size=u,s&&(s.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const s=n.next,u=n.previous;if(!s||!u)throw new Error("Invalid list");s.previous=u,u.next=s}n.next=void 0,n.previous=void 0,this._state++}touch(n,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(n===this._head)return;const u=n.next,l=n.previous;n===this._tail?(l.next=void 0,this._tail=l):(u.previous=l,l.next=u),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(s===2){if(n===this._tail)return;const u=n.next,l=n.previous;n===this._head?(u.previous=void 0,this._head=u):(u.previous=l,l.next=u),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((s,u)=>{n.push([u,s])}),n}fromJSON(n){this.clear();for(const[s,u]of n)this.set(s,u)}}e.LinkedMap=i;class o extends i{constructor(n,s=1){super(),this._limit=n,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,s=2){return super.get(n,s)}peek(n){return super.get(n,0)}set(n,s){return super.set(n,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o}),define(ne[84],re([0,1,34]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const r=new D.LRUCache(1e4);function R(E){return w(E,"NFC",r)}e.normalizeNFC=R;const L=new D.LRUCache(1e4);function T(E){return w(E,"NFD",L)}e.normalizeNFD=T;const P=/[^\u0000-\u0080]/;function w(E,I,b){if(!E)return E;const p=b.get(E);if(p)return p;let v;return P.test(E)?v=E.normalize(I):v=E,b.set(E,v),v}e.removeAccents=function(){const E=/[\u0300-\u036f]/g;return function(I){return T(I).replace(E,"")}}()}),define(ne[85],re([0,1,27]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var r;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(r||(r={})),function(R){const L="error",T="warning",P="warn",w="info",E="ignore";function I(p){return p?D.equalsIgnoreCase(L,p)?R.Error:D.equalsIgnoreCase(T,p)||D.equalsIgnoreCase(P,p)?R.Warning:D.equalsIgnoreCase(w,p)?R.Info:R.Ignore:R.Ignore}R.fromValue=I;function b(p){switch(p){case R.Error:return L;case R.Warning:return T;case R.Info:return w;default:return E}}R.toString=b}(r||(r={})),e.default=r}),define(ne[7],re([0,1,12,4]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const R=/^\w[\w\d+.-]*$/,L=/^\//,T=/^\/\//;function P(t,n){if(!t.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!R.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!L.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(t,n){return!t&&!n?"file":t}function E(t,n){switch(t){case"https":case"http":case"file":n?n[0]!==b&&(n=b+n):n=b;break}return n}const I="",b="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{static isUri(n){return n instanceof v?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,s,u,l,m,y=!1){typeof n=="object"?(this.scheme=n.scheme||I,this.authority=n.authority||I,this.path=n.path||I,this.query=n.query||I,this.fragment=n.fragment||I):(this.scheme=w(n,y),this.authority=s||I,this.path=E(this.scheme,u||I),this.query=l||I,this.fragment=m||I,P(this,y))}get fsPath(){return a(this,!1)}with(n){if(!n)return this;let{scheme:s,authority:u,path:l,query:m,fragment:y}=n;return s===void 0?s=this.scheme:s===null&&(s=I),u===void 0?u=this.authority:u===null&&(u=I),l===void 0?l=this.path:l===null&&(l=I),m===void 0?m=this.query:m===null&&(m=I),y===void 0?y=this.fragment:y===null&&(y=I),s===this.scheme&&u===this.authority&&l===this.path&&m===this.query&&y===this.fragment?this:new S(s,u,l,m,y)}static parse(n,s=!1){const u=p.exec(n);return u?new S(u[2]||I,o(u[4]||I),o(u[5]||I),o(u[7]||I),o(u[9]||I),s):new S(I,I,I,I,I)}static file(n){let s=I;if(r.isWindows&&(n=n.replace(/\\/g,b)),n[0]===b&&n[1]===b){const u=n.indexOf(b,2);u===-1?(s=n.substring(2),n=b):(s=n.substring(2,u),n=n.substring(u)||b)}return new S("file",s,n,I,I)}static from(n){const s=new S(n.scheme,n.authority,n.path,n.query,n.fragment);return P(s,!0),s}static joinPath(n,...s){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let u;return r.isWindows&&n.scheme==="file"?u=v.file(D.win32.join(a(n,!0),...s)).path:u=D.posix.join(n.path,...s),n.with({path:u})}toString(n=!1){return d(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof v)return n;{const s=new S(n);return s._formatted=n.external,s._fsPath=n._sep===h?n.fsPath:null,s}}else return n}}e.URI=v;const h=r.isWindows?1:void 0;class S extends v{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(n=!1){return n?d(this,!0):(this._formatted||(this._formatted=d(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=h),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const C={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function g(t,n){let s,u=-1;for(let l=0;l<t.length;l++){const m=t.charCodeAt(l);if(m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57||m===45||m===46||m===95||m===126||n&&m===47)u!==-1&&(s+=encodeURIComponent(t.substring(u,l)),u=-1),s!==void 0&&(s+=t.charAt(l));else{s===void 0&&(s=t.substr(0,l));const y=C[m];y!==void 0?(u!==-1&&(s+=encodeURIComponent(t.substring(u,l)),u=-1),s+=y):u===-1&&(u=l)}}return u!==-1&&(s+=encodeURIComponent(t.substring(u))),s!==void 0?s:t}function f(t){let n;for(let s=0;s<t.length;s++){const u=t.charCodeAt(s);u===35||u===63?(n===void 0&&(n=t.substr(0,s)),n+=C[u]):n!==void 0&&(n+=t[s])}return n!==void 0?n:t}function a(t,n){let s;return t.authority&&t.path.length>1&&t.scheme==="file"?s=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?n?s=t.path.substr(1):s=t.path[1].toLowerCase()+t.path.substr(2):s=t.path,r.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=a;function d(t,n){const s=n?f:g;let u="",{scheme:l,authority:m,path:y,query:_,fragment:$}=t;if(l&&(u+=l,u+=":"),(m||l==="file")&&(u+=b,u+=b),m){let A=m.indexOf("@");if(A!==-1){const U=m.substr(0,A);m=m.substr(A+1),A=U.indexOf(":"),A===-1?u+=s(U,!1):(u+=s(U.substr(0,A),!1),u+=":",u+=s(U.substr(A+1),!1)),u+="@"}m=m.toLowerCase(),A=m.indexOf(":"),A===-1?u+=s(m,!1):(u+=s(m.substr(0,A),!1),u+=m.substr(A))}if(y){if(y.length>=3&&y.charCodeAt(0)===47&&y.charCodeAt(2)===58){const A=y.charCodeAt(1);A>=65&&A<=90&&(y=`/${String.fromCharCode(A+32)}:${y.substr(3)}`)}else if(y.length>=2&&y.charCodeAt(1)===58){const A=y.charCodeAt(0);A>=65&&A<=90&&(y=`${String.fromCharCode(A+32)}:${y.substr(2)}`)}u+=s(y,!0)}return _&&(u+="?",u+=s(_,!1)),$&&(u+="#",u+=n?$:g($,!1)),u}function c(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+c(t.substr(3)):t}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(t){return t.match(i)?t.replace(i,n=>c(n)):t}}),define(ne[131],re([0,1,7]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function r(E){const I=E;return I&&typeof I.type=="string"&&typeof I.severity=="string"}e.isRemoteConsoleLog=r;function R(E){const I=[];let b;try{const p=JSON.parse(E.arguments),v=p[p.length-1];v&&v.__$stack&&(p.pop(),b=v.__$stack),I.push(...p)}catch{I.push("Unable to log remote console arguments",E.arguments)}return{args:I,stack:b}}e.parse=R;function L(E){if(typeof E!="string")return L(R(E).stack);const I=E;if(I){const b=T(I),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(p&&p.length===4)return{uri:D.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.getFirstFrame=L;function T(E){if(!E)return E;const I=E.indexOf(`
`);return I===-1?E:E.substring(0,I)}function P(E,I){const{args:b,stack:p}=R(E),v=typeof b[0]=="string"&&b.length===1;let h=T(p);h&&(h=`(${h.trim()})`);let S=[];if(typeof b[0]=="string"?h&&v?S=[`%c[${I}] %c${b[0]} %c${h}`,w("blue"),w(""),w("grey")]:S=[`%c[${I}] %c${b[0]}`,w("blue"),w(""),...b.slice(1)]:S=[`%c[${I}]%`,w("blue"),...b],h&&!v&&S.push(h),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,S)}e.log=P;function w(E){return`color: ${E}`}}),define(ne[66],re([0,1,16,27,7]),function(Q,e,D,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(E){return JSON.stringify(E,P)}e.stringify=L;function T(E){let I=JSON.parse(E);return I=w(I),I}e.parse=T;function P(E,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,r.regExpFlags)(I)}:I}function w(E,I=0){if(!E||I>200)return E;if(typeof E=="object"){switch(E.$mid){case 1:return R.URI.revive(E);case 2:return new RegExp(E.source,E.flags);case 14:return new Date(E.source)}if(E instanceof D.VSBuffer||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let b=0;b<E.length;++b)E[b]=w(E[b],I+1);else for(const b in E)Object.hasOwnProperty.call(E,b)&&(E[b]=w(E[b],I+1))}return E}e.revive=w}),define(ne[23],re([0,1,4,7]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var R;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebook="vscode-notebook",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractive="vscode-interactive",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm"})(R=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class L{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(E){this._preferredWebSchema=E}setDelegate(E){this._delegate=E}setServerRootPath(E){this._remoteResourcesPath=`${E}/${R.vscodeRemoteResource}`}set(E,I,b){this._hosts[E]=I,this._ports[E]=b}setConnectionToken(E,I){this._connectionTokens[E]=I}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(E){if(this._delegate)return this._delegate(E);const I=E.authority;let b=this._hosts[I];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const p=this._ports[I],v=this._connectionTokens[I];let h=`path=${encodeURIComponent(E.path)}`;return typeof v=="string"&&(h+=`&${e.connectionTokenQueryName}=${encodeURIComponent(v)}`),r.URI.from({scheme:D.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${b}:${p}`,path:this._remoteResourcesPath,query:h})}}e.RemoteAuthorities=new L;class T{asBrowserUri(E,I){const b=this.toUri(E,I);return b.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(b):b.scheme===R.file&&(D.isNative||D.isWebWorker&&D.globals.origin===`${R.vscodeFileResource}://${T.FALLBACK_AUTHORITY}`)?b.with({scheme:R.vscodeFileResource,authority:b.authority||T.FALLBACK_AUTHORITY,query:null,fragment:null}):b}asFileUri(E,I){const b=this.toUri(E,I);return b.scheme===R.vscodeFileResource?b.with({scheme:R.file,authority:b.authority!==T.FALLBACK_AUTHORITY?b.authority:null,query:null,fragment:null}):b}toUri(E,I){return r.URI.isUri(E)?E:r.URI.parse(I.toUrl(E))}}T.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new T;var P;(function(w){const E=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);w.CoopAndCoep=Object.freeze(E.get("3"));const I="vscode-coi";function b(v){let h;typeof v=="string"?h=new URL(v).searchParams:v instanceof URL?h=v.searchParams:r.URI.isUri(v)&&(h=new URL(v.toString(!0)).searchParams);const S=h?.get(I);if(!!S)return E.get(S)}w.getHeadersFromQuery=b;function p(v,h,S){if(!globalThis.crossOriginIsolated)return;const C=h&&S?"3":S?"2":"1";v instanceof URLSearchParams?v.set(I,C):v[I]=C}w.addSearchParam=p})(P=e.COI||(e.COI={}))}),define(ne[19],re([0,1,47,23,12,4,27,7]),function(Q,e,D,r,R,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function w(v){return(0,P.uriToFsPath)(v,!0)}e.originalFSPath=w;class E{constructor(h){this._ignorePathCasing=h}compare(h,S,C=!1){return h===S?0:(0,T.compare)(this.getComparisonKey(h,C),this.getComparisonKey(S,C))}isEqual(h,S,C=!1){return h===S?!0:!h||!S?!1:this.getComparisonKey(h,C)===this.getComparisonKey(S,C)}getComparisonKey(h,S=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:S?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,S,C=!1){if(h.scheme===S.scheme){if(h.scheme===r.Schemas.file)return D.isEqualOrParent(w(h),w(S),this._ignorePathCasing(h))&&h.query===S.query&&(C||h.fragment===S.fragment);if((0,e.isEqualAuthority)(h.authority,S.authority))return D.isEqualOrParent(h.path,S.path,this._ignorePathCasing(h),"/")&&h.query===S.query&&(C||h.fragment===S.fragment)}return!1}joinPath(h,...S){return P.URI.joinPath(h,...S)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return R.posix.basename(h.path)}extname(h){return R.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let S;return h.scheme===r.Schemas.file?S=P.URI.file(R.dirname(w(h))).path:(S=R.posix.dirname(h.path),h.authority&&S.length&&S.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),S="/")),h.with({path:S})}normalizePath(h){if(!h.path.length)return h;let S;return h.scheme===r.Schemas.file?S=P.URI.file(R.normalize(w(h))).path:S=R.posix.normalize(h.path),h.with({path:S})}relativePath(h,S){if(h.scheme!==S.scheme||!(0,e.isEqualAuthority)(h.authority,S.authority))return;if(h.scheme===r.Schemas.file){const f=R.relative(w(h),w(S));return L.isWindows?D.toSlashes(f):f}let C=h.path||"/";const g=S.path||"/";if(this._ignorePathCasing(h)){let f=0;for(const a=Math.min(C.length,g.length);f<a&&!(C.charCodeAt(f)!==g.charCodeAt(f)&&C.charAt(f).toLowerCase()!==g.charAt(f).toLowerCase());f++);C=g.substr(0,f)+C.substr(f)}return R.posix.relative(C,g)}resolvePath(h,S){if(h.scheme===r.Schemas.file){const C=P.URI.file(R.resolve(w(h),S));return h.with({authority:C.authority,path:C.path})}return S=D.toPosixPath(S),h.with({path:R.posix.resolve(h.path,S)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,S){return h===S||h!==void 0&&S!==void 0&&(0,T.equalsIgnoreCase)(h,S)}hasTrailingPathSeparator(h,S=R.sep){if(h.scheme===r.Schemas.file){const C=w(h);return C.length>D.getRoot(C).length&&C[C.length-1]===S}else{const C=h.path;return C.length>1&&C.charCodeAt(C.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,S=R.sep){return(0,e.hasTrailingPathSeparator)(h,S)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,S=R.sep){let C=!1;if(h.scheme===r.Schemas.file){const g=w(h);C=g!==void 0&&g.length===D.getRoot(g).length&&g[g.length-1]===S}else{S="/";const g=h.path;C=g.length===1&&g.charCodeAt(g.length-1)===47}return!C&&!(0,e.hasTrailingPathSeparator)(h,S)?h.with({path:h.path+"/"}):h}}e.ExtUri=E,e.extUri=new E(()=>!1),e.extUriBiasedIgnorePathCase=new E(v=>v.scheme===r.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new E(v=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function I(v,h){const S=[];for(let C=0;C<v.length;C++){const g=h(v[C]);v.some((f,a)=>a===C?!1:(0,e.isEqualOrParent)(g,h(f)))||S.push(v[C])}return S}e.distinctParents=I;var b;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function h(S){const C=new Map;S.path.substring(S.path.indexOf(";")+1,S.path.lastIndexOf(";")).split(";").forEach(a=>{const[d,c]=a.split(":");d&&c&&C.set(d,c)});const f=S.path.substring(0,S.path.indexOf(";"));return f&&C.set(v.META_DATA_MIME,f),C}v.parseMetaData=h})(b=e.DataUri||(e.DataUri={}));function p(v,h,S){if(h){let C=v.path;return C&&C[0]!==R.posix.sep&&(C=R.posix.sep+C),v.with({scheme:S,authority:h,path:C})}return v.with({scheme:S})}e.toLocalResource=p}),define(ne[6],re([0,1,22,9,3,2,19,4]),function(Q,e,D,r,R,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function w(G){return!!G&&typeof G.then=="function"}e.isThenable=w;function E(G){const O=new D.CancellationTokenSource,M=G(O.token),x=new Promise((V,ee)=>{const oe=O.token.onCancellationRequested(()=>{oe.dispose(),O.dispose(),ee(new r.CancellationError)});Promise.resolve(M).then(Z=>{oe.dispose(),O.dispose(),V(Z)},Z=>{oe.dispose(),O.dispose(),ee(Z)})});return new class{cancel(){O.cancel()}then(V,ee){return x.then(V,ee)}catch(V){return this.then(void 0,V)}finally(V){return x.finally(V)}}}e.createCancelablePromise=E;function I(G,O,M){return new Promise((x,V)=>{const ee=O.onCancellationRequested(()=>{ee.dispose(),x(M)});G.then(x,V).finally(()=>ee.dispose())})}e.raceCancellation=I;function b(G,O){return new Promise((M,x)=>{const V=O.onCancellationRequested(()=>{V.dispose(),x(new r.CancellationError)});G.then(M,x).finally(()=>V.dispose())})}e.raceCancellationError=b;async function p(G){let O=-1;const M=G.map((V,ee)=>V.then(oe=>(O=ee,oe))),x=await Promise.race(M);return G.forEach((V,ee)=>{ee!==O&&V.cancel()}),x}e.raceCancellablePromises=p;function v(G,O,M){let x;const V=setTimeout(()=>{x?.(void 0),M?.()},O);return Promise.race([G.finally(()=>clearTimeout(V)),new Promise(ee=>x=ee)])}e.raceTimeout=v;function h(G){return new Promise((O,M)=>{const x=G();w(x)?x.then(O,M):O(x)})}e.asPromise=h;class S{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(O){if(this.activePromise){if(this.queuedPromiseFactory=O,!this.queuedPromise){const M=()=>{this.queuedPromise=null;const x=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,x};this.queuedPromise=new Promise(x=>{this.activePromise.then(M,M).then(x)})}return new Promise((M,x)=>{this.queuedPromise.then(M,x)})}return this.activePromise=O(),new Promise((M,x)=>{this.activePromise.then(V=>{this.activePromise=null,M(V)},V=>{this.activePromise=null,x(V)})})}}e.Throttler=S;class C{constructor(){this.current=Promise.resolve(null)}queue(O){return this.current=this.current.then(()=>O(),()=>O())}}e.Sequencer=C;class g{constructor(){this.promiseMap=new Map}queue(O,M){const V=(this.promiseMap.get(O)??Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.promiseMap.get(O)===V&&this.promiseMap.delete(O)});return this.promiseMap.set(O,V),V}}e.SequencerByKey=g;const f=(G,O)=>{let M=!0;const x=setTimeout(()=>{M=!1,O()},G);return{isTriggered:()=>M,dispose:()=>{clearTimeout(x),M=!1}}},a=G=>{let O=!0;return queueMicrotask(()=>{O&&(O=!1,G())}),{isTriggered:()=>O,dispose:()=>{O=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class d{constructor(O){this.defaultDelay=O,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(O,M=this.defaultDelay){this.task=O,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((V,ee)=>{this.doResolve=V,this.doReject=ee}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const V=this.task;return this.task=null,V()}}));const x=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=M===e.MicrotaskDelay?a(x):f(M,x),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new r.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=d;class c{constructor(O){this.delayer=new d(O),this.throttler=new S}trigger(O,M){return this.delayer.trigger(()=>this.throttler.queue(O),M)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=c;class i{constructor(){this._isOpen=!1,this._promise=new Promise((O,M)=>{this._completePromise=O})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=i;class o extends i{constructor(O){super(),this._timeout=setTimeout(()=>this.open(),O)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function t(G,O){return O?new Promise((M,x)=>{const V=setTimeout(()=>{ee.dispose(),M()},G),ee=O.onCancellationRequested(()=>{clearTimeout(V),ee.dispose(),x(new r.CancellationError)})}):E(M=>t(G,M))}e.timeout=t;function n(G,O=0){const M=setTimeout(G,O);return(0,L.toDisposable)(()=>clearTimeout(M))}e.disposableTimeout=n;function s(G){const O=[];let M=0;const x=G.length;function V(){return M<x?G[M++]():null}function ee(oe){oe!=null&&O.push(oe);const Z=V();return Z?Z.then(ee):Promise.resolve(O)}return Promise.resolve(null).then(ee)}e.sequence=s;function u(G,O=x=>!!x,M=null){let x=0;const V=G.length,ee=()=>{if(x>=V)return Promise.resolve(M);const oe=G[x++];return Promise.resolve(oe()).then(ie=>O(ie)?Promise.resolve(ie):ee())};return ee()}e.first=u;function l(G,O=x=>!!x,M=null){if(G.length===0)return Promise.resolve(M);let x=G.length;const V=()=>{x=-1;for(const ee of G)ee.cancel?.()};return new Promise((ee,oe)=>{for(const Z of G)Z.then(ie=>{--x>=0&&O(ie)?(V(),ee(ie)):x===0&&ee(M)}).catch(ie=>{--x>=0&&(V(),oe(ie))})})}e.firstParallel=l;class m{constructor(O){this._size=0,this.maxDegreeOfParalellism=O,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new R.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(O){return this._size++,new Promise((M,x)=>{this.outstandingPromises.push({factory:O,c:M,e:x}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const O=this.outstandingPromises.shift();this.runningPromises++;const M=O.factory();M.then(O.c,O.e),M.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=m;class y extends m{constructor(){super(1)}}e.Queue=y;class _{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const O=new W;return this.drainers.add(O),O.p}isDrained(){for(const[,O]of this.queues)if(O.size>0)return!1;return!0}queueFor(O,M=T.extUri){const x=M.getComparisonKey(O);let V=this.queues.get(x);return V||(V=new y,R.Event.once(V.onDrained)(()=>{V?.dispose(),this.queues.delete(x),this.onDidQueueDrain()}),this.queues.set(x,V)),V}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const O of this.drainers)O.complete();this.drainers.clear()}dispose(){for(const[,O]of this.queues)O.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=_;class ${constructor(O,M){this._token=-1,typeof O=="function"&&typeof M=="number"&&this.setIfNotSet(O,M)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(O,M){this.cancel(),this._token=setTimeout(()=>{this._token=-1,O()},M)}setIfNotSet(O,M){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,O()},M))}}e.TimeoutTimer=$;class A{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(O,M){this.cancel(),this._token=setInterval(()=>{O()},M)}}e.IntervalTimer=A;class U{constructor(O,M){this.timeoutToken=-1,this.runner=O,this.timeout=M,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(O=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,O)}get delay(){return this.timeout}set delay(O){this.timeout=O}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=U;class k{constructor(O,M){M%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.runner=O,this.timeout=M,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(O=this.timeout){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(O/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=k;class N extends U{constructor(O,M){super(O,M),this.units=[]}work(O){this.units.push(O),this.isScheduled()||this.schedule()}doRun(){const O=this.units;this.units=[],this.runner?.(O)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=N;class F extends L.Disposable{constructor(O,M){super(),this.options=O,this.handler=M,this.pendingWork=[],this.throttler=this._register(new L.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(O){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+O.length>this.options.maxBufferedWork)return!1}else if(this.pending+O.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...O),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new U(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=F,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=G=>{(0,P.setTimeout0)(()=>{if(O)return;const M=Date.now()+15;G(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,M-Date.now())}}))});let O=!1;return{dispose(){O||(O=!0)}}}:e.runWhenIdle=(G,O)=>{const M=requestIdleCallback(G,typeof O=="number"?{timeout:O}:void 0);let x=!1;return{dispose(){x||(x=!0,cancelIdleCallback(M))}}}}();class q{constructor(O){this._didRun=!1,this._executor=()=>{try{this._value=O()}catch(M){this._error=M}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=q;async function J(G,O,M){let x;for(let V=0;V<M;V++)try{return await G()}catch(ee){x=ee,await t(O)}throw x}e.retry=J;class j{hasPending(O){return this._pending?typeof O=="number"?this._pending.taskId===O:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(O,M,x){return this._pending={taskId:O,cancel:()=>x?.(),promise:M},M.then(()=>this.donePending(O),()=>this.donePending(O)),M}donePending(O){this._pending&&O===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const O=this._next;this._next=void 0,O.run().then(O.promiseResolve,O.promiseReject)}}setNext(O){if(this._next)this._next.run=O;else{let M,x;const V=new Promise((ee,oe)=>{M=ee,x=oe});this._next={run:O,promise:V,promiseResolve:M,promiseReject:x}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=j;class H{constructor(O,M=()=>Date.now()){this.interval=O,this.nowFn=M,this.lastIncrementTime=0,this.value=0}increment(){const O=this.nowFn();return O-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=O,this.value=0),this.value++,this.value}}e.IntervalCounter=H;class W{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((O,M)=>{this.completeCallback=O,this.errorCallback=M})}complete(O){return new Promise(M=>{this.completeCallback(O),this.resolved=!0,M()})}error(O){return new Promise(M=>{this.errorCallback(O),this.rejected=!0,M()})}cancel(){new Promise(O=>{this.errorCallback(new r.CancellationError),this.rejected=!0,O()})}}e.DeferredPromise=W;var z;(function(G){async function O(x){let V;const ee=await Promise.all(x.map(oe=>oe.then(Z=>Z,Z=>{V||(V=Z)})));if(typeof V<"u")throw V;return ee}G.settled=O;function M(x){return new Promise(async(V,ee)=>{try{await x(V,ee)}catch(oe){ee(oe)}})}G.withAsyncBody=M})(z=e.Promises||(e.Promises={}));var K;(function(G){G[G.Initial=0]="Initial",G[G.DoneOK=1]="DoneOK",G[G.DoneError=2]="DoneError"})(K||(K={}));class X{static fromArray(O){return new X(M=>{M.emitMany(O)})}static fromPromise(O){return new X(async M=>{M.emitMany(await O)})}static fromPromises(O){return new X(async M=>{await Promise.all(O.map(async x=>M.emitOne(await x)))})}static merge(O){return new X(async M=>{await Promise.all(O.map(async x=>{for await(const V of x)M.emitOne(V)}))})}constructor(O){this._state=0,this._results=[],this._error=null,this._onStateChanged=new R.Emitter,queueMicrotask(async()=>{const M={emitOne:x=>this.emitOne(x),emitMany:x=>this.emitMany(x),reject:x=>this.reject(x)};try{await Promise.resolve(O(M)),this.resolve()}catch(x){this.reject(x)}finally{M.emitOne=void 0,M.emitMany=void 0,M.reject=void 0}})}[Symbol.asyncIterator](){let O=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(O<this._results.length)return{done:!1,value:this._results[O++]};if(this._state===1)return{done:!0,value:void 0};await R.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(O,M){return new X(async x=>{for await(const V of O)x.emitOne(M(V))})}map(O){return X.map(this,O)}static filter(O,M){return new X(async x=>{for await(const V of O)M(V)&&x.emitOne(V)})}filter(O){return X.filter(this,O)}static coalesce(O){return X.filter(O,M=>!!M)}coalesce(){return X.coalesce(this)}static async toPromise(O){const M=[];for await(const x of O)M.push(x);return M}toPromise(){return X.toPromise(this)}emitOne(O){this._state===0&&(this._results.push(O),this._onStateChanged.fire())}emitMany(O){this._state===0&&(this._results=this._results.concat(O),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(O){this._state===0&&(this._state=2,this._error=O,this._onStateChanged.fire())}}e.AsyncIterableObject=X,X.EMPTY=X.fromArray([]);class ce extends X{constructor(O,M){super(M),this._source=O}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ce;function B(G){const O=new D.CancellationTokenSource,M=G(O.token);return new ce(O,async x=>{const V=O.token.onCancellationRequested(()=>{V.dispose(),O.dispose(),x.reject(new r.CancellationError)});try{for await(const ee of M){if(O.token.isCancellationRequested)return;x.emitOne(ee)}V.dispose(),O.dispose()}catch(ee){V.dispose(),O.dispose(),x.reject(ee)}})}e.createCancelableAsyncIterable=B}),define(ne[86],re([0,1,18,6,47,34,12,4,27]),function(Q,e,D,r,R,L,T,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function E(){return Object.create(null)}e.getEmptyExpression=E,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const I="[/\\\\]",b="[^/\\\\]",p=/\//g;function v(W,z){switch(W){case 0:return"";case 1:return`${b}*?`;default:return`(?:${I}|${b}+${I}${z?`|${I}${b}+`:""})*?`}}function h(W,z){if(!W)return[];const K=[];let X=!1,ce=!1,B="";for(const G of W){switch(G){case z:if(!X&&!ce){K.push(B),B="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}B+=G}return B&&K.push(B),K}e.splitGlobAware=h;function S(W){if(!W)return"";let z="";const K=h(W,e.GLOB_SPLIT);if(K.every(X=>X===e.GLOBSTAR))z=".*";else{let X=!1;K.forEach((ce,B)=>{if(ce===e.GLOBSTAR){if(X)return;z+=v(2,B===K.length-1)}else{let G=!1,O="",M=!1,x="";for(const V of ce){if(V!=="}"&&G){O+=V;continue}if(M&&(V!=="]"||!x)){let ee;V==="-"?ee=V:(V==="^"||V==="!")&&!x?ee="^":V===e.GLOB_SPLIT?ee="":ee=(0,w.escapeRegExpCharacters)(V),x+=ee;continue}switch(V){case"{":G=!0;continue;case"[":M=!0;continue;case"}":{z+=`(?:${h(O,",").map(Z=>S(Z)).join("|")})`,G=!1,O="";break}case"]":{z+="["+x+"]",M=!1,x="";break}case"?":z+=b;continue;case"*":z+=v(1);continue;default:z+=(0,w.escapeRegExpCharacters)(V)}}B<K.length-1&&(K[B+1]!==e.GLOBSTAR||B+2<K.length)&&(z+=I)}X=ce===e.GLOBSTAR})}return z}const C=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,f=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,a=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new L.LRUCache(1e4),o=function(){return!1},t=function(){return null};function n(W,z){if(!W)return t;let K;typeof W!="string"?K=W.pattern:K=W,K=K.trim();const X=`${K}_${!!z.trimForExclusions}`;let ce=i.get(X);if(ce)return s(ce,W);let B;return C.test(K)?ce=l(K.substr(4),K):(B=g.exec(u(K,z)))?ce=m(B[1],K):(z.trimForExclusions?a:f).test(K)?ce=y(K,z):(B=d.exec(u(K,z)))?ce=_(B[1].substr(1),K,!0):(B=c.exec(u(K,z)))?ce=_(B[1],K,!1):ce=$(K),i.set(X,ce),s(ce,W)}function s(W,z){if(typeof z=="string")return W;const K=function(X,ce){return(0,R.isEqualOrParent)(X,z.base,!P.isLinux)?W(X.substr(z.base.length+1),ce):null};return K.allBasenames=W.allBasenames,K.allPaths=W.allPaths,K.basenames=W.basenames,K.patterns=W.patterns,K}function u(W,z){return z.trimForExclusions&&W.endsWith("/**")?W.substr(0,W.length-2):W}function l(W,z){return function(K,X){return typeof K=="string"&&K.endsWith(W)?z:null}}function m(W,z){const K=`/${W}`,X=`\\${W}`,ce=function(G,O){return typeof G!="string"?null:O?O===W?z:null:G===W||G.endsWith(K)||G.endsWith(X)?z:null},B=[W];return ce.basenames=B,ce.patterns=[z],ce.allBasenames=B,ce}function y(W,z){const K=j(W.slice(1,-1).split(",").map(O=>n(O,z)).filter(O=>O!==t),W),X=K.length;if(!X)return t;if(X===1)return K[0];const ce=function(O,M){for(let x=0,V=K.length;x<V;x++)if(K[x](O,M))return W;return null},B=K.find(O=>!!O.allBasenames);B&&(ce.allBasenames=B.allBasenames);const G=K.reduce((O,M)=>M.allPaths?O.concat(M.allPaths):O,[]);return G.length&&(ce.allPaths=G),ce}function _(W,z,K){const X=T.sep===T.posix.sep,ce=X?W:W.replace(p,T.sep),B=T.sep+ce,G=T.posix.sep+W;let O;return K?O=function(M,x){return typeof M=="string"&&(M===ce||M.endsWith(B)||!X&&(M===W||M.endsWith(G)))?z:null}:O=function(M,x){return typeof M=="string"&&(M===ce||!X&&M===W)?z:null},O.allPaths=[(K?"*/":"./")+W],O}function $(W){try{const z=new RegExp(`^${S(W)}$`);return function(K){return z.lastIndex=0,typeof K=="string"&&z.test(K)?W:null}}catch{return t}}function A(W,z,K){return!W||typeof z!="string"?!1:U(W)(z,void 0,K)}e.match=A;function U(W,z={}){if(!W)return o;if(typeof W=="string"||k(W)){const K=n(W,z);if(K===t)return o;const X=function(ce,B){return!!K(ce,B)};return K.allBasenames&&(X.allBasenames=K.allBasenames),K.allPaths&&(X.allPaths=K.allPaths),X}return q(W,z)}e.parse=U;function k(W){const z=W;return z?typeof z.base=="string"&&typeof z.pattern=="string":!1}e.isRelativePattern=k;function N(W){return W.allBasenames||[]}e.getBasenameTerms=N;function F(W){return W.allPaths||[]}e.getPathTerms=F;function q(W,z){const K=j(Object.getOwnPropertyNames(W).map(O=>J(O,W[O],z)).filter(O=>O!==t)),X=K.length;if(!X)return t;if(!K.some(O=>!!O.requiresSiblings)){if(X===1)return K[0];const O=function(V,ee){let oe;for(let Z=0,ie=K.length;Z<ie;Z++){const se=K[Z](V,ee);if(typeof se=="string")return se;(0,r.isThenable)(se)&&(oe||(oe=[]),oe.push(se))}return oe?(async()=>{for(const Z of oe){const ie=await Z;if(typeof ie=="string")return ie}return null})():null},M=K.find(V=>!!V.allBasenames);M&&(O.allBasenames=M.allBasenames);const x=K.reduce((V,ee)=>ee.allPaths?V.concat(ee.allPaths):V,[]);return x.length&&(O.allPaths=x),O}const ce=function(O,M,x){let V,ee;for(let oe=0,Z=K.length;oe<Z;oe++){const ie=K[oe];ie.requiresSiblings&&x&&(M||(M=(0,T.basename)(O)),V||(V=M.substr(0,M.length-(0,T.extname)(O).length)));const se=ie(O,M,V,x);if(typeof se=="string")return se;(0,r.isThenable)(se)&&(ee||(ee=[]),ee.push(se))}return ee?(async()=>{for(const oe of ee){const Z=await oe;if(typeof Z=="string")return Z}return null})():null},B=K.find(O=>!!O.allBasenames);B&&(ce.allBasenames=B.allBasenames);const G=K.reduce((O,M)=>M.allPaths?O.concat(M.allPaths):O,[]);return G.length&&(ce.allPaths=G),ce}function J(W,z,K){if(z===!1)return t;const X=n(W,K);if(X===t)return t;if(typeof z=="boolean")return X;if(z){const ce=z.when;if(typeof ce=="string"){const B=(G,O,M,x)=>{if(!x||!X(G,O))return null;const V=ce.replace("$(basename)",M),ee=x(V);return(0,r.isThenable)(ee)?ee.then(oe=>oe?W:null):ee?W:null};return B.requiresSiblings=!0,B}}return X}function j(W,z){const K=W.filter(O=>!!O.basenames);if(K.length<2)return W;const X=K.reduce((O,M)=>{const x=M.basenames;return x?O.concat(x):O},[]);let ce;if(z){ce=[];for(let O=0,M=X.length;O<M;O++)ce.push(z)}else ce=K.reduce((O,M)=>{const x=M.patterns;return x?O.concat(x):O},[]);const B=function(O,M){if(typeof O!="string")return null;if(!M){let V;for(V=O.length;V>0;V--){const ee=O.charCodeAt(V-1);if(ee===47||ee===92)break}M=O.substr(V)}const x=X.indexOf(M);return x!==-1?ce[x]:null};B.basenames=X,B.patterns=ce,B.allBasenames=X;const G=W.filter(O=>!O.basenames);return G.push(B),G}function H(W,z){return(0,D.equals)(W,z,(K,X)=>typeof K=="string"&&typeof X=="string"?K===X:typeof K!="string"&&typeof X!="string"?K.base===X.base&&K.pattern===X.pattern:!1)}e.patternsEquals=H}),define(ne[132],re([0,1,7]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function r(I){return I.toJSON()}class R{constructor(b){this._uriTransformer=b}transformIncoming(b){const p=this._uriTransformer.transformIncoming(b);return p===b?b:r(D.URI.from(p))}transformOutgoing(b){const p=this._uriTransformer.transformOutgoing(b);return p===b?b:r(D.URI.from(p))}transformOutgoingURI(b){const p=this._uriTransformer.transformOutgoing(b);return p===b?b:D.URI.from(p)}transformOutgoingScheme(b){return this._uriTransformer.transformOutgoingScheme(b)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function L(I,b,p){if(!I||p>200)return null;if(typeof I=="object"){if(I instanceof D.URI)return b.transformOutgoing(I);for(const v in I)if(Object.hasOwnProperty.call(I,v)){const h=L(I[v],b,p+1);h!==null&&(I[v]=h)}}return null}function T(I,b){const p=L(I,b,0);return p===null?I:p}e.transformOutgoingURIs=T;function P(I,b,p,v){if(!I||v>200)return null;if(typeof I=="object"){if(I.$mid===1)return p?D.URI.revive(b.transformIncoming(I)):b.transformIncoming(I);for(const h in I)if(Object.hasOwnProperty.call(I,h)){const S=P(I[h],b,p,v+1);S!==null&&(I[h]=S)}}return null}function w(I,b){const p=P(I,b,!1,0);return p===null?I:p}e.transformIncomingURIs=w;function E(I,b){const p=P(I,b,!0,0);return p===null?I:p}e.transformAndReviveIncomingURIs=E}),define(ne[133],re([0,1,36,9,34,30,119]),function(Q,e,D,r,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(I){return this._virtualMachineOUIs||(this._virtualMachineOUIs=R.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(I)}value(){if(this._value===void 0){let I=0,b=0;const p=(0,D.networkInterfaces)();for(const v in p){const h=p[v];if(h)for(const{mac:S,internal:C}of h)C||(b+=1,this._isVirtualMachineMacAddress(S.toUpperCase())&&(I+=1))}this._value=b>0?I/b:0}return this._value}};let P;async function w(){return P||(P=(async()=>await E()||L.generateUuid())()),P}e.getMachineId=w;async function E(){try{const I=await new Promise((p,v)=>{Q(["crypto"],p,v)}),b=(0,T.getMac)();return I.createHash("sha256").update(b,"utf8").digest("hex")}catch(I){r.onUnexpectedError(I);return}}}),define(ne[28],re([0,1,53,36,274,6,47,84,12,4,19,7]),function(Q,e,D,r,R,L,T,P,w,E,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(q){q[q.UNLINK=0]="UNLINK",q[q.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function v(q,J=p.UNLINK){if((0,T.isRootOrDriveLetter)(q))throw new Error("rimraf - will refuse to recursively delete root");return J===p.UNLINK?S(q):h(q)}async function h(q){try{const J=(0,T.randomPath)((0,r.tmpdir)());try{await D.promises.rename(q,J)}catch(j){return j.code==="ENOENT"?void 0:S(q)}S(J).catch(j=>{})}catch(J){if(J.code!=="ENOENT")throw J}}async function S(q){return(0,R.promisify)(D.rm)(q,{recursive:!0,force:!0,maxRetries:3})}function C(q){if((0,T.isRootOrDriveLetter)(q))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(q,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=C;async function g(q,J){return d(await(J?f(q):(0,R.promisify)(D.readdir)(q)))}async function f(q){try{return await(0,R.promisify)(D.readdir)(q,{withFileTypes:!0})}catch(H){console.warn("[node.js fs] readdir with filetypes failed with error: ",H)}const J=[],j=await g(q);for(const H of j){let W=!1,z=!1,K=!1;try{const X=await e.Promises.lstat((0,w.join)(q,H));W=X.isFile(),z=X.isDirectory(),K=X.isSymbolicLink()}catch(X){console.warn("[node.js fs] unexpected error from lstat after readdir: ",X)}J.push({name:H,isFile:()=>W,isDirectory:()=>z,isSymbolicLink:()=>K})}return J}function a(q){return d(D.readdirSync(q))}e.readdirSync=a;function d(q){return q.map(J=>typeof J=="string"?E.isMacintosh?(0,P.normalizeNFC)(J):J:(J.name=E.isMacintosh?(0,P.normalizeNFC)(J.name):J.name,J))}async function c(q){const J=await g(q),j=[];for(const H of J)await o.existsDirectory((0,w.join)(q,H))&&j.push(H);return j}function i(q,J=1e3){return new Promise(j=>{let H=!1;const W=setInterval(()=>{H||(H=!0,D.access(q,z=>{H=!1,z&&(clearInterval(W),j(void 0))}))},J)})}e.whenDeleted=i;var o;(function(q){async function J(W){let z;try{if(z=await e.Promises.lstat(W),!z.isSymbolicLink())return{stat:z}}catch{}try{return{stat:await e.Promises.stat(W),symbolicLink:z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(K){if(K.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};if(E.isWindows&&K.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(W)),symbolicLink:{dangling:!1}}}catch(X){if(X.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};throw X}throw K}}q.stat=J;async function j(W){try{const{stat:z,symbolicLink:K}=await q.stat(W);return z.isFile()&&K?.dangling!==!0}catch{}return!1}q.existsFile=j;async function H(W){try{const{stat:z,symbolicLink:K}=await q.stat(W);return z.isDirectory()&&K?.dangling!==!0}catch{}return!1}q.existsDirectory=H})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new L.ResourceQueue;function n(q,J,j){return t.queueFor(b.URI.file(q),I.extUriBiasedIgnorePathCase).queue(()=>{const H=y(j);return new Promise((W,z)=>l(q,J,H,K=>K?z(K):W()))})}let s=!0;function u(q){s=q}e.configureFlushOnWrite=u;function l(q,J,j,H){if(!s)return D.writeFile(q,J,{mode:j.mode,flag:j.flag},H);D.open(q,j.flag,j.mode,(W,z)=>{if(W)return H(W);D.writeFile(z,J,K=>{if(K)return D.close(z,()=>H(K));D.fdatasync(z,X=>(X&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",X),u(!1)),D.close(z,ce=>H(ce))))})})}function m(q,J,j){const H=y(j);if(!s)return D.writeFileSync(q,J,{mode:H.mode,flag:H.flag});const W=D.openSync(q,H.flag,H.mode);try{D.writeFileSync(W,J);try{D.fdatasyncSync(W)}catch(z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",z),u(!1)}}finally{D.closeSync(W)}}e.writeFileSync=m;function y(q){return q?{mode:typeof q.mode=="number"?q.mode:438,flag:typeof q.flag=="string"?q.flag:"w"}:{mode:438,flag:"w"}}async function _(q,J){if(q!==J)try{await e.Promises.rename(q,J)}catch(j){if(q.toLowerCase()!==J.toLowerCase()&&j.code==="EXDEV"||q.endsWith("."))await $(q,J,{preserveSymlinks:!1}),await v(q,p.MOVE);else throw j}}async function $(q,J,j){return U(q,J,{root:{source:q,target:J},options:j,handledSourcePaths:new Set})}const A=511;async function U(q,J,j){if(j.handledSourcePaths.has(q))return;j.handledSourcePaths.add(q);const{stat:H,symbolicLink:W}=await o.stat(q);if(W){if(j.options.preserveSymlinks)try{return await F(q,J,j)}catch(z){console.warn("[node.js fs] copy of symlink failed: ",z)}if(W.dangling)return}return H.isDirectory()?k(q,J,H.mode&A,j):N(q,J,H.mode&A)}async function k(q,J,j,H){await e.Promises.mkdir(J,{recursive:!0,mode:j});const W=await g(q);for(const z of W)await U((0,w.join)(q,z),(0,w.join)(J,z),H)}async function N(q,J,j){await e.Promises.copyFile(q,J),await e.Promises.chmod(J,j)}async function F(q,J,j){let H=await e.Promises.readlink(q);(0,T.isEqualOrParent)(H,j.root.source,!E.isLinux)&&(H=(0,w.join)(j.root.target,H.substr(j.root.source.length+1))),await e.Promises.symlink(H,J)}e.Promises=new class{get access(){return(0,R.promisify)(D.access)}get stat(){return(0,R.promisify)(D.stat)}get lstat(){return(0,R.promisify)(D.lstat)}get utimes(){return(0,R.promisify)(D.utimes)}get read(){return(q,J,j,H,W)=>new Promise((z,K)=>{D.read(q,J,j,H,W,(X,ce,B)=>X?K(X):z({bytesRead:ce,buffer:B}))})}get readFile(){return(0,R.promisify)(D.readFile)}get write(){return(q,J,j,H,W)=>new Promise((z,K)=>{D.write(q,J,j,H,W,(X,ce,B)=>X?K(X):z({bytesWritten:ce,buffer:B}))})}get appendFile(){return(0,R.promisify)(D.appendFile)}get fdatasync(){return(0,R.promisify)(D.fdatasync)}get truncate(){return(0,R.promisify)(D.truncate)}get rename(){return(0,R.promisify)(D.rename)}get copyFile(){return(0,R.promisify)(D.copyFile)}get open(){return(0,R.promisify)(D.open)}get close(){return(0,R.promisify)(D.close)}get symlink(){return(0,R.promisify)(D.symlink)}get readlink(){return(0,R.promisify)(D.readlink)}get chmod(){return(0,R.promisify)(D.chmod)}get mkdir(){return(0,R.promisify)(D.mkdir)}get unlink(){return(0,R.promisify)(D.unlink)}get rmdir(){return(0,R.promisify)(D.rmdir)}get realpath(){return(0,R.promisify)(D.realpath)}async exists(q){try{return await e.Promises.access(q),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return c}get writeFile(){return n}get rm(){return v}get move(){return _}get copy(){return $}}}),define(ne[134],re([0,1,53,12,4,27,28]),function(Q,e,D,r,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(p){if(R.isLinux)return p;const v=(0,r.dirname)(p);if(p===v)return p;const h=((0,r.basename)(p)||p).toLowerCase();try{const C=(0,T.readdirSync)(v).filter(g=>g.toLowerCase()===h);if(C.length===1){const g=P(v);if(g)return(0,r.join)(g,C[0])}else if(C.length>1){const g=C.indexOf(h);if(g>=0){const f=P(v);if(f)return(0,r.join)(f,C[g])}}}catch{}return null}e.realcaseSync=P;async function w(p){if(R.isLinux)return p;const v=(0,r.dirname)(p);if(p===v)return p;const h=((0,r.basename)(p)||p).toLowerCase();try{const C=(await T.Promises.readdir(v)).filter(g=>g.toLowerCase()===h);if(C.length===1){const g=await w(v);if(g)return(0,r.join)(g,C[0])}else if(C.length>1){const g=C.indexOf(h);if(g>=0){const f=await w(v);if(f)return(0,r.join)(f,C[g])}}}catch{}return null}e.realcase=w;async function E(p){try{return await T.Promises.realpath(p)}catch{const h=b(p);return await T.Promises.access(h,D.constants.R_OK),h}}e.realpath=E;function I(p){try{return D.realpathSync(p)}catch{const h=b(p);return D.accessSync(h,D.constants.R_OK),h}}e.realpathSync=I;function b(p){return(0,L.rtrim)((0,r.normalize)(p),r.sep)}}),define(ne[87],re([0,1,36,12,28]),function(Q,e,D,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const L=/^\d+$/,T=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var w;(function(d){d[d.x64=0]="x64",d[d.x86=1]="x86",d[d.ARM=2]="ARM"})(w||(w={}));let E;switch(process.arch){case"ia32":case"x32":E=1;break;case"arm":case"arm64":E=2;break;default:E=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class b{constructor(c,i,o){this.exePath=c,this.displayName=i,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await R.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function p({useAlternateBitness:d=!1}={}){return d?E===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function v({useAlternateBitness:d=!1,findPreview:c=!1}={}){const i=p({useAlternateBitness:d});if(!i)return null;const o=r.join(i,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(o))return null;let t=-1,n=null;for(const l of await R.Promises.readdir(o)){let m=-1;if(c){const _=l.indexOf("-");if(_<0)continue;const $=l.substring(0,_);if(!L.test($)||l.substring(_+1)!=="preview")continue;m=parseInt($,10)}else{if(!L.test(l))continue;m=parseInt(l,10)}if(m<=t)continue;const y=r.join(o,l,"pwsh.exe");!await R.SymlinkSupport.existsFile(y)||(n=y,t=m)}if(!n)return null;const s=i.includes("x86")?" (x86)":"",u=c?" Preview":"";return new b(n,`PowerShell${u}${s}`,!0)}async function h({findPreview:d}={}){if(!process.env.LOCALAPPDATA)return null;const c=r.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:i,pwshMsixName:o}=d?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const t of await R.Promises.readdir(c))if(i.test(t)){const n=r.join(c,t,"pwsh.exe");return new b(n,o)}return null}function S(){const d=r.join(D.homedir(),".dotnet","tools","pwsh.exe");return new b(d,".NET Core PowerShell Global Tool")}function C(){const d=r.join(process.env.windir,E===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(d,"Windows PowerShell",!0)}async function*g(){let d=await v();d&&(yield d),d=await v({useAlternateBitness:!0}),d&&(yield d),d=await h(),d&&(yield d),d=S(),d&&(yield d),d=await v({findPreview:!0}),d&&(yield d),d=await h({findPreview:!0}),d&&(yield d),d=await v({useAlternateBitness:!0,findPreview:!0}),d&&(yield d),d=C(),d&&(yield d)}async function*f(){for await(const d of g())await d.exists()&&(yield d)}e.enumeratePowerShellInstallations=f;async function a(){for await(const d of f())return d;return null}e.getFirstAvailablePowerShellInstallation=a}),define(ne[88],re([0,1,12,4,37,82,15,28]),function(Q,e,D,r,R,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function w(b=R.env){return b.comspec||"cmd.exe"}e.getWindowsShell=w;function E(b){let p=[],v=!1;const h=function(S){if(v){p.push(S);return}(!b.send(S,g=>{if(g&&console.error(g),v=!1,p.length>0){const f=p.slice(0);p=[],f.forEach(a=>h(a))}})||r.isWindows)&&(v=!0)};return{send:h}}e.createQueuedSender=E;var I;(function(b){async function p(v,h,S){if(D.isAbsolute(v))return v;if(h===void 0&&(h=R.cwd()),D.dirname(v)!=="."||(S===void 0&&T.isString(R.env.PATH)&&(S=R.env.PATH.split(D.delimiter)),S===void 0||S.length===0))return D.join(h,v);async function g(f){if(await P.Promises.exists(f)){let a;try{a=await P.Promises.stat(f)}catch(d){d.message.startsWith("EACCES")&&(a=await P.Promises.lstat(f))}return a?!a.isDirectory():!1}return!1}for(const f of S){let a;if(D.isAbsolute(f)?a=D.join(f,v):a=D.join(h,f,v),await g(a))return a;let d=a+".com";if(await g(d)||(d=a+".exe",await g(d)))return d}return D.join(h,v)}b.findExecutable=p})(I=e.win32||(e.win32={}))}),define(ne[135],re([0,1,54,23]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function R(T){return new Promise((P,w)=>{let E;const I=new Map;function b(v,h,S,C,g){const f=I.get(h);if(v===T||f){const a={name:p(S),cmd:S,pid:v,ppid:h,load:C,mem:g};I.set(v,a),v===T&&(E=a),f&&(f.children||(f.children=[]),f.children.push(a),f.children.length>1&&(f.children=f.children.sort((d,c)=>d.pid-c.pid)))}}function p(v){const h=/--vscode-window-kind=shared-process/,S=/--vscode-window-kind=issue-reporter/,C=/--vscode-window-kind=process-explorer/,g=/--utility-sub-type=network/,f=/--utility-sub-type=node.mojom.NodeService/,a=/--crashes-directory/,d=/\\pipe\\winpty-control/,c=/conhost\.exe/,i=/--type=([a-zA-Z-]+)/;if(a.exec(v))return"electron-crash-reporter";if(d.exec(v))return"winpty-process";if(c.exec(v))return"console-window-host (Windows internal process)";let o=i.exec(v);if(o&&o.length===2){if(o[1]==="renderer")return h.exec(v)?"shared-process":S.exec(v)?"issue-reporter":C.exec(v)?"process-explorer":"window";if(o[1]==="utility"){if(g.exec(v))return"utility-network-service";if(f.exec(v))return"extension-host"}return o[1]}const t=/[a-zA-Z-]+\.js/g;let n="";do o=t.exec(v),o&&(n+=o+" ");while(o);return n&&v.indexOf("node ")<0&&v.indexOf("node.exe")<0?`electron_node ${n}`:v}if(process.platform==="win32"){const v=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,S)=>{Q(["windows-process-tree"],h,S)}).then(h=>{h.getProcessList(T,S=>{if(!S){w(new Error(`Root process ${T} not found`));return}h.getProcessCpuUsage(S,C=>{const g=new Map;C.forEach(f=>{const a=v(f.commandLine||"");g.set(f.pid,{name:p(a),cmd:a,pid:f.pid,ppid:f.ppid,load:f.cpu||0,mem:f.memory||0})}),E=g.get(T),E?(g.forEach(f=>{const a=g.get(f.ppid);a&&(a.children||(a.children=[]),a.children.push(f))}),g.forEach(f=>{f.children&&(f.children=f.children.sort((a,d)=>a.pid-d.pid))}),P(E)):w(new Error(`Root process ${T} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let v=function(){let h=[E];const S=[];for(;h.length;){const g=h.shift();g&&(S.push(g.pid),g.children&&(h=h.concat(g.children)))}let C=JSON.stringify(r.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",Q).fsPath);C+=" "+S.join(" "),(0,D.exec)(C,{},(g,f,a)=>{if(g||a)w(g||new Error(a.toString()));else{const d=f.toString().split(`
`);for(let c=0;c<S.length;c++){const i=I.get(S[c]);i.load=parseFloat(d[c])}if(!E){w(new Error(`Root process ${T} not found`));return}P(E)}})};(0,D.exec)("which ps",{},(h,S,C)=>{if(h||C)if(process.platform!=="linux")w(h||new Error(C.toString()));else{const g=JSON.stringify(r.FileAccess.asFileUri("vs/base/node/ps.sh",Q).fsPath);(0,D.exec)(g,{},(f,a,d)=>{f||d?w(f||new Error(d.toString())):(L(a,b),v())})}else{const g=S.toString().trim(),f="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${g} ${f}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(a,d,c)=>{a||c&&!c.includes("screen size is bogus")?w(a||new Error(c.toString())):(L(d,b),process.platform==="linux"?v():E?P(E):w(new Error(`Root process ${T} not found`)))})}})}})}e.listProcesses=R;function L(T,P){const w=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,E=T.toString().split(`
`);for(const I of E){const b=w.exec(I.trim());b&&b.length===6&&P(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}}),define(ne[136],re([0,1,36,4,87,88]),function(Q,e,D,r,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function T(v,h){return v===1?r.isWindows?b():L.getWindowsShell(h):E(v,h)}e.getSystemShell=T;function P(v,h){return v===1?r.isWindows?p(h):L.getWindowsShell(h):E(v,h)}e.getSystemShellSync=P;let w=null;function E(v,h){if(r.isLinux&&v===2||r.isMacintosh&&v===3)return"/bin/bash";if(!w){let S;if(r.isWindows)S="/bin/bash";else{if(S=h.SHELL,!S)try{S=(0,D.userInfo)().shell}catch{}S||(S="sh"),S==="/bin/false"&&(S="/bin/bash")}w=S}return w}let I=null;async function b(){return I||(I=(await(0,R.getFirstAvailablePowerShellInstallation)()).exePath),I}function p(v){if(I)return I;const h=r.isWindows&&parseFloat((0,D.release)())>=10,S=v.hasOwnProperty("PROCESSOR_ARCHITEW6432"),C=`${v.windir}\\${S?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?C:L.getWindowsShell(v)}});var pe=this&&this.__decorate||function(Q,e,D,r){var R=arguments.length,L=R<3?e:r===null?r=Object.getOwnPropertyDescriptor(e,D):r,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(Q,e,D,r);else for(var P=Q.length-1;P>=0;P--)(T=Q[P])&&(L=(R<3?T(L):R>3?T(e,D,L):T(e,D))||L);return R>3&&L&&Object.defineProperty(e,D,L),L};define(ne[39],re([0,1,18,6,16,22,63,9,3,2,66,27,15]),function(Q,e,D,r,R,L,T,P,w,E,I,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var v;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(v=e.RequestType||(e.RequestType={}));function h(W){switch(W){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var S;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(S=e.ResponseType||(e.ResponseType={}));function C(W){switch(W){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(g||(g={}));class f{constructor(z){this.buffer=z,this.pos=0}read(z){const K=this.buffer.slice(this.pos,this.pos+z);return this.pos+=K.byteLength,K}}class a{constructor(){this.buffers=[]}get buffer(){return R.VSBuffer.concat(this.buffers)}write(z){this.buffers.push(z)}}var d;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object"})(d||(d={}));function c(W){const z=R.VSBuffer.alloc(4);return z.writeUInt32BE(W,0),z}function i(W){return W.read(4).readUInt32BE(0)}function o(W){const z=R.VSBuffer.alloc(1);return z.writeUInt8(W,0),z}const t={Undefined:o(d.Undefined),String:o(d.String),Buffer:o(d.Buffer),VSBuffer:o(d.VSBuffer),Array:o(d.Array),Object:o(d.Object)},n=typeof Buffer<"u";function s(W,z){if(typeof z>"u")W.write(t.Undefined);else if(typeof z=="string"){const K=R.VSBuffer.fromString(z);W.write(t.String),W.write(c(K.byteLength)),W.write(K)}else if(n&&Buffer.isBuffer(z)){const K=R.VSBuffer.wrap(z);W.write(t.Buffer),W.write(c(K.byteLength)),W.write(K)}else if(z instanceof R.VSBuffer)W.write(t.VSBuffer),W.write(c(z.byteLength)),W.write(z);else if(Array.isArray(z)){W.write(t.Array),W.write(c(z.length));for(const K of z)s(W,K)}else{const K=R.VSBuffer.fromString(JSON.stringify(z));W.write(t.Object),W.write(c(K.byteLength)),W.write(K)}}function u(W){switch(W.read(1).readUInt8(0)){case d.Undefined:return;case d.String:return W.read(i(W)).toString();case d.Buffer:return W.read(i(W)).buffer;case d.VSBuffer:return W.read(i(W));case d.Array:{const K=i(W),X=[];for(let ce=0;ce<K;ce++)X.push(u(W));return X}case d.Object:return JSON.parse(W.read(i(W)).toString())}}class l{constructor(z,K,X=null,ce=1e3){this.protocol=z,this.ctx=K,this.logger=X,this.timeoutDelay=ce,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(B=>this.onRawMessage(B)),this.sendResponse({type:200})}registerChannel(z,K){this.channels.set(z,K),setTimeout(()=>this.flushPendingRequests(z),0)}sendResponse(z){switch(z.type){case 200:{const K=this.send([z.type]);this.logger?.logOutgoing(K,0,1,C(z.type));return}case 201:case 202:case 204:case 203:{const K=this.send([z.type,z.id],z.data);this.logger?.logOutgoing(K,z.id,1,C(z.type),z.data);return}}}send(z,K=void 0){const X=new a;return s(X,z),s(X,K),this.sendBuffer(X.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch{return 0}}onRawMessage(z){const K=new f(z),X=u(K),ce=u(K),B=X[0];switch(B){case 100:return this.logger?.logIncoming(z.byteLength,X[1],1,`${h(B)}: ${X[2]}.${X[3]}`,ce),this.onPromise({type:B,id:X[1],channelName:X[2],name:X[3],arg:ce});case 102:return this.logger?.logIncoming(z.byteLength,X[1],1,`${h(B)}: ${X[2]}.${X[3]}`,ce),this.onEventListen({type:B,id:X[1],channelName:X[2],name:X[3],arg:ce});case 101:return this.logger?.logIncoming(z.byteLength,X[1],1,`${h(B)}`),this.disposeActiveRequest({type:B,id:X[1]});case 103:return this.logger?.logIncoming(z.byteLength,X[1],1,`${h(B)}`),this.disposeActiveRequest({type:B,id:X[1]})}}onPromise(z){const K=this.channels.get(z.channelName);if(!K){this.collectPendingRequest(z);return}const X=new L.CancellationTokenSource;let ce;try{ce=K.call(this.ctx,z.name,z.arg,X.token)}catch(O){ce=Promise.reject(O)}const B=z.id;ce.then(O=>{this.sendResponse({id:B,data:O,type:201}),this.activeRequests.delete(z.id)},O=>{O instanceof Error?this.sendResponse({id:B,data:{message:O.message,name:O.name,stack:O.stack?O.stack.split?O.stack.split(`
`):O.stack:void 0},type:202}):this.sendResponse({id:B,data:O,type:203}),this.activeRequests.delete(z.id)});const G=(0,E.toDisposable)(()=>X.cancel());this.activeRequests.set(z.id,G)}onEventListen(z){const K=this.channels.get(z.channelName);if(!K){this.collectPendingRequest(z);return}const X=z.id,B=K.listen(this.ctx,z.name,z.arg)(G=>this.sendResponse({id:X,data:G,type:204}));this.activeRequests.set(z.id,B)}disposeActiveRequest(z){const K=this.activeRequests.get(z.id);K&&(K.dispose(),this.activeRequests.delete(z.id))}collectPendingRequest(z){let K=this.pendingRequests.get(z.channelName);K||(K=[],this.pendingRequests.set(z.channelName,K));const X=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===100&&this.sendResponse({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);K.push({request:z,timeoutTimer:X})}flushPendingRequests(z){const K=this.pendingRequests.get(z);if(K){for(const X of K)switch(clearTimeout(X.timeoutTimer),X.request.type){case 100:this.onPromise(X.request);break;case 102:this.onEventListen(X.request);break}this.pendingRequests.delete(z)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,E.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=l;var m;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(m=e.RequestInitiator||(e.RequestInitiator={}));class y{constructor(z,K=null){this.protocol=z,this.isDisposed=!1,this.state=g.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new w.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(X=>this.onBuffer(X)),this.logger=K}getChannel(z){const K=this;return{call(X,ce,B){return K.isDisposed?Promise.reject(new P.CancellationError):K.requestPromise(z,X,ce,B)},listen(X,ce){return K.isDisposed?w.Event.None:K.requestEvent(z,X,ce)}}}requestPromise(z,K,X,ce=L.CancellationToken.None){const B=this.lastRequestId++,O={id:B,type:100,channelName:z,name:K,arg:X};if(ce.isCancellationRequested)return Promise.reject(new P.CancellationError);let M;return new Promise((V,ee)=>{if(ce.isCancellationRequested)return ee(new P.CancellationError);const oe=()=>{const ue=de=>{switch(de.type){case 201:this.handlers.delete(B),V(de.data);break;case 202:{this.handlers.delete(B);const ve=new Error(de.data.message);ve.stack=de.data.stack,ve.name=de.data.name,ee(ve);break}case 203:this.handlers.delete(B),ee(de.data);break}};this.handlers.set(B,ue),this.sendRequest(O)};let Z=null;this.state===g.Idle?oe():(Z=(0,r.createCancelablePromise)(ue=>this.whenInitialized()),Z.then(()=>{Z=null,oe()}));const ie=()=>{Z?(Z.cancel(),Z=null):this.sendRequest({id:B,type:101}),ee(new P.CancellationError)},se=ce.onCancellationRequested(ie);M=(0,E.combinedDisposable)((0,E.toDisposable)(ie),se),this.activeRequests.add(M)}).finally(()=>{this.activeRequests.delete(M)})}requestEvent(z,K,X){const ce=this.lastRequestId++,G={id:ce,type:102,channelName:z,name:K,arg:X};let O=null;const M=new w.Emitter({onFirstListenerAdd:()=>{O=(0,r.createCancelablePromise)(V=>this.whenInitialized()),O.then(()=>{O=null,this.activeRequests.add(M),this.sendRequest(G)})},onLastListenerRemove:()=>{O?(O.cancel(),O=null):(this.activeRequests.delete(M),this.sendRequest({id:ce,type:103}))}}),x=V=>M.fire(V.data);return this.handlers.set(ce,x),M.event}sendRequest(z){switch(z.type){case 100:case 102:{const K=this.send([z.type,z.id,z.channelName,z.name],z.arg);this.logger?.logOutgoing(K,z.id,0,`${h(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case 101:case 103:{const K=this.send([z.type,z.id]);this.logger?.logOutgoing(K,z.id,0,h(z.type));return}}}send(z,K=void 0){const X=new a;return s(X,z),s(X,K),this.sendBuffer(X.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch{return 0}}onBuffer(z){const K=new f(z),X=u(K),ce=u(K),B=X[0];switch(B){case 200:return this.logger?.logIncoming(z.byteLength,0,0,C(B)),this.onResponse({type:X[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(z.byteLength,X[1],0,C(B),ce),this.onResponse({type:X[0],id:X[1],data:ce})}}onResponse(z){if(z.type===200){this.state=g.Idle,this._onDidInitialize.fire();return}this.handlers.get(z.id)?.(z)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,E.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}pe([T.memoize],y.prototype,"onDidInitializePromise",null),e.ChannelClient=y;class _{get connections(){const z=[];return this._connections.forEach(K=>z.push(K)),z}constructor(z){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new w.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new w.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,z(({protocol:K,onDidClientDisconnect:X})=>{w.Event.once(K.onMessage)(B=>{const G=new f(B),O=u(G),M=new l(K,O),x=new y(K);this.channels.forEach((ee,oe)=>M.registerChannel(oe,ee));const V={channelServer:M,channelClient:x,ctx:O};this._connections.add(V),this._onDidAddConnection.fire(V),X(()=>{M.dispose(),x.dispose(),this._connections.delete(V),this._onDidRemoveConnection.fire(V)})})})}getChannel(z,K){const X=this;return{call(ce,B,G){let O;if((0,p.isFunction)(K)){const x=(0,D.getRandomElement)(X.connections.filter(K));O=x?Promise.resolve(x):w.Event.toPromise(w.Event.filter(X.onDidAddConnection,K))}else O=K.routeCall(X,ce,B);const M=O.then(x=>x.channelClient.getChannel(z));return A(M).call(ce,B,G)},listen(ce,B){if((0,p.isFunction)(K))return X.getMulticastEvent(z,K,ce,B);const G=K.routeEvent(X,ce,B).then(O=>O.channelClient.getChannel(z));return A(G).listen(ce,B)}}}getMulticastEvent(z,K,X,ce){const B=this;let G=new E.DisposableStore;const O=new w.Emitter({onFirstListenerAdd:()=>{G=new E.DisposableStore;const M=new w.EventMultiplexer,x=new Map,V=oe=>{const ie=oe.channelClient.getChannel(z).listen(X,ce),se=M.add(ie);x.set(oe,se)},ee=oe=>{const Z=x.get(oe);!Z||(Z.dispose(),x.delete(oe))};B.connections.filter(K).forEach(V),w.Event.filter(B.onDidAddConnection,K)(V,void 0,G),B.onDidRemoveConnection(ee,void 0,G),M.event(O.fire,O,G),G.add(M)},onLastListenerRemove:()=>{G.dispose()}});return O.event}registerChannel(z,K){this.channels.set(z,K),this._connections.forEach(X=>{X.channelServer.registerChannel(z,K)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=_;class ${constructor(z,K,X=null){const ce=new a;s(ce,K),z.send(ce.buffer),this.channelClient=new y(z,X),this.channelServer=new l(z,K,X)}getChannel(z){return this.channelClient.getChannel(z)}registerChannel(z,K){this.channelServer.registerChannel(z,K)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=$;function A(W){return{call(z,K,X){return W.then(ce=>ce.call(z,K,X))},listen(z,K){const X=new w.Relay;return W.then(ce=>X.input=ce.listen(z,K)),X.event}}}e.getDelayedChannel=A;function U(W){let z=!1;return{call(K,X,ce){return z?W.call(K,X,ce):(0,r.timeout)(0).then(()=>z=!0).then(()=>W.call(K,X,ce))},listen(K,X){if(z)return W.listen(K,X);const ce=new w.Relay;return(0,r.timeout)(0).then(()=>z=!0).then(()=>ce.input=W.listen(K,X)),ce.event}}}e.getNextTickChannel=U;class k{constructor(z){this.fn=z}routeCall(z){return this.route(z)}routeEvent(z){return this.route(z)}async route(z){for(const K of z.connections)if(await Promise.resolve(this.fn(K.ctx)))return Promise.resolve(K);return await w.Event.toPromise(z.onDidAddConnection),await this.route(z)}}e.StaticRouter=k;var N;(function(W){function z(B,G){const O=B,M=G&&G.disableMarshalling,x=new Map;for(const V in O)X(V)&&x.set(V,w.Event.buffer(O[V],!0));return new class{listen(V,ee,oe){const Z=x.get(ee);if(Z)return Z;if(ce(ee)){const ie=O[ee];if(typeof ie=="function")return ie.call(O,oe)}throw new Error(`Event not found: ${ee}`)}call(V,ee,oe){const Z=O[ee];if(typeof Z=="function"){if(!M&&Array.isArray(oe))for(let ie=0;ie<oe.length;ie++)oe[ie]=(0,I.revive)(oe[ie]);return Z.apply(O,oe)}throw new Error(`Method not found: ${ee}`)}}}W.fromService=z;function K(B,G){const O=G&&G.disableMarshalling;return new Proxy({},{get(M,x){if(typeof x=="string")return G?.properties?.has(x)?G.properties.get(x):ce(x)?function(V){return B.listen(x,V)}:X(x)?B.listen(x):async function(...V){let ee;G&&!(0,p.isUndefinedOrNull)(G.context)?ee=[G.context,...V]:ee=V;const oe=await B.call(x,ee);return O?oe:(0,I.revive)(oe)};throw new Error(`Property not found: ${String(x)}`)}})}W.toService=K;function X(B){return B[0]==="o"&&B[1]==="n"&&b.isUpperAsciiLetter(B.charCodeAt(2))}function ce(B){return/^onDynamic/.test(B)&&b.isUpperAsciiLetter(B.charCodeAt(9))}})(N=e.ProxyChannel||(e.ProxyChannel={}));const F=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function q(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){const z=W.toString();if(z!=="[object Object]")return z}return W}function J(W){return Array.isArray(W)?W.map(q):q(W)}function j(W,z,K,X,ce,B,G){G=J(G);const O=F[ce],M=O[X%O.length];let x=[`%c[${W}]%c[${String(z).padStart(7," ")}]%c[len: ${String(K).padStart(5," ")}]%c${String(X).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${M}`];/\($/.test(B)?(x=x.concat(G),x.push(")")):x.push(G),console.log.apply(console,x)}e.logWithColors=j;class H{constructor(z,K){this._outgoingPrefix=z,this._incomingPrefix=K,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(z,K,X,ce,B){this._totalOutgoing+=z,j(this._outgoingPrefix,this._totalOutgoing,z,K,X,ce,B)}logIncoming(z,K,X,ce,B){this._totalIncoming+=z,j(this._incomingPrefix,this._totalIncoming,z,K,X,ce,B)}}e.IPCLogger=H}),define(ne[137],re([0,1,16,3,39]),function(Q,e,D,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class L{constructor(w){this.port=w,this.onMessage=r.Event.fromDOMEventEmitter(this.port,"message",E=>D.VSBuffer.wrap(E.data)),w.start()}send(w){this.port.postMessage(w.buffer)}disconnect(){this.port.close()}}e.Protocol=L;class T extends R.IPCClient{constructor(w,E){const I=new L(w);super(I,E),this.protocol=I}dispose(){this.protocol.disconnect()}}e.Client=T}),define(ne[89],re([0,1,16,3,2,39]),function(Q,e,D,r,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(T=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var P;(function(n){n.enableDiagnostics=!1,n.records=[];const s=new WeakMap;let u=0;function l(y,_){if(!s.has(y)){const $=String(++u);s.set(y,$)}return s.get(y)}function m(y,_,$,A){if(!n.enableDiagnostics)return;const U=l(y,_);if(A instanceof D.VSBuffer||A instanceof Uint8Array||A instanceof ArrayBuffer||ArrayBuffer.isView(A)){const k=D.VSBuffer.alloc(A.byteLength);k.set(A),n.records.push({timestamp:Date.now(),id:U,label:_,type:$,buff:k})}else n.records.push({timestamp:Date.now(),id:U,label:_,type:$,data:A})}n.traceSocketEvent=m})(P=e.SocketDiagnostics||(e.SocketDiagnostics={}));var w;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(w=e.SocketCloseEventType||(e.SocketCloseEventType={}));let E=null;function I(){return E||(E=D.VSBuffer.alloc(0)),E}class b{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,u){if(s===0)return I();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const _=this._chunks[0];return u&&(this._chunks.shift(),this._totalLength-=s),_}if(this._chunks[0].byteLength>s){const _=this._chunks[0].slice(0,s);return u&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),_}const l=D.VSBuffer.alloc(s);let m=0,y=0;for(;s>0;){const _=this._chunks[y];if(_.byteLength>s){const $=_.slice(0,s);l.set($,m),m+=s,u&&(this._chunks[y]=_.slice(s),this._totalLength-=s),s-=s}else l.set(_,m),m+=_.byteLength,u?(this._chunks.shift(),this._totalLength-=_.byteLength):y++,s-=_.byteLength}return l}}e.ChunkStream=b;var p;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume",n[n.KeepAlive=9]="KeepAlive"})(p||(p={}));function v(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var h;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(h=e.ProtocolConstants||(e.ProtocolConstants={}));class S{constructor(s,u,l,m){this.type=s,this.id=u,this.ack=l,this.data=m,this.writtenTime=0}get size(){return this.data.byteLength}}class C extends R.Disposable{constructor(s){super(),this._onMessage=this._register(new r.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new b,this._register(this._socket.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const u=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=u.readUInt32BE(9),this._state.messageType=u.readUInt8(0),this._state.id=u.readUInt32BE(1),this._state.ack=u.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:v(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const l=this._state.messageType,m=this._state.id,y=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",u),this._onMessage.fire(new S(l,m,y,u)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class g{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=D.VSBuffer.alloc(13);u.writeUInt8(s.type,0),u.writeUInt32BE(s.id,1),u.writeUInt32BE(s.ack,5),u.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:v(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(u,s.data)}_bufferAdd(s,u){const l=this._totalLength===0;return this._data.push(s,u),this._totalLength+=s.byteLength+u.byteLength,l}_bufferTake(){const s=D.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,u){this._bufferAdd(s,u)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class f extends R.Disposable{constructor(s){super(),this._onMessage=new r.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new r.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new g(this._socket)),this._socketReader=this._register(new C(this._socket)),this._register(this._socketReader.onMessage(u=>{u.type===1&&this._onMessage.fire(u.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new S(1,0,0,s))}}e.Protocol=f;class a extends L.IPCClient{static fromSocket(s,u){return new a(new f(s),u)}get onDidDispose(){return this.protocol.onDidDispose}constructor(s,u,l=null){super(s,u,l),this.protocol=s}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=a;class d{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new r.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=d;class c{constructor(s){this.data=s,this.next=null}}class i{constructor(){this._first=null,this._last=null}length(){let s=0,u=this._first;for(;u;)u=u.next,s++;return s}peek(){return this._first?this._first.data:null}toArray(){const s=[];let u=0,l=this._first;for(;l;)s[u++]=l.data,l=l.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const u=new c(s);if(!this._first){this._first=u,this._last=u;return}this._last.next=u,this._last=u}}class o{static getInstance(){return o._INSTANCE||(o._INSTANCE=new o),o._INSTANCE}constructor(){this.lastRuns=[];const s=Date.now();for(let u=0;u<o._HISTORY_LENGTH;u++)this.lastRuns[u]=s-1e3*u;setInterval(()=>{for(let u=o._HISTORY_LENGTH;u>=1;u--)this.lastRuns[u]=this.lastRuns[u-1];this.lastRuns[0]=Date.now()},1e3)}load(){const s=Date.now(),u=(1+o._HISTORY_LENGTH)*1e3;let l=0;for(let m=0;m<o._HISTORY_LENGTH;m++)s-this.lastRuns[m]<=u&&l++;return 1-l/o._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}o._HISTORY_LENGTH=10,o._INSTANCE=null;class t{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(s,u=null,l=o.getInstance()){this._onControlMessage=new d,this.onControlMessage=this._onControlMessage.event,this._onMessage=new d,this.onMessage=this._onMessage.event,this._onDidDispose=new d,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new d,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new d,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=l,this._isReconnecting=!1,this._outgoingUnackMsg=new i,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new g(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new C(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(m=>this._receiveMessage(m))),this._socketDisposables.push(this._socket.onClose(m=>this._onSocketClose.fire(m))),u&&this._socketReader.acceptChunk(u),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,R.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new S(5,0,0,I());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new S(7,0,0,I());this._socketWriter.write(s)}sendResume(){const s=new S(8,0,0,I());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,u){this._isReconnecting=!0,this._socketDisposables=(0,R.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new g(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new C(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),this._socketReader.acceptChunk(u)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new S(3,0,this._incomingAckId,I());this._socketWriter.write(s);const u=this._outgoingUnackMsg.toArray();for(let l=0,m=u.length;l<m;l++)this._socketWriter.write(u[l]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const u=this._outgoingUnackMsg.peek();if(u&&u.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const u=Date.now();u-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=u,this._socketWriter.write(new S(6,0,0,I())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const u=this._outgoingUnackMsg.toArray();for(let l=0,m=u.length;l<m;l++)this._socketWriter.write(u[l]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const u=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const l=new S(1,u,this._incomingAckId,s);this._outgoingUnackMsg.push(l),this._isReconnecting||(this._socketWriter.write(l),this._recvAckCheck())}sendControl(s){const u=new S(2,0,0,s);this._socketWriter.write(u)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),u=Date.now()-s.writtenTime,l=Date.now()-this._socketReader.lastReadTime,m=Date.now()-this._lastSocketTimeoutTime;if(u>=2e4&&l>=2e4&&m>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:u,timeSinceLastReceivedSomeData:l});return}const y=Math.max(2e4-u,2e4-l,2e4-m,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},y)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new S(3,0,this._incomingAckId,I());this._socketWriter.write(s)}_sendKeepAlive(){const s=new S(9,0,0,I());this._socketWriter.write(s)}}e.PersistentProtocol=t}),define(ne[138],re([0,1,90,3,39,137]),function(Q,e,D,r,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class T extends R.IPCServer{static getOnDidClientConnect(){const w=r.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:createMessageChannel",(E,I)=>I);return r.Event.map(w,E=>{const{port1:I,port2:b}=new MessageChannel,v={protocol:new L.Protocol(I),onDidClientDisconnect:r.Event.fromDOMEventEmitter(I,"close")};return D.ipcRenderer.postMessage("vscode:createMessageChannelResult",E,[b]),v})}constructor(){super(T.getOnDidClientConnect())}}e.Server=T}),define(ne[67],re([0,1,54,6,16,22,131,9,3,2,32,88,82,39]),function(Q,e,D,r,R,L,T,P,w,E,I,b,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class h extends v.ChannelServer{constructor(g){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:w.Event.fromNodeEventEmitter(process,"message",f=>R.VSBuffer.wrap(Buffer.from(f,"base64")))},g),process.once("disconnect",()=>this.dispose())}}e.Server=h;class S{constructor(g,f){this.modulePath=g,this.options=f,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new w.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const a=f&&f.timeout?f.timeout:6e4;this.disposeDelayer=new r.Delayer(a),this.child=null,this._client=null}getChannel(g){const f=this;return{call(a,d,c){return f.requestPromise(g,a,d,c)},listen(a,d){return f.requestEvent(g,a,d)}}}requestPromise(g,f,a,d=L.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(d.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(g),i=(0,r.createCancelablePromise)(n=>c.call(f,a,n)),o=d.onCancellationRequested(()=>i.cancel()),t=(0,E.toDisposable)(()=>i.cancel());return this.activeRequests.add(t),i.finally(()=>{o.dispose(),this.activeRequests.delete(t),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(g,f,a){if(!this.disposeDelayer)return w.Event.None;this.disposeDelayer.cancel();let d;const c=new w.Emitter({onFirstListenerAdd:()=>{d=this.getCachedChannel(g).listen(f,a)(c.fire,c),this.activeRequests.add(d)},onLastListenerRemove:()=>{this.activeRequests.delete(d),d.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const g=this.options&&this.options.args?this.options.args:[],f=Object.create(null);f.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(f.env={...f.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(f.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),(0,p.removeDangerousEnvVariables)(f.env),this.child=(0,D.fork)(this.modulePath,g,f);const a=new w.Emitter;w.Event.fromNodeEventEmitter(this.child,"message",s=>s)(s=>{if((0,T.isRemoteConsoleLog)(s)){(0,T.log)(s,`IPC Library: ${this.options.serverName}`);return}a.fire(R.VSBuffer.wrap(Buffer.from(s,"base64")))});const c=this.options.useQueue?(0,b.createQueuedSender)(this.child):this.child,i=s=>this.child&&this.child.connected&&c.send(s.buffer.toString("base64")),o=a.event,t={send:i,onMessage:o};this._client=new v.ChannelClient(t);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",s=>console.warn('IPC "'+this.options.serverName+'" errored with '+s)),this.child.on("exit",(s,u)=>{process.removeListener("exit",n),this.activeRequests.forEach(l=>(0,E.dispose)(l)),this.activeRequests.clear(),s!==0&&u!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+s+" and signal "+u),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:s,signal:u})})}return this._client}getCachedChannel(g){let f=this.channels.get(g);return f||(f=this.client.getChannel(g),this.channels.set(g,f)),f}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=S}),define(ne[139],re([0,1,16,9,3,2,12,4,30,39,89]),function(Q,e,D,r,R,L,T,P,w,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function b(){return{crypto:Q.__$__nodeRequire("crypto"),zlib:Q.__$__nodeRequire("zlib"),net:Q.__$__nodeRequire("net"),os:Q.__$__nodeRequire("os")}}class p{traceSocketEvent(l,m){I.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,l,m)}constructor(l,m=""){this._canWrite=!0,this.debugLabel=m,this.socket=l,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=y=>{if(this.traceSocketEvent("error",{code:y?.code,message:y?.message}),y){if(y.code==="EPIPE")return;(0,r.onUnexpectedError)(y)}},this.socket.on("error",this._errorListener),this._closeListener=y=>{this.traceSocketEvent("close",{hadError:y}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(l){const m=y=>{this.traceSocketEvent("read",y),l(D.VSBuffer.wrap(y))};return this.socket.on("data",m),{dispose:()=>this.socket.off("data",m)}}onClose(l){const m=y=>{l({type:0,hadError:y,error:void 0})};return this.socket.on("close",m),{dispose:()=>this.socket.off("close",m)}}onEnd(l){const m=()=>{l()};return this.socket.on("end",m),{dispose:()=>this.socket.off("end",m)}}write(l){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",l),this.socket.write(l.buffer,m=>{if(m){if(m.code==="EPIPE")return;(0,r.onUnexpectedError)(m)}})}catch(m){if(m.code==="EPIPE")return;(0,r.onUnexpectedError)(m)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((l,m)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),l();return}const y=()=>{this.socket.off("close",y),this.socket.off("end",y),this.socket.off("error",y),this.socket.off("timeout",y),this.socket.off("drain",y),this.traceSocketEvent("nodeDrainEnd"),l()};this.socket.on("close",y),this.socket.on("end",y),this.socket.on("error",y),this.socket.on("timeout",y),this.socket.on("drain",y)})}}e.NodeSocket=p;var v;(function(u){u[u.MinHeaderByteSize=2]="MinHeaderByteSize"})(v||(v={}));var h;(function(u){u[u.PeekHeader=1]="PeekHeader",u[u.ReadHeader=2]="ReadHeader",u[u.ReadBody=3]="ReadBody",u[u.Fin=4]="Fin"})(h||(h={}));class S extends L.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(l,m){this.socket.traceSocketEvent(l,m)}constructor(l,m,y,_){super(),this._onData=this._register(new R.Emitter),this._onClose=this._register(new R.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=l,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:m,inflateBytesLength:y?.byteLength||0,recordInflateBytes:_}),this._flowManager=this._register(new C(this,m,y,_,this._onData,($,A)=>this._write($,A))),this._register(this._flowManager.onError($=>{console.error($),(0,r.onUnexpectedError)($),this._onClose.fire({type:0,hadError:!0,error:$})})),this._incomingData=new I.ChunkStream,this._register(this.socket.onData($=>this._acceptChunk($))),this._register(this.socket.onClose($=>this._onClose.fire($)))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(l){return this._onData.event(l)}onClose(l){return this._onClose.event(l)}onEnd(l){return this.socket.onEnd(l)}write(l){this._flowManager.writeMessage(l)}_write(l,m){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",l);let y=2;l.byteLength<126?y+=0:l.byteLength<2**16?y+=2:y+=8;const _=D.VSBuffer.alloc(y);if(m?_.writeUInt8(194,0):_.writeUInt8(130,0),l.byteLength<126)_.writeUInt8(l.byteLength,1);else if(l.byteLength<2**16){_.writeUInt8(126,1);let $=1;_.writeUInt8(l.byteLength>>>8&255,++$),_.writeUInt8(l.byteLength>>>0&255,++$)}else{_.writeUInt8(127,1);let $=1;_.writeUInt8(0,++$),_.writeUInt8(0,++$),_.writeUInt8(0,++$),_.writeUInt8(0,++$),_.writeUInt8(l.byteLength>>>24&255,++$),_.writeUInt8(l.byteLength>>>16&255,++$),_.writeUInt8(l.byteLength>>>8&255,++$),_.writeUInt8(l.byteLength>>>0&255,++$)}this.socket.write(D.VSBuffer.concat([_,l]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(l){if(l.byteLength!==0){for(this._incomingData.acceptChunk(l);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const m=this._incomingData.peek(this._state.readLen),y=m.readUInt8(0),_=(y&128)>>>7,$=(y&64)>>>6,A=m.readUInt8(1),U=(A&128)>>>7,k=A&127;this._state.state=2,this._state.readLen=2+(U?4:0)+(k===126?2:0)+(k===127?8:0),this._state.fin=_,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean($)),this._state.firstFrameOfMessage=Boolean(_),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const m=this._incomingData.read(this._state.readLen),y=m.readUInt8(1),_=(y&128)>>>7;let $=y&127,A=1;$===126?$=m.readUInt8(++A)*2**8+m.readUInt8(++A):$===127&&($=m.readUInt8(++A)*0+m.readUInt8(++A)*0+m.readUInt8(++A)*0+m.readUInt8(++A)*0+m.readUInt8(++A)*2**24+m.readUInt8(++A)*2**16+m.readUInt8(++A)*2**8+m.readUInt8(++A));let U=0;_&&(U=m.readUInt8(++A)*2**24+m.readUInt8(++A)*2**16+m.readUInt8(++A)*2**8+m.readUInt8(++A)),this._state.state=3,this._state.readLen=$,this._state.mask=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const m=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",m),a(m,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",m),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(m,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await R.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=S;class C extends L.Disposable{get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:D.VSBuffer.alloc(0)}constructor(l,m,y,_,$,A){super(),this._tracer=l,this._onData=$,this._writeFn=A,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new R.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,m?(this._zlibInflateStream=this._register(new g(this._tracer,_,y,{windowBits:15})),this._zlibDeflateStream=this._register(new f(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(U=>this._onError.fire(U))),this._register(this._zlibDeflateStream.onError(U=>this._onError.fire(U)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(l){this._writeQueue.push(l),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const l=this._writeQueue.shift();if(this._zlibDeflateStream){const m=await this._deflateMessage(this._zlibDeflateStream,l);this._writeFn(m,!0)}else this._writeFn(l,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(l,m){return new Promise((y,_)=>{l.write(m),l.flush($=>y($))})}acceptFrame(l,m,y){this._readQueue.push({data:l,isCompressed:m,isLastFrameOfMessage:y}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const l=this._readQueue.shift();if(this._zlibInflateStream&&l.isCompressed){const m=await this._inflateFrame(this._zlibInflateStream,l.data,l.isLastFrameOfMessage);this._onData.fire(m)}else this._onData.fire(l.data)}this._isProcessingReadQueue=!1}}_inflateFrame(l,m,y){return new Promise((_,$)=>{l.write(m),y&&l.write(D.VSBuffer.fromByteArray([0,0,255,255])),l.flush(A=>_(A))})}}class g extends L.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?D.VSBuffer.concat(this._recordedInflateBytes):D.VSBuffer.alloc(0)}constructor(l,m,y,_){super(),this._tracer=l,this._recordInflateBytes=m,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=b().zlib.createInflateRaw(_),this._zlibInflate.on("error",$=>{this._tracer.traceSocketEvent("zlibInflateError",{message:$?.message,code:$?.code}),this._onError.fire($)}),this._zlibInflate.on("data",$=>{this._tracer.traceSocketEvent("zlibInflateData",$),this._pendingInflateData.push(D.VSBuffer.wrap($))}),y&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",y.buffer),this._zlibInflate.write(y.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(l){this._recordInflateBytes&&this._recordedInflateBytes.push(l.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",l),this._zlibInflate.write(l.buffer)}flush(l){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const m=D.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,l(m)})}}class f extends L.Disposable{constructor(l,m){super(),this._tracer=l,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=b().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",y=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:y?.message,code:y?.code}),this._onError.fire(y)}),this._zlibDeflate.on("data",y=>{this._tracer.traceSocketEvent("zlibDeflateData",y),this._pendingDeflateData.push(D.VSBuffer.wrap(y))})}write(l){this._tracer.traceSocketEvent("zlibDeflateWrite",l.buffer),this._zlibDeflate.write(l.buffer)}flush(l){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let m=D.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,m=m.slice(0,m.byteLength-4),l(m)})}}function a(u,l){if(l===0)return;const m=u.byteLength>>>2;for(let k=0;k<m;k++){const N=u.readUInt32BE(k*4);u.writeUInt32BE(N^l,k*4)}const y=m*4,_=u.byteLength-y,$=l>>>24&255,A=l>>>16&255,U=l>>>8&255;_>=1&&u.writeUInt8(u.readUInt8(y)^$,y),_>=2&&u.writeUInt8(u.readUInt8(y+1)^A,y+1),_>=3&&u.writeUInt8(u.readUInt8(y+2)^U,y+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const d={[2]:107,[1]:103};function c(){const u=(0,w.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${u}-sock`;let l;return e.XDG_RUNTIME_DIR?l=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${u}.sock`):l=(0,T.join)(b().os.tmpdir(),`vscode-ipc-${u}.sock`),o(l),l}e.createRandomIPCHandle=c;function i(u,l,m){const y=b().crypto.createHash("md5").update(u).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${y}-${m}-${l}-sock`;let _;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?_=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-${y.substr(0,8)}-${m}-${l}.sock`):_=(0,T.join)(u,`${m}-${l}.sock`),o(_),_}e.createStaticIPCHandle=i;function o(u){const l=d[P.platform];typeof l=="number"&&u.length>=l&&console.warn(`WARNING: IPC handle "${u}" is longer than ${l} chars, try a shorter --user-data-dir`)}class t extends E.IPCServer{static toClientConnectionEvent(l){const m=R.Event.fromNodeEventEmitter(l,"connection");return R.Event.map(m,y=>({protocol:new I.Protocol(new p(y,"ipc-server-connection")),onDidClientDisconnect:R.Event.once(R.Event.fromNodeEventEmitter(y,"close"))}))}constructor(l){super(t.toClientConnectionEvent(l)),this.server=l}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=t;function n(u){return new Promise((l,m)=>{const y=b().net.createServer();y.on("error",m),y.listen(u,()=>{y.removeListener("error",m),l(new t(y))})})}e.serve=n;function s(u,l){return new Promise((m,y)=>{const _=b().net.createConnection(u,()=>{_.removeListener("error",y),m(I.Client.fromSocket(new p(_,`ipc-client${l}`),l))});_.once("error",y)})}e.connect=s}),define(ne[68],re([0,1,6,3,2,15]),function(Q,e,D,r,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var T;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(T=e.StorageHint||(e.StorageHint={}));function P(b){const p=b;return p?.changed instanceof Map||p?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var w;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(w=e.StorageState||(e.StorageState={}));class E extends R.Disposable{constructor(p,v=Object.create(null)){super(),this.database=p,this.options=v,this._onDidChangeStorage=this._register(new r.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=w.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(E.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(p=>this.onDidChangeItemsExternal(p)))}onDidChangeItemsExternal(p){p.changed?.forEach((v,h)=>this.accept(h,v)),p.deleted?.forEach(v=>this.accept(v,void 0))}accept(p,v){if(this.state===w.Closed)return;let h=!1;(0,L.isUndefinedOrNull)(v)?h=this.cache.delete(p):this.cache.get(p)!==v&&(this.cache.set(p,v),h=!0),h&&this._onDidChangeStorage.fire(p)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===w.None&&(this.state=w.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(p,v){const h=this.cache.get(p);return(0,L.isUndefinedOrNull)(h)?v:h}getBoolean(p,v){const h=this.get(p);return(0,L.isUndefinedOrNull)(h)?v:h==="true"}getNumber(p,v){const h=this.get(p);return(0,L.isUndefinedOrNull)(h)?v:parseInt(h,10)}async set(p,v){if(this.state===w.Closed)return;if((0,L.isUndefinedOrNull)(v))return this.delete(p);const h=String(v);if(this.cache.get(p)!==h)return this.cache.set(p,h),this.pendingInserts.set(p,h),this.pendingDeletes.delete(p),this._onDidChangeStorage.fire(p),this.doFlush()}async delete(p){if(!(this.state===w.Closed||!this.cache.delete(p)))return this.pendingDeletes.has(p)||this.pendingDeletes.add(p),this.pendingInserts.delete(p),this._onDidChangeStorage.fire(p),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=w.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const p={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(p).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(p){if(!!this.hasPending)return this.doFlush(p)}async doFlush(p){return this.flushDelayer.trigger(()=>this.flushPending(),p)}async whenFlushed(){if(!!this.hasPending)return new Promise(p=>this.whenFlushedCallbacks.push(p))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=E,E.DEFAULT_FLUSH_DELAY=100;class I{constructor(){this.onDidChangeItemsExternal=r.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(p){p.insert?.forEach((v,h)=>this.items.set(h,v)),p.delete?.forEach(v=>this.items.delete(v))}async close(){}}e.InMemoryStorageDatabase=I}),define(ne[140],re([10,11]),function(Q,e){return Q.create("vs/base/node/zip",e)}),define(ne[141],re([10,11]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[142],re([10,11]),function(Q,e){return Q.create("vs/platform/environment/node/argv",e)}),define(ne[143],re([10,11]),function(Q,e){return Q.create("vs/platform/environment/node/argvHelper",e)}),define(ne[144],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[145],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[146],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[147],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[148],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(ne[149],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[150],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[151],re([10,11]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[152],re([10,11]),function(Q,e){return Q.create("vs/platform/files/common/fileService",e)}),define(ne[153],re([10,11]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(ne[154],re([10,11]),function(Q,e){return Q.create("vs/platform/files/common/io",e)}),define(ne[155],re([10,11]),function(Q,e){return Q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[156],re([10,11]),function(Q,e){return Q.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[157],re([10,11]),function(Q,e){return Q.create("vs/platform/request/common/request",e)}),define(ne[158],re([10,11]),function(Q,e){return Q.create("vs/platform/shell/node/shellEnv",e)}),define(ne[159],re([10,11]),function(Q,e){return Q.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[160],re([10,11]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ne[161],re([10,11]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ne[162],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[163],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ne[164],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ne[165],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ne[166],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ne[167],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ne[168],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ne[169],re([10,11]),function(Q,e){return Q.create("vs/platform/workspace/common/workspace",e)}),define(ne[91],re([0,1,64,63,23,12,37,19,7]),function(Q,e,D,r,R,L,T,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class E{get appRoot(){return(0,L.dirname)(R.FileAccess.asFileUri("",Q).fsPath)}get userHome(){return w.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return w.URI.file((0,L.join)(this.userDataPath,"User"))}get tmpDir(){return w.URI.file(this.paths.tmpDir)}get cacheHome(){return w.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const S=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.join)(this.userDataPath,"logs",S)}return this.args.logsPath}get userDataSyncLogResource(){return w.URI.file((0,L.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return w.URI.file((0,L.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(w.URI.file((0,L.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const S=T.env.VSCODE_PORTABLE;return S?w.URI.file((0,L.join)(S,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return w.URI.file((0,L.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,L.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const S=this.args["builtin-extensions-dir"];return S?(0,L.resolve)(S):(0,L.normalize)((0,L.join)(R.FileAccess.asFileUri("",Q).fsPath,"..","extensions"))}get extensionsDownloadPath(){const S=this.args["extensions-download-dir"];return S?(0,L.resolve)(S):(0,L.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const S=this.args["extensions-dir"];if(S)return(0,L.resolve)(S);const C=T.env.VSCODE_EXTENSIONS;if(C)return C;const g=T.env.VSCODE_PORTABLE;return g?(0,L.join)(g,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const S=this.args.extensionDevelopmentPath;if(Array.isArray(S))return S.map(C=>/^[^:/?#]+?:\/\//.test(C)?w.URI.parse(C):w.URI.file((0,L.normalize)(C)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(S=>S==="ui"||S==="workspace"||S==="web"?S:"workspace")}get extensionTestsLocationURI(){const S=this.args.extensionTestsPath;if(S)return/^[^:/?#]+?:\/\//.test(S)?w.URI.parse(S):w.URI.file((0,L.normalize)(S))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const S=this.args["disable-extension"];if(S){if(typeof S=="string")return[S];if(Array.isArray(S)&&S.length>0)return S}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,P.joinPath)(w.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return w.URI.file((0,L.join)(this.logsPath,"telemetry.log"))}get extensionTelemetryLogResource(){return w.URI.file((0,L.join)(this.logsPath,"extensionTelemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const S=T.env.VSCODE_PORTABLE;return S?w.URI.file((0,L.join)(S,"policy.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(S){this.args.continueOn=S}get args(){return this._args}constructor(S,C,g){this._args=S,this.paths=C,this.productService=g,this.editSessionId=this.args.editSessionId}}pe([r.memoize],E.prototype,"appRoot",null),pe([r.memoize],E.prototype,"userHome",null),pe([r.memoize],E.prototype,"userDataPath",null),pe([r.memoize],E.prototype,"appSettingsHome",null),pe([r.memoize],E.prototype,"tmpDir",null),pe([r.memoize],E.prototype,"cacheHome",null),pe([r.memoize],E.prototype,"stateResource",null),pe([r.memoize],E.prototype,"userRoamingDataHome",null),pe([r.memoize],E.prototype,"userDataSyncHome",null),pe([r.memoize],E.prototype,"userDataSyncLogResource",null),pe([r.memoize],E.prototype,"editSessionsLogResource",null),pe([r.memoize],E.prototype,"sync",null),pe([r.memoize],E.prototype,"machineSettingsResource",null),pe([r.memoize],E.prototype,"workspaceStorageHome",null),pe([r.memoize],E.prototype,"localHistoryHome",null),pe([r.memoize],E.prototype,"keyboardLayoutResource",null),pe([r.memoize],E.prototype,"argvResource",null),pe([r.memoize],E.prototype,"isExtensionDevelopment",null),pe([r.memoize],E.prototype,"untitledWorkspacesHome",null),pe([r.memoize],E.prototype,"installSourcePath",null),pe([r.memoize],E.prototype,"builtinExtensionsPath",null),pe([r.memoize],E.prototype,"extensionsPath",null),pe([r.memoize],E.prototype,"extensionDevelopmentLocationURI",null),pe([r.memoize],E.prototype,"extensionDevelopmentKind",null),pe([r.memoize],E.prototype,"extensionTestsLocationURI",null),pe([r.memoize],E.prototype,"debugExtensionHost",null),pe([r.memoize],E.prototype,"serviceMachineIdResource",null),pe([r.memoize],E.prototype,"telemetryLogResource",null),pe([r.memoize],E.prototype,"disableWorkspaceTrust",null),pe([r.memoize],E.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=E;function I(h,S){return v(h["inspect-extensions"],h["inspect-brk-extensions"],5870,S,h.debugId,h.extensionEnvironment)}e.parseExtensionHostPort=I;function b(h,S){return v(h["inspect-search"],h["inspect-brk-search"],5876,S,h.extensionEnvironment)}e.parseSearchPort=b;function p(h,S){return v(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,S,h.extensionEnvironment)}e.parsePtyHostPort=p;function v(h,S,C,g,f,a){const c=Number(S||h)||(g?null:C),i=c?Boolean(!!S):!1;let o;if(a)try{o=JSON.parse(a)}catch{}return{port:c,break:i,debugId:f,env:o}}}),define(ne[170],re([0,1,275,4,142]),function(Q,e,D,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const L={o:(0,R.localize)(0,null),e:(0,R.localize)(1,null),t:(0,R.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,R.localize)(3,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,R.localize)(4,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,R.localize)(5,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,R.localize)(6,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,R.localize)(7,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,R.localize)(8,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,R.localize)(9,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,R.localize)(10,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,R.localize)(11,null)},profile:{type:"string",cat:"o",args:"settingsProfileName",description:(0,R.localize)(12,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,R.localize)(13,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,R.localize)(14,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,R.localize)(15,null)},"show-versions":{type:"boolean",cat:"e",description:(0,R.localize)(16,null)},category:{type:"string",cat:"e",description:(0,R.localize)(17,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,R.localize)(18,null)},"pre-release":{type:"boolean",cat:"e",description:(0,R.localize)(19,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,R.localize)(20,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,R.localize)(21,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,R.localize)(22,null)},verbose:{type:"boolean",cat:"t",description:(0,R.localize)(23,null)},log:{type:"string",cat:"t",args:"level",description:(0,R.localize)(24,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,R.localize)(25,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,R.localize)(26,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,R.localize)(27,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,R.localize)(28,null)},sync:{type:"string",cat:"t",description:(0,R.localize)(29,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,R.localize)(30,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,R.localize)(31,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,R.localize)(32,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,R.localize)(33,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,R.localize)(34,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const T={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(h,S,C=T){const g={},f=["_"],a=[];for(const o in S){const t=S[o];t.alias&&(g[o]=t.alias),t.type==="string"||t.type==="string[]"?(f.push(o),t.deprecates&&f.push(...t.deprecates)):t.type==="boolean"&&(a.push(o),t.deprecates&&a.push(...t.deprecates))}const d=D(h,{string:f,boolean:a,alias:g}),c={},i=d;c._=d._.map(o=>String(o)).filter(o=>o.length>0),delete i._;for(const o in S){const t=S[o];t.alias&&delete i[t.alias];let n=i[o];if(t.deprecates)for(const s of t.deprecates)i.hasOwnProperty(s)&&(n||(n=i[s],n&&C.onDeprecatedOption(s,t.deprecationMessage||(0,R.localize)(35,null,o))),delete i[s]);if(typeof n<"u"){if(t.type==="string[]"){if(Array.isArray(n)||(n=[n]),!t.allowEmptyValue){const s=n.filter(u=>u.length>0);s.length!==n.length&&(C.onEmptyValue(o),n=s.length>0?s:void 0)}}else t.type==="string"&&(Array.isArray(n)?(n=n.pop(),C.onMultipleValues(o,n)):!n&&!t.allowEmptyValue&&(C.onEmptyValue(o),n=void 0));c[o]=n,t.deprecationMessage&&C.onDeprecatedOption(o,t.deprecationMessage)}delete i[o]}for(const o in i)C.onUnknownOption(o);return c}e.parseArgs=P;function w(h,S){let C="";return S.args&&(Array.isArray(S.args)?C=` <${S.args.join("> <")}>`:C=` <${S.args}>`),S.alias?`-${S.alias} --${h}${C}`:`--${h}${C}`}function E(h,S){let C=0;const g=[];for(const c in h){const i=h[c],o=w(c,i);C=Math.max(C,o.length),g.push([o,i.description])}const f=C+2+1;if(S-f<25)return g.reduce((c,i)=>c.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const a=S-f-1,d=[];for(const c of g){const i=c[0],o=b(c[1],a),t=I(f-i.length-2);d.push("  "+i+t+o[0]);for(let n=1;n<o.length;n++)d.push(I(f)+o[n])}return d}e.formatOptions=E;function I(h){return" ".repeat(h)}function b(h,S){const C=[];for(;h.length;){const g=h.length<S?h.length:h.lastIndexOf(" ",S),f=h.slice(0,g).trim();h=h.slice(g),C.push(f)}return C}function p(h,S,C,g,f){const a=process.stdout.isTTY&&process.stdout.columns||80,d=f?.noInputFiles!==!0?`[${(0,R.localize)(36,null)}...]`:"",c=[`${h} ${C}`];c.push(""),c.push(`${(0,R.localize)(37,null)}: ${S} [${(0,R.localize)(38,null)}]${d}`),c.push(""),f?.noPipe!==!0&&(r.isWindows?c.push((0,R.localize)(39,null,S)):c.push((0,R.localize)(40,null,S)),c.push(""));const i={};for(const o in g){const t=g[o];if(t.description&&t.cat){let n=i[t.cat];n||(i[t.cat]=n={}),n[o]=t}}for(const o in i){const t=o,n=i[t];n&&(c.push(L[t]),c.push(...E(n,a)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=p;function v(h,S){return`${h||(0,R.localize)(41,null)}
${S||(0,R.localize)(42,null)}
${process.arch}`}e.buildVersionMessage=v}),define(ne[171],re([0,1,276,143,170]),function(Q,e,D,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const L=2048;function T(p,v){const h={onUnknownOption:C=>{console.warn((0,r.localize)(0,null,C))},onMultipleValues:(C,g)=>{console.warn((0,r.localize)(1,null,C,g))},onEmptyValue:C=>{console.warn((0,r.localize)(2,null,C))},onDeprecatedOption:(C,g)=>{console.warn((0,r.localize)(3,null,C,g))}},S=(0,R.parseArgs)(p,R.OPTIONS,v?h:void 0);return S.goto&&S._.forEach(C=>D(/^(\w:)?[^:]+(:\d*){0,2}$/.test(C),(0,r.localize)(4,null))),S["max-memory"]&&D(parseInt(S["max-memory"])>=L,`The max-memory argument cannot be specified lower than ${L} MB.`),S}function P(p){const v=p.findIndex(h=>!/^-/.test(h));if(v>-1)return[...p.slice(0,v),...p.slice(v+1)]}function w(p){let[,...v]=p;process.env.VSCODE_DEV&&(v=P(v)||[]);const h=!b(process.env);return T(v,h)}e.parseMainProcessArgv=w;function E(p){const[,,...v]=p;return T(v,!0)}e.parseCLIProcessArgv=E;function I(p,...v){const h=p.indexOf("--");return h===-1?p.push(...v):p.splice(h,0,...v),p}e.addArg=I;function b(p){return p.VSCODE_CLI==="1"}e.isLaunchedFromCli=b}),function(){"use strict";function Q(e,D,r){function R(T,P){const w=L(T,P),E=[w];return e.isAbsolute(w)||E.unshift(r),e.resolve(...E)}function L(T,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const w=process.env.VSCODE_PORTABLE;if(w)return e.join(w,"user-data");let E=process.env.VSCODE_APPDATA;if(E)return e.join(E,P);const I=T["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(E=process.env.APPDATA,!E){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");E=e.join(b,"AppData","Roaming")}break;case"darwin":E=e.join(D.homedir(),"Library","Application Support");break;case"linux":E=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(E,P)}return{getUserDataPath:R}}if(typeof define=="function")define(ne[172],re([277,36,37]),function(e,D,r){return Q(e,D,r.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),D=require("os");module.exports=Q(e,D,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[173],re([0,1,36,91,172]),function(Q,e,D,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class L extends r.AbstractNativeEnvironmentService{constructor(P,w){super(P,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,R.getUserDataPath)(P,w.nameShort)},w)}}e.NativeEnvironmentService=L}),define(ne[174],re([0,1,7]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const r=/^([^@:]+@)?([^:]+):/,R=/^([^@:]+@)?([^:]+):(.+)$/,L=/^([^@]+@)?([^:]+)(:\d+)?$/,T=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,w=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function E(C){const g=C.match(T);return g?g[1]:null}function I(C){if(C.indexOf("://")===-1){const g=C.match(r);return g?E(g[2]):null}try{const g=D.URI.parse(C);if(g.authority)return E(g.authority)}catch{}return null}function b(C,g){const f=new Set;let a;for(;a=P.exec(C);){const c=I(a[1]);c&&f.add(c)}const d=new Set(g);return Array.from(f).map(c=>d.has(c)?c:c.replace(w,"a"))}e.getDomainsOfRemotes=b;function p(C){const g=C.match(L);return g?g[2]:null}function v(C,g,f){return C&&g?(f&&g.endsWith(".git")&&(g=g.substr(0,g.length-4)),g.indexOf("/")===0?`${C}${g}`:`${C}/${g}`):null}function h(C,g){if(C.indexOf("://")===-1){const f=C.match(R);if(f)return v(f[2],f[3],g)}try{const f=D.URI.parse(C);if(f.authority)return v(p(f.authority),f.path,g)}catch{}return null}function S(C,g=!1){const f=[];let a;for(;a=P.exec(C);){const d=h(a[1],g);d&&f.push(d)}return f}e.getRemotes=S}),define(ne[175],re([0,1,15,146]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function R(T,P,w){try{L(T,P,w)}catch{}return T}e.localizeManifest=R;function L(T,P,w){const E=(I,b,p)=>{const v=I[b];if((0,D.isString)(v)){const h=v,S=h.length;if(S>1&&h[0]==="%"&&h[S-1]==="%"){const C=h.substr(1,S-2);let g=P[C];g===void 0&&w&&(g=w[C]);const f=typeof g=="string"?g:g.message;if(f!==void 0){const a=w?.[C],d=typeof a=="string"?a:a?.message;if(p&&(b==="title"||b==="category")&&d&&d!==f){const c={value:f,original:d};I[b]=c}else I[b]=f}else console.warn(`[${T.name}]: ${(0,r.localize)(0,null,C)}`)}}else if((0,D.isObject)(v))for(const h in v)v.hasOwnProperty(h)&&(h==="commands"?E(v,h,!0):E(v,h,p));else if(Array.isArray(v))for(let h=0;h<v.length;h++)E(v,h,p)};for(const I in T)T.hasOwnProperty(I)&&E(T,I)}}),define(ne[176],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class D{constructor(L){this.channel=L}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(L,T,P,w){return this.channel.call("promptImportantExtensionsInstallNotification",[L,T,P,w])}promptWorkspaceRecommendations(L){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=D;class r{constructor(L){this.service=L}listen(L,T){throw new Error(`Event not found: ${T}`)}call(L,T,P){switch(T){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${T}`)}}e.ExtensionRecommendationNotificationServiceChannel=r}),define(ne[69],re([0,1,19,85,151,55]),function(Q,e,D,r,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function w(g){return g=g.trim(),g==="*"||T.test(g)}e.isValidVersionStr=w;function E(g){if(!w(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=g.match(T);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=E;function I(g){if(!g)return null;const f=g.majorBase,a=g.majorMustEqual,d=g.minorBase;let c=g.minorMustEqual;const i=g.patchBase;let o=g.patchMustEqual;g.hasCaret&&(f===0||(c=!1),o=!1);let t=0;if(g.preRelease){const n=P.exec(g.preRelease);if(n){const[,s,u,l]=n;t=Date.UTC(Number(s),Number(u)-1,Number(l))}}return{majorBase:f,majorMustEqual:a,minorBase:d,minorMustEqual:c,patchBase:i,patchMustEqual:o,isMinimum:g.hasGreaterEquals,notBefore:t}}e.normalizeVersion=I;function b(g,f,a){let d;typeof g=="string"?d=I(E(g)):d=g;let c;f instanceof Date?c=f.getTime():typeof f=="string"&&(c=new Date(f).getTime());let i;if(typeof a=="string"?i=I(E(a)):i=a,!d||!i)return!1;const o=d.majorBase,t=d.minorBase,n=d.patchBase;let s=i.majorBase,u=i.minorBase,l=i.patchBase;const m=i.notBefore;let y=i.majorMustEqual,_=i.minorMustEqual,$=i.patchMustEqual;return i.isMinimum?o>s?!0:o<s?!1:t>u?!0:t<u||c&&c<m?!1:n>=l:(o===1&&s===0&&(!y||!_||!$)&&(s=1,u=0,l=0,y=!0,_=!1,$=!1),o<s?!1:o>s?!y:t<u?!1:t>u?!_:n<l?!1:n>l?!$:!(c&&c<m))}e.isValidVersion=b;function p(g,f,a,d,c){const i=[];if(typeof d.publisher<"u"&&typeof d.publisher!="string")return i.push([r.default.Error,R.localize(0,null)]),i;if(typeof d.name!="string")return i.push([r.default.Error,R.localize(1,null,"name")]),i;if(typeof d.version!="string")return i.push([r.default.Error,R.localize(2,null,"version")]),i;if(!d.engines)return i.push([r.default.Error,R.localize(3,null,"engines")]),i;if(typeof d.engines.vscode!="string")return i.push([r.default.Error,R.localize(4,null,"engines.vscode")]),i;if(typeof d.extensionDependencies<"u"&&!C(d.extensionDependencies))return i.push([r.default.Error,R.localize(5,null,"extensionDependencies")]),i;if(typeof d.activationEvents<"u"){if(!C(d.activationEvents))return i.push([r.default.Error,R.localize(6,null,"activationEvents")]),i;if(typeof d.main>"u"&&typeof d.browser>"u")return i.push([r.default.Error,R.localize(7,null,"activationEvents","main")]),i}if(typeof d.extensionKind<"u"&&typeof d.main>"u"&&i.push([r.default.Warning,R.localize(8,null,"extensionKind")]),typeof d.main<"u"){if(typeof d.main!="string")return i.push([r.default.Error,R.localize(9,null,"main")]),i;{const n=(0,D.joinPath)(a,d.main);(0,D.isEqualOrParent)(n,a)||i.push([r.default.Warning,R.localize(10,null,n.path,a.path)])}if(typeof d.activationEvents>"u")return i.push([r.default.Error,R.localize(11,null,"activationEvents","main")]),i}if(typeof d.browser<"u"){if(typeof d.browser!="string")return i.push([r.default.Error,R.localize(12,null,"browser")]),i;{const n=(0,D.joinPath)(a,d.browser);(0,D.isEqualOrParent)(n,a)||i.push([r.default.Warning,R.localize(13,null,n.path,a.path)])}if(typeof d.activationEvents>"u")return i.push([r.default.Error,R.localize(14,null,"activationEvents","browser")]),i}if(!L.valid(d.version))return i.push([r.default.Error,R.localize(15,null)]),i;const o=[];if(!v(g,f,d,c,o))for(const n of o)i.push([r.default.Error,n]);return i}e.validateExtensionManifest=p;function v(g,f,a,d,c){return d||typeof a.main>"u"&&typeof a.browser>"u"?!0:S(g,f,a.engines.vscode,c)}e.isValidExtensionVersion=v;function h(g,f,a){return g==="*"||S(f,a,g)}e.isEngineValid=h;function S(g,f,a,d=[]){const c=I(E(a));if(!c)return d.push(R.localize(16,null,a)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return d.push(R.localize(17,null,a)),!1}else if(!c.majorMustEqual)return d.push(R.localize(18,null,a)),!1;return b(g,f,c)?!0:(d.push(R.localize(19,null,g,a)),!1)}function C(g){if(!Array.isArray(g))return!1;for(let f=0,a=g.length;f<a;f++)if(typeof g[f]!="string")return!1;return!0}}),define(ne[48],re([0,1,16,30]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function R(L,T,P){let w=P&&P.get("storage.serviceMachineId",-1)||null;if(w)return w;try{const I=(await T.readFile(L.serviceMachineIdResource)).value.toString();w=(0,r.isUUID)(I)?I:null}catch{w=null}if(!w){w=(0,r.generateUuid)();try{await T.writeFile(L.serviceMachineIdResource,D.VSBuffer.fromString(w))}catch{}}return P?.store("storage.serviceMachineId",w,-1,1),w}e.getServiceMachineId=R}),define(ne[56],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(R,L=[],T=!1){this.ctor=R,this.staticArguments=L,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=D}),define(ne[92],re([0,1,56]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const r=[];var R;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(R=e.InstantiationType||(e.InstantiationType={}));function L(P,w,E){w instanceof D.SyncDescriptor||(w=new D.SyncDescriptor(w,[],Boolean(E))),r.push([P,w])}e.registerSingleton=L;function T(){return r}e.getSingletonServiceDescriptors=T}),define(ne[177],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(L,T){this.key=L,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.Node=D;class r{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(const T of this._nodes.values())T.outgoing.size===0&&L.push(T);return L}insertEdge(L,T){const P=this.lookupOrInsertNode(L),w=this.lookupOrInsertNode(T);P.outgoing.set(w.key,w),w.incoming.set(P.key,P)}removeNode(L){const T=this._hashFn(L);this._nodes.delete(T);for(const P of this._nodes.values())P.outgoing.delete(T),P.incoming.delete(T)}lookupOrInsertNode(L){const T=this._hashFn(L);let P=this._nodes.get(T);return P||(P=new D(T,L),this._nodes.set(T,P)),P}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){const L=[];for(const[T,P]of this._nodes)L.push(`${T}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,T]of this._nodes){const P=new Set([L]),w=this._findCycle(T,P);if(w)return w}}_findCycle(L,T){for(const[P,w]of L.outgoing){if(T.has(P))return[...T,P].join(" -> ");T.add(P);const E=this._findCycle(w,T);if(E)return E;T.delete(P)}}}e.Graph=r}),define(ne[5],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var D;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function P(w){return w[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=P})(D=e._util||(e._util={})),e.IInstantiationService=R("instantiationService");function r(T,P,w){P[D.DI_TARGET]===P?P[D.DI_DEPENDENCIES].push({id:T,index:w}):(P[D.DI_DEPENDENCIES]=[{id:T,index:w}],P[D.DI_TARGET]=P)}function R(T){if(D.serviceIds.has(T))return D.serviceIds.get(T);const P=function(w,E,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");r(P,w,I)};return P.toString=()=>T,D.serviceIds.set(T,P),P}e.createDecorator=R;function L(T){return T}e.refineServiceDecorator=L}),define(ne[178],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,D.createDecorator)("checksumService")}),define(ne[17],re([0,1,15,7,5]),function(Q,e,D,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,R.createDecorator)("configurationService");function L(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof r.URI)}e.isConfigurationOverrides=L;function T(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||Array.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof r.URI)}e.isConfigurationUpdateOverrides=T;var P;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.USER=2]="USER",g[g.USER_LOCAL=3]="USER_LOCAL",g[g.USER_REMOTE=4]="USER_REMOTE",g[g.WORKSPACE=5]="WORKSPACE",g[g.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",g[g.DEFAULT=7]="DEFAULT",g[g.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function w(g){switch(g){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=w;function E(g,f){const a=Object.create(null);for(const d in g)I(a,d,g[d],f);return a}e.toValuesTree=E;function I(g,f,a,d){const c=f.split("."),i=c.pop();let o=g;for(let t=0;t<c.length;t++){const n=c[t];let s=o[n];switch(typeof s){case"undefined":s=o[n]=Object.create(null);break;case"object":break;default:d(`Ignoring ${f} as ${c.slice(0,t+1).join(".")} is ${JSON.stringify(s)}`);return}o=s}if(typeof o=="object"&&o!==null)try{o[i]=a}catch{d(`Ignoring ${f} as ${c.join(".")} is ${JSON.stringify(o)}`)}else d(`Ignoring ${f} as ${c.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=I;function b(g,f){const a=f.split(".");p(g,a)}e.removeFromValueTree=b;function p(g,f){const a=f.shift();if(f.length===0){delete g[a];return}if(Object.keys(g).indexOf(a)!==-1){const d=g[a];typeof d=="object"&&!Array.isArray(d)&&(p(d,f),Object.keys(d).length===0&&delete g[a])}}function v(g,f,a){function d(o,t){let n=o;for(const s of t){if(typeof n!="object"||n===null)return;n=n[s]}return n}const c=f.split("."),i=d(g,c);return typeof i>"u"?a:i}e.getConfigurationValue=v;function h(g,f,a){Object.keys(f).forEach(d=>{d!=="__proto__"&&(d in g?D.isObject(g[d])&&D.isObject(f[d])?h(g[d],f[d],a):a&&(g[d]=f[d]):g[d]=f[d])})}e.merge=h;function S(g,f,a){const d=g.inspect(f),c=g.inspect(a);return typeof d.userValue<"u"||typeof d.workspaceValue<"u"||typeof d.workspaceFolderValue<"u"?d.value:typeof c.userValue<"u"||typeof c.workspaceValue<"u"||typeof c.workspaceFolderValue<"u"?c.value:d.defaultValue}e.getMigratedSettingValue=S;function C(g){return g.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=C}),define(ne[179],re([0,1,4,27,5]),function(Q,e,D,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const L=new Map;L.set("false",!1),L.set("true",!0),L.set("isMac",D.isMacintosh),L.set("isLinux",D.isLinux),L.set("isWindows",D.isWindows),L.set("isWeb",D.isWeb),L.set("isMacNative",D.isMacintosh&&!D.isWeb),L.set("isEdge",D.isEdge),L.set("isFirefox",D.isFirefox),L.set("isChrome",D.isChrome),L.set("isSafari",D.isSafari);const T=Object.prototype.hasOwnProperty;var P;(function(U){U[U.False=0]="False",U[U.True=1]="True",U[U.Defined=2]="Defined",U[U.Not=3]="Not",U[U.Equals=4]="Equals",U[U.NotEquals=5]="NotEquals",U[U.And=6]="And",U[U.Regex=7]="Regex",U[U.NotRegex=8]="NotRegex",U[U.Or=9]="Or",U[U.In=10]="In",U[U.NotIn=11]="NotIn",U[U.Greater=12]="Greater",U[U.GreaterEquals=13]="GreaterEquals",U[U.Smaller=14]="Smaller",U[U.SmallerEquals=15]="SmallerEquals"})(P=e.ContextKeyExprType||(e.ContextKeyExprType={}));class w{static false(){return b.INSTANCE}static true(){return p.INSTANCE}static has(k){return v.create(k)}static equals(k,N){return h.create(k,N)}static notEquals(k,N){return g.create(k,N)}static regex(k,N){return t.create(k,N)}static in(k,N){return S.create(k,N)}static notIn(k,N){return C.create(k,N)}static not(k){return f.create(k)}static and(...k){return u.create(k,null)}static or(...k){return l.create(k,null,!0)}static greater(k,N){return d.create(k,N)}static greaterEquals(k,N){return c.create(k,N)}static smaller(k,N){return i.create(k,N)}static smallerEquals(k,N){return o.create(k,N)}static deserialize(k,N=!1){if(!!k)return this._deserializeOrExpression(k,N)}static _deserializeOrExpression(k,N){const F=k.split("||");return l.create(F.map(q=>this._deserializeAndExpression(q,N)),null,!0)}static _deserializeAndExpression(k,N){const F=k.split("&&");return u.create(F.map(q=>this._deserializeOne(q,N)),null)}static _deserializeOne(k,N){if(k=k.trim(),k.indexOf("!=")>=0){const F=k.split("!=");return g.create(F[0].trim(),this._deserializeValue(F[1],N))}if(k.indexOf("==")>=0){const F=k.split("==");return h.create(F[0].trim(),this._deserializeValue(F[1],N))}if(k.indexOf("=~")>=0){const F=k.split("=~");return t.create(F[0].trim(),this._deserializeRegexValue(F[1],N))}if(k.indexOf(" not in ")>=0){const F=k.split(" not in ");return C.create(F[0].trim(),F[1].trim())}if(k.indexOf(" in ")>=0){const F=k.split(" in ");return S.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(k)){const F=k.split(">=");return c.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(k)){const F=k.split(">");return d.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(k)){const F=k.split("<=");return o.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(k)){const F=k.split("<");return i.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(k)?f.create(k.substr(1).trim()):v.create(k)}static _deserializeValue(k,N){if(k=k.trim(),k==="true")return!0;if(k==="false")return!1;const F=/^'([^']*)'$/.exec(k);return F?F[1].trim():k}static _deserializeRegexValue(k,N){if((0,r.isFalsyOrWhitespace)(k)){if(N)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const F=k.indexOf("/"),q=k.lastIndexOf("/");if(F===q||F<0){if(N)throw new Error(`bad regexp-value '${k}', missing /-enclosure`);return console.warn(`bad regexp-value '${k}', missing /-enclosure`),null}const J=k.slice(F+1,q),j=k[q+1]==="i"?"i":"";try{return new RegExp(J,j)}catch(H){if(N)throw new Error(`bad regexp-value '${k}', parse error: ${H}`);return console.warn(`bad regexp-value '${k}', parse error: ${H}`),null}}}e.ContextKeyExpr=w;function E(U,k){const N=U?U.substituteConstants():void 0,F=k?k.substituteConstants():void 0;return!N&&!F?!0:!N||!F?!1:N.equals(F)}e.expressionsAreEqualWithConstantSubstitution=E;function I(U,k){return U.cmp(k)}class b{constructor(){this.type=0}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!1}serialize(){return"false"}keys(){return[]}map(k){return this}negate(){return p.INSTANCE}}e.ContextKeyFalseExpr=b,b.INSTANCE=new b;class p{constructor(){this.type=1}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!0}serialize(){return"true"}keys(){return[]}map(k){return this}negate(){return b.INSTANCE}}e.ContextKeyTrueExpr=p,p.INSTANCE=new p;class v{static create(k,N=null){const F=L.get(k);return typeof F=="boolean"?F?p.INSTANCE:b.INSTANCE:new v(k,N)}constructor(k,N){this.key=k,this.negated=N,this.type=2}cmp(k){return k.type!==this.type?this.type-k.type:y(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=L.get(this.key);return typeof k=="boolean"?k?p.INSTANCE:b.INSTANCE:this}evaluate(k){return!!k.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(k){return k.mapDefined(this.key)}negate(){return this.negated||(this.negated=f.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=v;class h{static create(k,N,F=null){if(typeof N=="boolean")return N?v.create(k,F):f.create(k,F);const q=L.get(k);return typeof q=="boolean"?N===(q?"true":"false")?p.INSTANCE:b.INSTANCE:new h(k,N,F)}constructor(k,N,F){this.key=k,this.value=N,this.negated=F,this.type=4}cmp(k){return k.type!==this.type?this.type-k.type:_(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=L.get(this.key);if(typeof k=="boolean"){const N=k?"true":"false";return this.value===N?p.INSTANCE:b.INSTANCE}return this}evaluate(k){return k.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(k){return k.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=h;class S{static create(k,N){return new S(k,N)}constructor(k,N){this.key=k,this.valueKey=N,this.type=10,this.negated=null}cmp(k){return k.type!==this.type?this.type-k.type:_(this.key,this.valueKey,k.key,k.valueKey)}equals(k){return k.type===this.type?this.key===k.key&&this.valueKey===k.valueKey:!1}substituteConstants(){return this}evaluate(k){const N=k.getValue(this.valueKey),F=k.getValue(this.key);return Array.isArray(N)?N.includes(F):typeof F=="string"&&typeof N=="object"&&N!==null?T.call(N,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(k){return k.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=C.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=S;class C{static create(k,N){return new C(k,N)}constructor(k,N){this.key=k,this.valueKey=N,this.type=11,this._negated=S.create(k,N)}cmp(k){return k.type!==this.type?this.type-k.type:this._negated.cmp(k._negated)}equals(k){return k.type===this.type?this._negated.equals(k._negated):!1}substituteConstants(){return this}evaluate(k){return!this._negated.evaluate(k)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(k){return k.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=C;class g{static create(k,N,F=null){if(typeof N=="boolean")return N?f.create(k,F):v.create(k,F);const q=L.get(k);return typeof q=="boolean"?N===(q?"true":"false")?b.INSTANCE:p.INSTANCE:new g(k,N,F)}constructor(k,N,F){this.key=k,this.value=N,this.negated=F,this.type=5}cmp(k){return k.type!==this.type?this.type-k.type:_(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=L.get(this.key);if(typeof k=="boolean"){const N=k?"true":"false";return this.value===N?b.INSTANCE:p.INSTANCE}return this}evaluate(k){return k.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(k){return k.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=g;class f{static create(k,N=null){const F=L.get(k);return typeof F=="boolean"?F?b.INSTANCE:p.INSTANCE:new f(k,N)}constructor(k,N){this.key=k,this.negated=N,this.type=3}cmp(k){return k.type!==this.type?this.type-k.type:y(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=L.get(this.key);return typeof k=="boolean"?k?b.INSTANCE:p.INSTANCE:this}evaluate(k){return!k.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(k){return k.mapNot(this.key)}negate(){return this.negated||(this.negated=v.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=f;function a(U,k){if(typeof U=="string"){const N=parseFloat(U);isNaN(N)||(U=N)}return typeof U=="string"||typeof U=="number"?k(U):b.INSTANCE}class d{static create(k,N,F=null){return a(N,q=>new d(k,q,F))}constructor(k,N,F){this.key=k,this.value=N,this.negated=F,this.type=12}cmp(k){return k.type!==this.type?this.type-k.type:_(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=d;class c{static create(k,N,F=null){return a(N,q=>new c(k,q,F))}constructor(k,N,F){this.key=k,this.value=N,this.negated=F,this.type=13}cmp(k){return k.type!==this.type?this.type-k.type:_(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=c;class i{static create(k,N,F=null){return a(N,q=>new i(k,q,F))}constructor(k,N,F){this.key=k,this.value=N,this.negated=F,this.type=14}cmp(k){return k.type!==this.type?this.type-k.type:_(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=i;class o{static create(k,N,F=null){return a(N,q=>new o(k,q,F))}constructor(k,N,F){this.key=k,this.value=N,this.negated=F,this.type=15}cmp(k){return k.type!==this.type?this.type-k.type:_(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=o;class t{static create(k,N){return new t(k,N)}constructor(k,N){this.key=k,this.regexp=N,this.type=7,this.negated=null}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.key<k.key)return-1;if(this.key>k.key)return 1;const N=this.regexp?this.regexp.source:"",F=k.regexp?k.regexp.source:"";return N<F?-1:N>F?1:0}equals(k){if(k.type===this.type){const N=this.regexp?this.regexp.source:"",F=k.regexp?k.regexp.source:"";return this.key===k.key&&N===F}return!1}substituteConstants(){return this}evaluate(k){const N=k.getValue(this.key);return this.regexp?this.regexp.test(N):!1}serialize(){const k=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${k}`}keys(){return[this.key]}map(k){return k.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=n.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class n{static create(k){return new n(k)}constructor(k){this._actual=k,this.type=8}cmp(k){return k.type!==this.type?this.type-k.type:this._actual.cmp(k._actual)}equals(k){return k.type===this.type?this._actual.equals(k._actual):!1}substituteConstants(){return this}evaluate(k){return!this._actual.evaluate(k)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(k){return new n(this._actual.map(k))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;function s(U){let k=null;for(let N=0,F=U.length;N<F;N++){const q=U[N].substituteConstants();if(U[N]!==q&&k===null){k=[];for(let J=0;J<N;J++)k[J]=U[J]}k!==null&&(k[N]=q)}return k===null?U:k}class u{static create(k,N){return u._normalizeArr(k,N)}constructor(k,N){this.expr=k,this.negated=N,this.type=6}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let N=0,F=this.expr.length;N<F;N++){const q=I(this.expr[N],k.expr[N]);if(q!==0)return q}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let N=0,F=this.expr.length;N<F;N++)if(!this.expr[N].equals(k.expr[N]))return!1;return!0}return!1}substituteConstants(){const k=s(this.expr);return k===this.expr?this:u.create(k,this.negated)}evaluate(k){for(let N=0,F=this.expr.length;N<F;N++)if(!this.expr[N].evaluate(k))return!1;return!0}static _normalizeArr(k,N){const F=[];let q=!1;for(const J of k)if(!!J){if(J.type===1){q=!0;continue}if(J.type===0)return b.INSTANCE;if(J.type===6){F.push(...J.expr);continue}F.push(J)}if(F.length===0&&q)return p.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];F.sort(I);for(let J=1;J<F.length;J++)F[J-1].equals(F[J])&&(F.splice(J,1),J--);if(F.length===1)return F[0];for(;F.length>1;){const J=F[F.length-1];if(J.type!==9)break;F.pop();const j=F.pop(),H=F.length===0,W=l.create(J.expr.map(z=>u.create([z,j],null)),null,H);W&&(F.push(W),F.sort(I))}return F.length===1?F[0]:new u(F,N)}}serialize(){return this.expr.map(k=>k.serialize()).join(" && ")}keys(){const k=[];for(const N of this.expr)k.push(...N.keys());return k}map(k){return new u(this.expr.map(N=>N.map(k)),null)}negate(){if(!this.negated){const k=[];for(const N of this.expr)k.push(N.negate());this.negated=l.create(k,this,!0)}return this.negated}}class l{static create(k,N,F){return l._normalizeArr(k,N,F)}constructor(k,N){this.expr=k,this.negated=N,this.type=9}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let N=0,F=this.expr.length;N<F;N++){const q=I(this.expr[N],k.expr[N]);if(q!==0)return q}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let N=0,F=this.expr.length;N<F;N++)if(!this.expr[N].equals(k.expr[N]))return!1;return!0}return!1}substituteConstants(){const k=s(this.expr);return k===this.expr?this:l.create(k,this.negated,!1)}evaluate(k){for(let N=0,F=this.expr.length;N<F;N++)if(this.expr[N].evaluate(k))return!0;return!1}static _normalizeArr(k,N,F){let q=[],J=!1;if(k){for(let j=0,H=k.length;j<H;j++){const W=k[j];if(!!W){if(W.type===0){J=!0;continue}if(W.type===1)return p.INSTANCE;if(W.type===9){q=q.concat(W.expr);continue}q.push(W)}}if(q.length===0&&J)return b.INSTANCE;q.sort(I)}if(q.length!==0){if(q.length===1)return q[0];for(let j=1;j<q.length;j++)q[j-1].equals(q[j])&&(q.splice(j,1),j--);if(q.length===1)return q[0];if(F){for(let j=0;j<q.length;j++)for(let H=j+1;H<q.length;H++)$(q[j],q[H])&&(q.splice(H,1),H--);if(q.length===1)return q[0]}return new l(q,N)}}serialize(){return this.expr.map(k=>k.serialize()).join(" || ")}keys(){const k=[];for(const N of this.expr)k.push(...N.keys());return k}map(k){return new l(this.expr.map(N=>N.map(k)),null)}negate(){if(!this.negated){const k=[];for(const N of this.expr)k.push(N.negate());for(;k.length>1;){const N=k.shift(),F=k.shift(),q=[];for(const j of A(N))for(const H of A(F))q.push(u.create([j,H],null));const J=k.length===0;k.unshift(l.create(q,null,J))}this.negated=k[0]}return this.negated}}class m extends v{static all(){return m._info.values()}constructor(k,N,F){super(k,null),this._defaultValue=N,typeof F=="object"?m._info.push({...F,key:k}):F!==!0&&m._info.push({key:k,description:F,type:N!=null?typeof N:void 0})}bindTo(k){return k.createKey(this.key,this._defaultValue)}getValue(k){return k.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(k){return h.create(this.key,k)}notEqualsTo(k){return g.create(this.key,k)}}e.RawContextKey=m,m._info=[],e.IContextKeyService=(0,R.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function y(U,k){return U<k?-1:U>k?1:0}function _(U,k,N,F){return U<N?-1:U>N?1:k<F?-1:k>F?1:0}function $(U,k){if(k.type===6&&U.type!==9&&U.type!==6){for(const q of k.expr)if(U.equals(q))return!0}const N=U.negate(),F=A(N).concat(A(k));F.sort(I);for(let q=0;q<F.length;q++){const j=F[q].negate();for(let H=q+1;H<F.length;H++){const W=F[H];if(j.equals(W))return!0}}return!1}e.implies=$;function A(U){return U.type===9?U.expr:[U]}}),define(ne[93],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,D.createDecorator)(e.ID);function r(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=r;class R{async getPerformanceInfo(T,P){return{}}async getSystemInfo(T,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(T,P){return""}async getWorkspaceFileExtensions(T){return{extensions:[]}}async reportWorkspaceStats(T){}}e.NullDiagnosticsService=R}),define(ne[94],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,D.createDecorator)("downloadService")}),define(ne[14],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(ne[29],re([0,1,145,5]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function R(g){switch(g){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=R;function L(g){switch(g){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function T(g,f){switch(g){case 3:return f==="x64"?"win32-x64":f==="ia32"?"win32-ia32":f==="arm64"?"win32-arm64":"unknown";case 2:return f==="x64"?"linux-x64":f==="arm64"?"linux-arm64":f==="arm"?"linux-armhf":"unknown";case"alpine":return f==="x64"?"alpine-x64":f==="arm64"?"alpine-arm64":"unknown";case 1:return f==="x64"?"darwin-x64":f==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=T;function P(g,f){return f==="web"&&!g.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function w(g,f,a){return P(f,a)?!1:g==="undefined"||g==="universal"?!0:g==="unknown"?!1:g===a?!0:E(a).includes(g)}e.isTargetPlatformCompatible=w;function E(g){switch(g){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=E;function I(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=I;var b;(function(g){g[g.NoneOrRelevance=0]="NoneOrRelevance",g[g.LastUpdatedDate=1]="LastUpdatedDate",g[g.Title=2]="Title",g[g.PublisherName=3]="PublisherName",g[g.InstallCount=4]="InstallCount",g[g.PublishedDate=10]="PublishedDate",g[g.AverageRating=6]="AverageRating",g[g.WeightedRating=12]="WeightedRating"})(b=e.SortBy||(e.SortBy={}));var p;(function(g){g[g.Default=0]="Default",g[g.Ascending=1]="Ascending",g[g.Descending=2]="Descending"})(p=e.SortOrder||(e.SortOrder={}));var v;(function(g){g.Install="install",g.Uninstall="uninstall"})(v=e.StatisticType||(e.StatisticType={}));var h;(function(g){g[g.None=1]="None",g[g.Install=2]="Install",g[g.Update=3]="Update",g[g.Migrate=4]="Migrate"})(h=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,r.createDecorator)("extensionGalleryService");var S;(function(g){g.Unsupported="Unsupported",g.Deprecated="Deprecated",g.Malicious="Malicious",g.Incompatible="Incompatible",g.IncompatiblePreRelease="IncompatiblePreRelease",g.IncompatibleTargetPlatform="IncompatibleTargetPlatform",g.ReleaseVersionNotFound="ReleaseVersionNotFound",g.Invalid="Invalid",g.Download="Download",g.Extract="Extract",g.Delete="Delete",g.Rename="Rename",g.CorruptZip="CorruptZip",g.IncompleteZip="IncompleteZip",g.Internal="Internal"})(S=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class C extends Error{constructor(f,a){super(f),this.code=a,this.name=a}}e.ExtensionManagementError=C,e.IExtensionManagementService=(0,r.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,r.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,r.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,D.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,D.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(ne[180],re([0,1,3,2,66,32,7,132,29]),function(Q,e,D,r,R,L,T,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function E(C,g){return T.URI.revive(g?g.transformIncoming(C):C)}function I(C,g){return g?g.transformOutgoingURI(C):C}function b(C,g){g=g||P.DefaultURITransformer;const f=C.manifest;return{...(0,P.transformAndReviveIncomingURIs)({...C,manifest:void 0},g),manifest:f}}function p(C,g){return g?(0,L.cloneAndChange)(C,f=>f instanceof T.URI?g.transformOutgoingURI(f):void 0):C}class v{constructor(g,f){this.service=g,this.getUriTransformer=f,this.onInstallExtension=D.Event.buffer(g.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(g.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(g.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(g.onDidUninstallExtension,!0)}listen(g,f){const a=this.getUriTransformer(g);switch(f){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,d=>d.map(c=>({...c,local:c.local?p(c.local,a):c.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(g,f,a){const d=this.getUriTransformer(g);switch(f){case"zip":return this.service.zip(b(a[0],d)).then(c=>I(c,d));case"unzip":return this.service.unzip(E(a[0],d));case"install":return this.service.install(E(a[0],d),(0,R.revive)(a[1]));case"getManifest":return this.service.getManifest(E(a[0],d));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(a[0]);case"installFromGallery":return this.service.installFromGallery(a[0],(0,R.revive)(a[1]));case"uninstall":return this.service.uninstall(b(a[0],d),(0,R.revive)(a[1]));case"reinstallFromGallery":return this.service.reinstallFromGallery(b(a[0],d));case"getInstalled":return this.service.getInstalled(a[0],T.URI.revive(a[1])).then(c=>c.map(i=>p(i,d)));case"getMetadata":return this.service.getMetadata(b(a[0],d));case"updateMetadata":return this.service.updateMetadata(b(a[0],d),a[1]).then(c=>p(c,d));case"updateExtensionScope":return this.service.updateExtensionScope(b(a[0],d),a[1]).then(c=>p(c,d));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=v;class h extends r.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(g){super(),this.channel=g,this._onInstallExtension=this._register(new D.Emitter),this._onDidInstallExtensions=this._register(new D.Emitter),this._onUninstallExtension=this._register(new D.Emitter),this._onDidUninstallExtension=this._register(new D.Emitter),this._register(this.channel.listen("onInstallExtension")(f=>this._onInstallExtension.fire({identifier:f.identifier,source:this.isUriComponents(f.source)?T.URI.revive(f.source):f.source,profileLocation:T.URI.revive(f.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(f=>this._onDidInstallExtensions.fire(f.map(a=>({...a,local:a.local?b(a.local,null):a.local,source:this.isUriComponents(a.source)?T.URI.revive(a.source):a.source,profileLocation:T.URI.revive(a.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(f=>this._onUninstallExtension.fire({identifier:f.identifier,profileLocation:T.URI.revive(f.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(f=>this._onDidUninstallExtension.fire({...f,profileLocation:T.URI.revive(f.profileLocation)})))}isUriComponents(g){return g?typeof g.path=="string"&&typeof g.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(g){const f=await this.getTargetPlatform();return g.allTargetPlatforms.some(a=>(0,w.isTargetPlatformCompatible)(a,g.allTargetPlatforms,f))}zip(g){return Promise.resolve(this.channel.call("zip",[g]).then(f=>T.URI.revive(f)))}unzip(g){return Promise.resolve(this.channel.call("unzip",[g]))}install(g,f){return Promise.resolve(this.channel.call("install",[g,f])).then(a=>b(a,null))}getManifest(g){return Promise.resolve(this.channel.call("getManifest",[g]))}installFromGallery(g,f){return Promise.resolve(this.channel.call("installFromGallery",[g,f])).then(a=>b(a,null))}uninstall(g,f){return Promise.resolve(this.channel.call("uninstall",[g,f]))}reinstallFromGallery(g){return Promise.resolve(this.channel.call("reinstallFromGallery",[g]))}getInstalled(g=null,f){return Promise.resolve(this.channel.call("getInstalled",[g,f])).then(a=>a.map(d=>b(d,null)))}getMetadata(g){return Promise.resolve(this.channel.call("getMetadata",[g]))}updateMetadata(g,f){return Promise.resolve(this.channel.call("updateMetadata",[g,f])).then(a=>b(a,null))}updateExtensionScope(g,f){return Promise.resolve(this.channel.call("updateExtensionScope",[g,f])).then(a=>b(a,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=h;class S{constructor(g){this.service=g}listen(g,f){throw new Error("Invalid listen")}call(g,f,a){switch(f){case"getConfigBasedTips":return this.service.getConfigBasedTips(T.URI.revive(a[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=S}),define(ne[95],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var r;(function(T){T[T.FILE=1]="FILE",T[T.WORKSPACE=2]="WORKSPACE",T[T.EXE=3]="EXE"})(r=e.RecommendationSource||(e.RecommendationSource={}));function R(T){switch(T){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=R;var L;(function(T){T.Ignored="ignored",T.Cancelled="cancelled",T.TooMany="toomany",T.IncompatibleWindow="incompatibleWindow",T.Accepted="reacted"})(L=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,D.createDecorator)("IExtensionRecommendationNotificationService")}),define(ne[13],re([0,1,34,12,27,15,7,153,5]),function(Q,e,D,r,R,L,T,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,w.createDecorator)("fileService");function E(j){return j.create===!0}e.isFileOpenForWriteOptions=E;var I;(function(j){j[j.Unknown=0]="Unknown",j[j.File=1]="File",j[j.Directory=2]="Directory",j[j.SymbolicLink=64]="SymbolicLink"})(I=e.FileType||(e.FileType={}));var b;(function(j){j[j.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var p;(function(j){j[j.FileReadWrite=2]="FileReadWrite",j[j.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",j[j.FileReadStream=16]="FileReadStream",j[j.FileFolderCopy=8]="FileFolderCopy",j[j.PathCaseSensitive=1024]="PathCaseSensitive",j[j.Readonly=2048]="Readonly",j[j.Trash=4096]="Trash",j[j.FileWriteUnlock=8192]="FileWriteUnlock",j[j.FileAtomicRead=16384]="FileAtomicRead",j[j.FileClone=32768]="FileClone"})(p=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function v(j){return!!(j.capabilities&2)}e.hasReadWriteCapability=v;function h(j){return!!(j.capabilities&8)}e.hasFileFolderCopyCapability=h;function S(j){return!!(j.capabilities&32768)}e.hasFileCloneCapability=S;function C(j){return!!(j.capabilities&4)}e.hasOpenReadWriteCloseCapability=C;function g(j){return!!(j.capabilities&16)}e.hasFileReadStreamCapability=g;function f(j){return v(j)?!!(j.capabilities&16384):!1}e.hasFileAtomicReadCapability=f;var a;(function(j){j.FileExists="EntryExists",j.FileNotFound="EntryNotFound",j.FileNotADirectory="EntryNotADirectory",j.FileIsADirectory="EntryIsADirectory",j.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",j.FileTooLarge="EntryTooLarge",j.FileWriteLocked="EntryWriteLocked",j.NoPermissions="NoPermissions",j.Unavailable="Unavailable",j.Unknown="Unknown"})(a=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class d extends Error{constructor(H,W){super(H),this.code=W}}e.FileSystemProviderError=d;function c(j,H){const W=new d(j.toString(),H);return o(W,H),W}e.createFileSystemProviderError=c;function i(j){return j||c((0,P.localize)(0,null),a.Unknown)}e.ensureFileSystemProviderError=i;function o(j,H){return j.name=H?`${H} (FileSystemError)`:"FileSystemError",j}e.markAsFileSystemProviderError=o;function t(j){if(!j)return a.Unknown;if(j instanceof d)return j.code;const H=/^(.+) \(FileSystemError\)$/.exec(j.name);if(!H)return a.Unknown;switch(H[1]){case a.FileExists:return a.FileExists;case a.FileIsADirectory:return a.FileIsADirectory;case a.FileNotADirectory:return a.FileNotADirectory;case a.FileNotFound:return a.FileNotFound;case a.FileExceedsMemoryLimit:return a.FileExceedsMemoryLimit;case a.FileTooLarge:return a.FileTooLarge;case a.FileWriteLocked:return a.FileWriteLocked;case a.NoPermissions:return a.NoPermissions;case a.Unavailable:return a.Unavailable}return a.Unknown}e.toFileSystemProviderErrorCode=t;function n(j){if(j instanceof _)return j.fileOperationResult;switch(t(j)){case a.FileNotFound:return 1;case a.FileIsADirectory:return 0;case a.FileNotADirectory:return 10;case a.FileWriteLocked:return 5;case a.NoPermissions:return 6;case a.FileExists:return 4;case a.FileExceedsMemoryLimit:return 9;case a.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var s;(function(j){j[j.CREATE=0]="CREATE",j[j.DELETE=1]="DELETE",j[j.MOVE=2]="MOVE",j[j.COPY=3]="COPY",j[j.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class u{constructor(H,W,z){this.resource=H,this.operation=W,this.target=z}isOperation(H){return this.operation===H}}e.FileOperationEvent=u;var l;(function(j){j[j.UPDATED=0]="UPDATED",j[j.ADDED=1]="ADDED",j[j.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class m{constructor(H,W){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=H;const z=new Map;for(const K of H){const X=z.get(K.type);switch(X?X.push([K.resource,K]):z.set(K.type,[[K.resource,K]]),K.type){case 1:this.rawAdded.push(K.resource);break;case 0:this.rawUpdated.push(K.resource);break;case 2:this.rawDeleted.push(K.resource);break}}for(const[K,X]of z)switch(K){case 1:this.added=D.TernarySearchTree.forUris(()=>W),this.added.fill(X);break;case 0:this.updated=D.TernarySearchTree.forUris(()=>W),this.updated.fill(X);break;case 2:this.deleted=D.TernarySearchTree.forUris(()=>W),this.deleted.fill(X);break}}contains(H,...W){return this.doContains(H,{includeChildren:!1},...W)}affects(H,...W){return this.doContains(H,{includeChildren:!0},...W)}doContains(H,W,...z){if(!H)return!1;const K=z.length>0;return!!((!K||z.includes(1))&&(this.added?.get(H)||W.includeChildren&&this.added?.findSuperstr(H))||(!K||z.includes(0))&&(this.updated?.get(H)||W.includeChildren&&this.updated?.findSuperstr(H))||(!K||z.includes(2))&&(this.deleted?.findSubstr(H)||W.includeChildren&&this.deleted?.findSuperstr(H)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=m;function y(j,H,W){return!j||!H||j===H||H.length>j.length?!1:(H.charAt(H.length-1)!==r.sep&&(H+=r.sep),W?(0,R.startsWithIgnoreCase)(j,H):j.indexOf(H)===0)}e.isParent=y;class _ extends Error{constructor(H,W,z){super(H),this.fileOperationResult=W,this.options=z}}e.FileOperationError=_;class $ extends _{constructor(H,W,z){super(H,2,z),this.stat=W}}e.NotModifiedSinceFileOperationError=$;var A;(function(j){j[j.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",j[j.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",j[j.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",j[j.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",j[j.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",j[j.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",j[j.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",j[j.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",j[j.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",j[j.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",j[j.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",j[j.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(A=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var U;(function(j){j[j.FILE=0]="FILE",j[j.FOLDER=1]="FOLDER",j[j.ROOT_FOLDER=2]="ROOT_FOLDER"})(U=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function k(j){if(!(typeof j.size!="number"||typeof j.mtime!="number"))return j.mtime.toString(29)+j.size.toString(31)}e.etag=k;async function N(j,H){if(!H.hasProvider(T.URI.from({scheme:j.scheme})))return new Promise(W=>{const z=H.onDidChangeFileSystemProviderRegistrations(K=>{K.scheme===j.scheme&&K.added&&(z.dispose(),W())})})}e.whenProviderRegistered=N,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class F{static formatSize(H){return(0,L.isNumber)(H)||(H=0),H<F.KB?(0,P.localize)(1,null,H.toFixed(0)):H<F.MB?(0,P.localize)(2,null,(H/F.KB).toFixed(2)):H<F.GB?(0,P.localize)(3,null,(H/F.MB).toFixed(2)):H<F.TB?(0,P.localize)(4,null,(H/F.GB).toFixed(2)):(0,P.localize)(5,null,(H/F.TB).toFixed(2))}}e.ByteSize=F,F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB;var q;(function(j){j[j.IA32=0]="IA32",j[j.OTHER=1]="OTHER"})(q=e.Arch||(e.Arch={}));function J(j){return{maxFileSize:j===0?300*F.MB:16*F.GB,maxHeapSize:j===0?700*F.MB:2*700*F.MB}}e.getPlatformLimits=J});var Y=this&&this.__param||function(Q,e){return function(D,r){e(D,r,Q)}};define(ne[181],re([0,1,96,42,13]),function(Q,e,D,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let L=class{constructor(P){this.fileService=P}async checksum(P){const w=(await this.fileService.readFileStream(P)).value;return new Promise((E,I)=>{const b=(0,D.createHash)("md5");(0,r.listenStream)(w,{onData:p=>b.update(p.buffer),onError:p=>I(p),onEnd:()=>E(b.digest("base64").replace(/=+$/,""))})})}};L=pe([Y(0,R.IFileService)],L),e.ChecksumService=L}),define(ne[182],re([0,1,16,38,9,3,2,42,7,30,13]),function(Q,e,D,r,R,L,T,P,w,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class b extends T.Disposable{constructor(v,h){super(),this.channel=v,this.extraCapabilities=h,this.onDidChangeCapabilities=L.Event.None,this._onDidChange=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,E.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=57374,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(v){return this.channel.call("stat",[v])}readdir(v){return this.channel.call("readdir",[v])}async readFile(v,h){const{buffer:S}=await this.channel.call("readFile",[v,h]);return S}readFileStream(v,h,S){const C=(0,P.newWriteableStream)(f=>D.VSBuffer.concat(f.map(a=>D.VSBuffer.wrap(a))).buffer),g=this.channel.listen("readFileStream",[v,h])(f=>{if(f instanceof D.VSBuffer)C.write(f.buffer);else{if(f==="end")C.end();else{let a=f;a instanceof Error||(a=(0,I.createFileSystemProviderError)((0,r.toErrorMessage)(a),I.FileSystemProviderErrorCode.Unknown)),C.error(a),C.end()}g.dispose()}});return S.onCancellationRequested(()=>{C.error((0,R.canceled)()),C.end(),g.dispose()}),C}writeFile(v,h,S){return this.channel.call("writeFile",[v,D.VSBuffer.wrap(h),S])}open(v,h){return this.channel.call("open",[v,h])}close(v){return this.channel.call("close",[v])}async read(v,h,S,C,g){const[f,a]=await this.channel.call("read",[v,h,g]);return S.set(f.buffer.slice(0,a),C),a}write(v,h,S,C,g){return this.channel.call("write",[v,h,D.VSBuffer.wrap(S),C,g])}mkdir(v){return this.channel.call("mkdir",[v])}delete(v,h){return this.channel.call("delete",[v,h])}rename(v,h,S){return this.channel.call("rename",[v,h,S])}copy(v,h,S){return this.channel.call("copy",[v,h,S])}cloneFile(v,h){return this.channel.call("cloneFile",[v,h])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(v=>{if(Array.isArray(v)){const h=v;this._onDidChange.fire(h.map(S=>({resource:w.URI.revive(S.resource),type:S.type})))}else{const h=v;this._onDidWatchError.fire(h)}}))}watch(v,h){const S=(0,E.generateUuid)();return this.channel.call("watch",[this.sessionId,S,v,h]),(0,T.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,S]))}}e.DiskFileSystemProviderClient=b}),define(ne[97],re([0,1,16,9,154,13]),function(Q,e,D,r,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function T(I,b,p,v,h,S){let C;try{await P(I,b,p,v,h,S)}catch(g){C=g}finally{C&&h.errorTransformer&&(C=h.errorTransformer(C)),typeof C<"u"&&p.error(C),p.end()}}e.readFileIntoStream=T;async function P(I,b,p,v,h,S){w(S);const C=await I.open(b,{create:!1});try{w(S);let g=0,f=0,a=h&&typeof h.length=="number"?h.length:void 0,d=D.VSBuffer.alloc(Math.min(h.bufferSize,typeof a=="number"?a:h.bufferSize)),c=h&&typeof h.position=="number"?h.position:0,i=0;do f=await I.read(C,c,d.buffer,i,d.byteLength-i),c+=f,i+=f,g+=f,typeof a=="number"&&(a-=f),i===d.byteLength&&(await p.write(v(d)),d=D.VSBuffer.alloc(Math.min(h.bufferSize,typeof a=="number"?a:h.bufferSize)),i=0);while(f>0&&(typeof a!="number"||a>0)&&w(S)&&E(g,h));if(i>0){let o=i;typeof a=="number"&&(o=Math.min(i,a)),p.write(v(d.slice(0,o)))}}catch(g){throw(0,L.ensureFileSystemProviderError)(g)}finally{await I.close(C)}}function w(I){if(I.isCancellationRequested)throw(0,r.canceled)();return!0}function E(I,b){if(b?.limits){if(typeof b.limits.memory=="number"&&I>b.limits.memory)throw(0,L.createFileSystemProviderError)((0,R.localize)(0,null),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof b.limits.size=="number"&&I>b.limits.size)throw(0,L.createFileSystemProviderError)((0,R.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ne[57],re([0,1,86,2,12,4,7,13]),function(Q,e,D,r,R,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function w(g){return g.recursive===!0}e.isRecursiveWatchRequest=w;class E extends r.Disposable{constructor(f,a,d,c){super(),this.onFileChanges=f,this.onLogMessage=a,this.verboseLogging=d,this.options=c,this.watcherDisposables=this._register(new r.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const f=new r.DisposableStore;this.watcherDisposables.value=f,this.watcher=this.createWatcher(f),this.watcher.setVerboseLogging(this.verboseLogging),f.add(this.watcher.onDidChangeFile(a=>this.onFileChanges(a))),f.add(this.watcher.onDidLogMessage(a=>this.onLogMessage(a))),f.add(this.watcher.onDidError(a=>this.onError(a)))}onError(f){this.options.restartOnError?this.restartCounter<E.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${f}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${f}`):this.error(f)}restart(f){this.restartCounter++,this.init(),this.watch(f)}async watch(f){this.requests=f,await this.watcher?.watch(f)}async setVerboseLogging(f){this.verboseLogging=f,await this.watcher?.setVerboseLogging(f)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${f}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=E,E.MAX_RESTARTS=5;class I extends E{constructor(f,a,d){super(f,a,d,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=I;class b extends E{constructor(f,a,d){super(f,a,d,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=b;function p(g){return g.map(f=>({type:f.type,resource:T.URI.file(f.path)}))}e.toFileChanges=p;function v(g){const f=new C;for(const a of g)f.processEvent(a);return f.coalesce()}e.coalesceEvents=v;function h(g,f){return typeof f=="string"&&!f.startsWith(D.GLOBSTAR)&&!(0,R.isAbsolute)(f)?{base:g,pattern:f}:f}e.normalizeWatcherPattern=h;function S(g,f){const a=[];for(const d of f)a.push((0,D.parse)(h(g,d)));return a}e.parseWatcherPatterns=S;class C{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(f){return L.isLinux?f.path:f.path.toLowerCase()}processEvent(f){const a=this.mapPathToChange.get(this.toKey(f));let d=!1;if(a){const c=a.type,i=f.type;a.path!==f.path&&(f.type===2||f.type===1)?d=!0:c===1&&i===2?(this.mapPathToChange.delete(this.toKey(f)),this.coalesced.delete(a)):c===2&&i===1?a.type=0:c===1&&i===0||(a.type=i)}else d=!0;d&&(this.coalesced.add(f),this.mapPathToChange.set(this.toKey(f),f))}coalesce(){const f=[],a=[];return Array.from(this.coalesced).filter(d=>d.type!==2?(f.push(d),!1):!0).sort((d,c)=>d.path.length-c.path.length).filter(d=>a.some(c=>(0,P.isParent)(d.path,c,!L.isLinux))?!1:(a.push(d.path),!0)).concat(f)}}}),define(ne[183],re([0,1,53,6,22,47,2,84,12,4,134,28,57]),function(Q,e,D,r,R,L,T,P,w,E,I,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class v extends T.Disposable{constructor(C,g,f,a){super(),this.request=C,this.onDidFilesChange=g,this.onLogMessage=f,this.verboseLogging=a,this.throttledFileChangesWorker=new r.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},d=>this.onDidFilesChange(d)),this.fileChangesDelayer=this._register(new r.ThrottledDelayer(v.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,p.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,p.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new R.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const C=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const g=await b.Promises.stat(C);this._register(await this.doWatch(C,g.isDirectory()))}catch(C){C.code!=="ENOENT"?this.error(C):this.trace(C)}}async normalizePath(C){let g=C.path;try{g=await b.Promises.realpath(C.path),C.path===g&&(g=await(0,I.realcase)(C.path)??C.path),C.path!==g&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${C.path}, real: ${g})`)}catch{}return g}async doWatch(C,g){if(E.isMacintosh&&(0,L.isEqualOrParent)(C,"/Volumes/",!0))return this.error(`Refusing to watch ${C} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),T.Disposable.None;const f=new R.CancellationTokenSource(this.cts.token),a=new T.DisposableStore;try{const d=(0,w.basename)(C),c=(0,D.watch)(C);a.add((0,T.toDisposable)(()=>{c.removeAllListeners(),c.close()})),this.trace(`Started watching: '${C}'`);const i=new Set;if(g)try{for(const t of await b.Promises.readdir(C))i.add(t)}catch(t){this.error(t)}const o=new Map;a.add((0,T.toDisposable)(()=>{for(const[,t]of o)t.dispose();o.clear()})),c.on("error",(t,n)=>{this.error(`Failed to watch ${C} for changes using fs.watch() (${t}, ${n})`),this.dispose()}),c.on("change",(t,n)=>{if(f.token.isCancellationRequested)return;this.trace(`[raw] ["${t}"] ${n}`);let s="";if(n&&(s=n.toString(),E.isMacintosh&&(s=(0,P.normalizeNFC)(s))),!(!s||t!=="change"&&t!=="rename"))if(g)if(t==="rename"){o.get(s)?.dispose();const u=setTimeout(async()=>{if(o.delete(s),s===d&&!await b.Promises.exists(C)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const l=await this.existsChildStrictCase((0,w.join)(C,s));if(f.token.isCancellationRequested)return;let m;l?i.has(s)?m=0:(m=1,i.add(s)):(i.delete(s),m=2),this.onFileChange({path:(0,w.join)(this.request.path,s),type:m})},v.FILE_DELETE_HANDLER_DELAY);o.set(s,(0,T.toDisposable)(()=>clearTimeout(u)))}else{let u;i.has(s)?u=0:(u=1,i.add(s)),this.onFileChange({path:(0,w.join)(this.request.path,s),type:u})}else if(t==="rename"||s!==d){const u=setTimeout(async()=>{const l=await b.Promises.exists(C);f.token.isCancellationRequested||(l?(this.onFileChange({path:this.request.path,type:0},!0),a.add(await this.doWatch(C,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},v.FILE_DELETE_HANDLER_DELAY);a.clear(),a.add((0,T.toDisposable)(()=>clearTimeout(u)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(d){await b.Promises.exists(C)&&!f.token.isCancellationRequested&&this.error(`Failed to watch ${C} for changes using fs.watch() (${d.toString()})`)}return(0,T.toDisposable)(()=>{f.dispose(!0),a.dispose()})}async onFileChange(C,g=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${C.type===1?"[ADDED]":C.type===2?"[DELETED]":"[CHANGED]"} ${C.path}`),!g&&this.excludes.some(f=>f(C.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${C.path}`):!g&&this.includes&&this.includes.length>0&&!this.includes.some(f=>f(C.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${C.path}`):this.fileChangesBuffer.push(C);try{await this.fileChangesDelayer.trigger(async()=>{const f=this.fileChangesBuffer;this.fileChangesBuffer=[];const a=(0,p.coalesceEvents)(f);if(a.length>0){if(this.verboseLogging)for(const c of a)this.trace(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`);this.throttledFileChangesWorker.work(a)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${a[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${a.length}, most recent change: ${a[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(C){if(E.isLinux)return b.Promises.exists(C);try{const g=(0,w.basename)(C);return(await b.Promises.readdir((0,w.dirname)(C))).some(a=>a===g)}catch(g){return this.trace(g),!1}}setVerboseLogging(C){this.verboseLogging=C}error(C){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${C}`})}warn(C){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${C}`})}trace(C){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${C}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=v,v.FILE_DELETE_HANDLER_DELAY=100,v.FILE_CHANGES_HANDLER_DELAY=50;async function h(S,C,g,f,a=512){const d=await b.Promises.open(S,"r"),c=Buffer.allocUnsafe(a),i=new R.CancellationTokenSource(f);let o,t=!1;const n={path:S,excludes:[],recursive:!1},s=new v(n,u=>{(async()=>{for(const{type:l}of u)if(l===0){if(t)return;t=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:m}=await b.Promises.read(d,c,0,a,null);if(!m||i.token.isCancellationRequested)break;C(c.slice(0,m))}}catch(m){o=new Error(m),i.dispose(!0)}finally{t=!1}}})()});return await s.ready,g(),new Promise((u,l)=>{i.token.onCancellationRequested(async()=>{s.dispose();try{await b.Promises.close(d)}catch(m){o=new Error(m)}o?l(o):u()})})}e.watchFileContents=h}),define(ne[184],re([0,1,3,86,2,4,183]),function(Q,e,D,r,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends R.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new D.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=D.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(E){const I=this.normalizeRequests(E),b=I.filter(v=>{const h=this.watchers.get(v.path);return h?!(0,r.patternsEquals)(h.request.excludes,v.excludes)||!(0,r.patternsEquals)(h.request.includes,v.includes):!0}),p=Array.from(this.watchers.values()).filter(({request:v})=>!I.find(h=>h.path===v.path&&(0,r.patternsEquals)(h.excludes,v.excludes)&&(0,r.patternsEquals)(h.includes,v.includes))).map(({request:v})=>v.path);b.length&&this.trace(`Request to start watching: ${b.map(v=>`${v.path} (excludes: ${v.excludes.length>0?v.excludes:"<none>"}, includes: ${v.includes&&v.includes.length>0?JSON.stringify(v.includes):"<all>"})`).join(",")}`),p.length&&this.trace(`Request to stop watching: ${p.join(",")}`);for(const v of p)this.stopWatching(v);for(const v of b)this.startWatching(v)}startWatching(E){const I=new T.NodeJSFileWatcherLibrary(E,p=>this._onDidChangeFile.fire(p),p=>this._onDidLogMessage.fire(p),this.verboseLogging),b={request:E,instance:I};this.watchers.set(E.path,b)}async stop(){for(const[E]of this.watchers)this.stopWatching(E);this.watchers.clear()}stopWatching(E){const I=this.watchers.get(E);I&&(this.watchers.delete(E),I.instance.dispose())}normalizeRequests(E){const I=new Map;for(const b of E){const p=L.isLinux?b.path:b.path.toLowerCase();I.set(p,b)}return Array.from(I.values())}async setVerboseLogging(E){this.verboseLogging=E;for(const[,I]of this.watchers)I.instance.setVerboseLogging(E)}trace(E){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(E)})}toMessage(E,I){return I?`[File Watcher (node.js)] ${E} (path: ${I.request.path})`:`[File Watcher (node.js)] ${E}`}}e.NodeJSWatcher=P}),define(ne[185],re([0,1,57,184]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class R extends D.AbstractNonRecursiveWatcherClient{constructor(T,P,w){super(T,P,w),this.init()}createWatcher(){return new r.NodeJSWatcher}}e.NodeJSWatcherClient=R}),define(ne[186],re([0,1,23,39,67,57]),function(Q,e,D,r,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class T extends L.AbstractUniversalWatcherClient{constructor(w,E,I){super(w,E,I),this.init()}createWatcher(w){const E=w.add(new R.Client(D.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return w.add(E.onDidProcessExit(({code:I,signal:b})=>this.onError(`terminated by itself with code ${I}, signal: ${b}`))),r.ProxyChannel.toService((0,r.getNextTickChannel)(E.getChannel("watcher")))}}e.UniversalWatcherClient=T}),define(ne[70],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...R){this._entries=new Map;for(const[L,T]of R)this.set(L,T)}set(R,L){const T=this._entries.get(R);return this._entries.set(R,L),T}has(R){return this._entries.has(R)}get(R){return this._entries.get(R)}}e.ServiceCollection=D}),define(ne[187],re([0,1,6,9,56,177,5,70]),function(Q,e,D,r,R,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const w=!1;class E extends Error{constructor(h){super("cyclic dependency between services"),this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class I{constructor(h=new P.ServiceCollection,S=!1,C,g=w){this._services=h,this._strict=S,this._parent=C,this._enableTracing=g,this._activeInstantiations=new Set,this._services.set(T.IInstantiationService,this),this._globalGraph=g?C?._globalGraph??new L.Graph(f=>f):void 0}createChild(h){return new I(h,this._strict,this,this._enableTracing)}invokeFunction(h,...S){const C=p.traceInvocation(this._enableTracing,h);let g=!1;try{return h({get:a=>{if(g)throw(0,r.illegalState)("service accessor is only valid during the invocation of its target method");const d=this._getOrCreateServiceInstance(a,C);if(!d)throw new Error(`[invokeFunction] unknown service '${a}'`);return d}},...S)}finally{g=!0,C.stop()}}createInstance(h,...S){let C,g;return h instanceof R.SyncDescriptor?(C=p.traceCreation(this._enableTracing,h.ctor),g=this._createInstance(h.ctor,h.staticArguments.concat(S),C)):(C=p.traceCreation(this._enableTracing,h),g=this._createInstance(h,S,C)),C.stop(),g}_createInstance(h,S=[],C){const g=T._util.getServiceDependencies(h).sort((d,c)=>d.index-c.index),f=[];for(const d of g){const c=this._getOrCreateServiceInstance(d.id,C);c||this._throwIfStrict(`[createInstance] ${h.name} depends on UNKNOWN service ${d.id}.`,!1),f.push(c)}const a=g.length>0?g[0].index:S.length;if(S.length!==a){console.trace(`[createInstance] First service dependency of ${h.name} at position ${a+1} conflicts with ${S.length} static arguments`);const d=a-S.length;d>0?S=S.concat(new Array(d)):S=S.slice(0,a)}return Reflect.construct(h,S.concat(f))}_setServiceInstance(h,S){if(this._services.get(h)instanceof R.SyncDescriptor)this._services.set(h,S);else if(this._parent)this._parent._setServiceInstance(h,S);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){const S=this._services.get(h);return!S&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):S}_getOrCreateServiceInstance(h,S){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(h));const C=this._getServiceInstanceOrDescriptor(h);return C instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,C,S.branch(h,!0)):(S.branch(h,!1),C)}_safeCreateAndCacheServiceInstance(h,S,C){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,S,C)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,S,C){const g=new L.Graph(d=>d.id.toString());let f=0;const a=[{id:h,desc:S,_trace:C}];for(;a.length;){const d=a.pop();if(g.lookupOrInsertNode(d),f++>1e3)throw new E(g);for(const c of T._util.getServiceDependencies(d.desc.ctor)){const i=this._getServiceInstanceOrDescriptor(c.id);if(i||this._throwIfStrict(`[createInstance] ${h} depends on ${c.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(d.id),String(c.id)),i instanceof R.SyncDescriptor){const o={id:c.id,desc:i,_trace:d._trace.branch(c.id,!0)};g.insertEdge(d,o),a.push(o)}}}for(;;){const d=g.roots();if(d.length===0){if(!g.isEmpty())throw new E(g);break}for(const{data:c}of d){if(this._getServiceInstanceOrDescriptor(c.id)instanceof R.SyncDescriptor){const o=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,o)}g.removeNode(c)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,S,C=[],g,f){if(this._services.get(h)instanceof R.SyncDescriptor)return this._createServiceInstance(h,S,C,g,f);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,S,C,g,f);throw new Error(`illegalState - creating UNKNOWN service instance ${S.name}`)}_createServiceInstance(h,S,C=[],g,f){if(g){const a=new I(void 0,this._strict,this,this._enableTracing);a._globalGraphImplicitDependency=String(h);const d=new D.IdleValue(()=>a._createInstance(S,C,f));return new Proxy(Object.create(null),{get(c,i){if(i in c)return c[i];const o=d.value;let t=o[i];return typeof t!="function"||(t=t.bind(o),c[i]=t),t},set(c,i,o){return d.value[i]=o,!0}})}else return this._createInstance(S,C,f)}_throwIfStrict(h,S){if(S&&console.warn(h),this._strict)throw new Error(h)}}e.InstantiationService=I;var b;(function(v){v[v.Creation=0]="Creation",v[v.Invocation=1]="Invocation",v[v.Branch=2]="Branch"})(b||(b={}));class p{static traceInvocation(h,S){return h?new p(1,S.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p._None}static traceCreation(h,S){return h?new p(0,S.name):p._None}constructor(h,S){this.type=h,this.name=S,this._start=Date.now(),this._dep=[]}branch(h,S){const C=new p(2,h.toString());return this._dep.push([h,S,C]),C}stop(){const h=Date.now()-this._start;p._totals+=h;let S=!1;function C(f,a){const d=[],c=new Array(f+1).join("	");for(const[i,o,t]of a._dep)if(o&&t){S=!0,d.push(`${c}CREATES -> ${i}`);const n=C(f+1,t);n&&d.push(n)}else d.push(`${c}uses -> ${i}`);return d.join(`
`)}const g=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${C(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${p._totals.toFixed(2)}ms)`];(h>2||S)&&p.all.add(g.join(`
`))}}e.Trace=p,p.all=new Set,p._None=new class extends p{constructor(){super(-1,null)}stop(){}branch(){return this}},p._totals=0}),define(ne[188],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class D{constructor(R,L){this.server=R,this.router=L}getChannel(R){return this.server.getChannel(R,this.router)}registerChannel(R,L){this.server.registerChannel(R,L)}}e.MessagePortMainProcessService=D}),define(ne[58],re([0,1,39,56,92,5]),function(Q,e,D,r,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class T{constructor(v,h,S,C){const g=S.getChannel(v);return P(h)?C.createInstance(new r.SyncDescriptor(h.channelClientCtor,[g])):D.ProxyChannel.toService(g,h?.proxyOptions)}}function P(p){return!!p?.channelClientCtor}e.IMainProcessService=(0,L.createDecorator)("mainProcessService");let w=class extends T{constructor(v,h,S,C){super(v,h,S,C)}};w=pe([Y(2,e.IMainProcessService),Y(3,L.IInstantiationService)],w);function E(p,v,h){(0,R.registerSingleton)(p,new r.SyncDescriptor(w,[v,h],!0))}e.registerMainProcessRemoteService=E,e.ISharedProcessService=(0,L.createDecorator)("sharedProcessService");let I=class extends T{constructor(v,h,S,C){super(v,h,S,C)}};I=pe([Y(2,e.ISharedProcessService),Y(3,L.IInstantiationService)],I);function b(p,v,h){(0,R.registerSingleton)(p,new r.SyncDescriptor(I,[v,h],!0))}e.registerSharedProcessRemoteService=b}),define(ne[71],re([0,1,22,2,4,156,29,5]),function(Q,e,D,r,R,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.ILanguagePackService=(0,P.createDecorator)("languagePackService");let w=class extends r.Disposable{constructor(I){super(),this.extensionGalleryService=I}async getAvailableLanguages(){const I=new D.CancellationTokenSource;setTimeout(()=>I.cancel(),1e3);let b;try{b=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},I.token)}catch{return[]}const v=b.firstPage.filter(h=>h.properties.localizedLanguages?.length&&h.tags.some(S=>S.startsWith("lp-"))).map(h=>{const S=h.properties.localizedLanguages?.[0],C=this.getLocale(h);return{...this.createQuickPickItem(C,S,h),extensionId:h.identifier.id,galleryExtension:h}});return v.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),v}getLocale(I){return I.tags.find(b=>b.startsWith("lp-"))?.split("lp-")[1]}createQuickPickItem(I,b,p){const v=b??I;let h;if(v!==I&&(h=`(${I})`),I.toLowerCase()===R.language.toLowerCase()&&(h??="",h+=(0,L.localize)(0,null)),p?.installCount){h??="";const S=p.installCount;let C;S>1e6?C=`${Math.floor(S/1e5)/10}M`:S>1e3?C=`${Math.floor(S/1e3)}K`:C=String(S),h+=` $(cloud-download) ${C}`}return{id:I,label:v,description:h}}};w=pe([Y(0,T.IExtensionGalleryService)],w),e.LanguagePackBaseService=w}),define(ne[189],re([0,1,2,71]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let R=class extends D.Disposable{constructor(T){super(),this.localizationsService=T,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};R=pe([Y(0,r.ILanguagePackService)],R),e.LocalizationsUpdater=R}),define(ne[8],re([0,1,38,3,2,4,5]),function(Q,e,D,r,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,T.createDecorator)("logService"),e.ILoggerService=(0,T.createDecorator)("loggerService");function P(){return new Date().toISOString()}var w;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(w=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=w.Info;function E(o,t,n){switch(t){case w.Trace:o.trace(n);break;case w.Debug:o.debug(n);break;case w.Info:o.info(n);break;case w.Warning:o.warn(n);break;case w.Error:o.error(n);break;case w.Critical:o.critical(n);break;default:throw new Error("Invalid log level")}}e.log=E;function I(o){let t="";for(let n=0;n<o.length;n++){let s=o[n];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}t+=(n>0?" ":"")+s}return t}e.format=I;class b extends R.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new r.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=b;class p extends b{constructor(t){super(),this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(w.Trace)&&this.log(w.Trace,I([t,...n]))}debug(t,...n){this.checkLogLevel(w.Debug)&&this.log(w.Debug,I([t,...n]))}info(t,...n){this.checkLogLevel(w.Info)&&this.log(w.Info,I([t,...n]))}warn(t,...n){this.checkLogLevel(w.Warning)&&this.log(w.Warning,I([t,...n]))}error(t,...n){if(this.checkLogLevel(w.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(w.Error,I(s))}else this.log(w.Error,I([t,...n]))}critical(t,...n){this.checkLogLevel(w.Critical)&&this.log(w.Critical,I([t,...n]))}flush(){}}e.AbstractMessageLogger=p;class v extends b{constructor(t=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(t),this.useColors=!L.isWindows}trace(t,...n){this.getLevel()<=w.Trace&&(this.useColors?console.log(`\x1B[90m[main ${P()}]\x1B[0m`,t,...n):console.log(`[main ${P()}]`,t,...n))}debug(t,...n){this.getLevel()<=w.Debug&&(this.useColors?console.log(`\x1B[90m[main ${P()}]\x1B[0m`,t,...n):console.log(`[main ${P()}]`,t,...n))}info(t,...n){this.getLevel()<=w.Info&&(this.useColors?console.log(`\x1B[90m[main ${P()}]\x1B[0m`,t,...n):console.log(`[main ${P()}]`,t,...n))}warn(t,...n){this.getLevel()<=w.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${P()}]\x1B[0m`,t,...n):console.warn(`[main ${P()}]`,t,...n))}error(t,...n){this.getLevel()<=w.Error&&(this.useColors?console.error(`\x1B[91m[main ${P()}]\x1B[0m`,t,...n):console.error(`[main ${P()}]`,t,...n))}critical(t,...n){this.getLevel()<=w.Critical&&(this.useColors?console.error(`\x1B[90m[main ${P()}]\x1B[0m`,t,...n):console.error(`[main ${P()}]`,t,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=v;class h extends b{constructor(t=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(t)}trace(t,...n){this.getLevel()<=w.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=w.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=w.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=w.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=w.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=w.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}e.ConsoleLogger=h;class S extends b{constructor(t,n=e.DEFAULT_LOG_LEVEL){super(),this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=w.Trace&&this.adapter.log(w.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=w.Debug&&this.adapter.log(w.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=w.Info&&this.adapter.log(w.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=w.Warning&&this.adapter.log(w.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=w.Error&&this.adapter.log(w.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=w.Critical&&this.adapter.log(w.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:(0,D.toErrorMessage)(t,this.getLevel()<=w.Trace)}dispose(){}flush(){}}e.AdapterLogger=S;class C extends b{constructor(t){super(),this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const s of this.logServices)s.trace(t,...n)}debug(t,...n){for(const s of this.logServices)s.debug(t,...n)}info(t,...n){for(const s of this.logServices)s.info(t,...n)}warn(t,...n){for(const s of this.logServices)s.warn(t,...n)}error(t,...n){for(const s of this.logServices)s.error(t,...n)}critical(t,...n){for(const s of this.logServices)s.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=C;class g extends R.Disposable{constructor(t){super(),this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}e.LogService=g;class f extends R.Disposable{constructor(t,n){super(),this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(u=>u.setLevel(s))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,n){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,n?.always?w.Trace:this.logLevel,n),this.loggers.set(t.toString(),s),n?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=f;class a{constructor(){this.onDidChangeLogLevel=new r.Emitter().event}setLevel(t){}getLevel(){return w.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}e.NullLogService=a;function d(o){if(o.verbose)return w.Trace;if(typeof o.logLevel=="string"){const t=c(o.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=d;function c(o){switch(o){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Critical;case"off":return w.Off}}e.parseLogLevel=c;function i(o){switch(o){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Critical:return"critical";case w.Off:return"off"}}e.LogLevelToString=i}),define(ne[190],re([0,1,6,9,2,12,28,14,8]),function(Q,e,D,r,R,L,T,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let E=class extends R.Disposable{constructor(b,p){super(),this.environmentService=b,this.logService=p,this._register(new D.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const b=(0,L.basename)(this.environmentService.logsPath),p=(0,L.dirname)(this.environmentService.logsPath),S=(await T.Promises.readdir(p)).filter(g=>/^\d{8}T\d{6}$/.test(g)).sort().filter(g=>g!==b),C=S.slice(0,Math.max(0,S.length-9));C.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${C.join(", ")}'`),await Promise.all(C.map(g=>T.Promises.rm((0,L.join)(p,g)))))}catch(b){(0,r.onUnexpectedError)(b)}}};E=pe([Y(0,P.IEnvironmentService),Y(1,w.ILogService)],E),e.LogsDataCleaner=E}),define(ne[191],re([0,1,18,6,9,3,2,12,57,8]),function(Q,e,D,r,R,L,T,P,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class I extends T.Disposable{constructor(p,v){super(),this.logService=p,this.options=v,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new r.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new r.ThrottledDelayer(0))}watch(p,v){return v.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(p,v):this.watchNonRecursive(p,v)}watchUniversal(p,v){const h={path:this.toFilePath(p),excludes:v.excludes,includes:v.includes,recursive:v.recursive},S=(0,D.insert)(this.universalPathsToWatch,h);return this.refreshUniversalWatchers(),(0,T.toDisposable)(()=>{S(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(p=>(0,R.onUnexpectedError)(p))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(v=>this._onDidChangeFile.fire((0,w.toFileChanges)(v)),v=>this.onWatcherLogMessage(v),this.logService.getLevel()===E.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)})));const p=this.options?.watcher?.recursive?.usePolling;if(p===!0)for(const v of this.universalPathsToWatch)(0,w.isRecursiveWatchRequest)(v)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const v of this.universalPathsToWatch)(0,w.isRecursiveWatchRequest)(v)&&p.includes(v.path)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(p,v){const h={path:this.toFilePath(p),excludes:v.excludes,includes:v.includes,recursive:!1},S=(0,D.insert)(this.nonRecursivePathsToWatch,h);return this.refreshNonRecursiveWatchers(),(0,T.toDisposable)(()=>{S(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(p=>(0,R.onUnexpectedError)(p))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(p=>this._onDidChangeFile.fire((0,w.toFileChanges)(p)),p=>this.onWatcherLogMessage(p),this.logService.getLevel()===E.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(p){p.type==="error"&&this._onDidWatchError.fire(p.message),this.logService[p.type](p.message)}toFilePath(p){return(0,P.normalize)(p.fsPath)}}e.AbstractDiskFileSystemProvider=I}),define(ne[192],re([0,1,18,6,16,22,3,65,52,2,34,23,193,19,42,152,13,97,8]),function(Q,e,D,r,R,L,T,P,w,E,I,b,p,v,h,S,C,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let a=class extends E.Disposable{constructor(c){super(),this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new r.ResourceQueue)}registerProvider(c,i){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${c}`);const o=new E.DisposableStore;return this.provider.set(c,i),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:i}),o.add(i.onDidChangeFile(t=>this._onDidFilesChange.fire(new C.FileChangesEvent(t,!this.isPathCaseSensitive(i))))),typeof i.onDidWatchError=="function"&&o.add(i.onDidWatchError(t=>this._onDidWatchError.fire(new Error(t)))),o.add(i.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:i,scheme:c}))),(0,E.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:i}),this.provider.delete(c),(0,E.dispose)(o)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const i=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(o){i.push(o)}}),!this.provider.has(c)&&await r.Promises.settled(i)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,i){const o=this.provider.get(c.scheme);return!!(o&&o.capabilities&i)}listCapabilities(){return w.Iterable.map(this.provider,([c,i])=>({scheme:c,capabilities:i.capabilities}))}async withProvider(c){if(!(0,v.isAbsolutePath)(c))throw new C.FileOperationError((0,S.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const i=this.provider.get(c.scheme);if(!i){const o=new Error;throw o.name="ENOPRO",o.message=(0,S.localize)(1,null,c.toString()),o}return i}async withReadProvider(c){const i=await this.withProvider(c);if((0,C.hasOpenReadWriteCloseCapability)(i)||(0,C.hasReadWriteCapability)(i)||(0,C.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const i=await this.withProvider(c);if((0,C.hasOpenReadWriteCloseCapability)(i)||(0,C.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,i){try{return await this.doResolveFile(c,i)}catch(o){throw(0,C.toFileSystemProviderErrorCode)(o)===C.FileSystemProviderErrorCode.FileNotFound?new C.FileOperationError((0,S.localize)(2,null,this.resourceForError(c)),1):(0,C.ensureFileSystemProviderError)(o)}}async doResolveFile(c,i){const o=await this.withProvider(c),t=this.isPathCaseSensitive(o),n=i?.resolveTo,s=i?.resolveSingleChildDescendants,u=i?.resolveMetadata,l=await o.stat(c);let m;return this.toFileStat(o,c,l,void 0,!!u,(y,_)=>(m||(m=I.TernarySearchTree.forUris(()=>!t),m.set(c,!0),n&&m.fill(!0,n)),m.get(y.resource)||m.findSuperstr(y.resource.with({query:null,fragment:null}))?!0:y.isDirectory&&s?_===1:!1))}async toFileStat(c,i,o,t,n,s){const{providerExtUri:u}=this.getExtUri(c),l={resource:i,name:u.basename(i),isFile:(o.type&C.FileType.File)!==0,isDirectory:(o.type&C.FileType.Directory)!==0,isSymbolicLink:(o.type&C.FileType.SymbolicLink)!==0,mtime:o.mtime,ctime:o.ctime,size:o.size,readonly:Boolean((o.permissions??0)&C.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,C.etag)({mtime:o.mtime,size:o.size}),children:void 0};if(l.isDirectory&&s(l,t)){try{const m=await c.readdir(i),y=await r.Promises.settled(m.map(async([_,$])=>{try{const A=u.joinPath(i,_),U=n?await c.stat(A):{type:$};return await this.toFileStat(c,A,U,m.length,n,s)}catch(A){return this.logService.trace(A),null}}));l.children=(0,D.coalesce)(y)}catch(m){this.logService.trace(m),l.children=[]}return l}return l}async resolveAll(c){return r.Promises.settled(c.map(async i=>{try{return{stat:await this.doResolveFile(i.resource,i.options),success:!0}}catch(o){return this.logService.trace(o),{stat:void 0,success:!1}}}))}async stat(c){const i=await this.withProvider(c),o=await i.stat(c);return this.toFileStat(i,c,o,void 0,!0,()=>!1)}async exists(c){const i=await this.withProvider(c);try{return!!await i.stat(c)}catch{return!1}}async canCreateFile(c,i){try{await this.doValidateCreateFile(c,i)}catch(o){return o}return!0}async doValidateCreateFile(c,i){if(!i?.overwrite&&await this.exists(c))throw new C.FileOperationError((0,S.localize)(3,null,this.resourceForError(c)),3,i)}async createFile(c,i=R.VSBuffer.fromString(""),o){await this.doValidateCreateFile(c,o);const t=await this.writeFile(c,i);return this._onDidRunOperation.fire(new C.FileOperationEvent(c,0,t)),t}async writeFile(c,i,o){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:n}=this.getExtUri(t);try{await this.validateWriteFile(t,c,o)||await this.mkdirp(t,n.dirname(c));let u;if((0,C.hasReadWriteCapability)(t)&&!(i instanceof R.VSBuffer))if((0,h.isReadableStream)(i)){const l=await(0,h.peekStream)(i,3);l.ended?u=R.VSBuffer.concat(l.buffer):u=l}else u=(0,h.peekReadable)(i,l=>R.VSBuffer.concat(l),3);else u=i;!(0,C.hasOpenReadWriteCloseCapability)(t)||(0,C.hasReadWriteCapability)(t)&&u instanceof R.VSBuffer?await this.doWriteUnbuffered(t,c,o,u):await this.doWriteBuffered(t,c,o,u instanceof R.VSBuffer?(0,R.bufferToReadable)(u):u),this._onDidRunOperation.fire(new C.FileOperationEvent(c,4))}catch(s){throw new C.FileOperationError((0,S.localize)(4,null,this.resourceForError(c),(0,C.ensureFileSystemProviderError)(s).toString()),(0,C.toFileOperationResult)(s),o)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,i,o){if(!!o?.unlock&&!(c.capabilities&8192))throw new Error((0,S.localize)(5,null,this.resourceForError(i)));let n;try{n=await c.stat(i)}catch{return}if((n.type&C.FileType.Directory)!==0)throw new C.FileOperationError((0,S.localize)(6,null,this.resourceForError(i)),0,o);if(this.throwIfFileIsReadonly(i,n),typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==C.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&o.mtime<n.mtime&&o.etag!==(0,C.etag)({mtime:o.mtime,size:n.size}))throw new C.FileOperationError((0,S.localize)(7,null),3,o);return n}async readFile(c,i,o){const t=await this.withReadProvider(c);return i?.atomic?this.doReadFileAtomic(t,c,i,o):this.doReadFile(t,c,i,o)}async doReadFileAtomic(c,i,o,t){return new Promise((n,s)=>{this.writeQueue.queueFor(i,this.getExtUri(c).providerExtUri).queue(async()=>{try{const u=await this.doReadFile(c,i,o,t);n(u)}catch(u){s(u)}})})}async doReadFile(c,i,o,t){const n=await this.doReadFileStream(c,i,{...o,preferUnbuffered:!0},t);return{...n,value:await(0,R.streamToBuffer)(n.value)}}async readFileStream(c,i,o){const t=await this.withReadProvider(c);return this.doReadFileStream(t,c,i,o)}async doReadFileStream(c,i,o,t){const n=new L.CancellationTokenSource(t),s=this.validateReadFile(i,o).then(l=>l,l=>{throw n.cancel(),l});let u;try{return typeof o?.etag=="string"&&o.etag!==C.ETAG_DISABLED&&await s,o?.atomic&&(0,C.hasFileAtomicReadCapability)(c)||!((0,C.hasOpenReadWriteCloseCapability)(c)||(0,C.hasFileReadStreamCapability)(c))||(0,C.hasReadWriteCapability)(c)&&o?.preferUnbuffered?u=this.readFileUnbuffered(c,i,o):(0,C.hasFileReadStreamCapability)(c)?u=this.readFileStreamed(c,i,n.token,o):u=this.readFileBuffered(c,i,n.token,o),{...await s,value:u}}catch(l){u&&await(0,h.consumeStream)(u);const m=(0,S.localize)(8,null,this.resourceForError(i),(0,C.ensureFileSystemProviderError)(l).toString());throw l instanceof C.NotModifiedSinceFileOperationError?new C.NotModifiedSinceFileOperationError(m,l.stat,o):new C.FileOperationError(m,(0,C.toFileOperationResult)(l),o)}}readFileStreamed(c,i,o,t=Object.create(null)){const n=c.readFileStream(i,t,o);return(0,h.transform)(n,{data:s=>s instanceof R.VSBuffer?s:R.VSBuffer.wrap(s),error:s=>new C.FileOperationError((0,S.localize)(9,null,this.resourceForError(i),(0,C.ensureFileSystemProviderError)(s).toString()),(0,C.toFileOperationResult)(s),t)},s=>R.VSBuffer.concat(s))}readFileBuffered(c,i,o,t=Object.create(null)){const n=(0,R.newWriteableBufferStream)();return(0,g.readFileIntoStream)(c,i,n,s=>s,{...t,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new C.FileOperationError((0,S.localize)(10,null,this.resourceForError(i),(0,C.ensureFileSystemProviderError)(s).toString()),(0,C.toFileOperationResult)(s),t)},o),n}readFileUnbuffered(c,i,o){const t=(0,h.newWriteableStream)(n=>R.VSBuffer.concat(n));return(async()=>{try{let n;o?.atomic&&(0,C.hasFileAtomicReadCapability)(c)?n=await c.readFile(i,{atomic:!0}):n=await c.readFile(i),typeof o?.position=="number"&&(n=n.slice(o.position)),typeof o?.length=="number"&&(n=n.slice(0,o.length)),this.validateReadFileLimits(i,n.byteLength,o),t.end(R.VSBuffer.wrap(n))}catch(n){t.error(n),t.end()}})(),t}async validateReadFile(c,i){const o=await this.resolve(c,{resolveMetadata:!0});if(o.isDirectory)throw new C.FileOperationError((0,S.localize)(11,null,this.resourceForError(c)),0,i);if(typeof i?.etag=="string"&&i.etag!==C.ETAG_DISABLED&&i.etag===o.etag)throw new C.NotModifiedSinceFileOperationError((0,S.localize)(12,null),o,i);return this.validateReadFileLimits(c,o.size,i),o}validateReadFileLimits(c,i,o){if(o?.limits){let t;if(typeof o.limits.memory=="number"&&i>o.limits.memory&&(t=9),typeof o.limits.size=="number"&&i>o.limits.size&&(t=7),typeof t=="number")throw new C.FileOperationError((0,S.localize)(13,null,this.resourceForError(c)),t)}}async canMove(c,i,o){return this.doCanMoveCopy(c,i,"move",o)}async canCopy(c,i,o){return this.doCanMoveCopy(c,i,"copy",o)}async doCanMoveCopy(c,i,o,t){if(c.toString()!==i.toString())try{const n=o==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);await this.doValidateMoveCopy(n,c,s,i,o,t)}catch(n){return n}return!0}async move(c,i,o){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),s=await this.doMoveCopy(t,c,n,i,"move",!!o),u=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new C.FileOperationEvent(c,s==="move"?2:3,u)),u}async copy(c,i,o){const t=await this.withReadProvider(c),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),s=await this.doMoveCopy(t,c,n,i,"copy",!!o),u=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new C.FileOperationEvent(c,s==="copy"?3:2,u)),u}async doMoveCopy(c,i,o,t,n,s){if(i.toString()===t.toString())return n;const{exists:u,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(c,i,o,t,n,s);if(u&&!l&&s&&await this.del(t,{recursive:!0}),await this.mkdirp(o,this.getExtUri(o).providerExtUri.dirname(t)),n==="copy"){if(c===o&&(0,C.hasFileFolderCopyCapability)(c))await c.copy(i,t,{overwrite:s});else{const m=await this.resolve(i);m.isDirectory?await this.doCopyFolder(c,m,o,t):await this.doCopyFile(c,i,o,t)}return n}else return c===o?(await c.rename(i,t,{overwrite:s}),n):(await this.doMoveCopy(c,i,o,t,"copy",s),await this.del(i,{recursive:!0}),"copy")}async doCopyFile(c,i,o,t){if((0,C.hasOpenReadWriteCloseCapability)(c)&&(0,C.hasOpenReadWriteCloseCapability)(o))return this.doPipeBuffered(c,i,o,t);if((0,C.hasOpenReadWriteCloseCapability)(c)&&(0,C.hasReadWriteCapability)(o))return this.doPipeBufferedToUnbuffered(c,i,o,t);if((0,C.hasReadWriteCapability)(c)&&(0,C.hasOpenReadWriteCloseCapability)(o))return this.doPipeUnbufferedToBuffered(c,i,o,t);if((0,C.hasReadWriteCapability)(c)&&(0,C.hasReadWriteCapability)(o))return this.doPipeUnbuffered(c,i,o,t)}async doCopyFolder(c,i,o,t){await o.mkdir(t),Array.isArray(i.children)&&await r.Promises.settled(i.children.map(async n=>{const s=this.getExtUri(o).providerExtUri.joinPath(t,n.name);return n.isDirectory?this.doCopyFolder(c,await this.resolve(n.resource),o,s):this.doCopyFile(c,n.resource,o,s)}))}async doValidateMoveCopy(c,i,o,t,n,s){let u=!1;if(c===o){const{providerExtUri:m,isPathCaseSensitive:y}=this.getExtUri(c);if(y||(u=m.isEqual(i,t)),u&&n==="copy")throw new Error((0,S.localize)(14,null,this.resourceForError(i),this.resourceForError(t)));if(!u&&m.isEqualOrParent(t,i))throw new Error((0,S.localize)(15,null,this.resourceForError(i),this.resourceForError(t)))}const l=await this.exists(t);if(l&&!u){if(!s)throw new C.FileOperationError((0,S.localize)(16,null,this.resourceForError(i),this.resourceForError(t)),4);if(c===o){const{providerExtUri:m}=this.getExtUri(c);if(m.isEqualOrParent(i,t))throw new Error((0,S.localize)(17,null,this.resourceForError(i),this.resourceForError(t)))}}return{exists:l,isSameResourceWithDifferentPathCase:u}}getExtUri(c){const i=this.isPathCaseSensitive(c);return{providerExtUri:i?v.extUri:v.extUriIgnorePathCase,isPathCaseSensitive:i}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(i,c);const o=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new C.FileOperationEvent(c,0,o)),o}async mkdirp(c,i){const o=[],{providerExtUri:t}=this.getExtUri(c);for(;!t.isEqual(i,t.dirname(i));)try{if(((await c.stat(i)).type&C.FileType.Directory)===0)throw new Error((0,S.localize)(18,null,this.resourceForError(i)));break}catch(n){if((0,C.toFileSystemProviderErrorCode)(n)!==C.FileSystemProviderErrorCode.FileNotFound)throw n;o.push(t.basename(i)),i=t.dirname(i)}for(let n=o.length-1;n>=0;n--){i=t.joinPath(i,o[n]);try{await c.mkdir(i)}catch(s){if((0,C.toFileSystemProviderErrorCode)(s)!==C.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(c,i){try{await this.doValidateDelete(c,i)}catch(o){return o}return!0}async doValidateDelete(c,i){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!i?.useTrash&&!(o.capabilities&4096))throw new Error((0,S.localize)(19,null,this.resourceForError(c)));let n;try{n=await o.stat(c)}catch{}if(n)this.throwIfFileIsReadonly(c,n);else throw new C.FileOperationError((0,S.localize)(20,null,this.resourceForError(c)),1);if(!!!i?.recursive){const u=await this.resolve(c);if(u.isDirectory&&Array.isArray(u.children)&&u.children.length>0)throw new Error((0,S.localize)(21,null,this.resourceForError(c)))}return o}async del(c,i){const o=await this.doValidateDelete(c,i),t=!!i?.useTrash,n=!!i?.recursive;await o.delete(c,{recursive:n,useTrash:t}),this._onDidRunOperation.fire(new C.FileOperationEvent(c,1))}async cloneFile(c,i){const o=await this.withProvider(c),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);if(o===t&&this.getExtUri(o).providerExtUri.isEqual(c,i))return;if(o===t&&(0,C.hasFileCloneCapability)(o))return o.cloneFile(c,i);await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(i));const n=this.writeQueue.queueFor(c,this.getExtUri(o).providerExtUri);return o===t&&(0,C.hasFileFolderCopyCapability)(o)?n.queue(()=>o.copy(c,i,{overwrite:!0})):n.queue(()=>this.doCopyFile(o,c,t,i))}watch(c,i={recursive:!1,excludes:[]}){const o=new E.DisposableStore;let t=!1,n=()=>{t=!0};return o.add((0,E.toDisposable)(()=>n())),(async()=>{try{const s=await this.doWatch(c,i);t?(0,E.dispose)(s):n=()=>(0,E.dispose)(s)}catch(s){this.logService.error(s)}})(),o}async doWatch(c,i){const o=await this.withProvider(c),t=(0,P.hash)([this.getExtUri(o).providerExtUri.getComparisonKey(c),i]);let n=this.activeWatchers.get(t);return n||(n={count:0,disposable:o.watch(c,i)},this.activeWatchers.set(t,n)),n.count+=1,(0,E.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,E.dispose)(n.disposable),this.activeWatchers.delete(t)))})}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,E.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,i,o,t){return this.writeQueue.queueFor(i,this.getExtUri(c).providerExtUri).queue(async()=>{const n=await c.open(i,{create:!0,unlock:o?.unlock??!1});try{(0,h.isReadableStream)(t)||(0,h.isReadableBufferedStream)(t)?await this.doWriteStreamBufferedQueued(c,n,t):await this.doWriteReadableBufferedQueued(c,n,t)}catch(s){throw(0,C.ensureFileSystemProviderError)(s)}finally{await c.close(n)}})}async doWriteStreamBufferedQueued(c,i,o){let t=0,n;if((0,h.isReadableBufferedStream)(o)){if(o.buffer.length>0){const s=R.VSBuffer.concat(o.buffer);await this.doWriteBuffer(c,i,s,s.byteLength,t,0),t+=s.byteLength}if(o.ended)return;n=o.stream}else n=o;return new Promise((s,u)=>{(0,h.listenStream)(n,{onData:async l=>{n.pause();try{await this.doWriteBuffer(c,i,l,l.byteLength,t,0)}catch(m){return u(m)}t+=l.byteLength,setTimeout(()=>n.resume())},onError:l=>u(l),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(c,i,o){let t=0,n;for(;(n=o.read())!==null;)await this.doWriteBuffer(c,i,n,n.byteLength,t,0),t+=n.byteLength}async doWriteBuffer(c,i,o,t,n,s){let u=0;for(;u<t;)u+=await c.write(i,n+u,o.buffer,s+u,t-u)}async doWriteUnbuffered(c,i,o,t){return this.writeQueue.queueFor(i,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,i,o,t))}async doWriteUnbufferedQueued(c,i,o,t){let n;t instanceof R.VSBuffer?n=t:(0,h.isReadableStream)(t)?n=await(0,R.streamToBuffer)(t):(0,h.isReadableBufferedStream)(t)?n=await(0,R.bufferedStreamToBuffer)(t):n=(0,R.readableToBuffer)(t),await c.writeFile(i,n.buffer,{create:!0,overwrite:!0,unlock:o?.unlock??!1})}async doPipeBuffered(c,i,o,t){return this.writeQueue.queueFor(t,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,i,o,t))}async doPipeBufferedQueued(c,i,o,t){let n,s;try{n=await c.open(i,{create:!1}),s=await o.open(t,{create:!0,unlock:!1});const u=R.VSBuffer.alloc(this.BUFFER_SIZE);let l=0,m=0,y=0;do y=await c.read(n,l,u.buffer,m,u.byteLength-m),await this.doWriteBuffer(o,s,u,y,l,m),l+=y,m+=y,m===u.byteLength&&(m=0);while(y>0)}catch(u){throw(0,C.ensureFileSystemProviderError)(u)}finally{await r.Promises.settled([typeof n=="number"?c.close(n):Promise.resolve(),typeof s=="number"?o.close(s):Promise.resolve()])}}async doPipeUnbuffered(c,i,o,t){return this.writeQueue.queueFor(t,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,i,o,t))}async doPipeUnbufferedQueued(c,i,o,t){return o.writeFile(t,await c.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,i,o,t){return this.writeQueue.queueFor(t,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,i,o,t))}async doPipeUnbufferedToBufferedQueued(c,i,o,t){const n=await o.open(t,{create:!0,unlock:!1});try{const s=await c.readFile(i);await this.doWriteBuffer(o,n,R.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,C.ensureFileSystemProviderError)(s)}finally{await o.close(n)}}async doPipeBufferedToUnbuffered(c,i,o,t){const n=await(0,R.streamToBuffer)(this.readFileBuffered(c,i,L.CancellationToken.None));await this.doWriteUnbuffered(o,t,void 0,n)}throwIfFileSystemIsReadonly(c,i){if(c.capabilities&2048)throw new C.FileOperationError((0,S.localize)(22,null,this.resourceForError(i)),6);return c}throwIfFileIsReadonly(c,i){if((i.permissions??0)&C.FilePermission.Readonly)throw new C.FileOperationError((0,S.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===b.Schemas.file?c.fsPath:c.toString(!0)}};a=pe([Y(0,f.ILogService)],a),e.FileService=a}),define(ne[194],re([0,1,53,278,6,34,16,3,47,2,12,4,19,42,28,155,13,97,191,38,186,185]),function(Q,e,D,r,R,L,T,P,w,E,I,b,p,v,h,S,C,g,f,a,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,r.gracefulify)(D)}catch(o){console.error(`Error enabling graceful-fs: ${(0,a.toErrorMessage)(o)}`)}})();class i extends f.AbstractDiskFileSystemProvider{constructor(t,n){super(t,n),this.onDidChangeCapabilities=P.Event.None,this.resourceLocks=new L.ResourceMap(s=>p.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,b.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(t){try{const{stat:n,symbolicLink:s}=await h.SymlinkSupport.stat(this.toFilePath(t));return{type:this.toType(n,s),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(t){try{const n=await h.Promises.readdir(this.toFilePath(t),{withFileTypes:!0}),s=[];return await Promise.all(n.map(async u=>{try{let l;u.isSymbolicLink()?l=(await this.stat((0,p.joinPath)(t,u.name))).type:l=this.toType(u),s.push([u.name,l])}catch(l){this.logService.trace(l)}})),s}catch(n){throw this.toFileSystemProviderError(n)}}toType(t,n){let s;return n?.dangling?s=C.FileType.Unknown:t.isFile()?s=C.FileType.File:t.isDirectory()?s=C.FileType.Directory:s=C.FileType.Unknown,n&&(s|=C.FileType.SymbolicLink),s}async createResourceLock(t){const n=this.toFilePath(t);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let s;for(;s=this.resourceLocks.get(t);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await s.wait();const u=new R.Barrier;return this.resourceLocks.set(t,u),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,E.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(t)===u&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(t)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),u.open()})}async readFile(t,n){let s;try{n?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(t)})`),s=await this.createResourceLock(t));const u=this.toFilePath(t);return await h.Promises.readFile(u)}catch(u){throw this.toFileSystemProviderError(u)}finally{s?.dispose()}}traceLock(t){i.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(t)}readFileStream(t,n,s){const u=(0,v.newWriteableStream)(l=>T.VSBuffer.concat(l.map(m=>T.VSBuffer.wrap(m))).buffer);return(0,g.readFileIntoStream)(this,t,u,l=>l.buffer,{...n,bufferSize:256*1024},s),u}async writeFile(t,n,s){let u;try{const l=this.toFilePath(t);if(!s.create||!s.overwrite){if(await h.Promises.exists(l)){if(!s.overwrite)throw(0,C.createFileSystemProviderError)((0,S.localize)(0,null),C.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,C.createFileSystemProviderError)((0,S.localize)(1,null),C.FileSystemProviderErrorCode.FileNotFound)}u=await this.open(t,{create:!0,unlock:s.unlock}),await this.write(u,0,n,0,n.byteLength)}catch(l){throw await this.toFileSystemProviderWriteError(t,l)}finally{typeof u=="number"&&await this.close(u)}}static configureFlushOnWrite(t){i.canFlush=t}async open(t,n){const s=this.toFilePath(t);let u;(0,C.isFileOpenForWriteOptions)(n)&&(u=await this.createResourceLock(t));let l;try{if((0,C.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:y}=await h.SymlinkSupport.stat(s);y.mode&128||await h.Promises.chmod(s,y.mode|128)}catch(y){this.logService.trace(y)}let m;if((0,C.isFileOpenForWriteOptions)(n)){if(b.isWindows)try{await h.Promises.truncate(s,0),m="r+"}catch(y){y.code!=="ENOENT"&&this.logService.trace(y)}m||(m="w")}else m="r";l=await h.Promises.open(s,m)}catch(m){throw u?.dispose(),(0,C.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(t,m):this.toFileSystemProviderError(m)}if(this.mapHandleToPos.set(l,0),(0,C.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(l,t),u){const m=this.mapHandleToLock.get(l);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${l} (${s})`),this.mapHandleToLock.set(l,u),m&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${l} (${s})`),m.dispose())}return l}async close(t){const n=this.mapHandleToLock.get(t);try{if(this.mapHandleToPos.delete(t),this.writeHandles.delete(t)&&i.canFlush)try{await h.Promises.fdatasync(t)}catch(s){i.configureFlushOnWrite(!1),this.logService.error(s)}return await h.Promises.close(t)}catch(s){throw this.toFileSystemProviderError(s)}finally{n&&(this.mapHandleToLock.get(t)===n&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.mapHandleToLock.delete(t)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),n.dispose())}}async read(t,n,s,u,l){const m=this.normalizePos(t,n);let y=null;try{y=(await h.Promises.read(t,s,u,l,m)).bytesRead}catch(_){throw this.toFileSystemProviderError(_)}finally{this.updatePos(t,m,y)}return y}normalizePos(t,n){return n===this.mapHandleToPos.get(t)?null:n}updatePos(t,n,s){const u=this.mapHandleToPos.get(t);typeof u=="number"&&(typeof n=="number"||(typeof s=="number"?this.mapHandleToPos.set(t,u+s):this.mapHandleToPos.delete(t)))}async write(t,n,s,u,l){return(0,R.retry)(()=>this.doWrite(t,n,s,u,l),100,3)}async doWrite(t,n,s,u,l){const m=this.normalizePos(t,n);let y=null;try{y=(await h.Promises.write(t,s,u,l,m)).bytesWritten}catch(_){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(t),_)}finally{this.updatePos(t,m,y)}return y}async mkdir(t){try{await h.Promises.mkdir(this.toFilePath(t))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(t,n){try{const s=this.toFilePath(t);n.recursive?await h.Promises.rm(s,h.RimRafMode.MOVE):await h.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(t,n,s){const u=this.toFilePath(t),l=this.toFilePath(n);if(u!==l)try{await this.validateTargetDeleted(t,n,"move",s.overwrite),await h.Promises.move(u,l)}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error((0,S.localize)(2,null,(0,I.basename)(u),(0,I.basename)((0,I.dirname)(l)),m.toString()))),this.toFileSystemProviderError(m)}}async copy(t,n,s){const u=this.toFilePath(t),l=this.toFilePath(n);if(u!==l)try{await this.validateTargetDeleted(t,n,"copy",s.overwrite),await h.Promises.copy(u,l,{preserveSymlinks:!0})}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error((0,S.localize)(3,null,(0,I.basename)(u),(0,I.basename)((0,I.dirname)(l)),m.toString()))),this.toFileSystemProviderError(m)}}async validateTargetDeleted(t,n,s,u){const l=this.toFilePath(t),m=this.toFilePath(n);let y=!1;if(!!(this.capabilities&1024)||(y=(0,w.isEqual)(l,m,!0)),y&&s==="copy")throw(0,C.createFileSystemProviderError)((0,S.localize)(4,null),C.FileSystemProviderErrorCode.FileExists);if(!y&&await h.Promises.exists(m)){if(!u)throw(0,C.createFileSystemProviderError)((0,S.localize)(5,null),C.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(t,n){return this.doCloneFile(t,n,!1)}async doCloneFile(t,n,s){const u=this.toFilePath(t),l=this.toFilePath(n),m=!!(this.capabilities&1024);if((0,w.isEqual)(u,l,!m))return;const y=new E.DisposableStore;try{const[_,$]=await Promise.all([this.createResourceLock(t),this.createResourceLock(n)]);y.add(_),y.add($),s&&await h.Promises.mkdir((0,I.dirname)(l),{recursive:!0}),await h.Promises.copyFile(u,l)}catch(_){if(_.code==="ENOENT"&&!s)return this.doCloneFile(t,n,!0);throw this.toFileSystemProviderError(_)}finally{y.dispose()}}createUniversalWatcher(t,n,s){return new d.UniversalWatcherClient(u=>t(u),u=>n(u),s)}createNonRecursiveWatcher(t,n,s){return new c.NodeJSWatcherClient(u=>t(u),u=>n(u),s)}toFileSystemProviderError(t){if(t instanceof C.FileSystemProviderError)return t;let n;switch(t.code){case"ENOENT":n=C.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=C.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=C.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=C.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=C.FileSystemProviderErrorCode.NoPermissions;break;default:n=C.FileSystemProviderErrorCode.Unknown}return(0,C.createFileSystemProviderError)(t,n)}async toFileSystemProviderWriteError(t,n){let s=this.toFileSystemProviderError(n);if(t&&s.code===C.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await h.SymlinkSupport.stat(this.toFilePath(t));u.mode&128||(s=(0,C.createFileSystemProviderError)(n,C.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.logService.trace(u)}return s}}e.DiskFileSystemProvider=i,i.TRACE_LOG_RESOURCE_LOCKS=!1,i.canFlush=!0}),define(ne[98],re([0,1,3,7,8]),function(Q,e,D,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class L{constructor(p){this.service=p,this.onDidChangeLogLevel=D.Event.buffer(p.onDidChangeLogLevel,!0)}listen(p,v){switch(v){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${v}`)}async call(p,v,h){switch(v){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${v}`)}}e.LogLevelChannel=L;class T{constructor(p){this.channel=p}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(p){T.setLevel(this.channel,p)}static setLevel(p,v){return p.call("setLevel",v)}}e.LogLevelChannelClient=T;class P{constructor(p){this.loggerService=p,this.loggers=new Map}listen(p,v){throw new Error(`Event not found: ${v}`)}async call(p,v,h){switch(v){case"createLogger":this.createLogger(r.URI.revive(h[0]),h[1]);return;case"log":return this.log(r.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${v}`)}createLogger(p,v){this.loggers.set(p.toString(),this.loggerService.createLogger(p,v))}consoleLog(p,v){let h=console.log;switch(p){case R.LogLevel.Error:h=console.error;break;case R.LogLevel.Warning:h=console.warn;break;case R.LogLevel.Info:h=console.info;break}h.call(console,...v)}log(p,v){const h=this.loggers.get(p.toString());if(!h)throw new Error("Create the logger before logging");for(const[S,C]of v)(0,R.log)(h,S,C)}}e.LoggerChannel=P;class w extends R.AbstractLoggerService{constructor(p,v,h){super(p,v),this.channel=h}createConsoleMainLogger(){return new R.AdapterLogger({log:(p,v)=>{this.channel.call("consoleLog",[p,v])}})}doCreateLogger(p,v,h){return new E(this.channel,p,v,h)}}e.LoggerChannelClient=w;class E extends R.AbstractMessageLogger{constructor(p,v,h,S){super(S?.always),this.channel=p,this.file=v,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[v,S]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(p,v){const h=[[p,v]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(p){this.channel.call("log",[this.file,p])}}class I extends R.LogService{constructor(p,v){super(v),this.parent=p,this._register(p.onDidChangeLogLevel(h=>v.setLevel(h)))}setLevel(p){super.setLevel(p),this.parent.setLevel(p)}}e.FollowerLogService=I}),define(ne[59],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,D.createDecorator)("nativeHostService")}),define(ne[60],re([0,1,3,52,2,5]),function(Q,e,D,r,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,L.createDecorator)("policy");class T extends R.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(E){const I=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...E,...this.policyDefinitions},I!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(E),r.Iterable.reduce(this.policies.entries(),(b,[p,v])=>({...b,[p]:v}),{})}getPolicyValue(E){return this.policies.get(E)}serialize(){return r.Iterable.reduce(Object.entries(this.policyDefinitions),(E,[I,b])=>({...E,[I]:{definition:b,value:this.policies.get(I)}}),{})}}e.AbstractPolicyService=T;class P{constructor(){this.onDidChange=D.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(ne[195],re([0,1,3,2,60]),function(Q,e,D,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class L{constructor(w){this.service=w,this.disposables=new r.DisposableStore}listen(w,E){switch(E){case"onDidChange":return D.Event.map(this.service.onDidChange,I=>I.reduce((b,p)=>({...b,[p]:this.service.getPolicyValue(p)??null}),{}),this.disposables)}throw new Error(`Event not found: ${E}`)}call(w,E,I){switch(E){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(I)}throw new Error(`Call not found: ${E}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=L;class T extends R.AbstractPolicyService{constructor(w,E){super(),this.channel=E;for(const I in w){const{definition:b,value:p}=w[I];this.policyDefinitions[I]=b,p!==void 0&&this.policies.set(I,p)}this.channel.listen("onDidChange")(I=>{for(const b in I){const p=I[b];p===null?this.policies.delete(b):this.policies.set(b,p)}this._onDidChange.fire(Object.keys(I))})}async initializePolicies(w){const E=await this.channel.call("registerPolicyDefinitions",w);for(const I in E)this.policies.set(I,E[I])}}e.PolicyChannelClient=T}),define(ne[99],re([0,1,23,4,37,19]),function(Q,e,D,r,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof r.globals.vscode<"u"&&typeof r.globals.vscode.context<"u"){const P=r.globals.vscode.context.configuration();if(P)T=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Q?.__$__nodeRequire=="function"){const P=(0,L.dirname)(D.FileAccess.asFileUri("",Q));if(T=Q.__$__nodeRequire((0,L.joinPath)(P,"product.json").fsPath),R.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`,serverDataFolderName:T.serverDataFolderName?`${T.serverDataFolderName}-dev`:void 0}),!T.version){const w=Q.__$__nodeRequire((0,L.joinPath)(P,"package.json").fsPath);Object.assign(T,{version:w.version})}}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=T}),define(ne[25],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ne[196],re([0,1,6,9,2,12,28,8,25]),function(Q,e,D,r,R,L,T,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let E=class extends R.Disposable{constructor(b,p,v){super(),this.productService=p,this.logService=v,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,b&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpCodeCaches(b)},3e4)).schedule()}async cleanUpCodeCaches(b){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const p=Date.now(),v=(0,L.dirname)(b),h=(0,L.basename)(b),S=await T.Promises.readdir(v);await Promise.all(S.map(async C=>{if(C===h)return;const g=(0,L.join)(v,C),f=await T.Promises.stat(g);if(f.isDirectory()&&p-f.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${C}.`),T.Promises.rm(g)}))}catch(p){(0,r.onUnexpectedError)(p)}}};E=pe([Y(1,w.IProductService),Y(2,P.ILogService)],E),e.CodeCacheCleaner=E}),define(ne[197],re([0,1,6,9,2,12,28,14,8,25]),function(Q,e,D,r,R,L,T,P,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let I=class extends R.Disposable{constructor(p,v,h){super(),this.environmentService=p,this.logService=v,this.productService=h,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},4e4)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const p=Object.create(null),v=JSON.parse(await T.Promises.readFile((0,L.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(const f of Object.keys(v)){const a=v[f];p[`${a.hash}.${f}`]=!0}const h=(0,L.join)(this.environmentService.userDataPath,"clp");if(!await T.Promises.exists(h))return;const C=await T.Promises.readdir(h);for(const f of C){if(p[f]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${f}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${f}`),await T.Promises.rm((0,L.join)(h,f))}const g=Date.now();for(const f of Object.keys(p)){const a=(0,L.join)(h,f),d=await T.Promises.readdir(a);for(const c of d){if(c==="tcf.json")continue;const i=(0,L.join)(a,c),o=await T.Promises.stat(i);o.isDirectory()&&g-o.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,L.join)(f,c)}`),await T.Promises.rm(i))}}}catch(p){(0,r.onUnexpectedError)(p)}}};I=pe([Y(0,P.INativeEnvironmentService),Y(1,w.ILogService),Y(2,E.IProductService)],I),e.LanguagePackCachedDataCleaner=I}),define(ne[198],re([0,1,12,5]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,r.createDecorator)("IV8InspectProfilingService");var R;(function(L){function T(P,w="noAbsolutePaths"){for(const E of P.nodes)E.callFrame&&E.callFrame.url&&((0,D.isAbsolute)(E.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(E.callFrame.url))&&(E.callFrame.url=(0,D.join)(w,(0,D.basename)(E.callFrame.url)));return P}L.rewriteAbsolutePaths=T})(R=e.Utils||(e.Utils={}))}),define(ne[199],re([0,1,30]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class r{constructor(){this._sessions=new Map}async startProfiling(L){const P=await(await new Promise((E,I)=>{Q(["v8-inspect-profiler"],E,I)})).startProfiling({port:L.port,checkForPaused:!0}),w=(0,D.generateUuid)();return this._sessions.set(w,P),w}async stopProfiling(L){const T=this._sessions.get(L);if(!T)throw new Error(`UNKNOWN session '${L}'`);const P=await T.stop();return this._sessions.delete(L),P.profile}}e.InspectProfilingService=r}),define(ne[40],re([0,1,115,15]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.data=new Map}add(T,P){D.ok(r.isString(T)),D.ok(r.isObject(P)),D.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,P)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new R}),define(ne[100],re([0,1,3,40]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class L{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(w,E){this.schemasById[R(w)]=E,this._onDidChangeSchema.fire(w)}notifySchemaChanged(w){this._onDidChangeSchema.fire(w)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new L;r.Registry.add(e.Extensions.JSONContribution,T)}),define(ne[43],re([0,1,18,3,15,141,17,100,40]),function(Q,e,D,r,R,L,T,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var E;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(E=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=w.Registry.as(P.Extensions.JSONContribution);class p{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new r.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new r.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const t=this.doRegisterConfigurations(i,o);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}deregisterConfigurations(i){const o=this.doDeregisterConfigurations(i);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:i,remove:o}){const t=[];t.push(...this.doDeregisterConfigurations(o)),t.push(...this.doRegisterConfigurations(i,!1)),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,D.distinct)(t)})}registerDefaultConfigurations(i){const o=[],t=[];for(const{overrides:n,source:s}of i)for(const u in n)if(o.push(u),e.OVERRIDE_PROPERTY_REGEX.test(u)){const l=this.configurationDefaultsOverrides.get(u),m=l?.valuesSources??new Map;if(s)for(const A of Object.keys(n[u]))m.set(A,s);const y={...l?.value||{},...n[u]};this.configurationDefaultsOverrides.set(u,{source:s,value:y,valuesSources:m});const _=(0,T.getLanguageTagSettingPlainKey)(u),$={type:"object",default:y,description:L.localize(1,null,_),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:y,source:R.isString(s)?void 0:s,defaultValueSource:s};t.push(...S(u)),this.configurationProperties[u]=$,this.defaultLanguageConfigurationOverridesNode.properties[u]=$}else{this.configurationDefaultsOverrides.set(u,{value:n[u],source:s});const l=this.configurationProperties[u];l&&(this.updatePropertyDefaultValue(u,l),this.updateSchema(u,l))}this.registerOverrideIdentifiers(t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}deregisterDefaultConfigurations(i){const o=[];for(const{overrides:t,source:n}of i)for(const s in t){const u=this.configurationDefaultsOverrides.get(s),l=R.isString(n)?n:n?.id,m=R.isString(u?.source)?u?.source:u?.source?.id;if(l===m)if(o.push(s),this.configurationDefaultsOverrides.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const y=this.configurationProperties[s];y&&(this.updatePropertyDefaultValue(s,y),this.updateSchema(s,y))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){for(const o of i)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,o){const t=[];return i.forEach(n=>{t.push(...this.validateAndRegisterProperties(n,o,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),t}doDeregisterConfigurations(i){const o=[],t=n=>{if(n.properties)for(const s in n.properties){o.push(s);const u=this.configurationProperties[s];u?.policy?.name&&this.policyConfigurations.delete(u.policy.name),delete this.configurationProperties[s],this.removeFromSchema(s,n.properties[s])}n.allOf?.forEach(s=>t(s))};for(const n of i){t(n);const s=this.configurationContributors.indexOf(n);s!==-1&&this.configurationContributors.splice(s,1)}return o}validateAndRegisterProperties(i,o=!0,t,n,s=3){s=R.isUndefinedOrNull(i.scope)?s:i.scope;const u=[],l=i.properties;if(l)for(const y in l){const _=l[y];if(o&&a(y,_)){delete l[y];continue}if(_.source=t,_.defaultDefaultValue=l[y].default,this.updatePropertyDefaultValue(y,_),e.OVERRIDE_PROPERTY_REGEX.test(y)?_.scope=void 0:(_.scope=R.isUndefinedOrNull(_.scope)?s:_.scope,_.restricted=R.isUndefinedOrNull(_.restricted)?!!n?.includes(y):_.restricted),l[y].hasOwnProperty("included")&&!l[y].included){this.excludedConfigurationProperties[y]=l[y],delete l[y];continue}else this.configurationProperties[y]=l[y],l[y].policy?.name&&this.policyConfigurations.set(l[y].policy.name,y);!l[y].deprecationMessage&&l[y].markdownDeprecationMessage&&(l[y].deprecationMessage=l[y].markdownDeprecationMessage),u.push(y)}const m=i.allOf;if(m)for(const y of m)u.push(...this.validateAndRegisterProperties(y,o,t,n,s));return u}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const o=t=>{const n=t.properties;if(n)for(const u in n)this.updateSchema(u,n[u]);t.allOf?.forEach(o)};o(i)}updateSchema(i,o){switch(e.allSettings.properties[i]=o,o.scope){case 1:e.applicationSettings.properties[i]=o;break;case 2:e.machineSettings.properties[i]=o;break;case 6:e.machineOverridableSettings.properties[i]=o;break;case 3:e.windowSettings.properties[i]=o;break;case 4:e.resourceSettings.properties[i]=o;break;case 5:e.resourceSettings.properties[i]=o,this.resourceLanguageSettingsSchema.properties[i]=o;break}}removeFromSchema(i,o){switch(delete e.allSettings.properties[i],o.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const o=`[${i}]`,t={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,t),e.allSettings.properties[o]=t,e.applicationSettings.properties[o]=t,e.machineSettings.properties[o]=t,e.machineOverridableSettings.properties[o]=t,e.windowSettings.properties[o]=t,e.resourceSettings.properties[o]=t}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const i={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,o){const t=this.configurationDefaultsOverrides.get(i);let n=t?.value,s=t?.source;R.isUndefined(n)&&(n=o.defaultDefaultValue,s=void 0),R.isUndefined(n)&&(n=g(o.type)),o.default=n,o.defaultValueSource=s}}const v="\\[([^\\]]+)\\]",h=new RegExp(v,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${v})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function S(c){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(c)){let o=h.exec(c);for(;o?.length;){const t=o[1].trim();t&&i.push(t),o=h.exec(c)}}return(0,D.distinct)(i)}e.overrideIdentifiersFromKey=S;function C(c){return c.reduce((i,o)=>`${i}[${o}]`,"")}e.keyFromOverrideIdentifiers=C;function g(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=g;const f=new p;w.Registry.add(e.Extensions.Configuration,f);function a(c,i){return c.trim()?e.OVERRIDE_PROPERTY_REGEX.test(c)?L.localize(7,null,c):f.getConfigurationProperties()[c]!==void 0?L.localize(8,null,c):i.policy?.name&&f.getPolicyConfigurations().get(i.policy?.name)!==void 0?L.localize(9,null,c,i.policy?.name,f.getPolicyConfigurations().get(i.policy?.name)):null:L.localize(6,null)}e.validateProperty=a;function d(){const c=[],i=f.getConfigurationProperties();for(const o of Object.keys(i))c.push([o,i[o].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.getScopes=d}),define(ne[72],re([0,1,18,3,35,2,34,32,15,7,17,43,40]),function(Q,e,D,r,R,L,T,P,w,E,I,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class v{constructor(i={},o=[],t=[],n){this._contents=i,this._keys=o,this._overrides=t,this.raw=n,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const i=this.raw.map(o=>{if(o instanceof v)return o;const t=new h("");return t.parseRaw(o),t.configurationModel});this._rawConfiguration=i.reduce((o,t)=>t===o?t:o.merge(t),i[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(i){return i?(0,I.getConfigurationValue)(this.contents,i):this.contents}inspect(i,o){const t=this.rawConfiguration.getValue(i),n=o?this.rawConfiguration.getOverrideValue(i,o):void 0,s=o?this.rawConfiguration.override(o).getValue(i):t;return{value:t,override:n,merged:s}}getOverrideValue(i,o){const t=this.getContentsForOverrideIdentifer(o);return t?i?(0,I.getConfigurationValue)(t,i):t:void 0}getKeysForOverrideIdentifier(i){const o=[];for(const t of this.overrides)t.identifiers.includes(i)&&o.push(...t.keys);return D.distinct(o)}getAllOverrideIdentifiers(){const i=[];for(const o of this.overrides)i.push(...o.identifiers);return D.distinct(i)}override(i){let o=this.overrideConfigurations.get(i);return o||(o=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,o)),o}merge(...i){const o=P.deepClone(this.contents),t=P.deepClone(this.overrides),n=[...this.keys],s=this.raw?.length?[...this.raw]:[this];for(const u of i)if(s.push(...u.raw?.length?u.raw:[u]),!u.isEmpty()){this.mergeContents(o,u.contents);for(const l of u.overrides){const[m]=t.filter(y=>D.equals(y.identifiers,l.identifiers));m?(this.mergeContents(m.contents,l.contents),m.keys.push(...l.keys),m.keys=D.distinct(m.keys)):t.push(P.deepClone(l))}for(const l of u.keys)n.indexOf(l)===-1&&n.push(l)}return new v(o,n,t,s.every(u=>u instanceof v)?void 0:s)}freeze(){return this.frozen=!0,this}clone(){return new v(P.deepClone(this.contents),[...this.keys],P.deepClone(this.overrides))}createOverrideConfigurationModel(i){const o=this.getContentsForOverrideIdentifer(i);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const t={};for(const n of D.distinct([...Object.keys(this.contents),...Object.keys(o)])){let s=this.contents[n];const u=o[n];u&&(typeof s=="object"&&typeof u=="object"?(s=P.deepClone(s),this.mergeContents(s,u)):s=u),t[n]=s}return new v(t,this.keys,this.overrides)}mergeContents(i,o){for(const t of Object.keys(o)){if(t in i&&w.isObject(i[t])&&w.isObject(o[t])){this.mergeContents(i[t],o[t]);continue}i[t]=P.deepClone(o[t])}}checkAndFreeze(i){return this.frozen&&!Object.isFrozen(i)?P.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let o=null,t=null;const n=s=>{s&&(t?this.mergeContents(t,s):t=P.deepClone(s))};for(const s of this.overrides)D.equals(s.identifiers,[i])?o=s.contents:s.identifiers.includes(i)&&n(s.contents);return n(o),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,o){this.addKey(i),(0,I.addToValueTree)(this.contents,i,o,t=>{throw new Error(t)})}removeValue(i){this.removeKey(i)&&(0,I.removeFromValueTree)(this.contents,i)}addKey(i){let o=this.keys.length;for(let t=0;t<o;t++)i.indexOf(this.keys[t])===0&&(o=t);this.keys.splice(o,1,i)}removeKey(i){const o=this.keys.indexOf(i);return o!==-1?(this.keys.splice(o,1),!0):!1}}e.ConfigurationModel=v;class h{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new v}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,o){if(!w.isUndefinedOrNull(i)){const t=this.doParseContent(i);this.parseRaw(t,o)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,o){this._raw=i;const{contents:t,keys:n,overrides:s,restricted:u,hasExcludedProperties:l}=this.doParseRaw(i,o);this._configurationModel=new v(t,n,s,l?[i]:void 0),this._restrictedConfigurations=u||[]}doParseContent(i){let o={},t=null,n=[];const s=[],u=[];function l(y){Array.isArray(n)?n.push(y):t!==null&&(n[t]=y)}const m={onObjectBegin:()=>{const y={};l(y),s.push(n),n=y,t=null},onObjectProperty:y=>{t=y},onObjectEnd:()=>{n=s.pop()},onArrayBegin:()=>{const y=[];l(y),s.push(n),n=y,t=null},onArrayEnd:()=>{n=s.pop()},onLiteralValue:l,onError:(y,_,$)=>{u.push({error:y,offset:_,length:$})}};if(i)try{R.visit(i,m),o=n[0]||{}}catch(y){console.error(`Error while parsing settings file ${this._name}: ${y}`),this._parseErrors=[y]}return o}doParseRaw(i,o){const t=p.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),n=this.filter(i,t,!0,o);i=n.raw;const s=(0,I.toValuesTree)(i,m=>console.error(`Conflict in settings file ${this._name}: ${m}`)),u=Object.keys(i),l=this.toOverrides(i,m=>console.error(`Conflict in settings file ${this._name}: ${m}`));return{contents:s,keys:u,overrides:l,restricted:n.restricted,hasExcludedProperties:n.hasExcludedProperties}}filter(i,o,t,n){let s=!1;if(!n?.scopes&&!n?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:s};const u={},l=[];for(const m in i)if(b.OVERRIDE_PROPERTY_REGEX.test(m)&&t){const y=this.filter(i[m],o,!1,n);u[m]=y.raw,s=s||y.hasExcludedProperties,l.push(...y.restricted)}else{const y=o[m],_=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&l.push(m),(_===void 0||n.scopes===void 0||n.scopes.includes(_))&&!(n.skipRestricted&&y?.restricted)?u[m]=i[m]:s=!0}return{raw:u,restricted:l,hasExcludedProperties:s}}toOverrides(i,o){const t=[];for(const n of Object.keys(i))if(b.OVERRIDE_PROPERTY_REGEX.test(n)){const s={};for(const u in i[n])s[u]=i[n][u];t.push({identifiers:(0,b.overrideIdentifiersFromKey)(n),keys:Object.keys(s),contents:(0,I.toValuesTree)(s,o)})}return t}}e.ConfigurationModelParser=h;class S extends L.Disposable{constructor(i,o,t,n){super(),this.userSettingsResource=i,this.scopes=o,this.fileService=n,this._onDidChange=this._register(new r.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(t.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(r.Event.any(r.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource)),r.Event.filter(this.fileService.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&t.isEqual(s.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new v}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=S;class C{constructor(i,o,t,n,s=new v,u=new v,l=new T.ResourceMap,m=new v,y=new T.ResourceMap,_=!0){this._defaultConfiguration=i,this._policyConfiguration=o,this._applicationConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=s,this._workspaceConfiguration=u,this._folderConfigurations=l,this._memoryConfiguration=m,this._memoryConfigurationByResource=y,this._freeze=_,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(i,o,t){return this.getConsolidatedConfigurationModel(i,o,t).getValue(i)}updateValue(i,o,t={}){let n;t.resource?(n=this._memoryConfigurationByResource.get(t.resource),n||(n=new v,this._memoryConfigurationByResource.set(t.resource,n))):n=this._memoryConfiguration,o===void 0?n.removeValue(i):n.setValue(i,o),t.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,o,t){const n=this.getConsolidatedConfigurationModel(i,o,t),s=this.getFolderConfigurationModelForResource(o.resource,t),u=o.resource?this._memoryConfigurationByResource.get(o.resource)||this._memoryConfiguration:this._memoryConfiguration,l=this._defaultConfiguration.inspect(i,o.overrideIdentifier),m=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().inspect(i),y=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().inspect(i),_=this.userConfiguration.freeze().inspect(i,o.overrideIdentifier),$=this.localUserConfiguration.freeze().inspect(i,o.overrideIdentifier),A=this.remoteUserConfiguration.freeze().inspect(i,o.overrideIdentifier),U=t?this._workspaceConfiguration.freeze().inspect(i,o.overrideIdentifier):void 0,k=s?s.freeze().inspect(i,o.overrideIdentifier):void 0,N=u.inspect(i,o.overrideIdentifier),F=n.getValue(i),q=D.distinct(n.overrides.map(J=>J.identifiers).flat()).filter(J=>n.getOverrideValue(i,J)!==void 0);return{defaultValue:l?l.merged:void 0,policyValue:m?m.merged:void 0,applicationValue:y?y.merged:void 0,userValue:_?_.merged:void 0,userLocalValue:$?$.merged:void 0,userRemoteValue:A?A.merged:void 0,workspaceValue:U?U.merged:void 0,workspaceFolderValue:k?k.merged:void 0,memoryValue:N?N.merged:void 0,value:F,default:l.value!==void 0||l.override!==void 0?{value:l.value,override:l.override}:void 0,policy:m?.value!==void 0?{value:m.value}:void 0,application:y?.value!==void 0||y?.override!==void 0?{value:y.value,override:y.override}:void 0,user:_.value!==void 0||_.override!==void 0?{value:_.value,override:_.override}:void 0,userLocal:$.value!==void 0||$.override!==void 0?{value:$.value,override:$.override}:void 0,userRemote:A.value!==void 0||A.override!==void 0?{value:A.value,override:A.override}:void 0,workspace:U?.value!==void 0||U?.override!==void 0?{value:U.value,override:U.override}:void 0,workspaceFolder:k?.value!==void 0||k?.override!==void 0?{value:k.value,override:k.override}:void 0,memory:N.value!==void 0||N.override!==void 0?{value:N.value,override:N.override}:void 0,overrideIdentifiers:q.length?q:void 0}}keys(i){const o=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:o?o.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(i){this._policyConfiguration=i}updateApplicationConfiguration(i){this._applicationConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,o){this._folderConfigurations.set(i,o),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,o){const t=[];if(!o){const{added:n,updated:s,removed:u}=a(this._defaultConfiguration,i);o=[...n,...s,...u]}for(const n of o)for(const s of(0,b.overrideIdentifiersFromKey)(n)){const u=this._defaultConfiguration.getKeysForOverrideIdentifier(s),l=i.getKeysForOverrideIdentifier(s),m=[...l.filter(y=>u.indexOf(y)===-1),...u.filter(y=>l.indexOf(y)===-1),...u.filter(y=>!P.equals(this._defaultConfiguration.override(s).getValue(y),i.override(s).getValue(y)))];t.push([s,m])}return this.updateDefaultConfiguration(i),{keys:o,overrides:t}}compareAndUpdatePolicyConfiguration(i){const{added:o,updated:t,removed:n}=a(this._policyConfiguration,i),s=[...o,...t,...n];return s.length&&this.updatePolicyConfiguration(i),{keys:s,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:o,updated:t,removed:n,overrides:s}=a(this.applicationConfiguration,i),u=[...o,...t,...n];return u.length&&this.updateApplicationConfiguration(i),{keys:u,overrides:s}}compareAndUpdateLocalUserConfiguration(i){const{added:o,updated:t,removed:n,overrides:s}=a(this.localUserConfiguration,i),u=[...o,...t,...n];return u.length&&this.updateLocalUserConfiguration(i),{keys:u,overrides:s}}compareAndUpdateRemoteUserConfiguration(i){const{added:o,updated:t,removed:n,overrides:s}=a(this.remoteUserConfiguration,i),u=[...o,...t,...n];return u.length&&this.updateRemoteUserConfiguration(i),{keys:u,overrides:s}}compareAndUpdateWorkspaceConfiguration(i){const{added:o,updated:t,removed:n,overrides:s}=a(this.workspaceConfiguration,i),u=[...o,...t,...n];return u.length&&this.updateWorkspaceConfiguration(i),{keys:u,overrides:s}}compareAndUpdateFolderConfiguration(i,o){const t=this.folderConfigurations.get(i),{added:n,updated:s,removed:u,overrides:l}=a(t,o),m=[...n,...s,...u];return(m.length||!t)&&this.updateFolderConfiguration(i,o),{keys:m,overrides:l}}compareAndDeleteFolderConfiguration(i){const o=this.folderConfigurations.get(i);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:t,updated:n,removed:s,overrides:u}=a(o,void 0);return{keys:[...t,...n,...s],overrides:u}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(i,o,t){let n=this.getConsolidatedConfigurationModelForResource(o,t);return o.overrideIdentifier&&(n=n.override(o.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(i)!==void 0&&(n=n.merge(this._policyConfiguration)),n}getConsolidatedConfigurationModelForResource({resource:i},o){let t=this.getWorkspaceConsolidatedConfiguration();if(o&&i){const n=o.getFolder(i);n&&(t=this.getFolderConsolidatedConfiguration(n.uri)||t);const s=this._memoryConfigurationByResource.get(i);s&&(t=t.merge(s))}return t}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let o=this._foldersConsolidatedConfigurations.get(i);if(!o){const t=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(i);n?(o=t.merge(n),this._freeze&&(o=o.freeze()),this._foldersConsolidatedConfigurations.set(i,o)):o=t}return o}getFolderConfigurationModelForResource(i,o){if(o&&i){const t=o.getFolder(i);if(t)return this._folderConfigurations.get(t.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,o)=>{const{contents:t,overrides:n,keys:s}=this._folderConfigurations.get(o);return i.push([o,{contents:t,overrides:n,keys:s}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(o=>i.add(o)),this.userConfiguration.freeze().keys.forEach(o=>i.add(o)),this._workspaceConfiguration.freeze().keys.forEach(o=>i.add(o)),this._folderConfigurations.forEach(o=>o.freeze().keys.forEach(t=>i.add(t))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>i.add(o)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>i.add(o)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>i.add(o)),this._folderConfigurations.forEach(o=>o.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const o=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(t=>o.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(t=>o.add(t)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(t=>o.add(t)),this._folderConfigurations.forEach(t=>t.getKeysForOverrideIdentifier(i).forEach(n=>o.add(n))),[...o.values()]}static parse(i){const o=this.parseConfigurationModel(i.defaults),t=this.parseConfigurationModel(i.policy),n=this.parseConfigurationModel(i.application),s=this.parseConfigurationModel(i.user),u=this.parseConfigurationModel(i.workspace),l=i.folders.reduce((m,y)=>(m.set(E.URI.revive(y[0]),this.parseConfigurationModel(y[1])),m),new T.ResourceMap);return new C(o,t,n,s,new v,u,l,new v,new T.ResourceMap,!1)}static parseConfigurationModel(i){return new v(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=C;function g(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const i=new Set,o=new Map;for(const n of c)n.keys.forEach(s=>i.add(s)),n.overrides.forEach(([s,u])=>{const l=(0,T.getOrSet)(o,s,new Set);u.forEach(m=>l.add(m))});const t=[];return o.forEach((n,s)=>t.push([s,[...n.values()]])),{keys:[...i.values()],overrides:t}}e.mergeChanges=g;class f{constructor(i,o,t,n){this.change=i,this.previous=o,this.currentConfiguraiton=t,this.currentWorkspace=n,this._previousConfiguration=void 0;const s=new Set;i.keys.forEach(l=>s.add(l)),i.overrides.forEach(([,l])=>l.forEach(m=>s.add(m))),this.affectedKeys=[...s.values()];const u=new v;this.affectedKeys.forEach(l=>u.setValue(l,{})),this.affectedKeysTree=u.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=C.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,o){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(o){const t=this.previousConfiguration?this.previousConfiguration.getValue(i,o,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(i,o,this.currentWorkspace);return!P.equals(t,n)}return!0}return!1}doesAffectedKeysTreeContains(i,o){let t=(0,I.toValuesTree)({[o]:!0},()=>{}),n;for(;typeof t=="object"&&(n=Object.keys(t)[0]);){if(i=i[n],!i)return!1;t=t[n]}return!0}}e.ConfigurationChangeEvent=f;function a(c,i){const{added:o,removed:t,updated:n}=d(i,c),s=[],u=c?.getAllOverrideIdentifiers()||[],l=i?.getAllOverrideIdentifiers()||[];if(i){const m=l.filter(y=>!u.includes(y));for(const y of m)s.push([y,i.getKeysForOverrideIdentifier(y)])}if(c){const m=u.filter(y=>!l.includes(y));for(const y of m)s.push([y,c.getKeysForOverrideIdentifier(y)])}if(i&&c){for(const m of u)if(l.includes(m)){const y=d({contents:c.getOverrideValue(void 0,m)||{},keys:c.getKeysForOverrideIdentifier(m)},{contents:i.getOverrideValue(void 0,m)||{},keys:i.getKeysForOverrideIdentifier(m)});s.push([m,[...y.added,...y.removed,...y.updated]])}}return{added:o,removed:t,updated:n,overrides:s}}function d(c,i){const o=c?i?c.keys.filter(s=>i.keys.indexOf(s)===-1):[...c.keys]:[],t=i?c?i.keys.filter(s=>c.keys.indexOf(s)===-1):[...i.keys]:[],n=[];if(c&&i){for(const s of i.keys)if(c.keys.indexOf(s)!==-1){const u=(0,I.getConfigurationValue)(i.contents,s),l=(0,I.getConfigurationValue)(c.contents,s);P.equals(u,l)||n.push(s)}}return{added:o,removed:t,updated:n}}}),define(ne[200],re([0,1,18,3,2,32,15,17,72,43,8,60,40]),function(Q,e,D,r,R,L,T,P,w,E,I,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class v extends R.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new r.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new h(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(p.Registry.as(E.Extensions.Configuration).onDidUpdateConfiguration(({properties:f,defaultsOverrides:a})=>this.onDidUpdateConfiguration(f,a))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(f,a){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:f})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=v;class h extends w.ConfigurationModel{constructor(f={}){const a=p.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),d=Object.keys(a),c=Object.create(null),i=[];for(const o in a){const t=f[o],n=t!==void 0?t:a[o].default;(0,P.addToValueTree)(c,o,n,s=>console.error(`Conflict in default settings: ${s}`))}for(const o of Object.keys(c))E.OVERRIDE_PROPERTY_REGEX.test(o)&&i.push({identifiers:(0,E.overrideIdentifiersFromKey)(o),keys:Object.keys(c[o]),contents:(0,P.toValuesTree)(c[o],t=>console.error(`Conflict in default settings file: ${t}`))});super(c,d,i)}}e.DefaultConfigurationModel=h;class S{constructor(){this.onDidChangeConfiguration=r.Event.None,this.configurationModel=new w.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=S;let C=class extends R.Disposable{get configurationModel(){return this._configurationModel}constructor(f,a,d){super(),this.defaultConfiguration=f,this.policyService=a,this.logService=d,this._onDidChangeConfiguration=this._register(new r.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new w.ConfigurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(f=>this.onDidChangePolicies(f))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:f})=>this.update(await this.registerPolicyDefinitions(f),!0))),this._configurationModel}async registerPolicyDefinitions(f){const a={},d=[],c=p.Registry.as(E.Extensions.Configuration).getConfigurationProperties();for(const i of f){const o=c[i];if(!o){d.push(i);continue}if(o.policy){if(o.type!=="string"&&o.type!=="number"){this.logService.warn(`Policy ${o.policy.name} has unsupported type ${o.type}`);continue}d.push(i),a[o.policy.name]={type:o.type}}}return(0,T.isEmptyObject)(a)||await this.policyService.registerPolicyDefinitions(a),d}onDidChangePolicies(f){const a=p.Registry.as(E.Extensions.Configuration).getPolicyConfigurations(),d=(0,D.coalesce)(f.map(c=>a.get(c)));this.update(d,!0)}update(f,a){const d=p.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),c=[],i=this._configurationModel.isEmpty();for(const o of f){const t=d[o]?.policy?.name;if(t){const n=this.policyService.getPolicyValue(t);(i?n!==void 0:!(0,L.equals)(this._configurationModel.getValue(o),n))&&c.push([o,n])}else this._configurationModel.getValue(o)!==void 0&&c.push([o,void 0])}if(c.length){const o=this._configurationModel;this._configurationModel=new w.ConfigurationModel;for(const t of o.keys)this._configurationModel.setValue(t,o.getValue(t));for(const[t,n]of c)n===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,n);a&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};C=pe([Y(1,b.IPolicyService),Y(2,I.ILogService)],C),e.PolicyConfiguration=C}),define(ne[201],re([0,1,6,3,2,19,17,72,200,60]),function(Q,e,D,r,R,L,T,P,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class I extends R.Disposable{constructor(p,v,h,S){super(),this.settingsResource=p,this._onDidChangeConfiguration=this._register(new r.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new w.DefaultConfiguration),this.policyConfiguration=h instanceof E.NullPolicyService?new w.NullPolicyConfiguration:this._register(new w.PolicyConfiguration(this.defaultConfiguration,h,S)),this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,L.extUriBiasedIgnorePathCase,v)),this.configuration=new P.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new P.ConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:C,properties:g})=>this.onDidDefaultConfigurationChange(C,g))),this._register(this.policyConfiguration.onDidChangeConfiguration(C=>this.onDidPolicyConfigurationChange(C))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[p,v,h]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new P.Configuration(p,v,new P.ConfigurationModel,h)}getConfigurationData(){return this.configuration.toData()}getValue(p,v){const h=typeof p=="string"?p:void 0,S=(0,T.isConfigurationOverrides)(p)?p:(0,T.isConfigurationOverrides)(v)?v:{};return this.configuration.getValue(h,S,void 0)}updateValue(p,v,h,S){return Promise.reject(new Error("not supported"))}inspect(p){return this.configuration.inspect(p,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const p=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(p)}onDidChangeUserConfiguration(p){const v=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(p);this.trigger(h,v,2)}onDidDefaultConfigurationChange(p,v){const h=this.configuration.toData(),S=this.configuration.compareAndUpdateDefaultConfiguration(p,v);this.trigger(S,h,7)}onDidPolicyConfigurationChange(p){const v=this.configuration.toData(),h=this.configuration.compareAndUpdatePolicyConfiguration(p);this.trigger(h,v,7)}trigger(p,v,h){const S=new P.ConfigurationChangeEvent(p,{data:v},this.configuration);S.source=h,S.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(S)}getTargetConfiguration(p){switch(p){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=I}),define(ne[202],re([0,1,9,5]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,r.createDecorator)("remoteAuthorityResolverService");var R;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends D.ErrorNoTelemetry{static isTemporarilyNotAvailable(P){return P instanceof L&&P._code===R.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof L&&P._code===R.NoResolverFound}static isHandled(P){return P instanceof L&&P.isHandled}constructor(P,w=R.Unknown,E){super(P),this._message=P,this._code=w,this._detail=E,this.isHandled=w===R.NotAvailable&&E===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,L.prototype)}}e.RemoteAuthorityResolverError=L}),define(ne[101],re([0,1,23]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function r(E){return E.scheme===D.Schemas.vscodeRemote?E.authority:void 0}e.getRemoteAuthority=r;function R(E){if(!E)return;const I=E.indexOf("+");return I<0?E:E.substr(0,I)}e.getRemoteName=R;function L(E){return`/${E.quality??"oss"}-${E.commit??"dev"}`}e.getRemoteServerRootPath=L;function T(E){const{host:I,port:b}=w(E);if(typeof b>"u")throw new Error("Remote authority doesn't contain a port!");return{host:I,port:b}}e.parseAuthorityWithPort=T;function P(E,I){let{host:b,port:p}=w(E);return typeof p>"u"&&(p=I),{host:b,port:p}}e.parseAuthorityWithOptionalPort=P;function w(E){const I=E.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(I)return{host:I[1],port:parseInt(I[2],10)};const b=E.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const p=E.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:E,port:void 0}}}),define(ne[44],re([0,1,27,5,101]),function(Q,e,D,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.getWorkspaceSupportTypeMessage=L;function T(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var w;(function(h){h.WIN32_X64="win32-x64",h.WIN32_IA32="win32-ia32",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(w=e.TargetPlatform||(e.TargetPlatform={}));class E{constructor(S){this.value=S,this._lower=S.toLowerCase()}static equals(S,C){if(typeof S>"u"||S===null)return typeof C>"u"||C===null;if(typeof C>"u"||C===null)return!1;if(typeof S=="string"||typeof C=="string"){const g=typeof S=="string"?S:S.value,f=typeof C=="string"?C:C.value;return D.equalsIgnoreCase(g,f)}return S._lower===C._lower}static toKey(S){return typeof S=="string"?S.toLowerCase():S._lower}}e.ExtensionIdentifier=E;function I(h){return b(h)}e.isApplicationScopedExtension=I;function b(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function p(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=p;function v(h,S){if(S){const C=`onResolveRemoteAuthority:${(0,R.getRemoteName)(S)}`;return h.activationEvents?.indexOf(C)!==-1}return!1}e.isResolverExtension=v,e.IBuiltinExtensionsScannerService=(0,r.createDecorator)("IBuiltinExtensionsScannerService")}),define(ne[33],re([0,1,27,29,44,4,7,9,37]),function(Q,e,D,r,R,L,T,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function E(o,t){return o.uuid&&t.uuid?o.uuid===t.uuid:o.id===t.id?!0:(0,D.compareIgnoreCase)(o.id,t.id)===0}e.areSameExtensions=E;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(t){const n=t.manifest?t.manifest.version:t.version,s=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new b(t.identifier,n,s)}static parse(t){const n=I.exec(t);return n&&n[1]&&n[2]?new b({id:n[1]},n[2],n[4]||void 0):null}constructor(t,n,s="undefined"){this.version=n,this.targetPlatform=s,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof b?E(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.ExtensionKey=b;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(o){const t=p.exec(o);return t&&t[1]?[S(t[1]),t[2]]:[S(o),void 0]}e.getIdAndVersion=v;function h(o,t){return`${o}.${t}`}e.getExtensionId=h;function S(o){return o.toLocaleLowerCase()}e.adoptToGalleryExtensionId=S;function C(o,t){return S(h(o,t))}e.getGalleryExtensionId=C;function g(o,t){const n=[],s=u=>{for(const l of n)if(l.some(m=>E(t(m),t(u))))return l;return null};for(const u of o){const l=s(u);l?l.push(u):n.push([u])}return n}e.groupByExtension=g;function f(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=f;function a(o){return{id:o.identifier.id,name:o.name,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),...o.telemetryData}}e.getGalleryExtensionTelemetryData=a,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function d(o,t){const n=[],s=t.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const u=s.shift();if(u&&n.every(l=>!E(l.identifier,{id:u}))){const l=o.filter(m=>E(m.identifier,{id:u}));l.length===1&&(n.push(l[0]),s.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.getExtensionDependencies=d;async function c(o,t){if(!L.isLinux)return!1;let n;try{n=(await o.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await o.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(u){t.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(u))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=c;async function i(o,t){const n=await c(o,t),s=(0,r.getTargetPlatform)(n?"alpine":L.platform,w.arch);return t.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=i}),define(ne[49],re([0,1,6,16,2,34,7,33,13,5,8]),function(Q,e,D,r,R,L,T,P,w,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,E.createDecorator)("IExtensionsProfileScannerService");let b=class extends R.Disposable{constructor(v,h){super(),this.fileService=v,this.logService=h,this.resourcesAccessQueueMap=new L.ResourceMap}scanProfileExtensions(v){return this.withProfileExtensions(v)}addExtensionsToProfile(v,h){return this.withProfileExtensions(h,S=>(S=S.filter(C=>v.some(([g])=>!(0,P.areSameExtensions)(C.identifier,g.identifier))),S.push(...v.map(([C,g])=>({identifier:C.identifier,version:C.manifest.version,location:C.location,metadata:g}))),S))}removeExtensionFromProfile(v,h){return this.withProfileExtensions(h,S=>S.filter(C=>!(0,P.areSameExtensions)(C.identifier,v)))}async withProfileExtensions(v,h){return this.getResourceAccessQueue(v).queue(async()=>{let S=[];try{const C=await this.fileService.readFile(v),g=JSON.parse(C.value.toString());for(const f of g){if(!f.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",f);continue}if(!f.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",f);continue}if(!f.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",f);continue}S.push({identifier:f.identifier,location:T.URI.revive(f.location),version:f.version,metadata:f.metadata})}}catch(C){C.fileOperationResult!==1&&this.logService.error(C)}if(h){S=h(S);const C=S.map(g=>({identifier:g.identifier,version:g.version,location:g.location.toJSON(),metadata:g.metadata}));await this.fileService.writeFile(v,r.VSBuffer.fromString(JSON.stringify(C)))}return S})}getResourceAccessQueue(v){let h=this.resourcesAccessQueueMap.get(v);return h||(h=new D.Queue,this.resourcesAccessQueueMap.set(v,h)),h}};b=pe([Y(0,w.IFileService),Y(1,I.ILogService)],b),e.ExtensionsProfileScannerService=b}),define(ne[203],re([0,1,22,33]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function R(L,T,P,w,E){try{const I=await L.getExtensionsControlManifest();if(!I.deprecated)return;const b=await L.getInstalled(1);for(const[p,v]of Object.entries(I.deprecated)){if(!v?.extension)continue;const{id:h,autoMigrate:S,preRelease:C}=v.extension;if(!S)continue;const g=b.find(a=>(0,r.areSameExtensions)(a.identifier,{id:p}));if(!g)continue;const f=(await T.getExtensions([{id:h,preRelease:C}],{targetPlatform:await L.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0];if(!f){E.info(`Skipping migrating '${g.identifier.id}' extension because, the comaptible target '${h}' extension is not found`);continue}try{E.info(`Migrating '${g.identifier.id}' extension to '${h}' extension...`);const a=!w.getDisabledExtensions().some(c=>(0,r.areSameExtensions)(c,g.identifier));await L.uninstall(g),E.info(`Uninstalled the unsupported extension '${g.identifier.id}'`);let d=b.find(c=>(0,r.areSameExtensions)(c.identifier,{id:h}));(!d||!d.isPreReleaseVersion&&a)&&(d=await L.installFromGallery(f,{installPreReleaseVersion:!0,isMachineScoped:g.isMachineScoped,operation:4}),E.info(`Installed the pre-release extension '${d.identifier.id}'`),a||(await w.disableExtension(d.identifier),E.info(`Disabled the pre-release extension '${d.identifier.id}' because the unsupported extension '${g.identifier.id}' is disabled`)),S.storage&&(P.addToMigrationList((0,r.getExtensionId)(g.manifest.publisher,g.manifest.name),(0,r.getExtensionId)(d.manifest.publisher,d.manifest.name)),E.info("Added pre-release extension to the storage migration list"))),E.info(`Migrated '${g.identifier.id}' extension to '${h}' extension.`)}catch(a){E.error(a)}}}catch(I){E.error(I)}}e.migrateUnsupportedExtensions=R}),define(ne[204],re([0,1,6,9,2,4,19,55,7,30,28,14,29,33,13,8]),function(Q,e,D,r,R,L,T,P,w,E,I,b,p,v,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let C=class extends R.Disposable{constructor(f,a,d,c){super(),this.fileService=a,this.extensionGalleryService=d,this.logService=c,this.extensionsDownloadDir=w.URI.file(f.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(f,a){await this.cleanUpPromise;const d=this.getName(f),c=(0,T.joinPath)(this.extensionsDownloadDir,d);if(!await this.fileService.exists(c)){const i=(0,T.joinPath)(this.extensionsDownloadDir,`.${(0,E.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(f,i,a);try{await this.rename(i,c,Date.now()+2*60*1e3)}catch(o){try{await this.fileService.del(i)}catch{}if(o.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",f.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,r.getErrorMessage)(o)}. Deleted the vsix from downloaded location`,i.path),o}}return c}async delete(f){await this.cleanUpPromise,await this.fileService.del(f)}async rename(f,a,d){try{await I.Promises.rename(f.fsPath,a.fsPath)}catch(c){if(L.isWindows&&c&&c.code==="EPERM"&&Date.now()<d)return this.logService.info(`Failed renaming ${f} to ${a} with 'EPERM' error. Trying again...`),this.rename(f,a,d);throw c}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const f=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(f.children){const a=[],d=[];for(const o of f.children){const t=v.ExtensionKey.parse(o.name);t&&d.push([t,o])}const c=(0,v.groupByExtension)(d,([o])=>o),i=[];for(const o of c)o.sort((t,n)=>P.rcompare(t[0].version,n[0].version)),a.push(...o.slice(1).map(t=>t[1].resource)),i.push(o[0][1]);i.sort((o,t)=>o.mtime-t.mtime),a.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(o=>o.resource)),await D.Promises.settled(a.map(o=>(this.logService.trace("Deleting vsix from cache",o.path),this.fileService.del(o))))}}catch(f){this.logService.error(f)}}getName(f){return this.cache?v.ExtensionKey.create(f).toString().toLowerCase():(0,E.generateUuid)()}};C=pe([Y(0,b.INativeEnvironmentService),Y(1,h.IFileService),Y(2,p.IExtensionGalleryService),Y(3,S.ILogService)],C),e.ExtensionsDownloader=C}),define(ne[205],re([0,1,2,12,28,44]),function(Q,e,D,r,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class T extends D.Disposable{constructor(w,E){super(),this.environmentService=w,this.extensionsManifestCache=(0,r.join)(this.environmentService.userDataPath,L.MANIFEST_CACHE_FOLDER,L.USER_MANIFEST_CACHE_FILE),this._register(E.onDidInstallExtensions(I=>this.onDidInstallExtensions(I))),this._register(E.onDidUninstallExtension(I=>this.onDidUnInstallExtension(I)))}onDidInstallExtensions(w){w.some(E=>!!E.local)&&this.invalidate()}onDidUnInstallExtension(w){w.error||this.invalidate()}invalidate(){R.Promises.rm(this.extensionsManifestCache,R.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=T}),define(ne[206],re([0,1,96,18,6,2,23,12,28,14,29,33,8,71]),function(Q,e,D,r,R,L,T,P,w,E,I,b,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let h=class extends v.LanguagePackBaseService{constructor(f,a,d,c){super(d),this.extensionManagementService=f,this.logService=c,this.cache=this._register(new S(a,c)),this.extensionManagementService.registerParticipant({postInstall:async i=>this.postInstallExtension(i),postUninstall:async i=>this.postUninstallExtension(i)})}async getInstalledLanguages(){const f=await this.cache.getLanguagePacks(),a=Object.keys(f).map(d=>{const c=f[d];return{...this.createQuickPickItem(d,c.label),extensionId:c.extensions[0].extensionIdentifier.id}});return a.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),a.sort((d,c)=>d.label.localeCompare(c.label)),a}async postInstallExtension(f){f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",f.identifier.id),await this.update())}async postUninstallExtension(f){const a=await this.cache.getLanguagePacks();Object.keys(a).some(d=>a[d]&&a[d].extensions.some(c=>(0,b.areSameExtensions)(c.extensionIdentifier,f.identifier)))&&(this.logService.info("Removing language packs from the extension",f.identifier.id),await this.update())}async update(){const[f,a]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),d=await this.cache.update(a);return!(0,r.equals)(Object.keys(f),Object.keys(d))}};h=pe([Y(0,I.IExtensionManagementService),Y(1,E.INativeEnvironmentService),Y(2,I.IExtensionGalleryService),Y(3,p.ILogService)],h),e.NativeLanguagePackService=h;let S=class extends L.Disposable{constructor(f,a){super(),this.logService=a,this.languagePacks={},this.languagePacksFilePath=(0,P.join)(f.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new R.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(f){return this.withLanguagePacks(a=>{Object.keys(a).forEach(d=>delete a[d]),this.createLanguagePacksFromExtensions(a,...f)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(f,...a){for(const d of a)d&&d.manifest&&d.manifest.contributes&&d.manifest.contributes.localizations&&d.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(f,d);Object.keys(f).forEach(d=>this.updateHash(f[d]))}createLanguagePacksFromExtension(f,a){const d=a.identifier,c=a.manifest.contributes&&a.manifest.contributes.localizations?a.manifest.contributes.localizations:[];for(const i of c)if(a.location.scheme===T.Schemas.file&&C(i)){let o=f[i.languageId];o||(o={hash:"",extensions:[],translations:{},label:i.localizedLanguageName??i.languageName},f[i.languageId]=o);const t=o.extensions.filter(n=>(0,b.areSameExtensions)(n.extensionIdentifier,d))[0];t?t.version=a.manifest.version:o.extensions.push({extensionIdentifier:d,version:a.manifest.version});for(const n of i.translations)o.translations[n.id]=(0,P.join)(a.location.fsPath,n.path)}}updateHash(f){if(f){const a=(0,D.createHash)("md5");for(const d of f.extensions)a.update(d.extensionIdentifier.uuid||d.extensionIdentifier.id).update(d.version);f.hash=a.digest("hex")}}withLanguagePacks(f=()=>null){return this.languagePacksFileLimiter.queue(()=>{let a=null;return w.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,d=>d.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(d)).then(d=>{try{return JSON.parse(d)}catch{return{}}}).then(d=>(a=f(d),d)).then(d=>{for(const i of Object.keys(d))d[i]||delete d[i];this.languagePacks=d,this.initializedCache=!0;const c=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",c),w.Promises.writeFile(this.languagePacksFilePath,c)}).then(()=>a,d=>this.logService.error(d))})}};S=pe([Y(0,E.INativeEnvironmentService),Y(1,p.ILogService)],S);function C(g){if(typeof g.languageId!="string"||!Array.isArray(g.translations)||g.translations.length===0)return!1;for(const f of g.translations)if(typeof f.id!="string"||typeof f.path!="string")return!1;return!(g.languageName&&typeof g.languageName!="string"||g.localizedLanguageName&&typeof g.localizedLanguageName!="string")}}),define(ne[207],re([0,1,6,16,22,9,3,2,30,89,202,101]),function(Q,e,D,r,R,L,T,P,w,E,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const p=30*1e3;var v;(function(B){B[B.Management=1]="Management",B[B.ExtensionHost=2]="ExtensionHost",B[B.Tunnel=3]="Tunnel"})(v=e.ConnectionType||(e.ConnectionType={}));function h(B){switch(B){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function S(B){const G=new R.CancellationTokenSource;return setTimeout(()=>G.cancel(),B),G.token}function C(B,G){if(B.isCancellationRequested||G.isCancellationRequested)return R.CancellationToken.Cancelled;const O=new R.CancellationTokenSource;return B.onCancellationRequested(()=>O.cancel()),G.onCancellationRequested(()=>O.cancel()),O.token}class g{get didTimeout(){return this._state==="timedout"}constructor(G){this._state="pending",this._disposables=new P.DisposableStore,this.promise=new Promise((O,M)=>{this._resolvePromise=O,this._rejectPromise=M}),G.isCancellationRequested?this._timeout():this._disposables.add(G.onCancellationRequested(()=>this._timeout()))}registerDisposable(G){this._state==="pending"?this._disposables.add(G):G.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const G=new Error("Time limit reached");return G.code="ETIMEDOUT",G.syscall="connect",G}resolve(G){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(G))}reject(G){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(G))}}function f(B,G){const O=new g(G);return O.registerDisposable(B.onControlMessage(M=>{const x=JSON.parse(M.toString()),V=W(x);V?O.reject(V):O.resolve(x)})),O.promise}function a(B,G,O,M,x,V,ee,oe){const Z=new g(oe);return G.connect(O,M,x,V,ee,(ie,se)=>{Z.didTimeout?(ie&&B.error(ie),se?.dispose()):ie||!se?Z.reject(ie):Z.resolve(se)}),Z.promise}function d(B,G){const O=new g(G);return B.then(M=>{O.didTimeout||O.resolve(M)},M=>{O.didTimeout||O.reject(M)}),O.promise}async function c(B,G,O,M){const x=X(B,G);B.logService.trace(`${x} 1/6. invoking socketFactory.connect().`);let V;try{V=await a(B.logService,B.socketFactory,B.host,B.port,(0,b.getRemoteServerRootPath)(B),`reconnectionToken=${B.reconnectionToken}&reconnection=${B.reconnectionProtocol?"true":"false"}`,`renderer-${h(G)}-${B.reconnectionToken}`,M)}catch(se){throw B.logService.error(`${x} socketFactory.connect() failed or timed out. Error:`),B.logService.error(se),se}B.logService.trace(`${x} 2/6. socketFactory.connect() was successful.`);let ee,oe;B.reconnectionProtocol?(B.reconnectionProtocol.beginAcceptReconnection(V,null),ee=B.reconnectionProtocol,oe=!1):(ee=new E.PersistentProtocol(V,null),oe=!0),B.logService.trace(`${x} 3/6. sending AuthRequest control message.`);const Z=await d(B.signService.createNewMessage((0,w.generateUuid)()),M),ie={type:"auth",auth:B.connectionToken||"00000000000000000000",data:Z.data};ee.sendControl(r.VSBuffer.fromString(JSON.stringify(ie)));try{const se=await f(ee,C(M,S(1e4)));if(se.type!=="sign"||typeof se.data!="string"){const we=new Error("Unexpected handshake message");throw we.code="VSCODE_CONNECTION_ERROR",we}if(B.logService.trace(`${x} 4/6. received SignRequest control message.`),!await d(B.signService.validate(Z,se.signedData),M)){const we=new Error("Refused to connect to unsupported server");throw we.code="VSCODE_CONNECTION_ERROR",we}const de=await d(B.signService.sign(se.data),M),ve={type:"connectionType",commit:B.commit,signedData:de,desiredConnectionType:G};return O&&(ve.args=O),B.logService.trace(`${x} 5/6. sending ConnectionTypeRequest control message.`),ee.sendControl(r.VSBuffer.fromString(JSON.stringify(ve))),{protocol:ee,ownsProtocol:oe}}catch(se){throw se&&se.code==="ETIMEDOUT"&&(B.logService.error(`${x} the handshake timed out. Error:`),B.logService.error(se)),se&&se.code==="VSCODE_CONNECTION_ERROR"&&(B.logService.error(`${x} received error control message when negotiating connection. Error:`),B.logService.error(se)),oe&&H(ee),se}}async function i(B,G,O,M){const x=Date.now(),V=X(B,G),{protocol:ee,ownsProtocol:oe}=await c(B,G,O,M),Z=new g(M);return Z.registerDisposable(ee.onControlMessage(ie=>{const se=JSON.parse(ie.toString()),ue=W(se);ue?(B.logService.error(`${V} received error control message when negotiating connection. Error:`),B.logService.error(ue),oe&&H(ee),Z.reject(ue)):(B.reconnectionProtocol?.endAcceptReconnection(),B.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${ce(x)}!`),Z.resolve({protocol:ee,firstMessage:se}))})),Z.promise}async function o(B,G){const{protocol:O}=await i(B,1,void 0,G);return{protocol:O}}async function t(B,G,O){const{protocol:M,firstMessage:x}=await i(B,2,G,O),V=x&&x.debugPort;return{protocol:M,debugPort:V}}async function n(B,G,O){const M=Date.now(),x=X(B,3),{protocol:V}=await c(B,3,G,O);return B.logService.trace(`${x} 6/6. handshake finished, connection is up and running after ${ce(M)}!`),V}async function s(B,G,O){const{host:M,port:x,connectionToken:V}=await B.addressProvider.getAddress();return{commit:B.commit,quality:B.quality,host:M,port:x,connectionToken:V,reconnectionToken:G,reconnectionProtocol:O,socketFactory:B.socketFactory,signService:B.signService,logService:B.logService}}async function u(B,G,O){return m(B,async M=>{const{protocol:x}=await o(M,R.CancellationToken.None);return new J(B,G,O,M.reconnectionToken,x)})}e.connectRemoteAgentManagement=u;async function l(B,G){return m(B,async O=>{const{protocol:M,debugPort:x}=await t(O,G,R.CancellationToken.None);return new j(B,G,O.reconnectionToken,M,x)})}e.connectRemoteAgentExtensionHost=l;async function m(B,G){for(let M=1;;M++)try{const x=(0,w.generateUuid)(),V=await s(B,x,null);return await G(V)}catch(x){if(M<5)B.logService.error(`[remote-connection][attempt ${M}] An error occurred in initial connection! Will retry... Error:`),B.logService.error(x);else throw B.logService.error(`[remote-connection][attempt ${M}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),B.logService.error(x),q.triggerPermanentFailure(0,0,I.RemoteAuthorityResolverError.isHandled(x)),x}}async function y(B,G,O){const M=await s(B,(0,w.generateUuid)(),null);return await n(M,{host:G,port:O},R.CancellationToken.None)}e.connectRemoteAgentTunnel=y;function _(B){return(0,D.createCancelablePromise)(G=>new Promise((O,M)=>{const x=setTimeout(O,B*1e3);G.onCancellationRequested(()=>{clearTimeout(x),O()})}))}var $;(function(B){B[B.ConnectionLost=0]="ConnectionLost",B[B.ReconnectionWait=1]="ReconnectionWait",B[B.ReconnectionRunning=2]="ReconnectionRunning",B[B.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",B[B.ConnectionGain=4]="ConnectionGain"})($=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class A{constructor(G,O){this.reconnectionToken=G,this.millisSinceLastIncomingData=O,this.type=0}}e.ConnectionLostEvent=A;class U{constructor(G,O,M,x){this.reconnectionToken=G,this.millisSinceLastIncomingData=O,this.durationSeconds=M,this.cancellableTimer=x,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=U;class k{constructor(G,O,M){this.reconnectionToken=G,this.millisSinceLastIncomingData=O,this.attempt=M,this.type=2}}e.ReconnectionRunningEvent=k;class N{constructor(G,O,M){this.reconnectionToken=G,this.millisSinceLastIncomingData=O,this.attempt=M,this.type=4}}e.ConnectionGainEvent=N;class F{constructor(G,O,M,x){this.reconnectionToken=G,this.millisSinceLastIncomingData=O,this.attempt=M,this.handled=x,this.type=3}}e.ReconnectionPermanentFailureEvent=F;class q extends P.Disposable{static triggerPermanentFailure(G,O,M){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=G,this._permanentFailureAttempt=O,this._permanentFailureHandled=M,this._instances.forEach(x=>x._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(G=>G._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(G=>G._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||q._permanentFailure}constructor(G,O,M,x,V){super(),this._connectionType=G,this._options=O,this.reconnectionToken=M,this.protocol=x,this._reconnectionFailureIsFatal=V,this._onDidStateChange=this._register(new T.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new N(this.reconnectionToken,0,0)),this._register(x.onSocketClose(ee=>{const oe=K(this._connectionType,this.reconnectionToken,!0);ee?ee.type===0?(this._options.logService.info(`${oe} received socket close event (hadError: ${ee.hadError}).`),ee.error&&this._options.logService.error(ee.error)):(this._options.logService.info(`${oe} received socket close event (wasClean: ${ee.wasClean}, code: ${ee.code}, reason: ${ee.reason}).`),ee.event&&this._options.logService.error(ee.event)):this._options.logService.info(`${oe} received socket close event.`),this._beginReconnecting()})),this._register(x.onSocketTimeout(ee=>{const oe=K(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${oe} received socket timeout event (unacknowledgedMsgCount: ${ee.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ee.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ee.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),q._instances.push(this),this._register((0,P.toDisposable)(()=>{const ee=q._instances.indexOf(this);ee>=0&&q._instances.splice(ee,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(q._permanentFailureMillisSinceLastIncomingData,q._permanentFailureAttempt,q._permanentFailureHandled)}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const G=K(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${G} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new A(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const O=[0,5,5,10,10,10,10,10,30];let M=-1;do{M++;const x=M<O.length?O[M]:O[O.length-1];try{if(x>0){const ee=_(x);this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),x,ee)),this._options.logService.info(`${G} waiting for ${x} seconds before reconnecting...`);try{await ee}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${G} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new k(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),M+1)),this._options.logService.info(`${G} resolving connection...`);const V=await s(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${G} connecting to ${V.host}:${V.port}...`),await this._reconnect(V,S(p)),this._options.logService.info(`${G} reconnected!`),this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),M+1));break}catch(V){if(V.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${G} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}if(M>360){this._options.logService.error(`${G} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}if(I.RemoteAuthorityResolverError.isTemporarilyNotAvailable(V)){this._options.logService.info(`${G} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((V.code==="ETIMEDOUT"||V.code==="ENETUNREACH"||V.code==="ECONNREFUSED"||V.code==="ECONNRESET")&&V.syscall==="connect"){this._options.logService.info(`${G} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((0,L.isCancellationError)(V)){this._options.logService.info(`${G} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if(V instanceof I.RemoteAuthorityResolverError){this._options.logService.error(`${G} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),M+1,I.RemoteAuthorityResolverError.isHandled(V));break}this._options.logService.error(`${G} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(G,O,M){this._reconnectionFailureIsFatal?q.triggerPermanentFailure(G,O,M):this._gotoPermanentFailure(G,O,M)}_gotoPermanentFailure(G,O,M){this._onDidStateChange.fire(new F(this.reconnectionToken,G,O,M)),H(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=q,q._permanentFailure=!1,q._permanentFailureMillisSinceLastIncomingData=0,q._permanentFailureAttempt=0,q._permanentFailureHandled=!1,q._instances=[];class J extends q{constructor(G,O,M,x,V){super(1,G,x,V,!0),this.client=this._register(new E.Client(V,{remoteAuthority:O,clientId:M},G.ipcLogger))}async _reconnect(G,O){await o(G,O)}}e.ManagementPersistentConnection=J;class j extends q{constructor(G,O,M,x,V){super(2,G,M,x,!1),this._startArguments=O,this.debugPort=V}async _reconnect(G,O){await t(G,this._startArguments,O)}}e.ExtensionHostPersistentConnection=j;function H(B){try{B.acceptDisconnect();const G=B.getSocket();B.dispose(),G.dispose()}catch(G){(0,L.onUnexpectedError)(G)}}function W(B){if(B&&B.type==="error"){const G=new Error(`Connection error: ${B.reason}`);return G.code="VSCODE_CONNECTION_ERROR",G}return null}function z(B,G){for(;B.length<G;)B+=" ";return B}function K(B,G,O){return`[remote-connection][${z(h(B),13)}][${G.substr(0,5)}\u2026][${O?"reconnect":"initial"}]`}function X(B,G){return`${K(G,B.reconnectionToken,!!B.reconnectionProtocol)}[${B.host}:${B.port}]`}function ce(B){return`${Date.now()-B} ms`}}),define(ne[208],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,D.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(ne[209],re([0,1,81,139]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(R,L,T,P,w,E){const I=p=>E(p,void 0),b=D.createConnection({host:R,port:L},()=>{b.removeListener("error",I);const p=Buffer.alloc(16);for(let C=0;C<16;C++)p[C]=Math.round(Math.random()*256);const v=p.toString("base64"),h=[`GET ws://${/:/.test(R)?`[${R}]`:R}:${L}${T}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${v}`];b.write(h.join(`\r
`)+`\r
\r
`);const S=C=>{C.toString().indexOf(`\r
\r
`)>=0&&(b.off("data",S),E(void 0,new r.NodeSocket(b,w)))};b.on("data",S)});b.setNoDelay(!0),b.once("error",I)}}}),define(ne[210],re([0,1,122,17,8]),function(Q,e,D,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let L=class{constructor(P,w){this.configurationService=P,this.logService=w}async request(P,w){this.logService.trace("RequestService#request (browser) - begin",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization"));try{const E=await(0,D.request)(P,w);return this.logService.trace("RequestService#request (browser) - success",P.url),E}catch(E){throw this.logService.error("RequestService#request (browser) - error",P.url,E),E}}async resolveProxy(P){}};L=pe([Y(0,r.IConfigurationService),Y(1,R.ILogService)],L),e.RequestService=L}),define(ne[45],re([0,1,16,157,43,5,40]),function(Q,e,D,r,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,L.createDecorator)("requestService");function P(S){return S.res.statusCode&&S.res.statusCode>=200&&S.res.statusCode<300||S.res.statusCode===1223}e.isSuccess=P;function w(S){return S.res.statusCode===204}async function E(S){return w(S)?null:(await(0,D.streamToBuffer)(S.stream)).toString()}e.asText=E;async function I(S){if(!P(S))throw new Error("Server returned "+S.res.statusCode);return E(S)}e.asTextOrError=I;async function b(S){if(!P(S))throw new Error("Server returned "+S.res.statusCode);if(w(S))return null;const g=(await(0,D.streamToBuffer)(S.stream)).toString();try{return JSON.parse(g)}catch(f){throw f.message+=`:
`+g,f}}e.asJson=b;function p(S){h(S)}e.updateProxyConfigurationsScope=p;let v;function h(S){const C=T.Registry.as(R.Extensions.Configuration),g=v;v={id:"http",order:15,title:(0,r.localize)(0,null),type:"object",scope:S,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,r.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,r.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,r.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,r.localize)(4,null),(0,r.localize)(5,null),(0,r.localize)(6,null),(0,r.localize)(7,null)],default:"override",description:(0,r.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,r.localize)(9,null),restricted:!0}}},C.updateConfigurations({add:[v],remove:g?[g]:[]})}h(2)}),define(ne[211],re([0,1,22,23,13,45]),function(Q,e,D,r,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let T=class{constructor(w,E){this.requestService=w,this.fileService=E}async download(w,E,I=D.CancellationToken.None){if(w.scheme===r.Schemas.file||w.scheme===r.Schemas.vscodeRemote){await this.fileService.copy(w,E);return}const b={type:"GET",url:w.toString(!0)},p=await this.requestService.request(b,I);if(p.res.statusCode===200)await this.fileService.writeFile(E,p.stream);else{const v=await(0,L.asTextOrError)(p);throw new Error(`Expected 200, got back ${p.res.statusCode} instead.

${v}`)}}};T=pe([Y(0,L.IRequestService),Y(1,R.IFileService)],T),e.DownloadService=T}),define(ne[212],re([0,1,18,22,2,19,174,13,8,25,45]),function(Q,e,D,r,R,L,T,P,w,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let b=class extends R.Disposable{constructor(v,h,S,C){super(),this.fileService=v,this.productService=h,this.requestService=S,this.logService=C,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&Object.entries(this.productService.configBasedExtensionTips).forEach(([,g])=>this.allConfigBasedTips.set(g.configPath,g))}getConfigBasedTips(v){return this.getValidConfigBasedTips(v)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(v){const h=[];for(const[S,C]of this.allConfigBasedTips)if(!(C.configScheme&&C.configScheme!==v.scheme))try{const g=await this.fileService.readFile((0,L.joinPath)(v,S)),f=new Map;Object.entries(C.recommendations).forEach(([d,c])=>{if((0,D.isNonEmptyArray)(c.remotes))for(const i of c.remotes)f.set(i,{extensionId:d,extensionName:c.name,configName:C.configName,important:!!c.important,isExtensionPack:!!c.isExtensionPack,whenNotInstalled:c.whenNotInstalled});else h.push({extensionId:d,extensionName:c.name,configName:C.configName,important:!!c.important,isExtensionPack:!!c.isExtensionPack,whenNotInstalled:c.whenNotInstalled})});const a=(0,T.getDomainsOfRemotes)(g.value.toString(),[...f.keys()]);for(const d of a){const c=f.get(d);c&&h.push(c)}}catch{}return h}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const v=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},r.CancellationToken.None);if(v.res.statusCode!==200)return[];const h=await(0,I.asJson)(v);return h?h.workspaceRecommendations||[]:[]}catch(v){return this.logService.error(v),[]}}};b=pe([Y(0,P.IFileService),Y(1,E.IProductService),Y(2,I.IRequestService),Y(3,w.ILogService)],b),e.ExtensionTipsService=b}),define(ne[213],re([0,1,16,22]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class R{constructor(P){this.service=P}listen(P,w){throw new Error("Invalid listen")}call(P,w,E,I=r.CancellationToken.None){switch(w){case"request":return this.service.request(E[0],I).then(async({res:b,stream:p})=>{const v=await(0,D.streamToBuffer)(p);return[{statusCode:b.statusCode,headers:b.headers},v]});case"resolveProxy":return this.service.resolveProxy(E[0])}throw new Error("Invalid call")}}e.RequestChannel=R;class L{constructor(P){this.channel=P}async request(P,w){const[E,I]=await this.channel.call("request",[P],w);return{res:E,stream:(0,D.bufferToStream)(I)}}async resolveProxy(P){return this.channel.call("resolveProxy",[P])}}e.RequestChannelClient=L}),define(ne[214],re([0,1,210,213]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRequestService=void 0;class R{constructor(T,P,w){this.configurationService=P,this.logService=w,this.browserRequestService=new D.RequestService(P,w),this.mainRequestService=new r.RequestChannelClient(T.getChannel("request"))}request(T,P){return this.getRequestService().request(T,P)}async resolveProxy(T){return this.getRequestService().resolveProxy(T)}getRequestService(){return this.configurationService.getValue("developer.sharedProcess.redirectRequestsToMain")===!0?(this.logService.trace("Using main request service"),this.mainRequestService):(this.logService.trace("Using browser request service"),this.browserRequestService)}}e.SharedProcessRequestService=R}),define(ne[102],re([0,1,65,5]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function R(L){return(0,D.hash)({moduleId:L.process.moduleId,windowId:L.reply.windowId})}e.hash=R,e.ISharedProcessWorkerService=(0,r.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(ne[215],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var D;(function(r){r.Spawn="vscode:shared-process->shared-process-worker=spawn",r.Terminate="vscode:shared-process->shared-process-worker=terminate",r.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",r.Ready="vscode:shared-process-worker->shared-process=ready",r.Ack="vscode:shared-process-worker->shared-process=ack",r.Trace="vscode:shared-process-worker->shared-process=trace",r.Info="vscode:shared-process-worker->shared-process=info",r.Warn="vscode:shared-process-worker->shared-process=warn",r.Error="vscode:shared-process-worker->shared-process=error"})(D=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(ne[216],re([0,1,90,6,22,3,2,23,30,8,102,215]),function(Q,e,D,r,R,L,T,P,w,E,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let p=class{constructor(S){this.logService=S,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(S){const C=`window: ${S.reply.windowId}, moduleId: ${S.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${C})`);const g=(0,I.hash)(S);this.processeDisposables.has(g)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${C})`),this.doDisposeWorker(S));const f=new R.CancellationTokenSource;let a,d,c;this.processeDisposables.set(g,n=>{f.dispose(!0),a?.terminate(S,R.CancellationToken.None),d?.close(),c?.close(),this.processeDisposables.delete(g);const s=this.processResolvers.get(g);s&&(this.processResolvers.delete(g),s({reason:n}))}),a=await this.getOrCreateWebWorker(S);const i=new Promise(n=>{this.processResolvers.set(g,n)});if(f.token.isCancellationRequested)return i;const{port1:o,port2:t}=new MessageChannel;return d=o,c=t,await a.spawn(S,c,f.token),f.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${C})`),D.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",S,[d])),i}getOrCreateWebWorker(S){let C=this.workers.get(S.process.moduleId);if(!C){this.logService.trace(`SharedProcess: creating new web worker (${S.process.moduleId})`);const g=new v(S.process.type,this.logService);C=g.init(),g.onDidProcessSelfTerminate(({configuration:f,reason:a})=>{this.doDisposeWorker(f,a)}),this.workers.set(S.process.moduleId,C)}return C}async disposeWorker(S){return this.doDisposeWorker(S)}doDisposeWorker(S,C){const g=this.processeDisposables.get((0,I.hash)(S));g&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${S.reply.windowId}, moduleId: ${S.process.moduleId})`),g(C))}};p=pe([Y(0,E.ILogService)],p),e.SharedProcessWorkerService=p;class v extends T.Disposable{constructor(S,C){super(),this.type=S,this.logService=C,this._onDidProcessSelfTerminate=this._register(new L.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const S=new r.DeferredPromise,C=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return C.onerror=g=>{this.logService.error(`SharedProcess: worker error (${this.type})`,g.message)},C.onmessageerror=g=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,g)},C.onmessage=g=>{const{id:f,message:a,configuration:d,nonce:c}=g.data;switch(f){case b.SharedProcessWorkerMessages.Ready:S.complete(C);break;case b.SharedProcessWorkerMessages.Ack:if(c){const i=this.mapMessageNonceToPendingMessageResolve.get(c);i&&(this.mapMessageNonceToPendingMessageResolve.delete(c),i())}break;case b.SharedProcessWorkerMessages.SelfTerminated:d&&a&&this._onDidProcessSelfTerminate.fire({configuration:d,reason:JSON.parse(a)});break;case b.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,a);break;case b.SharedProcessWorkerMessages.Info:a&&this.logService.info(a);break;case b.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,a);break;case b.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,a);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,g)}},C.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),S.p}async send(S,C,g){const f=await this.workerReady;if(!C.isCancellationRequested)return new Promise(a=>{const d=(0,w.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(d,a);const c={...S,nonce:d};g?f.postMessage(c,[g]):f.postMessage(c),C.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(d)&&a()})})}spawn(S,C,g){const f={id:b.SharedProcessWorkerMessages.Spawn,configuration:S,environment:{bootstrapPath:P.FileAccess.asFileUri("bootstrap-fork",Q).fsPath}};return this.send(f,g,C)}terminate(S,C){const g={id:b.SharedProcessWorkerMessages.Terminate,configuration:S};return this.send(g,C)}}}),define(ne[217],re([0,1,63,23,173]),function(Q,e,D,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class L extends R.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:r.Schemas.vscodeUserData})}}pe([D.memoize],L.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=L}),define(ne[218],re([0,1,54,12,158,22,38,9,4,30,136,171,6]),function(Q,e,D,r,R,L,T,P,w,E,I,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const v=1e4;let h;async function S(g,f,a){return f["force-disable-user-env"]?(g.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):w.isWindows?(g.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.isLaunchedFromCli)(a)&&!f["force-user-env"]?(g.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.isLaunchedFromCli)(a)?g.trace("resolveShellEnv(): running (--force-user-env)"):g.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=p.Promises.withAsyncBody(async(d,c)=>{const i=new L.CancellationTokenSource,o=setTimeout(()=>{i.dispose(!0),c(new Error((0,R.localize)(0,null)))},v);try{d(await C(g,i.token))}catch(t){!(0,P.isCancellationError)(t)&&!i.token.isCancellationRequested?c(new Error((0,R.localize)(1,null,(0,T.toErrorMessage)(t)))):d({})}finally{clearTimeout(o),i.dispose()}})),h)}e.getResolvedShellEnv=S;async function C(g,f){const a=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",a);const d=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",d);const c=(0,E.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(c+"(.*)"+c),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};g.trace("getUnixShellEnvironment#env",o);const t=await(0,I.getSystemShell)(w.OS,o);return g.trace("getUnixShellEnvironment#shell",t),new Promise((n,s)=>{if(f.isCancellationRequested)return s((0,P.canceled)());const u=(0,r.basename)(t);let l,m;const y=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(u)?(l=`& '${process.execPath}' ${y} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,m=["-Login","-Command"]):(l=`'${process.execPath}' ${y} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,u==="tcsh"?m=["-ic"]:m=["-ilc"]),g.trace("getUnixShellEnvironment#spawn",JSON.stringify(m),l);const _=(0,D.spawn)(t,[...m,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});f.onCancellationRequested(()=>(_.kill(),s((0,P.canceled)()))),_.on("error",U=>{g.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(U)),s(U)});const $=[];_.stdout.on("data",U=>$.push(U));const A=[];_.stderr.on("data",U=>A.push(U)),_.on("close",(U,k)=>{const N=Buffer.concat($).toString("utf8");g.trace("getUnixShellEnvironment#raw",N);const F=Buffer.concat(A).toString("utf8");if(F.trim()&&g.trace("getUnixShellEnvironment#stderr",F),U||k)return s(new Error((0,R.localize)(2,null,U,k)));const q=i.exec(N),J=q?q[1]:"{}";try{const j=JSON.parse(J);a?j.ELECTRON_RUN_AS_NODE=a:delete j.ELECTRON_RUN_AS_NODE,d?j.ELECTRON_NO_ATTACH_CONSOLE=d:delete j.ELECTRON_NO_ATTACH_CONSOLE,delete j.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",j),n(j)}catch(j){g.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(j)),s(j)}})})}}),define(ne[103],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,D.createDecorator)(e.SIGN_SERVICE_ID)}),define(ne[219],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class D{constructor(){this.validators=new Map}vsda(){return new Promise((R,L)=>Q(["vsda"],R,L))}async createNewMessage(R){try{const L=await this.vsda(),T=new L.validator;if(T){const P=String(D._nextId++);return this.validators.set(P,T),{id:P,data:T.createNewMessage(R)}}}catch{}return{id:"",data:R}}async validate(R,L){if(!R.id)return!0;const T=this.validators.get(R.id);if(!T)return!1;this.validators.delete(R.id);try{return T.validate(L)==="ok"}catch{return!1}}async sign(R){try{const L=await this.vsda(),T=new L.signer;if(T)return T.sign(R)}catch{}return R}}e.SignService=D,D._nextId=1}),define(ne[73],re([0,1,3,2]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class R extends r.Disposable{constructor(b,p,v){super(),this.channel=b,this.profile=p,this.workspace=v}async getItems(){const b={profile:this.profile,workspace:this.workspace},p=await this.channel.call("getItems",b);return new Map(p)}updateItems(b){const p={profile:this.profile,workspace:this.workspace};return b.insert&&(p.insert=Array.from(b.insert.entries())),b.delete&&(p.delete=Array.from(b.delete.values())),this.channel.call("updateItems",p)}}class L extends R{constructor(b,p){super(b,p,void 0),this._onDidChangeItemsExternal=this._register(new D.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeStorage",{profile:this.profile})(b=>this.onDidChangeStorage(b)))}onDidChangeStorage(b){(Array.isArray(b.changed)||Array.isArray(b.deleted))&&this._onDidChangeItemsExternal.fire({changed:b.changed?new Map(b.changed):void 0,deleted:b.deleted?new Set(b.deleted):void 0})}}class T extends L{constructor(b){super(b,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=T;class P extends L{constructor(b,p){super(b,p)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=P;class w extends R{constructor(b,p){super(b,void 0,p),this.onDidChangeItemsExternal=D.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=w;class E{constructor(b){this.channel=b}isUsed(b){const p={payload:b,profile:void 0,workspace:void 0};return this.channel.call("isUsed",p)}}e.StorageClient=E}),define(ne[104],re([0,1,4,37,7,30]),function(Q,e,D,r,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function T(E){if(D.platform===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}async function P(E,I,b,p,v,h,S,C,g,f){const a=Object.create(null);a["common.machineId"]=S,a.sessionID=(0,L.generateUuid)()+Date.now(),a.commitHash=v,a.version=h,a["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),a["common.platform"]=(0,D.PlatformToString)(D.platform),a["common.nodePlatform"]=r.platform,a["common.nodeArch"]=p,a["common.product"]=f||"desktop",C&&(a["common.msftInternal"]=C);let d=0;const c=Date.now();Object.defineProperties(a,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),D.isLinuxSnap&&(a["common.snap"]="true");const i=T(b);i&&(a["common.platformDetail"]=i);try{const o=await E.readFile(R.URI.file(g));a["common.source"]=o.value.toString().slice(0,30)}catch{}return a}e.resolveCommonProperties=P;function w(E){const I=r.env.USERDNSDOMAIN;if(!I)return!1;const b=I.toLowerCase();return E.some(p=>b===p)}e.verifyMicrosoftInternalDomain=w}),define(ne[24],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var r;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(r=e.TelemetryLevel||(e.TelemetryLevel={}));var R;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(R=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ne[220],re([0,1,36,52,6,35,23,12,4,7,133,28,135,93,13,25,24]),function(Q,e,D,r,R,L,T,P,w,E,I,b,p,v,h,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const g=new Map;async function f(o,t){const n=`${o}::${t.join(":")}`,s=g.get(n);if(s)return s;const u=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,m=new Map,y=2e4;function _(A,U,k,N){const F=U.substring(A.length+1);return R.Promises.withAsyncBody(async q=>{let J;try{J=await b.Promises.readdir(U,{withFileTypes:!0})}catch{q();return}if(N.count>=y){N.count+=J.length,N.maxReached=!0,q();return}let j=J.length;if(j===0){q();return}let H=J;N.count+J.length>y&&(N.maxReached=!0,j=y-N.count,H=J.slice(0,j)),N.count+=J.length;for(const W of H)if(W.isDirectory()){if(k.includes(W.name)||await _(A,(0,P.join)(U,W.name),k,N),--j===0){q();return}}else{const z=W.name.lastIndexOf(".");if(z>=0){const K=W.name.substring(z+1);K&&l.set(K,(l.get(K)??0)+1)}for(const K of u)K.relativePathPattern?.test(F)!==!1&&K.filePattern.test(W.name)&&m.set(K.tag,(m.get(K.tag)??0)+1);if(--j===0){q();return}}})}const $=R.Promises.withAsyncBody(async A=>{const U={count:0,maxReached:!1};await _(o,o,t,U);const k=await c(o);A({configFiles:a(m),fileTypes:a(l),fileCount:U.count,maxFilesReached:U.maxReached,launchConfigFiles:k})});return g.set(n,$),$}e.collectWorkspaceStats=f;function a(o){return[...r.Iterable.map(o.entries(),([t,n])=>({name:t,count:n}))].sort((t,n)=>n.count-t.count)}function d(){const o={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(I.virtualMachineHint.value()*100)}%`},t=D.cpus();return t&&t.length>0&&(o.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),o}e.getMachineInfo=d;async function c(o){try{const t=new Map,n=(0,P.join)(o,".vscode","launch.json"),s=await b.Promises.readFile(n),u=[],l=(0,L.parse)(s.toString(),u);if(u.length)return console.log(`Unable to parse ${n}`),[];if((0,L.getNodeType)(l)==="object"&&l.configurations)for(const m of l.configurations){const y=m.type;y&&(t.has(y)?t.set(y,t.get(y)+1):t.set(y,1))}return a(t)}catch{return[]}}e.collectLaunchConfigs=c;let i=class{constructor(t,n){this.telemetryService=t,this.productService=n}formatMachineInfo(t){const n=[];return n.push(`OS Version:       ${t.os}`),n.push(`CPUs:             ${t.cpus}`),n.push(`Memory (System):  ${t.memory}`),n.push(`VM:               ${t.vmHint}`),n.join(`
`)}formatEnvironment(t){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const s=D.cpus();return s&&s.length>0&&n.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),n.push(`Memory (System):  ${(D.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),w.isWindows||n.push(`Load (avg):       ${D.loadavg().map(u=>Math.round(u)).join(", ")}`),n.push(`VM:               ${Math.round(I.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${t.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(t,n){return Promise.all([(0,p.listProcesses)(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async s=>{let[u,l]=s,m=this.formatProcessList(t,u);return n.forEach(y=>{if((0,v.isRemoteDiagnosticError)(y))m+=`
${y.errorMessage}`,l+=`
${y.errorMessage}`;else if(m+=`

Remote: ${y.hostName}`,y.processes&&(m+=`
${this.formatProcessList(t,y.processes)}`),y.workspaceMetadata){l+=`
|  Remote: ${y.hostName}`;for(const _ of Object.keys(y.workspaceMetadata)){const $=y.workspaceMetadata[_];let A=`${$.fileCount} files`;$.maxFilesReached&&(A=`more than ${A}`),l+=`|    Folder (${_}): ${A}`,l+=this.formatWorkspaceStats($)}}}),{processInfo:m,workspaceInfo:l}})}async getSystemInfo(t,n){const{memory:s,vmHint:u,os:l,cpus:m}=d(),y={os:l,memory:s,cpus:m,vmHint:u,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:n};return w.isWindows||(y.load=`${D.loadavg().map(_=>Math.round(_)).join(", ")}`),w.isLinux&&(y.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(y)}async getDiagnostics(t,n){const s=[];return(0,p.listProcesses)(t.mainPID).then(async u=>(s.push(""),s.push(this.formatEnvironment(t)),s.push(""),s.push(this.formatProcessList(t,u)),t.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.formatWorkspaceMetadata(t))),n.forEach(l=>{if((0,v.isRemoteDiagnosticError)(l))s.push(`
${l.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${l.hostName}`),s.push(this.formatMachineInfo(l.machineInfo)),l.processes&&s.push(this.formatProcessList(t,l.processes)),l.workspaceMetadata)for(const m of Object.keys(l.workspaceMetadata)){const y=l.workspaceMetadata[m];let _=`${y.fileCount} files`;y.maxFilesReached&&(_=`more than ${_}`),s.push(`Folder (${m}): ${_}`),s.push(this.formatWorkspaceStats(y))}}),s.push(""),s.push(""),s.join(`
`)))}formatWorkspaceStats(t){const n=[];let u=0;const l=($,A)=>{const U=` ${$}(${A})`;u+U.length>60?(n.push(m),m="|                 ",u=m.length):u+=U.length,m+=U};let m="|      File types:";const y=10,_=t.fileTypes.length>y?y:t.fileTypes.length;for(let $=0;$<_;$++){const A=t.fileTypes[$];l(A.name,A.count)}if(n.push(m),t.configFiles.length>=0&&(m="|      Conf files:",u=0,t.configFiles.forEach($=>{l($.name,$.count)}),n.push(m)),t.launchConfigFiles.length>0){let $="|      Launch Configs:";t.launchConfigFiles.forEach(A=>{$+=A.count>1?` ${A.name}(${A.count})`:` ${A.name}`}),n.push($)}return n.join(`
`)}expandGPUFeatures(t){const n=Math.max(...Object.keys(t).map(s=>s.length));return Object.keys(t).map(s=>`${s}:  ${" ".repeat(n-s.length)}  ${t[s]}`).join(`
                  `)}formatWorkspaceMetadata(t){const n=[],s=[];return t.windows.forEach(u=>{u.folderURIs.length===0||!!u.remoteAuthority||(n.push(`|  Window (${u.title})`),u.folderURIs.forEach(l=>{const m=E.URI.revive(l);if(m.scheme===T.Schemas.file){const y=m.fsPath;s.push(f(y,["node_modules",".git"]).then(_=>{let $=`${_.fileCount} files`;_.maxFilesReached&&($=`more than ${$}`),n.push(`|    Folder (${(0,P.basename)(y)}): ${$}`),n.push(this.formatWorkspaceStats(_))}).catch(_=>{n.push(`|      Error: Unable to collect workspace stats for folder ${y} (${_.toString()})`)}))}else n.push(`|    Folder (${m.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(u=>n.join(`
`)).catch(u=>`Unable to collect workspace stats: ${u}`)}formatProcessList(t,n){const s=new Map;t.windows.forEach(l=>s.set(l.pid,l.title));const u=[];return u.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(t.mainPID,s,u,n,0),u.join(`
`)}formatProcessItem(t,n,s,u,l){const m=l===0;let y;m?y=u.pid===t?`${this.productService.applicationName} main`:"remote agent":(y=`${"  ".repeat(l)} ${u.name}`,u.name==="window"&&(y=`${y} (${n.get(u.pid)})`));const _=process.platform==="win32"?u.mem:D.totalmem()*(u.mem/100);s.push(`${u.load.toFixed(0).padStart(5," ")}	${(_/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${u.pid.toFixed(0).padStart(6," ")}	${y}`),Array.isArray(u.children)&&u.children.forEach($=>this.formatProcessItem(t,n,s,$,l+1))}async getWorkspaceFileExtensions(t){const n=new Set;for(const{uri:s}of t.folders){const u=E.URI.revive(s);if(u.scheme!==T.Schemas.file)continue;const l=u.fsPath;try{(await f(l,["node_modules",".git"])).fileTypes.forEach(y=>n.add(y.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(t){for(const{uri:n}of t.folders){const s=E.URI.revive(n);if(s.scheme!==T.Schemas.file)continue;const u=s.fsPath;try{const l=await f(u,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),l.fileTypes.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:m.name,count:m.count})}),l.launchConfigFiles.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:m.name,count:m.count})}),l.configFiles.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:m.name,count:m.count})})}catch{}}}};i=pe([Y(0,C.ITelemetryService),Y(1,S.IProductService)],i),e.DiagnosticsService=i}),define(ne[105],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class D{constructor(L){this.appenders=L}listen(L,T){throw new Error(`Event not found: ${T}`)}call(L,T,{eventName:P,data:w}){return this.appenders.forEach(E=>E.log(P,w)),Promise.resolve(null)}}e.TelemetryAppenderChannel=D;class r{constructor(L){this.channel=L}log(L,T){return this.channel.call("log",{eventName:L,data:T}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=r}),define(ne[50],re([0,1,32,83,15,17,104,24]),function(Q,e,D,r,R,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class w{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,r.staticObservableValue)(0)}publicLog(i,o){return Promise.resolve(void 0)}publicLog2(i,o){return this.publicLog(i,o)}publicLogError(i,o){return Promise.resolve(void 0)}publicLogError2(i,o){return this.publicLogError(i,o)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=w,e.NullTelemetryService=new w;class E{async publicLog(i,o,t){}async publicLogError(i,o,t){}}e.NullEndpointTelemetryService=E,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function I(c,i){return i.onDidChangeConfiguration(o=>{o.source!==7&&c.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(o.source),configurationKeys:g(o.sourceConfig)})})}e.configurationTelemetry=I;function b(c,i){return!(i.disableTelemetry||!c.enableTelemetry||i.extensionTestsLocationURI)}e.supportsTelemetry=b;function p(c){const i=c.getValue(P.TELEMETRY_SETTING_ID),o=c.getValue("telemetry.enableCrashReporter");if(c.getValue(P.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(i??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=p;function v(c){const i={},o={},t={};C(c,t);for(let n in t){n=n.length>150?n.substr(n.length-149):n;const s=t[n];typeof s=="number"?o[n]=s:typeof s=="boolean"?o[n]=s?1:0:typeof s=="string"?(s.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${s.length}`),i[n]=s.substring(0,8191)):typeof s<"u"&&s!==null&&(i[n]=s)}return{properties:i,measurements:o}}e.validateTelemetryData=v;const h=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function S(c){if(!c)return"none";for(const i of h)if(c.startsWith(`${i}+`))return i;return"other"}e.cleanRemoteAuthority=S;function C(c,i,o=0,t){if(!!c)for(const n of Object.getOwnPropertyNames(c)){const s=c[n],u=t?t+n:n;Array.isArray(s)?i[u]=(0,D.safeStringify)(s):s instanceof Date?i[u]=s.toISOString():(0,R.isObject)(s)?o<2?C(s,i,o+1,u+"."):i[u]=(0,D.safeStringify)(s):i[u]=s}}function g(c){if(!c)return[];const i=[];return f(i,"",c),i}function f(c,i,o){o&&typeof o=="object"&&!Array.isArray(o)?Object.keys(o).forEach(t=>f(c,i?`${i}.${t}`:t,o[t])):c.push(i)}function a(c,i){const o=c.msftInternalDomains||[],t=i.getValue("telemetry.internalTesting");return(0,T.verifyMicrosoftInternalDomain)(o)||t}e.isInternalTelemetry=a;function d(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}e.getPiiPathsFromEnvironment=d}),define(ne[221],re([0,1,48,50]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function R(L,T,P,w,E,I,b){const p={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${T.nameShort})`};if((0,r.supportsTelemetry)(T,P)&&(0,r.getTelemetryLevel)(w)===3){const v=await(0,D.getServiceMachineId)(P,E,I),{sessionId:h}=await b.getTelemetryInfo();p["X-Market-User-Id"]=v,p["VSCode-SessionId"]=h}return p}e.resolveMarketplaceHeaders=R}),define(ne[222],re([0,1,9,32,50]),function(Q,e,D,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const L="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function T(w,E,I){const b=await new Promise((C,g)=>{Q(["@microsoft/1ds-core-js"],C,g)}),p=await new Promise((C,g)=>{Q(["@microsoft/1ds-post-js"],C,g)}),v=new b.AppInsightsCore,h=new p.PostChannel,S={instrumentationKey:w,endpointUrl:L,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[h]]};if(I){S.extensionConfig={};const C={alwaysUseXhrOverride:!0,httpXHROverride:I};S.extensionConfig[h.identifier]=C}return v.initialize(S,[]),v.addTelemetryInitializer(C=>{E&&(C.ext=C.ext??{},C.ext.utc=C.ext.utc??{},C.ext.utc.flags=8462029)}),v}class P{constructor(E,I,b,p,v){this._isInternalTelemetry=E,this._eventPrefix=I,this._defaultData=b,this._xhrOverride=v,this.endPointUrl=L,this._defaultData||(this._defaultData={}),typeof p=="function"?this._aiCoreOrKey=p():this._aiCoreOrKey=p,this._asyncAiCore=null}_withAIClient(E){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){E(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=T(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(I=>{E(I)},I=>{(0,D.onUnexpectedError)(I),console.error(I)})}}log(E,I){if(!this._aiCoreOrKey)return;I=(0,r.mixin)(I,this._defaultData),I=(0,R.validateTelemetryData)(I);const b=this._eventPrefix+"/"+E;try{this._withAIClient(p=>{p.pluginVersionString=I?.properties.version??"Unknown",p.track({name:b,baseData:{name:b,properties:I?.properties,measurements:I?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(E=>{this._withAIClient(I=>{I.unload(!0,()=>{this._aiCoreOrKey=void 0,E(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=P}),define(ne[106],re([0,1,2,14,8,50]),function(Q,e,D,r,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let T=class extends D.Disposable{constructor(w,E,I=""){super(),this.prefix=I;const b=w.getLogger(E.telemetryLogResource);b?this.logger=this._register(b):(this.logger=this._register(w.createLogger(E.telemetryLogResource)),this.logger.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(w,E){this.logger.trace(`${this.prefix}telemetry/${w}`,(0,L.validateTelemetryData)(E))}};T=pe([Y(0,R.ILoggerService),Y(1,r.IEnvironmentService)],T),e.TelemetryLogAppender=T}),define(ne[107],re([0,1,2,32,83,4,27,159,17,43,99,25,40,24,50]),function(Q,e,D,r,R,L,T,P,w,E,I,b,p,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let S=class{constructor(f,a,d){this._configurationService=a,this._productService=d,this._experimentProperties={},this.telemetryLevel=new R.MutableObservableValue(3),this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appenders=f.appenders,this._commonProperties=f.commonProperties||Promise.resolve({}),this._piiPaths=f.piiPaths||[],this._sendErrorTelemetry=!!f.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const c of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,T.escapeRegExpCharacters)(c),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(f,a){this._experimentProperties[f]=a}_updateTelemetryLevel(){let f=(0,h.getTelemetryLevel)(this._configurationService);const a=this._productService.enabledTelemetryLevels;if(a){this._sendErrorTelemetry=this.sendErrorTelemetry?a.error:!1;const d=a.usage?3:a.error?2:0;f=Math.min(f,d)}this.telemetryLevel.value=f}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const f=await this._commonProperties,a=f.sessionID,d=f["common.machineId"],c=f["common.firstSessionDate"],i=f["common.msftInternal"];return{sessionId:a,machineId:d,firstSessionDate:c,msftInternal:i}}dispose(){this._disposables.dispose()}_log(f,a,d,c){return this.telemetryLevel.value<a?Promise.resolve(void 0):this._commonProperties.then(i=>{d=(0,r.mixin)(d,i),d=(0,r.mixin)(d,this._experimentProperties),d=(0,r.cloneAndChange)(d,o=>{if(typeof o=="string")return this._cleanupInfo(o,c)}),this._appenders.forEach(o=>o.log(f,d))},i=>{console.error(i)})}publicLog(f,a,d){return this._log(f,3,a,d)}publicLog2(f,a,d){return this.publicLog(f,a,d)}publicLogError(f,a){return this._sendErrorTelemetry?this._log(f,2,a,!0):Promise.resolve(void 0)}publicLogError2(f,a){return this.publicLogError(f,a)}_anonymizeFilePaths(f){let a=f;const d=[];for(const t of this._cleanupPatterns)for(;;){const n=t.exec(f);if(!n)break;d.push([n.index,t.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,i=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(a="";;){const t=i.exec(f);if(!t)break;!c.test(t[0])&&d.every(([n,s])=>t.index<n||t.index>=s)&&(a+=f.substring(o,t.index)+"<REDACTED: user-file-path>",o=i.lastIndex)}return o<f.length&&(a+=f.substr(o)),a}_removePropertiesWithPossibleUserInfo(f){if(!f)return f;const a=f.toLowerCase(),d=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const c of d)if(c.regex.test(a))return`<REDACTED: ${c.label}>`;return f}_cleanupInfo(f,a){let d=f;a&&(d=this._anonymizeFilePaths(d));for(const c of this._cleanupPatterns)d=d.replace(c,"");return d=this._removePropertiesWithPossibleUserInfo(d),d}};S.IDLE_START_EVENT_NAME="UserIdleStart",S.IDLE_STOP_EVENT_NAME="UserIdleStop",S=pe([Y(1,w.IConfigurationService),Y(2,b.IProductService)],S),e.TelemetryService=S;function C(){const g=(0,P.localize)(0,null,I.default.nameLong),f=I.default.privacyStatementUrl?(0,P.localize)(2,null,"https://aka.ms/vscode-telemetry",I.default.privacyStatementUrl):(0,P.localize)(1,null,"https://aka.ms/vscode-telemetry"),a=L.isWeb?"":(0,P.localize)(3,null),d=(0,P.localize)(4,null),c=(0,P.localize)(5,null),i=(0,P.localize)(6,null),o=(0,P.localize)(7,null),t=`
|       | ${d} | ${c} | ${i} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,P.localize)(8,null);return`
${g} ${f} ${a}

&nbsp;

${o}
${t}

&nbsp;

${n}
`}p.Registry.as(E.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(9,null),properties:{[v.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,P.localize)(10,null),(0,P.localize)(11,null),(0,P.localize)(12,null),(0,P.localize)(13,null)],markdownDescription:C(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),p.Registry.as(E.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(14,null),properties:{[v.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:I.default.privacyStatementUrl?(0,P.localize)(16,null,I.default.nameLong,I.default.privacyStatementUrl):(0,P.localize)(15,null,I.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,P.localize)(17,null,`\`#${v.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[223],re([0,1,279,222]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class R extends r.AbstractOneDataSystemAppender{constructor(T,P,w,E){const I={sendPOST:(b,p)=>{const v={method:"POST",headers:{...b.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(b.data)}};try{const h=D.request(b.urlString,v,S=>{S.on("data",function(C){p(S.statusCode??200,S.headers,C.toString())}),S.on("error",function(C){p(0,{})})});h.write(b.data),h.end()}catch{p(0,{})}}};super(T,P,w,E,I)}}e.OneDataSystemAppender=R}),define(ne[224],re([0,1,23,67,17,14,8,25,24,105,106,107]),function(Q,e,D,r,R,L,T,P,w,E,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let p=class{constructor(h,S,C,g,f){this.configurationService=h,this.telemetryService=S,this.loggerService=C,this.environmentService=g,this.productService=f,this.customTelemetryServices=new Map}async getCustomTelemetryService(h){if(!this.customTelemetryServices.has(h.id)){const{machineId:S,sessionId:C}=await this.telemetryService.getTelemetryInfo(),g=Object.create(null);g["common.vscodemachineid"]=S,g["common.vscodesessionid"]=C;const f=[h.id,JSON.stringify(g),h.aiKey],d=new r.Client(D.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:f,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),c=[new E.TelemetryAppenderClient(d),new I.TelemetryLogAppender(this.loggerService,this.environmentService,`[${h.id}] `)];this.customTelemetryServices.set(h.id,new b.TelemetryService({appenders:c,sendErrorTelemetry:h.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(h.id)}async publicLog(h,S,C){await(await this.getCustomTelemetryService(h)).publicLog(S,C)}async publicLogError(h,S,C){await(await this.getCustomTelemetryService(h)).publicLogError(S,C)}};p=pe([Y(0,R.IConfigurationService),Y(1,w.ITelemetryService),Y(2,T.ILoggerService),Y(3,L.IEnvironmentService),Y(4,P.IProductService)],p),e.CustomEndpointTelemetryService=p}),define(ne[225],re([0,1,6,22,3,2,8]),function(Q,e,D,r,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends L.Disposable{constructor(E,I){super(),this._logService=I,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new R.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=E===void 0?15e3:E}createRequest(E){return new Promise((I,b)=>{const p=++this._lastRequestId;this._pendingRequests.set(p,I),this._onCreateRequest.fire({requestId:p,...E});const v=new r.CancellationTokenSource;(0,D.timeout)(this._timeout,v.token).then(()=>b(`Request ${p} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(p,[(0,L.toDisposable)(()=>v.cancel())])})}acceptReply(E,I){const b=this._pendingRequests.get(E);b?(this._pendingRequests.delete(E),(0,L.dispose)(this._pendingRequestDisposables.get(E)||[]),this._pendingRequestDisposables.delete(E),b(I)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${E}`)}};P=pe([Y(1,T.ILogService)],P),e.RequestStore=P}),define(ne[108],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var r;(function(a){a.Shell="terminal.integrated.shell.",a.ShellArgs="terminal.integrated.shellArgs.",a.DefaultProfile="terminal.integrated.defaultProfile.",a.Profiles="terminal.integrated.profiles."})(r=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var R;(function(a){a.ShellLinux="terminal.integrated.shell.linux",a.ShellMacOs="terminal.integrated.shell.osx",a.ShellWindows="terminal.integrated.shell.windows",a.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",a.AutomationShellLinux="terminal.integrated.automationShell.linux",a.AutomationShellMacOs="terminal.integrated.automationShell.osx",a.AutomationShellWindows="terminal.integrated.automationShell.windows",a.AutomationProfileLinux="terminal.integrated.automationProfile.linux",a.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",a.AutomationProfileWindows="terminal.integrated.automationProfile.windows",a.ShellArgsLinux="terminal.integrated.shellArgs.linux",a.ShellArgsMacOs="terminal.integrated.shellArgs.osx",a.ShellArgsWindows="terminal.integrated.shellArgs.windows",a.ProfilesWindows="terminal.integrated.profiles.windows",a.ProfilesMacOs="terminal.integrated.profiles.osx",a.ProfilesLinux="terminal.integrated.profiles.linux",a.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",a.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",a.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",a.UseWslProfiles="terminal.integrated.useWslProfiles",a.TabsDefaultColor="terminal.integrated.tabs.defaultColor",a.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",a.TabsEnabled="terminal.integrated.tabs.enabled",a.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",a.TabsHideCondition="terminal.integrated.tabs.hideCondition",a.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",a.TabsShowActions="terminal.integrated.tabs.showActions",a.TabsLocation="terminal.integrated.tabs.location",a.TabsFocusMode="terminal.integrated.tabs.focusMode",a.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",a.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",a.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",a.CopyOnSelection="terminal.integrated.copyOnSelection",a.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",a.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",a.FontFamily="terminal.integrated.fontFamily",a.FontSize="terminal.integrated.fontSize",a.LetterSpacing="terminal.integrated.letterSpacing",a.LineHeight="terminal.integrated.lineHeight",a.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",a.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",a.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",a.BellDuration="terminal.integrated.bellDuration",a.FontWeight="terminal.integrated.fontWeight",a.FontWeightBold="terminal.integrated.fontWeightBold",a.CursorBlinking="terminal.integrated.cursorBlinking",a.CursorStyle="terminal.integrated.cursorStyle",a.CursorWidth="terminal.integrated.cursorWidth",a.Scrollback="terminal.integrated.scrollback",a.DetectLocale="terminal.integrated.detectLocale",a.DefaultLocation="terminal.integrated.defaultLocation",a.GpuAcceleration="terminal.integrated.gpuAcceleration",a.TerminalTitleSeparator="terminal.integrated.tabs.separator",a.TerminalTitle="terminal.integrated.tabs.title",a.TerminalDescription="terminal.integrated.tabs.description",a.RightClickBehavior="terminal.integrated.rightClickBehavior",a.Cwd="terminal.integrated.cwd",a.ConfirmOnExit="terminal.integrated.confirmOnExit",a.ConfirmOnKill="terminal.integrated.confirmOnKill",a.EnableBell="terminal.integrated.enableBell",a.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",a.AllowChords="terminal.integrated.allowChords",a.AllowMnemonics="terminal.integrated.allowMnemonics",a.EnvMacOs="terminal.integrated.env.osx",a.EnvLinux="terminal.integrated.env.linux",a.EnvWindows="terminal.integrated.env.windows",a.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",a.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",a.ShowExitAlert="terminal.integrated.showExitAlert",a.SplitCwd="terminal.integrated.splitCwd",a.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",a.WordSeparators="terminal.integrated.wordSeparators",a.EnableFileLinks="terminal.integrated.enableFileLinks",a.UnicodeVersion="terminal.integrated.unicodeVersion",a.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",a.LocalEchoEnabled="terminal.integrated.localEchoEnabled",a.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",a.LocalEchoStyle="terminal.integrated.localEchoStyle",a.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",a.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",a.CustomGlyphs="terminal.integrated.customGlyphs",a.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",a.InheritEnv="terminal.integrated.inheritEnv",a.ShowLinkHover="terminal.integrated.showLinkHover",a.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",a.AutoReplies="terminal.integrated.autoReplies",a.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",a.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",a.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",a.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",a.SmoothScrolling="terminal.integrated.smoothScrolling"})(R=e.TerminalSettingId||(e.TerminalSettingId={}));var L;(function(a){a.FileName="ptyhost"})(L=e.TerminalLogConstants||(e.TerminalLogConstants={}));var T;(function(a){a.PowerShell="pwsh",a.Bash="bash",a.Fish="fish",a.Sh="sh",a.Csh="csh",a.Ksh="ksh",a.Zsh="zsh"})(T=e.PosixShellType||(e.PosixShellType={}));var P;(function(a){a.CommandPrompt="cmd",a.PowerShell="pwsh",a.Wsl="wsl",a.GitBash="gitbash"})(P=e.WindowsShellType||(e.WindowsShellType={}));var w;(function(a){a[a.Api=0]="Api",a[a.Process=1]="Process",a[a.Sequence=2]="Sequence",a[a.Config=3]="Config"})(w=e.TitleEventSource||(e.TitleEventSource={}));var E;(function(a){a.LocalPty="localPty",a.PtyHost="ptyHost",a.Log="log",a.Heartbeat="heartbeat"})(E=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,D.createDecorator)("ptyService");var I;(function(a){a.Cwd="cwd",a.InitialCwd="initialCwd",a.FixedDimensions="fixedDimensions",a.Title="title",a.ShellType="shellType",a.HasChildProcesses="hasChildProcesses",a.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",a.OverrideDimensions="overrideDimensions",a.FailedShellIntegrationActivation="failedShellIntegrationActivation",a.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(I=e.ProcessPropertyType||(e.ProcessPropertyType={}));var b;(function(a){a[a.BeatInterval=5e3]="BeatInterval",a[a.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",a[a.SecondWaitMultiplier=1]="SecondWaitMultiplier",a[a.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(b=e.HeartbeatConstants||(e.HeartbeatConstants={}));var p;(function(a){a[a.Panel=1]="Panel",a[a.Editor=2]="Editor"})(p=e.TerminalLocation||(e.TerminalLocation={}));var v;(function(a){a.TerminalView="view",a.Editor="editor"})(v=e.TerminalLocationString||(e.TerminalLocationString={}));var h;(function(a){a[a.GraceTime=6e4]="GraceTime",a[a.ShortGraceTime=6e3]="ShortGraceTime"})(h=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var S;(function(a){a[a.HighWatermarkChars=1e5]="HighWatermarkChars",a[a.LowWatermarkChars=5e3]="LowWatermarkChars",a[a.CharCountAckSize=5e3]="CharCountAckSize"})(S=e.FlowControlConstants||(e.FlowControlConstants={}));var C;(function(a){a.GitBash="Git Bash",a.Pwsh="PowerShell"})(C=e.ProfileSource||(e.ProfileSource={}));var g;(function(a){a[a.Off=0]="Off",a[a.FinalTerm=1]="FinalTerm",a[a.VSCode=2]="VSCode"})(g=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var f;(function(a){a[a.Unknown=0]="Unknown",a[a.Shutdown=1]="Shutdown",a[a.Process=2]="Process",a[a.User=3]="User",a[a.Extension=4]="Extension"})(f=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(ne[226],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,D.createDecorator)("localPtyService")}),define(ne[227],re([0,1,36,23,32,12,4,37,27,15,28]),function(Q,e,D,r,R,L,T,P,w,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function b(){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let c=0;return d&&d.length===4&&(c=parseInt(d[3])),c}e.getWindowsBuildNumber=b;async function p(d,c,i,o=P.env,t=I.Promises.exists){if(L.isAbsolute(d))return await t(d)?d:void 0;if(c===void 0&&(c=P.cwd()),L.dirname(d)!=="."){const l=L.join(c,d);return await t(l)?l:void 0}const s=(0,R.getCaseInsensitive)(o,"PATH");if(i===void 0&&(0,E.isString)(s)&&(i=s.split(L.delimiter)),i===void 0||i.length===0){const l=L.join(c,d);return await t(l)?l:void 0}for(const l of i){let m;if(L.isAbsolute(l)?m=L.join(l,d):m=L.join(c,l,d),await t(m))return m;if(T.isWindows){let y=m+".com";if(await t(y)||(y=m+".exe",await t(y)))return y}}const u=L.join(c,d);return await t(u)?u:void 0}e.findExecutable=p;function v(d,c,i,o,t){if(!c.shellIntegration.enabled||!d.executable||d.isFeatureTerminal||d.hideFromUser||d.ignoreShellIntegration||T.isWindows&&!c.windowsEnableConpty)return;const n=d.args,s=P.platform==="win32"?L.basename(d.executable).toLowerCase():L.basename(d.executable),u=L.dirname(r.FileAccess.asFileUri("",Q).fsPath);let l;const m={VSCODE_INJECTION:"1"};if(T.isWindows){if(s==="pwsh.exe")return!n||f(n)?l=e.shellIntegrationArgs.get(h.WindowsPwsh):g(n)&&(l=e.shellIntegrationArgs.get(h.WindowsPwshLogin)),l?(l=[...l],l[l.length-1]=(0,w.format)(l[l.length-1],u,""),{newArgs:l,envMixin:m}):void 0;o.warn(`Shell integration cannot be enabled for executable "${d.executable}" and args`,d.args);return}switch(s){case"bash":return!n||n.length===0?l=e.shellIntegrationArgs.get(h.Bash):a(n)&&(m.VSCODE_SHELL_LOGIN="1",l=e.shellIntegrationArgs.get(h.Bash)),l?(l=[...l],l[l.length-1]=(0,w.format)(l[l.length-1],u),{newArgs:l,envMixin:m}):void 0;case"pwsh":return!n||f(n)?l=e.shellIntegrationArgs.get(h.Pwsh):g(n)&&(l=e.shellIntegrationArgs.get(h.PwshLogin)),l?(l=[...l],l[l.length-1]=(0,w.format)(l[l.length-1],u,""),{newArgs:l,envMixin:m}):void 0;case"zsh":{if(!n||n.length===0?l=e.shellIntegrationArgs.get(h.Zsh):a(n)?l=e.shellIntegrationArgs.get(h.ZshLogin):(n===e.shellIntegrationArgs.get(h.Zsh)||n===e.shellIntegrationArgs.get(h.ZshLogin))&&(l=n),!l)return;l=[...l],l[l.length-1]=(0,w.format)(l[l.length-1],u);const y=L.join(D.tmpdir(),`${D.userInfo().username}-${t.applicationName}-zsh`);m.ZDOTDIR=y;const _=i?.ZDOTDIR??D.homedir()??"~";m.USER_ZDOTDIR=_;const $=[];return $.push({source:L.join(u,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:L.join(y,".zshrc")}),$.push({source:L.join(u,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:L.join(y,".zprofile")}),$.push({source:L.join(u,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:L.join(y,".zshenv")}),$.push({source:L.join(u,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:L.join(y,".zlogin")}),{newArgs:l,envMixin:m,filesToCopy:$}}}o.warn(`Shell integration cannot be enabled for executable "${d.executable}" and args`,d.args)}e.getShellIntegrationInjection=v;var h;(function(d){d.WindowsPwsh="windows-pwsh",d.WindowsPwshLogin="windows-pwsh-login",d.Pwsh="pwsh",d.PwshLogin="pwsh-login",d.Zsh="zsh",d.ZshLogin="zsh-login",d.Bash="bash"})(h=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(h.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(h.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(h.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(h.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(h.Zsh,["-i"]),e.shellIntegrationArgs.set(h.ZshLogin,["-il"]),e.shellIntegrationArgs.set(h.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const S=["-login","-l"],C=["-nol","-nologo"];function g(d){return typeof d=="string"?S.includes(d.toLowerCase()):d.length===1&&S.includes(d[0].toLowerCase())||d.length===2&&(S.includes(d[0].toLowerCase())||S.includes(d[1].toLowerCase()))&&(C.includes(d[0].toLowerCase())||C.includes(d[1].toLowerCase()))}function f(d){return typeof d=="string"?C.includes(d.toLowerCase()):d.length===0||d?.length===1&&C.includes(d[0].toLowerCase())}function a(d){return d==="string"&&S.includes(d.toLowerCase())||typeof d!="string"&&d.length===1&&S.includes(d[0].toLowerCase())}}),define(ne[228],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var D;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST_DARK="hcDark",L.HIGH_CONTRAST_LIGHT="hcLight"})(D=e.ColorScheme||(e.ColorScheme={}));function r(L){return L===D.HIGH_CONTRAST_DARK||L===D.HIGH_CONTRAST_LIGHT}e.isHighContrast=r;function R(L){return L===D.DARK||L===D.HIGH_CONTRAST_DARK}e.isDark=R}),define(ne[109],re([0,1,51,3,2,5,40,228]),function(Q,e,D,r,R,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,L.createDecorator)("themeService");var w;(function(C){function g(f){return f&&typeof f=="object"&&typeof f.id=="string"}C.isThemeColor=g})(w=e.ThemeColor||(e.ThemeColor={}));function E(C){return{id:C}}e.themeColorFromId=E;var I;(function(C){function g(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||w.isThemeColor(n.color))}C.isThemeIcon=g;const f=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function a(n){const s=f.exec(n);if(!s)return;const[,u]=s;return{id:u}}C.fromString=a;function d(n){return{id:n}}C.fromId=d;function c(n,s){let u=n.id;const l=u.lastIndexOf("~");return l!==-1&&(u=u.substring(0,l)),s&&(u=`${u}~${s}`),{id:u}}C.modify=c;function i(n){const s=n.id.lastIndexOf("~");if(s!==-1)return n.id.substring(s+1)}C.getModifier=i;function o(n,s){return n.id===s.id&&n.color?.id===s.color?.id}C.isEqual=o;function t(n,s){return{id:n.id,color:s?E(s):void 0}}C.asThemeIcon=t,C.asClassNameArray=D.CSSIcon.asClassNameArray,C.asClassName=D.CSSIcon.asClassName,C.asCSSSelector=D.CSSIcon.asCSSSelector})(I=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function b(C){switch(C){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case P.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=b,e.Extensions={ThemingContribution:"base.contributions.theming"};class p{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new r.Emitter}onColorThemeChange(g){return this.themingParticipants.push(g),this.onThemingParticipantAddedEmitter.fire(g),(0,R.toDisposable)(()=>{const f=this.themingParticipants.indexOf(g);this.themingParticipants.splice(f,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const v=new p;T.Registry.add(e.Extensions.ThemingContribution,v);function h(C){return v.onColorThemeChange(C)}e.registerThemingParticipant=h;class S extends R.Disposable{constructor(g){super(),this.themeService=g,this.theme=g.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(f=>this.onThemeChange(f)))}onThemeChange(g){this.theme=g,this.updateStyles()}updateStyles(){}getColor(g,f){let a=this.theme.getColor(g);return a&&f&&(a=f(a,this.theme)),a?a.toString():null}}e.Themable=S}),define(ne[229],re([0,1,51,7,161,109]),function(Q,e,D,r,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function T(p,v){const h=[{name:null,description:(0,R.localize)(0,null)}];return h.push(...p.map(S=>({name:S.profileName,description:P(S)}))),v&&h.push(...v.map(S=>({name:S.title,description:w(S)}))),{values:h.map(S=>S.name),markdownDescriptions:h.map(S=>S.description)}}e.createProfileSchemaEnums=T;function P(p){let v=`$(${L.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:D.Codicon.terminal.id}) ${p.profileName}
- path: ${p.path}`;return p.args&&(typeof p.args=="string"?v+=`
- args: "${p.args}"`:v+=`
- args: [${p.args.length===0?"":`'${p.args.join("','")}'`}]`),p.overrideName!==void 0&&(v+=`
- overrideName: ${p.overrideName}`),p.color&&(v+=`
- color: ${p.color}`),p.env&&(v+=`
- env: ${JSON.stringify(p.env)}`),v}function w(p){return`$(${L.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:D.Codicon.terminal.id}) ${p.title}
- extensionIdentifier: ${p.extensionIdentifier}`}function E(p,v){if(!p&&!v)return!0;if(typeof p=="string"&&typeof v=="string")return p===v;if(Array.isArray(p)&&Array.isArray(v)){if(p.length!==v.length)return!1;for(let h=0;h<p.length;h++)if(p[h]!==v[h])return!1;return!0}return!1}e.terminalProfileArgsMatch=E;function I(p,v){if(!p&&!v)return!0;if(!p||!v)return!1;if(L.ThemeIcon.isThemeIcon(p)&&L.ThemeIcon.isThemeIcon(v))return p.id===v.id&&p.color===v.color;if(typeof p=="object"&&"light"in p&&"dark"in p&&typeof v=="object"&&"light"in v&&"dark"in v){const h=p,S=v;if((r.URI.isUri(h.light)||b(h.light))&&(r.URI.isUri(h.dark)||b(h.dark))&&(r.URI.isUri(S.light)||b(S.light))&&(r.URI.isUri(S.dark)||b(S.dark)))return h.light.path===S.light.path&&h.dark.path===S.dark.path}if(r.URI.isUri(p)&&r.URI.isUri(v)||b(p)||b(v)){const h=p,S=v;return h.path===S.path&&h.scheme===S.scheme}return!1}e.terminalIconsEqual=I;function b(p){return p?typeof p.path=="string"&&typeof p.scheme=="string":!1}e.isUriComponents=b}),define(ne[230],re([0,1,51,160,43,40,229]),function(Q,e,D,r,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from(D.Codicon.getAll(),d=>d.id),markdownEnumDescriptions:Array.from(D.Codicon.getAll(),d=>`$(${d.id})`)};const P={args:{description:(0,r.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,r.localize)(1,null),type:"boolean"},icon:{description:(0,r.localize)(2,null),...e.terminalIconSchema},color:{description:(0,r.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,r.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},w={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},E={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(6,null),type:["string"],items:{type:"string"}},...P}},I=(0,r.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),b=(0,r.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),p=(0,r.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),v=(0,r.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),h=(0,r.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),S=(0,r.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),C={id:"terminal",order:100,title:(0,r.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:v},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:I},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:b},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,r.localize)(26,null)}},{type:"string",markdownDescription:(0,r.localize)(27,null)}],default:[],markdownDeprecationMessage:p},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,r.localize)(29,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(30,null),type:"string"},id:{description:(0,r.localize)(31,null),type:"string"},title:{description:(0,r.localize)(32,null),type:"string"},...P}},{type:"null"},w]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(34,null),type:"string"},id:{description:(0,r.localize)(35,null),type:"string"},title:{description:(0,r.localize)(36,null),type:"string"},...P}},{type:"null"},w]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(38,null),type:"string"},id:{description:(0,r.localize)(39,null),type:"string"},title:{description:(0,r.localize)(40,null),type:"string"},...P}},{type:"null"},w]}},["terminal.integrated.useWslProfiles"]:{description:(0,r.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,r.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,r.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,r.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,r.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function g(){L.Registry.as(R.Extensions.Configuration).registerConfiguration(C),a()}e.registerTerminalPlatformConfiguration=g;let f;function a(d,c){const i=L.Registry.as(R.Extensions.Configuration);let o;d&&(o=(0,T.createProfileSchemaEnums)(d?.profiles,c));const t=f;f={id:"terminal",order:100,title:(0,r.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:d?.os===3?o?.values:void 0,markdownEnumDescriptions:d?.os===3?o?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:d?.os===2?o?.values:void 0,markdownEnumDescriptions:d?.os===2?o?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:d?.os===1?o?.values:void 0,markdownEnumDescriptions:d?.os===1?o?.markdownDescriptions:void 0}}},i.updateConfigurations({add:[f],remove:t?[t]:[]})}e.registerTerminalDefaultProfileConfiguration=a}),define(ne[231],re([0,1,54,51,12,4,28,87,227,109]),function(Q,e,D,r,R,L,T,P,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let I,b=!0;function p(o,t,n,s,u=process.env,l,m,y,_){return l=l||{existsFile:T.SymlinkSupport.existsFile,readFile:T.Promises.readFile},L.isWindows?v(n,l,u,m,s.getValue("terminal.integrated.useWslProfiles")!==!1,o&&typeof o=="object"?{...o}:s.getValue("terminal.integrated.profiles.windows"),typeof t=="string"?t:s.getValue("terminal.integrated.defaultProfile.windows"),_,y):d(l,m,n,o&&typeof o=="object"?{...o}:s.getValue(L.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof t=="string"?t:s.getValue(L.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),_,y,u)}e.detectAvailableProfiles=p;async function v(o,t,n,s,u,l,m,y,_){const $=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),A=`${process.env.windir}\\${$?"Sysnative":"System32"}`;let U=!1;(0,w.getWindowsBuildNumber)()>=16299&&(U=!0),await C(y);const k=new Map;o&&(k.set("PowerShell",{source:"PowerShell",icon:r.Codicon.terminalPowershell,isAutoDetected:!0}),k.set("Windows PowerShell",{path:`${A}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:r.Codicon.terminalPowershell,isAutoDetected:!0}),k.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),k.set("Command Prompt",{path:`${A}\\cmd.exe`,icon:r.Codicon.terminalCmd,isAutoDetected:!0})),c(l,k);const N=await h(k.entries(),m,t,n,s,_);if(o||u)try{const F=await f(`${A}\\${U?"wsl":"bash"}.exe`,m);for(const q of F)(!l||!(q.profileName in l))&&N.push(q)}catch{b&&(s?.info("WSL is not installed, so could not detect WSL profiles"),b=!1)}return N}async function h(o,t,n,s=process.env,u,l){const m=[];for(const[y,_]of o){if(_===null)continue;let $,A,U;if("source"in _){const F=I?.get(_.source);if(!F)continue;$=F.paths,A=_.args||F.args,_.icon?U=S(_.icon):F.icon&&(U=F.icon)}else $=Array.isArray(_.path)?_.path:[_.path],A=L.isWindows||Array.isArray(_.args)?_.args:void 0,U=S(_.icon);const k=await l?.($)||$.slice(),N=await i(y,t,k,n,s,A,_.env,_.overrideName,_.isAutoDetected,u);N?(N.isAutoDetected=_.isAutoDetected,N.icon=U,N.color=_.color,m.push(N)):u?.debug("Terminal profile not validated",y,$)}return u?.debug("Validated terminal profiles",m),m}function S(o){return typeof o=="string"?{id:o}:o}async function C(o){I&&!o||(I=new Map,I.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),I.set("PowerShell",{profileName:"PowerShell",paths:o||await g(),icon:E.ThemeIcon.asThemeIcon(r.Codicon.terminalPowershell)}))}async function g(){const o=[];for await(const t of(0,P.enumeratePowerShellInstallations)())o.push(t.exePath);return o}async function f(o,t){const n=[],s=await new Promise((m,y)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(_,$)=>{if(_)return y("Problem occurred when getting wsl distros");m($)})});if(!s)return[];const u=new RegExp(/[\r?\n]/),l=s.split(u).filter(m=>m.trim().length>0&&m!=="");for(const m of l){if(m===""||m.startsWith("docker-desktop"))continue;const y=`${m} (WSL)`,_={profileName:y,path:o,args:["-d",`${m}`],isDefault:y===t,icon:a(m),isAutoDetected:!1};n.push(_)}return n}function a(o){return o.includes("Ubuntu")?E.ThemeIcon.asThemeIcon(r.Codicon.terminalUbuntu):o.includes("Debian")?E.ThemeIcon.asThemeIcon(r.Codicon.terminalDebian):E.ThemeIcon.asThemeIcon(r.Codicon.terminalLinux)}async function d(o,t,n,s,u,l,m,y){const _=new Map;if(n){const $=(await o.readFile("/etc/shells")).toString(),A=l||$.split(`
`).filter(k=>k.trim().indexOf("#")!==0&&k.trim().length>0),U=new Map;for(const k of A){let N=(0,R.basename)(k),F=U.get(N)||0;F++,F>1&&(N=`${N} (${F})`),U.set(N,F),_.set(N,{path:k,isAutoDetected:!0})}}return c(s,_),await h(_.entries(),u,o,y,t,m)}function c(o,t){if(!!o)for(const[n,s]of Object.entries(o))s===null||!("path"in s)&&!("source"in s)?t.delete(n):(s.icon=s.icon||t.get(n)?.icon,t.set(n,s))}async function i(o,t,n,s,u,l,m,y,_,$){if(n.length===0)return Promise.resolve(void 0);const A=n.shift();if(A==="")return i(o,t,n,s,u,l,m,y,_);const U={profileName:o,path:A,args:l,env:m,overrideName:y,isAutoDetected:_,isDefault:o===t};if((0,R.basename)(A)===A){const N=u.PATH?u.PATH.split(R.delimiter):void 0,F=await(0,w.findExecutable)(A,void 0,N,void 0,s.existsFile);return F?(U.path=F,U.isFromPath=!0,U):i(o,t,n,s,u,l)}return await s.existsFile((0,R.normalize)(A))?U:i(o,t,n,s,u,l,m,y,_)}}),define(ne[232],re([0,1,3,2,23,4,39,67,17,14,91,218,8,98,225,108,230,231]),function(Q,e,D,r,R,L,T,P,w,E,I,b,p,v,h,S,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var f;(function(c){c[c.MaxRestarts=5]="MaxRestarts"})(f||(f={}));let a=0,d=class extends r.Disposable{constructor(i,o,t,n){super(),this._reconnectConstants=i,this._configurationService=o,this._environmentService=t,this._logService=n,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new D.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new D.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new D.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new D.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new D.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new D.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new D.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new D.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new D.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new D.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new D.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new D.Emitter),this.onProcessExit=this._onProcessExit.event,(0,C.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,r.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new h.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async s=>{s.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}initialize(){this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(L.isWindows)return process.env;try{return await(0,b.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(i){return this._logService.error("ptyHost was unable to resolve shell environment",i),{}}}_startPtyHost(){const i={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this._environmentService.logsPath],env:{VSCODE_LAST_PTY_ID:a,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},o=(0,I.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);o&&(o.break&&o.port?i.debugBrk=o.port:!o.break&&o.port&&(i.debug=o.port));const t=new P.Client(R.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,i);this._onPtyHostStart.fire(),T.ProxyChannel.toService(t.getChannel(S.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(t.onDidProcessExit(l=>{this._onPtyHostExit.fire(l.code),this._isDisposed||(this._restartCount<=f.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${l.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${l.code}, giving up`))}));const s=t.getChannel(S.TerminalIpcChannels.Log);v.LogLevelChannelClient.setLevel(s,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{v.LogLevelChannelClient.setLevel(s,this._logService.getLevel())}));const u=T.ProxyChannel.toService(t.getChannel(S.TerminalIpcChannels.PtyHost));return this._register(u.onProcessData(l=>this._onProcessData.fire(l))),this._register(u.onProcessReady(l=>this._onProcessReady.fire(l))),this._register(u.onProcessExit(l=>this._onProcessExit.fire(l))),this._register(u.onDidChangeProperty(l=>this._onDidChangeProperty.fire(l))),this._register(u.onProcessReplay(l=>this._onProcessReplay.fire(l))),this._register(u.onProcessOrphanQuestion(l=>this._onProcessOrphanQuestion.fire(l))),this._register(u.onDidRequestDetach(l=>this._onDidRequestDetach.fire(l))),[t,u]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(i,o,t,n,s,u,l,m,y,_,$){const A=setTimeout(()=>this._handleUnresponsiveCreateProcess(),S.HeartbeatConstants.CreateProcessTimeout),U=await this._proxy.createProcess(i,o,t,n,s,u,l,m,y,_,$);return clearTimeout(A),a=Math.max(a,U),U}updateTitle(i,o,t){return this._proxy.updateTitle(i,o,t)}updateIcon(i,o,t,n){return this._proxy.updateIcon(i,o,t,n)}attachToProcess(i){return this._proxy.attachToProcess(i)}detachFromProcess(i,o){return this._proxy.detachFromProcess(i,o)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(i){return this._proxy.start(i)}shutdown(i,o){return this._proxy.shutdown(i,o)}input(i,o){return this._proxy.input(i,o)}processBinary(i,o){return this._proxy.processBinary(i,o)}resize(i,o,t){return this._proxy.resize(i,o,t)}acknowledgeDataEvent(i,o){return this._proxy.acknowledgeDataEvent(i,o)}setUnicodeVersion(i,o){return this._proxy.setUnicodeVersion(i,o)}getInitialCwd(i){return this._proxy.getInitialCwd(i)}getCwd(i){return this._proxy.getCwd(i)}getLatency(i){return this._proxy.getLatency(i)}orphanQuestionReply(i){return this._proxy.orphanQuestionReply(i)}installAutoReply(i,o){return this._proxy.installAutoReply(i,o)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(i){return this._proxy.uninstallAutoReply(i)}getDefaultSystemShell(i){return this._proxy.getDefaultSystemShell(i)}async getProfiles(i,o,t,n=!1){const s=await this._shellEnv;return(0,g.detectAvailableProfiles)(o,t,n,this._configurationService,s,void 0,this._logService,this._resolveVariables.bind(this,i))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(i){return this._proxy.getWslPath(i)}getRevivedPtyNewId(i){return this._proxy.getRevivedPtyNewId(i)}setTerminalLayoutInfo(i){return this._proxy.setTerminalLayoutInfo(i)}async getTerminalLayoutInfo(i){return await this._proxy.getTerminalLayoutInfo(i)}async requestDetachInstance(i,o){return this._proxy.requestDetachInstance(i,o)}async acceptDetachInstanceReply(i,o){return this._proxy.acceptDetachInstanceReply(i,o)}async freePortKillProcess(i){if(!this._proxy.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this._proxy.freePortKillProcess(i)}async serializeTerminalState(i){return this._proxy.serializeTerminalState(i)}async reviveTerminalProcesses(i,o){return this._proxy.reviveTerminalProcesses(i,o)}async refreshProperty(i,o){return this._proxy.refreshProperty(i,o)}async updateProperty(i,o,t){return this._proxy.updateProperty(i,o,t)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier+S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${S.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(i,o){return this._resolveVariablesRequestStore.createRequest({workspaceId:i,originalText:o})}async acceptPtyHostResolvedVariables(i,o){this._resolveVariablesRequestStore.acceptReply(i,o)}};d=pe([Y(1,w.IConfigurationService),Y(2,E.IEnvironmentService),Y(3,p.ILogService)],d),e.PtyHostService=d}),define(ne[74],re([0,1,3,4,5,8]),function(Q,e,D,r,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,R.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,R.createDecorator)("sharedTunnelsService");var T;(function(S){S.Http="http",S.Https="https"})(T=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(S){S.ConstantPrivate="constantPrivate",S.Private="private",S.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var w;(function(S){S[S.Notify=1]="Notify",S[S.OpenBrowser=2]="OpenBrowser",S[S.OpenPreview=3]="OpenPreview",S[S.Silent=4]="Silent",S[S.Ignore=5]="Ignore",S[S.OpenBrowserOnce=6]="OpenBrowserOnce"})(w=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function E(S){if(S.scheme!=="http"&&S.scheme!=="https")return;const C=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(S.authority);if(!!C)return{address:C[1],port:+C[2]}}e.extractLocalHostUriMetaDataForPortMapping=E,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(S){return e.LOCALHOST_ADDRESSES.indexOf(S)>=0}e.isLocalhost=I,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(S){return e.ALL_INTERFACES_ADDRESSES.indexOf(S)>=0}e.isAllInterfaces=b;function p(S,C){return C?C!==1&&S<1024:!r.isWindows&&S<1024}e.isPortPrivileged=p;class v{constructor(C,g,f){this.remoteAddress=C,this.localAddress=g,this._dispose=f,this._onDispose=new D.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=v;let h=class{constructor(C){this.logService=C,this._onTunnelOpened=new D.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new D.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new D.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(C){return this._tunnelProvider=C,C?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(C){this._canElevate=C.elevation,this._privacyOptions=C.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const C=[],g=Array.from(this._tunnels.values());for(const f of g){const a=Array.from(f.values());for(const d of a){const c=await d.value;c&&C.push(c)}}return C}async dispose(){for(const C of this._tunnels.values()){for(const{value:g}of C.values())await g.then(f=>f?.dispose());C.clear()}this._tunnels.clear()}setEnvironmentTunnel(C,g,f,a,d){this.addTunnelToMap(C,g,Promise.resolve({tunnelRemoteHost:C,tunnelRemotePort:g,localAddress:f,privacy:a,protocol:d,dispose:()=>Promise.resolve()}))}openTunnel(C,g,f,a,d=!1,c,i){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${f} on local port ${a}.`),!C)return;if(g||(g="localhost"),this._tunnelProvider&&this._factoryInProgress.has(f)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const o=this.retainOrCreateTunnel(C,g,f,a,d,c,i);return o?o.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(g,f);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(t);return(t.tunnelRemoteHost!==g||t.tunnelRemotePort!==f)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}makeTunnel(C){return{tunnelRemotePort:C.tunnelRemotePort,tunnelRemoteHost:C.tunnelRemoteHost,tunnelLocalPort:C.tunnelLocalPort,localAddress:C.localAddress,privacy:C.privacy,protocol:C.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${C.tunnelRemoteHost}:${C.tunnelRemotePort} `);const g=this._tunnels.get(C.tunnelRemoteHost);if(g){const f=g.get(C.tunnelRemotePort);f&&(f.refcount--,await this.tryDisposeTunnel(C.tunnelRemoteHost,C.tunnelRemotePort,f))}}}}async tryDisposeTunnel(C,g,f){if(f.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${C}:${g}.`);const a=f.value.then(async d=>{d&&(await d.dispose(!0),this._onTunnelClosed.fire({host:d.tunnelRemoteHost,port:d.tunnelRemotePort}))});return this._tunnels.has(C)&&this._tunnels.get(C).delete(g),a}}async closeTunnel(C,g){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${C}:${g} `);const f=this._tunnels.get(C);if(f&&f.has(g)){const a=f.get(g);a.refcount=0,await this.tryDisposeTunnel(C,g,a)}}addTunnelToMap(C,g,f){this._tunnels.has(C)||this._tunnels.set(C,new Map),this._tunnels.get(C).set(g,{refcount:1,value:f})}async removeEmptyTunnelFromMap(C,g){const f=this._tunnels.get(C);f&&(await f.get(g)||f.delete(g),f.size===0&&this._tunnels.delete(C))}getTunnelFromMap(C,g){const f=[C];I(C)?(f.push(...e.LOCALHOST_ADDRESSES),f.push(...e.ALL_INTERFACES_ADDRESSES)):b(C)&&f.push(...e.ALL_INTERFACES_ADDRESSES);const a=f.map(d=>this._tunnels.get(d));for(const d of a){const c=d?.get(g);if(c)return c}}canTunnel(C){return!!E(C)}doIsPortPrivileged(C,g,f,a){if(g)return!1;if(f){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(a);if(d?.length===4){const c=parseInt(d[1]),i=parseInt(d[2]);if(c>10||c===10&&i>=14)return!1}}return C<1024}createWithProvider(C,g,f,a,d,c,i){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${f} on local port ${a}.`);const o=f;this._factoryInProgress.add(o);const t=a===void 0?f:a,n={elevationRequired:d?this.isPortPrivileged(t):!1},s={remoteAddress:{host:g,port:f},localAddressPort:a,privacy:c,public:c?c!==P.Private:void 0,protocol:i},u=C.forwardPort(s,n);return u?(this.addTunnelToMap(g,f,u),u.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(o)})):this._factoryInProgress.delete(o),u}};h=pe([Y(0,L.ILogService)],h),e.AbstractTunnelService=h}),define(ne[233],re([0,1,8,74,2,9,6]),function(Q,e,D,r,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class P extends R.Disposable{constructor(){super(),this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new T.DeferredPromise),this._addressPromise.p)}setAddress(I){this._address=I,this._addressPromise&&(this._addressPromise.complete(I),this._addressPromise=null)}setTunnel(I){this._register(I)}}let w=class Dt extends R.Disposable{constructor(I,b){super(),this._tunnelService=I,this._logService=b,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(I=>I.dispose())}async createTunnel(){return{id:String(++Dt._lastId)}}async startTunnel(I,b,p,v,h,S){const C=new P,g=await Promise.resolve(this._tunnelService.openTunnel(I,C,p,v,h,S));if(!g)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${p}:${v} (remote).`),C.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(b))throw this._disposedTunnels.delete(b),C.dispose(),await g.dispose(),(0,L.canceled)();return C.setTunnel(g),this._tunnels.set(b,C),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${b}: ${g.localAddress} (local) to ${p}:${v} (remote).`),{tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress}}async setAddress(I,b){const p=this._tunnels.get(I);!p||p.setAddress(b)}async destroyTunnel(I){const b=this._tunnels.get(I);if(b){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${I}.`),this._tunnels.delete(I),await b.dispose();return}this._disposedTunnels.add(I)}};w._lastId=0,w=pe([Y(0,r.ISharedTunnelsService),Y(1,D.ILogService)],w),e.SharedProcessTunnelService=w}),define(ne[234],re([0,1,81,36,120,209,6,2,17,8,25,207,74,103,4]),function(Q,e,D,r,R,L,T,P,w,E,I,b,p,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function S(d,c,i,o,t){let n;for(let s=3;s&&(n?.dispose(),n=await new C(d,c,i,o,t).waitForReady(),!(t&&R.BROWSER_RESTRICTED_PORTS[t]||!R.BROWSER_RESTRICTED_PORTS[n.tunnelLocalPort]));s--);return n}class C extends P.Disposable{constructor(c,i,o,t,n){super(),this.defaultTunnelHost=i,this.suggestedLocalPort=n,this.privacy=p.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=c,this._server=D.createServer(),this._barrier=new T.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=t,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(i=>{i()})}async waitForReady(){let c=await(0,R.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),i=null;return this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),i=this._server.address(),i||(c=0,this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),i=this._server.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async _onConnection(c){c.pause();const i=(0,p.isLocalhost)(this.tunnelRemoteHost)||(0,p.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,o=await(0,b.connectRemoteAgentTunnel)(this._options,i,this.tunnelRemotePort),t=o.getSocket().socket,n=o.readEntireBuffer();o.dispose(),n.byteLength>0&&c.write(n.buffer),c.on("end",()=>{c.localAddress&&this._socketsDispose.delete(c.localAddress),t.end()}),c.on("close",()=>t.end()),c.on("error",()=>{c.localAddress&&this._socketsDispose.delete(c.localAddress),t.destroy()}),t.on("end",()=>c.end()),t.on("close",()=>c.end()),t.on("error",()=>{c.destroy()}),c.pipe(t),t.pipe(c),c.localAddress&&this._socketsDispose.set(c.localAddress,()=>{c.end(),t.end()})}}let g=class extends p.AbstractTunnelService{constructor(c,i,o,t,n){super(i),this.socketFactory=c,this.signService=o,this.productService=t,this.configurationService=n}get defaultTunnelHost(){const c=this.configurationService.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}isPortPrivileged(c){return this.doIsPortPrivileged(c,h.isWindows,h.isMacintosh,r.release())}retainOrCreateTunnel(c,i,o,t,n,s,u){const l=this.getTunnelFromMap(i,o);if(l)return++l.refcount,l.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,i,o,t,n,s,u);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${i}:${o} on local port ${t}.`);const m={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:c,signService:this.signService,logService:this.logService,ipcLogger:null},y=S(m,this.defaultTunnelHost,i,o,t);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(i,o,y),y}}};g=pe([Y(1,E.ILogService),Y(2,v.ISignService),Y(3,I.IProductService),Y(4,w.IConfigurationService)],g),e.BaseTunnelService=g;let f=class extends g{constructor(c,i,o,t){super(L.nodeSocketFactory,c,i,o,t)}};f=pe([Y(0,E.ILogService),Y(1,v.ISignService),Y(2,I.IProductService),Y(3,w.IConfigurationService)],f),e.TunnelService=f;let a=class extends P.Disposable{constructor(c,i,o,t){super(),this.logService=c,this.productService=i,this.signService=o,this.configurationService=t,this._tunnelServices=new Map}async openTunnel(c,i,o,t,n,s,u,l){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${o}:${t} on local port ${n}.`),!this._tunnelServices.has(c)){const m=new f(this.logService,this.signService,this.productService,this.configurationService);this._register(m),this._tunnelServices.set(c,m),m.onTunnelClosed(async()=>{(await m.tunnels).length===0&&(m.dispose(),this._tunnelServices.delete(c))})}return this._tunnelServices.get(c).openTunnel(i,o,t,n,s,u,l)}};a=pe([Y(0,E.ILogService),Y(1,I.IProductService),Y(2,v.ISignService),Y(3,w.IConfigurationService)],a),e.SharedTunnelsService=a}),define(ne[31],re([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(ne[235],re([0,1,3,2,7,14,33,13,8,31]),function(Q,e,D,r,R,L,T,P,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let I=class extends r.Disposable{constructor(p,v,h,S,C){super(),this.extensionsManagementService=p,this.logService=S,this.uriIdentityService=C,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(f=>{this.installedExtensions=f.map(a=>a.identifier),this.startTimestamp=Date.now()}),this._register(p.onInstallExtension(f=>this.onInstallExtension(f))),this._register(p.onDidInstallExtensions(f=>this.onDidInstallExtensions(f))),this._register(p.onDidUninstallExtension(f=>this.onDidUninstallExtension(f)));const g=R.URI.file(h.extensionsPath);this._register(v.watch(g)),this._register(D.Event.filter(v.onDidFilesChange,f=>f.rawChanges.some(a=>this.doesChangeAffects(a,g)))(()=>this.onDidChange()))}doesChangeAffects(p,v){return p.type!==1&&p.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(p.resource),v)?!1:this.uriIdentityService.extUri.isEqual(p.resource,this.uriIdentityService.extUri.joinPath(v,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(p.resource).startsWith(".")}onInstallExtension(p){this.addInstallingExtension(p.identifier)}onDidInstallExtensions(p){for(const v of p)this.removeInstallingExtension(v.identifier),v.local&&this.addInstalledExtension(v.identifier)}onDidUninstallExtension(p){p.error||this.removeInstalledExtension(p.identifier)}addInstallingExtension(p){this.removeInstallingExtension(p),this.installingExtensions.push(p)}removeInstallingExtension(p){this.installingExtensions=this.installingExtensions.filter(v=>!(0,T.areSameExtensions)(v,p))}addInstalledExtension(p){this.installedExtensions&&(this.removeInstalledExtension(p),this.installedExtensions.push(p))}removeInstalledExtension(p){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(v=>!(0,T.areSameExtensions)(v,p)))}async onDidChange(){if(this.installedExtensions){const p=await this.extensionsManagementService.getInstalled(),v=p.filter(S=>[...this.installingExtensions,...this.installedExtensions].some(C=>(0,T.areSameExtensions)(C,S.identifier))?!1:S.installedTimestamp&&S.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",S.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",S.identifier.id),!1)),h=this.installedExtensions.filter(S=>this.installingExtensions.some(C=>(0,T.areSameExtensions)(C,S))?!1:p.every(C=>!(0,T.areSameExtensions)(C.identifier,S))?(this.logService.info("Detected extension removed from another source",S.id),!0):!1);this.installedExtensions=p.map(S=>S.identifier),(v.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:v,removed:h})}}};I=pe([Y(1,P.IFileService),Y(2,L.INativeEnvironmentService),Y(3,w.ILogService),Y(4,E.IUriIdentityService)],I),e.ExtensionsWatcher=I}),define(ne[236],re([0,1,31,92,13,19,118,3,2]),function(Q,e,D,r,R,L,T,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class E{constructor(p){this.uri=p,this.time=E._clock++}touch(){return this.time=E._clock++,this}}E._clock=0;let I=class{constructor(p){this._fileService=p,this._dispooables=new w.DisposableStore,this._limit=2**16;const v=new Map,h=S=>{let C=v.get(S.scheme);return C===void 0&&(C=p.hasProvider(S)&&!this._fileService.hasCapability(S,1024),v.set(S.scheme,C)),C};this._dispooables.add(P.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(S=>{v.delete(S.scheme)})),this.extUri=new L.ExtUri(h),this._canonicalUris=new T.SkipList((S,C)=>this.extUri.compare(S,C,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(p){this._fileService.hasProvider(p)&&(p=(0,L.normalizePath)(p));const v=this._canonicalUris.get(p);return v?v.touch().uri.with({fragment:p.fragment}):(this._canonicalUris.set(p,new E(p)),this._checkTrim(),p)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const p=[...this._canonicalUris.entries()].sort((h,S)=>h[1].touch<S[1].touch?1:h[1].touch>S[1].touch?-1:0);E._clock=0,this._canonicalUris.clear();const v=this._limit*.5;for(let h=0;h<v;h++)this._canonicalUris.set(p[h][0],p[h][1].touch())}};I=pe([Y(0,R.IFileService)],I),e.UriIdentityService=I,(0,r.registerSingleton)(D.IUriIdentityService,I,1)}),define(ne[237],re([0,1,3,2,13,42,34,16]),function(Q,e,D,r,R,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class w extends r.Disposable{get capabilities(){return this.fileSystemProvider.capabilities&-5}constructor(I,b,p,v){super(),this.fileSystemScheme=I,this.fileSystemProvider=b,this.userDataScheme=p,this.logService=v,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=T.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(h=>this.handleFileChanges(h)))}watch(I,b){this.watchResources.set(I,I);const p=this.fileSystemProvider.watch(this.toFileSystemResource(I),b);return(0,r.toDisposable)(()=>{this.watchResources.delete(I),p.dispose()})}stat(I){return this.fileSystemProvider.stat(this.toFileSystemResource(I))}mkdir(I){return this.fileSystemProvider.mkdir(this.toFileSystemResource(I))}rename(I,b,p){return this.fileSystemProvider.rename(this.toFileSystemResource(I),this.toFileSystemResource(b),p)}readFile(I){return this.fileSystemProvider.readFile(this.toFileSystemResource(I),{atomic:!0})}readFileStream(I,b,p){const v=(0,L.newWriteableStream)(h=>P.VSBuffer.concat(h.map(S=>P.VSBuffer.wrap(S))).buffer);return(async()=>{try{const h=await this.readFile(I);v.end(h)}catch(h){v.error(h),v.end()}})(),v}readdir(I){return this.fileSystemProvider.readdir(this.toFileSystemResource(I))}writeFile(I,b,p){return this.fileSystemProvider.writeFile(this.toFileSystemResource(I),b,p)}delete(I,b){return this.fileSystemProvider.delete(this.toFileSystemResource(I),b)}copy(I,b,p){if((0,R.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(I),this.toFileSystemResource(b),p);throw new Error("copy not supported")}handleFileChanges(I){const b=[];for(const p of I){if(p.resource.scheme!==this.fileSystemScheme)continue;const v=this.toUserDataResource(p.resource);this.watchResources.findSubstr(v)&&b.push({resource:v,type:p.type})}b.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(b))}toFileSystemResource(I){return I.with({scheme:this.fileSystemScheme})}toUserDataResource(I){return I.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=w}),define(ne[61],re([0,1,80]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function r(T,P,w,E){const I=(0,D.setProperty)(T,P,w,E)[0];return I&&(T=T.substring(0,I.offset)+I.content+T.substring(I.offset+I.length)),T}e.edit=r;function R(T,P,w){let E=w;for(;E>=0;){if(T.charAt(E)===P.charAt(P.length-1)&&P.length===1)return E+1;if(E--,P.length===2&&E>=0&&T.charAt(E)===P.charAt(0))return E+2}return 0}e.getLineStartOffset=R;function L(T,P,w){let E=w;for(;E>=0;)if(T.charAt(E)===P.charAt(P.length-1)&&P.length===1||(E++,P.length===2&&E>=0&&T.charAt(E)===P.charAt(1)))return E;return T.length-1}e.getLineEndOffset=L}),define(ne[238],re([0,1,32,55,15]),function(Q,e,D,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(v,h,S,C,g,f){const a=[],d=[],c=[];if(!h){const F=v.filter(({identifier:q})=>g.every(J=>J.toLowerCase()!==q.id.toLowerCase()));return{local:{added:a,removed:d,updated:c},remote:F.length>0?{added:F,updated:[],removed:[],all:F}:null}}v=v.map(b),h=h.map(b),S=S?S.map(b):null;const i=new Map,o=F=>{F.uuid&&i.set(F.id.toLowerCase(),F.uuid)};v.forEach(({identifier:F})=>o(F)),h.forEach(({identifier:F})=>o(F)),S?.forEach(({identifier:F})=>o(F));const t=F=>{const q=F.identifier.uuid||i.get(F.identifier.id.toLowerCase());return q?`uuid:${q}`:`id:${F.identifier.id.toLowerCase()}`},n=(F,q)=>(F.set(t(q),q),F),s=v.reduce(n,new Map),u=h.reduce(n,new Map),l=h.reduce((F,q)=>n(F,(0,D.deepClone)(q)),new Map),m=S?S.reduce(n,new Map):null,y=C.reduce(n,new Map),_=g.reduce((F,q)=>{const J=i.get(q.toLowerCase());return F.add(J?`uuid:${J}`:`id:${q.toLowerCase()}`)},new Set),$=f.reduce((F,{id:q,uuid:J})=>(J=J??i.get(q.toLowerCase()),F.add(J?`uuid:${J}`:`id:${q.toLowerCase()}`)),new Set),A=T(s,u,_,!1);if(A.added.size>0||A.removed.size>0||A.updated.size>0){const F=T(m,s,_,!1),q=T(m,u,_,!0),J=(j,H,W,z)=>({...z,installed:H.installed||W.installed,version:W.version&&(!H.installed||r.gt(W.version,H.version))?W.version:H.version,state:w(H,W,m?.get(j)),preRelease:(H.installed?z.preRelease:W.preRelease)??H.preRelease});for(const j of q.removed.values()){const H=s.get(j);if(!H)continue;const W=(0,R.assertIsDefined)(m?.get(j)),z=!$.has(j)&&W.installed;H.installed&&z?d.push(H.identifier):l.set(j,H)}for(const j of q.added.values()){const H=(0,R.assertIsDefined)(u.get(j)),W=s.get(j);if(W){if(A.updated.has(j)){const z=J(j,W,H,H);P(W,H,!1,!1)||c.push(p(z,j)),l.set(j,z)}}else H.installed&&a.push(p(H,j))}for(const j of q.updated.values()){const H=(0,R.assertIsDefined)(u.get(j)),W=(0,R.assertIsDefined)(m?.get(j)),z=s.get(j);if(z)if(!$.has(j)&&W.installed&&z.installed&&!H.installed)d.push(z.identifier);else{const X=J(j,z,H,H);c.push(p(X,j)),l.set(j,X)}else H.installed&&a.push(p(H,j))}for(const j of F.added.values())q.added.has(j)||l.set(j,(0,R.assertIsDefined)(s.get(j)));for(const j of F.updated.values()){if(q.removed.has(j)||q.updated.has(j))continue;const H=(0,R.assertIsDefined)(s.get(j)),W=(0,R.assertIsDefined)(u.get(j));l.set(j,J(j,H,W,H))}for(const j of F.removed.values())q.updated.has(j)||q.removed.has(j)||y.has(j)||!(0,R.assertIsDefined)(u.get(j)).installed||$.has(j)||!(0,R.assertIsDefined)(m?.get(j)).installed||l.delete(j)}const U=[],k=T(u,l,new Set,!0),N=k.added.size>0||k.updated.size>0||k.removed.size>0;return N&&l.forEach((F,q)=>U.push(p(F,q))),{local:{added:a,removed:d,updated:c},remote:N?{added:[...k.added].map(F=>l.get(F)),updated:[...k.updated].map(F=>l.get(F)),removed:[...k.removed].map(F=>u.get(F)),all:U}:null}}e.merge=L;function T(v,h,S,C){const g=v?[...v.keys()].filter(i=>!S.has(i)):[],f=[...h.keys()].filter(i=>!S.has(i)),a=f.filter(i=>g.indexOf(i)===-1).reduce((i,o)=>(i.add(o),i),new Set),d=g.filter(i=>f.indexOf(i)===-1).reduce((i,o)=>(i.add(o),i),new Set),c=new Set;for(const i of g){if(d.has(i))continue;const o=v.get(i),t=h.get(i);(!t||!P(o,t,C,!0))&&c.add(i)}return{added:a,removed:d,updated:c}}function P(v,h,S,C){return!(v.disabled!==h.disabled||C&&v.installed!==h.installed||v.installed&&h.installed&&v.preRelease!==h.preRelease||!I(v.state,h.state)||S&&v.version!==h.version)}function w(v,h,S){const C=v.state,g=h.state,f=S?.state;if(!h.version||C&&r.gt(v.version,h.version))return C;if(g&&r.gt(h.version,v.version)||!C)return g;if(!g)return C;const a=(0,D.deepClone)(C),d=f?E(f,g):{added:Object.keys(g).reduce((i,o)=>(i.add(o),i),new Set),removed:new Set,updated:new Set},c=f?E(f,C):{added:Object.keys(C).reduce((i,o)=>(i.add(o),i),new Set),removed:new Set,updated:new Set};for(const i of[...d.added.values(),...d.updated.values()])a[i]=g[i];for(const i of d.removed.values())c.updated.has(i)||delete a[i];return a}function E(v,h){const S=Object.keys(v),C=Object.keys(h),g=C.filter(d=>S.indexOf(d)===-1).reduce((d,c)=>(d.add(c),d),new Set),f=S.filter(d=>C.indexOf(d)===-1).reduce((d,c)=>(d.add(c),d),new Set),a=new Set;for(const d of S){if(f.has(d))continue;const c=v[d],i=h[d];(0,D.equals)(c,i)||a.add(d)}return{added:g,removed:f,updated:a}}function I(v={},h={}){const{added:S,removed:C,updated:g}=E(v,h);return S.size===0&&C.size===0&&g.size===0}function b(v){return{...v,disabled:!!v.disabled,installed:!!v.installed}}function p(v,h){const S={identifier:{id:v.identifier.id,uuid:h.startsWith("uuid:")?h.substring(5):void 0},preRelease:!!v.preRelease};return v.version&&(S.version=v.version),v.disabled&&(S.disabled=!0),v.installed&&(S.installed=!0),v.state&&(S.state=v.state),S}}),define(ne[110],re([0,1,18,17,5]),function(Q,e,D,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,R.createDecorator)("IIgnoredExtensionsManagementService");let L=class{constructor(P){this.configurationService=P}hasToNeverSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,w){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return E=E.filter(I=>I!==P&&I!==`-${P}`),w&&E.push(P.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,2)}updateSynchronizedExtensions(P,w){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return E=E.filter(I=>I!==P&&I!==`-${P}`),w&&E.push(`-${P.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,2)}getIgnoredExtensions(P){const w=P.filter(p=>p.isMachineScoped).map(p=>p.identifier.id.toLowerCase()),E=this.getConfiguredIgnoredExtensions().map(p=>p.toLowerCase()),I=[],b=[];if(Array.isArray(E))for(const p of E)p.startsWith("-")?b.push(p.substring(1)):I.push(p);return(0,D.distinct)([...w,...I].filter(p=>b.indexOf(p)===-1))}getConfiguredIgnoredExtensions(){let P=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.configurationService.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(w=>w.toLowerCase())}};L=pe([Y(0,r.IConfigurationService)],L),e.IgnoredExtensionsManagementService=L}),define(ne[239],re([0,1,18,35,32,179,61]),function(Q,e,D,r,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(d){return(0,r.parse)(d)||[]}e.parseKeybindings=P;async function w(d,c,i,o,t){const n=P(d),s=P(c),u=i?P(i):null,l=[...n,...s,...u||[]].map(J=>J.key),m=await t.resolveUserBindings(l),y=I(n,s,u,m);if(!y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:d,hasChanges:!1,hasConflicts:!1};if(!y.hasLocalForwarded&&y.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};if(y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:d,hasChanges:!0,hasConflicts:!1};const _=p(n),$=p(s),A=u?p(u):null,U=h(_,$,m),k=A?h(A,_,m):{added:[..._.keys()].reduce((J,j)=>(J.add(j),J),new Set),removed:new Set,updated:new Set},N=A?h(A,$,m):{added:[...$.keys()].reduce((J,j)=>(J.add(j),J),new Set),removed:new Set,updated:new Set},F=E(U,k,N);let q=d;for(const J of F.removed.values())F.conflicts.has(J)||(q=f(q,J,o));for(const J of F.added.values()){if(F.conflicts.has(J))continue;const j=$.get(J);if(j.some(H=>H.command!==`-${J}`&&y.conflicts.has(m[H.key]))){F.conflicts.add(J);continue}q=g(q,j,o)}for(const J of F.updated.values()){if(F.conflicts.has(J))continue;const j=$.get(J);if(j.some(H=>H.command!==`-${J}`&&y.conflicts.has(m[H.key]))){F.conflicts.add(J);continue}q=a(q,J,j,o)}return{mergeContent:q,hasChanges:!0,hasConflicts:F.conflicts.size>0}}e.merge=w;function E(d,c,i){const o=new Set,t=new Set,n=new Set,s=new Set;for(const u of c.removed.values())i.updated.has(u)&&s.add(u);for(const u of i.removed.values())s.has(u)||(c.updated.has(u)?s.add(u):t.add(u));for(const u of c.added.values())s.has(u)||i.added.has(u)&&d.updated.has(u)&&s.add(u);for(const u of i.added.values())s.has(u)||(c.added.has(u)?d.updated.has(u)&&s.add(u):o.add(u));for(const u of c.updated.values())s.has(u)||i.updated.has(u)&&d.updated.has(u)&&s.add(u);for(const u of i.updated.values())s.has(u)||(c.updated.has(u)?d.updated.has(u)&&s.add(u):n.add(u));return{added:o,removed:t,updated:n,conflicts:s}}function I(d,c,i,o){const t=new Set,n=b(d,o),s=b(c,o),u=i?b(i,o):null,l=v(n,s);if(l.added.size===0&&l.removed.size===0&&l.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const m=u?v(u,n):{added:[...n.keys()].reduce((k,N)=>(k.add(N),k),new Set),removed:new Set,updated:new Set};if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:t,removed:t,updated:t,conflicts:t};const y=u?v(u,s):{added:[...s.keys()].reduce((k,N)=>(k.add(N),k),new Set),removed:new Set,updated:new Set};if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const{added:_,removed:$,updated:A,conflicts:U}=E(l,m,y);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:_,removed:$,updated:A,conflicts:U}}function b(d,c){const i=new Map;for(const o of d){const t=c[o.key];let n=i.get(t);n||(n=[],i.set(t,n)),n.push(o)}return i}function p(d){const c=new Map;for(const i of d){const o=i.command[0]==="-"?i.command.substring(1):i.command;let t=c.get(o);t||(t=[],c.set(o,t)),t.push(i)}return c}function v(d,c){const i=[...d.keys()],o=[...c.keys()],t=o.filter(u=>i.indexOf(u)===-1).reduce((u,l)=>(u.add(l),u),new Set),n=i.filter(u=>o.indexOf(u)===-1).reduce((u,l)=>(u.add(l),u),new Set),s=new Set;for(const u of i){if(n.has(u))continue;const l=d.get(u).map(y=>({...y,key:u})),m=c.get(u).map(y=>({...y,key:u}));(0,D.equals)(l,m,(y,_)=>C(y,_))||s.add(u)}return{added:t,removed:n,updated:s}}function h(d,c,i){const o=[...d.keys()],t=[...c.keys()],n=t.filter(l=>o.indexOf(l)===-1).reduce((l,m)=>(l.add(m),l),new Set),s=o.filter(l=>t.indexOf(l)===-1).reduce((l,m)=>(l.add(m),l),new Set),u=new Set;for(const l of o){if(s.has(l))continue;const m=d.get(l).map(_=>({..._,key:i[_.key]})),y=c.get(l).map(_=>({..._,key:i[_.key]}));S(m,y)||u.add(l)}return{added:n,removed:s,updated:u}}function S(d,c){return!(!(0,D.equals)(d.filter(({command:i})=>i[0]!=="-"),c.filter(({command:i})=>i[0]!=="-"),(i,o)=>C(i,o))||!(0,D.equals)(d.filter(({command:i})=>i[0]==="-"),c.filter(({command:i})=>i[0]==="-"),(i,o)=>C(i,o)))}function C(d,c){if(d.command!==c.command||d.key!==c.key)return!1;const i=L.ContextKeyExpr.deserialize(d.when),o=L.ContextKeyExpr.deserialize(c.when);return!(i&&!o||!i&&o||i&&o&&!i.equals(o)||!R.equals(d.args,c.args))}function g(d,c,i){for(const o of c)d=T.edit(d,[-1],o,i);return d}function f(d,c,i){const o=P(d);for(let t=o.length-1;t>=0;t--)(o[t].command===c||o[t].command===`-${c}`)&&(d=T.edit(d,[t],void 0,i));return d}function a(d,c,i,o){const t=P(d),n=t.findIndex(s=>s.command===c||s.command===`-${c}`);for(let s=t.length-1;s>=0;s--)(t[s].command===c||t[s].command===`-${c}`)&&(d=T.edit(d,[s],void 0,o));for(let s=i.length-1;s>=0;s--)d=T.edit(d,[n],i[s],o);return d}}),define(ne[240],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function D(L,T,P){const w={},E={},I=new Set;if(!T)return{local:{added:w,updated:E,removed:[...I.values()]},remote:{added:L,updated:{},removed:[]},conflicts:[]};const b=r(L,T);if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{local:{added:w,updated:E,removed:[...I.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const p=r(P,L),v=r(P,T),h={},S={},C=new Set,g=new Set;for(const f of p.removed.values())v.updated.has(f)?w[f]=T[f]:C.add(f);for(const f of v.removed.values())g.has(f)||(p.updated.has(f)?g.add(f):I.add(f));for(const f of p.updated.values())g.has(f)||(v.updated.has(f)?b.updated.has(f)&&g.add(f):S[f]=L[f]);for(const f of v.updated.values())g.has(f)||(p.updated.has(f)?b.updated.has(f)&&g.add(f):L[f]!==void 0&&(E[f]=T[f]));for(const f of p.added.values())g.has(f)||(v.added.has(f)?b.updated.has(f)&&g.add(f):h[f]=L[f]);for(const f of v.added.values())g.has(f)||(p.added.has(f)?b.updated.has(f)&&g.add(f):w[f]=T[f]);return{local:{added:w,removed:[...I.values()],updated:E},remote:{added:h,removed:[...C.values()],updated:S},conflicts:[...g.values()]}}e.merge=D;function r(L,T){const P=L?Object.keys(L):[],w=T?Object.keys(T):[],E=w.filter(p=>P.indexOf(p)===-1).reduce((p,v)=>(p.add(v),p),new Set),I=P.filter(p=>w.indexOf(p)===-1).reduce((p,v)=>(p.add(v),p),new Set),b=new Set;for(const p of P){if(I.has(p))continue;const v=L[p],h=T[p];v!==h&&b.add(p)}return{added:E,removed:I,updated:b}}function R(L,T){const{added:P,removed:w,updated:E}=r(L,T);return P.size===0&&w.size===0&&E.size===0}e.areSame=R}),define(ne[241],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(R,L,T,P){const w={local:{added:[],removed:[],updated:[]},remote:{added:[],removed:[],updated:[]}};if(!L){const I=R.filter(({id:b})=>!P.includes(b));return I.length?w.remote.added=I:w.remote=null,w}const E=r(R,L,P);if(E.added.length>0||E.removed.length>0||E.updated.length>0){const I=r(T,R,P),b=r(T,L,P);for(const p of b.removed){const v=R.find(h=>h.id===p);v&&w.local.removed.push(v)}for(const p of b.added){const v=L.find(h=>h.id===p);I.added.includes(p)?E.updated.includes(p)&&w.local.updated.push(v):w.local.added.push(v)}for(const p of b.updated)w.local.updated.push(L.find(v=>v.id===p));for(const p of I.added)b.added.includes(p)||w.remote.added.push(R.find(v=>v.id===p));for(const p of I.updated)b.removed.includes(p)||b.updated.includes(p)||w.remote.updated.push(R.find(v=>v.id===p));for(const p of I.removed)w.remote.removed.push(L.find(v=>v.id===p))}return w.remote.added.length===0&&w.remote.removed.length===0&&w.remote.updated.length===0&&(w.remote=null),w}e.merge=D;function r(R,L,T){R=R?R.filter(({id:p})=>!T.includes(p)):[],L=L.filter(({id:p})=>!T.includes(p));const P=R.map(({id:p})=>p),w=L.map(({id:p})=>p),E=w.filter(p=>P.indexOf(p)===-1),I=P.filter(p=>w.indexOf(p)===-1),b=[];for(const{id:p,name:v,shortName:h}of R){if(I.includes(p))continue;const S=L.find(C=>C.id===p);(!S||S.name!==v||S.shortName!==h)&&b.push(p)}return{added:E,removed:I,updated:b}}}),define(ne[26],re([0,1,18,15,167,43,29,5,100,40]),function(Q,e,D,r,R,L,T,P,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function I(){const s=E.Registry.as(L.Extensions.Configuration).getConfigurationProperties();return Object.keys(s).filter(u=>!!s[u].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=I;function b(){const s=E.Registry.as(L.Extensions.Configuration).getConfigurationProperties(),u=Object.keys(s).filter(y=>!!s[y].ignoreSync),l=Object.keys(s).filter(y=>s[y].scope===2||s[y].scope===6),m=I();return(0,D.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...u,...l,...m])}e.getDefaultIgnoredSettings=b,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function p(){const s="vscode://schemas/ignoredSettings",u=E.Registry.as(L.Extensions.Configuration);u.registerConfiguration({id:"settingsSync",order:30,title:(0,R.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,R.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,R.localize)(2,null),items:[{type:"string",pattern:T.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,R.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,R.localize)(4,null),default:[],scope:1,$ref:s,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const l=E.Registry.as(w.Extensions.JSONContribution),m=()=>{const y=I(),_=b().filter(k=>k!==e.CONFIGURATION_SYNC_STORE_KEY),$=Object.keys(L.allSettings.properties).filter(k=>_.indexOf(k)===-1),A=_.filter(k=>y.indexOf(k)===-1),U={items:{type:"string",enum:[...$,...A.map(k=>`-${k}`)]}};l.registerSchema(s,U)};return u.onDidUpdateConfiguration(()=>m())}e.registerConfiguration=p;function v(s){return s&&(0,r.isObject)(s)&&(0,r.isString)(s.id)&&Array.isArray(s.scopes)}e.isAuthenticationProvider=v;var h;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState",s.Profiles="profiles"})(h=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function S(s,...u){return s?[s,...u]:u}e.getPathSegments=S;function C(s,u,l,m){return m.joinPath(l.userDataSyncHome,...S(s,u,`lastSync${u}.json`))}e.getLastSyncResourceUri=C,e.IUserDataSyncStoreManagementService=(0,P.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,P.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,P.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function g(s){const u={};return u[e.HEADER_EXECUTION_ID]=s,u}e.createSyncHeaders=g;var f;(function(s){s.Unauthorized="Unauthorized",s.Conflict="Conflict",s.Gone="Gone",s.PreconditionFailed="PreconditionFailed",s.TooLarge="TooLarge",s.UpgradeRequired="UpgradeRequired",s.PreconditionRequired="PreconditionRequired",s.TooManyRequests="RemoteTooManyRequests",s.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",s.RequestFailed="RequestFailed",s.RequestCanceled="RequestCanceled",s.RequestTimeout="RequestTimeout",s.RequestProtocolNotSupported="RequestProtocolNotSupported",s.RequestPathNotEscaped="RequestPathNotEscaped",s.RequestHeadersNotObject="RequestHeadersNotObject",s.NoCollection="NoCollection",s.NoRef="NoRef",s.EmptyResponse="EmptyResponse",s.TurnedOff="TurnedOff",s.SessionExpired="SessionExpired",s.ServiceChanged="ServiceChanged",s.DefaultServiceChanged="DefaultServiceChanged",s.LocalTooManyRequests="LocalTooManyRequests",s.LocalPreconditionFailed="LocalPreconditionFailed",s.LocalInvalidContent="LocalInvalidContent",s.LocalError="LocalError",s.IncompatibleLocalContent="IncompatibleLocalContent",s.IncompatibleRemoteContent="IncompatibleRemoteContent",s.UnresolvedConflicts="UnresolvedConflicts",s.Unknown="Unknown"})(f=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class a extends Error{constructor(u,l,m,y){super(u),this.code=l,this.resource=m,this.operationId=y,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=a;class d extends a{constructor(u,l,m,y,_){super(u,m,void 0,_),this.url=l,this.serverCode=y}}e.UserDataSyncStoreError=d;class c extends a{constructor(u,l){super(u,l)}}e.UserDataAutoSyncError=c,function(s){function u(l){if(l instanceof s)return l;const m=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(l.name);if(m&&m[1]){const y=m[2]==="unknown"?void 0:m[2],_=m[3]==="unknown"?void 0:m[3];return new s(l.message,m[1],y,_)}return new s(l.message,"Unknown")}s.toUserDataSyncError=u}(a=e.UserDataSyncError||(e.UserDataSyncError={}));var i;(function(s){s.Uninitialized="uninitialized",s.Idle="idle",s.Syncing="syncing",s.HasConflicts="hasConflicts"})(i=e.SyncStatus||(e.SyncStatus={}));var o;(function(s){s[s.None=0]="None",s[s.Added=1]="Added",s[s.Modified=2]="Modified",s[s.Deleted=3]="Deleted"})(o=e.Change||(e.Change={}));var t;(function(s){s.Preview="preview",s.Conflict="conflict",s.Accepted="accepted"})(t=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function n(s){return`sync.enable.${s}`}e.getEnablementKey=n,e.IUserDataSyncEnablementService=(0,P.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,P.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncService=(0,P.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,P.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,P.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(ne[242],re([0,1,32,26]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(P,w,E,I,b){if(!w)return{remote:Object.keys(P).length>0?P:null,local:{added:{},removed:[],updated:{}}};const p=L(P,w);if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const v=E?L(E,w):{added:Object.keys(w).reduce((f,a)=>(f.add(a),f),new Set),removed:new Set,updated:new Set},h=E?L(E,P):{added:Object.keys(P).reduce((f,a)=>(f.add(a),f),new Set),removed:new Set,updated:new Set},S={added:{},removed:[],updated:{}},C=D.deepClone(w),g=!E;for(const f of h.added.values())f!==r.SYNC_SERVICE_URL_TYPE&&g&&v.added.has(f)||(C[f]=P[f]);for(const f of h.updated.values())C[f]=P[f];for(const f of h.removed.values())I.unregistered.includes(f)||delete C[f];for(const f of v.added.values()){const a=w[f];if(I.machine.includes(f)){b.info(`GlobalState: Skipped adding ${f} in local storage because it is declared as machine scoped.`);continue}if(E&&h.added.has(f))continue;const d=P[f];d&&d.value===a.value||f===r.SYNC_SERVICE_URL_TYPE&&g&&h.added.has(f)||(d?S.updated[f]=a:S.added[f]=a)}for(const f of v.updated.values()){const a=w[f];if(I.machine.includes(f)){b.info(`GlobalState: Skipped updating ${f} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(f)||h.removed.has(f))continue;const d=P[f];d&&d.value===a.value||(S.updated[f]=a)}for(const f of v.removed.values()){if(I.machine.includes(f)){b.trace(`GlobalState: Skipped removing ${f} in local storage because it is declared as machine scoped.`);continue}h.updated.has(f)||h.removed.has(f)||S.removed.push(f)}return{local:S,remote:T(C,w)?null:C}}e.merge=R;function L(P,w){const E=Object.keys(P),I=Object.keys(w),b=I.filter(h=>E.indexOf(h)===-1).reduce((h,S)=>(h.add(S),h),new Set),p=E.filter(h=>I.indexOf(h)===-1).reduce((h,S)=>(h.add(S),h),new Set),v=new Set;for(const h of E){if(p.has(h))continue;const S=P[h],C=w[h];D.equals(S,C)||v.add(h)}return{added:b,removed:p,updated:v}}function T(P,w){const{added:E,removed:I,updated:b}=L(P,w);return E.size===0&&I.size===0&&b.size===0}}),define(ne[243],re([0,1,18,35,80,46,32,61,26]),function(Q,e,D,r,R,L,T,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function E(l,m,y){let _=[];y?_=b(y):_=I(m);const $=[],A=[...(0,w.getDisallowedIgnoredSettings)()];if(Array.isArray(_))for(const U of _)U.startsWith("-")?A.push(U.substring(1)):$.push(U);return(0,D.distinct)([...l,...$].filter(U=>A.indexOf(U)===-1))}e.getIgnoredSettings=E;function I(l){let m=l.inspect("settingsSync.ignoredSettings").userValue;return m!==void 0||(m=l.inspect("sync.ignoredSettings").userValue,m!==void 0)?m:l.getValue("settingsSync.ignoredSettings")||[]}function b(l){const m=(0,r.parse)(l);return m?m["settingsSync.ignoredSettings"]||m["sync.ignoredSettings"]||[]:[]}function p(l,m){const y=(0,r.parse)(l)||{};let _="{}";for(const $ of Object.keys(y)){const A=(0,R.setProperty)(_,[$],y[$],m);_=(0,R.applyEdits)(_,A)}return _}e.removeComments=p;function v(l,m,y,_){if(y.length){const $=u(m),A=(0,r.parse)(m)||{},U=(0,r.parse)(l);if(!U)return l;const k=[];for(const N of y){const F=A[N],q=U[N];F===void 0?l=P.edit(l,[N],void 0,_):q!==void 0?l=P.edit(l,[N],F,_):k.push(i(N,$))}k.sort((N,F)=>N.startOffset-F.startOffset),k.forEach(N=>l=f(N.setting.key,m,l,_))}return l}e.updateIgnoredSettings=v;function h(l,m,y,_,$,A){const U=v(l,m,_,A),k=y!==U,N=y!==m;if(!k&&!N)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(k&&!N)return{conflictsSettings:[],localContent:null,remoteContent:U,hasConflicts:!1};if(N&&!k)return{conflictsSettings:[],localContent:v(m,l,_,A),remoteContent:null,hasConflicts:!1};if(y===null&&C(l)){const V=S(l,m,_)?null:v(m,l,_,A);return{conflictsSettings:[],localContent:V,remoteContent:null,hasConflicts:!1}}let F=l,q=m;const J=(0,r.parse)(l),j=(0,r.parse)(m),H=y?(0,r.parse)(y):null,W=_.reduce((V,ee)=>(V.add(ee),V),new Set),z=g(J,j,W),K=g(H,J,W),X=g(H,j,W),ce=new Map,B=new Set,G=V=>{B.add(V);const ee=$.filter(({key:oe})=>oe===V)[0];ee?(F=P.edit(F,[V],ee.value,A),q=P.edit(q,[V],ee.value,A)):ce.set(V,{key:V,localValue:J[V],remoteValue:j[V]})};for(const V of K.removed.values())X.updated.has(V)?G(V):q=P.edit(q,[V],void 0,A);for(const V of X.removed.values())B.has(V)||(K.updated.has(V)?G(V):F=P.edit(F,[V],void 0,A));for(const V of K.updated.values())B.has(V)||(X.updated.has(V)?z.updated.has(V)&&G(V):q=P.edit(q,[V],J[V],A));for(const V of X.updated.values())B.has(V)||(K.updated.has(V)?z.updated.has(V)&&G(V):F=P.edit(F,[V],j[V],A));for(const V of K.added.values())B.has(V)||(X.added.has(V)?z.updated.has(V)&&G(V):q=f(V,F,q,A));for(const V of X.added.values())B.has(V)||(K.added.has(V)?z.updated.has(V)&&G(V):F=f(V,q,F,A));const O=ce.size>0||!S(F,q,_),M=O||!S(F,l,[]),x=O||!S(q,m,[]);return{localContent:M?F:null,remoteContent:x?q:null,conflictsSettings:[...ce.values()],hasConflicts:O}}e.merge=h;function S(l,m,y){if(l===m)return!0;const _=(0,r.parse)(l),$=(0,r.parse)(m),A=y.reduce((N,F)=>(N.add(F),N),new Set),U=u(l).filter(N=>!(N.setting&&A.has(N.setting.key))),k=u(m).filter(N=>!(N.setting&&A.has(N.setting.key)));if(U.length!==k.length)return!1;for(let N=0;N<U.length;N++){const F=U[N],q=k[N];if(F.setting&&q.setting){if(F.setting.key!==q.setting.key||!T.equals(_[F.setting.key],$[F.setting.key]))return!1}else if(!F.setting&&!q.setting){if(F.value!==q.value)return!1}else return!1}return!0}e.areSame=S;function C(l){return l?u(l).length===0:!0}e.isEmpty=C;function g(l,m,y){const _=l?Object.keys(l).filter(N=>!y.has(N)):[],$=Object.keys(m).filter(N=>!y.has(N)),A=$.filter(N=>_.indexOf(N)===-1).reduce((N,F)=>(N.add(F),N),new Set),U=_.filter(N=>$.indexOf(N)===-1).reduce((N,F)=>(N.add(F),N),new Set),k=new Set;if(l)for(const N of _){if(U.has(N))continue;const F=l[N],q=m[N];T.equals(F,q)||k.add(N)}return{added:A,removed:U,updated:k}}function f(l,m,y,_){const $=(0,r.parse)(m),A=u(m),U=u(y),k=a(l,A,U);return d(y,l,$[l],k,U,_)}e.addSetting=f;function a(l,m,y){const _=m.findIndex(A=>A.setting?.key===l),$=m[_-1];if($){if($.setting){const U=i($.setting.key,y);if(U)return{index:y.indexOf(U),insertAfter:!0}}else{const U=o(_,m);if(U){const k=i(U.setting.key,y);if(k){const N=t(y.indexOf(k),y),F=n(m,U,m[_]);if(N){const q=n(y,k,N),J=s(F,q);return J?{index:y.indexOf(J),insertAfter:!0}:{index:y.indexOf(N),insertAfter:!1}}else{const q=n(y,k,y[y.length-1]),J=s(F,q);return J?{index:y.indexOf(J),insertAfter:!0}:{index:y.length-1,insertAfter:!0}}}}}const A=m[_+1];if(A)if(A.setting){const U=i(A.setting.key,y);if(U)return{index:y.indexOf(U),insertAfter:!1}}else{const U=t(_,m);if(U){const k=i(U.setting.key,y);if(k){const N=o(y.indexOf(k),y),F=n(m,m[_],U);if(N){const q=n(y,N,k),J=s(F.reverse(),q.reverse());return J?{index:y.indexOf(J),insertAfter:!1}:{index:y.indexOf(N),insertAfter:!0}}else{const q=n(y,y[0],k),J=s(F.reverse(),q.reverse());return J?{index:y.indexOf(J),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:y.length-1,insertAfter:!0}}function d(l,m,y,_,$,A){let U;return _.index===-1?U=(0,R.setProperty)(l,[m],y,A):U=c(l,m,y,_,$,A).map(k=>(0,R.withFormatting)(l,k,A)[0]),(0,R.applyEdits)(l,U)}function c(l,m,y,_,$,A){const U=`${JSON.stringify(m)}: ${JSON.stringify(y)}`,k=(0,L.getEOL)(A,l),N=$[_.index];if(_.insertAfter){const F=[];if(N.setting)F.push({offset:N.endOffset,length:0,content:","+U});else{const q=t(_.index,$),J=o(_.index,$),j=J?.setting?.commaOffset;J&&j===void 0&&F.push({offset:J.endOffset,length:0,content:","});const H=j!==void 0&&j>N.endOffset;F.push({offset:H?j+1:N.endOffset,length:0,content:q?k+U+",":k+U})}return F}else{if(N.setting)return[{offset:N.startOffset,length:0,content:U+","}];const F=($[_.index-1]&&!$[_.index-1].setting?k:"")+U+(t(_.index,$)?",":"")+k;return[{offset:N.startOffset,length:0,content:F}]}}function i(l,m){return m.filter(y=>y.setting?.key===l)[0]}function o(l,m){for(let y=l-1;y>=0;y--)if(m[y].setting)return m[y]}function t(l,m){for(let y=l+1;y<m.length;y++)if(m[y].setting)return m[y]}function n(l,m,y){const _=l.indexOf(m),$=l.indexOf(y);return l.filter((A,U)=>_<U&&U<$)}function s(l,m){if(l.length&&m.length){let y=0;for(;y<m.length&&y<l.length;y++)if(l[y].value!==m[y].value)return m[y-1];return m[y-1]}}function u(l){const m=[];let y=-1,_,$;const A={onObjectBegin:U=>{y++},onObjectProperty:(U,k,N)=>{y===0&&(_=k,$=U)},onObjectEnd:(U,k)=>{y--,y===0&&m.push({startOffset:_,endOffset:U+k,value:l.substring(_,U+k),setting:{key:$,commaOffset:void 0}})},onArrayBegin:(U,k)=>{y++},onArrayEnd:(U,k)=>{y--,y===0&&m.push({startOffset:_,endOffset:U+k,value:l.substring(_,U+k),setting:{key:$,commaOffset:void 0}})},onLiteralValue:(U,k,N)=>{y===0&&m.push({startOffset:_,endOffset:k+N,value:l.substring(_,k+N),setting:{key:$,commaOffset:void 0}})},onSeparator:(U,k,N)=>{if(y===0&&U===","){let F=m.length-1;for(;F>=0&&!m[F].setting;F--);const q=m[F];q&&m.splice(F,1,{startOffset:q.startOffset,endOffset:q.endOffset,value:q.value,setting:{key:q.setting.key,commaOffset:k}})}},onComment:(U,k)=>{y===0&&m.push({startOffset:U,endOffset:U+k,value:l.substring(U,U+k)})}};return(0,r.visit)(l,A),m}}),define(ne[75],re([0,1,3,2,5,26]),function(Q,e,D,r,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,R.createDecorator)("IUserDataSyncAccountService");let T=class extends r.Disposable{get account(){return this._account}constructor(w,E){super(),this.userDataSyncStoreService=w,this.logService=E,this._onDidChangeAccount=this._register(new D.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new D.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(w.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(w.onTokenSucceed(()=>this.wasTokenFailed=!1))}async updateAccount(w){(w&&this._account?w.token!==this._account.token||w.authenticationProviderId!==this._account.authenticationProviderId:w!==this._account)&&(this._account=w,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(w))}};T=pe([Y(0,L.IUserDataSyncStoreService),Y(1,L.IUserDataSyncLogService)],T),e.UserDataSyncAccountService=T}),define(ne[244],re([0,1,2,7]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class R{constructor(p){this.service=p}listen(p,v){switch(v){case"onError":return this.service.onError}throw new Error(`Event not found: ${v}`)}call(p,v,h){switch(v){case"triggerSync":return this.service.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=R;class L{constructor(p){this.service=p}listen(p,v){throw new Error(`Event not found: ${v}`)}call(p,v,h){switch(v){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(r.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=L;class T{constructor(p){this.channel=p}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(p){return this.channel.call("resolveUserKeybindings",[p])}async resolveFormattingOptions(p){return this.channel.call("resolveFormattingOptions",[p])}}e.UserDataSyncUtilServiceClient=T;class P{constructor(p){this.service=p}listen(p,v){switch(v){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${v}`)}async call(p,v,h){switch(v){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(h[0],h[1]);case"setEnablements":return this.service.setEnablements(h)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class w{constructor(p){this.service=p}listen(p,v){switch(v){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${v}`)}call(p,v,h){switch(v){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=w;class E{constructor(p){this.service=p}listen(p,v){switch(v){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${v}`)}call(p,v,h){switch(v){case"switch":return this.service.switch(h[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=E;class I extends D.Disposable{constructor(p){super(),this.channel=p,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(p){return this.channel.call("switch",[p])}async getPreviousUserDataSyncStore(){const p=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(p)}revive(p){return{url:r.URI.revive(p.url),type:p.type,defaultUrl:r.URI.revive(p.defaultUrl),insidersUrl:r.URI.revive(p.insidersUrl),stableUrl:r.URI.revive(p.stableUrl),canSwitch:p.canSwitch,authenticationProviders:p.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=I}),define(ne[245],re([0,1,14,8]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let R=class extends r.AbstractLogger{constructor(T,P){super(),this.logger=this._register(T.createLogger(P.userDataSyncLogResource,{name:"settingssync"}))}trace(T,...P){this.logger.trace(T,...P)}debug(T,...P){this.logger.debug(T,...P)}info(T,...P){this.logger.info(T,...P)}warn(T,...P){this.logger.warn(T,...P)}error(T,...P){this.logger.error(T,...P)}critical(T,...P){this.logger.critical(T,...P)}flush(){this.logger.flush()}};R=pe([Y(0,r.ILoggerService),Y(1,D.IEnvironmentService)],R),e.UserDataSyncLogService=R}),define(ne[246],re([0,1,6,3,2]),function(Q,e,D,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class L extends R.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:w,getActiveWindowId:E}){super(),this.disposables=this._register(new R.DisposableStore),r.Event.latch(r.Event.any(P,w))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>E()),(async()=>{try{const b=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:b}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=L}),define(ne[111],re([0,1,169,12,34,19,7,5,23]),function(Q,e,D,r,R,L,T,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function E(o){const t=o;return typeof t?.id=="string"&&T.URI.isUri(t.uri)}e.isSingleFolderWorkspaceIdentifier=E,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function I(o,t){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,r.basename)(o)}:t?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const n=o;if(n.configuration)return{id:n.id,configPath:n.configuration};if(n.folders.length===1)return{id:n.id,uri:n.folders[0].uri}}e.toWorkspaceIdentifier=I;function b(o){const t=o;return typeof t?.id=="string"&&T.URI.isUri(t.configPath)}e.isWorkspaceIdentifier=b;function p(o){const t=o;if(t?.uri)return{id:t.id,uri:T.URI.revive(t.uri)};const n=o;if(n?.configPath)return{id:n.id,configPath:T.URI.revive(n.configPath)};if(o?.id)return{id:o.id}}e.reviveIdentifier=p;var v;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(v=e.WorkbenchState||(e.WorkbenchState={}));function h(o){const t=o;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.isWorkspace=h;function S(o){const t=o;return!!(t&&typeof t=="object"&&T.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.isWorkspaceFolder=S;class C{constructor(t,n,s,u,l){this._id=t,this._transient=s,this._configuration=u,this._ignorePathCasing=l,this._foldersMap=R.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=n}update(t){this._id=t.id,this._configuration=t.configuration,this._transient=t.transient,this._ignorePathCasing=t._ignorePathCasing,this.folders=t.folders}get folders(){return this._folders}set folders(t){this._folders=t,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(t){this._configuration=t}getFolder(t){return t&&this._foldersMap.findSubstr(t)||null}updateFoldersMap(){this._foldersMap=R.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const t of this.folders)this._foldersMap.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=C;class g{constructor(t,n){this.raw=n,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,L.joinPath)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=g;function f(o){return new g({uri:o,index:0,name:(0,L.basenameOrAuthority)(o)},{uri:o.toString()})}e.toWorkspaceFolder=f,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,D.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function a(o,t){return L.extUriBiasedIgnorePathCase.isEqualOrParent(o,t.untitledWorkspacesHome)}e.isUntitledWorkspace=a;function d(o){let t;return T.URI.isUri(o)?t=o:t=o.configuration,t?.scheme===w.Schemas.tmp}e.isTemporaryWorkspace=d;function c(o,t){return!a(o,t)&&!d(o)}e.isSavedWorkspace=c;function i(o){return(typeof o=="string"?(0,r.extname)(o):(0,L.extname)(o))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(ne[20],re([0,1,65,3,2,19,15,7,162,14,13,5,8,111,34,31,6,30,27]),function(Q,e,D,r,R,L,T,P,w,E,I,b,p,v,h,S,C,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function a(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&P.URI.isUri(n.location)&&P.URI.isUri(n.globalStorageHome)&&P.URI.isUri(n.settingsResource)&&P.URI.isUri(n.keybindingsResource)&&P.URI.isUri(n.tasksResource)&&P.URI.isUri(n.snippetsHome)&&((0,T.isUndefined)(n.extensionsResource)||P.URI.isUri(n.extensionsResource)))}e.isUserDataProfile=a,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,b.createDecorator)("IUserDataProfilesService");function d(t,n){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,location:P.URI.revive(t.location).with({scheme:n}),globalStorageHome:P.URI.revive(t.globalStorageHome).with({scheme:n}),settingsResource:P.URI.revive(t.settingsResource).with({scheme:n}),keybindingsResource:P.URI.revive(t.keybindingsResource).with({scheme:n}),tasksResource:P.URI.revive(t.tasksResource).with({scheme:n}),snippetsHome:P.URI.revive(t.snippetsHome).with({scheme:n}),extensionsResource:P.URI.revive(t.extensionsResource)?.with({scheme:n}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}e.reviveProfile=d,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function c(t,n,s,u){return{id:t,name:n,location:s,isDefault:!1,shortName:u?.shortName,globalStorageHome:(0,L.joinPath)(s,"globalStorage"),settingsResource:(0,L.joinPath)(s,"settings.json"),keybindingsResource:(0,L.joinPath)(s,"keybindings.json"),tasksResource:(0,L.joinPath)(s,"tasks.json"),snippetsHome:(0,L.joinPath)(s,"snippets"),extensionsResource:(0,L.joinPath)(s,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:u?.useDefaultFlags,isTransient:u?.transient}}e.toUserDataProfile=c;let i=class extends R.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(n,s,u,l){super(),this.environmentService=n,this.fileService=s,this.uriIdentityService=u,this.logService=l,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new r.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new r.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new r.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new r.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new h.ResourceMap},this.profilesHome=(0,L.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}setEnablement(n){this.enabled!==n&&(this._profilesObject=void 0,this.enabled=n)}get profilesObject(){if(!this._profilesObject){const n=this.enabled?this.getStoredProfiles().map(m=>c((0,L.basename)(m.location),m.name,m.location,{shortName:m.shortName,useDefaultFlags:m.useDefaultFlags})):[];let s;const u=new h.ResourceMap,l=c((0,D.hash)(this.environmentService.userRoamingDataHome.path).toString(16),(0,w.localize)(0,null),this.environmentService.userRoamingDataHome);if(n.unshift({...l,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||n.length>0||this.transientProfilesObject.profiles.length>0?l.extensionsResource:void 0}),n.length){const m=this.getStoredProfileAssociations();if(m.workspaces)for(const[y,_]of Object.entries(m.workspaces)){const $=P.URI.parse(y),A=P.URI.parse(_),U=n.find(k=>this.uriIdentityService.extUri.isEqual(k.location,A));U&&u.set($,U)}if(m.emptyWindow){const y=P.URI.parse(m.emptyWindow);s=n.find(_=>this.uriIdentityService.extUri.isEqual(_.location,y))}}this._profilesObject={profiles:n,workspaces:u,emptyWindow:s}}return this._profilesObject}async createTransientProfile(n){const s="Temp",u=new RegExp(`${(0,f.escapeRegExpCharacters)(s)}\\s(\\d+)`);let l=0;for(const y of this.profiles){const _=u.exec(y.name),$=_?parseInt(_[1]):0;l=$>l?$:l}const m=`${s} ${l+1}`;return this.createProfile((0,D.hash)((0,g.generateUuid)()).toString(16),m,{transient:!0},n)}async createNamedProfile(n,s,u){return this.createProfile((0,D.hash)((0,g.generateUuid)()).toString(16),n,s,u)}async createProfile(n,s,u,l){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const m=await this.doCreateProfile(n,s,u);return l&&await this.setProfileForWorkspace(l,m),m}async doCreateProfile(n,s,u){let l=this.profileCreationPromises.get(s);return l||(l=(async()=>{try{const m=this.profiles.find($=>$.name===s||$.id===n);if(m)return m;const y=c(n,s,(0,L.joinPath)(this.profilesHome,n),u);await this.fileService.createFolder(y.location);const _=[];return this._onWillCreateProfile.fire({profile:y,join($){_.push($)}}),await C.Promises.settled(_),this.updateProfiles([y],[],[]),y}finally{this.profileCreationPromises.delete(s)}})(),this.profileCreationPromises.set(s,l)),l}async updateProfile(n,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let u=this.profiles.find(l=>l.id===n.id);if(!u)throw new Error(`Profile '${n.name}' does not exist`);return u=c(u.id,s.name??u.name,u.location,{shortName:s.shortName??u.shortName,transient:s.transient??u.isTransient,useDefaultFlags:s.useDefaultFlags??u.useDefaultFlags}),this.updateProfiles([],[],[u]),u}async removeProfile(n){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(n.isDefault)throw new Error("Cannot remove default profile");const s=this.profiles.find(l=>l.id===n.id);if(!s)throw new Error(`Profile '${n.name}' does not exist`);const u=[];this._onWillRemoveProfile.fire({profile:s,join(l){u.push(l)}});try{await Promise.allSettled(u)}catch(l){this.logService.error(l)}s.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const l of[...this.profilesObject.workspaces.keys()])s.id===this.profilesObject.workspaces.get(l)?.id&&this.profilesObject.workspaces.delete(l);this.updateStoredProfileAssociations(),this.updateProfiles([],[s],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(s.location,{recursive:!0})}catch(l){this.logService.error(l)}}getOrSetProfileForWorkspace(n,s=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let u=this.getProfileForWorkspace(n);return u||(u=s,this.profiles.length>1&&this.setProfileForWorkspaceSync(n,u)),u}async setProfileForWorkspace(n,s){this.setProfileForWorkspaceSync(n,s)}setProfileForWorkspaceSync(n,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const u=this.profiles.find(l=>l.id===s.id);if(!u)throw new Error(`Profile '${s.name}' does not exist`);this.updateWorkspaceAssociation(n,u)}unsetWorkspace(n,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(n,void 0,s)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const n=await this.fileService.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(s=>s.isDirectory&&this.profiles.every(u=>!this.uriIdentityService.extUri.isEqual(u.location,s.resource))).map(s=>this.fileService.del(s.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const n=this.transientProfilesObject.profiles.filter(s=>!this.isProfileAssociatedToWorkspace(s));await Promise.allSettled(n.map(s=>this.removeProfile(s)))}getProfileForWorkspace(n){const s=this.getWorkspace(n);return P.URI.isUri(s)?this.transientProfilesObject.workspaces.get(s)??this.profilesObject.workspaces.get(s):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(n){return(0,v.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,v.isWorkspaceIdentifier)(n)?n.configPath:"empty-window"}isProfileAssociatedToWorkspace(n){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,n.location)||[...this.transientProfilesObject.workspaces.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,n.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,n.location)||[...this.profilesObject.workspaces.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,n.location)))}updateProfiles(n,s,u){const l=[...this.profiles,...n],m=[];this.transientProfilesObject.profiles=[];for(let y of l)y.isDefault||s.some(_=>y.id===_.id)||(y=u.find(_=>y.id===_.id)??y,y.isTransient?this.transientProfilesObject.profiles.push(y):m.push({location:y.location,name:y.name,shortName:y.shortName,useDefaultFlags:y.useDefaultFlags}));this.saveStoredProfiles(m),this._profilesObject=void 0,this.triggerProfilesChanges(n,s,u)}triggerProfilesChanges(n,s,u){this._onDidChangeProfiles.fire({added:n,removed:s,updated:u,all:this.profiles})}updateWorkspaceAssociation(n,s,u){u=s?.isTransient?!0:u,u||this.updateWorkspaceAssociation(n,void 0,!0);const l=this.getWorkspace(n),m=u?this.transientProfilesObject:this.profilesObject;P.URI.isUri(l)?(m.workspaces.delete(l),s&&m.workspaces.set(l,s)):m.emptyWindow=s,u||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const n={};for(const[u,l]of this.profilesObject.workspaces.entries())n[u.toString()]=l.location.toString();const s=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:n,emptyWindow:s}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(n){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(n){throw new Error("not implemented")}};i.PROFILES_KEY="userDataProfiles",i.PROFILE_ASSOCIATIONS_KEY="profileAssociations",i=pe([Y(0,E.IEnvironmentService),Y(1,I.IFileService),Y(2,S.IUriIdentityService),Y(3,p.ILogService)],i),e.UserDataProfilesService=i;class o extends i{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(n){this.storedProfiles=n}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(n){this.storedProfileAssociations=n}}e.InMemoryUserDataProfilesService=o}),define(ne[247],re([0,1,6,2,20]),function(Q,e,D,r,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let L=class extends r.Disposable{constructor(P){super(),this._register(new D.RunOnceScheduler(()=>{P.cleanUp()},10*1e3)).schedule()}};L=pe([Y(0,R.IUserDataProfilesService)],L),e.UserDataProfilesCleaner=L}),define(ne[248],re([0,1,18,6,22,9,3,2,4,7,144,29,33,44,8,25,24,20]),function(Q,e,D,r,R,L,T,P,w,E,I,b,p,v,h,S,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let f=class extends P.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(t,n,s,u,l){super(),this.galleryService=t,this.telemetryService=n,this.logService=s,this.productService=u,this.userDataProfilesService=l,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new T.Emitter),this._onDidInstallExtensions=this._register(new T.Emitter),this._onUninstallExtension=this._register(new T.Emitter),this._onDidUninstallExtension=this._register(new T.Emitter),this.participants=[],this._register((0,P.toDisposable)(()=>{this.installingExtensions.forEach(({task:m})=>m.cancel()),this.uninstallingExtensions.forEach(m=>m.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(t){const n=await this.getTargetPlatform();return t.allTargetPlatforms.some(s=>(0,b.isTargetPlatformCompatible)(s,t.allTargetPlatforms,n))}async installFromGallery(t,n={}){try{if(!this.galleryService.isEnabled())throw new b.ExtensionManagementError(I.localize(0,null),b.ExtensionManagementErrorCode.Internal);const s=await this.checkAndGetCompatibleVersion(t,!!n.installGivenVersion,!!n.installPreReleaseVersion);return await this.installExtension(s.manifest,s.extension,n)}catch(s){throw c(this.telemetryService,"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(t),error:s}),this.logService.error("Failed to install extension.",t.identifier.id),this.logService.error(s),d(s)}}async uninstall(t,n={}){return this.logService.trace("ExtensionManagementService#uninstall",t.identifier.id),this.uninstallExtension(t,n)}async reinstallFromGallery(t){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",t.identifier.id),!this.galleryService.isEnabled())throw new Error(I.localize(1,null));const n=await this.getTargetPlatform(),[s]=await this.galleryService.getExtensions([{...t.identifier,preRelease:t.preRelease}],{targetPlatform:n,compatible:!0},R.CancellationToken.None);if(!s)throw new Error(I.localize(2,null));await this.createUninstallExtensionTask(t,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(s)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.extensionsControlManifest||t-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=t),this.extensionsControlManifest}registerParticipant(t){this.participants.push(t)}async installExtension(t,n,s){const u=A=>`${p.ExtensionKey.create(A).toString()}${s.profileLocation?`-${s.profileLocation.toString()}`:""}`;if(!E.URI.isUri(n)){const A=this.installingExtensions.get(u(n));if(A){this.logService.info("Extensions is already requested to install",n.identifier.id);const{local:U}=await A.task.waitUntilTaskIsFinished();return U}s={...s,installOnlyNewlyAddedFromExtensionPack:!0}}const l=[],m=[],y=[],_=this.createInstallExtensionTask(t,n,s);E.URI.isUri(n)||this.installingExtensions.set(u(n),{task:_,waitingTasks:[]}),this._onInstallExtension.fire({identifier:_.identifier,source:n,profileLocation:s.profileLocation}),this.logService.info("Installing extension:",_.identifier.id),l.push({task:_,manifest:t});let $=!1;try{if(s.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",_.identifier.id);else try{const U=await this.getAllDepsAndPackExtensions(_.identifier,t,!!s.installOnlyNewlyAddedFromExtensionPack,!!s.installPreReleaseVersion,s.profileLocation),k=await this.getInstalled(void 0,s.profileLocation);for(const{gallery:N,manifest:F}of U){$=$||!!F.extensionDependencies?.some(j=>(0,p.areSameExtensions)({id:j},_.identifier));const q=u(N),J=this.installingExtensions.get(q);if(J){if(this.canWaitForTask(_,J.task)){this.logService.info("Waiting for already requested installing extension",N.identifier.id,_.identifier.id),J.waitingTasks.push(_);const j=J.task.identifier;m.push(T.Event.toPromise(T.Event.filter(this.onDidInstallExtensions,H=>H.some(W=>(0,p.areSameExtensions)(W.identifier,j)))).then(H=>{if(!H.find(z=>(0,p.areSameExtensions)(z.identifier,j))?.local)throw new Error(`Extension ${j.id} is not installed`)}))}}else if(!k.some(({identifier:j})=>(0,p.areSameExtensions)(j,N.identifier))){const j=this.createInstallExtensionTask(F,N,{...s,donotIncludePackAndDependencies:!0});this.installingExtensions.set(q,{task:j,waitingTasks:[_]}),this._onInstallExtension.fire({identifier:j.identifier,source:N,profileLocation:s.profileLocation}),this.logService.info("Installing extension:",j.identifier.id,_.identifier.id),l.push({task:j,manifest:F})}}}catch(U){if(E.URI.isUri(_.source))(0,D.isNonEmptyArray)(t.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",_.identifier.id,U.message),(0,D.isNonEmptyArray)(t.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",_.identifier.id,U.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",_.identifier.id),U}const A=l.reduce((U,{task:k,manifest:N})=>(U.set(k.identifier.id.toLowerCase(),{task:k,manifest:N}),U),new Map);for(;A.size;){let U;const k=[...A.values()].filter(({manifest:N})=>!N.extensionDependencies?.some(F=>A.has(F.toLowerCase())));k.length?U=A.size===1?k:k.filter(({task:N})=>!(N===_&&!$)):(this.logService.info("Found extensions with circular dependencies",k.map(({task:N})=>N.identifier.id)),U=[...A.values()]),await this.joinAllSettled(U.map(async({task:N})=>{const F=new Date().getTime();try{const{local:q}=await N.run();if(await this.joinAllSettled(this.participants.map(J=>J.postInstall(q,N.source,s,R.CancellationToken.None))),!E.URI.isUri(N.source)){const J=N.operation===3,j=J?void 0:(new Date().getTime()-N.source.lastUpdated)/1e3;if(c(this.telemetryService,J?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(N.source),duration:new Date().getTime()-F,durationSinceUpdate:j}),w.isWeb&&N.operation!==3)try{await this.galleryService.reportStatistic(q.manifest.publisher,q.manifest.name,q.manifest.version,"install")}catch{}}y.push({local:q,identifier:N.identifier,operation:N.operation,source:N.source,context:s.context,profileLocation:s.profileLocation,applicationScoped:q.isApplicationScoped})}catch(q){throw E.URI.isUri(N.source)||c(this.telemetryService,N.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.getGalleryExtensionTelemetryData)(N.source),duration:new Date().getTime()-F,error:q}),this.logService.error("Error while installing the extension:",N.identifier.id),q}finally{A.delete(N.identifier.id.toLowerCase())}}))}return m.length&&await this.joinAllSettled(m),y.forEach(({identifier:U})=>this.logService.info("Extension installed successfully:",U.id)),this._onDidInstallExtensions.fire(y),y.filter(({identifier:U})=>(0,p.areSameExtensions)(U,_.identifier))[0].local}catch(A){if(l.forEach(({task:U})=>U.cancel()),y.length)try{const U=await Promise.allSettled(y.map(({local:k})=>this.createUninstallExtensionTask(k,{versionOnly:!0,profileLocation:s.profileLocation}).run()));for(let k=0;k<U.length;k++){const N=U[k],{identifier:F}=y[k];N.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",F.id):this.logService.warn("Rollback: Error while uninstalling extension",F.id,(0,L.getErrorMessage)(N.reason))}}catch(U){this.logService.warn("Error while rolling back extensions",(0,L.getErrorMessage)(U),y.map(({identifier:k})=>k.id))}throw this._onDidInstallExtensions.fire(l.map(({task:U})=>({identifier:U.identifier,operation:2,source:U.source,context:s.context,profileLocation:s.profileLocation}))),A}finally{for(const[A,{task:U,waitingTasks:k}]of this.installingExtensions.entries()){const N=k.indexOf(_);N!==-1&&k.splice(N,1),k.length===0&&(U===_||N!==-1)&&this.installingExtensions.delete(A)}}}canWaitForTask(t,n){for(const[,{task:s,waitingTasks:u}]of this.installingExtensions.entries())if(s===t&&(u.includes(n)||u.some(l=>this.canWaitForTask(l,n)))||s===n&&u[0]&&!this.canWaitForTask(t,u[0]))return!1;return!0}async joinAllSettled(t){const n=[],s=[],u=await Promise.allSettled(t);for(const l of u)l.status==="fulfilled"?n.push(l.value):s.push(l.reason);if(s.length)throw a(s);return n}async getAllDepsAndPackExtensions(t,n,s,u,l){if(!this.galleryService.isEnabled())return[];const m=await this.getInstalled(void 0,l),y=[t],_=[],$=async(A,U)=>{const k=U.extensionDependencies||[],N=[...k];if(U.extensionPack){const F=s?m.find(q=>(0,p.areSameExtensions)(q.identifier,A)):void 0;for(const q of U.extensionPack)F&&F.manifest.extensionPack&&F.manifest.extensionPack.some(J=>(0,p.areSameExtensions)({id:J},{id:q}))||N.every(J=>!(0,p.areSameExtensions)({id:J},{id:q}))&&N.push(q)}if(N.length){const F=[...y,..._.map(J=>J.gallery.identifier)],q=N.filter(J=>F.every(j=>!(0,p.areSameExtensions)(j,{id:J})));if(q.length){const J=await this.galleryService.getExtensions(q.map(j=>({id:j,preRelease:u})),R.CancellationToken.None);for(const j of J){if(F.find(z=>(0,p.areSameExtensions)(z,j.identifier)))continue;const H=k.some(z=>(0,p.areSameExtensions)({id:z},j.identifier));let W;try{W=await this.checkAndGetCompatibleVersion(j,!1,u)}catch(z){if(z instanceof b.ExtensionManagementError&&z.code===b.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!H){this.logService.info("Skipping the packed extension as it cannot be installed",j.identifier.id);continue}else throw z}_.push({gallery:W.extension,manifest:W.manifest}),await $(W.extension.identifier,W.manifest)}}}};return await $(t,n),_}async checkAndGetCompatibleVersion(t,n,s){if((await this.getExtensionsControlManifest()).malicious.some(y=>(0,p.areSameExtensions)(t.identifier,y)))throw new b.ExtensionManagementError(I.localize(3,null,t.identifier.id),b.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(t)){const y=await this.getTargetPlatform();throw new b.ExtensionManagementError(I.localize(4,null,t.identifier.id,this.productService.nameLong,(0,b.TargetPlatformToString)(y)),b.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const l=await this.getCompatibleVersion(t,n,s);if(l){if(s&&!n&&t.hasPreReleaseVersion&&!l.properties.isPreReleaseVersion)throw new b.ExtensionManagementError(I.localize(5,null,t.identifier.id,this.productService.nameLong,this.productService.version),b.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!s&&t.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([t.identifier],R.CancellationToken.None))[0]?new b.ExtensionManagementError(I.localize(6,null,t.identifier.id),b.ExtensionManagementErrorCode.ReleaseVersionNotFound):new b.ExtensionManagementError(I.localize(7,null,t.identifier.id,this.productService.nameLong,this.productService.version),b.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",l.identifier.id);const m=await this.galleryService.getManifest(l,R.CancellationToken.None);if(m===null)throw new b.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,b.ExtensionManagementErrorCode.Invalid);if(m.version!==l.version)throw new b.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,b.ExtensionManagementErrorCode.Invalid);return{extension:l,manifest:m}}async getCompatibleVersion(t,n,s){const u=await this.getTargetPlatform();let l=null;return!n&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==s&&(l=(await this.galleryService.getExtensions([{...t.identifier,preRelease:s}],{targetPlatform:u,compatible:!0},R.CancellationToken.None))[0]||null),!l&&await this.galleryService.isExtensionCompatible(t,s,u)&&(l=t),l||(n?l=(await this.galleryService.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:u,compatible:!0},R.CancellationToken.None))[0]||null:l=await this.galleryService.getCompatibleExtension(t,s,u)),l}async uninstallExtension(t,n){const s=$=>`${$.id.toLowerCase()}${n.versionOnly?`-${t.manifest.version}`:""}${n.profileLocation?`@${n.profileLocation.toString()}`:""}`,u=this.uninstallingExtensions.get(s(t.identifier));if(u)return this.logService.info("Extensions is already requested to uninstall",t.identifier.id),u.waitUntilTaskIsFinished();const l=($,A)=>{const U=this.createUninstallExtensionTask($,A);return this.uninstallingExtensions.set(s(U.extension.identifier),U),n.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${$.identifier.id}@${$.manifest.version}`,n.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${$.identifier.id}@${$.manifest.version}`),this._onUninstallExtension.fire({identifier:$.identifier,profileLocation:n.profileLocation,applicationScoped:$.isApplicationScoped}),U},m=($,A)=>{A?n.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${$.identifier.id}@${$.manifest.version}`,n.profileLocation.toString(),A.message):this.logService.error("Failed to uninstall extension:",`${$.identifier.id}@${$.manifest.version}`,A.message):n.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${$.identifier.id}@${$.manifest.version}`,n.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${$.identifier.id}@${$.manifest.version}`),c(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,p.getLocalExtensionTelemetryData)($),error:A}),this._onDidUninstallExtension.fire({identifier:$.identifier,version:$.manifest.version,error:A?.code,profileLocation:n.profileLocation,applicationScoped:$.isApplicationScoped})},y=[],_=[];try{y.push(l(t,n));const $=await this.getInstalled(1,n.profileLocation);if(n.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const A=this.getAllPackExtensionsToUninstall(t,$);for(const U of A)this.uninstallingExtensions.has(s(U.identifier))?this.logService.info("Extensions is already requested to uninstall",U.identifier.id):y.push(l(U,n))}n.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.checkForDependents(y.map(A=>A.extension),$,t),await this.joinAllSettled(y.map(async A=>{try{if(await A.run(),await this.joinAllSettled(this.participants.map(U=>U.postUninstall(A.extension,n,R.CancellationToken.None))),A.extension.identifier.uuid)try{await this.galleryService.reportStatistic(A.extension.manifest.publisher,A.extension.manifest.name,A.extension.manifest.version,"uninstall")}catch{}m(A.extension)}catch(U){const k=U instanceof b.ExtensionManagementError?U:new b.ExtensionManagementError((0,L.getErrorMessage)(U),b.ExtensionManagementErrorCode.Internal);throw m(A.extension,k),k}finally{_.push(A)}}))}catch($){const A=$ instanceof b.ExtensionManagementError?$:new b.ExtensionManagementError((0,L.getErrorMessage)($),b.ExtensionManagementErrorCode.Internal);for(const U of y){try{U.cancel()}catch{}_.includes(U)||m(U.extension,A)}throw A}finally{for(const $ of y)this.uninstallingExtensions.delete(s($.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",$.extension.identifier.id)}}checkForDependents(t,n,s){for(const u of t){const l=this.getDependents(u,n);if(l.length){const m=l.filter(y=>!t.some(_=>(0,p.areSameExtensions)(_.identifier,y.identifier)));if(m.length)throw new Error(this.getDependentsErrorMessage(u,m,s))}}}getDependentsErrorMessage(t,n,s){return s===t?n.length===1?I.localize(8,null,s.manifest.displayName||s.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?I.localize(9,null,s.manifest.displayName||s.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):I.localize(10,null,s.manifest.displayName||s.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):n.length===1?I.localize(11,null,s.manifest.displayName||s.manifest.name,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?I.localize(12,null,s.manifest.displayName||s.manifest.name,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):I.localize(13,null,s.manifest.displayName||s.manifest.name,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name)}getAllPackExtensionsToUninstall(t,n,s=[]){if(s.indexOf(t)!==-1)return[];s.push(t);const u=t.manifest.extensionPack?t.manifest.extensionPack:[];if(u.length){const l=n.filter(y=>!y.isBuiltin&&u.some(_=>(0,p.areSameExtensions)({id:_},y.identifier))),m=[];for(const y of l)m.push(...this.getAllPackExtensionsToUninstall(y,n,s));return[...l,...m]}return[]}getDependents(t,n){return n.filter(s=>s.manifest.extensionDependencies&&s.manifest.extensionDependencies.some(u=>(0,p.areSameExtensions)({id:u},t.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const t=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}createInstallExtensionTask(t,n,s){return s.profileLocation&&(0,v.isApplicationScopedExtension)(t)&&(s={...s,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateInstallExtensionTask(t,n,s)}createUninstallExtensionTask(t,n){return n.profileLocation&&t.isApplicationScoped&&(n={...n,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateUninstallExtensionTask(t,n)}};f=pe([Y(0,b.IExtensionGalleryService),Y(1,C.ITelemetryService),Y(2,h.ILogService),Y(3,S.IProductService),Y(4,g.IUserDataProfilesService)],f),e.AbstractExtensionManagementService=f;function a(o){const t=Array.isArray(o)?o:[o];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((n,s)=>new Error(`${n.message}${n.message?",":""}${s instanceof Error?s.message:s}`),new Error(""))}e.joinErrors=a;function d(o){if(o instanceof b.ExtensionManagementError)return o;const t=new b.ExtensionManagementError(o.message,b.ExtensionManagementErrorCode.Internal);return t.stack=o.stack,t}function c(o,t,{extensionData:n,duration:s,error:u,durationSinceUpdate:l}){const m=u?u instanceof b.ExtensionManagementError?u.code:b.ExtensionManagementErrorCode.Internal:void 0;o.publicLog(t,{...n,success:!u,duration:s,errorcode:m,durationSinceUpdate:l})}e.reportTelemetry=c;class i{constructor(){this.barrier=new r.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,r.createCancelablePromise)(t=>this.doRun(t))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,r.createCancelablePromise)(t=>new Promise((n,s)=>{const u=t.onCancellationRequested(()=>{u.dispose(),s(new L.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=i}),define(ne[76],re([0,1,18,6,32,16,9,35,126,2,23,12,4,19,55,85,15,7,147,14,33,44,69,13,5,8,25,3,66,49,20,31,175]),function(Q,e,D,r,R,L,T,P,w,E,I,b,p,v,h,S,C,g,f,a,d,c,i,o,t,n,s,u,l,m,y,_,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var A;(function(j){function H(W,z){if(W===z)return!0;const K=Object.keys(W),X=new Set;for(const ce of Object.keys(z))X.add(ce);if(K.length!==X.size)return!1;for(const ce of K){if(W[ce]!==z[ce])return!1;X.delete(ce)}return X.size===0}j.equals=H})(A=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let U=class extends E.Disposable{constructor(H,W,z,K,X,ce,B,G,O,M,x){super(),this.systemExtensionsLocation=H,this.userExtensionsLocation=W,this.extensionsControlLocation=z,this.cacheLocation=K,this.userDataProfilesService=X,this.extensionsProfileScannerService=ce,this.fileService=B,this.logService=G,this.environmentService=O,this.productService=M,this.instantiationService=x,this._onDidChangeCache=this._register(new u.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,v.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(F,(0,v.joinPath)(this.cacheLocation,c.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(F,(0,v.joinPath)(this.cacheLocation,c.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(N,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,d.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(H,W,z){const[K,X]=await Promise.all([this.scanSystemExtensions(H),this.scanUserExtensions(W)]),ce=z?await this.scanExtensionsUnderDevelopment(H,[...K,...X]):[];return this.dedupExtensions(K,X,ce,await this.getTargetPlatform(),!0)}async scanSystemExtensions(H){const W=[];W.push(this.scanDefaultSystemExtensions(!!H.useCache,H.language)),W.push(this.scanDevSystemExtensions(H.language,!!H.checkControlFile));const[z,K]=await Promise.all(W);return this.applyScanOptions([...z,...K],0,H,!1)}async scanUserExtensions(H){this.logService.trace("Started scanning user extensions");const W=await this.createExtensionScannerInput(H.profileLocation??this.userExtensionsLocation,!!H.profileLocation,1,!H.includeUninstalled,H.language);let K=await(H.useCache&&!W.devMode&&W.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(W);return K=await this.applyScanOptions(K,1,H,!0),this.logService.trace("Scanned user extensions:",K.length),K}async scanExtensionsUnderDevelopment(H,W){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const z=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(K=>K.scheme===I.Schemas.file).map(async K=>{const X=await this.createExtensionScannerInput(K,!1,1,!0,H.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(X)).map(B=>(B.type=W.find(G=>(0,d.areSameExtensions)(G.identifier,B.identifier))?.type??B.type,this.extensionsScanner.validate(B,X)))}))).flat();return this.applyScanOptions(z,"development",H,!0)}return[]}async scanExistingExtension(H,W,z){const K=await this.createExtensionScannerInput(H,!1,W,!0,z.language),X=await this.extensionsScanner.scanExtension(K);return!X||!z.includeInvalid&&!X.isValid?null:X}async scanOneOrMultipleExtensions(H,W,z){const K=await this.createExtensionScannerInput(H,!1,W,!0,z.language),X=await this.extensionsScanner.scanOneOrMultipleExtensions(K);return this.applyScanOptions(X,W,z,!0)}async scanMetadata(H){const W=(0,v.joinPath)(H,"package.json"),z=(await this.fileService.readFile(W)).value.toString();return JSON.parse(z).__metadata}async updateMetadata(H,W){const z=(0,v.joinPath)(H,"package.json"),K=(await this.fileService.readFile(z)).value.toString(),X=JSON.parse(K);W.isMachineScoped=W.isMachineScoped||void 0,W.isBuiltin=W.isBuiltin||void 0,W.installedTimestamp=W.installedTimestamp||void 0,X.__metadata={...X.__metadata,...W},await this.fileService.writeFile((0,v.joinPath)(H,"package.json"),L.VSBuffer.fromString(JSON.stringify(X,null,"	")))}async applyScanOptions(H,W,z,K){return z.includeAllVersions||(H=this.dedupExtensions(W===0?H:void 0,W===1?H:void 0,W==="development"?H:void 0,await this.getTargetPlatform(),K)),z.includeInvalid||(H=H.filter(X=>X.isValid)),H.sort((X,ce)=>{const B=b.basename(X.location.fsPath),G=b.basename(ce.location.fsPath);return B<G?-1:B>G?1:0})}dedupExtensions(H,W,z,K,X){const ce=(G,O,M)=>{if(G.isValid&&!O.isValid)return!1;if(G.isValid===O.isValid){if(X&&h.gt(G.manifest.version,O.manifest.version))return this.logService.debug(`Skipping extension ${O.location.path} with lower version ${O.manifest.version} in favour of ${G.location.path} with version ${G.manifest.version}`),!1;if(h.eq(G.manifest.version,O.manifest.version)){if(G.type===0)return this.logService.debug(`Skipping extension ${O.location.path} in favour of system extension ${G.location.path} with same version`),!1;if(G.targetPlatform===K)return this.logService.debug(`Skipping extension ${O.location.path} from different target platform ${O.targetPlatform}`),!1}}return M?this.logService.warn(`Overwriting user extension ${G.location.path} with ${O.location.path}.`):this.logService.debug(`Overwriting user extension ${G.location.path} with ${O.location.path}.`),!0},B=new Map;return H?.forEach(G=>{const O=c.ExtensionIdentifier.toKey(G.identifier.id),M=B.get(O);(!M||ce(M,G,!1))&&B.set(O,G)}),W?.forEach(G=>{const O=c.ExtensionIdentifier.toKey(G.identifier.id),M=B.get(O);if(!M&&H&&G.type===0){this.logService.debug(`Skipping obsolete system extension ${G.location.path}.`);return}(!M||ce(M,G,!1))&&B.set(O,G)}),z?.forEach(G=>{const O=c.ExtensionIdentifier.toKey(G.identifier.id),M=B.get(O);(!M||ce(M,G,!0))&&B.set(O,G),B.set(O,G)}),[...B.values()]}async scanDefaultSystemExtensions(H,W){this.logService.trace("Started scanning system extensions");const z=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,W),X=await(H&&!z.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(z);return this.logService.trace("Scanned system extensions:",X.length),X}async scanDevSystemExtensions(H,W){const z=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!z?.length)return[];this.logService.trace("Started scanning dev system extensions");const K=W?await this.getBuiltInExtensionControl():{},X=[],ce=g.URI.file(b.normalize(b.join(I.FileAccess.asFileUri("",Q).fsPath,"..",".build","builtInExtensions")));for(const G of z){const O=K[G.name]||"marketplace";switch(O){case"disabled":break;case"marketplace":X.push((0,v.joinPath)(ce,G.name));break;default:X.push(g.URI.file(O));break}}const B=await Promise.all(X.map(async G=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(G,!1,0,!0,H))));return this.logService.trace("Scanned dev system extensions:",B.length),(0,D.coalesce)(B)}async getBuiltInExtensionControl(){try{const H=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(H.value.toString())}catch{return{}}}async createExtensionScannerInput(H,W,z,K,X,ce=!0){const B=await this.getTranslations(X??p.language),G=await this.getMtime(H),O=W?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,M=O?await this.getMtime(O):void 0;return new k(H,G,O,M,W,z,K,ce,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,X,B)}async getMtime(H){try{const W=await this.fileService.stat(H);if(typeof W.mtime=="number")return W.mtime}catch{}}};U=pe([Y(4,y.IUserDataProfilesService),Y(5,m.IExtensionsProfileScannerService),Y(6,o.IFileService),Y(7,n.ILogService),Y(8,a.IEnvironmentService),Y(9,s.IProductService),Y(10,t.IInstantiationService)],U),e.AbstractExtensionsScannerService=U;class k{constructor(H,W,z,K,X,ce,B,G,O,M,x,V,ee,oe){this.location=H,this.mtime=W,this.applicationExtensionslocation=z,this.applicationExtensionslocationMtime=K,this.profile=X,this.type=ce,this.excludeObsolete=B,this.validate=G,this.productVersion=O,this.productDate=M,this.productCommit=x,this.devMode=V,this.language=ee,this.translations=oe}static createNlsConfiguration(H){return{language:H.language,pseudo:H.language==="pseudo",devMode:H.devMode,translations:H.translations}}static equals(H,W){return(0,v.isEqual)(H.location,W.location)&&H.mtime===W.mtime&&(0,v.isEqual)(H.applicationExtensionslocation,W.applicationExtensionslocation)&&H.applicationExtensionslocationMtime===W.applicationExtensionslocationMtime&&H.profile===W.profile&&H.type===W.type&&H.excludeObsolete===W.excludeObsolete&&H.validate===W.validate&&H.productVersion===W.productVersion&&H.productDate===W.productDate&&H.productCommit===W.productCommit&&H.devMode===W.devMode&&H.language===W.language&&A.equals(H.translations,W.translations)}}let N=class extends E.Disposable{constructor(H,W,z,K,X){super(),this.obsoleteFile=H,this.extensionsProfileScannerService=W,this.uriIdentityService=z,this.fileService=K,this.logService=X}async scanExtensions(H){const W=H.profile?await this.scanExtensionsFromProfile(H):await this.scanExtensionsFromLocation(H);let z={};if(H.excludeObsolete&&H.type===1)try{const K=(await this.fileService.readFile(this.obsoleteFile)).value.toString();z=JSON.parse(K)}catch{}return(0,C.isEmptyObject)(z)?W:W.filter(K=>!z[d.ExtensionKey.create(K).toString()])}async scanExtensionsFromLocation(H){const W=await this.fileService.resolve(H.location);if(!W.children?.length)return[];const z=await Promise.all(W.children.map(async K=>{if(!K.isDirectory||H.type===1&&(0,v.basename)(K.resource).indexOf(".")===0)return null;const X=new k(K.resource,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(X)}));return(0,D.coalesce)(z).sort((K,X)=>K.location.path<X.location.path?-1:1)}async scanExtensionsFromProfile(H){let W=await this.scanExtensionsFromProfileResource(H.location,()=>!0,H);if(H.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(H.location,H.applicationExtensionslocation)){W=W.filter(K=>!K.metadata?.isApplicationScoped);const z=await this.scanExtensionsFromProfileResource(H.applicationExtensionslocation,K=>!!K.metadata?.isApplicationScoped,H);W.push(...z)}return W}async scanExtensionsFromProfileResource(H,W,z){const K=await this.extensionsProfileScannerService.scanProfileExtensions(H);if(!K.length)return[];const X=await Promise.all(K.map(async ce=>{if(W(ce)){const B=new k(ce.location,z.mtime,z.applicationExtensionslocation,z.applicationExtensionslocationMtime,z.profile,z.type,z.excludeObsolete,z.validate,z.productVersion,z.productDate,z.productCommit,z.devMode,z.language,z.translations);return this.scanExtension(B,ce.metadata)}return null}));return(0,D.coalesce)(X)}async scanOneOrMultipleExtensions(H){try{if(await this.fileService.exists((0,v.joinPath)(H.location,"package.json"))){const W=await this.scanExtension(H);return W?[W]:[]}else return await this.scanExtensions(H)}catch(W){return this.logService.error(`Error scanning extensions at ${H.location.path}:`,(0,T.getErrorMessage)(W)),[]}}async scanExtension(H,W){try{let z=await this.scanExtensionManifest(H.location);if(z){z.publisher||(z.publisher=c.UNDEFINED_PUBLISHER),W=W??z.__metadata,delete z.__metadata;const K=(0,d.getGalleryExtensionId)(z.publisher,z.name),X=W?.id?{id:K,uuid:W.id}:{id:K},ce=W?.isSystem?0:H.type,B=ce===0||!!W?.isBuiltin;z=await this.translateManifest(H.location,z,k.createNlsConfiguration(H));const G={type:ce,identifier:X,manifest:z,location:H.location,isBuiltin:B,targetPlatform:W?.targetPlatform??"undefined",metadata:W,isValid:!0,validations:[]};return H.validate?this.validate(G,H):G}}catch(z){H.type!==0&&this.logService.error(z)}return null}validate(H,W){let z=!0;const K=(0,i.validateExtensionManifest)(W.productVersion,W.productDate,W.location,H.manifest,H.isBuiltin);for(const[X,ce]of K)X===S.default.Error&&(z=!1,this.logService.error(this.formatMessage(W.location,ce)));return H.isValid=z,H.validations=K,H}async scanExtensionManifest(H){const W=(0,v.joinPath)(H,"package.json");let z;try{z=(await this.fileService.readFile(W)).value.toString()}catch(X){return(0,o.toFileOperationResult)(X)!==1&&this.logService.error(this.formatMessage(H,(0,f.localize)(0,null,W.path,X.message))),null}let K;try{K=JSON.parse(z)}catch{const ce=[];(0,P.parse)(z,ce);for(const B of ce)this.logService.error(this.formatMessage(H,(0,f.localize)(1,null,W.path,B.offset,B.length,(0,w.getParseErrorMessage)(B.error))));return null}return(0,P.getNodeType)(K)!=="object"?(this.logService.error(this.formatMessage(H,(0,f.localize)(2,null,W.path))),null):K}async translateManifest(H,W,z){const K=await this.getLocalizedMessages(H,W,z);if(K)try{const X=[],ce=await this.resolveOriginalMessageBundle(K.default,X);if(X.length>0)return X.forEach(G=>{this.logService.error(this.formatMessage(H,(0,f.localize)(3,null,K.default?.path,(0,w.getParseErrorMessage)(G.error))))}),W;if((0,P.getNodeType)(K)!=="object")return this.logService.error(this.formatMessage(H,(0,f.localize)(4,null,K.default?.path))),W;const B=K.values||Object.create(null);return(0,$.localizeManifest)(W,B,ce)}catch{}return W}async getLocalizedMessages(H,W,z){const K=(0,v.joinPath)(H,"package.nls.json"),X=(O,M)=>{M.forEach(x=>{this.logService.error(this.formatMessage(H,(0,f.localize)(5,null,O?.path,(0,w.getParseErrorMessage)(x.error))))})},ce=O=>{this.logService.error(this.formatMessage(H,(0,f.localize)(6,null,O?.path)))},B=`${W.publisher}.${W.name}`,G=z.translations[B];if(G)try{const O=g.URI.file(G),M=(await this.fileService.readFile(O)).value.toString(),x=[],V=(0,P.parse)(M,x);return x.length>0?(X(O,x),{values:void 0,default:K}):(0,P.getNodeType)(V)!=="object"?(ce(O),{values:void 0,default:K}):{values:V.contents?V.contents.package:void 0,default:K}}catch{return{values:void 0,default:K}}else{if(!await this.fileService.exists(K))return;let M;try{M=await this.findMessageBundles(H,z)}catch{return}if(!M.localized)return{values:void 0,default:M.original};try{const x=(await this.fileService.readFile(M.localized)).value.toString(),V=[],ee=(0,P.parse)(x,V);return V.length>0?(X(M.localized,V),{values:void 0,default:M.original}):(0,P.getNodeType)(ee)!=="object"?(ce(M.localized),{values:void 0,default:M.original}):{values:ee,default:M.original}}catch{return{values:void 0,default:M.original}}}}async resolveOriginalMessageBundle(H,W){if(H)try{const z=(await this.fileService.readFile(H)).value.toString();return(0,P.parse)(z,W)}catch{}}findMessageBundles(H,W){return new Promise((z,K)=>{const X=ce=>{const B=(0,v.joinPath)(H,`package.nls.${ce}.json`);this.fileService.exists(B).then(G=>{G&&z({localized:B,original:(0,v.joinPath)(H,"package.nls.json")});const O=ce.lastIndexOf("-");O===-1?z({localized:(0,v.joinPath)(H,"package.nls.json"),original:null}):(ce=ce.substring(0,O),X(ce))})};if(W.devMode||W.pseudo||!W.language)return z({localized:(0,v.joinPath)(H,"package.nls.json"),original:null});X(W.language)})}formatMessage(H,W){return`[${H.path}]: ${W}`}};N=pe([Y(1,m.IExtensionsProfileScannerService),Y(2,_.IUriIdentityService),Y(3,o.IFileService),Y(4,n.ILogService)],N);let F=class extends N{constructor(H,W,z,K,X,ce){super(W,z,K,X,ce),this.cacheFile=H,this.cacheValidatorThrottler=this._register(new r.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new u.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(H){const W=await this.readExtensionCache();if(this.input=H,W&&W.input&&k.equals(W.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),W.result.map(K=>(K.location=g.URI.revive(K.location),K));const z=await super.scanExtensions(H);return await this.writeExtensionCache({input:H,result:z}),z}async readExtensionCache(){try{const H=await this.fileService.readFile(this.cacheFile),W=JSON.parse(H.value.toString());return{result:W.result,input:(0,l.revive)(W.input)}}catch(H){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,T.getErrorMessage)(H))}return null}async writeExtensionCache(H){try{await this.fileService.writeFile(this.cacheFile,L.VSBuffer.fromString(JSON.stringify(H)))}catch(W){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,T.getErrorMessage)(W))}}async validateCache(){if(!this.input)return;const H=await this.readExtensionCache();if(!H)return;const W=H.result,z=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!R.equals(z,W))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(K){this.logService.error(K)}}};F=pe([Y(2,m.IExtensionsProfileScannerService),Y(3,_.IUriIdentityService),Y(4,o.IFileService),Y(5,n.ILogService)],F);function q(j,H){const W=(0,d.getExtensionId)(j.manifest.publisher,j.manifest.name);return{id:W,identifier:new c.ExtensionIdentifier(W),isBuiltin:j.type===0,isUserBuiltin:j.type===1&&j.isBuiltin,isUnderDevelopment:H,extensionLocation:j.location,uuid:j.identifier.uuid,targetPlatform:j.targetPlatform,...j.manifest}}e.toExtensionDescription=q;class J extends U{constructor(H,W,z,K,X,ce,B,G,O,M,x){super(H,W,(0,v.joinPath)(z,".vscode-oss-dev","extensions","control.json"),(0,v.joinPath)(K,c.MANIFEST_CACHE_FOLDER),X,ce,B,G,O,M,x),this.translationsPromise=(async()=>{if(p.translationsConfigFile)try{const V=await this.fileService.readFile(g.URI.file(p.translationsConfigFile));return JSON.parse(V.value.toString())}catch{}return Object.create(null)})()}getTranslations(H){return this.translationsPromise}}e.NativeExtensionsScannerService=J}),define(ne[249],re([0,1,54,6,38,3,2,23,12,28,8,20]),function(Q,e,D,r,R,L,T,P,w,E,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let p=class extends T.Disposable{constructor(h,S){super(),this.userDataProfilesService=h,this.logService=S,this.processesLimiter=new r.Limiter(5)}async postUninstall(h){const S=this.parseScript(h,"uninstall");return S&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(S.script,"uninstall",S.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),C=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${C}`)))),E.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,C=>this.logService.error("Error while removing extension storage path",C))}parseScript(h,S){const C=`vscode:${S}`;if(h.location.scheme===P.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[C]=="string"){const g=h.manifest.scripts[C].split(" ");return g.length<2||g[0]!=="node"||!g[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${C} should be a node script`),null):{script:(0,w.join)(h.location.fsPath,g[1]),args:g.slice(2)||[]}}return null}runLifecycleHook(h,S,C,g,f){return new Promise((a,d)=>{const c=this.start(h,S,C,f);let i;const o=t=>{i&&(clearTimeout(i),i=null),t?d(t):a(void 0)};c.on("error",t=>{o((0,R.toErrorMessage)(t)||"Unknown")}),c.on("exit",(t,n)=>{o(t?`post-${S} process exited with code ${t}`:void 0)}),g&&(i=setTimeout(()=>{i=null,c.kill(),d("timed out")},5e3))})}start(h,S,C,g){const f={silent:!0,execArgv:void 0},a=(0,D.fork)(h,[`--type=extension-post-${S}`,...C],f);a.stdout.setEncoding("utf8"),a.stderr.setEncoding("utf8");const d=L.Event.fromNodeEventEmitter(a.stdout,"data"),c=L.Event.fromNodeEventEmitter(a.stderr,"data");d(t=>this.logService.info(g.identifier.id,g.manifest.version,`post-${S}`,t)),c(t=>this.logService.error(g.identifier.id,g.manifest.version,`post-${S}`,t));const i=L.Event.any(L.Event.map(d,t=>({data:`%c${t}`,format:[""]})),L.Event.map(c,t=>({data:`%c${t}`,format:["color: red"]})));return L.Event.debounce(i,(t,n)=>t?{data:t.data+n.data,format:[...t.format,...n.format]}:{data:n.data,format:n.format},100)(t=>{console.group(g.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),a}getExtensionStoragePath(h){return(0,w.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};p=pe([Y(0,b.IUserDataProfilesService),Y(1,I.ILogService)],p),e.ExtensionsLifecycle=p}),define(ne[250],re([0,1,7,14,49,76,13,5,8,25,20]),function(Q,e,D,r,R,L,T,P,w,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let b=class extends L.NativeExtensionsScannerService{constructor(v,h,S,C,g,f,a){super(D.URI.file(g.builtinExtensionsPath),D.URI.file(g.extensionsPath),g.userHome,D.URI.file(g.userDataPath),v,h,S,C,g,f,a)}};b=pe([Y(0,I.IUserDataProfilesService),Y(1,R.IExtensionsProfileScannerService),Y(2,T.IFileService),Y(3,w.ILogService),Y(4,r.INativeEnvironmentService),Y(5,E.IProductService),Y(6,P.IInstantiationService)],b),e.ExtensionsScannerService=b}),define(ne[21],re([0,1,6,3,2,193,15,68,5,20]),function(Q,e,D,r,R,L,T,P,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,w.createDecorator)("storageService");var I;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(I=e.WillSaveStateReason||(e.WillSaveStateReason={}));var b;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(b=e.StorageScope||(e.StorageScope={}));var p;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(p=e.StorageTarget||(e.StorageTarget={}));function v(f){const a=f.get(e.TARGET_KEY);if(a)try{return JSON.parse(a)}catch{}return Object.create(null)}e.loadKeyTargets=v;class h extends R.Disposable{constructor(a={flushInterval:h.DEFAULT_FLUSH_INTERVAL}){super(),this.options=a,this._onDidChangeValue=this._register(new r.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new r.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new r.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new R.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,R.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,L.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(a,d){if(d===e.TARGET_KEY){switch(a){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:a})}else this._onDidChangeValue.fire({scope:a,key:d,target:this.getKeyTargets(a)[d]})}emitWillSaveState(a){this._onWillSaveState.fire({reason:a})}get(a,d,c){return this.getStorage(d)?.get(a,c)}getBoolean(a,d,c){return this.getStorage(d)?.getBoolean(a,c)}getNumber(a,d,c){return this.getStorage(d)?.getNumber(a,c)}store(a,d,c,i){if((0,T.isUndefinedOrNull)(d)){this.remove(a,c);return}this.withPausedEmitters(()=>{this.updateKeyTarget(a,c,i),this.getStorage(c)?.set(a,d)})}remove(a,d){this.withPausedEmitters(()=>{this.updateKeyTarget(a,d,void 0),this.getStorage(d)?.delete(a)})}withPausedEmitters(a){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{a()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(a,d){const c=[],i=this.getKeyTargets(a);for(const o of Object.keys(i))i[o]===d&&c.push(o);return c}updateKeyTarget(a,d,c){const i=this.getKeyTargets(d);typeof c=="number"?i[a]!==c&&(i[a]=c,this.getStorage(d)?.set(e.TARGET_KEY,JSON.stringify(i))):typeof i[a]=="number"&&(delete i[a],this.getStorage(d)?.set(e.TARGET_KEY,JSON.stringify(i)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(a){switch(a){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(a){const d=this.getStorage(a);return d?v(d):Object.create(null)}isNew(a){return this.getBoolean(e.IS_NEW_KEY,a)===!0}async flush(a=I.NONE){this._onWillSaveState.fire({reason:a});const d=this.getStorage(-1),c=this.getStorage(0),i=this.getStorage(1);switch(a){case I.NONE:await D.Promises.settled([d?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await D.Promises.settled([d?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const a=this.getStorage(-1)?.items??new Map,d=this.getStorage(0)?.items??new Map,c=this.getStorage(1)?.items??new Map;return g(a,d,c,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(a,d){return this.emitWillSaveState(I.NONE),(0,E.isUserDataProfile)(a)?this.switchToProfile(a,d):this.switchToWorkspace(a,d)}canSwitchProfile(a,d){return!(a.id===d.id||S(d)&&S(a))}switchData(a,d,c,i){this.withPausedEmitters(()=>{if(i)for(const[o,t]of a)d.set(o,t);else{const o=new Set;for(const[t,n]of a)o.add(t),d.get(t)!==n&&this.emitDidChangeValue(c,t);for(const[t]of d.items)o.has(t)||this.emitDidChangeValue(c,t)}})}}e.AbstractStorageService=h,h.DEFAULT_FLUSH_INTERVAL=60*1e3;function S(f){return f.isDefault||!!f.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=S;class C extends h{constructor(){super(),this.applicationStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.profileStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(a=>this.emitDidChangeValue(1,a))),this._register(this.profileStorage.onDidChangeStorage(a=>this.emitDidChangeValue(0,a))),this._register(this.applicationStorage.onDidChangeStorage(a=>this.emitDidChangeValue(-1,a)))}getStorage(a){switch(a){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(a){switch(a){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(a){return!1}}e.InMemoryStorageService=C;async function g(f,a,d,c,i,o){const t=A=>{try{return JSON.parse(A)}catch{return A}},n=new Map,s=new Map;f.forEach((A,U)=>{n.set(U,A),s.set(U,t(A))});const u=new Map,l=new Map;a.forEach((A,U)=>{u.set(U,A),l.set(U,t(A))});const m=new Map,y=new Map;d.forEach((A,U)=>{m.set(U,A),y.set(U,t(A))}),console.group(c!==i?`Storage: Application (path: ${c})`:`Storage: Application & Profile (path: ${c}, default profile)`);const _=[];if(n.forEach((A,U)=>{_.push({key:U,value:A})}),console.table(_),console.groupEnd(),console.log(s),c!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const A=[];u.forEach((U,k)=>{A.push({key:k,value:U})}),console.table(A),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${o})`);const $=[];m.forEach((A,U)=>{$.push({key:U,value:A})}),console.table($),console.groupEnd(),console.log(y)}e.logStorage=g}),define(ne[112],re([0,1,3,2,15,29,33,21]),function(Q,e,D,r,R,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let w=class extends r.Disposable{constructor(b,p){super(),this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new E(b)),this._register(this.storageManger.onDidChange(v=>this._onDidChangeEnablement.fire({extensions:v,source:"storage"}))),this._register(p.onDidInstallExtensions(v=>v.forEach(({local:h,operation:S})=>{h&&S===4&&this._removeFromDisabledExtensions(h.identifier)})))}async enableExtension(b,p){return this._removeFromDisabledExtensions(b)?(this._onDidChangeEnablement.fire({extensions:[b],source:p}),!0):!1}async disableExtension(b,p){return this._addToDisabledExtensions(b)?(this._onDidChangeEnablement.fire({extensions:[b],source:p}),!0):!1}getDisabledExtensions(){return this._getExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(b){const p=this.getDisabledExtensions();return p.every(v=>!(0,T.areSameExtensions)(v,b))?(p.push(b),this._setDisabledExtensions(p),!0):!1}_removeFromDisabledExtensions(b){const p=this.getDisabledExtensions();for(let v=0;v<p.length;v++){const h=p[v];if((0,T.areSameExtensions)(h,b))return p.splice(v,1),this._setDisabledExtensions(p),!0}return!1}_setDisabledExtensions(b){this._setExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH,b)}_getExtensions(b){return this.storageManger.get(b,0)}_setExtensions(b,p){this.storageManger.set(b,p,0)}};w=pe([Y(0,P.IStorageService),Y(1,L.IExtensionManagementService)],w),e.GlobalExtensionEnablementService=w;class E extends r.Disposable{constructor(b){super(),this.storageService=b,this.storage=Object.create(null),this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._register(b.onDidChangeValue(p=>this.onDidStorageChange(p)))}get(b,p){let v;return p===0?((0,R.isUndefinedOrNull)(this.storage[b])&&(this.storage[b]=this._get(b,p)),v=this.storage[b]):v=this._get(b,p),JSON.parse(v)}set(b,p,v){const h=JSON.stringify(p.map(({id:C,uuid:g})=>({id:C,uuid:g})));this._get(b,v)!==h&&(v===0&&(p.length?this.storage[b]=h:delete this.storage[b]),this._set(b,p.length?h:void 0,v))}onDidStorageChange(b){if(b.scope===0&&!(0,R.isUndefinedOrNull)(this.storage[b.key])&&this._get(b.key,b.scope)!==this.storage[b.key]){const v=this.get(b.key,b.scope);delete this.storage[b.key];const h=this.get(b.key,b.scope),S=v.filter(g=>!h.some(f=>(0,T.areSameExtensions)(g,f))),C=h.filter(g=>!v.some(f=>(0,T.areSameExtensions)(f,g)));(S.length||C.length)&&this._onDidChange.fire([...S,...C])}}_get(b,p){return this.storageService.get(b,p,"[]")}_set(b,p,v){p?this.storageService.store(b,p,v,1):this.storageService.remove(b,v)}}e.StorageManager=E}),define(ne[251],re([0,1,18,22,9,4,37,15,7,17,14,29,33,69,13,8,25,45,221,21,24]),function(Q,e,D,r,R,L,T,P,w,E,I,b,p,v,h,S,C,g,f,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const c=L.isWeb?"web":(0,b.getTargetPlatform)(L.platform,T.arch);var i;(function(O){O[O.None=0]="None",O[O.IncludeVersions=1]="IncludeVersions",O[O.IncludeFiles=2]="IncludeFiles",O[O.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",O[O.IncludeSharedAccounts=8]="IncludeSharedAccounts",O[O.IncludeVersionProperties=16]="IncludeVersionProperties",O[O.ExcludeNonValidated=32]="ExcludeNonValidated",O[O.IncludeInstallationTargets=64]="IncludeInstallationTargets",O[O.IncludeAssetUri=128]="IncludeAssetUri",O[O.IncludeStatistics=256]="IncludeStatistics",O[O.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",O[O.Unpublished=4096]="Unpublished",O[O.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function o(...O){return String(O.reduce((M,x)=>M|x,0))}var t;(function(O){O[O.Tag=1]="Tag",O[O.ExtensionId=4]="ExtensionId",O[O.Category=5]="Category",O[O.ExtensionName=7]="ExtensionName",O[O.Target=8]="Target",O[O.Featured=9]="Featured",O[O.SearchText=10]="SearchText",O[O.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const n={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},s={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},l={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class m{constructor(M=l){this.state=M}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(M,x=this.state.pageSize){return new m({...this.state,pageNumber:M,pageSize:x})}withFilter(M,...x){const V=[...this.state.criteria,...x.length?x.map(ee=>({filterType:M,value:ee})):[{filterType:M}]];return new m({...this.state,criteria:V})}withSortBy(M){return new m({...this.state,sortBy:M})}withSortOrder(M){return new m({...this.state,sortOrder:M})}withFlags(...M){return new m({...this.state,flags:M.reduce((x,V)=>x|V,0)})}withAssetTypes(...M){return new m({...this.state,assetTypes:M})}withSource(M){return new m({...this.state,source:M})}get raw(){const{criteria:M,pageNumber:x,pageSize:V,sortBy:ee,sortOrder:oe,flags:Z,assetTypes:ie}=this.state;return{filters:[{criteria:M,pageNumber:x,pageSize:V,sortBy:ee,sortOrder:oe}],assetTypes:ie,flags:Z}}get searchText(){const M=this.state.criteria.filter(x=>x.filterType===t.SearchText)[0];return M&&M.value?M.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(M=>String(M.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function y(O,M){const x=(O||[]).filter(V=>V.statisticName===M)[0];return x?x.value:0}function _(O){const M="Microsoft.VisualStudio.Code.Translation.";return O.files.filter(V=>V.assetType.indexOf(M)===0).reduce((V,ee)=>{const oe=U(O,ee.assetType);return oe&&V.push([ee.assetType.substring(M.length),oe]),V},[])}function $(O){if(O.properties){const M=O.properties.filter(ee=>ee.key===n.Repository),x=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),V=M.filter(ee=>x.test(ee.value))[0];return V?{uri:V.value,fallbackUri:V.value}:null}return U(O,n.Repository)}function A(O){return{uri:`${O.fallbackAssetUri}/${n.VSIX}?redirect=true${O.targetPlatform?`&targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${n.VSIX}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}}function U(O,M){return O.files.filter(V=>V.assetType===M)[0]?{uri:`${O.assetUri}/${M}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${M}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}:null}function k(O,M){const x=O.properties?O.properties.filter(ee=>ee.key===M):[],V=x.length>0&&x[0].value;return V?V.split(",").map(ee=>(0,p.adoptToGalleryExtensionId)(ee)):[]}function N(O){const M=O.properties?O.properties.filter(x=>x.key===s.Engine):[];return M.length>0&&M[0].value||""}function F(O){const M=O.properties?O.properties.filter(x=>x.key===s.PreRelease):[];return M.length>0&&M[0].value==="true"}function q(O){const M=O.properties?O.properties.filter(V=>V.key===s.LocalizedLanguages):[],x=M.length>0&&M[0].value||"";return x?x.split(","):[]}function J(O){return O.properties?.find(M=>M.key===s.SponsorLink)?.value}function j(O){return O.indexOf("preview")!==-1}function H(O){return O.targetPlatform?(0,b.toTargetPlatform)(O.targetPlatform):"undefined"}function W(O){const M=(0,D.distinct)(O.versions.map(H)),x=!!O.tags?.includes(b.WEB_EXTENSION_TAG),V=M.indexOf("web");return x?V===-1&&M.push("web"):V!==-1&&M.splice(V,1),M}function z(O,M){const x=(0,b.getFallbackTargetPlarforms)(M);for(let V=0;V<O.length;V++){const ee=O[V];if(ee.version===O[V-1]?.version){let oe=V;const Z=H(ee);if(Z===M)for(;oe>0&&O[oe-1].version===ee.version;)oe--;else if(x.includes(Z))for(;oe>0&&O[oe-1].version===ee.version&&H(O[oe-1])!==M;)oe--;oe!==V&&(O.splice(V,1),O.splice(oe,0,ee))}}return O}e.sortExtensionVersions=z;function K(O,M,x){O.telemetryData={index:M,querySource:x}}function X(O,M,x){const V=O.versions[0],ee={manifest:U(M,n.Manifest),readme:U(M,n.Details),changelog:U(M,n.Changelog),license:U(M,n.License),repository:$(M),download:A(M),icon:U(M,n.Icon),coreTranslations:_(M)};return{identifier:{id:(0,p.getGalleryExtensionId)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},name:O.extensionName,version:M.version,displayName:O.displayName,publisherId:O.publisher.publisherId,publisher:O.publisher.publisherName,publisherDisplayName:O.publisher.displayName,publisherDomain:O.publisher.domain?{link:O.publisher.domain,verified:!!O.publisher.isDomainVerified}:void 0,publisherSponsorLink:J(V),description:O.shortDescription||"",installCount:y(O.statistics,"install"),rating:y(O.statistics,"averagerating"),ratingCount:y(O.statistics,"ratingcount"),categories:O.categories||[],tags:O.tags||[],releaseDate:Date.parse(O.releaseDate),lastUpdated:Date.parse(O.lastUpdated),allTargetPlatforms:x,assets:ee,properties:{dependencies:k(M,s.Dependency),extensionPack:k(M,s.ExtensionPack),engine:N(M),localizedLanguages:q(M),targetPlatform:H(M),isPreReleaseVersion:F(M)},hasPreReleaseVersion:F(V),hasReleaseVersion:!0,preview:j(O.flags)}}let ce=class{constructor(M,x,V,ee,oe,Z,ie,se){this.requestService=x,this.logService=V,this.environmentService=ee,this.telemetryService=oe,this.fileService=Z,this.productService=ie,this.configurationService=se;const ue=ie.extensionsGallery;this.extensionsGalleryUrl=ue?.serviceUrl,this.extensionsGallerySearchUrl=ue?.searchUrl,this.extensionsControlUrl=ue?.controlUrl,this.commonHeadersPromise=(0,f.resolveMarketplaceHeaders)(ie.version,ie,this.environmentService,this.configurationService,this.fileService,M,this.telemetryService)}api(M=""){return`${this.extensionsGalleryUrl}${M}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(M,x,V){const ee=r.CancellationToken.isCancellationToken(x)?{}:x,oe=r.CancellationToken.isCancellationToken(x)?x:V,Z=[],ie=[],se=[],ue=[];let de=!0;for(const Ee of M){Ee.uuid?ie.push(Ee.uuid):Z.push(Ee.id);const Ce=!!(Ee.version||Ee.preRelease);se.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:Ce}),Ee.version&&ue.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),de=de&&!!Ee.hasPreRelease&&!Ce}if(!ie.length&&!Z.length)return[];let ve=new m().withPage(1,M.length);ie.length&&(ve=ve.withFilter(t.ExtensionId,...ie)),Z.length&&(ve=ve.withFilter(t.ExtensionName,...Z)),(ee.queryAllVersions||de)&&(ve=ve.withFlags(ve.flags,i.IncludeVersions)),ee.source&&(ve=ve.withSource(ee.source));const{extensions:we}=await this.queryGalleryExtensions(ve,{targetPlatform:ee.targetPlatform??c,includePreRelease:se,versions:ue,compatible:!!ee.compatible},oe);return ee.source&&we.forEach((Ee,Ce)=>K(Ee,Ce,ee.source)),we}async getCompatibleExtension(M,x,V){if((0,b.isNotWebExtensionInWebTargetPlatform)(M.allTargetPlatforms,V))return null;if(await this.isExtensionCompatible(M,x,V))return M;const ee=new m().withFlags(i.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,M.identifier.uuid),{extensions:oe}=await this.queryGalleryExtensions(ee,{targetPlatform:V,compatible:!0,includePreRelease:x},r.CancellationToken.None);return oe[0]||null}async isExtensionCompatible(M,x,V){if(!(0,b.isTargetPlatformCompatible)(M.properties.targetPlatform,M.allTargetPlatforms,V)||!x&&M.properties.isPreReleaseVersion)return!1;let ee=M.properties.engine;if(!ee){const oe=await this.getManifest(M,r.CancellationToken.None);if(!oe)throw new Error("Manifest was not found");ee=oe.engines.vscode}return(0,v.isEngineValid)(ee,this.productService.version,this.productService.date)}async isValidVersion(M,x,V,ee,oe){if(!(0,b.isTargetPlatformCompatible)(H(M),ee,oe)||x!=="any"&&F(M)!==(x==="prerelease"))return!1;if(V)try{const Z=await this.getEngine(M);if(!(0,v.isEngineValid)(Z,this.productService.version,this.productService.date))return!1}catch(Z){return this.logService.error(`Error while getting the engine for the version ${M.version}.`,(0,R.getErrorMessage)(Z)),!1}return!0}async query(M,x){let V=M.text||"";const ee=M.pageSize??50;let oe=new m().withPage(1,ee);V?(V=V.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,ve,we)=>(oe=oe.withFilter(t.Category,we||ve),"")),V=V.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,ve,we)=>(oe=oe.withFilter(t.Tag,we||ve),"")),V=V.replace(/\bfeatured(\s+|\b|$)/g,()=>(oe=oe.withFilter(t.Featured),"")),V=V.trim(),V&&(V=V.length<200?V:V.substring(0,200),oe=oe.withFilter(t.SearchText,V)),oe=oe.withSortBy(0)):M.ids?oe=oe.withFilter(t.ExtensionId,...M.ids):M.names?oe=oe.withFilter(t.ExtensionName,...M.names):oe=oe.withSortBy(4),typeof M.sortBy=="number"&&(oe=oe.withSortBy(M.sortBy)),typeof M.sortOrder=="number"&&(oe=oe.withSortOrder(M.sortOrder)),M.source&&(oe=oe.withSource(M.source));const Z=async(de,ve)=>{const{extensions:we,total:Ee}=await this.queryGalleryExtensions(de,{targetPlatform:c,compatible:!1,includePreRelease:!!M.includePreRelease},ve);return we.forEach((Ce,Ue)=>K(Ce,(de.pageNumber-1)*de.pageSize+Ue,M.source)),{extensions:we,total:Ee}},{extensions:ie,total:se}=await Z(oe,x),ue=async(de,ve)=>{if(ve.isCancellationRequested)throw new R.CancellationError;const{extensions:we}=await Z(oe.withPage(de+1),ve);return we};return{firstPage:ie,total:se,pageSize:oe.pageSize,getPage:ue}}async queryGalleryExtensions(M,x,V){const ee=M.flags;!!(M.flags&i.IncludeLatestVersionOnly)&&!!(M.flags&i.IncludeVersions)&&(M=M.withFlags(M.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(M.flags&i.IncludeLatestVersionOnly)&&!(M.flags&i.IncludeVersions)&&(M=M.withFlags(M.flags,i.IncludeLatestVersionOnly)),x.versions?.length&&(M=M.withFlags(M.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),M=M.withFlags(M.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:oe,total:Z}=await this.queryRawGalleryExtensions(M,V);if(!(M.flags&i.IncludeLatestVersionOnly)){const de=[];for(const ve of oe){const we=await this.toGalleryExtensionWithCriteria(ve,x);we&&de.push(we)}return{extensions:de,total:Z}}const se=[],ue=new Map;for(let de=0;de<oe.length;de++){const ve=oe[de],we={id:(0,p.getGalleryExtensionId)(ve.publisher.publisherName,ve.extensionName),uuid:ve.extensionId},Ee=(0,P.isBoolean)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(Ue=>(0,p.areSameExtensions)(Ue,we))?.includePreRelease;if(x.compatible&&(0,b.isNotWebExtensionInWebTargetPlatform)(W(ve),x.targetPlatform))continue;const Ce=await this.toGalleryExtensionWithCriteria(ve,x);!Ce||Ce.properties.isPreReleaseVersion&&(!Ee||!Ce.hasReleaseVersion)||!Ce.properties.isPreReleaseVersion&&Ce.properties.targetPlatform!==x.targetPlatform&&Ce.hasPreReleaseVersion?ue.set(ve.extensionId,de):se.push([de,Ce])}if(ue.size){const de=new Date().getTime(),ve=new m().withFlags(ee&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,ue.size).withFilter(t.ExtensionId,...ue.keys()),{extensions:we}=await this.queryGalleryExtensions(ve,x,V);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-de,count:ue.size});for(const Ee of we){const Ce=ue.get(Ee.identifier.uuid);se.push([Ce,Ee])}}return{extensions:se.sort((de,ve)=>de[0]-ve[0]).map(([,de])=>de),total:Z}}async toGalleryExtensionWithCriteria(M,x){const V={id:(0,p.getGalleryExtensionId)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},ee=x.versions?.find(se=>(0,p.areSameExtensions)(se,V))?.version,oe=(0,P.isBoolean)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(se=>(0,p.areSameExtensions)(se,V))?.includePreRelease,Z=W(M),ie=z(M.versions,x.targetPlatform);if(x.compatible&&(0,b.isNotWebExtensionInWebTargetPlatform)(Z,x.targetPlatform))return null;for(let se=0;se<ie.length;se++){const ue=ie[se];if(!(ee&&ue.version!==ee)){if(await this.isValidVersion(ue,oe?"any":"release",x.compatible,Z,x.targetPlatform))return X(M,ue,Z);if(ee&&ue.version===ee)return null}}return ee||x.compatible?null:X(M,M.versions[0],Z)}async queryRawGalleryExtensions(M,x){if(!this.isEnabled())throw new Error("No extension gallery service configured.");M=M.withFlags(M.flags,i.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,o(i.Unpublished));const V=await this.commonHeadersPromise,ee=JSON.stringify(M.raw),oe={...V,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ee.length)},Z=new Date().getTime();let ie,se,ue=0;try{if(ie=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&M.criteria.some(ve=>ve.filterType===t.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:ee,headers:oe},x),ie.res.statusCode&&ie.res.statusCode>=400&&ie.res.statusCode<500)return{galleryExtensions:[],total:ue};const de=await(0,g.asJson)(ie);if(de){const ve=de.results[0],we=ve.extensions,Ee=ve.resultMetadata&&ve.resultMetadata.filter(Ce=>Ce.metadataType==="ResultCount")[0];return ue=Ee&&Ee.metadataItems.filter(Ce=>Ce.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:ue}}return{galleryExtensions:[],total:ue}}catch(de){throw se=de,de}finally{this.telemetryService.publicLog2("galleryService:query",{...M.telemetryData,requestBodySize:String(ee.length),duration:new Date().getTime()-Z,success:!!ie&&(0,g.isSuccess)(ie),responseBodySize:ie?.res.headers["Content-Length"],statusCode:ie?String(ie.res.statusCode):void 0,errorCode:se?(0,R.isCancellationError)(se)?"canceled":(0,R.getErrorMessage)(se).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ue)})}}async reportStatistic(M,x,V,ee){if(!this.isEnabled())return;const oe=L.isWeb?this.api(`/itemName/${M}.${x}/version/${V}/statType/${ee==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${M}/extensions/${x}/${V}/stats?statType=${ee}`),Z=L.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",se={...await this.commonHeadersPromise,Accept:Z};try{await this.requestService.request({type:"POST",url:oe,headers:se},r.CancellationToken.None)}catch{}}async download(M,x,V){this.logService.trace("ExtensionGalleryService#download",M.identifier.id);const ee=(0,p.getGalleryExtensionTelemetryData)(M),oe=new Date().getTime(),Z=de=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ee,duration:de}),ie=V===2?"install":V===3?"update":"",se=ie?{uri:`${M.assets.download.uri}${w.URI.parse(M.assets.download.uri).query?"&":"?"}${ie}=true`,fallbackUri:`${M.assets.download.fallbackUri}${w.URI.parse(M.assets.download.fallbackUri).query?"&":"?"}${ie}=true`}:M.assets.download,ue=await this.getAsset(se);await this.fileService.writeFile(x,ue.stream),Z(new Date().getTime()-oe)}async getReadme(M,x){if(M.assets.readme){const V=await this.getAsset(M.assets.readme,{},x);return await(0,g.asTextOrError)(V)||""}return""}async getManifest(M,x){if(M.assets.manifest){const V=await this.getAsset(M.assets.manifest,{},x),ee=await(0,g.asTextOrError)(V);return ee?JSON.parse(ee):null}return null}async getManifestFromRawExtensionVersion(M,x){const V=U(M,n.Manifest);if(!V)throw new Error("Manifest was not found");const ee={"Accept-Encoding":"gzip"},oe=await this.getAsset(V,{headers:ee});return await(0,g.asJson)(oe)}async getCoreTranslation(M,x){const V=M.assets.coreTranslations.filter(ee=>ee[0]===x.toUpperCase())[0];if(V){const ee=await this.getAsset(V[1]),oe=await(0,g.asTextOrError)(ee);return oe?JSON.parse(oe):null}return null}async getChangelog(M,x){if(M.assets.changelog){const V=await this.getAsset(M.assets.changelog,{},x);return await(0,g.asTextOrError)(V)||""}return""}async getAllCompatibleVersions(M,x,V){let ee=new m().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);M.identifier.uuid?ee=ee.withFilter(t.ExtensionId,M.identifier.uuid):ee=ee.withFilter(t.ExtensionName,M.identifier.id);const{galleryExtensions:oe}=await this.queryRawGalleryExtensions(ee,r.CancellationToken.None);if(!oe.length)return[];const Z=W(oe[0]);if((0,b.isNotWebExtensionInWebTargetPlatform)(Z,V))return[];const ie=[];await Promise.all(oe[0].versions.map(async de=>{try{await this.isValidVersion(de,x?"any":"release",!0,Z,V)&&ie.push(de)}catch{}}));const se=[],ue=new Set;for(const de of z(ie,V))ue.has(de.version)||(ue.add(de.version),se.push({version:de.version,date:de.lastUpdated,isPreReleaseVersion:F(de)}));return se}async getAsset(M,x={},V=r.CancellationToken.None){const ee=await this.commonHeadersPromise,oe={type:"GET"},Z={...ee,...x.headers||{}};x={...x,...oe,headers:Z};const ie=M.uri,se=M.fallbackUri,ue={...x,url:ie};try{const de=await this.requestService.request(ue,V);if(de.res.statusCode===200)return de;const ve=await(0,g.asTextOrError)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${ve}`)}catch(de){if((0,R.isCancellationError)(de))throw de;const ve=(0,R.getErrorMessage)(de);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ie,message:ve});const we={...x,url:se};return this.requestService.request(we,V)}}async getEngine(M){let x=N(M);if(!x){const V=await this.getManifestFromRawExtensionVersion(M,r.CancellationToken.None);if(!V)throw new Error("Manifest was not found");x=V.engines.vscode}return x}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const M=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},r.CancellationToken.None);if(M.res.statusCode!==200)throw new Error("Could not get extensions report.");const x=await(0,g.asJson)(M),V=[],ee={};if(x){for(const oe of x.malicious)V.push({id:oe});if(x.migrateToPreRelease)for(const[oe,Z]of Object.entries(x.migrateToPreRelease))(!Z.engine||(0,v.isEngineValid)(Z.engine,this.productService.version,this.productService.date))&&(ee[oe.toLowerCase()]={disallowInstall:!0,extension:{id:Z.id,displayName:Z.displayName,autoMigrate:{storage:!!Z.migrateStorage},preRelease:!0}});if(x.deprecated)for(const[oe,Z]of Object.entries(x.deprecated))Z&&(ee[oe.toLowerCase()]=(0,P.isBoolean)(Z)?{}:Z)}return{malicious:V,deprecated:ee}}};ce=pe([Y(1,g.IRequestService),Y(2,S.ILogService),Y(3,I.IEnvironmentService),Y(4,d.ITelemetryService),Y(5,h.IFileService),Y(6,C.IProductService),Y(7,E.IConfigurationService)],ce);let B=class extends ce{constructor(M,x,V,ee,oe,Z,ie,se){super(M,x,V,ee,oe,Z,ie,se)}};B=pe([Y(0,a.IStorageService),Y(1,g.IRequestService),Y(2,S.ILogService),Y(3,I.IEnvironmentService),Y(4,d.ITelemetryService),Y(5,h.IFileService),Y(6,C.IProductService),Y(7,E.IConfigurationService)],B),e.ExtensionGalleryService=B;let G=class extends ce{constructor(M,x,V,ee,oe,Z,ie){super(void 0,M,x,V,ee,oe,Z,ie)}};G=pe([Y(0,g.IRequestService),Y(1,S.ILogService),Y(2,I.IEnvironmentService),Y(3,d.ITelemetryService),Y(4,h.IFileService),Y(5,C.IProductService),Y(6,E.IConfigurationService)],G),e.ExtensionGalleryServiceWithNoStorageService=G}),define(ne[77],re([0,1,5,3,2,21,33,25,18,8,15]),function(Q,e,D,r,R,L,T,P,w,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,D.createDecorator)("IExtensionStorageService");const b=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let p=class Xe extends R.Disposable{static toKey(h){return`extensionKeys/${(0,T.adoptToGalleryExtensionId)(h.id)}@${h.version}`}static fromKey(h){const S=b.exec(h);if(S&&S[1])return{id:S[1],version:S[2]}}static async removeOutdatedExtensionVersions(h,S){const C=await h.getInstalled(),g=[];for(const[f,a]of Xe.readAllExtensionsWithKeysForSync(S)){const d=C.find(c=>(0,T.areSameExtensions)(c.identifier,{id:f}))?.manifest.version;for(const c of a)d!==c&&g.push(Xe.toKey({id:f,version:c}))}for(const f of g)S.remove(f,0)}static readAllExtensionsWithKeysForSync(h){const S=new Map,C=h.keys(0,1);for(const g of C){const f=Xe.fromKey(g);if(f){let a=S.get(f.id.toLowerCase());a||S.set(f.id.toLowerCase(),a=[]),a.push(f.version)}}return S}constructor(h,S,C){super(),this.storageService=h,this.productService=S,this.logService=C,this._onDidChangeExtensionStorageToSync=this._register(new r.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=Xe.readAllExtensionsWithKeysForSync(h),this._register(this.storageService.onDidChangeValue(g=>this.onDidChangeStorageValue(g)))}onDidChangeStorageValue(h){if(h.scope!==0)return;if(this.extensionsWithKeysForSync.has(h.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const S=Xe.fromKey(h.key);if(S){if(this.storageService.get(h.key,0)===void 0)this.extensionsWithKeysForSync.delete(S.id.toLowerCase());else{let C=this.extensionsWithKeysForSync.get(S.id.toLowerCase());C||this.extensionsWithKeysForSync.set(S.id.toLowerCase(),C=[]),C.push(S.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(h){if((0,I.isString)(h))return h;const S=h.manifest?h.manifest.publisher:h.publisher,C=h.manifest?h.manifest.name:h.name;return(0,T.getExtensionId)(S,C)}getExtensionState(h,S){const C=this.getExtensionId(h),g=this.storageService.get(C,S?0:1);if(g)try{return JSON.parse(g)}catch(f){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${C}, global: ${S}): ${f}`)}}setExtensionState(h,S,C){const g=this.getExtensionId(h);S===void 0?this.storageService.remove(g,C?0:1):this.storageService.store(g,JSON.stringify(S),C?0:1,1)}setKeysForSync(h,S){this.storageService.store(Xe.toKey(h),JSON.stringify(S),0,1)}getKeysForSync(h){const S=this.productService.extensionSyncedKeys?.[h.id.toLowerCase()],C=this.storageService.get(Xe.toKey(h),0),g=C?JSON.parse(C):void 0;return g&&S?(0,w.distinct)([...g,...S]):g||S}addToMigrationList(h,S){if(h!==S){const C=this.migrationList.filter(g=>!g.includes(h)&&!g.includes(S));C.push([h,S]),this.migrationList=C}}getSourceExtensionToMigrate(h){const S=this.migrationList.find(([,C])=>h===C);return S?S[0]:void 0}get migrationList(){const h=this.storageService.get("extensionStorage.migrationList",-1,"[]");try{const S=JSON.parse(h);if(Array.isArray(S))return S}catch{}return[]}set migrationList(h){h.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(h),-1,1):this.storageService.remove("extensionStorage.migrationList",-1)}};p=pe([Y(0,L.IStorageService),Y(1,P.IProductService),Y(2,E.ILogService)],p),e.ExtensionStorageService=p}),define(ne[252],re([0,1,18,6,3,12,4,37,7,148,14,29,33,212,95,13,8,59,25,45,21,24]),function(Q,e,D,r,R,L,T,P,w,E,I,b,p,v,h,S,C,g,f,a,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const i="extensionTips/promptedExecutableTips",o="extensionTips/lastPromptedMediumImpExeTime";let t=class extends v.ExtensionTipsService{constructor(s,u,l,m,y,_,$,A,U,k){super($,A,U,k),this.environmentService=s,this.telemetryService=u,this.extensionManagementService=l,this.storageService=m,this.nativeHostService=y,this.extensionRecommendationNotificationService=_,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,A.exeBasedExtensionTips&&Object.entries(A.exeBasedExtensionTips).forEach(([N,F])=>{const q=[],J=[],j=[];Object.entries(F.recommendations).forEach(([H,W])=>{W.important?F.important?q.push({extensionId:H,extensionName:W.name,isExtensionPack:!!W.isExtensionPack}):J.push({extensionId:H,extensionName:W.name,isExtensionPack:!!W.isExtensionPack}):j.push({extensionId:H,extensionName:W.name,isExtensionPack:!!W.isExtensionPack})}),q.length&&this.highImportanceExecutableTips.set(N,{exeFriendlyName:F.friendlyName,windowsPath:F.windowsPath,recommendations:q}),J.length&&this.mediumImportanceExecutableTips.set(N,{exeFriendlyName:F.friendlyName,windowsPath:F.windowsPath,recommendations:J}),j.length&&this.allOtherExecutableTips.set(N,{exeFriendlyName:F.friendlyName,windowsPath:F.windowsPath,recommendations:j})}),(0,r.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),u=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...s,...u]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),u=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),l=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(s,l),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(u,l)}groupImportantTipsByExe(s,u){const l=new Map;s.forEach(A=>l.set(A.extensionId.toLowerCase(),A));const{installed:m,uninstalled:y}=this.groupByInstalled([...l.keys()],u);for(const A of m){const U=l.get(A);U&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:A,exeName:U.exeName})}for(const A of y){const U=l.get(A);U&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:A,exeName:U.exeName})}const _=this.getPromptedExecutableTips(),$=new Map;for(const A of y){const U=l.get(A);if(U&&(!_[U.exeName]||!_[U.exeName].includes(U.extensionId))){let k=$.get(U.exeName);k||(k=[],$.set(U.exeName,k)),k.push(U)}}return $}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[s,u]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(u).then(l=>{switch(l){case"reacted":this.addToRecommendedExecutables(u[0].exeName,u);break;case"ignored":this.highImportanceTipsByExe.delete(s);break;case"incompatibleWindow":{const m=R.Event.once(R.Event.latch(R.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(m(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const m=this._register((0,r.disposableTimeout)(()=>{m.dispose(),this.promptHighImportanceExeBasedTip()},36e5));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const s=this.getLastPromptedMediumExeTime(),u=Date.now()-s,l=7*24*60*60*1e3;if(u<l){const _=this._register((0,r.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},l-u));return}const[m,y]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(y).then(_=>{switch(_){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(m),this.addToRecommendedExecutables(y[0].exeName,y);const $=this._register((0,r.disposableTimeout)(()=>{$.dispose(),this.promptMediumImportanceExeBasedTip()},l));break}case"ignored":this.mediumImportanceTipsByExe.delete(m),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const $=R.Event.once(R.Event.latch(R.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register($(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const $=this._register((0,r.disposableTimeout)(()=>{$.dispose(),this.promptMediumImportanceExeBasedTip()},36e5));break}}})}async promptExeRecommendations(s){const u=await this.extensionManagementService.getInstalled(1),l=s.filter(y=>!y.whenNotInstalled||y.whenNotInstalled.every(_=>u.every($=>!(0,p.areSameExtensions)($.identifier,{id:_})))).map(({extensionId:y})=>y.toLowerCase()),m=(0,E.localize)(0,null,s[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(l,m,`@exe:"${s[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let s=this.storageService.getNumber(o,-1);return s||(s=Date.now(),this.updateLastPromptedMediumExeTime(s)),s}updateLastPromptedMediumExeTime(s){this.storageService.store(o,s,-1,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(i,-1,"{}"))}addToRecommendedExecutables(s,u){const l=this.getPromptedExecutableTips();l[s]=u.map(({extensionId:m})=>m.toLowerCase()),this.storageService.store(i,JSON.stringify(l),-1,0)}groupByInstalled(s,u){const l=[],m=[],y=u.reduce((_,$)=>(_.add($.identifier.id.toLowerCase()),_),new Set);return s.forEach(_=>{y.has(_.toLowerCase())?l.push(_):m.push(_)}),{installed:l,uninstalled:m}}async getValidExecutableBasedExtensionTips(s){const u=[],l=new Map;for(const m of s.keys()){const y=s.get(m);if(!y||!(0,D.isNonEmptyArray)(y.recommendations))continue;const _=[];T.isWindows?y.windowsPath&&_.push(y.windowsPath.replace("%USERPROFILE%",P.env.USERPROFILE).replace("%ProgramFiles(x86)%",P.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",P.env.ProgramFiles).replace("%APPDATA%",P.env.APPDATA).replace("%WINDIR%",P.env.WINDIR)):(_.push((0,L.join)("/usr/local/bin",m)),_.push((0,L.join)("/usr/bin",m)),_.push((0,L.join)(this.environmentService.userHome.fsPath,m)));for(const $ of _){let A=l.get($);if(A===void 0&&(A=await this.fileService.exists(w.URI.file($)),l.set($,A)),A)for(const{extensionId:U,extensionName:k,isExtensionPack:N,whenNotInstalled:F}of y.recommendations)u.push({extensionId:U,extensionName:k,isExtensionPack:N,exeName:m,exeFriendlyName:y.exeFriendlyName,windowsPath:y.windowsPath,whenNotInstalled:F})}}return u}};t=pe([Y(0,I.INativeEnvironmentService),Y(1,c.ITelemetryService),Y(2,b.IExtensionManagementService),Y(3,d.IStorageService),Y(4,g.INativeHostService),Y(5,h.IExtensionRecommendationNotificationService),Y(6,S.IFileService),Y(7,f.IProductService),Y(8,a.IRequestService),Y(9,C.ILogService)],t),e.ExtensionTipsService=t}),define(ne[253],re([0,1,6,2,19,68,21,73,20]),function(Q,e,D,r,R,L,T,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class E extends T.AbstractStorageService{constructor(b,p,v,h){super(),this.initialWorkspace=b,this.initialProfiles=p,this.mainProcessService=v,this.environmentService=h,this.applicationStorageProfile=this.initialProfiles.defaultProfile,this.applicationStorage=this.createApplicationStorage(),this.profileStorageProfile=this.initialProfiles.currentProfile,this.profileStorageDisposables=this._register(new r.DisposableStore),this.profileStorage=this.createProfileStorage(this.profileStorageProfile),this.workspaceStorageId=this.initialWorkspace?.id,this.workspaceStorageDisposables=this._register(new r.DisposableStore),this.workspaceStorage=this.createWorkspaceStorage(this.initialWorkspace)}createApplicationStorage(){const b=this._register(new P.ApplicationStorageDatabaseClient(this.mainProcessService.getChannel("storage"))),p=this._register(new L.Storage(b));return this._register(p.onDidChangeStorage(v=>this.emitDidChangeValue(-1,v))),p}createProfileStorage(b){this.profileStorageDisposables.clear(),this.profileStorageProfile=b;let p;if((0,T.isProfileUsingDefaultStorage)(b))p=this.applicationStorage;else{const v=this.profileStorageDisposables.add(new P.ProfileStorageDatabaseClient(this.mainProcessService.getChannel("storage"),b));p=this.profileStorageDisposables.add(new L.Storage(v))}return this.profileStorageDisposables.add(p.onDidChangeStorage(v=>this.emitDidChangeValue(0,v))),p}createWorkspaceStorage(b){this.workspaceStorageDisposables.clear(),this.workspaceStorageId=b?.id;let p;if(b){const v=this.workspaceStorageDisposables.add(new P.WorkspaceStorageDatabaseClient(this.mainProcessService.getChannel("storage"),b));p=this.workspaceStorageDisposables.add(new L.Storage(v)),this.workspaceStorageDisposables.add(p.onDidChangeStorage(h=>this.emitDidChangeValue(1,h)))}return p}async doInitialize(){await D.Promises.settled([this.applicationStorage.init(),this.profileStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(b){switch(b){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(b){switch(b){case-1:return this.applicationStorageProfile.globalStorageHome.fsPath;case 0:return this.profileStorageProfile?.globalStorageHome.fsPath;default:return this.workspaceStorageId?`${(0,R.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(T.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.applicationStorage.close(),this.profileStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async switchToProfile(b,p){if(!this.canSwitchProfile(this.profileStorageProfile,b))return;const v=this.profileStorage,h=v.items;v!==this.applicationStorage&&await v.close(),this.profileStorage=this.createProfileStorage(b),await this.profileStorage.init(),this.switchData(h,this.profileStorage,0,p)}async switchToWorkspace(b,p){const v=this.workspaceStorage,h=v?.items??new Map;await v?.close(),this.workspaceStorage=this.createWorkspaceStorage(b),await this.workspaceStorage.init(),this.switchData(h,this.workspaceStorage,1,p)}hasScope(b){return(0,w.isUserDataProfile)(b)?this.profileStorageProfile.id===b.id:this.workspaceStorageId===b.id}}e.NativeStorageService=E}),define(ne[254],re([0,1,3,2,19,14,58,20]),function(Q,e,D,r,R,L,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesNativeService=void 0;let w=class extends r.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this._profiles}constructor(I,b,p){super(),this._profiles=[],this._onDidChangeProfiles=this._register(new D.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.channel=b.getChannel("userDataProfiles"),this.profilesHome=(0,R.joinPath)(p.userRoamingDataHome,"profiles"),this._profiles=I.map(v=>(0,P.reviveProfile)(v,this.profilesHome.scheme)),this._register(this.channel.listen("onDidChangeProfiles")(v=>{const h=v.added.map(g=>(0,P.reviveProfile)(g,this.profilesHome.scheme)),S=v.removed.map(g=>(0,P.reviveProfile)(g,this.profilesHome.scheme)),C=v.updated.map(g=>(0,P.reviveProfile)(g,this.profilesHome.scheme));this._profiles=v.all.map(g=>(0,P.reviveProfile)(g,this.profilesHome.scheme)),this._onDidChangeProfiles.fire({added:h,removed:S,updated:C,all:this.profiles})})),this.onDidResetWorkspaces=this.channel.listen("onDidResetWorkspaces")}async createNamedProfile(I,b,p){const v=await this.channel.call("createNamedProfile",[I,b,p]);return(0,P.reviveProfile)(v,this.profilesHome.scheme)}async createProfile(I,b,p,v){const h=await this.channel.call("createProfile",[I,b,p,v]);return(0,P.reviveProfile)(h,this.profilesHome.scheme)}async createTransientProfile(I){const b=await this.channel.call("createTransientProfile",[I]);return(0,P.reviveProfile)(b,this.profilesHome.scheme)}async setProfileForWorkspace(I,b){await this.channel.call("setProfileForWorkspace",[I,b])}removeProfile(I){return this.channel.call("removeProfile",[I])}async updateProfile(I,b){const p=await this.channel.call("updateProfile",[I,b]);return(0,P.reviveProfile)(p,this.profilesHome.scheme)}resetWorkspaces(){return this.channel.call("resetWorkspaces")}cleanUp(){return this.channel.call("cleanUp")}cleanUpTransientProfiles(){return this.channel.call("cleanUpTransientProfiles")}};w=pe([Y(1,T.IMainProcessService),Y(2,L.IEnvironmentService)],w),e.UserDataProfilesNativeService=w}),define(ne[41],re([0,1,18,6,16,22,3,35,2,27,15,7,163,17,14,13,8,48,21,24,31,26,20]),function(Q,e,D,r,R,L,T,P,w,E,I,b,p,v,h,S,C,g,f,a,d,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function o(l){return!!(l&&l.version!==void 0&&typeof l.version=="number"&&l.content!==void 0&&typeof l.content=="string"&&(Object.keys(l).length===2||Object.keys(l).length===3&&l.machineId!==void 0&&typeof l.machineId=="string"))}e.isSyncData=o;let t=class extends w.Disposable{get status(){return this._status}get conflicts(){return{...this.syncResource,conflicts:this._conflicts}}constructor(m,y,_,$,A,U,k,N,F,q,J,j){super(),this.syncResource=m,this.collection=y,this.fileService=_,this.environmentService=$,this.userDataSyncStoreService=U,this.userDataSyncBackupStoreService=k,this.userDataSyncEnablementService=N,this.telemetryService=F,this.logService=q,this.configurationService=J,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new r.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.resource=this.syncResource.syncResource,this.syncResourceLogLabel=`${(0,E.uppercaseFirstLetter)(this.resource)}${m.profile.isDefault?"":` (${m.profile.name})`}`,this.extUri=j.extUri,this.syncFolder=this.extUri.joinPath($.userDataSyncHome,...(0,c.getPathSegments)(m.profile.isDefault?void 0:m.profile.id,m.syncResource)),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,c.PREVIEW_DIR_NAME),this.lastSyncResource=(0,c.getLastSyncResourceUri)(m.profile.isDefault?void 0:m.profile.id,m.syncResource,$,this.extUri),this.currentMachineIdPromise=(0,g.getServiceMachineId)($,_,A)}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const m=await this.syncPreviewPromise;this.syncPreviewPromise=null;const y=await this.performSync(m.remoteUserData,m.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(y)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const m=await this.getLastSyncUserData();(m?await this.hasRemoteChanged(m):!0)&&this._onDidChangeLocal.fire()}}setStatus(m){this._status!==m&&(this._status=m,this._onDidChangStatus.fire(m))}async sync(m,y={}){await this._sync(m,!0,this.getUserDataSyncConfiguration(),y)}async preview(m,y,_={}){return this._sync(m,!1,y,_)}async apply(m,y={}){try{this.syncHeaders={...y};const _=await this.doApply(m);return this.setStatus(_),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(m,y,_,$){try{if(this.syncHeaders={...$},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let A="idle";try{const U=await this.getLastSyncUserData(),k=await this.getLatestRemoteUserData(m,U);return A=await this.performSync(k,U,y,_),A==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):A==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(A)}}finally{this.syncHeaders={}}}async replace(m){const y=await this.resolveContent(m);if(!y)return!1;const _=this.parseSyncData(y);if(!_)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const $=await this.getLastSyncUserData(),A=await this.getLatestRemoteUserData(null,$),U=await this.isRemoteDataFromCurrentMachine(A),k=await this.generateSyncPreview({ref:A.ref,syncData:_},$,U,this.getUserDataSyncConfiguration(),L.CancellationToken.None),N=[];for(const F of k){const q=await this.getAcceptResult(F,F.remoteResource,void 0,L.CancellationToken.None),{remoteChange:J}=await this.getAcceptResult(F,F.previewResource,F.remoteContent,L.CancellationToken.None);N.push([F,{...q,remoteChange:J!==0?J:2}])}await this.applyResult(A,$,N,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(m){const y=await this.currentMachineIdPromise;return!!m.syncData?.machineId&&m.syncData.machineId===y}async getLatestRemoteUserData(m,y){if(y){const _=m?m[this.resource]:void 0;if(y.ref===_||_===void 0&&y.syncData===null)return y}return this.getRemoteUserData(y)}async performSync(m,y,_,$){if(m.syncData&&m.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new c.UserDataSyncError((0,p.localize)(0,null,this.resource,this.version,m.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(m,y,_,$)}catch(A){if(A instanceof c.UserDataSyncError)switch(A.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(m,y,_,$);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),m=await this.getRemoteUserData(null),y=await this.getLastSyncUserData(),this.performSync(m,y,_,$)}throw A}}async doSync(m,y,_,$){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,r.createCancelablePromise)(U=>this.doGenerateSyncResourcePreview(m,y,_,$,U)));const A=await this.syncPreviewPromise;return this.updateConflicts(A.resourcePreviews),A.resourcePreviews.some(({mergeState:U})=>U==="conflict")?"hasConflicts":_?await this.doApply(!1):"syncing"}catch(A){throw this.syncPreviewPromise=null,A}}async merge(m){return await this.updateSyncResourcePreview(m,async y=>{const _=await this.getMergeResult(y,L.CancellationToken.None);await this.fileService.writeFile(y.previewResource,R.VSBuffer.fromString(_?.content||""));const $=_&&!_.hasConflicts?await this.getAcceptResult(y,y.previewResource,void 0,L.CancellationToken.None):void 0;return y.acceptResult=$,y.mergeState=_.hasConflicts?"conflict":$?"accepted":"preview",y.localChange=$?$.localChange:_.localChange,y.remoteChange=$?$.remoteChange:_.remoteChange,y}),this.syncPreviewPromise}async accept(m,y){return await this.updateSyncResourcePreview(m,async _=>{const $=await this.getAcceptResult(_,m,y,L.CancellationToken.None);return _.acceptResult=$,_.mergeState="accepted",_.localChange=$.localChange,_.remoteChange=$.remoteChange,_}),this.syncPreviewPromise}async discard(m){return await this.updateSyncResourcePreview(m,async y=>{const _=await this.getMergeResult(y,L.CancellationToken.None);return await this.fileService.writeFile(y.previewResource,R.VSBuffer.fromString(_.content||"")),y.acceptResult=void 0,y.mergeState="preview",y.localChange=_.localChange,y.remoteChange=_.remoteChange,y}),this.syncPreviewPromise}async updateSyncResourcePreview(m,y){if(!this.syncPreviewPromise)return;let _=await this.syncPreviewPromise;const $=_.resourcePreviews.findIndex(({localResource:A,remoteResource:U,previewResource:k})=>this.extUri.isEqual(A,m)||this.extUri.isEqual(U,m)||this.extUri.isEqual(k,m));$!==-1&&(this.syncPreviewPromise=(0,r.createCancelablePromise)(async A=>{const U=[..._.resourcePreviews];return U[$]=await y(U[$]),{..._,resourcePreviews:U}}),_=await this.syncPreviewPromise,this.updateConflicts(_.resourcePreviews),_.resourcePreviews.some(({mergeState:A})=>A==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(m){if(!this.syncPreviewPromise)return"idle";const y=await this.syncPreviewPromise;return y.resourcePreviews.some(({mergeState:_})=>_==="conflict")?"hasConflicts":y.resourcePreviews.some(({mergeState:_})=>_!=="accepted")?"syncing":(await this.applyResult(y.remoteUserData,y.lastSyncUserData,y.resourcePreviews.map(_=>[_,_.acceptResult]),m),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(m){const y=m.filter(({mergeState:_})=>_==="conflict");(0,D.equals)(this._conflicts,y,(_,$)=>this.extUri.isEqual(_.previewResource,$.previewResource))||(this._conflicts=y,this._onDidChangeConflicts.fire(this.conflicts))}async hasPreviouslySynced(){const m=await this.getLastSyncUserData();return!!m&&m.syncData!==null}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllResourceRefs(this.resource,this.collection)).map(({created:y,ref:_})=>({created:y,uri:this.toRemoteBackupResource(_)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.syncResource.profile,this.resource)).map(({created:y,ref:_})=>({created:y,uri:this.toLocalBackupResource(_)}))}toRemoteBackupResource(m){return b.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.syncResource.profile.isDefault?"":`${this.syncResource.profile.id}/`}${this.resource}/${m}`})}toLocalBackupResource(m){return b.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.syncResource.profile.id}/${this.resource}/${m}`})}async getMachineId({uri:m}){const y=this.extUri.basename(m);if(this.extUri.isEqual(m,this.toRemoteBackupResource(y))){const{content:_}=await this.getUserData(y);if(_)return this.parseSyncData(_)?.machineId}}async resolveContent(m){const y=this.extUri.basename(m);if(this.extUri.isEqual(m,this.toRemoteBackupResource(y))){const{content:_}=await this.getUserData(y);return _}return this.extUri.isEqual(m,this.toLocalBackupResource(y))?this.userDataSyncBackupStoreService.resolveContent(this.syncResource.profile,this.resource,y):null}async resolvePreviewContent(m){const y=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(y)for(const _ of y.resourcePreviews){if(this.extUri.isEqual(_.acceptedResource,m))return _.acceptResult?_.acceptResult.content:null;if(this.extUri.isEqual(_.remoteResource,m))return _.remoteContent;if(this.extUri.isEqual(_.localResource,m))return _.localContent;if(this.extUri.isEqual(_.baseResource,m))return _.baseContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch{}}async doGenerateSyncResourcePreview(m,y,_,$,A){const U=await this.isRemoteDataFromCurrentMachine(m),k=await this.generateSyncPreview(m,y,U,$,A),N=[];for(const F of k){const q=F.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(F.localChange===0&&F.remoteChange===0)N.push({...F,acceptedResource:q,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const J=_?await this.getMergeResult(F,A):void 0;if(A.isCancellationRequested)break;await this.fileService.writeFile(F.previewResource,R.VSBuffer.fromString(J?.content||""));const j=J&&!J.hasConflicts?await this.getAcceptResult(F,F.previewResource,void 0,A):void 0;N.push({...F,acceptResult:j,mergeState:J?.hasConflicts?"conflict":j?"accepted":"preview",localChange:j?j.localChange:J?J.localChange:F.localChange,remoteChange:j?j.remoteChange:J?J.remoteChange:F.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:m,lastSyncUserData:y,resourcePreviews:N,isLastSyncFromCurrentMachine:U}}async getLastSyncUserData(){try{const m=await this.fileService.readFile(this.lastSyncResource),y=JSON.parse(m.value.toString()),_=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=y.version&&_&&y.version!==_,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${y.version} is not compatible with current sync state version ${_}.`),await this.resetLocal(),null;const $=y;if($.content===null)return{ref:y.ref,syncData:null};const A=JSON.parse($.content);if(o(A))return{...y,syncData:A,content:void 0}}catch(m){m instanceof S.FileOperationError&&m.fileOperationResult===1?this.logService.info(`${this.syncResourceLogLabel}: Not synced yet. Last sync resource does not exist.`):this.logService.error(m)}return null}async updateLastSyncUserData(m,y={}){if(y.ref||y.content||y.version)throw new Error("Cannot have core properties as additional");const _=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),$={ref:m.ref,content:m.syncData?JSON.stringify(m.syncData):null,version:_,...y};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify($)))}async getRemoteUserData(m){const{ref:y,content:_}=await this.getUserData(m);let $=null;return _!==null&&($=this.parseSyncData(_)),{ref:y,syncData:$}}parseSyncData(m){try{const y=JSON.parse(m);if(o(y))return y}catch(y){this.logService.error(y)}throw new c.UserDataSyncError((0,p.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(m){if((0,I.isString)(m)){const y=await this.userDataSyncStoreService.resolveResourceContent(this.resource,m,this.collection);return{ref:m,content:y}}else{const y=m?{ref:m.ref,content:m.syncData?JSON.stringify(m.syncData):null}:null;return this.userDataSyncStoreService.readResource(this.resource,y,this.collection,this.syncHeaders)}}async updateRemoteUserData(m,y){const _=await this.currentMachineIdPromise,$={version:this.version,machineId:_,content:m};try{return y=await this.userDataSyncStoreService.writeResource(this.resource,JSON.stringify($),y,this.collection,this.syncHeaders),{ref:y,syncData:$}}catch(A){throw A instanceof c.UserDataSyncError&&A.code==="TooLarge"&&(A=new c.UserDataSyncError(A.message,A.code,this.resource)),A}}async backupLocal(m){const y={version:this.version,content:m};return this.userDataSyncBackupStoreService.backup(this.syncResource.profile,this.resource,JSON.stringify(y))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(c.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};t=pe([Y(2,S.IFileService),Y(3,h.IEnvironmentService),Y(4,f.IStorageService),Y(5,c.IUserDataSyncStoreService),Y(6,c.IUserDataSyncBackupStoreService),Y(7,c.IUserDataSyncEnablementService),Y(8,a.ITelemetryService),Y(9,c.IUserDataSyncLogService),Y(10,v.IConfigurationService),Y(11,d.IUriIdentityService)],t),e.AbstractSynchroniser=t;let n=class extends t{constructor(m,y,_,$,A,U,k,N,F,q,J,j,H){super(y,_,$,A,U,k,N,F,q,J,j,H),this.file=m,this._register(this.fileService.watch(this.extUri.dirname(m))),this._register(this.fileService.onDidFilesChange(W=>this.onFileChanges(W)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(m,y,_){try{y?await this.fileService.writeFile(this.file,R.VSBuffer.fromString(m),_?void 0:y):await this.fileService.createFile(this.file,R.VSBuffer.fromString(m),{overwrite:_})}catch($){throw $ instanceof S.FileOperationError&&$.fileOperationResult===1||$ instanceof S.FileOperationError&&$.fileOperationResult===3?new c.UserDataSyncError($.message,"LocalPreconditionFailed"):$}}onFileChanges(m){!m.contains(this.file)||this.triggerLocalChange()}};n=pe([Y(3,S.IFileService),Y(4,h.IEnvironmentService),Y(5,f.IStorageService),Y(6,c.IUserDataSyncStoreService),Y(7,c.IUserDataSyncBackupStoreService),Y(8,c.IUserDataSyncEnablementService),Y(9,a.ITelemetryService),Y(10,c.IUserDataSyncLogService),Y(11,v.IConfigurationService),Y(12,d.IUriIdentityService)],n),e.AbstractFileSynchroniser=n;let s=class extends n{constructor(m,y,_,$,A,U,k,N,F,q,J,j,H,W){super(m,y,_,$,A,U,k,N,F,q,J,H,W),this.userDataSyncUtilService=j,this._formattingOptions=void 0}hasErrors(m,y){const _=[],$=(0,P.parse)(m,_,{allowEmptyContent:!0,allowTrailingComma:!0});return _.length>0||!(0,I.isUndefined)($)&&y!==Array.isArray($)}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};s=pe([Y(3,S.IFileService),Y(4,h.IEnvironmentService),Y(5,f.IStorageService),Y(6,c.IUserDataSyncStoreService),Y(7,c.IUserDataSyncBackupStoreService),Y(8,c.IUserDataSyncEnablementService),Y(9,a.ITelemetryService),Y(10,c.IUserDataSyncLogService),Y(11,c.IUserDataSyncUtilService),Y(12,v.IConfigurationService),Y(13,d.IUriIdentityService)],s),e.AbstractJsonFileSynchroniser=s;let u=class{constructor(m,y,_,$,A,U){this.resource=m,this.userDataProfilesService=y,this.environmentService=_,this.logService=$,this.fileService=A,this.extUri=U.extUri,this.lastSyncResource=(0,c.getLastSyncResourceUri)(void 0,this.resource,_,this.extUri)}async initialize({ref:m,content:y}){if(!y){this.logService.info("Remote content does not exist.",this.resource);return}const _=this.parseSyncData(y);if(!!_)try{await this.doInitialize({ref:m,syncData:_})}catch($){this.logService.error($)}}parseSyncData(m){try{const y=JSON.parse(m);if(o(y))return y}catch(y){this.logService.error(y)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(m,y={}){const _={ref:m.ref,content:m.syncData?JSON.stringify(m.syncData):null,...y};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(_)))}};u=pe([Y(1,i.IUserDataProfilesService),Y(2,h.IEnvironmentService),Y(3,C.ILogService),Y(4,S.IFileService),Y(5,d.IUriIdentityService)],u),e.AbstractInitializer=u}),define(ne[255],re([0,1,18,16,3,35,4,15,164,17,14,13,21,24,31,20,41,239,26]),function(Q,e,D,r,R,L,T,P,w,E,I,b,p,v,h,S,C,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function a(i,o,t){try{const n=JSON.parse(i);if(!o)return(0,P.isUndefined)(n.all)?null:n.all;switch(T.OS){case 2:return(0,P.isUndefined)(n.mac)?null:n.mac;case 3:return(0,P.isUndefined)(n.linux)?null:n.linux;case 1:return(0,P.isUndefined)(n.windows)?null:n.windows}}catch(n){return t.error(n),null}}e.getKeybindingsContentFromSyncContent=a;let d=class extends C.AbstractJsonFileSynchroniser{constructor(o,t,n,s,u,l,m,y,_,$,A,U,k){super(o.keybindingsResource,{syncResource:"keybindings",profile:o},t,y,_,$,n,s,m,U,u,A,l,k),this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.baseResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(R.Event.filter(l.onDidChangeConfiguration,N=>N.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(o,t,n,s){const u=o.syncData?a(o.syncData.content,s.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;t=t===null&&n?o:t;const l=t?this.getKeybindingsContentFromLastSyncUserData(t):null,m=await this.getLocalFileContent(),y=await this.getFormattingOptions();let _=null,$=!1,A=!1,U=!1;if(u){let F=m?m.value.toString():"[]";if(F=F||"[]",this.hasErrors(F,!0))throw new f.UserDataSyncError((0,w.localize)(0,null),"LocalInvalidContent",this.resource);if(!l||l!==F||l!==u){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const q=await(0,g.merge)(F,u,l,y,this.userDataSyncUtilService);q.hasChanges&&(_=q.mergeContent,U=q.hasConflicts,$=U||q.mergeContent!==F,A=U||q.mergeContent!==u)}}else m&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),_=m.value.toString(),A=!0);const k={content:U?l:_,localChange:$?m?2:1:0,remoteChange:A?2:0,hasConflicts:U},N=m?m.value.toString():null;return[{fileContent:m,baseResource:this.baseResource,baseContent:l,localResource:this.localResource,localContent:N,localChange:k.localChange,remoteResource:this.remoteResource,remoteContent:u,remoteChange:k.remoteChange,previewResource:this.previewResource,previewResult:k,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(o){const t=this.getKeybindingsContentFromLastSyncUserData(o);if(t===null)return!0;const n=await this.getLocalFileContent(),s=n?n.value.toString():"",u=await this.getFormattingOptions(),l=await(0,g.merge)(s||"[]",t,t,u,this.userDataSyncUtilService);return l.hasConflicts||l.mergeContent!==t}async getMergeResult(o,t){return o.previewResult}async getAcceptResult(o,t,n,s){if(this.extUri.isEqual(t,this.localResource))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return n===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:n,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(o,t,n,s){const{fileContent:u}=n[0][0];let{content:l,localChange:m,remoteChange:y}=n[0][1];if(m===0&&y===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),l!==null&&(l=l.trim(),l=l||"[]",this.hasErrors(l,!0)))throw new f.UserDataSyncError((0,w.localize)(1,null),"LocalInvalidContent",this.resource);if(m!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),u&&await this.backupLocal(this.toSyncContent(u.value.toString())),await this.updateLocalFileContent(l||"[]",u,s),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),y!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const _=this.toSyncContent(l||"[]",o.syncData?.content);o=await this.updateRemoteUserData(_,s?null:o.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}t?.ref!==o.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(o,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.getLocalFileContent();if(o){const t=(0,L.parse)(o.value.toString());if((0,D.isNonEmptyArray)(t))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:o}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(o,"keybindings.json"),comparableResource:t}]}async resolveContent(o){if(this.extUri.isEqual(this.remoteResource,o)||this.extUri.isEqual(this.baseResource,o)||this.extUri.isEqual(this.localResource,o)||this.extUri.isEqual(this.acceptedResource,o))return this.resolvePreviewContent(o);let t=await super.resolveContent(o);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(o)),t){const n=this.parseSyncData(t);if(n)switch(this.extUri.basename(o)){case"keybindings.json":return a(n.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.syncKeybindingsPerPlatform()?null:a(o.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(o,t){let n={};try{n=JSON.parse(t||"{}")}catch(s){this.logService.error(s)}switch(this.syncKeybindingsPerPlatform()?delete n.all:n.all=o,T.OS){case 2:n.mac=o;break;case 3:n.linux=o;break;case 1:n.windows=o;break}return JSON.stringify(n)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};d=pe([Y(2,f.IUserDataSyncStoreService),Y(3,f.IUserDataSyncBackupStoreService),Y(4,f.IUserDataSyncLogService),Y(5,E.IConfigurationService),Y(6,f.IUserDataSyncEnablementService),Y(7,b.IFileService),Y(8,I.IEnvironmentService),Y(9,p.IStorageService),Y(10,f.IUserDataSyncUtilService),Y(11,v.ITelemetryService),Y(12,h.IUriIdentityService)],d),e.KeybindingsSynchroniser=d;let c=class extends C.AbstractInitializer{constructor(o,t,n,s,u){super("keybindings",t,n,s,o,u)}async doInitialize(o){const t=o.syncData?this.getKeybindingsContentFromSyncContent(o.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.keybindingsResource,r.VSBuffer.fromString(t)),await this.updateLastSyncUserData(o)}async isEmpty(){try{const o=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource),t=(0,L.parse)(o.value.toString());return!(0,D.isNonEmptyArray)(t)}catch(o){return o.fileOperationResult===1}}getKeybindingsContentFromSyncContent(o){try{return a(o,!0,this.logService)}catch(t){return this.logService.error(t),null}}};c=pe([Y(0,b.IFileService),Y(1,S.IUserDataProfilesService),Y(2,I.IEnvironmentService),Y(3,f.IUserDataSyncLogService),Y(4,h.IUriIdentityService)],c),e.KeybindingsInitializer=c}),define(ne[256],re([0,1,16,3,165,17,72,14,29,13,21,24,31,20,41,61,243,26]),function(Q,e,D,r,R,L,T,P,w,E,I,b,p,v,h,S,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function f(i){return i&&i.settings&&typeof i.settings=="string"&&Object.keys(i).length===1}function a(i){const o=JSON.parse(i);return f(o)?o:{settings:i}}e.parseSettingsSyncContent=a;let d=class extends h.AbstractJsonFileSynchroniser{constructor(o,t,n,s,u,l,m,y,_,$,A,U,k,N){super(o.settingsResource,{syncResource:"settings",profile:o},t,n,s,u,l,m,A,U,y,_,$,N),this.extensionManagementService=k,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.baseResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(o){const t=await this.getLastSyncUserData(),n=await this.getLatestRemoteUserData(o,t),s=this.getSettingsSyncContent(n),u=new T.ConfigurationModelParser(g.USER_DATA_SYNC_CONFIGURATION_SCOPE);return s?.settings&&u.parse(s.settings),u.configurationModel.getValue(g.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(o,t,n){const s=await this.getLocalFileContent(),u=await this.getFormattingOptions(),l=this.getSettingsSyncContent(o);t=t===null&&n?o:t;const m=t?this.getSettingsSyncContent(t):null,y=await this.getIgnoredSettings();let _=null,$=!1,A=!1,U=!1;if(l){let q=s?s.value.toString().trim():"{}";q=q||"{}",this.validateContent(q),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const J=(0,C.merge)(q,l.settings,m?m.settings:null,y,[],u);_=J.localContent||J.remoteContent,$=J.localContent!==null,A=J.remoteContent!==null,U=J.hasConflicts}else s&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),_=s.value.toString().trim()||"{}",this.validateContent(_),A=!0);const k=s?s.value.toString():null,N=m?.settings??null,F={content:U?N:_,localChange:$?2:0,remoteChange:A?2:0,hasConflicts:U};return[{fileContent:s,baseResource:this.baseResource,baseContent:N,localResource:this.localResource,localContent:k,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:l?l.settings:null,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(o){const t=this.getSettingsSyncContent(o);if(t===null)return!0;const n=await this.getLocalFileContent(),s=n?n.value.toString().trim():"",u=await this.getIgnoredSettings(),l=await this.getFormattingOptions();return(0,C.merge)(s||"{}",t.settings,t.settings,u,[],l).remoteContent!==null}async getMergeResult(o,t){const n=await this.getFormattingOptions(),s=await this.getIgnoredSettings();return{...o.previewResult,content:o.previewResult.content?(0,C.updateIgnoredSettings)(o.previewResult.content,"{}",s,n):null}}async getAcceptResult(o,t,n,s){const u=await this.getFormattingOptions(),l=await this.getIgnoredSettings();if(this.extUri.isEqual(t,this.localResource))return{content:o.fileContent?(0,C.updateIgnoredSettings)(o.fileContent.value.toString(),"{}",l,u):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:o.remoteContent!==null?(0,C.updateIgnoredSettings)(o.remoteContent,o.fileContent?o.fileContent.value.toString():"{}",l,u):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return n===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:n!==null?(0,C.updateIgnoredSettings)(n,o.fileContent?o.fileContent.value.toString():"{}",l,u):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(o,t,n,s){const{fileContent:u}=n[0][0];let{content:l,localChange:m,remoteChange:y}=n[0][1];if(m===0&&y===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),l=l?l.trim():"{}",l=l||"{}",this.validateContent(l),m!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),u&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(u.value.toString()))),await this.updateLocalFileContent(l,u,s),await this.configurationService.reloadConfiguration(3),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),y!==0){const _=await this.getFormattingOptions(),$=this.getSettingsSyncContent(o),A=await this.getIgnoredSettings(l);l=(0,C.updateIgnoredSettings)(l,$?$.settings:"{}",A,_),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),o=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(l)),s?null:o.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}t?.ref!==o.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(o),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const o=await this.getLocalFileContent();if(o){const t=await this.getFormattingOptions(),n=(0,S.edit)(o.value.toString(),[g.CONFIGURATION_SYNC_STORE_KEY],void 0,t);return!(0,C.isEmpty)(n)}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:o}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(o,"settings.json"),comparableResource:t}]}async resolveContent(o){if(this.extUri.isEqual(this.remoteResource,o)||this.extUri.isEqual(this.localResource,o)||this.extUri.isEqual(this.acceptedResource,o)||this.extUri.isEqual(this.baseResource,o))return this.resolvePreviewContent(o);let t=await super.resolveContent(o);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(o)),t){const n=this.parseSyncData(t);if(n){const s=this.parseSettingsSyncContent(n.content);if(s)switch(this.extUri.basename(o)){case"settings.json":return s.settings}}}return null}async resolvePreviewContent(o){let t=await super.resolvePreviewContent(o);if(t){const n=await this.getFormattingOptions(),s=await this.getIgnoredSettings();t=(0,C.updateIgnoredSettings)(t,"{}",s,n)}return t}getSettingsSyncContent(o){return o.syncData?this.parseSettingsSyncContent(o.syncData.content):null}parseSettingsSyncContent(o){try{return a(o)}catch(t){this.logService.error(t)}return null}toSettingsSyncContent(o){return{settings:o}}async getIgnoredSettings(o){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const n=r.Event.any(r.Event.filter(this.extensionManagementService.onDidInstallExtensions,s=>s.some(({local:u})=>!!u)),r.Event.filter(this.extensionManagementService.onDidUninstallExtension,s=>!s.error))(()=>{n.dispose(),this._defaultIgnoredSettings=void 0})}const t=await this._defaultIgnoredSettings;return(0,C.getIgnoredSettings)(t,this.configurationService,o)}validateContent(o){if(this.hasErrors(o,!1))throw new g.UserDataSyncError((0,R.localize)(0,null),"LocalInvalidContent",this.resource)}};d=pe([Y(2,E.IFileService),Y(3,P.IEnvironmentService),Y(4,I.IStorageService),Y(5,g.IUserDataSyncStoreService),Y(6,g.IUserDataSyncBackupStoreService),Y(7,g.IUserDataSyncLogService),Y(8,g.IUserDataSyncUtilService),Y(9,L.IConfigurationService),Y(10,g.IUserDataSyncEnablementService),Y(11,b.ITelemetryService),Y(12,w.IExtensionManagementService),Y(13,p.IUriIdentityService)],d),e.SettingsSynchroniser=d;let c=class extends h.AbstractInitializer{constructor(o,t,n,s,u){super("settings",t,n,s,o,u)}async doInitialize(o){const t=o.syncData?this.parseSettingsSyncContent(o.syncData.content):null;if(!t){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.settingsResource,D.VSBuffer.fromString(t.settings)),await this.updateLastSyncUserData(o)}async isEmpty(){try{const o=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource);return(0,C.isEmpty)(o.value.toString().trim())}catch(o){return o.fileOperationResult===1}}parseSettingsSyncContent(o){try{return a(o)}catch(t){this.logService.error(t)}return null}};c=pe([Y(0,E.IFileService),Y(1,v.IUserDataProfilesService),Y(2,P.IEnvironmentService),Y(3,g.IUserDataSyncLogService),Y(4,p.IUriIdentityService)],c),e.SettingsInitializer=c}),define(ne[257],re([0,1,16,3,32,17,14,13,21,24,31,20,41,240,26]),function(Q,e,D,r,R,L,T,P,w,E,I,b,p,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let S=class extends p.AbstractSynchroniser{constructor(f,a,d,c,i,o,t,n,s,u,l,m){super({syncResource:"snippets",profile:f},a,c,d,i,o,t,u,l,n,s,m),this.version=1,this.snippetsFolder=f.snippetsHome,this._register(this.fileService.watch(d.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(r.Event.filter(this.fileService.onDidFilesChange,y=>y.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(f,a,d){const c=await this.getSnippetsFileContents(),i=this.toSnippetsContents(c),o=f.syncData?this.parseSnippets(f.syncData):null;a=a===null&&d?f:a;const t=a&&a.syncData?this.parseSnippets(a.syncData):null;o?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const n=(0,v.merge)(i,o,t);return this.getResourcePreviews(n,c,o||{},t||{})}async hasRemoteChanged(f){const a=f.syncData?this.parseSnippets(f.syncData):null;if(a===null)return!0;const d=await this.getSnippetsFileContents(),c=this.toSnippetsContents(d),i=(0,v.merge)(c,a,a);return Object.keys(i.remote.added).length>0||Object.keys(i.remote.updated).length>0||i.remote.removed.length>0||i.conflicts.length>0}async getMergeResult(f,a){return f.previewResult}async getAcceptResult(f,a,d,c){if(this.extUri.isEqualOrParent(a,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:f.fileContent?f.fileContent.value.toString():null,localChange:0,remoteChange:f.fileContent?f.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(a,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:f.remoteContent,localChange:f.remoteContent!==null?f.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(a,this.syncPreviewFolder))return d===void 0?{content:f.previewResult.content,localChange:f.previewResult.localChange,remoteChange:f.previewResult.remoteChange}:{content:d,localChange:d===null?f.fileContent!==null?3:0:2,remoteChange:d===null?f.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${a.toString()}`)}async applyResult(f,a,d,c){const i=d.map(([o,t])=>({...o,acceptResult:t}));i.every(({localChange:o,remoteChange:t})=>o===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),i.some(({localChange:o})=>o!==0)&&(await this.updateLocalBackup(i),await this.updateLocalSnippets(i,c)),i.some(({remoteChange:o})=>o!==0)&&(f=await this.updateRemoteSnippets(i,f,c)),a?.ref!==f.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(f),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:o}of i)try{await this.fileService.del(o)}catch{}}getResourcePreviews(f,a,d,c){const i=new Map;for(const o of Object.keys(f.local.added)){const t={content:f.local.added[o],hasConflicts:!1,localChange:1,remoteChange:0};i.set(o,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(f.local.updated)){const t={content:f.local.updated[o],hasConflicts:!1,localChange:2,remoteChange:0},n=a[o]?a[o].value.toString():null;i.set(o,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:c[o]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:a[o],localContent:n,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of f.local.removed){const t={content:null,hasConflicts:!1,localChange:3,remoteChange:0},n=a[o]?a[o].value.toString():null;i.set(o,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:c[o]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:a[o],localContent:n,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(f.remote.added)){const t={content:f.remote.added[o],hasConflicts:!1,localChange:0,remoteChange:1},n=a[o]?a[o].value.toString():null;i.set(o,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:c[o]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:a[o],localContent:n,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(f.remote.updated)){const t={content:f.remote.updated[o],hasConflicts:!1,localChange:0,remoteChange:2},n=a[o]?a[o].value.toString():null;i.set(o,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:c[o]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:a[o],localContent:n,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of f.remote.removed){const t={content:null,hasConflicts:!1,localChange:0,remoteChange:3};i.set(o,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:c[o]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of f.conflicts){const t={content:c[o]??null,hasConflicts:!0,localChange:a[o]?2:1,remoteChange:d[o]?2:1},n=a[o]?a[o].value.toString():null;i.set(o,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:c[o]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:a[o]||null,localContent:n,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[o]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(a))if(!i.has(o)){const t={content:a[o]?a[o].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},n=a[o]?a[o].value.toString():null;i.set(o,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:c[o]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:a[o]||null,localContent:n,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[o]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...i.values()]}async getAssociatedResources({uri:f}){const a=await super.resolveContent(f);if(a){const d=this.parseSyncData(a);if(d){const c=this.parseSnippets(d),i=[];for(const o of Object.keys(c)){const t=this.extUri.joinPath(f,o),n=this.extUri.joinPath(this.snippetsFolder,o),s=await this.fileService.exists(n);i.push({resource:t,comparableResource:s?n:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"})})}return i}}return[]}async resolveContent(f){if(this.extUri.isEqualOrParent(f,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(f,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(f,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.extUri.isEqualOrParent(f,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(f);let a=await super.resolveContent(f);if(a)return a;if(a=await super.resolveContent(this.extUri.dirname(f)),a){const d=this.parseSyncData(a);if(d)return this.parseSnippets(d)[this.extUri.basename(f)]||null}return null}async hasLocalData(){try{const f=await this.getSnippetsFileContents();if(Object.keys(f).length)return!0}catch{}return!1}async updateLocalBackup(f){const a={};for(const d of f)d.fileContent&&(a[this.extUri.basename(d.localResource)]=d.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(a)))}async updateLocalSnippets(f,a){for(const{fileContent:d,acceptResult:c,localResource:i,remoteResource:o,localChange:t}of f)if(t!==0){const n=o?this.extUri.basename(o):this.extUri.basename(i),s=this.extUri.joinPath(this.snippetsFolder,n);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(s)),await this.fileService.del(s),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(s))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(s)),await this.fileService.createFile(s,D.VSBuffer.fromString(c.content),{overwrite:a}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(s))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(s)),await this.fileService.writeFile(s,D.VSBuffer.fromString(c.content),a?void 0:d),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(s)))}}async updateRemoteSnippets(f,a,d){const c=a.syncData?this.parseSnippets(a.syncData):{},i=(0,R.deepClone)(c);for(const{acceptResult:o,localResource:t,remoteResource:n,remoteChange:s}of f)if(s!==0){const u=t?this.extUri.basename(t):this.extUri.basename(n);s===3?delete i[u]:i[u]=o.content}return(0,v.areSame)(c,i)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),a=await this.updateRemoteUserData(JSON.stringify(i),d?null:a.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),a}parseSnippets(f){return JSON.parse(f.content)}toSnippetsContents(f){const a={};for(const d of Object.keys(f))a[d]=f[d].value.toString();return a}async getSnippetsFileContents(){const f={};let a;try{a=await this.fileService.resolve(this.snippetsFolder)}catch(d){if(d instanceof P.FileOperationError&&d.fileOperationResult===1)return f;throw d}for(const d of a.children||[]){const c=d.resource,i=this.extUri.extname(c);if(i===".json"||i===".code-snippets"){const o=this.extUri.relativePath(this.snippetsFolder,c),t=await this.fileService.readFile(c);f[o]=t}}return f}};S=pe([Y(2,T.IEnvironmentService),Y(3,P.IFileService),Y(4,w.IStorageService),Y(5,h.IUserDataSyncStoreService),Y(6,h.IUserDataSyncBackupStoreService),Y(7,h.IUserDataSyncLogService),Y(8,L.IConfigurationService),Y(9,h.IUserDataSyncEnablementService),Y(10,E.ITelemetryService),Y(11,I.IUriIdentityService)],S),e.SnippetsSynchroniser=S;let C=class extends p.AbstractInitializer{constructor(f,a,d,c,i){super("snippets",a,d,c,f,i)}async doInitialize(f){const a=f.syncData?JSON.parse(f.syncData.content):null;if(!a){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const c of Object.keys(a)){const i=a[c];if(i){const o=this.extUri.joinPath(this.userDataProfilesService.defaultProfile.snippetsHome,c);await this.fileService.createFile(o,D.VSBuffer.fromString(i)),this.logService.info("Created snippet",this.extUri.basename(o))}}await this.updateLastSyncUserData(f)}async isEmpty(){try{return!(await this.fileService.resolve(this.userDataProfilesService.defaultProfile.snippetsHome)).children?.length}catch(f){return f.fileOperationResult===1}}};C=pe([Y(0,P.IFileService),Y(1,b.IUserDataProfilesService),Y(2,T.IEnvironmentService),Y(3,h.IUserDataSyncLogService),Y(4,I.IUriIdentityService)],C),e.SnippetsInitializer=C}),define(ne[258],re([0,1,16,17,14,13,21,24,31,20,41,26]),function(Q,e,D,r,R,L,T,P,w,E,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function p(C,g){try{return JSON.parse(C).tasks}catch(f){return g.error(f),null}}e.getTasksContentFromSyncContent=p;let v=class extends I.AbstractFileSynchroniser{constructor(g,f,a,d,c,i,o,t,n,s,u,l){super(g.tasksResource,{syncResource:"tasks",profile:g},f,t,n,s,a,d,o,u,c,i,l),this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.baseResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(g,f,a,d){const c=g.syncData?p(g.syncData.content,this.logService):null;f=f===null&&a?g:f;const i=f?.syncData?p(f.syncData.content,this.logService):null,o=await this.getLocalFileContent();let t=null,n=!1,s=!1,u=!1;if(c){const y=o?o.value.toString():null;if(!i||i!==y||i!==c){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const _=S(y,c,i);t=_.content,u=_.hasConflicts,n=_.hasLocalChanged,s=_.hasRemoteChanged}}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),t=o.value.toString(),s=!0);const l={content:u?i:t,localChange:n?o?2:1:0,remoteChange:s?2:0,hasConflicts:u},m=o?o.value.toString():null;return[{fileContent:o,baseResource:this.baseResource,baseContent:i,localResource:this.localResource,localContent:m,localChange:l.localChange,remoteResource:this.remoteResource,remoteContent:c,remoteChange:l.remoteChange,previewResource:this.previewResource,previewResult:l,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(g){const f=g?.syncData?p(g.syncData.content,this.logService):null;if(f===null)return!0;const a=await this.getLocalFileContent(),d=a?a.value.toString():null,c=S(d,f,f);return c.hasLocalChanged||c.hasRemoteChanged}async getMergeResult(g,f){return g.previewResult}async getAcceptResult(g,f,a,d){if(this.extUri.isEqual(f,this.localResource))return{content:g.fileContent?g.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(f,this.remoteResource))return{content:g.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(f,this.previewResource))return a===void 0?{content:g.previewResult.content,localChange:g.previewResult.localChange,remoteChange:g.previewResult.remoteChange}:{content:a,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${f.toString()}`)}async applyResult(g,f,a,d){const{fileContent:c}=a[0][0],{content:i,localChange:o,remoteChange:t}=a[0][1];if(o===0&&t===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),o!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),c&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(c.value.toString()))),await this.updateLocalFileContent(i||"{}",c,d),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),t!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const n=JSON.stringify(this.toTasksSyncContent(i||"{}"));g=await this.updateRemoteUserData(n,d?null:g.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}f?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(g),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async getAssociatedResources({uri:g}){const f=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(g,"tasks.json"),comparableResource:f}]}async resolveContent(g){if(this.extUri.isEqual(this.remoteResource,g)||this.extUri.isEqual(this.baseResource,g)||this.extUri.isEqual(this.localResource,g)||this.extUri.isEqual(this.acceptedResource,g))return this.resolvePreviewContent(g);let f=await super.resolveContent(g);if(f)return f;if(f=await super.resolveContent(this.extUri.dirname(g)),f){const a=this.parseSyncData(f);if(a)switch(this.extUri.basename(g)){case"tasks.json":return p(a.content,this.logService)}}return null}toTasksSyncContent(g){return{tasks:g}}};v=pe([Y(2,b.IUserDataSyncStoreService),Y(3,b.IUserDataSyncBackupStoreService),Y(4,b.IUserDataSyncLogService),Y(5,r.IConfigurationService),Y(6,b.IUserDataSyncEnablementService),Y(7,L.IFileService),Y(8,R.IEnvironmentService),Y(9,T.IStorageService),Y(10,P.ITelemetryService),Y(11,w.IUriIdentityService)],v),e.TasksSynchroniser=v;let h=class extends I.AbstractInitializer{constructor(g,f,a,d,c){super("tasks",f,a,d,g,c),this.tasksResource=this.userDataProfilesService.defaultProfile.tasksResource}async doInitialize(g){const f=g.syncData?p(g.syncData.content,this.logService):null;if(!f){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,D.VSBuffer.fromString(f)),await this.updateLastSyncUserData(g)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};h=pe([Y(0,L.IFileService),Y(1,E.IUserDataProfilesService),Y(2,R.IEnvironmentService),Y(3,b.IUserDataSyncLogService),Y(4,w.IUriIdentityService)],h),e.TasksInitializer=h;function S(C,g,f){if(C===null&&g===null&&f===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(C===g)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const a=f!==C,d=f!==g;return!a&&!d?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:a&&!d?{content:C,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:d&&!a?{content:g,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:C,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(ne[259],re([0,1,46,7,17,14,13,21,24,31,20,41,241,26]),function(Q,e,D,r,R,L,T,P,w,E,I,b,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesManifestSynchroniser=void 0;let h=class mt extends b.AbstractSynchroniser{constructor(g,f,a,d,c,i,o,t,n,s,u,l,m){super({syncResource:"profiles",profile:g},f,d,c,i,o,t,u,l,n,s,m),this.userDataProfilesService=a,this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"profiles.json"),this.baseResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async getLastSyncedProfiles(){const g=await this.getLastSyncUserData();return g?.syncData?S(g.syncData):null}async getRemoteSyncedProfiles(g){const f=await this.getLastSyncUserData(),a=await this.getLatestRemoteUserData(g,f);return a?.syncData?S(a.syncData):null}async generateSyncPreview(g,f,a){const d=g.syncData?S(g.syncData):null,c=f?.syncData?S(f.syncData):null,i=this.getLocalUserDataProfiles(),{local:o,remote:t}=(0,p.merge)(i,d,c,[]),n={local:o,remote:t,content:c?this.stringifyRemoteProfiles(c):null,localChange:o.added.length>0||o.removed.length>0||o.updated.length>0?2:0,remoteChange:t!==null?2:0},s=this.stringifyLocalProfiles(i,!1);return[{baseResource:this.baseResource,baseContent:c?this.stringifyRemoteProfiles(c):null,localResource:this.localResource,localContent:s,remoteResource:this.remoteResource,remoteContent:d?this.stringifyRemoteProfiles(d):null,remoteProfiles:d,previewResource:this.previewResource,previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(g){const f=g?.syncData?S(g.syncData):null,a=this.getLocalUserDataProfiles(),{remote:d}=(0,p.merge)(a,f,f,[]);return!!d?.added.length||!!d?.removed.length||!!d?.updated.length}async getMergeResult(g,f){return{...g.previewResult,hasConflicts:!1}}async getAcceptResult(g,f,a,d){if(this.extUri.isEqual(f,this.localResource))return this.acceptLocal(g);if(this.extUri.isEqual(f,this.remoteResource))return this.acceptRemote(g);if(this.extUri.isEqual(f,this.previewResource))return g.previewResult;throw new Error(`Invalid Resource: ${f.toString()}`)}async acceptLocal(g){const f=this.getLocalUserDataProfiles(),a=(0,p.merge)(f,null,null,[]),{local:d,remote:c}=a;return{content:g.localContent,local:d,remote:c,localChange:d.added.length>0||d.removed.length>0||d.updated.length>0?2:0,remoteChange:c!==null?2:0}}async acceptRemote(g){const f=g.remoteContent?JSON.parse(g.remoteContent):null,a=[],d=[];for(const c of this.getLocalUserDataProfiles()){const i=f?.find(o=>o.id===c.id);i&&(a.push({id:c.id,name:c.name,collection:i.collection}),d.push(c))}if(f!==null){const c=(0,p.merge)(d,f,a,[]),{local:i,remote:o}=c;return{content:g.remoteContent,local:i,remote:o,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?2:0,remoteChange:o!==null?2:0}}else return{content:g.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(g,f,a,d){const{local:c,remote:i,localChange:o,remoteChange:t}=a[0][1];if(o===0&&t===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing profiles.`),o!==0){await this.backupLocal(this.stringifyLocalProfiles(this.getLocalUserDataProfiles(),!1));const n=[];for(const s of c.added)n.push(this.userDataProfilesService.createProfile(s.id,s.name,{shortName:s.shortName}));for(const s of c.removed)n.push(this.userDataProfilesService.removeProfile(s));for(const s of c.updated){const u=this.userDataProfilesService.profiles.find(l=>l.id===s.id);u?n.push(this.userDataProfilesService.updateProfile(u,{name:s.name,shortName:s.shortName})):this.logService.info(`${this.syncResourceLogLabel}: Could not find profile with id '${s.id}' to update.`)}await Promise.all(n)}if(t!==0){const n=a[0][0].remoteProfiles||[];this.logService.trace(`${this.syncResourceLogLabel}: Updating remote profiles...`);for(const s of i?.added||[]){const u=await this.userDataSyncStoreService.createCollection(this.syncHeaders);n.push({id:s.id,name:s.name,collection:u,shortName:s.shortName})}for(const s of i?.removed||[])n.splice(n.findIndex(({id:u})=>s.id===u),1);for(const s of i?.updated||[]){const u=n.find(({id:l})=>s.id===l);u&&n.splice(n.indexOf(u),1,{id:s.id,name:s.name,collection:u.collection,shortName:s.shortName})}g=await this.updateRemoteUserData(this.stringifyRemoteProfiles(n),d?null:g.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote profiles.${i?.added.length?` Added: ${JSON.stringify(i.added.map(s=>s.name))}.`:""}${i?.updated.length?` Updated: ${JSON.stringify(i.updated.map(s=>s.name))}.`:""}${i?.removed.length?` Removed: ${JSON.stringify(i.removed.map(s=>s.name))}.`:""}`);for(const s of i?.removed||[])await this.userDataSyncStoreService.deleteCollection(s.collection,this.syncHeaders)}f?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized profiles...`),await this.updateLastSyncUserData(g),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized profiles.`))}async hasLocalData(){return this.getLocalUserDataProfiles().length>0}async getAssociatedResources({uri:g}){return[{resource:this.extUri.joinPath(g,"profiles.json"),comparableResource:mt.PROFILES_DATA_URI}]}async resolveContent(g){if(this.extUri.isEqual(g,mt.PROFILES_DATA_URI))return this.stringifyLocalProfiles(this.getLocalUserDataProfiles(),!0);if(this.extUri.isEqual(this.remoteResource,g)||this.extUri.isEqual(this.baseResource,g)||this.extUri.isEqual(this.localResource,g)||this.extUri.isEqual(this.acceptedResource,g)){const a=await this.resolvePreviewContent(g);return a&&(0,D.toFormattedString)(JSON.parse(a),{})}let f=await super.resolveContent(g);if(f)return f;if(f=await super.resolveContent(this.extUri.dirname(g)),f){const a=this.parseSyncData(f);if(a)switch(this.extUri.basename(g)){case"profiles.json":return(0,D.toFormattedString)(S(a),{})}}return null}getLocalUserDataProfiles(){return this.userDataProfilesService.profiles.filter(g=>!g.isDefault&&!g.isTransient)}stringifyRemoteProfiles(g){return JSON.stringify([...g].sort((f,a)=>f.name.localeCompare(a.name)))}stringifyLocalProfiles(g,f){const a=[...g].sort((d,c)=>d.name.localeCompare(c.name)).map(d=>({id:d.id,name:d.name}));return f?(0,D.toFormattedString)(a,{}):JSON.stringify(a)}};h.PROFILES_DATA_URI=r.URI.from({scheme:v.USER_DATA_SYNC_SCHEME,authority:"profiles",path:"/profiles.json"}),h=pe([Y(2,I.IUserDataProfilesService),Y(3,T.IFileService),Y(4,L.IEnvironmentService),Y(5,P.IStorageService),Y(6,v.IUserDataSyncStoreService),Y(7,v.IUserDataSyncBackupStoreService),Y(8,v.IUserDataSyncLogService),Y(9,R.IConfigurationService),Y(10,v.IUserDataSyncEnablementService),Y(11,w.ITelemetryService),Y(12,E.IUriIdentityService)],h),e.UserDataProfilesManifestSynchroniser=h;function S(C){return JSON.parse(C.content)}}),define(ne[260],re([0,1,6,16,64,2,19,17,14,13,20,26]),function(Q,e,D,r,R,L,T,P,w,E,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let p=class extends L.Disposable{constructor(h,S,C,g,f){super(),this.environmentService=h,this.fileService=S,this.configurationService=C,this.logService=g,this.userDataProfilesService=f;for(const a of this.userDataProfilesService.profiles)for(const d of b.ALL_SYNC_RESOURCES)this.cleanUpBackup(this.getResourceBackupHome(a,d))}async getAllRefs(h,S){const C=this.getResourceBackupHome(h,S),g=await this.fileService.resolve(C);return g.children?g.children.filter(a=>a.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(a.name)).sort().reverse().map(a=>({ref:a.name,created:this.getCreationTime(a)})):[]}async resolveContent(h,S,C){if(!C){const g=await this.getAllRefs(h,S);g.length&&(C=g[g.length-1].ref)}if(C){const g=(0,T.joinPath)(this.environmentService.userDataSyncHome,S,C);return(await this.fileService.readFile(g)).value.toString()}return null}async backup(h,S,C){const g=this.getResourceBackupHome(h,S),f=(0,T.joinPath)(g,`${(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(f,r.VSBuffer.fromString(C))}catch(a){this.logService.error(a)}try{this.cleanUpBackup(g)}catch{}}getResourceBackupHome(h,S){return(0,T.joinPath)(this.environmentService.userDataSyncHome,...h.isDefault?[S]:[h.id,S])}async cleanUpBackup(h){try{try{if(!await this.fileService.exists(h))return}catch{return}const S=await this.fileService.resolve(h);if(S.children){const C=S.children.filter(d=>d.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(d.name)).sort(),g=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let f=C.filter(d=>Date.now()-this.getCreationTime(d)>g);const a=C.length-f.length;a<10&&(f=f.slice(10-a)),await D.Promises.settled(f.map(async d=>{this.logService.info("Deleting from backup",d.resource.path),await this.fileService.del(d.resource)}))}}catch(S){this.logService.error(S)}}getCreationTime(h){return h.ctime||new Date(parseInt(h.name.substring(0,4)),parseInt(h.name.substring(4,6))-1,parseInt(h.name.substring(6,8)),parseInt(h.name.substring(9,11)),parseInt(h.name.substring(11,13)),parseInt(h.name.substring(13,15))).getTime()}};p=pe([Y(0,w.IEnvironmentService),Y(1,E.IFileService),Y(2,P.IConfigurationService),Y(3,b.IUserDataSyncLogService),Y(4,I.IUserDataProfilesService)],p),e.UserDataSyncBackupStoreService=p}),define(ne[261],re([0,1,3,2,4,14,21,24,26]),function(Q,e,D,r,R,L,T,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const E="sync.enable";let I=class extends r.Disposable{constructor(p,v,h,S){super(),this.storageService=p,this.telemetryService=v,this.environmentService=h,this.userDataSyncStoreManagementService=S,this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new D.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(p.onDidChangeValue(C=>this.onDidStorageChange(C)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(E,-1,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(p){p&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(E,{enabled:p}),this.storageService.store(E,p,-1,1))}isResourceEnabled(p){return this.storageService.getBoolean((0,w.getEnablementKey)(p),-1,!0)}setResourceEnablement(p,v){if(this.isResourceEnabled(p)!==v){const h=(0,w.getEnablementKey)(p);this.storeResourceEnablement(h,v)}}getResourceSyncStateVersion(p){}storeResourceEnablement(p,v){this.storageService.store(p,v,-1,R.isWeb?0:1)}onDidStorageChange(p){if(p.scope!==-1)return;if(E===p.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const v=w.ALL_SYNC_RESOURCES.filter(h=>(0,w.getEnablementKey)(h)===p.key)[0];if(v){this._onDidChangeResourceEnablement.fire([v,this.isResourceEnabled(v)]);return}}};I=pe([Y(0,T.IStorageService),Y(1,P.ITelemetryService),Y(2,L.IEnvironmentService),Y(3,w.IUserDataSyncStoreManagementService)],I),e.UserDataSyncEnablementService=I}),define(ne[78],re([0,1,3,2,4,27,168,14,13,5,25,48,21,26]),function(Q,e,D,r,R,L,T,P,w,E,I,b,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,E.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName",S="Safari",C="Chrome",g="Edge",f="Firefox",a="Android";function d(o){switch(o){case S:case C:case g:case f:case a:case(0,R.PlatformToString)(0):return!0}return!1}e.isWebPlatform=d;function c(){return R.isSafari?S:R.isChrome?C:R.isEdge?g:R.isFirefox?f:R.isAndroid?a:(0,R.PlatformToString)(R.isWeb?0:R.platform)}let i=class nt extends r.Disposable{constructor(t,n,s,u,l,m){super(),this.storageService=s,this.userDataSyncStoreService=u,this.logService=l,this.productService=m,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,b.getServiceMachineId)(t,n,s)}async getMachines(t){const n=await this.currentMachineIdPromise;return(await this.readMachinesData(t)).machines.map(u=>({...u,isCurrent:u.id===n}))}async addCurrentMachine(t){const n=await this.currentMachineIdPromise,s=await this.readMachinesData(t);s.machines.some(({id:u})=>u===n)||(s.machines.push({id:n,name:this.computeCurrentMachineName(s.machines),platform:c()}),await this.writeMachinesData(s))}async removeCurrentMachine(t){const n=await this.currentMachineIdPromise,s=await this.readMachinesData(t),u=s.machines.filter(({id:l})=>l!==n);u.length!==s.machines.length&&(s.machines=u,await this.writeMachinesData(s))}async renameMachine(t,n,s){const u=await this.readMachinesData(s),l=u.machines.find(({id:m})=>m===t);if(l){l.name=n,await this.writeMachinesData(u);const m=await this.currentMachineIdPromise;t===m&&this.storageService.store(h,n,-1,1)}}async setEnablements(t){const n=await this.readMachinesData();for(const[s,u]of t){const l=n.machines.find(m=>m.id===s);l&&(l.disabled=u?void 0:!0)}await this.writeMachinesData(n)}computeCurrentMachineName(t){const n=this.storageService.get(h,-1);if(n)return n;const s=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${c()} (${this.productService.nameShort})`,u=new RegExp(`${(0,L.escapeRegExpCharacters)(s)}\\s#(\\d+)`);let l=0;for(const m of t){const y=u.exec(m.name),_=y?parseInt(y[1]):0;l=_>l?_:l}return`${s} #${l+1}`}async readMachinesData(t){this.userData=await this.readUserData(t);const n=this.parse(this.userData);if(n.version!==nt.VERSION)throw new Error((0,T.localize)(0,null,this.productService.nameLong));return n}async writeMachinesData(t){const n=JSON.stringify(t),s=await this.userDataSyncStoreService.writeResource(nt.RESOURCE,n,this.userData?.ref||null);this.userData={ref:s,content:n},this._onDidChange.fire()}async readUserData(t){if(this.userData){const n=t&&t.latest?t.latest[nt.RESOURCE]:void 0;if(this.userData.ref===n)return this.userData;if(n===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.readResource(nt.RESOURCE,this.userData)}parse(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(n){this.logService.error(n)}return{version:nt.VERSION,machines:[]}}};i.VERSION=1,i.RESOURCE="machines",i=pe([Y(0,P.IEnvironmentService),Y(1,w.IFileService),Y(2,p.IStorageService),Y(3,v.IUserDataSyncStoreService),Y(4,v.IUserDataSyncLogService),Y(5,I.IProductService)],i),e.UserDataSyncMachinesService=i}),define(ne[262],re([0,1,6,64,38,9,3,2,4,19,7,166,25,21,24,26,75,78]),function(Q,e,D,r,R,L,T,P,w,E,I,b,p,v,h,S,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const f="sync.disableMachineEventually",a="sync.sessionId",d="sync.storeUrl",c="sync.productQuality";let i=class extends P.Disposable{get syncUrl(){const n=this.storageService.get(d,-1);return n?I.URI.parse(n):void 0}set syncUrl(n){n?this.storageService.store(d,n.toString(),-1,1):this.storageService.remove(d,-1)}get productQuality(){return this.storageService.get(c,-1)}set productQuality(n){n?this.storageService.store(c,n,-1,1):this.storageService.remove(c,-1)}constructor(n,s,u,l,m,y,_,$,A,U){super(),this.userDataSyncStoreManagementService=s,this.userDataSyncStoreService=u,this.userDataSyncEnablementService=l,this.userDataSyncService=m,this.logService=y,this.userDataSyncAccountService=_,this.telemetryService=$,this.userDataSyncMachinesService=A,this.storageService=U,this.autoSync=this._register(new P.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new T.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new D.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=n.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(s.onDidChangeUserDataSyncStore(()=>{(0,E.isEqual)(this.syncUrl,s.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(_.onDidChangeAccount(()=>this.updateAutoSync())),this._register(u.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(m.onDidChangeLocal(k=>this.triggerSync([k],!1,!1))),this._register(T.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,k])=>k)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}updateAutoSync(){const{enabled:n,message:s}=this.isAutoSyncEnabled();n?this.autoSync.value===void 0&&(this.autoSync.value=new o(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(u=>this.onDidFinishSync(u))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(s&&this.logService.info(s),this.autoSync.clear()):s&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(s))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,r.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(n,s,u){try{this.userDataSyncAccountService.account&&!u&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(a,-1),n?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(l){if(this.logService.error(l),s)this.updateEnablement(!1);else throw l}}updateEnablement(n){this.userDataSyncEnablementService.isEnabled()!==n&&(this.userDataSyncEnablementService.setEnablement(n),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(n){if(!n){this.successiveFailures=0;return}const s=S.UserDataSyncError.toUserDataSyncError(n);s instanceof S.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:s.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),s.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):s.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):s.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code==="UpgradeRequired"||s.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code==="ServiceChanged"||s.code==="DefaultServiceChanged"?w.isWeb&&s.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(s),this.successiveFailures++),this._onError.fire(s)}async disableMachineEventually(){this.storageService.store(f,!0,-1,1),await(0,D.timeout)(1e3*60*10),this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(f,-1,!1)}stopDisableMachineEventually(){this.storageService.remove(f,-1)}async triggerSync(n,s,u){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(s&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...n),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",u)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};i=pe([Y(0,p.IProductService),Y(1,S.IUserDataSyncStoreManagementService),Y(2,S.IUserDataSyncStoreService),Y(3,S.IUserDataSyncEnablementService),Y(4,S.IUserDataSyncService),Y(5,S.IUserDataSyncLogService),Y(6,C.IUserDataSyncAccountService),Y(7,h.ITelemetryService),Y(8,g.IUserDataSyncMachinesService),Y(9,v.IStorageService)],i),e.UserDataAutoSyncService=i;class o extends P.Disposable{constructor(n,s,u,l,m,y,_,$){super(),this.lastSyncUrl=n,this.interval=s,this.userDataSyncStoreManagementService=u,this.userDataSyncStoreService=l,this.userDataSyncService=m,this.userDataSyncMachinesService=y,this.logService=_,this.storageService=$,this.intervalHandler=this._register(new P.MutableDisposable),this._onDidStartSync=this._register(new T.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new T.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,P.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask?.stop(),this.logService.info("Auto Sync: Stopped")})),this.sync(o.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,D.disposableTimeout)(()=>this.sync(o.INTERVAL_SYNCING,!1),this.interval)}sync(n,s){const u=(0,D.createCancelablePromise)(async l=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(m){if((0,L.isCancellationError)(m))return}return this.doSync(n,s,l)});return this.syncPromise=u,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,E.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const n=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),s=this.userDataSyncStoreManagementService.userDataSyncStore;return!!s&&!!n&&(!(0,E.isEqual)(s.defaultUrl,n.defaultUrl)||!(0,E.isEqual)(s.insidersUrl,n.insidersUrl)||!(0,E.isEqual)(s.stableUrl,n.stableUrl))}async doSync(n,s,u){this.logService.info(`Auto Sync: Triggered by ${n}`),this._onDidStartSync.fire();let l;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,s),u.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new S.UserDataAutoSyncError((0,b.localize)(0,null),"DefaultServiceChanged"):new S.UserDataAutoSyncError((0,b.localize)(1,null),"ServiceChanged"):new S.UserDataAutoSyncError((0,b.localize)(2,null),"TurnedOff");const m=this.storageService.get(a,-1);if(m&&this.manifest&&m!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new S.UserDataAutoSyncError((0,b.localize)(3,null),"DefaultServiceChanged"):new S.UserDataAutoSyncError((0,b.localize)(4,null),"ServiceChanged"):new S.UserDataAutoSyncError((0,b.localize)(5,null),"SessionExpired");const y=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(u.isCancellationRequested)return;const _=y.find($=>$.isCurrent);if(_?.disabled)throw new S.UserDataAutoSyncError((0,b.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch($){throw new S.UserDataAutoSyncError((0,R.toErrorMessage)($),$ instanceof S.UserDataSyncError?$.code:"Unknown")}if(this.manifest&&this.manifest.session!==m&&this.storageService.store(a,this.manifest.session,-1,1),u.isCancellationRequested)return;_||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(m){this.logService.error(m),l=m}this._onDidFinishSync.fire(l)}register(n){return super._register(n)}}o.INTERVAL_SYNCING="Interval"}),define(ne[62],re([0,1,2,68,5,21]),function(Q,e,D,r,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUserDataSyncProfilesStorageService=e.IUserDataSyncProfilesStorageService=void 0,e.IUserDataSyncProfilesStorageService=(0,R.createDecorator)("IUserDataSyncProfilesStorageService");let T=class extends D.Disposable{constructor(E){super(),this.storageService=E}async readStorageData(E){return this.withProfileScopedStorageService(E,async I=>this.getItems(I))}async updateStorageData(E,I,b){return this.withProfileScopedStorageService(E,async p=>this.writeItems(p,I,b))}async withProfileScopedStorageService(E,I){if(this.storageService.hasScope(E))return I(this.storageService);const b=await this.createStorageDatabase(E),p=new P(b);try{await p.initialize();const v=await I(p);return await p.flush(),v}finally{p.dispose(),await this.closeAndDispose(b)}}getItems(E){const I=new Map,b=p=>{for(const v of E.keys(0,p))I.set(v,{value:E.get(v,0),target:p})};return b(0),b(1),I}writeItems(E,I,b){for(const[p,v]of I)E.store(p,v,0,b)}async closeAndDispose(E){try{await E.close()}finally{(0,D.isDisposable)(E)&&E.dispose()}}};T=pe([Y(0,L.IStorageService)],T),e.AbstractUserDataSyncProfilesStorageService=T;class P extends L.AbstractStorageService{constructor(E){super({flushInterval:100}),this.profileStorage=this._register(new r.Storage(E))}doInitialize(){return this.profileStorage.init()}getStorage(E){return E===0?this.profileStorage:void 0}getLogDetails(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(){return!1}}}),define(ne[263],re([0,1,6,22,9,3,46,2,27,7,17,14,112,29,33,77,13,5,70,8,21,24,31,20,41,238,110,26,62]),function(Q,e,D,r,R,L,T,P,w,E,I,b,p,v,h,S,C,g,f,a,d,c,i,o,t,n,s,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=void 0;async function m($,A){const U=JSON.parse($.content);if($.version===1||$.version===2){const k=(await A.getInstalled(0)).filter(N=>N.isBuiltin);for(const N of U)$.version===1&&(N.enabled===!1&&(N.disabled=!0),delete N.enabled),$.version===2&&k.every(F=>!(0,h.areSameExtensions)(F.identifier,N.identifier))&&(N.installed=!0)}return U}let y=class pt extends t.AbstractSynchroniser{constructor(A,U,k,N,F,q,J,j,H,W,z,K,X,ce,B,G,O,M){super({syncResource:"extensions",profile:A},U,N,k,F,q,J,X,ce,W,K,G),this.extensionManagementService=j,this.ignoredExtensionsManagementService=H,this.extensionGalleryService=z,this.userDataSyncProfilesStorageService=O,this.instantiationService=M,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.baseResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.profileLocation=A.extensionsResource,this._register(L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,x=>x.some(({local:V})=>!!V)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,x=>!x.error),L.Event.filter(O.onDidChange,x=>x.valueChanges.some(({profile:V,changes:ee})=>this.syncResource.profile.id===V.id&&ee.some(oe=>oe.key===v.DISABLED_EXTENSIONS_STORAGE_PATH))),B.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(A,U){const k=A.syncData?await m(A.syncData,this.extensionManagementService):null,N=U?.skippedExtensions||[],F=U?.builtinExtensions||[],q=U?.syncData?await m(U.syncData,this.extensionManagementService):null,J=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),j=await this.getLocalExtensions(J),H=this.ignoredExtensionsManagementService.getIgnoredExtensions(J);k?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:W,remote:z}=(0,n.merge)(j,k,q,N,H,F),K={local:W,remote:z,content:this.getPreviewContent(j,W.added,W.updated,W.removed),localChange:W.added.length>0||W.removed.length>0||W.updated.length>0?2:0,remoteChange:z!==null?2:0},X=this.stringify(j,!1);return[{skippedExtensions:N,builtinExtensions:F,baseResource:this.baseResource,baseContent:q?this.stringify(q,!1):X,localResource:this.localResource,localContent:X,localExtensions:j,remoteResource:this.remoteResource,remoteExtensions:k,remoteContent:k?this.stringify(k,!1):null,previewResource:this.previewResource,previewResult:K,localChange:K.localChange,remoteChange:K.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(A){const U=A.syncData?await m(A.syncData,this.extensionManagementService):null,k=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),N=await this.getLocalExtensions(k),F=this.ignoredExtensionsManagementService.getIgnoredExtensions(k),{remote:q}=(0,n.merge)(N,U,U,A.skippedExtensions||[],F,A.builtinExtensions||[]);return q!==null}getPreviewContent(A,U,k,N){const F=[...U,...k],q=new Set,J=j=>{q.add(j.id.toLowerCase()),j.uuid&&q.add(j.uuid)};F.forEach(({identifier:j})=>J(j)),N.forEach(J);for(const j of A)q.has(j.identifier.id.toLowerCase())||j.identifier.uuid&&q.has(j.identifier.uuid)||F.push(j);return this.stringify(F,!1)}async getMergeResult(A,U){return{...A.previewResult,hasConflicts:!1}}async getAcceptResult(A,U,k,N){if(this.extUri.isEqual(U,this.localResource))return this.acceptLocal(A);if(this.extUri.isEqual(U,this.remoteResource))return this.acceptRemote(A);if(this.extUri.isEqual(U,this.previewResource))return A.previewResult;throw new Error(`Invalid Resource: ${U.toString()}`)}async acceptLocal(A){const U=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),k=this.ignoredExtensionsManagementService.getIgnoredExtensions(U),N=(0,n.merge)(A.localExtensions,null,null,A.skippedExtensions,k,A.builtinExtensions),{local:F,remote:q}=N;return{content:A.localContent,local:F,remote:q,localChange:F.added.length>0||F.removed.length>0||F.updated.length>0?2:0,remoteChange:q!==null?2:0}}async acceptRemote(A){const U=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),k=this.ignoredExtensionsManagementService.getIgnoredExtensions(U),N=A.remoteContent?JSON.parse(A.remoteContent):null;if(N!==null){const F=(0,n.merge)(A.localExtensions,N,A.localExtensions,[],k,A.builtinExtensions),{local:q,remote:J}=F;return{content:A.remoteContent,local:q,remote:J,localChange:q.added.length>0||q.removed.length>0||q.updated.length>0?2:0,remoteChange:J!==null?2:0}}else return{content:A.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(A,U,k,N){let{skippedExtensions:F,localExtensions:q}=k[0][0];const{local:J,remote:j,localChange:H,remoteChange:W}=k[0][1];if(H===0&&W===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),H!==0&&(await this.backupLocal(JSON.stringify(q)),F=await this.updateLocalExtensions(J.added,J.removed,J.updated,F)),j){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const z=JSON.stringify(j.all);A=await this.updateRemoteUserData(z,N?null:A.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${j.added.length?` Added: ${JSON.stringify(j.added.map(K=>K.identifier.id))}.`:""}${j.updated.length?` Updated: ${JSON.stringify(j.updated.map(K=>K.identifier.id))}.`:""}${j.removed.length?` Removed: ${JSON.stringify(j.removed.map(K=>K.identifier.id))}.`:""}`)}if(U?.ref!==A.ref){this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`);const z=q.filter(K=>!K.installed).map(K=>K.identifier);await this.updateLastSyncUserData(A,{skippedExtensions:F,builtinExtensions:z}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${F.length?` Skipped: ${JSON.stringify(F.map(K=>K.identifier.id))}.`:""}`)}}async getAssociatedResources({uri:A}){return[{resource:this.extUri.joinPath(A,"extensions.json"),comparableResource:pt.EXTENSIONS_DATA_URI}]}async resolveContent(A){if(this.extUri.isEqual(A,pt.EXTENSIONS_DATA_URI)){const k=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),N=this.ignoredExtensionsManagementService.getIgnoredExtensions(k),F=(await this.getLocalExtensions(k)).filter(q=>!N.some(J=>(0,h.areSameExtensions)({id:J},q.identifier)));return this.stringify(F,!0)}if(this.extUri.isEqual(this.remoteResource,A)||this.extUri.isEqual(this.baseResource,A)||this.extUri.isEqual(this.localResource,A)||this.extUri.isEqual(this.acceptedResource,A)){const k=await this.resolvePreviewContent(A);return k&&this.stringify(JSON.parse(k),!0)}let U=await super.resolveContent(A);if(U)return U;if(U=await super.resolveContent(this.extUri.dirname(A)),U){const k=this.parseSyncData(U);if(k)switch(this.extUri.basename(A)){case"extensions.json":return this.stringify(this.parseExtensions(k),!0)}}return null}stringify(A,U){return A.sort((k,N)=>!k.identifier.uuid&&N.identifier.uuid?-1:k.identifier.uuid&&!N.identifier.uuid?1:(0,w.compare)(k.identifier.id,N.identifier.id)),U?(0,T.toFormattedString)(A,{}):JSON.stringify(A)}async hasLocalData(){try{const A=await this.extensionManagementService.getInstalled(void 0,this.profileLocation);if((await this.getLocalExtensions(A)).some(k=>k.installed||k.disabled))return!0}catch{}return!1}async updateLocalExtensions(A,U,k,N){return this.withProfileScopedServices(async(F,q)=>{const J=[],j=[],H=await this.extensionManagementService.getInstalled(void 0,this.profileLocation);if(U.length){const z=H.filter(({identifier:K,isBuiltin:X})=>!X&&U.some(ce=>(0,h.areSameExtensions)(K,ce)));await D.Promises.settled(z.map(async K=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,K.identifier.id),await this.extensionManagementService.uninstall(K,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:this.profileLocation}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,K.identifier.id),J.push(K.identifier)}))}(A.length||k.length)&&await D.Promises.settled([...A,...k].map(async z=>{const K=H.find(ce=>(0,h.areSameExtensions)(ce.identifier,z.identifier));if(K&&K.isBuiltin){z.state&&K.manifest.version===z.version&&this.updateExtensionState(z.state,K,K.manifest.version,q),F.getDisabledExtensions().some(B=>(0,h.areSameExtensions)(B,z.identifier))!==!!z.disabled&&(z.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,z.identifier.id),await F.disableExtension(z.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,z.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,z.identifier.id),await F.enableExtension(z.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,z.identifier.id))),J.push(z.identifier);return}const X=(await this.extensionGalleryService.getExtensions([{...z.identifier,preRelease:z.preRelease}],r.CancellationToken.None))[0];if(z.state&&(K?K.manifest.version===z.version:!!X)&&this.updateExtensionState(z.state,K||X,K?.manifest.version,q),X)try{F.getDisabledExtensions().some(B=>(0,h.areSameExtensions)(B,z.identifier))!==!!z.disabled&&(z.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,z.identifier.id,X.version),await F.disableExtension(X.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,z.identifier.id,X.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,z.identifier.id,X.version),await F.enableExtension(X.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,z.identifier.id,X.version))),(!K||K.preRelease!==z.preRelease)&&(await this.extensionManagementService.canInstall(X)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,z.identifier.id,X.version),await this.extensionManagementService.installFromGallery(X,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:z.preRelease,profileLocation:this.profileLocation}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,z.identifier.id,X.version),J.push(X.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,X.displayName||X.identifier.id),j.push(z)))}catch(ce){j.push(z),ce instanceof v.ExtensionManagementError&&[v.ExtensionManagementErrorCode.Incompatible,v.ExtensionManagementErrorCode.IncompatiblePreRelease,v.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(ce.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,X.displayName||X.identifier.id):(this.logService.error(ce),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,X.displayName||X.identifier.id))}else j.push(z),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,z.identifier.id)}));const W=[];for(const z of N)J.some(K=>(0,h.areSameExtensions)(K,z.identifier))||W.push(z);for(const z of j)W.some(K=>(0,h.areSameExtensions)(K.identifier,z.identifier))||W.push(z);return W})}updateExtensionState(A,U,k,N){const F=N.getExtensionState(U,!0)||{},q=k?N.getKeysForSync({id:U.identifier.id,version:k}):void 0;q?q.forEach(J=>{F[J]=A[J]}):Object.keys(A).forEach(J=>F[J]=A[J]),N.setExtensionState(U,F,!0)}parseExtensions(A){return JSON.parse(A.content)}getLocalExtensions(A){return this.withProfileScopedServices(async(U,k)=>{const N=U.getDisabledExtensions();return A.map(F=>{const{identifier:q,isBuiltin:J,manifest:j,preRelease:H}=F,W={identifier:q,preRelease:H,version:j.version};N.some(z=>(0,h.areSameExtensions)(z,q))&&(W.disabled=!0),J||(W.installed=!0);try{const z=k.getKeysForSync({id:q.id,version:j.version});if(z){const K=k.getExtensionState(F,!0)||{};W.state=Object.keys(K).reduce((X,ce)=>(z.includes(ce)&&(X[ce]=K[ce]),X),{})}}catch(z){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,R.getErrorMessage)(z))}return W})})}async withProfileScopedServices(A){return this.userDataSyncProfilesStorageService.withProfileScopedStorageService(this.syncResource.profile,async U=>{const k=new P.DisposableStore,N=this.instantiationService.createChild(new f.ServiceCollection([d.IStorageService,U])),F=k.add(N.createInstance(p.GlobalExtensionEnablementService)),q=k.add(N.createInstance(S.ExtensionStorageService));try{return await A(F,q)}finally{k.dispose()}})}};y.EXTENSIONS_DATA_URI=E.URI.from({scheme:u.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),y=pe([Y(2,b.IEnvironmentService),Y(3,C.IFileService),Y(4,d.IStorageService),Y(5,u.IUserDataSyncStoreService),Y(6,u.IUserDataSyncBackupStoreService),Y(7,v.IExtensionManagementService),Y(8,s.IIgnoredExtensionsManagementService),Y(9,u.IUserDataSyncLogService),Y(10,v.IExtensionGalleryService),Y(11,I.IConfigurationService),Y(12,u.IUserDataSyncEnablementService),Y(13,c.ITelemetryService),Y(14,S.IExtensionStorageService),Y(15,i.IUriIdentityService),Y(16,l.IUserDataSyncProfilesStorageService),Y(17,g.IInstantiationService)],y),e.ExtensionsSynchroniser=y;let _=class extends t.AbstractInitializer{constructor(A,U,k,N,F,q,J){super("extensions",N,F,q,k,J),this.extensionManagementService=A,this.ignoredExtensionsManagementService=U}async parseExtensions(A){return A.syncData?await m(A.syncData,this.extensionManagementService):null}generatePreview(A,U){const k=[],N=[],F=[];for(const q of A){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(q.identifier.id))continue;const J=U.find(j=>(0,h.areSameExtensions)(j.identifier,q.identifier));J?(k.push(J),q.disabled&&F.push(q.identifier)):q.installed&&(N.push({...q.identifier,preRelease:!!q.preRelease}),q.disabled&&F.push(q.identifier))}return{installedExtensions:k,newExtensions:N,disabledExtensions:F,remoteExtensions:A}}};_=pe([Y(0,v.IExtensionManagementService),Y(1,s.IIgnoredExtensionsManagementService),Y(2,C.IFileService),Y(3,o.IUserDataProfilesService),Y(4,b.IEnvironmentService),Y(5,a.ILogService),Y(6,i.IUriIdentityService)],_),e.AbstractExtensionsInitializer=_}),define(ne[264],re([0,1,16,9,3,35,46,4,7,30,17,14,13,8,48,21,24,31,41,61,242,26,20,62]),function(Q,e,D,r,R,L,T,P,w,E,I,b,p,v,h,S,C,g,f,a,d,c,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const t="globalState.argv.",n=["locale"];function s(_,$){const A=_.storage?Object.keys(_.storage).sort():[],U={};return A.forEach(k=>U[k]=_.storage[k]),_.storage=U,$?(0,T.toFormattedString)(_,{}):JSON.stringify(_)}const u=1;let l=class vt extends f.AbstractSynchroniser{constructor($,A,U,k,N,F,q,J,j,H,W,z,K){super({syncResource:"globalState",profile:$},A,k,J,z,N,F,j,H,q,W,K),this.userDataSyncProfilesStorageService=U,this.version=u,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.baseResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(k.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(R.Event.any(R.Event.filter(k.onDidFilesChange,X=>X.contains(this.environmentService.argvResource)),R.Event.filter(this.userDataSyncProfilesStorageService.onDidChange,X=>!!(X.targetChanges.some(ce=>this.syncResource.profile.id===ce.id)||X.valueChanges.some(({profile:ce,changes:B})=>this.syncResource.profile.id===ce.id&&B.some(G=>G.target===0)))))(()=>this.triggerLocalChange()))}async generateSyncPreview($,A,U){const k=$.syncData?JSON.parse($.syncData.content):null;A=A===null&&U?$:A;const N=A&&A.syncData?JSON.parse(A.syncData.content):null,F=await this.getLocalGlobalState();k?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const q=await this.getStorageKeys(N),{local:J,remote:j}=(0,d.merge)(F.storage,k?k.storage:null,N?N.storage:null,q,this.logService),H={content:null,local:J,remote:j,localChange:Object.keys(J.added).length>0||Object.keys(J.updated).length>0||J.removed.length>0?2:0,remoteChange:j!==null?2:0},W=s(F,!1);return[{baseResource:this.baseResource,baseContent:N?s(N,!1):W,localResource:this.localResource,localContent:W,localUserData:F,remoteResource:this.remoteResource,remoteContent:k?s(k,!1):null,previewResource:this.previewResource,previewResult:H,localChange:H.localChange,remoteChange:H.remoteChange,acceptedResource:this.acceptedResource,storageKeys:q}]}async hasRemoteChanged($){const A=$.syncData?JSON.parse($.syncData.content):null;if(A===null)return!0;const U=await this.getLocalGlobalState(),k=await this.getStorageKeys(A),{remote:N}=(0,d.merge)(U.storage,A.storage,A.storage,k,this.logService);return N!==null}async getMergeResult($,A){return{...$.previewResult,hasConflicts:!1}}async getAcceptResult($,A,U,k){if(this.extUri.isEqual(A,this.localResource))return this.acceptLocal($);if(this.extUri.isEqual(A,this.remoteResource))return this.acceptRemote($);if(this.extUri.isEqual(A,this.previewResource))return $.previewResult;throw new Error(`Invalid Resource: ${A.toString()}`)}async acceptLocal($){return{content:$.localContent,local:{added:{},removed:[],updated:{}},remote:$.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote($){if($.remoteContent!==null){const A=JSON.parse($.remoteContent),{local:U,remote:k}=(0,d.merge)($.localUserData.storage,A.storage,null,$.storageKeys,this.logService);return{content:$.remoteContent,local:U,remote:k,localChange:Object.keys(U.added).length>0||Object.keys(U.updated).length>0||U.removed.length>0?2:0,remoteChange:k!==null?2:0}}else return{content:$.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult($,A,U,k){const{localUserData:N}=U[0][0],{local:F,remote:q,localChange:J,remoteChange:j}=U[0][1];if(J===0&&j===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),J!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(N)),await this.writeLocalGlobalState(F),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),j!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const H=JSON.stringify({storage:q});$=await this.updateRemoteUserData(H,k?null:$.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}A?.ref!==$.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData($),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:$}){return[{resource:this.extUri.joinPath($,"globalState.json"),comparableResource:vt.GLOBAL_STATE_DATA_URI}]}async resolveContent($){if(this.extUri.isEqual($,vt.GLOBAL_STATE_DATA_URI)){const U=await this.getLocalGlobalState();return s(U,!0)}if(this.extUri.isEqual(this.remoteResource,$)||this.extUri.isEqual(this.baseResource,$)||this.extUri.isEqual(this.localResource,$)||this.extUri.isEqual(this.acceptedResource,$)){const U=await this.resolvePreviewContent($);return U&&s(JSON.parse(U),!0)}let A=await super.resolveContent($);if(A)return A;if(A=await super.resolveContent(this.extUri.dirname($)),A){const U=this.parseSyncData(A);if(U)switch(this.extUri.basename($)){case"globalState.json":return s(JSON.parse(U.content),!0)}}return null}async hasLocalData(){try{const{storage:$}=await this.getLocalGlobalState();if(Object.keys($).length>1||$[`${t}.locale`]?.value!=="en")return!0}catch{}return!1}async getLocalGlobalState(){const $={};if(this.syncResource.profile.isDefault){const U=await this.getLocalArgvContent(),k=(0,L.parse)(U);for(const N of n)k[N]!==void 0&&($[`${t}${N}`]={version:1,value:k[N]})}const A=await this.userDataSyncProfilesStorageService.readStorageData(this.syncResource.profile);for(const[U,k]of A)k.value&&k.target===0&&($[U]={version:1,value:k.value});return{storage:$}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const $=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),$.value.toString()}catch($){this.logService.debug((0,r.getErrorMessage)($))}return"{}"}async writeLocalGlobalState({added:$,removed:A,updated:U}){const k={},N=new Map,F=await this.userDataSyncProfilesStorageService.readStorageData(this.syncResource.profile),q=(J,j)=>{for(const H of J){if(H.startsWith(t)){k[H.substring(t.length)]=j?j[H].value:void 0;continue}if(j){const W=j[H];W.value!==F.get(H)?.value&&N.set(H,W.value)}else F.get(H)!==void 0&&N.set(H,void 0)}};q(Object.keys($),$),q(Object.keys(U),U),q(A),Object.keys(k).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(k),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),N.size&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`),await this.userDataSyncProfilesStorageService.updateStorageData(this.syncResource.profile,N,0),this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,[...N.keys()]))}async updateArgv($){const A=await this.getLocalArgvContent();let U=A;for(const k of Object.keys($))U=(0,a.edit)(U,[k],$[k],{});A!==U&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(U)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}async getStorageKeys($){const A=await this.userDataSyncProfilesStorageService.readStorageData(this.syncResource.profile),U=[],k=[];for(const[q,J]of A)J.target===0?U.push(q):J.target===1&&k.push(q);const N=[...U,...k],F=$?.storage?Object.keys($.storage).filter(q=>!q.startsWith(t)&&!N.includes(q)&&A.get(q)!==void 0):[];if(!P.isWeb){const q=[...c.ALL_SYNC_RESOURCES.map(J=>(0,c.getEnablementKey)(J)),c.SYNC_SERVICE_URL_TYPE];F.push(...q),k.push(...q)}return{user:U,machine:k,unregistered:F}}};l.GLOBAL_STATE_DATA_URI=w.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),l=pe([Y(2,o.IUserDataSyncProfilesStorageService),Y(3,p.IFileService),Y(4,c.IUserDataSyncStoreService),Y(5,c.IUserDataSyncBackupStoreService),Y(6,c.IUserDataSyncLogService),Y(7,b.IEnvironmentService),Y(8,c.IUserDataSyncEnablementService),Y(9,C.ITelemetryService),Y(10,I.IConfigurationService),Y(11,S.IStorageService),Y(12,g.IUriIdentityService)],l),e.GlobalStateSynchroniser=l;let m=class extends f.AbstractInitializer{constructor($,A,U,k,N,F){super("globalState",U,k,N,A,F),this.storageService=$}async doInitialize($){const A=$.syncData?JSON.parse($.syncData.content):null;if(!A){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const U={},k={};for(const N of Object.keys(A.storage))N.startsWith(t)?U[N.substring(t.length)]=A.storage[N].value:this.storageService.get(N,0)===void 0&&(k[N]=A.storage[N].value);if(Object.keys(U).length){let N="{}";try{N=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const F of Object.keys(U))N=(0,a.edit)(N,[F],U[F],{});await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(N))}if(Object.keys(k).length)for(const N of Object.keys(k))this.storageService.store(N,k[N],0,0)}};m=pe([Y(0,S.IStorageService),Y(1,p.IFileService),Y(2,i.IUserDataProfilesService),Y(3,b.IEnvironmentService),Y(4,c.IUserDataSyncLogService),Y(5,g.IUriIdentityService)],m),e.GlobalStateInitializer=m;let y=class{constructor($,A,U,k,N){this.userDataSyncStoreClient=$,this.storageService=A,this.environmentService=U,this.fileService=k,this.logService=N}getSyncStoreType($){return this.parseGlobalState($)?.storage[c.SYNC_SERVICE_URL_TYPE]?.value}async sync($){const A=(0,c.createSyncHeaders)((0,E.generateUuid)());try{return await this.doSync($,A)}catch(U){if(U instanceof c.UserDataSyncError)switch(U.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync($,A)}throw U}}async doSync($,A){const U=await this.userDataSyncStoreClient.readResource("globalState",null,void 0,A),k=this.parseGlobalState(U)||{storage:{}};k.storage[c.SYNC_SERVICE_URL_TYPE]={value:$,version:u};const N=await(0,h.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),F={version:u,machineId:N,content:s(k,!1)};await this.userDataSyncStoreClient.writeResource("globalState",JSON.stringify(F),U.ref,void 0,A)}parseGlobalState({content:$}){if(!$)return null;const A=JSON.parse($);if((0,f.isSyncData)(A))return A?JSON.parse(A.content):null;throw new Error("Invalid remote data")}};y=pe([Y(1,S.IStorageService),Y(2,b.IEnvironmentService),Y(3,p.IFileService),Y(4,v.ILogService)],y),e.UserDataSyncStoreTypeSynchronizer=y}),define(ne[265],re([0,1,18,6,22,38,3,2,19,15,30,17,14,29,5,25,21,24,20,263,264,255,256,257,258,259,26]),function(Q,e,D,r,R,L,T,P,w,E,I,b,p,v,h,S,C,g,f,a,d,c,i,o,t,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const u="sync.lastSyncTime";let l=class extends P.Disposable{get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}constructor(A,U,k,N,F,q,J,j,H,W){super(),this.userDataSyncStoreService=A,this.userDataSyncStoreManagementService=U,this.instantiationService=k,this.logService=N,this.telemetryService=F,this.storageService=q,this.userDataSyncEnablementService=J,this.userDataProfilesService=j,this.productService=H,this.environmentService=W,this._status="uninitialized",this._onDidChangeStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new T.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new T.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new T.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new T.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.activeProfileSynchronizers=new Map,this._status=U.userDataSyncStore?"idle":"uninitialized",this._lastSyncTime=this.storageService.getNumber(u,-1,void 0),this._register((0,P.toDisposable)(()=>this.clearActiveProfileSynchronizers()))}async createSyncTask(A,U){this.checkEnablement(),this.logService.info("Sync started.");const k=new Date().getTime(),N=(0,I.generateUuid)();try{const j=(0,s.createSyncHeaders)(N);U&&(j["Cache-Control"]="no-cache"),A=await this.userDataSyncStoreService.manifest(A,j)}catch(j){const H=s.UserDataSyncError.toUserDataSyncError(j);throw _(H,N,this.userDataSyncStoreManagementService,this.telemetryService),H}const F=!1,q=this;let J;return{manifest:A,async run(){if(F)throw new Error("Can run a task only once");J=(0,r.createCancelablePromise)(j=>q.sync(A,!1,N,j)),await J.finally(()=>J=void 0),q.logService.info(`Sync done. Took ${new Date().getTime()-k}ms`),q.updateLastSyncTime()},stop(){return J?.cancel(),q.stop()}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new s.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.logService.info("Sync started.");const A=new Date().getTime(),U=(0,I.generateUuid)(),k=(0,s.createSyncHeaders)(U);let N;try{N=await this.userDataSyncStoreService.manifest(null,k)}catch(J){const j=s.UserDataSyncError.toUserDataSyncError(J);throw _(j,U,this.userDataSyncStoreManagementService,this.telemetryService),j}await this.resetLocal();const F=this,q=new R.CancellationTokenSource;return{id:U,async merge(){return F.sync(N,!0,U,q.token)},async apply(){await F.applyManualSync(N,U,q.token),F.logService.info(`Sync done. Took ${new Date().getTime()-A}ms`),F.updateLastSyncTime()},stop(){return q.cancel(),F.stop()},dispose(){q.cancel(),F.stop()}}}async sync(A,U,k,N){this._syncErrors=[];try{this.status!=="hasConflicts"&&this.setStatus("syncing");const F=this.getOrCreateActiveProfileSynchronizer(this.userDataProfilesService.defaultProfile,void 0);this._syncErrors.push(...await this.syncProfile(F,A,U,k,N));const q=F.enabled.find(J=>J.resource==="profiles");if(q){const J=await q.getLastSyncedProfiles()||[];if(N.isCancellationRequested)return;await this.syncRemoteProfiles(J,A,U,k,N)}}finally{this._onSyncErrors.fire(this._syncErrors)}}async syncRemoteProfiles(A,U,k,N,F){for(const q of A){if(F.isCancellationRequested)return;const J=this.userDataProfilesService.profiles.find(H=>H.id===q.id);if(!J){this.logService.error(`Settings Profile with id:${q.id} and name: ${q.name} does not exist locally to sync.`);continue}this.logService.info("Syncing profile.",q.name);const j=this.getOrCreateActiveProfileSynchronizer(J,q);this._syncErrors.push(...await this.syncProfile(j,U,k,N,F))}}async applyManualSync(A,U,k){const N=this.getActiveProfileSynchronizers();for(const H of N){if(k.isCancellationRequested)return;await H.apply(U,k)}const F=N.find(H=>H.profile.isDefault);if(!F)return;const q=F.enabled.find(H=>H.resource==="profiles");if(!q)return;const j=(await q.getRemoteSyncedProfiles(A?.latest??null)||[]).filter(H=>N.every(W=>W.profile.id!==H.id));j.length&&await this.syncRemoteProfiles(j,A,!1,U,k)}async syncProfile(A,U,k,N,F){return(await A.sync(U,k,N,F)).map(([J,j])=>({profile:A.profile,syncResource:J,error:j}))}async stop(){this.status!=="idle"&&await Promise.allSettled(this.getActiveProfileSynchronizers().map(A=>A.stop()))}async resolveContent(A){for(const U of this.userDataProfilesService.profiles){const k=await this.performAction(U,async N=>{const F=await N.resolveContent(A);if(F)return F});if(!(0,E.isUndefinedOrNull)(k))return k}return null}async replace(A,U){this.checkEnablement(),await this.performAction(A.profile,async k=>{if(A.syncResource===k.resource)return await k.replace(U),!0})}async accept(A,U,k,N){this.checkEnablement(),await this.performAction(A.profile,async F=>{if(A.syncResource===F.resource)return await F.accept(U,k),N&&await F.apply((0,E.isBoolean)(N)?!1:N.force,(0,s.createSyncHeaders)((0,I.generateUuid)())),!0})}async getRemoteSyncResourceHandles(A){return await this.performAction(A.profile,async k=>{if(k.resource===A.syncResource)return k.getRemoteSyncResourceHandles()})||[]}async getLocalSyncResourceHandles(A){return await this.performAction(A.profile,async k=>{if(k.resource===A.syncResource)return k.getLocalSyncResourceHandles()})||[]}async getAssociatedResources(A,U){return await this.performAction(A.profile,async N=>{if(N.resource===A.syncResource)return N.getAssociatedResources(U)})||[]}async getMachineId(A,U){return await this.performAction(A.profile,async N=>{if(N.resource===A.syncResource)return await N.getMachineId(U)||null})||void 0}async hasLocalData(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async U=>{if(U.resource!=="globalState"&&await U.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async U=>{if(await U.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(A){this.logService.error(A)}this._onDidResetRemote.fire()}async resetLocal(){this.checkEnablement(),this.storageService.remove(u,-1);for(const[A]of this.activeProfileSynchronizers.values())try{await A.resetLocal()}catch(U){this.logService.error(U)}this.clearActiveProfileSynchronizers(),this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performAction(A,U){const k=new P.DisposableStore;try{const N=this.activeProfileSynchronizers.get(A.id);if(N){const H=await this.performActionWithProfileSynchronizer(N[0],U,k);return(0,E.isUndefined)(H)?null:H}if(A.isDefault){const H=k.add(this.instantiationService.createInstance(m,A,void 0)),W=await this.performActionWithProfileSynchronizer(H,U,k);return(0,E.isUndefined)(W)?null:W}if(this.environmentService.isBuilt&&(!this.productService.enableSyncingProfiles||(0,w.isEqual)(this.userDataSyncStoreManagementService.userDataSyncStore?.url,this.userDataSyncStoreManagementService.userDataSyncStore?.stableUrl)))return null;const F=k.add(this.instantiationService.createInstance(n.UserDataProfilesManifestSynchroniser,A,void 0)),q=await this.userDataSyncStoreService.manifest(null),j=(await F.getRemoteSyncedProfiles(q?.latest??null)||[]).find(H=>H.id===A.id);if(j){const H=k.add(this.instantiationService.createInstance(m,A,j.collection)),W=await this.performActionWithProfileSynchronizer(H,U,k);return(0,E.isUndefined)(W)?null:W}return null}finally{k.dispose()}}async performActionWithProfileSynchronizer(A,U,k){const N=[...A.enabled,...A.disabled.map(F=>k.add(A.createSynchronizer(F)))];for(const F of N){const q=await U(F);if(!(0,E.isUndefined)(q))return q}}setStatus(A){const U=this._status;this._status!==A&&(this._status=A,this._onDidChangeStatus.fire(A),U==="hasConflicts"&&this.updateLastSyncTime())}updateConflicts(){const A=this.getActiveProfileSynchronizers().map(U=>U.conflicts).flat();(0,D.equals)(this._conflicts,A,(U,k)=>U.profile.id===k.profile.id&&U.syncResource===k.syncResource&&(0,D.equals)(U.conflicts,k.conflicts,(N,F)=>(0,w.isEqual)(N.previewResource,F.previewResource)))||(this._conflicts=A,this._onDidChangeConflicts.fire(A))}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(u,this._lastSyncTime,-1,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}getOrCreateActiveProfileSynchronizer(A,U){let k=this.activeProfileSynchronizers.get(A.id);if(!k){const N=new P.DisposableStore,F=N.add(this.instantiationService.createInstance(m,A,U?.collection));N.add(F.onDidChangeStatus(q=>this.setStatus(q))),N.add(F.onDidChangeConflicts(q=>this.updateConflicts())),N.add(F.onDidChangeLocal(q=>this._onDidChangeLocal.fire(q))),this.activeProfileSynchronizers.set(A.id,k=[F,N])}return k[0]}getActiveProfileSynchronizers(){const A=[];for(const[U]of this.activeProfileSynchronizers.values())A.push(U);return A}clearActiveProfileSynchronizers(){this.activeProfileSynchronizers.forEach(([,A])=>A.dispose()),this.activeProfileSynchronizers.clear()}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};l=pe([Y(0,s.IUserDataSyncStoreService),Y(1,s.IUserDataSyncStoreManagementService),Y(2,h.IInstantiationService),Y(3,s.IUserDataSyncLogService),Y(4,g.ITelemetryService),Y(5,C.IStorageService),Y(6,s.IUserDataSyncEnablementService),Y(7,f.IUserDataProfilesService),Y(8,S.IProductService),Y(9,p.IEnvironmentService)],l),e.UserDataSyncService=l;let m=class extends P.Disposable{get enabled(){return this._enabled.sort((A,U)=>A[1]-U[1]).map(([A])=>A)}get disabled(){return s.ALL_SYNC_RESOURCES.filter(A=>!this.userDataSyncEnablementService.isResourceEnabled(A))}get status(){return this._status}get conflicts(){return this._conflicts}get profile(){return this._profile}constructor(A,U,k,N,F,q,J,j,H,W,z,K){super(),this._profile=A,this.collection=U,this.userDataSyncEnablementService=k,this.instantiationService=N,this.extensionGalleryService=F,this.userDataSyncStoreManagementService=q,this.telemetryService=J,this.logService=j,this.productService=H,this.configurationService=z,this.environmentService=K,this._enabled=[],this._status="idle",this._onDidChangeStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._profile.isDefault&&this._register(W.onDidChangeProfiles(()=>{if(W.defaultProfile.extensionsResource&&!this._profile.extensionsResource||!W.defaultProfile.extensionsResource&&this._profile.extensionsResource){this._profile=W.defaultProfile;for(const[X]of this._enabled)X instanceof a.ExtensionsSynchroniser&&(X.profileLocation=this._profile.extensionsResource)}})),this._register(k.onDidChangeResourceEnablement(([X,ce])=>this.onDidChangeResourceEnablement(X,ce))),this._register((0,P.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,X])=>X.dispose())));for(const X of s.ALL_SYNC_RESOURCES)k.isResourceEnabled(X)&&this.registerSynchronizer(X)}onDidChangeResourceEnablement(A,U){U?this.registerSynchronizer(A):this.deRegisterSynchronizer(A)}registerSynchronizer(A){if(this._enabled.some(([F])=>F.resource===A))return;if(A==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}if(A==="profiles"){if(!this._profile.isDefault)return;if(this.environmentService.isBuilt&&(!this.productService.enableSyncingProfiles||(0,w.isEqual)(this.userDataSyncStoreManagementService.userDataSyncStore?.url,this.userDataSyncStoreManagementService.userDataSyncStore?.stableUrl))){this.logService.debug("Skipping profiles sync");return}}const U=new P.DisposableStore,k=U.add(this.createSynchronizer(A));U.add(k.onDidChangeStatus(()=>this.updateStatus())),U.add(k.onDidChangeConflicts(()=>this.updateConflicts())),U.add(k.onDidChangeLocal(()=>this._onDidChangeLocal.fire(A)));const N=this.getOrder(A);this._enabled.push([k,N,U])}deRegisterSynchronizer(A){const U=this._enabled.findIndex(([k])=>k.resource===A);if(U!==-1){const k=this._enabled.splice(U,1);for(const[N,,F]of k){if(N.status!=="idle"){const q=N.conflicts.conflicts.length>0;N.stop(),q&&this.updateConflicts(),this.updateStatus()}F.dispose()}}}createSynchronizer(A){switch(A){case"settings":return this.instantiationService.createInstance(i.SettingsSynchroniser,this._profile,this.collection);case"keybindings":return this.instantiationService.createInstance(c.KeybindingsSynchroniser,this._profile,this.collection);case"snippets":return this.instantiationService.createInstance(o.SnippetsSynchroniser,this._profile,this.collection);case"tasks":return this.instantiationService.createInstance(t.TasksSynchroniser,this._profile,this.collection);case"globalState":return this.instantiationService.createInstance(d.GlobalStateSynchroniser,this._profile,this.collection);case"extensions":return this.instantiationService.createInstance(a.ExtensionsSynchroniser,this._profile,this.collection);case"profiles":return this.instantiationService.createInstance(n.UserDataProfilesManifestSynchroniser,this._profile,this.collection)}}async sync(A,U,k,N){if(N.isCancellationRequested)return[];const F=this.enabled;if(!F.length)return[];try{const q=[],J=(0,s.createSyncHeaders)(k),j=(this.collection?A?.collections?.[this.collection]?.latest:A?.latest)??null,H=U?await this.getUserDataSyncConfiguration(j):{};for(const W of F){if(N.isCancellationRequested)return[];if(!this.userDataSyncEnablementService.isResourceEnabled(W.resource))return[];try{if(U){const z=await W.preview(j,H,J);if(z)for(const K of z.resourcePreviews)(K.localChange!==0||K.remoteChange!==0)&&K.mergeState==="preview"&&await W.merge(K.previewResource)}else await W.sync(j,J)}catch(z){const K=s.UserDataSyncError.toUserDataSyncError(z);if(_(K,k,this.userDataSyncStoreManagementService,this.telemetryService),y(z))throw K;this.logService.error(z),this.logService.error(`${W.resource}: ${(0,L.toErrorMessage)(z)}`),q.push([W.resource,K])}}return q}finally{this.updateStatus()}}async apply(A,U){const k=(0,s.createSyncHeaders)(A);for(const N of this.enabled){if(U.isCancellationRequested)return;try{await N.apply(!1,k)}catch(F){const q=s.UserDataSyncError.toUserDataSyncError(F);if(_(q,A,this.userDataSyncStoreManagementService,this.telemetryService),y(F))throw q;this.logService.error(F),this.logService.error(`${N.resource}: ${(0,L.toErrorMessage)(F)}`)}}}async stop(){for(const A of this.enabled)try{A.status!=="idle"&&await A.stop()}catch(U){this.logService.error(U)}}async resetLocal(){for(const A of this.enabled)try{await A.resetLocal()}catch(U){this.logService.error(`${A.resource}: ${(0,L.toErrorMessage)(U)}`),this.logService.error(U)}}async getUserDataSyncConfiguration(A){if(!this.profile.isDefault)return{};const U=this.configurationService.getValue(s.USER_DATA_SYNC_CONFIGURATION_SCOPE),k=this.enabled.find(N=>N instanceof i.SettingsSynchroniser);if(k){const N=await k.getRemoteUserDataSyncConfiguration(A);return{...U,...N}}return U}setStatus(A){this._status!==A&&(this._status=A,this._onDidChangeStatus.fire(A))}updateStatus(){return this.updateConflicts(),this.enabled.some(A=>A.status==="hasConflicts")?this.setStatus("hasConflicts"):this.enabled.some(A=>A.status==="syncing")?this.setStatus("syncing"):this.setStatus("idle")}updateConflicts(){const A=this.enabled.filter(U=>U.status==="hasConflicts").filter(U=>U.conflicts.conflicts.length>0).map(U=>U.conflicts);(0,D.equals)(this._conflicts,A,(U,k)=>U.syncResource===k.syncResource&&(0,D.equals)(U.conflicts,k.conflicts,(N,F)=>(0,w.isEqual)(N.previewResource,F.previewResource)))||(this._conflicts=A,this._onDidChangeConflicts.fire(A))}getOrder(A){switch(A){case"profiles":return 0;case"settings":return 1;case"keybindings":return 2;case"snippets":return 3;case"tasks":return 4;case"globalState":return 5;case"extensions":return 6}}};m=pe([Y(2,s.IUserDataSyncEnablementService),Y(3,h.IInstantiationService),Y(4,v.IExtensionGalleryService),Y(5,s.IUserDataSyncStoreManagementService),Y(6,g.ITelemetryService),Y(7,s.IUserDataSyncLogService),Y(8,S.IProductService),Y(9,f.IUserDataProfilesService),Y(10,b.IConfigurationService),Y(11,p.IEnvironmentService)],m);function y($){if($ instanceof s.UserDataSyncError)switch($.code){case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function _($,A,U,k){k.publicLog2("sync/error",{code:$.code,serverCode:$ instanceof s.UserDataSyncStoreError?String($.serverCode):void 0,url:$ instanceof s.UserDataSyncStoreError?$.url:void 0,resource:$.resource,executionId:A,service:U.userDataSyncStore.url.toString()})}}),define(ne[266],re([0,1,3,2,7,20,26]),function(Q,e,D,r,R,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function P(b,p){return{...b,profile:(0,L.reviveProfile)(b.profile,p.profilesHome.scheme)}}class w{constructor(p,v,h){this.service=p,this.userDataProfilesService=v,this.logService=h,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new D.Emitter}listen(p,v){switch(v){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${v}`)}async call(p,v,h){try{return await this._call(p,v,h)}catch(S){throw this.logService.error(S),S}}async _call(p,v,h){switch(v){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"resolveContent":return this.service.resolveContent(R.URI.revive(h[0]));case"accept":return this.service.accept(P(h[0],this.userDataProfilesService),R.URI.revive(h[1]),h[2],h[3]);case"replace":return this.service.replace(P(h[0],this.userDataProfilesService),R.URI.revive(h[1]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(P(h[0],this.userDataProfilesService));case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(P(h[0],this.userDataProfilesService));case"getAssociatedResources":return this.service.getAssociatedResources(P(h[0],this.userDataProfilesService),{created:h[1].created,uri:R.URI.revive(h[1].uri)});case"getMachineId":return this.service.getMachineId(P(h[0],this.userDataProfilesService),{created:h[1].created,uri:R.URI.revive(h[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(v.startsWith("manualSync/")){const S=v.substring(11),C=h[0],g=this.getManualSyncTask(C);switch(h=h.slice(1),S){case"merge":return g.merge();case"apply":return g.apply();case"stop":return g.stop();case"dispose":return this.disposeManualSyncTask(g)}}throw new Error("Invalid call")}getManualSyncTask(p){const v=this.manualSyncTasks.get(this.createKey(p));if(!v)throw new Error(`Manual sync taks not found: ${p}`);return v.manualSyncTask}async createManualSyncTask(){const p=new r.DisposableStore,v=p.add(await this.service.createManualSyncTask());return this.manualSyncTasks.set(this.createKey(v.id),{manualSyncTask:v,disposables:p}),v.id}disposeManualSyncTask(p){p.dispose();const v=this.createKey(p.id);this.manualSyncTasks.get(v)?.disposables.dispose(),this.manualSyncTasks.delete(v)}createKey(p){return`manualSyncTask-${p}`}}e.UserDataSyncChannel=w;let E=class extends r.Disposable{get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}constructor(p,v){super(),this.userDataProfilesService=v,this._status="uninitialized",this._onDidChangeStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new D.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new D.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(h,S,C){return p.call(h,S,C).then(null,g=>{throw T.UserDataSyncError.toUserDataSyncError(g)})},listen(h,S){return p.listen(h,S)}},this.channel.call("_getInitialData").then(([h,S,C])=>{this.updateStatus(h),this.updateConflicts(S),C&&this.updateLastSyncTime(C),this._register(this.channel.listen("onDidChangeStatus")(g=>this.updateStatus(g))),this._register(this.channel.listen("onDidChangeLastSyncTime")(g=>this.updateLastSyncTime(g)))}),this._register(this.channel.listen("onDidChangeConflicts")(h=>this.updateConflicts(h))),this._register(this.channel.listen("onSyncErrors")(h=>this._onSyncErrors.fire(h.map(S=>({...S,error:T.UserDataSyncError.toUserDataSyncError(S.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const p=await this.channel.call("createManualSyncTask"),v=this;return new I(p,{async call(S,C,g){return v.channel.call(`manualSync/${S}`,[p,...Array.isArray(C)?C:[C]],g)},listen(){throw new Error("not supported")}})}replace(p,v){return this.channel.call("replace",[p,v])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(p,v,h,S){return this.channel.call("accept",[p,v,h,S])}resolveContent(p){return this.channel.call("resolveContent",[p])}async getLocalSyncResourceHandles(p){return(await this.channel.call("getLocalSyncResourceHandles",[p])).map(({created:h,uri:S})=>({created:h,uri:R.URI.revive(S)}))}async getRemoteSyncResourceHandles(p){return(await this.channel.call("getRemoteSyncResourceHandles",[p])).map(({created:h,uri:S})=>({created:h,uri:R.URI.revive(S)}))}async getAssociatedResources(p,v){return(await this.channel.call("getAssociatedResources",[p,v])).map(({resource:S,comparableResource:C})=>({resource:R.URI.revive(S),comparableResource:R.URI.revive(C)}))}async getMachineId(p,v){return this.channel.call("getMachineId",[p,v])}async updateStatus(p){this._status=p,this._onDidChangeStatus.fire(p)}async updateConflicts(p){this._conflicts=p.map(v=>({syncResource:v.syncResource,profile:(0,L.reviveProfile)(v.profile,this.userDataProfilesService.profilesHome.scheme),conflicts:v.conflicts.map(h=>({...h,baseResource:R.URI.revive(h.baseResource),localResource:R.URI.revive(h.localResource),remoteResource:R.URI.revive(h.remoteResource),previewResource:R.URI.revive(h.previewResource)}))})),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(p){this._lastSyncTime!==p&&(this._lastSyncTime=p,this._onDidChangeLastSyncTime.fire(p))}};E=pe([Y(1,L.IUserDataProfilesService)],E),e.UserDataSyncChannelClient=E;class I extends r.Disposable{constructor(p,v){super(),this.id=p,this.channel=v}async merge(){return this.channel.call("merge")}async apply(){return this.channel.call("apply")}stop(){return this.channel.call("stop")}dispose(){this.channel.call("dispose")}}}),define(ne[267],re([0,1,6,22,9,3,2,128,4,19,15,7,30,17,14,13,25,45,48,21,26]),function(Q,e,D,r,R,L,T,P,w,E,I,b,p,v,h,S,C,g,f,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const c="sync.previous.store",i="sync.donot-make-requests-until",o="sync.user-session-id",t="sync.machine-session-id",n=100,s=1e3*60*5;let u=class extends T.Disposable{get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(d.SYNC_SERVICE_URL_TYPE,-1)}set userDataSyncStoreType(A){this.storageService.store(d.SYNC_SERVICE_URL_TYPE,A,-1,w.isWeb?0:1)}constructor(A,U,k){super(),this.productService=A,this.configurationService=U,this.storageService=k,this._onDidChangeUserDataSyncStore=this._register(new L.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(L.Event.filter(k.onDidChangeValue,N=>N.key===d.SYNC_SERVICE_URL_TYPE&&N.scope===-1&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[d.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(d.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(A,U){A=w.isWeb&&A?.web?{...A,...A.web}:A;const k={...A||{},...U||{}};if(k&&(0,I.isString)(k.url)&&(0,I.isObject)(k.authenticationProviders)&&Object.keys(k.authenticationProviders).every(N=>Array.isArray(k.authenticationProviders[N].scopes))){const N=k,F=!!N.canSwitch&&!U?.url,q=N.url===N.insidersUrl?"insiders":"stable",J=(F?this.userDataSyncStoreType:void 0)||q,j=U?.url||(J==="insiders"?N.insidersUrl:J==="stable"?N.stableUrl:N.url);return{url:b.URI.parse(j),type:J,defaultType:q,defaultUrl:b.URI.parse(N.url),stableUrl:b.URI.parse(N.stableUrl),insidersUrl:b.URI.parse(N.insidersUrl),canSwitch:F,authenticationProviders:Object.keys(N.authenticationProviders).reduce((H,W)=>(H.push({id:W,scopes:N.authenticationProviders[W].scopes}),H),[])}}}};u=pe([Y(0,C.IProductService),Y(1,v.IConfigurationService),Y(2,a.IStorageService)],u),e.AbstractUserDataSyncStoreManagementService=u;let l=class extends u{constructor(A,U,k){super(A,U,k);const N=this.storageService.get(c,-1);N&&(this.previousConfigurationSyncStore=JSON.parse(N));const F=this.productService[d.CONFIGURATION_SYNC_STORE_KEY];F?this.storageService.store(c,JSON.stringify(F),-1,1):this.storageService.remove(c,-1)}async switch(A){A!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=A,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};l=pe([Y(0,C.IProductService),Y(1,v.IConfigurationService),Y(2,a.IStorageService)],l),e.UserDataSyncStoreManagementService=l;let m=class extends T.Disposable{get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}constructor(A,U,k,N,F,q,J){super(),this.requestService=k,this.logService=N,this.storageService=J,this._onTokenFailed=this._register(new L.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new L.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new L.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(A),this.commonHeadersPromise=(0,f.getServiceMachineId)(F,q,J).then(j=>{const H={"X-Client-Name":`${U.applicationName}${w.isWeb?"-web":""}`,"X-Client-Version":U.version};return U.commit&&(H["X-Client-Commit"]=U.commit),H}),this.session=new _(n,s,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,T.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}setAuthToken(A,U){this.authToken={token:A,type:U}}updateUserDataSyncStoreUrl(A){this.userDataSyncStoreUrl=A?(0,E.joinPath)(A,"v1"):void 0}initDonotMakeRequestsUntil(){const A=this.storageService.getNumber(i,-1);A&&Date.now()<A&&this.setDonotMakeRequestsUntil(new Date(A))}setDonotMakeRequestsUntil(A){this._donotMakeRequestsUntil?.getTime()!==A?.getTime()&&(this._donotMakeRequestsUntil=A,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(i,this._donotMakeRequestsUntil.getTime(),-1,1),this.resetDonotMakeRequestsUntilPromise=(0,D.createCancelablePromise)(U=>(0,D.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),U).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,U=>null)):this.storageService.remove(i,-1),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllCollections(A={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,E.joinPath)(this.userDataSyncStoreUrl,"collection").toString();A={...A},A["Content-Type"]="application/json";const k=await this.request(U,{type:"GET",headers:A},[],r.CancellationToken.None);return await(0,g.asJson)(k)||[]}async createCollection(A={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,E.joinPath)(this.userDataSyncStoreUrl,"collection").toString();A={...A},A["Content-Type"]=P.Mimes.text;const k=await this.request(U,{type:"POST",headers:A},[],r.CancellationToken.None),N=await(0,g.asTextOrError)(k);if(!N)throw new d.UserDataSyncStoreError("Server did not return the collection id",U,"NoCollection",k.res.statusCode,k.res.headers[d.HEADER_OPERATION_ID]);return N}async deleteCollection(A,U={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=A?(0,E.joinPath)(this.userDataSyncStoreUrl,"collection",A).toString():(0,E.joinPath)(this.userDataSyncStoreUrl,"collection").toString();U={...U},await this.request(k,{type:"DELETE",headers:U},[],r.CancellationToken.None)}async getAllResourceRefs(A,U){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=this.getResourceUrl(this.userDataSyncStoreUrl,U,A),N={},F=await this.request(k.toString(),{type:"GET",headers:N},[],r.CancellationToken.None);return(await(0,g.asJson)(F)||[]).map(({url:J,created:j})=>({ref:(0,E.relativePath)(k,k.with({path:J})),created:j*1e3}))}async resolveResourceContent(A,U,k,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,E.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,k,A),U).toString();N={...N},N["Cache-Control"]="no-cache";const q=await this.request(F,{type:"GET",headers:N},[],r.CancellationToken.None);return await(0,g.asTextOrError)(q)}async deleteResource(A,U,k){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=U!==null?(0,E.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,k,A),U).toString():this.getResourceUrl(this.userDataSyncStoreUrl,k,A).toString(),F={};await this.request(N,{type:"DELETE",headers:F},[],r.CancellationToken.None)}async deleteResources(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const A=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),U={"Content-Type":P.Mimes.text};await this.request(A,{type:"DELETE",headers:U},[],r.CancellationToken.None)}async readResource(A,U,k,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,E.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,k,A),"latest").toString();N={...N},N["Cache-Control"]="no-cache",U&&(N["If-None-Match"]=U.ref);const q=await this.request(F,{type:"GET",headers:N},[304],r.CancellationToken.None);let J=null;if(q.res.statusCode===304&&(J=U),J===null){const j=q.res.headers.etag;if(!j)throw new d.UserDataSyncStoreError("Server did not return the ref",F,"NoRef",q.res.statusCode,q.res.headers[d.HEADER_OPERATION_ID]);const H=await(0,g.asTextOrError)(q);if(!H&&q.res.statusCode===304)throw new d.UserDataSyncStoreError("Empty response",F,"EmptyResponse",q.res.statusCode,q.res.headers[d.HEADER_OPERATION_ID]);J={ref:j,content:H}}return J}async writeResource(A,U,k,N,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const q=this.getResourceUrl(this.userDataSyncStoreUrl,N,A).toString();F={...F},F["Content-Type"]=P.Mimes.text,k&&(F["If-Match"]=k);const J=await this.request(q,{type:"POST",data:U,headers:F},[],r.CancellationToken.None),j=J.res.headers.etag;if(!j)throw new d.UserDataSyncStoreError("Server did not return the ref",q,"NoRef",J.res.statusCode,J.res.headers[d.HEADER_OPERATION_ID]);return j}async manifest(A,U={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=(0,E.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();U={...U},U["Content-Type"]="application/json",A&&(U["If-None-Match"]=A.ref);const N=await this.request(k,{type:"GET",headers:U},[304],r.CancellationToken.None);let F=null;if(N.res.statusCode===304&&(F=A),!F){const J=N.res.headers.etag;if(!J)throw new d.UserDataSyncStoreError("Server did not return the ref",k,"NoRef",N.res.statusCode,N.res.headers[d.HEADER_OPERATION_ID]);const j=await(0,g.asTextOrError)(N);if(!j&&N.res.statusCode===304)throw new d.UserDataSyncStoreError("Empty response",k,"EmptyResponse",N.res.statusCode,N.res.headers[d.HEADER_OPERATION_ID]);j&&(F={...JSON.parse(j),ref:J})}const q=this.storageService.get(o,-1);return q&&F&&q!==F.session&&this.clearSession(),F===null&&q&&this.clearSession(),F&&this.storageService.store(o,F.session,-1,1),F}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");await this.deleteResources(),await this.deleteCollection(),this.clearSession()}getResourceUrl(A,U,k){return U?(0,E.joinPath)(A,"collection",U,"resource",k):(0,E.joinPath)(A,"resource",k)}clearSession(){this.storageService.remove(o,-1),this.storageService.remove(t,-1)}async request(A,U,k,N){if(!this.authToken)throw new d.UserDataSyncStoreError("No Auth Token Available",A,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new d.UserDataSyncStoreError(`${U.type} request '${A}' failed because of too many requests (429).`,A,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const F=await this.commonHeadersPromise;U.headers={...U.headers||{},...F,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(U.headers),this.logService.trace("Sending request to server",{url:A,type:U.type,headers:{...U.headers,authorization:void 0}});let q;try{q=await this.session.request(A,U,N)}catch(W){if(!(W instanceof d.UserDataSyncStoreError)){let z="RequestFailed";const K=(0,R.getErrorMessage)(W).toLowerCase();K.includes("xhr timeout")?z="RequestTimeout":K.includes("protocol")&&K.includes("not supported")?z="RequestProtocolNotSupported":K.includes("request path contains unescaped characters")?z="RequestPathNotEscaped":K.includes("headers must be an object")?z="RequestHeadersNotObject":(0,R.isCancellationError)(W)&&(z="RequestCanceled"),W=new d.UserDataSyncStoreError(`Connection refused for the request '${A}'.`,A,z,void 0,void 0)}throw this.logService.info("Request failed",A),W}const J=q.res.headers[d.HEADER_OPERATION_ID],j={url:A,status:q.res.statusCode,"execution-id":U.headers[d.HEADER_EXECUTION_ID],"operation-id":J},H=(0,g.isSuccess)(q)||q.res.statusCode&&k.indexOf(q.res.statusCode)!==-1;if(H?this.logService.trace("Request succeeded",j):this.logService.info("Request failed",j),q.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new d.UserDataSyncStoreError(`Request '${A}' failed because of Unauthorized (401).`,A,"Unauthorized",q.res.statusCode,J);if(this._onTokenSucceed.fire(),q.res.statusCode===409)throw new d.UserDataSyncStoreError(`${U.type} request '${A}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,A,"Conflict",q.res.statusCode,J);if(q.res.statusCode===410)throw new d.UserDataSyncStoreError(`${U.type} request '${A}' failed because the requested resource is not longer available (410).`,A,"Gone",q.res.statusCode,J);if(q.res.statusCode===412)throw new d.UserDataSyncStoreError(`${U.type} request '${A}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,A,"PreconditionFailed",q.res.statusCode,J);if(q.res.statusCode===413)throw new d.UserDataSyncStoreError(`${U.type} request '${A}' failed because of too large payload (413).`,A,"TooLarge",q.res.statusCode,J);if(q.res.statusCode===426)throw new d.UserDataSyncStoreError(`${U.type} request '${A}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,A,"UpgradeRequired",q.res.statusCode,J);if(q.res.statusCode===429){const W=q.res.headers["retry-after"];throw W?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(W)*1e3)),new d.UserDataSyncStoreError(`${U.type} request '${A}' failed because of too many requests (429).`,A,"TooManyRequestsAndRetryAfter",q.res.statusCode,J)):new d.UserDataSyncStoreError(`${U.type} request '${A}' failed because of too many requests (429).`,A,"RemoteTooManyRequests",q.res.statusCode,J)}if(!H)throw new d.UserDataSyncStoreError("Server returned "+q.res.statusCode,A,"Unknown",q.res.statusCode,J);return q}addSessionHeaders(A){let U=this.storageService.get(t,-1);U===void 0&&(U=(0,p.generateUuid)(),this.storageService.store(t,U,-1,1)),A["X-Machine-Session-Id"]=U;const k=this.storageService.get(o,-1);k!==void 0&&(A["X-User-Session-Id"]=k)}};m=pe([Y(1,C.IProductService),Y(2,g.IRequestService),Y(3,d.IUserDataSyncLogService),Y(4,h.IEnvironmentService),Y(5,S.IFileService),Y(6,a.IStorageService)],m),e.UserDataSyncStoreClient=m;let y=class extends m{constructor(A,U,k,N,F,q,J){super(A.userDataSyncStore?.url,U,k,N,F,q,J),this._register(A.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(A.userDataSyncStore?.url)))}};y=pe([Y(0,d.IUserDataSyncStoreManagementService),Y(1,C.IProductService),Y(2,g.IRequestService),Y(3,d.IUserDataSyncLogService),Y(4,h.IEnvironmentService),Y(5,S.IFileService),Y(6,a.IStorageService)],y),e.UserDataSyncStoreService=y;class _{constructor(A,U,k,N){this.limit=A,this.interval=U,this.requestService=k,this.logService=N,this.requests=[],this.startTime=void 0}request(A,U,k){if(this.isExpired()&&this.reset(),U.url=A,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new d.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,A,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(A),this.requestService.request(U,k)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=_}),define(ne[268],re([0,1,3,59,25,21,24,262,26,75,78]),function(Q,e,D,r,R,L,T,P,w,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let b=class extends P.UserDataAutoSyncService{constructor(v,h,S,C,g,f,a,d,c,i,o){super(v,h,S,C,g,a,d,c,i,o),this._register(D.Event.debounce(D.Event.any(D.Event.map(f.onDidFocusWindow,()=>"windowFocus"),D.Event.map(f.onDidOpenWindow,()=>"windowOpen")),(t,n)=>t?[...t,n]:[n],1e3)(t=>this.triggerSync(t,!0,!1)))}};b=pe([Y(0,R.IProductService),Y(1,w.IUserDataSyncStoreManagementService),Y(2,w.IUserDataSyncStoreService),Y(3,w.IUserDataSyncEnablementService),Y(4,w.IUserDataSyncService),Y(5,r.INativeHostService),Y(6,w.IUserDataSyncLogService),Y(7,E.IUserDataSyncAccountService),Y(8,T.ITelemetryService),Y(9,I.IUserDataSyncMachinesService),Y(10,L.IStorageService)],b),e.UserDataAutoSyncService=b}),define(ne[269],re([0,1,3,2,58,8,62,21,73,20]),function(Q,e,D,r,R,L,T,P,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncProfilesStorageService=void 0;let I=class extends T.AbstractUserDataSyncProfilesStorageService{constructor(p,v,h,S){super(h),this.mainProcessService=p;const C=p.getChannel("profileStorageListener"),g=this._register(new r.MutableDisposable);this._onDidChange=this._register(new D.Emitter({onFirstListenerAdd:()=>{g.value=C.listen("onDidChange")(f=>{S.trace("profile storage changes",f),this._onDidChange.fire({targetChanges:f.targetChanges.map(a=>(0,E.reviveProfile)(a,v.profilesHome.scheme)),valueChanges:f.valueChanges.map(a=>({...a,profile:(0,E.reviveProfile)(a.profile,v.profilesHome.scheme)}))})})},onLastListenerRemove:()=>g.value=void 0})),this.onDidChange=this._onDidChange.event}async createStorageDatabase(p){const v=this.mainProcessService.getChannel("storage");return(0,P.isProfileUsingDefaultStorage)(p)?new w.ApplicationStorageDatabaseClient(v):new w.ProfileStorageDatabaseClient(v,p)}};I=pe([Y(0,R.IMainProcessService),Y(1,E.IUserDataProfilesService),Y(2,P.IStorageService),Y(3,L.ILogService)],I),e.UserDataSyncProfilesStorageService=I}),define(ne[270],re([0,1,96,23,4,19]),function(Q,e,D,r,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function T(E){function I(){let b=E.scheme===r.Schemas.file?(0,L.originalFSPath)(E):E.toString();return R.isLinux||(b=b.toLowerCase()),(0,D.createHash)("md5").update(b).digest("hex")}return{id:I(),configPath:E}}e.getWorkspaceIdentifier=T;function P(E,I){function b(){if(E.scheme!==r.Schemas.file)return(0,D.createHash)("md5").update(E.toString()).digest("hex");if(!I)return;let v;return R.isLinux?v=I.ino:R.isMacintosh?v=I.birthtime.getTime():R.isWindows&&(typeof I.birthtimeMs=="number"?v=Math.floor(I.birthtimeMs):v=I.birthtime.getTime()),(0,D.createHash)("md5").update(E.fsPath).update(v?String(v):"").digest("hex")}const p=b();if(typeof p=="string")return{id:p,uri:E}}e.getSingleFolderWorkspaceIdentifier=P;function w(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=w}),define(ne[271],re([0,1,6,9,2,12,28,14,58,8,59,73,111,270]),function(Q,e,D,r,R,L,T,P,w,E,I,b,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let h=class extends R.Disposable{constructor(C,g,f,a){super(),this.environmentService=C,this.logService=g,this.nativeHostService=f,this.mainProcessService=a,this._register(new D.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const C=await T.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath),g=new b.StorageClient(this.mainProcessService.getChannel("storage"));await Promise.all(C.map(async f=>{const a=(0,L.join)(this.environmentService.workspaceStorageHome.fsPath,f);f.length===v.NON_EMPTY_WORKSPACE_ID_LENGTH||f===p.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.nativeHostService.getWindows()).some(i=>i.workspace?.id===f)||await g.isUsed(a)||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${f} as it seems to be an unused empty workspace.`),await T.Promises.rm(a))}))}catch(C){(0,r.onUnexpectedError)(C)}}};h=pe([Y(0,P.INativeEnvironmentService),Y(1,E.ILogService),Y(2,I.INativeHostService),Y(3,w.IMainProcessService)],h),e.UnusedWorkspaceStorageDataCleaner=h}),define(ne[113],re([0,1,53,6,12,15,28,140,280,281]),function(Q,e,D,r,R,L,T,P,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class I extends Error{constructor(i,o){let t=o.message;switch(i){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=i,this.cause=o}}e.ExtractError=I;function b(c){const i=c.externalFileAttributes>>16||33188;return[448,56,7].map(o=>i&o).reduce((o,t)=>o+t,i&61440)}function p(c){if(c instanceof I)return c;let i;return/end of central directory record signature not found/.test(c.message)&&(i="CorruptZip"),new I(i,c)}function v(c,i,o,t,n,s){const u=R.dirname(i),l=R.join(t,u);if(!l.startsWith(t))return Promise.reject(new Error(P.localize(0,null,i)));const m=R.join(t,i);let y;return s.onCancellationRequested(()=>{y?.destroy()}),Promise.resolve(T.Promises.mkdir(l,{recursive:!0})).then(()=>new Promise((_,$)=>{if(!s.isCancellationRequested)try{y=(0,D.createWriteStream)(m,{mode:o}),y.once("close",()=>_()),y.once("error",$),c.once("error",$),c.pipe(y)}catch(A){$(A)}}))}function h(c,i,o,t){let n=(0,r.createCancelablePromise)(()=>Promise.resolve()),s=0;return t.onCancellationRequested(()=>{n.cancel(),c.close()}),new Promise((u,l)=>{const m=new r.Sequencer,y=_=>{_.isCancellationRequested||(s++,c.readEntry())};c.once("error",l),c.once("close",()=>n.then(()=>{t.isCancellationRequested||c.entryCount===s?u():l(new I("Incomplete",new Error(P.localize(1,null,s,c.entryCount))))},l)),c.readEntry(),c.on("entry",_=>{if(t.isCancellationRequested)return;if(!o.sourcePathRegex.test(_.fileName)){y(t);return}const $=_.fileName.replace(o.sourcePathRegex,"");if(/\/$/.test($)){const k=R.join(i,$);n=(0,r.createCancelablePromise)(N=>T.Promises.mkdir(k,{recursive:!0}).then(()=>y(N)).then(void 0,l));return}const A=C(c,_),U=b(_);n=(0,r.createCancelablePromise)(k=>m.queue(()=>A.then(N=>v(N,$,U,i,o,k).then(()=>y(k)))).then(null,l))})})}function S(c,i=!1){return new Promise((o,t)=>{(0,w.open)(c,i?{lazyEntries:!0}:void 0,(n,s)=>{n?t(p(n)):o((0,L.assertIsDefined)(s))})})}function C(c,i){return new Promise((o,t)=>{c.openReadStream(i,(n,s)=>{n?t(p(n)):o((0,L.assertIsDefined)(s))})})}function g(c,i){return new Promise((o,t)=>{const n=new E.ZipFile;i.forEach(u=>{u.contents?n.addBuffer(typeof u.contents=="string"?Buffer.from(u.contents,"utf8"):u.contents,u.path):u.localPath&&n.addFile(u.localPath,u.path)}),n.end();const s=(0,D.createWriteStream)(c);n.outputStream.pipe(s),n.outputStream.once("error",t),s.once("error",t),s.once("finish",()=>o(c))})}e.zip=g;function f(c,i,o={},t){const n=new RegExp(o.sourcePath?`^${o.sourcePath}`:"");let s=S(c,!0);return o.overwrite&&(s=s.then(u=>T.Promises.rm(i).then(()=>u))),s.then(u=>h(u,i,{sourcePathRegex:n},t))}e.extract=f;function a(c,i){return S(c).then(o=>new Promise((t,n)=>{o.on("entry",s=>{s.fileName===i&&C(o,s).then(u=>t(u),u=>n(u))}),o.once("close",()=>n(new Error(P.localize(2,null,i))))}))}function d(c,i){return a(c,i).then(o=>new Promise((t,n)=>{const s=[];o.once("error",n),o.on("data",u=>s.push(u)),o.on("end",()=>t(Buffer.concat(s)))}))}e.buffer=d}),define(ne[272],re([0,1,113,150]),function(Q,e,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function R(L){return(0,D.buffer)(L,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch{throw new Error((0,r.localize)(0,null))}})}e.getManifest=R}),define(ne[114],re([0,1,6,38,9,2,23,12,4,19,55,15,7,30,28,113,149,94,14,248,29,33,49,76,204,249,272,205,235,44,69,13,5,8,25,24,31,20]),function(Q,e,D,r,R,L,T,P,w,E,I,b,p,v,h,S,C,g,f,a,d,c,i,o,t,n,s,u,l,m,y,_,$,A,U,k,N,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,$.refineServiceDecorator)(d.IExtensionManagementService);let q=class extends a.AbstractExtensionManagementService{constructor(B,G,O,M,x,V,ee,oe,Z,ie,se,ue){super(B,G,O,ie,ue),this.extensionsScannerService=x,this.extensionsProfileScannerService=V,this.downloadService=ee,this.fileService=Z,this.installGalleryExtensionsTasks=new Map;const de=this._register(oe.createInstance(n.ExtensionsLifecycle));this.extensionsScanner=this._register(oe.createInstance(J,we=>de.postUninstall(we))),this.manifestCache=this._register(new u.ExtensionsManifestCache(M,this)),this.extensionsDownloader=this._register(oe.createInstance(t.ExtensionsDownloader));const ve=this._register(new l.ExtensionsWatcher(this,Z,M,O,se));this._register(ve.onDidChangeExtensionsByAnotherSource(({added:we,removed:Ee})=>{we.length&&this._onDidInstallExtensions.fire(we.map(Ce=>({identifier:Ce.identifier,operation:1,local:Ce}))),Ee.forEach(Ce=>this._onDidUninstallExtension.fire({identifier:Ce}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,c.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(B){this.logService.trace("ExtensionManagementService#zip",B.identifier.id);const G=await this.collectFiles(B),O=await(0,S.zip)((0,E.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,v.generateUuid)()).fsPath,G);return p.URI.file(O)}async unzip(B){return this.logService.trace("ExtensionManagementService#unzip",B.toString()),(await this.install(B)).identifier}async getManifest(B){const{location:G,cleanup:O}=await this.downloadVsix(B),M=P.resolve(G.fsPath);try{return await(0,s.getManifest)(M)}finally{await O()}}getInstalled(B,G){return this.extensionsScanner.scanExtensions(B??null,G)}getAllUserInstalled(){return this.extensionsScanner.scanUserExtensions(!1)}async install(B,G={}){this.logService.trace("ExtensionManagementService#install",B.toString());const{location:O,cleanup:M}=await this.downloadVsix(B);try{const x=await(0,s.getManifest)(P.resolve(O.fsPath));if(x.engines&&x.engines.vscode&&!(0,y.isEngineValid)(x.engines.vscode,this.productService.version,this.productService.date))throw new Error(C.localize(0,null,(0,c.getGalleryExtensionId)(x.publisher,x.name),this.productService.version));return await this.installExtension(x,O,G)}finally{await M()}}getMetadata(B){return this.extensionsScannerService.scanMetadata(B.location)}async updateMetadata(B,G){this.logService.trace("ExtensionManagementService#updateMetadata",B.identifier.id);const O={...G};return G.isPreReleaseVersion&&(O.preRelease=!0),B=await this.extensionsScanner.updateMetadata(B,O),this.manifestCache.invalidate(),B}async updateExtensionScope(B,G){return this.logService.trace("ExtensionManagementService#updateExtensionScope",B.identifier.id),B=await this.extensionsScanner.updateMetadata(B,{isMachineScoped:G}),this.manifestCache.invalidate(),B}removeUninstalledExtensions(B){return this.extensionsScanner.cleanUp(B)}async downloadVsix(B){if(B.scheme===T.Schemas.file)return{location:B,async cleanup(){}};this.logService.trace("Downloading extension from",B.toString());const G=(0,E.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,v.generateUuid)());return await this.downloadService.download(B,G),this.logService.info("Downloaded extension to",G.toString()),{location:G,cleanup:async()=>{try{await this.fileService.del(G)}catch(M){this.logService.error(M)}}}}doCreateInstallExtensionTask(B,G,O){let M;if(p.URI.isUri(G))M=new W(B,G,O,this.galleryService,this.extensionsScanner,this.logService);else{const x=c.ExtensionKey.create(G).toString();M=this.installGalleryExtensionsTasks.get(x),M||(this.installGalleryExtensionsTasks.set(x,M=new H(B,G,O,this.extensionsDownloader,this.extensionsScanner,this.logService)),M.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(x)))}return O.profileLocation?new z(M,O.profileLocation,this.extensionsProfileScannerService):M}doCreateUninstallExtensionTask(B,G){return G.profileLocation?new X(B,G.profileLocation,this.extensionsProfileScannerService):new K(B,G,this.extensionsScanner)}async collectFiles(B){const G=async M=>{let x=await h.Promises.readdir(M);x=x.map(oe=>P.join(M,oe));const V=await Promise.all(x.map(oe=>h.Promises.stat(oe)));let ee=Promise.resolve([]);return V.forEach((oe,Z)=>{const ie=x[Z];oe.isFile()&&(ee=ee.then(se=>[...se,ie])),oe.isDirectory()&&(ee=ee.then(se=>G(ie).then(ue=>[...se,...ue])))}),ee};return(await G(B.location.fsPath)).map(M=>({path:`extension/${P.relative(B.location.fsPath,M)}`,localPath:M}))}};q=pe([Y(0,d.IExtensionGalleryService),Y(1,k.ITelemetryService),Y(2,A.ILogService),Y(3,f.INativeEnvironmentService),Y(4,o.IExtensionsScannerService),Y(5,i.IExtensionsProfileScannerService),Y(6,g.IDownloadService),Y(7,$.IInstantiationService),Y(8,_.IFileService),Y(9,U.IProductService),Y(10,N.IUriIdentityService),Y(11,F.IUserDataProfilesService)],q),e.ExtensionManagementService=q;let J=class extends L.Disposable{constructor(B,G,O,M){super(),this.beforeRemovingExtension=B,this.fileService=G,this.extensionsScannerService=O,this.logService=M,this.uninstalledPath=(0,E.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new D.Queue}async cleanUp(B){await this.removeUninstalledExtensions(),B&&await this.removeOutdatedExtensions()}async scanExtensions(B,G){const O={includeInvalid:!0,profileLocation:G};let M=[];return B===null||B===0?M.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},O,!1)):B===1&&M.push(...await this.extensionsScannerService.scanUserExtensions(O)),M=B!==null?M.filter(x=>x.type===B):M,Promise.all(M.map(x=>this.toLocalExtension(x)))}async scanUserExtensions(B){const G=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!B,includeInvalid:!0});return Promise.all(G.map(O=>this.toLocalExtension(O)))}async extractUserExtension(B,G,O,M){const x=B.toString(),V=P.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,v.generateUuid)()}`),ee=P.join(this.extensionsScannerService.userExtensionsLocation.fsPath,x);try{await h.Promises.rm(ee)}catch{throw new d.ExtensionManagementError(C.localize(1,null,ee,B.id),d.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(B,G,V,M),await this.extensionsScannerService.updateMetadata(p.URI.file(V),O);try{await this.rename(B,V,ee,Date.now()+2*60*1e3),this.logService.info("Renamed to",ee)}catch(oe){try{await h.Promises.rm(V)}catch{}if(oe.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",B.id);else throw this.logService.info(`Rename failed because of ${(0,R.getErrorMessage)(oe)}. Deleted from extracted location`,V),oe}return this.scanLocalExtension(p.URI.file(ee),1)}async updateMetadata(B,G){return await this.extensionsScannerService.updateMetadata(B.location,G),this.scanLocalExtension(B.location,B.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...B){const G=B.map(O=>c.ExtensionKey.create(O));await this.withUninstalledExtensions(O=>{G.forEach(M=>O[M.toString()]=!0)})}async setInstalled(B){await this.withUninstalledExtensions(M=>delete M[B.toString()]);const O=(await this.scanUserExtensions(!0)).find(M=>c.ExtensionKey.create(M).equals(B))||null;return O?this.updateMetadata(O,{installedTimestamp:Date.now()}):null}async removeExtension(B,G){this.logService.trace(`Deleting ${G} extension from disk`,B.identifier.id,B.location.fsPath),await h.Promises.rm(B.location.fsPath),this.logService.info("Deleted from disk",B.identifier.id,B.location.fsPath)}async removeUninstalledExtension(B){await this.removeExtension(B,"uninstalled"),await this.withUninstalledExtensions(G=>delete G[c.ExtensionKey.create(B).toString()])}async withUninstalledExtensions(B){return this.uninstalledFileLimiter.queue(async()=>{let G;try{G=await h.Promises.readFile(this.uninstalledPath,"utf8")}catch(M){if(M.code!=="ENOENT")throw M}let O={};if(G)try{O=JSON.parse(G)}catch{}return B&&(B(O),Object.keys(O).length?await h.Promises.writeFile(this.uninstalledPath,JSON.stringify(O)):await h.Promises.rm(this.uninstalledPath)),O})}async extractAtLocation(B,G,O,M){this.logService.trace(`Started extracting the extension from ${G} to ${O}`);try{await h.Promises.rm(O)}catch(x){throw new d.ExtensionManagementError(this.joinErrors(x).message,d.ExtensionManagementErrorCode.Delete)}try{await(0,S.extract)(G,O,{sourcePath:"extension",overwrite:!0},M),this.logService.info(`Extracted extension to ${O}:`,B.id)}catch(x){try{await h.Promises.rm(O)}catch{}let V=d.ExtensionManagementErrorCode.Extract;throw x instanceof S.ExtractError&&(x.type==="CorruptZip"?V=d.ExtensionManagementErrorCode.CorruptZip:x.type==="Incomplete"&&(V=d.ExtensionManagementErrorCode.IncompleteZip)),new d.ExtensionManagementError(x.message,V)}}async rename(B,G,O,M){try{await h.Promises.rename(G,O)}catch(x){if(w.isWindows&&x&&x.code==="EPERM"&&Date.now()<M)return this.logService.info(`Failed renaming ${G} to ${O} with 'EPERM' error. Trying again...`,B.id),this.rename(B,G,O,M);throw new d.ExtensionManagementError(x.message||C.localize(2,null,G,O),x.code||d.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(B,G){const O=await this.extensionsScannerService.scanExistingExtension(B,G,{includeInvalid:!0});if(O)return this.toLocalExtension(O);throw new Error(C.localize(3,null,B.path))}async toLocalExtension(B){const G=await this.fileService.resolve(B.location);let O,M;return G.children&&(O=G.children.find(({name:x})=>/^readme(\.txt|\.md|)$/i.test(x))?.resource,M=G.children.find(({name:x})=>/^changelog(\.txt|\.md|)$/i.test(x))?.resource),{identifier:B.identifier,type:B.type,isBuiltin:B.isBuiltin||!!B.metadata?.isBuiltin,location:B.location,manifest:B.manifest,targetPlatform:B.targetPlatform,validations:B.validations,isValid:B.isValid,readmeUrl:O,changelogUrl:M,publisherDisplayName:B.metadata?.publisherDisplayName||null,publisherId:B.metadata?.publisherId||null,isApplicationScoped:!!B.metadata?.isApplicationScoped,isMachineScoped:!!B.metadata?.isMachineScoped,isPreReleaseVersion:!!B.metadata?.isPreReleaseVersion,preRelease:!!B.metadata?.preRelease,installedTimestamp:B.metadata?.installedTimestamp,updated:!!B.metadata?.updated}}async removeUninstalledExtensions(){const B=await this.getUninstalledExtensions(),G=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),O=new Set;for(const V of G)B[c.ExtensionKey.create(V).toString()]||O.add(V.identifier.id.toLowerCase());const M=(0,c.groupByExtension)(G,V=>V.identifier);await D.Promises.settled(M.map(async V=>{const ee=V.sort((oe,Z)=>I.rcompare(oe.manifest.version,Z.manifest.version))[0];O.has(ee.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(ee))}));const x=G.filter(V=>B[c.ExtensionKey.create(V).toString()]);await D.Promises.settled(x.map(V=>this.removeUninstalledExtension(V)))}async removeOutdatedExtensions(){const B=await this.extensionsScannerService.scanSystemExtensions({}),G=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),O=[],M=await this.extensionsScannerService.getTargetPlatform(),x=(0,c.groupByExtension)(G,V=>V.identifier);for(const V of x)if(V.length>1&&O.push(...V.sort((ee,oe)=>{const Z=I.rcompare(ee.manifest.version,oe.manifest.version);return Z!==0?Z:ee.targetPlatform===M?-1:1}).slice(1)),V[0].type===0){const ee=B.find(oe=>(0,c.areSameExtensions)(oe.identifier,V[0].identifier));(!ee||I.gte(ee.manifest.version,V[0].manifest.version))&&O.push(V[0])}await D.Promises.settled(O.map(V=>this.removeExtension(V,"outdated")))}joinErrors(B){const G=Array.isArray(B)?B:[B];return G.length===1?G[0]instanceof Error?G[0]:new Error(G[0]):G.reduce((O,M)=>new Error(`${O.message}${O.message?",":""}${M instanceof Error?M.message:M}`),new Error(""))}};J=pe([Y(1,_.IFileService),Y(2,o.IExtensionsScannerService),Y(3,A.ILogService)],J);class j extends a.AbstractExtensionTask{get operation(){return(0,b.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(B,G,O,M,x){super(),this.identifier=B,this.source=G,this.options=O,this.extensionsScanner=M,this.logService=x,this._operation=2}async installExtension(B,G){try{const O=await this.unsetUninstalledAndGetLocal(B.key);if(O)return this.extensionsScanner.updateMetadata(O,B.metadata)}catch{throw w.isMacintosh?new d.ExtensionManagementError(C.localize(4,null),d.ExtensionManagementErrorCode.Internal):new d.ExtensionManagementError(C.localize(5,null),d.ExtensionManagementErrorCode.Internal)}return this.extract(B,G)}async unsetUninstalledAndGetLocal(B){if(!await this.isUninstalled(B))return null;this.logService.trace("Removing the extension from uninstalled list:",B.id);const O=await this.extensionsScanner.setInstalled(B);return this.logService.info("Removed the extension from uninstalled list:",B.id),O}async isUninstalled(B){return!!(await this.extensionsScanner.getUninstalledExtensions())[B.toString()]}async extract({zipPath:B,key:G,metadata:O},M){const x=await this.extensionsScanner.extractUserExtension(G,B,O,M);return this.logService.info("Extracting completed.",G.id),x}}class H extends j{constructor(B,G,O,M,x,V){super(G.identifier,G,O,x,V),this.manifest=B,this.gallery=G,this.extensionsDownloader=M}async doRun(B){const O=(await this.extensionsScanner.scanExtensions(null,void 0)).find(V=>(0,c.areSameExtensions)(V.identifier,this.gallery.identifier));O&&(this._operation=3);const M={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,m.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||O?.isMachineScoped,isBuiltin:this.options.isBuiltin||O?.isBuiltin,isSystem:O?.type===0?!0:void 0,updated:!!O,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.gallery.properties.isPreReleaseVersion||((0,b.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:O?.preRelease)};if(O?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(O,M),metadata:M};const x=await this.downloadExtension(this.gallery,this._operation);try{const V=await this.installExtension({zipPath:x,key:c.ExtensionKey.create(this.gallery),metadata:M},B);return O&&!this.options.profileLocation&&(O.targetPlatform!==V.targetPlatform||I.neq(O.manifest.version,V.manifest.version))&&await this.extensionsScanner.setUninstalled(O),{local:V,metadata:M}}catch(V){throw await this.deleteDownloadedVSIX(x),V}}async deleteDownloadedVSIX(B){try{await this.extensionsDownloader.delete(p.URI.file(B))}catch(G){this.logService.warn("Error while deleting the downloaded vsix",B.toString(),(0,R.getErrorMessage)(G))}}async downloadExtension(B,G){let O;try{this.logService.trace("Started downloading extension:",B.identifier.id),O=(await this.extensionsDownloader.downloadExtension(B,G)).fsPath,this.logService.info("Downloaded extension:",B.identifier.id,O)}catch(M){throw new d.ExtensionManagementError((0,a.joinErrors)(M).message,d.ExtensionManagementErrorCode.Download)}try{return await(0,s.getManifest)(O),O}catch(M){throw await this.deleteDownloadedVSIX(O),new d.ExtensionManagementError((0,a.joinErrors)(M).message,d.ExtensionManagementErrorCode.Invalid)}}}class W extends j{constructor(B,G,O,M,x,V){super({id:(0,c.getGalleryExtensionId)(B.publisher,B.name)},G,O,x,V),this.manifest=B,this.location=G,this.galleryService=M}async doRun(B){const G=new c.ExtensionKey(this.identifier,this.manifest.version),M=(await this.extensionsScanner.scanExtensions(1,void 0)).find(ee=>(0,c.areSameExtensions)(this.identifier,ee.identifier)),x=await this.getMetadata(this.identifier.id,this.manifest.version,B);if(x.isApplicationScoped=(0,m.isApplicationScopedExtension)(this.manifest),x.isMachineScoped=this.options.isMachineScoped||M?.isMachineScoped,x.isBuiltin=this.options.isBuiltin||M?.isBuiltin,x.installedTimestamp=Date.now(),M)if(this._operation=3,G.equals(new c.ExtensionKey(M.identifier,M.manifest.version)))try{await this.extensionsScanner.removeExtension(M,"existing")}catch{throw new Error(C.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&I.gt(M.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(M);else{const ee=await this.unsetUninstalledAndGetLocal(G);if(ee)try{await this.extensionsScanner.removeExtension(ee,"existing")}catch{throw new Error(C.localize(7,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:P.resolve(this.location.fsPath),key:G,metadata:x},B),metadata:x}}async getMetadata(B,G,O){try{let[M]=await this.galleryService.getExtensions([{id:B,version:G}],O);if(M||([M]=await this.galleryService.getExtensions([{id:B}],O)),M)return{id:M.identifier.uuid,publisherDisplayName:M.publisherDisplayName,publisherId:M.publisherId,isPreReleaseVersion:M.properties.isPreReleaseVersion,preRelease:M.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class z{constructor(B,G,O){this.task=B,this.profileLocation=G,this.extensionsProfileScannerService=O,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const B=await this.task.waitUntilTaskIsFinished();return await this.extensionsProfileScannerService.addExtensionsToProfile([[B.local,B.metadata]],this.profileLocation),B}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class K extends a.AbstractExtensionTask{constructor(B,G,O){super(),this.extension=B,this.options=G,this.extensionsScanner=O}async doRun(B){const G=[],O=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const M=c.ExtensionKey.create(this.extension);G.push(...O.filter(x=>M.equals(c.ExtensionKey.create(x))))}else G.push(...O.filter(M=>(0,c.areSameExtensions)(M.identifier,this.extension.identifier)));if(!G.length)throw new Error(C.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...G),this.options.remove)for(const M of G)try{B.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(M)}catch(x){throw new Error(C.localize(9,null,(0,r.toErrorMessage)(x)))}}}class X extends a.AbstractExtensionTask{constructor(B,G,O){super(),this.extension=B,this.profileLocation=G,this.extensionsProfileScannerService=O}async doRun(B){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.profileLocation)}}}),define(ne[273],re([0,1,2,29,33,49,77,203,114,44,5,8,21,31,20]),function(Q,e,D,r,R,L,T,P,w,E,I,b,p,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;const S={versionOnly:!0,donotIncludePack:!0,donotCheckDependents:!0};let C=class extends D.Disposable{constructor(a,d,c,i,o,t,n,s){super(),this.userDataProfilesService=d,a.removeUninstalledExtensions(this.userDataProfilesService.profiles.length===1),(0,P.migrateUnsupportedExtensions)(a,c,i,o,s),T.ExtensionStorageService.removeOutdatedExtensionVersions(a,n),this._register(t.createInstance(g))}};C=pe([Y(0,w.INativeServerExtensionManagementService),Y(1,h.IUserDataProfilesService),Y(2,r.IExtensionGalleryService),Y(3,T.IExtensionStorageService),Y(4,r.IGlobalExtensionEnablementService),Y(5,I.IInstantiationService),Y(6,p.IStorageService),Y(7,b.ILogService)],C),e.ExtensionsCleaner=C;let g=class extends D.Disposable{constructor(a,d,c,i,o){super(),this.extensionManagementService=a,this.userDataProfilesService=d,this.extensionsProfileScannerService=c,this.uriIdentityService=i,this.logService=o,this.profileExtensionsLocations=new Map,this.profileModeDisposables=this._register(new D.MutableDisposable),this.onDidChangeProfiles({added:this.userDataProfilesService.profiles,removed:[],all:this.userDataProfilesService.profiles})}async onDidChangeProfiles({added:a,removed:d,all:c}){try{await Promise.all(d.map(i=>i.extensionsResource?this.removeExtensionsFromProfile(i.extensionsResource):Promise.resolve()))}catch(i){this.logService.error(i)}if(c.length===1){this.profileModeDisposables.clear();const i=this._register(this.userDataProfilesService.onDidChangeProfiles(()=>{i.dispose(),this.onDidChangeProfiles({added:this.userDataProfilesService.profiles,removed:[],all:this.userDataProfilesService.profiles})}));return}try{a.length&&(await Promise.all(a.map(i=>i.extensionsResource?this.populateExtensionsFromProfile(i.extensionsResource):Promise.resolve())),this.profileModeDisposables.value||(this.profileModeDisposables.value=new D.DisposableStore,this.profileModeDisposables.value.add((0,D.toDisposable)(()=>this.profileExtensionsLocations.clear())),this.profileModeDisposables.value.add(this.userDataProfilesService.onDidChangeProfiles(i=>this.onDidChangeProfiles(i))),this.profileModeDisposables.value.add(this.extensionManagementService.onDidInstallExtensions(i=>this.onDidInstallExtensions(i))),this.profileModeDisposables.value.add(this.extensionManagementService.onDidUninstallExtension(i=>this.onDidUninstallExtension(i))),await this.uninstallExtensionsNotInProfiles()))}catch(i){this.logService.error(i)}}async uninstallExtensionsNotInProfiles(){const d=(await this.extensionManagementService.getAllUserInstalled()).filter(c=>c.installedTimestamp&&!this.profileExtensionsLocations.has(this.getKey(c.identifier,c.manifest.version)));d.length&&await Promise.all(d.map(c=>this.extensionManagementService.uninstall(c,S)))}async onDidInstallExtensions(a){for(const{local:d,profileLocation:c}of a)!d||!c||this.addExtensionWithKey(this.getKey(d.identifier,d.manifest.version),c)}async onDidUninstallExtension(a){!a.profileLocation||!a.version||this.removeExtensionWithKey(this.getKey(a.identifier,a.version),a.profileLocation)&&await this.uninstallExtensions([{identifier:a.identifier,version:a.version}])}async populateExtensionsFromProfile(a){const d=await this.extensionsProfileScannerService.scanProfileExtensions(a);for(const c of d)this.addExtensionWithKey(this.getKey(c.identifier,c.version),a)}async removeExtensionsFromProfile(a){const d=[];for(const c of[...this.profileExtensionsLocations.keys()]){if(!this.removeExtensionWithKey(c,a))continue;const i=this.fromKey(c);i&&d.push(i)}d.length&&await this.uninstallExtensions(d)}addExtensionWithKey(a,d){let c=this.profileExtensionsLocations.get(a);c||(c=[],this.profileExtensionsLocations.set(a,c)),c.push(d)}removeExtensionWithKey(a,d){const c=this.profileExtensionsLocations.get(a);if(c){const i=c.findIndex(o=>this.uriIdentityService.extUri.isEqual(o,d));i>-1&&c.splice(i,1)}return c?.length?!1:(this.profileExtensionsLocations.delete(a),!0)}async uninstallExtensions(a){const c=(await this.extensionManagementService.getAllUserInstalled()).filter(i=>i.installedTimestamp&&a.some(o=>this.getKey(i.identifier,i.manifest.version)===this.getKey(o.identifier,o.version)));c.length&&await Promise.all(c.map(i=>this.extensionManagementService.uninstall(i,S)))}getKey(a,d){return`${E.ExtensionIdentifier.toKey(a.id)}@${d}`}fromKey(a){const[d,c]=(0,R.getIdAndVersion)(a);return c?{identifier:{id:d},version:c}:void 0}};g=pe([Y(0,w.INativeServerExtensionManagementService),Y(1,h.IUserDataProfilesService),Y(2,L.IExtensionsProfileScannerService),Y(3,v.IUriIdentityService),Y(4,b.ILogService)],g)}),define(ne[282],re([0,1,90,36,38,9,2,23,19,7,39,138,196,273,197,189,190,271,178,181,17,201,93,220,94,211,14,217,112,251,29,180,252,114,95,176,13,192,194,56,5,187,70,188,58,71,206,8,98,59,99,25,45,21,253,104,24,105,106,107,50,224,108,226,232,77,110,26,75,260,244,245,78,261,265,266,267,268,269,62,246,103,219,74,234,208,233,102,216,31,236,4,237,182,199,198,76,250,20,49,195,60,254,214,223,247]),function(Q,e,D,r,R,L,T,P,w,E,I,b,p,v,h,S,C,g,f,a,d,c,i,o,t,n,s,u,l,m,y,_,$,A,U,k,N,F,q,J,j,H,W,z,K,X,ce,B,G,O,M,x,V,ee,oe,Z,ie,se,ue,de,ve,we,Ee,Ce,Ue,$e,He,We,ae,fe,ge,be,Ie,Le,Re,Ne,Ae,Me,ze,ke,_e,te,le,he,me,Se,Pe,De,Be,Fe,Te,qe,xe,Ze,rt,St,Rt,kt,yt,wt,Lt,Et,Tt,At,_t,Ot){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Ut extends T.Disposable{constructor(ye){super(),this.configuration=ye,this.server=this._register(new b.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const ye=()=>this.dispose();process.once("exit",ye),D.ipcRenderer.once("vscode:electron-main->shared-process=exit",ye);const Oe="vscode:electron-main->shared-process=disposeWorker",je=(Ge,et)=>{this.onDisposeWorker(et)};D.ipcRenderer.on(Oe,je),this._register((0,T.toDisposable)(()=>D.ipcRenderer.removeListener(Oe,je)))}onDisposeWorker(ye){this.sharedProcessWorkerService?.disposeWorker(ye)}async open(){const ye=await this.initServices();(0,We.registerConfiguration)(),ye.invokeFunction(Oe=>{const je=Oe.get(B.ILogService);je.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Oe),this.registerErrorHandler(je)}),this._register((0,T.combinedDisposable)(ye.createInstance(p.CodeCacheCleaner,this.configuration.codeCachePath),ye.createInstance(h.LanguagePackCachedDataCleaner),ye.createInstance(g.UnusedWorkspaceStorageDataCleaner),ye.createInstance(C.LogsDataCleaner),ye.createInstance(S.LocalizationsUpdater),ye.createInstance(v.ExtensionsCleaner),ye.createInstance(Ot.UserDataProfilesCleaner)))}async initServices(){const ye=new W.ServiceCollection,Oe={_serviceBrand:void 0,...M.default};ye.set(x.IProductService,Oe);const je=new I.StaticRouter(Je=>Je==="main"),Ge=new z.MessagePortMainProcessService(this.server,je);ye.set(K.IMainProcessService,Ge);const et=this.configuration.policiesData?new Lt.PolicyChannelClient(this.configuration.policiesData,Ge.getChannel("policy")):new Et.NullPolicyService;ye.set(Et.IPolicyService,et);const Ve=new u.SharedProcessEnvironmentService(this.configuration.args,Oe);ye.set(s.INativeEnvironmentService,Ve);const at=new G.LogLevelChannelClient(this.server.getChannel("logLevel",je)),tt=new G.LoggerChannelClient(this.configuration.logLevel,at.onDidChangeLogLevel,Ge.getChannel("logger"));ye.set(B.ILoggerService,tt);const ut=this._register(new B.MultiplexLogService([this._register(new B.ConsoleLogger(this.configuration.logLevel)),this._register(tt.createLogger((0,w.joinPath)(E.URI.file(Ve.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ke=this._register(new G.FollowerLogService(at,ut));ye.set(B.ILogService,Ke),this.sharedProcessWorkerService=new Be.SharedProcessWorkerService(Ke),ye.set(De.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Qe=this._register(new F.FileService(Ke));ye.set(N.IFileService,Qe);const ht=this._register(new q.DiskFileSystemProvider(Ke));Qe.registerProvider(P.Schemas.file,ht);const dt=this._register(new xe.FileUserDataProvider(P.Schemas.file,this._register(new Ze.DiskFileSystemProviderClient(Ge.getChannel(Ze.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:qe.isLinux})),P.Schemas.vscodeUserData,Ke));Qe.registerProvider(P.Schemas.vscodeUserData,dt);const it=this._register(new Tt.UserDataProfilesNativeService(this.configuration.profiles,Ge,Ve));ye.set(yt.IUserDataProfilesService,it);const Ye=this._register(new c.ConfigurationService(it.defaultProfile.settingsResource,Qe,et,Ke));ye.set(d.IConfigurationService,Ye);const st=new oe.NativeStorageService(void 0,{defaultProfile:it.defaultProfile,currentProfile:it.defaultProfile},Ge,Ve);ye.set(ee.IStorageService,st),this._register((0,T.toDisposable)(()=>st.flush())),await Promise.all([Ye.initialize(),st.initialize()]),ye.set(Fe.IUriIdentityService,new Te.UriIdentityService(Qe)),ye.set(V.IRequestService,new At.SharedProcessRequestService(Ge,Ye,Ke)),ye.set(f.IChecksumService,new J.SyncDescriptor(a.ChecksumService,void 0,!1)),ye.set(St.IV8InspectProfilingService,new J.SyncDescriptor(rt.InspectProfilingService,void 0,!1));const ct=I.ProxyChannel.toService(Ge.getChannel("nativeHost"),{context:this.configuration.windowId});ye.set(O.INativeHostService,ct),ye.set(t.IDownloadService,new J.SyncDescriptor(n.DownloadService,void 0,!0));const ft=this._register(new _e.ActiveWindowManager(ct)),Nt=new I.StaticRouter(Je=>ft.getActiveClientId().then(gt=>Je===gt));ye.set(U.IExtensionRecommendationNotificationService,new k.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",Nt)));let lt;const ot=[],Ct=(0,ve.isInternalTelemetry)(Oe,Ye);if((0,ve.supportsTelemetry)(Oe,Ve)){const Je=new ue.TelemetryLogAppender(tt,Ve);ot.push(Je);const{installSourcePath:gt}=Ve;if(Oe.aiConfig?.ariaKey){const It=new _t.OneDataSystemAppender(Ct,"monacoworkbench",null,Oe.aiConfig.ariaKey);this._register((0,T.toDisposable)(()=>It.flush())),ot.push(It)}lt=new de.TelemetryService({appenders:ot,commonProperties:(0,Z.resolveCommonProperties)(Qe,(0,r.release)(),(0,r.hostname)(),process.arch,Oe.commit,Oe.version,this.configuration.machineId,Ct,gt),sendErrorTelemetry:!0,piiPaths:(0,ve.getPiiPathsFromEnvironment)(Ve)},Ye,Oe)}else{lt=ve.NullTelemetryService;const Je=ve.NullAppender;ot.push(Je)}this.server.registerChannel("telemetryAppender",new se.TelemetryAppenderChannel(ot)),ye.set(ie.ITelemetryService,lt);const Ft=new we.CustomEndpointTelemetryService(Ye,lt,tt,Ve,Oe);ye.set(ie.ICustomEndpointTelemetryService,Ft),ye.set(wt.IExtensionsProfileScannerService,new J.SyncDescriptor(wt.ExtensionsProfileScannerService,void 0,!0)),ye.set(Rt.IExtensionsScannerService,new J.SyncDescriptor(kt.ExtensionsScannerService,void 0,!0)),ye.set(A.INativeServerExtensionManagementService,new J.SyncDescriptor(A.ExtensionManagementService,void 0,!0)),ye.set(y.IExtensionGalleryService,new J.SyncDescriptor(m.ExtensionGalleryService,void 0,!0)),ye.set(y.IExtensionTipsService,new J.SyncDescriptor($.ExtensionTipsService,void 0,!1)),ye.set(X.ILanguagePackService,new J.SyncDescriptor(ce.NativeLanguagePackService,void 0,!1)),ye.set(i.IDiagnosticsService,new J.SyncDescriptor(o.DiagnosticsService,void 0,!1)),ye.set(ae.IUserDataSyncAccountService,new J.SyncDescriptor(ae.UserDataSyncAccountService,void 0,!0)),ye.set(We.IUserDataSyncLogService,new J.SyncDescriptor(be.UserDataSyncLogService,void 0,!0)),ye.set(We.IUserDataSyncUtilService,new ge.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Je=>Je.ctx!=="main"))),ye.set(y.IGlobalExtensionEnablementService,new J.SyncDescriptor(l.GlobalExtensionEnablementService,void 0,!1)),ye.set(He.IIgnoredExtensionsManagementService,new J.SyncDescriptor(He.IgnoredExtensionsManagementService,void 0,!0)),ye.set($e.IExtensionStorageService,new J.SyncDescriptor($e.ExtensionStorageService)),ye.set(We.IUserDataSyncStoreManagementService,new J.SyncDescriptor(Ae.UserDataSyncStoreManagementService,void 0,!0)),ye.set(We.IUserDataSyncStoreService,new J.SyncDescriptor(Ae.UserDataSyncStoreService,void 0,!0)),ye.set(Ie.IUserDataSyncMachinesService,new J.SyncDescriptor(Ie.UserDataSyncMachinesService,void 0,!0)),ye.set(We.IUserDataSyncBackupStoreService,new J.SyncDescriptor(fe.UserDataSyncBackupStoreService,void 0,!1)),ye.set(We.IUserDataSyncEnablementService,new J.SyncDescriptor(Le.UserDataSyncEnablementService,void 0,!0)),ye.set(We.IUserDataSyncService,new J.SyncDescriptor(Re.UserDataSyncService,void 0,!1)),ye.set(ke.IUserDataSyncProfilesStorageService,new J.SyncDescriptor(ze.UserDataSyncProfilesStorageService,void 0,!0));const Pt=new Ue.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Ye.getValue("terminal.integrated.persistentSessionScrollback")??100},Ye,Ve,Ke);return Pt.initialize(),ye.set(Ce.ILocalPtyService,this._register(Pt)),ye.set(te.ISignService,new J.SyncDescriptor(le.SignService,void 0,!1)),ye.set(he.ISharedTunnelsService,new J.SyncDescriptor(me.SharedTunnelsService)),ye.set(Se.ISharedProcessTunnelService,new J.SyncDescriptor(Pe.SharedProcessTunnelService)),new H.InstantiationService(ye)}initChannels(ye){const Oe=new _.ExtensionManagementChannel(ye.get(y.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Oe);const je=I.ProxyChannel.fromService(ye.get(X.ILanguagePackService));this.server.registerChannel("languagePacks",je);const Ge=I.ProxyChannel.fromService(ye.get(i.IDiagnosticsService));this.server.registerChannel("diagnostics",Ge);const et=new _.ExtensionTipsChannel(ye.get(y.IExtensionTipsService));this.server.registerChannel("extensionTipsService",et);const Ve=I.ProxyChannel.fromService(ye.get(f.IChecksumService));this.server.registerChannel("checksum",Ve);const at=I.ProxyChannel.fromService(ye.get(St.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",at);const tt=new ge.UserDataSyncMachinesServiceChannel(ye.get(Ie.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",tt);const ut=I.ProxyChannel.fromService(ye.get(ie.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",ut);const Ke=new ge.UserDataSyncAccountServiceChannel(ye.get(ae.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ke);const Qe=new ge.UserDataSyncStoreManagementServiceChannel(ye.get(We.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Qe);const ht=new Ne.UserDataSyncChannel(ye.get(We.IUserDataSyncService),ye.get(yt.IUserDataProfilesService),ye.get(B.ILogService));this.server.registerChannel("userDataSync",ht);const dt=this._register(ye.get(j.IInstantiationService).createInstance(Me.UserDataAutoSyncService)),it=new ge.UserDataAutoSyncChannel(dt);this.server.registerChannel("userDataAutoSync",it);const Ye=ye.get(Ce.ILocalPtyService),st=I.ProxyChannel.fromService(Ye);this.server.registerChannel(Ee.TerminalIpcChannels.LocalPty,st);const ct=I.ProxyChannel.fromService(ye.get(Se.ISharedProcessTunnelService));this.server.registerChannel(Se.ipcSharedProcessTunnelChannelName,ct);const ft=I.ProxyChannel.fromService(ye.get(De.ISharedProcessWorkerService));this.server.registerChannel(De.ipcSharedProcessWorkerChannelName,ft)}registerErrorHandler(ye){window.addEventListener("unhandledrejection",Oe=>{(0,L.onUnexpectedError)(Oe.reason),Oe.preventDefault()}),(0,L.setUnexpectedErrorHandler)(Oe=>{const je=(0,R.toErrorMessage)(Oe,!0);!je||ye.error(`[uncaught exception in sharedProcess]: ${je}`)})}}async function Mt(bt){const ye=new Ut(bt);D.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ye.open(),D.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Mt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/fad3a77833b9249158dfd88477114a06435e46a2/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
