/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/errors","vs/base/common/platform","vs/base/common/network","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/arrays","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/buffer","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/node/pfs","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/uuid","vs/editor/common/core/range","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","vs/base/common/severity","vs/platform/registry/common/platform","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/editor/common/core/position","vs/base/common/errorMessage","vs/base/common/stopwatch","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","fs","vs/editor/common/languages","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/hash","vs/base/common/normalization","vs/base/common/marshalling","os","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configuration","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/common/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/mime","vs/base/common/processes","vs/base/common/filters","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/tunnel/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostTelemetryLogService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],Ie=function(J){for(var e=[],l=0,t=J.length;l<t;l++)e[l]=De[J[l]];return e};define(De[74],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function l(_){return _?_.replace(/\$\((.*?)\)/g,(I,w)=>` ${w} `).trim():""}e.getCodiconAriaLabel=l;class t{constructor(I,w,k){this.id=I,this.definition=w,this.description=k,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function C(_,I){const w=["codicon","codicon-"+_];return I&&w.push("codicon-modifier-"+I),w}e.getClassNamesArray=C;var P;(function(_){_.iconNameSegment="[A-Za-z0-9]+",_.iconNameExpression="[A-Za-z0-9-]+",_.iconModifierExpression="~[A-Za-z]+",_.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${_.iconNameExpression})(${_.iconModifierExpression})?$`);function w(D){if(D instanceof t)return["codicon","codicon-"+D.id];const S=I.exec(D.id);if(!S)return w(t.error);const[,T,E]=S,p=["codicon","codicon-"+T];return E&&p.push("codicon-modifier-"+E.substr(1)),p}_.asClassNameArray=w;function k(D){return w(D).join(" ")}_.asClassName=k;function L(D){return"."+w(D).join(".")}_.asCSSSelector=L})(P=e.CSSIcon||(e.CSSIcon={}))}),define(De[75],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function l(_,I){const w=Object.create(null);for(const k of _){const L=I(k);let D=w[L];D||(D=w[L]=[]),D.push(k)}return w}e.groupBy=l;function t(_,I){const w=[],k=[];for(const L of _)I.has(L)||w.push(L);for(const L of I)_.has(L)||k.push(L);return{removed:w,added:k}}e.diffSets=t;function C(_,I){const w=[],k=[];for(const[L,D]of _)I.has(L)||w.push(D);for(const[L,D]of I)_.has(L)||k.push(D);return{removed:w,added:k}}e.diffMaps=C;class P{constructor(){this.map=new Map}add(I,w){let k=this.map.get(I);k||(k=new Set,this.map.set(I,k)),k.add(w)}delete(I,w){const k=this.map.get(I);!k||(k.delete(w),k.size===0&&this.map.delete(I))}forEach(I,w){const k=this.map.get(I);!k||k.forEach(w)}}e.SetMap=P}),define(De[59],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function l(_){return(I,w,k)=>{let L=null,D=null;if(typeof k.value=="function"?(L="value",D=k.value):typeof k.get=="function"&&(L="get",D=k.get),!D)throw new Error("not supported");k[L]=_(D,w)}}e.createDecorator=l;function t(_,I,w){let k=null,L=null;if(typeof w.value=="function"?(k="value",L=w.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(k="get",L=w.get),!L)throw new Error("not supported");const D=`$memoize$${I}`;w[k]=function(...S){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,S)}),this[D]}}e.memoize=t;function C(_,I,w){return l((k,L)=>{const D=`$debounce$${L}`,S=`$debounce$result$${L}`;return function(...T){this[S]||(this[S]=w?w():void 0),clearTimeout(this[D]),I&&(this[S]=I(this[S],...T),T=[this[S]]),this[D]=setTimeout(()=>{k.apply(this,T),this[S]=w?w():void 0},_)}})}e.debounce=C;function P(_,I,w){return l((k,L)=>{const D=`$throttle$timer$${L}`,S=`$throttle$result$${L}`,T=`$throttle$lastRun$${L}`,E=`$throttle$pending$${L}`;return function(...p){if(this[S]||(this[S]=w?w():void 0),(this[T]===null||this[T]===void 0)&&(this[T]=-Number.MAX_VALUE),I&&(this[S]=I(this[S],...p)),this[E])return;const b=this[T]+_;b<=Date.now()?(this[T]=Date.now(),k.apply(this,[this[S]]),this[S]=w?w():void 0):(this[E]=!0,this[D]=setTimeout(()=>{this[E]=!1,this[T]=Date.now(),k.apply(this,[this[S]]),this[S]=w?w():void 0},b-Date.now()))}})}e.throttle=P}),define(De[10],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class l{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?h.isErrorNoTelemetry(n)?new h(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(u=>{u(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=l,e.errorHandler=new l;function t(g){e.errorHandler.setUnexpectedErrorHandler(g)}e.setUnexpectedErrorHandler=t;function C(g){w(g)||e.errorHandler.onUnexpectedError(g)}e.onUnexpectedError=C;function P(g){w(g)||e.errorHandler.onUnexpectedExternalError(g)}e.onUnexpectedExternalError=P;function _(g){if(g instanceof Error){const{name:n,message:u}=g,s=g.stacktrace||g.stack;return{$isError:!0,name:n,message:u,stack:s,noTelemetry:h.isErrorNoTelemetry(g)}}return g}e.transformErrorForSerialization=_;const I="Canceled";function w(g){return g instanceof k?!0:g instanceof Error&&g.name===I&&g.message===I}e.isCancellationError=w;class k extends Error{constructor(){super(I),this.name=this.message}}e.CancellationError=k;function L(){const g=new Error(I);return g.name=g.message,g}e.canceled=L;function D(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}e.illegalArgument=D;function S(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}e.illegalState=S;function T(g){return g?new Error(`readonly property '${g} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=T;function E(g){const n=new Error(`${g} has been disposed`);return n.name="DISPOSED",n}e.disposed=E;function p(g){return g?g.message?g.message:g.stack?g.stack.split(`
`)[0]:String(g):"Error"}e.getErrorMessage=p;class b extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.NotImplementedError=b;class m extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.NotSupportedError=m;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=v;class h extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof h)return n;const u=new h;return u.message=n.message,u.stack=n.stack,u}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.ErrorNoTelemetry=h;class c extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,c.prototype);debugger}}e.BugIndicatingError=c}),define(De[17],Ie([1,0,10]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(oe,le=0){return oe[oe.length-(1+le)]}e.tail=t;function C(oe){if(oe.length===0)throw new Error("Invalid tail call");return[oe.slice(0,oe.length-1),oe[oe.length-1]]}e.tail2=C;function P(oe,le,me=(Z,ae)=>Z===ae){if(oe===le)return!0;if(!oe||!le||oe.length!==le.length)return!1;for(let Z=0,ae=oe.length;Z<ae;Z++)if(!me(oe[Z],le[Z]))return!1;return!0}e.equals=P;function _(oe,le){const me=oe.length-1;le<me&&(oe[le]=oe[me]),oe.pop()}e.removeFastWithoutKeepingOrder=_;function I(oe,le,me){return w(oe.length,Z=>me(oe[Z],le))}e.binarySearch=I;function w(oe,le){let me=0,Z=oe-1;for(;me<=Z;){const ae=(me+Z)/2|0,ne=le(ae);if(ne<0)me=ae+1;else if(ne>0)Z=ae-1;else return ae}return-(me+1)}e.binarySearch2=w;function k(oe,le){let me=0,Z=oe.length;if(Z===0)return 0;for(;me<Z;){const ae=Math.floor((me+Z)/2);le(oe[ae])?Z=ae:me=ae+1}return me}e.findFirstInSorted=k;function L(oe,le,me){if(oe=oe|0,oe>=le.length)throw new TypeError("invalid index");const Z=le[Math.floor(le.length*Math.random())],ae=[],ne=[],ie=[];for(const O of le){const V=me(O,Z);V<0?ae.push(O):V>0?ne.push(O):ie.push(O)}return oe<ae.length?L(oe,ae,me):oe<ae.length+ie.length?ie[0]:L(oe-(ae.length+ie.length),ne,me)}e.quickSelect=L;function D(oe,le){const me=[];let Z;for(const ae of oe.slice(0).sort(le))!Z||le(Z[0],ae)!==0?(Z=[ae],me.push(Z)):Z.push(ae);return me}e.groupBy=D;function S(oe,le,me){const Z=[];function ae(O,V,q){if(V===0&&q.length===0)return;const X=Z[Z.length-1];X&&X.start+X.deleteCount===O?(X.deleteCount+=V,X.toInsert.push(...q)):Z.push({start:O,deleteCount:V,toInsert:q})}let ne=0,ie=0;for(;;){if(ne===oe.length){ae(ne,0,le.slice(ie));break}if(ie===le.length){ae(ne,oe.length-ne,[]);break}const O=oe[ne],V=le[ie],q=me(O,V);q===0?(ne+=1,ie+=1):q<0?(ae(ne,1,[]),ne+=1):q>0&&(ae(ne,0,[V]),ie+=1)}return Z}e.sortedDiff=S;function T(oe,le,me){const Z=S(oe,le,me),ae=[],ne=[];for(const ie of Z)ae.push(...oe.slice(ie.start,ie.start+ie.deleteCount)),ne.push(...ie.toInsert);return{removed:ae,added:ne}}e.delta=T;function E(oe,le,me){if(me===0)return[];const Z=oe.slice(0,me).sort(le);return b(oe,le,Z,me,oe.length),Z}e.top=E;function p(oe,le,me,Z,ae){return me===0?Promise.resolve([]):new Promise((ne,ie)=>{(async()=>{const O=oe.length,V=oe.slice(0,me).sort(le);for(let q=me,X=Math.min(me+Z,O);q<O;q=X,X=Math.min(X+Z,O)){if(q>me&&await new Promise(ge=>setTimeout(ge)),ae&&ae.isCancellationRequested)throw new l.CancellationError;b(oe,le,V,q,X)}return V})().then(ne,ie)})}e.topAsync=p;function b(oe,le,me,Z,ae){for(const ne=me.length;Z<ae;Z++){const ie=oe[Z];if(le(ie,me[ne-1])<0){me.pop();const O=k(me,V=>le(ie,V)<0);me.splice(O,0,ie)}}}function m(oe){return oe.filter(le=>!!le)}e.coalesce=m;function v(oe){let le=0;for(let me=0;me<oe.length;me++)oe[me]&&(oe[le]=oe[me],le+=1);oe.length=le}e.coalesceInPlace=v;function h(oe,le,me){oe.splice(me,0,oe.splice(le,1)[0])}e.move=h;function c(oe){return!Array.isArray(oe)||oe.length===0}e.isFalsyOrEmpty=c;function g(oe){return Array.isArray(oe)&&oe.length>0}e.isNonEmptyArray=g;function n(oe,le=me=>me){const me=new Set;return oe.filter(Z=>{const ae=le(Z);return me.has(ae)?!1:(me.add(ae),!0)})}e.distinct=n;function u(oe){const le=new Set;return me=>{const Z=oe(me);return le.has(Z)?!1:(le.add(Z),!0)}}e.uniqueFilter=u;function s(oe,le){const me=i(oe,le);if(me!==-1)return oe[me]}e.findLast=s;function i(oe,le){for(let me=oe.length-1;me>=0;me--){const Z=oe[me];if(le(Z))return me}return-1}e.lastIndex=i;function o(oe,le){return oe.length>0?oe[0]:le}e.firstOrDefault=o;function d(oe,le){return oe.length>0?oe[oe.length-1]:le}e.lastOrDefault=d;function r(oe,le,me=(Z,ae)=>Z===ae){let Z=0;for(let ae=0,ne=Math.min(oe.length,le.length);ae<ne&&me(oe[ae],le[ae]);ae++)Z++;return Z}e.commonPrefixLength=r;function a(oe){return[].concat(...oe)}e.flatten=a;function f(oe,le){let me=typeof le=="number"?oe:0;typeof le=="number"?me=oe:(me=0,le=oe);const Z=[];if(me<=le)for(let ae=me;ae<le;ae++)Z.push(ae);else for(let ae=me;ae>le;ae--)Z.push(ae);return Z}e.range=f;function y(oe,le,me){return oe.reduce((Z,ae)=>(Z[le(ae)]=me?me(ae):ae,Z),Object.create(null))}e.index=y;function R(oe,le){return oe.push(le),()=>N(oe,le)}e.insert=R;function N(oe,le){const me=oe.indexOf(le);if(me>-1)return oe.splice(me,1),le}e.remove=N;function M(oe,le,me){const Z=oe.slice(0,le),ae=oe.slice(le);return Z.concat(me,ae)}e.arrayInsert=M;function A(oe,le){let me;if(typeof le=="number"){let Z=le;me=()=>{const ae=Math.sin(Z++)*179426549;return ae-Math.floor(ae)}}else me=Math.random;for(let Z=oe.length-1;Z>0;Z-=1){const ae=Math.floor(me()*(Z+1)),ne=oe[Z];oe[Z]=oe[ae],oe[ae]=ne}}e.shuffle=A;function z(oe,le){const me=oe.indexOf(le);me>-1&&(oe.splice(me,1),oe.unshift(le))}e.pushToStart=z;function H(oe,le){const me=oe.indexOf(le);me>-1&&(oe.splice(me,1),oe.push(le))}e.pushToEnd=H;function F(oe,le){for(const me of le)oe.push(me)}e.pushMany=F;function G(oe,le){return Array.isArray(oe)?oe.map(le):le(oe)}e.mapArrayOrNot=G;function B(oe){return Array.isArray(oe)?oe:[oe]}e.asArray=B;function U(oe){return oe[Math.floor(Math.random()*oe.length)]}e.getRandomElement=U;function x(oe,le){for(const me of oe){const Z=le(me);if(Z!==void 0)return Z}}e.mapFind=x;function $(oe,le,me){const Z=K(oe,le),ae=oe.length,ne=me.length;oe.length=ae+ne;for(let ie=ae-1;ie>=Z;ie--)oe[ie+ne]=oe[ie];for(let ie=0;ie<ne;ie++)oe[ie+Z]=me[ie]}e.insertInto=$;function Q(oe,le,me,Z){const ae=K(oe,le),ne=oe.splice(ae,me);return $(oe,ae,Z),ne}e.splice=Q;function K(oe,le){return le<0?Math.max(le+oe.length,0):Math.min(le,oe.length)}var de;(function(oe){function le(ae){return ae<0}oe.isLessThan=le;function me(ae){return ae>0}oe.isGreaterThan=me;function Z(ae){return ae===0}oe.isNeitherLessOrGreaterThan=Z,oe.greaterThan=1,oe.lessThan=-1,oe.neitherLessOrGreaterThan=0})(de=e.CompareResult||(e.CompareResult={}));function te(oe,le){return(me,Z)=>le(oe(me),oe(Z))}e.compareBy=te;function he(...oe){return(le,me)=>{for(const Z of oe){const ae=Z(le,me);if(!de.isNeitherLessOrGreaterThan(ae))return ae}return de.neitherLessOrGreaterThan}}e.tieBreakComparators=he;const Y=(oe,le)=>oe-le;e.numberComparator=Y;function ve(oe,le){if(oe.length===0)return;let me=oe[0];for(let Z=1;Z<oe.length;Z++){const ae=oe[Z];le(ae,me)>0&&(me=ae)}return me}e.findMaxBy=ve;function be(oe,le){if(oe.length===0)return;let me=oe[0];for(let Z=1;Z<oe.length;Z++){const ae=oe[Z];le(ae,me)>=0&&(me=ae)}return me}e.findLastMaxBy=be;function ke(oe,le){return ve(oe,(me,Z)=>-le(me,Z))}e.findMinBy=ke;class Re{constructor(le){this.items=le,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(le){let me=this.firstIdx;for(;me<this.items.length&&le(this.items[me]);)me++;const Z=me===this.firstIdx?null:this.items.slice(this.firstIdx,me);return this.firstIdx=me,Z}takeFromEndWhile(le){let me=this.lastIdx;for(;me>=0&&le(this.items[me]);)me--;const Z=me===this.lastIdx?null:this.items.slice(me+1,this.lastIdx+1);return this.lastIdx=me,Z}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const le=this.items[this.firstIdx];return this.firstIdx++,le}removeLast(){const le=this.items[this.lastIdx];return this.lastIdx--,le}takeCount(le){const me=this.items.slice(this.firstIdx,this.firstIdx+le);return this.firstIdx+=le,me}}e.ArrayQueue=Re;class ze{constructor(le){this.iterate=le}forEach(le){this.iterate(me=>(le(me),!0))}toArray(){const le=[];return this.iterate(me=>(le.push(me),!0)),le}filter(le){return new ze(me=>this.iterate(Z=>le(Z)?me(Z):!0))}map(le){return new ze(me=>this.iterate(Z=>me(le(Z))))}some(le){let me=!1;return this.iterate(Z=>(me=le(Z),!me)),me}findFirst(le){let me;return this.iterate(Z=>le(Z)?(me=Z,!1):!0),me}findLast(le){let me;return this.iterate(Z=>(le(Z)&&(me=Z),!0)),me}findLastMaxBy(le){let me,Z=!0;return this.iterate(ae=>((Z||de.isGreaterThan(le(ae,me)))&&(Z=!1,me=ae),!0)),me}}e.CallbackIterable=ze,ze.empty=new ze(oe=>{})}),define(De[48],Ie([1,0,10]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(w,k){if(!w)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=t;function C(w,k="Unreachable"){throw new Error(k)}e.assertNever=C;function P(w){if(!w)throw new l.BugIndicatingError("Assertion Failed")}e.assert=P;function _(w){if(!w()){debugger;w(),(0,l.onUnexpectedError)(new l.BugIndicatingError("Assertion Failed"))}}e.assertFn=_;function I(w,k){let L=0;for(;L<w.length-1;){const D=w[L],S=w[L+1];if(!k(D,S))return!1;L++}return!0}e.checkAdjacentItems=I}),define(De[60],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function l(t){const C=this;let P=!1,_;return function(){return P||(P=!0,_=t.apply(C,arguments)),_}}e.once=l}),define(De[94],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class l{constructor(C){this._prefix=C,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=l,e.defaultGenerator=new l("id#")}),define(De[61],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var l;(function(t){function C(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}t.is=C;const P=Object.freeze([]);function _(){return P}t.empty=_;function*I(u){yield u}t.single=I;function w(u){return u||P}t.from=w;function k(u){return!u||u[Symbol.iterator]().next().done===!0}t.isEmpty=k;function L(u){return u[Symbol.iterator]().next().value}t.first=L;function D(u,s){for(const i of u)if(s(i))return!0;return!1}t.some=D;function S(u,s){for(const i of u)if(s(i))return i}t.find=S;function*T(u,s){for(const i of u)s(i)&&(yield i)}t.filter=T;function*E(u,s){let i=0;for(const o of u)yield s(o,i++)}t.map=E;function*p(...u){for(const s of u)for(const i of s)yield i}t.concat=p;function*b(u){for(const s of u)for(const i of s)yield i}t.concatNested=b;function m(u,s,i){let o=i;for(const d of u)o=s(o,d);return o}t.reduce=m;function v(u,s){let i=0;for(const o of u)s(o,i++)}t.forEach=v;function*h(u,s,i=u.length){for(s<0&&(s+=u.length),i<0?i+=u.length:i>u.length&&(i=u.length);s<i;s++)yield u[s]}t.slice=h;function c(u,s=Number.POSITIVE_INFINITY){const i=[];if(s===0)return[i,u];const o=u[Symbol.iterator]();for(let d=0;d<s;d++){const r=o.next();if(r.done)return[i,t.empty()];i.push(r.value)}return[i,{[Symbol.iterator](){return o}}]}t.consume=c;function g(u){return c(u)[0]}t.collect=g;function n(u,s,i=(o,d)=>o===d){const o=u[Symbol.iterator](),d=s[Symbol.iterator]();for(;;){const r=o.next(),a=d.next();if(r.done!==a.done)return!1;if(r.done)return!0;if(!i(r.value,a.value))return!1}}t.equals=n})(l=e.Iterable||(e.Iterable={}))}),define(De[144],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var l;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(l=e.ScanError||(e.ScanError={}));var t;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var C;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(C=e.ParseErrorCode||(e.ParseErrorCode={}));var P;(function(n){n.DEFAULT={allowTrailingComma:!0}})(P=e.ParseOptions||(e.ParseOptions={}));function _(n,u=!1){let s=0;const i=n.length;let o="",d=0,r=16,a=0;function f(H){let F=0,G=0;for(;F<H;){const B=n.charCodeAt(s);if(B>=48&&B<=57)G=G*16+B-48;else if(B>=65&&B<=70)G=G*16+B-65+10;else if(B>=97&&B<=102)G=G*16+B-97+10;else break;s++,F++}return F<H&&(G=-1),G}function y(H){s=H,o="",d=0,r=16,a=0}function R(){const H=s;if(n.charCodeAt(s)===48)s++;else for(s++;s<n.length&&k(n.charCodeAt(s));)s++;if(s<n.length&&n.charCodeAt(s)===46)if(s++,s<n.length&&k(n.charCodeAt(s)))for(s++;s<n.length&&k(n.charCodeAt(s));)s++;else return a=3,n.substring(H,s);let F=s;if(s<n.length&&(n.charCodeAt(s)===69||n.charCodeAt(s)===101))if(s++,(s<n.length&&n.charCodeAt(s)===43||n.charCodeAt(s)===45)&&s++,s<n.length&&k(n.charCodeAt(s))){for(s++;s<n.length&&k(n.charCodeAt(s));)s++;F=s}else a=3;return n.substring(H,F)}function N(){let H="",F=s;for(;;){if(s>=i){H+=n.substring(F,s),a=2;break}const G=n.charCodeAt(s);if(G===34){H+=n.substring(F,s),s++;break}if(G===92){if(H+=n.substring(F,s),s++,s>=i){a=2;break}switch(n.charCodeAt(s++)){case 34:H+='"';break;case 92:H+="\\";break;case 47:H+="/";break;case 98:H+="\b";break;case 102:H+="\f";break;case 110:H+=`
`;break;case 114:H+="\r";break;case 116:H+="	";break;case 117:{const U=f(4);U>=0?H+=String.fromCharCode(U):a=4;break}default:a=5}F=s;continue}if(G>=0&&G<=31)if(w(G)){H+=n.substring(F,s),a=2;break}else a=6;s++}return H}function M(){if(o="",a=0,d=s,s>=i)return d=i,r=17;let H=n.charCodeAt(s);if(I(H)){do s++,o+=String.fromCharCode(H),H=n.charCodeAt(s);while(I(H));return r=15}if(w(H))return s++,o+=String.fromCharCode(H),H===13&&n.charCodeAt(s)===10&&(s++,o+=`
`),r=14;switch(H){case 123:return s++,r=1;case 125:return s++,r=2;case 91:return s++,r=3;case 93:return s++,r=4;case 58:return s++,r=6;case 44:return s++,r=5;case 34:return s++,o=N(),r=10;case 47:{const F=s-1;if(n.charCodeAt(s+1)===47){for(s+=2;s<i&&!w(n.charCodeAt(s));)s++;return o=n.substring(F,s),r=12}if(n.charCodeAt(s+1)===42){s+=2;const G=i-1;let B=!1;for(;s<G;){if(n.charCodeAt(s)===42&&n.charCodeAt(s+1)===47){s+=2,B=!0;break}s++}return B||(s++,a=1),o=n.substring(F,s),r=13}return o+=String.fromCharCode(H),s++,r=16}case 45:if(o+=String.fromCharCode(H),s++,s===i||!k(n.charCodeAt(s)))return r=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=R(),r=11;default:for(;s<i&&A(H);)s++,H=n.charCodeAt(s);if(d!==s){switch(o=n.substring(d,s),o){case"true":return r=8;case"false":return r=9;case"null":return r=7}return r=16}return o+=String.fromCharCode(H),s++,r=16}}function A(H){if(I(H)||w(H))return!1;switch(H){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let H;do H=M();while(H>=12&&H<=15);return H}return{setPosition:y,getPosition:()=>s,scan:u?z:M,getToken:()=>r,getTokenValue:()=>o,getTokenOffset:()=>d,getTokenLength:()=>s-d,getTokenError:()=>a}}e.createScanner=_;function I(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function w(n){return n===10||n===13||n===8232||n===8233}function k(n){return n>=48&&n<=57}var L;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(L||(L={}));function D(n,u){const s=[],i=new Object;let o;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let r=!1;function a(f,y,R,N){d.value=f,d.offset=y,d.length=R,d.type=N,d.colonOffset=void 0,o=d}try{h(n,{onObjectBegin:(f,y)=>{if(u<=f)throw i;o=void 0,r=u>f,s.push("")},onObjectProperty:(f,y,R)=>{if(u<y||(a(f,y,R,"property"),s[s.length-1]=f,u<=y+R))throw i},onObjectEnd:(f,y)=>{if(u<=f)throw i;o=void 0,s.pop()},onArrayBegin:(f,y)=>{if(u<=f)throw i;o=void 0,s.push(0)},onArrayEnd:(f,y)=>{if(u<=f)throw i;o=void 0,s.pop()},onLiteralValue:(f,y,R)=>{if(u<y||(a(f,y,R,g(f)),u<=y+R))throw i},onSeparator:(f,y,R)=>{if(u<=y)throw i;if(f===":"&&o&&o.type==="property")o.colonOffset=y,r=!1,o=void 0;else if(f===","){const N=s[s.length-1];typeof N=="number"?s[s.length-1]=N+1:(r=!0,s[s.length-1]=""),o=void 0}}})}catch(f){if(f!==i)throw f}return{path:s,previousNode:o,isAtPropertyKey:r,matches:f=>{let y=0;for(let R=0;y<f.length&&R<s.length;R++)if(f[y]===s[R]||f[y]==="*")y++;else if(f[y]!=="**")return!1;return y===f.length}}}e.getLocation=D;function S(n,u=[],s=P.DEFAULT){let i=null,o=[];const d=[];function r(f){Array.isArray(o)?o.push(f):i!==null&&(o[i]=f)}return h(n,{onObjectBegin:()=>{const f={};r(f),d.push(o),o=f,i=null},onObjectProperty:f=>{i=f},onObjectEnd:()=>{o=d.pop()},onArrayBegin:()=>{const f=[];r(f),d.push(o),o=f,i=null},onArrayEnd:()=>{o=d.pop()},onLiteralValue:r,onError:(f,y,R)=>{u.push({error:f,offset:y,length:R})}},s),o[0]}e.parse=S;function T(n,u=[],s=P.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(f){i.type==="property"&&(i.length=f-i.offset,i=i.parent)}function d(f){return i.children.push(f),f}h(n,{onObjectBegin:f=>{i=d({type:"object",offset:f,length:-1,parent:i,children:[]})},onObjectProperty:(f,y,R)=>{i=d({type:"property",offset:y,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:f,offset:y,length:R,parent:i})},onObjectEnd:(f,y)=>{i.length=f+y-i.offset,i=i.parent,o(f+y)},onArrayBegin:(f,y)=>{i=d({type:"array",offset:f,length:-1,parent:i,children:[]})},onArrayEnd:(f,y)=>{i.length=f+y-i.offset,i=i.parent,o(f+y)},onLiteralValue:(f,y,R)=>{d({type:g(f),offset:y,length:R,parent:i,value:f}),o(y+R)},onSeparator:(f,y,R)=>{i.type==="property"&&(f===":"?i.colonOffset=y:f===","&&o(y))},onError:(f,y,R)=>{u.push({error:f,offset:y,length:R})}},s);const a=i.children[0];return a&&delete a.parent,a}e.parseTree=T;function E(n,u){if(!n)return;let s=n;for(const i of u)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let o=!1;for(const d of s.children)if(Array.isArray(d.children)&&d.children[0].value===i){s=d.children[1],o=!0;break}if(!o)return}else{const o=i;if(s.type!=="array"||o<0||!Array.isArray(s.children)||o>=s.children.length)return;s=s.children[o]}return s}e.findNodeAtLocation=E;function p(n){if(!n.parent||!n.parent.children)return[];const u=p(n.parent);if(n.parent.type==="property"){const s=n.parent.children[0].value;u.push(s)}else if(n.parent.type==="array"){const s=n.parent.children.indexOf(n);s!==-1&&u.push(s)}return u}e.getNodePath=p;function b(n){switch(n.type){case"array":return n.children.map(b);case"object":{const u=Object.create(null);for(const s of n.children){const i=s.children[1];i&&(u[s.children[0].value]=b(i))}return u}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=b;function m(n,u,s=!1){return u>=n.offset&&u<n.offset+n.length||s&&u===n.offset+n.length}e.contains=m;function v(n,u,s=!1){if(m(n,u,s)){const i=n.children;if(Array.isArray(i))for(let o=0;o<i.length&&i[o].offset<=u;o++){const d=v(i[o],u,s);if(d)return d}return n}}e.findNodeAtOffset=v;function h(n,u,s=P.DEFAULT){const i=_(n,!1);function o(te){return te?()=>te(i.getTokenOffset(),i.getTokenLength()):()=>!0}function d(te){return te?he=>te(he,i.getTokenOffset(),i.getTokenLength()):()=>!0}const r=o(u.onObjectBegin),a=d(u.onObjectProperty),f=o(u.onObjectEnd),y=o(u.onArrayBegin),R=o(u.onArrayEnd),N=d(u.onLiteralValue),M=d(u.onSeparator),A=o(u.onComment),z=d(u.onError),H=s&&s.disallowComments,F=s&&s.allowTrailingComma;function G(){for(;;){const te=i.scan();switch(i.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:H||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(te){case 12:case 13:H?B(10):A();break;case 16:B(1);break;case 15:case 14:break;default:return te}}}function B(te,he=[],Y=[]){if(z(te),he.length+Y.length>0){let ve=i.getToken();for(;ve!==17;){if(he.indexOf(ve)!==-1){G();break}else if(Y.indexOf(ve)!==-1)break;ve=G()}}}function U(te){const he=i.getTokenValue();return te?N(he):a(he),G(),!0}function x(){switch(i.getToken()){case 11:{let te=0;try{te=JSON.parse(i.getTokenValue()),typeof te!="number"&&(B(2),te=0)}catch{B(2)}N(te);break}case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return G(),!0}function $(){return i.getToken()!==10?(B(3,[],[2,5]),!1):(U(!1),i.getToken()===6?(M(":"),G(),de()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function Q(){r(),G();let te=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(te||B(4,[],[]),M(","),G(),i.getToken()===2&&F)break}else te&&B(6,[],[]);$()||B(4,[],[2,5]),te=!0}return f(),i.getToken()!==2?B(7,[2],[]):G(),!0}function K(){y(),G();let te=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(te||B(4,[],[]),M(","),G(),i.getToken()===4&&F)break}else te&&B(6,[],[]);de()||B(4,[],[4,5]),te=!0}return R(),i.getToken()!==4?B(8,[4],[]):G(),!0}function de(){switch(i.getToken()){case 3:return K();case 1:return Q();case 10:return U(!0);default:return x()}}return G(),i.getToken()===17?s.allowEmptyContent?!0:(B(4,[],[]),!1):de()?(i.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}e.visit=h;function c(n,u){const s=_(n),i=[];let o,d=0,r;do switch(r=s.getPosition(),o=s.scan(),o){case 12:case 13:case 17:d!==r&&i.push(n.substring(d,r)),u!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,u)),d=s.getPosition();break}while(o!==17);return i.join("")}e.stripComments=c;function g(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=g}),define(De[76],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class l{constructor(C){this.executor=C,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(C){this._error=C}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(C){return new l(()=>C(this.getValue()))}}e.Lazy=l}),define(De[6],Ie([1,0,60,61]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const C=!1;let P=null;function _(o){P=o}if(e.setDisposableTracker=_,C){const o="__is_disposable_tracked__";_(new class{trackDisposable(d){const r=new Error("Potentially leaked disposable").stack;setTimeout(()=>{d[o]||console.log(r)},3e3)}setParent(d,r){if(d&&d!==v.None)try{d[o]=!0}catch{}}markAsDisposed(d){if(d&&d!==v.None)try{d[o]=!0}catch{}}markAsSingleton(d){}})}function I(o){return P?.trackDisposable(o),o}function w(o){P?.markAsDisposed(o)}function k(o,d){P?.setParent(o,d)}function L(o,d){if(!!P)for(const r of o)P.setParent(r,d)}function D(o){return P?.markAsSingleton(o),o}e.markAsSingleton=D;function S(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.isDisposable=S;function T(o){if(t.Iterable.is(o)){const d=[];for(const r of o)if(r)try{r.dispose()}catch(a){d.push(a)}if(d.length===1)throw d[0];if(d.length>1)throw new AggregateError(d,"Encountered errors while disposing of store");return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}e.dispose=T;function E(o){for(const d of o)S(d)&&d.dispose();return[]}e.disposeIfDisposable=E;function p(...o){const d=b(()=>T(o));return L(o,d),d}e.combinedDisposable=p;function b(o){const d=I({dispose:(0,l.once)(()=>{w(d),o()})});return d}e.toDisposable=b;class m{constructor(){this._toDispose=new Set,this._isDisposed=!1,I(this)}dispose(){this._isDisposed||(w(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{T(this._toDispose.values())}finally{this._toDispose.clear()}}add(d){if(!d)return d;if(d===this)throw new Error("Cannot register a disposable on itself!");return k(d,this),this._isDisposed?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(d),d}}e.DisposableStore=m,m.DISABLE_DISPOSED_WARNING=!1;class v{constructor(){this._store=new m,I(this),k(this._store,this)}dispose(){w(this),this._store.dispose()}_register(d){if(d===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(d)}}e.Disposable=v,v.None=Object.freeze({dispose(){}});class h{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(d){this._isDisposed||d===this._value||(this._value?.dispose(),d&&k(d,this),this._value=d)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,w(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const d=this._value;return this._value=void 0,d&&k(d,null),d}}e.MutableDisposable=h;class c{constructor(d){this._disposable=d,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=c;class g{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(d){let r=d;return this.unset=()=>r=void 0,this.isset=()=>r!==void 0,this.dispose=()=>{r&&(r(),r=void 0,w(this))},this}}e.SafeDisposable=g;class n{constructor(){this.references=new Map}acquire(d,...r){let a=this.references.get(d);a||(a={counter:0,object:this.createReferencedObject(d,...r)},this.references.set(d,a));const{object:f}=a,y=(0,l.once)(()=>{--a.counter===0&&(this.destroyReferencedObject(d,a.object),this.references.delete(d))});return a.counter++,{object:f,dispose:y}}}e.ReferenceCollection=n;class u{constructor(d){this.referenceCollection=d}async acquire(d,...r){const a=this.referenceCollection.acquire(d,...r);try{return{object:await a.object,dispose:()=>a.dispose()}}catch(f){throw a.dispose(),f}}}e.AsyncReferenceCollection=u;class s{constructor(d){this.object=d}dispose(){}}e.ImmortalReference=s;function i(o){const d=new m;try{o(d)}finally{d.dispose()}}e.disposeOnReturn=i}),define(De[77],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class l{constructor(P){this.element=P,this.next=l.Undefined,this.prev=l.Undefined}}l.Undefined=new l(void 0);class t{constructor(){this._first=l.Undefined,this._last=l.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===l.Undefined}clear(){let P=this._first;for(;P!==l.Undefined;){const _=P.next;P.prev=l.Undefined,P.next=l.Undefined,P=_}this._first=l.Undefined,this._last=l.Undefined,this._size=0}unshift(P){return this._insert(P,!1)}push(P){return this._insert(P,!0)}_insert(P,_){const I=new l(P);if(this._first===l.Undefined)this._first=I,this._last=I;else if(_){const k=this._last;this._last=I,I.prev=k,k.next=I}else{const k=this._first;this._first=I,I.next=k,k.prev=I}this._size+=1;let w=!1;return()=>{w||(w=!0,this._remove(I))}}shift(){if(this._first!==l.Undefined){const P=this._first.element;return this._remove(this._first),P}}pop(){if(this._last!==l.Undefined){const P=this._last.element;return this._remove(this._last),P}}_remove(P){if(P.prev!==l.Undefined&&P.next!==l.Undefined){const _=P.prev;_.next=P.next,P.next.prev=_}else P.prev===l.Undefined&&P.next===l.Undefined?(this._first=l.Undefined,this._last=l.Undefined):P.next===l.Undefined?(this._last=this._last.prev,this._last.next=l.Undefined):P.prev===l.Undefined&&(this._first=this._first.next,this._first.prev=l.Undefined);this._size-=1}*[Symbol.iterator](){let P=this._first;for(;P!==l.Undefined;)yield P.element,P=P.next}}e.LinkedList=t}),function(J,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(De[145],Ie([0]),e):(J=typeof globalThis<"u"?globalThis:J||self,e(J.marked={}))}(this,function(J){"use strict";function e(oe,le){for(var me=0;me<le.length;me++){var Z=le[me];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(oe,Z.key,Z)}}function l(oe,le,me){return le&&e(oe.prototype,le),me&&e(oe,me),Object.defineProperty(oe,"prototype",{writable:!1}),oe}function t(oe,le){if(!!oe){if(typeof oe=="string")return C(oe,le);var me=Object.prototype.toString.call(oe).slice(8,-1);if(me==="Object"&&oe.constructor&&(me=oe.constructor.name),me==="Map"||me==="Set")return Array.from(oe);if(me==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(me))return C(oe,le)}}function C(oe,le){(le==null||le>oe.length)&&(le=oe.length);for(var me=0,Z=new Array(le);me<le;me++)Z[me]=oe[me];return Z}function P(oe,le){var me=typeof Symbol<"u"&&oe[Symbol.iterator]||oe["@@iterator"];if(me)return(me=me.call(oe)).next.bind(me);if(Array.isArray(oe)||(me=t(oe))||le&&oe&&typeof oe.length=="number"){me&&(oe=me);var Z=0;return function(){return Z>=oe.length?{done:!0}:{done:!1,value:oe[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function _(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}J.defaults=_();function I(oe){J.defaults=oe}var w=/[&<>"']/,k=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,S={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},T=function(le){return S[le]};function E(oe,le){if(le){if(w.test(oe))return oe.replace(k,T)}else if(L.test(oe))return oe.replace(D,T);return oe}var p=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function b(oe){return oe.replace(p,function(le,me){return me=me.toLowerCase(),me==="colon"?":":me.charAt(0)==="#"?me.charAt(1)==="x"?String.fromCharCode(parseInt(me.substring(2),16)):String.fromCharCode(+me.substring(1)):""})}var m=/(^|[^\[])\^/g;function v(oe,le){oe=typeof oe=="string"?oe:oe.source,le=le||"";var me={replace:function(ae,ne){return ne=ne.source||ne,ne=ne.replace(m,"$1"),oe=oe.replace(ae,ne),me},getRegex:function(){return new RegExp(oe,le)}};return me}var h=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function g(oe,le,me){if(oe){var Z;try{Z=decodeURIComponent(b(me)).replace(h,"").toLowerCase()}catch{return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}le&&!c.test(me)&&(me=o(le,me));try{me=encodeURI(me).replace(/%25/g,"%")}catch{return null}return me}var n={},u=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function o(oe,le){n[" "+oe]||(u.test(oe)?n[" "+oe]=oe+"/":n[" "+oe]=f(oe,"/",!0)),oe=n[" "+oe];var me=oe.indexOf(":")===-1;return le.substring(0,2)==="//"?me?le:oe.replace(s,"$1")+le:le.charAt(0)==="/"?me?le:oe.replace(i,"$1")+le:oe+le}var d={exec:function(){}};function r(oe){for(var le=1,me,Z;le<arguments.length;le++){me=arguments[le];for(Z in me)Object.prototype.hasOwnProperty.call(me,Z)&&(oe[Z]=me[Z])}return oe}function a(oe,le){var me=oe.replace(/\|/g,function(ne,ie,O){for(var V=!1,q=ie;--q>=0&&O[q]==="\\";)V=!V;return V?"|":" |"}),Z=me.split(/ \|/),ae=0;if(Z[0].trim()||Z.shift(),Z.length>0&&!Z[Z.length-1].trim()&&Z.pop(),Z.length>le)Z.splice(le);else for(;Z.length<le;)Z.push("");for(;ae<Z.length;ae++)Z[ae]=Z[ae].trim().replace(/\\\|/g,"|");return Z}function f(oe,le,me){var Z=oe.length;if(Z===0)return"";for(var ae=0;ae<Z;){var ne=oe.charAt(Z-ae-1);if(ne===le&&!me)ae++;else if(ne!==le&&me)ae++;else break}return oe.slice(0,Z-ae)}function y(oe,le){if(oe.indexOf(le[1])===-1)return-1;for(var me=oe.length,Z=0,ae=0;ae<me;ae++)if(oe[ae]==="\\")ae++;else if(oe[ae]===le[0])Z++;else if(oe[ae]===le[1]&&(Z--,Z<0))return ae;return-1}function R(oe){oe&&oe.sanitize&&!oe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function N(oe,le){if(le<1)return"";for(var me="";le>1;)le&1&&(me+=oe),le>>=1,oe+=oe;return me+oe}function M(oe,le,me,Z){var ae=le.href,ne=le.title?E(le.title):null,ie=oe[1].replace(/\\([\[\]])/g,"$1");if(oe[0].charAt(0)!=="!"){Z.state.inLink=!0;var O={type:"link",raw:me,href:ae,title:ne,text:ie,tokens:Z.inlineTokens(ie)};return Z.state.inLink=!1,O}return{type:"image",raw:me,href:ae,title:ne,text:E(ie)}}function A(oe,le){var me=oe.match(/^(\s+)(?:```)/);if(me===null)return le;var Z=me[1];return le.split(`
`).map(function(ae){var ne=ae.match(/^\s+/);if(ne===null)return ae;var ie=ne[0];return ie.length>=Z.length?ae.slice(Z.length):ae}).join(`
`)}var z=function(){function oe(me){this.options=me||J.defaults}var le=oe.prototype;return le.space=function(Z){var ae=this.rules.block.newline.exec(Z);if(ae&&ae[0].length>0)return{type:"space",raw:ae[0]}},le.code=function(Z){var ae=this.rules.block.code.exec(Z);if(ae){var ne=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?ne:f(ne,`
`)}}},le.fences=function(Z){var ae=this.rules.block.fences.exec(Z);if(ae){var ne=ae[0],ie=A(ne,ae[3]||"");return{type:"code",raw:ne,lang:ae[2]?ae[2].trim():ae[2],text:ie}}},le.heading=function(Z){var ae=this.rules.block.heading.exec(Z);if(ae){var ne=ae[2].trim();if(/#$/.test(ne)){var ie=f(ne,"#");(this.options.pedantic||!ie||/ $/.test(ie))&&(ne=ie.trim())}return{type:"heading",raw:ae[0],depth:ae[1].length,text:ne,tokens:this.lexer.inline(ne)}}},le.hr=function(Z){var ae=this.rules.block.hr.exec(Z);if(ae)return{type:"hr",raw:ae[0]}},le.blockquote=function(Z){var ae=this.rules.block.blockquote.exec(Z);if(ae){var ne=ae[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ae[0],tokens:this.lexer.blockTokens(ne,[]),text:ne}}},le.list=function(Z){var ae=this.rules.block.list.exec(Z);if(ae){var ne,ie,O,V,q,X,ge,we,ce,Ce,ye,We,qe=ae[1].trim(),Ze=qe.length>1,Ye={type:"list",raw:"",ordered:Ze,start:Ze?+qe.slice(0,-1):"",loose:!1,items:[]};qe=Ze?"\\d{1,9}\\"+qe.slice(-1):"\\"+qe,this.options.pedantic&&(qe=Ze?qe:"[*+-]");for(var Oe=new RegExp("^( {0,3}"+qe+")((?:[	 ][^\\n]*)?(?:\\n|$))");Z&&(We=!1,!(!(ae=Oe.exec(Z))||this.rules.block.hr.test(Z)));){if(ne=ae[0],Z=Z.substring(ne.length),we=ae[2].split(`
`,1)[0],ce=Z.split(`
`,1)[0],this.options.pedantic?(V=2,ye=we.trimLeft()):(V=ae[2].search(/[^ ]/),V=V>4?1:V,ye=we.slice(V),V+=ae[1].length),X=!1,!we&&/^ *$/.test(ce)&&(ne+=ce+`
`,Z=Z.substring(ce.length+1),We=!0),!We)for(var ot=new RegExp("^ {0,"+Math.min(3,V-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),re=new RegExp("^ {0,"+Math.min(3,V-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),se=new RegExp("^ {0,"+Math.min(3,V-1)+"}(?:```|~~~)"),Ee=new RegExp("^ {0,"+Math.min(3,V-1)+"}#");Z&&(Ce=Z.split(`
`,1)[0],we=Ce,this.options.pedantic&&(we=we.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(se.test(we)||Ee.test(we)||ot.test(we)||re.test(Z)));){if(we.search(/[^ ]/)>=V||!we.trim())ye+=`
`+we.slice(V);else if(!X)ye+=`
`+we;else break;!X&&!we.trim()&&(X=!0),ne+=Ce+`
`,Z=Z.substring(Ce.length+1)}Ye.loose||(ge?Ye.loose=!0:/\n *\n *$/.test(ne)&&(ge=!0)),this.options.gfm&&(ie=/^\[[ xX]\] /.exec(ye),ie&&(O=ie[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),Ye.items.push({type:"list_item",raw:ne,task:!!ie,checked:O,loose:!1,text:ye}),Ye.raw+=ne}Ye.items[Ye.items.length-1].raw=ne.trimRight(),Ye.items[Ye.items.length-1].text=ye.trimRight(),Ye.raw=Ye.raw.trimRight();var xe=Ye.items.length;for(q=0;q<xe;q++){this.lexer.state.top=!1,Ye.items[q].tokens=this.lexer.blockTokens(Ye.items[q].text,[]);var fe=Ye.items[q].tokens.filter(function(Le){return Le.type==="space"}),Ae=fe.every(function(Le){for(var Me=Le.raw.split(""),Ge=0,Je=P(Me),st;!(st=Je()).done;){var vt=st.value;if(vt===`
`&&(Ge+=1),Ge>1)return!0}return!1});!Ye.loose&&fe.length&&Ae&&(Ye.loose=!0,Ye.items[q].loose=!0)}return Ye}},le.html=function(Z){var ae=this.rules.block.html.exec(Z);if(ae){var ne={type:"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:ae[0]};if(this.options.sanitize){var ie=this.options.sanitizer?this.options.sanitizer(ae[0]):E(ae[0]);ne.type="paragraph",ne.text=ie,ne.tokens=this.lexer.inline(ie)}return ne}},le.def=function(Z){var ae=this.rules.block.def.exec(Z);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var ne=ae[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ne,raw:ae[0],href:ae[2],title:ae[3]}}},le.table=function(Z){var ae=this.rules.block.table.exec(Z);if(ae){var ne={type:"table",header:a(ae[1]).map(function(ge){return{text:ge}}),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ae[3]&&ae[3].trim()?ae[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ne.header.length===ne.align.length){ne.raw=ae[0];var ie=ne.align.length,O,V,q,X;for(O=0;O<ie;O++)/^ *-+: *$/.test(ne.align[O])?ne.align[O]="right":/^ *:-+: *$/.test(ne.align[O])?ne.align[O]="center":/^ *:-+ *$/.test(ne.align[O])?ne.align[O]="left":ne.align[O]=null;for(ie=ne.rows.length,O=0;O<ie;O++)ne.rows[O]=a(ne.rows[O],ne.header.length).map(function(ge){return{text:ge}});for(ie=ne.header.length,V=0;V<ie;V++)ne.header[V].tokens=this.lexer.inline(ne.header[V].text);for(ie=ne.rows.length,V=0;V<ie;V++)for(X=ne.rows[V],q=0;q<X.length;q++)X[q].tokens=this.lexer.inline(X[q].text);return ne}}},le.lheading=function(Z){var ae=this.rules.block.lheading.exec(Z);if(ae)return{type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1],tokens:this.lexer.inline(ae[1])}},le.paragraph=function(Z){var ae=this.rules.block.paragraph.exec(Z);if(ae){var ne=ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1];return{type:"paragraph",raw:ae[0],text:ne,tokens:this.lexer.inline(ne)}}},le.text=function(Z){var ae=this.rules.block.text.exec(Z);if(ae)return{type:"text",raw:ae[0],text:ae[0],tokens:this.lexer.inline(ae[0])}},le.escape=function(Z){var ae=this.rules.inline.escape.exec(Z);if(ae)return{type:"escape",raw:ae[0],text:E(ae[1])}},le.tag=function(Z){var ae=this.rules.inline.tag.exec(Z);if(ae)return!this.lexer.state.inLink&&/^<a /i.test(ae[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ae[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ae[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ae[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ae[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):E(ae[0]):ae[0]}},le.link=function(Z){var ae=this.rules.inline.link.exec(Z);if(ae){var ne=ae[2].trim();if(!this.options.pedantic&&/^</.test(ne)){if(!/>$/.test(ne))return;var ie=f(ne.slice(0,-1),"\\");if((ne.length-ie.length)%2===0)return}else{var O=y(ae[2],"()");if(O>-1){var V=ae[0].indexOf("!")===0?5:4,q=V+ae[1].length+O;ae[2]=ae[2].substring(0,O),ae[0]=ae[0].substring(0,q).trim(),ae[3]=""}}var X=ae[2],ge="";if(this.options.pedantic){var we=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(X);we&&(X=we[1],ge=we[3])}else ge=ae[3]?ae[3].slice(1,-1):"";return X=X.trim(),/^</.test(X)&&(this.options.pedantic&&!/>$/.test(ne)?X=X.slice(1):X=X.slice(1,-1)),M(ae,{href:X&&X.replace(this.rules.inline._escapes,"$1"),title:ge&&ge.replace(this.rules.inline._escapes,"$1")},ae[0],this.lexer)}},le.reflink=function(Z,ae){var ne;if((ne=this.rules.inline.reflink.exec(Z))||(ne=this.rules.inline.nolink.exec(Z))){var ie=(ne[2]||ne[1]).replace(/\s+/g," ");if(ie=ae[ie.toLowerCase()],!ie||!ie.href){var O=ne[0].charAt(0);return{type:"text",raw:O,text:O}}return M(ne,ie,ne[0],this.lexer)}},le.emStrong=function(Z,ae,ne){ne===void 0&&(ne="");var ie=this.rules.inline.emStrong.lDelim.exec(Z);if(!!ie&&!(ie[3]&&ne.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var O=ie[1]||ie[2]||"";if(!O||O&&(ne===""||this.rules.inline.punctuation.exec(ne))){var V=ie[0].length-1,q,X,ge=V,we=0,ce=ie[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ce.lastIndex=0,ae=ae.slice(-1*Z.length+V);(ie=ce.exec(ae))!=null;)if(q=ie[1]||ie[2]||ie[3]||ie[4]||ie[5]||ie[6],!!q){if(X=q.length,ie[3]||ie[4]){ge+=X;continue}else if((ie[5]||ie[6])&&V%3&&!((V+X)%3)){we+=X;continue}if(ge-=X,!(ge>0)){if(X=Math.min(X,X+ge+we),Math.min(V,X)%2){var Ce=Z.slice(1,V+ie.index+X);return{type:"em",raw:Z.slice(0,V+ie.index+X+1),text:Ce,tokens:this.lexer.inlineTokens(Ce)}}var ye=Z.slice(2,V+ie.index+X-1);return{type:"strong",raw:Z.slice(0,V+ie.index+X+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}}}}},le.codespan=function(Z){var ae=this.rules.inline.code.exec(Z);if(ae){var ne=ae[2].replace(/\n/g," "),ie=/[^ ]/.test(ne),O=/^ /.test(ne)&&/ $/.test(ne);return ie&&O&&(ne=ne.substring(1,ne.length-1)),ne=E(ne,!0),{type:"codespan",raw:ae[0],text:ne}}},le.br=function(Z){var ae=this.rules.inline.br.exec(Z);if(ae)return{type:"br",raw:ae[0]}},le.del=function(Z){var ae=this.rules.inline.del.exec(Z);if(ae)return{type:"del",raw:ae[0],text:ae[2],tokens:this.lexer.inlineTokens(ae[2])}},le.autolink=function(Z,ae){var ne=this.rules.inline.autolink.exec(Z);if(ne){var ie,O;return ne[2]==="@"?(ie=E(this.options.mangle?ae(ne[1]):ne[1]),O="mailto:"+ie):(ie=E(ne[1]),O=ie),{type:"link",raw:ne[0],text:ie,href:O,tokens:[{type:"text",raw:ie,text:ie}]}}},le.url=function(Z,ae){var ne;if(ne=this.rules.inline.url.exec(Z)){var ie,O;if(ne[2]==="@")ie=E(this.options.mangle?ae(ne[0]):ne[0]),O="mailto:"+ie;else{var V;do V=ne[0],ne[0]=this.rules.inline._backpedal.exec(ne[0])[0];while(V!==ne[0]);ie=E(ne[0]),ne[1]==="www."?O="http://"+ie:O=ie}return{type:"link",raw:ne[0],text:ie,href:O,tokens:[{type:"text",raw:ie,text:ie}]}}},le.inlineText=function(Z,ae){var ne=this.rules.inline.text.exec(Z);if(ne){var ie;return this.lexer.state.inRawBlock?ie=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ne[0]):E(ne[0]):ne[0]:ie=E(this.options.smartypants?ae(ne[0]):ne[0]),{type:"text",raw:ne[0],text:ie}}},oe}(),H={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:d,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};H._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,H._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,H.def=v(H.def).replace("label",H._label).replace("title",H._title).getRegex(),H.bullet=/(?:[*+-]|\d{1,9}[.)])/,H.listItemStart=v(/^( *)(bull) */).replace("bull",H.bullet).getRegex(),H.list=v(H.list).replace(/bull/g,H.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+H.def.source+")").getRegex(),H._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",H._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,H.html=v(H.html,"i").replace("comment",H._comment).replace("tag",H._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),H.paragraph=v(H._paragraph).replace("hr",H.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",H._tag).getRegex(),H.blockquote=v(H.blockquote).replace("paragraph",H.paragraph).getRegex(),H.normal=r({},H),H.gfm=r({},H.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),H.gfm.table=v(H.gfm.table).replace("hr",H.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",H._tag).getRegex(),H.gfm.paragraph=v(H._paragraph).replace("hr",H.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",H.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",H._tag).getRegex(),H.pedantic=r({},H.normal,{html:v(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",H._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:d,paragraph:v(H.normal._paragraph).replace("hr",H.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",H.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var F={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:d,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:d,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};F._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",F.punctuation=v(F.punctuation).replace(/punctuation/g,F._punctuation).getRegex(),F.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,F.escapedEmSt=/\\\*|\\_/g,F._comment=v(H._comment).replace("(?:-->|$)","-->").getRegex(),F.emStrong.lDelim=v(F.emStrong.lDelim).replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimAst=v(F.emStrong.rDelimAst,"g").replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimUnd=v(F.emStrong.rDelimUnd,"g").replace(/punct/g,F._punctuation).getRegex(),F._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,F._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,F._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,F.autolink=v(F.autolink).replace("scheme",F._scheme).replace("email",F._email).getRegex(),F._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,F.tag=v(F.tag).replace("comment",F._comment).replace("attribute",F._attribute).getRegex(),F._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,F._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,F._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,F.link=v(F.link).replace("label",F._label).replace("href",F._href).replace("title",F._title).getRegex(),F.reflink=v(F.reflink).replace("label",F._label).replace("ref",H._label).getRegex(),F.nolink=v(F.nolink).replace("ref",H._label).getRegex(),F.reflinkSearch=v(F.reflinkSearch,"g").replace("reflink",F.reflink).replace("nolink",F.nolink).getRegex(),F.normal=r({},F),F.pedantic=r({},F.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:v(/^!?\[(label)\]\((.*?)\)/).replace("label",F._label).getRegex(),reflink:v(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",F._label).getRegex()}),F.gfm=r({},F.normal,{escape:v(F.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),F.gfm.url=v(F.gfm.url,"i").replace("email",F.gfm._extended_email).getRegex(),F.breaks=r({},F.gfm,{br:v(F.br).replace("{2,}","*").getRegex(),text:v(F.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function G(oe){return oe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function B(oe){var le="",me,Z,ae=oe.length;for(me=0;me<ae;me++)Z=oe.charCodeAt(me),Math.random()>.5&&(Z="x"+Z.toString(16)),le+="&#"+Z+";";return le}var U=function(){function oe(me){this.tokens=[],this.tokens.links=Object.create(null),this.options=me||J.defaults,this.options.tokenizer=this.options.tokenizer||new z,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Z={block:H.normal,inline:F.normal};this.options.pedantic?(Z.block=H.pedantic,Z.inline=F.pedantic):this.options.gfm&&(Z.block=H.gfm,this.options.breaks?Z.inline=F.breaks:Z.inline=F.gfm),this.tokenizer.rules=Z}oe.lex=function(Z,ae){var ne=new oe(ae);return ne.lex(Z)},oe.lexInline=function(Z,ae){var ne=new oe(ae);return ne.inlineTokens(Z)};var le=oe.prototype;return le.lex=function(Z){Z=Z.replace(/\r\n|\r/g,`
`),this.blockTokens(Z,this.tokens);for(var ae;ae=this.inlineQueue.shift();)this.inlineTokens(ae.src,ae.tokens);return this.tokens},le.blockTokens=function(Z,ae){var ne=this;ae===void 0&&(ae=[]),this.options.pedantic?Z=Z.replace(/\t/g,"    ").replace(/^ +$/gm,""):Z=Z.replace(/^( *)(\t+)/gm,function(ge,we,ce){return we+"    ".repeat(ce.length)});for(var ie,O,V,q;Z;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ge){return(ie=ge.call({lexer:ne},Z,ae))?(Z=Z.substring(ie.raw.length),ae.push(ie),!0):!1}))){if(ie=this.tokenizer.space(Z)){Z=Z.substring(ie.raw.length),ie.raw.length===1&&ae.length>0?ae[ae.length-1].raw+=`
`:ae.push(ie);continue}if(ie=this.tokenizer.code(Z)){Z=Z.substring(ie.raw.length),O=ae[ae.length-1],O&&(O.type==="paragraph"||O.type==="text")?(O.raw+=`
`+ie.raw,O.text+=`
`+ie.text,this.inlineQueue[this.inlineQueue.length-1].src=O.text):ae.push(ie);continue}if(ie=this.tokenizer.fences(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.heading(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.hr(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.blockquote(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.list(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.html(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.def(Z)){Z=Z.substring(ie.raw.length),O=ae[ae.length-1],O&&(O.type==="paragraph"||O.type==="text")?(O.raw+=`
`+ie.raw,O.text+=`
`+ie.raw,this.inlineQueue[this.inlineQueue.length-1].src=O.text):this.tokens.links[ie.tag]||(this.tokens.links[ie.tag]={href:ie.href,title:ie.title});continue}if(ie=this.tokenizer.table(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.lheading(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(V=Z,this.options.extensions&&this.options.extensions.startBlock&&function(){var ge=1/0,we=Z.slice(1),ce=void 0;ne.options.extensions.startBlock.forEach(function(Ce){ce=Ce.call({lexer:this},we),typeof ce=="number"&&ce>=0&&(ge=Math.min(ge,ce))}),ge<1/0&&ge>=0&&(V=Z.substring(0,ge+1))}(),this.state.top&&(ie=this.tokenizer.paragraph(V))){O=ae[ae.length-1],q&&O.type==="paragraph"?(O.raw+=`
`+ie.raw,O.text+=`
`+ie.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=O.text):ae.push(ie),q=V.length!==Z.length,Z=Z.substring(ie.raw.length);continue}if(ie=this.tokenizer.text(Z)){Z=Z.substring(ie.raw.length),O=ae[ae.length-1],O&&O.type==="text"?(O.raw+=`
`+ie.raw,O.text+=`
`+ie.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=O.text):ae.push(ie);continue}if(Z){var X="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(X);break}else throw new Error(X)}}return this.state.top=!0,ae},le.inline=function(Z,ae){return ae===void 0&&(ae=[]),this.inlineQueue.push({src:Z,tokens:ae}),ae},le.inlineTokens=function(Z,ae){var ne=this;ae===void 0&&(ae=[]);var ie,O,V,q=Z,X,ge,we;if(this.tokens.links){var ce=Object.keys(this.tokens.links);if(ce.length>0)for(;(X=this.tokenizer.rules.inline.reflinkSearch.exec(q))!=null;)ce.includes(X[0].slice(X[0].lastIndexOf("[")+1,-1))&&(q=q.slice(0,X.index)+"["+N("a",X[0].length-2)+"]"+q.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(X=this.tokenizer.rules.inline.blockSkip.exec(q))!=null;)q=q.slice(0,X.index)+"["+N("a",X[0].length-2)+"]"+q.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(X=this.tokenizer.rules.inline.escapedEmSt.exec(q))!=null;)q=q.slice(0,X.index)+"++"+q.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;)if(ge||(we=""),ge=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(ie=ye.call({lexer:ne},Z,ae))?(Z=Z.substring(ie.raw.length),ae.push(ie),!0):!1}))){if(ie=this.tokenizer.escape(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.tag(Z)){Z=Z.substring(ie.raw.length),O=ae[ae.length-1],O&&ie.type==="text"&&O.type==="text"?(O.raw+=ie.raw,O.text+=ie.text):ae.push(ie);continue}if(ie=this.tokenizer.link(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring(ie.raw.length),O=ae[ae.length-1],O&&ie.type==="text"&&O.type==="text"?(O.raw+=ie.raw,O.text+=ie.text):ae.push(ie);continue}if(ie=this.tokenizer.emStrong(Z,q,we)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.codespan(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.br(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.del(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.autolink(Z,B)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(!this.state.inLink&&(ie=this.tokenizer.url(Z,B))){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(V=Z,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,We=Z.slice(1),qe=void 0;ne.options.extensions.startInline.forEach(function(Ze){qe=Ze.call({lexer:this},We),typeof qe=="number"&&qe>=0&&(ye=Math.min(ye,qe))}),ye<1/0&&ye>=0&&(V=Z.substring(0,ye+1))}(),ie=this.tokenizer.inlineText(V,G)){Z=Z.substring(ie.raw.length),ie.raw.slice(-1)!=="_"&&(we=ie.raw.slice(-1)),ge=!0,O=ae[ae.length-1],O&&O.type==="text"?(O.raw+=ie.raw,O.text+=ie.text):ae.push(ie);continue}if(Z){var Ce="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(Ce);break}else throw new Error(Ce)}}return ae},l(oe,null,[{key:"rules",get:function(){return{block:H,inline:F}}}]),oe}(),x=function(){function oe(me){this.options=me||J.defaults}var le=oe.prototype;return le.code=function(Z,ae,ne){var ie=(ae||"").match(/\S*/)[0];if(this.options.highlight){var O=this.options.highlight(Z,ie);O!=null&&O!==Z&&(ne=!0,Z=O)}return Z=Z.replace(/\n$/,"")+`
`,ie?'<pre><code class="'+this.options.langPrefix+E(ie,!0)+'">'+(ne?Z:E(Z,!0))+`</code></pre>
`:"<pre><code>"+(ne?Z:E(Z,!0))+`</code></pre>
`},le.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},le.html=function(Z){return Z},le.heading=function(Z,ae,ne,ie){if(this.options.headerIds){var O=this.options.headerPrefix+ie.slug(ne);return"<h"+ae+' id="'+O+'">'+Z+"</h"+ae+`>
`}return"<h"+ae+">"+Z+"</h"+ae+`>
`},le.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},le.list=function(Z,ae,ne){var ie=ae?"ol":"ul",O=ae&&ne!==1?' start="'+ne+'"':"";return"<"+ie+O+`>
`+Z+"</"+ie+`>
`},le.listitem=function(Z){return"<li>"+Z+`</li>
`},le.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},le.paragraph=function(Z){return"<p>"+Z+`</p>
`},le.table=function(Z,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+ae+`</table>
`},le.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},le.tablecell=function(Z,ae){var ne=ae.header?"th":"td",ie=ae.align?"<"+ne+' align="'+ae.align+'">':"<"+ne+">";return ie+Z+("</"+ne+`>
`)},le.strong=function(Z){return"<strong>"+Z+"</strong>"},le.em=function(Z){return"<em>"+Z+"</em>"},le.codespan=function(Z){return"<code>"+Z+"</code>"},le.br=function(){return this.options.xhtml?"<br/>":"<br>"},le.del=function(Z){return"<del>"+Z+"</del>"},le.link=function(Z,ae,ne){if(Z=g(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ne;var ie='<a href="'+E(Z)+'"';return ae&&(ie+=' title="'+ae+'"'),ie+=">"+ne+"</a>",ie},le.image=function(Z,ae,ne){if(Z=g(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ne;var ie='<img src="'+Z+'" alt="'+ne+'"';return ae&&(ie+=' title="'+ae+'"'),ie+=this.options.xhtml?"/>":">",ie},le.text=function(Z){return Z},oe}(),$=function(){function oe(){}var le=oe.prototype;return le.strong=function(Z){return Z},le.em=function(Z){return Z},le.codespan=function(Z){return Z},le.del=function(Z){return Z},le.html=function(Z){return Z},le.text=function(Z){return Z},le.link=function(Z,ae,ne){return""+ne},le.image=function(Z,ae,ne){return""+ne},le.br=function(){return""},oe}(),Q=function(){function oe(){this.seen={}}var le=oe.prototype;return le.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},le.getNextSafeSlug=function(Z,ae){var ne=Z,ie=0;if(this.seen.hasOwnProperty(ne)){ie=this.seen[Z];do ie++,ne=Z+"-"+ie;while(this.seen.hasOwnProperty(ne))}return ae||(this.seen[Z]=ie,this.seen[ne]=0),ne},le.slug=function(Z,ae){ae===void 0&&(ae={});var ne=this.serialize(Z);return this.getNextSafeSlug(ne,ae.dryrun)},oe}(),K=function(){function oe(me){this.options=me||J.defaults,this.options.renderer=this.options.renderer||new x,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new $,this.slugger=new Q}oe.parse=function(Z,ae){var ne=new oe(ae);return ne.parse(Z)},oe.parseInline=function(Z,ae){var ne=new oe(ae);return ne.parseInline(Z)};var le=oe.prototype;return le.parse=function(Z,ae){ae===void 0&&(ae=!0);var ne="",ie,O,V,q,X,ge,we,ce,Ce,ye,We,qe,Ze,Ye,Oe,ot,re,se,Ee,xe=Z.length;for(ie=0;ie<xe;ie++){if(ye=Z[ie],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(Ee=this.options.extensions.renderers[ye.type].call({parser:this},ye),Ee!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){ne+=Ee||"";continue}switch(ye.type){case"space":continue;case"hr":{ne+=this.renderer.hr();continue}case"heading":{ne+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,b(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{ne+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for(ce="",we="",q=ye.header.length,O=0;O<q;O++)we+=this.renderer.tablecell(this.parseInline(ye.header[O].tokens),{header:!0,align:ye.align[O]});for(ce+=this.renderer.tablerow(we),Ce="",q=ye.rows.length,O=0;O<q;O++){for(ge=ye.rows[O],we="",X=ge.length,V=0;V<X;V++)we+=this.renderer.tablecell(this.parseInline(ge[V].tokens),{header:!1,align:ye.align[V]});Ce+=this.renderer.tablerow(we)}ne+=this.renderer.table(ce,Ce);continue}case"blockquote":{Ce=this.parse(ye.tokens),ne+=this.renderer.blockquote(Ce);continue}case"list":{for(We=ye.ordered,qe=ye.start,Ze=ye.loose,q=ye.items.length,Ce="",O=0;O<q;O++)Oe=ye.items[O],ot=Oe.checked,re=Oe.task,Ye="",Oe.task&&(se=this.renderer.checkbox(ot),Ze?Oe.tokens.length>0&&Oe.tokens[0].type==="paragraph"?(Oe.tokens[0].text=se+" "+Oe.tokens[0].text,Oe.tokens[0].tokens&&Oe.tokens[0].tokens.length>0&&Oe.tokens[0].tokens[0].type==="text"&&(Oe.tokens[0].tokens[0].text=se+" "+Oe.tokens[0].tokens[0].text)):Oe.tokens.unshift({type:"text",text:se}):Ye+=se),Ye+=this.parse(Oe.tokens,Ze),Ce+=this.renderer.listitem(Ye,re,ot);ne+=this.renderer.list(Ce,We,qe);continue}case"html":{ne+=this.renderer.html(ye.text);continue}case"paragraph":{ne+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(Ce=ye.tokens?this.parseInline(ye.tokens):ye.text;ie+1<xe&&Z[ie+1].type==="text";)ye=Z[++ie],Ce+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);ne+=ae?this.renderer.paragraph(Ce):Ce;continue}default:{var fe='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(fe);return}else throw new Error(fe)}}}return ne},le.parseInline=function(Z,ae){ae=ae||this.renderer;var ne="",ie,O,V,q=Z.length;for(ie=0;ie<q;ie++){if(O=Z[ie],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[O.type]&&(V=this.options.extensions.renderers[O.type].call({parser:this},O),V!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(O.type))){ne+=V||"";continue}switch(O.type){case"escape":{ne+=ae.text(O.text);break}case"html":{ne+=ae.html(O.text);break}case"link":{ne+=ae.link(O.href,O.title,this.parseInline(O.tokens,ae));break}case"image":{ne+=ae.image(O.href,O.title,O.text);break}case"strong":{ne+=ae.strong(this.parseInline(O.tokens,ae));break}case"em":{ne+=ae.em(this.parseInline(O.tokens,ae));break}case"codespan":{ne+=ae.codespan(O.text);break}case"br":{ne+=ae.br();break}case"del":{ne+=ae.del(this.parseInline(O.tokens,ae));break}case"text":{ne+=ae.text(O.text);break}default:{var X='Token with "'+O.type+'" type was not found.';if(this.options.silent){console.error(X);return}else throw new Error(X)}}}return ne},oe}();function de(oe,le,me){if(typeof oe>"u"||oe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof oe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(oe)+", string expected");if(typeof le=="function"&&(me=le,le=null),le=r({},de.defaults,le||{}),R(le),me){var Z=le.highlight,ae;try{ae=U.lex(oe,le)}catch(q){return me(q)}var ne=function(X){var ge;if(!X)try{le.walkTokens&&de.walkTokens(ae,le.walkTokens),ge=K.parse(ae,le)}catch(we){X=we}return le.highlight=Z,X?me(X):me(null,ge)};if(!Z||Z.length<3||(delete le.highlight,!ae.length))return ne();var ie=0;de.walkTokens(ae,function(q){q.type==="code"&&(ie++,setTimeout(function(){Z(q.text,q.lang,function(X,ge){if(X)return ne(X);ge!=null&&ge!==q.text&&(q.text=ge,q.escaped=!0),ie--,ie===0&&ne()})},0))}),ie===0&&ne();return}function O(q){if(q.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+E(q.message+"",!0)+"</pre>";throw q}try{var V=U.lex(oe,le);if(le.walkTokens){if(le.async)return Promise.all(de.walkTokens(V,le.walkTokens)).then(function(){return K.parse(V,le)}).catch(O);de.walkTokens(V,le.walkTokens)}return K.parse(V,le)}catch(q){O(q)}}de.options=de.setOptions=function(oe){return r(de.defaults,oe),I(de.defaults),de},de.getDefaults=_,de.defaults=J.defaults,de.use=function(){for(var oe=arguments.length,le=new Array(oe),me=0;me<oe;me++)le[me]=arguments[me];var Z=r.apply(void 0,[{}].concat(le)),ae=de.defaults.extensions||{renderers:{},childTokens:{}},ne;le.forEach(function(ie){if(ie.extensions&&(ne=!0,ie.extensions.forEach(function(V){if(!V.name)throw new Error("extension name required");if(V.renderer){var q=ae.renderers?ae.renderers[V.name]:null;q?ae.renderers[V.name]=function(){for(var X=arguments.length,ge=new Array(X),we=0;we<X;we++)ge[we]=arguments[we];var ce=V.renderer.apply(this,ge);return ce===!1&&(ce=q.apply(this,ge)),ce}:ae.renderers[V.name]=V.renderer}if(V.tokenizer){if(!V.level||V.level!=="block"&&V.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ae[V.level]?ae[V.level].unshift(V.tokenizer):ae[V.level]=[V.tokenizer],V.start&&(V.level==="block"?ae.startBlock?ae.startBlock.push(V.start):ae.startBlock=[V.start]:V.level==="inline"&&(ae.startInline?ae.startInline.push(V.start):ae.startInline=[V.start]))}V.childTokens&&(ae.childTokens[V.name]=V.childTokens)})),ie.renderer&&function(){var V=de.defaults.renderer||new x,q=function(we){var ce=V[we];V[we]=function(){for(var Ce=arguments.length,ye=new Array(Ce),We=0;We<Ce;We++)ye[We]=arguments[We];var qe=ie.renderer[we].apply(V,ye);return qe===!1&&(qe=ce.apply(V,ye)),qe}};for(var X in ie.renderer)q(X);Z.renderer=V}(),ie.tokenizer&&function(){var V=de.defaults.tokenizer||new z,q=function(we){var ce=V[we];V[we]=function(){for(var Ce=arguments.length,ye=new Array(Ce),We=0;We<Ce;We++)ye[We]=arguments[We];var qe=ie.tokenizer[we].apply(V,ye);return qe===!1&&(qe=ce.apply(V,ye)),qe}};for(var X in ie.tokenizer)q(X);Z.tokenizer=V}(),ie.walkTokens){var O=de.defaults.walkTokens;Z.walkTokens=function(V){var q=[];return q.push(ie.walkTokens.call(this,V)),O&&(q=q.concat(O.call(this,V))),q}}ne&&(Z.extensions=ae),de.setOptions(Z)})},de.walkTokens=function(oe,le){for(var me=[],Z=function(){var O=ne.value;switch(me=me.concat(le.call(de,O)),O.type){case"table":{for(var V=P(O.header),q;!(q=V()).done;){var X=q.value;me=me.concat(de.walkTokens(X.tokens,le))}for(var ge=P(O.rows),we;!(we=ge()).done;)for(var ce=we.value,Ce=P(ce),ye;!(ye=Ce()).done;){var We=ye.value;me=me.concat(de.walkTokens(We.tokens,le))}break}case"list":{me=me.concat(de.walkTokens(O.items,le));break}default:de.defaults.extensions&&de.defaults.extensions.childTokens&&de.defaults.extensions.childTokens[O.type]?de.defaults.extensions.childTokens[O.type].forEach(function(qe){me=me.concat(de.walkTokens(O[qe],le))}):O.tokens&&(me=me.concat(de.walkTokens(O.tokens,le)))}},ae=P(oe),ne;!(ne=ae()).done;)Z();return me},de.parseInline=function(oe,le){if(typeof oe>"u"||oe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof oe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(oe)+", string expected");le=r({},de.defaults,le||{}),R(le);try{var me=U.lexInline(oe,le);return le.walkTokens&&de.walkTokens(me,le.walkTokens),K.parseInline(me,le)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+E(Z.message+"",!0)+"</pre>";throw Z}},de.Parser=K,de.parser=K.parse,de.Renderer=x,de.TextRenderer=$,de.Lexer=U,de.lexer=U.lex,de.Tokenizer=z,de.Slugger=Q,de.parse=de;var te=de.options,he=de.setOptions,Y=de.use,ve=de.walkTokens,be=de.parseInline,ke=de,Re=K.parse,ze=U.lex;J.Lexer=U,J.Parser=K,J.Renderer=x,J.Slugger=Q,J.TextRenderer=$,J.Tokenizer=z,J.getDefaults=_,J.lexer=ze,J.marked=de,J.options=te,J.parse=ke,J.parseInline=be,J.parser=Re,J.setOptions=he,J.use=Y,J.walkTokens=ve,Object.defineProperty(J,"__esModule",{value:!0})}),define(De[95],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function l(I,w,k){return Math.min(Math.max(I,w),k)}e.clamp=l;function t(I,w){return(w+I%w)%w}e.rot=t;class C{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=C;class P{constructor(){this._n=1,this._val=0}update(w){return this._val=this._val+(w-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=P;class _{constructor(w){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(w),this._values.fill(0,0,w)}update(w){const k=this._values[this._index];return this._values[this._index]=w,this._index=(this._index+1)%this._values.length,this._sum-=k,this._sum+=w,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=_}),function(){function J(C){const P=[];typeof C=="number"&&P.push("code/timeOrigin",C);function _(w){P.push(w,Date.now())}function I(){const w=[];for(let k=0;k<P.length;k+=2)w.push({name:P[k],startTime:P[k+1]});return w}return{mark:_,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const _ of performance.getEntriesByType("mark"))P.push({name:_.name,startTime:Math.round(C+_.startTime)});return P}};if(typeof process=="object"){const C=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function l(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return l(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=l(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=l(t))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var l=e();for(var t in l)(typeof exports=="object"?exports:J)[t]=l[t]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function l(t){if(e[t])return e[t].exports;var C=e[t]={i:t,l:!1,exports:{}};return J[t].call(C.exports,C,C.exports,l),C.l=!0,C.exports}return l.m=J,l.c=e,l.d=function(t,C,P){l.o(t,C)||Object.defineProperty(t,C,{enumerable:!0,get:P})},l.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},l.t=function(t,C){if(1&C&&(t=l(t)),8&C||4&C&&typeof t=="object"&&t&&t.__esModule)return t;var P=Object.create(null);if(l.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:t}),2&C&&typeof t!="string")for(var _ in t)l.d(P,_,function(I){return t[I]}.bind(null,_));return P},l.n=function(t){var C=t&&t.__esModule?function(){return t.default}:function(){return t};return l.d(C,"a",C),C},l.o=function(t,C){return Object.prototype.hasOwnProperty.call(t,C)},l.p="",l(l.s=0)}([function(J,e,l){(function(t){var C;e=J.exports=Y,C=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var P=256,_=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],w=e.src=[],k=0,L=k++;w[L]="0|[1-9]\\d*";var D=k++;w[D]="[0-9]+";var S=k++;w[S]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var T=k++;w[T]="("+w[L]+")\\.("+w[L]+")\\.("+w[L]+")";var E=k++;w[E]="("+w[D]+")\\.("+w[D]+")\\.("+w[D]+")";var p=k++;w[p]="(?:"+w[L]+"|"+w[S]+")";var b=k++;w[b]="(?:"+w[D]+"|"+w[S]+")";var m=k++;w[m]="(?:-("+w[p]+"(?:\\."+w[p]+")*))";var v=k++;w[v]="(?:-?("+w[b]+"(?:\\."+w[b]+")*))";var h=k++;w[h]="[0-9A-Za-z-]+";var c=k++;w[c]="(?:\\+("+w[h]+"(?:\\."+w[h]+")*))";var g=k++,n="v?"+w[T]+w[m]+"?"+w[c]+"?";w[g]="^"+n+"$";var u="[v=\\s]*"+w[E]+w[v]+"?"+w[c]+"?",s=k++;w[s]="^"+u+"$";var i=k++;w[i]="((?:<|>)?=?)";var o=k++;w[o]=w[D]+"|x|X|\\*";var d=k++;w[d]=w[L]+"|x|X|\\*";var r=k++;w[r]="[v=\\s]*("+w[d]+")(?:\\.("+w[d]+")(?:\\.("+w[d]+")(?:"+w[m]+")?"+w[c]+"?)?)?";var a=k++;w[a]="[v=\\s]*("+w[o]+")(?:\\.("+w[o]+")(?:\\.("+w[o]+")(?:"+w[v]+")?"+w[c]+"?)?)?";var f=k++;w[f]="^"+w[i]+"\\s*"+w[r]+"$";var y=k++;w[y]="^"+w[i]+"\\s*"+w[a]+"$";var R=k++;w[R]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=k++;w[N]="(?:~>?)";var M=k++;w[M]="(\\s*)"+w[N]+"\\s+",I[M]=new RegExp(w[M],"g");var A=k++;w[A]="^"+w[N]+w[r]+"$";var z=k++;w[z]="^"+w[N]+w[a]+"$";var H=k++;w[H]="(?:\\^)";var F=k++;w[F]="(\\s*)"+w[H]+"\\s+",I[F]=new RegExp(w[F],"g");var G=k++;w[G]="^"+w[H]+w[r]+"$";var B=k++;w[B]="^"+w[H]+w[a]+"$";var U=k++;w[U]="^"+w[i]+"\\s*("+u+")$|^$";var x=k++;w[x]="^"+w[i]+"\\s*("+n+")$|^$";var $=k++;w[$]="(\\s*)"+w[i]+"\\s*("+u+"|"+w[r]+")",I[$]=new RegExp(w[$],"g");var Q=k++;w[Q]="^\\s*("+w[r]+")\\s+-\\s+("+w[r]+")\\s*$";var K=k++;w[K]="^\\s*("+w[a]+")\\s+-\\s+("+w[a]+")\\s*$";var de=k++;w[de]="(<|>)?=?\\s*\\*";for(var te=0;te<35;te++)C(te,w[te]),I[te]||(I[te]=new RegExp(w[te]));function he(ce,Ce){if(ce instanceof Y)return ce;if(typeof ce!="string"||ce.length>P||!(Ce?I[s]:I[g]).test(ce))return null;try{return new Y(ce,Ce)}catch{return null}}function Y(ce,Ce){if(ce instanceof Y){if(ce.loose===Ce)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof Y))return new Y(ce,Ce);C("SemVer",ce,Ce),this.loose=Ce;var ye=ce.trim().match(Ce?I[s]:I[g]);if(!ye)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>_||this.major<0)throw new TypeError("Invalid major version");if(this.minor>_||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>_||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(We){if(/^[0-9]+$/.test(We)){var qe=+We;if(qe>=0&&qe<_)return qe}return We}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=he,e.valid=function(ce,Ce){var ye=he(ce,Ce);return ye?ye.version:null},e.clean=function(ce,Ce){var ye=he(ce.trim().replace(/^[=v]+/,""),Ce);return ye?ye.version:null},e.SemVer=Y,Y.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Y.prototype.toString=function(){return this.version},Y.prototype.compare=function(ce){return C("SemVer.compare",this.version,this.loose,ce),ce instanceof Y||(ce=new Y(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},Y.prototype.compareMain=function(ce){return ce instanceof Y||(ce=new Y(ce,this.loose)),be(this.major,ce.major)||be(this.minor,ce.minor)||be(this.patch,ce.patch)},Y.prototype.comparePre=function(ce){if(ce instanceof Y||(ce=new Y(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var Ce=0;do{var ye=this.prerelease[Ce],We=ce.prerelease[Ce];if(C("prerelease compare",Ce,ye,We),ye===void 0&&We===void 0)return 0;if(We===void 0)return 1;if(ye===void 0)return-1;if(ye!==We)return be(ye,We)}while(++Ce)},Y.prototype.inc=function(ce,Ce){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Ce);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Ce);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Ce),this.inc("pre",Ce);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Ce),this.inc("pre",Ce);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}Ce&&(this.prerelease[0]===Ce?isNaN(this.prerelease[1])&&(this.prerelease=[Ce,0]):this.prerelease=[Ce,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,Ce,ye,We){typeof ye=="string"&&(We=ye,ye=void 0);try{return new Y(ce,ye).inc(Ce,We).version}catch{return null}},e.diff=function(ce,Ce){if(oe(ce,Ce))return null;var ye=he(ce),We=he(Ce);if(ye.prerelease.length||We.prerelease.length){for(var qe in ye)if((qe==="major"||qe==="minor"||qe==="patch")&&ye[qe]!==We[qe])return"pre"+qe;return"prerelease"}for(var qe in ye)if((qe==="major"||qe==="minor"||qe==="patch")&&ye[qe]!==We[qe])return qe},e.compareIdentifiers=be;var ve=/^[0-9]+$/;function be(ce,Ce){var ye=ve.test(ce),We=ve.test(Ce);return ye&&We&&(ce=+ce,Ce=+Ce),ye&&!We?-1:We&&!ye?1:ce<Ce?-1:ce>Ce?1:0}function ke(ce,Ce,ye){return new Y(ce,ye).compare(new Y(Ce,ye))}function Re(ce,Ce,ye){return ke(ce,Ce,ye)>0}function ze(ce,Ce,ye){return ke(ce,Ce,ye)<0}function oe(ce,Ce,ye){return ke(ce,Ce,ye)===0}function le(ce,Ce,ye){return ke(ce,Ce,ye)!==0}function me(ce,Ce,ye){return ke(ce,Ce,ye)>=0}function Z(ce,Ce,ye){return ke(ce,Ce,ye)<=0}function ae(ce,Ce,ye,We){var qe;switch(Ce){case"===":typeof ce=="object"&&(ce=ce.version),typeof ye=="object"&&(ye=ye.version),qe=ce===ye;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof ye=="object"&&(ye=ye.version),qe=ce!==ye;break;case"":case"=":case"==":qe=oe(ce,ye,We);break;case"!=":qe=le(ce,ye,We);break;case">":qe=Re(ce,ye,We);break;case">=":qe=me(ce,ye,We);break;case"<":qe=ze(ce,ye,We);break;case"<=":qe=Z(ce,ye,We);break;default:throw new TypeError("Invalid operator: "+Ce)}return qe}function ne(ce,Ce){if(ce instanceof ne){if(ce.loose===Ce)return ce;ce=ce.value}if(!(this instanceof ne))return new ne(ce,Ce);C("comparator",ce,Ce),this.loose=Ce,this.parse(ce),this.semver===ie?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(ce,Ce){return be(Ce,ce)},e.major=function(ce,Ce){return new Y(ce,Ce).major},e.minor=function(ce,Ce){return new Y(ce,Ce).minor},e.patch=function(ce,Ce){return new Y(ce,Ce).patch},e.compare=ke,e.compareLoose=function(ce,Ce){return ke(ce,Ce,!0)},e.rcompare=function(ce,Ce,ye){return ke(Ce,ce,ye)},e.sort=function(ce,Ce){return ce.sort(function(ye,We){return e.compare(ye,We,Ce)})},e.rsort=function(ce,Ce){return ce.sort(function(ye,We){return e.rcompare(ye,We,Ce)})},e.gt=Re,e.lt=ze,e.eq=oe,e.neq=le,e.gte=me,e.lte=Z,e.cmp=ae,e.Comparator=ne;var ie={};function O(ce,Ce){if(ce instanceof O)return ce.loose===Ce?ce:new O(ce.raw,Ce);if(ce instanceof ne)return new O(ce.value,Ce);if(!(this instanceof O))return new O(ce,Ce);if(this.loose=Ce,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function V(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function q(ce,Ce,ye,We,qe,Ze,Ye,Oe,ot,re,se,Ee,xe){return((Ce=V(ye)?"":V(We)?">="+ye+".0.0":V(qe)?">="+ye+"."+We+".0":">="+Ce)+" "+(Oe=V(ot)?"":V(re)?"<"+(+ot+1)+".0.0":V(se)?"<"+ot+"."+(+re+1)+".0":Ee?"<="+ot+"."+re+"."+se+"-"+Ee:"<="+Oe)).trim()}function X(ce,Ce){for(var ye=0;ye<ce.length;ye++)if(!ce[ye].test(Ce))return!1;if(Ce.prerelease.length){for(ye=0;ye<ce.length;ye++)if(C(ce[ye].semver),ce[ye].semver!==ie&&ce[ye].semver.prerelease.length>0){var We=ce[ye].semver;if(We.major===Ce.major&&We.minor===Ce.minor&&We.patch===Ce.patch)return!0}return!1}return!0}function ge(ce,Ce,ye){try{Ce=new O(Ce,ye)}catch{return!1}return Ce.test(ce)}function we(ce,Ce,ye,We){var qe,Ze,Ye,Oe,ot;switch(ce=new Y(ce,We),Ce=new O(Ce,We),ye){case">":qe=Re,Ze=Z,Ye=ze,Oe=">",ot=">=";break;case"<":qe=ze,Ze=me,Ye=Re,Oe="<",ot="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ge(ce,Ce,We))return!1;for(var re=0;re<Ce.set.length;++re){var se=Ce.set[re],Ee=null,xe=null;if(se.forEach(function(fe){fe.semver===ie&&(fe=new ne(">=0.0.0")),Ee=Ee||fe,xe=xe||fe,qe(fe.semver,Ee.semver,We)?Ee=fe:Ye(fe.semver,xe.semver,We)&&(xe=fe)}),Ee.operator===Oe||Ee.operator===ot||(!xe.operator||xe.operator===Oe)&&Ze(ce,xe.semver)||xe.operator===ot&&Ye(ce,xe.semver))return!1}return!0}ne.prototype.parse=function(ce){var Ce=this.loose?I[U]:I[x],ye=ce.match(Ce);if(!ye)throw new TypeError("Invalid comparator: "+ce);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new Y(ye[2],this.loose):this.semver=ie},ne.prototype.toString=function(){return this.value},ne.prototype.test=function(ce){return C("Comparator.test",ce,this.loose),this.semver===ie||(typeof ce=="string"&&(ce=new Y(ce,this.loose)),ae(ce,this.operator,this.semver,this.loose))},ne.prototype.intersects=function(ce,Ce){if(!(ce instanceof ne))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new O(ce.value,Ce),ge(this.value,ye,Ce);if(ce.operator==="")return ye=new O(this.value,Ce),ge(ce.semver,ye,Ce);var We=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),qe=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),Ze=this.semver.version===ce.semver.version,Ye=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),Oe=ae(this.semver,"<",ce.semver,Ce)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),ot=ae(this.semver,">",ce.semver,Ce)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return We||qe||Ze&&Ye||Oe||ot},e.Range=O,O.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},O.prototype.toString=function(){return this.range},O.prototype.parseRange=function(ce){var Ce=this.loose;ce=ce.trim(),C("range",ce,Ce);var ye=Ce?I[K]:I[Q];ce=ce.replace(ye,q),C("hyphen replace",ce),ce=ce.replace(I[$],"$1$2$3"),C("comparator trim",ce,I[$]),ce=(ce=(ce=ce.replace(I[M],"$1~")).replace(I[F],"$1^")).split(/\s+/).join(" ");var We=Ce?I[U]:I[x],qe=ce.split(" ").map(function(Ze){return function(Ye,Oe){return C("comp",Ye),Ye=function(ot,re){return ot.trim().split(/\s+/).map(function(se){return function(Ee,xe){C("caret",Ee,xe);var fe=xe?I[B]:I[G];return Ee.replace(fe,function(Ae,Le,Me,Ge,Je){var st;return C("caret",Ee,Ae,Le,Me,Ge,Je),V(Le)?st="":V(Me)?st=">="+Le+".0.0 <"+(+Le+1)+".0.0":V(Ge)?st=Le==="0"?">="+Le+"."+Me+".0 <"+Le+"."+(+Me+1)+".0":">="+Le+"."+Me+".0 <"+(+Le+1)+".0.0":Je?(C("replaceCaret pr",Je),Je.charAt(0)!=="-"&&(Je="-"+Je),st=Le==="0"?Me==="0"?">="+Le+"."+Me+"."+Ge+Je+" <"+Le+"."+Me+"."+(+Ge+1):">="+Le+"."+Me+"."+Ge+Je+" <"+Le+"."+(+Me+1)+".0":">="+Le+"."+Me+"."+Ge+Je+" <"+(+Le+1)+".0.0"):(C("no pr"),st=Le==="0"?Me==="0"?">="+Le+"."+Me+"."+Ge+" <"+Le+"."+Me+"."+(+Ge+1):">="+Le+"."+Me+"."+Ge+" <"+Le+"."+(+Me+1)+".0":">="+Le+"."+Me+"."+Ge+" <"+(+Le+1)+".0.0"),C("caret return",st),st})}(se,re)}).join(" ")}(Ye,Oe),C("caret",Ye),Ye=function(ot,re){return ot.trim().split(/\s+/).map(function(se){return function(Ee,xe){var fe=xe?I[z]:I[A];return Ee.replace(fe,function(Ae,Le,Me,Ge,Je){var st;return C("tilde",Ee,Ae,Le,Me,Ge,Je),V(Le)?st="":V(Me)?st=">="+Le+".0.0 <"+(+Le+1)+".0.0":V(Ge)?st=">="+Le+"."+Me+".0 <"+Le+"."+(+Me+1)+".0":Je?(C("replaceTilde pr",Je),Je.charAt(0)!=="-"&&(Je="-"+Je),st=">="+Le+"."+Me+"."+Ge+Je+" <"+Le+"."+(+Me+1)+".0"):st=">="+Le+"."+Me+"."+Ge+" <"+Le+"."+(+Me+1)+".0",C("tilde return",st),st})}(se,re)}).join(" ")}(Ye,Oe),C("tildes",Ye),Ye=function(ot,re){return C("replaceXRanges",ot,re),ot.split(/\s+/).map(function(se){return function(Ee,xe){Ee=Ee.trim();var fe=xe?I[y]:I[f];return Ee.replace(fe,function(Ae,Le,Me,Ge,Je,st){C("xRange",Ee,Ae,Le,Me,Ge,Je,st);var vt=V(Me),nt=vt||V(Ge),it=nt||V(Je);return Le==="="&&it&&(Le=""),vt?Ae=Le===">"||Le==="<"?"<0.0.0":"*":Le&&it?(nt&&(Ge=0),it&&(Je=0),Le===">"?(Le=">=",nt?(Me=+Me+1,Ge=0,Je=0):it&&(Ge=+Ge+1,Je=0)):Le==="<="&&(Le="<",nt?Me=+Me+1:Ge=+Ge+1),Ae=Le+Me+"."+Ge+"."+Je):nt?Ae=">="+Me+".0.0 <"+(+Me+1)+".0.0":it&&(Ae=">="+Me+"."+Ge+".0 <"+Me+"."+(+Ge+1)+".0"),C("xRange return",Ae),Ae})}(se,re)}).join(" ")}(Ye,Oe),C("xrange",Ye),Ye=function(ot,re){return C("replaceStars",ot,re),ot.trim().replace(I[de],"")}(Ye,Oe),C("stars",Ye),Ye}(Ze,Ce)}).join(" ").split(/\s+/);return this.loose&&(qe=qe.filter(function(Ze){return!!Ze.match(We)})),qe=qe.map(function(Ze){return new ne(Ze,Ce)})},O.prototype.intersects=function(ce,Ce){if(!(ce instanceof O))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(We){return ce.set.some(function(qe){return qe.every(function(Ze){return We.intersects(Ze,Ce)})})})})},e.toComparators=function(ce,Ce){return new O(ce,Ce).set.map(function(ye){return ye.map(function(We){return We.value}).join(" ").trim().split(" ")})},O.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new Y(ce,this.loose));for(var Ce=0;Ce<this.set.length;Ce++)if(X(this.set[Ce],ce))return!0;return!1},e.satisfies=ge,e.maxSatisfying=function(ce,Ce,ye){var We=null,qe=null;try{var Ze=new O(Ce,ye)}catch{return null}return ce.forEach(function(Ye){Ze.test(Ye)&&(We&&qe.compare(Ye)!==-1||(qe=new Y(We=Ye,ye)))}),We},e.minSatisfying=function(ce,Ce,ye){var We=null,qe=null;try{var Ze=new O(Ce,ye)}catch{return null}return ce.forEach(function(Ye){Ze.test(Ye)&&(We&&qe.compare(Ye)!==1||(qe=new Y(We=Ye,ye)))}),We},e.validRange=function(ce,Ce){try{return new O(ce,Ce).range||"*"}catch{return null}},e.ltr=function(ce,Ce,ye){return we(ce,Ce,"<",ye)},e.gtr=function(ce,Ce,ye){return we(ce,Ce,">",ye)},e.outside=we,e.prerelease=function(ce,Ce){var ye=he(ce,Ce);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(ce,Ce,ye){return ce=new O(ce,ye),Ce=new O(Ce,ye),ce.intersects(Ce)},e.coerce=function(ce){if(ce instanceof Y)return ce;if(typeof ce!="string")return null;var Ce=ce.match(I[R]);return Ce==null?null:he((Ce[1]||"0")+"."+(Ce[2]||"0")+"."+(Ce[3]||"0"))}}).call(this,l(1))},function(J,e){var l,t,C=J.exports={};function P(){throw new Error("setTimeout has not been defined")}function _(){throw new Error("clearTimeout has not been defined")}function I(b){if(l===setTimeout)return setTimeout(b,0);if((l===P||!l)&&setTimeout)return l=setTimeout,setTimeout(b,0);try{return l(b,0)}catch{try{return l.call(null,b,0)}catch{return l.call(this,b,0)}}}(function(){try{l=typeof setTimeout=="function"?setTimeout:P}catch{l=P}try{t=typeof clearTimeout=="function"?clearTimeout:_}catch{t=_}})();var w,k=[],L=!1,D=-1;function S(){L&&w&&(L=!1,w.length?k=w.concat(k):D=-1,k.length&&T())}function T(){if(!L){var b=I(S);L=!0;for(var m=k.length;m;){for(w=k,k=[];++D<m;)w&&w[D].run();D=-1,m=k.length}w=null,L=!1,function(v){if(t===clearTimeout)return clearTimeout(v);if((t===_||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(v);try{t(v)}catch{try{return t.call(null,v)}catch{return t.call(this,v)}}}(b)}}function E(b,m){this.fun=b,this.array=m}function p(){}C.nextTick=function(b){var m=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)m[v-1]=arguments[v];k.push(new E(b,m)),k.length!==1||L||I(T)},E.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=p,C.addListener=p,C.once=p,C.off=p,C.removeListener=p,C.removeAllListeners=p,C.emit=p,C.prependListener=p,C.prependOnceListener=p,C.listeners=function(b){return[]},C.binding=function(b){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(b){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(De[96],Ie([1,0,10,6]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function C(c){const g=c;return g?typeof g.read=="function":!1}e.isReadable=C;function P(c){const g=c;return g?[g.on,g.pause,g.resume,g.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=P;function _(c){const g=c;return g?P(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}e.isReadableBufferedStream=_;function I(c,g){return new w(c,g)}e.newWriteableStream=I;class w{constructor(g,n){this.reducer=g,this.options=n,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(g){if(!this.state.destroyed){if(this.state.flowing)this.emitData(g);else if(this.buffer.data.push(g),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(n=>this.pendingWritePromises.push(n))}}error(g){this.state.destroyed||(this.state.flowing?this.emitError(g):this.buffer.error.push(g))}end(g){this.state.destroyed||(typeof g<"u"&&this.write(g),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(g){this.listeners.data.slice(0).forEach(n=>n(g))}emitError(g){this.listeners.error.length===0?(0,l.onUnexpectedError)(g):this.listeners.error.slice(0).forEach(n=>n(g))}emitEnd(){this.listeners.end.slice(0).forEach(g=>g())}on(g,n){if(!this.state.destroyed)switch(g){case"data":this.listeners.data.push(n),this.resume();break;case"end":this.listeners.end.push(n),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(n),this.state.flowing&&this.flowErrors();break}}removeListener(g,n){if(this.state.destroyed)return;let u;switch(g){case"data":u=this.listeners.data;break;case"end":u=this.listeners.end;break;case"error":u=this.listeners.error;break}if(u){const s=u.indexOf(n);s>=0&&u.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const g=this.reducer(this.buffer.data);this.emitData(g),this.buffer.data.length=0;const n=[...this.pendingWritePromises];this.pendingWritePromises.length=0,n.forEach(u=>u())}}flowErrors(){if(this.listeners.error.length>0){for(const g of this.buffer.error)this.emitError(g);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function k(c,g){const n=[];let u;for(;(u=c.read())!==null;)n.push(u);return g(n)}e.consumeReadable=k;function L(c,g,n){const u=[];let s;for(;(s=c.read())!==null&&u.length<n;)u.push(s);return s===null&&u.length>0?g(u):{read:()=>{if(u.length>0)return u.shift();if(typeof s<"u"){const i=s;return s=void 0,i}return c.read()}}}e.peekReadable=L;function D(c,g){return new Promise((n,u)=>{const s=[];S(c,{onData:i=>{g&&s.push(i)},onError:i=>{g?u(i):n(void 0)},onEnd:()=>{n(g?g(s):void 0)}})})}e.consumeStream=D;function S(c,g){let n=!1;return c.on("error",u=>{n||g.onError(u)}),c.on("end",()=>{n||g.onEnd()}),c.on("data",u=>{n||g.onData(u)}),(0,t.toDisposable)(()=>n=!0)}e.listenStream=S;function T(c,g){return new Promise((n,u)=>{const s=new t.DisposableStore,i=[],o=a=>{if(i.push(a),i.length>g)return s.dispose(),c.pause(),n({stream:c,buffer:i,ended:!1})},d=a=>u(a),r=()=>n({stream:c,buffer:i,ended:!0});s.add((0,t.toDisposable)(()=>c.removeListener("error",d))),c.on("error",d),s.add((0,t.toDisposable)(()=>c.removeListener("end",r))),c.on("end",r),s.add((0,t.toDisposable)(()=>c.removeListener("data",o))),c.on("data",o)})}e.peekStream=T;function E(c,g){const n=I(g);return n.end(c),n}e.toStream=E;function p(){const c=I(()=>{throw new Error("not supported")});return c.end(),c}e.emptyStream=p;function b(c){let g=!1;return{read:()=>g?null:(g=!0,c)}}e.toReadable=b;function m(c,g,n){const u=I(n);return S(c,{onData:s=>u.write(g.data(s)),onError:s=>u.error(g.error?g.error(s):s),onEnd:()=>u.end()}),u}e.transform=m;function v(c,g,n){let u=!1;return{read:()=>{const s=g.read();return u?s:(u=!0,s!==null?n([c,s]):c)}}}e.prefixedReadable=v;function h(c,g,n){let u=!1;const s=I(n);return S(g,{onData:i=>u?s.write(i):(u=!0,s.write(n([c,i]))),onError:i=>s.error(i),onEnd:()=>{u||(u=!0,s.write(c)),s.end()}}),s}e.prefixedStream=h}),define(De[23],Ie([1,0,96]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let C,P;class _{static alloc(a){return t?new _(Buffer.allocUnsafe(a)):new _(new Uint8Array(a))}static wrap(a){return t&&!Buffer.isBuffer(a)&&(a=Buffer.from(a.buffer,a.byteOffset,a.byteLength)),new _(a)}static fromString(a,f){return!(f?.dontUseNodeBuffer||!1)&&t?new _(Buffer.from(a)):(C||(C=new TextEncoder),new _(C.encode(a)))}static fromByteArray(a){const f=_.alloc(a.length);for(let y=0,R=a.length;y<R;y++)f.buffer[y]=a[y];return f}static concat(a,f){if(typeof f>"u"){f=0;for(let N=0,M=a.length;N<M;N++)f+=a[N].byteLength}const y=_.alloc(f);let R=0;for(let N=0,M=a.length;N<M;N++){const A=a[N];y.set(A,R),R+=A.byteLength}return y}constructor(a){this.buffer=a,this.byteLength=this.buffer.byteLength}clone(){const a=_.alloc(this.byteLength);return a.set(this),a}toString(){return t?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(a,f){return new _(this.buffer.subarray(a,f))}set(a,f){if(a instanceof _)this.buffer.set(a.buffer,f);else if(a instanceof Uint8Array)this.buffer.set(a,f);else if(a instanceof ArrayBuffer)this.buffer.set(new Uint8Array(a),f);else if(ArrayBuffer.isView(a))this.buffer.set(new Uint8Array(a.buffer,a.byteOffset,a.byteLength),f);else throw new Error("Unknown argument 'array'")}readUInt32BE(a){return k(this.buffer,a)}writeUInt32BE(a,f){L(this.buffer,a,f)}readUInt32LE(a){return D(this.buffer,a)}writeUInt32LE(a,f){S(this.buffer,a,f)}readUInt8(a){return T(this.buffer,a)}writeUInt8(a,f){E(this.buffer,a,f)}}e.VSBuffer=_;function I(r,a){return r[a+0]<<0>>>0|r[a+1]<<8>>>0}e.readUInt16LE=I;function w(r,a,f){r[f+0]=a&255,a=a>>>8,r[f+1]=a&255}e.writeUInt16LE=w;function k(r,a){return r[a]*2**24+r[a+1]*2**16+r[a+2]*2**8+r[a+3]}e.readUInt32BE=k;function L(r,a,f){r[f+3]=a,a=a>>>8,r[f+2]=a,a=a>>>8,r[f+1]=a,a=a>>>8,r[f]=a}e.writeUInt32BE=L;function D(r,a){return r[a+0]<<0>>>0|r[a+1]<<8>>>0|r[a+2]<<16>>>0|r[a+3]<<24>>>0}e.readUInt32LE=D;function S(r,a,f){r[f+0]=a&255,a=a>>>8,r[f+1]=a&255,a=a>>>8,r[f+2]=a&255,a=a>>>8,r[f+3]=a&255}e.writeUInt32LE=S;function T(r,a){return r[a]}e.readUInt8=T;function E(r,a,f){r[f]=a}e.writeUInt8=E;function p(r){return l.consumeReadable(r,a=>_.concat(a))}e.readableToBuffer=p;function b(r){return l.toReadable(r)}e.bufferToReadable=b;function m(r){return l.consumeStream(r,a=>_.concat(a))}e.streamToBuffer=m;async function v(r){return r.ended?_.concat(r.buffer):_.concat([...r.buffer,await m(r.stream)])}e.bufferedStreamToBuffer=v;function h(r){return l.toStream(r,a=>_.concat(a))}e.bufferToStream=h;function c(r){return l.transform(r,{data:a=>typeof a=="string"?_.fromString(a):_.wrap(a)},a=>_.concat(a))}e.streamToBufferReadableStream=c;function g(r){return l.newWriteableStream(a=>_.concat(a),r)}e.newWriteableBufferStream=g;function n(r,a){return l.prefixedReadable(r,a,f=>_.concat(f))}e.prefixedBufferReadable=n;function u(r,a){return l.prefixedStream(r,a,f=>_.concat(f))}e.prefixedBufferStream=u;function s(r){let a=0,f=0,y=0;const R=new Uint8Array(Math.floor(r.length/4*3)),N=A=>{switch(f){case 3:R[y++]=a|A,f=0;break;case 2:R[y++]=a|A>>>2,a=A<<6,f=3;break;case 1:R[y++]=a|A>>>4,a=A<<4,f=2;break;default:a=A<<2,f=1}};for(let A=0;A<r.length;A++){const z=r.charCodeAt(A);if(z>=65&&z<=90)N(z-65);else if(z>=97&&z<=122)N(z-97+26);else if(z>=48&&z<=57)N(z-48+52);else if(z===43||z===45)N(62);else if(z===47||z===95)N(63);else{if(z===61)break;throw new SyntaxError(`Unexpected base64 character ${r[A]}`)}}const M=y;for(;f>0;)N(0);return _.wrap(R).slice(0,M)}e.decodeBase64=s;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function d({buffer:r},a=!0,f=!1){const y=f?o:i;let R="";const N=r.byteLength%3;let M=0;for(;M<r.byteLength-N;M+=3){const A=r[M+0],z=r[M+1],H=r[M+2];R+=y[A>>>2],R+=y[(A<<4|z>>>4)&63],R+=y[(z<<2|H>>>6)&63],R+=y[H&63]}if(N===1){const A=r[M+0];R+=y[A>>>2],R+=y[A<<4&63],a&&(R+="==")}else if(N===2){const A=r[M+0],z=r[M+1];R+=y[A>>>2],R+=y[(A<<4|z>>>4)&63],R+=y[z<<2&63],a&&(R+="=")}return R}e.encodeBase64=d}),define(De[16],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function l(u){return typeof u=="string"}e.isString=l;function t(u){return Array.isArray(u)&&u.every(s=>l(s))}e.isStringArray=t;function C(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}e.isObject=C;function P(u){const s=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof s}e.isTypedArray=P;function _(u){return typeof u=="number"&&!isNaN(u)}e.isNumber=_;function I(u){return!!u&&typeof u[Symbol.iterator]=="function"}e.isIterable=I;function w(u){return u===!0||u===!1}e.isBoolean=w;function k(u){return typeof u>"u"}e.isUndefined=k;function L(u){return!D(u)}e.isDefined=L;function D(u){return k(u)||u===null}e.isUndefinedOrNull=D;function S(u,s){if(!u)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}e.assertType=S;function T(u){if(D(u))throw new Error("Assertion Failed: argument is undefined or null");return u}e.assertIsDefined=T;function E(...u){const s=[];for(let i=0;i<u.length;i++){const o=u[i];if(D(o))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);s.push(o)}return s}e.assertAllDefined=E;const p=Object.prototype.hasOwnProperty;function b(u){if(!C(u))return!1;for(const s in u)if(p.call(u,s))return!1;return!0}e.isEmptyObject=b;function m(u){return typeof u=="function"}e.isFunction=m;function v(...u){return u.length>0&&u.every(m)}e.areFunctions=v;function h(u,s){const i=Math.min(u.length,s.length);for(let o=0;o<i;o++)c(u[o],s[o])}e.validateConstraints=h;function c(u,s){if(l(s)){if(typeof u!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(m(s)){try{if(u instanceof s)return}catch{}if(!D(u)&&u.constructor===s||s.length===1&&s.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function g(u){return u===null?void 0:u}e.withNullAsUndefined=g;function n(u){return typeof u>"u"?null:u}e.withUndefinedAsNull=n}),define(De[24],Ie([1,0,16]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const v=Array.isArray(m)?[]:{};return Object.keys(m).forEach(h=>{m[h]&&typeof m[h]=="object"?v[h]=t(m[h]):v[h]=m[h]}),v}e.deepClone=t;function C(m){if(!m||typeof m!="object")return m;const v=[m];for(;v.length>0;){const h=v.shift();Object.freeze(h);for(const c in h)if(P.call(h,c)){const g=h[c];typeof g=="object"&&!Object.isFrozen(g)&&!(0,l.isTypedArray)(g)&&v.push(g)}}return m}e.deepFreeze=C;const P=Object.prototype.hasOwnProperty;function _(m,v){return I(m,v,new Set)}e.cloneAndChange=_;function I(m,v,h){if((0,l.isUndefinedOrNull)(m))return m;const c=v(m);if(typeof c<"u")return c;if(Array.isArray(m)){const g=[];for(const n of m)g.push(I(n,v,h));return g}if((0,l.isObject)(m)){if(h.has(m))throw new Error("Cannot clone recursive data-structure");h.add(m);const g={};for(const n in m)P.call(m,n)&&(g[n]=I(m[n],v,h));return h.delete(m),g}return m}function w(m,v,h=!0){return(0,l.isObject)(m)?((0,l.isObject)(v)&&Object.keys(v).forEach(c=>{c in m?h&&((0,l.isObject)(m[c])&&(0,l.isObject)(v[c])?w(m[c],v[c],h):m[c]=v[c]):m[c]=v[c]}),m):v}e.mixin=w;function k(m,v){if(m===v)return!0;if(m==null||v===null||v===void 0||typeof m!=typeof v||typeof m!="object"||Array.isArray(m)!==Array.isArray(v))return!1;let h,c;if(Array.isArray(m)){if(m.length!==v.length)return!1;for(h=0;h<m.length;h++)if(!k(m[h],v[h]))return!1}else{const g=[];for(c in m)g.push(c);g.sort();const n=[];for(c in v)n.push(c);if(n.sort(),!k(g,n))return!1;for(h=0;h<g.length;h++)if(!k(m[g[h]],v[g[h]]))return!1}return!0}e.equals=k;function L(m){const v=new Set;return JSON.stringify(m,(h,c)=>{if((0,l.isObject)(c)||Array.isArray(c)){if(v.has(c))return"[Circular]";v.add(c)}return c})}e.safeStringify=L;function D(m,v){const h=Object.create(null);return!m||!v||Object.keys(v).forEach(g=>{const n=m[g],u=v[g];k(n,u)||(h[g]=u)}),h}e.distinct=D;function S(m,v){const h=v.toLowerCase(),c=Object.keys(m).find(g=>g.toLowerCase()===h);return c?m[c]:m[v]}e.getCaseInsensitive=S;function T(m,v){const h=Object.create(null);for(const[c,g]of Object.entries(m))v(c,g)&&(h[c]=g);return h}e.filter=T;function E(m){let v=[],h=Object.getPrototypeOf(m);for(;Object.prototype!==h;)v=v.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return v}e.getAllPropertyNames=E;function p(m){const v=[];for(const h of E(m))typeof m[h]=="function"&&v.push(h);return v}e.getAllMethodNames=p;function b(m,v){const h=g=>function(){const n=Array.prototype.slice.call(arguments,0);return v(g,n)},c={};for(const g of m)c[g]=h(g);return c}e.createProxyObject=b}),define(De[97],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var l;(function(P){P[P.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",P[P.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",P[P.MAX_UINT_8=255]="MAX_UINT_8",P[P.MAX_UINT_16=65535]="MAX_UINT_16",P[P.MAX_UINT_32=4294967295]="MAX_UINT_32",P[P.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(l=e.Constants||(e.Constants={}));function t(P){return P<0?0:P>255?255:P|0}e.toUint8=t;function C(P){return P<0?0:P>4294967295?4294967295:P|0}e.toUint32=C}),define(De[34],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const l=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(C){return l.test(C)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(I){for(let w=0;w<I.length;w++)I[w]=Math.floor(Math.random()*256);return I};const P=new Uint8Array(16),_=[];for(let I=0;I<256;I++)_.push(I.toString(16).padStart(2,"0"));return function(){C(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let w=0,k="";return k+=_[P[w++]],k+=_[P[w++]],k+=_[P[w++]],k+=_[P[w++]],k+="-",k+=_[P[w++]],k+=_[P[w++]],k+="-",k+=_[P[w++]],k+=_[P[w++]],k+="-",k+=_[P[w++]],k+=_[P[w++]],k+="-",k+=_[P[w++]],k+=_[P[w++]],k+=_[P[w++]],k+=_[P[w++]],k+=_[P[w++]],k+=_[P[w++]],k}}()}),define(De[98],Ie([1,0,97]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class t{constructor(I){const w=(0,l.toUint8)(I);this._defaultValue=w,this._asciiMap=t._createAsciiMap(w),this._map=new Map}static _createAsciiMap(I){const w=new Uint8Array(256);for(let k=0;k<256;k++)w[k]=I;return w}set(I,w){const k=(0,l.toUint8)(w);I>=0&&I<256?this._asciiMap[I]=k:this._map.set(I,k)}get(I){return I>=0&&I<256?this._asciiMap[I]:this._map.get(I)||this._defaultValue}}e.CharacterClassifier=t;var C;(function(_){_[_.False=0]="False",_[_.True=1]="True"})(C||(C={}));class P{constructor(){this._actual=new t(0)}add(I){this._actual.set(I,1)}has(I){return this._actual.get(I)===1}}e.CharacterSet=P}),define(De[49],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class l{constructor(C,P){this.lineNumber=C,this.column=P}with(C=this.lineNumber,P=this.column){return C===this.lineNumber&&P===this.column?this:new l(C,P)}delta(C=0,P=0){return this.with(this.lineNumber+C,this.column+P)}equals(C){return l.equals(this,C)}static equals(C,P){return!C&&!P?!0:!!C&&!!P&&C.lineNumber===P.lineNumber&&C.column===P.column}isBefore(C){return l.isBefore(this,C)}static isBefore(C,P){return C.lineNumber<P.lineNumber?!0:P.lineNumber<C.lineNumber?!1:C.column<P.column}isBeforeOrEqual(C){return l.isBeforeOrEqual(this,C)}static isBeforeOrEqual(C,P){return C.lineNumber<P.lineNumber?!0:P.lineNumber<C.lineNumber?!1:C.column<=P.column}static compare(C,P){const _=C.lineNumber|0,I=P.lineNumber|0;if(_===I){const w=C.column|0,k=P.column|0;return w-k}return _-I}clone(){return new l(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(C){return new l(C.lineNumber,C.column)}static isIPosition(C){return C&&typeof C.lineNumber=="number"&&typeof C.column=="number"}}e.Position=l}),define(De[35],Ie([1,0,49]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(P,_,I,w){P>I||P===I&&_>w?(this.startLineNumber=I,this.startColumn=w,this.endLineNumber=P,this.endColumn=_):(this.startLineNumber=P,this.startColumn=_,this.endLineNumber=I,this.endColumn=w)}isEmpty(){return t.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return t.containsPosition(this,P)}static containsPosition(P,_){return!(_.lineNumber<P.startLineNumber||_.lineNumber>P.endLineNumber||_.lineNumber===P.startLineNumber&&_.column<P.startColumn||_.lineNumber===P.endLineNumber&&_.column>P.endColumn)}static strictContainsPosition(P,_){return!(_.lineNumber<P.startLineNumber||_.lineNumber>P.endLineNumber||_.lineNumber===P.startLineNumber&&_.column<=P.startColumn||_.lineNumber===P.endLineNumber&&_.column>=P.endColumn)}containsRange(P){return t.containsRange(this,P)}static containsRange(P,_){return!(_.startLineNumber<P.startLineNumber||_.endLineNumber<P.startLineNumber||_.startLineNumber>P.endLineNumber||_.endLineNumber>P.endLineNumber||_.startLineNumber===P.startLineNumber&&_.startColumn<P.startColumn||_.endLineNumber===P.endLineNumber&&_.endColumn>P.endColumn)}strictContainsRange(P){return t.strictContainsRange(this,P)}static strictContainsRange(P,_){return!(_.startLineNumber<P.startLineNumber||_.endLineNumber<P.startLineNumber||_.startLineNumber>P.endLineNumber||_.endLineNumber>P.endLineNumber||_.startLineNumber===P.startLineNumber&&_.startColumn<=P.startColumn||_.endLineNumber===P.endLineNumber&&_.endColumn>=P.endColumn)}plusRange(P){return t.plusRange(this,P)}static plusRange(P,_){let I,w,k,L;return _.startLineNumber<P.startLineNumber?(I=_.startLineNumber,w=_.startColumn):_.startLineNumber===P.startLineNumber?(I=_.startLineNumber,w=Math.min(_.startColumn,P.startColumn)):(I=P.startLineNumber,w=P.startColumn),_.endLineNumber>P.endLineNumber?(k=_.endLineNumber,L=_.endColumn):_.endLineNumber===P.endLineNumber?(k=_.endLineNumber,L=Math.max(_.endColumn,P.endColumn)):(k=P.endLineNumber,L=P.endColumn),new t(I,w,k,L)}intersectRanges(P){return t.intersectRanges(this,P)}static intersectRanges(P,_){let I=P.startLineNumber,w=P.startColumn,k=P.endLineNumber,L=P.endColumn;const D=_.startLineNumber,S=_.startColumn,T=_.endLineNumber,E=_.endColumn;return I<D?(I=D,w=S):I===D&&(w=Math.max(w,S)),k>T?(k=T,L=E):k===T&&(L=Math.min(L,E)),I>k||I===k&&w>L?null:new t(I,w,k,L)}equalsRange(P){return t.equalsRange(this,P)}static equalsRange(P,_){return!!P&&!!_&&P.startLineNumber===_.startLineNumber&&P.startColumn===_.startColumn&&P.endLineNumber===_.endLineNumber&&P.endColumn===_.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(P){return new l.Position(P.endLineNumber,P.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(P){return new l.Position(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,_){return new t(this.startLineNumber,this.startColumn,P,_)}setStartPosition(P,_){return new t(P,_,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}delta(P){return new t(this.startLineNumber+P,this.startColumn,this.endLineNumber+P,this.endColumn)}static collapseToStart(P){return new t(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}static fromPositions(P,_=P){return new t(P.lineNumber,P.column,_.lineNumber,_.column)}static lift(P){return P?new t(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,_){return!(P.endLineNumber<_.startLineNumber||P.endLineNumber===_.startLineNumber&&P.endColumn<_.startColumn||_.endLineNumber<P.startLineNumber||_.endLineNumber===P.startLineNumber&&_.endColumn<P.startColumn)}static areIntersecting(P,_){return!(P.endLineNumber<_.startLineNumber||P.endLineNumber===_.startLineNumber&&P.endColumn<=_.startColumn||_.endLineNumber<P.startLineNumber||_.endLineNumber===P.startLineNumber&&_.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,_){if(P&&_){const k=P.startLineNumber|0,L=_.startLineNumber|0;if(k===L){const D=P.startColumn|0,S=_.startColumn|0;if(D===S){const T=P.endLineNumber|0,E=_.endLineNumber|0;if(T===E){const p=P.endColumn|0,b=_.endColumn|0;return p-b}return T-E}return D-S}return k-L}return(P?1:0)-(_?1:0)}static compareRangesUsingEnds(P,_){return P.endLineNumber===_.endLineNumber?P.endColumn===_.endColumn?P.startLineNumber===_.startLineNumber?P.startColumn-_.startColumn:P.startLineNumber-_.startLineNumber:P.endColumn-_.endColumn:P.endLineNumber-_.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}toJSON(){return this}}e.Range=t}),define(De[146],Ie([1,0,49,35]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var C;(function(_){_[_.LTR=0]="LTR",_[_.RTL=1]="RTL"})(C=e.SelectionDirection||(e.SelectionDirection={}));class P extends t.Range{constructor(I,w,k,L){super(I,w,k,L),this.selectionStartLineNumber=I,this.selectionStartColumn=w,this.positionLineNumber=k,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(I){return P.selectionsEqual(this,I)}static selectionsEqual(I,w){return I.selectionStartLineNumber===w.selectionStartLineNumber&&I.selectionStartColumn===w.selectionStartColumn&&I.positionLineNumber===w.positionLineNumber&&I.positionColumn===w.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(I,w){return this.getDirection()===0?new P(this.startLineNumber,this.startColumn,I,w):new P(I,w,this.startLineNumber,this.startColumn)}getPosition(){return new l.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new l.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(I,w){return this.getDirection()===0?new P(I,w,this.endLineNumber,this.endColumn):new P(this.endLineNumber,this.endColumn,I,w)}static fromPositions(I,w=I){return new P(I.lineNumber,I.column,w.lineNumber,w.column)}static fromRange(I,w){return w===0?new P(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn):new P(I.endLineNumber,I.endColumn,I.startLineNumber,I.startColumn)}static liftSelection(I){return new P(I.selectionStartLineNumber,I.selectionStartColumn,I.positionLineNumber,I.positionColumn)}static selectionsArrEqual(I,w){if(I&&!w||!I&&w)return!1;if(!I&&!w)return!0;if(I.length!==w.length)return!1;for(let k=0,L=I.length;k<L;k++)if(!this.selectionsEqual(I[k],w[k]))return!1;return!0}static isISelection(I){return I&&typeof I.selectionStartLineNumber=="number"&&typeof I.selectionStartColumn=="number"&&typeof I.positionLineNumber=="number"&&typeof I.positionColumn=="number"}static createWithDirection(I,w,k,L,D){return D===0?new P(I,w,k,L):new P(k,L,I,w)}}e.Selection=P}),define(De[147],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(De[148],Ie([1,0,98]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var t;(function(_){_[_.Regular=0]="Regular",_[_.Whitespace=1]="Whitespace",_[_.WordSeparator=2]="WordSeparator"})(t=e.WordCharacterClass||(e.WordCharacterClass={}));class C extends l.CharacterClassifier{constructor(I){super(0);for(let w=0,k=I.length;w<k;w++)this.set(I.charCodeAt(w),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=C;function P(_){const I={};return w=>(I.hasOwnProperty(w)||(I[w]=_(w)),I[w])}e.getMapForWordSeparators=P(_=>new C(_))}),define(De[99],Ie([1,0,61,6,77]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function P(D=""){let S="(-?\\d*\\.\\d\\w*)|([^";for(const T of e.USUAL_WORD_SEPARATORS)D.indexOf(T)>=0||(S+="\\"+T);return S+="\\s]+)",new RegExp(S,"g")}e.DEFAULT_WORD_REGEXP=P();function _(D){let S=e.DEFAULT_WORD_REGEXP;if(D&&D instanceof RegExp)if(D.global)S=D;else{let T="g";D.ignoreCase&&(T+="i"),D.multiline&&(T+="m"),D.unicode&&(T+="u"),S=new RegExp(D.source,T)}return S.lastIndex=0,S}e.ensureValidWordDefinition=_;const I=new C.LinkedList;I.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function w(D){const S=I.unshift(D);return(0,t.toDisposable)(S)}e.setDefaultGetWordAtTextConfig=w;function k(D,S,T,E,p){if(p||(p=l.Iterable.first(I)),T.length>p.maxLen){let c=D-p.maxLen/2;return c<0?c=0:E+=c,T=T.substring(c,D+p.maxLen/2),k(D,S,T,E,p)}const b=Date.now(),m=D-1-E;let v=-1,h=null;for(let c=1;!(Date.now()-b>=p.timeBudget);c++){const g=m-p.windowSize*c;S.lastIndex=Math.max(0,g);const n=L(S,T,m,v);if(!n&&h||(h=n,g<=0))break;v=g}if(h){const c={word:h[0],startColumn:E+1+h.index,endColumn:E+1+h.index+h[0].length};return S.lastIndex=0,c}return null}e.getWordAtText=k;function L(D,S,T,E){let p;for(;p=D.exec(S);){const b=p.index||0;if(b<=T&&D.lastIndex>=T)return p;if(E>0&&b>E)return null}return null}}),define(De[149],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var l;(function(_){_[_.None=0]="None",_[_.Indent=1]="Indent",_[_.IndentOutdent=2]="IndentOutdent",_[_.Outdent=3]="Outdent"})(l=e.IndentAction||(e.IndentAction={}));class t{constructor(I){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=I.open,this.close=I.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(I.notIn))for(let w=0,k=I.notIn.length;w<k;w++)switch(I.notIn[w]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(I){switch(I){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(I,w){if(I.getTokenCount()===0)return!0;const k=I.findTokenIndexAtOffset(w-2),L=I.getStandardTokenType(k);return this.isOK(L)}_findNeutralCharacterInRange(I,w){for(let k=I;k<=w;k++){const L=String.fromCharCode(k);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=t;class C{constructor(I){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const w of I)P(this.autoClosingPairsOpenByStart,w.open.charAt(0),w),P(this.autoClosingPairsOpenByEnd,w.open.charAt(w.open.length-1),w),P(this.autoClosingPairsCloseByStart,w.close.charAt(0),w),P(this.autoClosingPairsCloseByEnd,w.close.charAt(w.close.length-1),w),w.close.length===1&&w.open.length===1&&P(this.autoClosingPairsCloseSingleChar,w.close,w)}}e.AutoClosingPairs=C;function P(_,I,w){_.has(I)?_.get(I).push(w):_.set(I,[w])}}),define(De[150],Ie([1,0,98]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var t;(function(T){T[T.Invalid=0]="Invalid",T[T.Start=1]="Start",T[T.H=2]="H",T[T.HT=3]="HT",T[T.HTT=4]="HTT",T[T.HTTP=5]="HTTP",T[T.F=6]="F",T[T.FI=7]="FI",T[T.FIL=8]="FIL",T[T.BeforeColon=9]="BeforeColon",T[T.AfterColon=10]="AfterColon",T[T.AlmostThere=11]="AlmostThere",T[T.End=12]="End",T[T.Accept=13]="Accept",T[T.LastKnownState=14]="LastKnownState"})(t=e.State||(e.State={}));class C{constructor(E,p,b){const m=new Uint8Array(E*p);for(let v=0,h=E*p;v<h;v++)m[v]=b;this._data=m,this.rows=E,this.cols=p}get(E,p){return this._data[E*this.cols+p]}set(E,p,b){this._data[E*this.cols+p]=b}}e.Uint8Matrix=C;class P{constructor(E){let p=0,b=0;for(let v=0,h=E.length;v<h;v++){const[c,g,n]=E[v];g>p&&(p=g),c>b&&(b=c),n>b&&(b=n)}p++,b++;const m=new C(b,p,0);for(let v=0,h=E.length;v<h;v++){const[c,g,n]=E[v];m.set(c,g,n)}this._states=m,this._maxCharCode=p}nextState(E,p){return p<0||p>=this._maxCharCode?0:this._states.get(E,p)}}e.StateMachine=P;let _=null;function I(){return _===null&&(_=new P([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),_}var w;(function(T){T[T.None=0]="None",T[T.ForceTermination=1]="ForceTermination",T[T.CannotEndIn=2]="CannotEndIn"})(w||(w={}));let k=null;function L(){if(k===null){k=new l.CharacterClassifier(0);const T=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let p=0;p<T.length;p++)k.set(T.charCodeAt(p),1);const E=".,;:";for(let p=0;p<E.length;p++)k.set(E.charCodeAt(p),2)}return k}class D{static _createLink(E,p,b,m,v){let h=v-1;do{const c=p.charCodeAt(h);if(E.get(c)!==2)break;h--}while(h>m);if(m>0){const c=p.charCodeAt(m-1),g=p.charCodeAt(h);(c===40&&g===41||c===91&&g===93||c===123&&g===125)&&h--}return{range:{startLineNumber:b,startColumn:m+1,endLineNumber:b,endColumn:h+2},url:p.substring(m,h+1)}}static computeLinks(E,p=I()){const b=L(),m=[];for(let v=1,h=E.getLineCount();v<=h;v++){const c=E.getLineContent(v),g=c.length;let n=0,u=0,s=0,i=1,o=!1,d=!1,r=!1,a=!1;for(;n<g;){let f=!1;const y=c.charCodeAt(n);if(i===13){let R;switch(y){case 40:o=!0,R=0;break;case 41:R=o?0:1;break;case 91:r=!0,d=!0,R=0;break;case 93:r=!1,R=d?0:1;break;case 123:a=!0,R=0;break;case 125:R=a?0:1;break;case 39:R=s===39?1:0;break;case 34:R=s===34?1:0;break;case 96:R=s===96?1:0;break;case 42:R=s===42?1:0;break;case 124:R=s===124?1:0;break;case 32:R=r?0:1;break;default:R=b.get(y)}R===1&&(m.push(D._createLink(b,c,v,u,n)),f=!0)}else if(i===12){let R;y===91?(d=!0,R=0):R=b.get(y),R===1?f=!0:i=13}else i=p.nextState(i,y),i===0&&(f=!0);f&&(i=1,o=!1,d=!1,a=!1,u=n+1,s=y),n++}i===13&&m.push(D._createLink(b,c,v,u,g))}return m}}e.LinkComputer=D;function S(T){return!T||typeof T.getLineCount!="function"||typeof T.getLineContent!="function"?[]:D.computeLinks(T)}e.computeLinks=S}),define(De[100],Ie([1,0,24]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var t;(function(h){h[h.Left=1]="Left",h[h.Center=2]="Center",h[h.Right=4]="Right",h[h.Full=7]="Full"})(t=e.OverviewRulerLane||(e.OverviewRulerLane={}));var C;(function(h){h[h.Inline=1]="Inline",h[h.Gutter=2]="Gutter"})(C=e.MinimapPosition||(e.MinimapPosition={}));var P;(function(h){h[h.Both=0]="Both",h[h.Right=1]="Right",h[h.Left=2]="Left",h[h.None=3]="None"})(P=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var _;(function(h){h[h.TextDefined=0]="TextDefined",h[h.LF=1]="LF",h[h.CRLF=2]="CRLF"})(_=e.EndOfLinePreference||(e.EndOfLinePreference={}));var I;(function(h){h[h.LF=1]="LF",h[h.CRLF=2]="CRLF"})(I=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var w;(function(h){h[h.LF=0]="LF",h[h.CRLF=1]="CRLF"})(w=e.EndOfLineSequence||(e.EndOfLineSequence={}));class k{constructor(c){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,c.tabSize|0),this.indentSize=c.tabSize|0,this.insertSpaces=Boolean(c.insertSpaces),this.defaultEOL=c.defaultEOL|0,this.trimAutoWhitespace=Boolean(c.trimAutoWhitespace),this.bracketPairColorizationOptions=c.bracketPairColorizationOptions}equals(c){return this.tabSize===c.tabSize&&this.indentSize===c.indentSize&&this.insertSpaces===c.insertSpaces&&this.defaultEOL===c.defaultEOL&&this.trimAutoWhitespace===c.trimAutoWhitespace&&(0,l.equals)(this.bracketPairColorizationOptions,c.bracketPairColorizationOptions)}createChangeEvent(c){return{tabSize:this.tabSize!==c.tabSize,indentSize:this.indentSize!==c.indentSize,insertSpaces:this.insertSpaces!==c.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==c.trimAutoWhitespace}}}e.TextModelResolvedOptions=k;class L{constructor(c,g){this._findMatchBrand=void 0,this.range=c,this.matches=g}}e.FindMatch=L;var D;(function(h){h[h.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",h[h.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",h[h.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",h[h.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(D=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function S(h){return h&&typeof h.read=="function"}e.isITextSnapshot=S;var T;(function(h){h[h.Left=0]="Left",h[h.Right=1]="Right",h[h.None=2]="None",h[h.LeftOfInjectedText=3]="LeftOfInjectedText",h[h.RightOfInjectedText=4]="RightOfInjectedText"})(T=e.PositionAffinity||(e.PositionAffinity={}));var E;(function(h){h[h.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(E=e.ModelConstants||(e.ModelConstants={}));class p{constructor(c,g,n,u,s,i){this.identifier=c,this.range=g,this.text=n,this.forceMoveMarkers=u,this.isAutoWhitespaceEdit=s,this._isTracked=i}}e.ValidAnnotatedEditOperation=p;class b{constructor(c,g,n){this.regex=c,this.wordSeparators=g,this.simpleSearch=n}}e.SearchData=b;class m{constructor(c,g,n){this.reverseEdits=c,this.changes=g,this.trimAutoWhitespaceLineNumbers=n}}e.ApplyEditsResult=m;function v(h){return!h.isTooLargeForSyncing()&&!h.isForSimpleWidget}e.shouldSynchronizeModel=v}),define(De[151],Ie([1,0,17,97]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class C{constructor(w){this.values=w,this.prefixSum=new Uint32Array(w.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(w,k){w=(0,t.toUint32)(w);const L=this.values,D=this.prefixSum,S=k.length;return S===0?!1:(this.values=new Uint32Array(L.length+S),this.values.set(L.subarray(0,w),0),this.values.set(L.subarray(w),w+S),this.values.set(k,w),w-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=w-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(D.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(w,k){return w=(0,t.toUint32)(w),k=(0,t.toUint32)(k),this.values[w]===k?!1:(this.values[w]=k,w-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=w-1),!0)}removeValues(w,k){w=(0,t.toUint32)(w),k=(0,t.toUint32)(k);const L=this.values,D=this.prefixSum;if(w>=L.length)return!1;const S=L.length-w;return k>=S&&(k=S),k===0?!1:(this.values=new Uint32Array(L.length-k),this.values.set(L.subarray(0,w),0),this.values.set(L.subarray(w+k),w),this.prefixSum=new Uint32Array(this.values.length),w-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=w-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(D.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(w){return w<0?0:(w=(0,t.toUint32)(w),this._getPrefixSum(w))}_getPrefixSum(w){if(w<=this.prefixSumValidIndex[0])return this.prefixSum[w];let k=this.prefixSumValidIndex[0]+1;k===0&&(this.prefixSum[0]=this.values[0],k++),w>=this.values.length&&(w=this.values.length-1);for(let L=k;L<=w;L++)this.prefixSum[L]=this.prefixSum[L-1]+this.values[L];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],w),this.prefixSum[w]}getIndexOf(w){w=Math.floor(w),this.getTotalSum();let k=0,L=this.values.length-1,D=0,S=0,T=0;for(;k<=L;)if(D=k+(L-k)/2|0,S=this.prefixSum[D],T=S-this.values[D],w<T)L=D-1;else if(w>=S)k=D+1;else break;return new _(D,w-T)}}e.PrefixSumComputer=C;class P{constructor(w){this._values=w,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(w){return this._ensureValid(),w===0?0:this._prefixSum[w-1]}getIndexOf(w){this._ensureValid();const k=this._indexBySum[w],L=k>0?this._prefixSum[k-1]:0;return new _(k,w-L)}removeValues(w,k){this._values.splice(w,k),this._invalidate(w)}insertValues(w,k){this._values=(0,l.arrayInsert)(this._values,w,k),this._invalidate(w)}_invalidate(w){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,w-1)}_ensureValid(){if(!this._isValid){for(let w=this._validEndIndex+1,k=this._values.length;w<k;w++){const L=this._values[w],D=w>0?this._prefixSum[w-1]:0;this._prefixSum[w]=D+L;for(let S=0;S<L;S++)this._indexBySum[D+S]=w}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(w,k){this._values[w]!==k&&(this._values[w]=k,this._invalidate(w))}}e.ConstantTimePrefixSumComputer=P;class _{constructor(w,k){this.index=w,this.remainder=k,this._prefixSumIndexOfResultBrand=void 0,this.index=w,this.remainder=k}}e.PrefixSumIndexOfResult=_}),define(De[152],Ie([19,20]),function(J,e){return J.create("vs/base/common/date",e)}),define(De[153],Ie([1,0,152]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,C=t*60,P=C*24,_=P*7,I=P*30,w=P*365;function k(D,S,T){typeof D!="number"&&(D=D.getTime());const E=Math.round((new Date().getTime()-D)/1e3);if(E<-30)return(0,l.localize)(0,null,k(new Date().getTime()+E*1e3,!1));if(E<30)return(0,l.localize)(1,null);let p;return E<t?(p=E,S?p===1?T?(0,l.localize)(2,null,p):(0,l.localize)(3,null,p):T?(0,l.localize)(4,null,p):(0,l.localize)(5,null,p):p===1?T?(0,l.localize)(6,null,p):(0,l.localize)(7,null,p):T?(0,l.localize)(8,null,p):(0,l.localize)(9,null,p)):E<C?(p=Math.floor(E/t),S?p===1?T?(0,l.localize)(10,null,p):(0,l.localize)(11,null,p):T?(0,l.localize)(12,null,p):(0,l.localize)(13,null,p):p===1?T?(0,l.localize)(14,null,p):(0,l.localize)(15,null,p):T?(0,l.localize)(16,null,p):(0,l.localize)(17,null,p)):E<P?(p=Math.floor(E/C),S?p===1?T?(0,l.localize)(18,null,p):(0,l.localize)(19,null,p):T?(0,l.localize)(20,null,p):(0,l.localize)(21,null,p):p===1?T?(0,l.localize)(22,null,p):(0,l.localize)(23,null,p):T?(0,l.localize)(24,null,p):(0,l.localize)(25,null,p)):E<_?(p=Math.floor(E/P),S?p===1?(0,l.localize)(26,null,p):(0,l.localize)(27,null,p):p===1?(0,l.localize)(28,null,p):(0,l.localize)(29,null,p)):E<I?(p=Math.floor(E/_),S?p===1?T?(0,l.localize)(30,null,p):(0,l.localize)(31,null,p):T?(0,l.localize)(32,null,p):(0,l.localize)(33,null,p):p===1?T?(0,l.localize)(34,null,p):(0,l.localize)(35,null,p):T?(0,l.localize)(36,null,p):(0,l.localize)(37,null,p)):E<w?(p=Math.floor(E/I),S?p===1?T?(0,l.localize)(38,null,p):(0,l.localize)(39,null,p):T?(0,l.localize)(40,null,p):(0,l.localize)(41,null,p):p===1?T?(0,l.localize)(42,null,p):(0,l.localize)(43,null,p):T?(0,l.localize)(44,null,p):(0,l.localize)(45,null,p)):(p=Math.floor(E/w),S?p===1?T?(0,l.localize)(46,null,p):(0,l.localize)(47,null,p):T?(0,l.localize)(48,null,p):(0,l.localize)(49,null,p):p===1?T?(0,l.localize)(50,null,p):(0,l.localize)(51,null,p):T?(0,l.localize)(52,null,p):(0,l.localize)(53,null,p))}e.fromNow=k;function L(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(De[154],Ie([19,20]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(De[50],Ie([1,0,17,16,154]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function P(D,S){return S&&(D.stack||D.stacktrace)?C.localize(0,null,I(D),_(D.stack)||_(D.stacktrace)):I(D)}function _(D){return Array.isArray(D)?D.join(`
`):D}function I(D){return typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?C.localize(1,null,D.message):D.message||C.localize(2,null)}function w(D=null,S=!1){if(!D)return C.localize(3,null);if(Array.isArray(D)){const T=l.coalesce(D),E=w(T[0],S);return T.length>1?C.localize(4,null,E,T.length):E}if(t.isString(D))return D;if(D.detail){const T=D.detail;if(T.error)return P(T.error,S);if(T.exception)return P(T.exception,S)}return D.stack?P(D,S):D.message?D.message:C.localize(5,null)}e.toErrorMessage=w;function k(D){const S=D;return S instanceof Error&&Array.isArray(S.actions)}e.isErrorWithActions=k;function L(D,S){let T;return typeof D=="string"?T=new Error(D):T=D,T.actions=S,T}e.createErrorWithActions=L}),define(De[155],Ie([19,20]),function(J,e){return J.create("vs/base/common/platform",e)}),define(De[11],Ie([1,0,155]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,C=!1,P=!1,_=!1,I=!1,w=!1,k=!1,L=!1,D=!1,S=!1,T,E=e.LANGUAGE_DEFAULT,p,b;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let m;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?m=e.globals.vscode.process:typeof process<"u"&&(m=process);const v=typeof m?.versions?.electron=="string",h=v&&m?.type==="renderer";if(typeof navigator=="object"&&!h)b=navigator.userAgent,t=b.indexOf("Windows")>=0,C=b.indexOf("Macintosh")>=0,L=(b.indexOf("Macintosh")>=0||b.indexOf("iPad")>=0||b.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=b.indexOf("Linux")>=0,S=b?.indexOf("Mobi")>=0,w=!0,T=l.getConfiguredDefaultLocale(l.localize(0,null))||e.LANGUAGE_DEFAULT,E=T;else if(typeof m=="object"){t=m.platform==="win32",C=m.platform==="darwin",P=m.platform==="linux",_=P&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,k=v,D=!!m.env.CI||!!m.env.BUILD_ARTIFACTSTAGINGDIRECTORY,T=e.LANGUAGE_DEFAULT,E=e.LANGUAGE_DEFAULT;const r=m.env.VSCODE_NLS_CONFIG;if(r)try{const a=JSON.parse(r),f=a.availableLanguages["*"];T=a.locale,E=f||e.LANGUAGE_DEFAULT,p=a._translationsConfigFile}catch{}I=!0}else console.error("Unable to resolve platform.");var c;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(c=e.Platform||(e.Platform={}));function g(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=g;let n=0;C?n=1:t?n=3:P&&(n=2),e.isWindows=t,e.isMacintosh=C,e.isLinux=P,e.isLinuxSnap=_,e.isNative=I,e.isElectron=k,e.isWeb=w,e.isWebWorker=w&&typeof e.globals.importScripts=="function",e.isIOS=L,e.isMobile=S,e.isCI=D,e.platform=n,e.userAgent=b,e.language=E;var u;(function(r){function a(){return e.language}r.value=a;function f(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=f;function y(){return e.language==="en"}r.isDefault=y})(u=e.Language||(e.Language={})),e.locale=T,e.translationsConfigFile=p,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const r=[];e.globals.addEventListener("message",f=>{if(f.data&&f.data.vscodeScheduleAsyncWork)for(let y=0,R=r.length;y<R;y++){const N=r[y];if(N.id===f.data.vscodeScheduleAsyncWork){r.splice(y,1),N.callback();return}}});let a=0;return f=>{const y=++a;r.push({id:y,callback:f}),e.globals.postMessage({vscodeScheduleAsyncWork:y},"*")}}return r=>setTimeout(r)})();var s;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=C||L?2:t?1:3;let i=!0,o=!1;function d(){if(!o){o=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,i=new Uint16Array(r.buffer)[0]===(2<<8)+1}return i}e.isLittleEndian=d,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(De[41],Ie([1,0,11]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof l.globals.vscode<"u"&&typeof l.globals.vscode.process<"u"){const C=l.globals.vscode.process;t={get platform(){return C.platform},get arch(){return C.arch},get env(){return C.env},cwd(){return C.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return l.isWindows?"win32":l.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(De[9],Ie([1,0,41]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,C=97,P=90,_=122,I=46,w=47,k=92,L=58,D=63;class S extends Error{constructor(c,g,n){let u;typeof g=="string"&&g.indexOf("not ")===0?(u="must not be",g=g.replace(/^not /,"")):u="must be";const s=c.indexOf(".")!==-1?"property":"argument";let i=`The "${c}" ${s} ${u} of type ${g}`;i+=`. Received type ${typeof n}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function T(h,c){if(typeof h!="string")throw new S(c,"string",h)}function E(h){return h===w||h===k}function p(h){return h===w}function b(h){return h>=t&&h<=P||h>=C&&h<=_}function m(h,c,g,n){let u="",s=0,i=-1,o=0,d=0;for(let r=0;r<=h.length;++r){if(r<h.length)d=h.charCodeAt(r);else{if(n(d))break;d=w}if(n(d)){if(!(i===r-1||o===1))if(o===2){if(u.length<2||s!==2||u.charCodeAt(u.length-1)!==I||u.charCodeAt(u.length-2)!==I){if(u.length>2){const a=u.lastIndexOf(g);a===-1?(u="",s=0):(u=u.slice(0,a),s=u.length-1-u.lastIndexOf(g)),i=r,o=0;continue}else if(u.length!==0){u="",s=0,i=r,o=0;continue}}c&&(u+=u.length>0?`${g}..`:"..",s=2)}else u.length>0?u+=`${g}${h.slice(i+1,r)}`:u=h.slice(i+1,r),s=r-i-1;i=r,o=0}else d===I&&o!==-1?++o:o=-1}return u}function v(h,c){if(c===null||typeof c!="object")throw new S("pathObject","Object",c);const g=c.dir||c.root,n=c.base||`${c.name||""}${c.ext||""}`;return g?g===c.root?`${g}${n}`:`${g}${h}${n}`:n}e.win32={resolve(...h){let c="",g="",n=!1;for(let u=h.length-1;u>=-1;u--){let s;if(u>=0){if(s=h[u],T(s,"path"),s.length===0)continue}else c.length===0?s=l.cwd():(s=l.env[`=${c}`]||l.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==c.toLowerCase()&&s.charCodeAt(2)===k)&&(s=`${c}\\`));const i=s.length;let o=0,d="",r=!1;const a=s.charCodeAt(0);if(i===1)E(a)&&(o=1,r=!0);else if(E(a))if(r=!0,E(s.charCodeAt(1))){let f=2,y=f;for(;f<i&&!E(s.charCodeAt(f));)f++;if(f<i&&f!==y){const R=s.slice(y,f);for(y=f;f<i&&E(s.charCodeAt(f));)f++;if(f<i&&f!==y){for(y=f;f<i&&!E(s.charCodeAt(f));)f++;(f===i||f!==y)&&(d=`\\\\${R}\\${s.slice(y,f)}`,o=f)}}}else o=1;else b(a)&&s.charCodeAt(1)===L&&(d=s.slice(0,2),o=2,i>2&&E(s.charCodeAt(2))&&(r=!0,o=3));if(d.length>0)if(c.length>0){if(d.toLowerCase()!==c.toLowerCase())continue}else c=d;if(n){if(c.length>0)break}else if(g=`${s.slice(o)}\\${g}`,n=r,r&&c.length>0)break}return g=m(g,!n,"\\",E),n?`${c}\\${g}`:`${c}${g}`||"."},normalize(h){T(h,"path");const c=h.length;if(c===0)return".";let g=0,n,u=!1;const s=h.charCodeAt(0);if(c===1)return p(s)?"\\":h;if(E(s))if(u=!0,E(h.charCodeAt(1))){let o=2,d=o;for(;o<c&&!E(h.charCodeAt(o));)o++;if(o<c&&o!==d){const r=h.slice(d,o);for(d=o;o<c&&E(h.charCodeAt(o));)o++;if(o<c&&o!==d){for(d=o;o<c&&!E(h.charCodeAt(o));)o++;if(o===c)return`\\\\${r}\\${h.slice(d)}\\`;o!==d&&(n=`\\\\${r}\\${h.slice(d,o)}`,g=o)}}}else g=1;else b(s)&&h.charCodeAt(1)===L&&(n=h.slice(0,2),g=2,c>2&&E(h.charCodeAt(2))&&(u=!0,g=3));let i=g<c?m(h.slice(g),!u,"\\",E):"";return i.length===0&&!u&&(i="."),i.length>0&&E(h.charCodeAt(c-1))&&(i+="\\"),n===void 0?u?`\\${i}`:i:u?`${n}\\${i}`:`${n}${i}`},isAbsolute(h){T(h,"path");const c=h.length;if(c===0)return!1;const g=h.charCodeAt(0);return E(g)||c>2&&b(g)&&h.charCodeAt(1)===L&&E(h.charCodeAt(2))},join(...h){if(h.length===0)return".";let c,g;for(let s=0;s<h.length;++s){const i=h[s];T(i,"path"),i.length>0&&(c===void 0?c=g=i:c+=`\\${i}`)}if(c===void 0)return".";let n=!0,u=0;if(typeof g=="string"&&E(g.charCodeAt(0))){++u;const s=g.length;s>1&&E(g.charCodeAt(1))&&(++u,s>2&&(E(g.charCodeAt(2))?++u:n=!1))}if(n){for(;u<c.length&&E(c.charCodeAt(u));)u++;u>=2&&(c=`\\${c.slice(u)}`)}return e.win32.normalize(c)},relative(h,c){if(T(h,"from"),T(c,"to"),h===c)return"";const g=e.win32.resolve(h),n=e.win32.resolve(c);if(g===n||(h=g.toLowerCase(),c=n.toLowerCase(),h===c))return"";let u=0;for(;u<h.length&&h.charCodeAt(u)===k;)u++;let s=h.length;for(;s-1>u&&h.charCodeAt(s-1)===k;)s--;const i=s-u;let o=0;for(;o<c.length&&c.charCodeAt(o)===k;)o++;let d=c.length;for(;d-1>o&&c.charCodeAt(d-1)===k;)d--;const r=d-o,a=i<r?i:r;let f=-1,y=0;for(;y<a;y++){const N=h.charCodeAt(u+y);if(N!==c.charCodeAt(o+y))break;N===k&&(f=y)}if(y!==a){if(f===-1)return n}else{if(r>a){if(c.charCodeAt(o+y)===k)return n.slice(o+y+1);if(y===2)return n.slice(o+y)}i>a&&(h.charCodeAt(u+y)===k?f=y:y===2&&(f=3)),f===-1&&(f=0)}let R="";for(y=u+f+1;y<=s;++y)(y===s||h.charCodeAt(y)===k)&&(R+=R.length===0?"..":"\\..");return o+=f,R.length>0?`${R}${n.slice(o,d)}`:(n.charCodeAt(o)===k&&++o,n.slice(o,d))},toNamespacedPath(h){if(typeof h!="string")return h;if(h.length===0)return"";const c=e.win32.resolve(h);if(c.length<=2)return h;if(c.charCodeAt(0)===k){if(c.charCodeAt(1)===k){const g=c.charCodeAt(2);if(g!==D&&g!==I)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(b(c.charCodeAt(0))&&c.charCodeAt(1)===L&&c.charCodeAt(2)===k)return`\\\\?\\${c}`;return h},dirname(h){T(h,"path");const c=h.length;if(c===0)return".";let g=-1,n=0;const u=h.charCodeAt(0);if(c===1)return E(u)?h:".";if(E(u)){if(g=n=1,E(h.charCodeAt(1))){let o=2,d=o;for(;o<c&&!E(h.charCodeAt(o));)o++;if(o<c&&o!==d){for(d=o;o<c&&E(h.charCodeAt(o));)o++;if(o<c&&o!==d){for(d=o;o<c&&!E(h.charCodeAt(o));)o++;if(o===c)return h;o!==d&&(g=n=o+1)}}}}else b(u)&&h.charCodeAt(1)===L&&(g=c>2&&E(h.charCodeAt(2))?3:2,n=g);let s=-1,i=!0;for(let o=c-1;o>=n;--o)if(E(h.charCodeAt(o))){if(!i){s=o;break}}else i=!1;if(s===-1){if(g===-1)return".";s=g}return h.slice(0,s)},basename(h,c){c!==void 0&&T(c,"ext"),T(h,"path");let g=0,n=-1,u=!0,s;if(h.length>=2&&b(h.charCodeAt(0))&&h.charCodeAt(1)===L&&(g=2),c!==void 0&&c.length>0&&c.length<=h.length){if(c===h)return"";let i=c.length-1,o=-1;for(s=h.length-1;s>=g;--s){const d=h.charCodeAt(s);if(E(d)){if(!u){g=s+1;break}}else o===-1&&(u=!1,o=s+1),i>=0&&(d===c.charCodeAt(i)?--i===-1&&(n=s):(i=-1,n=o))}return g===n?n=o:n===-1&&(n=h.length),h.slice(g,n)}for(s=h.length-1;s>=g;--s)if(E(h.charCodeAt(s))){if(!u){g=s+1;break}}else n===-1&&(u=!1,n=s+1);return n===-1?"":h.slice(g,n)},extname(h){T(h,"path");let c=0,g=-1,n=0,u=-1,s=!0,i=0;h.length>=2&&h.charCodeAt(1)===L&&b(h.charCodeAt(0))&&(c=n=2);for(let o=h.length-1;o>=c;--o){const d=h.charCodeAt(o);if(E(d)){if(!s){n=o+1;break}continue}u===-1&&(s=!1,u=o+1),d===I?g===-1?g=o:i!==1&&(i=1):g!==-1&&(i=-1)}return g===-1||u===-1||i===0||i===1&&g===u-1&&g===n+1?"":h.slice(g,u)},format:v.bind(null,"\\"),parse(h){T(h,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return c;const g=h.length;let n=0,u=h.charCodeAt(0);if(g===1)return E(u)?(c.root=c.dir=h,c):(c.base=c.name=h,c);if(E(u)){if(n=1,E(h.charCodeAt(1))){let f=2,y=f;for(;f<g&&!E(h.charCodeAt(f));)f++;if(f<g&&f!==y){for(y=f;f<g&&E(h.charCodeAt(f));)f++;if(f<g&&f!==y){for(y=f;f<g&&!E(h.charCodeAt(f));)f++;f===g?n=f:f!==y&&(n=f+1)}}}}else if(b(u)&&h.charCodeAt(1)===L){if(g<=2)return c.root=c.dir=h,c;if(n=2,E(h.charCodeAt(2))){if(g===3)return c.root=c.dir=h,c;n=3}}n>0&&(c.root=h.slice(0,n));let s=-1,i=n,o=-1,d=!0,r=h.length-1,a=0;for(;r>=n;--r){if(u=h.charCodeAt(r),E(u)){if(!d){i=r+1;break}continue}o===-1&&(d=!1,o=r+1),u===I?s===-1?s=r:a!==1&&(a=1):s!==-1&&(a=-1)}return o!==-1&&(s===-1||a===0||a===1&&s===o-1&&s===i+1?c.base=c.name=h.slice(i,o):(c.name=h.slice(i,s),c.base=h.slice(i,o),c.ext=h.slice(s,o))),i>0&&i!==n?c.dir=h.slice(0,i-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...h){let c="",g=!1;for(let n=h.length-1;n>=-1&&!g;n--){const u=n>=0?h[n]:l.cwd();T(u,"path"),u.length!==0&&(c=`${u}/${c}`,g=u.charCodeAt(0)===w)}return c=m(c,!g,"/",p),g?`/${c}`:c.length>0?c:"."},normalize(h){if(T(h,"path"),h.length===0)return".";const c=h.charCodeAt(0)===w,g=h.charCodeAt(h.length-1)===w;return h=m(h,!c,"/",p),h.length===0?c?"/":g?"./":".":(g&&(h+="/"),c?`/${h}`:h)},isAbsolute(h){return T(h,"path"),h.length>0&&h.charCodeAt(0)===w},join(...h){if(h.length===0)return".";let c;for(let g=0;g<h.length;++g){const n=h[g];T(n,"path"),n.length>0&&(c===void 0?c=n:c+=`/${n}`)}return c===void 0?".":e.posix.normalize(c)},relative(h,c){if(T(h,"from"),T(c,"to"),h===c||(h=e.posix.resolve(h),c=e.posix.resolve(c),h===c))return"";const g=1,n=h.length,u=n-g,s=1,i=c.length-s,o=u<i?u:i;let d=-1,r=0;for(;r<o;r++){const f=h.charCodeAt(g+r);if(f!==c.charCodeAt(s+r))break;f===w&&(d=r)}if(r===o)if(i>o){if(c.charCodeAt(s+r)===w)return c.slice(s+r+1);if(r===0)return c.slice(s+r)}else u>o&&(h.charCodeAt(g+r)===w?d=r:r===0&&(d=0));let a="";for(r=g+d+1;r<=n;++r)(r===n||h.charCodeAt(r)===w)&&(a+=a.length===0?"..":"/..");return`${a}${c.slice(s+d)}`},toNamespacedPath(h){return h},dirname(h){if(T(h,"path"),h.length===0)return".";const c=h.charCodeAt(0)===w;let g=-1,n=!0;for(let u=h.length-1;u>=1;--u)if(h.charCodeAt(u)===w){if(!n){g=u;break}}else n=!1;return g===-1?c?"/":".":c&&g===1?"//":h.slice(0,g)},basename(h,c){c!==void 0&&T(c,"ext"),T(h,"path");let g=0,n=-1,u=!0,s;if(c!==void 0&&c.length>0&&c.length<=h.length){if(c===h)return"";let i=c.length-1,o=-1;for(s=h.length-1;s>=0;--s){const d=h.charCodeAt(s);if(d===w){if(!u){g=s+1;break}}else o===-1&&(u=!1,o=s+1),i>=0&&(d===c.charCodeAt(i)?--i===-1&&(n=s):(i=-1,n=o))}return g===n?n=o:n===-1&&(n=h.length),h.slice(g,n)}for(s=h.length-1;s>=0;--s)if(h.charCodeAt(s)===w){if(!u){g=s+1;break}}else n===-1&&(u=!1,n=s+1);return n===-1?"":h.slice(g,n)},extname(h){T(h,"path");let c=-1,g=0,n=-1,u=!0,s=0;for(let i=h.length-1;i>=0;--i){const o=h.charCodeAt(i);if(o===w){if(!u){g=i+1;break}continue}n===-1&&(u=!1,n=i+1),o===I?c===-1?c=i:s!==1&&(s=1):c!==-1&&(s=-1)}return c===-1||n===-1||s===0||s===1&&c===n-1&&c===g+1?"":h.slice(c,n)},format:v.bind(null,"/"),parse(h){T(h,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return c;const g=h.charCodeAt(0)===w;let n;g?(c.root="/",n=1):n=0;let u=-1,s=0,i=-1,o=!0,d=h.length-1,r=0;for(;d>=n;--d){const a=h.charCodeAt(d);if(a===w){if(!o){s=d+1;break}continue}i===-1&&(o=!1,i=d+1),a===I?u===-1?u=d:r!==1&&(r=1):u!==-1&&(r=-1)}if(i!==-1){const a=s===0&&g?1:s;u===-1||r===0||r===1&&u===i-1&&u===s+1?c.base=c.name=h.slice(a,i):(c.name=h.slice(a,u),c.base=h.slice(a,i),c.ext=h.slice(u,i))}return s>0?c.dir=h.slice(0,s-1):g&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=l.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=l.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=l.platform==="win32"?e.win32.join:e.posix.join,e.resolve=l.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=l.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=l.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=l.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=l.platform==="win32"?e.win32.extname:e.posix.extname,e.format=l.platform==="win32"?e.win32.format:e.posix.format,e.parse=l.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=l.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=l.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=l.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(De[101],Ie([1,0,9]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const t={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function P(L){const D=(0,l.extname)(L),S=t[D.toLowerCase()];return S!==void 0?S:_(L)}e.getMediaOrTextMime=P;function _(L){const D=(0,l.extname)(L);return C[D.toLowerCase()]}e.getMediaMime=_;function I(L){for(const D in C)if(C[D]===L)return D}e.getExtensionForMimeType=I;const w=/^(.+)\/(.+?)(;.+)?$/;function k(L,D){const S=w.exec(L);return S?`${S[1].toLowerCase()}/${S[2].toLowerCase()}${S[3]??""}`:D?void 0:L}e.normalizeMimeType=k}),define(De[102],Ie([1,0,11]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var C;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(C=e.TerminateResponseCode||(e.TerminateResponseCode={}));function P(I,...w){const k=w.reduce((S,T)=>(S[T]=!0,S),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(S=>!k[S]).forEach(S=>{for(let T=0;T<L.length;T++)if(S.search(L[T])!==-1){delete I[S];break}})}e.sanitizeProcessEnvironment=P;function _(I){!I||(delete I.DEBUG,l.isMacintosh&&delete I.DYLD_LIBRARY_PATH,l.isLinux&&delete I.LD_PRELOAD)}e.removeDangerousEnvVariables=_}),define(De[51],Ie([1,0,11]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=l.globals.performance&&typeof l.globals.performance.now=="function";class C{static create(_=!0){return new C(_)}constructor(_){this._highResolution=t&&_,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?l.globals.performance.now():Date.now()}}e.StopWatch=C}),define(De[4],Ie([1,0,10,60,6,77,51]),function(J,e,l,t,C,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const I=!1,w=!1;var k;(function(d){d.None=()=>C.Disposable.None;function r(ve){if(w){const{onListenerDidAdd:be}=ve,ke=E.create();let Re=0;ve.onListenerDidAdd=()=>{++Re===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ke.print()),be?.()}}}function a(ve){return(be,ke=null,Re)=>{let ze=!1,oe;return oe=ve(le=>{if(!ze)return oe?oe.dispose():ze=!0,be.call(ke,le)},null,Re),ze&&oe.dispose(),oe}}d.once=a;function f(ve,be,ke){return z((Re,ze=null,oe)=>ve(le=>Re.call(ze,be(le)),null,oe),ke)}d.map=f;function y(ve,be,ke){return z((Re,ze=null,oe)=>ve(le=>{be(le),Re.call(ze,le)},null,oe),ke)}d.forEach=y;function R(ve,be,ke){return z((Re,ze=null,oe)=>ve(le=>be(le)&&Re.call(ze,le),null,oe),ke)}d.filter=R;function N(ve){return ve}d.signal=N;function M(...ve){return(be,ke=null,Re)=>(0,C.combinedDisposable)(...ve.map(ze=>ze(oe=>be.call(ke,oe),null,Re)))}d.any=M;function A(ve,be,ke,Re){let ze=ke;return f(ve,oe=>(ze=be(ze,oe),ze),Re)}d.reduce=A;function z(ve,be){let ke;const Re={onFirstListenerAdd(){ke=ve(ze.fire,ze)},onLastListenerRemove(){ke?.dispose()}};be||r(Re);const ze=new b(Re);return be?.add(ze),ze.event}function H(ve,be,ke=100,Re=!1,ze,oe){let le,me,Z,ae=0;const ne={leakWarningThreshold:ze,onFirstListenerAdd(){le=ve(O=>{ae++,me=be(me,O),Re&&!Z&&(ie.fire(me),me=void 0),clearTimeout(Z),Z=setTimeout(()=>{const V=me;me=void 0,Z=void 0,(!Re||ae>1)&&ie.fire(V),ae=0},ke)})},onLastListenerRemove(){le.dispose()}};oe||r(ne);const ie=new b(ne);return oe?.add(ie),ie.event}d.debounce=H;function F(ve,be=(Re,ze)=>Re===ze,ke){let Re=!0,ze;return R(ve,oe=>{const le=Re||!be(oe,ze);return Re=!1,ze=oe,le},ke)}d.latch=F;function G(ve,be,ke){return[d.filter(ve,be,ke),d.filter(ve,Re=>!be(Re),ke)]}d.split=G;function B(ve,be=!1,ke=[]){let Re=ke.slice(),ze=ve(me=>{Re?Re.push(me):le.fire(me)});const oe=()=>{Re?.forEach(me=>le.fire(me)),Re=null},le=new b({onFirstListenerAdd(){ze||(ze=ve(me=>le.fire(me)))},onFirstListenerDidAdd(){Re&&(be?setTimeout(oe):oe())},onLastListenerRemove(){ze&&ze.dispose(),ze=null}});return le.event}d.buffer=B;class U{constructor(be){this.event=be,this.disposables=new C.DisposableStore}map(be){return new U(f(this.event,be,this.disposables))}forEach(be){return new U(y(this.event,be,this.disposables))}filter(be){return new U(R(this.event,be,this.disposables))}reduce(be,ke){return new U(A(this.event,be,ke,this.disposables))}latch(){return new U(F(this.event,void 0,this.disposables))}debounce(be,ke=100,Re=!1,ze){return new U(H(this.event,be,ke,Re,ze,this.disposables))}on(be,ke,Re){return this.event(be,ke,Re)}once(be,ke,Re){return a(this.event)(be,ke,Re)}dispose(){this.disposables.dispose()}}function x(ve){return new U(ve)}d.chain=x;function $(ve,be,ke=Re=>Re){const Re=(...me)=>le.fire(ke(...me)),ze=()=>ve.on(be,Re),oe=()=>ve.removeListener(be,Re),le=new b({onFirstListenerAdd:ze,onLastListenerRemove:oe});return le.event}d.fromNodeEventEmitter=$;function Q(ve,be,ke=Re=>Re){const Re=(...me)=>le.fire(ke(...me)),ze=()=>ve.addEventListener(be,Re),oe=()=>ve.removeEventListener(be,Re),le=new b({onFirstListenerAdd:ze,onLastListenerRemove:oe});return le.event}d.fromDOMEventEmitter=Q;function K(ve){return new Promise(be=>a(ve)(be))}d.toPromise=K;function de(ve,be){return be(void 0),ve(ke=>be(ke))}d.runAndSubscribe=de;function te(ve,be){let ke=null;function Re(oe){ke?.dispose(),ke=new C.DisposableStore,be(oe,ke)}Re(void 0);const ze=ve(oe=>Re(oe));return(0,C.toDisposable)(()=>{ze.dispose(),ke?.dispose()})}d.runAndSubscribeWithStore=te;class he{constructor(be,ke){this.obs=be,this._counter=0,this._hasChanged=!1;const Re={onFirstListenerAdd:()=>{be.addObserver(this)},onLastListenerRemove:()=>{be.removeObserver(this)}};ke||r(Re),this.emitter=new b(Re),ke&&ke.add(this.emitter)}beginUpdate(be){this._counter++}handleChange(be,ke){this._hasChanged=!0}endUpdate(be){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function Y(ve,be){return new he(ve,be).emitter.event}d.fromObservable=Y})(k=e.Event||(e.Event={}));class L{constructor(r){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${r}_${L._idPool++}`,L.all.add(this)}start(r){this._stopWatch=new _.StopWatch(!0),this.listenerCount=r}stop(){if(this._stopWatch){const r=this._stopWatch.elapsed();this.durations.push(r),this.elapsedOverall+=r,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=L,L.all=new Set,L._idPool=0;let D=-1;function S(d){const r=D;return D=d,{dispose(){D=r}}}e.setGlobalLeakWarningThreshold=S;class T{constructor(r,a=Math.random().toString(18).slice(2,5)){this.customThreshold=r,this.name=a,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(r,a){let f=D;if(typeof this.customThreshold=="number"&&(f=this.customThreshold),f<=0||a<f)return;this._stacks||(this._stacks=new Map);const y=this._stacks.get(r.value)||0;if(this._stacks.set(r.value,y+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=f*.5;let R,N=0;for(const[M,A]of this._stacks)(!R||N<A)&&(R=M,N=A);console.warn(`[${this.name}] potential listener LEAK detected, having ${a} listeners already. MOST frequent listener (${N}):`),console.warn(R)}return()=>{const R=this._stacks.get(r.value)||0;this._stacks.set(r.value,R-1)}}}class E{static create(){return new E(new Error().stack??"")}constructor(r){this.value=r}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class p{constructor(r,a,f){this.callback=r,this.callbackThis=a,this.stack=f,this.subscription=new C.SafeDisposable}invoke(r){this.callback.call(this.callbackThis,r)}}class b{constructor(r){this._disposed=!1,this._options=r,this._leakageMon=D>0?new T(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new L(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(I){const r=Array.from(this._listeners);queueMicrotask(()=>{for(const a of r)a.subscription.isset()&&(a.subscription.unset(),a.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(r,a,f)=>{this._listeners||(this._listeners=new P.LinkedList);const y=this._listeners.isEmpty();y&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let R,N;this._leakageMon&&this._listeners.size>=30&&(N=E.create(),R=this._leakageMon.check(N,this._listeners.size+1)),I&&(N=N??E.create());const M=new p(r,a,N),A=this._listeners.push(M);y&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,r,a);const z=M.subscription.set(()=>{R?.(),this._disposed||(A(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return f instanceof C.DisposableStore?f.add(z):Array.isArray(f)&&f.push(z),z}),this._event}fire(r){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new v);for(const a of this._listeners)this._deliveryQueue.push(this,a,r);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=b;class m{constructor(){this._queue=new P.LinkedList}get size(){return this._queue.size}push(r,a,f){this._queue.push(new h(r,a,f))}clear(r){const a=new P.LinkedList;for(const f of this._queue)f.emitter!==r&&a.push(f);this._queue=a}deliver(){for(;this._queue.size>0;){const r=this._queue.shift();try{r.listener.invoke(r.event)}catch(a){(0,l.onUnexpectedError)(a)}}}}e.EventDeliveryQueue=m;class v extends m{clear(r){this._queue.clear()}}class h{constructor(r,a,f){this.emitter=r,this.listener=a,this.event=f}}class c extends b{async fireAsync(r,a,f){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new P.LinkedList);for(const y of this._listeners)this._asyncDeliveryQueue.push([y,r]);for(;this._asyncDeliveryQueue.size>0&&!a.isCancellationRequested;){const[y,R]=this._asyncDeliveryQueue.shift(),N=[],M={...R,token:a,waitUntil:A=>{if(Object.isFrozen(N))throw new Error("waitUntil can NOT be called asynchronous");f&&(A=f(A,y.callback)),N.push(A)}};try{y.invoke(M)}catch(A){(0,l.onUnexpectedError)(A);continue}Object.freeze(N),await Promise.allSettled(N).then(A=>{for(const z of A)z.status==="rejected"&&(0,l.onUnexpectedError)(z.reason)})}}}}e.AsyncEmitter=c;class g extends b{constructor(r){super(r),this._isPaused=0,this._eventQueue=new P.LinkedList,this._mergeFn=r?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const r=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(r))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(r){this._listeners&&(this._isPaused!==0?this._eventQueue.push(r):super.fire(r))}}e.PauseableEmitter=g;class n extends g{constructor(r){super(r),this._delay=r.delay??100}fire(r){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(r)}}e.DebounceEmitter=n;class u extends b{constructor(r){super(r),this._queuedEvents=[],this._mergeFn=r?.merge}fire(r){!this.hasListeners()||(this._queuedEvents.push(r),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(a=>super.fire(a)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=u;class s{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new b({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(r){const a={event:r,listener:null};this.events.push(a),this.hasListeners&&this.hook(a);const f=()=>{this.hasListeners&&this.unhook(a);const y=this.events.indexOf(a);this.events.splice(y,1)};return(0,C.toDisposable)((0,t.once)(f))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(r=>this.hook(r))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(r=>this.unhook(r))}hook(r){r.listener=r.event(a=>this.emitter.fire(a))}unhook(r){r.listener&&r.listener.dispose(),r.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=s;class i{constructor(){this.buffers=[]}wrapEvent(r){return(a,f,y)=>r(R=>{const N=this.buffers[this.buffers.length-1];N?N.push(()=>a.call(f,R)):a.call(f,R)},void 0,y)}bufferEvents(r){const a=[];this.buffers.push(a);const f=r();return this.buffers.pop(),a.forEach(y=>y()),f}}e.EventBufferer=i;class o{constructor(){this.listening=!1,this.inputEvent=k.None,this.inputEventListener=C.Disposable.None,this.emitter=new b({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(r){this.inputEvent=r,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=r(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=o}),define(De[21],Ie([1,0,4]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(I,w){const k=setTimeout(I.bind(w),0);return{dispose(){clearTimeout(k)}}});var C;(function(I){function w(k){return k===I.None||k===I.Cancelled||k instanceof P?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}I.isCancellationToken=w,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:l.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(C=e.CancellationToken||(e.CancellationToken={}));class P{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new l.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class _{constructor(w){this._token=void 0,this._parentListener=void 0,this._parentListener=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new P),this._token}cancel(){this._token?this._token instanceof P&&this._token.cancel():this._token=C.Cancelled}dispose(w=!1){w&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof P&&this._token.dispose():this._token=C.None}}e.CancellationTokenSource=_}),define(De[156],Ie([1,0,21]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(I){this.task=I,this.result=null}get(){if(this.result)return this.result;const I=new l.CancellationTokenSource,w=this.task(I.token);return this.result={promise:w,dispose:()=>{this.result=null,I.cancel(),I.dispose()}},this.result}}e.Cache=t;class C{constructor(I){this.fn=I,this.lastCache=void 0,this.lastArgKey=void 0}get(I){const w=JSON.stringify(I);return this.lastArgKey!==w&&(this.lastArgKey=w,this.lastCache=this.fn(I)),this.lastCache}}e.LRUCachedFunction=C;class P{get cachedValues(){return this._map}constructor(I){this.fn=I,this._map=new Map}get(I){if(this._map.has(I))return this._map.get(I);const w=this.fn(I);return this._map.set(I,w),w}}e.CachedFunction=P}),define(De[8],Ie([1,0,156,76]),function(J,e,l,t){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function P(fe){return!fe||typeof fe!="string"?!0:fe.trim().length===0}e.isFalsyOrWhitespace=P;const _=/{(\d+)}/g;function I(fe,...Ae){return Ae.length===0?fe:fe.replace(_,function(Le,Me){const Ge=parseInt(Me,10);return isNaN(Ge)||Ge<0||Ge>=Ae.length?Le:Ae[Ge]})}e.format=I;const w=/{([^}]+)}/g;function k(fe,Ae){return fe.replace(w,(Le,Me)=>Ae[Me]??Le)}e.format2=k;function L(fe){return fe.replace(/[<>&]/g,function(Ae){switch(Ae){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ae}})}e.escape=L;function D(fe){return fe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=D;function S(fe,Ae){let Le=0;const Me=Ae.charCodeAt(0);for(let Ge=fe.length-1;Ge>=0;Ge--)fe.charCodeAt(Ge)===Me&&Le++;return Le}e.count=S;function T(fe,Ae,Le="\u2026"){return fe.length<=Ae?fe:`${fe.substr(0,Ae)}${Le}`}e.truncate=T;function E(fe,Ae=" "){const Le=p(fe,Ae);return b(Le,Ae)}e.trim=E;function p(fe,Ae){if(!fe||!Ae)return fe;const Le=Ae.length;if(Le===0||fe.length===0)return fe;let Me=0;for(;fe.indexOf(Ae,Me)===Me;)Me=Me+Le;return fe.substring(Me)}e.ltrim=p;function b(fe,Ae){if(!fe||!Ae)return fe;const Le=Ae.length,Me=fe.length;if(Le===0||Me===0)return fe;let Ge=Me,Je=-1;for(;Je=fe.lastIndexOf(Ae,Ge-1),!(Je===-1||Je+Le!==Ge);){if(Je===0)return"";Ge=Je}return fe.substring(0,Ge)}e.rtrim=b;function m(fe){return fe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=m;function v(fe){return fe.replace(/\*/g,"")}e.stripWildcards=v;function h(fe,Ae,Le={}){if(!fe)throw new Error("Cannot create regex from empty string");Ae||(fe=D(fe)),Le.wholeWord&&(/\B/.test(fe.charAt(0))||(fe="\\b"+fe),/\B/.test(fe.charAt(fe.length-1))||(fe=fe+"\\b"));let Me="";return Le.global&&(Me+="g"),Le.matchCase||(Me+="i"),Le.multiline&&(Me+="m"),Le.unicode&&(Me+="u"),new RegExp(fe,Me)}e.createRegExp=h;function c(fe){return fe.source==="^"||fe.source==="^$"||fe.source==="$"||fe.source==="^\\s*$"?!1:!!(fe.exec("")&&fe.lastIndex===0)}e.regExpLeadsToEndlessLoop=c;function g(fe){return!!fe.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=g;function n(fe){return(fe.global?"g":"")+(fe.ignoreCase?"i":"")+(fe.multiline?"m":"")+(fe.unicode?"u":"")}e.regExpFlags=n;function u(fe){return fe.split(/\r\n|\r|\n/)}e.splitLines=u;function s(fe){for(let Ae=0,Le=fe.length;Ae<Le;Ae++){const Me=fe.charCodeAt(Ae);if(Me!==32&&Me!==9)return Ae}return-1}e.firstNonWhitespaceIndex=s;function i(fe,Ae=0,Le=fe.length){for(let Me=Ae;Me<Le;Me++){const Ge=fe.charCodeAt(Me);if(Ge!==32&&Ge!==9)return fe.substring(Ae,Me)}return fe.substring(Ae,Le)}e.getLeadingWhitespace=i;function o(fe,Ae=fe.length-1){for(let Le=Ae;Le>=0;Le--){const Me=fe.charCodeAt(Le);if(Me!==32&&Me!==9)return Le}return-1}e.lastNonWhitespaceIndex=o;function d(fe,Ae,Le){const Me=[];let Ge=0;for(const Je of fe.matchAll(Ae)){if(Me.push(fe.slice(Ge,Je.index)),Je.index===void 0)throw new Error("match.index should be defined");Ge=Je.index+Je[0].length,Me.push(Le(Je[0],...Je.slice(1),Je.index,fe,Je.groups))}return Me.push(fe.slice(Ge)),Promise.all(Me).then(Je=>Je.join(""))}e.replaceAsync=d;function r(fe,Ae){return fe<Ae?-1:fe>Ae?1:0}e.compare=r;function a(fe,Ae,Le=0,Me=fe.length,Ge=0,Je=Ae.length){for(;Le<Me&&Ge<Je;Le++,Ge++){const nt=fe.charCodeAt(Le),it=Ae.charCodeAt(Ge);if(nt<it)return-1;if(nt>it)return 1}const st=Me-Le,vt=Je-Ge;return st<vt?-1:st>vt?1:0}e.compareSubstring=a;function f(fe,Ae){return y(fe,Ae,0,fe.length,0,Ae.length)}e.compareIgnoreCase=f;function y(fe,Ae,Le=0,Me=fe.length,Ge=0,Je=Ae.length){for(;Le<Me&&Ge<Je;Le++,Ge++){let nt=fe.charCodeAt(Le),it=Ae.charCodeAt(Ge);if(nt===it)continue;if(nt>=128||it>=128)return a(fe.toLowerCase(),Ae.toLowerCase(),Le,Me,Ge,Je);N(nt)&&(nt-=32),N(it)&&(it-=32);const wt=nt-it;if(wt!==0)return wt}const st=Me-Le,vt=Je-Ge;return st<vt?-1:st>vt?1:0}e.compareSubstringIgnoreCase=y;function R(fe){return fe>=48&&fe<=57}e.isAsciiDigit=R;function N(fe){return fe>=97&&fe<=122}e.isLowerAsciiLetter=N;function M(fe){return fe>=65&&fe<=90}e.isUpperAsciiLetter=M;function A(fe,Ae){return fe.length===Ae.length&&y(fe,Ae)===0}e.equalsIgnoreCase=A;function z(fe,Ae){const Le=Ae.length;return Ae.length>fe.length?!1:y(fe,Ae,0,Le)===0}e.startsWithIgnoreCase=z;function H(fe,Ae){const Le=Math.min(fe.length,Ae.length);let Me;for(Me=0;Me<Le;Me++)if(fe.charCodeAt(Me)!==Ae.charCodeAt(Me))return Me;return Le}e.commonPrefixLength=H;function F(fe,Ae){const Le=Math.min(fe.length,Ae.length);let Me;const Ge=fe.length-1,Je=Ae.length-1;for(Me=0;Me<Le;Me++)if(fe.charCodeAt(Ge-Me)!==Ae.charCodeAt(Je-Me))return Me;return Le}e.commonSuffixLength=F;function G(fe){return 55296<=fe&&fe<=56319}e.isHighSurrogate=G;function B(fe){return 56320<=fe&&fe<=57343}e.isLowSurrogate=B;function U(fe,Ae){return(fe-55296<<10)+(Ae-56320)+65536}e.computeCodePoint=U;function x(fe,Ae,Le){const Me=fe.charCodeAt(Le);if(G(Me)&&Le+1<Ae){const Ge=fe.charCodeAt(Le+1);if(B(Ge))return U(Me,Ge)}return Me}e.getNextCodePoint=x;function $(fe,Ae){const Le=fe.charCodeAt(Ae-1);if(B(Le)&&Ae>1){const Me=fe.charCodeAt(Ae-2);if(G(Me))return U(Me,Le)}return Le}class Q{get offset(){return this._offset}constructor(Ae,Le=0){this._str=Ae,this._len=Ae.length,this._offset=Le}setOffset(Ae){this._offset=Ae}prevCodePoint(){const Ae=$(this._str,this._offset);return this._offset-=Ae>=65536?2:1,Ae}nextCodePoint(){const Ae=x(this._str,this._len,this._offset);return this._offset+=Ae>=65536?2:1,Ae}eol(){return this._offset>=this._len}}e.CodePointIterator=Q;class K{get offset(){return this._iterator.offset}constructor(Ae,Le=0){this._iterator=new Q(Ae,Le)}nextGraphemeLength(){const Ae=Ze.getInstance(),Le=this._iterator,Me=Le.offset;let Ge=Ae.getGraphemeBreakType(Le.nextCodePoint());for(;!Le.eol();){const Je=Le.offset,st=Ae.getGraphemeBreakType(Le.nextCodePoint());if(We(Ge,st)){Le.setOffset(Je);break}Ge=st}return Le.offset-Me}prevGraphemeLength(){const Ae=Ze.getInstance(),Le=this._iterator,Me=Le.offset;let Ge=Ae.getGraphemeBreakType(Le.prevCodePoint());for(;Le.offset>0;){const Je=Le.offset,st=Ae.getGraphemeBreakType(Le.prevCodePoint());if(We(st,Ge)){Le.setOffset(Je);break}Ge=st}return Me-Le.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=K;function de(fe,Ae){return new K(fe,Ae).nextGraphemeLength()}e.nextCharLength=de;function te(fe,Ae){return new K(fe,Ae).prevGraphemeLength()}e.prevCharLength=te;function he(fe,Ae){Ae>0&&B(fe.charCodeAt(Ae))&&Ae--;const Le=Ae+de(fe,Ae);return[Le-te(fe,Le),Le]}e.getCharContainingOffset=he;function Y(fe){const Ae=new K(fe);let Le=0;for(;!Ae.eol();)Le++,Ae.nextGraphemeLength();return Le}e.charCount=Y;let ve;function be(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ke(fe){return ve||(ve=be()),ve.test(fe)}e.containsRTL=ke;const Re=/^[\t\n\r\x20-\x7E]*$/;function ze(fe){return Re.test(fe)}e.isBasicASCII=ze,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function oe(fe){return e.UNUSUAL_LINE_TERMINATORS.test(fe)}e.containsUnusualLineTerminators=oe;function le(fe){return fe>=11904&&fe<=55215||fe>=63744&&fe<=64255||fe>=65281&&fe<=65374}e.isFullWidthCharacter=le;function me(fe){return fe>=127462&&fe<=127487||fe===8986||fe===8987||fe===9200||fe===9203||fe>=9728&&fe<=10175||fe===11088||fe===11093||fe>=127744&&fe<=128591||fe>=128640&&fe<=128764||fe>=128992&&fe<=129008||fe>=129280&&fe<=129535||fe>=129648&&fe<=129782}e.isEmojiImprecise=me;function Z(fe,Ae){if(fe.length<Ae)return fe;const Le=/\b/g;let Me=0;for(;Le.test(fe)&&!(fe.length-Le.lastIndex<Ae);)Me=Le.lastIndex,Le.lastIndex+=1;return fe.substring(Me).replace(/^\s/,"")}e.lcut=Z;const ae=/\x1B\x5B[12]?K/g,ne=/\x1b\[\d+m/g,ie=/\x1b\[0?m/g;function O(fe){return fe&&(fe=fe.replace(ae,""),fe=fe.replace(ne,""),fe=fe.replace(ie,"")),fe}e.removeAnsiEscapeCodes=O,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function V(fe){return!!(fe&&fe.length>0&&fe.charCodeAt(0)===65279)}e.startsWithUTF8BOM=V;function q(fe){return V(fe)?fe.substr(1):fe}e.stripUTF8BOM=q;function X(fe,Ae){if(!fe||!Ae||fe.length<Ae.length)return!1;const Le=Ae.length,Me=fe.toLowerCase();let Ge=0,Je=-1;for(;Ge<Le;){const st=Me.indexOf(Ae[Ge],Je+1);if(st<0)return!1;Je=st,Ge++}return!0}e.fuzzyContains=X;function ge(fe,Ae=!1){return fe?(Ae&&(fe=fe.replace(/\\./g,"")),fe.toLowerCase()!==fe):!1}e.containsUppercaseCharacter=ge;function we(fe){return fe.charAt(0).toUpperCase()+fe.slice(1)}e.uppercaseFirstLetter=we;function ce(fe,Ae=1){if(Ae===0)return"";let Le=-1;do Le=fe.indexOf(`
`,Le+1),Ae--;while(Ae>0&&Le>=0);return Le===-1?fe:(fe[Le-1]==="\r"&&Le--,fe.substr(0,Le))}e.getNLines=ce;function Ce(fe){return fe=fe%(2*26),fe<26?String.fromCharCode(97+fe):String.fromCharCode(65+fe-26)}e.singleLetterHash=Ce;function ye(fe){return Ze.getInstance().getGraphemeBreakType(fe)}e.getGraphemeBreakType=ye;function We(fe,Ae){return fe===0?Ae!==5&&Ae!==7:fe===2&&Ae===3?!1:fe===4||fe===2||fe===3||Ae===4||Ae===2||Ae===3?!0:!(fe===8&&(Ae===8||Ae===9||Ae===11||Ae===12)||(fe===11||fe===9)&&(Ae===9||Ae===10)||(fe===12||fe===10)&&Ae===10||Ae===5||Ae===13||Ae===7||fe===1||fe===13&&Ae===14||fe===6&&Ae===6)}var qe;(function(fe){fe[fe.Other=0]="Other",fe[fe.Prepend=1]="Prepend",fe[fe.CR=2]="CR",fe[fe.LF=3]="LF",fe[fe.Control=4]="Control",fe[fe.Extend=5]="Extend",fe[fe.Regional_Indicator=6]="Regional_Indicator",fe[fe.SpacingMark=7]="SpacingMark",fe[fe.L=8]="L",fe[fe.V=9]="V",fe[fe.T=10]="T",fe[fe.LV=11]="LV",fe[fe.LVT=12]="LVT",fe[fe.ZWJ=13]="ZWJ",fe[fe.Extended_Pictographic=14]="Extended_Pictographic"})(qe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ze{static getInstance(){return Ze._INSTANCE||(Ze._INSTANCE=new Ze),Ze._INSTANCE}constructor(){this._data=Ye()}getGraphemeBreakType(Ae){if(Ae<32)return Ae===10?3:Ae===13?2:4;if(Ae<127)return 0;const Le=this._data,Me=Le.length/3;let Ge=1;for(;Ge<=Me;)if(Ae<Le[3*Ge])Ge=2*Ge;else if(Ae>Le[3*Ge+1])Ge=2*Ge+1;else return Le[3*Ge+2];return 0}}Ze._INSTANCE=null;function Ye(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Oe(fe,Ae){if(fe===0)return 0;const Le=ot(fe,Ae);if(Le!==void 0)return Le;const Me=new Q(Ae,fe);return Me.prevCodePoint(),Me.offset}e.getLeftDeleteOffset=Oe;function ot(fe,Ae){const Le=new Q(Ae,fe);let Me=Le.prevCodePoint();for(;re(Me)||Me===65039||Me===8419;){if(Le.offset===0)return;Me=Le.prevCodePoint()}if(!me(Me))return;let Ge=Le.offset;return Ge>0&&Le.prevCodePoint()===8205&&(Ge=Le.offset),Ge}function re(fe){return 127995<=fe&&fe<=127999}var se;(function(fe){fe[fe.zwj=8205]="zwj",fe[fe.emojiVariantSelector=65039]="emojiVariantSelector",fe[fe.enclosingKeyCap=8419]="enclosingKeyCap"})(se||(se={})),e.noBreakWhitespace="\xA0";class Ee{static getInstance(Ae){return Ee.cache.get(Array.from(Ae))}static getLocales(){return Ee._locales.getValue()}constructor(Ae){this.confusableDictionary=Ae}isAmbiguous(Ae){return this.confusableDictionary.has(Ae)}getPrimaryConfusable(Ae){return this.confusableDictionary.get(Ae)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Ee,C=Ee,Ee.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ee.cache=new l.LRUCachedFunction(fe=>{function Ae(it){const wt=new Map;for(let Ct=0;Ct<it.length;Ct+=2)wt.set(it[Ct],it[Ct+1]);return wt}function Le(it,wt){const Ct=new Map(it);for(const[Dt,ht]of wt)Ct.set(Dt,ht);return Ct}function Me(it,wt){if(!it)return wt;const Ct=new Map;for(const[Dt,ht]of it)wt.has(Dt)&&Ct.set(Dt,ht);return Ct}const Ge=C.ambiguousCharacterData.getValue();let Je=fe.filter(it=>!it.startsWith("_")&&it in Ge);Je.length===0&&(Je=["_default"]);let st;for(const it of Je){const wt=Ae(Ge[it]);st=Me(st,wt)}const vt=Ae(Ge._common),nt=Le(vt,st);return new Ee(nt)}),Ee._locales=new t.Lazy(()=>Object.keys(Ee.ambiguousCharacterData.getValue()).filter(fe=>!fe.startsWith("_")));class xe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(xe.getRawData())),this._data}static isInvisibleCharacter(Ae){return xe.getData().has(Ae)}static get codePoints(){return xe.getData()}}e.InvisibleCharacters=xe,xe._data=void 0}),define(De[31],Ie([1,0,9,11,8,16]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function _(o){return o===47||o===92}e.isPathSeparator=_;function I(o){return o.replace(/[\\/]/g,l.posix.sep)}e.toSlashes=I;function w(o){return o.indexOf("/")===-1&&(o=I(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=w;function k(o,d=l.posix.sep){if(!o)return"";const r=o.length,a=o.charCodeAt(0);if(_(a)){if(_(o.charCodeAt(1))&&!_(o.charCodeAt(2))){let y=3;const R=y;for(;y<r&&!_(o.charCodeAt(y));y++);if(R!==y&&!_(o.charCodeAt(y+1))){for(y+=1;y<r;y++)if(_(o.charCodeAt(y)))return o.slice(0,y+1).replace(/[\\/]/g,d)}}return d}else if(m(a)&&o.charCodeAt(1)===58)return _(o.charCodeAt(2))?o.slice(0,2)+d:o.slice(0,2);let f=o.indexOf("://");if(f!==-1){for(f+=3;f<r;f++)if(_(o.charCodeAt(f)))return o.slice(0,f+1)}return""}e.getRoot=k;function L(o){if(!t.isWindows||!o||o.length<5)return!1;let d=o.charCodeAt(0);if(d!==92||(d=o.charCodeAt(1),d!==92))return!1;let r=2;const a=r;for(;r<o.length&&(d=o.charCodeAt(r),d!==92);r++);return!(a===r||(d=o.charCodeAt(r+1),isNaN(d)||d===92))}e.isUNC=L;const D=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,T=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function E(o,d=t.isWindows){const r=d?D:S;return!(!o||o.length===0||/^\s+$/.test(o)||(r.lastIndex=0,r.test(o))||d&&T.test(o)||o==="."||o===".."||d&&o[o.length-1]==="."||d&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=E;function p(o,d,r){const a=o===d;return!r||a?a:!o||!d?!1:(0,C.equalsIgnoreCase)(o,d)}e.isEqual=p;function b(o,d,r,a=l.sep){if(o===d)return!0;if(!o||!d||d.length>o.length)return!1;if(r){if(!(0,C.startsWithIgnoreCase)(o,d))return!1;if(d.length===o.length)return!0;let y=d.length;return d.charAt(d.length-1)===a&&y--,o.charAt(y)===a}return d.charAt(d.length-1)!==a&&(d+=a),o.indexOf(d)===0}e.isEqualOrParent=b;function m(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=m;function v(o,d){return t.isWindows&&o.endsWith(":")&&(o+=l.sep),(0,l.isAbsolute)(o)||(o=(0,l.join)(d,o)),o=(0,l.normalize)(o),t.isWindows?(o=(0,C.rtrim)(o,l.sep),o.endsWith(":")&&(o+=l.sep)):(o=(0,C.rtrim)(o,l.sep),o||(o=l.sep)),o}e.sanitizeFilePath=v;function h(o){const d=(0,l.normalize)(o);return t.isWindows?o.length>3?!1:c(d)&&(o.length===2||d.charCodeAt(2)===92):d===l.posix.sep}e.isRootOrDriveLetter=h;function c(o,d=t.isWindows){return d?m(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function g(o){return c(o)?o[0]:void 0}e.getDriveLetter=g;function n(o,d,r){return d.length>o.length?-1:o===d?0:(r&&(o=o.toLowerCase(),d=d.toLowerCase()),o.indexOf(d))}e.indexOfPath=n;function u(o){const d=o.split(":");let r,a,f;for(const y of d){const R=Number(y);(0,P.isNumber)(R)?a===void 0?a=R:f===void 0&&(f=R):r=r?[r,y].join(":"):y}if(!r)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:r,line:a!==void 0?a:void 0,column:f!==void 0?f:a!==void 0?1:void 0}}e.parseLineAndColumnAware=u;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(o,d,r=8){let a="";for(let y=0;y<r;y++)a+=s.charAt(Math.floor(Math.random()*s.length));let f;return d?f=`${d}-${a}`:f=a,o?(0,l.join)(o,f):f}e.randomPath=i}),define(De[78],Ie([1,0,8]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(m){return C(m,0)}e.hash=t;function C(m,v){switch(typeof m){case"object":return m===null?P(349,v):Array.isArray(m)?w(m,v):k(m,v);case"string":return I(m,v);case"boolean":return _(m,v);case"number":return P(m,v);case"undefined":return P(937,v);default:return P(617,v)}}e.doHash=C;function P(m,v){return(v<<5)-v+m|0}e.numberHash=P;function _(m,v){return P(m?433:863,v)}function I(m,v){v=P(149417,v);for(let h=0,c=m.length;h<c;h++)v=P(m.charCodeAt(h),v);return v}e.stringHash=I;function w(m,v){return v=P(104579,v),m.reduce((h,c)=>C(c,h),v)}function k(m,v){return v=P(181387,v),Object.keys(m).sort().reduce((h,c)=>(h=I(c,h),C(m[c],h)),v)}class L{constructor(){this._value=0}get value(){return this._value}hash(v){return this._value=C(v,this._value),this._value}}e.Hasher=L;var D;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(D||(D={}));function S(m,v,h=32){const c=h-v,g=~((1<<c)-1);return(m<<v|(g&m)>>>c)>>>0}function T(m,v=0,h=m.byteLength,c=0){for(let g=0;g<h;g++)m[v+g]=c}function E(m,v,h="0"){for(;m.length<v;)m=h+m;return m}function p(m,v=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(h=>h.toString(16).padStart(2,"0")).join(""):E((m>>>0).toString(16),v/4)}e.toHexString=p;class b{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(v){const h=v.length;if(h===0)return;const c=this._buff;let g=this._buffLen,n=this._leftoverHighSurrogate,u,s;for(n!==0?(u=n,s=-1,n=0):(u=v.charCodeAt(0),s=0);;){let i=u;if(l.isHighSurrogate(u))if(s+1<h){const o=v.charCodeAt(s+1);l.isLowSurrogate(o)?(s++,i=l.computeCodePoint(u,o)):i=65533}else{n=u;break}else l.isLowSurrogate(u)&&(i=65533);if(g=this._push(c,g,i),s++,s<h)u=v.charCodeAt(s);else break}this._buffLen=g,this._leftoverHighSurrogate=n}_push(v,h,c){return c<128?v[h++]=c:c<2048?(v[h++]=192|(c&1984)>>>6,v[h++]=128|(c&63)>>>0):c<65536?(v[h++]=224|(c&61440)>>>12,v[h++]=128|(c&4032)>>>6,v[h++]=128|(c&63)>>>0):(v[h++]=240|(c&1835008)>>>18,v[h++]=128|(c&258048)>>>12,v[h++]=128|(c&4032)>>>6,v[h++]=128|(c&63)>>>0),h>=64&&(this._step(),h-=64,this._totalLen+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),h}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),p(this._h0)+p(this._h1)+p(this._h2)+p(this._h3)+p(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,T(this._buff,this._buffLen),this._buffLen>56&&(this._step(),T(this._buff));const v=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(v/4294967296),!1),this._buffDV.setUint32(60,v%4294967296,!1),this._step()}_step(){const v=b._bigBlock32,h=this._buffDV;for(let r=0;r<64;r+=4)v.setUint32(r,h.getUint32(r,!1),!1);for(let r=64;r<320;r+=4)v.setUint32(r,S(v.getUint32(r-12,!1)^v.getUint32(r-32,!1)^v.getUint32(r-56,!1)^v.getUint32(r-64,!1),1),!1);let c=this._h0,g=this._h1,n=this._h2,u=this._h3,s=this._h4,i,o,d;for(let r=0;r<80;r++)r<20?(i=g&n|~g&u,o=1518500249):r<40?(i=g^n^u,o=1859775393):r<60?(i=g&n|g&u|n&u,o=2400959708):(i=g^n^u,o=3395469782),d=S(c,5)+i+s+o+v.getUint32(r*4,!1)&4294967295,s=u,u=n,n=S(g,30),g=c,c=d;this._h0=this._h0+c&4294967295,this._h1=this._h1+g&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+u&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=b,b._bigBlock32=new DataView(new ArrayBuffer(320))}),define(De[26],Ie([1,0,17,8]),function(J,e,l,t){"use strict";var C,P,_;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function I(s,i,o){let d=s.get(i);return d===void 0&&(d=o,s.set(i,d)),d}e.getOrSet=I;function w(s){const i=[];return s.forEach((o,d)=>{i.push(`${d} => ${o}`)}),`Map(${s.size}) {${i.join(", ")}}`}e.mapToString=w;function k(s){const i=[];return s.forEach(o=>{i.push(o)}),`Set(${s.size}) {${i.join(", ")}}`}e.setToString=k;class L{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const o=i.charCodeAt(0),d=this._value.charCodeAt(this._pos);return o-d}value(){return this._value[this._pos]}}e.StringIterator=L;class D{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=D;class S{constructor(i=!0,o=!0){this._splitOnBackslash=i,this._caseSensitive=o}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let o=i.length-1;o>=0;o--,this._valueLen--){const d=this._value.charCodeAt(o);if(!(d===47||this._splitOnBackslash&&d===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=S;var T;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(T||(T={}));class E{constructor(i,o){this._ignorePathCasing=i,this._ignoreQueryAndFragment=o,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new S(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(i)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,t.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=E;class p{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(s){s[s.Left=-1]="Left",s[s.Mid=0]="Mid",s[s.Right=1]="Right"})(b||(b={}));class m{static forUris(i=()=>!1,o=()=>!1){return new m(new E(i,o))}static forPaths(i=!1){return new m(new S(void 0,!i))}static forStrings(){return new m(new L)}static forConfigKeys(){return new m(new D)}constructor(i){this._iter=i}clear(){this._root=void 0}fill(i,o){if(o){const d=o.slice(0);(0,l.shuffle)(d);for(const r of d)this.set(r,i)}else{const d=i.slice(0);(0,l.shuffle)(d);for(const r of d)this.set(r[0],r[1])}}set(i,o){const d=this._iter.reset(i);let r;this._root||(this._root=new p,this._root.segment=d.value());const a=[];for(r=this._root;;){const y=d.cmp(r.segment);if(y>0)r.left||(r.left=new p,r.left.segment=d.value()),a.push([-1,r]),r=r.left;else if(y<0)r.right||(r.right=new p,r.right.segment=d.value()),a.push([1,r]),r=r.right;else if(d.hasNext())d.next(),r.mid||(r.mid=new p,r.mid.segment=d.value()),a.push([0,r]),r=r.mid;else break}const f=r.value;r.value=o,r.key=i;for(let y=a.length-1;y>=0;y--){const R=a[y][1];R.updateHeight();const N=R.balanceFactor();if(N<-1||N>1){const M=a[y][0],A=a[y+1][0];if(M===1&&A===1)a[y][1]=R.rotateLeft();else if(M===-1&&A===-1)a[y][1]=R.rotateRight();else if(M===1&&A===-1)R.right=a[y+1][1]=a[y+1][1].rotateRight(),a[y][1]=R.rotateLeft();else if(M===-1&&A===1)R.left=a[y+1][1]=a[y+1][1].rotateLeft(),a[y][1]=R.rotateRight();else throw new Error;if(y>0)switch(a[y-1][0]){case-1:a[y-1][1].left=a[y][1];break;case 1:a[y-1][1].right=a[y][1];break;case 0:a[y-1][1].mid=a[y][1];break}else this._root=a[0][1]}}return f}get(i){return this._getNode(i)?.value}_getNode(i){const o=this._iter.reset(i);let d=this._root;for(;d;){const r=o.cmp(d.segment);if(r>0)d=d.left;else if(r<0)d=d.right;else if(o.hasNext())o.next(),d=d.mid;else break}return d}has(i){const o=this._getNode(i);return!(o?.value===void 0&&o?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,o){const d=this._iter.reset(i),r=[];let a=this._root;for(;a;){const f=d.cmp(a.segment);if(f>0)r.push([-1,a]),a=a.left;else if(f<0)r.push([1,a]),a=a.right;else if(d.hasNext())d.next(),r.push([0,a]),a=a.mid;else break}if(!!a){if(o?(a.left=void 0,a.mid=void 0,a.right=void 0,a.height=1):(a.key=void 0,a.value=void 0),!a.mid&&!a.value)if(a.left&&a.right){const f=this._min(a.right);if(f.key){const{key:y,value:R,segment:N}=f;this._delete(f.key,!1),a.key=y,a.value=R,a.segment=N}}else{const f=a.left??a.right;if(r.length>0){const[y,R]=r[r.length-1];switch(y){case-1:R.left=f;break;case 0:R.mid=f;break;case 1:R.right=f;break}}else this._root=f}for(let f=r.length-1;f>=0;f--){const y=r[f][1];y.updateHeight();const R=y.balanceFactor();if(R>1?(y.right.balanceFactor()>=0||(y.right=y.right.rotateRight()),r[f][1]=y.rotateLeft()):R<-1&&(y.left.balanceFactor()<=0||(y.left=y.left.rotateLeft()),r[f][1]=y.rotateRight()),f>0)switch(r[f-1][0]){case-1:r[f-1][1].left=r[f][1];break;case 1:r[f-1][1].right=r[f][1];break;case 0:r[f-1][1].mid=r[f][1];break}else this._root=r[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const o=this._iter.reset(i);let d=this._root,r;for(;d;){const a=o.cmp(d.segment);if(a>0)d=d.left;else if(a<0)d=d.right;else if(o.hasNext())o.next(),r=d.value||r,d=d.mid;else break}return d&&d.value||r}findSuperstr(i){const o=this._iter.reset(i);let d=this._root;for(;d;){const r=o.cmp(d.segment);if(r>0)d=d.left;else if(r<0)d=d.right;else if(o.hasNext())o.next(),d=d.mid;else return d.mid?this._entries(d.mid):void 0}}forEach(i){for(const[o,d]of this)i(d,o)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(i){const o=[];return this._dfsEntries(i,o),o[Symbol.iterator]()}_dfsEntries(i,o){!i||(i.left&&this._dfsEntries(i.left,o),i.value&&o.push([i.key,i.value]),i.mid&&this._dfsEntries(i.mid,o),i.right&&this._dfsEntries(i.right,o))}_isBalanced(){const i=o=>{if(!o)return!0;const d=o.balanceFactor();return d<-1||d>1?!1:i(o.left)&&i(o.right)};return i(this._root)}}e.TernarySearchTree=m;class v{constructor(i,o){this.uri=i,this.value=o}}class h{constructor(i,o){this[C]="ResourceMap",i instanceof h?(this.map=new Map(i.map),this.toKey=o??h.defaultToKey):(this.map=new Map,this.toKey=i??h.defaultToKey)}set(i,o){return this.map.set(this.toKey(i),new v(i,o)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,o){typeof o<"u"&&(i=i.bind(o));for(const[d,r]of this.map)i(r.value,r.uri,this)}*values(){for(const i of this.map.values())yield i.value}*keys(){for(const i of this.map.values())yield i.uri}*entries(){for(const i of this.map.values())yield[i.uri,i.value]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=h,h.defaultToKey=s=>s.toString();class c{constructor(i,o){this[P]="ResourceSet",!i||typeof i=="function"?this._map=new h(i):(this._map=new h(o),i.forEach(this.add,this))}get size(){return this._map.size}add(i){return this._map.set(i,i),this}clear(){this._map.clear()}delete(i){return this._map.delete(i)}forEach(i,o){this._map.forEach((d,r)=>i.call(o,r,r,this))}has(i){return this._map.has(i)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=c;var g;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(g=e.Touch||(e.Touch={}));class n{constructor(){this[_]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,o=0){const d=this._map.get(i);if(!!d)return o!==0&&this.touch(d,o),d.value}set(i,o,d=0){let r=this._map.get(i);if(r)r.value=o,d!==0&&this.touch(r,d);else{switch(r={key:i,value:o,next:void 0,previous:void 0},d){case 0:this.addItemLast(r);break;case 1:this.addItemFirst(r);break;case 2:this.addItemLast(r);break;default:this.addItemLast(r);break}this._map.set(i,r),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const o=this._map.get(i);if(!!o)return this._map.delete(i),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,o){const d=this._state;let r=this._head;for(;r;){if(o?i.bind(o)(r.value,r.key,this):i(r.value,r.key,this),this._state!==d)throw new Error("LinkedMap got modified during iteration.");r=r.next}}keys(){const i=this,o=this._state;let d=this._head;const r={[Symbol.iterator](){return r},next(){if(i._state!==o)throw new Error("LinkedMap got modified during iteration.");if(d){const a={value:d.key,done:!1};return d=d.next,a}else return{value:void 0,done:!0}}};return r}values(){const i=this,o=this._state;let d=this._head;const r={[Symbol.iterator](){return r},next(){if(i._state!==o)throw new Error("LinkedMap got modified during iteration.");if(d){const a={value:d.value,done:!1};return d=d.next,a}else return{value:void 0,done:!0}}};return r}entries(){const i=this,o=this._state;let d=this._head;const r={[Symbol.iterator](){return r},next(){if(i._state!==o)throw new Error("LinkedMap got modified during iteration.");if(d){const a={value:[d.key,d.value],done:!1};return d=d.next,a}else return{value:void 0,done:!0}}};return r}[(_=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let o=this._head,d=this.size;for(;o&&d>i;)this._map.delete(o.key),o=o.next,d--;this._head=o,this._size=d,o&&(o.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const o=i.next,d=i.previous;if(!o||!d)throw new Error("Invalid list");o.previous=d,d.next=o}i.next=void 0,i.previous=void 0,this._state++}touch(i,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(i===this._head)return;const d=i.next,r=i.previous;i===this._tail?(r.next=void 0,this._tail=r):(d.previous=r,r.next=d),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(o===2){if(i===this._tail)return;const d=i.next,r=i.previous;i===this._head?(d.previous=void 0,this._head=d):(d.previous=r,r.next=d),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((o,d)=>{i.push([d,o])}),i}fromJSON(i){this.clear();for(const[o,d]of i)this.set(o,d)}}e.LinkedMap=n;class u extends n{constructor(i,o=1){super(),this._limit=i,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,o=2){return super.get(i,o)}peek(i){return super.get(i,0)}set(i,o){return super.set(i,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=u}),define(De[103],Ie([1,0,26,8]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function C(...ne){return function(ie,O){for(let V=0,q=ne.length;V<q;V++){const X=ne[V](ie,O);if(X)return X}return null}}e.or=C,e.matchesStrictPrefix=P.bind(void 0,!1),e.matchesPrefix=P.bind(void 0,!0);function P(ne,ie,O){if(!O||O.length<ie.length)return null;let V;return ne?V=t.startsWithIgnoreCase(O,ie):V=O.indexOf(ie)===0,V?ie.length>0?[{start:0,end:ie.length}]:[]:null}function _(ne,ie){const O=ie.toLowerCase().indexOf(ne.toLowerCase());return O===-1?null:[{start:O,end:O+ne.length}]}e.matchesContiguousSubString=_;function I(ne,ie){return w(ne.toLowerCase(),ie.toLowerCase(),0,0)}e.matchesSubString=I;function w(ne,ie,O,V){if(O===ne.length)return[];if(V===ie.length)return null;if(ne[O]===ie[V]){let q=null;return(q=w(ne,ie,O+1,V+1))?m({start:V,end:V+1},q):null}return w(ne,ie,O,V+1)}function k(ne){return 97<=ne&&ne<=122}function L(ne){return 65<=ne&&ne<=90}e.isUpper=L;function D(ne){return 48<=ne&&ne<=57}function S(ne){return ne===32||ne===9||ne===10||ne===13}const T=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ne=>T.add(ne.charCodeAt(0)));function E(ne){return S(ne)||T.has(ne)}function p(ne,ie){return ne===ie||E(ne)&&E(ie)}function b(ne){return k(ne)||L(ne)||D(ne)}function m(ne,ie){return ie.length===0?ie=[ne]:ne.end===ie[0].start?ie[0].start=ne.start:ie.unshift(ne),ie}function v(ne,ie){for(let O=ie;O<ne.length;O++){const V=ne.charCodeAt(O);if(L(V)||D(V)||O>0&&!b(ne.charCodeAt(O-1)))return O}return ne.length}function h(ne,ie,O,V){if(O===ne.length)return[];if(V===ie.length)return null;if(ne[O]!==ie[V].toLowerCase())return null;{let q=null,X=V+1;for(q=h(ne,ie,O+1,V+1);!q&&(X=v(ie,X))<ie.length;)q=h(ne,ie,O+1,X),X++;return q===null?null:m({start:V,end:V+1},q)}}function c(ne){let ie=0,O=0,V=0,q=0,X=0;for(let ye=0;ye<ne.length;ye++)X=ne.charCodeAt(ye),L(X)&&ie++,k(X)&&O++,b(X)&&V++,D(X)&&q++;const ge=ie/ne.length,we=O/ne.length,ce=V/ne.length,Ce=q/ne.length;return{upperPercent:ge,lowerPercent:we,alphaPercent:ce,numericPercent:Ce}}function g(ne){const{upperPercent:ie,lowerPercent:O}=ne;return O===0&&ie>.6}function n(ne){const{upperPercent:ie,lowerPercent:O,alphaPercent:V,numericPercent:q}=ne;return O>.2&&ie<.8&&V>.6&&q<.2}function u(ne){let ie=0,O=0,V=0,q=0;for(let X=0;X<ne.length;X++)V=ne.charCodeAt(X),L(V)&&ie++,k(V)&&O++,S(V)&&q++;return(ie===0||O===0)&&q===0?ne.length<=30:ie<=5}function s(ne,ie){if(!ie||(ie=ie.trim(),ie.length===0)||!u(ne)||ie.length>60)return null;const O=c(ie);if(!n(O)){if(!g(O))return null;ie=ie.toLowerCase()}let V=null,q=0;for(ne=ne.toLowerCase();q<ie.length&&(V=h(ne,ie,0,q))===null;)q=v(ie,q+1);return V}e.matchesCamelCase=s;function i(ne,ie,O=!1){if(!ie||ie.length===0)return null;let V=null,q=0;for(ne=ne.toLowerCase(),ie=ie.toLowerCase();q<ie.length&&(V=o(ne,ie,0,q,O))===null;)q=d(ie,q+1);return V}e.matchesWords=i;function o(ne,ie,O,V,q){if(O===ne.length)return[];if(V===ie.length)return null;if(p(ne.charCodeAt(O),ie.charCodeAt(V))){let X=null,ge=V+1;if(X=o(ne,ie,O+1,V+1,q),!q)for(;!X&&(ge=d(ie,ge))<ie.length;)X=o(ne,ie,O+1,ge,q),ge++;return X?ne.charCodeAt(O)!==ie.charCodeAt(V)?X:m({start:V,end:V+1},X):null}else return null}function d(ne,ie){for(let O=ie;O<ne.length;O++)if(E(ne.charCodeAt(O))||O>0&&E(ne.charCodeAt(O-1)))return O;return ne.length}const r=C(e.matchesPrefix,s,_),a=C(e.matchesPrefix,s,I),f=new l.LRUCache(1e4);function y(ne,ie,O=!1){if(typeof ne!="string"||typeof ie!="string")return null;let V=f.get(ne);V||(V=new RegExp(t.convertSimple2RegExpPattern(ne),"i"),f.set(ne,V));const q=V.exec(ie);return q?[{start:q.index,end:q.index+q[0].length}]:O?a(ne,ie):r(ne,ie)}e.matchesFuzzy=y;function R(ne,ie){const O=Re(ne,ne.toLowerCase(),0,ie,ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return O?M(O):null}e.matchesFuzzy2=R;function N(ne,ie,O,V,q,X){const ge=Math.min(13,ne.length);for(;O<ge;O++){const we=Re(ne,ie,O,V,q,X,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(we)return we}return[0,X]}e.anyScore=N;function M(ne){if(typeof ne>"u")return[];const ie=[],O=ne[1];for(let V=ne.length-1;V>1;V--){const q=ne[V]+O,X=ie[ie.length-1];X&&X.end===q?X.end=q+1:ie.push({start:q,end:q+1})}return ie}e.createMatches=M;const A=128;function z(){const ne=[],ie=[];for(let O=0;O<=A;O++)ie[O]=0;for(let O=0;O<=A;O++)ne.push(ie.slice(0));return ne}function H(ne){const ie=[];for(let O=0;O<=ne;O++)ie[O]=0;return ie}const F=H(2*A),G=H(2*A),B=z(),U=z(),x=z(),$=!1;function Q(ne,ie,O,V,q){function X(we,ce,Ce=" "){for(;we.length<ce;)we=Ce+we;return we}let ge=` |   |${V.split("").map(we=>X(we,3)).join("|")}
`;for(let we=0;we<=O;we++)we===0?ge+=" |":ge+=`${ie[we-1]}|`,ge+=ne[we].slice(0,q+1).map(ce=>X(ce.toString(),3)).join("|")+`
`;return ge}function K(ne,ie,O,V){ne=ne.substr(ie),O=O.substr(V),console.log(Q(U,ne,ne.length,O,O.length)),console.log(Q(x,ne,ne.length,O,O.length)),console.log(Q(B,ne,ne.length,O,O.length))}function de(ne,ie){if(ie<0||ie>=ne.length)return!1;const O=ne.codePointAt(ie);switch(O){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(O)}}function te(ne,ie){if(ie<0||ie>=ne.length)return!1;switch(ne.charCodeAt(ie)){case 32:case 9:return!0;default:return!1}}function he(ne,ie,O){return ie[ne]!==O[ne]}function Y(ne,ie,O,V,q,X,ge=!1){for(;ie<O&&q<X;)ne[ie]===V[q]&&(ge&&(F[ie]=q),ie+=1),q+=1;return ie===O}e.isPatternInWord=Y;var ve;(function(ne){ne[ne.Diag=1]="Diag",ne[ne.Left=2]="Left",ne[ne.LeftLeft=3]="LeftLeft"})(ve||(ve={}));var be;(function(ne){ne.Default=[-100,0];function ie(O){return!O||O.length===2&&O[0]===-100&&O[1]===0}ne.isDefault=ie})(be=e.FuzzyScore||(e.FuzzyScore={}));class ke{constructor(ie,O){this.firstMatchCanBeWeak=ie,this.boostFullMatch=O}}e.FuzzyScoreOptions=ke,ke.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Re(ne,ie,O,V,q,X,ge=ke.default){const we=ne.length>A?A:ne.length,ce=V.length>A?A:V.length;if(O>=we||X>=ce||we-O>ce-X||!Y(ie,O,we,q,X,ce,!0))return;ze(we,ce,O,X,ie,q);let Ce=1,ye=1,We=O,qe=X;const Ze=[!1];for(Ce=1,We=O;We<we;Ce++,We++){const se=F[We],Ee=G[We],xe=We+1<we?G[We+1]:ce;for(ye=se-X+1,qe=se;qe<xe;ye++,qe++){let fe=Number.MIN_SAFE_INTEGER,Ae=!1;qe<=Ee&&(fe=oe(ne,ie,We,O,V,q,qe,ce,X,B[Ce-1][ye-1]===0,Ze));let Le=0;fe!==Number.MAX_SAFE_INTEGER&&(Ae=!0,Le=fe+U[Ce-1][ye-1]);const Me=qe>se,Ge=Me?U[Ce][ye-1]+(B[Ce][ye-1]>0?-5:0):0,Je=qe>se+1&&B[Ce][ye-1]>0,st=Je?U[Ce][ye-2]+(B[Ce][ye-2]>0?-5:0):0;if(Je&&(!Me||st>=Ge)&&(!Ae||st>=Le))U[Ce][ye]=st,x[Ce][ye]=3,B[Ce][ye]=0;else if(Me&&(!Ae||Ge>=Le))U[Ce][ye]=Ge,x[Ce][ye]=2,B[Ce][ye]=0;else if(Ae)U[Ce][ye]=Le,x[Ce][ye]=1,B[Ce][ye]=B[Ce-1][ye-1]+1;else throw new Error("not possible")}}if($&&K(ne,O,V,X),!Ze[0]&&!ge.firstMatchCanBeWeak)return;Ce--,ye--;const Ye=[U[Ce][ye],X];let Oe=0,ot=0;for(;Ce>=1;){let se=ye;do{const Ee=x[Ce][se];if(Ee===3)se=se-2;else if(Ee===2)se=se-1;else break}while(se>=1);Oe>1&&ie[O+Ce-1]===q[X+ye-1]&&!he(se+X-1,V,q)&&Oe+1>B[Ce][se]&&(se=ye),se===ye?Oe++:Oe=1,ot||(ot=se),Ce--,ye=se-1,Ye.push(ye)}ce===we&&ge.boostFullMatch&&(Ye[0]+=2);const re=ot-we;return Ye[0]-=re,Ye}e.fuzzyScore=Re;function ze(ne,ie,O,V,q,X){let ge=ne-1,we=ie-1;for(;ge>=O&&we>=V;)q[ge]===X[we]&&(G[ge]=we,ge--),we--}function oe(ne,ie,O,V,q,X,ge,we,ce,Ce,ye){if(ie[O]!==X[ge])return Number.MIN_SAFE_INTEGER;let We=1,qe=!1;return ge===O-V?We=ne[O]===q[ge]?7:5:he(ge,q,X)&&(ge===0||!he(ge-1,q,X))?(We=ne[O]===q[ge]?7:5,qe=!0):de(X,ge)&&(ge===0||!de(X,ge-1))?We=5:(de(X,ge-1)||te(X,ge-1))&&(We=5,qe=!0),We>1&&O===V&&(ye[0]=!0),qe||(qe=he(ge,q,X)||de(X,ge-1)||te(X,ge-1)),O===V?ge>ce&&(We-=qe?3:5):Ce?We+=qe?2:0:We+=qe?0:1,ge+1===we&&(We-=qe?3:5),We}function le(ne,ie,O,V,q,X,ge){return Z(ne,ie,O,V,q,X,!0,ge)}e.fuzzyScoreGracefulAggressive=le;function me(ne,ie,O,V,q,X,ge){return Z(ne,ie,O,V,q,X,!1,ge)}e.fuzzyScoreGraceful=me;function Z(ne,ie,O,V,q,X,ge,we){let ce=Re(ne,ie,O,V,q,X,we);if(ce&&!ge)return ce;if(ne.length>=3){const Ce=Math.min(7,ne.length-1);for(let ye=O+1;ye<Ce;ye++){const We=ae(ne,ye);if(We){const qe=Re(We,We.toLowerCase(),O,V,q,X,we);qe&&(qe[0]-=3,(!ce||qe[0]>ce[0])&&(ce=qe))}}}return ce}function ae(ne,ie){if(ie+1>=ne.length)return;const O=ne[ie],V=ne[ie+1];if(O!==V)return ne.slice(0,ie)+V+O+ne.slice(ie+2)}}),define(De[157],Ie([1,0,74,103,8]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const P=new RegExp(`\\$\\(${l.CSSIcon.iconNameExpression}(?:${l.CSSIcon.iconModifierExpression})?\\)`,"g"),_=new RegExp(l.CSSIcon.iconNameCharacter),I=new RegExp(`(\\\\)?${P.source}`,"g");function w(b){return b.replace(I,(m,v)=>v?m:`\\${m}`)}e.escapeIcons=w;const k=new RegExp(`\\\\${P.source}`,"g");function L(b){return b.replace(k,m=>`\\${m}`)}e.markdownEscapeEscapedIcons=L;const D=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function S(b){return b.indexOf(e.iconStartMarker)===-1?b:b.replace(D,(m,v,h,c)=>h?m:v||c||"")}e.stripIcons=S;function T(b){const m=b.indexOf(e.iconStartMarker);return m===-1?{text:b}:E(b,m)}e.parseLabelWithIcons=T;function E(b,m){const v=[];let h="";function c(r){if(r){h+=r;for(const a of r)v.push(u)}}let g=-1,n="",u=0,s,i,o=m;const d=b.length;for(c(b.substr(0,m));o<d;)s=b[o],i=b[o+1],s===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(g=o,c(n),n=e.iconStartMarker,o++):s===")"&&g!==-1?(u+=o-g+1,g=-1,n=""):g!==-1?_.test(s)?n+=s:(c(n),g=-1,n=""):c(s),o++;return c(n),{text:h,iconOffsets:v}}function p(b,m,v=!1){const{text:h,iconOffsets:c}=m;if(!c||c.length===0)return(0,t.matchesFuzzy)(b,h,v);const g=(0,C.ltrim)(h," "),n=h.length-g.length,u=(0,t.matchesFuzzy)(b,g,v);if(u)for(const s of u){const i=c[s.start+n]+n;s.start+=i,s.end+=i}return u}e.matchesFuzzyIconAware=p}),define(De[79],Ie([1,0,26]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new l.LRUCache(1e4);function C(k){return w(k,"NFC",t)}e.normalizeNFC=C;const P=new l.LRUCache(1e4);function _(k){return w(k,"NFD",P)}e.normalizeNFD=_;const I=/[^\u0000-\u0080]/;function w(k,L,D){if(!k)return k;const S=D.get(k);if(S)return S;let T;return I.test(k)?T=k.normalize(L):T=k,D.set(k,T),T}e.removeAccents=function(){const k=/[\u0300-\u036f]/g;return function(L){return _(L).replace(k,"")}}()}),define(De[42],Ie([1,0,8]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(t||(t={})),function(C){const P="error",_="warning",I="warn",w="info",k="ignore";function L(S){return S?l.equalsIgnoreCase(P,S)?C.Error:l.equalsIgnoreCase(_,S)||l.equalsIgnoreCase(I,S)?C.Warning:l.equalsIgnoreCase(w,S)?C.Info:C.Ignore:C.Ignore}C.fromValue=L;function D(S){switch(S){case C.Error:return P;case C.Warning:return _;case C.Info:return w;default:return k}}C.toString=D}(t||(t={})),e.default=t}),define(De[2],Ie([1,0,9,11]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const C=/^\w[\w\d+.-]*$/,P=/^\//,_=/^\/\//;function I(s,i){if(!s.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!C.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!P.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(_.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(s,i){return!s&&!i?"file":s}function k(s,i){switch(s){case"https":case"http":case"file":i?i[0]!==D&&(i=D+i):i=D;break}return i}const L="",D="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class T{static isUri(i){return i instanceof T?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}constructor(i,o,d,r,a,f=!1){typeof i=="object"?(this.scheme=i.scheme||L,this.authority=i.authority||L,this.path=i.path||L,this.query=i.query||L,this.fragment=i.fragment||L):(this.scheme=w(i,f),this.authority=o||L,this.path=k(this.scheme,d||L),this.query=r||L,this.fragment=a||L,I(this,f))}get fsPath(){return h(this,!1)}with(i){if(!i)return this;let{scheme:o,authority:d,path:r,query:a,fragment:f}=i;return o===void 0?o=this.scheme:o===null&&(o=L),d===void 0?d=this.authority:d===null&&(d=L),r===void 0?r=this.path:r===null&&(r=L),a===void 0?a=this.query:a===null&&(a=L),f===void 0?f=this.fragment:f===null&&(f=L),o===this.scheme&&d===this.authority&&r===this.path&&a===this.query&&f===this.fragment?this:new p(o,d,r,a,f)}static parse(i,o=!1){const d=S.exec(i);return d?new p(d[2]||L,u(d[4]||L),u(d[5]||L),u(d[7]||L),u(d[9]||L),o):new p(L,L,L,L,L)}static file(i){let o=L;if(t.isWindows&&(i=i.replace(/\\/g,D)),i[0]===D&&i[1]===D){const d=i.indexOf(D,2);d===-1?(o=i.substring(2),i=D):(o=i.substring(2,d),i=i.substring(d)||D)}return new p("file",o,i,L,L)}static from(i){const o=new p(i.scheme,i.authority,i.path,i.query,i.fragment);return I(o,!0),o}static joinPath(i,...o){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let d;return t.isWindows&&i.scheme==="file"?d=T.file(l.win32.join(h(i,!0),...o)).path:d=l.posix.join(i.path,...o),i.with({path:d})}toString(i=!1){return c(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof T)return i;{const o=new p(i);return o._formatted=i.external,o._fsPath=i._sep===E?i.fsPath:null,o}}else return i}}e.URI=T;const E=t.isWindows?1:void 0;class p extends T{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(i=!1){return i?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=E),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(s,i){let o,d=-1;for(let r=0;r<s.length;r++){const a=s.charCodeAt(r);if(a>=97&&a<=122||a>=65&&a<=90||a>=48&&a<=57||a===45||a===46||a===95||a===126||i&&a===47)d!==-1&&(o+=encodeURIComponent(s.substring(d,r)),d=-1),o!==void 0&&(o+=s.charAt(r));else{o===void 0&&(o=s.substr(0,r));const f=b[a];f!==void 0?(d!==-1&&(o+=encodeURIComponent(s.substring(d,r)),d=-1),o+=f):d===-1&&(d=r)}}return d!==-1&&(o+=encodeURIComponent(s.substring(d))),o!==void 0?o:s}function v(s){let i;for(let o=0;o<s.length;o++){const d=s.charCodeAt(o);d===35||d===63?(i===void 0&&(i=s.substr(0,o)),i+=b[d]):i!==void 0&&(i+=s[o])}return i!==void 0?i:s}function h(s,i){let o;return s.authority&&s.path.length>1&&s.scheme==="file"?o=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?i?o=s.path.substr(1):o=s.path[1].toLowerCase()+s.path.substr(2):o=s.path,t.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=h;function c(s,i){const o=i?v:m;let d="",{scheme:r,authority:a,path:f,query:y,fragment:R}=s;if(r&&(d+=r,d+=":"),(a||r==="file")&&(d+=D,d+=D),a){let N=a.indexOf("@");if(N!==-1){const M=a.substr(0,N);a=a.substr(N+1),N=M.indexOf(":"),N===-1?d+=o(M,!1):(d+=o(M.substr(0,N),!1),d+=":",d+=o(M.substr(N+1),!1)),d+="@"}a=a.toLowerCase(),N=a.indexOf(":"),N===-1?d+=o(a,!1):(d+=o(a.substr(0,N),!1),d+=a.substr(N))}if(f){if(f.length>=3&&f.charCodeAt(0)===47&&f.charCodeAt(2)===58){const N=f.charCodeAt(1);N>=65&&N<=90&&(f=`/${String.fromCharCode(N+32)}:${f.substr(3)}`)}else if(f.length>=2&&f.charCodeAt(1)===58){const N=f.charCodeAt(0);N>=65&&N<=90&&(f=`${String.fromCharCode(N+32)}:${f.substr(2)}`)}d+=o(f,!0)}return y&&(d+="?",d+=o(y,!1)),R&&(d+="#",d+=i?R:m(R,!1)),d}function g(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+g(s.substr(3)):s}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function u(s){return s.match(n)?s.replace(n,i=>g(i)):s}}),define(De[80],Ie([1,0,23,8,2]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function P(k){return JSON.stringify(k,I)}e.stringify=P;function _(k){let L=JSON.parse(k);return L=w(L),L}e.parse=_;function I(k,L){return L instanceof RegExp?{$mid:2,source:L.source,flags:(0,t.regExpFlags)(L)}:L}function w(k,L=0){if(!k||L>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return C.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 14:return new Date(k.source)}if(k instanceof l.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let D=0;D<k.length;++D)k[D]=w(k[D],L+1);else for(const D in k)Object.hasOwnProperty.call(k,D)&&(k[D]=w(k[D],L+1))}return k}e.revive=w}),define(De[12],Ie([1,0,11,2]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var C;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebook="vscode-notebook",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractive="vscode-interactive",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm"})(C=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class P{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${C.vscodeRemoteResource}`}setPreferredWebSchema(k){this._preferredWebSchema=k}setDelegate(k){this._delegate=k}setServerRootPath(k){this._remoteResourcesPath=`${k}/${C.vscodeRemoteResource}`}set(k,L,D){this._hosts[k]=L,this._ports[k]=D}setConnectionToken(k,L){this._connectionTokens[k]=L}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(k){if(this._delegate)return this._delegate(k);const L=k.authority;let D=this._hosts[L];D&&D.indexOf(":")!==-1&&D.indexOf("[")===-1&&(D=`[${D}]`);const S=this._ports[L],T=this._connectionTokens[L];let E=`path=${encodeURIComponent(k.path)}`;return typeof T=="string"&&(E+=`&${e.connectionTokenQueryName}=${encodeURIComponent(T)}`),t.URI.from({scheme:l.isWeb?this._preferredWebSchema:C.vscodeRemoteResource,authority:`${D}:${S}`,path:this._remoteResourcesPath,query:E})}}e.RemoteAuthorities=new P;class _{asBrowserUri(k,L){const D=this.toUri(k,L);return D.scheme===C.vscodeRemote?e.RemoteAuthorities.rewrite(D):D.scheme===C.file&&(l.isNative||l.isWebWorker&&l.globals.origin===`${C.vscodeFileResource}://${_.FALLBACK_AUTHORITY}`)?D.with({scheme:C.vscodeFileResource,authority:D.authority||_.FALLBACK_AUTHORITY,query:null,fragment:null}):D}asFileUri(k,L){const D=this.toUri(k,L);return D.scheme===C.vscodeFileResource?D.with({scheme:C.file,authority:D.authority!==_.FALLBACK_AUTHORITY?D.authority:null,query:null,fragment:null}):D}toUri(k,L){return t.URI.isUri(k)?k:t.URI.parse(L.toUrl(k))}}_.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new _;var I;(function(w){const k=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);w.CoopAndCoep=Object.freeze(k.get("3"));const L="vscode-coi";function D(T){let E;typeof T=="string"?E=new URL(T).searchParams:T instanceof URL?E=T.searchParams:t.URI.isUri(T)&&(E=new URL(T.toString(!0)).searchParams);const p=E?.get(L);if(!!p)return k.get(p)}w.getHeadersFromQuery=D;function S(T,E,p){if(!globalThis.crossOriginIsolated)return;const b=E&&p?"3":p?"2":"1";T instanceof URLSearchParams?T.set(L,b):T[L]=b}w.addSearchParam=S})(I=e.COI||(e.COI={}))}),define(De[22],Ie([1,0,31,12,9,11,8,2]),function(J,e,l,t,C,P,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function w(T){return(0,I.uriToFsPath)(T,!0)}e.originalFSPath=w;class k{constructor(E){this._ignorePathCasing=E}compare(E,p,b=!1){return E===p?0:(0,_.compare)(this.getComparisonKey(E,b),this.getComparisonKey(p,b))}isEqual(E,p,b=!1){return E===p?!0:!E||!p?!1:this.getComparisonKey(E,b)===this.getComparisonKey(p,b)}getComparisonKey(E,p=!1){return E.with({path:this._ignorePathCasing(E)?E.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(E){return this._ignorePathCasing(E)}isEqualOrParent(E,p,b=!1){if(E.scheme===p.scheme){if(E.scheme===t.Schemas.file)return l.isEqualOrParent(w(E),w(p),this._ignorePathCasing(E))&&E.query===p.query&&(b||E.fragment===p.fragment);if((0,e.isEqualAuthority)(E.authority,p.authority))return l.isEqualOrParent(E.path,p.path,this._ignorePathCasing(E),"/")&&E.query===p.query&&(b||E.fragment===p.fragment)}return!1}joinPath(E,...p){return I.URI.joinPath(E,...p)}basenameOrAuthority(E){return(0,e.basename)(E)||E.authority}basename(E){return C.posix.basename(E.path)}extname(E){return C.posix.extname(E.path)}dirname(E){if(E.path.length===0)return E;let p;return E.scheme===t.Schemas.file?p=I.URI.file(C.dirname(w(E))).path:(p=C.posix.dirname(E.path),E.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${E.toString})) resulted in a relative path`),p="/")),E.with({path:p})}normalizePath(E){if(!E.path.length)return E;let p;return E.scheme===t.Schemas.file?p=I.URI.file(C.normalize(w(E))).path:p=C.posix.normalize(E.path),E.with({path:p})}relativePath(E,p){if(E.scheme!==p.scheme||!(0,e.isEqualAuthority)(E.authority,p.authority))return;if(E.scheme===t.Schemas.file){const v=C.relative(w(E),w(p));return P.isWindows?l.toSlashes(v):v}let b=E.path||"/";const m=p.path||"/";if(this._ignorePathCasing(E)){let v=0;for(const h=Math.min(b.length,m.length);v<h&&!(b.charCodeAt(v)!==m.charCodeAt(v)&&b.charAt(v).toLowerCase()!==m.charAt(v).toLowerCase());v++);b=m.substr(0,v)+b.substr(v)}return C.posix.relative(b,m)}resolvePath(E,p){if(E.scheme===t.Schemas.file){const b=I.URI.file(C.resolve(w(E),p));return E.with({authority:b.authority,path:b.path})}return p=l.toPosixPath(p),E.with({path:C.posix.resolve(E.path,p)})}isAbsolutePath(E){return!!E.path&&E.path[0]==="/"}isEqualAuthority(E,p){return E===p||E!==void 0&&p!==void 0&&(0,_.equalsIgnoreCase)(E,p)}hasTrailingPathSeparator(E,p=C.sep){if(E.scheme===t.Schemas.file){const b=w(E);return b.length>l.getRoot(b).length&&b[b.length-1]===p}else{const b=E.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(E.fsPath)}}removeTrailingPathSeparator(E,p=C.sep){return(0,e.hasTrailingPathSeparator)(E,p)?E.with({path:E.path.substr(0,E.path.length-1)}):E}addTrailingPathSeparator(E,p=C.sep){let b=!1;if(E.scheme===t.Schemas.file){const m=w(E);b=m!==void 0&&m.length===l.getRoot(m).length&&m[m.length-1]===p}else{p="/";const m=E.path;b=m.length===1&&m.charCodeAt(m.length-1)===47}return!b&&!(0,e.hasTrailingPathSeparator)(E,p)?E.with({path:E.path+"/"}):E}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(T=>T.scheme===t.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new k(T=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(T,E){const p=[];for(let b=0;b<T.length;b++){const m=E(T[b]);T.some((v,h)=>h===b?!1:(0,e.isEqualOrParent)(m,E(v)))||p.push(T[b])}return p}e.distinctParents=L;var D;(function(T){T.META_DATA_LABEL="label",T.META_DATA_DESCRIPTION="description",T.META_DATA_SIZE="size",T.META_DATA_MIME="mime";function E(p){const b=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(h=>{const[c,g]=h.split(":");c&&g&&b.set(c,g)});const v=p.path.substring(0,p.path.indexOf(";"));return v&&b.set(T.META_DATA_MIME,v),b}T.parseMetaData=E})(D=e.DataUri||(e.DataUri={}));function S(T,E,p){if(E){let b=T.path;return b&&b[0]!==C.posix.sep&&(b=C.posix.sep+b),T.with({scheme:p,authority:E,path:b})}return T.with({scheme:p})}e.toLocalResource=S}),define(De[18],Ie([1,0,21,10,4,6,22,11]),function(J,e,l,t,C,P,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function w(he){return!!he&&typeof he.then=="function"}e.isThenable=w;function k(he){const Y=new l.CancellationTokenSource,ve=he(Y.token),be=new Promise((ke,Re)=>{const ze=Y.token.onCancellationRequested(()=>{ze.dispose(),Y.dispose(),Re(new t.CancellationError)});Promise.resolve(ve).then(oe=>{ze.dispose(),Y.dispose(),ke(oe)},oe=>{ze.dispose(),Y.dispose(),Re(oe)})});return new class{cancel(){Y.cancel()}then(ke,Re){return be.then(ke,Re)}catch(ke){return this.then(void 0,ke)}finally(ke){return be.finally(ke)}}}e.createCancelablePromise=k;function L(he,Y,ve){return new Promise((be,ke)=>{const Re=Y.onCancellationRequested(()=>{Re.dispose(),be(ve)});he.then(be,ke).finally(()=>Re.dispose())})}e.raceCancellation=L;function D(he,Y){return new Promise((ve,be)=>{const ke=Y.onCancellationRequested(()=>{ke.dispose(),be(new t.CancellationError)});he.then(ve,be).finally(()=>ke.dispose())})}e.raceCancellationError=D;async function S(he){let Y=-1;const ve=he.map((ke,Re)=>ke.then(ze=>(Y=Re,ze))),be=await Promise.race(ve);return he.forEach((ke,Re)=>{Re!==Y&&ke.cancel()}),be}e.raceCancellablePromises=S;function T(he,Y,ve){let be;const ke=setTimeout(()=>{be?.(void 0),ve?.()},Y);return Promise.race([he.finally(()=>clearTimeout(ke)),new Promise(Re=>be=Re)])}e.raceTimeout=T;function E(he){return new Promise((Y,ve)=>{const be=he();w(be)?be.then(Y,ve):Y(be)})}e.asPromise=E;class p{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Y){if(this.activePromise){if(this.queuedPromiseFactory=Y,!this.queuedPromise){const ve=()=>{this.queuedPromise=null;const be=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,be};this.queuedPromise=new Promise(be=>{this.activePromise.then(ve,ve).then(be)})}return new Promise((ve,be)=>{this.queuedPromise.then(ve,be)})}return this.activePromise=Y(),new Promise((ve,be)=>{this.activePromise.then(ke=>{this.activePromise=null,ve(ke)},ke=>{this.activePromise=null,be(ke)})})}}e.Throttler=p;class b{constructor(){this.current=Promise.resolve(null)}queue(Y){return this.current=this.current.then(()=>Y(),()=>Y())}}e.Sequencer=b;class m{constructor(){this.promiseMap=new Map}queue(Y,ve){const ke=(this.promiseMap.get(Y)??Promise.resolve()).catch(()=>{}).then(ve).finally(()=>{this.promiseMap.get(Y)===ke&&this.promiseMap.delete(Y)});return this.promiseMap.set(Y,ke),ke}}e.SequencerByKey=m;const v=(he,Y)=>{let ve=!0;const be=setTimeout(()=>{ve=!1,Y()},he);return{isTriggered:()=>ve,dispose:()=>{clearTimeout(be),ve=!1}}},h=he=>{let Y=!0;return queueMicrotask(()=>{Y&&(Y=!1,he())}),{isTriggered:()=>Y,dispose:()=>{Y=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class c{constructor(Y){this.defaultDelay=Y,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Y,ve=this.defaultDelay){this.task=Y,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ke,Re)=>{this.doResolve=ke,this.doReject=Re}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ke=this.task;return this.task=null,ke()}}));const be=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ve===e.MicrotaskDelay?h(be):v(ve,be),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=c;class g{constructor(Y){this.delayer=new c(Y),this.throttler=new p}trigger(Y,ve){return this.delayer.trigger(()=>this.throttler.queue(Y),ve)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=g;class n{constructor(){this._isOpen=!1,this._promise=new Promise((Y,ve)=>{this._completePromise=Y})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=n;class u extends n{constructor(Y){super(),this._timeout=setTimeout(()=>this.open(),Y)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function s(he,Y){return Y?new Promise((ve,be)=>{const ke=setTimeout(()=>{Re.dispose(),ve()},he),Re=Y.onCancellationRequested(()=>{clearTimeout(ke),Re.dispose(),be(new t.CancellationError)})}):k(ve=>s(he,ve))}e.timeout=s;function i(he,Y=0){const ve=setTimeout(he,Y);return(0,P.toDisposable)(()=>clearTimeout(ve))}e.disposableTimeout=i;function o(he){const Y=[];let ve=0;const be=he.length;function ke(){return ve<be?he[ve++]():null}function Re(ze){ze!=null&&Y.push(ze);const oe=ke();return oe?oe.then(Re):Promise.resolve(Y)}return Promise.resolve(null).then(Re)}e.sequence=o;function d(he,Y=be=>!!be,ve=null){let be=0;const ke=he.length,Re=()=>{if(be>=ke)return Promise.resolve(ve);const ze=he[be++];return Promise.resolve(ze()).then(le=>Y(le)?Promise.resolve(le):Re())};return Re()}e.first=d;function r(he,Y=be=>!!be,ve=null){if(he.length===0)return Promise.resolve(ve);let be=he.length;const ke=()=>{be=-1;for(const Re of he)Re.cancel?.()};return new Promise((Re,ze)=>{for(const oe of he)oe.then(le=>{--be>=0&&Y(le)?(ke(),Re(le)):be===0&&Re(ve)}).catch(le=>{--be>=0&&(ke(),ze(le))})})}e.firstParallel=r;class a{constructor(Y){this._size=0,this.maxDegreeOfParalellism=Y,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new C.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(Y){return this._size++,new Promise((ve,be)=>{this.outstandingPromises.push({factory:Y,c:ve,e:be}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Y=this.outstandingPromises.shift();this.runningPromises++;const ve=Y.factory();ve.then(Y.c,Y.e),ve.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=a;class f extends a{constructor(){super(1)}}e.Queue=f;class y{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const Y=new x;return this.drainers.add(Y),Y.p}isDrained(){for(const[,Y]of this.queues)if(Y.size>0)return!1;return!0}queueFor(Y,ve=_.extUri){const be=ve.getComparisonKey(Y);let ke=this.queues.get(be);return ke||(ke=new f,C.Event.once(ke.onDrained)(()=>{ke?.dispose(),this.queues.delete(be),this.onDidQueueDrain()}),this.queues.set(be,ke)),ke}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const Y of this.drainers)Y.complete();this.drainers.clear()}dispose(){for(const[,Y]of this.queues)Y.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=y;class R{constructor(Y,ve){this._token=-1,typeof Y=="function"&&typeof ve=="number"&&this.setIfNotSet(Y,ve)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Y,ve){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Y()},ve)}setIfNotSet(Y,ve){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Y()},ve))}}e.TimeoutTimer=R;class N{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Y,ve){this.cancel(),this._token=setInterval(()=>{Y()},ve)}}e.IntervalTimer=N;class M{constructor(Y,ve){this.timeoutToken=-1,this.runner=Y,this.timeout=ve,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Y=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Y)}get delay(){return this.timeout}set delay(Y){this.timeout=Y}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=M;class A{constructor(Y,ve){ve%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ve}ms is not a multiple of 1000ms.`),this.runner=Y,this.timeout=ve,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(Y=this.timeout){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(Y/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=A;class z extends M{constructor(Y,ve){super(Y,ve),this.units=[]}work(Y){this.units.push(Y),this.isScheduled()||this.schedule()}doRun(){const Y=this.units;this.units=[],this.runner?.(Y)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=z;class H extends P.Disposable{constructor(Y,ve){super(),this.options=Y,this.handler=ve,this.pendingWork=[],this.throttler=this._register(new P.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(Y){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+Y.length>this.options.maxBufferedWork)return!1}else if(this.pending+Y.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...Y),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new M(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=H,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=he=>{(0,I.setTimeout0)(()=>{if(Y)return;const ve=Date.now()+15;he(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ve-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.runWhenIdle=(he,Y)=>{const ve=requestIdleCallback(he,typeof Y=="number"?{timeout:Y}:void 0);let be=!1;return{dispose(){be||(be=!0,cancelIdleCallback(ve))}}}}();class F{constructor(Y){this._didRun=!1,this._executor=()=>{try{this._value=Y()}catch(ve){this._error=ve}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=F;async function G(he,Y,ve){let be;for(let ke=0;ke<ve;ke++)try{return await he()}catch(Re){be=Re,await s(Y)}throw be}e.retry=G;class B{hasPending(Y){return this._pending?typeof Y=="number"?this._pending.taskId===Y:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(Y,ve,be){return this._pending={taskId:Y,cancel:()=>be?.(),promise:ve},ve.then(()=>this.donePending(Y),()=>this.donePending(Y)),ve}donePending(Y){this._pending&&Y===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Y=this._next;this._next=void 0,Y.run().then(Y.promiseResolve,Y.promiseReject)}}setNext(Y){if(this._next)this._next.run=Y;else{let ve,be;const ke=new Promise((Re,ze)=>{ve=Re,be=ze});this._next={run:Y,promise:ke,promiseResolve:ve,promiseReject:be}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=B;class U{constructor(Y,ve=()=>Date.now()){this.interval=Y,this.nowFn=ve,this.lastIncrementTime=0,this.value=0}increment(){const Y=this.nowFn();return Y-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Y,this.value=0),this.value++,this.value}}e.IntervalCounter=U;class x{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Y,ve)=>{this.completeCallback=Y,this.errorCallback=ve})}complete(Y){return new Promise(ve=>{this.completeCallback(Y),this.resolved=!0,ve()})}error(Y){return new Promise(ve=>{this.errorCallback(Y),this.rejected=!0,ve()})}cancel(){new Promise(Y=>{this.errorCallback(new t.CancellationError),this.rejected=!0,Y()})}}e.DeferredPromise=x;var $;(function(he){async function Y(be){let ke;const Re=await Promise.all(be.map(ze=>ze.then(oe=>oe,oe=>{ke||(ke=oe)})));if(typeof ke<"u")throw ke;return Re}he.settled=Y;function ve(be){return new Promise(async(ke,Re)=>{try{await be(ke,Re)}catch(ze){Re(ze)}})}he.withAsyncBody=ve})($=e.Promises||(e.Promises={}));var Q;(function(he){he[he.Initial=0]="Initial",he[he.DoneOK=1]="DoneOK",he[he.DoneError=2]="DoneError"})(Q||(Q={}));class K{static fromArray(Y){return new K(ve=>{ve.emitMany(Y)})}static fromPromise(Y){return new K(async ve=>{ve.emitMany(await Y)})}static fromPromises(Y){return new K(async ve=>{await Promise.all(Y.map(async be=>ve.emitOne(await be)))})}static merge(Y){return new K(async ve=>{await Promise.all(Y.map(async be=>{for await(const ke of be)ve.emitOne(ke)}))})}constructor(Y){this._state=0,this._results=[],this._error=null,this._onStateChanged=new C.Emitter,queueMicrotask(async()=>{const ve={emitOne:be=>this.emitOne(be),emitMany:be=>this.emitMany(be),reject:be=>this.reject(be)};try{await Promise.resolve(Y(ve)),this.resolve()}catch(be){this.reject(be)}finally{ve.emitOne=void 0,ve.emitMany=void 0,ve.reject=void 0}})}[Symbol.asyncIterator](){let Y=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(Y<this._results.length)return{done:!1,value:this._results[Y++]};if(this._state===1)return{done:!0,value:void 0};await C.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(Y,ve){return new K(async be=>{for await(const ke of Y)be.emitOne(ve(ke))})}map(Y){return K.map(this,Y)}static filter(Y,ve){return new K(async be=>{for await(const ke of Y)ve(ke)&&be.emitOne(ke)})}filter(Y){return K.filter(this,Y)}static coalesce(Y){return K.filter(Y,ve=>!!ve)}coalesce(){return K.coalesce(this)}static async toPromise(Y){const ve=[];for await(const be of Y)ve.push(be);return ve}toPromise(){return K.toPromise(this)}emitOne(Y){this._state===0&&(this._results.push(Y),this._onStateChanged.fire())}emitMany(Y){this._state===0&&(this._results=this._results.concat(Y),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(Y){this._state===0&&(this._state=2,this._error=Y,this._onStateChanged.fire())}}e.AsyncIterableObject=K,K.EMPTY=K.fromArray([]);class de extends K{constructor(Y,ve){super(ve),this._source=Y}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=de;function te(he){const Y=new l.CancellationTokenSource,ve=he(Y.token);return new de(Y,async be=>{const ke=Y.token.onCancellationRequested(()=>{ke.dispose(),Y.dispose(),be.reject(new t.CancellationError)});try{for await(const Re of ve){if(Y.token.isCancellationRequested)return;be.emitOne(Re)}ke.dispose(),Y.dispose()}catch(Re){ke.dispose(),Y.dispose(),be.reject(Re)}})}e.createCancelableAsyncIterable=te}),define(De[104],Ie([1,0,18,9]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const C=new l.IdleValue(()=>{const f=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:f,collatorIsNumeric:f.resolvedOptions().numeric}}),P=new l.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),_=new l.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function I(f,y,R=!1){const N=f||"",M=y||"",A=C.value.collator.compare(N,M);return C.value.collatorIsNumeric&&A===0&&N!==M?N<M?-1:1:A}e.compareFileNames=I;function w(f,y){const R=P.value.collator;return f=f||"",y=y||"",g(R,f,y)}e.compareFileNamesDefault=w;function k(f,y){const R=P.value.collator;return f=f||"",y=y||"",i(f,y)||g(R,f,y)}e.compareFileNamesUpper=k;function L(f,y){const R=P.value.collator;return f=f||"",y=y||"",s(f,y)||g(R,f,y)}e.compareFileNamesLower=L;function D(f,y){return f=f||"",y=y||"",f===y?0:f<y?-1:1}e.compareFileNamesUnicode=D;function S(f,y,R=!1){R||(f=f&&f.toLowerCase(),y=y&&y.toLowerCase());const[N,M]=h(f),[A,z]=h(y);return N!==A?N<A?-1:1:M===z?0:M<z?-1:1}e.noIntlCompareFileNames=S;function T(f,y){const[R,N]=h(f),[M,A]=h(y);let z=C.value.collator.compare(N,A);if(z===0){if(C.value.collatorIsNumeric&&N!==A)return N<A?-1:1;if(z=C.value.collator.compare(R,M),C.value.collatorIsNumeric&&z===0&&R!==M)return R<M?-1:1}return z}e.compareFileExtensions=T;function E(f,y){f=f||"",y=y||"";const R=c(f),N=c(y),M=P.value.collator,A=_.value.collator;return g(A,R,N)||g(M,f,y)}e.compareFileExtensionsDefault=E;function p(f,y){f=f||"",y=y||"";const R=c(f),N=c(y),M=P.value.collator,A=_.value.collator;return g(A,R,N)||i(f,y)||g(M,f,y)}e.compareFileExtensionsUpper=p;function b(f,y){f=f||"",y=y||"";const R=c(f),N=c(y),M=P.value.collator,A=_.value.collator;return g(A,R,N)||s(f,y)||g(M,f,y)}e.compareFileExtensionsLower=b;function m(f,y){f=f||"",y=y||"";const R=c(f).toLowerCase(),N=c(y).toLowerCase();return R!==N?R<N?-1:1:f!==y?f<y?-1:1:0}e.compareFileExtensionsUnicode=m;const v=/^(.*?)(\.([^.]*))?$/;function h(f,y=!1){const R=f?v.exec(f):[];let N=[R&&R[1]||"",R&&R[3]||""];return y&&(!N[0]&&N[1]||N[0]&&N[0].charAt(0)===".")&&(N=[N[0]+"."+N[1],""]),N}function c(f){const y=f?v.exec(f):[];return y&&y[1]&&y[1].charAt(0)!=="."&&y[3]||""}function g(f,y,R){const N=f.compare(y,R);return N!==0?N:y.length!==R.length?y.length<R.length?-1:1:0}function n(f){const y=f.charAt(0);return y.toLocaleUpperCase()!==y}function u(f){const y=f.charAt(0);return y.toLocaleLowerCase()!==y}function s(f,y){return n(f)&&u(y)?-1:u(f)&&n(y)?1:0}function i(f,y){return u(f)&&n(y)?-1:n(f)&&u(y)?1:0}function o(f,y,R=!1){return R||(f=f&&f.toLowerCase(),y=y&&y.toLowerCase()),f===y?0:f<y?-1:1}function d(f,y,R=!1){const N=f.split(t.sep),M=y.split(t.sep),A=N.length-1,z=M.length-1;let H,F;for(let G=0;;G++){if(H=A===G,F=z===G,H&&F)return I(N[G],M[G],R);if(H)return-1;if(F)return 1;const B=o(N[G],M[G],R);if(B!==0)return B}}e.comparePaths=d;function r(f,y,R){const N=f.toLowerCase(),M=y.toLowerCase(),A=a(f,y,R);if(A)return A;const z=N.endsWith(R),H=M.endsWith(R);if(z!==H)return z?-1:1;const F=I(N,M);return F!==0?F:N.localeCompare(M)}e.compareAnything=r;function a(f,y,R){const N=f.toLowerCase(),M=y.toLowerCase(),A=N.startsWith(R),z=M.startsWith(R);if(A!==z)return A?-1:1;if(A&&z){if(N.length<M.length)return-1;if(N.length>M.length)return 1}return 0}e.compareByPrefix=a}),define(De[105],Ie([1,0,104,103,78,9,11,8]),function(J,e,l,t,C,P,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const w=0,k=[w,[]];function L(B,U,x,$){if(!B||!U)return k;const Q=B.length,K=U.length;if(Q<K)return k;const de=B.toLowerCase();return D(U,x,K,B,de,Q,$)}e.scoreFuzzy=L;function D(B,U,x,$,Q,K,de){const te=[],he=[];for(let ke=0;ke<x;ke++){const Re=ke*K,ze=Re-K,oe=ke>0,le=B[ke],me=U[ke];for(let Z=0;Z<K;Z++){const ae=Z>0,ne=Re+Z,ie=ne-1,O=ze+Z-1,V=ae?te[ie]:0,q=oe&&ae?te[O]:0,X=oe&&ae?he[O]:0;let ge;!q&&oe?ge=0:ge=S(le,me,$,Q,Z,X),ge&&q+ge>=V&&(de||oe||Q.startsWith(U,Z))?(he[ne]=X+1,te[ne]=q+ge):(he[ne]=w,te[ne]=V)}}const Y=[];let ve=x-1,be=K-1;for(;ve>=0&&be>=0;){const ke=ve*K+be;he[ke]===w||(Y.push(be),ve--),be--}return[te[x*K-1],Y.reverse()]}function S(B,U,x,$,Q,K){let de=0;if(!T(U,$[Q]))return de;if(de+=1,K>0&&(de+=K*5),B===x[Q]&&(de+=1),Q===0)de+=8;else{const te=E(x.charCodeAt(Q-1));te?de+=te:(0,t.isUpper)(x.charCodeAt(Q))&&K===0&&(de+=2)}return de}function T(B,U){return B===U?!0:B==="/"||B==="\\"?U==="/"||U==="\\":!1}function E(B){switch(B){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const p=[void 0,[]];function b(B,U,x=0,$=0){const Q=U;return Q.values&&Q.values.length>1?m(B,Q.values,x,$):v(B,U,x,$)}e.scoreFuzzy2=b;function m(B,U,x,$){let Q=0;const K=[];for(const de of U){const[te,he]=v(B,de,x,$);if(typeof te!="number")return p;Q+=te,K.push(...he)}return[Q,a(K)]}function v(B,U,x,$){const Q=(0,t.fuzzyScore)(U.original,U.originalLowercase,x,B,B.toLowerCase(),$,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Q?[Q[0],(0,t.createMatches)(Q)]:p}const h=Object.freeze({score:0}),c=1<<18,g=1<<17,n=1<<16;function u(B,U,x,$){const Q=$.values?$.values:[$];return(0,C.hash)({[$.normalized]:{values:Q.map(de=>({value:de.normalized,expectContiguousMatch:de.expectContiguousMatch})),label:B,description:U,allowNonContiguousMatches:x}})}function s(B,U,x,$,Q){if(!B||!U.normalized)return h;const K=$.getItemLabel(B);if(!K)return h;const de=$.getItemDescription(B),te=u(K,de,x,U),he=Q[te];if(he)return he;const Y=i(K,de,$.getItemPath(B),U,x);return Q[te]=Y,Y}e.scoreItemFuzzy=s;function i(B,U,x,$,Q){const K=!x||!$.containsPathSeparator;return x&&(_.isLinux?$.pathNormalized===x:(0,I.equalsIgnoreCase)($.pathNormalized,x))?{score:c,labelMatch:[{start:0,end:B.length}],descriptionMatch:U?[{start:0,end:U.length}]:void 0}:$.values&&$.values.length>1?o(B,U,x,$.values,K,Q):d(B,U,x,$,K,Q)}function o(B,U,x,$,Q,K){let de=0;const te=[],he=[];for(const Y of $){const{score:ve,labelMatch:be,descriptionMatch:ke}=d(B,U,x,Y,Q,K);if(ve===w)return h;de+=ve,be&&te.push(...be),ke&&he.push(...ke)}return{score:de,labelMatch:a(te),descriptionMatch:a(he)}}function d(B,U,x,$,Q,K){if(Q||!U){const[de,te]=L(B,$.normalized,$.normalizedLowercase,K&&!$.expectContiguousMatch);if(de){const he=(0,t.matchesPrefix)($.normalized,B);let Y;return he?(Y=g,Y+=Math.round($.normalized.length/B.length*100)):Y=n,{score:Y+de,labelMatch:he||r(te)}}}if(U){let de=U;x&&(de=`${U}${P.sep}`);const te=de.length,he=`${de}${B}`,[Y,ve]=L(he,$.normalized,$.normalizedLowercase,K&&!$.expectContiguousMatch);if(Y){const be=r(ve),ke=[],Re=[];return be.forEach(ze=>{ze.start<te&&ze.end>te?(ke.push({start:0,end:ze.end-te}),Re.push({start:ze.start,end:te})):ze.start>=te?ke.push({start:ze.start-te,end:ze.end-te}):Re.push(ze)}),{score:Y,labelMatch:ke,descriptionMatch:Re}}}return h}function r(B){const U=[];if(!B)return U;let x;for(const $ of B)x&&x.end===$?x.end+=1:(x={start:$,end:$+1},U.push(x));return U}function a(B){const U=B.sort((Q,K)=>Q.start-K.start),x=[];let $;for(const Q of U)!$||!f($,Q)?($=Q,x.push(Q)):($.start=Math.min($.start,Q.start),$.end=Math.max($.end,Q.end));return x}function f(B,U){return!(B.end<U.start||U.end<B.start)}function y(B,U,x,$,Q,K){const de=s(B,x,$,Q,K),te=s(U,x,$,Q,K),he=de.score,Y=te.score;if((he===c||Y===c)&&he!==Y)return he===c?-1:1;if(he>n||Y>n){if(he!==Y)return he>Y?-1:1;if(he<g&&Y<g){const le=N(de.labelMatch,te.labelMatch);if(le!==0)return le}const ze=Q.getItemLabel(B)||"",oe=Q.getItemLabel(U)||"";if(ze.length!==oe.length)return ze.length-oe.length}if(he!==Y)return he>Y?-1:1;const ve=Array.isArray(de.labelMatch)&&de.labelMatch.length>0,be=Array.isArray(te.labelMatch)&&te.labelMatch.length>0;if(ve&&!be)return-1;if(be&&!ve)return 1;const ke=R(B,de,Q),Re=R(U,te,Q);return ke&&Re&&ke!==Re?Re>ke?-1:1:M(B,U,x,Q)}e.compareItemsByFuzzyScore=y;function R(B,U,x){let $=-1,Q=-1;if(U.descriptionMatch&&U.descriptionMatch.length?$=U.descriptionMatch[0].start:U.labelMatch&&U.labelMatch.length&&($=U.labelMatch[0].start),U.labelMatch&&U.labelMatch.length){if(Q=U.labelMatch[U.labelMatch.length-1].end,U.descriptionMatch&&U.descriptionMatch.length){const K=x.getItemDescription(B);K&&(Q+=K.length)}}else U.descriptionMatch&&U.descriptionMatch.length&&(Q=U.descriptionMatch[U.descriptionMatch.length-1].end);return Q-$}function N(B,U){if(!B&&!U||(!B||!B.length)&&(!U||!U.length))return 0;if(!U||!U.length)return-1;if(!B||!B.length)return 1;const x=B[0].start,Q=B[B.length-1].end-x,K=U[0].start,te=U[U.length-1].end-K;return Q===te?0:te<Q?1:-1}function M(B,U,x,$){const Q=$.getItemLabel(B)||"",K=$.getItemLabel(U)||"",de=$.getItemDescription(B),te=$.getItemDescription(U),he=Q.length+(de?de.length:0),Y=K.length+(te?te.length:0);if(he!==Y)return he-Y;const ve=$.getItemPath(B),be=$.getItemPath(U);return ve&&be&&ve.length!==be.length?ve.length-be.length:Q!==K?(0,l.compareAnything)(Q,K,x.normalized):de&&te&&de!==te?(0,l.compareAnything)(de,te,x.normalized):ve&&be&&ve!==be?(0,l.compareAnything)(ve,be,x.normalized):0}function A(B){return B.startsWith('"')&&B.endsWith('"')}const z=" ";function H(B){typeof B!="string"&&(B="");const U=B.toLowerCase(),{pathNormalized:x,normalized:$,normalizedLowercase:Q}=F(B),K=x.indexOf(P.sep)>=0,de=A(B);let te;const he=B.split(z);if(he.length>1)for(const Y of he){const ve=A(Y),{pathNormalized:be,normalized:ke,normalizedLowercase:Re}=F(Y);ke&&(te||(te=[]),te.push({original:Y,originalLowercase:Y.toLowerCase(),pathNormalized:be,normalized:ke,normalizedLowercase:Re,expectContiguousMatch:ve}))}return{original:B,originalLowercase:U,pathNormalized:x,normalized:$,normalizedLowercase:Q,values:te,containsPathSeparator:K,expectContiguousMatch:de}}e.prepareQuery=H;function F(B){let U;_.isWindows?U=B.replace(/\//g,P.sep):U=B.replace(/\\/g,P.sep);const x=(0,I.stripWildcards)(U).replace(/\s|"/g,"");return{pathNormalized:U,normalized:x,normalizedLowercase:x.toLowerCase()}}function G(B){return Array.isArray(B)?H(B.map(U=>U.original).join(z)):H(B.original)}e.pieceToQuery=G}),define(De[36],Ie([1,0,17,18,31,26,9,11,8]),function(J,e,l,t,C,P,_,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const L="[/\\\\]",D="[^/\\\\]",S=/\//g;function T(x,$){switch(x){case 0:return"";case 1:return`${D}*?`;default:return`(?:${L}|${D}+${L}${$?`|${L}${D}+`:""})*?`}}function E(x,$){if(!x)return[];const Q=[];let K=!1,de=!1,te="";for(const he of x){switch(he){case $:if(!K&&!de){Q.push(te),te="";continue}break;case"{":K=!0;break;case"}":K=!1;break;case"[":de=!0;break;case"]":de=!1;break}te+=he}return te&&Q.push(te),Q}e.splitGlobAware=E;function p(x){if(!x)return"";let $="";const Q=E(x,e.GLOB_SPLIT);if(Q.every(K=>K===e.GLOBSTAR))$=".*";else{let K=!1;Q.forEach((de,te)=>{if(de===e.GLOBSTAR){if(K)return;$+=T(2,te===Q.length-1)}else{let he=!1,Y="",ve=!1,be="";for(const ke of de){if(ke!=="}"&&he){Y+=ke;continue}if(ve&&(ke!=="]"||!be)){let Re;ke==="-"?Re=ke:(ke==="^"||ke==="!")&&!be?Re="^":ke===e.GLOB_SPLIT?Re="":Re=(0,w.escapeRegExpCharacters)(ke),be+=Re;continue}switch(ke){case"{":he=!0;continue;case"[":ve=!0;continue;case"}":{$+=`(?:${E(Y,",").map(oe=>p(oe)).join("|")})`,he=!1,Y="";break}case"]":{$+="["+be+"]",ve=!1,be="";break}case"?":$+=D;continue;case"*":$+=T(1);continue;default:$+=(0,w.escapeRegExpCharacters)(ke)}}te<Q.length-1&&(Q[te+1]!==e.GLOBSTAR||te+2<Q.length)&&($+=L)}K=de===e.GLOBSTAR})}return $}const b=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,h=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new P.LRUCache(1e4),u=function(){return!1},s=function(){return null};function i(x,$){if(!x)return s;let Q;typeof x!="string"?Q=x.pattern:Q=x,Q=Q.trim();const K=`${Q}_${!!$.trimForExclusions}`;let de=n.get(K);if(de)return o(de,x);let te;return b.test(Q)?de=r(Q.substr(4),Q):(te=m.exec(d(Q,$)))?de=a(te[1],Q):($.trimForExclusions?h:v).test(Q)?de=f(Q,$):(te=c.exec(d(Q,$)))?de=y(te[1].substr(1),Q,!0):(te=g.exec(d(Q,$)))?de=y(te[1],Q,!1):de=R(Q),n.set(K,de),o(de,x)}function o(x,$){if(typeof $=="string")return x;const Q=function(K,de){return(0,C.isEqualOrParent)(K,$.base,!I.isLinux)?x(K.substr($.base.length+1),de):null};return Q.allBasenames=x.allBasenames,Q.allPaths=x.allPaths,Q.basenames=x.basenames,Q.patterns=x.patterns,Q}function d(x,$){return $.trimForExclusions&&x.endsWith("/**")?x.substr(0,x.length-2):x}function r(x,$){return function(Q,K){return typeof Q=="string"&&Q.endsWith(x)?$:null}}function a(x,$){const Q=`/${x}`,K=`\\${x}`,de=function(he,Y){return typeof he!="string"?null:Y?Y===x?$:null:he===x||he.endsWith(Q)||he.endsWith(K)?$:null},te=[x];return de.basenames=te,de.patterns=[$],de.allBasenames=te,de}function f(x,$){const Q=B(x.slice(1,-1).split(",").map(Y=>i(Y,$)).filter(Y=>Y!==s),x),K=Q.length;if(!K)return s;if(K===1)return Q[0];const de=function(Y,ve){for(let be=0,ke=Q.length;be<ke;be++)if(Q[be](Y,ve))return x;return null},te=Q.find(Y=>!!Y.allBasenames);te&&(de.allBasenames=te.allBasenames);const he=Q.reduce((Y,ve)=>ve.allPaths?Y.concat(ve.allPaths):Y,[]);return he.length&&(de.allPaths=he),de}function y(x,$,Q){const K=_.sep===_.posix.sep,de=K?x:x.replace(S,_.sep),te=_.sep+de,he=_.posix.sep+x;let Y;return Q?Y=function(ve,be){return typeof ve=="string"&&(ve===de||ve.endsWith(te)||!K&&(ve===x||ve.endsWith(he)))?$:null}:Y=function(ve,be){return typeof ve=="string"&&(ve===de||!K&&ve===x)?$:null},Y.allPaths=[(Q?"*/":"./")+x],Y}function R(x){try{const $=new RegExp(`^${p(x)}$`);return function(Q){return $.lastIndex=0,typeof Q=="string"&&$.test(Q)?x:null}}catch{return s}}function N(x,$,Q){return!x||typeof $!="string"?!1:M(x)($,void 0,Q)}e.match=N;function M(x,$={}){if(!x)return u;if(typeof x=="string"||A(x)){const Q=i(x,$);if(Q===s)return u;const K=function(de,te){return!!Q(de,te)};return Q.allBasenames&&(K.allBasenames=Q.allBasenames),Q.allPaths&&(K.allPaths=Q.allPaths),K}return F(x,$)}e.parse=M;function A(x){const $=x;return $?typeof $.base=="string"&&typeof $.pattern=="string":!1}e.isRelativePattern=A;function z(x){return x.allBasenames||[]}e.getBasenameTerms=z;function H(x){return x.allPaths||[]}e.getPathTerms=H;function F(x,$){const Q=B(Object.getOwnPropertyNames(x).map(Y=>G(Y,x[Y],$)).filter(Y=>Y!==s)),K=Q.length;if(!K)return s;if(!Q.some(Y=>!!Y.requiresSiblings)){if(K===1)return Q[0];const Y=function(ke,Re){let ze;for(let oe=0,le=Q.length;oe<le;oe++){const me=Q[oe](ke,Re);if(typeof me=="string")return me;(0,t.isThenable)(me)&&(ze||(ze=[]),ze.push(me))}return ze?(async()=>{for(const oe of ze){const le=await oe;if(typeof le=="string")return le}return null})():null},ve=Q.find(ke=>!!ke.allBasenames);ve&&(Y.allBasenames=ve.allBasenames);const be=Q.reduce((ke,Re)=>Re.allPaths?ke.concat(Re.allPaths):ke,[]);return be.length&&(Y.allPaths=be),Y}const de=function(Y,ve,be){let ke,Re;for(let ze=0,oe=Q.length;ze<oe;ze++){const le=Q[ze];le.requiresSiblings&&be&&(ve||(ve=(0,_.basename)(Y)),ke||(ke=ve.substr(0,ve.length-(0,_.extname)(Y).length)));const me=le(Y,ve,ke,be);if(typeof me=="string")return me;(0,t.isThenable)(me)&&(Re||(Re=[]),Re.push(me))}return Re?(async()=>{for(const ze of Re){const oe=await ze;if(typeof oe=="string")return oe}return null})():null},te=Q.find(Y=>!!Y.allBasenames);te&&(de.allBasenames=te.allBasenames);const he=Q.reduce((Y,ve)=>ve.allPaths?Y.concat(ve.allPaths):Y,[]);return he.length&&(de.allPaths=he),de}function G(x,$,Q){if($===!1)return s;const K=i(x,Q);if(K===s)return s;if(typeof $=="boolean")return K;if($){const de=$.when;if(typeof de=="string"){const te=(he,Y,ve,be)=>{if(!be||!K(he,Y))return null;const ke=de.replace("$(basename)",ve),Re=be(ke);return(0,t.isThenable)(Re)?Re.then(ze=>ze?x:null):Re?x:null};return te.requiresSiblings=!0,te}}return K}function B(x,$){const Q=x.filter(Y=>!!Y.basenames);if(Q.length<2)return x;const K=Q.reduce((Y,ve)=>{const be=ve.basenames;return be?Y.concat(be):Y},[]);let de;if($){de=[];for(let Y=0,ve=K.length;Y<ve;Y++)de.push($)}else de=Q.reduce((Y,ve)=>{const be=ve.patterns;return be?Y.concat(be):Y},[]);const te=function(Y,ve){if(typeof Y!="string")return null;if(!ve){let ke;for(ke=Y.length;ke>0;ke--){const Re=Y.charCodeAt(ke-1);if(Re===47||Re===92)break}ve=Y.substr(ke)}const be=K.indexOf(ve);return be!==-1?de[be]:null};te.basenames=K,te.patterns=de,te.allBasenames=K;const he=x.filter(Y=>!Y.basenames);return he.push(te),he}function U(x,$){return(0,l.equals)(x,$,(Q,K)=>typeof Q=="string"&&typeof K=="string"?Q===K:typeof Q!="string"&&typeof K!="string"?Q.base===K.base&&Q.pattern===K.pattern:!1)}e.patternsEquals=U}),define(De[106],Ie([1,0,10,157,22,8,2]),function(J,e,l,t,C,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var I;(function(b){b[b.Paragraph=0]="Paragraph",b[b.Break=1]="Break"})(I=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class w{constructor(m="",v=!1){if(this.value=m,typeof this.value!="string")throw(0,l.illegalArgument)("value");typeof v=="boolean"?(this.isTrusted=v,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=v.isTrusted??void 0,this.supportThemeIcons=v.supportThemeIcons??!1,this.supportHtml=v.supportHtml??!1)}appendText(m,v=0){return this.value+=S(this.supportThemeIcons?(0,t.escapeIcons)(m):m).replace(/([ \t]+)/g,(h,c)=>"&nbsp;".repeat(c.length)).replace(/\>/gm,"\\>").replace(/\n/g,v===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,v){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=v,this.value+="\n```\n",this}appendLink(m,v,h){return this.value+="[",this.value+=this._escape(v,"]"),this.value+="](",this.value+=this._escape(String(m),")"),h&&(this.value+=` "${this._escape(this._escape(h,'"'),")")}"`),this.value+=")",this}_escape(m,v){const h=new RegExp((0,P.escapeRegExpCharacters)(v),"g");return m.replace(h,(c,g)=>m.charAt(g-1)!=="\\"?`\\${c}`:c)}}e.MarkdownString=w;function k(b){return L(b)?!b.value:Array.isArray(b)?b.every(k):!0}e.isEmptyMarkdownString=k;function L(b){return b instanceof w?!0:b&&typeof b=="object"?typeof b.value=="string"&&(typeof b.isTrusted=="boolean"||b.isTrusted===void 0)&&(typeof b.supportThemeIcons=="boolean"||b.supportThemeIcons===void 0):!1}e.isMarkdownString=L;function D(b,m){return b===m?!0:!b||!m?!1:b.value===m.value&&b.isTrusted===m.isTrusted&&b.supportThemeIcons===m.supportThemeIcons&&b.supportHtml===m.supportHtml&&(b.baseUri===m.baseUri||!!b.baseUri&&!!m.baseUri&&(0,C.isEqual)(_.URI.from(b.baseUri),_.URI.from(m.baseUri)))}e.markdownStringEqual=D;function S(b){return b.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=S;function T(b){return b.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=T;function E(b){return b&&b.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=E;function p(b){const m=[],v=b.split("|").map(c=>c.trim());b=v[0];const h=v[1];if(h){const c=/height=(\d+)/.exec(h),g=/width=(\d+)/.exec(h),n=c?c[1]:"",u=g?g[1]:"",s=isFinite(parseInt(u)),i=isFinite(parseInt(n));s&&m.push(`width="${u}"`),i&&m.push(`height="${n}"`)}return{href:b,dimensions:m}}e.parseHrefAndDimensions=p}),define(De[107],Ie([1,0,17,31,9,11,22,8]),function(J,e,l,t,C,P,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function w(s,i){const{os:o,tildify:d,relative:r}=i;if(r){const y=k(s,r,o);if(typeof y=="string")return y}let a=s.fsPath;if(o===1&&!P.isWindows?a=a.replace(/\//g,"\\"):o!==1&&P.isWindows&&(a=a.replace(/\\/g,"/")),o!==1&&d?.userHome){const y=d.userHome.fsPath;let R;s.scheme!==d.userHome.scheme&&s.path.startsWith(C.posix.sep)?R=d.userHome.with({path:s.path}).fsPath:R=s.fsPath,a=S(R,y,o)}return(o===1?C.win32:C.posix).normalize(L(a,o===1))}e.getPathLabel=w;function k(s,i,o){const d=o===1?C.win32:C.posix,r=o===3?_.extUri:_.extUriIgnorePathCase,a=i.getWorkspace(),f=(0,l.firstOrDefault)(a.folders);if(!f)return;s.scheme!==f.uri.scheme&&s.path.startsWith(C.posix.sep)&&(s=f.uri.with({path:s.path}));const y=i.getWorkspaceFolder(s);if(!y)return;let R;if(r.isEqual(y.uri,s)?R="":R=r.relativePath(y.uri,s)??"",R&&(R=d.normalize(R)),a.folders.length>1&&!i.noPrefix){const N=y.name?y.name:r.basenameOrAuthority(y.uri);R=R?`${N} \u2022 ${R}`:N}return R}function L(s,i=P.isWindows){return(0,t.hasDriveLetter)(s,i)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=L;let D=Object.create(null);function S(s,i,o=P.OS){if(o===1||!s||!i)return s;let d=D.original===i?D.normalized:void 0;d||(d=i,P.isWindows&&(d=(0,t.toSlashes)(d)),d=`${(0,I.rtrim)(d,C.posix.sep)}${C.posix.sep}`,D={original:i,normalized:d});let r=s;return P.isWindows&&(r=(0,t.toSlashes)(r)),(o===3?r.startsWith(d):(0,I.startsWithIgnoreCase)(r,d))?`~/${r.substr(d.length)}`:s}e.tildify=S;function T(s,i){return s.replace(/^~($|\/|\\)/,`${i}$1`)}e.untildify=T;const E="\u2026",p="\\\\",b="~";function m(s,i=C.sep){const o=new Array(s.length);let d=!1;for(let r=0;r<s.length;r++){const a=s[r];if(a===""){o[r]=`.${i}`;continue}if(!a){o[r]=a;continue}d=!0;let f="",y=a;y.indexOf(p)===0?(f=y.substr(0,y.indexOf(p)+p.length),y=y.substr(y.indexOf(p)+p.length)):y.indexOf(i)===0?(f=y.substr(0,y.indexOf(i)+i.length),y=y.substr(y.indexOf(i)+i.length)):y.indexOf(b)===0&&(f=y.substr(0,y.indexOf(b)+b.length),y=y.substr(y.indexOf(b)+b.length));const R=y.split(i);for(let N=1;d&&N<=R.length;N++)for(let M=R.length-N;d&&M>=0;M--){d=!1;let A=R.slice(M,M+N).join(i);for(let z=0;!d&&z<s.length;z++)if(z!==r&&s[z]&&s[z].indexOf(A)>-1){const H=M+N===R.length,F=M>0&&s[z].indexOf(i)>-1?i+A:A,G=s[z].endsWith(F);d=!H||G}if(!d){let z="";(R[0].endsWith(":")||f!=="")&&(M===1&&(M=0,N++,A=R[0]+i+A),M>0&&(z=R[0]+i),z=f+z),M>0&&(z=z+E+i),z=z+A,M+N<R.length&&(z=z+i+E),o[r]=z}}d&&(o[r]=a)}return o}e.shorten=m;var v;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function h(s,i=Object.create(null)){const o=[];let d=!1,r="";for(const a of s)if(a==="$"||d&&a==="{")r&&o.push({value:r,type:v.TEXT}),r="",d=!0;else if(a==="}"&&d){const f=i[r];if(typeof f=="string")f.length&&o.push({value:f,type:v.VARIABLE});else if(f){const y=o[o.length-1];(!y||y.type!==v.SEPARATOR)&&o.push({value:f.label,type:v.SEPARATOR})}r="",d=!1}else r+=a;return r&&!d&&o.push({value:r,type:v.TEXT}),o.filter((a,f)=>{if(a.type===v.SEPARATOR){const y=o[f-1],R=o[f+1];return[y,R].every(N=>N&&(N.type===v.VARIABLE||N.type===v.TEXT)&&N.value.length>0)}return!0}).map(a=>a.value).join("")}e.template=h;function c(s,i){return P.isMacintosh||i?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.isMacintosh?"&":"&&"):s.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function g(s,i){return P.isMacintosh||i?s.replace(/\(&&\w\)|&&/g,""):P.isWindows?s.replace(/&&|&/g,o=>o==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=g;function n(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=n;function u(s){const i=s.indexOf("/")!==-1?C.posix:C.win32,o=i.basename(s),d=i.dirname(s);return o.length?{name:o,parentPath:d}:{name:d,parentPath:""}}e.splitName=u}),define(De[108],Ie([1,0,2]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(L){return L.toJSON()}class C{constructor(D){this._uriTransformer=D}transformIncoming(D){const S=this._uriTransformer.transformIncoming(D);return S===D?D:t(l.URI.from(S))}transformOutgoing(D){const S=this._uriTransformer.transformOutgoing(D);return S===D?D:t(l.URI.from(S))}transformOutgoingURI(D){const S=this._uriTransformer.transformOutgoing(D);return S===D?D:l.URI.from(S)}transformOutgoingScheme(D){return this._uriTransformer.transformOutgoingScheme(D)}}e.URITransformer=C,e.DefaultURITransformer=new class{transformIncoming(L){return L}transformOutgoing(L){return L}transformOutgoingURI(L){return L}transformOutgoingScheme(L){return L}};function P(L,D,S){if(!L||S>200)return null;if(typeof L=="object"){if(L instanceof l.URI)return D.transformOutgoing(L);for(const T in L)if(Object.hasOwnProperty.call(L,T)){const E=P(L[T],D,S+1);E!==null&&(L[T]=E)}}return null}function _(L,D){const S=P(L,D,0);return S===null?L:S}e.transformOutgoingURIs=_;function I(L,D,S,T){if(!L||T>200)return null;if(typeof L=="object"){if(L.$mid===1)return S?l.URI.revive(D.transformIncoming(L)):D.transformIncoming(L);for(const E in L)if(Object.hasOwnProperty.call(L,E)){const p=I(L[E],D,S,T+1);p!==null&&(L[E]=p)}}return null}function w(L,D){const S=I(L,D,!1,0);return S===null?L:S}e.transformIncomingURIs=w;function k(L,D){const S=I(L,D,!0,0);return S===null?L:S}e.transformAndReviveIncomingURIs=k}),define(De[29],Ie([1,0,62,81,302,18,31,79,9,11,22,2]),function(J,e,l,t,C,P,_,I,w,k,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(S=e.RimRafMode||(e.RimRafMode={}));async function T(F,G=S.UNLINK){if((0,_.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");return G===S.UNLINK?p(F):E(F)}async function E(F){try{const G=(0,_.randomPath)((0,t.tmpdir)());try{await l.promises.rename(F,G)}catch(B){return B.code==="ENOENT"?void 0:p(F)}p(G).catch(B=>{})}catch(G){if(G.code!=="ENOENT")throw G}}async function p(F){return(0,C.promisify)(l.rm)(F,{recursive:!0,force:!0,maxRetries:3})}function b(F){if((0,_.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");l.rmSync(F,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=b;async function m(F,G){return c(await(G?v(F):(0,C.promisify)(l.readdir)(F)))}async function v(F){try{return await(0,C.promisify)(l.readdir)(F,{withFileTypes:!0})}catch(U){console.warn("[node.js fs] readdir with filetypes failed with error: ",U)}const G=[],B=await m(F);for(const U of B){let x=!1,$=!1,Q=!1;try{const K=await e.Promises.lstat((0,w.join)(F,U));x=K.isFile(),$=K.isDirectory(),Q=K.isSymbolicLink()}catch(K){console.warn("[node.js fs] unexpected error from lstat after readdir: ",K)}G.push({name:U,isFile:()=>x,isDirectory:()=>$,isSymbolicLink:()=>Q})}return G}function h(F){return c(l.readdirSync(F))}e.readdirSync=h;function c(F){return F.map(G=>typeof G=="string"?k.isMacintosh?(0,I.normalizeNFC)(G):G:(G.name=k.isMacintosh?(0,I.normalizeNFC)(G.name):G.name,G))}async function g(F){const G=await m(F),B=[];for(const U of G)await u.existsDirectory((0,w.join)(F,U))&&B.push(U);return B}function n(F,G=1e3){return new Promise(B=>{let U=!1;const x=setInterval(()=>{U||(U=!0,l.access(F,$=>{U=!1,$&&(clearInterval(x),B(void 0))}))},G)})}e.whenDeleted=n;var u;(function(F){async function G(x){let $;try{if($=await e.Promises.lstat(x),!$.isSymbolicLink())return{stat:$}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:$?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Q){if(Q.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};if(k.isWindows&&Q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(K){if(K.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};throw K}throw Q}}F.stat=G;async function B(x){try{const{stat:$,symbolicLink:Q}=await F.stat(x);return $.isFile()&&Q?.dangling!==!0}catch{}return!1}F.existsFile=B;async function U(x){try{const{stat:$,symbolicLink:Q}=await F.stat(x);return $.isDirectory()&&Q?.dangling!==!0}catch{}return!1}F.existsDirectory=U})(u=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new P.ResourceQueue;function i(F,G,B){return s.queueFor(D.URI.file(F),L.extUriBiasedIgnorePathCase).queue(()=>{const U=f(B);return new Promise((x,$)=>r(F,G,U,Q=>Q?$(Q):x()))})}let o=!0;function d(F){o=F}e.configureFlushOnWrite=d;function r(F,G,B,U){if(!o)return l.writeFile(F,G,{mode:B.mode,flag:B.flag},U);l.open(F,B.flag,B.mode,(x,$)=>{if(x)return U(x);l.writeFile($,G,Q=>{if(Q)return l.close($,()=>U(Q));l.fdatasync($,K=>(K&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",K),d(!1)),l.close($,de=>U(de))))})})}function a(F,G,B){const U=f(B);if(!o)return l.writeFileSync(F,G,{mode:U.mode,flag:U.flag});const x=l.openSync(F,U.flag,U.mode);try{l.writeFileSync(x,G);try{l.fdatasyncSync(x)}catch($){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",$),d(!1)}}finally{l.closeSync(x)}}e.writeFileSync=a;function f(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function y(F,G){if(F!==G)try{await e.Promises.rename(F,G)}catch(B){if(F.toLowerCase()!==G.toLowerCase()&&B.code==="EXDEV"||F.endsWith("."))await R(F,G,{preserveSymlinks:!1}),await T(F,S.MOVE);else throw B}}async function R(F,G,B){return M(F,G,{root:{source:F,target:G},options:B,handledSourcePaths:new Set})}const N=511;async function M(F,G,B){if(B.handledSourcePaths.has(F))return;B.handledSourcePaths.add(F);const{stat:U,symbolicLink:x}=await u.stat(F);if(x){if(B.options.preserveSymlinks)try{return await H(F,G,B)}catch($){console.warn("[node.js fs] copy of symlink failed: ",$)}if(x.dangling)return}return U.isDirectory()?A(F,G,U.mode&N,B):z(F,G,U.mode&N)}async function A(F,G,B,U){await e.Promises.mkdir(G,{recursive:!0,mode:B});const x=await m(F);for(const $ of x)await M((0,w.join)(F,$),(0,w.join)(G,$),U)}async function z(F,G,B){await e.Promises.copyFile(F,G),await e.Promises.chmod(G,B)}async function H(F,G,B){let U=await e.Promises.readlink(F);(0,_.isEqualOrParent)(U,B.root.source,!k.isLinux)&&(U=(0,w.join)(B.root.target,U.substr(B.root.source.length+1))),await e.Promises.symlink(U,G)}e.Promises=new class{get access(){return(0,C.promisify)(l.access)}get stat(){return(0,C.promisify)(l.stat)}get lstat(){return(0,C.promisify)(l.lstat)}get utimes(){return(0,C.promisify)(l.utimes)}get read(){return(F,G,B,U,x)=>new Promise(($,Q)=>{l.read(F,G,B,U,x,(K,de,te)=>K?Q(K):$({bytesRead:de,buffer:te}))})}get readFile(){return(0,C.promisify)(l.readFile)}get write(){return(F,G,B,U,x)=>new Promise(($,Q)=>{l.write(F,G,B,U,x,(K,de,te)=>K?Q(K):$({bytesWritten:de,buffer:te}))})}get appendFile(){return(0,C.promisify)(l.appendFile)}get fdatasync(){return(0,C.promisify)(l.fdatasync)}get truncate(){return(0,C.promisify)(l.truncate)}get rename(){return(0,C.promisify)(l.rename)}get copyFile(){return(0,C.promisify)(l.copyFile)}get open(){return(0,C.promisify)(l.open)}get close(){return(0,C.promisify)(l.close)}get symlink(){return(0,C.promisify)(l.symlink)}get readlink(){return(0,C.promisify)(l.readlink)}get chmod(){return(0,C.promisify)(l.chmod)}get mkdir(){return(0,C.promisify)(l.mkdir)}get unlink(){return(0,C.promisify)(l.unlink)}get rmdir(){return(0,C.promisify)(l.rmdir)}get realpath(){return(0,C.promisify)(l.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return m}get readDirsInDir(){return g}get writeFile(){return i}get rm(){return T}get move(){return y}get copy(){return R}}}),define(De[109],Ie([1,0,62,9,11,8,29]),function(J,e,l,t,C,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function I(S){if(C.isLinux)return S;const T=(0,t.dirname)(S);if(S===T)return S;const E=((0,t.basename)(S)||S).toLowerCase();try{const b=(0,_.readdirSync)(T).filter(m=>m.toLowerCase()===E);if(b.length===1){const m=I(T);if(m)return(0,t.join)(m,b[0])}else if(b.length>1){const m=b.indexOf(E);if(m>=0){const v=I(T);if(v)return(0,t.join)(v,b[m])}}}catch{}return null}e.realcaseSync=I;async function w(S){if(C.isLinux)return S;const T=(0,t.dirname)(S);if(S===T)return S;const E=((0,t.basename)(S)||S).toLowerCase();try{const b=(await _.Promises.readdir(T)).filter(m=>m.toLowerCase()===E);if(b.length===1){const m=await w(T);if(m)return(0,t.join)(m,b[0])}else if(b.length>1){const m=b.indexOf(E);if(m>=0){const v=await w(T);if(v)return(0,t.join)(v,b[m])}}}catch{}return null}e.realcase=w;async function k(S){try{return await _.Promises.realpath(S)}catch{const E=D(S);return await _.Promises.access(E,l.constants.R_OK),E}}e.realpath=k;function L(S){try{return l.realpathSync(S)}catch{const E=D(S);return l.accessSync(E,l.constants.R_OK),E}}e.realpathSync=L;function D(S){return(0,P.rtrim)((0,t.normalize)(S),t.sep)}}),define(De[110],Ie([1,0,9,11,41,102,16,29]),function(J,e,l,t,C,P,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function w(D=C.env){return D.comspec||"cmd.exe"}e.getWindowsShell=w;function k(D){let S=[],T=!1;const E=function(p){if(T){S.push(p);return}(!D.send(p,m=>{if(m&&console.error(m),T=!1,S.length>0){const v=S.slice(0);S=[],v.forEach(h=>E(h))}})||t.isWindows)&&(T=!0)};return{send:E}}e.createQueuedSender=k;var L;(function(D){async function S(T,E,p){if(l.isAbsolute(T))return T;if(E===void 0&&(E=C.cwd()),l.dirname(T)!=="."||(p===void 0&&_.isString(C.env.PATH)&&(p=C.env.PATH.split(l.delimiter)),p===void 0||p.length===0))return l.join(E,T);async function m(v){if(await I.Promises.exists(v)){let h;try{h=await I.Promises.stat(v)}catch(c){c.message.startsWith("EACCES")&&(h=await I.Promises.lstat(v))}return h?!h.isDirectory():!1}return!1}for(const v of p){let h;if(l.isAbsolute(v)?h=l.join(v,T):h=l.join(E,v,T),await m(h))return h;let c=h+".com";if(await m(c)||(c=h+".exe",await m(c)))return c}return l.join(E,T)}D.findExecutable=S})(L=e.win32||(e.win32={}))});var je=this&&this.__decorate||function(J,e,l,t){var C=arguments.length,P=C<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,l):t,_;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(J,e,l,t);else for(var I=J.length-1;I>=0;I--)(_=J[I])&&(P=(C<3?_(P):C>3?_(e,l,P):_(e,l))||P);return C>3&&P&&Object.defineProperty(e,l,P),P};define(De[111],Ie([1,0,17,18,23,21,59,10,4,6,80,8,16]),function(J,e,l,t,C,P,_,I,w,k,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var T;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(T=e.RequestType||(e.RequestType={}));function E(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(p=e.ResponseType||(e.ResponseType={}));function b(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(m||(m={}));class v{constructor($){this.buffer=$,this.pos=0}read($){const Q=this.buffer.slice(this.pos,this.pos+$);return this.pos+=Q.byteLength,Q}}class h{constructor(){this.buffers=[]}get buffer(){return C.VSBuffer.concat(this.buffers)}write($){this.buffers.push($)}}var c;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object"})(c||(c={}));function g(x){const $=C.VSBuffer.alloc(4);return $.writeUInt32BE(x,0),$}function n(x){return x.read(4).readUInt32BE(0)}function u(x){const $=C.VSBuffer.alloc(1);return $.writeUInt8(x,0),$}const s={Undefined:u(c.Undefined),String:u(c.String),Buffer:u(c.Buffer),VSBuffer:u(c.VSBuffer),Array:u(c.Array),Object:u(c.Object)},i=typeof Buffer<"u";function o(x,$){if(typeof $>"u")x.write(s.Undefined);else if(typeof $=="string"){const Q=C.VSBuffer.fromString($);x.write(s.String),x.write(g(Q.byteLength)),x.write(Q)}else if(i&&Buffer.isBuffer($)){const Q=C.VSBuffer.wrap($);x.write(s.Buffer),x.write(g(Q.byteLength)),x.write(Q)}else if($ instanceof C.VSBuffer)x.write(s.VSBuffer),x.write(g($.byteLength)),x.write($);else if(Array.isArray($)){x.write(s.Array),x.write(g($.length));for(const Q of $)o(x,Q)}else{const Q=C.VSBuffer.fromString(JSON.stringify($));x.write(s.Object),x.write(g(Q.byteLength)),x.write(Q)}}function d(x){switch(x.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return x.read(n(x)).toString();case c.Buffer:return x.read(n(x)).buffer;case c.VSBuffer:return x.read(n(x));case c.Array:{const Q=n(x),K=[];for(let de=0;de<Q;de++)K.push(d(x));return K}case c.Object:return JSON.parse(x.read(n(x)).toString())}}class r{constructor($,Q,K=null,de=1e3){this.protocol=$,this.ctx=Q,this.logger=K,this.timeoutDelay=de,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(te=>this.onRawMessage(te)),this.sendResponse({type:200})}registerChannel($,Q){this.channels.set($,Q),setTimeout(()=>this.flushPendingRequests($),0)}sendResponse($){switch($.type){case 200:{const Q=this.send([$.type]);this.logger?.logOutgoing(Q,0,1,b($.type));return}case 201:case 202:case 204:case 203:{const Q=this.send([$.type,$.id],$.data);this.logger?.logOutgoing(Q,$.id,1,b($.type),$.data);return}}}send($,Q=void 0){const K=new h;return o(K,$),o(K,Q),this.sendBuffer(K.buffer)}sendBuffer($){try{return this.protocol.send($),$.byteLength}catch{return 0}}onRawMessage($){const Q=new v($),K=d(Q),de=d(Q),te=K[0];switch(te){case 100:return this.logger?.logIncoming($.byteLength,K[1],1,`${E(te)}: ${K[2]}.${K[3]}`,de),this.onPromise({type:te,id:K[1],channelName:K[2],name:K[3],arg:de});case 102:return this.logger?.logIncoming($.byteLength,K[1],1,`${E(te)}: ${K[2]}.${K[3]}`,de),this.onEventListen({type:te,id:K[1],channelName:K[2],name:K[3],arg:de});case 101:return this.logger?.logIncoming($.byteLength,K[1],1,`${E(te)}`),this.disposeActiveRequest({type:te,id:K[1]});case 103:return this.logger?.logIncoming($.byteLength,K[1],1,`${E(te)}`),this.disposeActiveRequest({type:te,id:K[1]})}}onPromise($){const Q=this.channels.get($.channelName);if(!Q){this.collectPendingRequest($);return}const K=new P.CancellationTokenSource;let de;try{de=Q.call(this.ctx,$.name,$.arg,K.token)}catch(Y){de=Promise.reject(Y)}const te=$.id;de.then(Y=>{this.sendResponse({id:te,data:Y,type:201}),this.activeRequests.delete($.id)},Y=>{Y instanceof Error?this.sendResponse({id:te,data:{message:Y.message,name:Y.name,stack:Y.stack?Y.stack.split?Y.stack.split(`
`):Y.stack:void 0},type:202}):this.sendResponse({id:te,data:Y,type:203}),this.activeRequests.delete($.id)});const he=(0,k.toDisposable)(()=>K.cancel());this.activeRequests.set($.id,he)}onEventListen($){const Q=this.channels.get($.channelName);if(!Q){this.collectPendingRequest($);return}const K=$.id,te=Q.listen(this.ctx,$.name,$.arg)(he=>this.sendResponse({id:K,data:he,type:204}));this.activeRequests.set($.id,te)}disposeActiveRequest($){const Q=this.activeRequests.get($.id);Q&&(Q.dispose(),this.activeRequests.delete($.id))}collectPendingRequest($){let Q=this.pendingRequests.get($.channelName);Q||(Q=[],this.pendingRequests.set($.channelName,Q));const K=setTimeout(()=>{console.error(`Unknown channel: ${$.channelName}`),$.type===100&&this.sendResponse({id:$.id,data:{name:"Unknown channel",message:`Channel name '${$.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Q.push({request:$,timeoutTimer:K})}flushPendingRequests($){const Q=this.pendingRequests.get($);if(Q){for(const K of Q)switch(clearTimeout(K.timeoutTimer),K.request.type){case 100:this.onPromise(K.request);break;case 102:this.onEventListen(K.request);break}this.pendingRequests.delete($)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,k.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=r;var a;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(a=e.RequestInitiator||(e.RequestInitiator={}));class f{constructor($,Q=null){this.protocol=$,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new w.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(K=>this.onBuffer(K)),this.logger=Q}getChannel($){const Q=this;return{call(K,de,te){return Q.isDisposed?Promise.reject(new I.CancellationError):Q.requestPromise($,K,de,te)},listen(K,de){return Q.isDisposed?w.Event.None:Q.requestEvent($,K,de)}}}requestPromise($,Q,K,de=P.CancellationToken.None){const te=this.lastRequestId++,Y={id:te,type:100,channelName:$,name:Q,arg:K};if(de.isCancellationRequested)return Promise.reject(new I.CancellationError);let ve;return new Promise((ke,Re)=>{if(de.isCancellationRequested)return Re(new I.CancellationError);const ze=()=>{const Z=ae=>{switch(ae.type){case 201:this.handlers.delete(te),ke(ae.data);break;case 202:{this.handlers.delete(te);const ne=new Error(ae.data.message);ne.stack=ae.data.stack,ne.name=ae.data.name,Re(ne);break}case 203:this.handlers.delete(te),Re(ae.data);break}};this.handlers.set(te,Z),this.sendRequest(Y)};let oe=null;this.state===m.Idle?ze():(oe=(0,t.createCancelablePromise)(Z=>this.whenInitialized()),oe.then(()=>{oe=null,ze()}));const le=()=>{oe?(oe.cancel(),oe=null):this.sendRequest({id:te,type:101}),Re(new I.CancellationError)},me=de.onCancellationRequested(le);ve=(0,k.combinedDisposable)((0,k.toDisposable)(le),me),this.activeRequests.add(ve)}).finally(()=>{this.activeRequests.delete(ve)})}requestEvent($,Q,K){const de=this.lastRequestId++,he={id:de,type:102,channelName:$,name:Q,arg:K};let Y=null;const ve=new w.Emitter({onFirstListenerAdd:()=>{Y=(0,t.createCancelablePromise)(ke=>this.whenInitialized()),Y.then(()=>{Y=null,this.activeRequests.add(ve),this.sendRequest(he)})},onLastListenerRemove:()=>{Y?(Y.cancel(),Y=null):(this.activeRequests.delete(ve),this.sendRequest({id:de,type:103}))}}),be=ke=>ve.fire(ke.data);return this.handlers.set(de,be),ve.event}sendRequest($){switch($.type){case 100:case 102:{const Q=this.send([$.type,$.id,$.channelName,$.name],$.arg);this.logger?.logOutgoing(Q,$.id,0,`${E($.type)}: ${$.channelName}.${$.name}`,$.arg);return}case 101:case 103:{const Q=this.send([$.type,$.id]);this.logger?.logOutgoing(Q,$.id,0,E($.type));return}}}send($,Q=void 0){const K=new h;return o(K,$),o(K,Q),this.sendBuffer(K.buffer)}sendBuffer($){try{return this.protocol.send($),$.byteLength}catch{return 0}}onBuffer($){const Q=new v($),K=d(Q),de=d(Q),te=K[0];switch(te){case 200:return this.logger?.logIncoming($.byteLength,0,0,b(te)),this.onResponse({type:K[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming($.byteLength,K[1],0,b(te),de),this.onResponse({type:K[0],id:K[1],data:de})}}onResponse($){if($.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}this.handlers.get($.id)?.($)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,k.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}je([_.memoize],f.prototype,"onDidInitializePromise",null),e.ChannelClient=f;class y{get connections(){const $=[];return this._connections.forEach(Q=>$.push(Q)),$}constructor($){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new w.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new w.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,$(({protocol:Q,onDidClientDisconnect:K})=>{w.Event.once(Q.onMessage)(te=>{const he=new v(te),Y=d(he),ve=new r(Q,Y),be=new f(Q);this.channels.forEach((Re,ze)=>ve.registerChannel(ze,Re));const ke={channelServer:ve,channelClient:be,ctx:Y};this._connections.add(ke),this._onDidAddConnection.fire(ke),K(()=>{ve.dispose(),be.dispose(),this._connections.delete(ke),this._onDidRemoveConnection.fire(ke)})})})}getChannel($,Q){const K=this;return{call(de,te,he){let Y;if((0,S.isFunction)(Q)){const be=(0,l.getRandomElement)(K.connections.filter(Q));Y=be?Promise.resolve(be):w.Event.toPromise(w.Event.filter(K.onDidAddConnection,Q))}else Y=Q.routeCall(K,de,te);const ve=Y.then(be=>be.channelClient.getChannel($));return N(ve).call(de,te,he)},listen(de,te){if((0,S.isFunction)(Q))return K.getMulticastEvent($,Q,de,te);const he=Q.routeEvent(K,de,te).then(Y=>Y.channelClient.getChannel($));return N(he).listen(de,te)}}}getMulticastEvent($,Q,K,de){const te=this;let he=new k.DisposableStore;const Y=new w.Emitter({onFirstListenerAdd:()=>{he=new k.DisposableStore;const ve=new w.EventMultiplexer,be=new Map,ke=ze=>{const le=ze.channelClient.getChannel($).listen(K,de),me=ve.add(le);be.set(ze,me)},Re=ze=>{const oe=be.get(ze);!oe||(oe.dispose(),be.delete(ze))};te.connections.filter(Q).forEach(ke),w.Event.filter(te.onDidAddConnection,Q)(ke,void 0,he),te.onDidRemoveConnection(Re,void 0,he),ve.event(Y.fire,Y,he),he.add(ve)},onLastListenerRemove:()=>{he.dispose()}});return Y.event}registerChannel($,Q){this.channels.set($,Q),this._connections.forEach(K=>{K.channelServer.registerChannel($,Q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=y;class R{constructor($,Q,K=null){const de=new h;o(de,Q),$.send(de.buffer),this.channelClient=new f($,K),this.channelServer=new r($,Q,K)}getChannel($){return this.channelClient.getChannel($)}registerChannel($,Q){this.channelServer.registerChannel($,Q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=R;function N(x){return{call($,Q,K){return x.then(de=>de.call($,Q,K))},listen($,Q){const K=new w.Relay;return x.then(de=>K.input=de.listen($,Q)),K.event}}}e.getDelayedChannel=N;function M(x){let $=!1;return{call(Q,K,de){return $?x.call(Q,K,de):(0,t.timeout)(0).then(()=>$=!0).then(()=>x.call(Q,K,de))},listen(Q,K){if($)return x.listen(Q,K);const de=new w.Relay;return(0,t.timeout)(0).then(()=>$=!0).then(()=>de.input=x.listen(Q,K)),de.event}}}e.getNextTickChannel=M;class A{constructor($){this.fn=$}routeCall($){return this.route($)}routeEvent($){return this.route($)}async route($){for(const Q of $.connections)if(await Promise.resolve(this.fn(Q.ctx)))return Promise.resolve(Q);return await w.Event.toPromise($.onDidAddConnection),await this.route($)}}e.StaticRouter=A;var z;(function(x){function $(te,he){const Y=te,ve=he&&he.disableMarshalling,be=new Map;for(const ke in Y)K(ke)&&be.set(ke,w.Event.buffer(Y[ke],!0));return new class{listen(ke,Re,ze){const oe=be.get(Re);if(oe)return oe;if(de(Re)){const le=Y[Re];if(typeof le=="function")return le.call(Y,ze)}throw new Error(`Event not found: ${Re}`)}call(ke,Re,ze){const oe=Y[Re];if(typeof oe=="function"){if(!ve&&Array.isArray(ze))for(let le=0;le<ze.length;le++)ze[le]=(0,L.revive)(ze[le]);return oe.apply(Y,ze)}throw new Error(`Method not found: ${Re}`)}}}x.fromService=$;function Q(te,he){const Y=he&&he.disableMarshalling;return new Proxy({},{get(ve,be){if(typeof be=="string")return he?.properties?.has(be)?he.properties.get(be):de(be)?function(ke){return te.listen(be,ke)}:K(be)?te.listen(be):async function(...ke){let Re;he&&!(0,S.isUndefinedOrNull)(he.context)?Re=[he.context,...ke]:Re=ke;const ze=await te.call(be,Re);return Y?ze:(0,L.revive)(ze)};throw new Error(`Property not found: ${String(be)}`)}})}x.toService=Q;function K(te){return te[0]==="o"&&te[1]==="n"&&D.isUpperAsciiLetter(te.charCodeAt(2))}function de(te){return/^onDynamic/.test(te)&&D.isUpperAsciiLetter(te.charCodeAt(9))}})(z=e.ProxyChannel||(e.ProxyChannel={}));const H=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function F(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){const $=x.toString();if($!=="[object Object]")return $}return x}function G(x){return Array.isArray(x)?x.map(F):F(x)}function B(x,$,Q,K,de,te,he){he=G(he);const Y=H[de],ve=Y[K%Y.length];let be=[`%c[${x}]%c[${String($).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(K).padStart(5," ")} - ${te}`,"color: darkgreen","color: grey","color: grey",`color: ${ve}`];/\($/.test(te)?(be=be.concat(he),be.push(")")):be.push(he),console.log.apply(console,be)}e.logWithColors=B;class U{constructor($,Q){this._outgoingPrefix=$,this._incomingPrefix=Q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing($,Q,K,de,te){this._totalOutgoing+=$,B(this._outgoingPrefix,this._totalOutgoing,$,Q,K,de,te)}logIncoming($,Q,K,de,te){this._totalIncoming+=$,B(this._incomingPrefix,this._totalIncoming,$,Q,K,de,te)}}e.IPCLogger=U}),define(De[112],Ie([1,0,23,4,6,111]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var _;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(_=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var I;(function(i){i.enableDiagnostics=!1,i.records=[];const o=new WeakMap;let d=0;function r(f,y){if(!o.has(f)){const R=String(++d);o.set(f,R)}return o.get(f)}function a(f,y,R,N){if(!i.enableDiagnostics)return;const M=r(f,y);if(N instanceof l.VSBuffer||N instanceof Uint8Array||N instanceof ArrayBuffer||ArrayBuffer.isView(N)){const A=l.VSBuffer.alloc(N.byteLength);A.set(N),i.records.push({timestamp:Date.now(),id:M,label:y,type:R,buff:A})}else i.records.push({timestamp:Date.now(),id:M,label:y,type:R,data:N})}i.traceSocketEvent=a})(I=e.SocketDiagnostics||(e.SocketDiagnostics={}));var w;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(w=e.SocketCloseEventType||(e.SocketCloseEventType={}));let k=null;function L(){return k||(k=l.VSBuffer.alloc(0)),k}class D{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,d){if(o===0)return L();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const y=this._chunks[0];return d&&(this._chunks.shift(),this._totalLength-=o),y}if(this._chunks[0].byteLength>o){const y=this._chunks[0].slice(0,o);return d&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),y}const r=l.VSBuffer.alloc(o);let a=0,f=0;for(;o>0;){const y=this._chunks[f];if(y.byteLength>o){const R=y.slice(0,o);r.set(R,a),a+=o,d&&(this._chunks[f]=y.slice(o),this._totalLength-=o),o-=o}else r.set(y,a),a+=y.byteLength,d?(this._chunks.shift(),this._totalLength-=y.byteLength):f++,o-=y.byteLength}return r}}e.ChunkStream=D;var S;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(S||(S={}));function T(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var E;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(E=e.ProtocolConstants||(e.ProtocolConstants={}));class p{constructor(o,d,r,a){this.type=o,this.id=d,this.ack=r,this.data=a,this.writtenTime=0}get size(){return this.data.byteLength}}class b extends C.Disposable{constructor(o){super(),this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new D,this._register(this._socket.onData(d=>this.acceptChunk(d))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const d=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=d.readUInt32BE(9),this._state.messageType=d.readUInt8(0),this._state.id=d.readUInt32BE(1),this._state.ack=d.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:T(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const r=this._state.messageType,a=this._state.id,f=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",d),this._onMessage.fire(new p(r,a,f,d)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class m{constructor(o){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const d=l.VSBuffer.alloc(13);d.writeUInt8(o.type,0),d.writeUInt32BE(o.id,1),d.writeUInt32BE(o.ack,5),d.writeUInt32BE(o.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:T(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",o.data),this._writeSoon(d,o.data)}_bufferAdd(o,d){const r=this._totalLength===0;return this._data.push(o,d),this._totalLength+=o.byteLength+d.byteLength,r}_bufferTake(){const o=l.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,d){this._bufferAdd(o,d)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const o=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this._socket.write(o)}}class v extends C.Disposable{constructor(o){super(),this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new m(this._socket)),this._socketReader=this._register(new b(this._socket)),this._register(this._socketReader.onMessage(d=>{d.type===1&&this._onMessage.fire(d.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new p(1,0,0,o))}}e.Protocol=v;class h extends P.IPCClient{static fromSocket(o,d){return new h(new v(o),d)}get onDidDispose(){return this.protocol.onDidDispose}constructor(o,d,r=null){super(o,d,r),this.protocol=o}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=h;class c{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=c;class g{constructor(o){this.data=o,this.next=null}}class n{constructor(){this._first=null,this._last=null}length(){let o=0,d=this._first;for(;d;)d=d.next,o++;return o}peek(){return this._first?this._first.data:null}toArray(){const o=[];let d=0,r=this._first;for(;r;)o[d++]=r.data,r=r.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const d=new g(o);if(!this._first){this._first=d,this._last=d;return}this._last.next=d,this._last=d}}class u{static getInstance(){return u._INSTANCE||(u._INSTANCE=new u),u._INSTANCE}constructor(){this.lastRuns=[];const o=Date.now();for(let d=0;d<u._HISTORY_LENGTH;d++)this.lastRuns[d]=o-1e3*d;setInterval(()=>{for(let d=u._HISTORY_LENGTH;d>=1;d--)this.lastRuns[d]=this.lastRuns[d-1];this.lastRuns[0]=Date.now()},1e3)}load(){const o=Date.now(),d=(1+u._HISTORY_LENGTH)*1e3;let r=0;for(let a=0;a<u._HISTORY_LENGTH;a++)o-this.lastRuns[a]<=d&&r++;return 1-r/u._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}u._HISTORY_LENGTH=10,u._INSTANCE=null;class s{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(o,d=null,r=u.getInstance()){this._onControlMessage=new c,this.onControlMessage=this._onControlMessage.event,this._onMessage=new c,this.onMessage=this._onMessage.event,this._onDidDispose=new c,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new c,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new c,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=r,this._isReconnecting=!1,this._outgoingUnackMsg=new n,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=o,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new b(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),d&&this._socketReader.acceptChunk(d),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,C.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new p(5,0,0,L());this._socketWriter.write(o),this._socketWriter.flush()}sendPause(){const o=new p(7,0,0,L());this._socketWriter.write(o)}sendResume(){const o=new p(8,0,0,L());this._socketWriter.write(o)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,d){this._isReconnecting=!0,this._socketDisposables=(0,C.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=o,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new b(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(r=>this._receiveMessage(r))),this._socketDisposables.push(this._socket.onClose(r=>this._onSocketClose.fire(r))),this._socketReader.acceptChunk(d)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const o=new p(3,0,this._incomingAckId,L());this._socketWriter.write(o);const d=this._outgoingUnackMsg.toArray();for(let r=0,a=d.length;r<a;r++)this._socketWriter.write(d[r]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const d=this._outgoingUnackMsg.peek();if(d&&d.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const d=Date.now();d-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=d,this._socketWriter.write(new p(6,0,0,L())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data);break}case 2:{this._onControlMessage.fire(o.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const d=this._outgoingUnackMsg.toArray();for(let r=0,a=d.length;r<a;r++)this._socketWriter.write(d[r]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const d=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const r=new p(1,d,this._incomingAckId,o);this._outgoingUnackMsg.push(r),this._isReconnecting||(this._socketWriter.write(r),this._recvAckCheck())}sendControl(o){const d=new p(2,0,0,o);this._socketWriter.write(d)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const o=this._outgoingUnackMsg.peek(),d=Date.now()-o.writtenTime,r=Date.now()-this._socketReader.lastReadTime,a=Date.now()-this._lastSocketTimeoutTime;if(d>=2e4&&r>=2e4&&a>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:d,timeSinceLastReceivedSomeData:r});return}const f=Math.max(2e4-d,2e4-r,2e4-a,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},f)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new p(3,0,this._incomingAckId,L());this._socketWriter.write(o)}_sendKeepAlive(){const o=new p(9,0,0,L());this._socketWriter.write(o)}}e.PersistentProtocol=s}),define(De[113],Ie([1,0,23,10,4,6,9,11,34,111,112]),function(J,e,l,t,C,P,_,I,w,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function D(){return{crypto:J.__$__nodeRequire("crypto"),zlib:J.__$__nodeRequire("zlib"),net:J.__$__nodeRequire("net"),os:J.__$__nodeRequire("os")}}class S{traceSocketEvent(r,a){L.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,r,a)}constructor(r,a=""){this._canWrite=!0,this.debugLabel=a,this.socket=r,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=f=>{if(this.traceSocketEvent("error",{code:f?.code,message:f?.message}),f){if(f.code==="EPIPE")return;(0,t.onUnexpectedError)(f)}},this.socket.on("error",this._errorListener),this._closeListener=f=>{this.traceSocketEvent("close",{hadError:f}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(r){const a=f=>{this.traceSocketEvent("read",f),r(l.VSBuffer.wrap(f))};return this.socket.on("data",a),{dispose:()=>this.socket.off("data",a)}}onClose(r){const a=f=>{r({type:0,hadError:f,error:void 0})};return this.socket.on("close",a),{dispose:()=>this.socket.off("close",a)}}onEnd(r){const a=()=>{r()};return this.socket.on("end",a),{dispose:()=>this.socket.off("end",a)}}write(r){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",r),this.socket.write(r.buffer,a=>{if(a){if(a.code==="EPIPE")return;(0,t.onUnexpectedError)(a)}})}catch(a){if(a.code==="EPIPE")return;(0,t.onUnexpectedError)(a)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((r,a)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),r();return}const f=()=>{this.socket.off("close",f),this.socket.off("end",f),this.socket.off("error",f),this.socket.off("timeout",f),this.socket.off("drain",f),this.traceSocketEvent("nodeDrainEnd"),r()};this.socket.on("close",f),this.socket.on("end",f),this.socket.on("error",f),this.socket.on("timeout",f),this.socket.on("drain",f)})}}e.NodeSocket=S;var T;(function(d){d[d.MinHeaderByteSize=2]="MinHeaderByteSize"})(T||(T={}));var E;(function(d){d[d.PeekHeader=1]="PeekHeader",d[d.ReadHeader=2]="ReadHeader",d[d.ReadBody=3]="ReadBody",d[d.Fin=4]="Fin"})(E||(E={}));class p extends P.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(r,a){this.socket.traceSocketEvent(r,a)}constructor(r,a,f,y){super(),this._onData=this._register(new C.Emitter),this._onClose=this._register(new C.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=r,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:a,inflateBytesLength:f?.byteLength||0,recordInflateBytes:y}),this._flowManager=this._register(new b(this,a,f,y,this._onData,(R,N)=>this._write(R,N))),this._register(this._flowManager.onError(R=>{console.error(R),(0,t.onUnexpectedError)(R),this._onClose.fire({type:0,hadError:!0,error:R})})),this._incomingData=new L.ChunkStream,this._register(this.socket.onData(R=>this._acceptChunk(R))),this._register(this.socket.onClose(R=>this._onClose.fire(R)))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(r){return this._onData.event(r)}onClose(r){return this._onClose.event(r)}onEnd(r){return this.socket.onEnd(r)}write(r){this._flowManager.writeMessage(r)}_write(r,a){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",r);let f=2;r.byteLength<126?f+=0:r.byteLength<2**16?f+=2:f+=8;const y=l.VSBuffer.alloc(f);if(a?y.writeUInt8(194,0):y.writeUInt8(130,0),r.byteLength<126)y.writeUInt8(r.byteLength,1);else if(r.byteLength<2**16){y.writeUInt8(126,1);let R=1;y.writeUInt8(r.byteLength>>>8&255,++R),y.writeUInt8(r.byteLength>>>0&255,++R)}else{y.writeUInt8(127,1);let R=1;y.writeUInt8(0,++R),y.writeUInt8(0,++R),y.writeUInt8(0,++R),y.writeUInt8(0,++R),y.writeUInt8(r.byteLength>>>24&255,++R),y.writeUInt8(r.byteLength>>>16&255,++R),y.writeUInt8(r.byteLength>>>8&255,++R),y.writeUInt8(r.byteLength>>>0&255,++R)}this.socket.write(l.VSBuffer.concat([y,r]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(r){if(r.byteLength!==0){for(this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const a=this._incomingData.peek(this._state.readLen),f=a.readUInt8(0),y=(f&128)>>>7,R=(f&64)>>>6,N=a.readUInt8(1),M=(N&128)>>>7,A=N&127;this._state.state=2,this._state.readLen=2+(M?4:0)+(A===126?2:0)+(A===127?8:0),this._state.fin=y,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(R)),this._state.firstFrameOfMessage=Boolean(y),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const a=this._incomingData.read(this._state.readLen),f=a.readUInt8(1),y=(f&128)>>>7;let R=f&127,N=1;R===126?R=a.readUInt8(++N)*2**8+a.readUInt8(++N):R===127&&(R=a.readUInt8(++N)*0+a.readUInt8(++N)*0+a.readUInt8(++N)*0+a.readUInt8(++N)*0+a.readUInt8(++N)*2**24+a.readUInt8(++N)*2**16+a.readUInt8(++N)*2**8+a.readUInt8(++N));let M=0;y&&(M=a.readUInt8(++N)*2**24+a.readUInt8(++N)*2**16+a.readUInt8(++N)*2**8+a.readUInt8(++N)),this._state.state=3,this._state.readLen=R,this._state.mask=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const a=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",a),h(a,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",a),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(a,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await C.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=p;class b extends P.Disposable{get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:l.VSBuffer.alloc(0)}constructor(r,a,f,y,R,N){super(),this._tracer=r,this._onData=R,this._writeFn=N,this._onError=this._register(new C.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new C.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,a?(this._zlibInflateStream=this._register(new m(this._tracer,y,f,{windowBits:15})),this._zlibDeflateStream=this._register(new v(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(M=>this._onError.fire(M))),this._register(this._zlibDeflateStream.onError(M=>this._onError.fire(M)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(r){this._writeQueue.push(r),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const r=this._writeQueue.shift();if(this._zlibDeflateStream){const a=await this._deflateMessage(this._zlibDeflateStream,r);this._writeFn(a,!0)}else this._writeFn(r,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(r,a){return new Promise((f,y)=>{r.write(a),r.flush(R=>f(R))})}acceptFrame(r,a,f){this._readQueue.push({data:r,isCompressed:a,isLastFrameOfMessage:f}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const r=this._readQueue.shift();if(this._zlibInflateStream&&r.isCompressed){const a=await this._inflateFrame(this._zlibInflateStream,r.data,r.isLastFrameOfMessage);this._onData.fire(a)}else this._onData.fire(r.data)}this._isProcessingReadQueue=!1}}_inflateFrame(r,a,f){return new Promise((y,R)=>{r.write(a),f&&r.write(l.VSBuffer.fromByteArray([0,0,255,255])),r.flush(N=>y(N))})}}class m extends P.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?l.VSBuffer.concat(this._recordedInflateBytes):l.VSBuffer.alloc(0)}constructor(r,a,f,y){super(),this._tracer=r,this._recordInflateBytes=a,this._onError=this._register(new C.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=D().zlib.createInflateRaw(y),this._zlibInflate.on("error",R=>{this._tracer.traceSocketEvent("zlibInflateError",{message:R?.message,code:R?.code}),this._onError.fire(R)}),this._zlibInflate.on("data",R=>{this._tracer.traceSocketEvent("zlibInflateData",R),this._pendingInflateData.push(l.VSBuffer.wrap(R))}),f&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",f.buffer),this._zlibInflate.write(f.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(r){this._recordInflateBytes&&this._recordedInflateBytes.push(r.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",r),this._zlibInflate.write(r.buffer)}flush(r){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const a=l.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,r(a)})}}class v extends P.Disposable{constructor(r,a){super(),this._tracer=r,this._onError=this._register(new C.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=D().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",f=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:f?.message,code:f?.code}),this._onError.fire(f)}),this._zlibDeflate.on("data",f=>{this._tracer.traceSocketEvent("zlibDeflateData",f),this._pendingDeflateData.push(l.VSBuffer.wrap(f))})}write(r){this._tracer.traceSocketEvent("zlibDeflateWrite",r.buffer),this._zlibDeflate.write(r.buffer)}flush(r){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let a=l.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,a=a.slice(0,a.byteLength-4),r(a)})}}function h(d,r){if(r===0)return;const a=d.byteLength>>>2;for(let A=0;A<a;A++){const z=d.readUInt32BE(A*4);d.writeUInt32BE(z^r,A*4)}const f=a*4,y=d.byteLength-f,R=r>>>24&255,N=r>>>16&255,M=r>>>8&255;y>=1&&d.writeUInt8(d.readUInt8(f)^R,f),y>=2&&d.writeUInt8(d.readUInt8(f+1)^N,f+1),y>=3&&d.writeUInt8(d.readUInt8(f+2)^M,f+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const c={[2]:107,[1]:103};function g(){const d=(0,w.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${d}-sock`;let r;return e.XDG_RUNTIME_DIR?r=(0,_.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${d}.sock`):r=(0,_.join)(D().os.tmpdir(),`vscode-ipc-${d}.sock`),u(r),r}e.createRandomIPCHandle=g;function n(d,r,a){const f=D().crypto.createHash("md5").update(d).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${f}-${a}-${r}-sock`;let y;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?y=(0,_.join)(e.XDG_RUNTIME_DIR,`vscode-${f.substr(0,8)}-${a}-${r}.sock`):y=(0,_.join)(d,`${a}-${r}.sock`),u(y),y}e.createStaticIPCHandle=n;function u(d){const r=c[I.platform];typeof r=="number"&&d.length>=r&&console.warn(`WARNING: IPC handle "${d}" is longer than ${r} chars, try a shorter --user-data-dir`)}class s extends k.IPCServer{static toClientConnectionEvent(r){const a=C.Event.fromNodeEventEmitter(r,"connection");return C.Event.map(a,f=>({protocol:new L.Protocol(new S(f,"ipc-server-connection")),onDidClientDisconnect:C.Event.once(C.Event.fromNodeEventEmitter(f,"close"))}))}constructor(r){super(s.toClientConnectionEvent(r)),this.server=r}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function i(d){return new Promise((r,a)=>{const f=D().net.createServer();f.on("error",a),f.listen(d,()=>{f.removeListener("error",a),r(new s(f))})})}e.serve=i;function o(d,r){return new Promise((a,f)=>{const y=D().net.createConnection(d,()=>{y.removeListener("error",f),a(L.Client.fromSocket(new S(y,`ipc-client${r}`),r))});y.once("error",f)})}e.connect=o}),define(De[158],Ie([1,0,36,9]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function C(P,_,I,w,k,L){if(Array.isArray(P)){let D=0;for(const S of P){const T=C(S,_,I,w,k,L);if(T===10)return T;T>D&&(D=T)}return D}else{if(typeof P=="string")return w?P==="*"?5:P===I?10:0:0;if(P){const{language:D,pattern:S,scheme:T,hasAccessToAllModels:E,notebookType:p}=P;if(!w&&!E)return 0;p&&k&&(_=k);let b=0;if(T)if(T===_.scheme)b=10;else if(T==="*")b=5;else return 0;if(D)if(D===I)b=10;else if(D==="*")b=Math.max(b,5);else return 0;if(p)if(p===L)b=10;else if(p==="*"&&L!==void 0)b=Math.max(b,5);else return 0;if(S){let m;if(typeof S=="string"?m=S:m={...S,base:(0,t.normalize)(S.base)},m===_.fsPath||(0,l.match)(m,_.fsPath))b=10;else return 0}return b}else return 0}}e.score=C}),define(De[159],Ie([1,0,8,49,151]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class P{constructor(I,w,k,L){this._uri=I,this._lines=w,this._eol=k,this._versionId=L,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(I){I.eol&&I.eol!==this._eol&&(this._eol=I.eol,this._lineStarts=null);const w=I.changes;for(const k of w)this._acceptDeleteRange(k.range),this._acceptInsertText(new t.Position(k.range.startLineNumber,k.range.startColumn),k.text);this._versionId=I.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const I=this._eol.length,w=this._lines.length,k=new Uint32Array(w);for(let L=0;L<w;L++)k[L]=this._lines[L].length+I;this._lineStarts=new C.PrefixSumComputer(k)}}_setLineText(I,w){this._lines[I]=w,this._lineStarts&&this._lineStarts.setValue(I,this._lines[I].length+this._eol.length)}_acceptDeleteRange(I){if(I.startLineNumber===I.endLineNumber){if(I.startColumn===I.endColumn)return;this._setLineText(I.startLineNumber-1,this._lines[I.startLineNumber-1].substring(0,I.startColumn-1)+this._lines[I.startLineNumber-1].substring(I.endColumn-1));return}this._setLineText(I.startLineNumber-1,this._lines[I.startLineNumber-1].substring(0,I.startColumn-1)+this._lines[I.endLineNumber-1].substring(I.endColumn-1)),this._lines.splice(I.startLineNumber,I.endLineNumber-I.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(I.startLineNumber,I.endLineNumber-I.startLineNumber)}_acceptInsertText(I,w){if(w.length===0)return;const k=(0,l.splitLines)(w);if(k.length===1){this._setLineText(I.lineNumber-1,this._lines[I.lineNumber-1].substring(0,I.column-1)+k[0]+this._lines[I.lineNumber-1].substring(I.column-1));return}k[k.length-1]+=this._lines[I.lineNumber-1].substring(I.column-1),this._setLineText(I.lineNumber-1,this._lines[I.lineNumber-1].substring(0,I.column-1)+k[0]);const L=new Uint32Array(k.length-1);for(let D=1;D<k.length;D++)this._lines.splice(I.lineNumber+D-1,0,k[D]),L[D-1]=k[D].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(I.lineNumber,L)}}e.MirrorTextModel=P}),define(De[160],Ie([1,0,8,148,49,35,100]),function(J,e,l,t,C,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const I=999;class w{constructor(v,h,c,g){this.searchString=v,this.isRegex=h,this.matchCase=c,this.wordSeparators=g}parseSearchRequest(){if(this.searchString==="")return null;let v;this.isRegex?v=k(this.searchString):v=this.searchString.indexOf(`
`)>=0;let h=null;try{h=l.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:v,global:!0,unicode:!0})}catch{return null}if(!h)return null;let c=!this.isRegex&&!v;return c&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(c=this.matchCase),new _.SearchData(h,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,c?this.searchString:null)}}e.SearchParams=w;function k(m){if(!m||m.length===0)return!1;for(let v=0,h=m.length;v<h;v++){const c=m.charCodeAt(v);if(c===10)return!0;if(c===92){if(v++,v>=h)break;const g=m.charCodeAt(v);if(g===110||g===114||g===87)return!0}}return!1}e.isMultilineRegexSource=k;function L(m,v,h){if(!h)return new _.FindMatch(m,null);const c=[];for(let g=0,n=v.length;g<n;g++)c[g]=v[g];return new _.FindMatch(m,c)}e.createFindMatch=L;class D{constructor(v){const h=[];let c=0;for(let g=0,n=v.length;g<n;g++)v.charCodeAt(g)===10&&(h[c++]=g);this._lineFeedsOffsets=h}findLineFeedCountBeforeOffset(v){const h=this._lineFeedsOffsets;let c=0,g=h.length-1;if(g===-1||v<=h[0])return 0;for(;c<g;){const n=c+((g-c)/2>>0);h[n]>=v?g=n-1:h[n+1]>=v?(c=n,g=n):c=n+1}return c+1}}class S{static findMatches(v,h,c,g,n){const u=h.parseSearchRequest();return u?u.regex.multiline?this._doFindMatchesMultiline(v,c,new b(u.wordSeparators,u.regex),g,n):this._doFindMatchesLineByLine(v,c,u,g,n):[]}static _getMultilineMatchRange(v,h,c,g,n,u){let s,i=0;g?(i=g.findLineFeedCountBeforeOffset(n),s=h+n+i):s=h+n;let o;if(g){const f=g.findLineFeedCountBeforeOffset(n+u.length)-i;o=s+u.length+f}else o=s+u.length;const d=v.getPositionAt(s),r=v.getPositionAt(o);return new P.Range(d.lineNumber,d.column,r.lineNumber,r.column)}static _doFindMatchesMultiline(v,h,c,g,n){const u=v.getOffsetAt(h.getStartPosition()),s=v.getValueInRange(h,1),i=v.getEOL()===`\r
`?new D(s):null,o=[];let d=0,r;for(c.reset(0);r=c.next(s);)if(o[d++]=L(this._getMultilineMatchRange(v,u,s,i,r.index,r[0]),r,g),d>=n)return o;return o}static _doFindMatchesLineByLine(v,h,c,g,n){const u=[];let s=0;if(h.startLineNumber===h.endLineNumber){const o=v.getLineContent(h.startLineNumber).substring(h.startColumn-1,h.endColumn-1);return s=this._findMatchesInLine(c,o,h.startLineNumber,h.startColumn-1,s,u,g,n),u}const i=v.getLineContent(h.startLineNumber).substring(h.startColumn-1);s=this._findMatchesInLine(c,i,h.startLineNumber,h.startColumn-1,s,u,g,n);for(let o=h.startLineNumber+1;o<h.endLineNumber&&s<n;o++)s=this._findMatchesInLine(c,v.getLineContent(o),o,0,s,u,g,n);if(s<n){const o=v.getLineContent(h.endLineNumber).substring(0,h.endColumn-1);s=this._findMatchesInLine(c,o,h.endLineNumber,0,s,u,g,n)}return u}static _findMatchesInLine(v,h,c,g,n,u,s,i){const o=v.wordSeparators;if(!s&&v.simpleSearch){const a=v.simpleSearch,f=a.length,y=h.length;let R=-f;for(;(R=h.indexOf(a,R+f))!==-1;)if((!o||p(o,h,y,R,f))&&(u[n++]=new _.FindMatch(new P.Range(c,R+1+g,c,R+1+f+g),null),n>=i))return n;return n}const d=new b(v.wordSeparators,v.regex);let r;d.reset(0);do if(r=d.next(h),r&&(u[n++]=L(new P.Range(c,r.index+1+g,c,r.index+1+r[0].length+g),r,s),n>=i))return n;while(r);return n}static findNextMatch(v,h,c,g){const n=h.parseSearchRequest();if(!n)return null;const u=new b(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindNextMatchMultiline(v,c,u,g):this._doFindNextMatchLineByLine(v,c,u,g)}static _doFindNextMatchMultiline(v,h,c,g){const n=new C.Position(h.lineNumber,1),u=v.getOffsetAt(n),s=v.getLineCount(),i=v.getValueInRange(new P.Range(n.lineNumber,n.column,s,v.getLineMaxColumn(s)),1),o=v.getEOL()===`\r
`?new D(i):null;c.reset(h.column-1);const d=c.next(i);return d?L(this._getMultilineMatchRange(v,u,i,o,d.index,d[0]),d,g):h.lineNumber!==1||h.column!==1?this._doFindNextMatchMultiline(v,new C.Position(1,1),c,g):null}static _doFindNextMatchLineByLine(v,h,c,g){const n=v.getLineCount(),u=h.lineNumber,s=v.getLineContent(u),i=this._findFirstMatchInLine(c,s,u,h.column,g);if(i)return i;for(let o=1;o<=n;o++){const d=(u+o-1)%n,r=v.getLineContent(d+1),a=this._findFirstMatchInLine(c,r,d+1,1,g);if(a)return a}return null}static _findFirstMatchInLine(v,h,c,g,n){v.reset(g-1);const u=v.next(h);return u?L(new P.Range(c,u.index+1,c,u.index+1+u[0].length),u,n):null}static findPreviousMatch(v,h,c,g){const n=h.parseSearchRequest();if(!n)return null;const u=new b(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindPreviousMatchMultiline(v,c,u,g):this._doFindPreviousMatchLineByLine(v,c,u,g)}static _doFindPreviousMatchMultiline(v,h,c,g){const n=this._doFindMatchesMultiline(v,new P.Range(1,1,h.lineNumber,h.column),c,g,10*I);if(n.length>0)return n[n.length-1];const u=v.getLineCount();return h.lineNumber!==u||h.column!==v.getLineMaxColumn(u)?this._doFindPreviousMatchMultiline(v,new C.Position(u,v.getLineMaxColumn(u)),c,g):null}static _doFindPreviousMatchLineByLine(v,h,c,g){const n=v.getLineCount(),u=h.lineNumber,s=v.getLineContent(u).substring(0,h.column-1),i=this._findLastMatchInLine(c,s,u,g);if(i)return i;for(let o=1;o<=n;o++){const d=(n+u-o-1)%n,r=v.getLineContent(d+1),a=this._findLastMatchInLine(c,r,d+1,g);if(a)return a}return null}static _findLastMatchInLine(v,h,c,g){let n=null,u;for(v.reset(0);u=v.next(h);)n=L(new P.Range(c,u.index+1,c,u.index+1+u[0].length),u,g);return n}}e.TextModelSearch=S;function T(m,v,h,c,g){if(c===0)return!0;const n=v.charCodeAt(c-1);if(m.get(n)!==0||n===13||n===10)return!0;if(g>0){const u=v.charCodeAt(c);if(m.get(u)!==0)return!0}return!1}function E(m,v,h,c,g){if(c+g===h)return!0;const n=v.charCodeAt(c+g);if(m.get(n)!==0||n===13||n===10)return!0;if(g>0){const u=v.charCodeAt(c+g-1);if(m.get(u)!==0)return!0}return!1}function p(m,v,h,c,g){return T(m,v,h,c,g)&&E(m,v,h,c,g)}e.isValidMatch=p;class b{constructor(v,h){this._wordSeparators=v,this._searchRegex=h,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(v){this._searchRegex.lastIndex=v,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(v){const h=v.length;let c;do{if(this._prevMatchStartIndex+this._prevMatchLength===h||(c=this._searchRegex.exec(v),!c))return null;const g=c.index,n=c[0].length;if(g===this._prevMatchStartIndex&&n===this._prevMatchLength){if(n===0){l.getNextCodePoint(v,h,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=g,this._prevMatchLength=n,!this._wordSeparators||p(this._wordSeparators,v,h,g,n))return c}while(c);return null}}e.Searcher=b}),define(De[114],Ie([1,0,23,11]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var C;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(C||(C={}));function P(D){for(let S=0,T=D.length;S<T;S+=4){const E=D[S+0],p=D[S+1],b=D[S+2],m=D[S+3];D[S+0]=m,D[S+1]=b,D[S+2]=p,D[S+3]=E}}function _(D){const S=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return t.isLittleEndian()||P(S),l.VSBuffer.wrap(S)}function I(D){const S=D.buffer;if(t.isLittleEndian()||P(S),S.byteOffset%4===0)return new Uint32Array(S.buffer,S.byteOffset,S.length/4);{const T=new Uint8Array(S.byteLength);return T.set(S),new Uint32Array(T.buffer,T.byteOffset,T.length/4)}}function w(D){const S=new Uint32Array(k(D));let T=0;if(S[T++]=D.id,D.type==="full")S[T++]=1,S[T++]=D.data.length,S.set(D.data,T),T+=D.data.length;else{S[T++]=2,S[T++]=D.deltas.length;for(const E of D.deltas)S[T++]=E.start,S[T++]=E.deleteCount,E.data?(S[T++]=E.data.length,S.set(E.data,T),T+=E.data.length):S[T++]=0}return _(S)}e.encodeSemanticTokensDto=w;function k(D){let S=0;if(S+=1+1,D.type==="full")S+=1+D.data.length;else{S+=1,S+=(1+1+1)*D.deltas.length;for(const T of D.deltas)T.data&&(S+=T.data.length)}return S}function L(D){const S=I(D);let T=0;const E=S[T++];if(S[T++]===1){const v=S[T++],h=S.subarray(T,T+v);return T+=v,{id:E,type:"full",data:h}}const b=S[T++],m=[];for(let v=0;v<b;v++){const h=S[T++],c=S[T++],g=S[T++];let n;g>0&&(n=S.subarray(T,T+g),T+=g),m[v]={start:h,deleteCount:c,data:n}}return{id:E,type:"delta",deltas:m}}e.decodeSemanticTokensDto=L}),define(De[161],Ie([1,0,4,6]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class C{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new l.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(I){this._onDidChange.fire({changedLanguages:I,changedColorMap:!1})}register(I,w){return this._map.set(I,w),this.fire([I]),(0,t.toDisposable)(()=>{this._map.get(I)===w&&(this._map.delete(I),this.fire([I]))})}registerFactory(I,w){this._factories.get(I)?.dispose();const k=new P(this,I,w);return this._factories.set(I,k),(0,t.toDisposable)(()=>{const L=this._factories.get(I);!L||L!==k||(this._factories.delete(I),L.dispose())})}async getOrCreate(I){const w=this.get(I);if(w)return w;const k=this._factories.get(I);return!k||k.isResolved?null:(await k.resolve(),this.get(I))}get(I){return this._map.get(I)||null}isResolved(I){if(this.get(I))return!0;const k=this._factories.get(I);return!!(!k||k.isResolved)}setColorMap(I){this._colorMap=I,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=C;class P extends t.Disposable{get isResolved(){return this._isResolved}constructor(I,w,k){super(),this._registry=I,this._languageId=w,this._factory=k,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const I=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,I&&!this._isDisposed&&this._register(this._registry.register(this._languageId,I))}}}),define(De[63],Ie([1,0,74,2,35,161]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class _{constructor(f,y,R){this._tokenBrand=void 0,this.offset=f,this.type=y,this.language=R}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=_;class I{constructor(f,y){this._tokenizationResultBrand=void 0,this.tokens=f,this.endState=y}}e.TokenizationResult=I;class w{constructor(f,y){this._encodedTokenizationResultBrand=void 0,this.tokens=f,this.endState=y}}e.EncodedTokenizationResult=w;var k;(function(a){a[a.Method=0]="Method",a[a.Function=1]="Function",a[a.Constructor=2]="Constructor",a[a.Field=3]="Field",a[a.Variable=4]="Variable",a[a.Class=5]="Class",a[a.Struct=6]="Struct",a[a.Interface=7]="Interface",a[a.Module=8]="Module",a[a.Property=9]="Property",a[a.Event=10]="Event",a[a.Operator=11]="Operator",a[a.Unit=12]="Unit",a[a.Value=13]="Value",a[a.Constant=14]="Constant",a[a.Enum=15]="Enum",a[a.EnumMember=16]="EnumMember",a[a.Keyword=17]="Keyword",a[a.Text=18]="Text",a[a.Color=19]="Color",a[a.File=20]="File",a[a.Reference=21]="Reference",a[a.Customcolor=22]="Customcolor",a[a.Folder=23]="Folder",a[a.TypeParameter=24]="TypeParameter",a[a.User=25]="User",a[a.Issue=26]="Issue",a[a.Snippet=27]="Snippet"})(k=e.CompletionItemKind||(e.CompletionItemKind={}));var L;(function(a){const f=new Map;f.set(0,l.Codicon.symbolMethod),f.set(1,l.Codicon.symbolFunction),f.set(2,l.Codicon.symbolConstructor),f.set(3,l.Codicon.symbolField),f.set(4,l.Codicon.symbolVariable),f.set(5,l.Codicon.symbolClass),f.set(6,l.Codicon.symbolStruct),f.set(7,l.Codicon.symbolInterface),f.set(8,l.Codicon.symbolModule),f.set(9,l.Codicon.symbolProperty),f.set(10,l.Codicon.symbolEvent),f.set(11,l.Codicon.symbolOperator),f.set(12,l.Codicon.symbolUnit),f.set(13,l.Codicon.symbolValue),f.set(15,l.Codicon.symbolEnum),f.set(14,l.Codicon.symbolConstant),f.set(15,l.Codicon.symbolEnum),f.set(16,l.Codicon.symbolEnumMember),f.set(17,l.Codicon.symbolKeyword),f.set(27,l.Codicon.symbolSnippet),f.set(18,l.Codicon.symbolText),f.set(19,l.Codicon.symbolColor),f.set(20,l.Codicon.symbolFile),f.set(21,l.Codicon.symbolReference),f.set(22,l.Codicon.symbolCustomColor),f.set(23,l.Codicon.symbolFolder),f.set(24,l.Codicon.symbolTypeParameter),f.set(25,l.Codicon.account),f.set(26,l.Codicon.issues);function y(M){let A=f.get(M);return A||(console.info("No codicon found for CompletionItemKind "+M),A=l.Codicon.symbolProperty),A}a.toIcon=y;const R=new Map;R.set("method",0),R.set("function",1),R.set("constructor",2),R.set("field",3),R.set("variable",4),R.set("class",5),R.set("struct",6),R.set("interface",7),R.set("module",8),R.set("property",9),R.set("event",10),R.set("operator",11),R.set("unit",12),R.set("value",13),R.set("constant",14),R.set("enum",15),R.set("enum-member",16),R.set("enumMember",16),R.set("keyword",17),R.set("snippet",27),R.set("text",18),R.set("color",19),R.set("file",20),R.set("reference",21),R.set("customcolor",22),R.set("folder",23),R.set("type-parameter",24),R.set("typeParameter",24),R.set("account",25),R.set("issue",26);function N(M,A){let z=R.get(M);return typeof z>"u"&&!A&&(z=9),z}a.fromString=N})(L=e.CompletionItemKinds||(e.CompletionItemKinds={}));var D;(function(a){a[a.Deprecated=1]="Deprecated"})(D=e.CompletionItemTag||(e.CompletionItemTag={}));var S;(function(a){a[a.KeepWhitespace=1]="KeepWhitespace",a[a.InsertAsSnippet=4]="InsertAsSnippet"})(S=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var T;(function(a){a[a.Invoke=0]="Invoke",a[a.TriggerCharacter=1]="TriggerCharacter",a[a.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(T=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var E;(function(a){a[a.Automatic=0]="Automatic",a[a.Explicit=1]="Explicit"})(E=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var p;(function(a){a[a.Invoke=1]="Invoke",a[a.Auto=2]="Auto"})(p=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var b;(function(a){a[a.Invoke=1]="Invoke",a[a.TriggerCharacter=2]="TriggerCharacter",a[a.ContentChange=3]="ContentChange"})(b=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var m;(function(a){a[a.Text=0]="Text",a[a.Read=1]="Read",a[a.Write=2]="Write"})(m=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function v(a){return a&&t.URI.isUri(a.uri)&&C.Range.isIRange(a.range)&&(C.Range.isIRange(a.originSelectionRange)||C.Range.isIRange(a.targetSelectionRange))}e.isLocationLink=v;var h;(function(a){a[a.File=0]="File",a[a.Module=1]="Module",a[a.Namespace=2]="Namespace",a[a.Package=3]="Package",a[a.Class=4]="Class",a[a.Method=5]="Method",a[a.Property=6]="Property",a[a.Field=7]="Field",a[a.Constructor=8]="Constructor",a[a.Enum=9]="Enum",a[a.Interface=10]="Interface",a[a.Function=11]="Function",a[a.Variable=12]="Variable",a[a.Constant=13]="Constant",a[a.String=14]="String",a[a.Number=15]="Number",a[a.Boolean=16]="Boolean",a[a.Array=17]="Array",a[a.Object=18]="Object",a[a.Key=19]="Key",a[a.Null=20]="Null",a[a.EnumMember=21]="EnumMember",a[a.Struct=22]="Struct",a[a.Event=23]="Event",a[a.Operator=24]="Operator",a[a.TypeParameter=25]="TypeParameter"})(h=e.SymbolKind||(e.SymbolKind={}));var c;(function(a){a[a.Deprecated=1]="Deprecated"})(c=e.SymbolTag||(e.SymbolTag={}));var g;(function(a){const f=new Map;f.set(0,l.Codicon.symbolFile),f.set(1,l.Codicon.symbolModule),f.set(2,l.Codicon.symbolNamespace),f.set(3,l.Codicon.symbolPackage),f.set(4,l.Codicon.symbolClass),f.set(5,l.Codicon.symbolMethod),f.set(6,l.Codicon.symbolProperty),f.set(7,l.Codicon.symbolField),f.set(8,l.Codicon.symbolConstructor),f.set(9,l.Codicon.symbolEnum),f.set(10,l.Codicon.symbolInterface),f.set(11,l.Codicon.symbolFunction),f.set(12,l.Codicon.symbolVariable),f.set(13,l.Codicon.symbolConstant),f.set(14,l.Codicon.symbolString),f.set(15,l.Codicon.symbolNumber),f.set(16,l.Codicon.symbolBoolean),f.set(17,l.Codicon.symbolArray),f.set(18,l.Codicon.symbolObject),f.set(19,l.Codicon.symbolKey),f.set(20,l.Codicon.symbolNull),f.set(21,l.Codicon.symbolEnumMember),f.set(22,l.Codicon.symbolStruct),f.set(23,l.Codicon.symbolEvent),f.set(24,l.Codicon.symbolOperator),f.set(25,l.Codicon.symbolTypeParameter);function y(R){let N=f.get(R);return N||(console.info("No codicon found for SymbolKind "+R),N=l.Codicon.symbolProperty),N}a.toIcon=y})(g=e.SymbolKinds||(e.SymbolKinds={}));class n{constructor(f){this.value=f}}e.FoldingRangeKind=n,n.Comment=new n("comment"),n.Imports=new n("imports"),n.Region=new n("region");var u;(function(a){function f(y){return!y||typeof y!="object"?!1:typeof y.id=="string"&&typeof y.title=="string"}a.is=f})(u=e.Command||(e.Command={}));var s;(function(a){a[a.Collapsed=0]="Collapsed",a[a.Expanded=1]="Expanded"})(s=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var i;(function(a){a[a.Unresolved=0]="Unresolved",a[a.Resolved=1]="Resolved"})(i=e.CommentThreadState||(e.CommentThreadState={}));var o;(function(a){a[a.Editing=0]="Editing",a[a.Preview=1]="Preview"})(o=e.CommentMode||(e.CommentMode={}));var d;(function(a){a[a.Type=1]="Type",a[a.Parameter=2]="Parameter"})(d=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new P.TokenizationRegistry;var r;(function(a){a[a.None=0]="None",a[a.Option=1]="Option",a[a.Default=2]="Default",a[a.Preferred=3]="Preferred"})(r=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(De[162],Ie([19,20]),function(J,e){return J.create("vs/editor/common/config/editorOptions",e)}),define(De[115],Ie([1,0,162,11,99,17,24,147]),function(J,e,l,t,C,P,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var w;(function(re){re[re.None=0]="None",re[re.Keep=1]="Keep",re[re.Brackets=2]="Brackets",re[re.Advanced=3]="Advanced",re[re.Full=4]="Full"})(w=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(se){this._values=se}hasChanged(se){return this._values[se]}}e.ConfigurationChangedEvent=k;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class D{constructor(se,Ee,xe,fe){this.id=se,this.name=Ee,this.defaultValue=xe,this.schema=fe}applyUpdate(se,Ee){return T(se,Ee)}compute(se,Ee,xe){return xe}}class S{constructor(se,Ee){this.newValue=se,this.didChange=Ee}}e.ApplyUpdateResult=S;function T(re,se){if(typeof re!="object"||typeof se!="object"||!re||!se)return new S(se,re!==se);if(Array.isArray(re)||Array.isArray(se)){const xe=Array.isArray(re)&&Array.isArray(se)&&P.equals(re,se);return new S(se,!xe)}let Ee=!1;for(const xe in se)if(se.hasOwnProperty(xe)){const fe=T(re[xe],se[xe]);fe.didChange&&(re[xe]=fe.newValue,Ee=!0)}return new S(re,Ee)}class E{constructor(se){this.schema=void 0,this.id=se,this.name="_never_",this.defaultValue=void 0}applyUpdate(se,Ee){return T(se,Ee)}validate(se){return this.defaultValue}}class p{constructor(se,Ee,xe,fe){this.id=se,this.name=Ee,this.defaultValue=xe,this.schema=fe}applyUpdate(se,Ee){return T(se,Ee)}validate(se){return typeof se>"u"?this.defaultValue:se}compute(se,Ee,xe){return xe}}function b(re,se){return typeof re>"u"?se:re==="false"?!1:Boolean(re)}e.boolean=b;class m extends p{constructor(se,Ee,xe,fe=void 0){typeof fe<"u"&&(fe.type="boolean",fe.default=xe),super(se,Ee,xe,fe)}validate(se){return b(se,this.defaultValue)}}function v(re,se,Ee,xe){if(typeof re>"u")return se;let fe=parseInt(re,10);return isNaN(fe)?se:(fe=Math.max(Ee,fe),fe=Math.min(xe,fe),fe|0)}e.clampedInt=v;class h extends p{static clampedInt(se,Ee,xe,fe){return v(se,Ee,xe,fe)}constructor(se,Ee,xe,fe,Ae,Le=void 0){typeof Le<"u"&&(Le.type="integer",Le.default=xe,Le.minimum=fe,Le.maximum=Ae),super(se,Ee,xe,Le),this.minimum=fe,this.maximum=Ae}validate(se){return h.clampedInt(se,this.defaultValue,this.minimum,this.maximum)}}class c extends p{static clamp(se,Ee,xe){return se<Ee?Ee:se>xe?xe:se}static float(se,Ee){if(typeof se=="number")return se;if(typeof se>"u")return Ee;const xe=parseFloat(se);return isNaN(xe)?Ee:xe}constructor(se,Ee,xe,fe,Ae){typeof Ae<"u"&&(Ae.type="number",Ae.default=xe),super(se,Ee,xe,Ae),this.validationFn=fe}validate(se){return this.validationFn(c.float(se,this.defaultValue))}}class g extends p{static string(se,Ee){return typeof se!="string"?Ee:se}constructor(se,Ee,xe,fe=void 0){typeof fe<"u"&&(fe.type="string",fe.default=xe),super(se,Ee,xe,fe)}validate(se){return g.string(se,this.defaultValue)}}function n(re,se,Ee){return typeof re!="string"||Ee.indexOf(re)===-1?se:re}e.stringSet=n;class u extends p{constructor(se,Ee,xe,fe,Ae=void 0){typeof Ae<"u"&&(Ae.type="string",Ae.enum=fe,Ae.default=xe),super(se,Ee,xe,Ae),this._allowedValues=fe}validate(se){return n(se,this.defaultValue,this._allowedValues)}}class s extends D{constructor(se,Ee,xe,fe,Ae,Le,Me=void 0){typeof Me<"u"&&(Me.type="string",Me.enum=Ae,Me.default=fe),super(se,Ee,xe,Me),this._allowedValues=Ae,this._convert=Le}validate(se){return typeof se!="string"?this.defaultValue:this._allowedValues.indexOf(se)===-1?this.defaultValue:this._convert(se)}}function i(re){switch(re){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class o extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[l.localize(0,null),l.localize(1,null),l.localize(2,null)],default:"auto",description:l.localize(3,null)})}validate(se){switch(se){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(se,Ee,xe){return xe===0?se.accessibilitySupport:xe}}class d extends D{constructor(){const se={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",se,{"editor.comments.insertSpace":{type:"boolean",default:se.insertSpace,description:l.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:se.ignoreEmptyLines,description:l.localize(5,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{insertSpace:b(Ee.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:b(Ee.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(re){re[re.Hidden=0]="Hidden",re[re.Blink=1]="Blink",re[re.Smooth=2]="Smooth",re[re.Phase=3]="Phase",re[re.Expand=4]="Expand",re[re.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function a(re){switch(re){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var f;(function(re){re[re.Line=1]="Line",re[re.Block=2]="Block",re[re.Underline=3]="Underline",re[re.LineThin=4]="LineThin",re[re.BlockOutline=5]="BlockOutline",re[re.UnderlineThin=6]="UnderlineThin"})(f=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function y(re){switch(re){case f.Line:return"line";case f.Block:return"block";case f.Underline:return"underline";case f.LineThin:return"line-thin";case f.BlockOutline:return"block-outline";case f.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=y;function R(re){switch(re){case"line":return f.Line;case"block":return f.Block;case"underline":return f.Underline;case"line-thin":return f.LineThin;case"block-outline":return f.BlockOutline;case"underline-thin":return f.UnderlineThin}}class N extends E{constructor(){super(130)}compute(se,Ee,xe){const fe=["monaco-editor"];return Ee.get(34)&&fe.push(Ee.get(34)),se.extraEditorClassName&&fe.push(se.extraEditorClassName),Ee.get(67)==="default"?fe.push("mouse-default"):Ee.get(67)==="copy"&&fe.push("mouse-copy"),Ee.get(101)&&fe.push("showUnused"),Ee.get(128)&&fe.push("showDeprecated"),fe.join(" ")}}class M extends m{constructor(){super(33,"emptySelectionClipboard",!0,{description:l.localize(6,null)})}compute(se,Ee,xe){return xe&&se.emptySelectionClipboard}}class A extends D{constructor(){const se={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",se,{"editor.find.cursorMoveOnType":{type:"boolean",default:se.cursorMoveOnType,description:l.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:se.seedSearchStringFromSelection,enumDescriptions:[l.localize(8,null),l.localize(9,null),l.localize(10,null)],description:l.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:se.autoFindInSelection,enumDescriptions:[l.localize(12,null),l.localize(13,null),l.localize(14,null)],description:l.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:se.globalFindClipboard,description:l.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:se.addExtraSpaceOnTop,description:l.localize(17,null)},"editor.find.loop":{type:"boolean",default:se.loop,description:l.localize(18,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{cursorMoveOnType:b(Ee.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof se.seedSearchStringFromSelection=="boolean"?se.seedSearchStringFromSelection?"always":"never":n(Ee.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof se.autoFindInSelection=="boolean"?se.autoFindInSelection?"always":"never":n(Ee.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:b(Ee.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:b(Ee.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:b(Ee.loop,this.defaultValue.loop)}}}class z extends D{constructor(){super(46,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:l.localize(19,null)},{type:"string",description:l.localize(20,null)}],description:l.localize(21,null),default:!1})}validate(se){return typeof se>"u"?this.defaultValue:typeof se=="string"?se==="false"?z.OFF:se==="true"?z.ON:se:Boolean(se)?z.ON:z.OFF}}e.EditorFontLigatures=z,z.OFF='"liga" off, "calt" off',z.ON='"liga" on, "calt" on';class H extends E{constructor(){super(45)}compute(se,Ee,xe){return se.fontInfo}}class F extends p{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:l.localize(22,null)})}validate(se){const Ee=c.float(se,this.defaultValue);return Ee===0?e.EDITOR_FONT_DEFAULTS.fontSize:c.clamp(Ee,6,100)}compute(se,Ee,xe){return se.fontInfo.fontSize}}class G extends D{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:G.MINIMUM_VALUE,maximum:G.MAXIMUM_VALUE,errorMessage:l.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:G.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:l.localize(24,null)})}validate(se){return se==="normal"||se==="bold"?se:String(h.clampedInt(se,e.EDITOR_FONT_DEFAULTS.fontWeight,G.MINIMUM_VALUE,G.MAXIMUM_VALUE))}}G.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],G.MINIMUM_VALUE=1,G.MAXIMUM_VALUE=1e3;class B extends D{constructor(){const se={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ee={type:"string",enum:["peek","gotoAndPeek","goto"],default:se.multiple,enumDescriptions:[l.localize(25,null),l.localize(26,null),l.localize(27,null)]},xe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(52,"gotoLocation",se,{"editor.gotoLocation.multiple":{deprecationMessage:l.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:l.localize(29,null),...Ee},"editor.gotoLocation.multipleTypeDefinitions":{description:l.localize(30,null),...Ee},"editor.gotoLocation.multipleDeclarations":{description:l.localize(31,null),...Ee},"editor.gotoLocation.multipleImplementations":{description:l.localize(32,null),...Ee},"editor.gotoLocation.multipleReferences":{description:l.localize(33,null),...Ee},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:se.alternativeDefinitionCommand,enum:xe,description:l.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:se.alternativeTypeDefinitionCommand,enum:xe,description:l.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:se.alternativeDeclarationCommand,enum:xe,description:l.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:se.alternativeImplementationCommand,enum:xe,description:l.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:se.alternativeReferenceCommand,enum:xe,description:l.localize(38,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{multiple:n(Ee.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ee.multipleDefinitions??n(Ee.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ee.multipleTypeDefinitions??n(Ee.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ee.multipleDeclarations??n(Ee.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ee.multipleImplementations??n(Ee.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ee.multipleReferences??n(Ee.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:g.string(Ee.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:g.string(Ee.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:g.string(Ee.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:g.string(Ee.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:g.string(Ee.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class U extends D{constructor(){const se={enabled:!0,delay:300,sticky:!0,above:!0};super(54,"hover",se,{"editor.hover.enabled":{type:"boolean",default:se.enabled,description:l.localize(39,null)},"editor.hover.delay":{type:"number",default:se.delay,minimum:0,maximum:1e4,description:l.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:se.sticky,description:l.localize(41,null)},"editor.hover.above":{type:"boolean",default:se.above,description:l.localize(42,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:b(Ee.enabled,this.defaultValue.enabled),delay:h.clampedInt(Ee.delay,this.defaultValue.delay,0,1e4),sticky:b(Ee.sticky,this.defaultValue.sticky),above:b(Ee.above,this.defaultValue.above)}}}var x;(function(re){re[re.None=0]="None",re[re.Text=1]="Text",re[re.Blocks=2]="Blocks"})(x=e.RenderMinimap||(e.RenderMinimap={}));class $ extends E{constructor(){super(133)}compute(se,Ee,xe){return $.computeLayout(Ee,{memory:se.memory,outerWidth:se.outerWidth,outerHeight:se.outerHeight,isDominatedByLongLines:se.isDominatedByLongLines,lineHeight:se.fontInfo.lineHeight,viewLineCount:se.viewLineCount,lineNumbersDigitCount:se.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:se.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:se.fontInfo.maxDigitWidth,pixelRatio:se.pixelRatio})}static computeContainedMinimapLineCount(se){const Ee=se.height/se.lineHeight,xe=se.scrollBeyondLastLine?Ee-1:0,fe=(se.viewLineCount+xe)/(se.pixelRatio*se.height),Ae=Math.floor(se.viewLineCount/fe);return{typicalViewportLineCount:Ee,extraLinesBeyondLastLine:xe,desiredRatio:fe,minimapLineCount:Ae}}static _computeMinimapLayout(se,Ee){const xe=se.outerWidth,fe=se.outerHeight,Ae=se.pixelRatio;if(!se.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ae*fe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:fe};const Le=Ee.stableMinimapLayoutInput,Me=Le&&se.outerHeight===Le.outerHeight&&se.lineHeight===Le.lineHeight&&se.typicalHalfwidthCharacterWidth===Le.typicalHalfwidthCharacterWidth&&se.pixelRatio===Le.pixelRatio&&se.scrollBeyondLastLine===Le.scrollBeyondLastLine&&se.minimap.enabled===Le.minimap.enabled&&se.minimap.side===Le.minimap.side&&se.minimap.size===Le.minimap.size&&se.minimap.showSlider===Le.minimap.showSlider&&se.minimap.renderCharacters===Le.minimap.renderCharacters&&se.minimap.maxColumn===Le.minimap.maxColumn&&se.minimap.scale===Le.minimap.scale&&se.verticalScrollbarWidth===Le.verticalScrollbarWidth&&se.isViewportWrapping===Le.isViewportWrapping,Ge=se.lineHeight,Je=se.typicalHalfwidthCharacterWidth,st=se.scrollBeyondLastLine,vt=se.minimap.renderCharacters;let nt=Ae>=2?Math.round(se.minimap.scale*2):se.minimap.scale;const it=se.minimap.maxColumn,wt=se.minimap.size,Ct=se.minimap.side,Dt=se.verticalScrollbarWidth,ht=se.viewLineCount,Tt=se.remainingWidth,Ut=se.isViewportWrapping,Wt=vt?2:3;let Qe=Math.floor(Ae*fe);const Ft=Qe/Ae;let Pt=!1,Nt=!1,gt=Wt*nt,Pe=nt/Ae,Fe=1;if(wt==="fill"||wt==="fit"){const{typicalViewportLineCount:rt,extraLinesBeyondLastLine:dt,desiredRatio:mt,minimapLineCount:It}=$.computeContainedMinimapLineCount({viewLineCount:ht,scrollBeyondLastLine:st,height:fe,lineHeight:Ge,pixelRatio:Ae});if(ht/It>1)Pt=!0,Nt=!0,nt=1,gt=1,Pe=nt/Ae;else{let _t=!1,At=nt+1;if(wt==="fit"){const St=Math.ceil((ht+dt)*gt);Ut&&Me&&Tt<=Ee.stableFitRemainingWidth?(_t=!0,At=Ee.stableFitMaxMinimapScale):_t=St>Qe}if(wt==="fill"||_t){Pt=!0;const St=nt;gt=Math.min(Ge*Ae,Math.max(1,Math.floor(1/mt))),Ut&&Me&&Tt<=Ee.stableFitRemainingWidth&&(At=Ee.stableFitMaxMinimapScale),nt=Math.min(At,Math.max(1,Math.floor(gt/Wt))),nt>St&&(Fe=Math.min(2,nt/St)),Pe=nt/Ae/Fe,Qe=Math.ceil(Math.max(rt,ht+dt)*gt),Ut?(Ee.stableMinimapLayoutInput=se,Ee.stableFitRemainingWidth=Tt,Ee.stableFitMaxMinimapScale=nt):(Ee.stableMinimapLayoutInput=null,Ee.stableFitRemainingWidth=0)}}}const _e=Math.floor(it*Pe),ee=Math.min(_e,Math.max(0,Math.floor((Tt-Dt-2)*Pe/(Je+Pe)))+e.MINIMAP_GUTTER_WIDTH);let Ne=Math.floor(Ae*ee);const Ve=Ne/Ae;Ne=Math.floor(Ne*Fe);const at=vt?1:2,Ke=Ct==="left"?0:xe-ee-Dt;return{renderMinimap:at,minimapLeft:Ke,minimapWidth:ee,minimapHeightIsEditorHeight:Pt,minimapIsSampling:Nt,minimapScale:nt,minimapLineHeight:gt,minimapCanvasInnerWidth:Ne,minimapCanvasInnerHeight:Qe,minimapCanvasOuterWidth:Ve,minimapCanvasOuterHeight:Ft}}static computeLayout(se,Ee){const xe=Ee.outerWidth|0,fe=Ee.outerHeight|0,Ae=Ee.lineHeight|0,Le=Ee.lineNumbersDigitCount|0,Me=Ee.typicalHalfwidthCharacterWidth,Ge=Ee.maxDigitWidth,Je=Ee.pixelRatio,st=Ee.viewLineCount,vt=se.get(125),nt=vt==="inherit"?se.get(124):vt,it=nt==="inherit"?se.get(120):nt,wt=se.get(123),Ct=se.get(2),Dt=Ee.isDominatedByLongLines,ht=se.get(51),Tt=se.get(61).renderType!==0,Ut=se.get(62),Wt=se.get(95),Qe=se.get(66),Ft=se.get(93),Pt=Ft.verticalScrollbarSize,Nt=Ft.verticalHasArrows,gt=Ft.arrowSize,Pe=Ft.horizontalScrollbarSize,Fe=se.get(59),_e=se.get(38),ee=se.get(100)!=="never";let Ne;if(typeof Fe=="string"&&/^\d+(\.\d+)?ch$/.test(Fe)){const bt=parseFloat(Fe.substr(0,Fe.length-2));Ne=h.clampedInt(bt*Me,0,0,1e3)}else Ne=h.clampedInt(Fe,0,0,1e3);_e&&ee&&(Ne+=16);let Ve=0;if(Tt){const bt=Math.max(Le,Ut);Ve=Math.round(bt*Ge)}let at=0;ht&&(at=Ae);let Ke=0,rt=Ke+at,dt=rt+Ve,mt=dt+Ne;const It=xe-at-Ve-Ne;let Et=!1,_t=!1,At=-1;Ct!==2&&(nt==="inherit"&&Dt?(Et=!0,_t=!0):it==="on"||it==="bounded"?_t=!0:it==="wordWrapColumn"&&(At=wt));const St=$._computeMinimapLayout({outerWidth:xe,outerHeight:fe,lineHeight:Ae,typicalHalfwidthCharacterWidth:Me,pixelRatio:Je,scrollBeyondLastLine:Wt,minimap:Qe,verticalScrollbarWidth:Pt,viewLineCount:st,remainingWidth:It,isViewportWrapping:_t},Ee.memory||new L);St.renderMinimap!==0&&St.minimapLeft===0&&(Ke+=St.minimapWidth,rt+=St.minimapWidth,dt+=St.minimapWidth,mt+=St.minimapWidth);const kt=It-St.minimapWidth,tn=Math.max(1,Math.floor((kt-Pt-2)/Me)),Xt=Nt?gt:0;return _t&&(At=Math.max(1,tn),it==="bounded"&&(At=Math.min(At,wt))),{width:xe,height:fe,glyphMarginLeft:Ke,glyphMarginWidth:at,lineNumbersLeft:rt,lineNumbersWidth:Ve,decorationsLeft:dt,decorationsWidth:Ne,contentLeft:mt,contentWidth:kt,minimap:St,viewportColumn:tn,isWordWrapMinified:Et,isViewportWrapping:_t,wrappingColumn:At,verticalScrollbarWidth:Pt,horizontalScrollbarHeight:Pe,overviewRuler:{top:Xt,width:Pt,height:fe-2*Xt,right:0}}}}e.EditorLayoutInfoComputer=$;class Q extends D{constructor(){const se={enabled:!0};super(58,"lightbulb",se,{"editor.lightbulb.enabled":{type:"boolean",default:se.enabled,description:l.localize(43,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:b(se.enabled,this.defaultValue.enabled)}}}class K extends D{constructor(){const se={enabled:!1,maxLineCount:5};super(105,"stickyScroll",se,{"editor.stickyScroll.enabled":{type:"boolean",default:se.enabled,description:l.localize(44,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:se.maxLineCount,minimum:1,maximum:10,description:l.localize(45,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:b(Ee.enabled,this.defaultValue.enabled),maxLineCount:h.clampedInt(Ee.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class de extends D{constructor(){const se={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(129,"inlayHints",se,{"editor.inlayHints.enabled":{type:"string",default:se.enabled,description:l.localize(46,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[l.localize(47,null),l.localize(48,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),l.localize(49,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),l.localize(50,null)]},"editor.inlayHints.fontSize":{type:"number",default:se.fontSize,markdownDescription:l.localize(51,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:se.fontFamily,markdownDescription:l.localize(52,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:se.padding,description:l.localize(53,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return typeof Ee.enabled=="boolean"&&(Ee.enabled=Ee.enabled?"on":"off"),{enabled:n(Ee.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:h.clampedInt(Ee.fontSize,this.defaultValue.fontSize,0,100),fontFamily:g.string(Ee.fontFamily,this.defaultValue.fontFamily),padding:b(Ee.padding,this.defaultValue.padding)}}}class te extends c{constructor(){super(60,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,se=>c.clamp(se,0,150),{markdownDescription:l.localize(54,null)})}compute(se,Ee,xe){return se.fontInfo.lineHeight}}class he extends D{constructor(){const se={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(66,"minimap",se,{"editor.minimap.enabled":{type:"boolean",default:se.enabled,description:l.localize(55,null)},"editor.minimap.autohide":{type:"boolean",default:se.autohide,description:l.localize(56,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[l.localize(57,null),l.localize(58,null),l.localize(59,null)],default:se.size,description:l.localize(60,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:se.side,description:l.localize(61,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:se.showSlider,description:l.localize(62,null)},"editor.minimap.scale":{type:"number",default:se.scale,minimum:1,maximum:3,enum:[1,2,3],description:l.localize(63,null)},"editor.minimap.renderCharacters":{type:"boolean",default:se.renderCharacters,description:l.localize(64,null)},"editor.minimap.maxColumn":{type:"number",default:se.maxColumn,description:l.localize(65,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:b(Ee.enabled,this.defaultValue.enabled),autohide:b(Ee.autohide,this.defaultValue.autohide),size:n(Ee.size,this.defaultValue.size,["proportional","fill","fit"]),side:n(Ee.side,this.defaultValue.side,["right","left"]),showSlider:n(Ee.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:b(Ee.renderCharacters,this.defaultValue.renderCharacters),scale:h.clampedInt(Ee.scale,1,1,3),maxColumn:h.clampedInt(Ee.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Y(re){return re==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ve extends D{constructor(){super(76,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(66,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(67,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{top:h.clampedInt(Ee.top,0,0,1e3),bottom:h.clampedInt(Ee.bottom,0,0,1e3)}}}class be extends D{constructor(){const se={enabled:!0,cycle:!1};super(77,"parameterHints",se,{"editor.parameterHints.enabled":{type:"boolean",default:se.enabled,description:l.localize(68,null)},"editor.parameterHints.cycle":{type:"boolean",default:se.cycle,description:l.localize(69,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:b(Ee.enabled,this.defaultValue.enabled),cycle:b(Ee.cycle,this.defaultValue.cycle)}}}class ke extends E{constructor(){super(131)}compute(se,Ee,xe){return se.pixelRatio}}class Re extends D{constructor(){const se={other:"on",comments:"off",strings:"off"},Ee=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[l.localize(70,null),l.localize(71,null),l.localize(72,null)]}];super(80,"quickSuggestions",se,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ee,default:se.strings,description:l.localize(73,null)},comments:{anyOf:Ee,default:se.comments,description:l.localize(74,null)},other:{anyOf:Ee,default:se.other,description:l.localize(75,null)}},default:se,markdownDescription:l.localize(76,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=se}validate(se){if(typeof se=="boolean"){const Je=se?"on":"off";return{comments:Je,strings:Je,other:Je}}if(!se||typeof se!="object")return this.defaultValue;const{other:Ee,comments:xe,strings:fe}=se,Ae=["on","inline","off"];let Le,Me,Ge;return typeof Ee=="boolean"?Le=Ee?"on":"off":Le=n(Ee,this.defaultValue.other,Ae),typeof xe=="boolean"?Me=xe?"on":"off":Me=n(xe,this.defaultValue.comments,Ae),typeof fe=="boolean"?Ge=fe?"on":"off":Ge=n(fe,this.defaultValue.strings,Ae),{other:Le,comments:Me,strings:Ge}}}var ze;(function(re){re[re.Off=0]="Off",re[re.On=1]="On",re[re.Relative=2]="Relative",re[re.Interval=3]="Interval",re[re.Custom=4]="Custom"})(ze=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class oe extends D{constructor(){super(61,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[l.localize(77,null),l.localize(78,null),l.localize(79,null),l.localize(80,null)],default:"on",description:l.localize(81,null)})}validate(se){let Ee=this.defaultValue.renderType,xe=this.defaultValue.renderFn;return typeof se<"u"&&(typeof se=="function"?(Ee=4,xe=se):se==="interval"?Ee=3:se==="relative"?Ee=2:se==="on"?Ee=1:Ee=0),{renderType:Ee,renderFn:xe}}}function le(re){const se=re.get(88);return se==="editable"?re.get(82):se!=="on"}e.filterValidationDecorations=le;class me extends D{constructor(){const se=[],Ee={type:"number",description:l.localize(82,null)};super(92,"rulers",se,{type:"array",items:{anyOf:[Ee,{type:["object"],properties:{column:Ee,color:{type:"string",description:l.localize(83,null),format:"color-hex"}}}]},default:se,description:l.localize(84,null)})}validate(se){if(Array.isArray(se)){const Ee=[];for(const xe of se)if(typeof xe=="number")Ee.push({column:h.clampedInt(xe,0,0,1e4),color:null});else if(xe&&typeof xe=="object"){const fe=xe;Ee.push({column:h.clampedInt(fe.column,0,0,1e4),color:fe.color})}return Ee.sort((xe,fe)=>xe.column-fe.column),Ee}return this.defaultValue}}function Z(re,se){if(typeof re!="string")return se;switch(re){case"hidden":return 2;case"visible":return 3;default:return 1}}class ae extends D{constructor(){const se={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(93,"scrollbar",se,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(85,null),l.localize(86,null),l.localize(87,null)],default:"auto",description:l.localize(88,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(89,null),l.localize(90,null),l.localize(91,null)],default:"auto",description:l.localize(92,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:se.verticalScrollbarSize,description:l.localize(93,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:se.horizontalScrollbarSize,description:l.localize(94,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:se.scrollByPage,description:l.localize(95,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se,xe=h.clampedInt(Ee.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),fe=h.clampedInt(Ee.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:h.clampedInt(Ee.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Z(Ee.vertical,this.defaultValue.vertical),horizontal:Z(Ee.horizontal,this.defaultValue.horizontal),useShadows:b(Ee.useShadows,this.defaultValue.useShadows),verticalHasArrows:b(Ee.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:b(Ee.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:b(Ee.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:b(Ee.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:xe,horizontalSliderSize:h.clampedInt(Ee.horizontalSliderSize,xe,0,1e3),verticalScrollbarSize:fe,verticalSliderSize:h.clampedInt(Ee.verticalSliderSize,fe,0,1e3),scrollByPage:b(Ee.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ne extends D{constructor(){const se={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(115,"unicodeHighlight",se,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.nonBasicASCII,description:l.localize(96,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:se.invisibleCharacters,description:l.localize(97,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:se.ambiguousCharacters,description:l.localize(98,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeComments,description:l.localize(99,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeStrings,description:l.localize(100,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:se.allowedCharacters,description:l.localize(101,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:se.allowedLocales,description:l.localize(102,null)}})}applyUpdate(se,Ee){let xe=!1;Ee.allowedCharacters&&se&&(_.equals(se.allowedCharacters,Ee.allowedCharacters)||(se={...se,allowedCharacters:Ee.allowedCharacters},xe=!0)),Ee.allowedLocales&&se&&(_.equals(se.allowedLocales,Ee.allowedLocales)||(se={...se,allowedLocales:Ee.allowedLocales},xe=!0));const fe=super.applyUpdate(se,Ee);return xe?new S(fe.newValue,!0):fe}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{nonBasicASCII:q(Ee.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:b(Ee.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:b(Ee.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:q(Ee.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:q(Ee.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(se.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(se.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(se,Ee){if(typeof se!="object"||!se)return Ee;const xe={};for(const[fe,Ae]of Object.entries(se))Ae===!0&&(xe[fe]=!0);return xe}}class ie extends D{constructor(){const se={enabled:!0,mode:"subwordSmart"};super(56,"inlineSuggest",se,{"editor.inlineSuggest.enabled":{type:"boolean",default:se.enabled,description:l.localize(103,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:b(Ee.enabled,this.defaultValue.enabled),mode:n(Ee.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class O extends D{constructor(){const se={enabled:I.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:I.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",se,{"editor.bracketPairColorization.enabled":{type:"boolean",default:se.enabled,markdownDescription:l.localize(104,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:se.independentColorPoolPerBracketType,description:l.localize(105,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:b(Ee.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:b(Ee.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class V extends D{constructor(){const se={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",se,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(106,null),l.localize(107,null),l.localize(108,null)],default:se.bracketPairs,description:l.localize(109,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(110,null),l.localize(111,null),l.localize(112,null)],default:se.bracketPairsHorizontal,description:l.localize(113,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:se.highlightActiveBracketPair,description:l.localize(114,null)},"editor.guides.indentation":{type:"boolean",default:se.indentation,description:l.localize(115,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[l.localize(116,null),l.localize(117,null),l.localize(118,null)],default:se.highlightActiveIndentation,description:l.localize(119,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{bracketPairs:q(Ee.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:q(Ee.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:b(Ee.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:b(Ee.indentation,this.defaultValue.indentation),highlightActiveIndentation:q(Ee.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function q(re,se,Ee){const xe=Ee.indexOf(re);return xe===-1?se:Ee[xe]}class X extends D{constructor(){const se={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(108,"suggest",se,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[l.localize(120,null),l.localize(121,null)],default:se.insertMode,description:l.localize(122,null)},"editor.suggest.filterGraceful":{type:"boolean",default:se.filterGraceful,description:l.localize(123,null)},"editor.suggest.localityBonus":{type:"boolean",default:se.localityBonus,description:l.localize(124,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:se.shareSuggestSelections,markdownDescription:l.localize(125,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:se.snippetsPreventQuickSuggestions,description:l.localize(126,null)},"editor.suggest.showIcons":{type:"boolean",default:se.showIcons,description:l.localize(127,null)},"editor.suggest.showStatusBar":{type:"boolean",default:se.showStatusBar,description:l.localize(128,null)},"editor.suggest.preview":{type:"boolean",default:se.preview,description:l.localize(129,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:se.showInlineDetails,description:l.localize(130,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:l.localize(131,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:l.localize(132,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:l.localize(133,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:l.localize(134,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:l.localize(135,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:l.localize(136,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:l.localize(137,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:l.localize(138,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:l.localize(139,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:l.localize(140,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:l.localize(141,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:l.localize(142,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:l.localize(143,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:l.localize(144,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:l.localize(145,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:l.localize(146,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:l.localize(147,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:l.localize(148,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:l.localize(149,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:l.localize(150,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:l.localize(151,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:l.localize(152,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:l.localize(153,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:l.localize(154,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:l.localize(155,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:l.localize(156,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:l.localize(157,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:l.localize(158,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:l.localize(159,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:l.localize(160,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:l.localize(161,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:l.localize(162,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{insertMode:n(Ee.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:b(Ee.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:b(Ee.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:b(Ee.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:b(Ee.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:b(Ee.showIcons,this.defaultValue.showIcons),showStatusBar:b(Ee.showStatusBar,this.defaultValue.showStatusBar),preview:b(Ee.preview,this.defaultValue.preview),previewMode:n(Ee.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:b(Ee.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:b(Ee.showMethods,this.defaultValue.showMethods),showFunctions:b(Ee.showFunctions,this.defaultValue.showFunctions),showConstructors:b(Ee.showConstructors,this.defaultValue.showConstructors),showDeprecated:b(Ee.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:b(Ee.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:b(Ee.showFields,this.defaultValue.showFields),showVariables:b(Ee.showVariables,this.defaultValue.showVariables),showClasses:b(Ee.showClasses,this.defaultValue.showClasses),showStructs:b(Ee.showStructs,this.defaultValue.showStructs),showInterfaces:b(Ee.showInterfaces,this.defaultValue.showInterfaces),showModules:b(Ee.showModules,this.defaultValue.showModules),showProperties:b(Ee.showProperties,this.defaultValue.showProperties),showEvents:b(Ee.showEvents,this.defaultValue.showEvents),showOperators:b(Ee.showOperators,this.defaultValue.showOperators),showUnits:b(Ee.showUnits,this.defaultValue.showUnits),showValues:b(Ee.showValues,this.defaultValue.showValues),showConstants:b(Ee.showConstants,this.defaultValue.showConstants),showEnums:b(Ee.showEnums,this.defaultValue.showEnums),showEnumMembers:b(Ee.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:b(Ee.showKeywords,this.defaultValue.showKeywords),showWords:b(Ee.showWords,this.defaultValue.showWords),showColors:b(Ee.showColors,this.defaultValue.showColors),showFiles:b(Ee.showFiles,this.defaultValue.showFiles),showReferences:b(Ee.showReferences,this.defaultValue.showReferences),showFolders:b(Ee.showFolders,this.defaultValue.showFolders),showTypeParameters:b(Ee.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:b(Ee.showSnippets,this.defaultValue.showSnippets),showUsers:b(Ee.showUsers,this.defaultValue.showUsers),showIssues:b(Ee.showIssues,this.defaultValue.showIssues)}}}class ge extends D{constructor(){super(103,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:l.localize(163,null),default:!0,type:"boolean"}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:b(se.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class we extends E{constructor(){super(132)}compute(se,Ee,xe){return Ee.get(82)?!0:se.tabFocusMode}}var ce;(function(re){re[re.None=0]="None",re[re.Same=1]="Same",re[re.Indent=2]="Indent",re[re.DeepIndent=3]="DeepIndent"})(ce=e.WrappingIndent||(e.WrappingIndent={}));function Ce(re){switch(re){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ye extends E{constructor(){super(134)}compute(se,Ee,xe){const fe=Ee.get(133);return{isDominatedByLongLines:se.isDominatedByLongLines,isWordWrapMinified:fe.isWordWrapMinified,isViewportWrapping:fe.isViewportWrapping,wrappingColumn:fe.wrappingColumn}}}class We extends D{constructor(){const se={enabled:!0};super(32,"dropIntoEditor",se,{"editor.dropIntoEditor.enabled":{type:"boolean",default:se.enabled,markdownDescription:l.localize(164,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:b(se.enabled,this.defaultValue.enabled)}}}const qe="Consolas, 'Courier New', monospace",Ze="Menlo, Monaco, 'Courier New', monospace",Ye="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?Ze:t.isLinux?Ye:qe,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Oe(re){return e.editorOptionsRegistry[re.id]=re,re}var ot;(function(re){re[re.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",re[re.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",re[re.accessibilitySupport=2]="accessibilitySupport",re[re.accessibilityPageSize=3]="accessibilityPageSize",re[re.ariaLabel=4]="ariaLabel",re[re.autoClosingBrackets=5]="autoClosingBrackets",re[re.autoClosingDelete=6]="autoClosingDelete",re[re.autoClosingOvertype=7]="autoClosingOvertype",re[re.autoClosingQuotes=8]="autoClosingQuotes",re[re.autoIndent=9]="autoIndent",re[re.automaticLayout=10]="automaticLayout",re[re.autoSurround=11]="autoSurround",re[re.bracketPairColorization=12]="bracketPairColorization",re[re.guides=13]="guides",re[re.codeLens=14]="codeLens",re[re.codeLensFontFamily=15]="codeLensFontFamily",re[re.codeLensFontSize=16]="codeLensFontSize",re[re.colorDecorators=17]="colorDecorators",re[re.columnSelection=18]="columnSelection",re[re.comments=19]="comments",re[re.contextmenu=20]="contextmenu",re[re.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",re[re.cursorBlinking=22]="cursorBlinking",re[re.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",re[re.cursorStyle=24]="cursorStyle",re[re.cursorSurroundingLines=25]="cursorSurroundingLines",re[re.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",re[re.cursorWidth=27]="cursorWidth",re[re.disableLayerHinting=28]="disableLayerHinting",re[re.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",re[re.domReadOnly=30]="domReadOnly",re[re.dragAndDrop=31]="dragAndDrop",re[re.dropIntoEditor=32]="dropIntoEditor",re[re.emptySelectionClipboard=33]="emptySelectionClipboard",re[re.extraEditorClassName=34]="extraEditorClassName",re[re.fastScrollSensitivity=35]="fastScrollSensitivity",re[re.find=36]="find",re[re.fixedOverflowWidgets=37]="fixedOverflowWidgets",re[re.folding=38]="folding",re[re.foldingStrategy=39]="foldingStrategy",re[re.foldingHighlight=40]="foldingHighlight",re[re.foldingImportsByDefault=41]="foldingImportsByDefault",re[re.foldingMaximumRegions=42]="foldingMaximumRegions",re[re.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",re[re.fontFamily=44]="fontFamily",re[re.fontInfo=45]="fontInfo",re[re.fontLigatures=46]="fontLigatures",re[re.fontSize=47]="fontSize",re[re.fontWeight=48]="fontWeight",re[re.formatOnPaste=49]="formatOnPaste",re[re.formatOnType=50]="formatOnType",re[re.glyphMargin=51]="glyphMargin",re[re.gotoLocation=52]="gotoLocation",re[re.hideCursorInOverviewRuler=53]="hideCursorInOverviewRuler",re[re.hover=54]="hover",re[re.inDiffEditor=55]="inDiffEditor",re[re.inlineSuggest=56]="inlineSuggest",re[re.letterSpacing=57]="letterSpacing",re[re.lightbulb=58]="lightbulb",re[re.lineDecorationsWidth=59]="lineDecorationsWidth",re[re.lineHeight=60]="lineHeight",re[re.lineNumbers=61]="lineNumbers",re[re.lineNumbersMinChars=62]="lineNumbersMinChars",re[re.linkedEditing=63]="linkedEditing",re[re.links=64]="links",re[re.matchBrackets=65]="matchBrackets",re[re.minimap=66]="minimap",re[re.mouseStyle=67]="mouseStyle",re[re.mouseWheelScrollSensitivity=68]="mouseWheelScrollSensitivity",re[re.mouseWheelZoom=69]="mouseWheelZoom",re[re.multiCursorMergeOverlapping=70]="multiCursorMergeOverlapping",re[re.multiCursorModifier=71]="multiCursorModifier",re[re.multiCursorPaste=72]="multiCursorPaste",re[re.occurrencesHighlight=73]="occurrencesHighlight",re[re.overviewRulerBorder=74]="overviewRulerBorder",re[re.overviewRulerLanes=75]="overviewRulerLanes",re[re.padding=76]="padding",re[re.parameterHints=77]="parameterHints",re[re.peekWidgetDefaultFocus=78]="peekWidgetDefaultFocus",re[re.definitionLinkOpensInPeek=79]="definitionLinkOpensInPeek",re[re.quickSuggestions=80]="quickSuggestions",re[re.quickSuggestionsDelay=81]="quickSuggestionsDelay",re[re.readOnly=82]="readOnly",re[re.renameOnType=83]="renameOnType",re[re.renderControlCharacters=84]="renderControlCharacters",re[re.renderFinalNewline=85]="renderFinalNewline",re[re.renderLineHighlight=86]="renderLineHighlight",re[re.renderLineHighlightOnlyWhenFocus=87]="renderLineHighlightOnlyWhenFocus",re[re.renderValidationDecorations=88]="renderValidationDecorations",re[re.renderWhitespace=89]="renderWhitespace",re[re.revealHorizontalRightPadding=90]="revealHorizontalRightPadding",re[re.roundedSelection=91]="roundedSelection",re[re.rulers=92]="rulers",re[re.scrollbar=93]="scrollbar",re[re.scrollBeyondLastColumn=94]="scrollBeyondLastColumn",re[re.scrollBeyondLastLine=95]="scrollBeyondLastLine",re[re.scrollPredominantAxis=96]="scrollPredominantAxis",re[re.selectionClipboard=97]="selectionClipboard",re[re.selectionHighlight=98]="selectionHighlight",re[re.selectOnLineNumbers=99]="selectOnLineNumbers",re[re.showFoldingControls=100]="showFoldingControls",re[re.showUnused=101]="showUnused",re[re.snippetSuggestions=102]="snippetSuggestions",re[re.smartSelect=103]="smartSelect",re[re.smoothScrolling=104]="smoothScrolling",re[re.stickyScroll=105]="stickyScroll",re[re.stickyTabStops=106]="stickyTabStops",re[re.stopRenderingLineAfter=107]="stopRenderingLineAfter",re[re.suggest=108]="suggest",re[re.suggestFontSize=109]="suggestFontSize",re[re.suggestLineHeight=110]="suggestLineHeight",re[re.suggestOnTriggerCharacters=111]="suggestOnTriggerCharacters",re[re.suggestSelection=112]="suggestSelection",re[re.tabCompletion=113]="tabCompletion",re[re.tabIndex=114]="tabIndex",re[re.unicodeHighlighting=115]="unicodeHighlighting",re[re.unusualLineTerminators=116]="unusualLineTerminators",re[re.useShadowDOM=117]="useShadowDOM",re[re.useTabStops=118]="useTabStops",re[re.wordSeparators=119]="wordSeparators",re[re.wordWrap=120]="wordWrap",re[re.wordWrapBreakAfterCharacters=121]="wordWrapBreakAfterCharacters",re[re.wordWrapBreakBeforeCharacters=122]="wordWrapBreakBeforeCharacters",re[re.wordWrapColumn=123]="wordWrapColumn",re[re.wordWrapOverride1=124]="wordWrapOverride1",re[re.wordWrapOverride2=125]="wordWrapOverride2",re[re.wrappingIndent=126]="wrappingIndent",re[re.wrappingStrategy=127]="wrappingStrategy",re[re.showDeprecated=128]="showDeprecated",re[re.inlayHints=129]="inlayHints",re[re.editorClassName=130]="editorClassName",re[re.pixelRatio=131]="pixelRatio",re[re.tabFocusMode=132]="tabFocusMode",re[re.layoutInfo=133]="layoutInfo",re[re.wrappingInfo=134]="wrappingInfo"})(ot=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Oe(new m(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:l.localize(165,null)})),acceptSuggestionOnEnter:Oe(new u(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",l.localize(166,null),""],markdownDescription:l.localize(167,null)})),accessibilitySupport:Oe(new o),accessibilityPageSize:Oe(new h(3,"accessibilityPageSize",10,1,1073741824,{description:l.localize(168,null)})),ariaLabel:Oe(new g(4,"ariaLabel",l.localize(169,null))),autoClosingBrackets:Oe(new u(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(170,null),l.localize(171,null),""],description:l.localize(172,null)})),autoClosingDelete:Oe(new u(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",l.localize(173,null),""],description:l.localize(174,null)})),autoClosingOvertype:Oe(new u(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",l.localize(175,null),""],description:l.localize(176,null)})),autoClosingQuotes:Oe(new u(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(177,null),l.localize(178,null),""],description:l.localize(179,null)})),autoIndent:Oe(new s(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],i,{enumDescriptions:[l.localize(180,null),l.localize(181,null),l.localize(182,null),l.localize(183,null),l.localize(184,null)],description:l.localize(185,null)})),automaticLayout:Oe(new m(10,"automaticLayout",!1)),autoSurround:Oe(new u(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[l.localize(186,null),l.localize(187,null),l.localize(188,null),""],description:l.localize(189,null)})),bracketPairColorization:Oe(new O),bracketPairGuides:Oe(new V),stickyTabStops:Oe(new m(106,"stickyTabStops",!1,{description:l.localize(190,null)})),codeLens:Oe(new m(14,"codeLens",!0,{description:l.localize(191,null)})),codeLensFontFamily:Oe(new g(15,"codeLensFontFamily","",{description:l.localize(192,null)})),codeLensFontSize:Oe(new h(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:l.localize(193,null)})),colorDecorators:Oe(new m(17,"colorDecorators",!0,{description:l.localize(194,null)})),columnSelection:Oe(new m(18,"columnSelection",!1,{description:l.localize(195,null)})),comments:Oe(new d),contextmenu:Oe(new m(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Oe(new m(21,"copyWithSyntaxHighlighting",!0,{description:l.localize(196,null)})),cursorBlinking:Oe(new s(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],a,{description:l.localize(197,null)})),cursorSmoothCaretAnimation:Oe(new m(23,"cursorSmoothCaretAnimation",!1,{description:l.localize(198,null)})),cursorStyle:Oe(new s(24,"cursorStyle",f.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],R,{description:l.localize(199,null)})),cursorSurroundingLines:Oe(new h(25,"cursorSurroundingLines",0,0,1073741824,{description:l.localize(200,null)})),cursorSurroundingLinesStyle:Oe(new u(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[l.localize(201,null),l.localize(202,null)],description:l.localize(203,null)})),cursorWidth:Oe(new h(27,"cursorWidth",0,0,1073741824,{markdownDescription:l.localize(204,null)})),disableLayerHinting:Oe(new m(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Oe(new m(29,"disableMonospaceOptimizations",!1)),domReadOnly:Oe(new m(30,"domReadOnly",!1)),dragAndDrop:Oe(new m(31,"dragAndDrop",!0,{description:l.localize(205,null)})),emptySelectionClipboard:Oe(new M),dropIntoEditor:Oe(new We),stickyScroll:Oe(new K),extraEditorClassName:Oe(new g(34,"extraEditorClassName","")),fastScrollSensitivity:Oe(new c(35,"fastScrollSensitivity",5,re=>re<=0?5:re,{markdownDescription:l.localize(206,null)})),find:Oe(new A),fixedOverflowWidgets:Oe(new m(37,"fixedOverflowWidgets",!1)),folding:Oe(new m(38,"folding",!0,{description:l.localize(207,null)})),foldingStrategy:Oe(new u(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[l.localize(208,null),l.localize(209,null)],description:l.localize(210,null)})),foldingHighlight:Oe(new m(40,"foldingHighlight",!0,{description:l.localize(211,null)})),foldingImportsByDefault:Oe(new m(41,"foldingImportsByDefault",!1,{description:l.localize(212,null)})),foldingMaximumRegions:Oe(new h(42,"foldingMaximumRegions",5e3,10,65e3,{description:l.localize(213,null)})),unfoldOnClickAfterEndOfLine:Oe(new m(43,"unfoldOnClickAfterEndOfLine",!1,{description:l.localize(214,null)})),fontFamily:Oe(new g(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:l.localize(215,null)})),fontInfo:Oe(new H),fontLigatures2:Oe(new z),fontSize:Oe(new F),fontWeight:Oe(new G),formatOnPaste:Oe(new m(49,"formatOnPaste",!1,{description:l.localize(216,null)})),formatOnType:Oe(new m(50,"formatOnType",!1,{description:l.localize(217,null)})),glyphMargin:Oe(new m(51,"glyphMargin",!0,{description:l.localize(218,null)})),gotoLocation:Oe(new B),hideCursorInOverviewRuler:Oe(new m(53,"hideCursorInOverviewRuler",!1,{description:l.localize(219,null)})),hover:Oe(new U),inDiffEditor:Oe(new m(55,"inDiffEditor",!1)),letterSpacing:Oe(new c(57,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,re=>c.clamp(re,-5,20),{description:l.localize(220,null)})),lightbulb:Oe(new Q),lineDecorationsWidth:Oe(new p(59,"lineDecorationsWidth",10)),lineHeight:Oe(new te),lineNumbers:Oe(new oe),lineNumbersMinChars:Oe(new h(62,"lineNumbersMinChars",5,1,300)),linkedEditing:Oe(new m(63,"linkedEditing",!1,{description:l.localize(221,null)})),links:Oe(new m(64,"links",!0,{description:l.localize(222,null)})),matchBrackets:Oe(new u(65,"matchBrackets","always",["always","near","never"],{description:l.localize(223,null)})),minimap:Oe(new he),mouseStyle:Oe(new u(67,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Oe(new c(68,"mouseWheelScrollSensitivity",1,re=>re===0?1:re,{markdownDescription:l.localize(224,null)})),mouseWheelZoom:Oe(new m(69,"mouseWheelZoom",!1,{markdownDescription:l.localize(225,null)})),multiCursorMergeOverlapping:Oe(new m(70,"multiCursorMergeOverlapping",!0,{description:l.localize(226,null)})),multiCursorModifier:Oe(new s(71,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Y,{markdownEnumDescriptions:[l.localize(227,null),l.localize(228,null)],markdownDescription:l.localize(229,null)})),multiCursorPaste:Oe(new u(72,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[l.localize(230,null),l.localize(231,null)],markdownDescription:l.localize(232,null)})),occurrencesHighlight:Oe(new m(73,"occurrencesHighlight",!0,{description:l.localize(233,null)})),overviewRulerBorder:Oe(new m(74,"overviewRulerBorder",!0,{description:l.localize(234,null)})),overviewRulerLanes:Oe(new h(75,"overviewRulerLanes",3,0,3)),padding:Oe(new ve),parameterHints:Oe(new be),peekWidgetDefaultFocus:Oe(new u(78,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[l.localize(235,null),l.localize(236,null)],description:l.localize(237,null)})),definitionLinkOpensInPeek:Oe(new m(79,"definitionLinkOpensInPeek",!1,{description:l.localize(238,null)})),quickSuggestions:Oe(new Re),quickSuggestionsDelay:Oe(new h(81,"quickSuggestionsDelay",10,0,1073741824,{description:l.localize(239,null)})),readOnly:Oe(new m(82,"readOnly",!1)),renameOnType:Oe(new m(83,"renameOnType",!1,{description:l.localize(240,null),markdownDeprecationMessage:l.localize(241,null)})),renderControlCharacters:Oe(new m(84,"renderControlCharacters",!0,{description:l.localize(242,null),restricted:!0})),renderFinalNewline:Oe(new m(85,"renderFinalNewline",!0,{description:l.localize(243,null)})),renderLineHighlight:Oe(new u(86,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",l.localize(244,null)],description:l.localize(245,null)})),renderLineHighlightOnlyWhenFocus:Oe(new m(87,"renderLineHighlightOnlyWhenFocus",!1,{description:l.localize(246,null)})),renderValidationDecorations:Oe(new u(88,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Oe(new u(89,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",l.localize(247,null),l.localize(248,null),l.localize(249,null),""],description:l.localize(250,null)})),revealHorizontalRightPadding:Oe(new h(90,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Oe(new m(91,"roundedSelection",!0,{description:l.localize(251,null)})),rulers:Oe(new me),scrollbar:Oe(new ae),scrollBeyondLastColumn:Oe(new h(94,"scrollBeyondLastColumn",4,0,1073741824,{description:l.localize(252,null)})),scrollBeyondLastLine:Oe(new m(95,"scrollBeyondLastLine",!0,{description:l.localize(253,null)})),scrollPredominantAxis:Oe(new m(96,"scrollPredominantAxis",!0,{description:l.localize(254,null)})),selectionClipboard:Oe(new m(97,"selectionClipboard",!0,{description:l.localize(255,null),included:t.isLinux})),selectionHighlight:Oe(new m(98,"selectionHighlight",!0,{description:l.localize(256,null)})),selectOnLineNumbers:Oe(new m(99,"selectOnLineNumbers",!0)),showFoldingControls:Oe(new u(100,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[l.localize(257,null),l.localize(258,null),l.localize(259,null)],description:l.localize(260,null)})),showUnused:Oe(new m(101,"showUnused",!0,{description:l.localize(261,null)})),showDeprecated:Oe(new m(128,"showDeprecated",!0,{description:l.localize(262,null)})),inlayHints:Oe(new de),snippetSuggestions:Oe(new u(102,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[l.localize(263,null),l.localize(264,null),l.localize(265,null),l.localize(266,null)],description:l.localize(267,null)})),smartSelect:Oe(new ge),smoothScrolling:Oe(new m(104,"smoothScrolling",!1,{description:l.localize(268,null)})),stopRenderingLineAfter:Oe(new h(107,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Oe(new X),inlineSuggest:Oe(new ie),suggestFontSize:Oe(new h(109,"suggestFontSize",0,0,1e3,{markdownDescription:l.localize(269,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Oe(new h(110,"suggestLineHeight",0,0,1e3,{markdownDescription:l.localize(270,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Oe(new m(111,"suggestOnTriggerCharacters",!0,{description:l.localize(271,null)})),suggestSelection:Oe(new u(112,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[l.localize(272,null),l.localize(273,null),l.localize(274,null)],description:l.localize(275,null)})),tabCompletion:Oe(new u(113,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[l.localize(276,null),l.localize(277,null),l.localize(278,null)],description:l.localize(279,null)})),tabIndex:Oe(new h(114,"tabIndex",0,-1,1073741824)),unicodeHighlight:Oe(new ne),unusualLineTerminators:Oe(new u(116,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[l.localize(280,null),l.localize(281,null),l.localize(282,null)],description:l.localize(283,null)})),useShadowDOM:Oe(new m(117,"useShadowDOM",!0)),useTabStops:Oe(new m(118,"useTabStops",!0,{description:l.localize(284,null)})),wordSeparators:Oe(new g(119,"wordSeparators",C.USUAL_WORD_SEPARATORS,{description:l.localize(285,null)})),wordWrap:Oe(new u(120,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[l.localize(286,null),l.localize(287,null),l.localize(288,null),l.localize(289,null)],description:l.localize(290,null)})),wordWrapBreakAfterCharacters:Oe(new g(121,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Oe(new g(122,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Oe(new h(123,"wordWrapColumn",80,1,1073741824,{markdownDescription:l.localize(291,null)})),wordWrapOverride1:Oe(new u(124,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Oe(new u(125,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Oe(new s(126,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Ce,{enumDescriptions:[l.localize(292,null),l.localize(293,null),l.localize(294,null),l.localize(295,null)],description:l.localize(296,null)})),wrappingStrategy:Oe(new u(127,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[l.localize(297,null),l.localize(298,null)],description:l.localize(299,null)})),editorClassName:Oe(new N),pixelRatio:Oe(new ke),tabFocusMode:Oe(new we),layoutInfo:Oe(new $),wrappingInfo:Oe(new ye)}}),define(De[163],Ie([19,20]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(De[164],Ie([19,20]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(De[165],Ie([19,20]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(De[166],Ie([19,20]),function(J,e){return J.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(De[167],Ie([19,20]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(De[168],Ie([19,20]),function(J,e){return J.create("vs/platform/markers/common/markers",e)}),define(De[169],Ie([19,20]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(De[170],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(De[171],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostExtensionService",e)}),define(De[172],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostProgress",e)}),define(De[173],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostStatusBar",e)}),define(De[174],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostTerminalService",e)}),define(De[175],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostTreeViews",e)}),define(De[176],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostWorkspace",e)}),define(De[177],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/node/extHostDebugService",e)}),define(De[178],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/node/extHostTunnelService",e)}),define(De[179],Ie([19,20]),function(J,e){return J.create("vs/workbench/common/editor",e)}),define(De[180],Ie([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(De[181],Ie([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/common/debug",e)}),define(De[182],Ie([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(De[183],Ie([19,20]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(De[184],Ie([19,20]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(De[185],Ie([19,20]),function(J,e){return J.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(De[186],Ie([19,20]),function(J,e){return J.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(De[187],Ie([19,20]),function(J,e){return J.create("vs/workbench/services/search/common/queryBuilder",e)}),define(De[188],Ie([1,0,22,42,165,303]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const _=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function w(m){return m=m.trim(),m==="*"||_.test(m)}e.isValidVersionStr=w;function k(m){if(!w(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=m.match(_);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=k;function L(m){if(!m)return null;const v=m.majorBase,h=m.majorMustEqual,c=m.minorBase;let g=m.minorMustEqual;const n=m.patchBase;let u=m.patchMustEqual;m.hasCaret&&(v===0||(g=!1),u=!1);let s=0;if(m.preRelease){const i=I.exec(m.preRelease);if(i){const[,o,d,r]=i;s=Date.UTC(Number(o),Number(d)-1,Number(r))}}return{majorBase:v,majorMustEqual:h,minorBase:c,minorMustEqual:g,patchBase:n,patchMustEqual:u,isMinimum:m.hasGreaterEquals,notBefore:s}}e.normalizeVersion=L;function D(m,v,h){let c;typeof m=="string"?c=L(k(m)):c=m;let g;v instanceof Date?g=v.getTime():typeof v=="string"&&(g=new Date(v).getTime());let n;if(typeof h=="string"?n=L(k(h)):n=h,!c||!n)return!1;const u=c.majorBase,s=c.minorBase,i=c.patchBase;let o=n.majorBase,d=n.minorBase,r=n.patchBase;const a=n.notBefore;let f=n.majorMustEqual,y=n.minorMustEqual,R=n.patchMustEqual;return n.isMinimum?u>o?!0:u<o?!1:s>d?!0:s<d||g&&g<a?!1:i>=r:(u===1&&o===0&&(!f||!y||!R)&&(o=1,d=0,r=0,f=!0,y=!1,R=!1),u<o?!1:u>o?!f:s<d?!1:s>d?!y:i<r?!1:i>r?!R:!(g&&g<a))}e.isValidVersion=D;function S(m,v,h,c,g){const n=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return n.push([t.default.Error,C.localize(0,null)]),n;if(typeof c.name!="string")return n.push([t.default.Error,C.localize(1,null,"name")]),n;if(typeof c.version!="string")return n.push([t.default.Error,C.localize(2,null,"version")]),n;if(!c.engines)return n.push([t.default.Error,C.localize(3,null,"engines")]),n;if(typeof c.engines.vscode!="string")return n.push([t.default.Error,C.localize(4,null,"engines.vscode")]),n;if(typeof c.extensionDependencies<"u"&&!b(c.extensionDependencies))return n.push([t.default.Error,C.localize(5,null,"extensionDependencies")]),n;if(typeof c.activationEvents<"u"){if(!b(c.activationEvents))return n.push([t.default.Error,C.localize(6,null,"activationEvents")]),n;if(typeof c.main>"u"&&typeof c.browser>"u")return n.push([t.default.Error,C.localize(7,null,"activationEvents","main")]),n}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&n.push([t.default.Warning,C.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return n.push([t.default.Error,C.localize(9,null,"main")]),n;{const i=(0,l.joinPath)(h,c.main);(0,l.isEqualOrParent)(i,h)||n.push([t.default.Warning,C.localize(10,null,i.path,h.path)])}if(typeof c.activationEvents>"u")return n.push([t.default.Error,C.localize(11,null,"activationEvents","main")]),n}if(typeof c.browser<"u"){if(typeof c.browser!="string")return n.push([t.default.Error,C.localize(12,null,"browser")]),n;{const i=(0,l.joinPath)(h,c.browser);(0,l.isEqualOrParent)(i,h)||n.push([t.default.Warning,C.localize(13,null,i.path,h.path)])}if(typeof c.activationEvents>"u")return n.push([t.default.Error,C.localize(14,null,"activationEvents","browser")]),n}if(!P.valid(c.version))return n.push([t.default.Error,C.localize(15,null)]),n;const u=[];if(!T(m,v,c,g,u))for(const i of u)n.push([t.default.Error,i]);return n}e.validateExtensionManifest=S;function T(m,v,h,c,g){return c||typeof h.main>"u"&&typeof h.browser>"u"?!0:p(m,v,h.engines.vscode,g)}e.isValidExtensionVersion=T;function E(m,v,h){return m==="*"||p(v,h,m)}e.isEngineValid=E;function p(m,v,h,c=[]){const g=L(k(h));if(!g)return c.push(C.localize(16,null,h)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return c.push(C.localize(17,null,h)),!1}else if(!g.majorMustEqual)return c.push(C.localize(18,null,h)),!1;return D(m,v,g)?!0:(c.push(C.localize(19,null,m,h)),!1)}function b(m){if(!Array.isArray(m))return!1;for(let v=0,h=m.length;v<h;v++)if(typeof m[v]!="string")return!1;return!0}}),define(De[116],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class l{constructor(C,P=[],_=!1){this.ctor=C,this.staticArguments=P,this.supportsDelayedInstantiation=_}}e.SyncDescriptor=l}),define(De[82],Ie([1,0,116]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var C;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(C=e.InstantiationType||(e.InstantiationType={}));function P(I,w,k){w instanceof l.SyncDescriptor||(w=new l.SyncDescriptor(w,[],Boolean(k))),t.push([I,w])}e.registerSingleton=P;function _(){return t}e.getSingletonServiceDescriptors=_}),define(De[189],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class l{constructor(P,_){this.key=P,this.data=_,this.incoming=new Map,this.outgoing=new Map}}e.Node=l;class t{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(const _ of this._nodes.values())_.outgoing.size===0&&P.push(_);return P}insertEdge(P,_){const I=this.lookupOrInsertNode(P),w=this.lookupOrInsertNode(_);I.outgoing.set(w.key,w),w.incoming.set(I.key,I)}removeNode(P){const _=this._hashFn(P);this._nodes.delete(_);for(const I of this._nodes.values())I.outgoing.delete(_),I.incoming.delete(_)}lookupOrInsertNode(P){const _=this._hashFn(P);let I=this._nodes.get(_);return I||(I=new l(_,P),this._nodes.set(_,I)),I}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){const P=[];for(const[_,I]of this._nodes)P.push(`${_}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return P.join(`
`)}findCycleSlow(){for(const[P,_]of this._nodes){const I=new Set([P]),w=this._findCycle(_,I);if(w)return w}}_findCycle(P,_){for(const[I,w]of P.outgoing){if(_.has(I))return[..._,I].join(" -> ");_.add(I);const k=this._findCycle(w,_);if(k)return k;_.delete(I)}}}e.Graph=t}),define(De[3],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var l;(function(_){_.serviceIds=new Map,_.DI_TARGET="$di$target",_.DI_DEPENDENCIES="$di$dependencies";function I(w){return w[_.DI_DEPENDENCIES]||[]}_.getServiceDependencies=I})(l=e._util||(e._util={})),e.IInstantiationService=C("instantiationService");function t(_,I,w){I[l.DI_TARGET]===I?I[l.DI_DEPENDENCIES].push({id:_,index:w}):(I[l.DI_DEPENDENCIES]=[{id:_,index:w}],I[l.DI_TARGET]=I)}function C(_){if(l.serviceIds.has(_))return l.serviceIds.get(_);const I=function(w,k,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(I,w,L)};return I.toString=()=>_,l.serviceIds.set(_,I),I}e.createDecorator=C;function P(_){return _}e.refineServiceDecorator=P}),define(De[83],Ie([1,0,16,2,3]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,C.createDecorator)("configurationService");function P(m){return m&&typeof m=="object"&&(!m.overrideIdentifier||typeof m.overrideIdentifier=="string")&&(!m.resource||m.resource instanceof t.URI)}e.isConfigurationOverrides=P;function _(m){return m&&typeof m=="object"&&(!m.overrideIdentifiers||Array.isArray(m.overrideIdentifiers))&&!m.overrideIdentifier&&(!m.resource||m.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=_;var I;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.USER=2]="USER",m[m.USER_LOCAL=3]="USER_LOCAL",m[m.USER_REMOTE=4]="USER_REMOTE",m[m.WORKSPACE=5]="WORKSPACE",m[m.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",m[m.DEFAULT=7]="DEFAULT",m[m.MEMORY=8]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function w(m){switch(m){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=w;function k(m,v){const h=Object.create(null);for(const c in m)L(h,c,m[c],v);return h}e.toValuesTree=k;function L(m,v,h,c){const g=v.split("."),n=g.pop();let u=m;for(let s=0;s<g.length;s++){const i=g[s];let o=u[i];switch(typeof o){case"undefined":o=u[i]=Object.create(null);break;case"object":break;default:c(`Ignoring ${v} as ${g.slice(0,s+1).join(".")} is ${JSON.stringify(o)}`);return}u=o}if(typeof u=="object"&&u!==null)try{u[n]=h}catch{c(`Ignoring ${v} as ${g.join(".")} is ${JSON.stringify(u)}`)}else c(`Ignoring ${v} as ${g.join(".")} is ${JSON.stringify(u)}`)}e.addToValueTree=L;function D(m,v){const h=v.split(".");S(m,h)}e.removeFromValueTree=D;function S(m,v){const h=v.shift();if(v.length===0){delete m[h];return}if(Object.keys(m).indexOf(h)!==-1){const c=m[h];typeof c=="object"&&!Array.isArray(c)&&(S(c,v),Object.keys(c).length===0&&delete m[h])}}function T(m,v,h){function c(u,s){let i=u;for(const o of s){if(typeof i!="object"||i===null)return;i=i[o]}return i}const g=v.split("."),n=c(m,g);return typeof n>"u"?h:n}e.getConfigurationValue=T;function E(m,v,h){Object.keys(v).forEach(c=>{c!=="__proto__"&&(c in m?l.isObject(m[c])&&l.isObject(v[c])?E(m[c],v[c],h):h&&(m[c]=v[c]):m[c]=v[c])})}e.merge=E;function p(m,v,h){const c=m.inspect(v),g=m.inspect(h);return typeof c.userValue<"u"||typeof c.workspaceValue<"u"||typeof c.workspaceFolderValue<"u"?c.value:typeof g.userValue<"u"||typeof g.workspaceValue<"u"||typeof g.workspaceFolderValue<"u"?g.value:c.defaultValue}e.getMigratedSettingValue=p;function b(m){return m.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=b}),define(De[52],Ie([1,0,11,8,3]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",l.isMacintosh),P.set("isLinux",l.isLinux),P.set("isWindows",l.isWindows),P.set("isWeb",l.isWeb),P.set("isMacNative",l.isMacintosh&&!l.isWeb),P.set("isEdge",l.isEdge),P.set("isFirefox",l.isFirefox),P.set("isChrome",l.isChrome),P.set("isSafari",l.isSafari);const _=Object.prototype.hasOwnProperty;var I;(function(M){M[M.False=0]="False",M[M.True=1]="True",M[M.Defined=2]="Defined",M[M.Not=3]="Not",M[M.Equals=4]="Equals",M[M.NotEquals=5]="NotEquals",M[M.And=6]="And",M[M.Regex=7]="Regex",M[M.NotRegex=8]="NotRegex",M[M.Or=9]="Or",M[M.In=10]="In",M[M.NotIn=11]="NotIn",M[M.Greater=12]="Greater",M[M.GreaterEquals=13]="GreaterEquals",M[M.Smaller=14]="Smaller",M[M.SmallerEquals=15]="SmallerEquals"})(I=e.ContextKeyExprType||(e.ContextKeyExprType={}));class w{static false(){return D.INSTANCE}static true(){return S.INSTANCE}static has(A){return T.create(A)}static equals(A,z){return E.create(A,z)}static notEquals(A,z){return m.create(A,z)}static regex(A,z){return s.create(A,z)}static in(A,z){return p.create(A,z)}static notIn(A,z){return b.create(A,z)}static not(A){return v.create(A)}static and(...A){return d.create(A,null)}static or(...A){return r.create(A,null,!0)}static greater(A,z){return c.create(A,z)}static greaterEquals(A,z){return g.create(A,z)}static smaller(A,z){return n.create(A,z)}static smallerEquals(A,z){return u.create(A,z)}static deserialize(A,z=!1){if(!!A)return this._deserializeOrExpression(A,z)}static _deserializeOrExpression(A,z){const H=A.split("||");return r.create(H.map(F=>this._deserializeAndExpression(F,z)),null,!0)}static _deserializeAndExpression(A,z){const H=A.split("&&");return d.create(H.map(F=>this._deserializeOne(F,z)),null)}static _deserializeOne(A,z){if(A=A.trim(),A.indexOf("!=")>=0){const H=A.split("!=");return m.create(H[0].trim(),this._deserializeValue(H[1],z))}if(A.indexOf("==")>=0){const H=A.split("==");return E.create(H[0].trim(),this._deserializeValue(H[1],z))}if(A.indexOf("=~")>=0){const H=A.split("=~");return s.create(H[0].trim(),this._deserializeRegexValue(H[1],z))}if(A.indexOf(" not in ")>=0){const H=A.split(" not in ");return b.create(H[0].trim(),H[1].trim())}if(A.indexOf(" in ")>=0){const H=A.split(" in ");return p.create(H[0].trim(),H[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(A)){const H=A.split(">=");return g.create(H[0].trim(),H[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(A)){const H=A.split(">");return c.create(H[0].trim(),H[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(A)){const H=A.split("<=");return u.create(H[0].trim(),H[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(A)){const H=A.split("<");return n.create(H[0].trim(),H[1].trim())}return/^\!\s*/.test(A)?v.create(A.substr(1).trim()):T.create(A)}static _deserializeValue(A,z){if(A=A.trim(),A==="true")return!0;if(A==="false")return!1;const H=/^'([^']*)'$/.exec(A);return H?H[1].trim():A}static _deserializeRegexValue(A,z){if((0,t.isFalsyOrWhitespace)(A)){if(z)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const H=A.indexOf("/"),F=A.lastIndexOf("/");if(H===F||H<0){if(z)throw new Error(`bad regexp-value '${A}', missing /-enclosure`);return console.warn(`bad regexp-value '${A}', missing /-enclosure`),null}const G=A.slice(H+1,F),B=A[F+1]==="i"?"i":"";try{return new RegExp(G,B)}catch(U){if(z)throw new Error(`bad regexp-value '${A}', parse error: ${U}`);return console.warn(`bad regexp-value '${A}', parse error: ${U}`),null}}}e.ContextKeyExpr=w;function k(M,A){const z=M?M.substituteConstants():void 0,H=A?A.substituteConstants():void 0;return!z&&!H?!0:!z||!H?!1:z.equals(H)}e.expressionsAreEqualWithConstantSubstitution=k;function L(M,A){return M.cmp(A)}class D{constructor(){this.type=0}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!1}serialize(){return"false"}keys(){return[]}map(A){return this}negate(){return S.INSTANCE}}e.ContextKeyFalseExpr=D,D.INSTANCE=new D;class S{constructor(){this.type=1}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!0}serialize(){return"true"}keys(){return[]}map(A){return this}negate(){return D.INSTANCE}}e.ContextKeyTrueExpr=S,S.INSTANCE=new S;class T{static create(A,z=null){const H=P.get(A);return typeof H=="boolean"?H?S.INSTANCE:D.INSTANCE:new T(A,z)}constructor(A,z){this.key=A,this.negated=z,this.type=2}cmp(A){return A.type!==this.type?this.type-A.type:f(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=P.get(this.key);return typeof A=="boolean"?A?S.INSTANCE:D.INSTANCE:this}evaluate(A){return!!A.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(A){return A.mapDefined(this.key)}negate(){return this.negated||(this.negated=v.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=T;class E{static create(A,z,H=null){if(typeof z=="boolean")return z?T.create(A,H):v.create(A,H);const F=P.get(A);return typeof F=="boolean"?z===(F?"true":"false")?S.INSTANCE:D.INSTANCE:new E(A,z,H)}constructor(A,z,H){this.key=A,this.value=z,this.negated=H,this.type=4}cmp(A){return A.type!==this.type?this.type-A.type:y(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){const A=P.get(this.key);if(typeof A=="boolean"){const z=A?"true":"false";return this.value===z?S.INSTANCE:D.INSTANCE}return this}evaluate(A){return A.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(A){return A.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=E;class p{static create(A,z){return new p(A,z)}constructor(A,z){this.key=A,this.valueKey=z,this.type=10,this.negated=null}cmp(A){return A.type!==this.type?this.type-A.type:y(this.key,this.valueKey,A.key,A.valueKey)}equals(A){return A.type===this.type?this.key===A.key&&this.valueKey===A.valueKey:!1}substituteConstants(){return this}evaluate(A){const z=A.getValue(this.valueKey),H=A.getValue(this.key);return Array.isArray(z)?z.includes(H):typeof H=="string"&&typeof z=="object"&&z!==null?_.call(z,H):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(A){return A.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=b.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=p;class b{static create(A,z){return new b(A,z)}constructor(A,z){this.key=A,this.valueKey=z,this.type=11,this._negated=p.create(A,z)}cmp(A){return A.type!==this.type?this.type-A.type:this._negated.cmp(A._negated)}equals(A){return A.type===this.type?this._negated.equals(A._negated):!1}substituteConstants(){return this}evaluate(A){return!this._negated.evaluate(A)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(A){return A.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=b;class m{static create(A,z,H=null){if(typeof z=="boolean")return z?v.create(A,H):T.create(A,H);const F=P.get(A);return typeof F=="boolean"?z===(F?"true":"false")?D.INSTANCE:S.INSTANCE:new m(A,z,H)}constructor(A,z,H){this.key=A,this.value=z,this.negated=H,this.type=5}cmp(A){return A.type!==this.type?this.type-A.type:y(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){const A=P.get(this.key);if(typeof A=="boolean"){const z=A?"true":"false";return this.value===z?D.INSTANCE:S.INSTANCE}return this}evaluate(A){return A.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(A){return A.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=E.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=m;class v{static create(A,z=null){const H=P.get(A);return typeof H=="boolean"?H?D.INSTANCE:S.INSTANCE:new v(A,z)}constructor(A,z){this.key=A,this.negated=z,this.type=3}cmp(A){return A.type!==this.type?this.type-A.type:f(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=P.get(this.key);return typeof A=="boolean"?A?D.INSTANCE:S.INSTANCE:this}evaluate(A){return!A.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(A){return A.mapNot(this.key)}negate(){return this.negated||(this.negated=T.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=v;function h(M,A){if(typeof M=="string"){const z=parseFloat(M);isNaN(z)||(M=z)}return typeof M=="string"||typeof M=="number"?A(M):D.INSTANCE}class c{static create(A,z,H=null){return h(z,F=>new c(A,F,H))}constructor(A,z,H){this.key=A,this.value=z,this.negated=H,this.type=12}cmp(A){return A.type!==this.type?this.type-A.type:y(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(A){return A.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=c;class g{static create(A,z,H=null){return h(z,F=>new g(A,F,H))}constructor(A,z,H){this.key=A,this.value=z,this.negated=H,this.type=13}cmp(A){return A.type!==this.type?this.type-A.type:y(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(A){return A.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=g;class n{static create(A,z,H=null){return h(z,F=>new n(A,F,H))}constructor(A,z,H){this.key=A,this.value=z,this.negated=H,this.type=14}cmp(A){return A.type!==this.type?this.type-A.type:y(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(A){return A.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=n;class u{static create(A,z,H=null){return h(z,F=>new u(A,F,H))}constructor(A,z,H){this.key=A,this.value=z,this.negated=H,this.type=15}cmp(A){return A.type!==this.type?this.type-A.type:y(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(A){return A.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=u;class s{static create(A,z){return new s(A,z)}constructor(A,z){this.key=A,this.regexp=z,this.type=7,this.negated=null}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.key<A.key)return-1;if(this.key>A.key)return 1;const z=this.regexp?this.regexp.source:"",H=A.regexp?A.regexp.source:"";return z<H?-1:z>H?1:0}equals(A){if(A.type===this.type){const z=this.regexp?this.regexp.source:"",H=A.regexp?A.regexp.source:"";return this.key===A.key&&z===H}return!1}substituteConstants(){return this}evaluate(A){const z=A.getValue(this.key);return this.regexp?this.regexp.test(z):!1}serialize(){const A=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${A}`}keys(){return[this.key]}map(A){return A.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=i.create(this)),this.negated}}e.ContextKeyRegexExpr=s;class i{static create(A){return new i(A)}constructor(A){this._actual=A,this.type=8}cmp(A){return A.type!==this.type?this.type-A.type:this._actual.cmp(A._actual)}equals(A){return A.type===this.type?this._actual.equals(A._actual):!1}substituteConstants(){return this}evaluate(A){return!this._actual.evaluate(A)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(A){return new i(this._actual.map(A))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;function o(M){let A=null;for(let z=0,H=M.length;z<H;z++){const F=M[z].substituteConstants();if(M[z]!==F&&A===null){A=[];for(let G=0;G<z;G++)A[G]=M[G]}A!==null&&(A[z]=F)}return A===null?M:A}class d{static create(A,z){return d._normalizeArr(A,z)}constructor(A,z){this.expr=A,this.negated=z,this.type=6}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let z=0,H=this.expr.length;z<H;z++){const F=L(this.expr[z],A.expr[z]);if(F!==0)return F}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let z=0,H=this.expr.length;z<H;z++)if(!this.expr[z].equals(A.expr[z]))return!1;return!0}return!1}substituteConstants(){const A=o(this.expr);return A===this.expr?this:d.create(A,this.negated)}evaluate(A){for(let z=0,H=this.expr.length;z<H;z++)if(!this.expr[z].evaluate(A))return!1;return!0}static _normalizeArr(A,z){const H=[];let F=!1;for(const G of A)if(!!G){if(G.type===1){F=!0;continue}if(G.type===0)return D.INSTANCE;if(G.type===6){H.push(...G.expr);continue}H.push(G)}if(H.length===0&&F)return S.INSTANCE;if(H.length!==0){if(H.length===1)return H[0];H.sort(L);for(let G=1;G<H.length;G++)H[G-1].equals(H[G])&&(H.splice(G,1),G--);if(H.length===1)return H[0];for(;H.length>1;){const G=H[H.length-1];if(G.type!==9)break;H.pop();const B=H.pop(),U=H.length===0,x=r.create(G.expr.map($=>d.create([$,B],null)),null,U);x&&(H.push(x),H.sort(L))}return H.length===1?H[0]:new d(H,z)}}serialize(){return this.expr.map(A=>A.serialize()).join(" && ")}keys(){const A=[];for(const z of this.expr)A.push(...z.keys());return A}map(A){return new d(this.expr.map(z=>z.map(A)),null)}negate(){if(!this.negated){const A=[];for(const z of this.expr)A.push(z.negate());this.negated=r.create(A,this,!0)}return this.negated}}class r{static create(A,z,H){return r._normalizeArr(A,z,H)}constructor(A,z){this.expr=A,this.negated=z,this.type=9}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let z=0,H=this.expr.length;z<H;z++){const F=L(this.expr[z],A.expr[z]);if(F!==0)return F}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let z=0,H=this.expr.length;z<H;z++)if(!this.expr[z].equals(A.expr[z]))return!1;return!0}return!1}substituteConstants(){const A=o(this.expr);return A===this.expr?this:r.create(A,this.negated,!1)}evaluate(A){for(let z=0,H=this.expr.length;z<H;z++)if(this.expr[z].evaluate(A))return!0;return!1}static _normalizeArr(A,z,H){let F=[],G=!1;if(A){for(let B=0,U=A.length;B<U;B++){const x=A[B];if(!!x){if(x.type===0){G=!0;continue}if(x.type===1)return S.INSTANCE;if(x.type===9){F=F.concat(x.expr);continue}F.push(x)}}if(F.length===0&&G)return D.INSTANCE;F.sort(L)}if(F.length!==0){if(F.length===1)return F[0];for(let B=1;B<F.length;B++)F[B-1].equals(F[B])&&(F.splice(B,1),B--);if(F.length===1)return F[0];if(H){for(let B=0;B<F.length;B++)for(let U=B+1;U<F.length;U++)R(F[B],F[U])&&(F.splice(U,1),U--);if(F.length===1)return F[0]}return new r(F,z)}}serialize(){return this.expr.map(A=>A.serialize()).join(" || ")}keys(){const A=[];for(const z of this.expr)A.push(...z.keys());return A}map(A){return new r(this.expr.map(z=>z.map(A)),null)}negate(){if(!this.negated){const A=[];for(const z of this.expr)A.push(z.negate());for(;A.length>1;){const z=A.shift(),H=A.shift(),F=[];for(const B of N(z))for(const U of N(H))F.push(d.create([B,U],null));const G=A.length===0;A.unshift(r.create(F,null,G))}this.negated=A[0]}return this.negated}}class a extends T{static all(){return a._info.values()}constructor(A,z,H){super(A,null),this._defaultValue=z,typeof H=="object"?a._info.push({...H,key:A}):H!==!0&&a._info.push({key:A,description:H,type:z!=null?typeof z:void 0})}bindTo(A){return A.createKey(this.key,this._defaultValue)}getValue(A){return A.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(A){return E.create(this.key,A)}notEqualsTo(A){return m.create(this.key,A)}}e.RawContextKey=a,a._info=[],e.IContextKeyService=(0,C.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function f(M,A){return M<A?-1:M>A?1:0}function y(M,A,z,H){return M<z?-1:M>z?1:A<H?-1:A>H?1:0}function R(M,A){if(A.type===6&&M.type!==9&&M.type!==6){for(const F of A.expr)if(M.equals(F))return!0}const z=M.negate(),H=N(z).concat(N(A));H.sort(L);for(let F=0;F<H.length;F++){const B=H[F].negate();for(let U=F+1;U<H.length;U++){const x=H[U];if(B.equals(x))return!0}}return!1}e.implies=R;function N(M){return M.type===9?M.expr:[M]}}),define(De[190],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,l.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,l.refineServiceDecorator)(e.IEnvironmentService)}),define(De[117],Ie([1,0,164,3]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function C(m){switch(m){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=C;function P(m){switch(m){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=P;function _(m,v){switch(m){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=_;function I(m,v){return v==="web"&&!m.includes("web")}e.isNotWebExtensionInWebTargetPlatform=I;function w(m,v,h){return I(v,h)?!1:m==="undefined"||m==="universal"?!0:m==="unknown"?!1:m===h?!0:k(h).includes(m)}e.isTargetPlatformCompatible=w;function k(m){switch(m){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=k;function L(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=L;var D;(function(m){m[m.NoneOrRelevance=0]="NoneOrRelevance",m[m.LastUpdatedDate=1]="LastUpdatedDate",m[m.Title=2]="Title",m[m.PublisherName=3]="PublisherName",m[m.InstallCount=4]="InstallCount",m[m.PublishedDate=10]="PublishedDate",m[m.AverageRating=6]="AverageRating",m[m.WeightedRating=12]="WeightedRating"})(D=e.SortBy||(e.SortBy={}));var S;(function(m){m[m.Default=0]="Default",m[m.Ascending=1]="Ascending",m[m.Descending=2]="Descending"})(S=e.SortOrder||(e.SortOrder={}));var T;(function(m){m.Install="install",m.Uninstall="uninstall"})(T=e.StatisticType||(e.StatisticType={}));var E;(function(m){m[m.None=1]="None",m[m.Install=2]="Install",m[m.Update=3]="Update",m[m.Migrate=4]="Migrate"})(E=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var p;(function(m){m.Unsupported="Unsupported",m.Deprecated="Deprecated",m.Malicious="Malicious",m.Incompatible="Incompatible",m.IncompatiblePreRelease="IncompatiblePreRelease",m.IncompatibleTargetPlatform="IncompatibleTargetPlatform",m.ReleaseVersionNotFound="ReleaseVersionNotFound",m.Invalid="Invalid",m.Download="Download",m.Extract="Extract",m.Delete="Delete",m.Rename="Rename",m.CorruptZip="CorruptZip",m.IncompleteZip="IncompleteZip",m.Internal="Internal"})(p=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class b extends Error{constructor(v,h){super(v),this.code=h,this.name=h}}e.ExtensionManagementError=b,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,l.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,l.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(De[191],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,l.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,l.createDecorator)("externalTerminal")}),define(De[192],Ie([1,0,44,12,9,11,102,29,110,166,191]),function(J,e,l,t,C,P,_,I,w,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const D=k.localize(0,null);class S{async getDefaultTerminalForPlatforms(){return{windows:T.getDefaultTerminalWindows(),linux:await p.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class T extends S{openTerminal(c,g){return this.spawnTerminal(l,c,w.getWindowsShell(),g)}spawnTerminal(c,g,n,u){const s=g.windowsExec||T.getDefaultTerminalWindows();u&&u[1]===":"&&(u=u[0].toUpperCase()+u.substr(1));const i=C.basename(s).toLowerCase();if(i==="cmder"||i==="cmder.exe")return c.spawn(s,u?[u]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return s.indexOf(" ")>=0&&o.push('""'),o.push(s),(i==="wt"||i==="wt.exe")&&o.push("-d ."),new Promise((d,r)=>{const a=b(process),f=c.spawn(n,o,{cwd:u,env:a});f.on("error",r),f.on("exit",()=>d())})}runInTerminal(c,g,n,u,s){const i="windowsExec"in s&&s.windowsExec?s.windowsExec:T.getDefaultTerminalWindows();return new Promise((o,d)=>{const r=`"${g} - ${D}"`,a=`""${n.join('" "')}" & pause"`,f=["/c","start",r,"/wait",i,"/c",a],y=Object.assign({},b(process),u);Object.keys(y).filter(M=>y[M]===null).forEach(M=>delete y[M]);const R={cwd:g,env:y,windowsVerbatimArguments:!0};l.spawn(T.CMD,f,R).on("error",M=>{d(m(M))}),o(void 0)})}static getDefaultTerminalWindows(){if(!T._DEFAULT_TERMINAL_WINDOWS){const c=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");T._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${c?"Sysnative":"System32"}\\cmd.exe`}return T._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=T,T.CMD="cmd.exe";class E extends S{openTerminal(c,g){return this.spawnTerminal(l,c,g)}runInTerminal(c,g,n,u,s){const i=s.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((o,d)=>{if(i===L.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const r=i===L.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",f=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${r}.scpt`,J).fsPath,"-t",c||D,"-w",g];for(const N of n)f.push("-a"),f.push(N);if(u){const N=Object.assign({},b(process),u);for(const M in N){const A=N[M];A===null?(f.push("-u"),f.push(M)):(f.push("-e"),f.push(`${M}=${A}`))}}let y="";const R=l.spawn(E.OSASCRIPT,f);R.on("error",N=>{d(m(N))}),R.stderr.on("data",N=>{y+=N.toString()}),R.on("exit",N=>{if(N===0)o(void 0);else if(y){const M=y.split(`
`,1);d(new Error(M[0]))}else d(new Error(k.localize(1,null,r,N)))})}else d(new Error(k.localize(2,null,i)))})}spawnTerminal(c,g,n){const u=g.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((s,i)=>{const o=["-a",u];n&&o.push(n);const d=b(process),r=c.spawn("/usr/bin/open",o,{cwd:n,env:d});r.on("error",i),r.on("exit",()=>s())})}}e.MacExternalTerminalService=E,E.OSASCRIPT="/usr/bin/osascript";class p extends S{openTerminal(c,g){return this.spawnTerminal(l,c,g)}runInTerminal(c,g,n,u,s){const i=s.linuxExec?Promise.resolve(s.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((o,d)=>{const r=[];i.then(a=>{a.indexOf("gnome-terminal")>=0?r.push("-x"):r.push("-e"),r.push("bash"),r.push("-c");const f=`${v(n)}; echo; read -p "${p.WAIT_MESSAGE}" -n1;`;r.push(`''${f}''`);const y=Object.assign({},b(process),u);Object.keys(y).filter(A=>y[A]===null).forEach(A=>delete y[A]);const R={cwd:g,env:y};let N="";const M=l.spawn(a,r,R);M.on("error",A=>{d(m(A))}),M.stderr.on("data",A=>{N+=A.toString()}),M.on("exit",A=>{if(A===0)o(void 0);else if(N){const z=N.split(`
`,1);d(new Error(z[0]))}else d(new Error(k.localize(4,null,a,A)))})})})}static async getDefaultTerminalLinuxReady(){if(!p._DEFAULT_TERMINAL_LINUX_READY)if(!P.isLinux)p._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const c=await I.Promises.exists("/etc/debian_version");p._DEFAULT_TERMINAL_LINUX_READY=new Promise(g=>{c?g("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?g("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?g("konsole"):process.env.COLORTERM?g(process.env.COLORTERM):process.env.TERM?g(process.env.TERM):g("xterm")})}return p._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(c,g,n){const u=g.linuxExec?Promise.resolve(g.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((s,i)=>{u.then(o=>{const d=b(process),r=c.spawn(o,[],{cwd:n,env:d});r.on("error",i),r.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=p,p.WAIT_MESSAGE=k.localize(3,null);function b(h){const c={...h.env};return(0,_.sanitizeProcessEnvironment)(c),c}function m(h){return"errno"in h&&h.errno==="ENOENT"&&"path"in h&&typeof h.path=="string"?new Error(k.localize(5,null,h.path)):h}function v(h){let c="";for(const g of h)g.indexOf(" ")>=0?c+='"'+g+'"':c+=g,c+=" ";return c}}),define(De[37],Ie([1,0,26,9,8,16,2,167,3]),function(J,e,l,t,C,P,_,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,w.createDecorator)("fileService");function k(B){return B.create===!0}e.isFileOpenForWriteOptions=k;var L;(function(B){B[B.Unknown=0]="Unknown",B[B.File=1]="File",B[B.Directory=2]="Directory",B[B.SymbolicLink=64]="SymbolicLink"})(L=e.FileType||(e.FileType={}));var D;(function(B){B[B.Readonly=1]="Readonly"})(D=e.FilePermission||(e.FilePermission={}));var S;(function(B){B[B.FileReadWrite=2]="FileReadWrite",B[B.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",B[B.FileReadStream=16]="FileReadStream",B[B.FileFolderCopy=8]="FileFolderCopy",B[B.PathCaseSensitive=1024]="PathCaseSensitive",B[B.Readonly=2048]="Readonly",B[B.Trash=4096]="Trash",B[B.FileWriteUnlock=8192]="FileWriteUnlock",B[B.FileAtomicRead=16384]="FileAtomicRead",B[B.FileClone=32768]="FileClone"})(S=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function T(B){return!!(B.capabilities&2)}e.hasReadWriteCapability=T;function E(B){return!!(B.capabilities&8)}e.hasFileFolderCopyCapability=E;function p(B){return!!(B.capabilities&32768)}e.hasFileCloneCapability=p;function b(B){return!!(B.capabilities&4)}e.hasOpenReadWriteCloseCapability=b;function m(B){return!!(B.capabilities&16)}e.hasFileReadStreamCapability=m;function v(B){return T(B)?!!(B.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var h;(function(B){B.FileExists="EntryExists",B.FileNotFound="EntryNotFound",B.FileNotADirectory="EntryNotADirectory",B.FileIsADirectory="EntryIsADirectory",B.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",B.FileTooLarge="EntryTooLarge",B.FileWriteLocked="EntryWriteLocked",B.NoPermissions="NoPermissions",B.Unavailable="Unavailable",B.Unknown="Unknown"})(h=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class c extends Error{constructor(U,x){super(U),this.code=x}}e.FileSystemProviderError=c;function g(B,U){const x=new c(B.toString(),U);return u(x,U),x}e.createFileSystemProviderError=g;function n(B){return B||g((0,I.localize)(0,null),h.Unknown)}e.ensureFileSystemProviderError=n;function u(B,U){return B.name=U?`${U} (FileSystemError)`:"FileSystemError",B}e.markAsFileSystemProviderError=u;function s(B){if(!B)return h.Unknown;if(B instanceof c)return B.code;const U=/^(.+) \(FileSystemError\)$/.exec(B.name);if(!U)return h.Unknown;switch(U[1]){case h.FileExists:return h.FileExists;case h.FileIsADirectory:return h.FileIsADirectory;case h.FileNotADirectory:return h.FileNotADirectory;case h.FileNotFound:return h.FileNotFound;case h.FileExceedsMemoryLimit:return h.FileExceedsMemoryLimit;case h.FileTooLarge:return h.FileTooLarge;case h.FileWriteLocked:return h.FileWriteLocked;case h.NoPermissions:return h.NoPermissions;case h.Unavailable:return h.Unavailable}return h.Unknown}e.toFileSystemProviderErrorCode=s;function i(B){if(B instanceof y)return B.fileOperationResult;switch(s(B)){case h.FileNotFound:return 1;case h.FileIsADirectory:return 0;case h.FileNotADirectory:return 10;case h.FileWriteLocked:return 5;case h.NoPermissions:return 6;case h.FileExists:return 4;case h.FileExceedsMemoryLimit:return 9;case h.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var o;(function(B){B[B.CREATE=0]="CREATE",B[B.DELETE=1]="DELETE",B[B.MOVE=2]="MOVE",B[B.COPY=3]="COPY",B[B.WRITE=4]="WRITE"})(o=e.FileOperation||(e.FileOperation={}));class d{constructor(U,x,$){this.resource=U,this.operation=x,this.target=$}isOperation(U){return this.operation===U}}e.FileOperationEvent=d;var r;(function(B){B[B.UPDATED=0]="UPDATED",B[B.ADDED=1]="ADDED",B[B.DELETED=2]="DELETED"})(r=e.FileChangeType||(e.FileChangeType={}));class a{constructor(U,x){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=U;const $=new Map;for(const Q of U){const K=$.get(Q.type);switch(K?K.push([Q.resource,Q]):$.set(Q.type,[[Q.resource,Q]]),Q.type){case 1:this.rawAdded.push(Q.resource);break;case 0:this.rawUpdated.push(Q.resource);break;case 2:this.rawDeleted.push(Q.resource);break}}for(const[Q,K]of $)switch(Q){case 1:this.added=l.TernarySearchTree.forUris(()=>x),this.added.fill(K);break;case 0:this.updated=l.TernarySearchTree.forUris(()=>x),this.updated.fill(K);break;case 2:this.deleted=l.TernarySearchTree.forUris(()=>x),this.deleted.fill(K);break}}contains(U,...x){return this.doContains(U,{includeChildren:!1},...x)}affects(U,...x){return this.doContains(U,{includeChildren:!0},...x)}doContains(U,x,...$){if(!U)return!1;const Q=$.length>0;return!!((!Q||$.includes(1))&&(this.added?.get(U)||x.includeChildren&&this.added?.findSuperstr(U))||(!Q||$.includes(0))&&(this.updated?.get(U)||x.includeChildren&&this.updated?.findSuperstr(U))||(!Q||$.includes(2))&&(this.deleted?.findSubstr(U)||x.includeChildren&&this.deleted?.findSuperstr(U)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=a;function f(B,U,x){return!B||!U||B===U||U.length>B.length?!1:(U.charAt(U.length-1)!==t.sep&&(U+=t.sep),x?(0,C.startsWithIgnoreCase)(B,U):B.indexOf(U)===0)}e.isParent=f;class y extends Error{constructor(U,x,$){super(U),this.fileOperationResult=x,this.options=$}}e.FileOperationError=y;class R extends y{constructor(U,x,$){super(U,2,$),this.stat=x}}e.NotModifiedSinceFileOperationError=R;var N;(function(B){B[B.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",B[B.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",B[B.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",B[B.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",B[B.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",B[B.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",B[B.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",B[B.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",B[B.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",B[B.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",B[B.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",B[B.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(N=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var M;(function(B){B[B.FILE=0]="FILE",B[B.FOLDER=1]="FOLDER",B[B.ROOT_FOLDER=2]="ROOT_FOLDER"})(M=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function A(B){if(!(typeof B.size!="number"||typeof B.mtime!="number"))return B.mtime.toString(29)+B.size.toString(31)}e.etag=A;async function z(B,U){if(!U.hasProvider(_.URI.from({scheme:B.scheme})))return new Promise(x=>{const $=U.onDidChangeFileSystemProviderRegistrations(Q=>{Q.scheme===B.scheme&&Q.added&&($.dispose(),x())})})}e.whenProviderRegistered=z,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class H{static formatSize(U){return(0,P.isNumber)(U)||(U=0),U<H.KB?(0,I.localize)(1,null,U.toFixed(0)):U<H.MB?(0,I.localize)(2,null,(U/H.KB).toFixed(2)):U<H.GB?(0,I.localize)(3,null,(U/H.MB).toFixed(2)):U<H.TB?(0,I.localize)(4,null,(U/H.GB).toFixed(2)):(0,I.localize)(5,null,(U/H.TB).toFixed(2))}}e.ByteSize=H,H.KB=1024,H.MB=H.KB*H.KB,H.GB=H.MB*H.KB,H.TB=H.GB*H.KB;var F;(function(B){B[B.IA32=0]="IA32",B[B.OTHER=1]="OTHER"})(F=e.Arch||(e.Arch={}));function G(B){return{maxFileSize:B===0?300*H.MB:16*H.GB,maxHeapSize:B===0?700*H.MB:2*700*H.MB}}e.getPlatformLimits=G}),define(De[84],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class l{constructor(...C){this._entries=new Map;for(const[P,_]of C)this.set(P,_)}set(C,P){const _=this._entries.get(C);return this._entries.set(C,P),_}has(C){return this._entries.has(C)}get(C){return this._entries.get(C)}}e.ServiceCollection=l}),define(De[193],Ie([1,0,18,10,116,189,3,84]),function(J,e,l,t,C,P,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const w=!1;class k extends Error{constructor(E){super("cyclic dependency between services"),this.message=E.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${E.toString()}`}}class L{constructor(E=new I.ServiceCollection,p=!1,b,m=w){this._services=E,this._strict=p,this._parent=b,this._enableTracing=m,this._activeInstantiations=new Set,this._services.set(_.IInstantiationService,this),this._globalGraph=m?b?._globalGraph??new P.Graph(v=>v):void 0}createChild(E){return new L(E,this._strict,this,this._enableTracing)}invokeFunction(E,...p){const b=S.traceInvocation(this._enableTracing,E);let m=!1;try{return E({get:h=>{if(m)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(h,b);if(!c)throw new Error(`[invokeFunction] unknown service '${h}'`);return c}},...p)}finally{m=!0,b.stop()}}createInstance(E,...p){let b,m;return E instanceof C.SyncDescriptor?(b=S.traceCreation(this._enableTracing,E.ctor),m=this._createInstance(E.ctor,E.staticArguments.concat(p),b)):(b=S.traceCreation(this._enableTracing,E),m=this._createInstance(E,p,b)),b.stop(),m}_createInstance(E,p=[],b){const m=_._util.getServiceDependencies(E).sort((c,g)=>c.index-g.index),v=[];for(const c of m){const g=this._getOrCreateServiceInstance(c.id,b);g||this._throwIfStrict(`[createInstance] ${E.name} depends on UNKNOWN service ${c.id}.`,!1),v.push(g)}const h=m.length>0?m[0].index:p.length;if(p.length!==h){console.trace(`[createInstance] First service dependency of ${E.name} at position ${h+1} conflicts with ${p.length} static arguments`);const c=h-p.length;c>0?p=p.concat(new Array(c)):p=p.slice(0,h)}return Reflect.construct(E,p.concat(v))}_setServiceInstance(E,p){if(this._services.get(E)instanceof C.SyncDescriptor)this._services.set(E,p);else if(this._parent)this._parent._setServiceInstance(E,p);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(E){const p=this._services.get(E);return!p&&this._parent?this._parent._getServiceInstanceOrDescriptor(E):p}_getOrCreateServiceInstance(E,p){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(E));const b=this._getServiceInstanceOrDescriptor(E);return b instanceof C.SyncDescriptor?this._safeCreateAndCacheServiceInstance(E,b,p.branch(E,!0)):(p.branch(E,!1),b)}_safeCreateAndCacheServiceInstance(E,p,b){if(this._activeInstantiations.has(E))throw new Error(`illegal state - RECURSIVELY instantiating service '${E}'`);this._activeInstantiations.add(E);try{return this._createAndCacheServiceInstance(E,p,b)}finally{this._activeInstantiations.delete(E)}}_createAndCacheServiceInstance(E,p,b){const m=new P.Graph(c=>c.id.toString());let v=0;const h=[{id:E,desc:p,_trace:b}];for(;h.length;){const c=h.pop();if(m.lookupOrInsertNode(c),v++>1e3)throw new k(m);for(const g of _._util.getServiceDependencies(c.desc.ctor)){const n=this._getServiceInstanceOrDescriptor(g.id);if(n||this._throwIfStrict(`[createInstance] ${E} depends on ${g.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(c.id),String(g.id)),n instanceof C.SyncDescriptor){const u={id:g.id,desc:n,_trace:c._trace.branch(g.id,!0)};m.insertEdge(c,u),h.push(u)}}}for(;;){const c=m.roots();if(c.length===0){if(!m.isEmpty())throw new k(m);break}for(const{data:g}of c){if(this._getServiceInstanceOrDescriptor(g.id)instanceof C.SyncDescriptor){const u=this._createServiceInstanceWithOwner(g.id,g.desc.ctor,g.desc.staticArguments,g.desc.supportsDelayedInstantiation,g._trace);this._setServiceInstance(g.id,u)}m.removeNode(g)}}return this._getServiceInstanceOrDescriptor(E)}_createServiceInstanceWithOwner(E,p,b=[],m,v){if(this._services.get(E)instanceof C.SyncDescriptor)return this._createServiceInstance(E,p,b,m,v);if(this._parent)return this._parent._createServiceInstanceWithOwner(E,p,b,m,v);throw new Error(`illegalState - creating UNKNOWN service instance ${p.name}`)}_createServiceInstance(E,p,b=[],m,v){if(m){const h=new L(void 0,this._strict,this,this._enableTracing);h._globalGraphImplicitDependency=String(E);const c=new l.IdleValue(()=>h._createInstance(p,b,v));return new Proxy(Object.create(null),{get(g,n){if(n in g)return g[n];const u=c.value;let s=u[n];return typeof s!="function"||(s=s.bind(u),g[n]=s),s},set(g,n,u){return c.value[n]=u,!0}})}else return this._createInstance(p,b,v)}_throwIfStrict(E,p){if(p&&console.warn(E),this._strict)throw new Error(E)}}e.InstantiationService=L;var D;(function(T){T[T.Creation=0]="Creation",T[T.Invocation=1]="Invocation",T[T.Branch=2]="Branch"})(D||(D={}));class S{static traceInvocation(E,p){return E?new S(1,p.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S._None}static traceCreation(E,p){return E?new S(0,p.name):S._None}constructor(E,p){this.type=E,this.name=p,this._start=Date.now(),this._dep=[]}branch(E,p){const b=new S(2,E.toString());return this._dep.push([E,p,b]),b}stop(){const E=Date.now()-this._start;S._totals+=E;let p=!1;function b(v,h){const c=[],g=new Array(v+1).join("	");for(const[n,u,s]of h._dep)if(u&&s){p=!0,c.push(`${g}CREATES -> ${n}`);const i=b(v+1,s);i&&c.push(i)}else c.push(`${g}uses -> ${n}`);return c.join(`
`)}const m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${E.toFixed(2)}ms (grand total ${S._totals.toFixed(2)}ms)`];(E>2||p)&&S.all.add(m.join(`
`))}}e.Trace=S,S.all=new Set,S._None=new class extends S{constructor(){super(-1,null)}stop(){}branch(){return this}},S._totals=0}),define(De[13],Ie([1,0,50,4,6,11,3]),function(J,e,l,t,C,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,_.createDecorator)("logService"),e.ILoggerService=(0,_.createDecorator)("loggerService");function I(){return new Date().toISOString()}var w;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(w=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=w.Info;function k(u,s,i){switch(s){case w.Trace:u.trace(i);break;case w.Debug:u.debug(i);break;case w.Info:u.info(i);break;case w.Warning:u.warn(i);break;case w.Error:u.error(i);break;case w.Critical:u.critical(i);break;default:throw new Error("Invalid log level")}}e.log=k;function L(u){let s="";for(let i=0;i<u.length;i++){let o=u[i];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}s+=(i>0?" ":"")+o}return s}e.format=L;class D extends C.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(s){this.level!==s&&(this.level=s,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=D;class S extends D{constructor(s){super(),this.logAlways=s}checkLogLevel(s){return this.logAlways||this.getLevel()<=s}trace(s,...i){this.checkLogLevel(w.Trace)&&this.log(w.Trace,L([s,...i]))}debug(s,...i){this.checkLogLevel(w.Debug)&&this.log(w.Debug,L([s,...i]))}info(s,...i){this.checkLogLevel(w.Info)&&this.log(w.Info,L([s,...i]))}warn(s,...i){this.checkLogLevel(w.Warning)&&this.log(w.Warning,L([s,...i]))}error(s,...i){if(this.checkLogLevel(w.Error))if(s instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=s.stack,this.log(w.Error,L(o))}else this.log(w.Error,L([s,...i]))}critical(s,...i){this.checkLogLevel(w.Critical)&&this.log(w.Critical,L([s,...i]))}flush(){}}e.AbstractMessageLogger=S;class T extends D{constructor(s=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(s),this.useColors=!P.isWindows}trace(s,...i){this.getLevel()<=w.Trace&&(this.useColors?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,s,...i):console.log(`[main ${I()}]`,s,...i))}debug(s,...i){this.getLevel()<=w.Debug&&(this.useColors?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,s,...i):console.log(`[main ${I()}]`,s,...i))}info(s,...i){this.getLevel()<=w.Info&&(this.useColors?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,s,...i):console.log(`[main ${I()}]`,s,...i))}warn(s,...i){this.getLevel()<=w.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${I()}]\x1B[0m`,s,...i):console.warn(`[main ${I()}]`,s,...i))}error(s,...i){this.getLevel()<=w.Error&&(this.useColors?console.error(`\x1B[91m[main ${I()}]\x1B[0m`,s,...i):console.error(`[main ${I()}]`,s,...i))}critical(s,...i){this.getLevel()<=w.Critical&&(this.useColors?console.error(`\x1B[90m[main ${I()}]\x1B[0m`,s,...i):console.error(`[main ${I()}]`,s,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=T;class E extends D{constructor(s=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(s)}trace(s,...i){this.getLevel()<=w.Trace&&console.log("%cTRACE","color: #888",s,...i)}debug(s,...i){this.getLevel()<=w.Debug&&console.log("%cDEBUG","background: #eee; color: #888",s,...i)}info(s,...i){this.getLevel()<=w.Info&&console.log("%c INFO","color: #33f",s,...i)}warn(s,...i){this.getLevel()<=w.Warning&&console.log("%c WARN","color: #993",s,...i)}error(s,...i){this.getLevel()<=w.Error&&console.log("%c  ERR","color: #f33",s,...i)}critical(s,...i){this.getLevel()<=w.Critical&&console.log("%cCRITI","background: #f33; color: white",s,...i)}dispose(){}flush(){}}e.ConsoleLogger=E;class p extends D{constructor(s,i=e.DEFAULT_LOG_LEVEL){super(),this.adapter=s,this.setLevel(i)}trace(s,...i){this.getLevel()<=w.Trace&&this.adapter.log(w.Trace,[this.extractMessage(s),...i])}debug(s,...i){this.getLevel()<=w.Debug&&this.adapter.log(w.Debug,[this.extractMessage(s),...i])}info(s,...i){this.getLevel()<=w.Info&&this.adapter.log(w.Info,[this.extractMessage(s),...i])}warn(s,...i){this.getLevel()<=w.Warning&&this.adapter.log(w.Warning,[this.extractMessage(s),...i])}error(s,...i){this.getLevel()<=w.Error&&this.adapter.log(w.Error,[this.extractMessage(s),...i])}critical(s,...i){this.getLevel()<=w.Critical&&this.adapter.log(w.Critical,[this.extractMessage(s),...i])}extractMessage(s){return typeof s=="string"?s:(0,l.toErrorMessage)(s,this.getLevel()<=w.Trace)}dispose(){}flush(){}}e.AdapterLogger=p;class b extends D{constructor(s){super(),this.logServices=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const i of this.logServices)i.setLevel(s);super.setLevel(s)}trace(s,...i){for(const o of this.logServices)o.trace(s,...i)}debug(s,...i){for(const o of this.logServices)o.debug(s,...i)}info(s,...i){for(const o of this.logServices)o.info(s,...i)}warn(s,...i){for(const o of this.logServices)o.warn(s,...i)}error(s,...i){for(const o of this.logServices)o.error(s,...i)}critical(s,...i){for(const o of this.logServices)o.critical(s,...i)}flush(){for(const s of this.logServices)s.flush()}dispose(){for(const s of this.logServices)s.dispose()}}e.MultiplexLogService=b;class m extends C.Disposable{constructor(s){super(),this.logger=s,this._register(s)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(s){this.logger.setLevel(s)}getLevel(){return this.logger.getLevel()}trace(s,...i){this.logger.trace(s,...i)}debug(s,...i){this.logger.debug(s,...i)}info(s,...i){this.logger.info(s,...i)}warn(s,...i){this.logger.warn(s,...i)}error(s,...i){this.logger.error(s,...i)}critical(s,...i){this.logger.critical(s,...i)}flush(){this.logger.flush()}}e.LogService=m;class v extends C.Disposable{constructor(s,i){super(),this.logLevel=s,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(d=>d.setLevel(o))}))}getLogger(s){return this.loggers.get(s.toString())}createLogger(s,i){let o=this.loggers.get(s.toString());return o||(o=this.doCreateLogger(s,i?.always?w.Trace:this.logLevel,i),this.loggers.set(s.toString(),o),i?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(s=>s.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=v;class h{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(s){}getLevel(){return w.Info}trace(s,...i){}debug(s,...i){}info(s,...i){}warn(s,...i){}error(s,...i){}critical(s,...i){}dispose(){}flush(){}}e.NullLogService=h;function c(u){if(u.verbose)return w.Trace;if(typeof u.logLevel=="string"){const s=g(u.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function g(u){switch(u){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Critical;case"off":return w.Off}}e.parseLogLevel=g;function n(u){switch(u){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Critical:return"critical";case w.Off:return"off"}}e.LogLevelToString=n}),define(De[194],Ie([1,0,37,13]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function C(I,w,k,L,D){try{const S=await new Promise((E,p)=>{J(["spdlog"],E,p)});S.setFlushOn(t.LogLevel.Trace);const T=await S.createAsyncRotatingLogger(I,w,k,L);return D&&T.clearFormatters(),T}catch(S){console.error(S)}return null}function P(I,w,k){switch(w){case t.LogLevel.Trace:I.trace(k);break;case t.LogLevel.Debug:I.debug(k);break;case t.LogLevel.Info:I.info(k);break;case t.LogLevel.Warning:I.warn(k);break;case t.LogLevel.Error:I.error(k);break;case t.LogLevel.Critical:I.critical(k);break;default:throw new Error("Invalid log level")}}class _ extends t.AbstractMessageLogger{constructor(w,k,L,D,S){super(),this.buffer=[],this.setLevel(S),this._loggerCreationPromise=this._createSpdLogLogger(w,k,L,D),this._register(this.onDidChangeLogLevel(T=>{this._logger?.setLevel(T)}))}async _createSpdLogLogger(w,k,L,D){const S=L?6:1,T=30/S*l.ByteSize.MB,E=await C(w,k,T,S,D);if(E){this._logger=E,this._logger.setLevel(this.getLevel());for(const{level:p,message:b}of this.buffer)P(this._logger,p,b);this.buffer=[]}}log(w,k){this._logger?P(this._logger,w,k):this.getLevel()<=w&&this.buffer.push({level:w,message:k})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=_}),define(De[118],Ie([1,0,42,168,3]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(w){w[w.Unnecessary=1]="Unnecessary",w[w.Deprecated=2]="Deprecated"})(P=e.MarkerTag||(e.MarkerTag={}));var _;(function(w){w[w.Hint=1]="Hint",w[w.Info=2]="Info",w[w.Warning=4]="Warning",w[w.Error=8]="Error"})(_=e.MarkerSeverity||(e.MarkerSeverity={})),function(w){function k(E,p){return p-E}w.compare=k;const L=Object.create(null);L[w.Error]=(0,t.localize)(0,null),L[w.Warning]=(0,t.localize)(1,null),L[w.Info]=(0,t.localize)(2,null);function D(E){return L[E]||""}w.toString=D;function S(E){switch(E){case l.default.Error:return w.Error;case l.default.Warning:return w.Warning;case l.default.Info:return w.Info;case l.default.Ignore:return w.Hint}}w.fromSeverity=S;function T(E){switch(E){case w.Error:return l.default.Error;case w.Warning:return l.default.Warning;case w.Info:return l.default.Info;case w.Hint:return l.default.Ignore}}w.toSeverity=T}(_=e.MarkerSeverity||(e.MarkerSeverity={}));var I;(function(w){const k="";function L(S){return D(S,!0)}w.makeKey=L;function D(S,T){const E=[k];return S.source?E.push(S.source.replace("\xA6","\\\xA6")):E.push(k),S.code?typeof S.code=="string"?E.push(S.code.replace("\xA6","\\\xA6")):E.push(S.code.value.replace("\xA6","\\\xA6")):E.push(k),S.severity!==void 0&&S.severity!==null?E.push(_.toString(S.severity)):E.push(k),S.message&&T?E.push(S.message.replace("\xA6","\\\xA6")):E.push(k),S.startLineNumber!==void 0&&S.startLineNumber!==null?E.push(S.startLineNumber.toString()):E.push(k),S.startColumn!==void 0&&S.startColumn!==null?E.push(S.startColumn.toString()):E.push(k),S.endLineNumber!==void 0&&S.endLineNumber!==null?E.push(S.endLineNumber.toString()):E.push(k),S.endColumn!==void 0&&S.endColumn!==null?E.push(S.endColumn.toString()):E.push(k),E.push(k),E.join("\xA6")}w.makeKeyOptionalMessage=D})(I=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,C.createDecorator)("markerService")}),define(De[195],Ie([1,0,4,42,3]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,C.createDecorator)("notificationService");var P;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.PROFILE=1]="PROFILE",k[k.APPLICATION=2]="APPLICATION"})(P=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var _;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(_=e.NotificationsFilter||(e.NotificationsFilter={}));class I{constructor(){this.progress=new w,this.onDidClose=l.Event.None,this.onDidChangeVisibility=l.Event.None}updateSeverity(L){}updateMessage(L){}updateActions(L){}close(){}}e.NoOpNotification=I;class w{infinite(){}done(){}total(L){}worked(L){}}e.NoOpProgress=w}),define(De[119],Ie([1,0,6,8,2,3]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,P.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return l.Disposable.None},registerValidator(){return l.Disposable.None},registerExternalUriResolver(){return l.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return l.Disposable.None},async open(){return!1},async resolveExternalUri(L){return{resolved:L,dispose(){}}}});function _(L,D){return C.URI.isUri(L)?(0,t.equalsIgnoreCase)(L.scheme,D):(0,t.startsWithIgnoreCase)(L,D+":")}e.matchesScheme=_;function I(L,...D){return D.some(S=>_(L,S))}e.matchesSomeScheme=I;function w(L,D){return L.with({fragment:`${D.startLineNumber},${D.startColumn}${D.endLineNumber?`-${D.endLineNumber}${D.endColumn?`,${D.endColumn}`:""}`:""}`})}e.withSelection=w;function k(L){let D;const S=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(L.fragment);return S&&(D={startLineNumber:parseInt(S[1]),startColumn:S[2]?parseInt(S[2]):1,endLineNumber:S[4]?parseInt(S[4]):void 0,endColumn:S[4]?S[5]?parseInt(S[5]):1:void 0},L=L.with({fragment:""})),{selection:D,uri:L}}e.extractSelection=k}),define(De[196],Ie([1,0,12,11,41,22]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let _;if(typeof t.globals.vscode<"u"&&typeof t.globals.vscode.context<"u"){const I=t.globals.vscode.context.configuration();if(I)_=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const I=(0,P.dirname)(l.FileAccess.asFileUri("",J));if(_=J.__$__nodeRequire((0,P.joinPath)(I,"product.json").fsPath),C.env.VSCODE_DEV&&Object.assign(_,{nameShort:`${_.nameShort} Dev`,nameLong:`${_.nameLong} Dev`,dataFolderName:`${_.dataFolderName}-dev`,serverDataFolderName:_.serverDataFolderName?`${_.serverDataFolderName}-dev`:void 0}),!_.version){const w=J.__$__nodeRequire((0,P.joinPath)(I,"package.json").fsPath);Object.assign(_,{version:w.version})}}else _={},Object.keys(_).length===0&&Object.assign(_,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=_}),define(De[197],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,l.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var $e=this&&this.__param||function(J,e){return function(l,t){e(l,t,J)}};define(De[120],Ie([1,0,18,21,6,3]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,P.createDecorator)("progressService");var _;(function(L){L[L.Explorer=1]="Explorer",L[L.Scm=3]="Scm",L[L.Extensions=5]="Extensions",L[L.Window=10]="Window",L[L.Notification=15]="Notification",L[L.Dialog=20]="Dialog"})(_=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class I{get value(){return this._value}constructor(D){this.callback=D}report(D){this._value=D,this.callback(this._value)}}e.Progress=I,I.None=Object.freeze({report(){}});let w=class extends C.Disposable{constructor(D,S){super(),this.deferred=new l.DeferredPromise,S.withProgress(D,T=>(this.reporter=T,this.lastStep&&T.report(this.lastStep),this.deferred.p)),this._register((0,C.toDisposable)(()=>this.deferred.complete()))}report(D){this.reporter?this.reporter.report(D):this.lastStep=D}};w=je([$e(1,e.IProgressService)],w),e.UnmanagedProgress=w;class k extends C.Disposable{constructor(D){super(),this.progressIndicator=D,this.currentOperationId=0,this.currentOperationDisposables=this._register(new C.DisposableStore)}start(D){this.stop();const S=++this.currentOperationId,T=new t.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{S===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},D),this.currentOperationDisposables.add((0,C.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,C.toDisposable)(()=>T.cancel())),this.currentOperationDisposables.add((0,C.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:S,token:T.token,stop:()=>this.doStop(S),isCurrent:()=>this.currentOperationId===S}}stop(){this.doStop(this.currentOperationId)}doStop(D){this.currentOperationId===D&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,P.createDecorator)("editorProgressService")}),define(De[43],Ie([1,0,48,16]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class C{constructor(){this.data=new Map}add(_,I){l.ok(t.isString(_)),l.ok(t.isObject(I)),l.ok(!this.data.has(_),"There is already an extension with this id"),this.data.set(_,I)}knows(_){return this.data.has(_)}as(_){return this.data.get(_)||null}}e.Registry=new C}),define(De[121],Ie([1,0,4,43]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function C(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class P{constructor(){this._onDidChangeSchema=new l.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(w,k){this.schemasById[C(w)]=k,this._onDidChangeSchema.fire(w)}notifySchemaChanged(w){this._onDidChangeSchema.fire(w)}getSchemaContributions(){return{schemas:this.schemasById}}}const _=new P;t.Registry.add(e.Extensions.JSONContribution,_)}),define(De[122],Ie([1,0,17,4,16,163,83,121,43]),function(J,e,l,t,C,P,_,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var k;(function(g){g.Multiline="multilineText",g.Singleline="singlelineText"})(k=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var L;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const D=w.Registry.as(I.Extensions.JSONContribution);class S{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(n,u=!0){this.registerConfigurations([n],u)}registerConfigurations(n,u=!0){const s=this.doRegisterConfigurations(n,u);D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}deregisterConfigurations(n){const u=this.doDeregisterConfigurations(n);D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u})}updateConfigurations({add:n,remove:u}){const s=[];s.push(...this.doDeregisterConfigurations(u)),s.push(...this.doRegisterConfigurations(n,!1)),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,l.distinct)(s)})}registerDefaultConfigurations(n){const u=[],s=[];for(const{overrides:i,source:o}of n)for(const d in i)if(u.push(d),e.OVERRIDE_PROPERTY_REGEX.test(d)){const r=this.configurationDefaultsOverrides.get(d),a=r?.valuesSources??new Map;if(o)for(const N of Object.keys(i[d]))a.set(N,o);const f={...r?.value||{},...i[d]};this.configurationDefaultsOverrides.set(d,{source:o,value:f,valuesSources:a});const y=(0,_.getLanguageTagSettingPlainKey)(d),R={type:"object",default:f,description:P.localize(1,null,y),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:f,source:C.isString(o)?void 0:o,defaultValueSource:o};s.push(...p(d)),this.configurationProperties[d]=R,this.defaultLanguageConfigurationOverridesNode.properties[d]=R}else{this.configurationDefaultsOverrides.set(d,{value:i[d],source:o});const r=this.configurationProperties[d];r&&(this.updatePropertyDefaultValue(d,r),this.updateSchema(d,r))}this.registerOverrideIdentifiers(s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}deregisterDefaultConfigurations(n){const u=[];for(const{overrides:s,source:i}of n)for(const o in s){const d=this.configurationDefaultsOverrides.get(o),r=C.isString(i)?i:i?.id,a=C.isString(d?.source)?d?.source:d?.source?.id;if(r===a)if(u.push(o),this.configurationDefaultsOverrides.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const f=this.configurationProperties[o];f&&(this.updatePropertyDefaultValue(o,f),this.updateSchema(o,f))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...n){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(n){for(const u of n)this.overrideIdentifiers.add(u);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(n,u){const s=[];return n.forEach(i=>{s.push(...this.validateAndRegisterProperties(i,u,i.extensionInfo,i.restrictedProperties)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),s}doDeregisterConfigurations(n){const u=[],s=i=>{if(i.properties)for(const o in i.properties){u.push(o);const d=this.configurationProperties[o];d?.policy?.name&&this.policyConfigurations.delete(d.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,i.properties[o])}i.allOf?.forEach(o=>s(o))};for(const i of n){s(i);const o=this.configurationContributors.indexOf(i);o!==-1&&this.configurationContributors.splice(o,1)}return u}validateAndRegisterProperties(n,u=!0,s,i,o=3){o=C.isUndefinedOrNull(n.scope)?o:n.scope;const d=[],r=n.properties;if(r)for(const f in r){const y=r[f];if(u&&h(f,y)){delete r[f];continue}if(y.source=s,y.defaultDefaultValue=r[f].default,this.updatePropertyDefaultValue(f,y),e.OVERRIDE_PROPERTY_REGEX.test(f)?y.scope=void 0:(y.scope=C.isUndefinedOrNull(y.scope)?o:y.scope,y.restricted=C.isUndefinedOrNull(y.restricted)?!!i?.includes(f):y.restricted),r[f].hasOwnProperty("included")&&!r[f].included){this.excludedConfigurationProperties[f]=r[f],delete r[f];continue}else this.configurationProperties[f]=r[f],r[f].policy?.name&&this.policyConfigurations.set(r[f].policy.name,f);!r[f].deprecationMessage&&r[f].markdownDeprecationMessage&&(r[f].deprecationMessage=r[f].markdownDeprecationMessage),d.push(f)}const a=n.allOf;if(a)for(const f of a)d.push(...this.validateAndRegisterProperties(f,u,s,i,o));return d}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(n){const u=s=>{const i=s.properties;if(i)for(const d in i)this.updateSchema(d,i[d]);s.allOf?.forEach(u)};u(n)}updateSchema(n,u){switch(e.allSettings.properties[n]=u,u.scope){case 1:e.applicationSettings.properties[n]=u;break;case 2:e.machineSettings.properties[n]=u;break;case 6:e.machineOverridableSettings.properties[n]=u;break;case 3:e.windowSettings.properties[n]=u;break;case 4:e.resourceSettings.properties[n]=u;break;case 5:e.resourceSettings.properties[n]=u,this.resourceLanguageSettingsSchema.properties[n]=u;break}}removeFromSchema(n,u){switch(delete e.allSettings.properties[n],u.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.resourceLanguageSettingsSchema.properties[n];break}}updateOverridePropertyPatternKey(){for(const n of this.overrideIdentifiers.values()){const u=`[${n}]`,s={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(u,s),e.allSettings.properties[u]=s,e.applicationSettings.properties[u]=s,e.machineSettings.properties[u]=s,e.machineOverridableSettings.properties[u]=s,e.windowSettings.properties[u]=s,e.resourceSettings.properties[u]=s}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const n={type:"object",description:P.localize(4,null),errorMessage:P.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(n,u){const s=this.configurationDefaultsOverrides.get(n);let i=s?.value,o=s?.source;C.isUndefined(i)&&(i=u.defaultDefaultValue,o=void 0),C.isUndefined(i)&&(i=m(u.type)),u.default=i,u.defaultValueSource=o}}const T="\\[([^\\]]+)\\]",E=new RegExp(T,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${T})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function p(g){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(g)){let u=E.exec(g);for(;u?.length;){const s=u[1].trim();s&&n.push(s),u=E.exec(g)}}return(0,l.distinct)(n)}e.overrideIdentifiersFromKey=p;function b(g){return g.reduce((n,u)=>`${n}[${u}]`,"")}e.keyFromOverrideIdentifiers=b;function m(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const v=new S;w.Registry.add(e.Extensions.Configuration,v);function h(g,n){return g.trim()?e.OVERRIDE_PROPERTY_REGEX.test(g)?P.localize(7,null,g):v.getConfigurationProperties()[g]!==void 0?P.localize(8,null,g):n.policy?.name&&v.getPolicyConfigurations().get(n.policy?.name)!==void 0?P.localize(9,null,g,n.policy?.name,v.getPolicyConfigurations().get(n.policy?.name)):null:P.localize(6,null)}e.validateProperty=h;function c(){const g=[],n=v.getConfigurationProperties();for(const u of Object.keys(n))g.push([u,n[u].scope]);return g.push(["launch",4]),g.push(["task",4]),g}e.getScopes=c}),define(De[198],Ie([1,0,17,4,144,6,26,24,16,2,83,122,43]),function(J,e,l,t,C,P,_,I,w,k,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class T{constructor(n={},u=[],s=[],i){this._contents=n,this._keys=u,this._overrides=s,this.raw=i,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const n=this.raw.map(u=>{if(u instanceof T)return u;const s=new E("");return s.parseRaw(u),s.configurationModel});this._rawConfiguration=n.reduce((u,s)=>s===u?s:u.merge(s),n[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(n){return n?(0,L.getConfigurationValue)(this.contents,n):this.contents}inspect(n,u){const s=this.rawConfiguration.getValue(n),i=u?this.rawConfiguration.getOverrideValue(n,u):void 0,o=u?this.rawConfiguration.override(u).getValue(n):s;return{value:s,override:i,merged:o}}getOverrideValue(n,u){const s=this.getContentsForOverrideIdentifer(u);return s?n?(0,L.getConfigurationValue)(s,n):s:void 0}getKeysForOverrideIdentifier(n){const u=[];for(const s of this.overrides)s.identifiers.includes(n)&&u.push(...s.keys);return l.distinct(u)}getAllOverrideIdentifiers(){const n=[];for(const u of this.overrides)n.push(...u.identifiers);return l.distinct(n)}override(n){let u=this.overrideConfigurations.get(n);return u||(u=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,u)),u}merge(...n){const u=I.deepClone(this.contents),s=I.deepClone(this.overrides),i=[...this.keys],o=this.raw?.length?[...this.raw]:[this];for(const d of n)if(o.push(...d.raw?.length?d.raw:[d]),!d.isEmpty()){this.mergeContents(u,d.contents);for(const r of d.overrides){const[a]=s.filter(f=>l.equals(f.identifiers,r.identifiers));a?(this.mergeContents(a.contents,r.contents),a.keys.push(...r.keys),a.keys=l.distinct(a.keys)):s.push(I.deepClone(r))}for(const r of d.keys)i.indexOf(r)===-1&&i.push(r)}return new T(u,i,s,o.every(d=>d instanceof T)?void 0:o)}freeze(){return this.frozen=!0,this}clone(){return new T(I.deepClone(this.contents),[...this.keys],I.deepClone(this.overrides))}createOverrideConfigurationModel(n){const u=this.getContentsForOverrideIdentifer(n);if(!u||typeof u!="object"||!Object.keys(u).length)return this;const s={};for(const i of l.distinct([...Object.keys(this.contents),...Object.keys(u)])){let o=this.contents[i];const d=u[i];d&&(typeof o=="object"&&typeof d=="object"?(o=I.deepClone(o),this.mergeContents(o,d)):o=d),s[i]=o}return new T(s,this.keys,this.overrides)}mergeContents(n,u){for(const s of Object.keys(u)){if(s in n&&w.isObject(n[s])&&w.isObject(u[s])){this.mergeContents(n[s],u[s]);continue}n[s]=I.deepClone(u[s])}}checkAndFreeze(n){return this.frozen&&!Object.isFrozen(n)?I.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let u=null,s=null;const i=o=>{o&&(s?this.mergeContents(s,o):s=I.deepClone(o))};for(const o of this.overrides)l.equals(o.identifiers,[n])?u=o.contents:o.identifiers.includes(n)&&i(o.contents);return i(u),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,u){this.addKey(n),(0,L.addToValueTree)(this.contents,n,u,s=>{throw new Error(s)})}removeValue(n){this.removeKey(n)&&(0,L.removeFromValueTree)(this.contents,n)}addKey(n){let u=this.keys.length;for(let s=0;s<u;s++)n.indexOf(this.keys[s])===0&&(u=s);this.keys.splice(u,1,n)}removeKey(n){const u=this.keys.indexOf(n);return u!==-1?(this.keys.splice(u,1),!0):!1}}e.ConfigurationModel=T;class E{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new T}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,u){if(!w.isUndefinedOrNull(n)){const s=this.doParseContent(n);this.parseRaw(s,u)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,u){this._raw=n;const{contents:s,keys:i,overrides:o,restricted:d,hasExcludedProperties:r}=this.doParseRaw(n,u);this._configurationModel=new T(s,i,o,r?[n]:void 0),this._restrictedConfigurations=d||[]}doParseContent(n){let u={},s=null,i=[];const o=[],d=[];function r(f){Array.isArray(i)?i.push(f):s!==null&&(i[s]=f)}const a={onObjectBegin:()=>{const f={};r(f),o.push(i),i=f,s=null},onObjectProperty:f=>{s=f},onObjectEnd:()=>{i=o.pop()},onArrayBegin:()=>{const f=[];r(f),o.push(i),i=f,s=null},onArrayEnd:()=>{i=o.pop()},onLiteralValue:r,onError:(f,y,R)=>{d.push({error:f,offset:y,length:R})}};if(n)try{C.visit(n,a),u=i[0]||{}}catch(f){console.error(`Error while parsing settings file ${this._name}: ${f}`),this._parseErrors=[f]}return u}doParseRaw(n,u){const s=S.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),i=this.filter(n,s,!0,u);n=i.raw;const o=(0,L.toValuesTree)(n,a=>console.error(`Conflict in settings file ${this._name}: ${a}`)),d=Object.keys(n),r=this.toOverrides(n,a=>console.error(`Conflict in settings file ${this._name}: ${a}`));return{contents:o,keys:d,overrides:r,restricted:i.restricted,hasExcludedProperties:i.hasExcludedProperties}}filter(n,u,s,i){let o=!1;if(!i?.scopes&&!i?.skipRestricted)return{raw:n,restricted:[],hasExcludedProperties:o};const d={},r=[];for(const a in n)if(D.OVERRIDE_PROPERTY_REGEX.test(a)&&s){const f=this.filter(n[a],u,!1,i);d[a]=f.raw,o=o||f.hasExcludedProperties,r.push(...f.restricted)}else{const f=u[a],y=f?typeof f.scope<"u"?f.scope:3:void 0;f?.restricted&&r.push(a),(y===void 0||i.scopes===void 0||i.scopes.includes(y))&&!(i.skipRestricted&&f?.restricted)?d[a]=n[a]:o=!0}return{raw:d,restricted:r,hasExcludedProperties:o}}toOverrides(n,u){const s=[];for(const i of Object.keys(n))if(D.OVERRIDE_PROPERTY_REGEX.test(i)){const o={};for(const d in n[i])o[d]=n[i][d];s.push({identifiers:(0,D.overrideIdentifiersFromKey)(i),keys:Object.keys(o),contents:(0,L.toValuesTree)(o,u)})}return s}}e.ConfigurationModelParser=E;class p extends P.Disposable{constructor(n,u,s,i){super(),this.userSettingsResource=n,this.scopes=u,this.fileService=i,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new E(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&s.isEqual(o.resource,n)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new T}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class b{constructor(n,u,s,i,o=new T,d=new T,r=new _.ResourceMap,a=new T,f=new _.ResourceMap,y=!0){this._defaultConfiguration=n,this._policyConfiguration=u,this._applicationConfiguration=s,this._localUserConfiguration=i,this._remoteUserConfiguration=o,this._workspaceConfiguration=d,this._folderConfigurations=r,this._memoryConfiguration=a,this._memoryConfigurationByResource=f,this._freeze=y,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new _.ResourceMap,this._userConfiguration=null}getValue(n,u,s){return this.getConsolidatedConfigurationModel(n,u,s).getValue(n)}updateValue(n,u,s={}){let i;s.resource?(i=this._memoryConfigurationByResource.get(s.resource),i||(i=new T,this._memoryConfigurationByResource.set(s.resource,i))):i=this._memoryConfiguration,u===void 0?i.removeValue(n):i.setValue(n,u),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,u,s){const i=this.getConsolidatedConfigurationModel(n,u,s),o=this.getFolderConfigurationModelForResource(u.resource,s),d=u.resource?this._memoryConfigurationByResource.get(u.resource)||this._memoryConfiguration:this._memoryConfiguration,r=this._defaultConfiguration.inspect(n,u.overrideIdentifier),a=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().inspect(n),f=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().inspect(n),y=this.userConfiguration.freeze().inspect(n,u.overrideIdentifier),R=this.localUserConfiguration.freeze().inspect(n,u.overrideIdentifier),N=this.remoteUserConfiguration.freeze().inspect(n,u.overrideIdentifier),M=s?this._workspaceConfiguration.freeze().inspect(n,u.overrideIdentifier):void 0,A=o?o.freeze().inspect(n,u.overrideIdentifier):void 0,z=d.inspect(n,u.overrideIdentifier),H=i.getValue(n),F=l.distinct(i.overrides.map(G=>G.identifiers).flat()).filter(G=>i.getOverrideValue(n,G)!==void 0);return{defaultValue:r?r.merged:void 0,policyValue:a?a.merged:void 0,applicationValue:f?f.merged:void 0,userValue:y?y.merged:void 0,userLocalValue:R?R.merged:void 0,userRemoteValue:N?N.merged:void 0,workspaceValue:M?M.merged:void 0,workspaceFolderValue:A?A.merged:void 0,memoryValue:z?z.merged:void 0,value:H,default:r.value!==void 0||r.override!==void 0?{value:r.value,override:r.override}:void 0,policy:a?.value!==void 0?{value:a.value}:void 0,application:f?.value!==void 0||f?.override!==void 0?{value:f.value,override:f.override}:void 0,user:y.value!==void 0||y.override!==void 0?{value:y.value,override:y.override}:void 0,userLocal:R.value!==void 0||R.override!==void 0?{value:R.value,override:R.override}:void 0,userRemote:N.value!==void 0||N.override!==void 0?{value:N.value,override:N.override}:void 0,workspace:M?.value!==void 0||M?.override!==void 0?{value:M.value,override:M.override}:void 0,workspaceFolder:A?.value!==void 0||A?.override!==void 0?{value:A.value,override:A.override}:void 0,memory:z.value!==void 0||z.override!==void 0?{value:z.value,override:z.override}:void 0,overrideIdentifiers:F.length?F:void 0}}keys(n){const u=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:u?u.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(n){this._policyConfiguration=n}updateApplicationConfiguration(n){this._applicationConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,u){this._folderConfigurations.set(n,u),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,u){const s=[];if(!u){const{added:i,updated:o,removed:d}=h(this._defaultConfiguration,n);u=[...i,...o,...d]}for(const i of u)for(const o of(0,D.overrideIdentifiersFromKey)(i)){const d=this._defaultConfiguration.getKeysForOverrideIdentifier(o),r=n.getKeysForOverrideIdentifier(o),a=[...r.filter(f=>d.indexOf(f)===-1),...d.filter(f=>r.indexOf(f)===-1),...d.filter(f=>!I.equals(this._defaultConfiguration.override(o).getValue(f),n.override(o).getValue(f)))];s.push([o,a])}return this.updateDefaultConfiguration(n),{keys:u,overrides:s}}compareAndUpdatePolicyConfiguration(n){const{added:u,updated:s,removed:i}=h(this._policyConfiguration,n),o=[...u,...s,...i];return o.length&&this.updatePolicyConfiguration(n),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:u,updated:s,removed:i,overrides:o}=h(this.applicationConfiguration,n),d=[...u,...s,...i];return d.length&&this.updateApplicationConfiguration(n),{keys:d,overrides:o}}compareAndUpdateLocalUserConfiguration(n){const{added:u,updated:s,removed:i,overrides:o}=h(this.localUserConfiguration,n),d=[...u,...s,...i];return d.length&&this.updateLocalUserConfiguration(n),{keys:d,overrides:o}}compareAndUpdateRemoteUserConfiguration(n){const{added:u,updated:s,removed:i,overrides:o}=h(this.remoteUserConfiguration,n),d=[...u,...s,...i];return d.length&&this.updateRemoteUserConfiguration(n),{keys:d,overrides:o}}compareAndUpdateWorkspaceConfiguration(n){const{added:u,updated:s,removed:i,overrides:o}=h(this.workspaceConfiguration,n),d=[...u,...s,...i];return d.length&&this.updateWorkspaceConfiguration(n),{keys:d,overrides:o}}compareAndUpdateFolderConfiguration(n,u){const s=this.folderConfigurations.get(n),{added:i,updated:o,removed:d,overrides:r}=h(s,u),a=[...i,...o,...d];return(a.length||!s)&&this.updateFolderConfiguration(n,u),{keys:a,overrides:r}}compareAndDeleteFolderConfiguration(n){const u=this.folderConfigurations.get(n);if(!u)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:s,updated:i,removed:o,overrides:d}=h(u,void 0);return{keys:[...s,...i,...o],overrides:d}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(n,u,s){let i=this.getConsolidatedConfigurationModelForResource(u,s);return u.overrideIdentifier&&(i=i.override(u.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(n)!==void 0&&(i=i.merge(this._policyConfiguration)),i}getConsolidatedConfigurationModelForResource({resource:n},u){let s=this.getWorkspaceConsolidatedConfiguration();if(u&&n){const i=u.getFolder(n);i&&(s=this.getFolderConsolidatedConfiguration(i.uri)||s);const o=this._memoryConfigurationByResource.get(n);o&&(s=s.merge(o))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let u=this._foldersConsolidatedConfigurations.get(n);if(!u){const s=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(n);i?(u=s.merge(i),this._freeze&&(u=u.freeze()),this._foldersConsolidatedConfigurations.set(n,u)):u=s}return u}getFolderConfigurationModelForResource(n,u){if(u&&n){const s=u.getFolder(n);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,u)=>{const{contents:s,overrides:i,keys:o}=this._folderConfigurations.get(u);return n.push([u,{contents:s,overrides:i,keys:o}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(u=>n.add(u)),this.userConfiguration.freeze().keys.forEach(u=>n.add(u)),this._workspaceConfiguration.freeze().keys.forEach(u=>n.add(u)),this._folderConfigurations.forEach(u=>u.freeze().keys.forEach(s=>n.add(s))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(u=>n.add(u)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(u=>n.add(u)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(u=>n.add(u)),this._folderConfigurations.forEach(u=>u.freeze().getAllOverrideIdentifiers().forEach(s=>n.add(s))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const u=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>u.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>u.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>u.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(n).forEach(i=>u.add(i))),[...u.values()]}static parse(n){const u=this.parseConfigurationModel(n.defaults),s=this.parseConfigurationModel(n.policy),i=this.parseConfigurationModel(n.application),o=this.parseConfigurationModel(n.user),d=this.parseConfigurationModel(n.workspace),r=n.folders.reduce((a,f)=>(a.set(k.URI.revive(f[0]),this.parseConfigurationModel(f[1])),a),new _.ResourceMap);return new b(u,s,i,o,new T,d,r,new T,new _.ResourceMap,!1)}static parseConfigurationModel(n){return new T(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=b;function m(...g){if(g.length===0)return{keys:[],overrides:[]};if(g.length===1)return g[0];const n=new Set,u=new Map;for(const i of g)i.keys.forEach(o=>n.add(o)),i.overrides.forEach(([o,d])=>{const r=(0,_.getOrSet)(u,o,new Set);d.forEach(a=>r.add(a))});const s=[];return u.forEach((i,o)=>s.push([o,[...i.values()]])),{keys:[...n.values()],overrides:s}}e.mergeChanges=m;class v{constructor(n,u,s,i){this.change=n,this.previous=u,this.currentConfiguraiton=s,this.currentWorkspace=i,this._previousConfiguration=void 0;const o=new Set;n.keys.forEach(r=>o.add(r)),n.overrides.forEach(([,r])=>r.forEach(a=>o.add(a))),this.affectedKeys=[...o.values()];const d=new T;this.affectedKeys.forEach(r=>d.setValue(r,{})),this.affectedKeysTree=d.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,u){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(u){const s=this.previousConfiguration?this.previousConfiguration.getValue(n,u,this.previous?.workspace):void 0,i=this.currentConfiguraiton.getValue(n,u,this.currentWorkspace);return!I.equals(s,i)}return!0}return!1}doesAffectedKeysTreeContains(n,u){let s=(0,L.toValuesTree)({[u]:!0},()=>{}),i;for(;typeof s=="object"&&(i=Object.keys(s)[0]);){if(n=n[i],!n)return!1;s=s[i]}return!0}}e.ConfigurationChangeEvent=v;function h(g,n){const{added:u,removed:s,updated:i}=c(n,g),o=[],d=g?.getAllOverrideIdentifiers()||[],r=n?.getAllOverrideIdentifiers()||[];if(n){const a=r.filter(f=>!d.includes(f));for(const f of a)o.push([f,n.getKeysForOverrideIdentifier(f)])}if(g){const a=d.filter(f=>!r.includes(f));for(const f of a)o.push([f,g.getKeysForOverrideIdentifier(f)])}if(n&&g){for(const a of d)if(r.includes(a)){const f=c({contents:g.getOverrideValue(void 0,a)||{},keys:g.getKeysForOverrideIdentifier(a)},{contents:n.getOverrideValue(void 0,a)||{},keys:n.getKeysForOverrideIdentifier(a)});o.push([a,[...f.added,...f.removed,...f.updated]])}}return{added:u,removed:s,updated:i,overrides:o}}function c(g,n){const u=g?n?g.keys.filter(o=>n.keys.indexOf(o)===-1):[...g.keys]:[],s=n?g?n.keys.filter(o=>g.keys.indexOf(o)===-1):[...n.keys]:[],i=[];if(g&&n){for(const o of n.keys)if(g.keys.indexOf(o)!==-1){const d=(0,L.getConfigurationValue)(n.contents,o),r=(0,L.getConfigurationValue)(g.contents,o);I.equals(d,r)||i.push(o)}}return{added:u,removed:s,updated:i}}}),define(De[123],Ie([1,0,10,3]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var C;(function(_){_.Unknown="Unknown",_.NotAvailable="NotAvailable",_.TemporarilyNotAvailable="TemporarilyNotAvailable",_.NoResolverFound="NoResolverFound"})(C=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class P extends l.ErrorNoTelemetry{static isTemporarilyNotAvailable(I){return I instanceof P&&I._code===C.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof P&&I._code===C.NoResolverFound}static isHandled(I){return I instanceof P&&I.isHandled}constructor(I,w=C.Unknown,k){super(I),this._message=I,this._code=w,this._detail=k,this.isHandled=w===C.NotAvailable&&k===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,P.prototype)}}e.RemoteAuthorityResolverError=P}),define(De[124],Ie([1,0,12]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(k){return k.scheme===l.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=t;function C(k){if(!k)return;const L=k.indexOf("+");return L<0?k:k.substr(0,L)}e.getRemoteName=C;function P(k){return`/${k.quality??"oss"}-${k.commit??"dev"}`}e.getRemoteServerRootPath=P;function _(k){const{host:L,port:D}=w(k);if(typeof D>"u")throw new Error("Remote authority doesn't contain a port!");return{host:L,port:D}}e.parseAuthorityWithPort=_;function I(k,L){let{host:D,port:S}=w(k);return typeof S>"u"&&(S=L),{host:D,port:S}}e.parseAuthorityWithOptionalPort=I;function w(k){const L=k.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(L)return{host:L[1],port:parseInt(L[2],10)};const D=k.match(/^(\[[0-9a-z:]+\])$/);if(D)return{host:D[1],port:void 0};const S=k.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:k,port:void 0}}}),define(De[27],Ie([1,0,8,3,124]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function P(E){if(typeof E=="object"&&E!==null&&E.supported!==!0)return E.description}e.getWorkspaceSupportTypeMessage=P;function _(E){return E&&typeof E=="object"&&typeof E.id=="string"&&(!E.uuid||typeof E.uuid=="string")}e.isIExtensionIdentifier=_,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(E){E[E.System=0]="System",E[E.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));var w;(function(E){E.WIN32_X64="win32-x64",E.WIN32_IA32="win32-ia32",E.WIN32_ARM64="win32-arm64",E.LINUX_X64="linux-x64",E.LINUX_ARM64="linux-arm64",E.LINUX_ARMHF="linux-armhf",E.ALPINE_X64="alpine-x64",E.ALPINE_ARM64="alpine-arm64",E.DARWIN_X64="darwin-x64",E.DARWIN_ARM64="darwin-arm64",E.WEB="web",E.UNIVERSAL="universal",E.UNKNOWN="unknown",E.UNDEFINED="undefined"})(w=e.TargetPlatform||(e.TargetPlatform={}));class k{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,b){if(typeof p>"u"||p===null)return typeof b>"u"||b===null;if(typeof b>"u"||b===null)return!1;if(typeof p=="string"||typeof b=="string"){const m=typeof p=="string"?p:p.value,v=typeof b=="string"?b:b.value;return l.equalsIgnoreCase(m,v)}return p._lower===b._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.ExtensionIdentifier=k;function L(E){return D(E)}e.isApplicationScopedExtension=L;function D(E){return E.contributes&&E.contributes.localizations?E.contributes.localizations.length>0:!1}e.isLanguagePackExtension=D;function S(E){return E.contributes&&E.contributes.authentication?E.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=S;function T(E,p){if(p){const b=`onResolveRemoteAuthority:${(0,C.getRemoteName)(p)}`;return E.activationEvents?.indexOf(b)!==-1}return!1}e.isResolverExtension=T,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(De[199],Ie([1,0,8,117,27,11,2,10,41]),function(J,e,l,t,C,P,_,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function k(u,s){return u.uuid&&s.uuid?u.uuid===s.uuid:u.id===s.id?!0:(0,l.compareIgnoreCase)(u.id,s.id)===0}e.areSameExtensions=k;const L=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class D{static create(s){const i=s.manifest?s.manifest.version:s.version,o=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new D(s.identifier,i,o)}static parse(s){const i=L.exec(s);return i&&i[1]&&i[2]?new D({id:i[1]},i[2],i[4]||void 0):null}constructor(s,i,o="undefined"){this.version=i,this.targetPlatform=o,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof D?k(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.ExtensionKey=D;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function T(u){const s=S.exec(u);return s&&s[1]?[p(s[1]),s[2]]:[p(u),void 0]}e.getIdAndVersion=T;function E(u,s){return`${u}.${s}`}e.getExtensionId=E;function p(u){return u.toLocaleLowerCase()}e.adoptToGalleryExtensionId=p;function b(u,s){return p(E(u,s))}e.getGalleryExtensionId=b;function m(u,s){const i=[],o=d=>{for(const r of i)if(r.some(a=>k(s(a),s(d))))return r;return null};for(const d of u){const r=o(d);r?r.push(d):i.push([d])}return i}e.groupByExtension=m;function v(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=v;function h(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}e.getGalleryExtensionTelemetryData=h,e.BetterMergeId=new C.ExtensionIdentifier("pprice.better-merge");function c(u,s){const i=[],o=s.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const d=o.shift();if(d&&i.every(r=>!k(r.identifier,{id:d}))){const r=u.filter(a=>k(a.identifier,{id:d}));r.length===1&&(i.push(r[0]),o.push(...r[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.getExtensionDependencies=c;async function g(u,s){if(!P.isLinux)return!1;let i;try{i=(await u.readFile(_.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await u.readFile(_.URI.file("/usr/lib/os-release"))).value.toString()}catch(d){s.debug("Error while getting the os-release file.",(0,I.getErrorMessage)(d))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=g;async function n(u,s){const i=await g(u,s),o=(0,t.getTargetPlatform)(i?"alpine":P.platform,w.arch);return s.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=n}),define(De[200],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class l{constructor(){this.validators=new Map}vsda(){return new Promise((C,P)=>J(["vsda"],C,P))}async createNewMessage(C){try{const P=await this.vsda(),_=new P.validator;if(_){const I=String(l._nextId++);return this.validators.set(I,_),{id:I,data:_.createNewMessage(C)}}}catch{}return{id:"",data:C}}async validate(C,P){if(!C.id)return!0;const _=this.validators.get(C.id);if(!_)return!1;this.validators.delete(C.id);try{return _.validate(P)==="ok"}catch{return!1}}async sign(C){try{const P=await this.vsda(),_=new P.signer;if(_)return _.sign(C)}catch{}return C}}e.SignService=l,l._nextId=1}),define(De[201],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class l{constructor(C){this._callback=C,this._terminalBufferMap=new Map}dispose(){for(const C of this._terminalBufferMap.values())C.dispose()}startBuffering(C,P,_=5){const I=P(w=>{const k=typeof w=="string"?w:w.data;let L=this._terminalBufferMap.get(C);if(L){L.data.push(k);return}const D=setTimeout(()=>this.flushBuffer(C),_);L={data:[k],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(C),I.dispose()}},this._terminalBufferMap.set(C,L)});return I}stopBuffering(C){this._terminalBufferMap.get(C)?.dispose()}flushBuffer(C){const P=this._terminalBufferMap.get(C);P&&(this._terminalBufferMap.delete(C),this._callback(C,P.data.join("")))}}e.TerminalDataBufferer=l}),define(De[202],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var l;(function(P){P.DARK="dark",P.LIGHT="light",P.HIGH_CONTRAST_DARK="hcDark",P.HIGH_CONTRAST_LIGHT="hcLight"})(l=e.ColorScheme||(e.ColorScheme={}));function t(P){return P===l.HIGH_CONTRAST_DARK||P===l.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function C(P){return P===l.DARK||P===l.HIGH_CONTRAST_DARK}e.isDark=C}),define(De[85],Ie([1,0,74,4,6,3,43,202]),function(J,e,l,t,C,P,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,P.createDecorator)("themeService");var w;(function(b){function m(v){return v&&typeof v=="object"&&typeof v.id=="string"}b.isThemeColor=m})(w=e.ThemeColor||(e.ThemeColor={}));function k(b){return{id:b}}e.themeColorFromId=k;var L;(function(b){function m(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||w.isThemeColor(i.color))}b.isThemeIcon=m;const v=new RegExp(`^\\$\\((${l.CSSIcon.iconNameExpression}(?:${l.CSSIcon.iconModifierExpression})?)\\)$`);function h(i){const o=v.exec(i);if(!o)return;const[,d]=o;return{id:d}}b.fromString=h;function c(i){return{id:i}}b.fromId=c;function g(i,o){let d=i.id;const r=d.lastIndexOf("~");return r!==-1&&(d=d.substring(0,r)),o&&(d=`${d}~${o}`),{id:d}}b.modify=g;function n(i){const o=i.id.lastIndexOf("~");if(o!==-1)return i.id.substring(o+1)}b.getModifier=n;function u(i,o){return i.id===o.id&&i.color?.id===o.color?.id}b.isEqual=u;function s(i,o){return{id:i.id,color:o?k(o):void 0}}b.asThemeIcon=s,b.asClassNameArray=l.CSSIcon.asClassNameArray,b.asClassName=l.CSSIcon.asClassName,b.asCSSSelector=l.CSSIcon.asCSSSelector})(L=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=l.Codicon.file,e.FolderThemeIcon=l.Codicon.folder;function D(b){switch(b){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case I.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=D,e.Extensions={ThemingContribution:"base.contributions.theming"};class S{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,C.toDisposable)(()=>{const v=this.themingParticipants.indexOf(m);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const T=new S;_.Registry.add(e.Extensions.ThemingContribution,T);function E(b){return T.onColorThemeChange(b)}e.registerThemingParticipant=E;class p extends C.Disposable{constructor(m){super(),this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,v){let h=this.theme.getColor(m);return h&&v&&(h=v(h,this.theme)),h?h.toString():null}}e.Themable=p}),define(De[125],Ie([1,0,4,11,3,13]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,C.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,C.createDecorator)("sharedTunnelsService");var _;(function(p){p.Http="http",p.Https="https"})(_=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(p){p.ConstantPrivate="constantPrivate",p.Private="private",p.Public="public"})(I=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var w;(function(p){p[p.Notify=1]="Notify",p[p.OpenBrowser=2]="OpenBrowser",p[p.OpenPreview=3]="OpenPreview",p[p.Silent=4]="Silent",p[p.Ignore=5]="Ignore",p[p.OpenBrowserOnce=6]="OpenBrowserOnce"})(w=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function k(p){if(p.scheme!=="http"&&p.scheme!=="https")return;const b=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(p.authority);if(!!b)return{address:b[1],port:+b[2]}}e.extractLocalHostUriMetaDataForPortMapping=k,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function L(p){return e.LOCALHOST_ADDRESSES.indexOf(p)>=0}e.isLocalhost=L,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function D(p){return e.ALL_INTERFACES_ADDRESSES.indexOf(p)>=0}e.isAllInterfaces=D;function S(p,b){return b?b!==1&&p<1024:!t.isWindows&&p<1024}e.isPortPrivileged=S;class T{constructor(b,m,v){this.remoteAddress=b,this.localAddress=m,this._dispose=v,this._onDispose=new l.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=T;let E=class{constructor(b){this.logService=b,this._onTunnelOpened=new l.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new l.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new l.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(b){return this._tunnelProvider=b,b?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(b){this._canElevate=b.elevation,this._privacyOptions=b.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const b=[],m=Array.from(this._tunnels.values());for(const v of m){const h=Array.from(v.values());for(const c of h){const g=await c.value;g&&b.push(g)}}return b}async dispose(){for(const b of this._tunnels.values()){for(const{value:m}of b.values())await m.then(v=>v?.dispose());b.clear()}this._tunnels.clear()}setEnvironmentTunnel(b,m,v,h,c){this.addTunnelToMap(b,m,Promise.resolve({tunnelRemoteHost:b,tunnelRemotePort:m,localAddress:v,privacy:h,protocol:c,dispose:()=>Promise.resolve()}))}openTunnel(b,m,v,h,c=!1,g,n){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${m}:${v} on local port ${h}.`),!b)return;if(m||(m="localhost"),this._tunnelProvider&&this._factoryInProgress.has(v)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const u=this.retainOrCreateTunnel(b,m,v,h,c,g,n);return u?u.then(s=>{if(!s){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(m,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(s);return(s.tunnelRemoteHost!==m||s.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),u)}makeTunnel(b){return{tunnelRemotePort:b.tunnelRemotePort,tunnelRemoteHost:b.tunnelRemoteHost,tunnelLocalPort:b.tunnelLocalPort,localAddress:b.localAddress,privacy:b.privacy,protocol:b.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${b.tunnelRemoteHost}:${b.tunnelRemotePort} `);const m=this._tunnels.get(b.tunnelRemoteHost);if(m){const v=m.get(b.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(b.tunnelRemoteHost,b.tunnelRemotePort,v))}}}}async tryDisposeTunnel(b,m,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${b}:${m}.`);const h=v.value.then(async c=>{c&&(await c.dispose(!0),this._onTunnelClosed.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this._tunnels.has(b)&&this._tunnels.get(b).delete(m),h}}async closeTunnel(b,m){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${b}:${m} `);const v=this._tunnels.get(b);if(v&&v.has(m)){const h=v.get(m);h.refcount=0,await this.tryDisposeTunnel(b,m,h)}}addTunnelToMap(b,m,v){this._tunnels.has(b)||this._tunnels.set(b,new Map),this._tunnels.get(b).set(m,{refcount:1,value:v})}async removeEmptyTunnelFromMap(b,m){const v=this._tunnels.get(b);v&&(await v.get(m)||v.delete(m),v.size===0&&this._tunnels.delete(b))}getTunnelFromMap(b,m){const v=[b];L(b)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):D(b)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const h=v.map(c=>this._tunnels.get(c));for(const c of h){const g=c?.get(m);if(g)return g}}canTunnel(b){return!!k(b)}doIsPortPrivileged(b,m,v,h){if(m)return!1;if(v){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if(c?.length===4){const g=parseInt(c[1]),n=parseInt(c[2]);if(g>10||g===10&&n>=14)return!1}}return b<1024}createWithProvider(b,m,v,h,c,g,n){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${m}:${v} on local port ${h}.`);const u=v;this._factoryInProgress.add(u);const s=h===void 0?v:h,i={elevationRequired:c?this.isPortPrivileged(s):!1},o={remoteAddress:{host:m,port:v},localAddressPort:h,privacy:g,public:g?g!==I.Private:void 0,protocol:n},d=b.forwardPort(o,i);return d?(this.addTunnelToMap(m,v,d),d.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(u)})):this._factoryInProgress.delete(u),d}};E=je([$e(0,P.ILogService)],E),e.AbstractTunnelService=E}),define(De[203],Ie([1,0,12]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function t(w){return w.scheme!==l.Schemas.file&&w.scheme!==l.Schemas.vscodeRemote}e.isVirtualResource=t;function C(w){if(w.folders.length)return w.folders.every(k=>t(k.uri))?w.folders[0].uri:void 0;if(w.configuration&&t(w.configuration))return w.configuration}e.getVirtualWorkspaceLocation=C;function P(w){return C(w)?.scheme}e.getVirtualWorkspaceScheme=P;function _(w){return C(w)?.authority}e.getVirtualWorkspaceAuthority=_;function I(w){return C(w)!==void 0}e.isVirtualWorkspace=I}),define(De[45],Ie([1,0,169,9,26,22,2,3,12]),function(J,e,l,t,C,P,_,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,I.createDecorator)("contextService");function k(u){const s=u;return typeof s?.id=="string"&&_.URI.isUri(s.uri)}e.isSingleFolderWorkspaceIdentifier=k,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function L(u,s){if(typeof u=="string"||typeof u>"u")return typeof u=="string"?{id:(0,t.basename)(u)}:s?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const i=u;if(i.configuration)return{id:i.id,configPath:i.configuration};if(i.folders.length===1)return{id:i.id,uri:i.folders[0].uri}}e.toWorkspaceIdentifier=L;function D(u){const s=u;return typeof s?.id=="string"&&_.URI.isUri(s.configPath)}e.isWorkspaceIdentifier=D;function S(u){const s=u;if(s?.uri)return{id:s.id,uri:_.URI.revive(s.uri)};const i=u;if(i?.configPath)return{id:i.id,configPath:_.URI.revive(i.configPath)};if(u?.id)return{id:u.id}}e.reviveIdentifier=S;var T;(function(u){u[u.EMPTY=1]="EMPTY",u[u.FOLDER=2]="FOLDER",u[u.WORKSPACE=3]="WORKSPACE"})(T=e.WorkbenchState||(e.WorkbenchState={}));function E(u){const s=u;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.isWorkspace=E;function p(u){const s=u;return!!(s&&typeof s=="object"&&_.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.isWorkspaceFolder=p;class b{constructor(s,i,o,d,r){this._id=s,this._transient=o,this._configuration=d,this._ignorePathCasing=r,this._foldersMap=C.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=i}update(s){this._id=s.id,this._configuration=s.configuration,this._transient=s.transient,this._ignorePathCasing=s._ignorePathCasing,this.folders=s.folders}get folders(){return this._folders}set folders(s){this._folders=s,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(s){this._configuration=s}getFolder(s){return s&&this._foldersMap.findSubstr(s)||null}updateFoldersMap(){this._foldersMap=C.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const s of this.folders)this._foldersMap.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=b;class m{constructor(s,i){this.raw=i,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,P.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=m;function v(u){return new m({uri:u,index:0,name:(0,P.basenameOrAuthority)(u)},{uri:u.toString()})}e.toWorkspaceFolder=v,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,l.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function h(u,s){return P.extUriBiasedIgnorePathCase.isEqualOrParent(u,s.untitledWorkspacesHome)}e.isUntitledWorkspace=h;function c(u){let s;return _.URI.isUri(u)?s=u:s=u.configuration,s?.scheme===w.Schemas.tmp}e.isTemporaryWorkspace=c;function g(u,s){return!h(u,s)&&!c(u)}e.isSavedWorkspace=g;function n(u){return(typeof u=="string"?(0,t.extname)(u):(0,P.extname)(u))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(De[86],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class l{constructor(C){this.id=C,this._data=new Map,this._idPool=1}add(C){const P=this._idPool++;return this._data.set(P,C),this.logDebugInfo(),P}get(C,P){return this._data.has(C)?this._data.get(C)[P]:void 0}delete(C){this._data.delete(C),this.logDebugInfo()}logDebugInfo(){!l.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=l,l.enableDebugLogging=!1}),define(De[46],Ie([1,0,12,22,3]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class P{constructor(){this._systemSchemes=new Set(Object.keys(l.Schemas)),this._providerInfo=new Map,this.extUri=new t.ExtUri(I=>{const w=this._providerInfo.get(I.scheme);return!(w===void 0||w&1024)})}$acceptProviderInfos(I,w){w===null?this._providerInfo.delete(I.scheme):this._providerInfo.set(I.scheme,w)}isFreeScheme(I){return!this._providerInfo.has(I)&&!this._systemSchemes.has(I)}getCapabilities(I){return this._providerInfo.get(I)}}e.ExtHostFileSystemInfo=P,e.IExtHostFileSystemInfo=(0,C.createDecorator)("IExtHostFileSystemInfo")}),define(De[25],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,l.createDecorator)("IExtHostInitDataService")}),define(De[204],Ie([1,0,18]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(_,I,w){this._deferredPromises=new Map,this._id=_,this._shared=I,this._storage=w,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(k=>(this._value=k,this)),this._storageListener=this._storage.onDidChangeStorage(k=>{k.shared===this._shared&&k.key===this._id&&(this._value=k.value)}),this._scheduler=new l.RunOnceScheduler(()=>{const k=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const L of k.values())L.complete()}catch(L){for(const D of k.values())D.error(L)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,_])=>_!==void 0).map(([_])=>_)}get whenReady(){return this._init}get(_,I){let w=this._value[_];return typeof w>"u"&&(w=I),w}update(_,I){this._value[_]=I;const w=this._deferredPromises.get(_);if(w!==void 0)return w.p;const k=new l.DeferredPromise;return this._deferredPromises.set(_,k),this._scheduler.isScheduled()||this._scheduler.schedule(),k.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=t;class C extends t{setKeysForSync(_){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},_)}constructor(_,I){super(_.identifier.value,!0,I),this._extension=_}}e.ExtensionGlobalMemento=C}),define(De[205],Ie([1,0,4,2]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class C{constructor(_){this._notebooksAndEditors=_,this._onDidSaveNotebookDocument=new l.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new l.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(_,I,w,k){const D=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(_)).acceptModelChanged(I.value,w,k);this._onDidChangeNotebookDocument.fire(D)}$acceptDirtyStateChanged(_,I){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(_)).acceptDirty(I)}$acceptModelSaved(_){const I=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(_));this._onDidSaveNotebookDocument.fire(I.apiNotebook)}}e.ExtHostNotebookDocuments=C}),define(De[14],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,l.createDecorator)("IExtHostRpcService");class t{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.dispose=P.dispose.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.ExtHostRpcService=t});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,l):C?C.value=l:e.set(J,l),l},Be=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[206],Ie([1,0,27,4]),function(J,e,l,t){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class P{constructor(I,w){C.set(this,void 0),this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._id=l.ExtensionIdentifier.toKey(I.identifier),tt(this,C,w,"f"),Be(this,C,"f").onDidChangePassword(k=>{k.extensionId===this._id&&this._onDidChange.fire({key:k.key})})}get(I){return Be(this,C,"f").get(this._id,I)}store(I,w){return Be(this,C,"f").store(this._id,I,w)}delete(I){return Be(this,C,"f").delete(this._id,I)}}e.ExtensionSecrets=P,C=new WeakMap}),define(De[126],Ie([1,0,3,4]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class C{constructor(){this._onDidChangeTelemetryEnabled=new t.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new t.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}$initializeTelemetryLevel(_,I){this._level=_,this._productConfig=I||{usage:!0,error:!0}}$onDidChangeTelemetryLevel(_){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=_,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=C,e.IExtHostTelemetry=(0,l.createDecorator)("IExtHostTelemetry")}),define(De[53],Ie([1,0,3,125,4,14]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var _;(function(w){function k(D){return{remoteAddress:D.remoteAddress,localAddress:D.localAddress,public:!!D.public,privacy:D.privacy??(D.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:D.protocol}}w.fromApiTunnel=k;function L(D){return{remoteAddress:{host:D.tunnelRemoteHost,port:D.tunnelRemotePort},localAddress:D.localAddress,public:D.privacy!==t.TunnelPrivacyId.ConstantPrivate&&D.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:D.privacy,protocol:D.protocol}}w.fromServiceTunnel=L})(_=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,l.createDecorator)("IExtHostTunnelService");let I=class{constructor(k){this.onDidChangeTunnels=new C.Emitter().event}async $applyCandidateFilter(k){return k}async openTunnel(k,L){}async getTunnels(){return[]}async setTunnelFactory(k){return{dispose:()=>{}}}registerPortsAttributesProvider(k,L){return{dispose:()=>{}}}async $providePortAttributes(k,L,D,S,T){return[]}async $forwardPort(k,L){}async $closeTunnel(k){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};I=je([$e(0,P.IExtHostRpcService)],I),e.ExtHostTunnelService=I}),define(De[54],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,l.createDecorator)("IURITransformerService");class t{constructor(P){P?(this.transformIncoming=P.transformIncoming.bind(P),this.transformOutgoing=P.transformOutgoing.bind(P),this.transformOutgoingURI=P.transformOutgoingURI.bind(P),this.transformOutgoingScheme=P.transformOutgoingScheme.bind(P)):(this.transformIncoming=_=>_,this.transformOutgoing=_=>_,this.transformOutgoingURI=_=>_,this.transformOutgoingScheme=_=>_)}}e.URITransformerService=t}),define(De[207],Ie([1,0,23]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(w){let k=this.buffers.indexOf(w);return k<0&&(k=this.buffers.length,this.buffers.push(w)),k}}function C(I,w){if(w.serializeBuffersForPostMessage){const k=new t,L=(T,E)=>{if(E instanceof ArrayBuffer){const p=k.add(E);return{$$vscode_array_buffer_reference$$:!0,index:p}}else if(ArrayBuffer.isView(E)){const p=P(E);if(p){const b=k.add(E.buffer);return{$$vscode_array_buffer_reference$$:!0,index:b,view:{type:p,byteLength:E.byteLength,byteOffset:E.byteOffset}}}}return E},D=JSON.stringify(I,L),S=k.buffers.map(T=>{const E=new Uint8Array(T);return l.VSBuffer.wrap(E)});return{message:D,buffers:S}}else return{message:JSON.stringify(I),buffers:[]}}e.serializeWebviewMessage=C;function P(I){switch(I.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function _(I,w){const k=w.map(S=>{const T=new ArrayBuffer(S.byteLength);return new Uint8Array(T).set(S.buffer),T}),L=w.length?(S,T)=>{if(T&&typeof T=="object"&&T.$$vscode_array_buffer_reference$$){const E=T,{index:p}=E,b=k[p];if(E.view)switch(E.view.type){case 1:return new Int8Array(b,E.view.byteOffset,E.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(b,E.view.byteOffset,E.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(b,E.view.byteOffset,E.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(b,E.view.byteOffset,E.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(b,E.view.byteOffset,E.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(b,E.view.byteOffset,E.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(b,E.view.byteOffset,E.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(b,E.view.byteOffset,E.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(b,E.view.byteOffset,E.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(b,E.view.byteOffset,E.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(b,E.view.byteOffset,E.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return b}return T}:void 0;return{message:JSON.parse(I,L),arrayBuffers:k}}e.deserializeWebviewMessage=_}),define(De[208],Ie([1,0,108]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(P){return{transformIncoming:_=>_.scheme==="vscode-remote"?{scheme:"file",path:_.path,query:_.query,fragment:_.fragment}:_.scheme==="file"?{scheme:"vscode-local",path:_.path,query:_.query,fragment:_.fragment}:_,transformOutgoing:_=>_.scheme==="file"?{scheme:"vscode-remote",authority:P,path:_.path,query:_.query,fragment:_.fragment}:_.scheme==="vscode-local"?{scheme:"file",path:_.path,query:_.query,fragment:_.fragment}:_,transformOutgoingScheme:_=>_==="file"?"vscode-remote":_==="vscode-local"?"file":_}}function C(P){return new l.URITransformer(t(P))}e.createURITransformer=C}),define(De[127],Ie([1,0,179,16,2,6,3,43,37,12]),function(J,e,l,t,C,P,_,I,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,l.localize)(0,null),providerDisplayName:(0,l.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var L;(function(x){x[x.PROGRAMMATIC=1]="PROGRAMMATIC",x[x.USER=2]="USER",x[x.EDIT=3]="EDIT",x[x.NAVIGATION=4]="NAVIGATION",x[x.JUMP=5]="JUMP"})(L=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var D;(function(x){x[x.IDENTICAL=1]="IDENTICAL",x[x.SIMILAR=2]="SIMILAR",x[x.DIFFERENT=3]="DIFFERENT"})(D=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function S(x){const $=x;return!!$&&typeof $.getSelection=="function"&&!!$.onDidChangeSelection}e.isEditorPaneWithSelection=S;function T(x,$,Q){for(const K of Q.visibleEditorPanes)if(K.group.id===$&&x.matches(K.input))return K.getViewState()}e.findViewStateForEditor=T;function E(x){if(o(x))return!1;const $=x;return C.URI.isUri($?.resource)}e.isResourceEditorInput=E;function p(x){if(o(x))return!1;const $=x;return $?.original!==void 0&&$.modified!==void 0}e.isResourceDiffEditorInput=p;function b(x){if(o(x)||p(x))return!1;const $=x;return $?.primary!==void 0&&$.secondary!==void 0}e.isResourceSideBySideEditorInput=b;function m(x){if(o(x))return!1;const $=x;return $?$.resource===void 0||$.resource.scheme===k.Schemas.untitled||$.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=m;const v=/Untitled-\d+/;function h(x){return x.scheme===k.Schemas.untitled&&x.path.length>1&&!v.test(x.path)}e.isUntitledWithAssociatedResource=h;function c(x){if(o(x))return!1;const $=x;return C.URI.isUri($?.base?.resource)&&C.URI.isUri($?.input1?.resource)&&C.URI.isUri($?.input2?.resource)&&C.URI.isUri($?.result?.resource)}e.isResourceMergeEditorInput=c;var g;(function(x){x[x.SHORT=0]="SHORT",x[x.MEDIUM=1]="MEDIUM",x[x.LONG=2]="LONG"})(g=e.Verbosity||(e.Verbosity={}));var n;(function(x){x[x.EXPLICIT=1]="EXPLICIT",x[x.AUTO=2]="AUTO",x[x.FOCUS_CHANGE=3]="FOCUS_CHANGE",x[x.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(n=e.SaveReason||(e.SaveReason={}));class u{constructor(){this.mapIdToSaveSource=new Map}registerSource($,Q){let K=this.mapIdToSaveSource.get($);return K||(K={source:$,label:Q},this.mapIdToSaveSource.set($,K)),K.source}getSourceLabel($){return this.mapIdToSaveSource.get($)?.label??$}}e.SaveSourceRegistry=new u;var s;(function(x){x[x.None=0]="None",x[x.Readonly=2]="Readonly",x[x.Untitled=4]="Untitled",x[x.Singleton=8]="Singleton",x[x.RequiresTrust=16]="RequiresTrust",x[x.CanSplitInGroup=32]="CanSplitInGroup",x[x.ForceDescription=64]="ForceDescription",x[x.CanDropIntoEditor=128]="CanDropIntoEditor",x[x.MultipleEditors=256]="MultipleEditors"})(s=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class i extends P.Disposable{}e.AbstractEditorInput=i;function o(x){return x instanceof i}e.isEditorInput=o;function d(x){const $=x;return C.URI.isUri($?.preferredResource)}function r(x){const $=x;return o($?.primary)&&o($?.secondary)}e.isSideBySideEditorInput=r;function a(x){const $=x;return o($?.modified)&&o($?.original)}e.isDiffEditorInput=a;function f(x){return o(x?.editor)}e.isEditorInputWithOptions=f;function y(x){const $=x;return f(x)&&$?.group!==void 0}e.isEditorInputWithOptionsAndGroup=y;function R(x){const $=x;return typeof $?.groupId=="number"&&o($.editor)}e.isEditorIdentifier=R;var N;(function(x){x[x.UNKNOWN=0]="UNKNOWN",x[x.REPLACE=1]="REPLACE",x[x.MOVE=2]="MOVE",x[x.UNPIN=3]="UNPIN"})(N=e.EditorCloseContext||(e.EditorCloseContext={}));var M;(function(x){x[x.GROUP_ACTIVE=0]="GROUP_ACTIVE",x[x.GROUP_INDEX=1]="GROUP_INDEX",x[x.GROUP_LOCKED=2]="GROUP_LOCKED",x[x.EDITOR_OPEN=3]="EDITOR_OPEN",x[x.EDITOR_CLOSE=4]="EDITOR_CLOSE",x[x.EDITOR_MOVE=5]="EDITOR_MOVE",x[x.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",x[x.EDITOR_LABEL=7]="EDITOR_LABEL",x[x.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",x[x.EDITOR_PIN=9]="EDITOR_PIN",x[x.EDITOR_STICKY=10]="EDITOR_STICKY",x[x.EDITOR_DIRTY=11]="EDITOR_DIRTY",x[x.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(M=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var A;(function(x){x[x.PRIMARY=1]="PRIMARY",x[x.SECONDARY=2]="SECONDARY",x[x.BOTH=3]="BOTH",x[x.ANY=4]="ANY"})(A=e.SideBySideEditor||(e.SideBySideEditor={}));class z{getOriginalUri($,Q){if(!$)return;if(c($))return e.EditorResourceAccessor.getOriginalUri($.result,Q);if(Q?.supportSideBySide){const{primary:de,secondary:te}=this.getSideEditors($);if(de&&te){if(Q?.supportSideBySide===A.BOTH)return{primary:this.getOriginalUri(de,{filterByScheme:Q.filterByScheme}),secondary:this.getOriginalUri(te,{filterByScheme:Q.filterByScheme})};if(Q?.supportSideBySide===A.ANY)return this.getOriginalUri(de,{filterByScheme:Q.filterByScheme})??this.getOriginalUri(te,{filterByScheme:Q.filterByScheme});$=Q.supportSideBySide===A.PRIMARY?de:te}}if(p($)||b($)||c($))return;const K=d($)?$.preferredResource:$.resource;return!K||!Q||!Q.filterByScheme?K:this.filterUri(K,Q.filterByScheme)}getSideEditors($){return r($)||b($)?{primary:$.primary,secondary:$.secondary}:a($)||p($)?{primary:$.modified,secondary:$.original}:{primary:void 0,secondary:void 0}}getCanonicalUri($,Q){if(!$)return;if(c($))return e.EditorResourceAccessor.getCanonicalUri($.result,Q);if(Q?.supportSideBySide){const{primary:de,secondary:te}=this.getSideEditors($);if(de&&te){if(Q?.supportSideBySide===A.BOTH)return{primary:this.getCanonicalUri(de,{filterByScheme:Q.filterByScheme}),secondary:this.getCanonicalUri(te,{filterByScheme:Q.filterByScheme})};if(Q?.supportSideBySide===A.ANY)return this.getCanonicalUri(de,{filterByScheme:Q.filterByScheme})??this.getCanonicalUri(te,{filterByScheme:Q.filterByScheme});$=Q.supportSideBySide===A.PRIMARY?de:te}}if(p($)||b($)||c($))return;const K=$.resource;return!K||!Q||!Q.filterByScheme?K:this.filterUri(K,Q.filterByScheme)}filterUri($,Q){if(Array.isArray(Q)){if(Q.some(K=>$.scheme===K))return $}else if(Q===$.scheme)return $}}e.EditorResourceAccessor=new z;var H;(function(x){x[x.LEFT=0]="LEFT",x[x.RIGHT=1]="RIGHT"})(H=e.CloseDirection||(e.CloseDirection={}));class F{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start($){const Q=this.instantiationService=$.get(_.IInstantiationService);for(const[K,de]of this.editorSerializerConstructors)this.createEditorSerializer(K,de,Q);this.editorSerializerConstructors.clear()}createEditorSerializer($,Q,K){const de=K.createInstance(Q);this.editorSerializerInstances.set($,de)}registerFileEditorFactory($){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=$}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer($,Q){if(this.editorSerializerConstructors.has($)||this.editorSerializerInstances.has($))throw new Error(`A editor serializer with type ID '${$}' was already registered.`);return this.instantiationService?this.createEditorSerializer($,Q,this.instantiationService):this.editorSerializerConstructors.set($,Q),(0,P.toDisposable)(()=>{this.editorSerializerConstructors.delete($),this.editorSerializerInstances.delete($)})}getEditorSerializer($){return this.editorSerializerInstances.get(typeof $=="string"?$:$.typeId)}}I.Registry.add(e.EditorExtensions.EditorFactory,new F);async function G(x,$){return!x||!x.length?[]:await Promise.all(x.map(async Q=>{const K=C.URI.revive(Q.fileUri);if(!K||!await $.canHandleResource(K))return;let te=Q.exists,he=Q.type;if(typeof te!="boolean"||typeof he!="number")try{he=(await $.stat(K)).isDirectory?w.FileType.Directory:w.FileType.Unknown,te=!0}catch{te=!1}if(!te&&Q.openOnlyIfExists||he===w.FileType.Directory)return;const Y={...Q.options,pinned:!0};return te?{resource:K,options:Y}:{resource:K,options:Y,forceUntitled:!0}}))}e.pathsToEditors=G;var B;(function(x){x[x.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",x[x.SEQUENTIAL=1]="SEQUENTIAL"})(B=e.EditorsOrder||(e.EditorsOrder={}));function U(x){const $=x;if(!$)return!1;const Q=$;if(Q.modified)return U(Q.modified);const K=$;return!!(K.contributionsState&&K.viewState&&Array.isArray(K.cursorState))}e.isTextEditorViewState=U}),define(De[87],Ie([1,0,12,2]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function C(I,w){return I.scheme===l.Schemas.http||I.scheme===l.Schemas.https?I:(w&&w.authority&&w.isRemote&&I.scheme===l.Schemas.file&&(I=t.URI.from({scheme:l.Schemas.vscodeRemote,authority:w.authority,path:I.path})),t.URI.from({scheme:l.Schemas.https,authority:`${I.scheme}+${P(I.authority)}.${e.webviewRootResourceAuthority}`,path:I.path,fragment:I.fragment,query:I.query}))}e.asWebviewUri=C;function P(I){return I.replace(/./g,w=>{const k=w.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?w:"-"+k.toString(16).padStart(4,"0")})}function _(I){return I.replace(/-([0-9a-f]{4})/g,(w,k)=>String.fromCharCode(parseInt(k,16)))}e.decodeAuthority=_}),define(De[209],Ie([1,0,4,6,87]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class P{constructor(I,w,k){this._proxy=I,this._editors=w,this._remoteInfo=k,this._handlePool=0,this._disposables=new t.DisposableStore,this._insets=new Map,this._disposables.add(w.onDidChangeVisibleTextEditors(()=>{const L=w.getVisibleTextEditors();for(const D of this._insets.values())L.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this._insets.forEach(I=>I.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(I,w,k,L,D){let S;for(const h of this._editors.getVisibleTextEditors(!0))if(h.value===I){S=h;break}if(!S)throw new Error("not a visible editor");const T=this,E=this._handlePool++,p=new l.Emitter,b=new l.Emitter,m=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(h){return(0,C.asWebviewUri)(h,T._remoteInfo)}get cspSource(){return C.webviewGenericCspSource}set options(h){this._options=h,T._proxy.$setOptions(E,h)}get options(){return this._options}set html(h){this._html=h,T._proxy.$setHtml(E,h)}get html(){return this._html}get onDidReceiveMessage(){return p.event}postMessage(h){return T._proxy.$postMessage(E,h)}},v=new class{constructor(){this.editor=I,this.line=w,this.height=k,this.webview=m,this.onDidDispose=b.event}dispose(){T._insets.has(E)&&(T._insets.delete(E),T._proxy.$disposeEditorInset(E),b.fire(),b.dispose(),p.dispose())}};return this._proxy.$createEditorInset(E,S.id,S.value.document.uri,w+1,k,L||{},D.identifier,D.extensionLocation),this._insets.set(E,{editor:I,inset:v,onDidReceiveMessage:p}),v}$onDidDispose(I){const w=this._insets.get(I);w&&w.inset.dispose()}$onDidReceiveMessage(I,w){this._insets.get(I)?.onDidReceiveMessage.fire(w)}}e.ExtHostEditorInsets=P}),define(De[128],Ie([1,0,4,18,180]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class P{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new l.Emitter,this._onExit=new l.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(I){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=I}onEvent(I){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=I}onRequest(I){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=I}sendResponse(I){I.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${I.command}`)):this.internalSend("response",I)}sendRequest(I,w,k,L){const D={command:I};if(w&&Object.keys(w).length>0&&(D.arguments=w),this.internalSend("request",D),typeof L=="number"){const S=setTimeout(()=>{clearTimeout(S);const T=this.pendingRequests.get(D.seq);if(T){this.pendingRequests.delete(D.seq);const E={type:"response",seq:0,request_seq:D.seq,success:!1,command:I,message:(0,C.localize)(0,null,L,I)};T(E)}},L)}return k&&this.pendingRequests.set(D.seq,k),D.seq}acceptMessage(I){this.messageCallback?this.messageCallback(I):(this.queue.push(I),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(I,w){return I.type!=="event"||w.type!=="event"}async processQueue(){let I;for(;this.queue.length;){if((!I||this.needsTaskBoundaryBetween(this.queue[0],I))&&await(0,t.timeout)(0),I=this.queue.shift(),!I)return;switch(I.type){case"event":this.eventCallback?.(I);break;case"request":this.requestCallback?.(I);break;case"response":{const w=I,k=this.pendingRequests.get(w.request_seq);k&&(this.pendingRequests.delete(w.request_seq),k(w));break}}}}internalSend(I,w){w.type=I,w.seq=this.sequence++,this.sendMessage(w)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const I=new Map;this.pendingRequests.forEach((w,k)=>I.set(k,w)),await(0,t.timeout)(500),I.forEach((w,k)=>{w({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(k)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=P}),define(De[210],Ie([1,0,181,52,3]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new t.RawContextKey("debugType",void 0,{type:"string",description:l.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new t.RawContextKey("debugConfigurationType",void 0,{type:"string",description:l.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new t.RawContextKey("debugState","inactive",{type:"string",description:l.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new t.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:l.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new t.RawContextKey("inDebugMode",!1,{type:"boolean",description:l.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new t.RawContextKey("inDebugRepl",!1,{type:"boolean",description:l.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new t.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:l.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new t.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:l.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new t.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:l.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new t.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:l.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new t.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:l.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new t.RawContextKey("variablesFocused",!0,{type:"boolean",description:l.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new t.RawContextKey("expressionSelected",!1,{type:"boolean",description:l.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new t.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:l.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new t.RawContextKey("callStackItemType",void 0,{type:"string",description:l.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new t.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:l.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new t.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:l.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new t.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:l.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new t.RawContextKey("watchItemType",void 0,{type:"string",description:l.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new t.RawContextKey("canViewMemory",void 0,{type:"boolean",description:l.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new t.RawContextKey("breakpointItemType",void 0,{type:"string",description:l.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new t.RawContextKey("breakpointAccessType",void 0,{type:"string",description:l.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new t.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:l.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new t.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:l.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new t.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:l.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new t.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:l.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new t.RawContextKey("stepBackSupported",!1,{type:"boolean",description:l.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new t.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:l.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new t.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:l.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new t.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:l.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new t.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:l.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new t.RawContextKey("breakpointsExist",!1,{type:"boolean",description:l.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new t.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:l.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new t.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:l.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new t.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:l.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new t.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:l.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new t.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:l.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new t.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:l.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new t.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:l.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new t.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:l.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new t.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:l.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new t.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:l.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new t.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:l.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new t.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:l.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new t.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:l.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new t.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:l.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new t.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:l.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new t.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:l.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new t.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:l.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new t.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:l.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new t.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:l.localize(50,null)});const P=S=>l.localize(51,null,S);e.debuggerDisabledMessage=P,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:l.localize(52,null)};var _;(function(S){S[S.Inactive=0]="Inactive",S[S.Initializing=1]="Initializing",S[S.Stopped=2]="Stopped",S[S.Running=3]="Running"})(_=e.State||(e.State={}));function I(S){switch(S){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=I;var w;(function(S){S[S.Valid=0]="Valid",S[S.Unreadable=1]="Unreadable",S[S.Error=2]="Error"})(w=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var k;(function(S){S[S.Initial=1]="Initial",S[S.Dynamic=2]="Dynamic"})(k=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var L;(function(S){S.UnverifiedBreakpoints="unverifiedBreakpoints"})(L=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,C.createDecorator)(e.DEBUG_SERVICE_ID);var D;(function(S){S[S.CONDITION=0]="CONDITION",S[S.HIT_COUNT=1]="HIT_COUNT",S[S.LOG_MESSAGE=2]="LOG_MESSAGE"})(D=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(De[211],Ie([1,0,8,2,9,24,12]),function(J,e,l,t,C,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const I=/{([^}]+)}/g;function w(s,i,o){return s.replace(I,function(d,r){return i&&r.length>0&&r[0]!=="_"?d:o&&o.hasOwnProperty(r)?o[r]:d})}e.formatPII=w;function k(s){const i={};for(const o of Object.keys(s))o.startsWith("!")||(i[o]=s[o]);return i}e.filterExceptionsFromTelemetry=k;function L(s){return s.configuration.request==="attach"&&!D(s)&&(!s.parentSession||L(s.parentSession))}e.isSessionAttach=L;function D(s){let i=s.configuration.type;if(!!i)return i==="vslsShare"&&(i=s.configuration.adapterProxy.configuration.type),(0,l.equalsIgnoreCase)(i,"extensionhost")||(0,l.equalsIgnoreCase)(i,"pwa-extensionhost")?s:s.parentSession?D(s.parentSession):void 0}e.getExtensionHostDebugSession=D;function S(s){return s.type&&(s.label||s.program||s.runtime)}e.isDebuggerMainContribution=S;function T(s,i,o){let d,r=0;const a=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let f=null;for(;f=a.exec(s);){const y=f.index+1,R=y+f[0].length;if(y<=i&&R>=o){d=f[0],r=y;break}}if(d){const y=/\w+/g;let R=null;for(;(R=y.exec(d))&&!(R.index+1+r+R[0].length>=o););R&&(d=d.substring(0,y.lastIndex))}return d?{start:r,end:r+d.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=T;const E=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function p(s){return!!(s&&s.match(E))}e.isUri=p;function b(s){if(typeof s.path=="string"&&!(typeof s.sourceReference=="number"&&s.sourceReference>0)){if(p(s.path))return t.URI.parse(s.path);if((0,C.isAbsolute)(s.path))return t.URI.file(s.path)}return s.path}function m(s){if(typeof s.path=="object"){const i=t.URI.revive(s.path);if(i)return i.scheme===_.Schemas.file?i.fsPath:i.toString()}return s.path}function v(s,i){const o=i?b:m,d=(0,P.deepClone)(s);return c(d,(r,a)=>{r&&a&&(a.path=o(a))}),d}e.convertToDAPaths=v;function h(s,i){const o=i?b:m,d=(0,P.deepClone)(s);return c(d,(r,a)=>{!r&&a&&(a.path=o(a))}),d}e.convertToVSCPaths=h;function c(s,i){switch(s.type){case"event":{const o=s;switch(o.event){case"output":i(!1,o.body.source);break;case"loadedSource":i(!1,o.body.source);break;case"breakpoint":i(!1,o.body.breakpoint.source);break;default:break}break}case"request":{const o=s;switch(o.command){case"setBreakpoints":i(!0,o.arguments.source);break;case"breakpointLocations":i(!0,o.arguments.source);break;case"source":i(!0,o.arguments.source);break;case"gotoTargets":i(!0,o.arguments.source);break;case"launchVSCode":o.arguments.args.forEach(d=>i(!1,d));break;default:break}break}case"response":{const o=s;if(o.success&&o.body)switch(o.command){case"stackTrace":o.body.stackFrames.forEach(d=>i(!1,d.source));break;case"loadedSources":o.body.sources.forEach(d=>i(!1,d));break;case"scopes":o.body.scopes.forEach(d=>i(!1,d.source));break;case"setFunctionBreakpoints":o.body.breakpoints.forEach(d=>i(!1,d.source));break;case"setBreakpoints":o.body.breakpoints.forEach(d=>i(!1,d.source));break;case"disassemble":o.body?.instructions.forEach(r=>i(!1,r.location));break;default:break}break}}}function g(s){return s.filter(i=>!i.presentation?.hidden).sort((i,o)=>i.presentation?o.presentation?i.presentation.group?o.presentation.group?i.presentation.group!==o.presentation.group?i.presentation.group.localeCompare(o.presentation.group):n(i.presentation.order,o.presentation.order):-1:o.presentation.group?1:n(i.presentation.order,o.presentation.order):-1:o.presentation?1:0)}e.getVisibleAndSorted=g;function n(s,i){return typeof s!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:s-i}async function u(s,i){const o=s.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorLanguageId});if(o!=="none"&&(await i.saveAll(),o==="allEditorsInActiveGroup")){const d=i.activeEditorPane;d&&d.input.resource?.scheme===_.Schemas.untitled&&await i.save({editor:d.input,groupId:d.group.id})}await s.reloadConfiguration()}e.saveAllBeforeDebugStart=u}),define(De[212],Ie([1,0,44,213,24,9,11,8,29,182,128]),function(J,e,l,t,C,P,_,I,w,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class D extends L.AbstractDebugAdapter{constructor(){super(),this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(m,v){this.outputStream=v,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,m.on("data",h=>this.handleData(h))}sendMessage(m){if(this.outputStream){const v=JSON.stringify(m);this.outputStream.write(`Content-Length: ${Buffer.byteLength(v,"utf8")}${D.TWO_CRLF}${v}`,"utf8")}}handleData(m){for(this.rawData=Buffer.concat([this.rawData,m]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const v=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,v.length>0)try{this.acceptMessage(JSON.parse(v))}catch(h){this._onError.fire(new Error((h.message||h)+`
`+v))}continue}}else{const v=this.rawData.indexOf(D.TWO_CRLF);if(v!==-1){const c=this.rawData.toString("utf8",0,v).split(D.HEADER_LINESEPARATOR);for(const g of c){const n=g.split(D.HEADER_FIELDSEPARATOR);n[0]==="Content-Length"&&(this.contentLength=Number(n[1]))}this.rawData=this.rawData.slice(v+D.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=D,D.TWO_CRLF=`\r
\r
`,D.HEADER_LINESEPARATOR=/\r?\n/,D.HEADER_FIELDSEPARATOR=/: */;class S extends D{startSession(){return new Promise((m,v)=>{let h=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),m(),h=!0}),this.socket.on("close",()=>{h?this._onError.fire(new Error("connection closed")):v(new Error("connection closed"))}),this.socket.on("error",c=>{h?this._onError.fire(c):v(c)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=S;class T extends S{constructor(m){super(),this.adapterServer=m}createConnection(m){return t.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",m)}}e.SocketDebugAdapter=T;class E extends S{constructor(m){super(),this.adapterServer=m}createConnection(m){return t.createConnection(this.adapterServer.path,m)}}e.NamedPipeDebugAdapter=E;class p extends D{constructor(m,v){super(),this.adapterExecutable=m,this.debugType=v}async startSession(){const m=this.adapterExecutable.command,v=this.adapterExecutable.args,h=this.adapterExecutable.options||{};try{if(m)if(P.isAbsolute(m)){if(!await w.Promises.exists(m))throw new Error(k.localize(0,null,m))}else m.indexOf("/")<0&&m.indexOf("\\")<0;else throw new Error(k.localize(1,null,this.debugType));let c=process.env;if(h.env&&Object.keys(h.env).length>0&&(c=C.mixin(C.deepClone(process.env),h.env)),m==="node")if(Array.isArray(v)&&v.length>0){const g=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,n={env:c,execArgv:g?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};h.cwd&&(n.cwd=h.cwd);const u=l.fork(v[0],v.slice(1),n);if(!u.pid)throw new Error(k.localize(2,null,v[0]));this.serverProcess=u}else throw new Error(k.localize(3,null));else{const g={env:c};h.cwd&&(g.cwd=h.cwd),this.serverProcess=l.spawn(m,v,g)}this.serverProcess.on("error",g=>{this._onError.fire(g)}),this.serverProcess.on("exit",(g,n)=>{this._onExit.fire(g)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",g=>{this._onError.fire(g)}),this.serverProcess.stdin.on("error",g=>{this._onError.fire(g)}),this.serverProcess.stderr.resume(),this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(c){this._onError.fire(c)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),_.isWindows?new Promise((m,v)=>{const h=l.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(c,g,n){if(c)return v(c)});h.on("exit",m),h.on("error",v)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(m,v){if(!m)return;const h=Object.create(null);m.runtime&&(m.runtime.indexOf("./")===0?h.runtime=P.join(v,m.runtime):h.runtime=m.runtime),m.runtimeArgs&&(h.runtimeArgs=m.runtimeArgs),m.program&&(P.isAbsolute(m.program)?h.program=m.program:h.program=P.join(v,m.program)),m.args&&(h.args=m.args);const c=m;return c.win&&(h.win=p.extract(c.win,v)),c.winx86&&(h.winx86=p.extract(c.winx86,v)),c.windows&&(h.windows=p.extract(c.windows,v)),c.osx&&(h.osx=p.extract(c.osx,v)),c.linux&&(h.linux=p.extract(c.linux,v)),h}static platformAdapterExecutable(m,v){let h=Object.create(null);v=v.toLowerCase();for(const i of m)if(i.contributes){const o=i.contributes.debuggers;o&&o.length>0&&o.filter(d=>typeof d.type=="string"&&I.equalsIgnoreCase(d.type,v)).forEach(d=>{const r=p.extract(d,i.extensionLocation.fsPath);h=C.mixin(h,r,i.isBuiltin)})}let c;_.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?c=h.winx86||h.win||h.windows:_.isWindows?c=h.win||h.windows:_.isMacintosh?c=h.osx:_.isLinux&&(c=h.linux),c=c||h;const g=c.program||h.program,n=c.args||h.args,u=c.runtime||h.runtime,s=c.runtimeArgs||h.runtimeArgs;if(u)return{type:"executable",command:u,args:(s||[]).concat(typeof g=="string"?[g]:[]).concat(n||[])};if(g)return{type:"executable",command:g,args:n||[]}}}e.ExecutableDebugAdapter=p}),define(De[214],Ie([1,0,44,31,11]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function P(k,L){return new Promise((D,S)=>{let T="";const E=l.spawn(k,L);E.pid&&E.stdout.on("data",p=>{T+=p.toString()}),E.on("error",p=>{S(p)}),E.on("close",p=>{D(T)})})}async function _(k){if(k)if(C.isWindows){const L=await new Promise((D,S)=>{J(["windows-process-tree"],D,S)});return new Promise(D=>{L.getProcessTree(k,S=>{D(!!S&&S.children.length>0)})})}else return P("/usr/bin/pgrep",["-lP",String(k)]).then(L=>{const D=L.trim();return!(D.length===0||D.indexOf(" tmux")>=0)},L=>!0);return Promise.resolve(!0)}e.hasChildProcesses=_;var I;(function(k){k[k.cmd=0]="cmd",k[k.powershell=1]="powershell",k[k.bash=2]="bash"})(I||(I={}));function w(k,L,D,S,T){k=k.trim().toLowerCase();let E;k.indexOf("powershell")>=0||k.indexOf("pwsh")>=0?E=1:k.indexOf("cmd.exe")>=0?E=0:k.indexOf("bash")>=0?E=2:C.isWindows?E=0:E=2;let p,b=" ";switch(E){case 1:if(p=m=>(m=m.replace(/\'/g,"''"),m.length>0&&m.charAt(m.length-1)==="\\"?`'${m}\\'`:`'${m}'`),S){const m=(0,t.getDriveLetter)(S);m&&(b+=`${m}:; `),b+=`cd ${p(S)}; `}if(T)for(const m in T){const v=T[m];v===null?b+=`Remove-Item env:${m}; `:b+=`\${env:${m}}='${v}'; `}if(L.length>0){const m=L.shift(),v=D?m:p(m);b+=v[0]==="'"?`& ${v} `:`${v} `;for(const h of L)b+=h==="<"||h===">"||D?h:p(h),b+=" "}break;case 0:if(p=m=>(m=m.replace(/\"/g,'""'),m=m.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(v=>m.includes(v))||m.length===0?`"${m}"`:m),S){const m=(0,t.getDriveLetter)(S);m&&(b+=`${m}: && `),b+=`cd ${p(S)} && `}if(T){b+='cmd /C "';for(const m in T){let v=T[m];v===null?b+=`set "${m}=" && `:(v=v.replace(/[&^|<>]/g,h=>`^${h}`),b+=`set "${m}=${v}" && `)}}for(const m of L)b+=m==="<"||m===">"||D?m:p(m),b+=" ";T&&(b+='"');break;case 2:{p=v=>(v=v.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),v.length===0?'""':v);const m=v=>/[^\w@%\/+=,.:^-]/.test(v)?`'${v.replace(/'/g,"'\\''")}'`:v;if(S&&(b+=`cd ${p(S)} ; `),T){b+="/usr/bin/env";for(const v in T){const h=T[v];h===null?b+=` -u ${m(v)}`:b+=` ${m(`${v}=${h}`)}`}b+=" "}for(const v of L)b+=v==="<"||v===">"||D?v:p(v),b+=" ";break}}return b}e.prepareCommand=w}),define(De[88],Ie([1,0,23,36,61,101,12,9,11,52]),function(J,e,l,t,C,P,_,I,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var L;(function(r){r[r.Markup=1]="Markup",r[r.Code=2]="Code"})(L=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",P.Mimes.latex,P.Mimes.markdown,"image/png","image/jpeg",P.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[P.Mimes.latex,P.Mimes.markdown,"application/json",P.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var D;(function(r){r[r.Running=1]="Running",r[r.Idle=2]="Idle"})(D=e.NotebookRunState||(e.NotebookRunState={}));var S;(function(r){r[r.Unconfirmed=1]="Unconfirmed",r[r.Pending=2]="Pending",r[r.Executing=3]="Executing"})(S=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var T;(function(r){r[r.WithHardKernelDependency=0]="WithHardKernelDependency",r[r.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",r[r.Pure=2]="Pure",r[r.Never=3]="Never"})(T=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var E;(function(r){r.Always="always",r.Never="never",r.Optional="optional"})(E=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var p;(function(r){r[r.ModelChange=1]="ModelChange",r[r.Move=2]="Move",r[r.ChangeCellLanguage=5]="ChangeCellLanguage",r[r.Initialize=6]="Initialize",r[r.ChangeCellMetadata=7]="ChangeCellMetadata",r[r.Output=8]="Output",r[r.OutputItem=9]="OutputItem",r[r.ChangeCellContent=10]="ChangeCellContent",r[r.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",r[r.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",r[r.ChangeCellMime=13]="ChangeCellMime",r[r.Unknown=100]="Unknown"})(p=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var b;(function(r){r[r.Handle=0]="Handle",r[r.Index=1]="Index"})(b=e.SelectionStateType||(e.SelectionStateType={}));var m;(function(r){r[r.Replace=1]="Replace",r[r.Output=2]="Output",r[r.Metadata=3]="Metadata",r[r.CellLanguage=4]="CellLanguage",r[r.DocumentMetadata=5]="DocumentMetadata",r[r.Move=6]="Move",r[r.OutputItems=7]="OutputItems",r[r.PartialMetadata=8]="PartialMetadata",r[r.PartialInternalMetadata=9]="PartialInternalMetadata"})(m=e.CellEditType||(e.CellEditType={}));var v;(function(r){r.scheme=_.Schemas.vscodeNotebookCell;const a=["W","X","Y","Z","a","b","c","d","e","f"],f=new RegExp(`^[${a.join("")}]+`),y=7;function R(F,G){const B=G.toString(y),x=`${B.length<a.length?a[B.length-1]:"z"}${B}s${(0,l.encodeBase64)(l.VSBuffer.fromString(F.scheme),!0,!0)}`;return F.with({scheme:r.scheme,fragment:x})}r.generate=R;function N(F){if(F.scheme!==r.scheme)return;const G=F.fragment.indexOf("s");if(G<0)return;const B=parseInt(F.fragment.substring(0,G).replace(f,""),y),U=(0,l.decodeBase64)(F.fragment.substring(G+1)).toString();if(!isNaN(B))return{handle:B,notebook:F.with({scheme:U,fragment:null})}}r.parse=N;function M(F,G){return F.with({scheme:_.Schemas.vscodeNotebookCellOutput,fragment:`op${G??""},${F.scheme!==_.Schemas.file?F.scheme:""}`})}r.generateCellOutputUri=M;function A(F){if(F.scheme!==_.Schemas.vscodeNotebookCellOutput)return;const G=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(F.fragment);if(!G)return;const B=G[1]&&G[1]!==""?G[1]:void 0,U=G[2];return{outputId:B,notebook:F.with({scheme:U||_.Schemas.file,fragment:null})}}r.parseCellOutputUri=A;function z(F,G,B){return r.generate(F,G).with({scheme:B})}r.generateCellPropertyUri=z;function H(F,G){if(F.scheme===G)return r.parse(F.with({scheme:r.scheme}))}r.parseCellPropertyUri=H})(v=e.CellUri||(e.CellUri={}));const h=r=>w.isWindows?r.replace(/\//g,"\\"):r;class c{constructor(a=[],f=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=f,this.order=[...new Set(a)].map(y=>({pattern:y,matches:t.parse(h(y))}))}sort(a){const f=new Map(C.Iterable.map(a,R=>[R,h(R)]));let y=[];for(const{matches:R}of this.order)for(const[N,M]of f)if(R(M)){y.push(N),f.delete(N);break}return f.size&&(y=y.concat([...f.keys()].sort((R,N)=>this.defaultOrder.indexOf(R)-this.defaultOrder.indexOf(N)))),y}prioritize(a,f){const y=this.findIndex(a);if(y===-1){this.order.unshift({pattern:a,matches:t.parse(h(a))});return}const R=new Set(f.map(M=>this.findIndex(M,y)));R.delete(-1);const N=Array.from(R).sort();this.order.splice(y+1,0,...N.map(M=>this.order[M]));for(let M=N.length-1;M>=0;M--)this.order.splice(N[M],1)}toArray(){return this.order.map(a=>a.pattern)}findIndex(a,f=this.order.length){const y=h(a);for(let R=0;R<f;R++)if(this.order[R].matches(y))return R;return-1}}e.MimeTypeDisplayOrder=c;function g(r,a,f,y=(R,N)=>R===N){const R=[];function N(z,H,F){if(H===0&&F.length===0)return;const G=R[R.length-1];G&&G.start+G.deleteCount===z?(G.deleteCount+=H,G.toInsert.push(...F)):R.push({start:z,deleteCount:H,toInsert:F})}let M=0,A=0;for(;;){if(M===r.length){N(M,0,a.slice(A));break}if(A===a.length){N(M,r.length-M,[]);break}const z=r[M],H=a[A];if(y(z,H)){M+=1,A+=1;continue}f(H)?(N(M,1,[]),M+=1):(N(M,0,[H]),A+=1)}return R}e.diff=g,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new k.RawContextKey("notebookEditorCursorAtBoundary","none");var n;(function(r){r.default="default",r.option="option"})(n=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function u(r){const a=r;return!!((typeof a.include=="string"||t.isRelativePattern(a.include))&&(typeof a.exclude=="string"||t.isRelativePattern(a.exclude)))}e.isDocumentExcludePattern=u;function s(r,a,f){if(Array.isArray(r.viewType)&&r.viewType.indexOf(a)>=0||r.viewType===a)return!0;if(r.filenamePattern){const y=u(r.filenamePattern)?r.filenamePattern.include:r.filenamePattern,R=u(r.filenamePattern)?r.filenamePattern.exclude:void 0;if(t.match(y,(0,I.basename)(f.fsPath).toLowerCase()))return!(R&&t.match(R,(0,I.basename)(f.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=s,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var i;(function(r){r[r.Left=1]="Left",r[r.Right=2]="Right"})(i=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class o{static create(a){return`${o._prefix}${a}`}static parse(a){if(a.startsWith(o._prefix))return a.substring(o._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=o,o._prefix="notebook/";function d(r){return["application/vnd.code.notebook.stdout","application/x.notebook.stdout","application/x.notebook.stream","application/vnd.code.notebook.stderr","application/x.notebook.stderr"].includes(r)}e.isTextStreamMime=d}),define(De[215],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,l.createDecorator)("INotebookExecutionService")}),define(De[216],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function l(_){return[..._.entries()]}e.serializeEnvironmentVariableCollection=l;function t(_){return new Map(_)}e.deserializeEnvironmentVariableCollection=t;function C(_){return Array.from(_.entries()).map(I=>[I[0],l(I[1].map)])}e.serializeEnvironmentVariableCollections=C;function P(_){return new Map(_.map(I=>[I[0],{map:t(I[1])}]))}e.deserializeEnvironmentVariableCollections=P}),define(De[55],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var l;(function(P){P.Delimiter="\0"})(l=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class C{static fromExtHostTestItem(_,I,w=_.parent){if(_._isRoot)return new C([I]);const k=[_.id];for(let L=w;L&&L.id!==I;L=L.parent)k.push(L.id);return k.push(I),new C(k.reverse())}static isRoot(_){return!_.includes("\0")}static root(_){const I=_.indexOf("\0");return I===-1?_:_.slice(0,I)}static fromString(_){return new C(_.split("\0"))}static join(_,I){return new C([..._.path,I])}static joinToString(_,I){return _.toString()+"\0"+I}static parentId(_){const I=_.lastIndexOf("\0");return I===-1?void 0:_.slice(0,I)}static compare(_,I){return _===I?0:I.startsWith(_+"\0")?2:_.startsWith(I+"\0")?3:1}constructor(_,I=_.length){if(this.path=_,this.viewEnd=I,_.length===0||I<1)throw new Error("cannot create test with empty path")}get parentId(){return this.viewEnd>1?new C(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let _=1;_<=this.viewEnd;_++)yield new C(this.path,_)}*idsToRoot(){for(let _=this.viewEnd;_>0;_--)yield new C(this.path,_)}compare(_){if(typeof _=="string")return C.compare(this.toString(),_);for(let I=0;I<_.viewEnd&&I<this.viewEnd;I++)if(_.path[I]!==this.path[I])return 1;return _.viewEnd>this.viewEnd?2:_.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let _=1;_<this.viewEnd;_++)this.stringifed+="\0",this.stringifed+=this.path[_]}return this.stringifed}}e.TestId=C}),define(De[64],Ie([1,0,2,35,55]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var P;(function(r){r[r.Unset=0]="Unset",r[r.Queued=1]="Queued",r[r.Running=2]="Running",r[r.Passed=3]="Passed",r[r.Failed=4]="Failed",r[r.Skipped=5]="Skipped",r[r.Errored=6]="Errored"})(P=e.TestResultState||(e.TestResultState={}));var _;(function(r){r[r.Run=2]="Run",r[r.Debug=4]="Debug",r[r.Coverage=8]="Coverage",r[r.HasNonDefaultProfile=16]="HasNonDefaultProfile",r[r.HasConfigurable=32]="HasConfigurable"})(_=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var I;(function(r){r.serialize=a=>({range:a.range.toJSON(),uri:a.uri.toJSON()}),r.deserialize=a=>({range:t.Range.lift(a.range),uri:l.URI.revive(a.uri)})})(I=e.IRichLocation||(e.IRichLocation={}));var w;(function(r){r[r.Error=0]="Error",r[r.Output=1]="Output"})(w=e.TestMessageType||(e.TestMessageType={}));var k;(function(r){r.serialize=a=>({message:a.message,type:0,expected:a.expected,actual:a.actual,location:a.location&&I.serialize(a.location)}),r.deserialize=a=>({message:a.message,type:0,expected:a.expected,actual:a.actual,location:a.location&&I.deserialize(a.location)})})(k=e.ITestErrorMessage||(e.ITestErrorMessage={}));const L=(r,a)=>`${a?"s":"e"}${r}`;e.getMarkId=L;var D;(function(r){r.serialize=a=>({message:a.message,type:1,offset:a.offset,length:a.length,location:a.location&&I.serialize(a.location)}),r.deserialize=a=>({message:a.message,type:1,offset:a.offset,length:a.length,location:a.location&&I.deserialize(a.location)})})(D=e.ITestOutputMessage||(e.ITestOutputMessage={}));var S;(function(r){r.serialize=a=>a.type===0?k.serialize(a):D.serialize(a),r.deserialize=a=>a.type===0?k.deserialize(a):D.deserialize(a)})(S=e.ITestMessage||(e.ITestMessage={}));var T;(function(r){r.serializeWithoutMessages=a=>({state:a.state,duration:a.duration,messages:[]}),r.serialize=a=>({state:a.state,duration:a.duration,messages:a.messages.map(S.serialize)}),r.deserialize=a=>({state:a.state,duration:a.duration,messages:a.messages.map(S.deserialize)})})(T=e.ITestTaskState||(e.ITestTaskState={}));const E="\0",p=(r,a)=>r+E+a;e.namespaceTestTag=p;const b=r=>{const a=r.indexOf(E);return{ctrlId:r.slice(0,a),tagId:r.slice(a+1)}};e.denamespaceTestTag=b;var m;(function(r){r.serialize=a=>({extId:a.extId,label:a.label,tags:a.tags,busy:a.busy,children:void 0,uri:a.uri?.toJSON(),range:a.range?.toJSON()||null,description:a.description,error:a.error,sortText:a.sortText}),r.deserialize=a=>({extId:a.extId,label:a.label,tags:a.tags,busy:a.busy,children:void 0,uri:a.uri?l.URI.revive(a.uri):void 0,range:a.range?t.Range.lift(a.range):null,description:a.description,error:a.error,sortText:a.sortText})})(m=e.ITestItem||(e.ITestItem={}));var v;(function(r){r[r.NotExpandable=0]="NotExpandable",r[r.Expandable=1]="Expandable",r[r.BusyExpanding=2]="BusyExpanding",r[r.Expanded=3]="Expanded"})(v=e.TestItemExpandState||(e.TestItemExpandState={}));var h;(function(r){r.serialize=a=>({expand:a.expand,item:m.serialize(a.item)}),r.deserialize=a=>({controllerId:C.TestId.root(a.item.extId),expand:a.expand,item:m.deserialize(a.item)})})(h=e.InternalTestItem||(e.InternalTestItem={}));var c;(function(r){r.serialize=a=>{let f;return a.item&&(f={},a.item.label!==void 0&&(f.label=a.item.label),a.item.tags!==void 0&&(f.tags=a.item.tags),a.item.busy!==void 0&&(f.busy=a.item.busy),a.item.uri!==void 0&&(f.uri=a.item.uri?.toJSON()),a.item.range!==void 0&&(f.range=a.item.range?.toJSON()),a.item.description!==void 0&&(f.description=a.item.description),a.item.error!==void 0&&(f.error=a.item.error),a.item.sortText!==void 0&&(f.sortText=a.item.sortText)),{extId:a.extId,expand:a.expand,item:f}},r.deserialize=a=>{let f;return a.item&&(f={},a.item.label!==void 0&&(f.label=a.item.label),a.item.tags!==void 0&&(f.tags=a.item.tags),a.item.busy!==void 0&&(f.busy=a.item.busy),a.item.range!==void 0&&(f.range=a.item.range?t.Range.lift(a.item.range):null),a.item.description!==void 0&&(f.description=a.item.description),a.item.error!==void 0&&(f.error=a.item.error),a.item.sortText!==void 0&&(f.sortText=a.item.sortText)),{extId:a.extId,expand:a.expand,item:f}}})(c=e.ITestItemUpdate||(e.ITestItemUpdate={}));const g=(r,a)=>{a.expand!==void 0&&(r.expand=a.expand),a.item!==void 0&&(r.item=r.item?Object.assign(r.item,a.item):a.item)};e.applyTestItemUpdate=g;var n;(function(r){r.serializeWithoutMessages=a=>({...h.serialize(a),ownComputedState:a.ownComputedState,computedState:a.computedState,tasks:a.tasks.map(T.serializeWithoutMessages),retired:a.retired}),r.serialize=a=>({...h.serialize(a),ownComputedState:a.ownComputedState,computedState:a.computedState,tasks:a.tasks.map(T.serialize),retired:a.retired}),r.deserialize=a=>({...h.deserialize(a),ownComputedState:a.ownComputedState,computedState:a.computedState,tasks:a.tasks.map(T.deserialize),retired:!0})})(n=e.TestResultItem||(e.TestResultItem={}));var u;(function(r){r[r.Function=0]="Function",r[r.Statement=1]="Statement"})(u=e.DetailType||(e.DetailType={}));var s;(function(r){r[r.Add=0]="Add",r[r.Update=1]="Update",r[r.DocumentSynced=2]="DocumentSynced",r[r.Remove=3]="Remove",r[r.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",r[r.Retire=5]="Retire",r[r.AddTag=6]="AddTag",r[r.RemoveTag=7]="RemoveTag"})(s=e.TestDiffOpType||(e.TestDiffOpType={}));var i;(function(r){r.deserialize=a=>a.op===0?{op:a.op,item:h.deserialize(a.item)}:a.op===1?{op:a.op,item:c.deserialize(a.item)}:a.op===2?{op:a.op,uri:l.URI.revive(a.uri),docv:a.docv}:a,r.serialize=a=>a.op===0?{op:a.op,item:h.serialize(a.item)}:a.op===1?{op:a.op,item:c.serialize(a.item)}:a})(i=e.TestsDiffOp||(e.TestsDiffOp={}));class o{add(a){}update(a){}remove(a,f){}complete(){}}e.IncrementalChangeCollector=o;class d{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(a){const f=this.createChangeCollector();for(const y of a)switch(y.op){case 0:{const R=h.deserialize(y.item),N=C.TestId.parentId(R.item.extId)?.toString();if(N){if(this.items.has(N)){const M=this.items.get(N);M.children.add(R.item.extId);const A=this.createItem(R,M);this.items.set(R.item.extId,A),f.add(A)}}else{const M=this.createItem(R);this.roots.add(M),this.items.set(R.item.extId,M),f.add(M)}R.expand===2&&this.busyControllerCount++;break}case 1:{const R=c.deserialize(y.item),N=this.items.get(R.extId);if(!N)break;R.expand!==void 0&&(N.expand===2&&this.busyControllerCount--,R.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(N,R),f.update(N);break}case 3:{const R=this.items.get(y.itemId);if(!R)break;const N=C.TestId.parentId(R.item.extId)?.toString();N?this.items.get(N).children.delete(R.item.extId):this.roots.delete(R);const M=[[y.itemId]];for(;M.length;)for(const A of M.pop()){const z=this.items.get(A);z&&(M.push(z.children),this.items.delete(A),f.remove(z,z!==R),z.expand===2&&this.busyControllerCount--)}break}case 5:this.retireTest(y.itemId);break;case 4:this.updatePendingRoots(y.amount);break;case 6:this._tags.set(y.tag.id,y.tag);break;case 7:this._tags.delete(y.id);break}f.complete()}retireTest(a){}updatePendingRoots(a){this.pendingRootCount+=a}createChangeCollector(){return new o}}e.AbstractIncrementalTestCollection=d}),define(De[89],Ie([1,0,18,4,6,48,64,55]),function(J,e,l,t,C,P,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var w;(function(m){m[m.Upsert=0]="Upsert",m[m.SetTags=1]="SetTags",m[m.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",m[m.RemoveChild=3]="RemoveChild",m[m.SetProp=4]="SetProp",m[m.Bulk=5]="Bulk",m[m.DocumentSynced=6]="DocumentSynced"})(w=e.TestItemEventOp||(e.TestItemEventOp={}));const k=(m,v)=>m===v,L={range:(m,v)=>m===v?!0:!m||!v?!1:m.equalsRange(v),busy:k,label:k,description:k,error:k,tags:(m,v)=>!(m.length!==v.length||m.some(h=>!v.includes(h)))},D=(m,v)=>{let h;for(const[c,g]of Object.entries(L))g(m[c],v[c])||(h?h[c]=v[c]:h={[c]:v[c]});return h};class S extends C.Disposable{get root(){return this.options.root}constructor(v){super(),this.options=v,this.debounceSendDiff=this._register(new l.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(v){this._resolveHandler=v;for(const h of this.tree.values())this.updateExpandability(h)}collectDiff(){const v=this.diff;return this.diff=[],v}pushDiff(v){switch(v.op){case 2:{for(const h of this.diff)if(h.op===2&&h.uri===v.uri){h.docv=v.docv;return}break}case 1:{const h=this.diff[this.diff.length-1];if(h){if(h.op===1&&h.item.extId===v.item.extId){(0,_.applyTestItemUpdate)(h.item,v.item);return}if(h.op===0&&h.item.item.extId===v.item.extId){(0,_.applyTestItemUpdate)(h.item,v.item);return}}break}}this.diff.push(v),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(v,h){const c=this.tree.get(v);if(!!c){if((c.expandLevels===void 0||h>c.expandLevels)&&(c.expandLevels=h),c.expand===1){const g=this.resolveChildren(c);return g.isOpen()?this.expandChildren(c,h-1):g.wait().then(()=>this.expandChildren(c,h-1))}else if(c.expand===3)return c.resolveBarrier?.isOpen()===!1?c.resolveBarrier.wait().then(()=>this.expandChildren(c,h-1)):this.expandChildren(c,h-1)}}dispose(){for(const v of this.tree.values())this.options.getApiFor(v.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(v,h){switch(h.op){case 3:this.removeItem(I.TestId.joinToString(v.fullId,h.id));break;case 0:this.upsertItem(h.item,v);break;case 5:for(const c of h.ops)this.onTestItemEvent(v,c);break;case 1:this.diffTagRefs(h.new,h.old,v.fullId.toString());break;case 2:this.updateExpandability(v);break;case 4:this.pushDiff({op:1,item:{extId:v.fullId.toString(),item:h.update}});break;case 6:this.documentSynced(v.actual.uri);break;default:(0,P.assertNever)(h)}}documentSynced(v){v&&this.pushDiff({op:2,uri:v,docv:this.options.getDocumentVersion(v)})}upsertItem(v,h){const c=I.TestId.fromExtHostTestItem(v,this.root.id,h?.actual),g=this.options.getApiFor(v);g.parent&&g.parent!==h?.actual&&this.options.getChildren(g.parent).delete(v.id);let n=this.tree.get(c.toString());if(!n){n={fullId:c,actual:v,expandLevels:h?.expandLevels?h.expandLevels-1:void 0,expand:0},v.tags.forEach(this.incrementTagRefs,this),this.tree.set(n.fullId.toString(),n),this.setItemParent(v,h),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:n.expand,item:this.options.toITestItem(v)}}),this.connectItemAndChildren(v,n,h);return}if(n.actual===v){this.connectItem(v,n,h);return}const u=this.options.getChildren(n.actual),s=n.actual,i=D(this.options.toITestItem(s),this.options.toITestItem(v));this.options.getApiFor(s).listener=void 0,n.actual=v,n.expand=0,i&&(i.hasOwnProperty("tags")&&(this.diffTagRefs(v.tags,s.tags,c.toString()),delete i.tags),this.onTestItemEvent(n,{op:4,update:i})),this.connectItemAndChildren(v,n,h);for(const[o,d]of u)this.options.getChildren(v).get(d.id)||this.removeItem(I.TestId.joinToString(c,d.id));this.documentSynced(n.actual.uri)}diffTagRefs(v,h,c){const g=new Set(h.map(n=>n.id));for(const n of v)g.delete(n.id)||this.incrementTagRefs(n);this.pushDiff({op:1,item:{extId:c,item:{tags:v.map(n=>(0,_.namespaceTestTag)(this.options.controllerId,n.id))}}}),g.forEach(this.decrementTagRefs,this)}incrementTagRefs(v){const h=this.tags.get(v.id);h?h.refCount++:(this.tags.set(v.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,_.namespaceTestTag)(this.options.controllerId,v.id)}}))}decrementTagRefs(v){const h=this.tags.get(v);h&&!--h.refCount&&(this.tags.delete(v),this.pushDiff({op:7,id:(0,_.namespaceTestTag)(this.options.controllerId,v)}))}setItemParent(v,h){this.options.getApiFor(v).parent=h&&h.actual!==this.root?h.actual:void 0}connectItem(v,h,c){this.setItemParent(v,c);const g=this.options.getApiFor(v);g.parent=c?.actual,g.listener=n=>this.onTestItemEvent(h,n),this.updateExpandability(h)}connectItemAndChildren(v,h,c){this.connectItem(v,h,c);for(const[g,n]of this.options.getChildren(v))this.upsertItem(n,h)}updateExpandability(v){let h;this._resolveHandler?v.resolveBarrier?h=v.resolveBarrier.isOpen()?3:2:h=v.actual.canResolveChildren?1:0:h=0,h!==v.expand&&(v.expand=h,this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:h}}),h===1&&v.expandLevels!==void 0&&this.resolveChildren(v))}expandChildren(v,h){if(h<0)return;const c=[];for(const[g,n]of this.options.getChildren(v.actual)){const u=this.expand(I.TestId.joinToString(v.fullId,n.id),h);(0,l.isThenable)(u)&&c.push(u)}if(c.length)return Promise.all(c).then(()=>{})}resolveChildren(v){if(v.resolveBarrier)return v.resolveBarrier;if(!this._resolveHandler){const n=new l.Barrier;return n.open(),n}v.expand=2,this.pushExpandStateUpdate(v);const h=v.resolveBarrier=new l.Barrier,c=n=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,n)};let g;try{g=this._resolveHandler(v.actual===this.root?void 0:v.actual)}catch(n){c(n)}return(0,l.isThenable)(g)?g.catch(c).then(()=>{h.open(),this.updateExpandability(v)}):(h.open(),this.updateExpandability(v)),v.resolveBarrier}pushExpandStateUpdate(v){this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:v.expand}})}removeItem(v){const h=this.tree.get(v);if(!h)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:v});const c=[h];for(;c.length;){const g=c.pop();if(!!g){this.options.getApiFor(g.actual).listener=void 0;for(const n of g.actual.tags)this.decrementTagRefs(n.id);this.tree.delete(g.fullId.toString());for(const[n,u]of this.options.getChildren(g.actual))c.push(this.tree.get(I.TestId.joinToString(g.fullId,u.id)))}}}flushDiff(){const v=this.collectDiff();v.length&&this.diffOpEmitter.fire(v)}}e.TestItemCollection=S;class T extends Error{constructor(v){super(`Attempted to insert a duplicate test item ID ${v}`)}}e.DuplicateTestItemError=T;class E extends Error{constructor(v){super(`TestItem with ID "${v}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=E;class p extends Error{constructor(v,h,c){super(`TestItem with ID "${v}" is from controller "${h}" and cannot be added as a child of an item from controller "${c}".`)}}e.MixedTestItemController=p;const b=(m,v,h)=>{let c=new Map;return{get size(){return c.size},forEach(g,n){for(const u of c.values())g.call(n,u,this)},[Symbol.iterator](){return c.entries()},replace(g){const n=new Map,u=new Set(c.keys()),s={op:5,ops:[]};for(const i of g){if(!(i instanceof h))throw new E(i.id);const o=v(i).controllerId;if(o!==m.controllerId)throw new p(i.id,o,m.controllerId);if(n.has(i.id))throw new T(i.id);n.set(i.id,i),u.delete(i.id),s.ops.push({op:0,item:i})}for(const i of u.keys())s.ops.push({op:3,id:i});m.listener?.(s),c=n},add(g){if(!(g instanceof h))throw new E(g.id);c.set(g.id,g),m.listener?.({op:0,item:g})},delete(g){c.delete(g)&&m.listener?.({op:3,id:g})},get(g){return c.get(g)},toJSON(){return Array.from(c.values())}}};e.createTestItemChildren=b}),define(De[129],Ie([1,0,89]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const t=new WeakMap,C=(_,I)=>{const w={controllerId:I};return t.set(_,w),w};e.createPrivateApiFor=C;const P=_=>{const I=t.get(_);if(!I)throw new l.InvalidTestItemError(_?.id||"<unknown>");return I};e.getPrivateApiFor=P}),define(De[217],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,l.createDecorator)("configurationResolverService");var t;(function(P){P.Unknown="unknown",P.Env="env",P.Config="config",P.Command="command",P.Input="input",P.ExtensionInstallFolder="extensionInstallFolder",P.WorkspaceFolder="workspaceFolder",P.Cwd="cwd",P.WorkspaceFolderBasename="workspaceFolderBasename",P.UserHome="userHome",P.LineNumber="lineNumber",P.SelectedText="selectedText",P.File="file",P.FileWorkspaceFolder="fileWorkspaceFolder",P.RelativeFile="relativeFile",P.RelativeFileDirname="relativeFileDirname",P.FileDirname="fileDirname",P.FileExtname="fileExtname",P.FileBasename="fileBasename",P.FileBasenameNoExtension="fileBasenameNoExtension",P.FileDirnameBasename="fileDirnameBasename",P.ExecPath="execPath",P.ExecInstallFolder="execInstallFolder",P.PathSeparator="pathSeparator"})(t=e.VariableKind||(e.VariableKind={}));class C extends Error{constructor(_,I){super(I),this.variable=_}}e.VariableError=C}),define(De[218],Ie([1,0,9,41,16,24,11,107,185,217,8]),function(J,e,l,t,C,P,_,I,w,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class D{constructor(T,E,p,b){this._contributedVariables=new Map,this._context=T,this._labelService=E,this._userHomePromise=p,b&&(this._envVariablesPromise=b.then(m=>this.prepareEnv(m)))}prepareEnv(T){if(_.isWindows){const E=Object.create(null);return Object.keys(T).forEach(p=>{E[p.toLowerCase()]=T[p]}),E}return T}resolveWithEnvironment(T,E,p){return this.recursiveResolve({env:this.prepareEnv(T),userHome:void 0},E?E.uri:void 0,p)}async resolveAsync(T,E){const p={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(p,T?T.uri:void 0,E)}async resolveAnyBase(T,E,p,b){const m=P.deepClone(E);_.isWindows&&m.windows?Object.keys(m.windows).forEach(h=>m[h]=m.windows[h]):_.isMacintosh&&m.osx?Object.keys(m.osx).forEach(h=>m[h]=m.osx[h]):_.isLinux&&m.linux&&Object.keys(m.linux).forEach(h=>m[h]=m.linux[h]),delete m.windows,delete m.osx,delete m.linux;const v={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(v,T?T.uri:void 0,m,p,b)}async resolveAnyAsync(T,E,p){return this.resolveAnyBase(T,E,p)}async resolveAnyMap(T,E,p){const b=new Map;return{newConfig:await this.resolveAnyBase(T,E,p,b),resolvedVariables:b}}resolveWithInteractionReplace(T,E,p,b){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(T,E,p,b){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(T,E){if(this._contributedVariables.has(T))throw new Error("Variable "+T+" is contributed twice.");this._contributedVariables.set(T,E)}async recursiveResolve(T,E,p,b,m){if(C.isString(p))return this.resolveString(T,E,p,b,m);if(Array.isArray(p))return Promise.all(p.map(v=>this.recursiveResolve(T,E,v,b,m)));if(C.isObject(p)){const v=Object.create(null),h=await Promise.all(Object.keys(p).map(async c=>[await this.resolveString(T,E,c,b,m),await this.recursiveResolve(T,E,p[c],b,m)]));for(const[c,g]of h)v[c]=g;return v}return p}resolveString(T,E,p,b,m){return(0,L.replaceAsync)(p,D.VARIABLE_REGEXP,async(v,h)=>{if(h.includes(D.VARIABLE_LHS))return v;let c=await this.evaluateSingleVariable(T,v,h,E,b);return m?.set(h,c),c!==v&&C.isString(c)&&c.match(D.VARIABLE_REGEXP)&&(c=await this.resolveString(T,E,c,b,m)),c})}fsPath(T){return this._labelService?this._labelService.getUriLabel(T,{noPrefix:!0}):T.fsPath}async evaluateSingleVariable(T,E,p,b,m){let v;const h=p.split(":");h.length>1&&(p=h[0],v=h[1]);const c=u=>{const s=this._context.getFilePath();if(s)return s;throw new k.VariableError(u,(0,w.localize)(0,null,E))},g=u=>{const s=c(u);if(this._context.getWorkspaceFolderPathForFile){const i=this._context.getWorkspaceFolderPathForFile();if(i)return i}throw new k.VariableError(u,(0,w.localize)(1,null,E,l.basename(s)))},n=u=>{if(v){const s=this._context.getFolderUri(v);if(s)return s;throw new k.VariableError(u,(0,w.localize)(2,null,E,v))}if(b)return b;throw this._context.getWorkspaceFolderCount()>1?new k.VariableError(u,(0,w.localize)(3,null,E)):new k.VariableError(u,(0,w.localize)(4,null,E))};switch(p){case"env":if(v){if(T.env){const u=T.env[_.isWindows?v.toLowerCase():v];if(C.isString(u))return u}return""}throw new k.VariableError(k.VariableKind.Env,(0,w.localize)(5,null,E));case"config":if(v){const u=this._context.getConfigurationValue(b,v);if(C.isUndefinedOrNull(u))throw new k.VariableError(k.VariableKind.Config,(0,w.localize)(6,null,E,v));if(C.isObject(u))throw new k.VariableError(k.VariableKind.Config,(0,w.localize)(7,null,E,v));return u}throw new k.VariableError(k.VariableKind.Config,(0,w.localize)(8,null,E));case"command":return this.resolveFromMap(k.VariableKind.Command,E,v,m,"command");case"input":return this.resolveFromMap(k.VariableKind.Input,E,v,m,"input");case"extensionInstallFolder":if(v){const u=await this._context.getExtension(v);if(!u)throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,w.localize)(9,null,E,v));return this.fsPath(u.extensionLocation)}throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,w.localize)(10,null,E));default:switch(p){case"workspaceRoot":case"workspaceFolder":return(0,I.normalizeDriveLetter)(this.fsPath(n(k.VariableKind.WorkspaceFolder)));case"cwd":return b||v?(0,I.normalizeDriveLetter)(this.fsPath(n(k.VariableKind.Cwd))):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return l.basename(this.fsPath(n(k.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(T.userHome)return T.userHome;throw new k.VariableError(k.VariableKind.UserHome,(0,w.localize)(11,null,E))}case"lineNumber":{const u=this._context.getLineNumber();if(u)return u;throw new k.VariableError(k.VariableKind.LineNumber,(0,w.localize)(12,null,E))}case"selectedText":{const u=this._context.getSelectedText();if(u)return u;throw new k.VariableError(k.VariableKind.SelectedText,(0,w.localize)(13,null,E))}case"file":return c(k.VariableKind.File);case"fileWorkspaceFolder":return g(k.VariableKind.FileWorkspaceFolder);case"relativeFile":return b||v?l.relative(this.fsPath(n(k.VariableKind.RelativeFile)),c(k.VariableKind.RelativeFile)):c(k.VariableKind.RelativeFile);case"relativeFileDirname":{const u=l.dirname(c(k.VariableKind.RelativeFileDirname));if(b||v){const s=l.relative(this.fsPath(n(k.VariableKind.RelativeFileDirname)),u);return s.length===0?".":s}return u}case"fileDirname":return l.dirname(c(k.VariableKind.FileDirname));case"fileExtname":return l.extname(c(k.VariableKind.FileExtname));case"fileBasename":return l.basename(c(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const u=l.basename(c(k.VariableKind.FileBasenameNoExtension));return u.slice(0,u.length-l.extname(u).length)}case"fileDirnameBasename":return l.basename(l.dirname(c(k.VariableKind.FileDirnameBasename)));case"execPath":{const u=this._context.getExecPath();return u||E}case"execInstallFolder":{const u=this._context.getAppRoot();return u||E}case"pathSeparator":return l.sep;default:try{const u=v?`${p}:${v}`:p;return this.resolveFromMap(k.VariableKind.Unknown,E,u,m,void 0)}catch{return E}}}}resolveFromMap(T,E,p,b,m){if(p&&b){const v=m===void 0?b[p]:b[m+":"+p];if(typeof v=="string")return v;throw new k.VariableError(T,(0,w.localize)(14,null,E))}return E}}e.AbstractVariableResolverService=D,D.VARIABLE_LHS="${",D.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(De[130],Ie([1,0,3,127]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,l.createDecorator)("editorGroupsService");var C;(function(E){E[E.UP=0]="UP",E[E.DOWN=1]="DOWN",E[E.LEFT=2]="LEFT",E[E.RIGHT=3]="RIGHT"})(C=e.GroupDirection||(e.GroupDirection={}));var P;(function(E){E[E.HORIZONTAL=0]="HORIZONTAL",E[E.VERTICAL=1]="VERTICAL"})(P=e.GroupOrientation||(e.GroupOrientation={}));var _;(function(E){E[E.FIRST=0]="FIRST",E[E.LAST=1]="LAST",E[E.NEXT=2]="NEXT",E[E.PREVIOUS=3]="PREVIOUS"})(_=e.GroupLocation||(e.GroupLocation={}));var I;(function(E){E[E.MAXIMIZE=0]="MAXIMIZE",E[E.EVEN=1]="EVEN",E[E.TOGGLE=2]="TOGGLE"})(I=e.GroupsArrangement||(e.GroupsArrangement={}));var w;(function(E){E[E.COPY_EDITORS=0]="COPY_EDITORS",E[E.MOVE_EDITORS=1]="MOVE_EDITORS"})(w=e.MergeGroupMode||(e.MergeGroupMode={}));function k(E){const p=E;return(0,t.isEditorInput)(p?.editor)&&(0,t.isEditorInput)(p?.replacement)}e.isEditorReplacement=k;var L;(function(E){E[E.CREATION_TIME=0]="CREATION_TIME",E[E.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",E[E.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L=e.GroupsOrder||(e.GroupsOrder={}));var D;(function(E){E[E.NEW_EDITOR=1]="NEW_EDITOR",E[E.MOVE_EDITOR=2]="MOVE_EDITOR",E[E.COPY_EDITOR=3]="COPY_EDITOR"})(D=e.OpenEditorContext||(e.OpenEditorContext={}));function S(E){const p=E;return!!p&&typeof p.id=="number"&&Array.isArray(p.editors)}e.isEditorGroup=S;function T(E){return E.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=T}),define(De[219],Ie([1,0,3,130]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,l.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function C(P){const _=P;return typeof P=="number"||(0,t.isEditorGroup)(_)}e.isPreferredGroup=C}),define(De[220],Ie([1,0,3,190]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,l.refineServiceDecorator)(t.IEnvironmentService)}),define(De[221],Ie([1,0,27,4,9]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class P{constructor(D){this.removedDueToLooping=D}}e.DeltaExtensionsResult=P;class _{constructor(D){this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=D,this._initialize()}_initialize(){this._extensionDescriptions.sort(w),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const D of this._extensionDescriptions){if(this._extensionsMap.has(l.ExtensionIdentifier.toKey(D.identifier))){console.error("Extension `"+D.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(l.ExtensionIdentifier.toKey(D.identifier),D),this._extensionsArr.push(D),Array.isArray(D.activationEvents))for(let S of D.activationEvents)S==="onUri"&&(S=`onUri:${l.ExtensionIdentifier.toKey(D.identifier)}`),this._activationMap.has(S)||this._activationMap.set(S,[]),this._activationMap.get(S).push(D)}}set(D){this._extensionDescriptions=D,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(D,S){this._extensionDescriptions=k(this._extensionDescriptions,S),this._extensionDescriptions=this._extensionDescriptions.concat(D);const T=_._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=k(this._extensionDescriptions,T.map(E=>E.identifier)),this._initialize(),this._onDidChange.fire(void 0),new P(T)}static _findLoopingExtensions(D){const S=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(m){this._nodesSet.has(m)||(this._nodesSet.add(m),this._nodesArr.push(m))}addArc(m,v){this.addNode(m),this.addNode(v),this._arcs.has(m)?this._arcs.get(m).push(v):this._arcs.set(m,[v])}getArcs(m){return this._arcs.has(m)?this._arcs.get(m):[]}hasOnlyGoodArcs(m,v){const h=S.getArcs(m);for(let c=0;c<h.length;c++)if(!v.has(h[c]))return!1;return!0}getNodes(){return this._nodesArr}},T=new Map;for(const m of D){const v=l.ExtensionIdentifier.toKey(m.identifier);if(T.set(v,m),m.extensionDependencies)for(const h of m.extensionDependencies){const c=l.ExtensionIdentifier.toKey(h);S.addArc(v,c)}}const E=new Set;S.getNodes().filter(m=>S.getArcs(m).length===0).forEach(m=>E.add(m));const p=S.getNodes().filter(m=>!E.has(m));let b;do{b=!1;for(let m=0;m<p.length;m++){const v=p[m];S.hasOnlyGoodArcs(v,E)&&(p.splice(m,1),m--,E.add(v),b=!0)}}while(b);return p.map(m=>T.get(m))}containsActivationEvent(D){return this._activationMap.has(D)}containsExtension(D){return this._extensionsMap.has(l.ExtensionIdentifier.toKey(D))}getExtensionDescriptionsForActivationEvent(D){const S=this._activationMap.get(D);return S?S.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(D){const S=this._extensionsMap.get(l.ExtensionIdentifier.toKey(D));return S||void 0}getExtensionDescriptionByUUID(D){for(const S of this._extensionsArr)if(S.uuid===D)return S}getExtensionDescriptionByIdOrUUID(D,S){return this.getExtensionDescription(D)??(S?this.getExtensionDescriptionByUUID(S):void 0)}}e.ExtensionDescriptionRegistry=_;var I;(function(L){L[L.Builtin=0]="Builtin",L[L.User=1]="User",L[L.Dev=2]="Dev"})(I||(I={}));function w(L,D){const S=L.isBuiltin?0:L.isUnderDevelopment?2:1,T=D.isBuiltin?0:D.isUnderDevelopment?2:1;if(S!==T)return S-T;const E=C.posix.basename(L.extensionLocation.path),p=C.posix.basename(D.extensionLocation.path);return E<p?-1:E>p?1:0}function k(L,D){const S=new Set;return D.forEach(T=>S.add(l.ExtensionIdentifier.toKey(T))),L.filter(T=>!S.has(l.ExtensionIdentifier.toKey(T.identifier)))}}),define(De[222],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var l;(function(L){L[L.IPC=1]="IPC",L[L.Socket=2]="Socket",L[L.MessagePort=3]="MessagePort"})(l=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class t{constructor(D){this.pipeName=D,this.type=1}serialize(D){D[t.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=t,t.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class C{constructor(){this.type=2}serialize(D){D[C.ENV_KEY]="1"}}e.SocketExtHostConnection=C,C.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class P{constructor(){this.type=3}serialize(D){D[P.ENV_KEY]="1"}}e.MessagePortExtHostConnection=P,P.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function _(L){delete L[t.ENV_KEY],delete L[C.ENV_KEY],delete L[P.ENV_KEY]}function I(L,D){_(D),L.serialize(D)}e.writeExtHostConnection=I;function w(L){if(L[t.ENV_KEY])return k(L,new t(L[t.ENV_KEY]));if(L[C.ENV_KEY])return k(L,new C);if(L[P.ENV_KEY])return k(L,new P);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=w;function k(L,D){return _(L),D}}),define(De[131],Ie([1,0,23]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var t;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(t=e.UIKind||(e.UIKind={}));var C;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(C=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var P;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(P=e.MessageType||(e.MessageType={}));function _(k){const L=l.VSBuffer.alloc(1);switch(k){case 0:L.writeUInt8(1,0);break;case 1:L.writeUInt8(2,0);break;case 2:L.writeUInt8(3,0);break}return L}e.createMessageOfType=_;function I(k,L){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return L===0;case 2:return L===1;case 3:return L===2;default:return!1}}e.isMessageOfType=I;var w;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})(w=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(De[28],Ie([1,0,4,2,3,27,199]),function(J,e,l,t,C,P,_){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new P.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,C.createDecorator)("extensionService");class w{constructor(d){this.affinity=d,this.kind=1}equals(d){return this.kind===d.kind&&this.affinity===d.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=w;class k{constructor(){this.kind=2,this.affinity=0}equals(d){return this.kind===d.kind}asString(){return"LocalWebWorker"}}e.LocalWebWorkerRunningLocation=k;class L{constructor(){this.kind=3,this.affinity=0}equals(d){return this.kind===d.kind}asString(){return"Remote"}}e.RemoteRunningLocation=L;class D{constructor(d){this.dependency=d}}e.MissingExtensionDependency=D;var S;(function(o){o[o.LocalProcess=1]="LocalProcess",o[o.LocalWebWorker=2]="LocalWebWorker",o[o.Remote=3]="Remote"})(S=e.ExtensionHostKind||(e.ExtensionHostKind={}));function T(o){if(o===null)return"None";switch(o){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=T;class E{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(d,r){const a=[],f=[],y=[],R=[],N=m(this._allExtensions),M=m(d),A=(G,B)=>G.extensionLocation.toString()===B.extensionLocation.toString()||G.isBuiltin===B.isBuiltin||G.isUserBuiltin===B.isUserBuiltin||G.isUnderDevelopment===B.isUnderDevelopment;for(const G of this._allExtensions){const B=M.get(P.ExtensionIdentifier.toKey(G.identifier));if(!B){a.push(G.identifier),N.delete(P.ExtensionIdentifier.toKey(G.identifier));continue}if(!A(G,B)){a.push(G.identifier),N.delete(P.ExtensionIdentifier.toKey(G.identifier));continue}}for(const G of d){const B=N.get(P.ExtensionIdentifier.toKey(G.identifier));if(!B){f.push(G);continue}if(!A(B,G)){a.push(B.identifier),N.delete(P.ExtensionIdentifier.toKey(B.identifier));continue}}const z=b(this._myExtensions),H=b(r);for(const G of this._myExtensions)H.has(P.ExtensionIdentifier.toKey(G))||y.push(G);for(const G of r)z.has(P.ExtensionIdentifier.toKey(G))||R.push(G);const F={toRemove:a,toAdd:f,myToRemove:y,myToAdd:R};return this.delta(F),F}delta(d){const{toRemove:r,toAdd:a,myToRemove:f,myToAdd:y}=d,R=b(r),N=b(f);for(let M=0;M<this._allExtensions.length;M++)R.has(P.ExtensionIdentifier.toKey(this._allExtensions[M].identifier))&&(this._allExtensions.splice(M,1),M--);for(let M=0;M<this._myExtensions.length;M++)N.has(P.ExtensionIdentifier.toKey(this._myExtensions[M]))&&(this._myExtensions.splice(M,1),M--);for(const M of a)this._allExtensions.push(M);for(const M of y)this._myExtensions.push(M)}containsExtension(d){for(const r of this._myExtensions)if(P.ExtensionIdentifier.equals(r,d))return!0;return!1}}e.ExtensionHostExtensions=E;class p{constructor(d){if(this[I]="ExtensionIdentifierSet",this._map=new Map,this._toKey=P.ExtensionIdentifier.toKey,d)for(const r of d)this.add(r)}get size(){return this._map.size}add(d){return this._map.set(this._toKey(d),d),this}clear(){this._map.clear()}delete(d){return this._map.delete(this._toKey(d))}has(d){return this._map.has(this._toKey(d))}forEach(d,r){this._map.forEach(a=>d.call(r,a,a,this))}*entries(){for(const[d,r]of this._map)yield[r,r]}keys(){return this._map.values()}values(){return this._map.values()}[(I=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=p;function b(o){const d=new Set;for(const r of o)d.add(P.ExtensionIdentifier.toKey(r));return d}e.extensionIdentifiersArrayToSet=b;function m(o){const d=new Map;for(const r of o)d.set(P.ExtensionIdentifier.toKey(r.identifier),r);return d}function v(o,d){return o.enabledApiProposals?o.enabledApiProposals.includes(d):!1}e.isProposedApiEnabled=v;function h(o,d){if(!v(o,d))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${d}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${d}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.checkProposedApiEnabled=h;class c{constructor(d,r,a,f){this.codeLoadingTime=d,this.activateCallTime=r,this.activateResolvedTime=a,this.activationReason=f}}e.ActivationTimes=c;class g{constructor(d,r){this.description=d,this.value=r}}e.ExtensionPointContribution=g,e.ExtensionHostLogFileName="exthost";var n;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(n=e.ActivationKind||(e.ActivationKind={}));function u(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,_.getGalleryExtensionId)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}e.toExtension=u;function s(o,d){return{identifier:new P.ExtensionIdentifier((0,_.getExtensionId)(o.manifest.publisher,o.manifest.name)),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!d,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform,browserNlsBundleUris:o.browserNlsBundleUris}}e.toExtensionDescription=s;class i{constructor(){this.onDidRegisterExtensions=l.Event.None,this.onDidChangeExtensionsStatus=l.Event.None,this.onDidChangeExtensions=l.Event.None,this.onWillActivateByEvent=l.Event.None,this.onDidChangeResponsiveChange=l.Event.None,this.extensions=[]}activateByEvent(d){return Promise.resolve(void 0)}activationEventIsDone(d){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(d){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(d,r){return Promise.resolve(0)}getInspectPorts(d,r){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(d){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(d,r){return Promise.resolve()}}e.NullExtensionService=i}),define(De[223],Ie([1,0,10,27,28,13,18]),function(J,e,l,t,C,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class I{constructor(b,m,v,h){this.startup=b,this.codeLoadingTime=m,this.activateCallTime=v,this.activateResolvedTime=h}}e.ExtensionActivationTimes=I,I.NONE=new I(!1,-1,-1,-1);class w{constructor(b){this._startup=b,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(b,m){return b===-1||m===-1?-1:m-b}build(){return new I(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=w;class k{constructor(b,m,v,h,c,g){this.activationFailed=b,this.activationFailedError=m,this.activationTimes=v,this.module=h,this.exports=c,this.subscriptions=g}}e.ActivatedExtension=k;class L extends k{constructor(b){super(!1,null,b,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=L;class D extends k{constructor(){super(!1,null,I.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=D;class S extends k{constructor(b){super(!0,b,I.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=S;let T=class{constructor(b,m,v,h,c){this._logService=c,this._registry=b,this._resolvedExtensionsSet=new Set,m.forEach(g=>this._resolvedExtensionsSet.add(t.ExtensionIdentifier.toKey(g))),this._externalExtensionsMap=new Map,v.forEach(g=>this._externalExtensionsMap.set(t.ExtensionIdentifier.toKey(g),g)),this._host=h,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[b,m]of this._operations)m.dispose()}isActivated(b){const m=this._operations.get(t.ExtensionIdentifier.toKey(b));return Boolean(m&&m.value)}getActivatedExtension(b){const m=this._operations.get(t.ExtensionIdentifier.toKey(b));if(!m||!m.value)throw new Error(`Extension '${b.value}' is not known or not activated`);return m.value}async activateByEvent(b,m){if(this._alreadyActivatedEvents[b])return;const v=this._registry.getExtensionDescriptionsForActivationEvent(b);await this._activateExtensions(v.map(h=>({id:h.identifier,reason:{startup:m,extensionId:h.identifier,activationEvent:b}}))),this._alreadyActivatedEvents[b]=!0}activateById(b,m){const v=this._registry.getExtensionDescription(b);if(!v)throw new Error(`Extension '${b}' is not known`);return this._activateExtensions([{id:v.identifier,reason:m}])}async _activateExtensions(b){const m=b.filter(v=>!this.isActivated(v.id)).map(v=>this._handleActivationRequest(v));await Promise.all(m.map(v=>v.wait()))}_handleActivationRequest(b){if(this._operations.has(t.ExtensionIdentifier.toKey(b.id)))return this._operations.get(t.ExtensionIdentifier.toKey(b.id));if(this._externalExtensionsMap.has(t.ExtensionIdentifier.toKey(b.id)))return this._createAndSaveOperation(b,null,[],null);const m=this._registry.getExtensionDescription(b.id);if(!m){const c=new Error(`Cannot activate unknown extension '${b.id.value}'`),g=this._createAndSaveOperation(b,null,[],new S(c));return this._host.onExtensionActivationError(b.id,c,new C.MissingExtensionDependency(b.id.value)),g}const v=[],h=typeof m.extensionDependencies>"u"?[]:m.extensionDependencies;for(const c of h){if(this._resolvedExtensionsSet.has(t.ExtensionIdentifier.toKey(c)))continue;const g=this._operations.get(t.ExtensionIdentifier.toKey(c));if(g){v.push(g);continue}if(this._externalExtensionsMap.has(t.ExtensionIdentifier.toKey(c))){v.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(t.ExtensionIdentifier.toKey(c)),reason:b.reason}));continue}const n=this._registry.getExtensionDescription(c);if(n){if(!n.main&&!n.browser)continue;v.push(this._handleActivationRequest({id:n.identifier,reason:b.reason}));continue}const u=m.displayName||m.identifier.value,s=new Error(`Cannot activate the '${u}' extension because it depends on unknown extension '${c}'`),i=this._createAndSaveOperation(b,m.displayName,[],new S(s));return this._host.onExtensionActivationError(m.identifier,s,new C.MissingExtensionDependency(c)),i}return this._createAndSaveOperation(b,m.displayName,v,null)}_createAndSaveOperation(b,m,v,h){const c=new E(b.id,m,b.reason,v,h,this._host,this._logService);return this._operations.set(t.ExtensionIdentifier.toKey(b.id),c),c}};T=je([$e(4,P.ILogService)],T),e.ExtensionsActivator=T;let E=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(b,m,v,h,c,g,n){this._id=b,this._displayName=m,this._reason=v,this._deps=h,this._value=c,this._host=g,this._logService=n,this._barrier=new _.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let b=0;b<this._deps.length;b++){const m=this._deps[b];if(m.value&&!m.value.activationFailed){this._deps.splice(b,1),b--;continue}if(m.value&&m.value.activationFailed){const v=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${m.friendlyName}' failed to activate`);v.detail=m.value.activationFailedError,this._value=new S(v),this._host.onExtensionActivationError(this._id,v,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(b=>b.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(b){const m=new Error;if(b&&b.name&&(m.name=b.name),b&&b.message?m.message=`Activating extension '${this._id.value}' failed: ${b.message}.`:m.message=`Activating extension '${this._id.value}' failed: ${b}.`,b&&b.stack&&(m.stack=b.stack),this._value=new S(m),this._isDisposed&&l.isCancellationError(b))return;this._host.onExtensionActivationError(this._id,m,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(b)}}};E=je([$e(6,P.ILogService)],E)}),define(De[224],Ie([1,0,13,25,28]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let P=class extends l.LogService{constructor(I,w){super(I.createLogger(w.logFile,{name:C.ExtensionHostLogFileName}))}};P=je([$e(0,l.ILoggerService),$e(1,t.IExtHostInitDataService)],P),e.ExtHostLogService=P});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,l):C?C.value=l:e.set(J,l),l},Be=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[7],Ie([1,0,17,10,106,26,101,8,16,2,34,37,123,88,28]),function(J,e,l,t,C,P,_,I,w,k,L,D,S,T,E){"use strict";var p,b,m,v,h,c,g,n,u,s,i,o,d,r,a,f,y,R,N,M,A,z,H;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function F(j){return Object.assign(j,{apply:function(){const ue=arguments.length===1?[]:arguments[1];return Reflect.construct(j,ue,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(j,[]);{const[ue,...Te]=arguments;return Reflect.construct(j,Te,ue.constructor)}}})}let G=c=class{static from(...W){let ue=W;return new c(function(){if(ue){for(const Te of ue)Te&&typeof Te.dispose=="function"&&Te.dispose();ue=void 0}})}constructor(W){p.set(this,void 0),tt(this,p,W,"f")}dispose(){typeof Be(this,p,"f")=="function"&&(Be(this,p,"f").call(this),tt(this,p,void 0,"f"))}};p=new WeakMap,G=c=je([F],G),e.Disposable=G;let B=g=class{static Min(...W){if(W.length===0)throw new TypeError;let ue=W[0];for(let Te=1;Te<W.length;Te++){const Xe=W[Te];Xe.isBefore(ue)&&(ue=Xe)}return ue}static Max(...W){if(W.length===0)throw new TypeError;let ue=W[0];for(let Te=1;Te<W.length;Te++){const Xe=W[Te];Xe.isAfter(ue)&&(ue=Xe)}return ue}static isPosition(W){if(!W)return!1;if(W instanceof g)return!0;const{line:ue,character:Te}=W;return typeof ue=="number"&&typeof Te=="number"}static of(W){if(W instanceof g)return W;if(this.isPosition(W))return new g(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(W,ue){if(W<0)throw(0,t.illegalArgument)("line must be non-negative");if(ue<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=W,this._character=ue}isBefore(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<W._character}isBeforeOrEqual(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<=W._character}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this._line===W._line&&this._character===W._character}compareTo(W){return this._line<W._line?-1:this._line>W.line?1:this._character<W._character?-1:this._character>W._character?1:0}translate(W,ue=0){if(W===null||ue===null)throw(0,t.illegalArgument)();let Te;return typeof W>"u"?Te=0:typeof W=="number"?Te=W:(Te=typeof W.lineDelta=="number"?W.lineDelta:0,ue=typeof W.characterDelta=="number"?W.characterDelta:0),Te===0&&ue===0?this:new g(this.line+Te,this.character+ue)}with(W,ue=this.character){if(W===null||ue===null)throw(0,t.illegalArgument)();let Te;return typeof W>"u"?Te=this.line:typeof W=="number"?Te=W:(Te=typeof W.line=="number"?W.line:this.line,ue=typeof W.character=="number"?W.character:this.character),Te===this.line&&ue===this.character?this:new g(Te,ue)}toJSON(){return{line:this.line,character:this.character}}};B=g=je([F],B),e.Position=B;let U=n=class{static isRange(W){return W instanceof n?!0:W?B.isPosition(W.start)&&B.isPosition(W.end):!1}static of(W){if(W instanceof n)return W;if(this.isRange(W))return new n(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(W,ue,Te,Xe){let et,ut;if(typeof W=="number"&&typeof ue=="number"&&typeof Te=="number"&&typeof Xe=="number"?(et=new B(W,ue),ut=new B(Te,Xe)):B.isPosition(W)&&B.isPosition(ue)&&(et=B.of(W),ut=B.of(ue)),!et||!ut)throw new Error("Invalid arguments");et.isBefore(ut)?(this._start=et,this._end=ut):(this._start=ut,this._end=et)}contains(W){return n.isRange(W)?this.contains(W.start)&&this.contains(W.end):B.isPosition(W)?!(B.of(W).isBefore(this._start)||this._end.isBefore(W)):!1}isEqual(W){return this._start.isEqual(W._start)&&this._end.isEqual(W._end)}intersection(W){const ue=B.Max(W.start,this._start),Te=B.Min(W.end,this._end);if(!ue.isAfter(Te))return new n(ue,Te)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const ue=B.Min(W.start,this._start),Te=B.Max(W.end,this.end);return new n(ue,Te)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(W,ue=this.end){if(W===null||ue===null)throw(0,t.illegalArgument)();let Te;return W?B.isPosition(W)?Te=W:(Te=W.start||this.start,ue=W.end||this.end):Te=this.start,Te.isEqual(this._start)&&ue.isEqual(this.end)?this:new n(Te,ue)}toJSON(){return[this.start,this.end]}};U=n=je([F],U),e.Range=U;let x=u=class extends U{static isSelection(W){return W instanceof u?!0:W?U.isRange(W)&&B.isPosition(W.anchor)&&B.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(W,ue,Te,Xe){let et,ut;if(typeof W=="number"&&typeof ue=="number"&&typeof Te=="number"&&typeof Xe=="number"?(et=new B(W,ue),ut=new B(Te,Xe)):B.isPosition(W)&&B.isPosition(ue)&&(et=B.of(W),ut=B.of(ue)),!et||!ut)throw new Error("Invalid arguments");super(et,ut),this._anchor=et,this._active=ut}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};x=u=je([F],x),e.Selection=x;class ${constructor(W,ue,Te){if(typeof W!="string"||W.length===0)throw(0,t.illegalArgument)("host");if(typeof ue!="number"||ue===0||Math.round(ue)!==ue)throw(0,t.illegalArgument)("port");if(typeof Te<"u"&&(typeof Te!="string"||Te.length===0||!/^[0-9A-Za-z\-]+$/.test(Te)))throw(0,t.illegalArgument)("connectionToken");this.host=W,this.port=Math.round(ue),this.connectionToken=Te}}e.ResolvedAuthority=$;class Q extends Error{static NotAvailable(W,ue){return new Q(W,S.RemoteAuthorityResolverErrorCode.NotAvailable,ue)}static TemporarilyNotAvailable(W){return new Q(W,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,ue=S.RemoteAuthorityResolverErrorCode.Unknown,Te){super(W),this._message=W,this._code=ue,this._detail=Te,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,Q.prototype)}}e.RemoteAuthorityResolverError=Q;var K;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(K=e.EndOfLine||(e.EndOfLine={}));var de;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(de=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let te=s=class{static isTextEdit(W){return W instanceof s?!0:W?U.isRange(W)&&typeof W.newText=="string":!1}static replace(W,ue){return new s(W,ue)}static insert(W,ue){return s.replace(new U(W,W),ue)}static delete(W){return s.replace(W,"")}static setEndOfLine(W){const ue=new s(new U(new B(0,0),new B(0,0)),"");return ue.newEol=W,ue}get range(){return this._range}set range(W){if(W&&!U.isRange(W))throw(0,t.illegalArgument)("range");this._range=W}get newText(){return this._newText||""}set newText(W){if(W&&typeof W!="string")throw(0,t.illegalArgument)("newText");this._newText=W}get newEol(){return this._newEol}set newEol(W){if(W&&typeof W!="number")throw(0,t.illegalArgument)("newEol");this._newEol=W}constructor(W,ue){this._range=W,this._newText=ue}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};te=s=je([F],te),e.TextEdit=te;let he=i=class{static isNotebookCellEdit(W){return W instanceof i?!0:W?Vt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,ue){return new i(W,ue)}static insertCells(W,ue){return new i(new Vt(W,W),ue)}static deleteCells(W){return new i(W,[])}static updateCellMetadata(W,ue){const Te=new i(new Vt(W,W),[]);return Te.newCellMetadata=ue,Te}static updateNotebookMetadata(W){const ue=new i(new Vt(0,0),[]);return ue.newNotebookMetadata=W,ue}constructor(W,ue){this.range=W,this.newCells=ue}};he=i=je([F],he),e.NotebookEdit=he;class Y{static isSnippetTextEdit(W){return W instanceof Y?!0:W?U.isRange(W.range)&&ke.isSnippetString(W.snippet):!1}static replace(W,ue){return new Y(W,ue)}static insert(W,ue){return Y.replace(new U(W,W),ue)}constructor(W,ue){this.range=W,this.snippet=ue}}e.SnippetTextEdit=Y;var ve;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})(ve=e.FileEditType||(e.FileEditType={}));let be=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(W,ue,Te,Xe){this._edits.push({_type:1,from:W,to:ue,options:Te,metadata:Xe})}createFile(W,ue,Te){this._edits.push({_type:1,from:void 0,to:W,options:ue,metadata:Te})}deleteFile(W,ue,Te){this._edits.push({_type:1,from:W,to:void 0,options:ue,metadata:Te})}replaceNotebookMetadata(W,ue,Te){this._edits.push({_type:3,metadata:Te,uri:W,edit:{editType:5,metadata:ue},notebookMetadata:ue})}replaceNotebookCells(W,ue,Te,Xe){const et=ue.start,ut=ue.end;(et!==ut||Te.length>0)&&this._edits.push({_type:5,uri:W,index:et,count:ut-et,cells:Te,metadata:Xe})}replaceNotebookCellMetadata(W,ue,Te,Xe){this._edits.push({_type:3,metadata:Xe,uri:W,edit:{editType:8,index:ue,metadata:Te}})}replace(W,ue,Te,Xe){this._edits.push({_type:2,uri:W,edit:new te(ue,Te),metadata:Xe})}insert(W,ue,Te,Xe){this.replace(W,new U(ue,ue),Te,Xe)}delete(W,ue,Te){this.replace(W,ue,"",Te)}has(W){return this._edits.some(ue=>ue._type===2&&ue.uri.toString()===W.toString())}set(W,ue){if(ue)for(const Te of ue){if(!Te)continue;let Xe,et;Array.isArray(Te)?(Xe=Te[0],et=Te[1]):Xe=Te,he.isNotebookCellEdit(Xe)?Xe.newCellMetadata?this.replaceNotebookCellMetadata(W,Xe.range.start,Xe.newCellMetadata,et):Xe.newNotebookMetadata?this.replaceNotebookMetadata(W,Xe.newNotebookMetadata,et):this.replaceNotebookCells(W,Xe.range,Xe.newCells,et):Y.isSnippetTextEdit(Xe)?this._edits.push({_type:6,uri:W,range:Xe.range,edit:Xe.snippet,metadata:et}):this._edits.push({_type:2,uri:W,edit:Xe,metadata:et})}else{for(let Te=0;Te<this._edits.length;Te++){const Xe=this._edits[Te];switch(Xe._type){case 2:case 6:case 3:case 5:Xe.uri.toString()===W.toString()&&(this._edits[Te]=void 0);break}}(0,l.coalesceInPlace)(this._edits)}}get(W){const ue=[];for(const Te of this._edits)Te._type===2&&Te.uri.toString()===W.toString()&&ue.push(Te.edit);return ue}entries(){const W=new P.ResourceMap;for(const ue of this._edits)if(ue._type===2){let Te=W.get(ue.uri);Te||(Te=[ue.uri,[]],W.set(ue.uri,Te)),Te[1].push(ue.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};be=je([F],be),e.WorkspaceEdit=be;let ke=o=class{static isSnippetString(W){return W instanceof o?!0:W?typeof W.value=="string":!1}static _escape(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this._tabstop=1,this.value=W||""}appendText(W){return this.value+=o._escape(W),this}appendTabstop(W=this._tabstop++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,ue=this._tabstop++){if(typeof W=="function"){const Te=new o;Te._tabstop=this._tabstop,W(Te),this._tabstop=Te._tabstop,W=Te.value}else W=o._escape(W);return this.value+="${",this.value+=ue,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,ue=this._tabstop++){const Te=W.map(Xe=>Xe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ue,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable(W,ue){if(typeof ue=="function"){const Te=new o;Te._tabstop=this._tabstop,ue(Te),this._tabstop=Te._tabstop,ue=Te.value}else typeof ue=="string"&&(ue=ue.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,ue&&(this.value+=":",this.value+=ue),this.value+="}",this}};ke=o=je([F],ke),e.SnippetString=ke;var Re;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(Re=e.DiagnosticTag||(e.DiagnosticTag={}));var ze;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(ze=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let oe=d=class{static isLocation(W){return W instanceof d?!0:W?U.isRange(W.range)&&k.URI.isUri(W.uri):!1}constructor(W,ue){if(this.uri=W,ue)if(U.isRange(ue))this.range=U.of(ue);else if(B.isPosition(ue))this.range=new U(ue,ue);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};oe=d=je([F],oe),e.Location=oe;let le=class{static is(W){return W?typeof W.message=="string"&&W.location&&U.isRange(W.location.range)&&k.URI.isUri(W.location.uri):!1}constructor(W,ue){this.location=W,this.message=ue}static isEqual(W,ue){return W===ue?!0:!W||!ue?!1:W.message===ue.message&&W.location.range.isEqual(ue.location.range)&&W.location.uri.toString()===ue.location.uri.toString()}};le=je([F],le),e.DiagnosticRelatedInformation=le;let me=class{constructor(W,ue,Te=ze.Error){if(!U.isRange(W))throw new TypeError("range must be set");if(!ue)throw new TypeError("message must be set");this.range=W,this.message=ue,this.severity=Te}toJSON(){return{severity:ze[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,ue){return W===ue?!0:!W||!ue?!1:W.message===ue.message&&W.severity===ue.severity&&W.code===ue.code&&W.severity===ue.severity&&W.source===ue.source&&W.range.isEqual(ue.range)&&(0,l.equals)(W.tags,ue.tags)&&(0,l.equals)(W.relatedInformation,ue.relatedInformation,le.isEqual)}};me=je([F],me),e.Diagnostic=me;let Z=class{constructor(W,ue){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=ue}};Z=je([F],Z),e.Hover=Z;var ae;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(ae=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ne=class{constructor(W,ue=ae.Text){this.range=W,this.kind=ue}toJSON(){return{range:this.range,kind:ae[this.kind]}}};ne=je([F],ne),e.DocumentHighlight=ne;var ie;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(ie=e.SymbolKind||(e.SymbolKind={}));var O;(function(j){j[j.Deprecated=1]="Deprecated"})(O=e.SymbolTag||(e.SymbolTag={}));let V=r=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,ue,Te,Xe,et){this.name=W,this.kind=ue,this.containerName=et,typeof Te=="string"&&(this.containerName=Te),Xe instanceof oe?this.location=Xe:Te instanceof U&&(this.location=new oe(Xe,Te)),r.validate(this)}toJSON(){return{name:this.name,kind:ie[this.kind],location:this.location,containerName:this.containerName}}};V=r=je([F],V),e.SymbolInformation=V;let q=a=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(a.validate)}constructor(W,ue,Te,Xe,et){this.name=W,this.detail=ue,this.kind=Te,this.range=Xe,this.selectionRange=et,this.children=[],a.validate(this)}};q=a=je([F],q),e.DocumentSymbol=q;var X;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(X=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ge=class{constructor(W,ue){this.title=W,this.kind=ue}};ge=je([F],ge),e.CodeAction=ge;let we=f=class{constructor(W){this.value=W}append(W){return new f(this.value?this.value+f.sep+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+f.sep)}};we.sep=".",we=f=je([F],we),e.CodeActionKind=we,we.Empty=new we(""),we.QuickFix=we.Empty.append("quickfix"),we.Refactor=we.Empty.append("refactor"),we.RefactorExtract=we.Refactor.append("extract"),we.RefactorInline=we.Refactor.append("inline"),we.RefactorMove=we.Refactor.append("move"),we.RefactorRewrite=we.Refactor.append("rewrite"),we.Source=we.Empty.append("source"),we.SourceOrganizeImports=we.Source.append("organizeImports"),we.SourceFixAll=we.Source.append("fixAll");let ce=class{constructor(W,ue){if(this.range=W,this.parent=ue,ue&&!ue.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ce=je([F],ce),e.SelectionRange=ce;class Ce{constructor(W,ue,Te,Xe,et,ut){this.kind=W,this.name=ue,this.detail=Te,this.uri=Xe,this.range=et,this.selectionRange=ut}}e.CallHierarchyItem=Ce;class ye{constructor(W,ue){this.fromRanges=ue,this.from=W}}e.CallHierarchyIncomingCall=ye;class We{constructor(W,ue){this.fromRanges=ue,this.to=W}}e.CallHierarchyOutgoingCall=We;var qe;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(qe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Ze=class{constructor(W,ue){this.range=W,this.command=ue}get isResolved(){return!!this.command}};Ze=je([F],Ze),e.CodeLens=Ze;let Ye=y=class{static isMarkdownString(W){return W instanceof y?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,ue=!1){b.set(this,void 0),tt(this,b,new C.MarkdownString(W,{supportThemeIcons:ue}),"f")}get value(){return Be(this,b,"f").value}set value(W){Be(this,b,"f").value=W}get isTrusted(){return Be(this,b,"f").isTrusted}set isTrusted(W){Be(this,b,"f").isTrusted=W}get supportThemeIcons(){return Be(this,b,"f").supportThemeIcons}set supportThemeIcons(W){Be(this,b,"f").supportThemeIcons=W}get supportHtml(){return Be(this,b,"f").supportHtml}set supportHtml(W){Be(this,b,"f").supportHtml=W}get baseUri(){return Be(this,b,"f").baseUri}set baseUri(W){Be(this,b,"f").baseUri=W}appendText(W){return Be(this,b,"f").appendText(W),this}appendMarkdown(W){return Be(this,b,"f").appendMarkdown(W),this}appendCodeblock(W,ue){return Be(this,b,"f").appendCodeblock(ue??"",W),this}};b=new WeakMap,Ye=y=je([F],Ye),e.MarkdownString=Ye;let Oe=class{constructor(W,ue){this.label=W,this.documentation=ue}};Oe=je([F],Oe),e.ParameterInformation=Oe;let ot=class{constructor(W,ue){this.label=W,this.documentation=ue,this.parameters=[]}};ot=je([F],ot),e.SignatureInformation=ot;let re=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};re=je([F],re),e.SignatureHelp=re;var se;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(se=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ee;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(Ee=e.InlayHintKind||(e.InlayHintKind={}));let xe=class{constructor(W){this.value=W}};xe=je([F],xe),e.InlayHintLabelPart=xe;let fe=class{constructor(W,ue,Te){this.position=W,this.label=ue,this.kind=Te}};fe=je([F],fe),e.InlayHint=fe;var Ae;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ae=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Le;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(Le=e.CompletionItemKind||(e.CompletionItemKind={}));var Me;(function(j){j[j.Deprecated=1]="Deprecated"})(Me=e.CompletionItemTag||(e.CompletionItemTag={}));let Ge=class{constructor(W,ue){this.label=W,this.kind=ue}toJSON(){return{label:this.label,kind:this.kind&&Le[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ge=je([F],Ge),e.CompletionItem=Ge;let Je=class{constructor(W=[],ue=!1){this.items=W,this.isIncomplete=ue}};Je=je([F],Je),e.CompletionList=Je;let st=class{constructor(W,ue,Te){this.insertText=W,this.range=ue,this.command=Te}};st=je([F],st),e.InlineSuggestion=st;let vt=class{constructor(W){this.commands=void 0,this.items=W}};vt=je([F],vt),e.InlineSuggestionList=vt;let nt=class{constructor(W,ue,Te){this.insertText=W,this.range=ue,this.command=Te}};nt=je([F],nt),e.InlineSuggestionNew=nt;let it=class{constructor(W,ue){this.items=W,this.commands=ue}};it=je([F],it),e.InlineSuggestionsNew=it;var wt;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(wt=e.ViewColumn||(e.ViewColumn={}));var Ct;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Ct=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Dt;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(Dt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ht;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(ht=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Tt;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Tt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ut;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(Ut=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Wt;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(Wt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Qe;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Qe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(j){function W(ue){switch(ue){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=W}(Ut=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ft=class{constructor(W,ue){if(ue&&!k.URI.isUri(ue))throw(0,t.illegalArgument)("target");if(!U.isRange(W)||W.isEmpty)throw(0,t.illegalArgument)("range");this.range=W,this.target=ue}};Ft=je([F],Ft),e.DocumentLink=Ft;let Pt=class{constructor(W,ue,Te,Xe){this.red=W,this.green=ue,this.blue=Te,this.alpha=Xe}};Pt=je([F],Pt),e.Color=Pt;let Nt=class{constructor(W,ue){if(ue&&!(ue instanceof Pt))throw(0,t.illegalArgument)("color");if(!U.isRange(W)||W.isEmpty)throw(0,t.illegalArgument)("range");this.range=W,this.color=ue}};Nt=je([F],Nt),e.ColorInformation=Nt;let gt=class{constructor(W){if(!W||typeof W!="string")throw(0,t.illegalArgument)("label");this.label=W}};gt=je([F],gt),e.ColorPresentation=gt;var Pe;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(Pe=e.ColorFormat||(e.ColorFormat={}));var Fe;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(Fe=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var _e;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(_e=e.TerminalExitReason||(e.TerminalExitReason={}));class ee{constructor(W,ue,Te){if(this.startIndex=W,this.length=ue,this.tooltip=Te,typeof W!="number"||W<0)throw(0,t.illegalArgument)("startIndex");if(typeof ue!="number"||ue<1)throw(0,t.illegalArgument)("length");if(Te!==void 0&&typeof Te!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=ee;var Ne;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(Ne=e.TerminalLocation||(e.TerminalLocation={}));class Ve{constructor(W){if(this.options=W,typeof W!="object")throw(0,t.illegalArgument)("options")}}e.TerminalProfile=Ve;var at;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(at=e.TaskRevealKind||(e.TaskRevealKind={}));var Ke;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(Ke=e.TaskPanelKind||(e.TaskPanelKind={}));let rt=R=class{static from(W){switch(W){case"clean":return R.Clean;case"build":return R.Build;case"rebuild":return R.Rebuild;case"test":return R.Test;default:return}}constructor(W,ue){if(this.label=ue,typeof W!="string"||typeof ue!="string")throw(0,t.illegalArgument)("name");this._id=W}get id(){return this._id}};rt.Clean=new R("clean","Clean"),rt.Build=new R("build","Build"),rt.Rebuild=new R("rebuild","Rebuild"),rt.Test=new R("test","Test"),rt=R=je([F],rt),e.TaskGroup=rt;function dt(j){let W="";for(let ue=0;ue<j.length;ue++)W+=j[ue].replace(/,/g,",,")+",";return W}let mt=class{constructor(W,ue,Te){if(typeof W!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=W,ue!==void 0&&(Array.isArray(ue)?(this._args=ue,this._options=Te):this._options=ue)}get process(){return this._process}set process(W){if(typeof W!="string")throw(0,t.illegalArgument)("process");this._process=W}get args(){return this._args}set args(W){Array.isArray(W)||(W=[]),this._args=W}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("process"),this._process!==void 0&&W.push(this._process),this._args&&this._args.length>0)for(const ue of this._args)W.push(ue);return dt(W)}};mt=je([F],mt),e.ProcessExecution=mt;let It=class{constructor(W,ue,Te){if(this._args=[],Array.isArray(ue)){if(!W)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,t.illegalArgument)("command");this._command=W,this._args=ue,this._options=Te}else{if(typeof W!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=W,this._options=ue}}get commandLine(){return this._commandLine}set commandLine(W){if(typeof W!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=W}get command(){return this._command?this._command:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,t.illegalArgument)("command");this._command=W}get args(){return this._args}set args(W){this._args=W||[]}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("shell"),this._commandLine!==void 0&&W.push(this._commandLine),this._command!==void 0&&W.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const ue of this._args)W.push(typeof ue=="string"?ue:ue.value);return dt(W)}};It=je([F],It),e.ShellExecution=It;var Et;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(Et=e.ShellQuoting||(e.ShellQuoting={}));var _t;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(_t=e.TaskScope||(e.TaskScope={}));class At{constructor(W){this._callback=W}computeId(){return"customExecution"+(0,L.generateUuid)()}set callback(W){this._callback=W}get callback(){return this._callback}}e.CustomExecution=At;let St=N=class{constructor(W,ue,Te,Xe,et,ut){this.__deprecated=!1,this._definition=this.definition=W;let ft;typeof ue=="string"?(this._name=this.name=ue,this._source=this.source=Te,this.execution=Xe,ft=et,this.__deprecated=!0):ue===_t.Global||ue===_t.Workspace?(this.target=ue,this._name=this.name=Te,this._source=this.source=Xe,this.execution=et,ft=ut):(this.target=ue,this._name=this.name=Te,this._source=this.source=Xe,this.execution=et,ft=ut),typeof ft=="string"?(this._problemMatchers=[ft],this._hasDefinedMatchers=!0):Array.isArray(ft)?(this._problemMatchers=ft,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(W){this.__id=W}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof mt?this._definition={type:N.ProcessType,id:this._execution.computeId()}:this._execution instanceof It?this._definition={type:N.ShellType,id:this._execution.computeId()}:this._execution instanceof At?this._definition={type:N.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:N.EmptyType,id:(0,L.generateUuid)()}}get definition(){return this._definition}set definition(W){if(W==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=W}get scope(){return this._scope}set target(W){this.clear(),this._scope=W}get name(){return this._name}set name(W){if(typeof W!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=W}get execution(){return this._execution}set execution(W){W===null&&(W=void 0),this.clear(),this._execution=W;const ue=this._definition.type;(N.EmptyType===ue||N.ProcessType===ue||N.ShellType===ue||N.ExtensionCallbackType===ue)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(W){if(Array.isArray(W))this.clear(),this._problemMatchers=W,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.clear(),this._isBackground=W}get source(){return this._source}set source(W){if(typeof W!="string"||W.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=W}get group(){return this._group}set group(W){W===null&&(W=void 0),this.clear(),this._group=W}get detail(){return this._detail}set detail(W){W===null&&(W=void 0),this._detail=W}get presentationOptions(){return this._presentationOptions}set presentationOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._presentationOptions=W}get runOptions(){return this._runOptions}set runOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._runOptions=W}};St.ExtensionCallbackType="customExecution",St.ProcessType="process",St.ShellType="shell",St.EmptyType="$empty",St=N=je([F],St),e.Task=St;var kt;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(kt=e.ProgressLocation||(e.ProgressLocation={}));var tn;(function(j){function W(ue){const Te=ue;return(0,w.isNumber)(Te.value)?Te.tooltip&&!(0,w.isString)(Te.tooltip)?(console.log("INVALID view badge, invalid tooltip",Te.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Te.value),!1)}j.isViewBadge=W})(tn=e.ViewBadge||(e.ViewBadge={}));let Xt=M=class{static isTreeItem(W,ue){if(W instanceof M)return!0;const Te=W;if(Te.label!==void 0&&!(0,w.isString)(Te.label)&&!Te.label?.label)return console.log("INVALID tree item, invalid label",Te.label),!1;if(Te.id!==void 0&&!(0,w.isString)(Te.id))return console.log("INVALID tree item, invalid id",Te.id),!1;if(Te.iconPath!==void 0&&!(0,w.isString)(Te.iconPath)&&!k.URI.isUri(Te.iconPath)&&(!Te.iconPath||!(0,w.isString)(Te.iconPath.id))){const Xe=Te.iconPath;if(!Xe||!(0,w.isString)(Xe.light)&&!k.URI.isUri(Xe.light)&&!(0,w.isString)(Xe.dark)&&!k.URI.isUri(Xe.dark))return console.log("INVALID tree item, invalid iconPath",Te.iconPath),!1}if(Te.description!==void 0&&!(0,w.isString)(Te.description)&&typeof Te.description!="boolean")return console.log("INVALID tree item, invalid description",Te.description),!1;if(Te.resourceUri!==void 0&&!k.URI.isUri(Te.resourceUri))return console.log("INVALID tree item, invalid resourceUri",Te.resourceUri),!1;if(Te.tooltip!==void 0&&!(0,w.isString)(Te.tooltip)&&!(Te.tooltip instanceof Ye))return console.log("INVALID tree item, invalid tooltip",Te.tooltip),!1;if(Te.command!==void 0&&!Te.command.command)return console.log("INVALID tree item, invalid command",Te.command),!1;if(Te.collapsibleState!==void 0&&Te.collapsibleState<bt.None&&Te.collapsibleState>bt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",Te.collapsibleState),!1;if(Te.contextValue!==void 0&&!(0,w.isString)(Te.contextValue))return console.log("INVALID tree item, invalid contextValue",Te.contextValue),!1;if(Te.accessibilityInformation!==void 0&&!Te.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",Te.accessibilityInformation),!1;if(Te.checkboxState!==void 0){(0,E.checkProposedApiEnabled)(ue,"treeItemCheckbox");const Xe=(0,w.isNumber)(Te.checkboxState)?Te.checkboxState:(0,w.isObject)(Te.checkboxState)&&(0,w.isNumber)(Te.checkboxState.state)?Te.checkboxState.state:void 0,et=!(0,w.isNumber)(Te.checkboxState)&&(0,w.isObject)(Te.checkboxState)?Te.checkboxState.tooltip:void 0;if(Xe===void 0||Xe!==nn.Checked&&Xe!==nn.Unchecked||et!==void 0&&!(0,w.isString)(et))return console.log("INVALID tree item, invalid checkboxState",Te.checkboxState),!1}return!0}constructor(W,ue=bt.None){this.collapsibleState=ue,k.URI.isUri(W)?this.resourceUri=W:this.label=W}};Xt=M=je([F],Xt),e.TreeItem=Xt;var bt;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(bt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var nn;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(nn=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let rn=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W,ue){this.value=W,this.id=ue??(0,L.generateUuid)()}};rn=je([F],rn),e.DataTransferItem=rn;let sn=class{constructor(W){m.set(this,new Map);for(const[ue,Te]of W??[]){const Xe=Be(this,m,"f").get(ue);Xe?Xe.push(Te):Be(this,m,"f").set(ue,[Te])}}get(W){return Be(this,m,"f").get(W)?.[0]}set(W,ue){Be(this,m,"f").set(W,[ue])}forEach(W,ue){for(const[Te,Xe]of Be(this,m,"f"))for(const et of Xe)W.call(ue,et,Te,this)}*[(m=new WeakMap,Symbol.iterator)](){for(const[W,ue]of Be(this,m,"f"))for(const Te of ue)yield[W,Te]}};sn=je([F],sn),e.DataTransfer=sn;let vn=class{constructor(W){this.insertText=W}};vn=je([F],vn),e.DocumentDropEdit=vn;let Rt=class{constructor(W){this.insertText=W}};Rt=je([F],Rt),e.DocumentPasteEdit=Rt;let Ht=class{constructor(W,ue){this.id=W,this.color=ue}};Ht=je([F],Ht),e.ThemeIcon=Ht,Ht.File=new Ht("file"),Ht.Folder=new Ht("folder");let bn=class{constructor(W){this.id=W}};bn=je([F],bn),e.ThemeColor=bn;var on;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(on=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Qt=class{get base(){return this._base}set base(W){this._base=W,this._baseUri=k.URI.file(W)}get baseUri(){return this._baseUri}set baseUri(W){this._baseUri=W,this._base=W.fsPath}constructor(W,ue){if(typeof W!="string"&&(!W||!k.URI.isUri(W)&&!k.URI.isUri(W.uri)))throw(0,t.illegalArgument)("base");if(typeof ue!="string")throw(0,t.illegalArgument)("pattern");typeof W=="string"?this.baseUri=k.URI.file(W):k.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=ue}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Qt=je([F],Qt),e.RelativePattern=Qt;let lt=class{constructor(W,ue,Te,Xe){this.enabled=typeof W=="boolean"?W:!0,typeof ue=="string"&&(this.condition=ue),typeof Te=="string"&&(this.hitCondition=Te),typeof Xe=="string"&&(this.logMessage=Xe)}get id(){return this._id||(this._id=(0,L.generateUuid)()),this._id}};lt=je([F],lt),e.Breakpoint=lt;let wn=class extends lt{constructor(W,ue,Te,Xe,et){if(super(ue,Te,Xe,et),W===null)throw(0,t.illegalArgument)("location");this.location=W}};wn=je([F],wn),e.SourceBreakpoint=wn;let $t=class extends lt{constructor(W,ue,Te,Xe,et){super(ue,Te,Xe,et),this.functionName=W}};$t=je([F],$t),e.FunctionBreakpoint=$t;let qt=class extends lt{constructor(W,ue,Te,Xe,et,ut,ft){if(super(Xe,et,ut,ft),!ue)throw(0,t.illegalArgument)("dataId");this.label=W,this.dataId=ue,this.canPersist=Te}};qt=je([F],qt),e.DataBreakpoint=qt;let an=class{constructor(W,ue,Te){this.command=W,this.args=ue||[],this.options=Te}};an=je([F],an),e.DebugAdapterExecutable=an;let En=class{constructor(W,ue){this.port=W,this.host=ue}};En=je([F],En),e.DebugAdapterServer=En;let cn=class{constructor(W){this.path=W}};cn=je([F],cn),e.DebugAdapterNamedPipeServer=cn;let Sn=class{constructor(W){this.implementation=W}};Sn=je([F],Sn),e.DebugAdapterInlineImplementation=Sn;let ln=class{constructor(W,ue){this.range=W,this.expression=ue}};ln=je([F],ln),e.EvaluatableExpression=ln;var un;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(un=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var Nn;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Nn=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let Yt=class{constructor(W,ue){this.range=W,this.text=ue}};Yt=je([F],Yt),e.InlineValueText=Yt;let Jt=class{constructor(W,ue,Te=!0){this.range=W,this.variableName=ue,this.caseSensitiveLookup=Te}};Jt=je([F],Jt),e.InlineValueVariableLookup=Jt;let _n=class{constructor(W,ue){this.range=W,this.expression=ue}};_n=je([F],_n),e.InlineValueEvaluatableExpression=_n;let yn=class{constructor(W,ue){this.frameId=W,this.stoppedLocation=ue}};yn=je([F],yn),e.InlineValueContext=yn;var Zt;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Zt=e.FileChangeType||(e.FileChangeType={}));let Cn=A=class extends Error{static FileExists(W){return new A(W,D.FileSystemProviderErrorCode.FileExists,A.FileExists)}static FileNotFound(W){return new A(W,D.FileSystemProviderErrorCode.FileNotFound,A.FileNotFound)}static FileNotADirectory(W){return new A(W,D.FileSystemProviderErrorCode.FileNotADirectory,A.FileNotADirectory)}static FileIsADirectory(W){return new A(W,D.FileSystemProviderErrorCode.FileIsADirectory,A.FileIsADirectory)}static NoPermissions(W){return new A(W,D.FileSystemProviderErrorCode.NoPermissions,A.NoPermissions)}static Unavailable(W){return new A(W,D.FileSystemProviderErrorCode.Unavailable,A.Unavailable)}constructor(W,ue=D.FileSystemProviderErrorCode.Unknown,Te){super(k.URI.isUri(W)?W.toString(!0):W),this.code=Te?.name??"Unknown",(0,D.markAsFileSystemProviderError)(this,ue),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,A.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}};Cn=A=je([F],Cn),e.FileSystemError=Cn;let Dn=class{constructor(W,ue,Te){this.start=W,this.end=ue,this.kind=Te}};Dn=je([F],Dn),e.FoldingRange=Dn;var Mn;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(Mn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Un;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(Un=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var In;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(In=e.CommentMode||(e.CommentMode={}));var An;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(An=e.CommentThreadState||(e.CommentThreadState={}));class Rn{constructor(W,ue=[]){this.tokenTypes=W,this.tokenModifiers=ue}}e.SemanticTokensLegend=Rn;function He(j){return typeof j>"u"||(0,w.isStringArray)(j)}class Bt{constructor(W){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,W){this._hasLegend=!0;for(let ue=0,Te=W.tokenTypes.length;ue<Te;ue++)this._tokenTypeStrToInt.set(W.tokenTypes[ue],ue);for(let ue=0,Te=W.tokenModifiers.length;ue<Te;ue++)this._tokenModifierStrToInt.set(W.tokenModifiers[ue],ue)}}push(W,ue,Te,Xe,et){if(typeof W=="number"&&typeof ue=="number"&&typeof Te=="number"&&typeof Xe=="number"&&(typeof et=="number"||typeof et>"u"))return typeof et>"u"&&(et=0),this._pushEncoded(W,ue,Te,Xe,et);if(U.isRange(W)&&typeof ue=="string"&&He(Te))return this._push(W,ue,Te);throw(0,t.illegalArgument)()}_push(W,ue,Te){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ue))throw new Error("`tokenType` is not in the provided legend");const Xe=W.start.line,et=W.start.character,ut=W.end.character-W.start.character,ft=this._tokenTypeStrToInt.get(ue);let Ot=0;if(Te)for(const zt of Te){if(!this._tokenModifierStrToInt.has(zt))throw new Error("`tokenModifier` is not in the provided legend");const xt=this._tokenModifierStrToInt.get(zt);Ot|=1<<xt>>>0}this._pushEncoded(Xe,et,ut,ft,Ot)}_pushEncoded(W,ue,Te,Xe,et){if(this._dataIsSortedAndDeltaEncoded&&(W<this._prevLine||W===this._prevLine&&ue<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Ot=this._data.length/5|0;let zt=0,xt=0;for(let jt=0;jt<Ot;jt++){let Gt=this._data[5*jt],Tn=this._data[5*jt+1];Gt===0?(Gt=zt,Tn+=xt):Gt+=zt,this._data[5*jt]=Gt,this._data[5*jt+1]=Tn,zt=Gt,xt=Tn}}let ut=W,ft=ue;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ut-=this._prevLine,ut===0&&(ft-=this._prevChar)),this._data[this._dataLen++]=ut,this._data[this._dataLen++]=ft,this._data[this._dataLen++]=Te,this._data[this._dataLen++]=Xe,this._data[this._dataLen++]=et,this._prevLine=W,this._prevChar=ue}static _sortAndDeltaEncode(W){const ue=[],Te=W.length/5|0;for(let ft=0;ft<Te;ft++)ue[ft]=ft;ue.sort((ft,Ot)=>{const zt=W[5*ft],xt=W[5*Ot];if(zt===xt){const jt=W[5*ft+1],Gt=W[5*Ot+1];return jt-Gt}return zt-xt});const Xe=new Uint32Array(W.length);let et=0,ut=0;for(let ft=0;ft<Te;ft++){const Ot=5*ue[ft],zt=W[Ot+0],xt=W[Ot+1],jt=W[Ot+2],Gt=W[Ot+3],Tn=W[Ot+4],ei=zt-et,Di=ei===0?xt-ut:xt,Pn=5*ft;Xe[Pn+0]=ei,Xe[Pn+1]=Di,Xe[Pn+2]=jt,Xe[Pn+3]=Gt,Xe[Pn+4]=Tn,et=zt,ut=xt}return Xe}build(W){return this._dataIsSortedAndDeltaEncoded?new dn(new Uint32Array(this._data),W):new dn(Bt._sortAndDeltaEncode(this._data),W)}}e.SemanticTokensBuilder=Bt;class dn{constructor(W,ue){this.resultId=ue,this.data=W}}e.SemanticTokens=dn;class pt{constructor(W,ue,Te){this.start=W,this.deleteCount=ue,this.data=Te}}e.SemanticTokensEdit=pt;class Bn{constructor(W,ue){this.resultId=ue,this.edits=W}}e.SemanticTokensEdits=Bn;var zn;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(zn=e.DebugConsoleMode||(e.DebugConsoleMode={}));let en=class{constructor(){}};en.Back={iconPath:new Ht("arrow-left")},en=je([F],en),e.QuickInputButtons=en;var Wn;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(Wn=e.QuickPickItemKind||(e.QuickPickItemKind={}));var hn;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(hn=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Hn;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(Hn=e.ExtensionKind||(e.ExtensionKind={}));class $n{static validate(W){if(W.badge){let ue=(0,I.nextCharLength)(W.badge,0);if(ue<W.badge.length&&(ue+=(0,I.nextCharLength)(W.badge,ue)),W.badge.length>ue)throw new Error("The 'badge'-property must be undefined or a short character")}if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,ue,Te){this.badge=W,this.tooltip=ue,this.color=Te}}e.FileDecoration=$n;let kn=class{constructor(W){this.kind=W}};kn=je([F],kn),e.ColorTheme=kn;var Ln;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(Ln=e.ColorThemeKind||(e.ColorThemeKind={}));class Vt{static isNotebookRange(W){return W instanceof Vt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(W,ue){if(W<0)throw(0,t.illegalArgument)("start must be positive");if(ue<0)throw(0,t.illegalArgument)("end must be positive");W<=ue?(this._start=W,this._end=ue):(this._start=ue,this._end=W)}with(W){let ue=this._start,Te=this._end;return W.start!==void 0&&(ue=W.start),W.end!==void 0&&(Te=W.end),ue===this._start&&Te===this._end?this:new Vt(ue,Te)}}e.NotebookRange=Vt;class fn{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(ue=>fn.isNotebookCellData(ue))}static isNotebookCellData(W){return!0}constructor(W,ue,Te,Xe,et,ut,ft){this.kind=W,this.value=ue,this.languageId=Te,this.mime=Xe,this.outputs=et??[],this.metadata=ut,this.executionSummary=ft,fn.validate(this)}}e.NotebookCellData=fn;class xn{constructor(W){this.cells=W}}e.NotebookData=xn;class Mt{static isNotebookCellOutputItem(W){return W instanceof Mt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const ue={name:W.name,message:W.message,stack:W.stack};return Mt.json(ue,"application/vnd.code.notebook.error")}static stdout(W){return Mt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Mt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,ue="application/octet-stream"){return new Mt(W,ue)}static text(W,ue=_.Mimes.text){const Te=Be(Mt,v,"f",h).encode(String(W));return new Mt(Te,ue)}static json(W,ue="text/x-json"){const Te=JSON.stringify(W,void 0,"	");return Mt.text(Te,ue)}constructor(W,ue){this.data=W,this.mime=ue;const Te=(0,_.normalizeMimeType)(ue,!0);if(!Te)throw new Error(`INVALID mime type: ${ue}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Te}}e.NotebookCellOutputItem=Mt,v=Mt,h={value:new TextEncoder};class mn{static isNotebookCellOutput(W){return W instanceof mn?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,ue=!1){const Te=new Set,Xe=new Set;for(let et=0;et<W.length;et++){const ut=W[et],ft=(0,_.normalizeMimeType)(ut.mime);if(!Te.has(ft)||(0,T.isTextStreamMime)(ft)){Te.add(ft);continue}Xe.add(et),ue&&console.warn(`DUPLICATED mime type '${ut.mime}' will be dropped`)}return Xe.size===0?W:W.filter((et,ut)=>!Xe.has(ut))}constructor(W,ue,Te){this.items=mn.ensureUniqueMimeTypes(W,!0),typeof ue=="string"?(this.id=ue,this.metadata=Te):(this.id=(0,L.generateUuid)(),this.metadata=ue??Te)}}e.NotebookCellOutput=mn;var Vn;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(Vn=e.NotebookCellKind||(e.NotebookCellKind={}));var pe;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(pe=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Se;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Se=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Ue;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Ue=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class ct{constructor(W,ue){this.text=W,this.alignment=ue}}e.NotebookCellStatusBarItem=ct;var yt;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(yt=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var Lt;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(Lt=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class ri{constructor(W,ue=[]){this.uri=W,this.provides=(0,l.asArray)(ue)}}e.NotebookRendererScript=ri;let jn=class{constructor(W,ue){this.label=W,this.timestamp=ue}};jn=je([F],jn),e.TimelineItem=jn;var si;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(si=e.ExtensionMode||(e.ExtensionMode={}));var oi;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(oi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var ai;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(ai=e.StandardTokenType||(e.StandardTokenType={}));class ci{constructor(W,ue){this.ranges=W,this.wordPattern=ue}}e.LinkedEditingRanges=ci;class li{constructor(W,ue){this._port=W,this._autoForwardAction=ue}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=li;var ui;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(ui=e.TestResultState||(e.TestResultState={}));var di;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(di=e.TestRunProfileKind||(e.TestRunProfileKind={}));let qn=class{constructor(W=void 0,ue=void 0,Te=void 0){this.include=W,this.exclude=ue,this.profile=Te}};qn=je([F],qn),e.TestRunRequest=qn;let Gn=z=class{static diff(W,ue,Te){const Xe=new z(W);return Xe.expectedOutput=ue,Xe.actualOutput=Te,Xe}constructor(W){this.message=W}};Gn=z=je([F],Gn),e.TestMessage=Gn;let Kn=class{constructor(W){this.id=W}};Kn=je([F],Kn),e.TestTag=Kn;let gn=class{constructor(W,ue){this.covered=W,this.total=ue}};gn=je([F],gn),e.CoveredCount=gn;let Xn=H=class{static fromDetails(W,ue){const Te=new gn(0,0),Xe=new gn(0,0),et=new gn(0,0);for(const ft of ue)if("branches"in ft){Te.total+=1,Te.covered+=ft.executionCount>0?1:0;for(const Ot of ft.branches)Xe.total+=1,Xe.covered+=Ot.executionCount>0?1:0}else et.total+=1,et.covered+=ft.executionCount>0?1:0;const ut=new H(W,Te,Xe.total>0?Xe:void 0,et.total>0?et:void 0);return ut.detailedCoverage=ue,ut}constructor(W,ue,Te,Xe){this.uri=W,this.statementCoverage=ue,this.branchCoverage=Te,this.functionCoverage=Xe}};Xn=H=je([F],Xn),e.FileCoverage=Xn;let Qn=class{constructor(W,ue,Te=[]){this.executionCount=W,this.location=ue,this.branches=Te}};Qn=je([F],Qn),e.StatementCoverage=Qn;let Yn=class{constructor(W,ue){this.executionCount=W,this.location=ue}};Yn=je([F],Yn),e.BranchCoverage=Yn;let Jn=class{constructor(W,ue){this.executionCount=W,this.location=ue}};Jn=je([F],Jn),e.FunctionCoverage=Jn;var hi;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(hi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var fi;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(fi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var mi;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(mi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class gi{constructor(W,ue,Te,Xe,et,ut){this.kind=W,this.name=ue,this.detail=Te,this.uri=Xe,this.range=et,this.selectionRange=ut}}e.TypeHierarchyItem=gi;class pi{constructor(W){this.uri=W}}e.TextTabInput=pi;class vi{constructor(W,ue){this.original=W,this.modified=ue}}e.TextDiffTabInput=vi;class bi{constructor(W,ue,Te,Xe){this.base=W,this.input1=ue,this.input2=Te,this.result=Xe}}e.TextMergeTabInput=bi;class wi{constructor(W,ue){this.uri=W,this.viewType=ue}}e.CustomEditorTabInput=wi;class Ei{constructor(W){this.viewType=W}}e.WebviewEditorTabInput=Ei;class Si{constructor(W,ue){this.uri=W,this.notebookType=ue}}e.NotebookEditorTabInput=Si;class _i{constructor(W,ue,Te){this.original=W,this.modified=ue,this.notebookType=Te}}e.NotebookDiffEditorTabInput=_i;class yi{constructor(){}}e.TerminalEditorTabInput=yi;class Ci{constructor(W,ue){this.uri=W,this.inputBoxUri=ue}}e.InteractiveWindowInput=Ci}),define(De[132],Ie([1,0,48,12,8,159,99,7,17]),function(J,e,l,t,C,P,_,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const k=new Map;function L(E,p){p?k.set(E,p):k.delete(E)}e.setWordDefinitionFor=L;function D(E){return k.get(E)}e.getWordDefinitionFor=D;class S extends P.MirrorTextModel{constructor(p,b,m,v,h,c,g,n){super(b,m,v,h),this._proxy=p,this._languageId=c,this._isDirty=g,this.notebook=n,this._isDisposed=!1}dispose(){(0,l.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(p){return(0,w.equals)(this._lines,p)}get document(){if(!this._document){const p=this;this._document={get uri(){return p._uri},get fileName(){return p._uri.fsPath},get isUntitled(){return p._uri.scheme===t.Schemas.untitled},get languageId(){return p._languageId},get version(){return p._versionId},get isClosed(){return p._isDisposed},get isDirty(){return p._isDirty},save(){return p._save()},getText(b){return b?p._getTextInRange(b):p.getText()},get eol(){return p._eol===`
`?I.EndOfLine.LF:I.EndOfLine.CRLF},get lineCount(){return p._lines.length},lineAt(b){return p._lineAt(b)},offsetAt(b){return p._offsetAt(b)},positionAt(b){return p._positionAt(b)},validateRange(b){return p._validateRange(b)},validatePosition(b){return p._validatePosition(b)},getWordRangeAtPosition(b,m){return p._getWordRangeAtPosition(b,m)}}}return Object.freeze(this._document)}_acceptLanguageId(p){(0,l.ok)(!this._isDisposed),this._languageId=p}_acceptIsDirty(p){(0,l.ok)(!this._isDisposed),this._isDirty=p}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(p){const b=this._validateRange(p);if(b.isEmpty)return"";if(b.isSingleLine)return this._lines[b.start.line].substring(b.start.character,b.end.character);const m=this._eol,v=b.start.line,h=b.end.line,c=[];c.push(this._lines[v].substring(b.start.character));for(let g=v+1;g<h;g++)c.push(this._lines[g]);return c.push(this._lines[h].substring(0,b.end.character)),c.join(m)}_lineAt(p){let b;if(p instanceof I.Position?b=p.line:typeof p=="number"&&(b=p),typeof b!="number"||b<0||b>=this._lines.length||Math.floor(b)!==b)throw new Error("Illegal value for `line`");return new T(b,this._lines[b],b===this._lines.length-1)}_offsetAt(p){return p=this._validatePosition(p),this._ensureLineStarts(),this._lineStarts.getPrefixSum(p.line-1)+p.character}_positionAt(p){p=Math.floor(p),p=Math.max(0,p),this._ensureLineStarts();const b=this._lineStarts.getIndexOf(p),m=this._lines[b.index].length;return new I.Position(b.index,Math.min(b.remainder,m))}_validateRange(p){if(!(p instanceof I.Range))throw new Error("Invalid argument");const b=this._validatePosition(p.start),m=this._validatePosition(p.end);return b===p.start&&m===p.end?p:new I.Range(b.line,b.character,m.line,m.character)}_validatePosition(p){if(!(p instanceof I.Position))throw new Error("Invalid argument");if(this._lines.length===0)return p.with(0,0);let{line:b,character:m}=p,v=!1;if(b<0)b=0,m=0,v=!0;else if(b>=this._lines.length)b=this._lines.length-1,m=this._lines[b].length,v=!0;else{const h=this._lines[b].length;m<0?(m=0,v=!0):m>h&&(m=h,v=!0)}return v?new I.Position(b,m):p}_getWordRangeAtPosition(p,b){const m=this._validatePosition(p);if(!b)b=D(this._languageId);else if((0,C.regExpLeadsToEndlessLoop)(b))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${b.source}' because it matches the empty string.`);const v=(0,_.getWordAtText)(m.character+1,(0,_.ensureValidWordDefinition)(b),this._lines[m.line],0);if(v)return new I.Range(m.line,v.startColumn-1,m.line,v.endColumn-1)}}e.ExtHostDocumentData=S;class T{constructor(p,b,m){this._line=p,this._text=b,this._isLastLine=m}get lineNumber(){return this._line}get text(){return this._text}get range(){return new I.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new I.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=T}),define(De[225],Ie([1,0,7,14,4]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let P=class{constructor(I){this._actual=new l.ColorTheme(l.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new C.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(I){let w;switch(I){case"light":w=l.ColorThemeKind.Light;break;case"hcDark":w=l.ColorThemeKind.HighContrast;break;case"hcLight":w=l.ColorThemeKind.HighContrastLight;break;default:w=l.ColorThemeKind.Dark}this._actual=new l.ColorTheme(w),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};P=je([$e(0,t.IExtHostRpcService)],P),e.ExtHostTheming=P}),define(De[15],Ie([1,0,17,23,106,26,145,80,24,16,2,35,63,118,129,127,88,55,64,219,7,60]),function(J,e,l,t,C,P,_,I,w,k,L,D,S,T,E,p,b,m,v,h,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var n;(function(Pe){function Fe(ee){const{selectionStartLineNumber:Ne,selectionStartColumn:Ve,positionLineNumber:at,positionColumn:Ke}=ee,rt=new c.Position(Ne-1,Ve-1),dt=new c.Position(at-1,Ke-1);return new c.Selection(rt,dt)}Pe.to=Fe;function _e(ee){const{anchor:Ne,active:Ve}=ee;return{selectionStartLineNumber:Ne.line+1,selectionStartColumn:Ne.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}Pe.from=_e})(n=e.Selection||(e.Selection={}));var u;(function(Pe){function Fe(ee){if(!ee)return;const{start:Ne,end:Ve}=ee;return{startLineNumber:Ne.line+1,startColumn:Ne.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}Pe.from=Fe;function _e(ee){if(!ee)return;const{startLineNumber:Ne,startColumn:Ve,endLineNumber:at,endColumn:Ke}=ee;return new c.Range(Ne-1,Ve-1,at-1,Ke-1)}Pe.to=_e})(u=e.Range||(e.Range={}));var s;(function(Pe){function Fe(_e){switch(_e){case 1:return c.StandardTokenType.Comment;case 0:return c.StandardTokenType.Other;case 3:return c.StandardTokenType.RegEx;case 2:return c.StandardTokenType.String}}Pe.to=Fe})(s=e.TokenType||(e.TokenType={}));var i;(function(Pe){function Fe(ee){return new c.Position(ee.lineNumber-1,ee.column-1)}Pe.to=Fe;function _e(ee){return{lineNumber:ee.line+1,column:ee.character+1}}Pe.from=_e})(i=e.Position||(e.Position={}));var o;(function(Pe){function Fe(Ne,Ve){return(0,l.coalesce)((0,l.asArray)(Ne).map(at=>_e(at,Ve)))}Pe.from=Fe;function _e(Ne,Ve){if(typeof Ne=="string")return{$serialized:!0,language:Ne};if(Ne)return{$serialized:!0,language:Ne.language,scheme:ee(Ne.scheme,Ve),pattern:Ee.from(Ne.pattern)??void 0,exclusive:Ne.exclusive,notebookType:Ne.notebookType}}function ee(Ne,Ve){return Ve&&typeof Ne=="string"?Ve.transformOutgoingScheme(Ne):Ne}})(o=e.DocumentSelector||(e.DocumentSelector={}));var d;(function(Pe){function Fe(ee){switch(ee){case c.DiagnosticTag.Unnecessary:return 1;case c.DiagnosticTag.Deprecated:return 2}}Pe.from=Fe;function _e(ee){switch(ee){case 1:return c.DiagnosticTag.Unnecessary;case 2:return c.DiagnosticTag.Deprecated;default:return}}Pe.to=_e})(d=e.DiagnosticTag||(e.DiagnosticTag={}));var r;(function(Pe){function Fe(ee){let Ne;return ee.code&&((0,k.isString)(ee.code)||(0,k.isNumber)(ee.code)?Ne=String(ee.code):Ne={value:String(ee.code.value),target:ee.code.target}),{...u.from(ee.range),message:ee.message,source:ee.source,code:Ne,severity:f.from(ee.severity),relatedInformation:ee.relatedInformation&&ee.relatedInformation.map(a.from),tags:Array.isArray(ee.tags)?(0,l.coalesce)(ee.tags.map(d.from)):void 0}}Pe.from=Fe;function _e(ee){const Ne=new c.Diagnostic(u.to(ee),ee.message,f.to(ee.severity));return Ne.source=ee.source,Ne.code=(0,k.isString)(ee.code)?ee.code:ee.code?.value,Ne.relatedInformation=ee.relatedInformation&&ee.relatedInformation.map(a.to),Ne.tags=ee.tags&&(0,l.coalesce)(ee.tags.map(d.to)),Ne}Pe.to=_e})(r=e.Diagnostic||(e.Diagnostic={}));var a;(function(Pe){function Fe(ee){return{...u.from(ee.location.range),message:ee.message,resource:ee.location.uri}}Pe.from=Fe;function _e(ee){return new c.DiagnosticRelatedInformation(new c.Location(ee.resource,u.to(ee)),ee.message)}Pe.to=_e})(a=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var f;(function(Pe){function Fe(ee){switch(ee){case c.DiagnosticSeverity.Error:return T.MarkerSeverity.Error;case c.DiagnosticSeverity.Warning:return T.MarkerSeverity.Warning;case c.DiagnosticSeverity.Information:return T.MarkerSeverity.Info;case c.DiagnosticSeverity.Hint:return T.MarkerSeverity.Hint}return T.MarkerSeverity.Error}Pe.from=Fe;function _e(ee){switch(ee){case T.MarkerSeverity.Info:return c.DiagnosticSeverity.Information;case T.MarkerSeverity.Warning:return c.DiagnosticSeverity.Warning;case T.MarkerSeverity.Error:return c.DiagnosticSeverity.Error;case T.MarkerSeverity.Hint:return c.DiagnosticSeverity.Hint;default:return c.DiagnosticSeverity.Error}}Pe.to=_e})(f=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var y;(function(Pe){function Fe(ee){return typeof ee=="number"&&ee>=c.ViewColumn.One?ee-1:ee===c.ViewColumn.Beside?h.SIDE_GROUP:h.ACTIVE_GROUP}Pe.from=Fe;function _e(ee){if(typeof ee=="number"&&ee>=0)return ee+1;throw new Error("invalid 'EditorGroupColumn'")}Pe.to=_e})(y=e.ViewColumn||(e.ViewColumn={}));function R(Pe){return typeof Pe.range<"u"}function N(Pe){return Pe.length===0?!0:!!R(Pe[0])}e.isDecorationOptionsArr=N;var M;(function(Pe){function Fe(Ke){return Ke.map(Pe.from)}Pe.fromMany=Fe;function _e(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function ee(Ke){let rt;if(_e(Ke)){const{language:Et,value:_t}=Ke;rt={value:"```"+Et+`
`+_t+"\n```\n"}}else c.MarkdownString.isMarkdownString(Ke)?rt={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons,supportHtml:Ke.supportHtml,baseUri:Ke.baseUri}:typeof Ke=="string"?rt={value:Ke}:rt={value:""};const dt=Object.create(null);rt.uris=dt;const mt=Et=>{try{let _t=L.URI.parse(Et,!0);_t=_t.with({query:Ne(_t.query,dt)}),dt[Et]=_t}catch{}return""},It=new _.marked.Renderer;return It.link=mt,It.image=Et=>typeof Et=="string"?mt(C.parseHrefAndDimensions(Et).href):"",(0,_.marked)(rt.value,{renderer:It}),rt}Pe.from=ee;function Ne(Ke,rt){if(!Ke)return Ke;let dt;try{dt=(0,I.parse)(Ke)}catch{}if(!dt)return Ke;let mt=!1;return dt=(0,w.cloneAndChange)(dt,It=>{if(L.URI.isUri(It)){const Et=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[Et]=It,mt=!0,Et}else return}),mt?JSON.stringify(dt):Ke}function Ve(Ke){const rt=new c.MarkdownString(Ke.value,Ke.supportThemeIcons);return rt.isTrusted=Ke.isTrusted,rt.supportHtml=Ke.supportHtml,rt.baseUri=Ke.baseUri?L.URI.from(Ke.baseUri):void 0,rt}Pe.to=Ve;function at(Ke){if(!!Ke)return typeof Ke=="string"?Ke:Pe.from(Ke)}Pe.fromStrict=at})(M=e.MarkdownString||(e.MarkdownString={}));function A(Pe){return N(Pe)?Pe.map(Fe=>({range:u.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?M.fromMany(Fe.hoverMessage):Fe.hoverMessage?M.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Pe.map(Fe=>({range:u.from(Fe)}))}e.fromRangeOrRangeWithMessage=A;function z(Pe){return typeof Pe>"u"?Pe:typeof Pe=="string"?L.URI.file(Pe):Pe}e.pathOrURIToURI=z;var H;(function(Pe){function Fe(_e){return typeof _e>"u"?_e:{contentText:_e.contentText,contentIconPath:_e.contentIconPath?z(_e.contentIconPath):void 0,border:_e.border,borderColor:_e.borderColor,fontStyle:_e.fontStyle,fontWeight:_e.fontWeight,textDecoration:_e.textDecoration,color:_e.color,backgroundColor:_e.backgroundColor,margin:_e.margin,width:_e.width,height:_e.height}}Pe.from=Fe})(H=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var F;(function(Pe){function Fe(_e){return typeof _e>"u"?_e:{backgroundColor:_e.backgroundColor,outline:_e.outline,outlineColor:_e.outlineColor,outlineStyle:_e.outlineStyle,outlineWidth:_e.outlineWidth,border:_e.border,borderColor:_e.borderColor,borderRadius:_e.borderRadius,borderSpacing:_e.borderSpacing,borderStyle:_e.borderStyle,borderWidth:_e.borderWidth,fontStyle:_e.fontStyle,fontWeight:_e.fontWeight,textDecoration:_e.textDecoration,cursor:_e.cursor,color:_e.color,opacity:_e.opacity,letterSpacing:_e.letterSpacing,gutterIconPath:_e.gutterIconPath?z(_e.gutterIconPath):void 0,gutterIconSize:_e.gutterIconSize,overviewRulerColor:_e.overviewRulerColor,before:_e.before?H.from(_e.before):void 0,after:_e.after?H.from(_e.after):void 0}}Pe.from=Fe})(F=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var G;(function(Pe){function Fe(_e){if(typeof _e>"u")return _e;switch(_e){case c.DecorationRangeBehavior.OpenOpen:return 0;case c.DecorationRangeBehavior.ClosedClosed:return 1;case c.DecorationRangeBehavior.OpenClosed:return 2;case c.DecorationRangeBehavior.ClosedOpen:return 3}}Pe.from=Fe})(G=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var B;(function(Pe){function Fe(_e){return{isWholeLine:_e.isWholeLine,rangeBehavior:_e.rangeBehavior?G.from(_e.rangeBehavior):void 0,overviewRulerLane:_e.overviewRulerLane,light:_e.light?F.from(_e.light):void 0,dark:_e.dark?F.from(_e.dark):void 0,backgroundColor:_e.backgroundColor,outline:_e.outline,outlineColor:_e.outlineColor,outlineStyle:_e.outlineStyle,outlineWidth:_e.outlineWidth,border:_e.border,borderColor:_e.borderColor,borderRadius:_e.borderRadius,borderSpacing:_e.borderSpacing,borderStyle:_e.borderStyle,borderWidth:_e.borderWidth,fontStyle:_e.fontStyle,fontWeight:_e.fontWeight,textDecoration:_e.textDecoration,cursor:_e.cursor,color:_e.color,opacity:_e.opacity,letterSpacing:_e.letterSpacing,gutterIconPath:_e.gutterIconPath?z(_e.gutterIconPath):void 0,gutterIconSize:_e.gutterIconSize,overviewRulerColor:_e.overviewRulerColor,before:_e.before?H.from(_e.before):void 0,after:_e.after?H.from(_e.after):void 0}}Pe.from=Fe})(B=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var U;(function(Pe){function Fe(ee){return{text:ee.newText,eol:ee.newEol&&Ye.from(ee.newEol),range:u.from(ee.range)}}Pe.from=Fe;function _e(ee){const Ne=new c.TextEdit(u.to(ee.range),ee.text);return Ne.newEol=typeof ee.eol>"u"?void 0:Ye.to(ee.eol),Ne}Pe.to=_e})(U=e.TextEdit||(e.TextEdit={}));var x;(function(Pe){function Fe(ee,Ne){const Ve={edits:[]};if(ee instanceof c.WorkspaceEdit){const at=new P.ResourceSet;for(const Ke of ee._allEntries())Ke._type===1&&L.URI.isUri(Ke.to)&&Ke.from===void 0&&at.add(Ke.to);for(const Ke of ee._allEntries())Ke._type===1?Ve.edits.push({oldResource:Ke.from,newResource:Ke.to,options:{...Ke.options,contentsBase64:Ke.options?.contents&&(0,t.encodeBase64)(t.VSBuffer.wrap(Ke.options.contents))},metadata:Ke.metadata}):Ke._type===2?Ve.edits.push({resource:Ke.uri,textEdit:U.from(Ke.edit),versionId:at.has(Ke.uri)?void 0:Ne?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===6?Ve.edits.push({resource:Ke.uri,textEdit:{range:u.from(Ke.range),text:Ke.edit.value,insertAsSnippet:!0},versionId:at.has(Ke.uri)?void 0:Ne?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===3?Ve.edits.push({metadata:Ke.metadata,resource:Ke.uri,cellEdit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:Ne?.getNotebookDocumentVersion(Ke.uri)}):Ke._type===5&&Ve.edits.push({metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:Ne?.getNotebookDocumentVersion(Ke.uri),cellEdit:{editType:1,index:Ke.index,count:Ke.count,cells:Ke.cells.map(Je.from)}})}return Ve}Pe.from=Fe;function _e(ee){const Ne=new c.WorkspaceEdit;for(const Ve of ee.edits)Ve.textEdit?Ne.replace(L.URI.revive(Ve.resource),u.to(Ve.textEdit.range),Ve.textEdit.text):Ne.renameFile(L.URI.revive(Ve.oldResource),L.URI.revive(Ve.newResource),Ve.options);return Ne}Pe.to=_e})(x=e.WorkspaceEdit||(e.WorkspaceEdit={}));var $;(function(Pe){const Fe=Object.create(null);Fe[c.SymbolKind.File]=0,Fe[c.SymbolKind.Module]=1,Fe[c.SymbolKind.Namespace]=2,Fe[c.SymbolKind.Package]=3,Fe[c.SymbolKind.Class]=4,Fe[c.SymbolKind.Method]=5,Fe[c.SymbolKind.Property]=6,Fe[c.SymbolKind.Field]=7,Fe[c.SymbolKind.Constructor]=8,Fe[c.SymbolKind.Enum]=9,Fe[c.SymbolKind.Interface]=10,Fe[c.SymbolKind.Function]=11,Fe[c.SymbolKind.Variable]=12,Fe[c.SymbolKind.Constant]=13,Fe[c.SymbolKind.String]=14,Fe[c.SymbolKind.Number]=15,Fe[c.SymbolKind.Boolean]=16,Fe[c.SymbolKind.Array]=17,Fe[c.SymbolKind.Object]=18,Fe[c.SymbolKind.Key]=19,Fe[c.SymbolKind.Null]=20,Fe[c.SymbolKind.EnumMember]=21,Fe[c.SymbolKind.Struct]=22,Fe[c.SymbolKind.Event]=23,Fe[c.SymbolKind.Operator]=24,Fe[c.SymbolKind.TypeParameter]=25;function _e(Ne){return typeof Fe[Ne]=="number"?Fe[Ne]:6}Pe.from=_e;function ee(Ne){for(const Ve in Fe)if(Fe[Ve]===Ne)return Number(Ve);return c.SymbolKind.Property}Pe.to=ee})($=e.SymbolKind||(e.SymbolKind={}));var Q;(function(Pe){function Fe(ee){switch(ee){case c.SymbolTag.Deprecated:return 1}}Pe.from=Fe;function _e(ee){switch(ee){case 1:return c.SymbolTag.Deprecated}}Pe.to=_e})(Q=e.SymbolTag||(e.SymbolTag={}));var K;(function(Pe){function Fe(ee){return{name:ee.name,kind:$.from(ee.kind),tags:ee.tags&&ee.tags.map(Q.from),containerName:ee.containerName,location:ve.from(ee.location)}}Pe.from=Fe;function _e(ee){const Ne=new c.SymbolInformation(ee.name,$.to(ee.kind),ee.containerName,ve.to(ee.location));return Ne.tags=ee.tags&&ee.tags.map(Q.to),Ne}Pe.to=_e})(K=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var de;(function(Pe){function Fe(ee){const Ne={name:ee.name||"!!MISSING: name!!",detail:ee.detail,range:u.from(ee.range),selectionRange:u.from(ee.selectionRange),kind:$.from(ee.kind),tags:ee.tags?.map(Q.from)??[]};return ee.children&&(Ne.children=ee.children.map(Fe)),Ne}Pe.from=Fe;function _e(ee){const Ne=new c.DocumentSymbol(ee.name,ee.detail,$.to(ee.kind),u.to(ee.range),u.to(ee.selectionRange));return(0,l.isNonEmptyArray)(ee.tags)&&(Ne.tags=ee.tags.map(Q.to)),ee.children&&(Ne.children=ee.children.map(_e)),Ne}Pe.to=_e})(de=e.DocumentSymbol||(e.DocumentSymbol={}));var te;(function(Pe){function Fe(ee){const Ne=new c.CallHierarchyItem($.to(ee.kind),ee.name,ee.detail||"",L.URI.revive(ee.uri),u.to(ee.range),u.to(ee.selectionRange));return Ne._sessionId=ee._sessionId,Ne._itemId=ee._itemId,Ne}Pe.to=Fe;function _e(ee,Ne,Ve){if(Ne=Ne??ee._sessionId,Ve=Ve??ee._itemId,Ne===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:Ve,name:ee.name,detail:ee.detail,kind:$.from(ee.kind),uri:ee.uri,range:u.from(ee.range),selectionRange:u.from(ee.selectionRange),tags:ee.tags?.map(Q.from)}}Pe.from=_e})(te=e.CallHierarchyItem||(e.CallHierarchyItem={}));var he;(function(Pe){function Fe(_e){return new c.CallHierarchyIncomingCall(te.to(_e.from),_e.fromRanges.map(ee=>u.to(ee)))}Pe.to=Fe})(he=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Y;(function(Pe){function Fe(_e){return new c.CallHierarchyOutgoingCall(te.to(_e.to),_e.fromRanges.map(ee=>u.to(ee)))}Pe.to=Fe})(Y=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ve;(function(Pe){function Fe(ee){return{range:ee.range&&u.from(ee.range),uri:ee.uri}}Pe.from=Fe;function _e(ee){return new c.Location(L.URI.revive(ee.uri),u.to(ee.range))}Pe.to=_e})(ve=e.location||(e.location={}));var be;(function(Pe){function Fe(ee){const Ne=ee,Ve=ee;return{originSelectionRange:Ne.originSelectionRange?u.from(Ne.originSelectionRange):void 0,uri:Ne.targetUri?Ne.targetUri:Ve.uri,range:u.from(Ne.targetRange?Ne.targetRange:Ve.range),targetSelectionRange:Ne.targetSelectionRange?u.from(Ne.targetSelectionRange):void 0}}Pe.from=Fe;function _e(ee){return{targetUri:L.URI.revive(ee.uri),targetRange:u.to(ee.range),targetSelectionRange:ee.targetSelectionRange?u.to(ee.targetSelectionRange):void 0,originSelectionRange:ee.originSelectionRange?u.to(ee.originSelectionRange):void 0}}Pe.to=_e})(be=e.DefinitionLink||(e.DefinitionLink={}));var ke;(function(Pe){function Fe(ee){return{range:u.from(ee.range),contents:M.fromMany(ee.contents)}}Pe.from=Fe;function _e(ee){return new c.Hover(ee.contents.map(M.to),u.to(ee.range))}Pe.to=_e})(ke=e.Hover||(e.Hover={}));var Re;(function(Pe){function Fe(ee){return{range:u.from(ee.range),expression:ee.expression}}Pe.from=Fe;function _e(ee){return new c.EvaluatableExpression(u.to(ee.range),ee.expression)}Pe.to=_e})(Re=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ze;(function(Pe){function Fe(ee){if(ee instanceof c.InlineValueText)return{type:"text",range:u.from(ee.range),text:ee.text};if(ee instanceof c.InlineValueVariableLookup)return{type:"variable",range:u.from(ee.range),variableName:ee.variableName,caseSensitiveLookup:ee.caseSensitiveLookup};if(ee instanceof c.InlineValueEvaluatableExpression)return{type:"expression",range:u.from(ee.range),expression:ee.expression};throw new Error("Unknown 'InlineValue' type")}Pe.from=Fe;function _e(ee){switch(ee.type){case"text":return{range:u.to(ee.range),text:ee.text};case"variable":return{range:u.to(ee.range),variableName:ee.variableName,caseSensitiveLookup:ee.caseSensitiveLookup};case"expression":return{range:u.to(ee.range),expression:ee.expression}}}Pe.to=_e})(ze=e.InlineValue||(e.InlineValue={}));var oe;(function(Pe){function Fe(ee){return{frameId:ee.frameId,stoppedLocation:u.from(ee.stoppedLocation)}}Pe.from=Fe;function _e(ee){return new c.InlineValueContext(ee.frameId,u.to(ee.stoppedLocation))}Pe.to=_e})(oe=e.InlineValueContext||(e.InlineValueContext={}));var le;(function(Pe){function Fe(ee){return{range:u.from(ee.range),kind:ee.kind}}Pe.from=Fe;function _e(ee){return new c.DocumentHighlight(u.to(ee.range),ee.kind)}Pe.to=_e})(le=e.DocumentHighlight||(e.DocumentHighlight={}));var me;(function(Pe){function Fe(_e){switch(_e){case 1:return c.CompletionTriggerKind.TriggerCharacter;case 2:return c.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return c.CompletionTriggerKind.Invoke}}Pe.to=Fe})(me=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Z;(function(Pe){function Fe(_e){return{triggerKind:me.to(_e.triggerKind),triggerCharacter:_e.triggerCharacter}}Pe.to=Fe})(Z=e.CompletionContext||(e.CompletionContext={}));var ae;(function(Pe){function Fe(ee){switch(ee){case c.CompletionItemTag.Deprecated:return 1}}Pe.from=Fe;function _e(ee){switch(ee){case 1:return c.CompletionItemTag.Deprecated}}Pe.to=_e})(ae=e.CompletionItemTag||(e.CompletionItemTag={}));var ne;(function(Pe){const Fe=new Map([[c.CompletionItemKind.Method,0],[c.CompletionItemKind.Function,1],[c.CompletionItemKind.Constructor,2],[c.CompletionItemKind.Field,3],[c.CompletionItemKind.Variable,4],[c.CompletionItemKind.Class,5],[c.CompletionItemKind.Interface,7],[c.CompletionItemKind.Struct,6],[c.CompletionItemKind.Module,8],[c.CompletionItemKind.Property,9],[c.CompletionItemKind.Unit,12],[c.CompletionItemKind.Value,13],[c.CompletionItemKind.Constant,14],[c.CompletionItemKind.Enum,15],[c.CompletionItemKind.EnumMember,16],[c.CompletionItemKind.Keyword,17],[c.CompletionItemKind.Snippet,27],[c.CompletionItemKind.Text,18],[c.CompletionItemKind.Color,19],[c.CompletionItemKind.File,20],[c.CompletionItemKind.Reference,21],[c.CompletionItemKind.Folder,23],[c.CompletionItemKind.Event,10],[c.CompletionItemKind.Operator,11],[c.CompletionItemKind.TypeParameter,24],[c.CompletionItemKind.Issue,26],[c.CompletionItemKind.User,25]]);function _e(Ve){return Fe.get(Ve)??9}Pe.from=_e;const ee=new Map([[0,c.CompletionItemKind.Method],[1,c.CompletionItemKind.Function],[2,c.CompletionItemKind.Constructor],[3,c.CompletionItemKind.Field],[4,c.CompletionItemKind.Variable],[5,c.CompletionItemKind.Class],[7,c.CompletionItemKind.Interface],[6,c.CompletionItemKind.Struct],[8,c.CompletionItemKind.Module],[9,c.CompletionItemKind.Property],[12,c.CompletionItemKind.Unit],[13,c.CompletionItemKind.Value],[14,c.CompletionItemKind.Constant],[15,c.CompletionItemKind.Enum],[16,c.CompletionItemKind.EnumMember],[17,c.CompletionItemKind.Keyword],[27,c.CompletionItemKind.Snippet],[18,c.CompletionItemKind.Text],[19,c.CompletionItemKind.Color],[20,c.CompletionItemKind.File],[21,c.CompletionItemKind.Reference],[23,c.CompletionItemKind.Folder],[10,c.CompletionItemKind.Event],[11,c.CompletionItemKind.Operator],[24,c.CompletionItemKind.TypeParameter],[25,c.CompletionItemKind.User],[26,c.CompletionItemKind.Issue]]);function Ne(Ve){return ee.get(Ve)??c.CompletionItemKind.Property}Pe.to=Ne})(ne=e.CompletionItemKind||(e.CompletionItemKind={}));var ie;(function(Pe){function Fe(_e,ee){const Ne=new c.CompletionItem(_e.label);return Ne.insertText=_e.insertText,Ne.kind=ne.to(_e.kind),Ne.tags=_e.tags?.map(ae.to),Ne.detail=_e.detail,Ne.documentation=C.isMarkdownString(_e.documentation)?M.to(_e.documentation):_e.documentation,Ne.sortText=_e.sortText,Ne.filterText=_e.filterText,Ne.preselect=_e.preselect,Ne.commitCharacters=_e.commitCharacters,D.Range.isIRange(_e.range)?Ne.range=u.to(_e.range):typeof _e.range=="object"&&(Ne.range={inserting:u.to(_e.range.insert),replacing:u.to(_e.range.replace)}),Ne.keepWhitespace=typeof _e.insertTextRules>"u"?!1:Boolean(_e.insertTextRules&1),typeof _e.insertTextRules<"u"&&_e.insertTextRules&4?Ne.insertText=new c.SnippetString(_e.insertText):(Ne.insertText=_e.insertText,Ne.textEdit=Ne.range instanceof c.Range?new c.TextEdit(Ne.range,Ne.insertText):void 0),_e.additionalTextEdits&&_e.additionalTextEdits.length>0&&(Ne.additionalTextEdits=_e.additionalTextEdits.map(Ve=>U.to(Ve))),Ne.command=ee&&_e.command?ee.fromInternal(_e.command):void 0,Ne}Pe.to=Fe})(ie=e.CompletionItem||(e.CompletionItem={}));var O;(function(Pe){function Fe(ee){if(typeof ee.label!="string"&&!Array.isArray(ee.label))throw new TypeError("Invalid label");return{label:ee.label,documentation:M.fromStrict(ee.documentation)}}Pe.from=Fe;function _e(ee){return{label:ee.label,documentation:C.isMarkdownString(ee.documentation)?M.to(ee.documentation):ee.documentation}}Pe.to=_e})(O=e.ParameterInformation||(e.ParameterInformation={}));var V;(function(Pe){function Fe(ee){return{label:ee.label,documentation:M.fromStrict(ee.documentation),parameters:Array.isArray(ee.parameters)?ee.parameters.map(O.from):[],activeParameter:ee.activeParameter}}Pe.from=Fe;function _e(ee){return{label:ee.label,documentation:C.isMarkdownString(ee.documentation)?M.to(ee.documentation):ee.documentation,parameters:Array.isArray(ee.parameters)?ee.parameters.map(O.to):[],activeParameter:ee.activeParameter}}Pe.to=_e})(V=e.SignatureInformation||(e.SignatureInformation={}));var q;(function(Pe){function Fe(ee){return{activeSignature:ee.activeSignature,activeParameter:ee.activeParameter,signatures:Array.isArray(ee.signatures)?ee.signatures.map(V.from):[]}}Pe.from=Fe;function _e(ee){return{activeSignature:ee.activeSignature,activeParameter:ee.activeParameter,signatures:Array.isArray(ee.signatures)?ee.signatures.map(V.to):[]}}Pe.to=_e})(q=e.SignatureHelp||(e.SignatureHelp={}));var X;(function(Pe){function Fe(_e,ee){const Ne=new c.InlayHint(i.to(ee.position),typeof ee.label=="string"?ee.label:ee.label.map(ge.to.bind(void 0,_e)),ee.kind&&we.to(ee.kind));return Ne.textEdits=ee.textEdits&&ee.textEdits.map(U.to),Ne.tooltip=C.isMarkdownString(ee.tooltip)?M.to(ee.tooltip):ee.tooltip,Ne.paddingLeft=ee.paddingLeft,Ne.paddingRight=ee.paddingRight,Ne}Pe.to=Fe})(X=e.InlayHint||(e.InlayHint={}));var ge;(function(Pe){function Fe(_e,ee){const Ne=new c.InlayHintLabelPart(ee.label);return Ne.tooltip=C.isMarkdownString(ee.tooltip)?M.to(ee.tooltip):ee.tooltip,S.Command.is(ee.command)&&(Ne.command=_e.fromInternal(ee.command)),ee.location&&(Ne.location=ve.to(ee.location)),Ne}Pe.to=Fe})(ge=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var we;(function(Pe){function Fe(ee){return ee}Pe.from=Fe;function _e(ee){return ee}Pe.to=_e})(we=e.InlayHintKind||(e.InlayHintKind={}));var ce;(function(Pe){function Fe(ee){return{range:u.from(ee.range),url:ee.target,tooltip:ee.tooltip}}Pe.from=Fe;function _e(ee){let Ne;if(ee.url)try{Ne=typeof ee.url=="string"?L.URI.parse(ee.url,!0):L.URI.revive(ee.url)}catch{}return new c.DocumentLink(u.to(ee.range),Ne)}Pe.to=_e})(ce=e.DocumentLink||(e.DocumentLink={}));var Ce;(function(Pe){function Fe(ee){const Ne=new c.ColorPresentation(ee.label);return ee.textEdit&&(Ne.textEdit=U.to(ee.textEdit)),ee.additionalTextEdits&&(Ne.additionalTextEdits=ee.additionalTextEdits.map(Ve=>U.to(Ve))),Ne}Pe.to=Fe;function _e(ee){return{label:ee.label,textEdit:ee.textEdit?U.from(ee.textEdit):void 0,additionalTextEdits:ee.additionalTextEdits?ee.additionalTextEdits.map(Ne=>U.from(Ne)):void 0}}Pe.from=_e})(Ce=e.ColorPresentation||(e.ColorPresentation={}));var ye;(function(Pe){function Fe(ee){return new c.Color(ee[0],ee[1],ee[2],ee[3])}Pe.to=Fe;function _e(ee){return[ee.red,ee.green,ee.blue,ee.alpha]}Pe.from=_e})(ye=e.Color||(e.Color={}));var We;(function(Pe){function Fe(ee){return{range:u.from(ee.range)}}Pe.from=Fe;function _e(ee){return new c.SelectionRange(u.to(ee.range))}Pe.to=_e})(We=e.SelectionRange||(e.SelectionRange={}));var qe;(function(Pe){function Fe(_e){switch(_e){case 2:return c.TextDocumentSaveReason.AfterDelay;case 1:return c.TextDocumentSaveReason.Manual;case 3:case 4:return c.TextDocumentSaveReason.FocusOut}}Pe.to=Fe})(qe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ze;(function(Pe){function Fe(ee){switch(ee){case c.TextEditorLineNumbersStyle.Off:return 0;case c.TextEditorLineNumbersStyle.Relative:return 2;case c.TextEditorLineNumbersStyle.On:default:return 1}}Pe.from=Fe;function _e(ee){switch(ee){case 0:return c.TextEditorLineNumbersStyle.Off;case 2:return c.TextEditorLineNumbersStyle.Relative;case 1:default:return c.TextEditorLineNumbersStyle.On}}Pe.to=_e})(Ze=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ye;(function(Pe){function Fe(ee){if(ee===c.EndOfLine.CRLF)return 1;if(ee===c.EndOfLine.LF)return 0}Pe.from=Fe;function _e(ee){if(ee===1)return c.EndOfLine.CRLF;if(ee===0)return c.EndOfLine.LF}Pe.to=_e})(Ye=e.EndOfLine||(e.EndOfLine={}));var Oe;(function(Pe){function Fe(_e){if(typeof _e=="object")return _e.viewId;switch(_e){case c.ProgressLocation.SourceControl:return 3;case c.ProgressLocation.Window:return 10;case c.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Pe.from=Fe})(Oe=e.ProgressLocation||(e.ProgressLocation={}));var ot;(function(Pe){function Fe(_e){const ee={start:_e.start+1,end:_e.end+1};return _e.kind&&(ee.kind=re.from(_e.kind)),ee}Pe.from=Fe})(ot=e.FoldingRange||(e.FoldingRange={}));var re;(function(Pe){function Fe(_e){if(_e)switch(_e){case c.FoldingRangeKind.Comment:return S.FoldingRangeKind.Comment;case c.FoldingRangeKind.Imports:return S.FoldingRangeKind.Imports;case c.FoldingRangeKind.Region:return S.FoldingRangeKind.Region}}Pe.from=Fe})(re=e.FoldingRangeKind||(e.FoldingRangeKind={}));var se;(function(Pe){function Fe(_e){if(_e)return{pinned:typeof _e.preview=="boolean"?!_e.preview:void 0,inactive:_e.background,preserveFocus:_e.preserveFocus,selection:typeof _e.selection=="object"?u.from(_e.selection):void 0,override:typeof _e.override=="boolean"?p.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Pe.from=Fe})(se=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ee;(function(Pe){function Fe(Ve){return Ve instanceof c.RelativePattern?Ve.toJSON():typeof Ve=="string"?Ve:_e(Ve)||ee(Ve)?new c.RelativePattern(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}Pe.from=Fe;function _e(Ve){const at=Ve;return at?L.URI.isUri(at.baseUri)&&typeof at.pattern=="string":!1}function ee(Ve){const at=Ve;return at?typeof at.base=="string"&&typeof at.pattern=="string":!1}function Ne(Ve){return typeof Ve=="string"?Ve:new c.RelativePattern(L.URI.revive(Ve.baseUri),Ve.pattern)}Pe.to=Ne})(Ee=e.GlobPattern||(e.GlobPattern={}));var xe;(function(Pe){function Fe(_e){if(_e){if(Array.isArray(_e))return _e.map(Fe);if(typeof _e=="string")return _e;{const ee=_e;return{language:ee.language,scheme:ee.scheme,pattern:Ee.from(ee.pattern),exclusive:ee.exclusive,notebookType:ee.notebookType}}}else return}Pe.from=Fe})(xe=e.LanguageSelector||(e.LanguageSelector={}));var fe;(function(Pe){function Fe(ee){return{start:ee.start,end:ee.end}}Pe.from=Fe;function _e(ee){return new c.NotebookRange(ee.start,ee.end)}Pe.to=_e})(fe=e.NotebookRange||(e.NotebookRange={}));var Ae;(function(Pe){function Fe(ee){return{timing:typeof ee.runStartTime=="number"&&typeof ee.runEndTime=="number"?{startTime:ee.runStartTime,endTime:ee.runEndTime}:void 0,executionOrder:ee.executionOrder,success:ee.lastRunSuccess}}Pe.to=Fe;function _e(ee){return{lastRunSuccess:ee.success,runStartTime:ee.timing?.startTime,runEndTime:ee.timing?.endTime,executionOrder:ee.executionOrder}}Pe.from=_e})(Ae=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Le;(function(Pe){function Fe(_e){if(_e===b.NotebookCellExecutionState.Unconfirmed)return c.NotebookCellExecutionState.Pending;if(_e===b.NotebookCellExecutionState.Pending)return;if(_e===b.NotebookCellExecutionState.Executing)return c.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${_e}`)}Pe.to=Fe})(Le=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Me;(function(Pe){function Fe(ee){switch(ee){case c.NotebookCellKind.Markup:return b.CellKind.Markup;case c.NotebookCellKind.Code:default:return b.CellKind.Code}}Pe.from=Fe;function _e(ee){switch(ee){case b.CellKind.Markup:return c.NotebookCellKind.Markup;case b.CellKind.Code:default:return c.NotebookCellKind.Code}}Pe.to=_e})(Me=e.NotebookCellKind||(e.NotebookCellKind={}));var Ge;(function(Pe){function Fe(ee){const Ne={metadata:ee.metadata??Object.create(null),cells:[]};for(const Ve of ee.cells)c.NotebookCellData.validate(Ve),Ne.cells.push(Je.from(Ve));return Ne}Pe.from=Fe;function _e(ee){const Ne=new c.NotebookData(ee.cells.map(Je.to));return(0,k.isEmptyObject)(ee.metadata)||(Ne.metadata=ee.metadata),Ne}Pe.to=_e})(Ge=e.NotebookData||(e.NotebookData={}));var Je;(function(Pe){function Fe(ee){return{cellKind:Me.from(ee.kind),language:ee.languageId,mime:ee.mime,source:ee.value,metadata:ee.metadata,internalMetadata:Ae.from(ee.executionSummary??{}),outputs:ee.outputs?ee.outputs.map(vt.from):[]}}Pe.from=Fe;function _e(ee){return new c.NotebookCellData(Me.to(ee.cellKind),ee.source,ee.language,ee.mime,ee.outputs?ee.outputs.map(vt.to):void 0,ee.metadata,ee.internalMetadata?Ae.to(ee.internalMetadata):void 0)}Pe.to=_e})(Je=e.NotebookCellData||(e.NotebookCellData={}));var st;(function(Pe){function Fe(ee){return{mime:ee.mime,valueBytes:t.VSBuffer.wrap(ee.data)}}Pe.from=Fe;function _e(ee){return new c.NotebookCellOutputItem(ee.valueBytes.buffer,ee.mime)}Pe.to=_e})(st=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var vt;(function(Pe){function Fe(ee){return{outputId:ee.id,items:ee.items.map(st.from),metadata:ee.metadata}}Pe.from=Fe;function _e(ee){const Ne=ee.items.map(st.to);return new c.NotebookCellOutput(Ne,ee.outputId,ee.metadata)}Pe.to=_e})(vt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var nt;(function(Pe){function Fe(Ne){return ee(Ne)?{include:(0,k.withNullAsUndefined)(Ee.from(Ne.include)),exclude:(0,k.withNullAsUndefined)(Ee.from(Ne.exclude))}:(0,k.withNullAsUndefined)(Ee.from(Ne))}Pe.from=Fe;function _e(Ne){return ee(Ne)?{include:Ee.to(Ne.include),exclude:Ee.to(Ne.exclude)}:Ee.to(Ne)}Pe.to=_e;function ee(Ne){const Ve=Ne;return Ve?!(0,k.isUndefinedOrNull)(Ve.include)&&!(0,k.isUndefinedOrNull)(Ve.exclude):!1}})(nt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var it;(function(Pe){function Fe(_e,ee,Ne){const Ve=typeof _e.command=="string"?{title:"",command:_e.command}:_e.command;return{alignment:_e.alignment===c.NotebookCellStatusBarAlignment.Left?1:2,command:ee.toInternal(Ve,Ne),text:_e.text,tooltip:_e.tooltip,accessibilityInformation:_e.accessibilityInformation,priority:_e.priority}}Pe.from=Fe})(it=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var wt;(function(Pe){function Fe(_e){return{transientOutputs:_e?.transientOutputs??!1,transientCellMetadata:_e?.transientCellMetadata??{},transientDocumentMetadata:_e?.transientDocumentMetadata??{},cellContentMetadata:_e?.cellContentMetadata??{}}}Pe.from=Fe})(wt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ct;(function(Pe){function Fe(ee){return{uri:ee.uri,provides:ee.provides}}Pe.from=Fe;function _e(ee){return new c.NotebookRendererScript(L.URI.revive(ee.uri),ee.provides)}Pe.to=_e})(Ct=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Dt;(function(Pe){function Fe(ee){return{message:M.fromStrict(ee.message)||"",type:0,expected:ee.expectedOutput,actual:ee.actualOutput,location:ee.location&&{range:u.from(ee.location.range),uri:ee.location.uri}}}Pe.from=Fe;function _e(ee){const Ne=new c.TestMessage(typeof ee.message=="string"?ee.message:M.to(ee.message));return Ne.actualOutput=ee.actual,Ne.expectedOutput=ee.expected,Ne.location=ee.location?ve.to(ee.location):void 0,Ne}Pe.to=_e})(Dt=e.TestMessage||(e.TestMessage={}));var ht;(function(Pe){Pe.namespace=v.namespaceTestTag,Pe.denamespace=v.denamespaceTestTag})(ht=e.TestTag||(e.TestTag={}));var Tt;(function(Pe){function Fe(ee){const Ne=(0,E.getPrivateApiFor)(ee).controllerId;return{extId:m.TestId.fromExtHostTestItem(ee,Ne).toString(),label:ee.label,uri:L.URI.revive(ee.uri),busy:ee.busy,tags:ee.tags.map(Ve=>ht.namespace(Ne,Ve.id)),range:D.Range.lift(u.from(ee.range)),description:ee.description||null,sortText:ee.sortText||null,error:ee.error&&M.fromStrict(ee.error)||null}}Pe.from=Fe;function _e(ee){return{parent:void 0,error:void 0,id:m.TestId.fromString(ee.extId).localId,label:ee.label,uri:L.URI.revive(ee.uri),tags:(ee.tags||[]).map(Ne=>{const{tagId:Ve}=ht.denamespace(Ne);return new c.TestTag(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:u.to(ee.range||void 0),canResolveChildren:!1,busy:ee.busy,description:ee.description||void 0,sortText:ee.sortText||void 0}}Pe.toPlain=_e})(Tt=e.TestItem||(e.TestItem={})),function(Pe){function Fe(ee){return{id:ee.id}}Pe.from=Fe;function _e(ee){return new c.TestTag(ee.id)}Pe.to=_e}(ht=e.TestTag||(e.TestTag={}));var Ut;(function(Pe){const Fe=(ee,Ne)=>{const Ve=[];for(const[Ke,rt]of Ne)m.TestId.compare(rt.item.extId,Ke)===2&&(Ne.delete(Ke),Ve.push(rt));const at={...Tt.toPlain(ee.item),parent:void 0,taskStates:ee.tasks.map(Ke=>({state:Ke.state,duration:Ke.duration,messages:Ke.messages.filter(rt=>rt.type===0).map(Dt.to)})),children:Ve.map(Ke=>Fe(Ke,Ne))};for(const Ke of at.children)Ke.parent=at;return at};function _e(ee){const Ne=[],Ve=new Map;for(const at of ee.items){Ve.set(at.item.extId,at);const Ke=m.TestId.root(at.item.extId);ee.request.targets.some(rt=>rt.controllerId===Ke&&rt.testIds.includes(at.item.extId))&&Ne.push(at)}return{completedAt:ee.completedAt,results:Ne.map(at=>Fe(at,Ve))}}Pe.to=_e})(Ut=e.TestResults||(e.TestResults={}));var Wt;(function(Pe){function Fe(Ve){return{covered:Ve.covered,total:Ve.covered}}function _e(Ve){return"line"in Ve?i.from(Ve):u.from(Ve)}function ee(Ve){return"branches"in Ve?{count:Ve.executionCount,location:_e(Ve.location),type:1,branches:Ve.branches.length?Ve.branches.map(at=>({count:at.executionCount,location:at.location&&_e(at.location)})):void 0}:{type:0,count:Ve.executionCount,location:_e(Ve.location)}}Pe.fromDetailed=ee;function Ne(Ve){return{uri:Ve.uri,statement:Fe(Ve.statementCoverage),branch:Ve.branchCoverage&&Fe(Ve.branchCoverage),function:Ve.functionCoverage&&Fe(Ve.functionCoverage),details:Ve.detailedCoverage?.map(ee)}}Pe.fromFile=Ne})(Wt=e.TestCoverage||(e.TestCoverage={}));var Qe;(function(Pe){function Fe(_e){switch(_e){case 1:return c.CodeActionTriggerKind.Invoke;case 2:return c.CodeActionTriggerKind.Automatic}}Pe.to=Fe})(Qe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ft;(function(Pe){function Fe(ee){const Ne=new c.TypeHierarchyItem($.to(ee.kind),ee.name,ee.detail||"",L.URI.revive(ee.uri),u.to(ee.range),u.to(ee.selectionRange));return Ne._sessionId=ee._sessionId,Ne._itemId=ee._itemId,Ne}Pe.to=Fe;function _e(ee,Ne,Ve){if(Ne=Ne??ee._sessionId,Ve=Ve??ee._itemId,Ne===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:Ve,kind:$.from(ee.kind),name:ee.name,detail:ee.detail??"",uri:ee.uri,range:u.from(ee.range),selectionRange:u.from(ee.selectionRange),tags:ee.tags?.map(Q.from)}}Pe.from=_e})(Ft=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Pt;(function(Pe){function Fe(_e){if(!!_e)return{value:_e.value,tooltip:_e.tooltip}}Pe.from=Fe})(Pt=e.ViewBadge||(e.ViewBadge={}));var Nt;(function(Pe){function Fe(_e,ee){const Ne=_e.fileData;return Ne?new class extends c.DataTransferItem{asFile(){return{name:Ne.name,uri:L.URI.revive(Ne.uri),data:(0,g.once)(()=>ee())}}}("",_e.id):new c.DataTransferItem(_e.asString)}Pe.toDataTransferItem=Fe})(Nt=e.DataTransferItem||(e.DataTransferItem={}));var gt;(function(Pe){function Fe(ee,Ne){const Ve=ee.items.map(([at,Ke])=>[at,Nt.toDataTransferItem(Ke,()=>Ne(Ke.id))]);return new c.DataTransfer(Ve)}Pe.toDataTransfer=Fe;async function _e(ee){const Ne={items:[]},Ve=[];return ee.forEach((at,Ke)=>{Ve.push((async()=>{const rt=await at.asString(),dt=at.asFile();Ne.items.push([Ke,{id:at.id,asString:rt,fileData:dt?{name:dt.name,uri:dt.uri}:void 0}])})())}),await Promise.all(Ve),Ne}Pe.toDataTransferDTO=_e})(gt=e.DataTransfer||(e.DataTransfer={}))}),define(De[226],Ie([1,0,2,10,7,15,77]),function(J,e,l,t,C,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class I{constructor(k,L,D,S={timeout:1500,errors:3}){this._logService=k,this._documents=L,this._mainThreadBulkEdits=D,this._thresholds=S,this._callbacks=new _.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(k){return(L,D,S)=>{const E={dispose:this._callbacks.push([L,D,k])};return Array.isArray(S)&&S.push(E),E}}async $participateInSave(k,L){const D=l.URI.revive(k);let S=!1;const T=setTimeout(()=>S=!0,this._thresholds.timeout),E=[];try{for(const p of[...this._callbacks]){if(S)break;const b=this._documents.getDocument(D),m=await this._deliverEventAsyncAndBlameBadListeners(p,{document:b,reason:P.TextDocumentSaveReason.to(L)});E.push(m)}}finally{clearTimeout(T)}return E}_deliverEventAsyncAndBlameBadListeners([k,L,D],S){const T=this._badListeners.get(k);return typeof T=="number"&&T>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(D,k,L,S).then(()=>!0,E=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this._logService.error(E),!(E instanceof Error)||E.message!=="concurrent_edits"){const p=this._badListeners.get(k);this._badListeners.set(k,p?p+1:1),typeof p=="number"&&p>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(k,L,D,S){const T=[],E=Date.now(),{document:p,reason:b}=S,{version:m}=p,v=Object.freeze({document:p,reason:b,waitUntil(h){if(Object.isFrozen(T))throw(0,t.illegalState)("waitUntil can not be called async");T.push(Promise.resolve(h))}});try{L.apply(D,[v])}catch(h){return Promise.reject(h)}return Object.freeze(T),new Promise((h,c)=>{const g=setTimeout(()=>c(new Error("timeout")),this._thresholds.timeout);return Promise.all(T).then(n=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-E}ms`),clearTimeout(g),h(n)}).catch(n=>{clearTimeout(g),c(n)})}).then(h=>{const c={edits:[]};for(const g of h)if(Array.isArray(g)&&g.every(n=>n instanceof C.TextEdit))for(const{newText:n,newEol:u,range:s}of g)c.edits.push({resource:p.uri,versionId:void 0,textEdit:{range:s&&P.Range.from(s),text:n,eol:u&&P.EndOfLine.from(u)}});if(c.edits.length!==0)return m===p.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=I}),define(De[227],Ie([1,0,12,2,15,7,88]),function(J,e,l,t,C,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class I{constructor(D,S,T,E){this.start=D,this.deletedCount=S,this.deletedItems=T,this.items=E}asApiEvent(){return{range:new P.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class w{static asModelAddData(D,S){return{EOL:S.eol,lines:S.source,languageId:S.language,uri:S.uri,isDirty:!1,versionId:1,notebook:D}}constructor(D,S,T){this.notebook=D,this._extHostDocument=S,this._cellData=T,this.handle=T.handle,this.uri=t.URI.revive(T.uri),this.cellKind=T.cellKind,this._outputs=T.outputs.map(C.NotebookCellOutput.to),this._internalMetadata=T.internalMetadata??{},this._metadata=Object.freeze(T.metadata??{}),this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(T.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const D=this,S=this._extHostDocument.getDocument(this.uri);if(!S)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const T={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:C.NotebookCellKind.to(this._cellData.cellKind),document:S.document,get mime(){return D._mime},set mime(E){D._mime=E},get outputs(){return D._outputs.slice(0)},get metadata(){return D._metadata},get executionSummary(){return D._previousResult}};this._apiCell=Object.freeze(T)}return this._apiCell}setOutputs(D){this._outputs=D.map(C.NotebookCellOutput.to)}setOutputItems(D,S,T){const E=T.map(C.NotebookCellOutputItem.to),p=this._outputs.find(b=>b.id===D);p&&(S||(p.items.length=0),p.items.push(...E))}setMetadata(D){this._metadata=Object.freeze(D)}setInternalMetadata(D){this._internalMetadata=D,this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.ExtHostCell=w;class k{constructor(D,S,T,E,p){this._proxy=D,this._textDocumentsAndEditors=S,this._textDocuments=T,this.uri=E,this.handle=k._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=p.viewType,this._metadata=Object.freeze(p.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,p.cells]],!0,void 0),this._versionId=p.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const D=this,S={get uri(){return D.uri},get version(){return D._versionId},get notebookType(){return D._notebookType},get isDirty(){return D._isDirty},get isUntitled(){return D.uri.scheme===l.Schemas.untitled},get isClosed(){return D._disposed},get metadata(){return D._metadata},get cellCount(){return D._cells.length},cellAt(T){return T=D._validateIndex(T),D._cells[T].apiCell},getCells(T){return(T?D._getCells(T):D._cells).map(p=>p.apiCell)},save(){return D._save()}};this._notebook=Object.freeze(S)}return this._notebook}acceptDocumentPropertiesChanged(D){D.metadata&&(this._metadata=Object.freeze({...this._metadata,...D.metadata}))}acceptDirty(D){this._isDirty=D}acceptModelChanged(D,S,T){this._versionId=D.versionId,this._isDirty=S,this.acceptDocumentPropertiesChanged({metadata:T});const E={notebook:this.apiNotebook,metadata:T,cellChanges:[],contentChanges:[]},p=[];for(const m of D.rawEvents)m.kind===_.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(m.changes,!1,E.contentChanges):m.kind===_.NotebookCellsChangeType.Move?this._moveCell(m.index,m.newIdx,E.contentChanges):m.kind===_.NotebookCellsChangeType.Output?(this._setCellOutputs(m.index,m.outputs),p.push({cell:this._cells[m.index].apiCell,outputs:this._cells[m.index].apiCell.outputs})):m.kind===_.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(m.index,m.outputId,m.append,m.outputItems),p.push({cell:this._cells[m.index].apiCell,outputs:this._cells[m.index].apiCell.outputs})):m.kind===_.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(m.index,m.language),p.push({cell:this._cells[m.index].apiCell,document:this._cells[m.index].apiCell.document})):m.kind===_.NotebookCellsChangeType.ChangeCellContent?p.push({cell:this._cells[m.index].apiCell,document:this._cells[m.index].apiCell.document}):m.kind===_.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(m.index,m.mime):m.kind===_.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(m.index,m.metadata),p.push({cell:this._cells[m.index].apiCell,metadata:this._cells[m.index].apiCell.metadata})):m.kind===_.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(m.index,m.internalMetadata),p.push({cell:this._cells[m.index].apiCell,executionSummary:this._cells[m.index].apiCell.executionSummary}));const b=new Map;for(let m=0;m<p.length;m++){const v=p[m],h=b.get(v.cell);if(h===void 0){const c=E.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...v});b.set(v.cell,c-1)}else E.cellChanges[h]={...E.cellChanges[h],...v}}return Object.freeze(E),Object.freeze(E.cellChanges),Object.freeze(E.contentChanges),E}_validateIndex(D){return D=D|0,D<0?0:D>=this._cells.length?this._cells.length-1:D}_validateRange(D){let S=D.start|0,T=D.end|0;return S<0&&(S=0),T>this._cells.length&&(T=this._cells.length),D.with({start:S,end:T})}_getCells(D){D=this._validateRange(D);const S=[];for(let T=D.start;T<D.end;T++)S.push(this._cells[T]);return S}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(D,S,T){if(this._disposed)return;const E=[],p=[],b=[];if(D.reverse().forEach(m=>{const h=m[2].map(n=>{const u=new w(this,this._textDocumentsAndEditors,n);return S||p.push(w.asModelAddData(this.apiNotebook,n)),u}),c=new I(m[0],m[1],[],h),g=this._cells.splice(m[0],m[1],...h);for(const n of g)b.push(n.uri),c.deletedItems.push(n.apiCell);E.push(c)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:p,removedDocuments:b}),T)for(const m of E)T.push(m.asApiEvent())}_moveCell(D,S,T){const E=this._cells.splice(D,1);this._cells.splice(S,0,...E);const p=[new I(D,1,E.map(b=>b.apiCell),[]),new I(S,0,[],E)];for(const b of p)T.push(b.asApiEvent())}_setCellOutputs(D,S){this._cells[D].setOutputs(S)}_setCellOutputItems(D,S,T,E){this._cells[D].setOutputItems(S,T,E)}_changeCellLanguage(D,S){const T=this._cells[D];T.apiCell.document.languageId!==S&&this._textDocuments.$acceptModelLanguageChanged(T.uri,S)}_changeCellMime(D,S){const T=this._cells[D];T.apiCell.mime=S}_changeCellMetadata(D,S){this._cells[D].setMetadata(S)}_changeCellInternalMetadata(D,S){this._cells[D].setInternalMetadata(S)}getCellFromApiCell(D){return this._cells.find(S=>S.apiCell===D)}getCellFromIndex(D){return this._cells[D]}getCell(D){return this._cells.find(S=>S.handle===D)}getCellIndex(D){return this._cells.indexOf(D)}}e.ExtHostNotebookDocument=k,k._handlePool=0}),define(De[133],Ie([1,0,10,15,7]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class P{constructor(I,w,k,L,D,S){this.id=I,this._proxy=w,this.notebookData=k,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=D,this._visibleRanges=L,this._viewColumn=S}get apiEditor(){if(!this._editor){const I=this;this._editor={get document(){return I.notebookData.apiNotebook},get notebook(){return I.notebookData.apiNotebook},get selection(){return I._selections[0]},set selection(w){this.selections=[w]},get selections(){return I._selections},set selections(w){if(!Array.isArray(w)||!w.every(C.NotebookRange.isNotebookRange))throw(0,l.illegalArgument)("selections");I._selections=w,I._trySetSelections(w)},get visibleRanges(){return I._visibleRanges},revealRange(w,k){I._proxy.$tryRevealRange(I.id,t.NotebookRange.from(w),k??C.NotebookEditorRevealType.Default)},get viewColumn(){return I._viewColumn}},P.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(I){this._visible=I}_acceptVisibleRanges(I){this._visibleRanges=I}_acceptSelections(I){this._selections=I}_trySetSelections(I){this._proxy.$trySetSelections(this.id,I.map(t.NotebookRange.from))}_acceptViewColumn(I){this._viewColumn=I}}e.ExtHostNotebookEditor=P,P.apiEditorsToExtHost=new WeakMap}),define(De[228],Ie([1,0,4,13,15]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let P=class{constructor(I,w){this._logService=I,this._notebooksAndEditors=w,this._onDidChangeNotebookEditorSelection=new l.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new l.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(I,w){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",I,w);const k=this._notebooksAndEditors.getEditorById(I);w.visibleRanges&&k._acceptVisibleRanges(w.visibleRanges.ranges.map(C.NotebookRange.to)),w.selections&&k._acceptSelections(w.selections.selections.map(C.NotebookRange.to)),w.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),w.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(I){for(const w in I)this._notebooksAndEditors.getEditorById(w)._acceptViewColumn(C.ViewColumn.to(I[w]))}};P=je([$e(0,t.ILogService)],P),e.ExtHostNotebookEditors=P}),define(De[229],Ie([1,0,15,120,172,21,59,10]),function(J,e,l,t,C,P,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class w{constructor(S){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=S}async withProgress(S,T,E){const p=this._handles++,{title:b,location:m,cancellable:v}=T,h={label:(0,C.localize)(0,null,S.displayName||S.name),id:S.identifier.value};return this._proxy.$startProgress(p,{location:l.ProgressLocation.from(m),title:b,source:h,cancellable:v},S.isUnderDevelopment?void 0:S.identifier.value).catch(I.onUnexpectedExternalError),this._withProgress(p,E,!!v)}_withProgress(S,T,E){let p;E&&(p=new P.CancellationTokenSource,this._mapHandleToCancellationSource.set(S,p));const b=v=>{this._proxy.$progressEnd(v),this._mapHandleToCancellationSource.delete(v),p?.dispose()};let m;try{m=T(new L(this._proxy,S),E&&p?p.token:P.CancellationToken.None)}catch(v){throw b(S),v}return m.then(v=>b(S),v=>b(S)),m}$acceptProgressCanceled(S){const T=this._mapHandleToCancellationSource.get(S);T&&(T.cancel(),this._mapHandleToCancellationSource.delete(S))}}e.ExtHostProgress=w;function k(D,S){return D.message=S.message,typeof S.increment=="number"&&(typeof D.increment=="number"?D.increment+=S.increment:D.increment=S.increment),D}class L extends t.Progress{constructor(S,T){super(E=>this.throttledReport(E)),this._proxy=S,this._handle=T}throttledReport(S){this._proxy.$progressReport(this._handle,S)}}je([(0,_.throttle)(100,(D,S)=>k(D,S),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(De[134],Ie([1,0,35,129,55,89,64,15,2]),function(J,e,l,t,C,P,_,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const k=(h,c,g,n)=>{let u=c;return{enumerable:!0,configurable:!1,get(){return u},set(s){if(!g(u,s)){const i=u;u=s,h.listener?.(n(s,i))}}}},L=(h,c)=>h===c,D={range:(h,c)=>h===c?!0:!h||!c?!1:h.isEqual(c),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(h,c)=>!(h.length!==c.length||h.some(g=>!c.find(n=>g.id===n.id)))},S=h=>c=>({op:4,update:h(c)}),T=(h,c)=>({range:(()=>{let g;const n=S(u=>({range:l.Range.lift(I.Range.from(u))}));return{enumerable:!0,configurable:!1,get(){return g},set(u){h.listener?.({op:6}),D.range(g,u)||(g=u,h.listener?.(n(u)))}}})(),label:k(h,c,D.label,S(g=>({label:g}))),description:k(h,void 0,D.description,S(g=>({description:g}))),sortText:k(h,void 0,D.sortText,S(g=>({sortText:g}))),canResolveChildren:k(h,!1,D.canResolveChildren,g=>({op:2,state:g})),busy:k(h,!1,D.busy,S(g=>({busy:g}))),error:k(h,void 0,D.error,S(g=>({error:I.MarkdownString.fromStrict(g)||null}))),tags:k(h,[],D.tags,(g,n)=>({op:1,new:g.map(I.TestTag.from),old:n.map(I.TestTag.from)}))}),E=h=>{const c=C.TestId.fromString(h.extId),g=new b(c.controllerId,c.localId,h.label,w.URI.revive(h.uri)||void 0);return g.range=I.Range.to(h.range||void 0),g.description=h.description||void 0,g.sortText=h.sortText||void 0,g.tags=h.tags.map(n=>I.TestTag.to({id:(0,_.denamespaceTestTag)(n).tagId})),g},p=h=>{let c;for(const g of h.tests){const n=E(g.item);(0,t.getPrivateApiFor)(n).parent=c,c=n}return c};e.toItemFromContext=p;class b{constructor(c,g,n,u){if(g.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(g)} symbol`);const s=(0,t.createPrivateApiFor)(this,c);Object.defineProperties(this,{id:{value:g,enumerable:!0,writable:!1},uri:{value:u,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof m?void 0:s.parent}},children:{value:(0,P.createTestItemChildren)(s,t.getPrivateApiFor,b),enumerable:!0,writable:!1},...T(s,n)})}}e.TestItemImpl=b;class m extends b{constructor(c,g){super(c,c,g,void 0),this._isRoot=!0}}e.TestItemRootImpl=m;class v extends P.TestItemCollection{constructor(c,g,n){super({controllerId:c,getDocumentVersion:u=>u&&n.getDocument(u)?.version,getApiFor:t.getPrivateApiFor,getChildren:u=>u.children,root:new m(c,g),toITestItem:I.TestItem.from})}}e.ExtHostTestItemCollection=v}),define(De[135],Ie([1,0,48,10,94,15,7]),function(J,e,l,t,C,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class I{constructor(S,T,E){const p=I._Keys.nextId();S.$registerTextEditorDecorationType(T.identifier,p,P.DecorationRenderOptions.from(E)),this.value=Object.freeze({key:p,dispose(){S.$removeTextEditorDecorationType(p)}})}}e.TextEditorDecorationType=I,I._Keys=new C.IdGenerator("TextEditorDecorationType");class w{constructor(S,T){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=S,this._documentVersionId=S.version,this._undoStopBefore=T.undoStopBefore,this._undoStopAfter=T.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(S,T){this._throwIfFinalized();let E=null;if(S instanceof _.Position)E=new _.Range(S,S);else if(S instanceof _.Range)E=S;else throw new Error("Unrecognized location");this._pushEdit(E,T,!1)}insert(S,T){this._throwIfFinalized(),this._pushEdit(new _.Range(S,S),T,!0)}delete(S){this._throwIfFinalized();let T=null;if(S instanceof _.Range)T=S;else throw new Error("Unrecognized location");this._pushEdit(T,null,!0)}_pushEdit(S,T,E){const p=this._document.validateRange(S);this._collectedEdits.push({range:p,text:T,forceMoveMarkers:E})}setEndOfLine(S){if(this._throwIfFinalized(),S!==_.EndOfLine.LF&&S!==_.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this._setEndOfLine=S}}e.TextEditorEdit=w;class k{constructor(S,T,E,p){this._proxy=S,this._id=T,this._accept(E),this._logService=p;const b=this;this.value={get tabSize(){return b._tabSize},set tabSize(m){b._setTabSize(m)},get insertSpaces(){return b._insertSpaces},set insertSpaces(m){b._setInsertSpaces(m)},get cursorStyle(){return b._cursorStyle},set cursorStyle(m){b._setCursorStyle(m)},get lineNumbers(){return b._lineNumbers},set lineNumbers(m){b._setLineNumbers(m)}}}_accept(S){this._tabSize=S.tabSize,this._insertSpaces=S.insertSpaces,this._cursorStyle=S.cursorStyle,this._lineNumbers=P.TextEditorLineNumbersStyle.to(S.lineNumbers)}_validateTabSize(S){if(S==="auto")return"auto";if(typeof S=="number"){const T=Math.floor(S);return T>0?T:null}if(typeof S=="string"){const T=parseInt(S,10);return isNaN(T)?null:T>0?T:null}return null}_setTabSize(S){const T=this._validateTabSize(S);if(T!==null){if(typeof T=="number"){if(this._tabSize===T)return;this._tabSize=T}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:T}))}}_validateInsertSpaces(S){return S==="auto"?"auto":S==="false"?!1:Boolean(S)}_setInsertSpaces(S){const T=this._validateInsertSpaces(S);if(typeof T=="boolean"){if(this._insertSpaces===T)return;this._insertSpaces=T}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:T}))}_setCursorStyle(S){this._cursorStyle!==S&&(this._cursorStyle=S,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:S})))}_setLineNumbers(S){this._lineNumbers!==S&&(this._lineNumbers=S,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:P.TextEditorLineNumbersStyle.from(S)})))}assign(S){const T={};let E=!1;if(typeof S.tabSize<"u"){const p=this._validateTabSize(S.tabSize);p==="auto"?(E=!0,T.tabSize=p):typeof p=="number"&&this._tabSize!==p&&(this._tabSize=p,E=!0,T.tabSize=p)}if(typeof S.insertSpaces<"u"){const p=this._validateInsertSpaces(S.insertSpaces);p==="auto"?(E=!0,T.insertSpaces=p):this._insertSpaces!==p&&(this._insertSpaces=p,E=!0,T.insertSpaces=p)}typeof S.cursorStyle<"u"&&this._cursorStyle!==S.cursorStyle&&(this._cursorStyle=S.cursorStyle,E=!0,T.cursorStyle=S.cursorStyle),typeof S.lineNumbers<"u"&&this._lineNumbers!==S.lineNumbers&&(this._lineNumbers=S.lineNumbers,E=!0,T.lineNumbers=P.TextEditorLineNumbersStyle.from(S.lineNumbers)),E&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,T))}_warnOnError(S,T){T.catch(E=>{this._logService.warn(`ExtHostTextEditorOptions '${S}' failed:'`),this._logService.warn(E)})}}e.ExtHostTextEditorOptions=k;class L{constructor(S,T,E,p,b,m,v,h){this.id=S,this._proxy=T,this._logService=E,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=b,this._options=new k(this._proxy,this.id,m,E),this._visibleRanges=v,this._viewColumn=h;const c=this;this.value=Object.freeze({get document(){return p.getValue()},set document(g){throw(0,t.readonly)("document")},get selection(){return c._selections&&c._selections[0]},set selection(g){if(!(g instanceof _.Selection))throw(0,t.illegalArgument)("selection");c._selections=[g],c._trySetSelection()},get selections(){return c._selections},set selections(g){if(!Array.isArray(g)||g.some(n=>!(n instanceof _.Selection)))throw(0,t.illegalArgument)("selections");c._selections=g,c._trySetSelection()},get visibleRanges(){return c._visibleRanges},set visibleRanges(g){throw(0,t.readonly)("visibleRanges")},get options(){return c._options.value},set options(g){c._disposed||c._options.assign(g)},get viewColumn(){return c._viewColumn},set viewColumn(g){throw(0,t.readonly)("viewColumn")},edit(g,n={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new w(p.getValue(),n);return g(u),c._applyEdit(u)},insertSnippet(g,n,u={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!n||Array.isArray(n)&&n.length===0)s=c._selections.map(i=>P.Range.from(i));else if(n instanceof _.Position){const{lineNumber:i,column:o}=P.Position.from(n);s=[{startLineNumber:i,startColumn:o,endLineNumber:i,endColumn:o}]}else if(n instanceof _.Range)s=[P.Range.from(n)];else{s=[];for(const i of n)if(i instanceof _.Range)s.push(P.Range.from(i));else{const{lineNumber:o,column:d}=P.Position.from(i);s.push({startLineNumber:o,startColumn:d,endLineNumber:o,endColumn:d})}}return T.$tryInsertSnippet(S,p.getValue().version,g.value,s,u)},setDecorations(g,n){const u=n.length===0;u&&!c._hasDecorationsForKey.has(g.key)||(u?c._hasDecorationsForKey.delete(g.key):c._hasDecorationsForKey.add(g.key),c._runOnProxy(()=>{if(P.isDecorationOptionsArr(n))return T.$trySetDecorations(S,g.key,P.fromRangeOrRangeWithMessage(n));{const s=new Array(4*n.length);for(let i=0,o=n.length;i<o;i++){const d=n[i];s[4*i]=d.start.line+1,s[4*i+1]=d.start.character+1,s[4*i+2]=d.end.line+1,s[4*i+3]=d.end.character+1}return T.$trySetDecorationsFast(S,g.key,s)}}))},revealRange(g,n){c._runOnProxy(()=>T.$tryRevealRange(S,P.Range.from(g),n||_.TextEditorRevealType.Default))},show(g){T.$tryShowEditor(S,P.ViewColumn.from(g))},hide(){T.$tryHideEditor(S)}})}dispose(){(0,l.ok)(!this._disposed),this._disposed=!0}_acceptOptions(S){(0,l.ok)(!this._disposed),this._options._accept(S)}_acceptVisibleRanges(S){(0,l.ok)(!this._disposed),this._visibleRanges=S}_acceptViewColumn(S){(0,l.ok)(!this._disposed),this._viewColumn=S}_acceptSelections(S){(0,l.ok)(!this._disposed),this._selections=S}async _trySetSelection(){const S=this._selections.map(P.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,S)),this.value}_applyEdit(S){const T=S.finalize();if(T.edits.length===0&&!T.setEndOfLine)return Promise.resolve(!0);const E=T.edits.map(b=>b.range);E.sort((b,m)=>b.end.line===m.end.line?b.end.character===m.end.character?b.start.line===m.start.line?b.start.character-m.start.character:b.start.line-m.start.line:b.end.character-m.end.character:b.end.line-m.end.line);for(let b=0,m=E.length-1;b<m;b++){const v=E[b].end;if(E[b+1].start.isBefore(v))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const p=T.edits.map(b=>({range:P.Range.from(b.range),text:b.text,forceMoveMarkers:b.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,T.documentVersionId,p,{setEndOfLine:typeof T.setEndOfLine=="number"?P.EndOfLine.from(T.setEndOfLine):void 0,undoStopBefore:T.undoStopBefore,undoStopAfter:T.undoStopAfter})}_runOnProxy(S){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):S().then(()=>this,T=>(T instanceof Error&&T.name==="DISPOSED"||this._logService.warn(T),null))}}e.ExtHostTextEditor=L}),define(De[230],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionLog:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionLog.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineCompletionsNew:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsNew.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",localization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.localization.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookContentProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookContentProvider.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDebugOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDebugOptions.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditor.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLog:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLog.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(De[231],Ie([1,0,186,10,42,117,121,43,27,230,197]),function(J,e,l,t,C,P,_,I,w,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const D=I.Registry.as(_.Extensions.JSONContribution);class S{constructor(c,g,n){this._messageHandler=c,this._extension=g,this._extensionPointId=n}_msg(c,g){this._messageHandler({type:c,message:g,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(c){this._msg(C.default.Error,c)}warn(c){this._msg(C.default.Warning,c)}info(c){this._msg(C.default.Info,c)}}e.ExtensionMessageCollector=S;class T{static _toSet(c){const g=new Set;for(let n=0,u=c.length;n<u;n++)g.add(w.ExtensionIdentifier.toKey(c[n].description.identifier));return g}static compute(c,g){if(!c||!c.length)return new T(g,[]);if(!g||!g.length)return new T([],c);const n=this._toSet(c),u=this._toSet(g),s=g.filter(o=>!n.has(w.ExtensionIdentifier.toKey(o.description.identifier))),i=c.filter(o=>!u.has(w.ExtensionIdentifier.toKey(o.description.identifier)));return new T(s,i)}constructor(c,g){this.added=c,this.removed=g}}e.ExtensionPointUserDelta=T;class E{constructor(c,g){this.name=c,this.defaultExtensionKind=g,this._handler=null,this._users=null,this._delta=null}setHandler(c){if(this._handler!==null)throw new Error("Handler already set!");this._handler=c,this._handle()}acceptUsers(c){this._delta=T.compute(this._users,c),this._users=c,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(c){(0,t.onUnexpectedError)(c)}}}e.ExtensionPoint=E;const p={type:"string",enum:["ui","workspace"],enumDescriptions:[l.localize(0,null),l.localize(1,null)]},b="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:l.localize(2,null),properties:{vscode:{type:"string",description:l.localize(3,null),default:"^1.22.0"}}},publisher:{description:l.localize(4,null),type:"string"},displayName:{description:l.localize(5,null),type:"string"},categories:{description:l.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:w.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:l.localize(7,null)}]}},galleryBanner:{type:"object",description:l.localize(8,null),properties:{color:{description:l.localize(9,null),type:"string"},theme:{description:l.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:l.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:l.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:l.localize(13,null)},enabledApiProposals:{markdownDescription:l.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},activationEvents:{description:l.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:l.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:l.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:l.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:l.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:l.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:l.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:l.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:l.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:l.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:l.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:l.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:l.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:l.localize(28,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:l.localize(29,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:l.localize(30,null)},{label:"onIdentity",body:"onIdentity:${8:identity}",description:l.localize(31,null)},{label:"onUri",body:"onUri",description:l.localize(32,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:l.localize(33,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:l.localize(34,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:l.localize(35,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:l.localize(36,null)},{label:"onRenderer",description:l.localize(37,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:l.localize(38,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:l.localize(39,null)},{label:"*",description:l.localize(40,null),body:"*"}]}},badges:{type:"array",description:l.localize(41,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:l.localize(42,null)},href:{type:"string",description:l.localize(43,null)},description:{type:"string",description:l.localize(44,null)}}}},markdown:{type:"string",description:l.localize(45,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:l.localize(46,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:l.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:l.localize(48,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:l.localize(49,null),type:"array",items:p,default:["workspace"],defaultSnippets:[{body:["ui"],description:l.localize(50,null)},{body:["workspace"],description:l.localize(51,null)},{body:["ui","workspace"],description:l.localize(52,null)},{body:["workspace","ui"],description:l.localize(53,null)},{body:[],description:l.localize(54,null)}]},capabilities:{description:l.localize(55,null),type:"object",properties:{virtualWorkspaces:{description:l.localize(56,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:l.localize(57,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[l.localize(58,null),l.localize(59,null),l.localize(60,null)]},description:{type:"string",markdownDescription:l.localize(61,null)}}},untrustedWorkspaces:{description:l.localize(62,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:l.localize(63,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[l.localize(64,null),l.localize(65,null),l.localize(66,null)]},restrictedConfigurations:{description:l.localize(67,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:l.localize(68,null)}}}}},sponsor:{description:l.localize(69,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:l.localize(70,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:l.localize(71,null),type:"string"},"vscode:uninstall":{description:l.localize(72,null),type:"string"}}},icon:{type:"string",description:l.localize(73,null)},l10n:{type:"string",description:l.localize(74,null)}}};class m{constructor(){this._extensionPoints=new Map}registerExtensionPoint(c){if(this._extensionPoints.has(c.extensionPoint))throw new Error("Duplicate extension point: "+c.extensionPoint);const g=new E(c.extensionPoint,c.defaultExtensionKind);return this._extensionPoints.set(c.extensionPoint,g),e.schema.properties.contributes.properties[c.extensionPoint]=c.jsonSchema,D.registerSchema(b,e.schema),g}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=m;const v={ExtensionsRegistry:"ExtensionsRegistry"};I.Registry.add(v.ExtensionsRegistry,new m),e.ExtensionsRegistry=I.Registry.as(v.ExtensionsRegistry),D.registerSchema(b,e.schema),D.registerSchema(L.productSchemaId,{properties:{extensionEnabledApiProposals:{description:l.localize(75,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(De[232],Ie([1,0,183,16,24,231,52,4]),function(J,e,l,t,C,P,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=e.TaskDefinitionRegistryImpl=void 0;const w={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:l.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:l.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:l.localize(2,null),default:""}}};var k;(function(S){function T(E,p,b){if(!E)return;const m=t.isString(E.type)?E.type:void 0;if(!m||m.length===0){b.error(l.localize(3,null));return}const v=[];if(Array.isArray(E.required))for(const h of E.required)t.isString(h)&&v.push(h);return{extensionId:p.value,taskType:m,required:v,properties:E.properties?C.deepClone(E.properties):{},when:E.when?_.ContextKeyExpr.deserialize(E.when):void 0}}S.from=T})(k||(k={}));const L=P.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:l.localize(4,null),type:"array",items:w}});class D{constructor(){this._onDefinitionsChanged=new I.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((T,E)=>{L.setHandler((p,b)=>{this._schema=void 0;try{for(const m of b.removed){const v=m.value;for(const h of v)this.taskTypes&&h.type&&this.taskTypes[h.type]&&delete this.taskTypes[h.type]}for(const m of b.added){const v=m.value;for(const h of v){const c=k.from(h,m.description.identifier,m.collector);c&&(this.taskTypes[c.taskType]=c)}}(b.removed.length>0||b.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}T(void 0)})})}onReady(){return this.readyPromise}get(T){return this.taskTypes[T]}all(){return Object.keys(this.taskTypes).map(T=>this.taskTypes[T])}getJsonSchema(){if(this._schema===void 0){const T=[];for(const E of this.all()){const p={type:"object",additionalProperties:!1};E.required.length>0&&(p.required=E.required.slice(0)),E.properties!==void 0?p.properties=C.deepClone(E.properties):p.properties=Object.create(null),p.properties.type={type:"string",enum:[E.taskType]},T.push(p)}this._schema={oneOf:T}}return this._schema}}e.TaskDefinitionRegistryImpl=D,e.TaskDefinitionRegistry=new D}),define(De[233],Ie([1,0,184,16,22,24,52,232]),function(J,e,l,t,C,P,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new _.RawContextKey("taskRunning",!1,l.localize(0,null)),e.TASKS_CATEGORY={value:l.localize(1,null),original:"Tasks"};var w;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(w=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(F){function G(B){if(!B)return F.Strong;switch(B.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=G}(w=e.ShellQuoting||(e.ShellQuoting={}));var k;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(k=e.CommandOptions||(e.CommandOptions={}));var L;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(L=e.RevealKind||(e.RevealKind={})),function(F){function G(B){switch(B.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=G}(L=e.RevealKind||(e.RevealKind={}));var D;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(D=e.RevealProblemKind||(e.RevealProblemKind={})),function(F){function G(B){switch(B.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=G}(D=e.RevealProblemKind||(e.RevealProblemKind={}));var S;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(S=e.PanelKind||(e.PanelKind={})),function(F){function G(B){switch(B.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=G}(S=e.PanelKind||(e.PanelKind={}));var T;(function(F){F.defaults={echo:!0,reveal:L.Always,revealProblems:D.Never,focus:!1,panel:S.Shared,showReuseMessage:!0,clear:!1}})(T=e.PresentationOptions||(e.PresentationOptions={}));var E;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(E=e.RuntimeType||(e.RuntimeType={})),function(F){function G(U){switch(U.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=G;function B(U){switch(U){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=B}(E=e.RuntimeType||(e.RuntimeType={}));var p;(function(F){function G(B){return t.isString(B)?B:B.value}F.value=G})(p=e.CommandString||(e.CommandString={}));var b;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function G(U){return U===F.Clean._id||U===F.Build._id||U===F.Rebuild._id||U===F.Test._id}F.is=G;function B(U){if(U!==void 0)return t.isString(U)?G(U)?{_id:U,isDefault:!1}:void 0:U}F.from=B})(b=e.TaskGroup||(e.TaskGroup={}));var m;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(m=e.TaskScope||(e.TaskScope={}));var v;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function G(B){switch(B){case F.User:return 2;case F.WorkspaceFile:return 5;default:return 6}}F.toConfigurationTarget=G})(v=e.TaskSourceKind||(e.TaskSourceKind={}));var h;(function(F){F.parallel="parallel",F.sequence="sequence"})(h=e.DependsOrder||(e.DependsOrder={}));var c;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(c=e.RunOnOptions||(e.RunOnOptions={}));var g;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(g=e.RunOptions||(e.RunOptions={}));class n{constructor(G,B,U,x,$,Q){this._label="",this._id=G,B&&(this._label=B),U&&(this.type=U),this.runOptions=x,this.configurationProperties=$,this._source=Q}getDefinition(G){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const G={folder:this.getFolderId(),id:this._id};return JSON.stringify(G)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(G,B=!1){if(G===void 0)return!1;if(t.isString(G))return G===this._label||G===this.configurationProperties.identifier||B&&G===this._id;const U=this.getDefinition(!0);return U!==void 0&&U._key===G._key}getQualifiedLabel(){const G=this.getWorkspaceFolder();return G?`${this._label} (${G.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(G){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),G&&(this._taskLoadMessages=this._taskLoadMessages.concat(G))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=n;class u extends n{constructor(G,B,U,x,$,Q,K,de){super(G,U,void 0,K,de,B),this.command={},this._source=B,this.hasDefinedMatchers=Q,$&&(this.command=$)}clone(){return new u(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(G=!1){if(G&&this._source.customizes!==void 0)return this._source.customizes;{let B;switch(this.command?this.command.runtime:void 0){case E.Shell:B="shell";break;case E.Process:B="process";break;case E.CustomExecution:B="customExecution";break;case void 0:B="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:B,_key:this._id,id:this._id}}}static is(G){return G instanceof u}getMapKey(){const G=this._source.config.workspaceFolder;return G?`${G.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const G=this.getFolderId();if(!G)return;let B=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&(B+=this._source.kind);const U={type:e.CUSTOMIZED_TASK_TYPE,folder:G,id:B};return JSON.stringify(U)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(G){return new u(G._id,G._source,G._label,G.type,G.command,G.hasDefinedMatchers,G.runOptions,G.configurationProperties)}}e.CustomTask=u;class s extends n{constructor(G,B,U,x,$,Q,K){super(G,U,x,Q,K,B),this._source=B,this.configures=$}static is(G){return G instanceof s}fromObject(G){return G}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const G=this.getFolderId();if(!G)return;let B=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&(B+=this._source.kind);const U={type:e.CUSTOMIZED_TASK_TYPE,folder:G,id:B};return JSON.stringify(U)}}e.ConfiguringTask=s;class i extends n{constructor(G,B,U,x,$,Q,K,de,te){super(G,U,x,de,te,B),this.defines=$,this.hasDefinedMatchers=K,this.command=Q,this.icon=te.icon,this.hide=te.hide}clone(){return new i(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(G){return G instanceof i}getMapKey(){const G=this._source.workspaceFolder;return G?`${this._source.scope.toString()}|${G.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const G={type:"contributed",scope:this._source.scope,id:this._id};return G.folder=this.getFolderId(),JSON.stringify(G)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(G){return new i(G._id,G._source,G._label,G.type,G.defines,G.command,G.hasDefinedMatchers,G.runOptions,G.configurationProperties)}}e.ContributedTask=i;class o extends n{constructor(G,B,U,x,$,Q){super(G,U,x,$,Q,B),this._source=B}clone(){return new o(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(G){return G instanceof o}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(G){return new o(G._id,G._source,G._label,G.type,G.runOptions,G.configurationProperties)}}e.InMemoryTask=o;var d;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(d=e.ExecutionEngine||(e.ExecutionEngine={})),function(F){F._default=F.Terminal}(d=e.ExecutionEngine||(e.ExecutionEngine={}));var r;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(r=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class a{constructor(G){this._order=new Map;for(let B=0;B<G.length;B++)this._order.set(G[B].uri.toString(),B)}compare(G,B){const U=G.getWorkspaceFolder(),x=B.getWorkspaceFolder();if(U&&x){let $=this._order.get(U.uri.toString());$=$===void 0?0:$+1;let Q=this._order.get(x.uri.toString());return Q=Q===void 0?0:Q+1,$===Q?G._label.localeCompare(B._label):$-Q}else return!U&&x?-1:U&&!x?1:0}}e.TaskSorter=a;var f;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(f=e.TaskEventKind||(e.TaskEventKind={}));var y;(function(F){F.SingleRun="singleRun",F.Background="background"})(y=e.TaskRunType||(e.TaskRunType={}));var R;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(R=e.TaskRunSource||(e.TaskRunSource={}));var N;(function(F){function G(B,U,x,$,Q){if(U){const K={kind:B,taskId:U._id,taskName:U.configurationProperties.name,runType:U.configurationProperties.isBackground?"background":"singleRun",group:U.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:void 0,__task:U};return B==="start"?(K.terminalId=x,K.resolvedVariables=$):B==="processStarted"?K.processId=x:B==="processEnded"&&(K.exitCode=x),Object.freeze(K)}else return Object.freeze({kind:"changed"})}F.create=G})(N=e.TaskEvent||(e.TaskEvent={}));var M;(function(F){function G(U){const x=Object.keys(U).sort();let $="";for(const Q of x){let K=U[Q];K instanceof Object?K=G(K):typeof K=="string"&&(K=K.replace(/,/g,",,")),$+=Q+","+K+","}return $}function B(U){const $={_key:G(U),type:U.taskType};return Object.assign($,U),$}F.create=B})(M=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var A;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.reconnection"})(A=e.TaskSettingId||(e.TaskSettingId={}));var z;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(z=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var H;(function(F){function G(B,U){const x=I.TaskDefinitionRegistry.get(B.type);if(x===void 0){const de=P.deepClone(B);return delete de._key,M.create(de)}const $=Object.create(null);$.type=x.taskType;const Q=new Set;x.required.forEach(de=>Q.add(de));const K=x.properties;for(const de of Object.keys(K)){const te=B[de];if(te!=null)$[de]=te;else if(Q.has(de)){const he=K[de];if(he.default!==void 0)$[de]=P.deepClone(he.default);else switch(he.type){case"boolean":$[de]=!1;break;case"number":case"integer":$[de]=0;break;case"string":$[de]="";break;default:U.error(l.localize(2,null,JSON.stringify(B,void 0,0),de));return}}}return M.create($)}F.createTaskIdentifier=G})(H=e.TaskDefinition||(e.TaskDefinition={}))}),define(De[234],Ie([1,0,10]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class t{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((_,I)=>{this._actualOk=_,this._actualErr=I,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(_){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=_,this._actual&&this._actualOk(_))}resolveErr(_){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=_,this._actual?this._actualErr(_):(0,l.onUnexpectedError)(_))}then(_,I){return this._ensureActual().then(_,I)}catch(_){return this._ensureActual().then(void 0,_)}finally(_){return this._ensureActual().finally(_)}}e.LazyPromise=t;class C extends t{constructor(){super(),this._hasErr=!0,this._err=new l.CancellationError}}e.CanceledLazyPromise=C}),define(De[56],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class l{constructor(w){this._proxyIdentifierBrand=void 0,this.sid=w,this.nid=++l.count}}e.ProxyIdentifier=l,l.count=0;const t=[];function C(I){const w=new l(I);return t[w.nid]=w,w}e.createProxyIdentifier=C;function P(I){return t[I].sid}e.getStringIdentifierForProxy=P;class _{constructor(w){this.value=w}}e.SerializableObjectWithBuffers=_}),define(De[5],Ie([1,0,56]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var t;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(t=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(p){p[p.UnknownInput=0]="UnknownInput",p[p.TextInput=1]="TextInput",p[p.TextDiffInput=2]="TextDiffInput",p[p.TextMergeInput=3]="TextMergeInput",p[p.NotebookInput=4]="NotebookInput",p[p.NotebookDiffInput=5]="NotebookDiffInput",p[p.CustomEditorInput=6]="CustomEditorInput",p[p.WebviewEditorInput=7]="WebviewEditorInput",p[p.TerminalEditorInput=8]="TerminalEditorInput",p[p.InteractiveEditorInput=9]="InteractiveEditorInput"})(C=e.TabInputKind||(e.TabInputKind={}));var P;(function(p){p[p.TAB_OPEN=0]="TAB_OPEN",p[p.TAB_CLOSE=1]="TAB_CLOSE",p[p.TAB_UPDATE=2]="TAB_UPDATE",p[p.TAB_MOVE=3]="TAB_MOVE"})(P=e.TabModelOperationKind||(e.TabModelOperationKind={}));var _;(function(p){p[p.Editable=0]="Editable",p[p.SupportsHotExit=1]="SupportsHotExit"})(_=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var I;(function(p){p[p.Int8Array=1]="Int8Array",p[p.Uint8Array=2]="Uint8Array",p[p.Uint8ClampedArray=3]="Uint8ClampedArray",p[p.Int16Array=4]="Int16Array",p[p.Uint16Array=5]="Uint16Array",p[p.Int32Array=6]="Int32Array",p[p.Uint32Array=7]="Uint32Array",p[p.Float32Array=8]="Float32Array",p[p.Float64Array=9]="Float64Array",p[p.BigInt64Array=10]="BigInt64Array",p[p.BigUint64Array=11]="BigUint64Array"})(I=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var w;(function(p){p[p.Text=1]="Text",p[p.Error=2]="Error",p[p.Rich=3]="Rich"})(w=e.CellOutputKind||(e.CellOutputKind={}));var k;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(k=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var L;(function(p){p[p.None=0]="None",p[p.Process=1]="Process",p[p.Output=2]="Output"})(L=e.CandidatePortSource||(e.CandidatePortSource={}));class D{static mixin(b){return b._id=D._n++,b}}e.IdObject=D,D._n=0;var S;(function(p){p.label="a",p.kind="b",p.detail="c",p.documentation="d",p.sortText="e",p.filterText="f",p.preselect="g",p.insertText="h",p.insertTextRules="i",p.range="j",p.commitCharacters="k",p.additionalTextEdits="l",p.command="m",p.kindModifier="n"})(S=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var T;(function(p){p.defaultRanges="a",p.completions="b",p.isIncomplete="c",p.duration="d"})(T=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var E;(function(p){p[p.Workspace=0]="Workspace",p[p.TextDocument=1]="TextDocument"})(E=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,l.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,l.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,l.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,l.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,l.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,l.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,l.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,l.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,l.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,l.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,l.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,l.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,l.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,l.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,l.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,l.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,l.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,l.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,l.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,l.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,l.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,l.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,l.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,l.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,l.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,l.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,l.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,l.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,l.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,l.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,l.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,l.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,l.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,l.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,l.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,l.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,l.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,l.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,l.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,l.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,l.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,l.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,l.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,l.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,l.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,l.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,l.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,l.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,l.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,l.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,l.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,l.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,l.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,l.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,l.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,l.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,l.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,l.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,l.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,l.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,l.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,l.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,l.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,l.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,l.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,l.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,l.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,l.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,l.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,l.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,l.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,l.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,l.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,l.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,l.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,l.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,l.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,l.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,l.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,l.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,l.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,l.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,l.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,l.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,l.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,l.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,l.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,l.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,l.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,l.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,l.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,l.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,l.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,l.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,l.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,l.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,l.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,l.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,l.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,l.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,l.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,l.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,l.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,l.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,l.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,l.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,l.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,l.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,l.createProxyIdentifier)("ExtHostLocalization")}}),define(De[65],Ie([1,0,3,13,5,14]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,l.createDecorator)("IExtHostApiDeprecationService");let _=class{constructor(w,k){this._extHostLogService=k,this._reportedUsages=new Set,this._telemetryShape=w.getProxy(C.MainContext.MainThreadTelemetry)}report(w,k,L){const D=this.getUsageKey(w,k);this._reportedUsages.has(D)||(this._reportedUsages.add(D),k.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${w}' is deprecated. ${L}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:w}))}getUsageKey(w,k){return`${w}-${k.identifier.value}`}};_=je([$e(0,P.IExtHostRpcService),$e(1,t.ILogService)],_),e.ExtHostApiDeprecationService=_,e.NullApiDeprecationService=Object.freeze(new class{report(I,w,k){}})}),define(De[235],Ie([1,0,4,5,7,27]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class _{constructor(w){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new l.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=w.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(w){return this._providers=w,Promise.resolve()}async getSession(w,k,L,D={}){const S=P.ExtensionIdentifier.toKey(w.identifier),T=this._inFlightRequests.get(S)||[],E=[...L].sort().join(" ");let p=T.find(b=>b.providerId===k&&b.scopes===E);if(p)return p.result;{const b=this._getSession(w,S,k,L,D);p={providerId:k,scopes:E,result:b},T.push(p),this._inFlightRequests.set(S,T);try{await b}finally{const m=T.findIndex(v=>v.providerId===k&&v.scopes===E);m>-1&&(T.splice(m),this._inFlightRequests.set(S,T))}return b}}async _getSession(w,k,L,D,S={}){await this._proxy.$ensureProvider(L);const T=w.displayName||w.name;return this._proxy.$getSession(L,D,k,T,S)}async removeSession(w,k){const L=this._authenticationProviders.get(w);return L?L.provider.removeSession(k):this._proxy.$removeSession(w,k)}registerAuthenticationProvider(w,k,L,D){if(this._authenticationProviders.get(w))throw new Error(`An authentication provider with id '${w}' is already registered.`);this._authenticationProviders.set(w,{label:k,provider:L,options:D??{supportsMultipleAccounts:!1}}),this._providers.find(T=>T.id===w)||this._providers.push({id:w,label:k});const S=L.onDidChangeSessions(T=>{this._proxy.$sendDidChangeSessions(w,{added:T.added??[],changed:T.changed??[],removed:T.removed??[]})});return this._proxy.$registerAuthenticationProvider(w,k,D?.supportsMultipleAccounts??!1),new C.Disposable(()=>{S.dispose(),this._authenticationProviders.delete(w);const T=this._providers.findIndex(E=>E.id===w);T>-1&&this._providers.splice(T),this._proxy.$unregisterAuthenticationProvider(w)})}$createSession(w,k){const L=this._authenticationProviders.get(w);if(L)return Promise.resolve(L.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$removeSession(w,k){const L=this._authenticationProviders.get(w);if(L)return Promise.resolve(L.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$getSessions(w,k){const L=this._authenticationProviders.get(w);if(L)return Promise.resolve(L.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$onDidChangeAuthenticationSessions(w,k){return this._onDidChangeSessions.fire({provider:{id:w,label:k}}),Promise.resolve()}}e.ExtHostAuthentication=_}),define(De[236],Ie([1,0,5,14,15]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let P=class{constructor(I,w){this._proxy=I.getProxy(l.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:k=>w.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(I,w,k){const L=C.WorkspaceEdit.from(I,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(L,void 0,k?.isRefactoring??!1)}};P=je([$e(0,t.IExtHostRpcService)],P),e.ExtHostBulkEdits=P}),define(De[237],Ie([1,0,5]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(P){const _=P.getProxy(l.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return _.$readText()},writeText(I){return _.$writeText(I)}})}}e.ExtHostClipboard=t});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,l):C?C.value=l:e.set(J,l),l},Be=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[38],Ie([1,0,16,7,15,24,5,17,13,80,35,49,2,6,3,14,134,23,56,50]),function(J,e,l,t,C,P,_,I,w,k,L,D,S,T,E,p,b,m,v,h){"use strict";var c,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let n=class{constructor(r,a){c.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,g.set(this,void 0),tt(this,c,r.getProxy(_.MainContext.MainThreadCommands),"f"),this._logService=a,tt(this,g,r.getProxy(_.MainContext.MainThreadTelemetry),"f"),this.converter=new u(this,f=>{const y=this._apiCommands.get(f);return y?.result===i.Void?y:void 0},a),this._argumentProcessors=[{processArgument(f){return(0,k.revive)(f)}},{processArgument(f){return(0,P.cloneAndChange)(f,function(y){if(L.Range.isIRange(y))return C.Range.to(y);if(D.Position.isIPosition(y))return C.Position.to(y);if(L.Range.isIRange(y.range)&&S.URI.isUri(y.uri))return C.location.to(y);if(y instanceof m.VSBuffer)return y.buffer.buffer;if(!Array.isArray(y))return y})}}]}registerArgumentProcessor(r){this._argumentProcessors.push(r)}registerApiCommand(r){const a=this.registerCommand(!1,r.id,async(...f)=>{const y=r.args.map((N,M)=>{if(!N.validate(f[M]))throw new Error(`Invalid argument '${N.name}' when running '${r.id}', received: ${f[M]}`);return N.convert(f[M])}),R=await this.executeCommand(r.internalId,...y);return r.result.convert(R,f,this.converter)},void 0,{description:r.description,args:r.args,returns:r.result.description});return this._apiCommands.set(r.id,r),new t.Disposable(()=>{a.dispose(),this._apiCommands.delete(r.id)})}registerCommand(r,a,f,y,R,N){if(this._logService.trace("ExtHostCommands#registerCommand",a),!a.trim().length)throw new Error("invalid id");if(this._commands.has(a))throw new Error(`command '${a}' already exists`);return this._commands.set(a,{callback:f,thisArg:y,description:R,extension:N}),r&&Be(this,c,"f").$registerCommand(a),new t.Disposable(()=>{this._commands.delete(a)&&r&&Be(this,c,"f").$unregisterCommand(a)})}executeCommand(r,...a){return this._logService.trace("ExtHostCommands#executeCommand",r),this._doExecuteCommand(r,a,!0)}async _doExecuteCommand(r,a,f){if(this._commands.has(r))return Be(this,c,"f").$fireCommandActivationEvent(r),this._executeContributedCommand(r,a,!1);{let y=!1;const R=(0,P.cloneAndChange)(a,function(N){if(N instanceof t.Position)return C.Position.from(N);if(N instanceof t.Range)return C.Range.from(N);if(N instanceof t.Location)return C.location.from(N);if(t.NotebookRange.isNotebookRange(N))return C.NotebookRange.from(N);if(N instanceof ArrayBuffer)return y=!0,m.VSBuffer.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return y=!0,m.VSBuffer.wrap(N);if(N instanceof m.VSBuffer)return y=!0,N;if(!Array.isArray(N))return N});try{const N=await Be(this,c,"f").$executeCommand(r,y?new v.SerializableObjectWithBuffers(R):R,f);return(0,k.revive)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this._doExecuteCommand(r,a,!1);throw N}}}async _executeContributedCommand(r,a,f){const y=this._commands.get(r);if(!y)throw new Error("Unknown command");this._reportTelemetry(y,r);const{callback:R,thisArg:N,description:M}=y;if(M)for(let A=0;A<M.args.length;A++)try{(0,l.validateConstraint)(a[A],M.args[A].constraint)}catch{throw new Error(`Running the contributed command: '${r}' failed. Illegal argument '${M.args[A].name}' - ${M.args[A].description}`)}try{return await R.apply(N,a)}catch(A){if(r===this.converter.delegatingCommandId){const z=this.converter.getActualCommand(...a);z&&(r=z.command)}throw this._logService.error(A,r,y.extension?.identifier),f?new class extends Error{constructor(){super((0,h.toErrorMessage)(A)),this.id=r,this.source=y.extension?.displayName??y.extension?.name}}:A}}_reportTelemetry(r,a){!r.extension||r.extension.isBuiltin||Be(this,g,"f").$publicLog2("Extension:ActionExecuted",{extensionId:r.extension.identifier.value,id:a})}$executeContributedCommand(r,...a){return this._logService.trace("ExtHostCommands#$executeContributedCommand",r),this._commands.has(r)?(a=a.map(f=>this._argumentProcessors.reduce((y,R)=>R.processArgument(y),f)),this._executeContributedCommand(r,a,!0)):Promise.reject(new Error(`Contributed command '${r}' does not exist.`))}getCommands(r=!1){return this._logService.trace("ExtHostCommands#getCommands",r),Be(this,c,"f").$getCommands().then(a=>(r&&(a=a.filter(f=>f[0]!=="_")),a))}$getContributedCommandHandlerDescriptions(){const r=Object.create(null);for(const[a,f]of this._commands){const{description:y}=f;y&&(r[a]=y)}return Promise.resolve(r)}};c=new WeakMap,g=new WeakMap,n=je([$e(0,p.IExtHostRpcService),$e(1,w.ILogService)],n),e.ExtHostCommands=n,e.IExtHostCommands=(0,E.createDecorator)("IExtHostCommands");class u{constructor(r,a,f){this._commands=r,this._lookupApiCommand=a,this._logService=f,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(r,a){if(!r)return;const f={$ident:void 0,id:r.command,title:r.title,tooltip:r.tooltip};if(!r.command)return f;const y=this._lookupApiCommand(r.command);if(y)f.id=y.internalId,f.arguments=y.args.map((R,N)=>R.convert(r.arguments&&r.arguments[N]));else if((0,I.isNonEmptyArray)(r.arguments)){const R=++this._cachIdPool;this._cache.set(R,r),a.add((0,T.toDisposable)(()=>{this._cache.delete(R),this._logService.trace("CommandsConverter#DISPOSE",R)})),f.$ident=R,f.id=this.delegatingCommandId,f.arguments=[R],this._logService.trace("CommandsConverter#CREATE",r.command,R)}return f}fromInternal(r){return typeof r.$ident=="number"?this._cache.get(r.$ident):{command:r.id,title:r.title,arguments:r.arguments}}getActualCommand(...r){return this._cache.get(r[0])}_executeConvertedCommand(...r){const a=this.getActualCommand(...r);return this._logService.trace("CommandsConverter#EXECUTE",r[0],a?a.command:"MISSING"),a?this._commands.executeCommand(a.command,...a.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=u;class s{constructor(r,a,f,y){this.name=r,this.description=a,this.validate=f,this.convert=y}optional(){return new s(this.name,`(optional) ${this.description}`,r=>r==null||this.validate(r),r=>r===void 0?void 0:r===null?null:this.convert(r))}with(r,a){return new s(r??this.name,a??this.description,this.validate,this.convert)}}e.ApiCommandArgument=s,s.Uri=new s("uri","Uri of a text document",d=>S.URI.isUri(d),d=>d),s.Position=new s("position","A position in a text document",d=>t.Position.isPosition(d),C.Position.from),s.Range=new s("range","A range in a text document",d=>t.Range.isRange(d),C.Range.from),s.Selection=new s("selection","A selection in a text document",d=>t.Selection.isSelection(d),C.Selection.from),s.Number=new s("number","",d=>typeof d=="number",d=>d),s.String=new s("string","",d=>typeof d=="string",d=>d),s.CallHierarchyItem=new s("item","A call hierarchy item",d=>d instanceof t.CallHierarchyItem,C.CallHierarchyItem.from),s.TypeHierarchyItem=new s("item","A type hierarchy item",d=>d instanceof t.TypeHierarchyItem,C.TypeHierarchyItem.from),s.TestItem=new s("testItem","A VS Code TestItem",d=>d instanceof b.TestItemImpl,C.TestItem.from);class i{constructor(r,a){this.description=r,this.convert=a}}e.ApiCommandResult=i,i.Void=new i("no result",d=>d);class o{constructor(r,a,f,y,R){this.id=r,this.internalId=a,this.description=f,this.args=y,this.result=R}}e.ApiCommand=o}),define(De[238],Ie([1,0,2,15,7,63,38,17,114,119,12]),function(J,e,l,t,C,P,_,I,w,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const D=[new _.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",T(t.DocumentHighlight.to))),new _.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(p,b)=>{if((0,I.isFalsyOrEmpty)(p))return;class m extends C.SymbolInformation{static to(h){const c=new m(h.name,t.SymbolKind.to(h.kind),h.containerName||"",new C.Location(b[0],t.Range.to(h.range)));return c.detail=h.detail,c.range=c.location.range,c.selectionRange=t.Range.to(h.selectionRange),c.children=h.children?h.children.map(m.to):[],c}}return p.map(m.to)})),new _.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("options","Formatting options",p=>!0,p=>p)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(t.TextEdit.to))),new _.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range,new _.ApiCommandArgument("options","Formatting options",p=>!0,p=>p)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(t.TextEdit.to))),new _.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,new _.ApiCommandArgument("ch","Trigger character",p=>typeof p=="string",p=>p),new _.ApiCommandArgument("options","Formatting options",p=>!0,p=>p)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(t.TextEdit.to))),new _.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new _.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new _.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new _.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new _.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location-instances.",T(t.location.to))),new _.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Hover-instances.",T(t.Hover.to))),new _.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("position","A position in a text document",p=>Array.isArray(p)&&p.every(b=>C.Position.isPosition(b)),p=>p.map(t.Position.from))],new _.ApiCommandResult("A promise that resolves to an array of ranges.",p=>p.map(b=>{let m;for(const v of b.reverse())m=new C.SelectionRange(t.Range.to(v),m);return m}))),new _.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[_.ApiCommandArgument.String.with("query","Search string")],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",p=>p.map(t.WorkspaceSymbol.to))),new _.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A CallHierarchyItem or undefined",p=>p.map(t.CallHierarchyItem.to))),new _.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",p=>p.map(t.CallHierarchyIncomingCall.to))),new _.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",p=>p.map(t.CallHierarchyOutgoingCall.to))),new _.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to a range and placeholder text.",p=>{if(!!p)return{range:t.Range.to(p.range),placeholder:p.text}})),new _.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("newName","The new symbol name")],new _.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",p=>{if(!!p){if(p.rejectReason)throw new Error(p.rejectReason);return t.WorkspaceEdit.to(p)}})),new _.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new _.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",p=>p.map(t.DocumentLink.to))),new _.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",p=>{if(!!p)return new C.SemanticTokensLegend(p.tokenTypes,p.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",p=>{if(!p)return;const b=(0,w.decodeSemanticTokensDto)(p);if(b.type==="full")return new C.SemanticTokens(b.data,void 0)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range.optional()],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",p=>{if(!!p)return new C.SemanticTokensLegend(p.tokenTypes,p.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",p=>{if(!p)return;const b=(0,w.decodeSemanticTokensDto)(p);if(b.type==="full")return new C.SemanticTokens(b.data,void 0)})),new _.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new _.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(p,b,m)=>{if(!p)return new C.CompletionList([]);const v=p.suggestions.map(h=>t.CompletionItem.to(h,m));return new C.CompletionList(v,p.incomplete)})),new _.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new _.ApiCommandResult("A promise that resolves to SignatureHelp.",p=>{if(p)return t.SignatureHelp.to(p)})),new _.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new _.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(p,b,m)=>T(v=>new C.CodeLens(t.Range.to(v.range),v.command&&m.fromInternal(v.command)))(p))),new _.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",p=>C.Range.isRange(p),p=>C.Selection.isSelection(p)?t.Selection.from(p):t.Range.from(p)),_.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new _.ApiCommandResult("A promise that resolves to an array of Command-instances.",(p,b,m)=>T(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return m.fromInternal(v.command)}else{const h=new C.CodeAction(v.title,v.kind?new C.CodeActionKind(v.kind):void 0);return v.edit&&(h.edit=t.WorkspaceEdit.to(v.edit)),v.command&&(h.command=m.fromInternal(v.command)),h.isPreferred=v.isPreferred,h}})(p))),new _.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",p=>p?p.map(b=>new C.ColorInformation(t.Range.to(b.range),t.Color.to(b.color))):[])),new _.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new _.ApiCommandArgument("color","The color to show and insert",p=>p instanceof C.Color,t.Color.from),new _.ApiCommandArgument("context","Context object with uri and range",p=>!0,p=>({uri:p.uri,range:t.Range.from(p.range)}))],new _.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",p=>p?p.map(t.ColorPresentation.to):[])),new _.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of Inlay objects",(p,b,m)=>p.map(t.InlayHint.to.bind(void 0,m)))),new _.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new _.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",T(p=>({viewType:p.viewType,displayName:p.displayName,options:{transientOutputs:p.options.transientOutputs,transientCellMetadata:p.options.transientCellMetadata,transientDocumentMetadata:p.options.transientDocumentMetadata},filenamePattern:p.filenamePattern.map(b=>t.NotebookExclusiveDocumentPattern.to(b))})))),new _.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of InlineValue objects",p=>p.map(t.InlineValue.to))),new _.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new _.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",p=>l.URI.isUri(p)||typeof p=="string"&&(0,k.matchesSomeScheme)(p,L.Schemas.http,L.Schemas.https),p=>p),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",p=>p===void 0||typeof p=="number"||typeof p=="object",p=>p&&(typeof p=="number"?[t.ViewColumn.from(p),void 0]:[t.ViewColumn.from(p.viewColumn),t.TextEditorOpenOptions.from(p)])).optional(),_.ApiCommandArgument.String.with("label","").optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[_.ApiCommandArgument.Uri.with("resource","Resource to open"),_.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",p=>p===void 0||typeof p=="number"||typeof p=="object",p=>p&&(typeof p=="number"?[t.ViewColumn.from(p),void 0]:[t.ViewColumn.from(p.viewColumn),t.TextEditorOpenOptions.from(p)])).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[_.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),_.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),_.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",p=>p===void 0||typeof p=="object",p=>p&&[t.ViewColumn.from(p.viewColumn),t.TextEditorOpenOptions.from(p)]).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A TypeHierarchyItem or undefined",p=>p.map(t.TypeHierarchyItem.to))),new _.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[_.ApiCommandArgument.TypeHierarchyItem],new _.ApiCommandResult("A TypeHierarchyItem or undefined",p=>p.map(t.TypeHierarchyItem.to))),new _.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[_.ApiCommandArgument.TypeHierarchyItem],new _.ApiCommandResult("A TypeHierarchyItem or undefined",p=>p.map(t.TypeHierarchyItem.to))),new _.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[_.ApiCommandArgument.TestItem],_.ApiCommandResult.Void),new _.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[_.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],_.ApiCommandResult.Void)];class S{static register(b){D.forEach(b.registerApiCommand,b)}}e.ExtHostApiCommands=S;function T(p){return b=>{if(Array.isArray(b))return b.map(p)}}function E(p){if(!Array.isArray(p))return;const b=[];for(const m of p)P.isLocationLink(m)?b.push(t.DefinitionLink.to(m)):b.push(t.location.to(m));return b}}),define(De[239],Ie([1,0,18,59,4,6,2,63,27,15,7,28,5]),function(J,e,l,t,C,P,_,I,w,k,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function T(E,p,b){const m=E.getProxy(S.MainContext.MainThreadComments);class v{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,p.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===6){const r=this._commentControllers.get(d.handle);return r?r.value:d}else if(d&&d.$mid===7){const r=this._commentControllers.get(d.commentControlHandle);if(!r)return d;const a=r.getCommentThread(d.commentThreadHandle);return a?a.value:d}else if(d&&d.$mid===8){const r=this._commentControllers.get(d.thread.commentControlHandle);if(!r)return d;const a=r.getCommentThread(d.thread.commentThreadHandle);return a?{thread:a.value,text:d.text}:d}else if(d&&d.$mid===9){const r=this._commentControllers.get(d.thread.commentControlHandle);if(!r)return d;const a=r.getCommentThread(d.thread.commentThreadHandle);if(!a)return d;const f=d.commentUniqueId,y=a.getCommentByUniqueId(f);return y||d}else if(d&&d.$mid===10){const r=this._commentControllers.get(d.thread.commentControlHandle);if(!r)return d;const a=r.getCommentThread(d.thread.commentThreadHandle);if(!a)return d;const f=d.text,y=d.commentUniqueId,R=a.getCommentByUniqueId(y);return R?(typeof R.body=="string"?R.body=f:R.body.value=f,R):d}return d}})}createCommentController(d,r,a){const f=v.handlePool++,y=new c(d,f,r,a);this._commentControllers.set(y.handle,y);const R=this._commentControllersByExtension.get(w.ExtensionIdentifier.toKey(d.identifier))||[];return R.push(y),this._commentControllersByExtension.set(w.ExtensionIdentifier.toKey(d.identifier),R),y.value}$createCommentThreadTemplate(d,r,a){const f=this._commentControllers.get(d);!f||f.$createCommentThreadTemplate(r,a)}async $updateCommentThreadTemplate(d,r,a){const f=this._commentControllers.get(d);!f||f.$updateCommentThreadTemplate(r,a)}$deleteCommentThread(d,r){this._commentControllers.get(d)?.$deleteCommentThread(r)}$provideCommentingRanges(d,r,a){const f=this._commentControllers.get(d);if(!f||!f.commentingRangeProvider)return Promise.resolve(void 0);const y=b.getDocument(_.URI.revive(r));return(0,l.asPromise)(()=>f.commentingRangeProvider.provideCommentingRanges(y,a)).then(R=>R?R.map(N=>k.Range.from(N)):void 0)}$toggleReaction(d,r,a,f,y){const R=this._commentControllers.get(d);return!R||!R.reactionHandler?Promise.resolve(void 0):(0,l.asPromise)(()=>{const N=R.getCommentThread(r);if(N){const M=N.getCommentByUniqueId(f.uniqueIdInThread);if(R!==void 0&&M&&R.reactionHandler)return R.reactionHandler(M,u(y))}return Promise.resolve(void 0)})}dispose(){}}v.handlePool=0;class h{set threadId(d){this._id=d}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(d){d.isEqual(this._range)||(this._range=d,this.modifications.range=d,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(d){this._canReply!==d&&(this._canReply=d,this.modifications.canReply=d,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(d){this._label=d,this.modifications.label=d,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(d){this._contextValue=d,this.modifications.contextValue=d,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(d){this._comments=d,this.modifications.comments=d,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(d){this._collapseState=d,this.modifications.collapsibleState=d,this._onDidUpdateCommentThread.fire()}get state(){return(0,D.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(d){(0,D.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=d,this.modifications.state=d,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(d,r,a,f,y,R,N,M){this._commentControllerHandle=r,this._id=a,this._uri=f,this._range=y,this._comments=R,this.extensionDescription=N,this._isTemplate=M,this.handle=h._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new C.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputDisposables.value=new P.DisposableStore,this._id===void 0&&(this._id=`${d}.${this.handle}`),m.$createCommentThread(r,this.handle,this._id,this._uri,k.Range.from(this._range),N.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=R,this._localDisposables.push({dispose:()=>{m.$deleteCommentThread(r,this.handle)}});const A=this;this.value={get uri(){return A.uri},get range(){return A.range},set range(z){A.range=z},get comments(){return A.comments},set comments(z){A.comments=z},get collapsibleState(){return A.collapsibleState},set collapsibleState(z){A.collapsibleState=z},get canReply(){return A.canReply},set canReply(z){A.canReply=z},get contextValue(){return A.contextValue},set contextValue(z){A.contextValue=z},get label(){return A.label},set label(z){A.label=z},get state(){return A.state},set state(z){A.state=z},dispose:()=>{A.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new P.DisposableStore);const d=a=>Object.prototype.hasOwnProperty.call(this.modifications,a),r={};d("range")&&(r.range=k.Range.from(this._range)),d("label")&&(r.label=this.label),d("contextValue")&&(r.contextValue=this.contextValue??null),d("comments")&&(r.comments=this._comments.map(a=>g(this,a,this._commentsMap))),d("collapsibleState")&&(r.collapseState=s(this._collapseState)),d("canReply")&&(r.canReply=this.canReply),d("state")&&(r.state=i(this._state)),d("isTemplate")&&(r.isTemplate=this._isTemplate),this.modifications={},m.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,r)}getCommentByUniqueId(d){for(const r of this._commentsMap){const a=r[0],f=r[1];if(d===f)return a}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(d=>d.dispose())}}h._handlePool=0,je([(0,t.debounce)(100)],h.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(d){this._commentingRangeProvider=d,m.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(d){this._reactionHandler=d,m.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this._options}set options(d){this._options=d,m.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(d,r,a,f){this._extension=d,this._handle=r,this._id=a,this._label=f,this._threads=new Map,m.$registerCommentController(this.handle,a,f);const y=this;this.value=Object.freeze({id:y.id,label:y.label,get options(){return y.options},set options(R){y.options=R},get commentingRangeProvider(){return y.commentingRangeProvider},set commentingRangeProvider(R){y.commentingRangeProvider=R},get reactionHandler(){return y.reactionHandler},set reactionHandler(R){y.reactionHandler=R},createCommentThread(R,N,M){return y.createCommentThread(R,N,M).value},dispose:()=>{y.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{m.$unregisterCommentController(this.handle)}})}createCommentThread(d,r,a,f){if(typeof d=="string"){const y=new h(this.id,this.handle,d,r,a,f,this._extension,!1);return this._threads.set(y.handle,y),y}else{const y=new h(this.id,this.handle,void 0,d,r,a,this._extension,!1);return this._threads.set(y.handle,y),y}}$createCommentThreadTemplate(d,r){const a=new h(this.id,this.handle,void 0,_.URI.revive(d),k.Range.to(r),[],this._extension,!0);return a.collapsibleState=I.CommentThreadCollapsibleState.Expanded,this._threads.set(a.handle,a),a}$updateCommentThreadTemplate(d,r){const a=this._threads.get(d);a&&(a.range=k.Range.to(r))}$deleteCommentThread(d){this._threads.get(d)?.dispose(),this._threads.delete(d)}getCommentThread(d){return this._threads.get(d)}dispose(){this._threads.forEach(d=>{d.dispose()}),this._localDisposables.forEach(d=>d.dispose())}}function g(o,d,r){let a=r.get(d);a||(a=++o.commentHandle,r.set(d,a));const f=d.author&&d.author.iconPath?d.author.iconPath.toString():void 0;return{mode:d.mode,contextValue:d.contextValue,uniqueIdInThread:a,body:typeof d.body=="string"?d.body:k.MarkdownString.from(d.body),userName:d.author.name,userIconPath:f,label:d.label,commentReactions:d.reactions?d.reactions.map(y=>n(y)):void 0,timestamp:d.timestamp?.toJSON()}}function n(o){return{label:o.label,iconPath:o.iconPath?k.pathOrURIToURI(o.iconPath):void 0,count:o.count,hasReacted:o.authorHasReacted}}function u(o){return{label:o.label||"",count:o.count||0,iconPath:o.iconPath?_.URI.revive(o.iconPath):"",authorHasReacted:o.hasReacted||!1}}function s(o){if(o!==void 0)switch(o){case L.CommentThreadCollapsibleState.Expanded:return I.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return I.CommentThreadCollapsibleState.Collapsed}return I.CommentThreadCollapsibleState.Collapsed}function i(o){if(o!==void 0)switch(o){case L.CommentThreadState.Unresolved:return I.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return I.CommentThreadState.Resolved}return I.CommentThreadState.Unresolved}return new v}e.createExtHostComments=T}),define(De[240],Ie([1,0,24,5,25,14]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let _=class{constructor(L,D){this._mainThreadConsole=L.getProxy(t.MainContext.MainThreadConsole),this._includeStack=D.consoleForward.includeStack,this._logNative=D.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(L,D){const S=this,T=console[L];Object.defineProperty(console,L,{set:()=>{},get:()=>function(){S._handleConsoleCall(L,D,T,arguments)}})}_handleConsoleCall(L,D,S,T){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:D,arguments:w(T,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(L,S,T)}};_=je([$e(0,P.IExtHostRpcService),$e(1,C.IExtHostInitDataService)],_),e.AbstractExtHostConsoleForwarder=_;const I=1e5;function w(k,L){const D=[];if(k.length)for(let S=0;S<k.length;S++){let T=k[S];if(typeof T>"u")T="undefined";else if(T instanceof Error){const E=T;E.stack?T=E.stack:T=E.toString()}D.push(T)}if(L){const S=new Error().stack;S&&D.push({__$stack:S.split(`
`).slice(3).join(`
`)})}try{const S=(0,l.safeStringify)(D);return S.length>I?"Output omitted for a large object that exceeds the limits":S}catch(S){return`Output omitted for an object that cannot be inspected ('${S.toString()}')`}}}),define(De[136],Ie([1,0,2,5,7,3,14,13,17,8,9]),function(J,e,l,t,C,P,_,I,w,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let D=class On{constructor(T,E){this._logService=E,this._provider=new Map,this._proxy=T.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(T,E){const p=On._handlePool++;this._provider.set(p,{provider:T,extensionId:E}),this._proxy.$registerDecorationProvider(p,E.value);const b=T.onDidChangeFileDecorations&&T.onDidChangeFileDecorations(m=>{if(!m){this._proxy.$onDidChange(p,null);return}const v=(0,w.asArray)(m);if(v.length<=On._maxEventSize){this._proxy.$onDidChange(p,v);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",E.value,v.length);const h=v.map(n=>({uri:n,rank:(0,k.count)(n.path,"/")})),c=(0,w.groupBy)(h,(n,u)=>n.rank-u.rank||(0,k.compare)(n.uri.path,u.uri.path)),g=[];e:for(const n of c){let u;for(const s of n){const i=(0,L.dirname)(s.uri.path);if(u!==i&&(u=i,g.push(s.uri)>=On._maxEventSize))break e}}this._proxy.$onDidChange(p,g)});return new C.Disposable(()=>{b?.dispose(),this._proxy.$unregisterDecorationProvider(p),this._provider.delete(p)})}async $provideDecorations(T,E,p){if(!this._provider.has(T))return Object.create(null);const b=Object.create(null),{provider:m,extensionId:v}=this._provider.get(T);return await Promise.all(E.map(async h=>{try{const{uri:c,id:g}=h,n=await Promise.resolve(m.provideFileDecoration(l.URI.revive(c),p));if(!n)return;try{C.FileDecoration.validate(n),b[g]=[n.propagate,n.tooltip,n.badge,n.color]}catch(u){this._logService.warn(`INVALID decoration from extension '${v.value}': ${u}`)}}catch(c){this._logService.error(c)}})),b}};D._handlePool=0,D._maxEventSize=250,D=je([$e(0,_.IExtHostRpcService),$e(1,I.ILogService)],D),e.ExtHostDecorations=D,e.IExtHostDecorations=(0,P.createDecorator)("IExtHostDecorations")});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,l):C?C.value=l:e.set(J,l),l},Be=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[241],Ie([1,0,170,118,2,5,7,15,4,13,26,46]),function(J,e,l,t,C,P,_,I,w,k,L,D){"use strict";var S,T,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class p{constructor(v,h,c,g,n,u){this._name=v,this._owner=h,this._maxDiagnosticsPerFile=c,S.set(this,void 0),T.set(this,void 0),E.set(this,void 0),this._isDisposed=!1,tt(this,E,new L.ResourceMap(s=>g.getComparisonKey(s)),"f"),tt(this,S,n,"f"),tt(this,T,u,"f")}dispose(){this._isDisposed||(Be(this,T,"f").fire([...Be(this,E,"f").keys()]),Be(this,S,"f")?.$clear(this._owner),Be(this,E,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(v,h){if(!v){this.clear();return}this._checkDisposed();let c=[];if(C.URI.isUri(v)){if(!h){this.delete(v);return}Be(this,E,"f").set(v,h.slice()),c=[v]}else if(Array.isArray(v)){c=[];let n;v=[...v].sort(p._compareIndexedTuplesByUri);for(const u of v){const[s,i]=u;if((!n||s.toString()!==n.toString())&&(n&&Be(this,E,"f").get(n).length===0&&Be(this,E,"f").delete(n),n=s,c.push(s),Be(this,E,"f").set(s,[])),i)Be(this,E,"f").get(s)?.push(...i);else{const o=Be(this,E,"f").get(s);o&&(o.length=0)}}}if(Be(this,T,"f").fire(c),!Be(this,S,"f"))return;const g=[];for(const n of c){let u=[];const s=Be(this,E,"f").get(n);if(s)if(s.length>this._maxDiagnosticsPerFile){u=[];const i=[_.DiagnosticSeverity.Error,_.DiagnosticSeverity.Warning,_.DiagnosticSeverity.Information,_.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const d of s)if(d.severity===i[o]&&u.push(I.Diagnostic.from(d))===this._maxDiagnosticsPerFile)break e;u.push({severity:t.MarkerSeverity.Info,message:(0,l.localize)(0,null,s.length-this._maxDiagnosticsPerFile),startLineNumber:u[u.length-1].startLineNumber,startColumn:u[u.length-1].startColumn,endLineNumber:u[u.length-1].endLineNumber,endColumn:u[u.length-1].endColumn})}else u=s.map(i=>I.Diagnostic.from(i));g.push([n,u])}Be(this,S,"f").$changeMany(this._owner,g)}delete(v){this._checkDisposed(),Be(this,T,"f").fire([v]),Be(this,E,"f").delete(v),Be(this,S,"f")?.$changeMany(this._owner,[[v,void 0]])}clear(){this._checkDisposed(),Be(this,T,"f").fire([...Be(this,E,"f").keys()]),Be(this,E,"f").clear(),Be(this,S,"f")?.$clear(this._owner)}forEach(v,h){this._checkDisposed();for(const[c,g]of this)v.call(h,c,g,this)}*[(S=new WeakMap,T=new WeakMap,E=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const v of Be(this,E,"f").keys())yield[v,this.get(v)]}get(v){this._checkDisposed();const h=Be(this,E,"f").get(v);return Array.isArray(h)?Object.freeze(h.slice(0)):[]}has(v){return this._checkDisposed(),Array.isArray(Be(this,E,"f").get(v))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(v,h){return v[0].toString()<h[0].toString()?-1:v[0].toString()>h[0].toString()?1:0}}e.DiagnosticCollection=p;let b=class pn{static _mapper(v){const h=new L.ResourceMap;for(const c of v)h.set(c,c);return{uris:Object.freeze(Array.from(h.values()))}}constructor(v,h,c){this._logService=h,this._fileSystemInfoService=c,this._collections=new Map,this._onDidChangeDiagnostics=new w.DebounceEmitter({merge:g=>g.flat(),delay:50}),this.onDidChangeDiagnostics=w.Event.map(this._onDidChangeDiagnostics.event,pn._mapper),this._proxy=v.getProxy(P.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(v,h){const{_collections:c,_proxy:g,_onDidChangeDiagnostics:n,_logService:u,_fileSystemInfoService:s}=this,i=new class{$changeMany(r,a){g.$changeMany(r,a),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",v.value,r,a.length===0?"CLEARING":a)}$clear(r){g.$clear(r),u.trace("[DiagnosticCollection] remove all (extension, owner)",v.value,r)}dispose(){g.dispose()}};let o;if(!h)h="_generated_diagnostic_collection_name_#"+pn._idPool++,o=h;else if(!c.has(h))o=h;else{this._logService.warn(`DiagnosticCollection with name '${h}' does already exist.`);do o=h+pn._idPool++;while(c.has(o))}return new class extends p{constructor(){super(h,o,pn._maxDiagnosticsPerFile,s.extUri,i,n),c.set(o,this)}dispose(){super.dispose(),c.delete(o)}}}getDiagnostics(v){if(v)return this._getDiagnostics(v);{const h=new Map,c=[];for(const g of this._collections.values())g.forEach((n,u)=>{let s=h.get(n.toString());typeof s>"u"&&(s=c.length,h.set(n.toString(),s),c.push([n,[]])),c[s][1]=c[s][1].concat(...u)});return c}}_getDiagnostics(v){let h=[];for(const c of this._collections.values())c.has(v)&&(h=h.concat(c.get(v)));return h}$acceptMarkersChange(v){if(!this._mirrorCollection){const h="_generated_mirror",c=new p(h,h,pn._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(h,c),this._mirrorCollection=c}for(const[h,c]of v)this._mirrorCollection.set(C.URI.revive(h),c.map(I.Diagnostic.to))}};b._idPool=0,b._maxDiagnosticsPerFile=1e3,b=je([$e(1,k.ILogService),$e(2,D.IExtHostFileSystemInfo)],b),e.ExtHostDiagnostics=b}),define(De[242],Ie([1,0,2,5]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class C{constructor(_){this._proxy=_.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(_){return this._proxy.$showOpenDialog(_).then(I=>I?I.map(w=>l.URI.revive(w)):void 0)}showSaveDialog(_){return this._proxy.$showSaveDialog(_).then(I=>I?l.URI.revive(I):void 0)}}e.ExtHostDialogs=C}),define(De[243],Ie([1,0,10,2,7,5,12,21,8]),function(J,e,l,t,C,P,_,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(D,S,T){this._documentsAndEditors=S,this._logService=T,this._documentContentProviders=new Map,this._proxy=D.getProxy(P.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,S){if(Object.keys(_.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const T=k._handlePool++;this._documentContentProviders.set(T,S),this._proxy.$registerTextContentProvider(T,D);let E;return typeof S.onDidChange=="function"&&(E=S.onDidChange(p=>{if(p.scheme!==D){this._logService.warn(`Provider for scheme '${D}' is firing event for schema '${p.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(p)&&this.$provideTextDocumentContent(T,p).then(b=>{if(!b&&typeof b!="string")return;const m=this._documentsAndEditors.getDocument(p);if(!m)return;const v=(0,w.splitLines)(b);if(!m.equalLines(v))return this._proxy.$onVirtualDocumentChange(p,b)},l.onUnexpectedError)})),new C.Disposable(()=>{this._documentContentProviders.delete(T)&&this._proxy.$unregisterTextContentProvider(T),E&&(E.dispose(),E=void 0)})}$provideTextDocumentContent(D,S){const T=this._documentContentProviders.get(D);return T?Promise.resolve(T.provideTextDocumentContent(t.URI.revive(S),I.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${S.scheme}`))}}e.ExtHostDocumentContentProvider=k,k._handlePool=0}),define(De[244],Ie([1,0,4,6,2,5,132,15,16,24,7]),function(J,e,l,t,C,P,_,I,w,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class D{constructor(T,E){this._onDidAddDocument=new l.Emitter,this._onDidRemoveDocument=new l.Emitter,this._onDidChangeDocument=new l.Emitter,this._onDidSaveDocument=new l.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new t.DisposableStore,this._documentLoader=new Map,this._proxy=T.getProxy(P.MainContext.MainThreadDocuments),this._documentsAndEditors=E,this._documentsAndEditors.onDidRemoveDocuments(p=>{for(const b of p)this._onDidRemoveDocument.fire(b.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(p=>{for(const b of p)this._onDidAddDocument.fire(b.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(T){if(!T)return;const E=this._documentsAndEditors.getDocument(T);if(E)return E}getDocument(T){const E=this.getDocumentData(T);if(!E?.document)throw new Error(`Unable to retrieve document from URI '${T}'`);return E.document}ensureDocumentData(T){const E=this._documentsAndEditors.getDocument(T);if(E)return Promise.resolve(E);let p=this._documentLoader.get(T.toString());return p||(p=this._proxy.$tryOpenDocument(T).then(b=>{this._documentLoader.delete(T.toString());const m=C.URI.revive(b);return(0,w.assertIsDefined)(this._documentsAndEditors.getDocument(m))},b=>(this._documentLoader.delete(T.toString()),Promise.reject(b))),this._documentLoader.set(T.toString(),p)),p}createDocumentData(T){return this._proxy.$tryCreateDocument(T).then(E=>C.URI.revive(E))}$acceptModelLanguageChanged(T,E){const p=C.URI.revive(T),b=this._documentsAndEditors.getDocument(p);if(!b)throw new Error("unknown document");this._onDidRemoveDocument.fire(b.document),b._acceptLanguageId(E),this._onDidAddDocument.fire(b.document)}$acceptModelSaved(T){const E=C.URI.revive(T),p=this._documentsAndEditors.getDocument(E);if(!p)throw new Error("unknown document");this.$acceptDirtyStateChanged(T,!1),this._onDidSaveDocument.fire(p.document)}$acceptDirtyStateChanged(T,E){const p=C.URI.revive(T),b=this._documentsAndEditors.getDocument(p);if(!b)throw new Error("unknown document");b._acceptIsDirty(E),this._onDidChangeDocument.fire({document:b.document,contentChanges:[],reason:void 0})}$acceptModelChanged(T,E,p){const b=C.URI.revive(T),m=this._documentsAndEditors.getDocument(b);if(!m)throw new Error("unknown document");m._acceptIsDirty(p),m.onEvents(E);let v;E.isUndoing?v=L.TextDocumentChangeReason.Undo:E.isRedoing&&(v=L.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,k.deepFreeze)({document:m.document,contentChanges:E.changes.map(h=>({range:I.Range.to(h.range),rangeOffset:h.rangeOffset,rangeLength:h.rangeLength,text:h.text})),reason:v}))}setWordDefinitionFor(T,E){(0,_.setWordDefinitionFor)(T,E)}}e.ExtHostDocuments=D}),define(De[57],Ie([1,0,48,4,6,2,3,5,132,14,135,15,13,26,12,61,76]),function(J,e,l,t,C,P,_,I,w,k,L,D,S,T,E,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class m{constructor(c){this.value=c,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let v=class{constructor(c,g){this._extHostRpc=c,this._logService=g,this._activeEditorId=null,this._editors=new Map,this._documents=new T.ResourceMap,this._onDidAddDocuments=new t.Emitter,this._onDidRemoveDocuments=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const g=[],n=[],u=[];if(c.removedDocuments)for(const s of c.removedDocuments){const i=P.URI.revive(s),o=this._documents.get(i);o?.unref()&&(this._documents.delete(i),g.push(o.value))}if(c.addedDocuments)for(const s of c.addedDocuments){const i=P.URI.revive(s.uri);let o=this._documents.get(i);if(o&&i.scheme!==E.Schemas.vscodeNotebookCell&&i.scheme!==E.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);o||(o=new m(new w.ExtHostDocumentData(this._extHostRpc.getProxy(I.MainContext.MainThreadDocuments),i,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this._documents.set(i,o),n.push(o.value)),o.ref()}if(c.removedEditors)for(const s of c.removedEditors){const i=this._editors.get(s);this._editors.delete(s),i&&u.push(i)}if(c.addedEditors)for(const s of c.addedEditors){const i=P.URI.revive(s.documentUri);l.ok(this._documents.has(i),`document '${i}' does not exist`),l.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const o=this._documents.get(i).value,d=new L.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(I.MainContext.MainThreadTextEditors),this._logService,new b.Lazy(()=>o.document),s.selections.map(D.Selection.to),s.options,s.visibleRanges.map(r=>D.Range.to(r)),typeof s.editorPosition=="number"?D.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,d)}c.newActiveEditor!==void 0&&(l.ok(c.newActiveEditor===null||this._editors.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this._activeEditorId=c.newActiveEditor),(0,C.dispose)(g),(0,C.dispose)(u),c.removedDocuments&&this._onDidRemoveDocuments.fire(g),c.addedDocuments&&this._onDidAddDocuments.fire(n),(c.removedEditors||c.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),c.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(c){return this._documents.get(c)?.value}allDocuments(){return p.Iterable.map(this._documents.values(),c=>c.value)}getEditor(c){return this._editors.get(c)}activeEditor(c){if(!this._activeEditorId)return;const g=this._editors.get(this._activeEditorId);return c?g:g?.value}allEditors(){return[...this._editors.values()]}};v=je([$e(0,k.IExtHostRpcService),$e(1,S.ILogService)],v),e.ExtHostDocumentsAndEditors=v,e.IExtHostDocumentsAndEditors=(0,_.createDecorator)("IExtHostDocumentsAndEditors")}),define(De[58],Ie([1,0,15,5,2,4,3,7,14,16,75]),function(J,e,l,t,C,P,_,I,w,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,_.createDecorator)("IExtHostEditorTabs");class D{constructor(b,m,v){this._activeTabIdGetter=v,this._parentGroup=m,this.acceptDtoUpdate(b)}get apiObject(){if(!this._apiObject){const b=this,m={get isActive(){return b._dto.id===b._activeTabIdGetter()},get label(){return b._dto.label},get input(){return b._input},get isDirty(){return b._dto.isDirty},get isPinned(){return b._dto.isPinned},get isPreview(){return b._dto.isPreview},get group(){return b._parentGroup.apiObject}};this._apiObject=Object.freeze(m)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(b){this._dto=b,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new I.TextTabInput(C.URI.revive(this._dto.input.uri));case 2:return new I.TextDiffTabInput(C.URI.revive(this._dto.input.original),C.URI.revive(this._dto.input.modified));case 3:return new I.TextMergeTabInput(C.URI.revive(this._dto.input.base),C.URI.revive(this._dto.input.input1),C.URI.revive(this._dto.input.input2),C.URI.revive(this._dto.input.result));case 6:return new I.CustomEditorTabInput(C.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new I.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new I.NotebookEditorTabInput(C.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new I.NotebookDiffEditorTabInput(C.URI.revive(this._dto.input.original),C.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new I.TerminalEditorTabInput;case 9:return new I.InteractiveWindowInput(C.URI.revive(this._dto.input.uri),C.URI.revive(this._dto.input.inputBoxUri));default:return}}}class S{constructor(b,m){this._tabs=[],this._activeTabId="",this._dto=b,this._activeGroupIdGetter=m;for(const v of b.tabs)v.isActive&&(this._activeTabId=v.id),this._tabs.push(new D(v,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const b=this,m={get isActive(){return b._dto.groupId===b._activeGroupIdGetter()},get viewColumn(){return l.ViewColumn.to(b._dto.viewColumn)},get activeTab(){return b._tabs.find(v=>v.tabId===b._activeTabId)?.apiObject},get tabs(){return Object.freeze(b._tabs.map(v=>v.apiObject))}};this._apiObject=Object.freeze(m)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(b){this._dto=b}acceptTabOperation(b){if(b.kind===0){const v=new D(b.tabDto,this,()=>this.activeTabId());return this._tabs.splice(b.index,0,v),b.tabDto.isActive&&(this._activeTabId=v.tabId),v}else if(b.kind===1){const v=this._tabs.splice(b.index,1)[0];if(!v)throw new Error(`Tab close updated received for index ${b.index} which does not exist`);return v.tabId===this._activeTabId&&(this._activeTabId=""),v}else if(b.kind===3){if(b.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const v=this._tabs.splice(b.oldIndex,1)[0];if(!v)throw new Error(`Tab move updated received for index ${b.oldIndex} which does not exist`);return this._tabs.splice(b.index,0,v),v}const m=this._tabs.find(v=>v.tabId===b.tabDto.id);if(!m)throw new Error("INVALID tab");return b.tabDto.isActive?this._activeTabId=b.tabDto.id:this._activeTabId===b.tabDto.id&&!b.tabDto.isActive&&(this._activeTabId=""),m.acceptDtoUpdate(b.tabDto),m}activeTabId(){return this._activeTabId}}let T=class{constructor(b){this._onDidChangeTabs=new P.Emitter,this._onDidChangeTabGroups=new P.Emitter,this._extHostTabGroups=[],this._proxy=b.getProxy(t.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const b=this,m={onDidChangeTabGroups:b._onDidChangeTabGroups.event,onDidChangeTabs:b._onDidChangeTabs.event,get all(){return Object.freeze(b._extHostTabGroups.map(v=>v.apiObject))},get activeTabGroup(){const v=b._activeGroupId;return(0,k.assertIsDefined)(b._extHostTabGroups.find(c=>c.groupId===v)?.apiObject)},close:async(v,h)=>{const c=Array.isArray(v)?v:[v];return c.length?E(c[0])?this._closeGroups(c,h):this._closeTabs(c,h):!0}};this._apiObject=Object.freeze(m)}return this._apiObject}$acceptEditorTabModel(b){const m=new Set(this._extHostTabGroups.map(s=>s.groupId)),v=new Set(b.map(s=>s.groupId)),h=(0,L.diffSets)(m,v),c=this._extHostTabGroups.filter(s=>h.removed.includes(s.groupId)).map(s=>s.apiObject),g=[],n=[];this._extHostTabGroups=b.map(s=>{const i=new S(s,()=>this._activeGroupId);return h.added.includes(i.groupId)?g.push(i.apiObject):n.push(i.apiObject),i});const u=(0,k.assertIsDefined)(b.find(s=>s.isActive===!0)?.groupId);u!==void 0&&this._activeGroupId!==u&&(this._activeGroupId=u),this._onDidChangeTabGroups.fire(Object.freeze({opened:g,closed:c,changed:n}))}$acceptTabGroupUpdate(b){const m=this._extHostTabGroups.find(v=>v.groupId===b.groupId);if(!m)throw new Error("Update Group IPC call received before group creation.");m.acceptGroupDtoUpdate(b),b.isActive&&(this._activeGroupId=b.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[m.apiObject],opened:[],closed:[]}))}$acceptTabOperation(b){const m=this._extHostTabGroups.find(h=>h.groupId===b.groupId);if(!m)throw new Error("Update Tabs IPC call received before group creation.");const v=m.acceptTabOperation(b);switch(b.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[v.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[v.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[v.apiObject]}));return}}_findExtHostTabFromApi(b){for(const m of this._extHostTabGroups)for(const v of m.tabs)if(v.apiObject===b)return v}_findExtHostTabGroupFromApi(b){return this._extHostTabGroups.find(m=>m.apiObject===b)}async _closeTabs(b,m){const v=[];for(const h of b){const c=this._findExtHostTabFromApi(h);if(!c)throw new Error("Tab close: Invalid tab not found!");v.push(c.tabId)}return this._proxy.$closeTab(v,m)}async _closeGroups(b,m){const v=[];for(const h of b){const c=this._findExtHostTabGroupFromApi(h);if(!c)throw new Error("Group close: Invalid group not found!");v.push(c.groupId)}return this._proxy.$closeGroup(v,m)}};T=je([$e(0,w.IExtHostRpcService)],T),e.ExtHostEditorTabs=T;function E(p){return p.tabs!==void 0}}),define(De[245],Ie([1,0,2,5,6,7,15,150,8,23,28]),function(J,e,l,t,C,P,_,I,w,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class D{constructor(){this._schemes=[]}add(E){this._stateMachine=void 0,this._schemes.push(E)}delete(E){const p=this._schemes.indexOf(E);p>=0&&(this._schemes.splice(p,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const E=this._schemes.sort(),p=[];let b,m,v=14,h=14;for(const c of E){let g=b?(0,w.commonPrefixLength)(b,c):0;for(g===0?m=1:m=h;g<c.length;g++)g+1===c.length?(v=h,h=9):h+=1,p.push([m,c.toUpperCase().charCodeAt(g),h]),p.push([m,c.toLowerCase().charCodeAt(g),h]),m=h;b=c,h=v}p.push([9,58,10]),p.push([10,47,12]),this._stateMachine=new I.StateMachine(p)}}provideDocumentLinks(E){this._initStateMachine();const p=[],b=I.LinkComputer.computeLinks({getLineContent(m){return E.lineAt(m-1).text},getLineCount(){return E.lineCount}},this._stateMachine);for(const m of b){const v=_.DocumentLink.to(m);v.target&&p.push(v)}return p}}class S{constructor(E,p){this._extHostLanguageFeatures=p,this._linkProvider=new D,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=E.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(E,p,b,m={}){if(this._registeredSchemes.has(p))throw new Error(`a provider for the scheme '${p}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(E,"*",this._linkProvider));const v=this._handlePool++;this._linkProvider.add(p),this._registeredSchemes.add(p),this._fsProvider.set(v,b);let h=2;m.isCaseSensitive&&(h+=1024),m.isReadonly&&(h+=2048),typeof b.copy=="function"&&(h+=8),typeof b.open=="function"&&typeof b.close=="function"&&typeof b.read=="function"&&typeof b.write=="function"&&((0,L.checkProposedApiEnabled)(E,"fsChunks"),h+=4),this._proxy.$registerFileSystemProvider(v,p,h).catch(g=>{console.error(`FAILED to register filesystem provider of ${E.identifier.value}-extension for the scheme ${p}`),console.error(g)});const c=b.onDidChangeFile(g=>{const n=[];for(const u of g){const{uri:s,type:i}=u;if(s.scheme!==p)continue;let o;switch(i){case P.FileChangeType.Changed:o=0;break;case P.FileChangeType.Created:o=1;break;case P.FileChangeType.Deleted:o=2;break;default:throw new Error("Unknown FileChangeType")}n.push({resource:s,type:o})}this._proxy.$onFileSystemChange(v,n)});return(0,C.toDisposable)(()=>{c.dispose(),this._linkProvider.delete(p),this._registeredSchemes.delete(p),this._fsProvider.delete(v),this._proxy.$unregisterProvider(v)})}static _asIStat(E){const{type:p,ctime:b,mtime:m,size:v,permissions:h}=E;return{type:p,ctime:b,mtime:m,size:v,permissions:h}}$stat(E,p){return Promise.resolve(this._getFsProvider(E).stat(l.URI.revive(p))).then(b=>S._asIStat(b))}$readdir(E,p){return Promise.resolve(this._getFsProvider(E).readDirectory(l.URI.revive(p)))}$readFile(E,p){return Promise.resolve(this._getFsProvider(E).readFile(l.URI.revive(p))).then(b=>k.VSBuffer.wrap(b))}$writeFile(E,p,b,m){return Promise.resolve(this._getFsProvider(E).writeFile(l.URI.revive(p),b.buffer,m))}$delete(E,p,b){return Promise.resolve(this._getFsProvider(E).delete(l.URI.revive(p),b))}$rename(E,p,b,m){return Promise.resolve(this._getFsProvider(E).rename(l.URI.revive(p),l.URI.revive(b),m))}$copy(E,p,b,m){const v=this._getFsProvider(E);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(l.URI.revive(p),l.URI.revive(b),m))}$mkdir(E,p){return Promise.resolve(this._getFsProvider(E).createDirectory(l.URI.revive(p)))}$watch(E,p,b,m){const v=this._getFsProvider(E).watch(l.URI.revive(b),m);this._watches.set(p,v)}$unwatch(E,p){const b=this._watches.get(p);b&&(b.dispose(),this._watches.delete(p))}$open(E,p,b){const m=this._getFsProvider(E);if(!m.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(m.open(l.URI.revive(p),b))}$close(E,p){const b=this._getFsProvider(E);if(!b.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(b.close(p))}$read(E,p,b,m){const v=this._getFsProvider(E);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const h=k.VSBuffer.alloc(m);return Promise.resolve(v.read(p,b,h.buffer,0,m)).then(c=>h.slice(0,c))}$write(E,p,b,m){const v=this._getFsProvider(E);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(p,b,m.buffer,0,m.byteLength))}_getFsProvider(E){const p=this._fsProvider.get(E);if(!p){const b=new Error;throw b.name="ENOPRO",b.message="no provider",b}return p}}e.ExtHostFileSystem=S}),define(De[66],Ie([1,0,5,37,7,23,3,14,46,6]),function(J,e,l,t,C,P,_,I,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let L=class Kt{constructor(S,T){this._fileSystemProvider=new Map,this._proxy=S.getProxy(l.MainContext.MainThreadFileSystem);const E=this;this.value=Object.freeze({async stat(p){try{const b=E._fileSystemProvider.get(p.scheme);if(!b)return await E._proxy.$stat(p);await E._proxy.$ensureActivation(p.scheme);const m=await b.stat(p);return{type:m.type,ctime:m.ctime,mtime:m.mtime,size:m.size,permissions:m.permissions}}catch(b){Kt._handleError(b)}},async readDirectory(p){try{const b=E._fileSystemProvider.get(p.scheme);return b?(await E._proxy.$ensureActivation(p.scheme),(await b.readDirectory(p)).slice()):await E._proxy.$readdir(p)}catch(b){return Kt._handleError(b)}},async createDirectory(p){try{return await E._proxy.$mkdir(p)}catch(b){return Kt._handleError(b)}},async readFile(p){try{const b=E._fileSystemProvider.get(p.scheme);return b?(await E._proxy.$ensureActivation(p.scheme),(await b.readFile(p)).slice()):(await E._proxy.$readFile(p)).buffer}catch(b){return Kt._handleError(b)}},async writeFile(p,b){try{return await E._proxy.$writeFile(p,P.VSBuffer.wrap(b))}catch(m){return Kt._handleError(m)}},async delete(p,b){try{const m=E._fileSystemProvider.get(p.scheme);return m?(await E._proxy.$ensureActivation(p.scheme),await m.delete(p,{recursive:!1,...b})):await E._proxy.$delete(p,{recursive:!1,useTrash:!1,...b})}catch(m){return Kt._handleError(m)}},async rename(p,b,m){try{return await E._proxy.$rename(p,b,{overwrite:!1,...m})}catch(v){return Kt._handleError(v)}},async copy(p,b,m){try{return await E._proxy.$copy(p,b,{overwrite:!1,...m})}catch(v){return Kt._handleError(v)}},isWritableFileSystem(p){const b=T.getCapabilities(p);if(typeof b=="number")return!(b&2048)}})}static _handleError(S){if(S instanceof C.FileSystemError)throw S;if(!(S instanceof Error))throw new C.FileSystemError(String(S));if(S.name==="ENOPRO")throw C.FileSystemError.Unavailable(S.message);switch(S.name){case t.FileSystemProviderErrorCode.FileExists:throw C.FileSystemError.FileExists(S.message);case t.FileSystemProviderErrorCode.FileNotFound:throw C.FileSystemError.FileNotFound(S.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw C.FileSystemError.FileNotADirectory(S.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw C.FileSystemError.FileIsADirectory(S.message);case t.FileSystemProviderErrorCode.NoPermissions:throw C.FileSystemError.NoPermissions(S.message);case t.FileSystemProviderErrorCode.Unavailable:throw C.FileSystemError.Unavailable(S.message);default:throw new C.FileSystemError(S.message,S.name)}}addFileSystemProvider(S,T){return this._fileSystemProvider.set(S,T),(0,k.toDisposable)(()=>this._fileSystemProvider.delete(S))}};L=je([$e(0,I.IExtHostRpcService),$e(1,w.IExtHostFileSystemInfo)],L),e.ExtHostConsumerFileSystem=L,e.IExtHostConsumerFileSystem=(0,_.createDecorator)("IExtHostConsumerFileSystem")}),define(De[246],Ie([1,0,4,36,2,5,15,7]),function(J,e,l,t,C,P,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class w{get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}constructor(D,S,T,E,p,b,m,v){this._onDidCreate=new l.Emitter,this._onDidChange=new l.Emitter,this._onDidDelete=new l.Emitter;const h=this.ensureWatching(D,T,p);this._config=0,b&&(this._config+=1),m&&(this._config+=2),v&&(this._config+=4);const c=(0,t.parse)(p),g=typeof p=="string",n=E(u=>{if(!b)for(const s of u.created){const i=C.URI.revive(s);c(i.fsPath)&&(!g||S.getWorkspaceFolder(i))&&this._onDidCreate.fire(i)}if(!m)for(const s of u.changed){const i=C.URI.revive(s);c(i.fsPath)&&(!g||S.getWorkspaceFolder(i))&&this._onDidChange.fire(i)}if(!v)for(const s of u.deleted){const i=C.URI.revive(s);c(i.fsPath)&&(!g||S.getWorkspaceFolder(i))&&this._onDidDelete.fire(i)}});this._disposable=I.Disposable.from(h,this._onDidCreate,this._onDidChange,this._onDidDelete,n)}ensureWatching(D,S,T){const E=I.Disposable.from();if(typeof T=="string")return E;const p=D.getProxy(P.MainContext.MainThreadFileSystem);let b=!1;(T.pattern.includes(t.GLOBSTAR)||T.pattern.includes(t.GLOB_SPLIT))&&(b=!0);const m=Math.random();return p.$watch(S.identifier.value,m,T.baseUri,{recursive:b,excludes:[]}),I.Disposable.from({dispose:()=>p.$unwatch(m)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class k{constructor(D,S,T){this._mainContext=D,this._logService=S,this._extHostDocumentsAndEditors=T,this._onFileSystemEvent=new l.Emitter,this._onDidRenameFile=new l.Emitter,this._onDidCreateFile=new l.Emitter,this._onDidDeleteFile=new l.Emitter,this._onWillRenameFile=new l.AsyncEmitter,this._onWillCreateFile=new l.AsyncEmitter,this._onWillDeleteFile=new l.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(D,S,T,E,p,b){return new w(this._mainContext,D,S,this._onFileSystemEvent.event,_.GlobPattern.from(T),E,p,b)}$onFileEvent(D){this._onFileSystemEvent.fire(D)}$onDidRunFileOperation(D,S){switch(D){case 2:this._onDidRenameFile.fire(Object.freeze({files:S.map(T=>({oldUri:C.URI.revive(T.source),newUri:C.URI.revive(T.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:S.map(T=>C.URI.revive(T.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:S.map(T=>C.URI.revive(T.target))}));break;default:}}getOnWillRenameFileEvent(D){return this._createWillExecuteEvent(D,this._onWillRenameFile)}getOnWillCreateFileEvent(D){return this._createWillExecuteEvent(D,this._onWillCreateFile)}getOnWillDeleteFileEvent(D){return this._createWillExecuteEvent(D,this._onWillDeleteFile)}_createWillExecuteEvent(D,S){return(T,E,p)=>{const b=function(v){T.call(E,v)};return b.extension=D,S.event(b,void 0,p)}}async $onWillRunFileOperation(D,S,T,E){switch(D){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:S.map(p=>({oldUri:C.URI.revive(p.source),newUri:C.URI.revive(p.target)}))},T,E);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:S.map(p=>C.URI.revive(p.target))},T,E);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:S.map(p=>C.URI.revive(p.target))},T,E)}}async _fireWillEvent(D,S,T,E){const p=new Set,b=[];if(await D.fireAsync(S,E,async(v,h)=>{const c=Date.now(),g=await Promise.resolve(v);g instanceof I.WorkspaceEdit&&(b.push([h.extension,g]),p.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-c>T&&this._logService.warn("SLOW file-participant",h.extension.identifier)}),E.isCancellationRequested||b.length===0)return;const m={edits:[]};for(const[,v]of b){const{edits:h}=_.WorkspaceEdit.from(v,{getTextDocumentVersion:c=>this._extHostDocumentsAndEditors.getDocument(c)?.version,getNotebookDocumentVersion:()=>{}});m.edits=m.edits.concat(h)}return{edit:m,extensionNames:Array.from(p)}}}e.ExtHostFileSystemEventService=k}),define(De[247],Ie([1,0,2,38]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class C{constructor(_,I,w,k,L){this._extHostNotebooks=I,this._textDocumentsAndEditors=w,this._commands=k;const D=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",S=>!0,S=>S),new t.ApiCommandArgument("resource","Interactive resource Uri",S=>!0,S=>S),new t.ApiCommandArgument("controllerId","Notebook controller Id",S=>!0,S=>S),new t.ApiCommandArgument("title","Interactive editor title",S=>!0,S=>S)],new t.ApiCommandResult("Notebook and input URI",S=>{if(L.debug("[ExtHostInteractive] open iw with notebook editor id",S.notebookEditorId),S.notebookEditorId!==void 0){const T=this._extHostNotebooks.getEditorById(S.notebookEditorId);return L.debug("[ExtHostInteractive] notebook editor found",T.id),{notebookUri:l.URI.revive(S.notebookUri),inputUri:l.URI.revive(S.inputUri),notebookEditor:T.apiEditor}}return L.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",S.notebookUri,S.inputUri),{notebookUri:l.URI.revive(S.notebookUri),inputUri:l.URI.revive(S.inputUri)}}));this._commands.registerApiCommand(D)}$willAddInteractiveDocument(_,I,w,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:I,lines:[""],languageId:w,uri:_,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(l.URI.revive(k))?.apiNotebook}]})}$willRemoveInteractiveDocument(_,I){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[_]})}}e.ExtHostInteractive=C}),define(De[248],Ie([1,0,6,5]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class C{constructor(_){this._handlePool=0,this._proxy=_.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(_){const I=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(I,_),(0,l.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(I)})}}e.ExtHostLabelService=C}),define(De[249],Ie([1,0,2,24,15,7,63,5,8,35,17,16,146,21,6,114,94,86,51,10,18,28]),function(J,e,l,t,C,P,_,I,w,k,L,D,S,T,E,p,b,m,v,h,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class n{constructor(O,V){this._documents=O,this._provider=V}async provideDocumentSymbols(O,V){const q=this._documents.getDocument(O),X=await this._provider.provideDocumentSymbols(q,V);if(!(0,L.isFalsyOrEmpty)(X))return X[0]instanceof P.DocumentSymbol?X.map(C.DocumentSymbol.from):n._asDocumentSymbolTree(X)}static _asDocumentSymbolTree(O){O=O.slice(0).sort((X,ge)=>{let we=X.location.range.start.compareTo(ge.location.range.start);return we===0&&(we=ge.location.range.end.compareTo(X.location.range.end)),we});const V=[],q=[];for(const X of O){const ge={name:X.name||"!!MISSING: name!!",kind:C.SymbolKind.from(X.kind),tags:X.tags?.map(C.SymbolTag.from)||[],detail:"",containerName:X.containerName,range:C.Range.from(X.location.range),selectionRange:C.Range.from(X.location.range),children:[]};for(;;){if(q.length===0){q.push(ge),V.push(ge);break}const we=q[q.length-1];if(k.Range.containsRange(we.range,ge.range)&&!k.Range.equalsRange(we.range,ge.range)){we.children?.push(ge),q.push(ge);break}q.pop()}}return V}}class u{constructor(O,V,q){this._documents=O,this._commands=V,this._provider=q,this._cache=new m.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(O,V){const q=this._documents.getDocument(O),X=await this._provider.provideCodeLenses(q,V);if(!X||V.isCancellationRequested)return;const ge=this._cache.add(X),we=new E.DisposableStore;this._disposables.set(ge,we);const ce={cacheId:ge,lenses:[]};for(let Ce=0;Ce<X.length;Ce++)ce.lenses.push({cacheId:[ge,Ce],range:C.Range.from(X[Ce].range),command:this._commands.toInternal(X[Ce].command,we)});return ce}async resolveCodeLens(O,V){const q=O.cacheId&&this._cache.get(...O.cacheId);if(!q)return;let X;if(typeof this._provider.resolveCodeLens!="function"||q.isResolved?X=q:X=await this._provider.resolveCodeLens(q,V),X||(X=q),V.isCancellationRequested)return;const ge=O.cacheId&&this._disposables.get(O.cacheId[0]);if(!!ge)return O.command=this._commands.toInternal(X.command??u._badCmd,ge),O}releaseCodeLenses(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}}u._badCmd={command:"missing",title:"!!MISSING: command!!"};function s(ie){return Array.isArray(ie)?ie.map(C.DefinitionLink.from):ie?[C.DefinitionLink.from(ie)]:[]}class i{constructor(O,V){this._documents=O,this._provider=V}async provideDefinition(O,V,q){const X=this._documents.getDocument(O),ge=C.Position.to(V),we=await this._provider.provideDefinition(X,ge,q);return s(we)}}class o{constructor(O,V){this._documents=O,this._provider=V}async provideDeclaration(O,V,q){const X=this._documents.getDocument(O),ge=C.Position.to(V),we=await this._provider.provideDeclaration(X,ge,q);return s(we)}}class d{constructor(O,V){this._documents=O,this._provider=V}async provideImplementation(O,V,q){const X=this._documents.getDocument(O),ge=C.Position.to(V),we=await this._provider.provideImplementation(X,ge,q);return s(we)}}class r{constructor(O,V){this._documents=O,this._provider=V}async provideTypeDefinition(O,V,q){const X=this._documents.getDocument(O),ge=C.Position.to(V),we=await this._provider.provideTypeDefinition(X,ge,q);return s(we)}}class a{constructor(O,V){this._documents=O,this._provider=V}async provideHover(O,V,q){const X=this._documents.getDocument(O),ge=C.Position.to(V),we=await this._provider.provideHover(X,ge,q);if(!(!we||(0,L.isFalsyOrEmpty)(we.contents)))return we.range||(we.range=X.getWordRangeAtPosition(ge)),we.range||(we.range=new P.Range(ge,ge)),C.Hover.from(we)}}class f{constructor(O,V){this._documents=O,this._provider=V}async provideEvaluatableExpression(O,V,q){const X=this._documents.getDocument(O),ge=C.Position.to(V),we=await this._provider.provideEvaluatableExpression(X,ge,q);if(we)return C.EvaluatableExpression.from(we)}}class y{constructor(O,V){this._documents=O,this._provider=V}async provideInlineValues(O,V,q,X){const ge=this._documents.getDocument(O),we=await this._provider.provideInlineValues(ge,C.Range.to(V),C.InlineValueContext.to(q),X);if(Array.isArray(we))return we.map(ce=>C.InlineValue.from(ce))}}class R{constructor(O,V){this._documents=O,this._provider=V}async provideDocumentHighlights(O,V,q){const X=this._documents.getDocument(O),ge=C.Position.to(V),we=await this._provider.provideDocumentHighlights(X,ge,q);if(Array.isArray(we))return we.map(C.DocumentHighlight.from)}}class N{constructor(O,V){this._documents=O,this._provider=V}async provideLinkedEditingRanges(O,V,q){const X=this._documents.getDocument(O),ge=C.Position.to(V),we=await this._provider.provideLinkedEditingRanges(X,ge,q);if(we&&Array.isArray(we.ranges))return{ranges:(0,L.coalesce)(we.ranges.map(C.Range.from)),wordPattern:we.wordPattern}}}class M{constructor(O,V){this._documents=O,this._provider=V}async provideReferences(O,V,q,X){const ge=this._documents.getDocument(O),we=C.Position.to(V),ce=await this._provider.provideReferences(ge,we,q,X);if(Array.isArray(ce))return ce.map(C.location.from)}}class A{constructor(O,V,q,X,ge,we,ce){this._documents=O,this._commands=V,this._diagnostics=q,this._provider=X,this._logService=ge,this._extension=we,this._apiDeprecation=ce,this._cache=new m.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(O,V,q,X){const ge=this._documents.getDocument(O),we=S.Selection.isISelection(V)?C.Selection.to(V):C.Range.to(V),ce=[];for(const Ye of this._diagnostics.getDiagnostics(O))if(we.intersection(Ye.range)&&ce.push(Ye)>A._maxCodeActionsPerFile)break;const Ce={diagnostics:ce,only:q.only?new P.CodeActionKind(q.only):void 0,triggerKind:C.CodeActionTriggerKind.to(q.trigger)},ye=await this._provider.provideCodeActions(ge,we,Ce,X);if(!(0,L.isNonEmptyArray)(ye)||X.isCancellationRequested)return;const We=this._cache.add(ye),qe=new E.DisposableStore;this._disposables.set(We,qe);const Ze=[];for(let Ye=0;Ye<ye.length;Ye++){const Oe=ye[Ye];!Oe||(A._isCommand(Oe)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ze.push({_isSynthetic:!0,title:Oe.title,command:this._commands.toInternal(Oe,qe)})):(Ce.only&&(Oe.kind?Ce.only.contains(Oe.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ce.only.value} 'requested but returned code action is of kind '${Oe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ce.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ze.push({cacheId:[We,Ye],title:Oe.title,command:Oe.command&&this._commands.toInternal(Oe.command,qe),diagnostics:Oe.diagnostics&&Oe.diagnostics.map(C.Diagnostic.from),edit:Oe.edit&&C.WorkspaceEdit.from(Oe.edit,void 0),kind:Oe.kind&&Oe.kind.value,isPreferred:Oe.isPreferred,disabled:Oe.disabled?.reason})))}return{cacheId:We,actions:Ze}}async resolveCodeAction(O,V){const[q,X]=O,ge=this._cache.get(q,X);if(!ge||A._isCommand(ge)||!this._provider.resolveCodeAction)return;const we=await this._provider.resolveCodeAction(ge,V)??ge;return we?.edit?C.WorkspaceEdit.from(we.edit,void 0):void 0}releaseCodeActions(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}static _isCommand(O){return typeof O.command=="string"&&typeof O.title=="string"}}A._maxCodeActionsPerFile=1e3;class z{constructor(O,V,q,X){this._proxy=O,this._documents=V,this._provider=q,this._handle=X}async prepareDocumentPaste(O,V,q,X){if(!this._provider.prepareDocumentPaste)return;const ge=this._documents.getDocument(O),we=V.map(Ce=>C.Range.to(Ce)),ce=C.DataTransfer.toDataTransfer(q,()=>{throw new h.NotImplementedError});return await this._provider.prepareDocumentPaste(ge,we,ce,X),C.DataTransfer.toDataTransferDTO(ce)}async providePasteEdits(O,V,q,X,ge){const we=this._documents.getDocument(V),ce=q.map(We=>C.Range.to(We)),Ce=C.DataTransfer.toDataTransfer(X,async We=>(await this._proxy.$resolvePasteFileData(this._handle,O,We)).buffer),ye=await this._provider.provideDocumentPasteEdits(we,ce,Ce,ge);if(!!ye)return{insertText:typeof ye.insertText=="string"?ye.insertText:{snippet:ye.insertText.value},additionalEdit:ye.additionalEdit?C.WorkspaceEdit.from(ye.additionalEdit,void 0):void 0}}}class H{constructor(O,V){this._documents=O,this._provider=V}async provideDocumentFormattingEdits(O,V,q){const X=this._documents.getDocument(O),ge=await this._provider.provideDocumentFormattingEdits(X,V,q);if(Array.isArray(ge))return ge.map(C.TextEdit.from)}}class F{constructor(O,V){this._documents=O,this._provider=V}async provideDocumentRangeFormattingEdits(O,V,q,X){const ge=this._documents.getDocument(O),we=C.Range.to(V),ce=await this._provider.provideDocumentRangeFormattingEdits(ge,we,q,X);if(Array.isArray(ce))return ce.map(C.TextEdit.from)}}class G{constructor(O,V){this._documents=O,this._provider=V,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(O,V,q,X,ge){const we=this._documents.getDocument(O),ce=C.Position.to(V),Ce=await this._provider.provideOnTypeFormattingEdits(we,ce,q,X,ge);if(Array.isArray(Ce))return Ce.map(C.TextEdit.from)}}class B{constructor(O,V){this._provider=O,this._logService=V,this._cache=new m.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(O,V){const q=await this._provider.provideWorkspaceSymbols(O,V);if(!(0,L.isNonEmptyArray)(q))return{symbols:[]};const X=this._cache.add(q),ge={cacheId:X,symbols:[]};for(let we=0;we<q.length;we++){const ce=q[we];if(!ce||!ce.name){this._logService.warn("INVALID SymbolInformation",ce);continue}ge.symbols.push({...C.WorkspaceSymbol.from(ce),cacheId:[X,we]})}return ge}async resolveWorkspaceSymbol(O,V){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!O.cacheId)return O;const q=this._cache.get(...O.cacheId);if(q){const X=await this._provider.resolveWorkspaceSymbol(q,V);return X&&(0,t.mixin)(O,C.WorkspaceSymbol.from(X),!0)}}releaseWorkspaceSymbols(O){this._cache.delete(O)}}class U{static supportsResolving(O){return typeof O.prepareRename=="function"}constructor(O,V,q){this._documents=O,this._provider=V,this._logService=q}async provideRenameEdits(O,V,q,X){const ge=this._documents.getDocument(O),we=C.Position.to(V);try{const ce=await this._provider.provideRenameEdits(ge,we,q,X);return ce?C.WorkspaceEdit.from(ce):void 0}catch(ce){const Ce=U._asMessage(ce);return Ce?{rejectReason:Ce,edits:void 0}:Promise.reject(ce)}}async resolveRenameLocation(O,V,q){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const X=this._documents.getDocument(O),ge=C.Position.to(V);try{const we=await this._provider.prepareRename(X,ge,q);let ce,Ce;if(P.Range.isRange(we)?(ce=we,Ce=X.getText(we)):(0,D.isObject)(we)&&(ce=we.range,Ce=we.placeholder),!ce||!Ce)return;if(ce.start.line>ge.line||ce.end.line<ge.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(ce),text:Ce}}catch(we){const ce=U._asMessage(we);return ce?{rejectReason:ce,range:void 0,text:void 0}:Promise.reject(we)}}static _asMessage(O){return typeof O=="string"?O:O instanceof Error&&typeof O.message=="string"?O.message:void 0}}class x{constructor(O,V){this.resultId=O,this.tokens=V}}class ${constructor(O,V){this._documents=O,this._provider=V,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(O,V,q){const X=this._documents.getDocument(O),ge=V!==0?this._previousResults.get(V):null;let we=typeof ge?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(X,ge.resultId,q):await this._provider.provideDocumentSemanticTokens(X,q);return ge&&this._previousResults.delete(V),we?(we=$._fixProvidedSemanticTokens(we),this._send($._convertToEdits(ge,we),we)):null}async releaseDocumentSemanticColoring(O){this._previousResults.delete(O)}static _fixProvidedSemanticTokens(O){return $._isSemanticTokens(O)?$._isCorrectSemanticTokens(O)?O:new P.SemanticTokens(new Uint32Array(O.data),O.resultId):$._isSemanticTokensEdits(O)?$._isCorrectSemanticTokensEdits(O)?O:new P.SemanticTokensEdits(O.edits.map(V=>new P.SemanticTokensEdit(V.start,V.deleteCount,V.data?new Uint32Array(V.data):V.data)),O.resultId):O}static _isSemanticTokens(O){return O&&!!O.data}static _isCorrectSemanticTokens(O){return O.data instanceof Uint32Array}static _isSemanticTokensEdits(O){return O&&Array.isArray(O.edits)}static _isCorrectSemanticTokensEdits(O){for(const V of O.edits)if(!(V.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(O,V){if(!$._isSemanticTokens(V)||!O||!O.tokens)return V;const q=O.tokens,X=q.length,ge=V.data,we=ge.length;let ce=0;const Ce=Math.min(X,we);for(;ce<Ce&&q[ce]===ge[ce];)ce++;if(ce===X&&ce===we)return new P.SemanticTokensEdits([],V.resultId);let ye=0;const We=Ce-ce;for(;ye<We&&q[X-ye-1]===ge[we-ye-1];)ye++;return new P.SemanticTokensEdits([{start:ce,deleteCount:X-ce-ye,data:ge.subarray(ce,we-ye)}],V.resultId)}_send(O,V){if($._isSemanticTokens(O)){const q=this._nextResultId++;return this._previousResults.set(q,new x(O.resultId,O.data)),(0,p.encodeSemanticTokensDto)({id:q,type:"full",data:O.data})}if($._isSemanticTokensEdits(O)){const q=this._nextResultId++;return $._isSemanticTokens(V)?this._previousResults.set(q,new x(V.resultId,V.data)):this._previousResults.set(q,new x(O.resultId)),(0,p.encodeSemanticTokensDto)({id:q,type:"delta",deltas:(O.edits||[]).map(X=>({start:X.start,deleteCount:X.deleteCount,data:X.data}))})}return null}}e.DocumentSemanticTokensAdapter=$;class Q{constructor(O,V){this._documents=O,this._provider=V}async provideDocumentRangeSemanticTokens(O,V,q){const X=this._documents.getDocument(O),ge=await this._provider.provideDocumentRangeSemanticTokens(X,C.Range.to(V),q);return ge?this._send(ge):null}_send(O){return(0,p.encodeSemanticTokensDto)({id:0,type:"full",data:O.data})}}e.DocumentRangeSemanticTokensAdapter=Q;class K{static supportsResolving(O){return typeof O.resolveCompletionItem=="function"}constructor(O,V,q,X,ge){this._documents=O,this._commands=V,this._provider=q,this._apiDeprecation=X,this._extension=ge,this._cache=new m.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(O,V,q,X){const ge=this._documents.getDocument(O),we=C.Position.to(V),ce=ge.getWordRangeAtPosition(we)||new P.Range(we,we),Ce=ce.with({end:we}),ye=new v.StopWatch(!0),We=await this._provider.provideCompletionItems(ge,we,X,C.CompletionContext.to(q));if(!We||X.isCancellationRequested)return;const qe=Array.isArray(We)?new P.CompletionList(We):We,Ze=K.supportsResolving(this._provider)?this._cache.add(qe.items):this._cache.add([]),Ye=new E.DisposableStore;this._disposables.set(Ze,Ye);const Oe=[],ot={x:Ze,b:Oe,a:{replace:C.Range.from(ce),insert:C.Range.from(Ce)},c:qe.isIncomplete||void 0,d:ye.elapsed()};for(let re=0;re<qe.items.length;re++){const se=qe.items[re],Ee=this._convertCompletionItem(se,[Ze,re],Ce,ce);Oe.push(Ee)}return ot}async resolveCompletionItem(O,V){if(typeof this._provider.resolveCompletionItem!="function")return;const q=this._cache.get(...O);if(!q)return;const X=await this._provider.resolveCompletionItem(q,V);if(!!X)return this._convertCompletionItem(X,O)}releaseCompletionItems(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}_convertCompletionItem(O,V,q,X){const ge=this._disposables.get(V[0]);if(!ge)throw Error("DisposableStore is missing...");const we={x:V,a:O.label,b:O.kind!==void 0?C.CompletionItemKind.from(O.kind):void 0,n:O.tags&&O.tags.map(C.CompletionItemTag.from),c:O.detail,d:typeof O.documentation>"u"?void 0:C.MarkdownString.fromStrict(O.documentation),e:O.sortText!==O.label?O.sortText:void 0,f:O.filterText!==O.label?O.filterText:void 0,g:O.preselect||void 0,i:O.keepWhitespace?1:0,k:O.commitCharacters,l:O.additionalTextEdits&&O.additionalTextEdits.map(C.TextEdit.from),m:this._commands.toInternal(O.command,ge)};O.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),we.h=O.textEdit.newText):typeof O.insertText=="string"?we.h=O.insertText:O.insertText instanceof P.SnippetString&&(we.h=O.insertText.value,we.i|=4);let ce;return O.textEdit?ce=O.textEdit.range:O.range&&(ce=O.range),P.Range.isRange(ce)?we.j=C.Range.from(ce):ce&&(!q?.isEqual(ce.inserting)||!X?.isEqual(ce.replacing))&&(we.j={insert:C.Range.from(ce.inserting),replace:C.Range.from(ce.replacing)}),we}}class de{async provideInlineCompletions(O,V,q,X){}disposeCompletions(O){}handleDidShowCompletionItem(O,V){}}class te extends de{constructor(O,V,q,X){super(),this._extension=O,this._documents=V,this._provider=q,this._commands=X,this._references=new Y,this._isAdditionsProposedApiEnabled=(0,g.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[_.InlineCompletionTriggerKind.Automatic]:P.InlineCompletionTriggerKind.Automatic,[_.InlineCompletionTriggerKind.Explicit]:P.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,g.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&typeof this._provider.handleDidShowCompletionItem=="function"}async provideInlineCompletions(O,V,q,X){const ge=this._documents.getDocument(O),we=C.Position.to(V),ce=await this._provider.provideInlineCompletionItems(ge,we,{selectedCompletionInfo:q.selectedSuggestionInfo?{range:C.Range.to(q.selectedSuggestionInfo.range),text:q.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[q.triggerKind]},X);if(!ce||X.isCancellationRequested)return;const Ce=Array.isArray(ce)?ce:ce.items,ye=this._isAdditionsProposedApiEnabled?Array.isArray(ce)?[]:ce.commands||[]:[];let We;return{pid:this._references.createReferenceId({dispose(){We?.dispose()},items:Ce}),items:Ce.map((Ze,Ye)=>{let Oe;Ze.command&&(We||(We=new E.DisposableStore),Oe=this._commands.toInternal(Ze.command,We));const ot=Ze.insertText;return{insertText:typeof ot=="string"?ot:{snippet:ot.value},filterText:Ze.filterText,range:Ze.range?C.Range.from(Ze.range):void 0,command:Oe,idx:Ye,completeBracketPairs:this._isAdditionsProposedApiEnabled?Ze.completeBracketPairs:!1}}),commands:ye.map(Ze=>(We||(We=new E.DisposableStore),this._commands.toInternal(Ze,We)))}}disposeCompletions(O){this._references.disposeReferenceId(O)?.dispose()}handleDidShowCompletionItem(O,V){const q=this._references.get(O)?.items[V];q&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(q)}}class he extends de{constructor(O,V,q,X){super(),this.extension=O,this._documents=V,this._provider=q,this._commands=X,this._references=new Y,this.isAdditionProposedApiEnabled=(0,g.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[_.InlineCompletionTriggerKind.Automatic]:P.InlineCompletionTriggerKindNew.Automatic,[_.InlineCompletionTriggerKind.Explicit]:P.InlineCompletionTriggerKindNew.Invoke}}async provideInlineCompletions(O,V,q,X){const ge=this._documents.getDocument(O),we=C.Position.to(V),ce=await this._provider.provideInlineCompletionItems(ge,we,{selectedCompletionInfo:q.selectedSuggestionInfo?{range:C.Range.to(q.selectedSuggestionInfo.range),text:q.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[q.triggerKind]},X);if(!ce||X.isCancellationRequested)return;const Ce=Array.isArray(ce)?ce:ce.items,ye=Array.isArray(ce)?[]:ce.commands||[];let We;return{pid:this._references.createReferenceId({dispose(){We?.dispose()},items:Ce}),items:Ce.map((Ze,Ye)=>{let Oe;Ze.command&&(We||(We=new E.DisposableStore),Oe=this._commands.toInternal(Ze.command,We));const ot=Ze.insertText;return{insertText:typeof ot=="string"?ot:{snippet:ot.value},filterText:Ze.filterText,range:Ze.range?C.Range.from(Ze.range):void 0,command:Oe,idx:Ye,completeBracketPairs:this.isAdditionProposedApiEnabled?Ze.completeBracketPairs:!1}}),commands:ye.map(Ze=>(We||(We=new E.DisposableStore),this._commands.toInternal(Ze,We)))}}disposeCompletions(O){this._references.disposeReferenceId(O)?.dispose()}handleDidShowCompletionItem(O,V){const q=this._references.get(O)?.items[V];q&&this._provider.handleDidShowCompletionItem&&this.isAdditionProposedApiEnabled&&this._provider.handleDidShowCompletionItem(q)}}class Y{constructor(){this._references=new Map,this._idPool=1}createReferenceId(O){const V=this._idPool++;return this._references.set(V,O),V}disposeReferenceId(O){const V=this._references.get(O);return this._references.delete(O),V}get(O){return this._references.get(O)}}class ve{constructor(O,V){this._documents=O,this._provider=V,this._cache=new m.Cache("SignatureHelp")}async provideSignatureHelp(O,V,q,X){const ge=this._documents.getDocument(O),we=C.Position.to(V),ce=this.reviveContext(q),Ce=await this._provider.provideSignatureHelp(ge,we,X,ce);if(Ce){const ye=this._cache.add([Ce]);return{...C.SignatureHelp.from(Ce),id:ye}}}reviveContext(O){let V;if(O.activeSignatureHelp){const q=C.SignatureHelp.to(O.activeSignatureHelp),X=this._cache.get(O.activeSignatureHelp.id,0);X?(V=X,V.activeSignature=q.activeSignature,V.activeParameter=q.activeParameter):V=q}return{...O,activeSignatureHelp:V}}releaseSignatureHelp(O){this._cache.delete(O)}}class be{constructor(O,V,q,X,ge){this._documents=O,this._commands=V,this._provider=q,this._logService=X,this._extension=ge,this._cache=new m.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(O,V,q){const X=this._documents.getDocument(O),ge=C.Range.to(V),we=await this._provider.provideInlayHints(X,ge,q);if(!Array.isArray(we)||we.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${V}`);return}if(q.isCancellationRequested)return;const ce=this._cache.add(we);this._disposables.set(ce,new E.DisposableStore);const Ce={hints:[],cacheId:ce};for(let ye=0;ye<we.length;ye++)this._isValidInlayHint(we[ye],ge)&&Ce.hints.push(this._convertInlayHint(we[ye],[ce,ye]));return this._logService.trace(`[InlayHints] ${Ce.hints.length} inlay hints from '${this._extension.identifier.value}' for ${V}`),Ce}async resolveInlayHint(O,V){if(typeof this._provider.resolveInlayHint!="function")return;const q=this._cache.get(...O);if(!q)return;const X=await this._provider.resolveInlayHint(q,V);if(!!X&&!!this._isValidInlayHint(X))return this._convertInlayHint(X,O)}releaseHints(O){this._disposables.get(O)?.dispose(),this._disposables.delete(O),this._cache.delete(O)}_isValidInlayHint(O,V){return O.label.length===0||Array.isArray(O.label)&&O.label.every(q=>q.value.length===0)?(console.log("INVALID inlay hint, empty label",O),!1):!(V&&!V.contains(O.position))}_convertInlayHint(O,V){const q=this._disposables.get(V[0]);if(!q)throw Error("DisposableStore is missing...");const X={label:"",cacheId:V,tooltip:C.MarkdownString.fromStrict(O.tooltip),position:C.Position.from(O.position),textEdits:O.textEdits&&O.textEdits.map(C.TextEdit.from),kind:O.kind&&C.InlayHintKind.from(O.kind),paddingLeft:O.paddingLeft,paddingRight:O.paddingRight};return typeof O.label=="string"?X.label=O.label:X.label=O.label.map(ge=>{const we={label:ge.value};return we.tooltip=C.MarkdownString.fromStrict(ge.tooltip),P.Location.isLocation(ge.location)&&(we.location=C.location.from(ge.location)),ge.command&&(we.command=this._commands.toInternal(ge.command,q)),we}),X}}class ke{constructor(O,V){this._documents=O,this._provider=V,this._cache=new m.Cache("DocumentLink")}async provideLinks(O,V){const q=this._documents.getDocument(O),X=await this._provider.provideDocumentLinks(q,V);if(!(!Array.isArray(X)||X.length===0)&&!V.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:X.filter(ke._validateLink).map(C.DocumentLink.from)};{const ge=this._cache.add(X),we={links:[],cacheId:ge};for(let ce=0;ce<X.length;ce++){if(!ke._validateLink(X[ce]))continue;const Ce=C.DocumentLink.from(X[ce]);Ce.cacheId=[ge,ce],we.links.push(Ce)}return we}}}static _validateLink(O){return O.target&&O.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(O,V){if(typeof this._provider.resolveDocumentLink!="function")return;const q=this._cache.get(...O);if(!q)return;const X=await this._provider.resolveDocumentLink(q,V);if(!(!X||!ke._validateLink(X)))return C.DocumentLink.from(X)}releaseLinks(O){this._cache.delete(O)}}class Re{constructor(O,V){this._documents=O,this._provider=V}async provideColors(O,V){const q=this._documents.getDocument(O),X=await this._provider.provideDocumentColors(q,V);return Array.isArray(X)?X.map(we=>({color:C.Color.from(we.color),range:C.Range.from(we.range)})):[]}async provideColorPresentations(O,V,q){const X=this._documents.getDocument(O),ge=C.Range.to(V.range),we=C.Color.to(V.color),ce=await this._provider.provideColorPresentations(we,{document:X,range:ge},q);if(!!Array.isArray(ce))return ce.map(C.ColorPresentation.from)}}class ze{constructor(O,V){this._documents=O,this._provider=V}async provideFoldingRanges(O,V,q){const X=this._documents.getDocument(O),ge=await this._provider.provideFoldingRanges(X,V,q);if(!!Array.isArray(ge))return ge.map(C.FoldingRange.from)}}class oe{constructor(O,V,q){this._documents=O,this._provider=V,this._logService=q}async provideSelectionRanges(O,V,q){const X=this._documents.getDocument(O),ge=V.map(C.Position.to),we=await this._provider.provideSelectionRanges(X,ge,q);if(!(0,L.isNonEmptyArray)(we))return[];if(we.length!==ge.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ce=[];for(let Ce=0;Ce<ge.length;Ce++){const ye=[];ce.push(ye);let We=ge[Ce],qe=we[Ce];for(;;){if(!qe.range.contains(We))throw new Error("INVALID selection range, must contain the previous range");if(ye.push(C.SelectionRange.from(qe)),!qe.parent)break;We=qe.range,qe=qe.parent}}return ce}}class le{constructor(O,V){this._documents=O,this._provider=V,this._idPool=new b.IdGenerator(""),this._cache=new Map}async prepareSession(O,V,q){const X=this._documents.getDocument(O),ge=C.Position.to(V),we=await this._provider.prepareCallHierarchy(X,ge,q);if(!we)return;const ce=this._idPool.nextId();return this._cache.set(ce,new Map),Array.isArray(we)?we.map(Ce=>this._cacheAndConvertItem(ce,Ce)):[this._cacheAndConvertItem(ce,we)]}async provideCallsTo(O,V,q){const X=this._itemFromCache(O,V);if(!X)throw new Error("missing call hierarchy item");const ge=await this._provider.provideCallHierarchyIncomingCalls(X,q);if(!!ge)return ge.map(we=>({from:this._cacheAndConvertItem(O,we.from),fromRanges:we.fromRanges.map(ce=>C.Range.from(ce))}))}async provideCallsFrom(O,V,q){const X=this._itemFromCache(O,V);if(!X)throw new Error("missing call hierarchy item");const ge=await this._provider.provideCallHierarchyOutgoingCalls(X,q);if(!!ge)return ge.map(we=>({to:this._cacheAndConvertItem(O,we.to),fromRanges:we.fromRanges.map(ce=>C.Range.from(ce))}))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,V){const q=this._cache.get(O),X=C.CallHierarchyItem.from(V,O,q.size.toString(36));return q.set(X._itemId,V),X}_itemFromCache(O,V){return this._cache.get(O)?.get(V)}}class me{constructor(O,V){this._documents=O,this._provider=V,this._idPool=new b.IdGenerator(""),this._cache=new Map}async prepareSession(O,V,q){const X=this._documents.getDocument(O),ge=C.Position.to(V),we=await this._provider.prepareTypeHierarchy(X,ge,q);if(!we)return;const ce=this._idPool.nextId();return this._cache.set(ce,new Map),Array.isArray(we)?we.map(Ce=>this._cacheAndConvertItem(ce,Ce)):[this._cacheAndConvertItem(ce,we)]}async provideSupertypes(O,V,q){const X=this._itemFromCache(O,V);if(!X)throw new Error("missing type hierarchy item");const ge=await this._provider.provideTypeHierarchySupertypes(X,q);if(!!ge)return ge.map(we=>this._cacheAndConvertItem(O,we))}async provideSubtypes(O,V,q){const X=this._itemFromCache(O,V);if(!X)throw new Error("missing type hierarchy item");const ge=await this._provider.provideTypeHierarchySubtypes(X,q);if(!!ge)return ge.map(we=>this._cacheAndConvertItem(O,we))}releaseSession(O){this._cache.delete(O)}_cacheAndConvertItem(O,V){const q=this._cache.get(O),X=C.TypeHierarchyItem.from(V,O,q.size.toString(36));return q.set(X._itemId,V),X}_itemFromCache(O,V){return this._cache.get(O)?.get(V)}}class Z{constructor(O,V,q,X){this._proxy=O,this._documents=V,this._provider=q,this._handle=X}async provideDocumentOnDropEdits(O,V,q,X,ge){const we=this._documents.getDocument(V),ce=C.Position.to(q),Ce=C.DataTransfer.toDataTransfer(X,async We=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,O,We)).buffer),ye=await this._provider.provideDocumentDropEdits(we,ce,Ce,ge);if(!!ye)return{insertText:typeof ye.insertText=="string"?ye.insertText:{snippet:ye.insertText.value},additionalEdit:ye.additionalEdit?C.WorkspaceEdit.from(ye.additionalEdit,void 0):void 0}}}class ae{constructor(O,V){this.adapter=O,this.extension=V}}class ne{constructor(O,V,q,X,ge,we,ce){this._adapter=new Map,this._uriTransformer=V,this._proxy=O.getProxy(I.MainContext.MainThreadLanguageFeatures),this._documents=q,this._commands=X,this._diagnostics=ge,this._logService=we,this._apiDeprecation=ce}_transformDocumentSelector(O){return C.DocumentSelector.from(O,this._uriTransformer)}_createDisposable(O){return new P.Disposable(()=>{this._adapter.delete(O),this._proxy.$unregister(O)})}_nextHandle(){return ne._handlePool++}async _withAdapter(O,V,q,X,ge,we=!1){const ce=this._adapter.get(O);if(!ce||!(ce.adapter instanceof V))return X;const Ce=Date.now();we||this._logService.trace(`[${ce.extension.identifier.value}] INVOKE provider '${q.toString().replace(/[\r\n]/g,"")}'`);const ye=q(ce.adapter,ce.extension);return Promise.resolve(ye).catch(We=>{(0,h.isCancellationError)(We)||(this._logService.error(`[${ce.extension.identifier.value}] provider FAILED`),this._logService.error(We))}).finally(()=>{we||this._logService.trace(`[${ce.extension.identifier.value}] provider DONE after ${Date.now()-Ce}ms`)}),T.CancellationToken.isCancellationToken(ge)?(0,c.raceCancellationError)(ye,ge):ye}_addNewAdapter(O,V){const q=this._nextHandle();return this._adapter.set(q,new ae(O,V)),q}static _extLabel(O){return O.displayName||O.name}registerDocumentSymbolProvider(O,V,q,X){const ge=this._addNewAdapter(new n(this._documents,q),O),we=X&&X.label||ne._extLabel(O);return this._proxy.$registerDocumentSymbolProvider(ge,this._transformDocumentSelector(V),we),this._createDisposable(ge)}$provideDocumentSymbols(O,V,q){return this._withAdapter(O,n,X=>X.provideDocumentSymbols(l.URI.revive(V),q),void 0,q)}registerCodeLensProvider(O,V,q){const X=this._nextHandle(),ge=typeof q.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(X,new ae(new u(this._documents,this._commands.converter,q),O)),this._proxy.$registerCodeLensSupport(X,this._transformDocumentSelector(V),ge);let we=this._createDisposable(X);if(ge!==void 0){const ce=q.onDidChangeCodeLenses(Ce=>this._proxy.$emitCodeLensEvent(ge));we=P.Disposable.from(we,ce)}return we}$provideCodeLenses(O,V,q){return this._withAdapter(O,u,X=>X.provideCodeLenses(l.URI.revive(V),q),void 0,q)}$resolveCodeLens(O,V,q){return this._withAdapter(O,u,X=>X.resolveCodeLens(V,q),void 0,void 0)}$releaseCodeLenses(O,V){this._withAdapter(O,u,q=>Promise.resolve(q.releaseCodeLenses(V)),void 0,void 0)}registerDefinitionProvider(O,V,q){const X=this._addNewAdapter(new i(this._documents,q),O);return this._proxy.$registerDefinitionSupport(X,this._transformDocumentSelector(V)),this._createDisposable(X)}$provideDefinition(O,V,q,X){return this._withAdapter(O,i,ge=>ge.provideDefinition(l.URI.revive(V),q,X),[],X)}registerDeclarationProvider(O,V,q){const X=this._addNewAdapter(new o(this._documents,q),O);return this._proxy.$registerDeclarationSupport(X,this._transformDocumentSelector(V)),this._createDisposable(X)}$provideDeclaration(O,V,q,X){return this._withAdapter(O,o,ge=>ge.provideDeclaration(l.URI.revive(V),q,X),[],X)}registerImplementationProvider(O,V,q){const X=this._addNewAdapter(new d(this._documents,q),O);return this._proxy.$registerImplementationSupport(X,this._transformDocumentSelector(V)),this._createDisposable(X)}$provideImplementation(O,V,q,X){return this._withAdapter(O,d,ge=>ge.provideImplementation(l.URI.revive(V),q,X),[],X)}registerTypeDefinitionProvider(O,V,q){const X=this._addNewAdapter(new r(this._documents,q),O);return this._proxy.$registerTypeDefinitionSupport(X,this._transformDocumentSelector(V)),this._createDisposable(X)}$provideTypeDefinition(O,V,q,X){return this._withAdapter(O,r,ge=>ge.provideTypeDefinition(l.URI.revive(V),q,X),[],X)}registerHoverProvider(O,V,q,X){const ge=this._addNewAdapter(new a(this._documents,q),O);return this._proxy.$registerHoverProvider(ge,this._transformDocumentSelector(V)),this._createDisposable(ge)}$provideHover(O,V,q,X){return this._withAdapter(O,a,ge=>ge.provideHover(l.URI.revive(V),q,X),void 0,X)}registerEvaluatableExpressionProvider(O,V,q,X){const ge=this._addNewAdapter(new f(this._documents,q),O);return this._proxy.$registerEvaluatableExpressionProvider(ge,this._transformDocumentSelector(V)),this._createDisposable(ge)}$provideEvaluatableExpression(O,V,q,X){return this._withAdapter(O,f,ge=>ge.provideEvaluatableExpression(l.URI.revive(V),q,X),void 0,X)}registerInlineValuesProvider(O,V,q,X){const ge=typeof q.onDidChangeInlineValues=="function"?this._nextHandle():void 0,we=this._addNewAdapter(new y(this._documents,q),O);this._proxy.$registerInlineValuesProvider(we,this._transformDocumentSelector(V),ge);let ce=this._createDisposable(we);if(ge!==void 0){const Ce=q.onDidChangeInlineValues(ye=>this._proxy.$emitInlineValuesEvent(ge));ce=P.Disposable.from(ce,Ce)}return ce}$provideInlineValues(O,V,q,X,ge){return this._withAdapter(O,y,we=>we.provideInlineValues(l.URI.revive(V),q,X,ge),void 0,ge)}registerDocumentHighlightProvider(O,V,q){const X=this._addNewAdapter(new R(this._documents,q),O);return this._proxy.$registerDocumentHighlightProvider(X,this._transformDocumentSelector(V)),this._createDisposable(X)}$provideDocumentHighlights(O,V,q,X){return this._withAdapter(O,R,ge=>ge.provideDocumentHighlights(l.URI.revive(V),q,X),void 0,X)}registerLinkedEditingRangeProvider(O,V,q){const X=this._addNewAdapter(new N(this._documents,q),O);return this._proxy.$registerLinkedEditingRangeProvider(X,this._transformDocumentSelector(V)),this._createDisposable(X)}$provideLinkedEditingRanges(O,V,q,X){return this._withAdapter(O,N,async ge=>{const we=await ge.provideLinkedEditingRanges(l.URI.revive(V),q,X);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?ne._serializeRegExp(we.wordPattern):void 0}},void 0,X)}registerReferenceProvider(O,V,q){const X=this._addNewAdapter(new M(this._documents,q),O);return this._proxy.$registerReferenceSupport(X,this._transformDocumentSelector(V)),this._createDisposable(X)}$provideReferences(O,V,q,X,ge){return this._withAdapter(O,M,we=>we.provideReferences(l.URI.revive(V),q,X,ge),void 0,ge)}registerCodeActionProvider(O,V,q,X){const ge=new E.DisposableStore,we=this._addNewAdapter(new A(this._documents,this._commands.converter,this._diagnostics,q,this._logService,O,this._apiDeprecation),O);return this._proxy.$registerQuickFixSupport(we,this._transformDocumentSelector(V),{providedKinds:X?.providedCodeActionKinds?.map(ce=>ce.value),documentation:X?.documentation?.map(ce=>({kind:ce.kind.value,command:this._commands.converter.toInternal(ce.command,ge)}))},ne._extLabel(O),Boolean(q.resolveCodeAction)),ge.add(this._createDisposable(we)),ge}$provideCodeActions(O,V,q,X,ge){return this._withAdapter(O,A,we=>we.provideCodeActions(l.URI.revive(V),q,X,ge),void 0,ge)}$resolveCodeAction(O,V,q){return this._withAdapter(O,A,X=>X.resolveCodeAction(V,q),void 0,void 0)}$releaseCodeActions(O,V){this._withAdapter(O,A,q=>Promise.resolve(q.releaseCodeActions(V)),void 0,void 0)}registerDocumentFormattingEditProvider(O,V,q){const X=this._addNewAdapter(new H(this._documents,q),O);return this._proxy.$registerDocumentFormattingSupport(X,this._transformDocumentSelector(V),O.identifier,O.displayName||O.name),this._createDisposable(X)}$provideDocumentFormattingEdits(O,V,q,X){return this._withAdapter(O,H,ge=>ge.provideDocumentFormattingEdits(l.URI.revive(V),q,X),void 0,X)}registerDocumentRangeFormattingEditProvider(O,V,q){const X=this._addNewAdapter(new F(this._documents,q),O);return this._proxy.$registerRangeFormattingSupport(X,this._transformDocumentSelector(V),O.identifier,O.displayName||O.name),this._createDisposable(X)}$provideDocumentRangeFormattingEdits(O,V,q,X,ge){return this._withAdapter(O,F,we=>we.provideDocumentRangeFormattingEdits(l.URI.revive(V),q,X,ge),void 0,ge)}registerOnTypeFormattingEditProvider(O,V,q,X){const ge=this._addNewAdapter(new G(this._documents,q),O);return this._proxy.$registerOnTypeFormattingSupport(ge,this._transformDocumentSelector(V),X,O.identifier),this._createDisposable(ge)}$provideOnTypeFormattingEdits(O,V,q,X,ge,we){return this._withAdapter(O,G,ce=>ce.provideOnTypeFormattingEdits(l.URI.revive(V),q,X,ge,we),void 0,we)}registerWorkspaceSymbolProvider(O,V){const q=this._addNewAdapter(new B(V,this._logService),O);return this._proxy.$registerNavigateTypeSupport(q,typeof V.resolveWorkspaceSymbol=="function"),this._createDisposable(q)}$provideWorkspaceSymbols(O,V,q){return this._withAdapter(O,B,X=>X.provideWorkspaceSymbols(V,q),{symbols:[]},q)}$resolveWorkspaceSymbol(O,V,q){return this._withAdapter(O,B,X=>X.resolveWorkspaceSymbol(V,q),void 0,void 0)}$releaseWorkspaceSymbols(O,V){this._withAdapter(O,B,q=>q.releaseWorkspaceSymbols(V),void 0,void 0)}registerRenameProvider(O,V,q){const X=this._addNewAdapter(new U(this._documents,q,this._logService),O);return this._proxy.$registerRenameSupport(X,this._transformDocumentSelector(V),U.supportsResolving(q)),this._createDisposable(X)}$provideRenameEdits(O,V,q,X,ge){return this._withAdapter(O,U,we=>we.provideRenameEdits(l.URI.revive(V),q,X,ge),void 0,ge)}$resolveRenameLocation(O,V,q,X){return this._withAdapter(O,U,ge=>ge.resolveRenameLocation(l.URI.revive(V),q,X),void 0,X)}registerDocumentSemanticTokensProvider(O,V,q,X){const ge=this._addNewAdapter(new $(this._documents,q),O),we=typeof q.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(ge,this._transformDocumentSelector(V),X,we);let ce=this._createDisposable(ge);if(we){const Ce=q.onDidChangeSemanticTokens(ye=>this._proxy.$emitDocumentSemanticTokensEvent(we));ce=P.Disposable.from(ce,Ce)}return ce}$provideDocumentSemanticTokens(O,V,q,X){return this._withAdapter(O,$,ge=>ge.provideDocumentSemanticTokens(l.URI.revive(V),q,X),null,X)}$releaseDocumentSemanticTokens(O,V){this._withAdapter(O,$,q=>q.releaseDocumentSemanticColoring(V),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(O,V,q,X){const ge=this._addNewAdapter(new Q(this._documents,q),O);return this._proxy.$registerDocumentRangeSemanticTokensProvider(ge,this._transformDocumentSelector(V),X),this._createDisposable(ge)}$provideDocumentRangeSemanticTokens(O,V,q,X){return this._withAdapter(O,Q,ge=>ge.provideDocumentRangeSemanticTokens(l.URI.revive(V),q,X),null,X)}registerCompletionItemProvider(O,V,q,X){const ge=this._addNewAdapter(new K(this._documents,this._commands.converter,q,this._apiDeprecation,O),O);return this._proxy.$registerCompletionsProvider(ge,this._transformDocumentSelector(V),X,K.supportsResolving(q),`${O.identifier.value}(${X.join("")})`),this._createDisposable(ge)}$provideCompletionItems(O,V,q,X,ge){return this._withAdapter(O,K,we=>we.provideCompletionItems(l.URI.revive(V),q,X,ge),void 0,ge)}$resolveCompletionItem(O,V,q){return this._withAdapter(O,K,X=>X.resolveCompletionItem(V,q),void 0,q)}$releaseCompletionItems(O,V){this._withAdapter(O,K,q=>q.releaseCompletionItems(V),void 0,void 0)}registerInlineCompletionsProvider(O,V,q){const X=new te(O,this._documents,q,this._commands.converter),ge=this._addNewAdapter(X,O);return this._proxy.$registerInlineCompletionsSupport(ge,this._transformDocumentSelector(V),X.supportsHandleDidShowCompletionItem),this._createDisposable(ge)}registerInlineCompletionsProviderNew(O,V,q){const X=this._addNewAdapter(new he(O,this._documents,q,this._commands.converter),O);return this._proxy.$registerInlineCompletionsSupport(X,this._transformDocumentSelector(V),!0),this._createDisposable(X)}$provideInlineCompletions(O,V,q,X,ge){return this._withAdapter(O,de,we=>we.provideInlineCompletions(l.URI.revive(V),q,X,ge),void 0,ge)}$handleInlineCompletionDidShow(O,V,q){this._withAdapter(O,de,async X=>{X.handleDidShowCompletionItem(V,q)},void 0,void 0)}$freeInlineCompletionsList(O,V){this._withAdapter(O,de,async q=>{q.disposeCompletions(V)},void 0,void 0)}registerSignatureHelpProvider(O,V,q,X){const ge=Array.isArray(X)?{triggerCharacters:X,retriggerCharacters:[]}:X,we=this._addNewAdapter(new ve(this._documents,q),O);return this._proxy.$registerSignatureHelpProvider(we,this._transformDocumentSelector(V),ge),this._createDisposable(we)}$provideSignatureHelp(O,V,q,X,ge){return this._withAdapter(O,ve,we=>we.provideSignatureHelp(l.URI.revive(V),q,X,ge),void 0,ge)}$releaseSignatureHelp(O,V){this._withAdapter(O,ve,q=>q.releaseSignatureHelp(V),void 0,void 0)}registerInlayHintsProvider(O,V,q){const X=typeof q.onDidChangeInlayHints=="function"?this._nextHandle():void 0,ge=this._addNewAdapter(new be(this._documents,this._commands.converter,q,this._logService,O),O);this._proxy.$registerInlayHintsProvider(ge,this._transformDocumentSelector(V),typeof q.resolveInlayHint=="function",X,ne._extLabel(O));let we=this._createDisposable(ge);if(X!==void 0){const ce=q.onDidChangeInlayHints(Ce=>this._proxy.$emitInlayHintsEvent(X));we=P.Disposable.from(we,ce)}return we}$provideInlayHints(O,V,q,X){return this._withAdapter(O,be,ge=>ge.provideInlayHints(l.URI.revive(V),q,X),void 0,X)}$resolveInlayHint(O,V,q){return this._withAdapter(O,be,X=>X.resolveInlayHint(V,q),void 0,q)}$releaseInlayHints(O,V){this._withAdapter(O,be,q=>q.releaseHints(V),void 0,void 0)}registerDocumentLinkProvider(O,V,q){const X=this._addNewAdapter(new ke(this._documents,q),O);return this._proxy.$registerDocumentLinkProvider(X,this._transformDocumentSelector(V),typeof q.resolveDocumentLink=="function"),this._createDisposable(X)}$provideDocumentLinks(O,V,q){return this._withAdapter(O,ke,X=>X.provideLinks(l.URI.revive(V),q),void 0,q,V.scheme==="output")}$resolveDocumentLink(O,V,q){return this._withAdapter(O,ke,X=>X.resolveLink(V,q),void 0,void 0,!0)}$releaseDocumentLinks(O,V){this._withAdapter(O,ke,q=>q.releaseLinks(V),void 0,void 0,!0)}registerColorProvider(O,V,q){const X=this._addNewAdapter(new Re(this._documents,q),O);return this._proxy.$registerDocumentColorProvider(X,this._transformDocumentSelector(V)),this._createDisposable(X)}$provideDocumentColors(O,V,q){return this._withAdapter(O,Re,X=>X.provideColors(l.URI.revive(V),q),[],q)}$provideColorPresentations(O,V,q,X){return this._withAdapter(O,Re,ge=>ge.provideColorPresentations(l.URI.revive(V),q,X),void 0,X)}registerFoldingRangeProvider(O,V,q){const X=this._nextHandle(),ge=typeof q.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(X,new ae(new ze(this._documents,q),O)),this._proxy.$registerFoldingRangeProvider(X,this._transformDocumentSelector(V),ge);let we=this._createDisposable(X);if(ge!==void 0){const ce=q.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(ge));we=P.Disposable.from(we,ce)}return we}$provideFoldingRanges(O,V,q,X){return this._withAdapter(O,ze,ge=>ge.provideFoldingRanges(l.URI.revive(V),q,X),void 0,X)}registerSelectionRangeProvider(O,V,q){const X=this._addNewAdapter(new oe(this._documents,q,this._logService),O);return this._proxy.$registerSelectionRangeProvider(X,this._transformDocumentSelector(V)),this._createDisposable(X)}$provideSelectionRanges(O,V,q,X){return this._withAdapter(O,oe,ge=>ge.provideSelectionRanges(l.URI.revive(V),q,X),[],X)}registerCallHierarchyProvider(O,V,q){const X=this._addNewAdapter(new le(this._documents,q),O);return this._proxy.$registerCallHierarchyProvider(X,this._transformDocumentSelector(V)),this._createDisposable(X)}$prepareCallHierarchy(O,V,q,X){return this._withAdapter(O,le,ge=>Promise.resolve(ge.prepareSession(l.URI.revive(V),q,X)),void 0,X)}$provideCallHierarchyIncomingCalls(O,V,q,X){return this._withAdapter(O,le,ge=>ge.provideCallsTo(V,q,X),void 0,X)}$provideCallHierarchyOutgoingCalls(O,V,q,X){return this._withAdapter(O,le,ge=>ge.provideCallsFrom(V,q,X),void 0,X)}$releaseCallHierarchy(O,V){this._withAdapter(O,le,q=>Promise.resolve(q.releaseSession(V)),void 0,void 0)}registerTypeHierarchyProvider(O,V,q){const X=this._addNewAdapter(new me(this._documents,q),O);return this._proxy.$registerTypeHierarchyProvider(X,this._transformDocumentSelector(V)),this._createDisposable(X)}$prepareTypeHierarchy(O,V,q,X){return this._withAdapter(O,me,ge=>Promise.resolve(ge.prepareSession(l.URI.revive(V),q,X)),void 0,X)}$provideTypeHierarchySupertypes(O,V,q,X){return this._withAdapter(O,me,ge=>ge.provideSupertypes(V,q,X),void 0,X)}$provideTypeHierarchySubtypes(O,V,q,X){return this._withAdapter(O,me,ge=>ge.provideSubtypes(V,q,X),void 0,X)}$releaseTypeHierarchy(O,V){this._withAdapter(O,me,q=>Promise.resolve(q.releaseSession(V)),void 0,void 0)}registerDocumentOnDropEditProvider(O,V,q){const X=this._nextHandle();return this._adapter.set(X,new ae(new Z(this._proxy,this._documents,q,X),O)),this._proxy.$registerDocumentOnDropEditProvider(X,this._transformDocumentSelector(V)),this._createDisposable(X)}$provideDocumentOnDropEdits(O,V,q,X,ge,we){return this._withAdapter(O,Z,ce=>Promise.resolve(ce.provideDocumentOnDropEdits(V,l.URI.revive(q),X,ge,we)),void 0,void 0)}registerDocumentPasteEditProvider(O,V,q,X){const ge=this._nextHandle();return this._adapter.set(ge,new ae(new z(this._proxy,this._documents,q,ge),O)),this._proxy.$registerPasteEditProvider(ge,this._transformDocumentSelector(V),!!q.prepareDocumentPaste,X.pasteMimeTypes),this._createDisposable(ge)}$prepareDocumentPaste(O,V,q,X,ge){return this._withAdapter(O,z,we=>we.prepareDocumentPaste(l.URI.revive(V),q,X,ge),void 0,ge)}$providePasteEdits(O,V,q,X,ge,we){return this._withAdapter(O,z,ce=>ce.providePasteEdits(V,l.URI.revive(q),X,ge,we),void 0,we)}static _serializeRegExp(O){return{pattern:O.source,flags:(0,w.regExpFlags)(O)}}static _serializeIndentationRule(O){return{decreaseIndentPattern:ne._serializeRegExp(O.decreaseIndentPattern),increaseIndentPattern:ne._serializeRegExp(O.increaseIndentPattern),indentNextLinePattern:O.indentNextLinePattern?ne._serializeRegExp(O.indentNextLinePattern):void 0,unIndentedLinePattern:O.unIndentedLinePattern?ne._serializeRegExp(O.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(O){return{beforeText:ne._serializeRegExp(O.beforeText),afterText:O.afterText?ne._serializeRegExp(O.afterText):void 0,previousLineText:O.previousLineText?ne._serializeRegExp(O.previousLineText):void 0,action:O.action}}static _serializeOnEnterRules(O){return O.map(ne._serializeOnEnterRule)}setLanguageConfiguration(O,V,q){const{wordPattern:X}=q;if(X&&(0,w.regExpLeadsToEndlessLoop)(X))throw new Error(`Invalid language configuration: wordPattern '${X}' is not allowed to match the empty string.`);X?this._documents.setWordDefinitionFor(V,X):this._documents.setWordDefinitionFor(V,void 0),q.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",O,"Do not use."),q.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",O,"Do not use.");const ge=this._nextHandle(),we={comments:q.comments,brackets:q.brackets,wordPattern:q.wordPattern?ne._serializeRegExp(q.wordPattern):void 0,indentationRules:q.indentationRules?ne._serializeIndentationRule(q.indentationRules):void 0,onEnterRules:q.onEnterRules?ne._serializeOnEnterRules(q.onEnterRules):void 0,__electricCharacterSupport:q.__electricCharacterSupport,__characterPairSupport:q.__characterPairSupport};return this._proxy.$setLanguageConfiguration(ge,V,we),this._createDisposable(ge)}$setWordDefinitions(O){for(const V of O)this._documents.setWordDefinitionFor(V.languageId,new RegExp(V.regexSource,V.regexFlags))}}e.ExtHostLanguageFeatures=ne,ne._handlePool=0}),define(De[250],Ie([1,0,5,15,7,42,18,6]),function(J,e,l,t,C,P,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class w{constructor(L,D,S,T){this._documents=D,this._commands=S,this._uriTransformer=T,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=L.getProxy(l.MainContext.MainThreadLanguages)}$acceptLanguageIds(L){this._languageIds=L}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(L,D){await this._proxy.$changeLanguage(L,D);const S=this._documents.getDocumentData(L);if(!S)throw new Error(`document '${L.toString()}' NOT found`);return S.document}async tokenAtPosition(L,D){const S=L.version,T=t.Position.from(D),E=await this._proxy.$tokensAtPosition(L.uri,T),p={type:C.StandardTokenType.Other,range:L.getWordRangeAtPosition(D)??new C.Range(D.line,D.character,D.line,D.character)};if(!E)return p;const b={range:t.Range.to(E.range),type:t.TokenType.to(E.type)};return!b.range.contains(D)||S!==L.version?p:b}createLanguageStatusItem(L,D,S){const T=this._handlePool++,E=this._proxy,p=this._ids,b=`${L.identifier.value}/${D}`;if(p.has(b))throw new Error(`LanguageStatusItem with id '${D}' ALREADY exists`);p.add(b);const m={selector:S,id:D,name:L.displayName??L.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let v;const h=new I.DisposableStore,c=()=>{v?.dispose(),v=(0,_.disposableTimeout)(()=>{h.clear(),this._proxy.$setLanguageStatus(T,{id:b,name:m.name??L.displayName??L.name,source:L.displayName??L.name,selector:t.DocumentSelector.from(m.selector,this._uriTransformer),label:m.text,detail:m.detail??"",severity:m.severity===C.LanguageStatusSeverity.Error?P.default.Error:m.severity===C.LanguageStatusSeverity.Warning?P.default.Warning:P.default.Info,command:m.command&&this._commands.toInternal(m.command,h),accessibilityInfo:m.accessibilityInformation,busy:m.busy})},0)},g={dispose(){h.dispose(),v?.dispose(),E.$removeLanguageStatus(T),p.delete(b)},get id(){return m.id},get name(){return m.name},set name(n){m.name=n,c()},get selector(){return m.selector},set selector(n){m.selector=n,c()},get text(){return m.text},set text(n){m.text=n,c()},get detail(){return m.detail},set detail(n){m.detail=n,c()},get severity(){return m.severity},set severity(n){m.severity=n,c()},get accessibilityInformation(){return m.accessibilityInformation},set accessibilityInformation(n){m.accessibilityInformation=n,c()},get command(){return m.command},set command(n){m.command=n,c()},get busy(){return m.busy},set busy(n){m.busy=n,c()}};return c(),g}}e.ExtHostLanguages=w}),define(De[90],Ie([1,0,11,8,2,3,13,5,25,14]),function(J,e,l,t,C,P,_,I,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let L=class{constructor(S,T,E){this.logService=E,this.bundleCache=new Map,this._proxy=T.getProxy(I.MainContext.MainThreadLocalization),this.currentLanguage=S.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===l.LANGUAGE_DEFAULT}getMessage(S,T){const{message:E,args:p,comment:b}=T;if(this.isDefaultLanguage)return(0,t.format2)(E,p??{});let m=E;b&&b.length>0&&(m+=`/${b.join()}`);const v=this.bundleCache.get(S)?.contents[m];return v||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${m}`),(0,t.format2)(v??m,p??{})}getBundle(S){return this.bundleCache.get(S)?.contents}getBundleUri(S){return this.bundleCache.get(S)?.uri}async initializeLocalizedMessages(S){if(this.isDefaultLanguage||!S.l10n||this.bundleCache.has(S.identifier.value))return;let T;const E=this.getBundleLocation(S);if(!E){this.logService.error(`No bundle location found for extension ${S.identifier.value}`);return}const p=C.URI.joinPath(E,`bundle.l10n.${this.currentLanguage}.json`);try{const b=await this._proxy.$fetchBundleContents(p);T=JSON.parse(b)}catch(b){this.logService.error(`Failed to load translations for ${S.identifier.value} from ${p}: ${b.message}`);return}T&&this.bundleCache.set(S.identifier.value,{contents:T,uri:p})}getBundleLocation(S){return S.l10n?C.URI.joinPath(S.extensionLocation,S.l10n):void 0}};L=je([$e(0,w.IExtHostInitDataService),$e(1,k.IExtHostRpcService),$e(2,_.ILogService)],L),e.ExtHostLocalizationService=L,e.IExtHostLocalizationService=(0,P.createDecorator)("IExtHostLocalizationService")}),define(De[137],Ie([1,0,13,5,25,14,4]),function(J,e,l,t,C,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let I=class extends l.AbstractLoggerService{constructor(L,D){const S=new _.Emitter;super(D.logLevel,S.event),this._proxy=L.getProxy(t.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(S)}$setLevel(L){this._onDidChangeLogLevel.fire(L)}doCreateLogger(L,D,S){return new w(this._proxy,L,D,S)}};I=je([$e(0,P.IExtHostRpcService),$e(1,C.IExtHostInitDataService)],I),e.ExtHostLoggerService=I;class w extends l.AbstractMessageLogger{constructor(L,D,S,T){super(T?.always),this.proxy=L,this.file=D,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(S),this.proxy.$createLogger(D,T).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(L,D){const S=[[L,D]];this.isLoggerCreated?this.doLog(S):this.buffer.push(...S)}doLog(L){this.proxy.$log(this.file,L)}}}),define(De[251],Ie([1,0,5,13,28]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function P(I){return I&&I.title}let _=class{constructor(w,k){this._logService=k,this._proxy=w.getProxy(l.MainContext.MainThreadMessageService)}showMessage(w,k,L,D,S){const T={source:{identifier:w.identifier,label:w.displayName||w.name}};let E;typeof D=="string"||P(D)?E=[D,...S]:(T.modal=D?.modal,T.useCustom=D?.useCustom,T.detail=D?.detail,E=S),T.useCustom&&(0,C.checkProposedApiEnabled)(w,"resolvers");const p=[];for(let b=0;b<E.length;b++){const m=E[b];if(typeof m=="string")p.push({title:m,handle:b,isCloseAffordance:!1});else if(typeof m=="object"){const{title:v,isCloseAffordance:h}=m;p.push({title:v,isCloseAffordance:!!h,handle:b})}else this._logService.warn("Invalid message item:",m)}return this._proxy.$showMessage(k,L,T,p).then(b=>{if(typeof b=="number")return E[b]})}};_=je([$e(1,t.ILogService)],_),e.ExtHostMessageService=_}),define(De[252],Ie([1,0,23,4,6,26,8,16,2,86,5,38,15,7,56,227,133]),function(J,e,l,t,C,P,_,I,w,k,L,D,S,T,E,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class m{get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(h=>h.apiEditor)}constructor(h,c,g,n){this._textDocumentsAndEditors=g,this._textDocuments=n,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new P.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new t.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new t.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new t.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new k.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=h.getProxy(L.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=h.getProxy(L.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=h.getProxy(L.MainContext.MainThreadNotebookEditors),this._commandsConverter=c.converter,c.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===12){const s=u.notebookEditor?.notebookUri,i=u.cell.handle,d=this._documents.get(s)?.getCell(i);if(d)return d.apiCell}return u}}),m._registerApiCommands(c)}getEditorById(h){const c=this._editors.get(h);if(!c)throw new Error(`unknown text editor: ${h}. known editors: ${[...this._editors.keys()]} `);return c}getIdByEditor(h){for(const[c,g]of this._editors)if(g.apiEditor===h)return c}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(h,c){const g=this._documents.get(h);if(!g&&!c)throw new Error(`NO notebook document for '${h}'`);return g}_getProviderData(h){const c=this._notebookContentProviders.get(h);if(!c)throw new Error(`NO provider for '${h}'`);return c}registerNotebookContentProvider(h,c,g,n,u){if((0,_.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(c))throw new Error(`Notebook provider for '${c}' already registered`);return this._notebookContentProviders.set(c,{extension:h,provider:g}),this._notebookProxy.$registerNotebookProvider({id:h.identifier,location:h.extensionLocation},c,S.NotebookDocumentContentOptions.from(n),m._convertNotebookRegistrationData(h,u)),new T.Disposable(()=>{this._notebookContentProviders.delete(c),this._notebookProxy.$unregisterNotebookProvider(c)})}static _convertNotebookRegistrationData(h,c){if(!c)return;const g=c.filenamePattern.map(n=>S.NotebookExclusiveDocumentPattern.from(n)).filter(n=>n!==void 0);if(c.filenamePattern&&!g){console.warn(`Notebook content provider view options file name pattern is invalid ${c.filenamePattern}`);return}return{extension:h.identifier,providerDisplayName:h.displayName||h.name,displayName:c.displayName,filenamePattern:g,exclusive:c.exclusive||!1}}registerNotebookCellStatusBarItemProvider(h,c,g){const n=m._notebookStatusBarItemProviderHandlePool++,u=typeof g.onDidChangeCellStatusBarItems=="function"?m._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(n,g),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(n,u,c);let s;return u!==void 0&&(s=g.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(u))),new T.Disposable(()=>{this._notebookStatusBarItemProviders.delete(n),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(n,u),s?.dispose()})}async createNotebookDocument(h){const c=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:h.viewType,content:h.content&&S.NotebookData.from(h.content)});return w.URI.revive(c)}async openNotebookDocument(h){const c=this._documents.get(h);if(c)return c.apiNotebook;const g=await this._notebookDocumentsProxy.$tryOpenNotebook(h),n=this._documents.get(w.URI.revive(g));return(0,I.assertIsDefined)(n?.apiNotebook)}async showNotebookDocument(h,c){w.URI.isUri(h)&&(h=await this.openNotebookDocument(h));let g;typeof c=="object"?g={position:S.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus,selections:c.selections&&c.selections.map(S.NotebookRange.from),pinned:typeof c.preview=="boolean"?!c.preview:void 0}:g={preserveFocus:!1};const n=await this._notebookEditorsProxy.$tryShowNotebookDocument(h.uri,h.notebookType,g),u=n&&this._editors.get(n)?.apiEditor;if(u)return u;throw n?new Error(`Could NOT open editor for "${h.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${h.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(h,c,g,n){const u=this._notebookStatusBarItemProviders.get(h),s=w.URI.revive(c),i=this._documents.get(s);if(!i||!u)return;const o=i.getCellFromIndex(g);if(!o)return;const d=await u.provideCellStatusBarItems(o.apiCell,n);if(!d)return;const r=new C.DisposableStore,a=this._statusBarCache.add([r]),y=(Array.isArray(d)?d:[d]).map(R=>S.NotebookStatusBarItem.from(R,this._commandsConverter,r));return{cacheId:a,items:y}}$releaseNotebookCellStatusBarItems(h){this._statusBarCache.delete(h)}registerNotebookSerializer(h,c,g,n,u){if((0,_.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");const s=this._handlePool++;return this._notebookSerializer.set(s,g),this._notebookProxy.$registerNotebookSerializer(s,{id:h.identifier,location:h.extensionLocation},c,S.NotebookDocumentContentOptions.from(n),m._convertNotebookRegistrationData(h,u)),(0,C.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(s)})}async $dataToNotebook(h,c,g){const n=this._notebookSerializer.get(h);if(!n)throw new Error("NO serializer found");const u=await n.deserializeNotebook(c.buffer,g);return new E.SerializableObjectWithBuffers(S.NotebookData.from(u))}async $notebookToData(h,c,g){const n=this._notebookSerializer.get(h);if(!n)throw new Error("NO serializer found");const u=await n.serializeNotebook(S.NotebookData.to(c.value),g);return l.VSBuffer.wrap(u)}async $openNotebook(h,c,g,n,u){const{provider:s}=this._getProviderData(h),i=await s.openNotebook(w.URI.revive(c),{backupId:g,untitledDocumentData:n?.buffer},u);return new E.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(S.NotebookCellData.from)})}_createExtHostEditor(h,c,g){if(this._editors.has(c))throw new Error(`editor with id ALREADY EXSIST: ${c}`);const n=new b.ExtHostNotebookEditor(c,this._notebookEditorsProxy,h,g.visibleRanges.map(S.NotebookRange.to),g.selections.map(S.NotebookRange.to),typeof g.viewColumn=="number"?S.ViewColumn.to(g.viewColumn):void 0);this._editors.set(c,n)}$acceptDocumentAndEditorsDelta(h){if(h.value.removedDocuments)for(const g of h.value.removedDocuments){const n=w.URI.revive(g),u=this._documents.get(n);u&&(u.dispose(),this._documents.delete(n),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:u.apiNotebook.getCells().map(s=>s.document.uri)}),this._onDidCloseNotebookDocument.fire(u.apiNotebook));for(const s of this._editors.values())s.notebookData.uri.toString()===n.toString()&&this._editors.delete(s.id)}if(h.value.addedDocuments){const g=[];for(const n of h.value.addedDocuments){const u=w.URI.revive(n.uri);if(this._documents.has(u))throw new Error(`adding EXISTING notebook ${u} `);const s=new p.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,u,n);g.push(...n.cells.map(i=>p.ExtHostCell.asModelAddData(s.apiNotebook,i))),this._documents.get(u)?.dispose(),this._documents.set(u,s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:g}),this._onDidOpenNotebookDocument.fire(s.apiNotebook)}}if(h.value.addedEditors)for(const g of h.value.addedEditors){if(this._editors.has(g.id))return;const n=w.URI.revive(g.documentUri),u=this._documents.get(n);u&&this._createExtHostEditor(u,g.id,g)}const c=[];if(h.value.removedEditors)for(const g of h.value.removedEditors){const n=this._editors.get(g);n&&(this._editors.delete(g),this._activeNotebookEditor?.id===n.id&&(this._activeNotebookEditor=void 0),c.push(n))}if(h.value.visibleEditors){this._visibleNotebookEditors=h.value.visibleEditors.map(n=>this._editors.get(n)).filter(n=>!!n);const g=new Set;this._visibleNotebookEditors.forEach(n=>g.add(n.id));for(const n of this._editors.values()){const u=g.has(n.id);n._acceptVisibility(u)}this._visibleNotebookEditors=[...this._editors.values()].map(n=>n).filter(n=>n.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}h.value.newActiveEditor===null?this._activeNotebookEditor=void 0:h.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(h.value.newActiveEditor)),h.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(h){const c=D.ApiCommandArgument.String.with("notebookType","A notebook type"),g=new D.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[c,new D.ApiCommandArgument("data","Bytes to convert to data",u=>u instanceof Uint8Array,u=>l.VSBuffer.wrap(u))],new D.ApiCommandResult("Notebook Data",u=>S.NotebookData.to(u.value))),n=new D.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[c,new D.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",u=>!0,u=>new E.SerializableObjectWithBuffers(S.NotebookData.from(u)))],new D.ApiCommandResult("Bytes",u=>u.buffer));h.registerApiCommand(g),h.registerApiCommand(n)}}e.ExtHostNotebookController=m,m._notebookStatusBarItemProviderHandlePool=0}),define(De[253],Ie([1,0,17,18,21,4,6,26,2,27,13,5,38,15,7,87,215,28,56]),function(J,e,l,t,C,P,_,I,w,k,L,D,S,T,E,p,b,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let h=class{constructor(i,o,d,r,a){this._initData=o,this._extHostNotebook=d,this._commands=r,this._logService=a,this._activeExecutions=new I.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new P.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=i.getProxy(D.MainContext.MainThreadNotebookKernels);const f=new S.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new S.ApiCommandArgument("options","Select kernel options",y=>!0,y=>{if(y&&"notebookEditor"in y&&"id"in y){const R=this._extHostNotebook.getIdByEditor(y.notebookEditor);return{id:y.id,extension:y.extension,notebookEditorId:R}}else if(y&&"notebookEditor"in y){const R=this._extHostNotebook.getIdByEditor(y.notebookEditor);if(R===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${y.notebookEditor.document.uri.toString()}`);return{notebookEditorId:R}}return y})],S.ApiCommandResult.Void);this._commands.registerApiCommand(f)}createNotebookController(i,o,d,r,a,f){for(const K of this._kernelData.values())if(K.controller.id===o&&k.ExtensionIdentifier.equals(i.identifier,K.extensionId))throw new Error(`notebook controller with id '${o}' ALREADY exist`);const y=this._handlePool++,R=this;this._logService.trace(`NotebookController[${y}], CREATED by ${i.identifier.value}, ${o}`);const N=()=>console.warn(`NO execute handler from notebook controller '${F.id}' of extension: '${i.identifier}'`);let M=!1;const A=new _.DisposableStore,z=new P.Emitter,H=new P.Emitter,F={id:u(i.identifier,o),notebookType:d,extensionId:i.identifier,extensionLocation:i.extensionLocation,label:r||i.identifier.value,preloads:f?f.map(T.NotebookRendererScript.from):[]};let G=a??N,B;this._proxy.$addKernel(y,F).catch(K=>{console.log(K),M=!0});let U=0;const x=()=>{if(M)return;const K=++U;Promise.resolve().then(()=>{K===U&&this._proxy.$updateKernel(y,F)})},$=new I.ResourceMap,Q={get id(){return o},get notebookType(){return F.notebookType},onDidChangeSelectedNotebooks:z.event,get label(){return F.label},set label(K){F.label=K??i.displayName??i.name,x()},get detail(){return F.detail??""},set detail(K){F.detail=K,x()},get description(){return F.description??""},set description(K){F.description=K,x()},get kind(){return(0,m.checkProposedApiEnabled)(i,"notebookControllerKind"),F.kind??""},set kind(K){(0,m.checkProposedApiEnabled)(i,"notebookControllerKind"),F.kind=K,x()},get supportedLanguages(){return F.supportedLanguages},set supportedLanguages(K){F.supportedLanguages=K,x()},get supportsExecutionOrder(){return F.supportsExecutionOrder??!1},set supportsExecutionOrder(K){F.supportsExecutionOrder=K,x()},get rendererScripts(){return F.preloads?F.preloads.map(T.NotebookRendererScript.to):[]},get executeHandler(){return G},set executeHandler(K){G=K??N},get interruptHandler(){return B},set interruptHandler(K){B=K,F.supportsInterrupt=Boolean(K),x()},createNotebookCellExecution(K){if(M)throw new Error("notebook controller is DISPOSED");if(!$.has(K.notebook.uri))throw R._logService.trace(`NotebookController[${y}] NOT associated to notebook, associated to THESE notebooks:`,Array.from($.keys()).map(de=>de.toString())),new Error(`notebook controller is NOT associated to notebook: ${K.notebook.uri.toString()}`);return R._createNotebookCellExecution(K,u(i.identifier,this.id))},dispose:()=>{M||(this._logService.trace(`NotebookController[${y}], DISPOSED`),M=!0,this._kernelData.delete(y),A.dispose(),z.dispose(),H.dispose(),this._proxy.$removeKernel(y))},updateNotebookAffinity(K,de){de===E.NotebookControllerAffinity2.Hidden&&(0,m.checkProposedApiEnabled)(i,"notebookControllerAffinityHidden"),R._proxy.$updateNotebookPriority(y,K.uri,de)},onDidReceiveMessage:H.event,postMessage(K,de){return(0,m.checkProposedApiEnabled)(i,"notebookMessaging"),R._proxy.$postMessage(y,de&&R._extHostNotebook.getIdByEditor(de),K)},asWebviewUri(K){return(0,m.checkProposedApiEnabled)(i,"notebookMessaging"),(0,p.asWebviewUri)(K,R._initData.remote)}};return this._kernelData.set(y,{extensionId:i.identifier,controller:Q,onDidReceiveMessage:H,onDidChangeSelection:z,associatedNotebooks:$}),Q}getIdByController(i){for(const[o,d]of this._kernelData)if(d.controller===i)return u(d.extensionId,i.id);return null}$acceptNotebookAssociation(i,o,d){const r=this._kernelData.get(i);if(r){const a=this._extHostNotebook.getNotebookDocument(w.URI.revive(o));d?r.associatedNotebooks.set(a.uri,!0):r.associatedNotebooks.delete(a.uri),this._logService.trace(`NotebookController[${i}] ASSOCIATE notebook`,a.uri.toString(),d),r.onDidChangeSelection.fire({selected:d,notebook:a.apiNotebook})}}async $executeCells(i,o,d){const r=this._kernelData.get(i);if(!r)return;const a=this._extHostNotebook.getNotebookDocument(w.URI.revive(o)),f=[];for(const y of d){const R=a.getCell(y);R&&f.push(R.apiCell)}try{this._logService.trace(`NotebookController[${i}] EXECUTE cells`,a.uri.toString(),f.length),await r.controller.executeHandler.call(r.controller,f,a.apiNotebook,r.controller)}catch(y){this._logService.error(`NotebookController[${i}] execute cells FAILED`,y),console.error(y)}}async $cancelCells(i,o,d){const r=this._kernelData.get(i);if(!r)return;const a=this._extHostNotebook.getNotebookDocument(w.URI.revive(o));if(r.controller.interruptHandler)await r.controller.interruptHandler.call(r.controller,a.apiNotebook);else for(const f of d){const y=a.getCell(f);y&&this._activeExecutions.get(y.uri)?.cancel()}}$acceptKernelMessageFromRenderer(i,o,d){const r=this._kernelData.get(i);if(!r)return;const a=this._extHostNotebook.getEditorById(o);r.onDidReceiveMessage.fire(Object.freeze({editor:a.apiEditor,message:d}))}$cellExecutionChanged(i,o,d){const a=this._extHostNotebook.getNotebookDocument(w.URI.revive(i)).getCell(o);if(a){const f=d?T.NotebookCellExecutionState.to(d):E.NotebookCellExecutionState.Idle;f!==void 0&&this._onDidChangeCellExecutionState.fire({cell:a.apiCell,state:f})}}_createNotebookCellExecution(i,o){if(i.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const r=this._extHostNotebook.getNotebookDocument(i.notebook.uri).getCellFromApiCell(i);if(!r)throw new Error("invalid cell");if(this._activeExecutions.has(r.uri))throw new Error(`duplicate execution for ${r.uri}`);const a=new g(o,r,this._proxy);this._activeExecutions.set(r.uri,a);const f=a.onDidChangeState(()=>{a.state===c.Resolved&&(a.dispose(),f.dispose(),this._activeExecutions.delete(r.uri))});return a.asApiObject()}};h=je([$e(4,L.ILogService)],h),e.ExtHostNotebookKernels=h;var c;(function(s){s[s.Init=0]="Init",s[s.Started=1]="Started",s[s.Resolved=2]="Resolved"})(c||(c={}));class g extends _.Disposable{get state(){return this._state}constructor(i,o,d){super(),this._cell=o,this._proxy=d,this._handle=g.HANDLE++,this._onDidChangeState=new P.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=c.Init,this._tokenSource=this._register(new C.CancellationTokenSource),this._collector=new n(10,r=>this.update(r)),this._executionOrder=o.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,i,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(i){await this._collector.addItem(i)}async update(i){const o=Array.isArray(i)?i:[i];return this._proxy.$updateExecution(this._handle,new v.SerializableObjectWithBuffers(o))}verifyStateForOutput(){if(this._state===c.Init)throw new Error("Must call start before modifying cell output");if(this._state===c.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(i){let o=this._cell;if(i&&(o=this._cell.notebook.getCellFromApiCell(i)),!o)throw new Error("INVALID cell");return o.handle}validateAndConvertOutputs(i){return i.map(o=>{const d=E.NotebookCellOutput.ensureUniqueMimeTypes(o.items,!0);return d===o.items?T.NotebookCellOutput.from(o):T.NotebookCellOutput.from({items:d,id:o.id,metadata:o.metadata})})}async updateOutputs(i,o,d){const r=this.cellIndexToHandle(o),a=this.validateAndConvertOutputs((0,l.asArray)(i));return this.updateSoon({editType:b.CellExecutionUpdateType.Output,cellHandle:r,append:d,outputs:a})}async updateOutputItems(i,o,d){return i=E.NotebookCellOutput.ensureUniqueMimeTypes((0,l.asArray)(i),!0),this.updateSoon({editType:b.CellExecutionUpdateType.OutputItems,items:i.map(T.NotebookCellOutputItem.from),outputId:o.id,append:d})}asApiObject(){const i=this;return Object.freeze({get token(){return i._tokenSource.token},get cell(){return i._cell.apiCell},get executionOrder(){return i._executionOrder},set executionOrder(d){i._executionOrder=d,i.update([{editType:b.CellExecutionUpdateType.ExecutionState,executionOrder:i._executionOrder}])},start(d){if(i._state===c.Resolved||i._state===c.Started)throw new Error("Cannot call start again");i._state=c.Started,i._onDidChangeState.fire(),i.update({editType:b.CellExecutionUpdateType.ExecutionState,runStartTime:d})},end(d,r){if(i._state===c.Resolved)throw new Error("Cannot call resolve twice");i._state=c.Resolved,i._onDidChangeState.fire(),i._collector.flush(),i._proxy.$completeExecution(i._handle,new v.SerializableObjectWithBuffers({runEndTime:r,lastRunSuccess:d}))},clearOutput(d){return i.verifyStateForOutput(),i.updateOutputs([],d,!1)},appendOutput(d,r){return i.verifyStateForOutput(),i.updateOutputs(d,r,!0)},replaceOutput(d,r){return i.verifyStateForOutput(),i.updateOutputs(d,r,!1)},appendOutputItems(d,r){return i.verifyStateForOutput(),i.updateOutputItems(d,r,!0)},replaceOutputItems(d,r){return i.verifyStateForOutput(),i.updateOutputItems(d,r,!1)}})}}g.HANDLE=0;class n{constructor(i,o){this.delay=i,this.callback=o,this.batch=[],this.startedTimer=Date.now()}addItem(i){return this.batch.push(i),this.currentDeferred||(this.currentDeferred=new t.DeferredPromise,this.startedTimer=Date.now(),(0,t.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const i=this.currentDeferred;this.currentDeferred=void 0;const o=this.batch;return this.batch=[],this.callback(o).finally(()=>i.complete())}}function u(s,i){return`${s.value}/${i}`}e.createKernelId=u}),define(De[254],Ie([1,0,4,5,133]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class P{constructor(I,w){this._extHostNotebook=w,this._rendererMessageEmitters=new Map,this.proxy=I.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(I,w,k){const L=this._extHostNotebook.getEditorById(I);this._rendererMessageEmitters.get(w)?.fire({editor:L.apiEditor,message:k})}createRendererMessaging(I,w){if(!I.contributes?.notebookRenderer?.some(L=>L.id===w))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${w})`);return{onDidReceiveMessage:(L,D,S)=>this.getOrCreateEmitterFor(w).event(L,D,S),postMessage:(L,D)=>{C.ExtHostNotebookEditor.apiEditorsToExtHost.has(L)&&([L,D]=[D,L]);const S=D&&C.ExtHostNotebookEditor.apiEditorsToExtHost.get(D);return this.proxy.$postMessage(S?.id,w,L)}}}getOrCreateEmitterFor(I){let w=this._rendererMessageEmitters.get(I);return w||(w=new l.Emitter({onLastListenerRemove:()=>{w?.dispose(),this._rendererMessageEmitters.delete(I)}}),this._rendererMessageEmitters.set(I,w),w)}}e.ExtHostNotebookRenderers=P}),define(De[255],Ie([1,0,21,4,6,5,2,7,10,17,42,85]),function(J,e,l,t,C,P,_,I,w,k,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function S(T,E,p){const b=T.getProxy(P.MainContext.MainThreadQuickOpen);class m{constructor(o,d){this._sessions=new Map,this._instances=0,this._workspace=o,this._commands=d}showQuickPick(o,d,r=l.CancellationToken.None){this._onDidSelectItem=void 0;const a=Promise.resolve(o),f=++this._instances,y=b.$show(f,{title:d?.title,placeHolder:d?.placeHolder,matchOnDescription:d?.matchOnDescription,matchOnDetail:d?.matchOnDetail,ignoreFocusLost:d?.ignoreFocusOut,canPickMany:d?.canPickMany},r),R={},N=y.then(()=>R);return Promise.race([N,a]).then(M=>{if(M!==R)return a.then(A=>{const z=[];for(let H=0;H<A.length;H++){const F=A[H];typeof F=="string"?z.push({label:F,handle:H}):F.kind===I.QuickPickItemKind.Separator?z.push({type:"separator",label:F.label}):z.push({label:F.label,description:F.description,detail:F.detail,picked:F.picked,alwaysShow:F.alwaysShow,handle:H})}return d&&typeof d.onDidSelectItem=="function"&&(this._onDidSelectItem=H=>{d.onDidSelectItem(A[H])}),b.$setItems(f,z),y.then(H=>{if(typeof H=="number")return A[H];if(Array.isArray(H))return H.map(F=>A[F])})})}).then(void 0,M=>{if(!(0,w.isCancellationError)(M))return b.$setError(f,M),Promise.reject(M)})}$onItemSelected(o){this._onDidSelectItem?.(o)}showInput(o,d=l.CancellationToken.None){return this._validateInput=o?.validateInput,b.$input(o,typeof this._validateInput=="function",d).then(void 0,r=>{if(!(0,w.isCancellationError)(r))return Promise.reject(r)})}async $validateInput(o){if(!this._validateInput)return;const d=await this._validateInput(o);if(!d||typeof d=="string")return d;let r;switch(d.severity){case I.InputBoxValidationSeverity.Info:r=L.default.Info;break;case I.InputBoxValidationSeverity.Warning:r=L.default.Warning;break;case I.InputBoxValidationSeverity.Error:r=L.default.Error;break;default:r=d.message?L.default.Error:L.default.Ignore;break}return{content:d.message,severity:r}}async showWorkspaceFolderPick(o,d=l.CancellationToken.None){const r=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[o]);if(!r)return;const a=await this._workspace.getWorkspaceFolders2();if(!!a)return a.find(f=>f.uri.toString()===r.uri.toString())}createQuickPick(o){const d=new u(o,()=>this._sessions.delete(d._id));return this._sessions.set(d._id,d),d}createInputBox(o){const d=new s(o,()=>this._sessions.delete(d._id));return this._sessions.set(d._id,d),d}$onDidChangeValue(o,d){this._sessions.get(o)?._fireDidChangeValue(d)}$onDidAccept(o){this._sessions.get(o)?._fireDidAccept()}$onDidChangeActive(o,d){const r=this._sessions.get(o);r instanceof u&&r._fireDidChangeActive(d)}$onDidChangeSelection(o,d){const r=this._sessions.get(o);r instanceof u&&r._fireDidChangeSelection(d)}$onDidTriggerButton(o,d){this._sessions.get(o)?._fireDidTriggerButton(d)}$onDidTriggerItemButton(o,d,r){const a=this._sessions.get(o);a instanceof u&&a._fireDidTriggerItemButton(d,r)}$onDidHide(o){this._sessions.get(o)?._fireDidHide()}}class v{constructor(o,d){this._extensionId=o,this._onDidDispose=d,this._id=u._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new t.Emitter,this._onDidChangeValueEmitter=new t.Emitter,this._onDidTriggerButtonEmitter=new t.Emitter,this._onDidHideEmitter=new t.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(o){this._title=o,this.update({title:o})}get step(){return this._steps}set step(o){this._steps=o,this.update({step:o})}get totalSteps(){return this._totalSteps}set totalSteps(o){this._totalSteps=o,this.update({totalSteps:o})}get enabled(){return this._enabled}set enabled(o){this._enabled=o,this.update({enabled:o})}get busy(){return this._busy}set busy(o){this._busy=o,this.update({busy:o})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(o){this._ignoreFocusOut=o,this.update({ignoreFocusOut:o})}get value(){return this._value}set value(o){this._value=o,this.update({value:o})}get placeholder(){return this._placeholder}set placeholder(o){this._placeholder=o,this.update({placeholder:o})}get buttons(){return this._buttons}set buttons(o){this._buttons=o.slice(),this._handlesToButtons.clear(),o.forEach((d,r)=>{const a=d===I.QuickInputButtons.Back?-1:r;this._handlesToButtons.set(a,d)}),this.update({buttons:o.map((d,r)=>({...n(d),tooltip:d.tooltip,handle:d===I.QuickInputButtons.Back?-1:r}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(o){this._value=o,this._onDidChangeValueEmitter.fire(o)}_fireDidTriggerButton(o){const d=this._handlesToButtons.get(o);d&&this._onDidTriggerButtonEmitter.fire(d)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,C.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),b.$dispose(this._id))}update(o){if(!this._disposed){for(const d of Object.keys(o)){const r=o[d];this._pendingUpdate[d]=r===void 0?null:r}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){b.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}v._nextId=1;function h(i){if(i instanceof I.ThemeIcon)return{id:i.id};const o=g(i),d=c(i);return{dark:typeof o=="string"?_.URI.file(o):o,light:typeof d=="string"?_.URI.file(d):d}}function c(i){return typeof i=="object"&&"light"in i?i.light:i}function g(i){return typeof i=="object"&&"dark"in i?i.dark:i}function n(i){const o=h(i.iconPath);let d,r;return"id"in o?r=D.ThemeIcon.asClassName(o):d=o,{iconPath:d,iconClass:r}}class u extends v{constructor(o,d){super(o.identifier,d),this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new t.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new t.Emitter,this._onDidTriggerItemButtonEmitter=new t.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(o){this._items=o.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),o.forEach((r,a)=>{this._handlesToItems.set(a,r),this._itemsToHandles.set(r,a)});const d=[];for(let r=0;r<o.length;r++){const a=o[r];a.kind===I.QuickPickItemKind.Separator?d.push({type:"separator",label:a.label}):d.push({handle:r,label:a.label,description:a.description,detail:a.detail,picked:a.picked,alwaysShow:a.alwaysShow,buttons:a.buttons?.map((f,y)=>({...n(f),tooltip:f.tooltip,handle:y}))})}this.update({items:d})}get canSelectMany(){return this._canSelectMany}set canSelectMany(o){this._canSelectMany=o,this.update({canSelectMany:o})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(o){this._matchOnDescription=o,this.update({matchOnDescription:o})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(o){this._matchOnDetail=o,this.update({matchOnDetail:o})}get sortByLabel(){return this._sortByLabel}set sortByLabel(o){this._sortByLabel=o,this.update({sortByLabel:o})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(o){this._keepScrollPosition=o,this.update({keepScrollPosition:o})}get activeItems(){return this._activeItems}set activeItems(o){this._activeItems=o.filter(d=>this._itemsToHandles.has(d)),this.update({activeItems:this._activeItems.map(d=>this._itemsToHandles.get(d))})}get selectedItems(){return this._selectedItems}set selectedItems(o){this._selectedItems=o.filter(d=>this._itemsToHandles.has(d)),this.update({selectedItems:this._selectedItems.map(d=>this._itemsToHandles.get(d))})}_fireDidChangeActive(o){const d=(0,k.coalesce)(o.map(r=>this._handlesToItems.get(r)));this._activeItems=d,this._onDidChangeActiveEmitter.fire(d)}_fireDidChangeSelection(o){const d=(0,k.coalesce)(o.map(r=>this._handlesToItems.get(r)));this._selectedItems=d,this._onDidChangeSelectionEmitter.fire(d)}_fireDidTriggerItemButton(o,d){const r=this._handlesToItems.get(o);if(!r||!r.buttons||!r.buttons.length)return;const a=r.buttons[d];a&&this._onDidTriggerItemButtonEmitter.fire({button:a,item:r})}}class s extends v{constructor(o,d){super(o.identifier,d),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(o){this._password=o,this.update({password:o})}get prompt(){return this._prompt}set prompt(o){this._prompt=o,this.update({prompt:o})}get validationMessage(){return this._validationMessage}set validationMessage(o){this._validationMessage=o,o?typeof o=="string"?this.update({validationMessage:o,severity:L.default.Error}):this.update({validationMessage:o.message,severity:o.severity??L.default.Error}):this.update({validationMessage:void 0,severity:L.default.Ignore})}}return new m(E,p)}e.createExtHostQuickOpen=S});var Be=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)},tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,l):C?C.value=l:e.set(J,l),l};define(De[256],Ie([1,0,2,4,59,6,18,5,17,104,13,27,85,15,28]),function(J,e,l,t,C,P,_,I,w,k,L,D,S,T,E){"use strict";var p,b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function m(a){if(a)return typeof a.iconPath=="string"?l.URI.file(a.iconPath):l.URI.isUri(a.iconPath)||S.ThemeIcon.isThemeIcon(a.iconPath)?a.iconPath:void 0}function v(a,f){if(!a.iconPath&&!f.iconPath)return 0;if(a.iconPath){if(!f.iconPath)return 1}else return-1;const y=typeof a.iconPath=="string"?a.iconPath:l.URI.isUri(a.iconPath)?a.iconPath.fsPath:a.iconPath.id,R=typeof f.iconPath=="string"?f.iconPath:l.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id;return(0,k.comparePaths)(y,R)}function h(a,f){let y=0;if(a.strikeThrough!==f.strikeThrough)return a.strikeThrough?1:-1;if(a.faded!==f.faded)return a.faded?1:-1;if(a.tooltip!==f.tooltip)return(a.tooltip||"").localeCompare(f.tooltip||"");if(y=v(a,f),y!==0)return y;if(a.light&&f.light)y=v(a.light,f.light);else{if(a.light)return 1;if(f.light)return-1}if(y!==0)return y;if(a.dark&&f.dark)y=v(a.dark,f.dark);else{if(a.dark)return 1;if(f.dark)return-1}return y}function c(a,f){if(a.command!==f.command)return a.command<f.command?-1:1;if(a.title!==f.title)return a.title<f.title?-1:1;if(a.tooltip!==f.tooltip){if(a.tooltip!==void 0&&f.tooltip!==void 0)return a.tooltip<f.tooltip?-1:1;if(a.tooltip!==void 0)return 1;if(f.tooltip!==void 0)return-1}if(a.arguments===f.arguments)return 0;if(a.arguments)if(f.arguments){if(a.arguments.length!==f.arguments.length)return a.arguments.length-f.arguments.length}else return 1;else return-1;for(let y=0;y<a.arguments.length;y++){const R=a.arguments[y],N=f.arguments[y];if(R!==N)return R<N?-1:1}return 0}function g(a,f){let y=(0,k.comparePaths)(a.resourceUri.fsPath,f.resourceUri.fsPath,!0);if(y!==0)return y;if(a.command&&f.command)y=c(a.command,f.command);else{if(a.command)return 1;if(f.command)return-1}if(y!==0)return y;if(a.decorations&&f.decorations)y=h(a.decorations,f.decorations);else{if(a.decorations)return 1;if(f.decorations)return-1}return y}function n(a,f){for(let y=0;y<a.length;y++)if(a[y]!==f[y])return!1;return!0}function u(a,f){return a.command===f.command&&a.title===f.title&&a.tooltip===f.tooltip&&(a.arguments&&f.arguments?n(a.arguments,f.arguments):a.arguments===f.arguments)}function s(a,f){return(0,w.equals)(a,f,u)}class i{get value(){return this._value}set value(f){f=f??"",Be(this,p,"f").$setInputBoxValue(this._sourceControlHandle,f),this.updateValue(f)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(f){Be(this,p,"f").$setInputBoxPlaceholder(this._sourceControlHandle,f),this._placeholder=f}get validateInput(){return(0,E.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(f){if((0,E.checkProposedApiEnabled)(this._extension,"scmValidation"),f&&typeof f!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=f,Be(this,p,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!f)}get enabled(){return this._enabled}set enabled(f){f=!!f,this._enabled!==f&&(this._enabled=f,Be(this,p,"f").$setInputBoxEnablement(this._sourceControlHandle,f))}get visible(){return this._visible}set visible(f){f=!!f,this._visible!==f&&(this._visible=f,Be(this,p,"f").$setInputBoxVisibility(this._sourceControlHandle,f))}constructor(f,y,R){this._extension=f,this._sourceControlHandle=R,p.set(this,void 0),this._value="",this._onDidChange=new t.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,tt(this,p,y,"f")}showValidationMessage(f,y){(0,E.checkProposedApiEnabled)(this._extension,"scmValidation"),Be(this,p,"f").$showValidationMessage(this._sourceControlHandle,f,y)}$onInputBoxValueChange(f){this.updateValue(f)}updateValue(f){this._value=f,this._onDidChange.fire(f)}}e.ExtHostSCMInputBox=i,p=new WeakMap;class o{get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(f){this._label=f,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,f)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(f){this._hideWhenEmpty=f,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(f){this._resourceStates=[...f],this._onDidUpdateResourceStates.fire()}constructor(f,y,R,N,M){this._proxy=f,this._commands=y,this._sourceControlHandle=R,this._id=N,this._label=M,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new t.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=o._handlePool++}getResourceState(f){return this._resourceStatesMap.get(f)}$executeResourceCommand(f,y){const R=this._resourceStatesCommandsMap.get(f);return R?(0,_.asPromise)(()=>this._commands.executeCommand(R.command,...R.arguments||[],y)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const f=[...this._resourceStates].sort(g),R=(0,w.sortedDiff)(this._resourceSnapshot,f,g).map(A=>{const z=A.toInsert.map(H=>{const F=this._resourceHandlePool++;this._resourceStatesMap.set(F,H);const G=H.resourceUri;let B;if(H.command)if(H.command.command==="vscode.open"||H.command.command==="vscode.diff"){const ve=new P.DisposableStore;B=this._commands.converter.toInternal(H.command,ve),this._resourceStatesDisposablesMap.set(F,ve)}else this._resourceStatesCommandsMap.set(F,H.command);const U=m(H.decorations),x=H.decorations&&m(H.decorations.light)||U,$=H.decorations&&m(H.decorations.dark)||U,Q=[x,$],K=H.decorations&&H.decorations.tooltip||"",de=H.decorations&&!!H.decorations.strikeThrough,te=H.decorations&&!!H.decorations.faded,he=H.contextValue||"";return{rawResource:[F,G,Q,K,de,te,he,B],handle:F}});return{start:A.start,deleteCount:A.deleteCount,toInsert:z}}),N=R.map(({start:A,deleteCount:z,toInsert:H})=>[A,z,H.map(F=>F.rawResource)]),M=R.reverse();for(const{start:A,deleteCount:z,toInsert:H}of M){const F=H.map(B=>B.handle),G=this._handlesSnapshot.splice(A,z,...F);for(const B of G)this._resourceStatesMap.delete(B),this._resourceStatesCommandsMap.delete(B),this._resourceStatesDisposablesMap.get(B)?.dispose(),this._resourceStatesDisposablesMap.delete(B)}return this._resourceSnapshot=f,N}dispose(){this._disposed=!0,this._onDidDispose.fire()}}o._handlePool=0;class d{get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(f){this._count!==f&&(this._count=f,Be(this,b,"f").$updateSourceControl(this.handle,{count:f}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(f){this._quickDiffProvider=f,Be(this,b,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!f})}get commitTemplate(){return this._commitTemplate}set commitTemplate(f){f!==this._commitTemplate&&(this._commitTemplate=f,Be(this,b,"f").$updateSourceControl(this.handle,{commitTemplate:f}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(f){this._acceptInputDisposables.value=new P.DisposableStore,this._acceptInputCommand=f;const y=this._commands.converter.toInternal(f,this._acceptInputDisposables.value);Be(this,b,"f").$updateSourceControl(this.handle,{acceptInputCommand:y})}get actionButton(){return(0,E.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(f){(0,E.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new P.DisposableStore,this._actionButton=f;const y=f!==void 0?{command:this._commands.converter.toInternal(f.command,this._actionButtonDisposables.value),secondaryCommands:f.secondaryCommands?.map(R=>R.map(N=>this._commands.converter.toInternal(N,this._actionButtonDisposables.value))),description:f.description,enabled:f.enabled}:void 0;Be(this,b,"f").$updateSourceControl(this.handle,{actionButton:y??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(f){if(this._statusBarCommands&&f&&s(this._statusBarCommands,f))return;this._statusBarDisposables.value=new P.DisposableStore,this._statusBarCommands=f;const y=(f||[]).map(R=>this._commands.converter.toInternal(R,this._statusBarDisposables.value));Be(this,b,"f").$updateSourceControl(this.handle,{statusBarCommands:y})}get selected(){return this._selected}constructor(f,y,R,N,M,A){this._extension=f,this._commands=R,this._id=N,this._label=M,this._rootUri=A,b.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new P.MutableDisposable,this._statusBarDisposables=new P.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new t.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=d._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,tt(this,b,y,"f"),this._inputBox=new i(f,Be(this,b,"f"),this.handle),Be(this,b,"f").$registerSourceControl(this.handle,N,M,A)}createResourceGroup(f,y){const R=new o(Be(this,b,"f"),this._commands,this.handle,f,y),N=t.Event.once(R.onDidDispose)(()=>this.createdResourceGroups.delete(R));return this.createdResourceGroups.set(R,N),this.eventuallyAddResourceGroups(),R}eventuallyAddResourceGroups(){const f=[],y=[];for(const[R,N]of this.createdResourceGroups){N.dispose();const M=R.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(R),this.eventuallyUpdateResourceStates()});t.Event.once(R.onDidDispose)(()=>{this.updatedResourceGroups.delete(R),M.dispose(),this._groups.delete(R.handle),Be(this,b,"f").$unregisterGroup(this.handle,R.handle)}),f.push([R.handle,R.id,R.label,R.features]);const A=R._takeResourceStateSnapshot();A.length>0&&y.push([R.handle,A]),this._groups.set(R.handle,R)}Be(this,b,"f").$registerGroups(this.handle,f,y),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const f=[];this.updatedResourceGroups.forEach(y=>{const R=y._takeResourceStateSnapshot();R.length!==0&&f.push([y.handle,R])}),f.length>0&&Be(this,b,"f").$spliceResourceStates(this.handle,f),this.updatedResourceGroups.clear()}getResourceGroup(f){return this._groups.get(f)}setSelectionState(f){this._selected=f,this._onDidChangeSelection.fire(f)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(f=>f.dispose()),Be(this,b,"f").$unregisterSourceControl(this.handle)}}b=new WeakMap,d._handlePool=0,je([(0,C.debounce)(100)],d.prototype,"eventuallyAddResourceGroups",null),je([(0,C.debounce)(100)],d.prototype,"eventuallyUpdateResourceStates",null);let r=class ti{get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(f,y,R){this._commands=y,this.logService=R,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new t.Emitter,this._proxy=f.getProxy(I.MainContext.MainThreadSCM),this._telemetry=f.getProxy(I.MainContext.MainThreadTelemetry),y.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===3){const M=this._sourceControls.get(N.sourceControlHandle);if(!M)return N;const A=M.getResourceGroup(N.groupHandle);return A?A.getResourceState(N.handle):N}else if(N&&N.$mid===4){const M=this._sourceControls.get(N.sourceControlHandle);return M?M.getResourceGroup(N.groupHandle):N}else if(N&&N.$mid===5){const M=this._sourceControls.get(N.handle);return M||N}return N}})}createSourceControl(f,y,R,N){this.logService.trace("ExtHostSCM#createSourceControl",f.identifier.value,y,R,N),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:f.identifier.value});const M=ti._handlePool++,A=new d(f,this._proxy,this._commands,y,R,N);this._sourceControls.set(M,A);const z=this._sourceControlsByExtension.get(D.ExtensionIdentifier.toKey(f.identifier))||[];return z.push(A),this._sourceControlsByExtension.set(D.ExtensionIdentifier.toKey(f.identifier),z),A}getLastInputBox(f){this.logService.trace("ExtHostSCM#getLastInputBox",f.identifier.value);const y=this._sourceControlsByExtension.get(D.ExtensionIdentifier.toKey(f.identifier)),R=y&&y[y.length-1];return R&&R.inputBox}$provideOriginalResource(f,y,R){const N=l.URI.revive(y);this.logService.trace("ExtHostSCM#$provideOriginalResource",f,N.toString());const M=this._sourceControls.get(f);return!M||!M.quickDiffProvider||!M.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,_.asPromise)(()=>M.quickDiffProvider.provideOriginalResource(N,R)).then(A=>A||null)}$onInputBoxValueChange(f,y){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",f);const R=this._sourceControls.get(f);return R&&R.inputBox.$onInputBoxValueChange(y),Promise.resolve(void 0)}$executeResourceCommand(f,y,R,N){this.logService.trace("ExtHostSCM#$executeResourceCommand",f,y,R);const M=this._sourceControls.get(f);if(!M)return Promise.resolve(void 0);const A=M.getResourceGroup(y);return A?A.$executeResourceCommand(R,N):Promise.resolve(void 0)}$validateInput(f,y,R){this.logService.trace("ExtHostSCM#$validateInput",f);const N=this._sourceControls.get(f);return!N||!N.inputBox.validateInput?Promise.resolve(void 0):(0,_.asPromise)(()=>N.inputBox.validateInput(y,R)).then(M=>{if(!M)return Promise.resolve(void 0);const A=T.MarkdownString.fromStrict(M.message);return A?Promise.resolve([A,M.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(f){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",f),f!==void 0&&this._sourceControls.get(f)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=f,Promise.resolve(void 0)}};r._handlePool=0,r=je([$e(2,L.ILogService)],r),e.ExtHostSCM=r}),define(De[91],Ie([1,0,5,4,3]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class P{constructor(I){this._onDidChangePassword=new t.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=I.getProxy(l.MainContext.MainThreadSecretState)}async $onDidChangePassword(I){this._onDidChangePassword.fire(I)}get(I,w){return this._proxy.$getPassword(I,w)}store(I,w,k){return this._proxy.$setPassword(I,w,k)}delete(I,w){return this._proxy.$deletePassword(I,w)}}e.ExtHostSecretState=P,e.IExtHostSecretState=(0,C.createDecorator)("IExtHostSecretState")});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,l):C?C.value=l:e.set(J,l),l},Be=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[257],Ie([1,0,7,5,173,6,15,16]),function(J,e,l,t,C,P,_,I){"use strict";var w,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class L{constructor(E,p,b,m,v=l.StatusBarAlignment.Left,h){w.set(this,void 0),k.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new P.DisposableStore,tt(this,w,E,"f"),tt(this,k,p,"f"),this._entryId=L.ID_GEN++,this._extension=b,this._id=m,this._alignment=v,this._priority=this.validatePriority(h)}validatePriority(E){if(!!(0,I.isNumber)(E))return E===Number.POSITIVE_INFINITY?Number.MAX_VALUE:E===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:E}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(E){this._text=E,this.update()}set name(E){this._name=E,this.update()}set tooltip(E){this._tooltip=E,this.update()}set color(E){this._color=E,this.update()}set backgroundColor(E){E&&!L.ALLOWED_BACKGROUND_COLORS.has(E.id)&&(E=void 0),this._backgroundColor=E,this.update()}set command(E){this._command?.fromApi!==E&&(this._internalCommandRegistration.clear(),typeof E=="string"?this._command={fromApi:E,internal:Be(this,k,"f").toInternal({title:"",command:E},this._internalCommandRegistration)}:E?this._command={fromApi:E,internal:Be(this,k,"f").toInternal(E,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(E){this._accessibilityInformation=E,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Be(this,w,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let E;this._extension?this._id?E=`${this._extension.identifier.value}.${this._id}`:E=this._extension.identifier.value:E=this._id;let p;this._name?p=this._name:p=(0,C.localize)(0,null,this._extension.displayName||this._extension.name);let b=this._color;this._backgroundColor&&(b=L.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const m=_.MarkdownString.fromStrict(this._tooltip);Be(this,w,"f").$setEntry(this._entryId,E,p,this._text,m,this._command?.internal,b,this._backgroundColor,this._alignment===l.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=L,w=new WeakMap,k=new WeakMap,L.ID_GEN=0,L.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new l.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new l.ThemeColor("statusBarItem.warningForeground")]]);class D{constructor(E){this._messages=[],this._item=E.createStatusBarEntry(void 0,"status.extensionMessage",l.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,C.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(E){const p={message:E};return this._messages.unshift(p),this._update(),new l.Disposable(()=>{const b=this._messages.indexOf(p);b>=0&&(this._messages.splice(b,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class S{constructor(E,p){this._proxy=E.getProxy(t.MainContext.MainThreadStatusBar),this._commands=p,this._statusMessage=new D(this)}createStatusBarEntry(E,p,b,m){return new L(this._proxy,this._commands,E,p,b,m)}setStatusBarMessage(E,p){const b=this._statusMessage.setMessage(E);let m;return typeof p=="number"?m=setTimeout(()=>b.dispose(),p):typeof p<"u"&&p.then(()=>b.dispose(),()=>b.dispose()),new l.Disposable(()=>{b.dispose(),clearTimeout(m)})}}e.ExtHostStatusBar=S}),define(De[92],Ie([1,0,5,4,3]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class P{constructor(I){this._onDidChangeStorage=new t.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=I.getProxy(l.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(I,w){this._proxy.$registerExtensionStorageKeysToSync(I,w)}initializeExtensionStorage(I,w,k){return this._proxy.$initializeExtensionStorage(I,w).then(L=>L||k)}setValue(I,w,k){return this._proxy.$setValue(I,w,k)}$acceptValue(I,w,k){this._onDidChangeStorage.fire({shared:I,key:w,value:k})}}e.ExtHostStorage=P,e.IExtHostStorage=(0,C.createDecorator)("IExtHostStorage")}),define(De[67],Ie([1,0,3,25,13,66,2]),function(J,e,l,t,C,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,l.createDecorator)("IExtensionStoragePaths");let I=class{constructor(k,L,D){this._logService=L,this._extHostFileSystem=D,this._workspace=k.workspace??void 0,this._environment=k.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(S=>this._value=S)}async _getWorkspaceStorageURI(k){return _.URI.joinPath(this._environment.workspaceStorageHome,k)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const k=this._workspace.id,L=await this._getWorkspaceStorageURI(k);try{return await this._extHostFileSystem.value.stat(L),this._logService.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",L),await this._extHostFileSystem.value.createDirectory(L),await this._extHostFileSystem.value.writeFile(_.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:_.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),L}catch(D){this._logService.error("[ExtHostStorage]",D);return}}workspaceValue(k){if(this._value)return _.URI.joinPath(this._value,k.identifier.value)}globalValue(k){return _.URI.joinPath(this._environment.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};I=je([$e(0,t.IExtHostInitDataService),$e(1,C.ILogService),$e(2,P.IExtHostConsumerFileSystem)],I),e.ExtensionStoragePaths=I}),define(De[138],Ie([1,0,3,5,14]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTelemetryLogService=e.IExtHostTelemetryLogService=void 0,e.IExtHostTelemetryLogService=(0,l.createDecorator)("IExtHostTelemetryLogService");let P=class{constructor(I){this._telemetryShape=I.getProxy(t.MainContext.MainThreadTelemetry)}logToTelemetryOutputChannel(I,w,k){this._telemetryShape.$logTelemetryToOutputChannel(`${I.identifier.value}/${w}`,k)}};P=je([$e(0,C.IExtHostRpcService)],P),e.ExtHostTelemetryLogService=P}),define(De[39],Ie([1,0,4,5,3,2,14,6,7,174,10,216,21,34,201,85,16,18,15]),function(J,e,l,t,C,P,_,I,w,k,L,D,S,T,E,p,b,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,C.createDecorator)("IExtHostTerminalService");class h{constructor(r,a,f,y){this._proxy=r,this._id=a,this._creationOptions=f,this._name=y,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(N=>this._pidPromiseComplete=N);const R=this;this.value={get name(){return R._name||""},get processId(){return R._pidPromise},get creationOptions(){return R._creationOptions},get exitStatus(){return R._exitStatus},get state(){return R._state},sendText(N,M=!0){R._checkDisposed(),R._proxy.$sendText(R._id,N,M)},show(N){R._checkDisposed(),R._proxy.$show(R._id,N)},hide(){R._checkDisposed(),R._proxy.$hide(R._id)},dispose(){R._disposed||(R._disposed=!0,R._proxy.$dispose(R._id))},get dimensions(){if(!(R._cols===void 0||R._rows===void 0))return{columns:R._cols,rows:R._rows}}}}async create(r,a){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:r.name,shellPath:(0,b.withNullAsUndefined)(r.shellPath),shellArgs:(0,b.withNullAsUndefined)(r.shellArgs),cwd:(0,b.withNullAsUndefined)(r.cwd),env:(0,b.withNullAsUndefined)(r.env),icon:(0,b.withNullAsUndefined)(i(r.iconPath)),color:p.ThemeColor.isThemeColor(r.color)?r.color.id:void 0,initialText:(0,b.withNullAsUndefined)(r.message),strictEnv:(0,b.withNullAsUndefined)(r.strictEnv),hideFromUser:(0,b.withNullAsUndefined)(r.hideFromUser),isFeatureTerminal:(0,b.withNullAsUndefined)(a?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,b.withNullAsUndefined)(a?.useShellEnvironment),location:a?.location||this._serializeParentTerminal(r.location,a?.resolvedExtHostIdentifier),isTransient:(0,b.withNullAsUndefined)(r.isTransient)})}async createExtensionTerminal(r,a,f,y){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:f,color:p.ThemeColor.isThemeColor(y)?y.id:void 0,location:this._serializeParentTerminal(r,a),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(r,a){return typeof r=="object"?"parentTerminal"in r&&r.parentTerminal&&a?{parentTerminal:a}:"viewColumn"in r?{viewColumn:v.ViewColumn.from(r.viewColumn),preserveFocus:r.preserveFocus}:void 0:r}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(r){this._name=r}setExitStatus(r,a){this._exitStatus=Object.freeze({code:r,reason:a})}setDimensions(r,a){return r===this._cols&&a===this._rows||r===0||a===0?!1:(this._cols=r,this._rows=a,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(r){this._pidPromiseComplete?(this._pidPromiseComplete(r),this._pidPromiseComplete=void 0):this._pidPromise.then(a=>{a!==r&&(this._pidPromise=Promise.resolve(r))})}}e.ExtHostTerminal=h;class c{get onProcessReady(){return this._onProcessReady.event}constructor(r){this._pty=r,this.id=0,this.shouldPersist=!1,this._onProcessData=new l.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new l.Emitter,this._onDidChangeProperty=new l.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new l.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(r){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${r}`)}updateProperty(r,a){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${r}, value: ${a}`)}async start(){}shutdown(){this._pty.close()}input(r){this._pty.handleInput?.(r)}resize(r,a){this._pty.setDimensions?.({columns:r,rows:a})}async processBinary(r){}acknowledgeDataEvent(r){}async setUnicodeVersion(r){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(r){this._pty.onDidWrite(a=>this._onProcessData.fire(a)),this._pty.onDidClose?.((a=void 0)=>{this._onProcessExit.fire(a===void 0?void 0:a)}),this._pty.onDidOverrideDimensions?.(a=>{a&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:a.columns,rows:a.rows}})}),this._pty.onDidChangeName?.(a=>{this._onDidChangeProperty.fire({type:"title",value:a})}),this._pty.open(r||void 0),r&&this._pty.setDimensions?.(r),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=c;let g=1,n=class extends I.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(r=>r.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}constructor(r,a){super(),this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new l.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new l.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new l.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new l.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new l.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new l.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._proxy=a.getProxy(t.MainContext.MainThreadTerminalService),this._bufferer=new E.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new l.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(r),this._register({dispose:()=>{for(const[f,y]of this._terminalProcesses)y.shutdown(!0)}})}getDefaultShell(r){return(r?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(r){return(r?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(r,a){const f=new h(this._proxy,(0,T.generateUuid)(),r,r.name),y=new c(r.pty);return f.createExtensionTerminal(r.location,this._serializeParentTerminal(r,a).resolvedExtHostIdentifier,i(r.iconPath),o(r.color)).then(R=>{const N=this._setupExtHostProcessListeners(R,y);this._terminalProcessDisposables[R]=N}),this._terminals.push(f),f.value}_serializeParentTerminal(r,a){if(a=a||{},r.location&&typeof r.location=="object"&&"parentTerminal"in r.location){const f=r.location.parentTerminal;if(f){const y=this._terminals.find(R=>R.value===f);y&&(a.resolvedExtHostIdentifier=y._id)}}else r.location&&typeof r.location!="object"?a.location=r.location:a.location&&typeof a.location=="object"&&"splitActiveTerminal"in a.location&&(a.location={splitActiveTerminal:!0});return a}attachPtyToTerminal(r,a){if(!this._getTerminalById(r))throw new Error(`Cannot resolve terminal with id ${r} for virtual process`);const y=new c(a),R=this._setupExtHostProcessListeners(r,y);this._terminalProcessDisposables[r]=R}async $acceptActiveTerminalChanged(r){const a=this._activeTerminal;if(r===null){this._activeTerminal=void 0,a!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const f=this._getTerminalById(r);f&&(this._activeTerminal=f,a!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(r,a){const f=this._getTerminalById(r);f&&this._onDidWriteTerminalData.fire({terminal:f.value,data:a})}async $acceptTerminalDimensions(r,a,f){const y=this._getTerminalById(r);y&&y.setDimensions(a,f)&&this._onDidChangeTerminalDimensions.fire({terminal:y.value,dimensions:y.value.dimensions})}async $acceptTerminalMaximumDimensions(r,a,f){this._terminalProcesses.get(r)?.resize(a,f)}async $acceptTerminalTitleChange(r,a){const f=this._getTerminalById(r);f&&(f.name=a)}async $acceptTerminalClosed(r,a,f){const y=this._getTerminalObjectIndexById(this._terminals,r);if(y!==null){const R=this._terminals.splice(y,1)[0];R.setExitStatus(a,f),this._onDidCloseTerminal.fire(R.value)}}$acceptTerminalOpened(r,a,f,y){if(a){const M=this._getTerminalObjectIndexById(this._terminals,a);if(M!==null){this._terminals[M]._id=r,this._onDidOpenTerminal.fire(this.terminals[M]),this._terminals[M].isOpen=!0;return}}const R={name:y.name,shellPath:y.executable,shellArgs:y.args,cwd:typeof y.cwd=="string"?y.cwd:P.URI.revive(y.cwd),env:y.env,hideFromUser:y.hideFromUser},N=new h(this._proxy,r,R,f);this._terminals.push(N),this._onDidOpenTerminal.fire(N.value),N.isOpen=!0}async $acceptTerminalProcessId(r,a){this._getTerminalById(r)?._setProcessId(a)}async $startExtensionTerminal(r,a){const f=this._getTerminalById(r);if(!f)return{message:(0,k.localize)(0,null,r)};f.isOpen||await new Promise(R=>{const N=this.onDidOpenTerminal(async M=>{M===f.value&&(N.dispose(),R())})});const y=this._terminalProcesses.get(r);y?y.startSendingEvents(a):this._extensionTerminalAwaitingStart[r]={initialDimensions:a}}_setupExtHostProcessListeners(r,a){const f=new I.DisposableStore;f.add(a.onProcessReady(R=>this._proxy.$sendProcessReady(r,R.pid,R.cwd))),f.add(a.onDidChangeProperty(R=>this._proxy.$sendProcessProperty(r,R))),this._bufferer.startBuffering(r,a.onProcessData),f.add(a.onProcessExit(R=>this._onProcessExit(r,R))),this._terminalProcesses.set(r,a);const y=this._extensionTerminalAwaitingStart[r];return y&&a instanceof c&&(a.startSendingEvents(y.initialDimensions),delete this._extensionTerminalAwaitingStart[r]),f}$acceptProcessAckDataEvent(r,a){this._terminalProcesses.get(r)?.acknowledgeDataEvent(a)}$acceptProcessInput(r,a){this._terminalProcesses.get(r)?.input(a)}$acceptTerminalInteraction(r){const a=this._getTerminalById(r);a?.setInteractedWith()&&this._onDidChangeTerminalState.fire(a.value)}$acceptProcessResize(r,a,f){try{this._terminalProcesses.get(r)?.resize(a,f)}catch(y){if(y.code!=="EPIPE"&&y.code!=="ERR_IPC_CHANNEL_CLOSED")throw y}}$acceptProcessShutdown(r,a){this._terminalProcesses.get(r)?.shutdown(a)}$acceptProcessRequestInitialCwd(r){this._terminalProcesses.get(r)?.getInitialCwd().then(a=>this._proxy.$sendProcessProperty(r,{type:"initialCwd",value:a}))}$acceptProcessRequestCwd(r){this._terminalProcesses.get(r)?.getCwd().then(a=>this._proxy.$sendProcessProperty(r,{type:"cwd",value:a}))}$acceptProcessRequestLatency(r){return Promise.resolve(r)}registerLinkProvider(r){return this._linkProviders.add(r),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new w.Disposable(()=>{this._linkProviders.delete(r),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(r,a,f){if(this._profileProviders.has(a))throw new Error(`Terminal profile provider "${a}" already registered`);return this._profileProviders.set(a,f),this._proxy.$registerProfileProvider(a,r.identifier.value),new w.Disposable(()=>{this._profileProviders.delete(a),this._proxy.$unregisterProfileProvider(a)})}async $createContributedProfileTerminal(r,a){const f=new S.CancellationTokenSource().token;let y=await this._profileProviders.get(r)?.provideTerminalProfile(f);if(!f.isCancellationRequested){if(y&&!("options"in y)&&(y={options:y}),!y||!("options"in y))throw new Error(`No terminal profile options provided for id "${r}"`);if("pty"in y.options){this.createExtensionTerminal(y.options,a);return}this.createTerminalFromOptions(y.options,a)}}async $provideLinks(r,a){const f=this._getTerminalById(r);if(!f)return[];this._terminalLinkCache.delete(r),this._terminalLinkCancellationSource.get(r)?.dispose(!0);const R=new S.CancellationTokenSource;this._terminalLinkCancellationSource.set(r,R);const N=[],M={terminal:f.value,line:a},A=[];for(const F of this._linkProviders)A.push(m.Promises.withAsyncBody(async G=>{R.token.onCancellationRequested(()=>G({provider:F,links:[]}));const B=await F.provideTerminalLinks(M,R.token)||[];R.token.isCancellationRequested||G({provider:F,links:B})}));const z=await Promise.all(A);if(R.token.isCancellationRequested)return[];const H=new Map;for(const F of z)F&&F.links.length>0&&N.push(...F.links.map(G=>{const B={id:g++,startIndex:G.startIndex,length:G.length,label:G.tooltip};return H.set(B.id,{provider:F.provider,link:G}),B}));return this._terminalLinkCache.set(r,H),N}$activateLink(r,a){const f=this._terminalLinkCache.get(r)?.get(a);!f||f.provider.handleTerminalLink(f.link)}_onProcessExit(r,a){this._bufferer.stopBuffering(r),this._terminalProcesses.delete(r),delete this._extensionTerminalAwaitingStart[r];const f=this._terminalProcessDisposables[r];f&&(f.dispose(),delete this._terminalProcessDisposables[r]),this._proxy.$sendProcessExit(r,a)}_getTerminalById(r){return this._getTerminalObjectById(this._terminals,r)}_getTerminalObjectById(r,a){const f=this._getTerminalObjectIndexById(r,a);return f!==null?r[f]:null}_getTerminalObjectIndexById(r,a){let f=null;return r.some((y,R)=>y._id===a?(f=R,!0):!1),f}getEnvironmentVariableCollection(r){let a=this._environmentVariableCollections.get(r.identifier.value);return a||(a=new u,this._setEnvironmentVariableCollection(r.identifier.value,a)),a}_syncEnvironmentVariableCollection(r,a){const f=(0,D.serializeEnvironmentVariableCollection)(a.map);this._proxy.$setEnvironmentVariableCollection(r,a.persistent,f.length===0?void 0:f)}$initEnvironmentVariableCollections(r){r.forEach(a=>{const f=a[0],y=new u(a[1]);this._setEnvironmentVariableCollection(f,y)})}$acceptDefaultProfile(r,a){const f=this._defaultProfile;this._defaultProfile=r,this._defaultAutomationProfile=a,f?.path!==r.path&&this._onDidChangeShell.fire(r.path)}_setEnvironmentVariableCollection(r,a){this._environmentVariableCollections.set(r,a),a.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(r,a)})}};n=je([$e(1,_.IExtHostRpcService)],n),e.BaseExtHostTerminalService=n;class u{get persistent(){return this._persistent}set persistent(r){this._persistent=r,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(r){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new l.Emitter,this.map=new Map(r)}get size(){return this.map.size}replace(r,a){this._setIfDiffers(r,{value:a,type:w.EnvironmentVariableMutatorType.Replace})}append(r,a){this._setIfDiffers(r,{value:a,type:w.EnvironmentVariableMutatorType.Append})}prepend(r,a){this._setIfDiffers(r,{value:a,type:w.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(r,a){const f=this.map.get(r);(!f||f.value!==a.value||f.type!==a.type)&&(this.map.set(r,a),this._onDidChangeCollection.fire())}get(r){return this.map.get(r)}forEach(r,a){this.map.forEach((f,y)=>r.call(a,y,f,this))}[Symbol.iterator](){return this.map.entries()}delete(r){this.map.delete(r),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=u;let s=class extends n{constructor(r){super(!1,r)}createTerminal(r,a,f){throw new L.NotSupportedError}createTerminalFromOptions(r,a){throw new L.NotSupportedError}};s=je([$e(0,_.IExtHostRpcService)],s),e.WorkerExtHostTerminalService=s;function i(d){if(!(!d||typeof d=="string"))return"id"in d?{id:d.id,color:d.color}:d}function o(d){return p.ThemeColor.isThemeColor(d)?d:void 0}});var Be=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)},tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,l):C?C.value=l:e.set(J,l),l};define(De[258],Ie([1,0,17,23,21,4,60,78,6,24,16,34,5,14,134,15,7,55,89,64]),function(J,e,l,t,C,P,_,I,w,k,L,D,S,T,E,p,b,m,v,h){"use strict";var c,g;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let n=class{constructor(M,A,z){this.editors=z,this.resultsChangedEmitter=new P.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=M.getProxy(S.MainContext.MainThreadTesting),this.observer=new f(this.proxy),this.runTracker=new s(this.proxy),A.registerArgumentProcessor({processArgument:H=>{if(H?.$mid!==13)return H;const F=H,G=F.tests[F.tests.length-1].item.extId;return this.controllers.get(m.TestId.root(G))?.collection.tree.get(G)?.actual??(0,E.toItemFromContext)(H)}})}createTestController(M,A,z){if(this.controllers.has(M))throw new Error(`Attempt to insert a duplicate controller with ID "${M}"`);const H=new w.DisposableStore,F=H.add(new E.ExtHostTestItemCollection(M,A,this.editors));F.root.label=A;const G=new Map,B=this.proxy,U={items:F.root.children,get label(){return A},set label($){A=$,F.root.label=$,B.$updateController(M,{label:A})},get refreshHandler(){return z},set refreshHandler($){z=$,B.$updateController(M,{canRefresh:!!$})},get id(){return M},createRunProfile:($,Q,K,de,te)=>{let he=(0,I.hash)($);for(;G.has(he);)he++;return new y(this.proxy,G,M,he,$,Q,K,de,te)},createTestItem($,Q,K){return new E.TestItemImpl(M,$,Q,K)},createTestRun:($,Q,K=!0)=>this.runTracker.createTestRun(M,F,$,Q,K),set resolveHandler($){F.resolveHandler=$},get resolveHandler(){return F.resolveHandler},dispose:()=>{H.dispose()}};B.$registerTestController(M,A,!!z),H.add((0,w.toDisposable)(()=>B.$unregisterTestController(M)));const x={controller:U,collection:F,profiles:G};return this.controllers.set(M,x),H.add((0,w.toDisposable)(()=>this.controllers.delete(M))),H.add(F.onDidGenerateDiff($=>B.$publishDiff(M,$.map(h.TestsDiffOp.serialize)))),U}createTestObserver(){return this.observer.checkout()}async runTests(M,A=C.CancellationToken.None){const z=i(M);if(!z)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const H=this.controllers.get(z.controllerId);if(!H)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:M.include?.map(F=>m.TestId.fromExtHostTestItem(F,H.collection.root.id).toString())??[H.collection.root.id],profileGroup:R[z.kind],profileId:z.profileId,controllerId:z.controllerId}],exclude:M.exclude?.map(F=>F.id)},A)}$provideFileCoverage(M,A,z){return(0,l.mapFind)(this.runTracker.trackers,F=>F.id===M?F.getCoverage(A):void 0)?.provideFileCoverage(z)??Promise.resolve([])}$resolveFileCoverage(M,A,z,H){return(0,l.mapFind)(this.runTracker.trackers,G=>G.id===M?G.getCoverage(A):void 0)?.resolveFileCoverage(z,H)??Promise.resolve([])}$configureRunProfile(M,A){this.controllers.get(M)?.profiles.get(A)?.configureHandler?.()}async $refreshTests(M,A){await this.controllers.get(M)?.controller.refreshHandler?.(A)}$publishTestResults(M){this.results=Object.freeze(M.map(A=>(0,k.deepFreeze)(p.TestResults.to(A))).concat(this.results).sort((A,z)=>z.completedAt-A.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(M,A){const z=this.controllers.get(m.TestId.fromString(M).controllerId)?.collection;z&&(await z.expand(M,A<0?1/0:A),z.flushDiff())}$acceptDiff(M){this.observer.applyDiff(M.map(h.TestsDiffOp.deserialize))}async $runControllerTests(M,A){return Promise.all(M.map(z=>this.runControllerTestRequest(z,A)))}async runControllerTestRequest(M,A){const z=this.controllers.get(M.controllerId);if(!z)return{};const{collection:H,profiles:F}=z,G=F.get(M.profileId);if(!G)return{};const B=M.testIds.map(Q=>H.tree.get(Q)).filter(L.isDefined),U=M.excludeExtIds.map(Q=>z.collection.tree.get(Q)).filter(L.isDefined).filter(Q=>B.some(K=>K.fullId.compare(Q.fullId)===2));if(!B.length)return{};const x=new b.TestRunRequest(B.some(Q=>Q.actual instanceof E.TestItemRootImpl)?void 0:B.map(Q=>Q.actual),U.map(Q=>Q.actual),G),$=this.runTracker.prepareForMainThreadTestRun(x,o.fromInternal(M,z.collection),A);try{return await G.runHandler(x,A),{}}catch(Q){return{error:String(Q)}}finally{$.isRunning&&!A.isCancellationRequested&&await P.Event.toPromise($.onEnd),$.dispose()}}$cancelExtensionTestRun(M){M===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(M)}};n=je([$e(0,T.IExtHostRpcService)],n),e.ExtHostTesting=n;class u extends w.Disposable{get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}constructor(M,A,z){super(),this.dto=M,this.proxy=A,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new P.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new C.CancellationTokenSource(z)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:H}of this.tasks.values())H.end()}))}getCoverage(M){return this.tasks.get(M)?.coverage}createRun(M){const A=this.dto.id,z=this.dto.controllerId,H=(0,D.generateUuid)(),F=new d(this.proxy,A,H),G=$=>(Q,...K)=>{if(U){console.warn(`Setting the state of test "${Q.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(Q)||(this.ensureTestIsKnown(Q),$(Q,...K))},B=($,Q)=>{const K=Q instanceof Array?Q.map(p.TestMessage.from):[p.TestMessage.from(Q)];if($.uri&&$.range){const de={range:p.Range.from($.range),uri:$.uri};for(const te of K)te.location=te.location||de}this.proxy.$appendTestMessagesInRun(A,H,m.TestId.fromExtHostTestItem($,z).toString(),K)};let U=!1;const x={isPersisted:this.dto.isPersisted,token:this.cts.token,name:M,get coverageProvider(){return F.coverageProvider},set coverageProvider($){F.coverageProvider=$},enqueued:G($=>{this.proxy.$updateTestStateInRun(A,H,m.TestId.fromExtHostTestItem($,z).toString(),1)}),skipped:G($=>{this.proxy.$updateTestStateInRun(A,H,m.TestId.fromExtHostTestItem($,z).toString(),5)}),started:G($=>{this.proxy.$updateTestStateInRun(A,H,m.TestId.fromExtHostTestItem($,z).toString(),2)}),errored:G(($,Q,K)=>{B($,Q),this.proxy.$updateTestStateInRun(A,H,m.TestId.fromExtHostTestItem($,z).toString(),6,K)}),failed:G(($,Q,K)=>{B($,Q),this.proxy.$updateTestStateInRun(A,H,m.TestId.fromExtHostTestItem($,z).toString(),4,K)}),passed:G(($,Q)=>{this.proxy.$updateTestStateInRun(A,H,m.TestId.fromExtHostTestItem($,this.dto.controllerId).toString(),3,Q)}),appendOutput:($,Q,K)=>{U||(K&&(this.dto.isIncluded(K)?this.ensureTestIsKnown(K):K=void 0),this.proxy.$appendOutputToRun(A,H,t.VSBuffer.fromString($),Q&&p.location.from(Q),K&&m.TestId.fromExtHostTestItem(K,z).toString()))},end:()=>{U||(U=!0,this.proxy.$finishedTestRunTask(A,H),this.tasks.delete(H),this.isRunning||this.dispose())}};return this.tasks.set(H,{run:x,coverage:F}),this.proxy.$startedTestRunTask(A,{id:H,name:M,running:!0}),x}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(M){if(!(M instanceof E.TestItemImpl))throw new v.InvalidTestItemError(M.id);if(this.sharedTestIds.has(m.TestId.fromExtHostTestItem(M,this.dto.controllerId).toString()))return;const A=[],z=this.dto.colllection.root;for(;;){const H=p.TestItem.from(M);if(A.unshift(H),this.sharedTestIds.has(H.extId)||(this.sharedTestIds.add(H.extId),M===z))break;M=M.parent||z}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,A)}}class s{get trackers(){return this.tracked.values()}constructor(M){this.proxy=M,this.tracked=new Map}prepareForMainThreadTestRun(M,A,z){return this.getTracker(M,A,z)}cancelRunById(M){for(const A of this.tracked.values())if(A.id===M){A.dispose();return}}cancelAllRuns(){for(const M of this.tracked.values())M.dispose()}createTestRun(M,A,z,H,F){const G=this.tracked.get(z);if(G)return G.createRun(H);const B=o.fromPublic(M,A,z,F),U=i(z);this.proxy.$startedExtensionTestRun({controllerId:M,profile:U&&{group:R[U.kind],id:U.profileId},exclude:z.exclude?.map($=>m.TestId.fromExtHostTestItem($,A.root.id).toString())??[],id:B.id,include:z.include?.map($=>m.TestId.fromExtHostTestItem($,A.root.id).toString())??[A.root.id],persist:F});const x=this.getTracker(z,B);return x.onEnd(()=>this.proxy.$finishedExtensionTestRun(B.id)),x.createRun(H)}getTracker(M,A,z){const H=new u(A,this.proxy,z);return this.tracked.set(M,H),H.onEnd(()=>this.tracked.delete(M)),H}}e.TestRunCoordinator=s;const i=N=>{if(!!N.profile){if(!(N.profile instanceof y))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return N.profile}};class o{static fromPublic(M,A,z,H){return new o(M,(0,D.generateUuid)(),z.include?.map(F=>m.TestId.fromExtHostTestItem(F,M).toString())??[M],z.exclude?.map(F=>m.TestId.fromExtHostTestItem(F,M).toString())??[],H,A)}static fromInternal(M,A){return new o(M.controllerId,M.runId,M.testIds,M.excludeExtIds,!0,A)}constructor(M,A,z,H,F,G){this.controllerId=M,this.id=A,this.isPersisted=F,this.colllection=G,this.includePrefix=z.map(B=>B+"\0"),this.excludePrefix=H.map(B=>B+"\0")}isIncluded(M){const A=m.TestId.fromExtHostTestItem(M,this.controllerId).toString()+"\0";for(const z of this.excludePrefix)if(A===z||A.startsWith(z))return!1;for(const z of this.includePrefix)if(A===z||A.startsWith(z))return!0;return!1}}e.TestRunDto=o;class d{set coverageProvider(M){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!M||(this._coverageProvider=M,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}constructor(M,A,z){this.proxy=M,this.runId=A,this.taskId=z}async provideFileCoverage(M){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(M))());try{return(await this.fileCoverage)?.map(p.TestCoverage.fromFile)??[]}catch(A){throw this.fileCoverage=void 0,A}}async resolveFileCoverage(M,A){const z=await this.fileCoverage;let H=z?.[M];return!this._coverageProvider||!z||!H?[]:(H.detailedCoverage||(H=z[M]=await this._coverageProvider.resolveFileCoverage?.(H,A)??H),H.detailedCoverage?.map(p.TestCoverage.fromDetailed)??[])}}class r extends h.IncrementalChangeCollector{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(M){super(),this.emitter=M,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(M){this.added.add(M)}update(M){Object.assign(M.revived,p.TestItem.toPlain(M.item)),this.added.has(M)||this.updated.add(M)}remove(M){if(this.added.has(M)){this.added.delete(M);return}this.updated.delete(M);const A=m.TestId.parentId(M.item.extId);if(A&&this.alreadyRemoved.has(A.toString())){this.alreadyRemoved.add(M.item.extId);return}this.removed.add(M)}getChangeEvent(){const{added:M,updated:A,removed:z}=this;return{get added(){return[...M].map(H=>H.revived)},get updated(){return[...A].map(H=>H.revived)},get removed(){return[...z].map(H=>H.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class a extends h.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new P.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(M){return this.items.get(M)}getMirroredTestDataByReference(M){return this.items.get(M.id)}createItem(M,A){return{...M,revived:p.TestItem.toPlain(M.item),depth:A?A.depth+1:0,children:new Set}}createChangeCollector(){return new r(this.changeEmitter)}}e.MirroredTestCollection=a;class f{constructor(M){this.proxy=M}checkout(){this.current||(this.current=this.createObserverData());const M=this.current;return M.observers++,{onDidChangeTest:M.tests.onDidChangeTests,get tests(){return[...M.tests.rootTests].map(A=>A.revived)},dispose:(0,_.once)(()=>{--M.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(M){return this.current?.tests.getMirroredTestDataByReference(M)}applyDiff(M){this.current?.tests.apply(M)}createObserverData(){const M=new a;return this.proxy.$subscribeToDiffs(),{observers:0,tests:M}}}class y{get label(){return this._label}set label(M){M!==this._label&&(this._label=M,Be(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:M}))}get isDefault(){return this._isDefault}set isDefault(M){M!==this._isDefault&&(this._isDefault=M,Be(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:M}))}get tag(){return this._tag}set tag(M){M?.id!==this._tag?.id&&(this._tag=M,Be(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:M?p.TestTag.namespace(this.controllerId,M.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(M){M!==this._configureHandler&&(this._configureHandler=M,Be(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!M}))}constructor(M,A,z,H,F,G,B,U=!1,x=void 0){this.controllerId=z,this.profileId=H,this._label=F,this.kind=G,this.runHandler=B,this._isDefault=U,this._tag=x,c.set(this,void 0),g.set(this,void 0),tt(this,c,M,"f"),tt(this,g,A,"f"),A.set(H,this);const $=R[G];if(typeof $!="number")throw new Error(`Unknown TestRunProfile.group ${G}`);Be(this,c,"f").$publishTestRunProfile({profileId:H,controllerId:z,tag:x?p.TestTag.namespace(this.controllerId,x.id):null,label:F,group:$,isDefault:U,hasConfigurationHandler:!1})}dispose(){Be(this,g,"f")?.delete(this.profileId)&&(tt(this,g,void 0,"f"),Be(this,c,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=y,c=new WeakMap,g=new WeakMap;const R={[b.TestRunProfileKind.Coverage]:8,[b.TestRunProfileKind.Debug]:4,[b.TestRunProfileKind.Run]:2}}),define(De[259],Ie([1,0,17,4,5,135,15,7]),function(J,e,l,t,C,P,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class w{constructor(L,D){this._extHostDocumentsAndEditors=D,this._onDidChangeTextEditorSelection=new t.Emitter,this._onDidChangeTextEditorOptions=new t.Emitter,this._onDidChangeTextEditorVisibleRanges=new t.Emitter,this._onDidChangeTextEditorViewColumn=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=L.getProxy(C.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(S=>this._onDidChangeVisibleTextEditors.fire(S)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(S=>this._onDidChangeActiveTextEditor.fire(S))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(L){const D=this._extHostDocumentsAndEditors.allEditors();return L?D:D.map(S=>S.value)}async showTextDocument(L,D,S){let T;typeof D=="number"?T={position:_.ViewColumn.from(D),preserveFocus:S}:typeof D=="object"?T={position:_.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selection:typeof D.selection=="object"?_.Range.from(D.selection):void 0,pinned:typeof D.preview=="boolean"?!D.preview:void 0}:T={preserveFocus:!1};const E=await this._proxy.$tryShowTextDocument(L.uri,T),p=E&&this._extHostDocumentsAndEditors.getEditor(E);if(p)return p.value;throw E?new Error(`Could NOT open editor for "${L.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${L.uri.toString()}".`)}createTextEditorDecorationType(L,D){return new P.TextEditorDecorationType(this._proxy,L,D).value}$acceptEditorPropertiesChanged(L,D){const S=this._extHostDocumentsAndEditors.getEditor(L);if(!S)throw new Error("unknown text editor");if(D.options&&S._acceptOptions(D.options),D.selections){const T=D.selections.selections.map(_.Selection.to);S._acceptSelections(T)}if(D.visibleRanges){const T=l.coalesce(D.visibleRanges.map(_.Range.to));S._acceptVisibleRanges(T)}if(D.options&&this._onDidChangeTextEditorOptions.fire({textEditor:S.value,options:{...D.options,lineNumbers:_.TextEditorLineNumbersStyle.to(D.options.lineNumbers)}}),D.selections){const T=I.TextEditorSelectionChangeKind.fromValue(D.selections.source),E=D.selections.selections.map(_.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:S.value,selections:E,kind:T})}if(D.visibleRanges){const T=l.coalesce(D.visibleRanges.map(_.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:S.value,visibleRanges:T})}}$acceptEditorPositionData(L){for(const D in L){const S=this._extHostDocumentsAndEditors.getEditor(D);if(!S)throw new Error("Unknown text editor");const T=_.ViewColumn.to(L[D]);S.value.viewColumn!==T&&(S._acceptViewColumn(T),this._onDidChangeTextEditorViewColumn.fire({textEditor:S.value,viewColumn:T}))}}getDiffInformation(L){return Promise.resolve(this._proxy.$getDiffInformation(L))}}e.ExtHostEditors=w}),define(De[260],Ie([1,0,2,3,5,6,7,15,16]),function(J,e,l,t,C,P,_,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class k{constructor(S,T){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=S.getProxy(C.MainContext.MainThreadTimeline),T.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===11){const p=E.uri===void 0?void 0:l.URI.revive(E.uri);return this._itemsBySourceAndUriMap.get(E.source)?.get(L(p))?.get(E.handle)}return E}})}async $getTimeline(S,T,E,p){return this._providers.get(S)?.provideTimeline(l.URI.revive(T),E,p)}registerTimelineProvider(S,T,E,p){const b=new P.DisposableStore,m=this.convertTimelineItem(T.id,p,b).bind(this);let v;T.onDidChange&&(v=T.onDidChange(c=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...c,id:T.id}),this));const h=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...T,scheme:S,onDidChange:void 0,async provideTimeline(c,g,n){g?.resetCache&&(b.clear(),h.get(T.id)?.clear());const u=await T.provideTimeline(c,g,n);if(u==null)return;const s=m(c,g);return{...u,source:T.id,items:u.items.map(s)}},dispose(){for(const c of h.values())c.get(T.id)?.clear();v?.dispose(),b.dispose()}})}convertTimelineItem(S,T,E){return(p,b)=>{let m;if(b?.cacheResults){let v=this._itemsBySourceAndUriMap.get(S);v===void 0&&(v=new Map,this._itemsBySourceAndUriMap.set(S,v));const h=L(p);m=v.get(h),m===void 0&&(m=new Map,v.set(h,m))}return v=>{const{iconPath:h,...c}=v,g=`${S}|${v.id??v.timestamp}`;m?.set(g,v);let n,u,s;v.iconPath&&(h instanceof _.ThemeIcon?s={id:h.id,color:h.color}:l.URI.isUri(h)?(n=h,u=h):{light:n,dark:u}=h);let i;return _.MarkdownString.isMarkdownString(c.tooltip)?i=I.MarkdownString.from(c.tooltip):(0,w.isString)(c.tooltip)?i=c.tooltip:_.MarkdownString.isMarkdownString(c.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),i=I.MarkdownString.from(c.detail)):(0,w.isString)(c.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),i=c.detail),{...c,id:c.id??void 0,handle:g,source:S,command:v.command?T.toInternal(v.command,E):void 0,icon:n,iconDark:u,themeIcon:s,tooltip:i,accessibilityInformation:v.accessibilityInformation}}}}registerTimelineProviderCore(S){if(this._providers.get(S.id))throw new Error(`Timeline Provider ${S.id} already exists.`);return this._proxy.$registerTimelineProvider({id:S.id,label:S.label,scheme:S.scheme}),this._providers.set(S.id,S),(0,P.toDisposable)(()=>{for(const E of this._itemsBySourceAndUriMap.values())E.get(S.id)?.clear();this._providers.delete(S.id),this._proxy.$unregisterTimelineProvider(S.id),S.dispose()})}}e.ExtHostTimeline=k;function L(D){return D?.toString()}}),define(De[261],Ie([1,0,6,12,2,5]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class _{constructor(w){this._openers=new Map,this._proxy=w.getProxy(P.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(w,k,L,D){if(this._openers.has(k))throw new Error(`Opener with id '${k}' already registered`);const S=D.schemes.find(T=>!_.supportedSchemes.has(T));if(S)throw new Error(`Scheme '${S}' is not supported. Only http and https are currently supported.`);return this._openers.set(k,L),this._proxy.$registerUriOpener(k,D.schemes,w,D.label),(0,l.toDisposable)(()=>{this._openers.delete(k),this._proxy.$unregisterUriOpener(k)})}async $canOpenUri(w,k,L){const D=this._openers.get(w);if(!D)throw new Error(`Unknown opener with id: ${w}`);const S=C.URI.revive(k);return D.canOpenExternalUri(S,L)}async $openUri(w,k,L){const D=this._openers.get(w);if(!D)throw new Error(`Unknown opener id: '${w}'`);return D.openExternalUri(C.URI.revive(k.resolvedUri),{sourceUri:C.URI.revive(k.sourceUri)},L)}}e.ExtHostUriOpeners=_,_.supportedSchemes=new Set([t.Schemas.http,t.Schemas.https])}),define(De[262],Ie([1,0,5,2,6,10,27]),function(J,e,l,t,C,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class I{constructor(k){this.handles=new Set,this.handlers=new Map,this._proxy=k.getProxy(l.MainContext.MainThreadUrls)}registerUriHandler(k,L){if(this.handles.has(_.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const D=I.HandlePool++;return this.handles.add(_.ExtensionIdentifier.toKey(k)),this.handlers.set(D,L),this._proxy.$registerUriHandler(D,k),(0,C.toDisposable)(()=>{this.handles.delete(_.ExtensionIdentifier.toKey(k)),this.handlers.delete(D),this._proxy.$unregisterUriHandler(D)})}$handleExternalUri(k,L){const D=this.handlers.get(k);if(!D)return Promise.resolve(void 0);try{D.handleUri(t.URI.revive(L))}catch(S){(0,P.onUnexpectedError)(S)}return Promise.resolve(void 0)}async createAppUri(k){return t.URI.revive(await this._proxy.$createAppUri(k))}}e.ExtHostUrls=I,I.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,l):C?C.value=l:e.set(J,l),l},Be=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[68],Ie([1,0,4,12,2,188,207,87,5]),function(J,e,l,t,C,P,_,I,w){"use strict";var k,L,D,S,T,E,p,b,m,v,h,c;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class g{constructor(a,f,y,R,N,M,A){k.set(this,void 0),L.set(this,void 0),D.set(this,void 0),S.set(this,void 0),T.set(this,void 0),E.set(this,void 0),p.set(this,""),b.set(this,void 0),m.set(this,!1),v.set(this,!1),h.set(this,!1),this._onMessageEmitter=new l.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,c.set(this,new l.Emitter),this._onDidDispose=Be(this,c,"f").event,tt(this,k,a,"f"),tt(this,L,f,"f"),tt(this,b,y,"f"),tt(this,S,R,"f"),tt(this,T,N,"f"),tt(this,E,M,"f"),tt(this,h,n(M),"f"),tt(this,D,A,"f")}dispose(){tt(this,m,!0,"f"),Be(this,c,"f").fire(),Be(this,c,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(a){return tt(this,v,!0,"f"),(0,I.asWebviewUri)(a,Be(this,S,"f"))}get cspSource(){const a=Be(this,E,"f").extensionLocation;if(a.scheme===t.Schemas.https||a.scheme===t.Schemas.http){let f=a.toString();return f.endsWith("/")||(f+="/"),f+" "+I.webviewGenericCspSource}return I.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Be(this,p,"f")}set html(a){this.assertNotDisposed(),Be(this,p,"f")!==a&&(tt(this,p,a,"f"),!Be(this,v,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(a)&&(tt(this,v,!0,"f"),Be(this,D,"f").report("Webview vscode-resource: uris",Be(this,E,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Be(this,L,"f").$setHtml(Be(this,k,"f"),a))}get options(){return this.assertNotDisposed(),Be(this,b,"f")}set options(a){this.assertNotDisposed(),Be(this,L,"f").$setOptions(Be(this,k,"f"),i(Be(this,E,"f"),Be(this,T,"f"),a)),tt(this,b,a,"f")}async postMessage(a){if(Be(this,m,"f"))return!1;const f=(0,_.serializeWebviewMessage)(a,{serializeBuffersForPostMessage:Be(this,h,"f")});return Be(this,L,"f").$postMessage(Be(this,k,"f"),f.message,...f.buffers)}assertNotDisposed(){if(Be(this,m,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=g,k=new WeakMap,L=new WeakMap,D=new WeakMap,S=new WeakMap,T=new WeakMap,E=new WeakMap,p=new WeakMap,b=new WeakMap,m=new WeakMap,v=new WeakMap,h=new WeakMap,c=new WeakMap;function n(r){try{const a=(0,P.normalizeVersion)((0,P.parseVersion)(r.engines.vscode));return!!a&&a.majorBase>=1&&a.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=n;class u{constructor(a,f,y,R,N){this.remoteInfo=f,this.workspace=y,this._logService=R,this._deprecationService=N,this._webviews=new Map,this._webviewProxy=a.getProxy(w.MainContext.MainThreadWebviews)}$onMessage(a,f,y){const R=this.getWebview(a);if(R){const{message:N}=(0,_.deserializeWebviewMessage)(f,y.value);R._onMessageEmitter.fire(N)}}$onMissingCsp(a,f){this._logService.warn(`${f} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(a,f,y){const R=new g(a,this._webviewProxy,o(f),this.remoteInfo,this.workspace,y,this._deprecationService);return this._webviews.set(a,R),R._onDidDispose(()=>{this._webviews.delete(a)}),R}deleteWebview(a){this._webviews.delete(a)}getWebview(a){return this._webviews.get(a)}}e.ExtHostWebviews=u;function s(r){return{id:r.identifier,location:r.extensionLocation}}e.toExtensionData=s;function i(r,a,f){return{enableCommandUris:f.enableCommandUris,enableScripts:f.enableScripts,enableForms:f.enableForms,portMapping:f.portMapping,localResourceRoots:f.localResourceRoots||d(r,a)}}e.serializeWebviewOptions=i;function o(r){return{enableCommandUris:r.enableCommandUris,enableScripts:r.enableScripts,enableForms:r.enableForms,portMapping:r.portMapping,localResourceRoots:r.localResourceRoots?.map(a=>C.URI.from(a))}}e.reviveOptions=o;function d(r,a){return[...(a?.getWorkspaceFolders()||[]).map(f=>f.uri),r.extensionLocation]}}),define(De[263],Ie([1,0,21,78,6,12,22,2,15,68,86,5,7]),function(J,e,l,t,C,P,_,I,w,k,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class T{constructor(n,u){this.document=n,this._storagePath=u,this._backupCounter=1,this._edits=new L.Cache("custom documents")}addEdit(n){return this._edits.add([n])}async undo(n,u){await this.getEdit(n).undo(),u||this.disposeBackup()}async redo(n,u){await this.getEdit(n).redo(),u||this.disposeBackup()}disposeEdits(n){for(const u of n)this._edits.delete(u)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const n=c(this.document.uri)+this._backupCounter++;return(0,_.joinPath)(this._storagePath,n)}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(n){const u=this._edits.get(n,0);if(!u)throw new Error("No edit found");return u}}class E{constructor(){this._documents=new Map}get(n,u){return this._documents.get(this.key(n,u))}add(n,u,s){const i=this.key(n,u.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${n} resource:${u.uri}`);const o=new T(u,s);return this._documents.set(i,o),o}delete(n,u){const s=this.key(n,u.uri);this._documents.delete(s)}key(n,u){return`${n}@@@${u}`}}var p;(function(g){g[g.Text=0]="Text",g[g.Custom=1]="Custom"})(p||(p={}));class b{constructor(){this._providers=new Map}addTextProvider(n,u,s){return this.add(0,n,u,s)}addCustomProvider(n,u,s){return this.add(1,n,u,s)}get(n){return this._providers.get(n)}add(n,u,s,i){if(this._providers.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this._providers.set(u,{type:n,extension:s,provider:i}),new S.Disposable(()=>this._providers.delete(u))}}class m{constructor(n,u,s,i,o){this._extHostDocuments=u,this._extensionStoragePaths=s,this._extHostWebview=i,this._extHostWebviewPanels=o,this._editorProviders=new b,this._documents=new E,this._proxy=n.getProxy(D.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(n,u,s,i){const o=new C.DisposableStore;return v(s)?(o.add(this._editorProviders.addTextProvider(u,n,s)),this._proxy.$registerTextEditorProvider((0,k.toExtensionData)(n),u,i.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(n))):(o.add(this._editorProviders.addCustomProvider(u,n,s)),this.supportEditing(s)&&o.add(s.onDidChangeCustomDocument(d=>{const r=this.getCustomDocumentEntry(u,d.document.uri);if(h(d)){const a=r.addEdit(d);this._proxy.$onDidEdit(d.document.uri,u,a,d.label)}else this._proxy.$onContentChange(d.document.uri,u)})),this._proxy.$registerCustomEditorProvider((0,k.toExtensionData)(n),u,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(n))),S.Disposable.from(o,new S.Disposable(()=>{this._proxy.$unregisterEditorProvider(u)}))}async $createCustomDocument(n,u,s,i,o){const d=this._editorProviders.get(u);if(!d)throw new Error(`No provider found for '${u}'`);if(d.type!==1)throw new Error(`Invalid provide type for '${u}'`);const r=I.URI.revive(n),a=await d.provider.openCustomDocument(r,{backupId:s,untitledDocumentData:i?.buffer},o);let f;return this.supportEditing(d.provider)&&this._extensionStoragePaths&&(f=this._extensionStoragePaths.workspaceValue(d.extension)??this._extensionStoragePaths.globalValue(d.extension)),this._documents.add(u,a,f),{editable:this.supportEditing(d.provider)}}async $disposeCustomDocument(n,u){const s=this._editorProviders.get(u);if(!s)throw new Error(`No provider found for '${u}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${u}'`);const i=I.URI.revive(n),{document:o}=this.getCustomDocumentEntry(u,i);this._documents.delete(u,o),o.dispose()}async $resolveWebviewEditor(n,u,s,i,o,d){const r=this._editorProviders.get(s);if(!r)throw new Error(`No provider found for '${s}'`);const a=w.ViewColumn.to(o),f=this._extHostWebview.createNewWebview(u,i.webviewOptions,r.extension),y=this._extHostWebviewPanels.createNewWebviewPanel(u,s,i.title,a,i.panelOptions,f,!0),R=I.URI.revive(n);switch(r.type){case 1:{const{document:N}=this.getCustomDocumentEntry(s,R);return r.provider.resolveCustomEditor(N,y,d)}case 0:{const N=this._extHostDocuments.getDocument(R);return r.provider.resolveCustomTextEditor(N,y,d)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(n,u,s){this.getCustomDocumentEntry(u,n).disposeEdits(s)}async $onMoveCustomEditor(n,u,s){const i=this._editorProviders.get(s);if(!i)throw new Error(`No provider found for '${s}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const o=this._extHostWebviewPanels.getWebviewPanel(n);if(!o)throw new Error("No webview found");const d=I.URI.revive(u),r=this._extHostDocuments.getDocument(d);await i.provider.moveCustomTextEditor(r,o,l.CancellationToken.None)}async $undo(n,u,s,i){return this.getCustomDocumentEntry(u,n).undo(s,i)}async $redo(n,u,s,i){return this.getCustomDocumentEntry(u,n).redo(s,i)}async $revert(n,u,s){const i=this.getCustomDocumentEntry(u,n);await this.getCustomEditorProvider(u).revertCustomDocument(i.document,s),i.disposeBackup()}async $onSave(n,u,s){const i=this.getCustomDocumentEntry(u,n);await this.getCustomEditorProvider(u).saveCustomDocument(i.document,s),i.disposeBackup()}async $onSaveAs(n,u,s,i){const o=this.getCustomDocumentEntry(u,n);return this.getCustomEditorProvider(u).saveCustomDocumentAs(o.document,I.URI.revive(s),i)}async $backup(n,u,s){const i=this.getCustomDocumentEntry(u,n),d=await this.getCustomEditorProvider(u).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},s);return i.updateBackup(d),d.id}getCustomDocumentEntry(n,u){const s=this._documents.get(n,I.URI.revive(u));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(n){const s=this._editorProviders.get(n)?.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(n){return!!n.onDidChangeCustomDocument}}e.ExtHostCustomEditors=m;function v(g){return typeof g.resolveCustomTextEditor=="function"}function h(g){return typeof g.undo=="function"&&typeof g.redo=="function"}function c(g){const n=g.scheme===P.Schemas.file||g.scheme===P.Schemas.untitled?g.fsPath:g.toString();return(0,t.hash)(n)+""}});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,l):C?C.value=l:e.set(J,l),l},Be=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[264],Ie([1,0,4,6,2,34,15,68,5,7]),function(J,e,l,t,C,P,_,I,w,k){"use strict";var L,D,S,T,E,p,b,m,v,h,c,g,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class u extends t.Disposable{constructor(d,r,a,f){super(),L.set(this,void 0),D.set(this,void 0),S.set(this,void 0),T.set(this,void 0),E.set(this,void 0),p.set(this,void 0),b.set(this,void 0),m.set(this,void 0),v.set(this,!0),h.set(this,void 0),c.set(this,!1),g.set(this,this._register(new l.Emitter)),this.onDidDispose=Be(this,g,"f").event,n.set(this,this._register(new l.Emitter)),this.onDidChangeViewState=Be(this,n,"f").event,tt(this,L,d,"f"),tt(this,D,r,"f"),tt(this,T,a,"f"),tt(this,S,f.viewType,"f"),tt(this,E,f.panelOptions,"f"),tt(this,m,f.viewColumn,"f"),tt(this,p,f.title,"f"),tt(this,h,f.active,"f")}dispose(){Be(this,c,"f")||(tt(this,c,!0,"f"),Be(this,g,"f").fire(),Be(this,D,"f").$disposeWebview(Be(this,L,"f")),Be(this,T,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Be(this,T,"f")}get viewType(){return this.assertNotDisposed(),Be(this,S,"f")}get title(){return this.assertNotDisposed(),Be(this,p,"f")}set title(d){this.assertNotDisposed(),Be(this,p,"f")!==d&&(tt(this,p,d,"f"),Be(this,D,"f").$setTitle(Be(this,L,"f"),d))}get iconPath(){return this.assertNotDisposed(),Be(this,b,"f")}set iconPath(d){this.assertNotDisposed(),Be(this,b,"f")!==d&&(tt(this,b,d,"f"),Be(this,D,"f").$setIconPath(Be(this,L,"f"),C.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return Be(this,E,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Be(this,m,"f")=="number"&&Be(this,m,"f")<0))return Be(this,m,"f")}get active(){return this.assertNotDisposed(),Be(this,h,"f")}get visible(){return this.assertNotDisposed(),Be(this,v,"f")}_updateViewState(d){Be(this,c,"f")||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(tt(this,h,d.active,"f"),tt(this,v,d.visible,"f"),tt(this,m,d.viewColumn,"f"),Be(this,n,"f").fire({webviewPanel:this}))}reveal(d,r){this.assertNotDisposed(),Be(this,D,"f").$reveal(Be(this,L,"f"),{viewColumn:typeof d>"u"?void 0:_.ViewColumn.from(d),preserveFocus:!!r})}assertNotDisposed(){if(Be(this,c,"f"))throw new Error("Webview is disposed")}}L=new WeakMap,D=new WeakMap,S=new WeakMap,T=new WeakMap,E=new WeakMap,p=new WeakMap,b=new WeakMap,m=new WeakMap,v=new WeakMap,h=new WeakMap,c=new WeakMap,g=new WeakMap,n=new WeakMap;class s{static newHandle(){return(0,P.generateUuid)()}constructor(d,r,a){this.webviews=r,this.workspace=a,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=d.getProxy(w.MainContext.MainThreadWebviewPanels)}createWebviewPanel(d,r,a,f,y={}){const R=typeof f=="object"?f.viewColumn:f,N={viewColumn:_.ViewColumn.from(R),preserveFocus:typeof f=="object"&&!!f.preserveFocus},M=(0,I.shouldSerializeBuffersForPostMessage)(d),A=s.newHandle();this._proxy.$createWebviewPanel((0,I.toExtensionData)(d),A,r,{title:a,panelOptions:i(y),webviewOptions:(0,I.serializeWebviewOptions)(d,this.workspace,y),serializeBuffersForPostMessage:M},N);const z=this.webviews.createNewWebview(A,y,d);return this.createNewWebviewPanel(A,r,a,R,y,z,!0)}$onDidChangeWebviewPanelViewStates(d){const r=Object.keys(d);r.sort((a,f)=>{const y=d[a],R=d[f];return y.active?1:R.active?-1:+y.visible-+R.visible});for(const a of r){const f=this.getWebviewPanel(a);if(!f)continue;const y=d[a];f._updateViewState({active:y.active,visible:y.visible,viewColumn:_.ViewColumn.to(y.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this._webviewPanels.delete(d),this.webviews.deleteWebview(d)}registerWebviewPanelSerializer(d,r,a){if(this._serializers.has(r))throw new Error(`Serializer for '${r}' already registered`);return this._serializers.set(r,{serializer:a,extension:d}),this._proxy.$registerSerializer(r,{serializeBuffersForPostMessage:(0,I.shouldSerializeBuffersForPostMessage)(d)}),new k.Disposable(()=>{this._serializers.delete(r),this._proxy.$unregisterSerializer(r)})}async $deserializeWebviewPanel(d,r,a,f){const y=this._serializers.get(r);if(!y)throw new Error(`No serializer found for '${r}'`);const{serializer:R,extension:N}=y,M=this.webviews.createNewWebview(d,a.webviewOptions,N),A=this.createNewWebviewPanel(d,r,a.title,f,a.panelOptions,M,a.active);await R.deserializeWebviewPanel(A,a.state)}createNewWebviewPanel(d,r,a,f,y,R,N){const M=new u(d,this._proxy,R,{viewType:r,title:a,viewColumn:f,panelOptions:y,active:N});return this._webviewPanels.set(d,M),M}getWebviewPanel(d){return this._webviewPanels.get(d)}}e.ExtHostWebviewPanels=s;function i(o){return{enableFindWidget:o.enableFindWidget,retainContextWhenHidden:o.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,l):C?C.value=l:e.set(J,l),l},Be=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[265],Ie([1,0,4,6,68,15,5,7]),function(J,e,l,t,C,P,_,I){"use strict";var w,k,L,D,S,T,E,p,b,m,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class h extends t.Disposable{constructor(n,u,s,i,o,d,r){super(),w.set(this,void 0),k.set(this,void 0),L.set(this,void 0),D.set(this,void 0),S.set(this,!1),T.set(this,void 0),E.set(this,void 0),p.set(this,void 0),b.set(this,void 0),m.set(this,this._register(new l.Emitter)),this.onDidChangeVisibility=Be(this,m,"f").event,v.set(this,this._register(new l.Emitter)),this.onDidDispose=Be(this,v,"f").event,tt(this,L,s,"f"),tt(this,E,i,"f"),tt(this,w,n,"f"),tt(this,k,u,"f"),tt(this,D,o,"f"),tt(this,T,r,"f")}dispose(){Be(this,S,"f")||(tt(this,S,!0,"f"),Be(this,v,"f").fire(),Be(this,D,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Be(this,E,"f")}set title(n){this.assertNotDisposed(),Be(this,E,"f")!==n&&(tt(this,E,n,"f"),Be(this,k,"f").$setWebviewViewTitle(Be(this,w,"f"),n))}get description(){return this.assertNotDisposed(),Be(this,p,"f")}set description(n){this.assertNotDisposed(),Be(this,p,"f")!==n&&(tt(this,p,n,"f"),Be(this,k,"f").$setWebviewViewDescription(Be(this,w,"f"),n))}get visible(){return Be(this,T,"f")}get webview(){return Be(this,D,"f")}get viewType(){return Be(this,L,"f")}_setVisible(n){n===Be(this,T,"f")||Be(this,S,"f")||(tt(this,T,n,"f"),Be(this,m,"f").fire())}get badge(){return this.assertNotDisposed(),Be(this,b,"f")}set badge(n){this.assertNotDisposed(),!(n?.value===Be(this,b,"f")?.value&&n?.tooltip===Be(this,b,"f")?.tooltip)&&(tt(this,b,P.ViewBadge.from(n),"f"),Be(this,k,"f").$setWebviewViewBadge(Be(this,w,"f"),n))}show(n){this.assertNotDisposed(),Be(this,k,"f").$show(Be(this,w,"f"),!!n)}assertNotDisposed(){if(Be(this,S,"f"))throw new Error("Webview is disposed")}}w=new WeakMap,k=new WeakMap,L=new WeakMap,D=new WeakMap,S=new WeakMap,T=new WeakMap,E=new WeakMap,p=new WeakMap,b=new WeakMap,m=new WeakMap,v=new WeakMap;class c{constructor(n,u){this._extHostWebview=u,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=n.getProxy(_.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(n,u,s,i){if(this._viewProviders.has(u))throw new Error(`View provider for '${u}' already registered`);return this._viewProviders.set(u,{provider:s,extension:n}),this._proxy.$registerWebviewViewProvider((0,C.toExtensionData)(n),u,{retainContextWhenHidden:i?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.shouldSerializeBuffersForPostMessage)(n)}),new I.Disposable(()=>{this._viewProviders.delete(u),this._proxy.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(n,u,s,i,o){const d=this._viewProviders.get(u);if(!d)throw new Error(`No view provider found for '${u}'`);const{provider:r,extension:a}=d,f=this._extHostWebview.createNewWebview(n,{},a),y=new h(n,this._proxy,u,s,f,a,!0);this._webviewViews.set(n,y),await r.resolveWebviewView(y,{state:i},o)}async $onDidChangeWebviewViewVisibility(n,u){this.getWebviewView(n)._setVisible(u)}async $disposeWebviewView(n){const u=this.getWebviewView(n);this._webviewViews.delete(n),u.dispose(),this._extHostWebview.deleteWebview(n)}getWebviewView(n){const u=this._webviewViews.get(n);if(!u)throw new Error("No webview found");return u}}e.ExtHostWebviewViews=c}),define(De[139],Ie([1,0,4,5,2,12,8,3,14]),function(J,e,l,t,C,P,_,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class ni{get state(){return this._state}constructor(D){this._onDidChangeWindowState=new l.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=ni.InitialState,this._proxy=D.getProxy(t.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(S=>this.$onDidChangeWindowFocus(S))}$onDidChangeWindowFocus(D){D!==this._state.focused&&(this._state={...this._state,focused:D},this._onDidChangeWindowState.fire(this._state))}openUri(D,S){let T;if(typeof D=="string"){T=D;try{D=C.URI.parse(D)}catch{return Promise.reject(`Invalid uri - '${D}'`)}}return(0,_.isFalsyOrWhitespace)(D.scheme)?Promise.reject("Invalid scheme - cannot be empty"):D.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${D.scheme}'`):this._proxy.$openUri(D,T,S)}async asExternalUri(D,S){if((0,_.isFalsyOrWhitespace)(D.scheme))return Promise.reject("Invalid scheme - cannot be empty");const T=await this._proxy.$asExternalUri(D,S);return C.URI.from(T)}};k.InitialState={focused:!0},k=je([$e(0,w.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,I.createDecorator)("IExtHostWindow")}),define(De[266],Ie([1,0,113,267,62,38,2,13,45]),function(J,e,l,t,C,P,_,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class k{constructor(S,T,E){this._commands=S,this.logService=T,this._ipcHandlePath=E,this._server=t.createServer((p,b)=>this.onRequest(p,b)),this.setup().catch(p=>(T.error(p),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",S=>this.logService.error(S))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(S,T){const E=(b,m)=>{T.writeHead(b,{"content-type":"application/json"}),T.end(JSON.stringify(m||null),v=>v&&this.logService.error(v))},p=[];S.setEncoding("utf8"),S.on("data",b=>p.push(b)),S.on("end",async()=>{try{const b=JSON.parse(p.join(""));let m;switch(b.type){case"open":m=await this.open(b);break;case"openExternal":m=await this.openExternal(b);break;case"status":m=await this.getStatus(b);break;case"extensionManagement":m=await this.manageExtensions(b);break;default:E(404,`Unknown message type: ${b.type}`);break}E(200,m)}catch(b){const m=b instanceof Error?b.message:JSON.stringify(b);E(500,m),this.logService.error("Error while processing pipe request",b)}})}async open(S){const{fileURIs:T,folderURIs:E,forceNewWindow:p,diffMode:b,mergeMode:m,addMode:v,forceReuseWindow:h,gotoLineMode:c,waitMarkerFilePath:g,remoteAuthority:n}=S,u=[];if(Array.isArray(E))for(const d of E)try{u.push({folderUri:_.URI.parse(d)})}catch{}if(Array.isArray(T))for(const d of T)try{(0,w.hasWorkspaceFileExtension)(d)?u.push({workspaceUri:_.URI.parse(d)}):u.push({fileUri:_.URI.parse(d)})}catch{}const s=g?_.URI.file(g):void 0,o={forceNewWindow:p,diffMode:b,mergeMode:m,addMode:v,gotoLineMode:c,forceReuseWindow:h,preferNewWindow:!h&&!s&&!v,waitMarkerFileURI:s,remoteAuthority:n};return this._commands.executeCommand("_remoteCLI.windowOpen",u,o),""}async openExternal(S){for(const T of S.uris){const E=_.URI.parse(T),p=E.scheme==="file"?E:T;await this._commands.executeCommand("_remoteCLI.openExternal",p)}}async manageExtensions(S){const T=p=>p?.map(b=>/\.vsix$/i.test(b)?_.URI.parse(b):b),E={list:S.list,install:T(S.install),uninstall:T(S.uninstall),force:S.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",E)}async getStatus(S){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&C.existsSync(this._ipcHandlePath)&&C.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=k;let L=class extends k{constructor(S,T){super(S,T,(0,l.createRandomIPCHandle)())}};L=je([$e(0,P.IExtHostCommands),$e(1,I.ILogService)],L),e.CLIServer=L}),define(De[268],Ie([1,0,240,25,14]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const P=1024*1024;let _=class extends l.AbstractExtHostConsoleForwarder{constructor(w,k){super(w,k),this._isMakingConsoleCall=!1,this._wrapStream("stderr","error"),this._wrapStream("stdout","log")}_nativeConsoleLogMessage(w,k,L){const D=w==="error"||w==="warn"?process.stderr:process.stdout;this._isMakingConsoleCall=!0,D.write(`
START_NATIVE_LOG
`),k.apply(console,L),D.write(`
END_NATIVE_LOG
`),this._isMakingConsoleCall=!1}_wrapStream(w,k){const L=process[w],D=L.write;let S="";Object.defineProperty(L,"write",{set:()=>{},get:()=>(T,E,p)=>{if(!this._isMakingConsoleCall){S+=T.toString(E);const b=S.length>P?S.length:S.lastIndexOf(`
`);b!==-1&&(console[k](S.slice(0,b)),S=S.slice(b+1))}D.call(L,T,E,p)}})}};_=je([$e(0,C.IExtHostRpcService),$e(1,t.IExtHostInitDataService)],_),e.ExtHostConsoleForwarder=_}),define(De[269],Ie([1,0,9,81,34,38,6,5,2,14]),function(J,e,l,t,C,P,_,I,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let L=class extends _.Disposable{constructor(S,T){super();const E=S.getProxy(I.MainContext.MainThreadDownloadService);T.registerCommand(!1,"_workbench.downloadResource",async p=>{const b=w.URI.file((0,l.join)((0,t.tmpdir)(),(0,C.generateUuid)()));return await E.$download(p,b),b})}};L=je([$e(0,k.IExtHostRpcService),$e(1,P.IExtHostCommands)],L),e.ExtHostDownloadService=L}),define(De[270],Ie([1,0,137,12,194,34]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class _ extends l.ExtHostLoggerService{doCreateLogger(w,k,L){return w.scheme===t.Schemas.file?new C.SpdLogLogger(L?.name||(0,P.generateUuid)(),w.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,k):super.doCreateLogger(w,k,L)}}e.ExtHostLoggerService=_}),define(De[271],Ie([1,0,62,9,2,67,6,12,18,29]),function(J,e,l,t,C,P,_,I,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class L extends P.ExtensionStoragePaths{constructor(){super(...arguments),this._workspaceStorageLock=null}async _getWorkspaceStorageURI(n){const u=await super._getWorkspaceStorageURI(n);if(u.scheme!==I.Schemas.file)return u;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${u.fsPath}.`),u;const s=u.fsPath;let i=0;do{let o;i===0?o=s:o=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${i}`:`${s}-${i}`,await D(o);const d=t.join(o,"vscode.lock"),r=await p(this._logService,d,!1);if(r)return this._workspaceStorageLock=r,process.on("exit",()=>{r.dispose()}),C.URI.file(o);i++}while(i<10);return u}onWillDeactivateAll(){this._workspaceStorageLock?.setWillRelease(6e3)}}e.ExtensionStoragePaths=L;async function D(g){try{await k.Promises.stat(g);return}catch{}try{await k.Promises.mkdir(g,{recursive:!0})}catch{}}const S=1e3,T=10*60*1e3;class E extends _.Disposable{constructor(n,u){super(),this.logService=n,this.filename=u,this._timer=this._register(new w.IntervalTimer),this._timer.cancelAndSet(async()=>{const s=await b(n,u);(!s||s.pid!==process.pid)&&(n.info(`Lock '${u}': The lock was lost unexpectedly.`),this._timer.cancel());try{await k.Promises.utimes(u,new Date,new Date)}catch(i){n.error(i),n.info(`Lock '${u}': Could not update mtime.`)}},S)}dispose(){super.dispose();try{l.unlinkSync(this.filename)}catch{}}async setWillRelease(n){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${n} ms.`);try{const u={pid:process.pid,willReleaseAt:Date.now()+n};await k.Promises.writeFile(this.filename,JSON.stringify(u),{flag:"w"})}catch(u){this.logService.error(u)}}}async function p(g,n,u){try{const i={pid:process.pid,willReleaseAt:0};await k.Promises.writeFile(n,JSON.stringify(i),{flag:"wx"})}catch(i){g.error(i)}const s=await b(g,n);return!s||s.pid!==process.pid?u?(g.info(`Lock '${n}': Could not acquire lock, giving up.`),null):(g.info(`Lock '${n}': Could not acquire lock, checking if the file is stale.`),h(g,n)):(g.info(`Lock '${n}': Lock acquired.`),new E(g,n))}async function b(g,n){let u;try{u=await k.Promises.readFile(n)}catch(s){return g.error(s),null}try{return JSON.parse(String(u))}catch(s){return g.error(s),null}}async function m(g,n){let u;try{u=await k.Promises.stat(n)}catch(s){return g.error(s),0}return u.mtime.getTime()}function v(g){try{return process.kill(g,0),!0}catch{return!1}}async function h(g,n){const u=await b(g,n);if(!u)return g.info(`Lock '${n}': Could not read pid of lock holder.`),c(g,n);if(u.willReleaseAt){let r=u.willReleaseAt-Date.now();if(r<5e3){for(r>0?g.info(`Lock '${n}': The lockfile is scheduled to be released in ${r} ms.`):g.info(`Lock '${n}': The lockfile is scheduled to have been released.`);r>0;){if(await(0,w.timeout)(Math.min(100,r)),await m(g,n)===0)return c(g,n);r=u.willReleaseAt-Date.now()}return c(g,n)}}if(!v(u.pid))return g.info(`Lock '${n}': The pid ${u.pid} appears to be gone.`),c(g,n);const s=await m(g,n),i=Date.now()-s;if(i<=T)return g.info(`Lock '${n}': The lock does not look stale, elapsed: ${i} ms, giving up.`),null;g.info(`Lock '${n}': The lock looks stale, waiting for 2s.`),await(0,w.timeout)(2e3);const o=await m(g,n),d=Date.now()-o;return d<=T?(g.info(`Lock '${n}': The lock does not look stale, elapsed: ${d} ms, giving up.`),null):(g.info(`Lock '${n}': The lock looks stale even after waiting for 2s.`),c(g,n))}async function c(g,n){g.info(`Lock '${n}': Deleting a stale lock.`);try{await k.Promises.unlink(n)}catch{}return p(g,n,!0)}}),define(De[272],Ie([1,0,34,14,39]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let P=class extends C.BaseExtHostTerminalService{constructor(I){super(!0,I)}createTerminal(I,w,k){return this.createTerminalFromOptions({name:I,shellPath:w,shellArgs:k})}createTerminalFromOptions(I,w){const k=new C.ExtHostTerminal(this._proxy,(0,l.generateUuid)(),I,I.name);return this._terminals.push(k),k.create(I,this._serializeParentTerminal(I,w)),k.value}};P=je([$e(0,t.IExtHostRpcService)],P),e.ExtHostTerminalService=P}),define(De[273],Ie([1,0,5,14,178,6,25,2,44,22,29,7,11,53,4,125,95,13]),function(J,e,l,t,C,P,_,I,w,k,L,D,S,T,E,p,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class v extends p.DisposableTunnel{}function h(r){const a=r.trim().split(`
`),f=[];return a.forEach(R=>{const N=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(R);N&&N.length>=3&&f.push({pid:parseInt(N[1],10),socket:parseInt(N[2],10)})}),f.reduce((R,N)=>(R[N.socket]=N,R),{})}e.getSockets=h;function c(...r){const a=[].concat(...r.map(n));return[...new Map(a.filter(f=>f.st==="0A").map(f=>{const y=f.local_address.split(":");return{socket:parseInt(f.inode,10),ip:g(y[0]),port:parseInt(y[1],16)}}).map(f=>[f.ip+":"+f.port,f])).values()]}e.loadListeningPorts=c;function g(r){let a="";if(r.length===8)for(let f=r.length-2;f>=0;f-=2)a+=parseInt(r.substr(f,2),16),f!==0&&(a+=".");else for(let f=r.length-4;f>=0;f-=4)a+=parseInt(r.substr(f,4),16).toString(16),f!==0&&(a+=":");return a}e.parseIpAddress=g;function n(r){const a=r.trim().split(`
`),f=a.shift().trim().split(/\s+/).filter(R=>R!=="rx_queue"&&R!=="tm->when");return a.map(R=>R.trim().split(/\s+/).reduce((N,M,A)=>(N[f[A]||A]=M,N),{}))}e.loadConnectionTable=n;function u(r){return!!r.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||r.indexOf("out/server-main.js")!==-1||r.indexOf("_productName=VSCode")!==-1}function s(r){const a=r.trim().split(`
`),f=[];return a.forEach(y=>{const R=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(y);R&&R.length>=4&&f.push({pid:parseInt(R[1],10),ppid:parseInt(R[2]),cmd:R[3]})}),f}e.getRootProcesses=s;async function i(r,a,f){const y=f.reduce((N,M)=>(N[M.pid]=M,N),{}),R=[];return r.forEach(({socket:N,ip:M,port:A})=>{const z=a[N]?a[N].pid:void 0,H=z?y[z]?.cmd:void 0;z&&H&&!u(H)&&R.push({host:M,port:A,detail:H,pid:z})}),R}e.findPorts=i;function o(r,a,f){const y=new Map,R=s(a);for(const N of r){const M=f.get(N.port);if(M){y.set(N.port,M);continue}const A=R.find(z=>z.cmd.includes(`${N.port}`));if(A){let z=A,H;do H=R.find(F=>F.ppid===z.pid),H&&(z=H);while(H);y.set(N.port,{host:N.ip,port:N.port,pid:z.pid,detail:z.cmd,ppid:z.ppid})}else y.set(N.port,{host:N.ip,port:N.port,ppid:Number.MAX_VALUE})}return y}e.tryFindRootPorts=o;let d=class extends P.Disposable{constructor(a,f,y){super(),this.logService=y,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new E.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=a.getProxy(l.MainContext.MainThreadTunnelService),S.isLinux&&f.remote.isRemote&&f.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(a,f){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${a.identifier.value} called openTunnel API for ${f.remoteAddress.host}:${f.remoteAddress.port}.`);const y=await this._proxy.$openTunnel(f,a.displayName);if(y){const R=new v(y.remoteAddress,y.localAddress,()=>this._proxy.$closeTunnel(y.remoteAddress));return this._register(R),R}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(a){return Math.max(a*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(a,f){const y=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(y,{selector:a,provider:f}),this._proxy.$registerPortsAttributesProvider(a,y),new D.Disposable(()=>{this._portAttributesProviders.delete(y),this._proxy.$unregisterPortsAttributesProvider(y)})}async $providePortAttributes(a,f,y,R,N){const M=[];for(const z of a){const H=this._portAttributesProviders.get(z);if(!H)return[];M.push(...await Promise.all(f.map(async F=>H.provider.providePortAttributes(F,y,R,N))))}const A=M.filter(z=>!!z);return A.length>0?A.map(z=>({autoForwardAction:z.autoForwardAction,port:z.port})):[]}async $registerCandidateFinder(a){if(a&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=a;const f=new b.MovingAverage;let y;for(;this._candidateFindingEnabled;){const R=new Date().getTime(),N=(await this.findCandidatePorts()).filter(A=>(0,p.isLocalhost)(A.host)||(0,p.isAllInterfaces)(A.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${N.map(A=>A.port).join(", ")}`);const M=new Date().getTime()-R;f.update(M),(!y||JSON.stringify(y)!==JSON.stringify(N))&&(y=N,await this._proxy.$onFoundNewCandidates(y)),await new Promise(A=>setTimeout(()=>A(),this.calculateDelay(f.value)))}}async setTunnelFactory(a){if(a){if(a.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(a.candidatePortSource),a.showCandidatePort&&(this._showCandidatePort=a.showCandidatePort,this._proxy.$setCandidateFilter()),a.tunnelFactory){this._forwardPortProvider=a.tunnelFactory;let f=a.tunnelFeatures?.privacyOptions??[];a.tunnelFeatures?.public&&f.length===0&&(f=[{id:"private",label:C.localize(0,null),themeIcon:"lock"},{id:"public",label:C.localize(1,null),themeIcon:"eye"}]);const y=a.tunnelFeatures?{elevation:!!a.tunnelFeatures?.elevation,public:!!a.tunnelFeatures?.public,privacyOptions:f}:void 0;this._proxy.$setTunnelProvider(y)}}else this._forwardPortProvider=void 0;return(0,P.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(a,f){if(this._extensionTunnels.has(a.host)){const y=this._extensionTunnels.get(a.host);y.has(a.port)&&(f&&y.get(a.port).disposeListener.dispose(),await y.get(a.port).tunnel.dispose(),y.delete(a.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(a,f){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const y=this._forwardPortProvider(a,f);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),y!==void 0){const R=await y;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(a.remoteAddress.host)||this._extensionTunnels.set(a.remoteAddress.host,new Map);const N=this._register(R.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(R.remoteAddress))));return this._extensionTunnels.get(a.remoteAddress.host).set(a.remoteAddress.port,{tunnel:R,disposeListener:N}),T.TunnelDtoConverter.fromApiTunnel(R)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(a){const f=await Promise.all(a.map(R=>this._showCandidatePort(R.host,R.port,R.detail??""))),y=a.filter((R,N)=>f[N]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${a.map(R=>R.port).join(", ")} to ${y.map(R=>R.port).join(", ")}`),y}async findCandidatePorts(){let a="",f="";try{a=await L.Promises.readFile("/proc/net/tcp","utf8"),f=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const y=c(a,f),R=await new Promise(B=>{(0,w.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(U,x,$)=>{B(x)})}),N=h(R),M=await L.Promises.readdir("/proc"),A=[];for(const B of M)try{const U=Number(B),x=k.joinPath(I.URI.file("/proc"),B);if((await L.Promises.stat(x.fsPath)).isDirectory()&&!isNaN(U)){const Q=await L.Promises.readlink(k.joinPath(x,"cwd").fsPath),K=await L.Promises.readFile(k.joinPath(x,"cmdline").fsPath,"utf8");A.push({pid:U,cwd:Q,cmd:K})}}catch{}const z=[],H=y.filter(B=>{const U=N[B.socket];return U||z.push(B),U}),F=i(H,N,A);let G;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${z.length}`),z.length>0){const B=await new Promise(U=>{(0,w.exec)("ps -F -A -l | grep root",(x,$,Q)=>{U($)})});this._foundRootPorts=o(z,B,this._foundRootPorts),G=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${G.join(", ")}`)}return F.then(B=>G?B.concat(G):B)}};d=je([$e(0,t.IExtHostRpcService),$e(1,_.IExtHostInitDataService),$e(2,m.ILogService)],d),e.ExtHostTunnelService=d}),define(De[274],Ie([1,0,18,23,21,10,4,6,108,234,56]),function(J,e,l,t,C,P,_,I,w,k,L){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function S(y,R){try{return JSON.stringify(y,R)}catch{return"null"}}const T="$$ref$$",E={[T]:-1};class p{constructor(R,N){this.jsonString=R,this.referencedBuffers=N}}function b(y,R=null,N=!1){const M=[];return{jsonString:(N?S:JSON.stringify)(y,(z,H)=>{if(typeof H>"u")return E;if(typeof H=="object"){if(H instanceof t.VSBuffer){const F=M.push(H)-1;return{[T]:F}}if(R)return R(z,H)}return H}),referencedBuffers:M}}e.stringifyJsonWithBufferRefs=b;function m(y,R,N){return JSON.parse(y,(M,A)=>{if(A){const z=A[T];if(typeof z=="number")return R[z];if(N&&A.$mid===1)return N.transformIncoming(A)}return A})}e.parseJsonAndRestoreBufferRefs=m;function v(y,R){return JSON.stringify(y,R)}function h(y){return y?(R,N)=>N&&N.$mid===1?y.transformOutgoing(N):N:null}var c;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(c=e.RequestInitiator||(e.RequestInitiator={}));var g;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(g=e.ResponsiveState||(e.ResponsiveState={}));const n=()=>{},u=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class i extends I.Disposable{constructor(R,N=null,M=null){super(),this[D]=!0,this._onDidChangeResponsiveState=this._register(new _.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=R,this._logger=N,this._uriTransformer=M,this._uriReplacer=h(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let A=0,z=L.ProxyIdentifier.count;A<z;A++)this._locals[A]=null,this._proxies[A]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new l.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(A=>this._receiveOneMessage(A))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(R=>{this._pendingRPCReplies[R].resolveErr(P.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(R){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(R){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(R){this._responsiveState!==R&&(this._responsiveState=R,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(R){return this._uriTransformer?(0,w.transformIncomingURIs)(R,this._uriTransformer):R}getProxy(R){const{nid:N,sid:M}=R;return this._proxies[N]||(this._proxies[N]=this._createProxy(N,M)),this._proxies[N]}_createProxy(R,N){const M={get:(A,z)=>(typeof z=="string"&&!A[z]&&z.charCodeAt(0)===36&&(A[z]=(...H)=>this._remoteCall(R,z,H)),z===s?N:A[z])};return new Proxy(Object.create(null),M)}set(R,N){return this._locals[R.nid]=N,N}assertRegistered(R){for(let N=0,M=R.length;N<M;N++){const A=R[N];if(!this._locals[A.nid])throw new Error(`Missing proxy instance ${A.sid}`)}}_receiveOneMessage(R){if(this._isDisposed)return;const N=R.byteLength,M=o.read(R,0),A=M.readUInt8(),z=M.readUInt32();switch(A){case 1:case 2:{let{rpcId:H,method:F,args:G}=r.deserializeRequestJSONArgs(M);this._uriTransformer&&(G=(0,w.transformIncomingURIs)(G,this._uriTransformer)),this._receiveRequest(N,z,H,F,G,A===2);break}case 3:case 4:{let{rpcId:H,method:F,args:G}=r.deserializeRequestMixedArgs(M);this._uriTransformer&&(G=(0,w.transformIncomingURIs)(G,this._uriTransformer)),this._receiveRequest(N,z,H,F,G,A===4);break}case 5:{this._logger?.logIncoming(N,z,0,"ack"),this._onDidReceiveAcknowledge(z);break}case 6:{this._receiveCancel(N,z);break}case 7:{this._receiveReply(N,z,void 0);break}case 9:{let H=r.deserializeReplyOKJSON(M);this._uriTransformer&&(H=(0,w.transformIncomingURIs)(H,this._uriTransformer)),this._receiveReply(N,z,H);break}case 10:{const H=r.deserializeReplyOKJSONWithBuffers(M,this._uriTransformer);this._receiveReply(N,z,H);break}case 8:{const H=r.deserializeReplyOKVSBuffer(M);this._receiveReply(N,z,H);break}case 11:{let H=r.deserializeReplyErrError(M);this._uriTransformer&&(H=(0,w.transformIncomingURIs)(H,this._uriTransformer)),this._receiveReplyErr(N,z,H);break}case 12:{this._receiveReplyErr(N,z,void 0);break}default:console.error("received unexpected message"),console.error(R)}}_receiveRequest(R,N,M,A,z,H){this._logger?.logIncoming(R,N,1,`receiveRequest ${(0,L.getStringIdentifierForProxy)(M)}.${A}(`,z);const F=String(N);let G,B;if(H){const x=new C.CancellationTokenSource;z.push(x.token),G=this._invokeHandler(M,A,z),B=()=>x.cancel()}else G=this._invokeHandler(M,A,z),B=n;this._cancelInvokedHandlers[F]=B;const U=r.serializeAcknowledged(N);this._logger?.logOutgoing(U.byteLength,N,1,"ack"),this._protocol.send(U),G.then(x=>{delete this._cancelInvokedHandlers[F];const $=r.serializeReplyOK(N,x,this._uriReplacer);this._logger?.logOutgoing($.byteLength,N,1,"reply:",x),this._protocol.send($)},x=>{delete this._cancelInvokedHandlers[F];const $=r.serializeReplyErr(N,x);this._logger?.logOutgoing($.byteLength,N,1,"replyErr:",x),this._protocol.send($)})}_receiveCancel(R,N){this._logger?.logIncoming(R,N,1,"receiveCancel");const M=String(N);this._cancelInvokedHandlers[M]?.()}_receiveReply(R,N,M){this._logger?.logIncoming(R,N,0,"receiveReply:",M);const A=String(N);if(!this._pendingRPCReplies.hasOwnProperty(A))return;const z=this._pendingRPCReplies[A];delete this._pendingRPCReplies[A],z.resolveOk(M)}_receiveReplyErr(R,N,M){this._logger?.logIncoming(R,N,0,"receiveReplyErr:",M);const A=String(N);if(!this._pendingRPCReplies.hasOwnProperty(A))return;const z=this._pendingRPCReplies[A];delete this._pendingRPCReplies[A];let H;M&&(M.$isError?(H=new Error,H.name=M.name,H.message=M.message,H.stack=M.stack):H=M),z.resolveErr(H)}_invokeHandler(R,N,M){try{return Promise.resolve(this._doInvokeHandler(R,N,M))}catch(A){return Promise.reject(A)}}_doInvokeHandler(R,N,M){const A=this._locals[R];if(!A)throw new Error("Unknown actor "+(0,L.getStringIdentifierForProxy)(R));const z=A[N];if(typeof z!="function")throw new Error("Unknown method "+N+" on actor "+(0,L.getStringIdentifierForProxy)(R));return z.apply(A,M)}_remoteCall(R,N,M){if(this._isDisposed)return new k.CanceledLazyPromise;let A=null;if(M.length>0&&C.CancellationToken.isCancellationToken(M[M.length-1])&&(A=M.pop()),A&&A.isCancellationRequested)return Promise.reject(P.canceled());const z=r.serializeRequestArguments(M,this._uriReplacer),H=++this._lastMessageId,F=String(H),G=new k.LazyPromise;A&&A.onCancellationRequested(()=>{const U=r.serializeCancel(H);this._logger?.logOutgoing(U.byteLength,H,0,"cancel"),this._protocol.send(r.serializeCancel(H))}),this._pendingRPCReplies[F]=G,this._onWillSendRequest(H);const B=r.serializeRequest(H,R,N,z,!!A);return this._logger?.logOutgoing(B.byteLength,H,0,`request: ${(0,L.getStringIdentifierForProxy)(R)}.${N}(`,M),this._protocol.send(B),G}}e.RPCProtocol=i,D=u,i.UNRESPONSIVE_TIME=3*1e3;class o{static alloc(R,N,M){const A=new o(t.VSBuffer.alloc(M+1+4),0);return A.writeUInt8(R),A.writeUInt32(N),A}static read(R,N){return new o(R,N)}get buffer(){return this._buff}constructor(R,N){this._buff=R,this._offset=N}static sizeUInt8(){return 1}writeUInt8(R){this._buff.writeUInt8(R,this._offset),this._offset+=1}readUInt8(){const R=this._buff.readUInt8(this._offset);return this._offset+=1,R}writeUInt32(R){this._buff.writeUInt32BE(R,this._offset),this._offset+=4}readUInt32(){const R=this._buff.readUInt32BE(this._offset);return this._offset+=4,R}static sizeShortString(R){return 1+R.byteLength}writeShortString(R){this._buff.writeUInt8(R.byteLength,this._offset),this._offset+=1,this._buff.set(R,this._offset),this._offset+=R.byteLength}readShortString(){const R=this._buff.readUInt8(this._offset);this._offset+=1;const M=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,M}static sizeLongString(R){return 4+R.byteLength}writeLongString(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readLongString(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const M=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,M}writeBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}static sizeVSBuffer(R){return 4+R.byteLength}writeVSBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readVSBuffer(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const N=this._buff.slice(this._offset,this._offset+R);return this._offset+=R,N}static sizeMixedArray(R){let N=0;N+=1;for(let M=0,A=R.length;M<A;M++){const z=R[M];switch(N+=1,z.type){case 1:N+=this.sizeLongString(z.value);break;case 2:N+=this.sizeVSBuffer(z.value);break;case 3:N+=this.sizeUInt32,N+=this.sizeLongString(z.value);for(let H=0;H<z.buffers.length;++H)N+=this.sizeVSBuffer(z.buffers[H]);break;case 4:break}}return N}writeMixedArray(R){this._buff.writeUInt8(R.length,this._offset),this._offset+=1;for(let N=0,M=R.length;N<M;N++){const A=R[N];switch(A.type){case 1:this.writeUInt8(1),this.writeLongString(A.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(A.value);break;case 3:this.writeUInt8(3),this.writeUInt32(A.buffers.length),this.writeLongString(A.value);for(let z=0;z<A.buffers.length;++z)this.writeBuffer(A.buffers[z]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const R=this._buff.readUInt8(this._offset);this._offset+=1;const N=new Array(R);for(let M=0;M<R;M++)switch(this.readUInt8()){case 1:N[M]=this.readLongString();break;case 2:N[M]=this.readVSBuffer();break;case 3:{const z=this.readUInt32(),H=this.readLongString(),F=[];for(let G=0;G<z;++G)F.push(this.readVSBuffer());N[M]=new L.SerializableObjectWithBuffers(m(H,F,null));break}case 4:N[M]=void 0;break}return N}}o.sizeUInt32=4;var d;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(d||(d={}));class r{static _useMixedArgSerialization(R){for(let N=0,M=R.length;N<M;N++)if(R[N]instanceof t.VSBuffer||R[N]instanceof L.SerializableObjectWithBuffers||typeof R[N]>"u")return!0;return!1}static serializeRequestArguments(R,N){if(this._useMixedArgSerialization(R)){const M=[];for(let A=0,z=R.length;A<z;A++){const H=R[A];if(H instanceof t.VSBuffer)M[A]={type:2,value:H};else if(typeof H>"u")M[A]={type:4};else if(H instanceof L.SerializableObjectWithBuffers){const{jsonString:F,referencedBuffers:G}=b(H.value,N);M[A]={type:3,value:t.VSBuffer.fromString(F),buffers:G}}else M[A]={type:1,value:t.VSBuffer.fromString(v(H,N))}}return{type:1,args:M}}return{type:0,args:v(R,N)}}static serializeRequest(R,N,M,A,z){switch(A.type){case 0:return this._requestJSONArgs(R,N,M,A.args,z);case 1:return this._requestMixedArgs(R,N,M,A.args,z)}}static _requestJSONArgs(R,N,M,A,z){const H=t.VSBuffer.fromString(M),F=t.VSBuffer.fromString(A);let G=0;G+=o.sizeUInt8(),G+=o.sizeShortString(H),G+=o.sizeLongString(F);const B=o.alloc(z?2:1,R,G);return B.writeUInt8(N),B.writeShortString(H),B.writeLongString(F),B.buffer}static deserializeRequestJSONArgs(R){const N=R.readUInt8(),M=R.readShortString(),A=R.readLongString();return{rpcId:N,method:M,args:JSON.parse(A)}}static _requestMixedArgs(R,N,M,A,z){const H=t.VSBuffer.fromString(M);let F=0;F+=o.sizeUInt8(),F+=o.sizeShortString(H),F+=o.sizeMixedArray(A);const G=o.alloc(z?4:3,R,F);return G.writeUInt8(N),G.writeShortString(H),G.writeMixedArray(A),G.buffer}static deserializeRequestMixedArgs(R){const N=R.readUInt8(),M=R.readShortString(),A=R.readMixedArray(),z=new Array(A.length);for(let H=0,F=A.length;H<F;H++){const G=A[H];typeof G=="string"?z[H]=JSON.parse(G):z[H]=G}return{rpcId:N,method:M,args:z}}static serializeAcknowledged(R){return o.alloc(5,R,0).buffer}static serializeCancel(R){return o.alloc(6,R,0).buffer}static serializeReplyOK(R,N,M){if(typeof N>"u")return this._serializeReplyOKEmpty(R);if(N instanceof t.VSBuffer)return this._serializeReplyOKVSBuffer(R,N);if(N instanceof L.SerializableObjectWithBuffers){const{jsonString:A,referencedBuffers:z}=b(N.value,M,!0);return this._serializeReplyOKJSONWithBuffers(R,A,z)}else return this._serializeReplyOKJSON(R,S(N,M))}static _serializeReplyOKEmpty(R){return o.alloc(7,R,0).buffer}static _serializeReplyOKVSBuffer(R,N){let M=0;M+=o.sizeVSBuffer(N);const A=o.alloc(8,R,M);return A.writeVSBuffer(N),A.buffer}static deserializeReplyOKVSBuffer(R){return R.readVSBuffer()}static _serializeReplyOKJSON(R,N){const M=t.VSBuffer.fromString(N);let A=0;A+=o.sizeLongString(M);const z=o.alloc(9,R,A);return z.writeLongString(M),z.buffer}static _serializeReplyOKJSONWithBuffers(R,N,M){const A=t.VSBuffer.fromString(N);let z=0;z+=o.sizeUInt32,z+=o.sizeLongString(A);for(const F of M)z+=o.sizeVSBuffer(F);const H=o.alloc(10,R,z);H.writeUInt32(M.length),H.writeLongString(A);for(const F of M)H.writeBuffer(F);return H.buffer}static deserializeReplyOKJSON(R){const N=R.readLongString();return JSON.parse(N)}static deserializeReplyOKJSONWithBuffers(R,N){const M=R.readUInt32(),A=R.readLongString(),z=[];for(let H=0;H<M;++H)z.push(R.readVSBuffer());return new L.SerializableObjectWithBuffers(m(A,z,N))}static serializeReplyErr(R,N){const M=N?S(P.transformErrorForSerialization(N),null):void 0;if(typeof M!="string")return this._serializeReplyErrEmpty(R);const A=t.VSBuffer.fromString(M);let z=0;z+=o.sizeLongString(A);const H=o.alloc(11,R,z);return H.writeLongString(A),H.buffer}static deserializeReplyErrError(R){const N=R.readLongString();return JSON.parse(N)}static _serializeReplyErrEmpty(R){return o.alloc(12,R,0).buffer}}var a;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(a||(a={}));var f;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(f||(f={}))}),define(De[275],Ie([1,0,4,43,52,3,37,10,18]),function(J,e,l,t,C,P,_,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new C.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new C.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new C.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,P.createDecorator)(e.OUTPUT_SERVICE_ID);var k;(function(T){T[T.Append=1]="Append",T[T.Replace=2]="Replace",T[T.Clear=3]="Clear"})(k=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class L{constructor(){this.channels=new Map,this._onDidRegisterChannel=new l.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new l.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(E){this.channels.has(E.id)||(this.channels.set(E.id,E),this._onDidRegisterChannel.fire(E.id))}getChannels(){const E=[];return this.channels.forEach(p=>E.push(p)),E}getChannel(E){return this.channels.get(E)}removeChannel(E){this.channels.delete(E),this._onDidRemoveChannel.fire(E)}}t.Registry.add(e.Extensions.OutputChannels,new L);function D(T,E,p,b,m){return(0,w.createCancelablePromise)(async v=>{await(0,_.whenProviderRegistered)(p,b);const h=t.Registry.as(e.Extensions.OutputChannels);try{await S(p,1,b,m,v),h.registerChannel({id:T,label:E,file:p,log:!0})}catch(c){(0,I.isCancellationError)(c)||m.error("Error while registering log channel",p.toString(),(0,I.getErrorMessage)(c))}})}e.registerLogChannel=D;async function S(T,E,p,b,m){if(!await p.exists(T)){if(m.isCancellationRequested)throw new I.CancellationError;if(E>10)throw new Error("Timed out while waiting for file to be created");b.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",T.toString()),await(0,w.timeout)(1e3,m),await S(T,E+1,p,b,m)}}}),define(De[140],Ie([1,0,5,3,14,13,275,66,25,46,153,23,16,37]),function(J,e,l,t,C,P,_,I,w,k,L,D,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class E extends P.AbstractMessageLogger{get disposed(){return this._disposed}constructor(v,h,c,g,n){super(),this.id=v,this.name=h,this.logger=c,this.proxy=g,this.extension=n,this.offset=0,this._disposed=!1,this.visible=!1,this._register(c.onDidChangeLogLevel(u=>this.setLevel(u)))}appendLine(v){this.append(v+`
`)}append(v){this.info(v),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,_.OutputChannelUpdateMode.Append))}clear(){const v=this.offset;this.logger.flush(),this.proxy.$update(this.id,_.OutputChannelUpdateMode.Clear,v)}replace(v){const h=this.offset;this.info(v),this.proxy.$update(this.id,_.OutputChannelUpdateMode.Replace,h),this.visible&&this.logger.flush()}show(v,h){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof v=="boolean"?v:h))}hide(){this.proxy.$close(this.id)}log(v,h){this.offset+=D.VSBuffer.fromString(h).byteLength,(0,P.log)(this.logger,v,h)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class p extends E{appendLine(v){this.append(v)}}let b=class{constructor(v,h,c,g,n){this.initData=h,this.extHostFileSystem=c,this.extHostFileSystemInfo=g,this.loggerService=n,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=v.getProxy(l.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(h.logsLocation,`output_logging_${(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(v){this.visibleChannelId=v;for(const[h,c]of this.channels)c.visible=h===this.visibleChannelId}createOutputChannel(v,h,c){if(v=v.trim(),!v)throw new Error("illegal argument `name`. must not be falsy");const g=typeof h=="object"&&h.log,n=(0,S.isString)(h)?h:void 0;if((0,S.isString)(n)&&!n.trim())throw new Error("illegal argument `languageId`. must not be empty");const u=g?this.doCreateLogOutputChannel(v,c):this.doCreateOutputChannel(v,n,c);return u.then(s=>{this.channels.set(s.id,s),s.visible=s.id===this.visibleChannelId}),g?this.createExtHostLogOutputChannel(v,u):this.createExtHostOutputChannel(v,u)}async doCreateOutputChannel(v,h,c){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const g=await this.outputDirectoryPromise,n=this.extHostFileSystemInfo.extUri.joinPath(g,`${this.namePool++}-${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),u=this.loggerService.createLogger(n,{always:!0,donotRotate:!0,donotUseFormatters:!0}),s=await this.proxy.$register(v,n,!1,h,c.identifier.value);return new E(s,v,u,this.proxy,c)}async doCreateLogOutputChannel(v,h){const c=await this.createExtensionLogDirectory(h),g=this.extHostFileSystemInfo.extUri.joinPath(c,`${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),n=this.loggerService.createLogger(g,{name:v}),u=await this.proxy.$register(v,g,!0,void 0,h.identifier.value);return new p(u,v,n,this.proxy,h)}createExtensionLogDirectory(v){let h=this.extensionLogDirectoryPromise.get(v.identifier.value);if(!h){const c=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,v.identifier.value);this.extensionLogDirectoryPromise.set(v.identifier.value,h=(async()=>{try{await this.extHostFileSystem.value.createDirectory(c)}catch(g){if((0,T.toFileSystemProviderErrorCode)(g)!==T.FileSystemProviderErrorCode.FileExists)throw g}return c})())}return h}createExtHostOutputChannel(v,h){let c=!1;const g=()=>{if(c)throw new Error("Channel has been closed")};return{get name(){return v},append(n){g(),h.then(u=>u.append(n))},appendLine(n){g(),h.then(u=>u.appendLine(n))},clear(){g(),h.then(n=>n.clear())},replace(n){g(),h.then(u=>u.replace(n))},show(n,u){g(),h.then(s=>s.show(n,u))},hide(){g(),h.then(n=>n.hide())},dispose(){c=!0,h.then(n=>n.dispose())}}}createExtHostLogOutputChannel(v,h){let c=!1;const g=()=>{if(c)throw new Error("Channel has been closed")};return{...this.createExtHostOutputChannel(v,h),trace(n,...u){g(),h.then(s=>s.trace(n,...u))},debug(n,...u){g(),h.then(s=>s.debug(n,...u))},info(n,...u){g(),h.then(s=>s.info(n,...u))},warn(n,...u){g(),h.then(s=>s.warn(n,...u))},error(n,...u){g(),h.then(s=>s.error(n,...u))},dispose(){c=!0,h.then(n=>n.dispose())}}}};b=je([$e(0,C.IExtHostRpcService),$e(1,w.IExtHostInitDataService),$e(2,I.IExtHostConsumerFileSystem),$e(3,k.IExtHostFileSystemInfo),$e(4,P.ILoggerService)],b),e.ExtHostOutputService=b,e.IExtHostOutputService=(0,t.createDecorator)("IExtHostOutputService")}),define(De[276],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,l.createDecorator)("remoteAgentService")}),define(De[277],Ie([1,0,31,12,9,11,22,2,3,203,45,220,276]),function(J,e,l,t,C,P,_,I,w,k,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,w.createDecorator)("pathService");let T=class ii{constructor(p,b,m,v){this.localUserHome=p,this.remoteAgentService=b,this.environmentService=m,this.contextService=v,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||P.OS)(),this.resolveUserHome=(async()=>{const h=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=h?.userHome??p})()}hasValidBasename(p,b,m){return typeof b=="string"||typeof b>"u"?this.resolveOS.then(v=>this.doHasValidBasename(p,v,b)):this.doHasValidBasename(p,b,m)}doHasValidBasename(p,b,m){return p.scheme===t.Schemas.file||p.scheme===t.Schemas.vscodeRemote?(0,l.isValidBasename)(m??(0,_.basename)(p),b===1):!0}get defaultUriScheme(){return ii.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(p,b){if(p.remoteAuthority)return t.Schemas.vscodeRemote;const m=(0,k.getVirtualWorkspaceScheme)(b.getWorkspace());if(m)return m;const v=b.getWorkspace().folders[0];if(v)return v.uri.scheme;const h=b.getWorkspace().configuration;return h?h.scheme:t.Schemas.file}userHome(p){return p?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(p=>p===1?C.win32:C.posix)}async fileURI(p){let b="";if(await this.resolveOS===1&&(p=p.replace(/\\/g,"/")),p[0]==="/"&&p[1]==="/"){const v=p.indexOf("/",2);v===-1?(b=p.substring(2),p="/"):(b=p.substring(2,v),p=p.substring(v)||"/")}return I.URI.from({scheme:t.Schemas.file,authority:b,path:p,query:"",fragment:""})}};T=je([$e(1,S.IRemoteAgentService),$e(2,D.IWorkbenchEnvironmentService),$e(3,L.IWorkspaceContextService)],T),e.AbstractPathService=T}),define(De[69],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class l{constructor(_,I){this.line=_,this.character=I}isBefore(_){return!1}isBeforeOrEqual(_){return!1}isAfter(_){return!1}isAfterOrEqual(_){return!1}isEqual(_){return!1}compareTo(_){return 0}translate(_,I){return new l(0,0)}with(_){return new l(0,0)}}e.Position=l;class t{constructor(_,I,w,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new l(_,I),this.end=new l(w,k)}contains(_){return!1}isEqual(_){return!1}intersection(_){}union(_){return new t(0,0,0,0)}with(_){return new t(0,0,0,0)}}e.Range=t;var C;(function(P){P[P.Information=1]="Information",P[P.Warning=2]="Warning"})(C=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(De[30],Ie([1,0,17,36,24,31,8,3,9,10,69,18]),function(J,e,l,t,C,P,_,I,w,k,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const S="\u27EA ",T=" characters skipped \u27EB",E=(S.length+T.length+5)*2;e.ISearchService=(0,I.createDecorator)("searchService");var p;(function(K){K[K.file=0]="file",K[K.text=1]="text"})(p=e.SearchProviderType||(e.SearchProviderType={}));var b;(function(K){K[K.File=1]="File",K[K.Text=2]="Text"})(b=e.QueryType||(e.QueryType={}));function m(K){return!!K.preview}e.resultIsMatch=m;function v(K){return!!K.resource}e.isFileMatch=v;function h(K){return!!K.message}e.isProgressMessage=h;var c;(function(K){K[K.Normal=0]="Normal",K[K.NewSearchStarted=1]="NewSearchStarted"})(c=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class g{constructor(de){this.resource=de,this.results=[]}}e.FileMatch=g;class n{constructor(de,te,he){this.ranges=te;const Y=Array.isArray(te)?te:[te];if(he&&he.matchLines===1&&u(Y)){de=(0,_.getNLines)(de,he.matchLines);let ve="",be=0,ke=0;const Re=Math.floor(he.charsPerLine/5),ze=[];for(const oe of Y){const le=Math.max(oe.startColumn-Re,0),me=oe.startColumn+he.charsPerLine;if(le>ke+Re+E){const Z=S+(le-ke)+T;ve+=Z+de.slice(le,me),be+=le-(ke+Z.length)}else ve+=de.slice(ke,me);ze.push(new i(0,oe.startColumn-be,oe.endColumn-be)),ke=me}this.preview={text:ve,matches:Array.isArray(this.ranges)?ze:ze[0]}}else{const ve=Array.isArray(te)?te[0].startLineNumber:te.startLineNumber;this.preview={text:de,matches:(0,l.mapArrayOrNot)(te,be=>new s(be.startLineNumber-ve,be.startColumn,be.endLineNumber-ve,be.endColumn))}}}}e.TextSearchMatch=n;function u(K){const de=K[0].startLineNumber;for(const te of K)if(te.startLineNumber!==de||te.endLineNumber!==de)return!1;return!0}class s{constructor(de,te,he,Y){this.startLineNumber=de,this.startColumn=te,this.endLineNumber=he,this.endColumn=Y}}e.SearchRange=s;class i extends s{constructor(de,te,he){super(de,te,de,he)}}e.OneLineRange=i;var o;(function(K){K.List="list",K.Tree="tree"})(o=e.ViewMode||(e.ViewMode={}));var d;(function(K){K.Default="default",K.FileNames="fileNames",K.Type="type",K.Modified="modified",K.CountDescending="countDescending",K.CountAscending="countAscending"})(d=e.SearchSortOrder||(e.SearchSortOrder={}));function r(K,de=!0){const te=K&&K.files&&K.files.exclude,he=de&&K&&K.search&&K.search.exclude;if(!te&&!he)return;if(!te||!he)return te||he;let Y=Object.create(null);return Y=C.mixin(Y,C.deepClone(te)),Y=C.mixin(Y,C.deepClone(he),!0),Y}e.getExcludes=r;function a(K,de){return K.excludePattern&&t.match(K.excludePattern,de)?!1:K.includePattern||K.usingSearchPaths?K.includePattern&&t.match(K.includePattern,de)?!0:K.usingSearchPaths?!!K.folderQueries&&K.folderQueries.some(te=>{const he=te.folder.fsPath;if(P.isEqualOrParent(de,he)){const Y=w.relative(he,de);return!te.includePattern||!!t.match(te.includePattern,Y)}else return!1}):!1:!0}e.pathIncludedInQuery=a;var f;(function(K){K[K.unknownEncoding=1]="unknownEncoding",K[K.regexParseError=2]="regexParseError",K[K.globParseError=3]="globParseError",K[K.invalidLiteral=4]="invalidLiteral",K[K.rgProcessError=5]="rgProcessError",K[K.other=6]="other",K[K.canceled=7]="canceled"})(f=e.SearchErrorCode||(e.SearchErrorCode={}));class y extends Error{constructor(de,te){super(de),this.code=te}}e.SearchError=y;function R(K){const de=K.message;if((0,k.isCancellationError)(K))return new y(de,f.canceled);try{const te=JSON.parse(de);return new y(te.message,te.code)}catch{return new y(de,f.other)}}e.deserializeSearchError=R;function N(K){const de={message:K.message,code:K.code};return new Error(JSON.stringify(de))}e.serializeSearchError=N;function M(K){return K.type==="error"?!0:K.type==="success"}e.isSerializedSearchComplete=M;function A(K){return K.type==="success"}e.isSerializedSearchSuccess=A;function z(K){return!!K.path}e.isSerializedFileMatch=z;function H(K,de){const te=K.searchPath?K.searchPath:K.relativePath;return(0,_.fuzzyContains)(te,de)}e.isFilePatternMatch=H;class F{constructor(de){this.path=de,this.results=[]}addMatch(de){this.results.push(de)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=F;function G(K,de){const te={...K||{},...de||{}};return Object.keys(te).filter(he=>{const Y=te[he];return typeof Y=="boolean"&&Y})}e.resolvePatternsForProvider=G;class B{constructor(de,te){this._parsedIncludeExpression=null,this._excludeExpression={...de.excludePattern||{},...te.excludePattern||{}},this._parsedExcludeExpression=t.parse(this._excludeExpression);let he=de.includePattern;te.includePattern&&(he?he={...he,...te.includePattern}:he=te.includePattern),he&&(this._parsedIncludeExpression=t.parse(he))}matchesExcludesSync(de,te,he){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(de,te,he))}includedInQuerySync(de,te,he){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(de,te,he)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(de,te,he))}includedInQuery(de,te,he){const Y=this._parsedExcludeExpression(de,te,he),ve=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(de,te,he):!0;return(0,D.isThenable)(Y)?Y.then(be=>be?!1:ve()):ve()}hasSiblingExcludeClauses(){return U(this._excludeExpression)}}e.QueryGlobTester=B;function U(K){for(const de in K)if(typeof K[de]!="boolean")return!0;return!1}function x(K){if(!K)return;let de;return te=>(de||(de=(K()||Promise.resolve([])).then(he=>he?Q(he):{})),de.then(he=>!!he[te]))}e.hasSiblingPromiseFn=x;function $(K){if(!K)return;let de;return te=>{if(!de){const he=K();de=he?Q(he):{}}return!!de[te]}}e.hasSiblingFn=$;function Q(K){const de={};for(const te of K)de[te]=!0;return de}}),define(De[32],Ie([1,0,17,18,21,4,6,26,12,95,22,8,16,2,176,3,13,195,45,46,25,14,15,7,54,30,5]),function(J,e,l,t,C,P,_,I,w,k,L,D,S,T,E,p,b,m,v,h,c,g,n,u,s,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function d(A,z,H){return new L.ExtUri(F=>y(F,H)).isEqual(A,z)}function r(A,z,H){return d(A.uri,z.uri,H)?0:(0,D.compare)(A.uri.toString(),z.uri.toString())}function a(A,z,H){return A.index!==z.index?A.index<z.index?-1:1:d(A.uri,z.uri,H)?(0,D.compare)(A.name,z.name):(0,D.compare)(A.uri.toString(),z.uri.toString())}function f(A,z,H,F){const G=A.slice(0).sort((U,x)=>H(U,x,F)),B=z.slice(0).sort((U,x)=>H(U,x,F));return(0,l.delta)(G,B,(U,x)=>H(U,x,F))}function y(A,z){const H=z.getCapabilities(A.scheme);return!(H&&H&1024)}class R extends v.Workspace{static toExtHostWorkspace(z,H,F,G){if(!z)return{workspace:null,added:[],removed:[]};const{id:B,name:U,folders:x,configuration:$,transient:Q,isUntitled:K}=z,de=[],te=H;H?x.forEach((be,ke)=>{const Re=T.URI.revive(be.uri),ze=R._findFolder(F||H,Re,G);ze?(ze.name=be.name,ze.index=be.index,de.push(ze)):de.push({uri:Re,name:be.name,index:ke})}):de.push(...x.map(({uri:be,name:ke,index:Re})=>({uri:T.URI.revive(be),name:ke,index:Re}))),de.sort((be,ke)=>be.index<ke.index?-1:1);const he=new R(B,U,de,!!Q,$?T.URI.revive($):null,!!K,be=>y(be,G)),{added:Y,removed:ve}=f(te?te.workspaceFolders:[],he.workspaceFolders,r,G);return{workspace:he,added:Y,removed:ve}}static _findFolder(z,H,F){for(let G=0;G<z.folders.length;G++){const B=z.workspaceFolders[G];if(d(B.uri,H,F))return B}}constructor(z,H,F,G,B,U,x){super(z,F.map($=>new v.WorkspaceFolder($)),G,B,x),this._name=H,this._isUntitled=U,this._workspaceFolders=[],this._structure=I.TernarySearchTree.forUris(x),F.forEach($=>{this._workspaceFolders.push($),this._structure.set($.uri,$)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(z,H){return H&&this._structure.get(z)&&(z=(0,L.dirname)(z)),this._structure.findSubstr(z)}resolveWorkspaceFolder(z){return this._structure.get(z)}}let N=class{constructor(z,H,F,G,B){this._onDidChangeWorkspace=new P.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new P.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._logService=G,this._extHostFileSystemInfo=F,this._uriTransformerService=B,this._requestIdProvider=new k.Counter,this._barrier=new t.Barrier,this._proxy=z.getProxy(o.MainContext.MainThreadWorkspace),this._messageService=z.getProxy(o.MainContext.MainThreadMessageService);const U=H.workspace;this._confirmedWorkspace=U?new R(U.id,U.name,[],!!U.transient,U.configuration?T.URI.revive(U.configuration):null,!!U.isUntitled,x=>y(x,F)):void 0}$initializeWorkspace(z,H){this._trusted=H,this.$acceptWorkspaceData(z),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?T.URI.from({scheme:w.Schemas.untitled,path:(0,L.basename)((0,L.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(z,H,F,...G){const B=[];if(Array.isArray(G)&&G.forEach(K=>{T.URI.isUri(K.uri)&&!B.some(de=>d(de.uri,K.uri,this._extHostFileSystemInfo))&&B.push({uri:K.uri,name:K.name||(0,L.basenameOrAuthority)(K.uri)})}),this._unconfirmedWorkspace||[H,F].some(K=>typeof K!="number"||K<0)||F===0&&B.length===0)return!1;const U=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(H+F>U.length)return!1;const x=U.slice(0);x.splice(H,F,...B.map(K=>({uri:K.uri,name:K.name||(0,L.basenameOrAuthority)(K.uri),index:void 0})));for(let K=0;K<x.length;K++){const de=x[K];if(x.some((te,he)=>he!==K&&d(de.uri,te.uri,this._extHostFileSystemInfo)))return!1}x.forEach((K,de)=>K.index=de);const{added:$,removed:Q}=f(U,x,a,this._extHostFileSystemInfo);if($.length===0&&Q.length===0)return!1;if(this._proxy){const K=z.displayName||z.name;this._proxy.$updateWorkspaceFolders(K,H,F,B).then(void 0,de=>{this._unconfirmedWorkspace=void 0;const te={source:{identifier:z.identifier,label:z.displayName||z.name}};this._messageService.$showMessage(m.Severity.Error,(0,E.localize)(0,null,K,de.toString()),te,[])})}return this.trySetWorkspaceFolders(x),!0}getWorkspaceFolder(z,H){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(z,H)}async getWorkspaceFolder2(z,H){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(z,H)}async resolveWorkspaceFolder(z){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(z)}getPath(){if(!this._actualWorkspace)return;const{folders:z}=this._actualWorkspace;if(z.length!==0)return z[0].uri.fsPath}getRelativePath(z,H){let F,G="";if(typeof z=="string"?(F=T.URI.file(z),G=z):typeof z<"u"&&(F=z,G=z.fsPath),!F)return G;const B=this.getWorkspaceFolder(F,!0);if(!B)return G;typeof H>"u"&&this._actualWorkspace&&(H=this._actualWorkspace.folders.length>1);let U=(0,L.relativePath)(B.uri,F);return H&&B.name&&(U=`${B.name}/${U}`),U}trySetWorkspaceFolders(z){this._actualWorkspace&&(this._unconfirmedWorkspace=R.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:z,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(z){const{workspace:H,added:F,removed:G}=R.toExtHostWorkspace(z,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=H||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:F,removed:G}))}findFiles(z,H,F,G,B=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${G.value}, entryPoint: findFiles`);let U;if(H===null?U=!1:H&&(typeof H=="string"?U=H:U=H.pattern),B&&B.isCancellationRequested)return Promise.resolve([]);const{includePattern:x,folder:$}=M(n.GlobPattern.from(z));return this._proxy.$startFileSearch((0,S.withUndefinedAsNull)(x),(0,S.withUndefinedAsNull)($),(0,S.withUndefinedAsNull)(U),(0,S.withUndefinedAsNull)(F),B).then(Q=>Array.isArray(Q)?Q.map(K=>T.URI.revive(K)):[])}async findTextInFiles(z,H,F,G,B=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${G.value}, entryPoint: findTextInFiles`);const U=this._requestIdProvider.getNext(),x=typeof H.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:H.previewOptions,{includePattern:$,folder:Q}=M(n.GlobPattern.from(H.include)),K=typeof H.exclude=="string"?H.exclude:H.exclude?H.exclude.pattern:void 0,de={ignoreSymlinks:typeof H.followSymlinks=="boolean"?!H.followSymlinks:void 0,disregardIgnoreFiles:typeof H.useIgnoreFiles=="boolean"?!H.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof H.useGlobalIgnoreFiles=="boolean"?!H.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof H.useParentIgnoreFiles=="boolean"?!H.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof H.useDefaultExcludes=="boolean"?!H.useDefaultExcludes:!0,fileEncoding:H.encoding,maxResults:H.maxResults,previewOptions:x,afterContext:H.afterContext,beforeContext:H.beforeContext,includePattern:$,excludePattern:K},te=!1;if(this._activeSearchCallbacks[U]=he=>{if(te)return;const Y=T.URI.revive(he.resource);he.results.forEach(ve=>{(0,i.resultIsMatch)(ve)?F({uri:Y,preview:{text:ve.preview.text,matches:(0,l.mapArrayOrNot)(ve.preview.matches,be=>new u.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))},ranges:(0,l.mapArrayOrNot)(ve.ranges,be=>new u.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))}):F({uri:Y,text:ve.text,lineNumber:ve.lineNumber})})},B.isCancellationRequested)return{};try{const he=await this._proxy.$startTextSearch(z,(0,S.withUndefinedAsNull)(Q),de,U,B);return delete this._activeSearchCallbacks[U],he||{}}catch(he){throw delete this._activeSearchCallbacks[U],he}}$handleTextSearchResult(z,H){this._activeSearchCallbacks[H]?.(z)}saveAll(z){return this._proxy.$saveAll(z)}resolveProxy(z){return this._proxy.$resolveProxy(z)}get trusted(){return this._trusted}requestWorkspaceTrust(z){return this._proxy.$requestWorkspaceTrust(z)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(z,H){if(this._editSessionIdentityProviders.has(z))throw new Error(`A provider has already been registered for scheme ${z}`);this._editSessionIdentityProviders.set(z,H);const F=this._uriTransformerService.transformOutgoingScheme(z),G=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(G,F),(0,_.toDisposable)(()=>{this._editSessionIdentityProviders.delete(z),this._proxy.$unregisterEditSessionIdentityProvider(G)})}async $getEditSessionIdentifier(z,H){this._logService.info("Getting edit session identifier for workspaceFolder",z);const F=await this.resolveWorkspaceFolder(T.URI.revive(z));if(!F){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const G=this._editSessionIdentityProviders.get(F.uri.scheme);if(this._logService.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!G),!G)return;const B=await G.provideEditSessionIdentity(F,H);if(this._logService.info("Provider returned edit session identifier: ",B),!!B)return B}};N=je([$e(0,g.IExtHostRpcService),$e(1,c.IExtHostInitDataService),$e(2,h.IExtHostFileSystemInfo),$e(3,b.ILogService),$e(4,s.IURITransformerService)],N),e.ExtHostWorkspace=N,e.IExtHostWorkspace=(0,p.createDecorator)("IExtHostWorkspace");function M(A){let z,H;return A&&(typeof A=="string"?z=A:(z=A.pattern,H=T.URI.revive(A.baseUri))),{includePattern:z,folder:H}}}),define(De[33],Ie([1,0,24,4,32,5,7,198,122,16,18,3,14,13,2]),function(J,e,l,t,C,P,_,I,w,k,L,D,S,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function p(u,s){if(s){const i=s.split(".");let o=u;for(let d=0;o&&d<i.length;d++)o=o[i[d]];return o}}function b(u){return u instanceof E.URI}function m(u){return u&&u.uri instanceof E.URI&&u.languageId&&typeof u.languageId=="string"}function v(u){return u&&!u.uri&&u.languageId&&typeof u.languageId=="string"}function h(u){return u&&u.uri instanceof E.URI&&(!u.name||typeof u.name=="string")&&(!u.index||typeof u.index=="number")}function c(u){if(b(u))return{resource:u};if(m(u))return{resource:u.uri,overrideIdentifier:u.languageId};if(v(u))return{overrideIdentifier:u.languageId};if(h(u))return{resource:u.uri};if(u===null)return{resource:null}}let g=class{constructor(s,i,o){this._proxy=s.getProxy(P.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=o,this._barrier=new L.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new n(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,i){this.getConfigProvider().then(o=>o.$acceptConfigurationChanged(s,i))}};g=je([$e(0,S.IExtHostRpcService),$e(1,C.IExtHostWorkspace),$e(2,T.ILogService)],g),e.ExtHostConfiguration=g;class n{constructor(s,i,o,d){this._onDidChangeConfiguration=new t.Emitter,this._proxy=s,this._logService=d,this._extHostWorkspace=i,this._configuration=I.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,i){const o={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=I.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,o))}getConfiguration(s,i,o){const d=c(i)||{},r=this._toReadonlyValue(s?p(this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,d,o?.identifier);function a(y){if(y==null)return null;if(typeof y=="boolean")return y?2:5;switch(y){case _.ConfigurationTarget.Global:return 2;case _.ConfigurationTarget.Workspace:return 5;case _.ConfigurationTarget.WorkspaceFolder:return 6}}const f={has(y){return typeof p(r,y)<"u"},get:(y,R)=>{this._validateConfigurationAccess(s?`${s}.${y}`:y,d,o?.identifier);let N=p(r,y);if(typeof N>"u")N=R;else{let M;const A=(z,H)=>{let F;const G=()=>{M=M||(0,l.deepClone)(r),F=F||p(M,H)};return(0,k.isObject)(z)?new Proxy(z,{get:(B,U)=>{if(typeof U=="string"&&U.toLowerCase()==="tojson")return G(),()=>F;if(M)return F=F||p(M,H),F[U];const x=B[U];return typeof U=="string"?A(x,`${H}.${U}`):x},set:(B,U,x)=>(G(),F&&(F[U]=x),!0),deleteProperty:(B,U)=>(G(),F&&delete F[U],!0),defineProperty:(B,U,x)=>(G(),F&&Object.defineProperty(F,U,x),!0)}):z};N=A(N,y)}return N},update:(y,R,N,M)=>{y=s?`${s}.${y}`:y;const A=a(N);return R!==void 0?this._proxy.$updateConfigurationOption(A,y,R,d,M):this._proxy.$removeConfigurationOption(A,y,d,M)},inspect:y=>{y=s?`${s}.${y}`:y;const R=(0,l.deepClone)(this._configuration.inspect(y,d,this._extHostWorkspace.workspace));if(R)return{key:y,defaultValue:R.policy?.value??R.default?.value,globalValue:R.user?.value??R.application?.value,workspaceValue:R.workspace?.value,workspaceFolderValue:R.workspaceFolder?.value,defaultLanguageValue:R.default?.override,globalLanguageValue:R.user?.override??R.application?.override,workspaceLanguageValue:R.workspace?.override,workspaceFolderLanguageValue:R.workspaceFolder?.override,languageIds:R.overrideIdentifiers}}};return typeof r=="object"&&(0,l.mixin)(f,r,!1),Object.freeze(f)}_toReadonlyValue(s){const i=o=>(0,k.isObject)(o)?new Proxy(o,{get:(d,r)=>i(d[r]),set:(d,r,a)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(r)}' of object`)},deleteProperty:(d,r)=>{throw new Error(`TypeError: Cannot delete read only property '${String(r)}' of object`)},defineProperty:(d,r)=>{throw new Error(`TypeError: Cannot define property '${String(r)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):o;return i(s)}_validateConfigurationAccess(s,i,o){const d=w.OVERRIDE_PROPERTY_REGEX.test(s)?4:this._configurationScopes.get(s),r=o?`[${o.value}] `:"";if(d===4){typeof i?.resource>"u"&&this._logService.warn(`${r}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){i?.resource&&this._logService.warn(`${r}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,i){const o=new I.ConfigurationChangeEvent(s,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(d,r)=>o.affectsConfiguration(d,c(r))})}_toMap(s){return s.reduce((i,o)=>(i.set(o[0],o[1]),i),new Map)}}e.ExtHostConfigProvider=n,e.IExtHostConfiguration=(0,D.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,l):C?C.value=l:e.set(J,l),l},Be=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[70],Ie([1,0,2,18,4,5,7,32,57,33,21,39,14,25,3,12,11,13,65,233,10]),function(J,e,l,t,C,P,_,I,w,k,L,D,S,T,E,p,b,m,v,h,c){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var n;(function(H){function F(B){if(B!=null)return B}H.from=F;function G(B){if(B!=null)return B}H.to=G})(n=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var u;(function(H){function F(B){if(B!=null)return B}H.from=F;function G(B){if(B!=null)return B}H.to=G})(u=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(H){function F(B){if(B!=null)return B}H.from=F;function G(B){if(B!=null)return B}H.to=G})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(H){function F(U){if(U){const x=U;return x&&!!x.process}else return!1}H.is=F;function G(U){if(U==null)return;const x={process:U.process,args:U.args};return U.options&&(x.options=s.from(U.options)),x}H.from=G;function B(U){if(U!=null)return new _.ProcessExecution(U.process,U.args,U.options)}H.to=B})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var o;(function(H){function F(B){if(B!=null)return B}H.from=F;function G(B){if(B!=null)return B}H.to=G})(o=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var d;(function(H){function F(U){if(U){const x=U;return x&&(!!x.commandLine||!!x.command)}else return!1}H.is=F;function G(U){if(U==null)return;const x={};return U.commandLine!==void 0?x.commandLine=U.commandLine:(x.command=U.command,x.args=U.args),U.options&&(x.options=o.from(U.options)),x}H.from=G;function B(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new _.ShellExecution(U.commandLine,U.options):new _.ShellExecution(U.command,U.args?U.args:[],U.options)}H.to=B})(d=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var r;(function(H){function F(U){if(U){const x=U;return x&&x.customExecution==="customExecution"}else return!1}H.is=F;function G(U){return{customExecution:"customExecution"}}H.from=G;function B(U,x){return x.get(U)}H.to=B})(r=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var a;(function(H){function F(G,B){let U;return G.scope!==void 0&&typeof G.scope!="number"?U=G.scope.uri:G.scope!==void 0&&typeof G.scope=="number"&&(G.scope===_.TaskScope.Workspace&&B&&B.workspaceFile?U=B.workspaceFile:U=h.USER_TASKS_GROUP_KEY),{id:G._id,workspaceFolder:U}}H.from=F})(a=e.TaskHandleDTO||(e.TaskHandleDTO={}));var f;(function(H){function F(G){if(G!=null)return{_id:G.id,isDefault:G.isDefault}}H.from=F})(f=e.TaskGroupDTO||(e.TaskGroupDTO={}));var y;(function(H){function F(U,x){if(U==null)return[];const $=[];for(const Q of U){const K=G(Q,x);K&&$.push(K)}return $}H.fromMany=F;function G(U,x){if(U==null)return;let $;U.execution instanceof _.ProcessExecution?$=i.from(U.execution):U.execution instanceof _.ShellExecution?$=d.from(U.execution):U.execution&&U.execution instanceof _.CustomExecution&&($=r.from(U.execution));const Q=n.from(U.definition);let K;return U.scope?typeof U.scope=="number"?K=U.scope:K=U.scope.uri:K=_.TaskScope.Workspace,!Q||!K?void 0:{_id:U._id,definition:Q,name:U.name,source:{extensionId:x.identifier.value,label:U.source,scope:K},execution:$,isBackground:U.isBackground,group:f.from(U.group),presentationOptions:u.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}H.from=G;async function B(U,x,$){if(U==null)return;let Q;i.is(U.execution)?Q=i.to(U.execution):d.is(U.execution)?Q=d.to(U.execution):r.is(U.execution)&&(Q=r.to(U._id,$));const K=n.to(U.definition);let de;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?de=U.source.scope:de=await x.resolveWorkspaceFolder(l.URI.revive(U.source.scope)):de=_.TaskScope.Workspace),!K||!de)return;const te=new _.Task(K,de,U.name,U.source.label,Q,U.problemMatchers);return U.isBackground!==void 0&&(te.isBackground=U.isBackground),U.group!==void 0&&(te.group=_.TaskGroup.from(U.group._id),te.group&&U.group.isDefault&&(te.group=new _.TaskGroup(te.group.id,te.group.label),U.group.isDefault===!0&&(te.group.isDefault=U.group.isDefault))),U.presentationOptions&&(te.presentationOptions=u.to(U.presentationOptions)),U._id&&(te._id=U._id),U.detail&&(te.detail=U.detail),te}H.to=B})(y=e.TaskDTO||(e.TaskDTO={}));var R;(function(H){function F(B){return B}H.from=F;function G(B){if(!!B)return Object.assign(Object.create(null),B)}H.to=G})(R=e.TaskFilterDTO||(e.TaskFilterDTO={}));class N{constructor(F,G,B){this._id=G,this._task=B,g.set(this,void 0),tt(this,g,F,"f")}get task(){return this._task}terminate(){Be(this,g,"f").terminateTask(this)}fireDidStartProcess(F){}fireDidEndProcess(F){}}g=new WeakMap;var M;(function(H){function F(G){return{id:G._id,task:void 0}}H.from=F})(M=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let A=class{constructor(F,G,B,U,x,$,Q,K){this._onDidExecuteTask=new C.Emitter,this._onDidTerminateTask=new C.Emitter,this._onDidTaskProcessStarted=new C.Emitter,this._onDidTaskProcessEnded=new C.Emitter,this._proxy=F.getProxy(P.MainContext.MainThreadTask),this._workspaceProvider=B,this._editorService=U,this._configurationService=x,this._terminalService=$,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=Q,this._deprecationService=K,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(F,G,B){if(!B)return new _.Disposable(()=>{});const U=this.nextHandle();return this._handlers.set(U,{type:G,provider:B,extension:F}),this._proxy.$registerTaskProvider(U,G),new _.Disposable(()=>{this._handlers.delete(U),this._proxy.$unregisterTaskProvider(U)})}registerTaskSystem(F,G){this._proxy.$registerTaskSystem(F,G)}fetchTasks(F){return this._proxy.$fetchTasks(R.from(F)).then(async G=>{const B=[];for(const U of G){const x=await y.to(U,this._workspaceProvider,this._providedCustomExecutions2);x&&B.push(x)}return B})}get taskExecutions(){const F=[];return this._taskExecutions.forEach(G=>F.push(G)),F}terminateTask(F){if(!(F instanceof N))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(F._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(F,G,B){const U=this._providedCustomExecutions2.get(F.id);U&&(this._activeCustomExecutions2.set(F.id,U),this._terminalService.attachPtyToTerminal(G,await U.callback(B))),this._lastStartedTask=F.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(F)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(F){const G=await this.getTaskExecution(F);this._taskExecutionPromises.delete(F.id),this._taskExecutions.delete(F.id),this.customExecutionComplete(F),this._onDidTerminateTask.fire({execution:G})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(F){const G=await this.getTaskExecution(F.id);this._onDidTaskProcessStarted.fire({execution:G,processId:F.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(F){const G=await this.getTaskExecution(F.id);this._onDidTaskProcessEnded.fire({execution:G,exitCode:F.exitCode})}$provideTasks(F,G){const B=this._handlers.get(F);if(!B)return Promise.reject(new Error("no handler found"));const U=[],x=(0,t.asPromise)(()=>B.provider.provideTasks(L.CancellationToken.None)).then($=>this.provideTasksInternal(G,U,B,$));return new Promise($=>{x.then(Q=>{Promise.all(U).then(()=>{$(Q)})})})}async $resolveTask(F,G){const B=this._handlers.get(F);if(!B)return Promise.reject(new Error("no handler found"));if(G.definition.type!==B.type)throw new Error(`Unexpected: Task of type [${G.definition.type}] cannot be resolved by provider of type [${B.type}].`);const U=await y.to(G,this._workspaceProvider,this._providedCustomExecutions2);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const x=await B.provider.resolveTask(U,L.CancellationToken.None);if(!x)return;this.checkDeprecation(x,B);const $=y.from(x,B.extension);if(!$)throw new Error("Unexpected: Task cannot be resolved.");if(x.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return r.is($.execution)&&await this.addCustomExecution($,x,!0),await this.resolveTaskInternal($)}nextHandle(){return this._handleCounter++}async addCustomExecution(F,G,B){const U=await this._proxy.$createTaskId(F);!B&&!this._providedCustomExecutions2.has(U)&&(this._notProvidedCustomExecutions.add(U),this._activeCustomExecutions2.set(U,G.execution)),this._providedCustomExecutions2.set(U,G.execution)}async getTaskExecution(F,G){if(typeof F=="string"){const x=this._taskExecutionPromises.get(F);if(!x)throw new c.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return x}const B=this._taskExecutionPromises.get(F.id);if(B)return B;const U=new Promise((x,$)=>{function Q(K,de,te){te?x(new N(K,de.id,te)):$("Unexpected: Task does not exist.")}G?Q(this,F,G):y.to(F.task,this._workspaceProvider,this._providedCustomExecutions2).then(K=>Q(this,F,K))});return this._taskExecutionPromises.set(F.id,U),U.then(x=>(this._taskExecutions.set(F.id,x),x),x=>Promise.reject(x))}checkDeprecation(F,G){F._deprecated&&this._deprecationService.report("Task.constructor",G.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(F){this._activeCustomExecutions2.get(F.id)&&this._activeCustomExecutions2.delete(F.id),this._notProvidedCustomExecutions.has(F.id)&&this._lastStartedTask!==F.id&&(this._providedCustomExecutions2.delete(F.id),this._notProvidedCustomExecutions.delete(F.id));const B=this._notProvidedCustomExecutions.values();let U=B.next();for(;!U.done;)!this._activeCustomExecutions2.has(U.value)&&this._lastStartedTask!==U.value&&(this._providedCustomExecutions2.delete(U.value),this._notProvidedCustomExecutions.delete(U.value)),U=B.next()}};A=je([$e(0,S.IExtHostRpcService),$e(1,T.IExtHostInitDataService),$e(2,I.IExtHostWorkspace),$e(3,w.IExtHostDocumentsAndEditors),$e(4,k.IExtHostConfiguration),$e(5,D.IExtHostTerminalService),$e(6,m.ILogService),$e(7,v.IExtHostApiDeprecationService)],A),e.ExtHostTaskBase=A;let z=class extends A{constructor(F,G,B,U,x,$,Q,K){super(F,G,B,U,x,$,Q,K),this.registerTaskSystem(p.Schemas.vscodeRemote,{scheme:p.Schemas.vscodeRemote,authority:"",platform:b.PlatformToString(0)})}async executeTask(F,G){if(!G.execution)throw new Error("Tasks to execute must include an execution");const B=y.from(G,F);if(B===void 0)throw new Error("Task is not valid");if(r.is(B.execution))await this.addCustomExecution(B,G,!1);else throw new c.NotSupportedError;const U=await this.getTaskExecution(await this._proxy.$getTaskExecution(B),G);return this._proxy.$executeTask(B).catch(x=>{throw new Error(x)}),U}provideTasksInternal(F,G,B,U){const x=[];if(U)for(const $ of U){this.checkDeprecation($,B),(!$.definition||!F[$.definition.type])&&this._logService.warn(`The task [${$.source}, ${$.name}] uses an undefined task type. The task will be ignored in the future.`);const Q=y.from($,B.extension);Q&&r.is(Q.execution)?(x.push(Q),G.push(this.addCustomExecution(Q,$,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:x,extension:B.extension}}async resolveTaskInternal(F){if(r.is(F.execution))return F;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(F,G){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(F,G,B){}};z=je([$e(0,S.IExtHostRpcService),$e(1,T.IExtHostInitDataService),$e(2,I.IExtHostWorkspace),$e(3,w.IExtHostDocumentsAndEditors),$e(4,k.IExtHostConfiguration),$e(5,D.IExtHostTerminalService),$e(6,m.ILogService),$e(7,v.IExtHostApiDeprecationService)],z),e.WorkerExtHostTask=z,e.IExtHostTask=(0,E.createDecorator)("IExtHostTask")}),define(De[278],Ie([1,0,9,21,50,36,22,51,30]),function(J,e,l,t,C,P,_,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(S,T,E){this.config=S,this.provider=T,this.sessionToken=E,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=S.filePattern,this.includePattern=S.includePattern&&P.parse(S.includePattern),this.maxResults=S.maxResults||void 0,this.exists=S.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=S.excludePattern&&P.parse(S.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(S=>S.cancel()),this.activeCancellationTokens=new Set}search(S){const T=this.config.folderQueries||[];return new Promise((E,p)=>{const b=m=>{this.resultCount++,S(m)};if(this.isCanceled)return E({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(m=>{const v=m.toString(),h=l.basename(v);this.globalExcludePattern&&this.globalExcludePattern(v,h)||this.matchFile(b,{base:m,basename:h})}),Promise.all(T.map(m=>this.searchInFolder(m,b))).then(m=>{E({limitHit:this.isLimitHit,stats:m[0]||void 0})},m=>{p(new Error((0,C.toErrorMessage)(m)))})})}async searchInFolder(S,T){const E=new t.CancellationTokenSource,p=this.getSearchOptionsForFolder(S),b=this.initDirectoryTree(),m=new w.QueryGlobTester(this.config,S),v=!m.hasSiblingExcludeClauses();let h;try{this.activeCancellationTokens.add(E),h=I.StopWatch.create();const c=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},p,E.token),g=h.elapsed(),n=I.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(c&&c.forEach(u=>{const s=l.posix.relative(S.folder.path,u.path);if(v){const i=l.basename(u.path);this.matchFile(T,{base:S.folder,relativePath:s,basename:i});return}this.addDirectoryEntries(b,S.folder,s,T)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(b,m,T),{providerTime:g,postProcessTime:n.elapsed()})}finally{E.dispose(),this.activeCancellationTokens.delete(E)}}getSearchOptionsForFolder(S){const T=(0,w.resolvePatternsForProvider)(this.config.includePattern,S.includePattern),E=(0,w.resolvePatternsForProvider)(this.config.excludePattern,S.excludePattern);return{folder:S.folder,excludes:E,includes:T,useIgnoreFiles:!S.disregardIgnoreFiles,useGlobalIgnoreFiles:!S.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!S.disregardParentIgnoreFiles,followSymlinks:!S.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const S={rootEntries:[],pathToEntries:Object.create(null)};return S.pathToEntries["."]=S.rootEntries,S}addDirectoryEntries({pathToEntries:S},T,E,p){if(E===this.filePattern){const m=l.basename(this.filePattern);this.matchFile(p,{base:T,relativePath:this.filePattern,basename:m})}function b(m){const v=l.basename(m),h=l.dirname(m);let c=S[h];c||(c=S[h]=[],b(h)),c.push({base:T,relativePath:m,basename:v})}b(E)}matchDirectoryTree({rootEntries:S,pathToEntries:T},E,p){const b=this,m=this.filePattern;function v(h){const c=(0,w.hasSiblingFn)(()=>h.map(g=>g.basename));for(let g=0,n=h.length;g<n;g++){const u=h[g],{relativePath:s,basename:i}=u;if(E.matchesExcludesSync(s,i,m!==i?c:void 0))continue;const o=T[s];if(o)v(o);else{if(s===m)continue;b.matchFile(p,u)}if(b.isLimitHit)break}}v(S)}matchFile(S,T){(!this.includePattern||T.relativePath&&this.includePattern(T.relativePath,T.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||S(T))}}class L{constructor(){this.sessions=new Map}fileSearch(S,T,E,p){const b=this.getSessionTokenSource(S.cacheKey),m=new k(S,T,b&&b.token);let v=0;const h=c=>{v+=c.length,E(c.map(g=>this.rawMatchToSearchItem(g)))};return this.doSearch(m,L.BATCH_SIZE,h,p).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:v,detailStats:c.stats}}))}clearCache(S){this.getSessionTokenSource(S)?.cancel()}getSessionTokenSource(S){if(!!S)return this.sessions.has(S)||this.sessions.set(S,new t.CancellationTokenSource),this.sessions.get(S)}rawMatchToSearchItem(S){return S.relativePath?{resource:_.joinPath(S.base,S.relativePath)}:{resource:S.base}}doSearch(S,T,E,p){p.onCancellationRequested(()=>{S.cancel()});const b=v=>{v&&(m.push(v),T>0&&m.length>=T&&(E(m),m=[]))};let m=[];return S.search(b).then(v=>(m.length&&E(m),v),v=>(m.length&&E(m),Promise.reject(v)))}}e.FileSearchManager=L,L.BATCH_SIZE=512}),define(De[279],Ie([1,0,17,75,36,107,26,12,9,22,8,16,2,160,187,83,13,45,130,277,30]),function(J,e,l,t,C,P,_,I,w,k,L,D,S,T,E,p,b,m,v,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let g=class{constructor(f,y,R,N,M){this.configurationService=f,this.workspaceContextService=y,this.editorGroupsService=R,this.logService=N,this.pathService=M}text(f,y,R={}){f=this.getContentPattern(f,R);const N=this.configurationService.getValue(),M=y&&y.some(z=>!this.configurationService.getValue({resource:z}).search.useRipgrep);return{...this.commonQuery(y?.map(m.toWorkspaceFolder),R),type:2,contentPattern:f,previewOptions:R.previewOptions,maxFileSize:R.maxFileSize,usePCRE2:N.search.usePCRE2||M||!1,beforeContext:R.beforeContext,afterContext:R.afterContext,userDisabledExcludesAndIgnoreFiles:R.disregardExcludeSettings&&R.disregardIgnoreFiles}}getContentPattern(f,y){const R=this.configurationService.getValue();f.isRegExp&&(f.pattern=f.pattern.replace(/\r?\n/g,"\\n"));const N={...f,wordSeparators:R.editor.wordSeparators};return this.isCaseSensitive(f,y)&&(N.isCaseSensitive=!0),this.isMultiline(f)&&(N.isMultiline=!0),N}file(f,y={}){return{...this.commonQuery(f,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey}}handleIncludeExclude(f,y){return f?(f=Array.isArray(f)?f.map(o):o(f),y?this.parseSearchPaths(f):{pattern:u(...Array.isArray(f)?f:[f])}):{}}commonQuery(f=[],y={}){const R=this.handleIncludeExclude(y.includePattern,y.expandPatterns),N=this.handleIncludeExclude(y.excludePattern,y.expandPatterns),M=f.length>1,A=(R.searchPaths&&R.searchPaths.length?R.searchPaths.map(F=>this.getFolderQueryForSearchPath(F,y,N)):f.map(F=>this.getFolderQueryForRoot(F,y,N,M))).filter(F=>!!F),z={_reason:y._reason,folderQueries:A,usingSearchPaths:!!(R.searchPaths&&R.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:N.pattern,includePattern:R.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const F=l.coalesce(l.flatten(this.editorGroupsService.groups.map(U=>U.editors.map(x=>x.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const G=F.filter(U=>(0,c.pathIncludedInQuery)(z,U.fsPath)),B=this.commonQueryFromFileList(G);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(B)),{...z,...B}}const H=y.extraFileResources&&y.extraFileResources.filter(F=>(0,c.pathIncludedInQuery)(z,F.fsPath));return z.extraFileResources=H&&H.length?H:void 0,z}commonQueryFromFileList(f){const y=[],R=new _.ResourceMap,N={};let M=!1;return f.forEach(A=>{if(A.scheme===I.Schemas.walkThrough)return;if((0,k.isAbsolutePath)(A)){const H=this.workspaceContextService.getWorkspaceFolder(A)?.uri??A.with({path:w.dirname(A.fsPath)});let F=R.get(H);F||(M=!0,F={folder:H,includePattern:{}},y.push(F),R.set(H,F));const G=w.relative(H.fsPath,A.fsPath);(0,D.assertIsDefined)(F.includePattern)[G.replace(/\\/g,"/")]=!0}else A.fsPath&&(M=!0,N[A.fsPath]=!0)}),{folderQueries:y,includePattern:N,usingSearchPaths:!0,excludePattern:M?void 0:{"**/*":!0}}}isCaseSensitive(f,y){if(y.isSmartCase){if(f.isRegExp){if(L.containsUppercaseCharacter(f.pattern,!0))return!0}else if(L.containsUppercaseCharacter(f.pattern))return!0}return!!f.isCaseSensitive}isMultiline(f){return f.isMultiline||f.isRegExp&&(0,T.isMultilineRegexSource)(f.pattern)||f.pattern.indexOf(`
`)>=0?!0:!!f.isMultiline}parseSearchPaths(f){const y=B=>w.isAbsolute(B)||/^\.\.?([\/\\]|$)/.test(B),N=(Array.isArray(f)?f:s(f)).map(B=>{const U=this.pathService.resolvedUserHome;return U?(0,P.untildify)(B,U.scheme===I.Schemas.file?U.fsPath:U.path):B}),M=t.groupBy(N,B=>y(B)?"searchPaths":"exprSegments"),A=(M.exprSegments||[]).map(B=>L.rtrim(B,"/")).map(B=>L.rtrim(B,"\\")).map(B=>(B[0]==="."&&(B="*"+B),i(B))),z={},H=this.expandSearchPathPatterns(M.searchPaths||[]);H&&H.length&&(z.searchPaths=H);const F=l.flatten(A),G=u(...F);return G&&(z.pattern=G),z}getExcludesForFolder(f,y){return y.disregardExcludeSettings?void 0:(0,c.getExcludes)(f,!y.disregardSearchExcludeSettings)}expandSearchPathPatterns(f){if(!f||!f.length)return[];const y=l.flatten(f.map(N=>{let{pathPortion:M,globPortion:A}=n(N);A&&(A=d(A));const z=this.expandOneSearchPath(M);return l.flatten(z.map(H=>this.resolveOneSearchPathPattern(H,A)))})),R=new Map;return y.forEach(N=>{const M=N.searchPath.toString(),A=R.get(M);A?N.pattern&&(A.pattern=A.pattern||{},A.pattern[N.pattern]=!0):R.set(M,{searchPath:N.searchPath,pattern:N.pattern?u(N.pattern):void 0})}),Array.from(R.values())}expandOneSearchPath(f){if(w.isAbsolute(f)){const y=this.workspaceContextService.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==I.Schemas.file?[{searchPath:y[0].uri.with({path:f})}]:[{searchPath:S.URI.file(w.normalize(f))}]}if(this.workspaceContextService.getWorkbenchState()===2){const y=this.workspaceContextService.getWorkspace().folders[0].uri;if(f=o(f),f.startsWith("../")||f===".."){const N=w.posix.resolve(y.path,f);return[{searchPath:y.with({path:N})}]}const R=d(f);return[{searchPath:y,pattern:R}]}else{if(f==="./"||f===".\\")return[];{const y=f.replace(/^\.[\/\\]/,""),N=this.workspaceContextService.getWorkspace().folders.map(M=>{const A=y.match(new RegExp(`^${L.escapeRegExpCharacters(M.name)}(?:/(.*)|$)`));return A?{match:A,folder:M}:null}).filter(D.isDefined);if(N.length)return N.map(M=>{const A=M.match[1];return{searchPath:M.folder.uri,pattern:A&&d(A)}});{const M=f.match(/\.[\/\\](.+)[\/\\]?/),A=M?M[1]:f,z=E.localize(0,null,A);throw new Error(z)}}}}resolveOneSearchPathPattern(f,y){const R=f.pattern&&y?`${f.pattern}/${y}`:f.pattern||y,N=[{searchPath:f.searchPath,pattern:R}];return R&&!R.endsWith("**")&&N.push({searchPath:f.searchPath,pattern:R+"/**"}),N}getFolderQueryForSearchPath(f,y,R){const N=this.getFolderQueryForRoot((0,m.toWorkspaceFolder)(f.searchPath),y,R,!1);return N?{...N,includePattern:f.pattern}:null}getFolderQueryForRoot(f,y,R,N){let M;const A=S.URI.isUri(f)?f:f.uri;if(R.searchPaths){const B=R.searchPaths.filter(U=>(0,k.isEqual)(U.searchPath,A))[0];if(B&&!B.pattern)return null;B&&(M=B.pattern)}const z=this.configurationService.getValue({resource:A}),F={...this.getExcludesForFolder(z,y)||{},...M||{}},G=S.URI.isUri(f)?(0,k.basename)(f):f.name;return{folder:A,folderName:N?G:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof y.disregardParentIgnoreFiles=="boolean"?y.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!z.search.followSymlinks}}};g=je([$e(0,p.IConfigurationService),$e(1,m.IWorkspaceContextService),$e(2,v.IEditorGroupsService),$e(3,b.ILogService),$e(4,h.IPathService)],g),e.QueryBuilder=g;function n(a){const f=a.match(/[\*\{\}\(\)\[\]\?]/);if(f){const y=f.index,R=a.substr(0,y).match(/[/|\\][^/\\]*$/);if(R){let N=a.substr(0,R.index);return N.match(/[/\\]/)||(N+="/"),{pathPortion:N,globPortion:a.substr((R.index||0)+1)}}}return{pathPortion:a}}function u(...a){return a.length?a.reduce((f,y)=>(f[y]=!0,f),Object.create(null)):void 0}function s(a){return C.splitGlobAware(a,",").map(f=>f.trim()).filter(f=>!!f.length)}function i(a){return[`**/${a}/**`,`**/${a}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function o(a){return a.replace(/\\/g,"/")}function d(a){return o(a).replace(/^\.\//,"").replace(/\/+$/g,"")}function r(a,f){a=l.distinct(a,N=>N.toString());const y=[],R=f.getWorkspace();return a&&a.forEach(N=>{let M;if(f.getWorkbenchState()===2)M=(0,k.relativePath)(R.folders[0].uri,N),M&&M!=="."&&(M="./"+M);else{const A=f.getWorkspaceFolder(N);if(A){const z=A.name;if(R.folders.filter(F=>F.name===z).length===1){const F=(0,k.relativePath)(A.uri,N);F===""?M=`./${A.name}`:M=`./${A.name}/${F}`}else M=N.fsPath}}M&&y.push(M)}),y}e.resolveResourcesForSearchIncludes=r}),define(De[280],Ie([1,0,22,2,21,10,3,279,30,45]),function(J,e,l,t,C,P,_,I,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const L=7e3;function D(p,b){const m=b.activationEvents;if(!m)return Promise.resolve(void 0);const v=[],h=[];for(const i of m)if(/^workspaceContains:/.test(i)){const o=i.substr(18);o.indexOf("*")>=0||o.indexOf("?")>=0||p.forceUsingSearch?h.push(o):v.push(o)}if(v.length===0&&h.length===0)return Promise.resolve(void 0);let c;const g=new Promise((i,o)=>{c=i}),n=i=>c({activationEvent:i}),u=Promise.all(v.map(i=>S(p,i,n))).then(()=>{}),s=T(p,b.identifier,h,n);return Promise.all([u,s]).then(()=>{c(void 0)}),g}e.checkActivateWorkspaceContainsExtension=D;async function S(p,b,m){for(const v of p.folders)if(await p.exists(l.joinPath(t.URI.revive(v),b))){m(`workspaceContains:${b}`);return}}async function T(p,b,m,v){if(m.length===0)return Promise.resolve(void 0);const h=new C.CancellationTokenSource,c=p.checkExists(p.folders,m,h.token),g=setTimeout(async()=>{h.cancel(),p.logService.info(`Not activating extension '${b.value}': Timed out while searching for 'workspaceContains' pattern ${m.join(",")}`)},L);let n=!1;try{n=await c}catch(u){P.isCancellationError(u)||P.onUnexpectedError(u)}h.dispose(),clearTimeout(g),n&&v(`workspaceContains:${m.join(",")}`)}function E(p,b,m,v){const h=p.get(_.IInstantiationService),c=p.get(w.ISearchService),n=h.createInstance(I.QueryBuilder).file(b.map(u=>(0,k.toWorkspaceFolder)(t.URI.revive(u))),{_reason:"checkExists",includePattern:m,exists:!0});return c.fileSearch(n,v).then(u=>!!u.limitHit,u=>P.isCancellationError(u)?!1:Promise.reject(u))}e.checkGlobFileExists=E});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,C){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!C:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?C.call(J,l):C?C.value=l:e.set(J,l),l},Be=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[40],Ie([1,0,171,9,71,22,18,6,26,2,13,5,33,223,92,32,28,221,10,27,23,204,7,123,3,25,67,14,84,53,39,4,280,91,206,12,90]),function(J,e,l,t,C,P,_,I,w,k,L,D,S,T,E,p,b,m,v,h,c,g,n,u,s,i,o,d,r,a,f,y,R,N,M,A,z){"use strict";var H,F,G;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let B=class Fn extends I.Disposable{constructor(te,he,Y,ve,be,ke,Re,ze,oe,le,me){super(),this._onDidChangeRemoteConnectionData=this._register(new y.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=he,this._extHostContext=Y,this._initData=Re,this._extHostWorkspace=ve,this._extHostConfiguration=be,this._logService=ke,this._extHostTunnelService=oe,this._extHostTerminalService=le,this._extHostLocalizationService=me,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(D.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(D.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(D.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new _.Barrier,this._readyToStartExtensionHost=new _.Barrier,this._readyToRunExtensions=new _.Barrier,this._eagerExtensionsActivated=new _.Barrier,this._globalRegistry=new m.ExtensionDescriptionRegistry(this._initData.allExtensions);const Z=(0,b.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new m.ExtensionDescriptionRegistry($(this._globalRegistry,Z)),this._storage=new E.ExtHostStorage(this._extHostContext),this._secretState=new N.ExtHostSecretState(this._extHostContext),this._storagePath=ze,this._instaService=te.createChild(new r.ServiceCollection([E.IExtHostStorage,this._storage],[N.IExtHostSecretState,this._secretState]));let ae=[],ne=[];this._initData.remote.isRemote&&(ae=this._initData.allExtensions.filter(O=>!O.main&&!O.browser).map(O=>O.identifier),ne=this._initData.allExtensions.filter(O=>!Z.has(h.ExtensionIdentifier.toKey(O.identifier.value))).filter(O=>(O.main||O.browser)&&O.api==="none").map(O=>O.identifier));const ie=(0,b.extensionIdentifiersArrayToSet)(ne);this._activator=this._register(new T.ExtensionsActivator(this._myRegistry,ae,ne,{onExtensionActivationError:(O,V,q)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(O,v.transformErrorForSerialization(V),q)},actualActivateExtension:async(O,V)=>{if(ie.has(h.ExtensionIdentifier.toKey(O)))return await this._mainThreadExtensionsProxy.$activateExtension(O,V),new T.HostExtension;const q=this._myRegistry.getExtensionDescription(O);return this._activateExtension(q,V)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),C.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(te){v.onUnexpectedError(te)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let te=[];try{te=this._myRegistry.getAllExtensionDescriptions().map(be=>be.identifier).filter(be=>this.isActivated(be)).map(be=>this._deactivate(be))}catch{}await Promise.all(te)}terminate(te,he=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${te}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),v.setUnexpectedErrorHandler(ve=>{this._logService.error(ve)}),this._extHostContext.dispose();const Y=this._deactivateAll();Promise.race([(0,_.timeout)(5e3),Y]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${he}`):this._logService.info(`Extension host exiting with code ${he}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(he)})}isActivated(te){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(te):!1}async getExtension(te){const he=await this._mainThreadExtensionsProxy.$getExtension(te);let Y;if(he?.browserNlsBundleUris){Y={};for(const ve of Object.keys(he.browserNlsBundleUris))Y[ve]=k.URI.revive(he.browserNlsBundleUris[ve])}return he&&{...he,identifier:new h.ExtensionIdentifier(he.identifier.value),extensionLocation:k.URI.revive(he.extensionLocation),browserNlsBundleUris:Y}}_activateByEvent(te,he){return this._activator.activateByEvent(te,he)}_activateById(te,he){return this._activator.activateById(te,he)}activateByIdWithErrors(te,he){return this._activateById(te,he).then(()=>{const Y=this._activator.getActivatedExtension(te);if(Y.activationFailed)return Promise.reject(Y.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(te=>this._myRegistry)}getExtensionExports(te){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(te).exports:null}async _realPathExtensionUri(te){if(te.scheme!==A.Schemas.file)return te;const he=await this._hostUtils.realpath(te.fsPath);return k.URI.file(he)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(te=>new K(te))),this._extensionPathIndex}async _createExtensionPathIndex(te){const he=w.TernarySearchTree.forUris(Y=>P.extUriBiasedIgnorePathCase.ignorePathCasing(Y));return await Promise.all(te.map(async Y=>{if(this._getEntryPoint(Y)){const ve=await this._realPathExtensionUri(Y.extensionLocation);he.set(ve,Y)}})),he}_deactivate(te){let he=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(te))return he;const Y=this._activator.getActivatedExtension(te);if(!Y)return he;try{typeof Y.module.deactivate=="function"&&(he=Promise.resolve(Y.module.deactivate()).then(void 0,ve=>(this._logService.error(ve),Promise.resolve(void 0))))}catch(ve){this._logService.error(`An error occurred when deactivating the extension '${te.value}':`),this._logService.error(ve)}try{(0,I.dispose)(Y.subscriptions)}catch(ve){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${te.value}':`),this._logService.error(ve)}return he}async _activateExtension(te,he){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(te.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(te.identifier),this._doActivateExtension(te,he).then(Y=>{const ve=Y.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(te.identifier,ve.codeLoadingTime,ve.activateCallTime,ve.activateResolvedTime,he),this._logExtensionActivationTimes(te,he,"success",ve),Y},Y=>{throw this._logExtensionActivationTimes(te,he,"failure"),Y})}_logExtensionActivationTimes(te,he,Y,ve){const be=U(te,he);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...be,...ve||{},outcome:Y})}_doActivateExtension(te,he){const Y=U(te,he);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",Y);const ve=this._getEntryPoint(te);if(!ve)return Promise.resolve(new T.EmptyExtension(T.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${te.identifier.value}, startup: ${he.startup}, activationEvent: '${he.activationEvent}'${te.identifier.value!==he.extensionId.value?`, root cause: ${he.extensionId.value}`:""}`),this._logService.flush();const be=new T.ExtensionActivationTimesBuilder(he.startup);return Promise.all([this._loadCommonJSModule(te,(0,P.joinPath)(te.extensionLocation,ve),be),this._loadExtensionContext(te)]).then(ke=>(C.mark(`code/extHost/willActivateExtension/${te.identifier.value}`),Fn._callActivate(this._logService,te.identifier,ke[0],ke[1],be))).then(ke=>(C.mark(`code/extHost/didActivateExtension/${te.identifier.value}`),ke))}_loadExtensionContext(te){const he=new g.ExtensionGlobalMemento(te,this._storage),Y=new g.ExtensionMemento(te.identifier.value,!1,this._storage),ve=new M.ExtensionSecrets(te,this._secretState),be=te.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,ke=this._initData.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${te.identifier.value}`),Promise.all([he.whenReady,Y.whenReady,this._storagePath.whenReady]).then(()=>{const Re=this;let ze,oe;const le=(0,b.isProposedApiEnabled)(te,"ipc")?this._initData.messagePorts?.get(h.ExtensionIdentifier.toKey(te.identifier)):void 0;return Object.freeze({globalState:he,workspaceState:Y,secrets:ve,subscriptions:[],get extensionUri(){return te.extensionLocation},get extensionPath(){return te.extensionLocation.fsPath},asAbsolutePath(me){return t.join(te.extensionLocation.fsPath,me)},get storagePath(){return Re._storagePath.workspaceValue(te)?.fsPath},get globalStoragePath(){return Re._storagePath.globalValue(te).fsPath},get logPath(){return t.join(Re._initData.logsLocation.fsPath,te.identifier.value)},get logUri(){return k.URI.joinPath(Re._initData.logsLocation,te.identifier.value)},get storageUri(){return Re._storagePath.workspaceValue(te)},get globalStorageUri(){return Re._storagePath.globalValue(te)},get extensionMode(){return be},get extension(){return ze===void 0&&(ze=new x(Re,te.identifier,te,ke,!1)),ze},get extensionRuntime(){return(0,b.checkProposedApiEnabled)(te,"extensionRuntime"),Re.extensionRuntime},get environmentVariableCollection(){return Re._extHostTerminalService.getEnvironmentVariableCollection(te)},get messagePassingProtocol(){if(!oe){if(!le)return;const me=y.Event.buffer(y.Event.fromDOMEventEmitter(le,"message",Z=>Z.data));le.start(),oe={onDidReceiveMessage:me,postMessage:le.postMessage.bind(le)}}return oe}})})}static _callActivate(te,he,Y,ve,be){return Y=Y||{activate:void 0,deactivate:void 0},this._callActivateOptional(te,he,Y,ve,be).then(ke=>new T.ActivatedExtension(!1,null,be.build(),Y,ke,ve.subscriptions))}static _callActivateOptional(te,he,Y,ve,be){if(typeof Y.activate=="function")try{be.activateCallStart(),te.trace(`ExtensionService#_callActivateOptional ${he.value}`);const ke=typeof global=="object"?global:self,Re=Y.activate.apply(ke,[ve]);return be.activateCallStop(),be.activateResolveStart(),Promise.resolve(Re).then(ze=>(be.activateResolveStop(),ze))}catch(ke){return Promise.reject(ke)}else return Promise.resolve(Y)}_activateOneStartupFinished(te,he){this._activateById(te.identifier,{startup:!1,extensionId:te.identifier,activationEvent:he}).then(void 0,Y=>{this._logService.error(Y)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(C.getMarks());for(const te of this._myRegistry.getAllExtensionDescriptions())if(te.activationEvents)for(const he of te.activationEvents)he==="onStartupFinished"&&this._activateOneStartupFinished(te,he)}_handleEagerExtensions(){const te=this._activateByEvent("*",!0).then(void 0,be=>{this._logService.error(be)});this._register(this._extHostWorkspace.onDidChangeWorkspace(be=>this._handleWorkspaceContainsEagerExtensions(be.added)));const he=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],Y=this._handleWorkspaceContainsEagerExtensions(he),ve=Promise.all([te,Y]).then(()=>{});return Promise.race([ve,(0,_.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ve}_handleWorkspaceContainsEagerExtensions(te){return te.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(he=>this._handleWorkspaceContainsEagerExtension(te,he))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(te,he){if(this.isActivated(he.identifier))return;const Y=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ve={logService:this._logService,folders:te.map(ke=>ke.uri),forceUsingSearch:Y,exists:ke=>this._hostUtils.exists(ke.fsPath),checkExists:(ke,Re,ze)=>this._mainThreadWorkspaceProxy.$checkExists(ke,Re,ze)},be=await(0,R.checkActivateWorkspaceContainsExtension)(ve,he);if(!!be)return this._activateById(he.identifier,{startup:!0,extensionId:he.identifier,activationEvent:be.activationEvent}).then(void 0,ke=>this._logService.error(ke))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(te){throw console.error(te),te}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:te,extensionTestsLocationURI:he}=this._initData.environment;if(!te||!he)throw new Error(l.localize(0,null));const Y=await this._loadCommonJSModule(null,he,new T.ExtensionActivationTimesBuilder(!1));if(!Y||typeof Y.run!="function")throw new Error(l.localize(1,null,he.toString()));return new Promise((ve,be)=>{const ke=(oe,le)=>{oe?be(oe):ve(typeof le=="number"&&le>0?1:0)},Re=(0,P.originalFSPath)(he),ze=Y.run(Re,ke);ze&&ze.then&&ze.then(()=>{ve(0)}).catch(oe=>{be(oe instanceof Error&&oe.stack?oe.stack:String(oe))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(te,he){return this._resolvers[te]=he,(0,I.toDisposable)(()=>{delete this._resolvers[te]})}async _activateAndGetResolver(te){const he=te.indexOf("+");if(he===-1)throw new Error("Not an authority that can be resolved!");const Y=te.substr(0,he);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${Y}`,!1),{authorityPrefix:Y,resolver:this._resolvers[Y]}}async $resolveAuthority(te,he){this._logService.info(`$resolveAuthority invoked for authority (${Q(te)})`);const{authorityPrefix:Y,resolver:ve}=await this._activateAndGetResolver(te);if(!ve)return{type:"error",error:{code:u.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Y}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(ve)),C.mark(`code/extHost/willResolveAuthority/${Y}`);const be=await ve.resolve(te,{resolveAttempt:he});C.mark(`code/extHost/didResolveAuthorityOK/${Y}`);const ke={authority:te,host:be.host,port:be.port,connectionToken:be.connectionToken},Re={extensionHostEnv:be.extensionHostEnv,isTrusted:be.isTrusted,authenticationSession:be.authenticationSessionForInitializingExtensions?{id:be.authenticationSessionForInitializingExtensions.id,providerId:be.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:ke,options:Re,tunnelInformation:{environmentTunnels:be.environmentTunnels,features:be.tunnelFeatures}}}}catch(be){if(C.mark(`code/extHost/didResolveAuthorityError/${Y}`),be instanceof n.RemoteAuthorityResolverError)return{type:"error",error:{code:be._code,message:be._message,detail:be._detail}};throw be}}async $getCanonicalURI(te,he){this._logService.info(`$getCanonicalURI invoked for authority (${Q(te)})`);const{resolver:Y}=await this._activateAndGetResolver(te);if(!Y)return null;const ve=k.URI.revive(he);if(typeof Y.getCanonicalURI>"u")return ve;const be=await(0,_.asPromise)(()=>Y.getCanonicalURI(ve));return be||ve}static _applyExtensionsDelta(te,he,Y){const ve=new m.ExtensionDescriptionRegistry(te.getAllExtensionDescriptions());ve.deltaExtensions(Y.toAdd,Y.toRemove);const be=(0,b.extensionIdentifiersArrayToSet)(he.getAllExtensionDescriptions().map(Re=>Re.identifier));for(const Re of Y.myToRemove)be.delete(h.ExtensionIdentifier.toKey(Re));for(const Re of Y.myToAdd)be.add(h.ExtensionIdentifier.toKey(Re));const ke=$(ve,be);return{globalRegistry:ve,myExtensions:ke}}$startExtensionHost(te){te.toAdd.forEach(ve=>ve.extensionLocation=k.URI.revive(ve.extensionLocation));const{globalRegistry:he,myExtensions:Y}=Fn._applyExtensionsDelta(this._globalRegistry,this._myRegistry,te);return this._globalRegistry.set(he.getAllExtensionDescriptions()),this._myRegistry.set(Y),this._startExtensionHost()}$activateByEvent(te,he){return he===1?this._activateByEvent(te,!1):this._readyToRunExtensions.wait().then(Y=>this._activateByEvent(te,!1))}async $activate(te,he){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(te)?(await this._activateById(te,he),!0):!1}async $deltaExtensions(te){te.toAdd.forEach(ke=>ke.extensionLocation=k.URI.revive(ke.extensionLocation));const{globalRegistry:he,myExtensions:Y}=Fn._applyExtensionsDelta(this._globalRegistry,this._myRegistry,te),ve=await this._createExtensionPathIndex(Y);return(await this.getExtensionPathIndex()).setSearchTree(ve),this._globalRegistry.set(he.getAllExtensionDescriptions()),this._myRegistry.set(Y),Promise.resolve(void 0)}async $test_latency(te){return te}async $test_up(te){return te.byteLength}async $test_down(te){const he=c.VSBuffer.alloc(te),Y=Math.random()%256;for(let ve=0;ve<te;ve++)he.writeUInt8(Y,ve);return he}async $updateRemoteConnectionData(te){this._remoteConnectionData=te,this._onDidChangeRemoteConnectionData.fire()}};B=je([$e(0,s.IInstantiationService),$e(1,e.IHostUtils),$e(2,d.IExtHostRpcService),$e(3,p.IExtHostWorkspace),$e(4,S.IExtHostConfiguration),$e(5,L.ILogService),$e(6,i.IExtHostInitDataService),$e(7,o.IExtensionStoragePaths),$e(8,a.IExtHostTunnelService),$e(9,f.IExtHostTerminalService),$e(10,z.IExtHostLocalizationService)],B),e.AbstractExtHostExtensionService=B;function U(de,te){return{id:de.identifier.value,name:de.name,extensionVersion:de.version,publisherDisplayName:de.publisher,activationEvents:de.activationEvents?de.activationEvents.join(","):null,isBuiltin:de.isBuiltin,reason:te.activationEvent,reasonId:te.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class x{constructor(te,he,Y,ve,be){H.set(this,void 0),F.set(this,void 0),G.set(this,void 0),tt(this,H,te,"f"),tt(this,F,he,"f"),tt(this,G,Y.identifier,"f"),this.id=Y.identifier.value,this.extensionUri=Y.extensionLocation,this.extensionPath=t.normalize((0,P.originalFSPath)(Y.extensionLocation)),this.packageJSON=Y,this.extensionKind=ve,this.isFromDifferentExtensionHost=be}get isActive(){return Be(this,H,"f").isActivated(Be(this,G,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Be(this,H,"f").getExtensionExports(Be(this,G,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Be(this,H,"f").activateByIdWithErrors(Be(this,G,"f"),{startup:!1,extensionId:Be(this,F,"f"),activationEvent:"api"}),this.exports}}e.Extension=x,H=new WeakMap,F=new WeakMap,G=new WeakMap;function $(de,te){return de.getAllExtensionDescriptions().filter(he=>te.has(h.ExtensionIdentifier.toKey(he.identifier)))}function Q(de){const te=de.indexOf("+");return te===-1?de:de.substring(0,te)}class K{constructor(te){this._searchTree=te}setSearchTree(te){this._searchTree=te}findSubstr(te){return this._searchTree.findSubstr(te)}forEach(te){return this._searchTree.forEach(te)}}e.ExtensionPaths=K}),define(De[281],Ie([1,0,71,2,5,33,28,27,14,25,3,40,41,13,8]),function(J,e,l,t,C,P,_,I,w,k,L,D,S,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let p=class{constructor(g,n,u,s,i,o,d){this._apiFactory=g,this._extensionRegistry=n,this._instaService=u,this._extHostConfiguration=s,this._extHostExtensionService=i,this._initData=o,this._logService=d,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),l.mark("code/extHost/willWaitForConfig");const g=await this._extHostConfiguration.getConfigProvider();l.mark("code/extHost/didWaitForConfig");const n=await this._extHostExtensionService.getExtensionPathIndex();this.register(new m(this._apiFactory,n,this._extensionRegistry,g,this._logService)),this.register(this._instaService.createInstance(v,n)),this.register(this._instaService.createInstance(b)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(h,n,this._initData.environment.appUriScheme))}register(g){if("nodeModuleName"in g)if(Array.isArray(g.nodeModuleName))for(const n of g.nodeModuleName)this._factories.set(n,g);else this._factories.set(g.nodeModuleName,g);typeof g.alternativeModuleName=="function"&&this._alternatives.push(n=>g.alternativeModuleName(n))}};p=je([$e(2,L.IInstantiationService),$e(3,P.IExtHostConfiguration),$e(4,D.IExtHostExtensionService),$e(5,k.IExtHostInitDataService),$e(6,T.ILogService)],p),e.RequireInterceptor=p;let b=class Zn{constructor(g){if(g.environment.appRoot&&Zn.aliased.size){const n=(0,E.escapeRegExpCharacters)(this.forceForwardSlashes(g.environment.appRoot.fsPath)),u="[a-z0-9_.-]",s=`@${u}+\\/${u}+|${u}+`,i="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${n}/${i}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(g){if(!this.re)return;const n=this.re.exec(this.forceForwardSlashes(g));if(!n)return;const[,u,s,i]=n,o=Zn.aliased.get(s);if(o!==void 0)return console.warn(`${s} as been renamed to ${o}, please update your imports`),u+o+i}forceForwardSlashes(g){return g.replace(/\\/g,"/")}};b.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),b=je([$e(0,k.IExtHostInitDataService)],b);class m{constructor(g,n,u,s,i){this._apiFactory=g,this._extensionPaths=n,this._extensionRegistry=u,this._configProvider=s,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(g,n){const u=this._extensionPaths.findSubstr(n);if(u){let s=this._extApiImpl.get(I.ExtensionIdentifier.toKey(u.identifier));return s||(s=this._apiFactory(u,this._extensionRegistry,this._configProvider),this._extApiImpl.set(I.ExtensionIdentifier.toKey(u.identifier),s)),s}if(!this._defaultApiImpl){let s="";this._extensionPaths.forEach((i,o)=>s+=`	${o} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${n}. These are the extension path mappings: 
${s}`),this._defaultApiImpl=this._apiFactory(_.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let v=class{constructor(g,n,u){this._extensionPaths=g,this.nodeModuleName="keytar",this._mainThreadTelemetry=n.getProxy(C.MainContext.MainThreadTelemetry);const{environment:s}=u,i=n.getProxy(C.MainContext.MainThreadKeytar);if(s.appRoot){let o=s.appRoot.fsPath;S.platform==="win32"&&(o=o.replace(/\\/g,"/")),o[o.length-1]==="/"&&(o=o.substr(0,o.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${o}/node_modules.asar/keytar`),this.alternativeNames.add(`${o}/node_modules/keytar`)}this._impl={getPassword:(o,d)=>i.$getPassword(o,d),setPassword:(o,d,r)=>i.$setPassword(o,d,r),deletePassword:(o,d)=>i.$deletePassword(o,d),findPassword:o=>i.$findPassword(o),findCredentials(o){return i.$findCredentials(o)}}}load(g,n){const u=this._extensionPaths.findSubstr(n);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:u?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(g){const n=g.length;if(n<=7||!this.alternativeNames)return;const u=n-7;if((g.charAt(u)==="/"||g.charAt(u)==="\\")&&g.endsWith("keytar")&&(g=g.replace(/\\/g,"/"),this.alternativeNames.has(g)))return"keytar"}};v=je([$e(1,w.IExtHostRpcService),$e(2,k.IExtHostInitDataService)],v);let h=class{constructor(g,n,u){this._extensionPaths=g,this._appUriScheme=n,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=u.getProxy(C.MainContext.MainThreadTelemetry);const s=u.getProxy(C.MainContext.MainThreadWindow);this._impl=(i,o)=>{const d=t.URI.parse(i);return o?this.callOriginal(i,o):d.scheme==="http"||d.scheme==="https"?s.$openUri(d,i,{allowTunneling:!0}):d.scheme==="mailto"||d.scheme===this._appUriScheme?s.$openUri(d,i,{}):this.callOriginal(i,o)}}load(g,n,u){const s=this._extensionPaths.findSubstr(n);return s&&(this._extensionId=s.identifier.value,this.sendShimmingTelemetry()),this._original=u(g),this._impl}callOriginal(g,n){return this.sendNoForwardTelemetry(),this._original(g,n)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};h=je([$e(2,w.IExtHostRpcService)],h)}),define(De[47],Ie([1,0,76,6,9,41,3,57,58,40,7,32,218,33]),function(J,e,l,t,C,P,_,I,w,k,L,D,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,_.createDecorator)("IExtHostVariableResolverProvider");class E extends S.AbstractVariableResolverService{constructor(m,v,h,c,g,n,u){function s(){if(h){const i=h.activeEditor();if(i)return i.document.uri;const o=c.tabGroups.all.find(d=>d.isActive)?.activeTab;if(o!==void 0){if(o.input instanceof L.TextDiffTabInput||o.input instanceof L.NotebookDiffEditorTabInput)return o.input.modified;if(o.input instanceof L.TextTabInput||o.input instanceof L.NotebookEditorTabInput||o.input instanceof L.CustomEditorTabInput)return o.input.uri}}}super({getFolderUri:i=>{const o=n.folders.filter(d=>d.name===i);if(o&&o.length>0)return o[0].uri},getWorkspaceFolderCount:()=>n.folders.length,getConfigurationValue:(i,o)=>g.getConfiguration(void 0,i).get(o),getAppRoot:()=>P.cwd(),getExecPath:()=>P.env.VSCODE_EXEC_PATH,getFilePath:()=>{const i=s();if(i)return C.normalize(i.fsPath)},getWorkspaceFolderPathForFile:()=>{if(v){const i=s();if(i){const o=v.getWorkspaceFolder(i);if(o)return C.normalize(o.uri.fsPath)}}},getSelectedText:()=>{if(h){const i=h.activeEditor();if(i&&!i.selection.isEmpty)return i.document.getText(i.selection)}},getLineNumber:()=>{if(h){const i=h.activeEditor();if(i)return String(i.selection.end.line+1)}},getExtension:i=>m.getExtension(i)},void 0,u?Promise.resolve(u):void 0,Promise.resolve(P.env))}}let p=class extends t.Disposable{constructor(m,v,h,c,g){super(),this.extensionService=m,this.workspaceService=v,this.editorService=h,this.configurationService=c,this.editorTabs=g,this._resolver=new l.Lazy(async()=>{const n=await this.configurationService.getConfigProvider(),s={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async i=>{s.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new E(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,n,s,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};p=je([$e(0,k.IExtHostExtensionService),$e(1,D.IExtHostWorkspace),$e(2,I.IExtHostDocumentsAndEditors),$e(3,T.IExtHostConfiguration),$e(4,w.IExtHostEditorTabs)],p),e.ExtHostVariableResolverProviderService=p}),define(De[72],Ie([1,0,18,4,16,2,3,5,58,40,14,7,32,128,211,33,47]),function(J,e,l,t,C,P,_,I,w,k,L,D,S,T,E,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,_.createDecorator)("IExtHostDebugService");let m=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(s,i,o,d,r,a){this._workspaceService=i,this._extensionService=o,this._configurationService=d,this._editorTabs=r,this._variableResolver=a,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new t.Emitter,this._onDidTerminateDebugSession=new t.Emitter,this._onDidChangeActiveDebugSession=new t.Emitter,this._onDidReceiveDebugSessionCustomEvent=new t.Emitter,this._debugServiceProxy=s.getProxy(I.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new t.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new h(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(f=>{f.onDidChange(y=>{this.registerAllDebugTypes(f)}),this.registerAllDebugTypes(f)})}asDebugSourceUri(s,i){const o=s;if(typeof o.sourceReference=="number"&&o.sourceReference>0){let d=`debug:${encodeURIComponent(o.path||"")}`,r="?";return i&&(d+=`${r}session=${encodeURIComponent(i.id)}`,r="&"),d+=`${r}ref=${o.sourceReference}`,P.URI.parse(d)}else{if(o.path)return P.URI.file(o.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(s){const i=[];for(const o of s.getAllExtensionDescriptions())if(o.contributes){const d=o.contributes.debuggers;if(d&&d.length>0)for(const r of d)(0,E.isDebuggerMainContribution)(r)&&i.push(r.type)}this._debugServiceProxy.$registerDebugTypes(i)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const s=[];return this._breakpoints.forEach(i=>s.push(i)),s}addBreakpoints(s){this.startBreakpoints();const i=s.filter(r=>{const a=r.id;return this._breakpoints.has(a)?!1:(this._breakpoints.set(a,r),!0)});this.fireBreakpointChanges(i,[],[]);const o=[],d=new Map;for(const r of i)if(r instanceof D.SourceBreakpoint){let a=d.get(r.location.uri.toString());a||(a={type:"sourceMulti",uri:r.location.uri,lines:[]},d.set(r.location.uri.toString(),a),o.push(a)),a.lines.push({id:r.id,enabled:r.enabled,condition:r.condition,hitCondition:r.hitCondition,logMessage:r.logMessage,line:r.location.range.start.line,character:r.location.range.start.character})}else r instanceof D.FunctionBreakpoint&&o.push({type:"function",id:r.id,enabled:r.enabled,hitCondition:r.hitCondition,logMessage:r.logMessage,condition:r.condition,functionName:r.functionName});return this._debugServiceProxy.$registerBreakpoints(o)}removeBreakpoints(s){this.startBreakpoints();const i=s.filter(a=>this._breakpoints.delete(a.id));this.fireBreakpointChanges([],i,[]);const o=i.filter(a=>a instanceof D.SourceBreakpoint).map(a=>a.id),d=i.filter(a=>a instanceof D.FunctionBreakpoint).map(a=>a.id),r=i.filter(a=>a instanceof D.DataBreakpoint).map(a=>a.id);return this._debugServiceProxy.$unregisterBreakpoints(o,d,r)}startDebugging(s,i,o){return this._debugServiceProxy.$startDebugging(s?s.uri:void 0,i,{parentSessionID:o.parentSession?o.parentSession.id:void 0,lifecycleManagedByParent:o.lifecycleManagedByParent,repl:o.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:o.noDebug,compact:o.compact,debugUI:o.debugUI,suppressSaveBeforeStart:o.suppressSaveBeforeStart})}stopDebugging(s){return this._debugServiceProxy.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,i,o){if(!i)return new D.Disposable(()=>{});const d=this._configProviderHandleCounter++;return this._configProviders.push({type:s,handle:d,provider:i}),this._debugServiceProxy.$registerDebugConfigurationProvider(s,o,!!i.provideDebugConfigurations,!!i.resolveDebugConfiguration,!!i.resolveDebugConfigurationWithSubstitutedVariables,d),new D.Disposable(()=>{this._configProviders=this._configProviders.filter(r=>r.provider!==i),this._debugServiceProxy.$unregisterDebugConfigurationProvider(d)})}registerDebugAdapterDescriptorFactory(s,i,o){if(!o)return new D.Disposable(()=>{});if(!this.definesDebugType(s,i))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${i}' debugger.`);if(this.getAdapterDescriptorFactoryByType(i))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const d=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:i,handle:d,factory:o}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(i,d),new D.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(r=>r.factory!==o),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(d)})}registerDebugAdapterTrackerFactory(s,i){if(!i)return new D.Disposable(()=>{});const o=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:s,handle:o,factory:i}),new D.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(d=>d.factory!==i)})}async $runInTerminal(s,i){return Promise.resolve(void 0)}async $substituteVariables(s,i){let o;const d=await this.getFolder(s);return d&&(o={uri:d.uri,name:d.name,index:d.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(o,i)}createDebugAdapter(s,i){if(s.type==="implementation")return new g(s.implementation)}createSignService(){}async $startDASession(s,i){const o=this,d=await this.getSession(i);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(d.type),d).then(r=>{if(!r)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${d.type}' (extension might have failed to activate)`);const a=this.convertToDto(r),f=this.createDebugAdapter(a,d);if(!f)throw new Error(`Couldn't create a debug adapter for type '${d.type}'.`);const y=f;return this._debugAdapters.set(s,y),this.getDebugAdapterTrackers(d).then(R=>(R&&this._debugAdaptersTrackers.set(s,R),y.onMessage(async N=>{if(N.type==="request"&&N.command==="handshake"){const M=N,A={type:"response",seq:0,command:M.command,request_seq:M.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const z=await this._signService.sign(M.arguments.value);A.body={signature:z},y.sendResponse(A)}else throw new Error("no signer")}catch(z){A.success=!1,A.message=z.message,y.sendResponse(A)}}else R&&R.onDidSendMessage&&R.onDidSendMessage(N),N=(0,E.convertToVSCPaths)(N,!0),o._debugServiceProxy.$acceptDAMessage(s,N)}),y.onError(N=>{R&&R.onError&&R.onError(N),this._debugServiceProxy.$acceptDAError(s,N.name,N.message,N.stack)}),y.onExit(N=>{R&&R.onExit&&R.onExit((0,C.withNullAsUndefined)(N),void 0),this._debugServiceProxy.$acceptDAExit(s,(0,C.withNullAsUndefined)(N),void 0)}),R&&R.onWillStartSession&&R.onWillStartSession(),y.startSession()))})}$sendDAMessage(s,i){i=(0,E.convertToDAPaths)(i,!1);const o=this._debugAdaptersTrackers.get(s);o&&o.onWillReceiveMessage&&o.onWillReceiveMessage(i),this._debugAdapters.get(s)?.sendMessage(i)}$stopDASession(s){const i=this._debugAdaptersTrackers.get(s);this._debugAdaptersTrackers.delete(s),i&&i.onWillStopSession&&i.onWillStopSession();const o=this._debugAdapters.get(s);return this._debugAdapters.delete(s),o?o.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const i=[],o=[],d=[];if(s.added)for(const r of s.added){const a=r.id;if(a&&!this._breakpoints.has(a)){let f;if(r.type==="function")f=new D.FunctionBreakpoint(r.functionName,r.enabled,r.condition,r.hitCondition,r.logMessage);else if(r.type==="data")f=new D.DataBreakpoint(r.label,r.dataId,r.canPersist,r.enabled,r.hitCondition,r.condition,r.logMessage);else{const y=P.URI.revive(r.uri);f=new D.SourceBreakpoint(new D.Location(y,new D.Position(r.line,r.character)),r.enabled,r.condition,r.hitCondition,r.logMessage)}f._id=a,this._breakpoints.set(a,f),i.push(f)}}if(s.removed)for(const r of s.removed){const a=this._breakpoints.get(r);a&&(this._breakpoints.delete(r),o.push(a))}if(s.changed){for(const r of s.changed)if(r.id){const a=this._breakpoints.get(r.id);if(a){if(a instanceof D.FunctionBreakpoint&&r.type==="function"){const f=a;f.enabled=r.enabled,f.condition=r.condition,f.hitCondition=r.hitCondition,f.logMessage=r.logMessage,f.functionName=r.functionName}else if(a instanceof D.SourceBreakpoint&&r.type==="source"){const f=a;f.enabled=r.enabled,f.condition=r.condition,f.hitCondition=r.hitCondition,f.logMessage=r.logMessage,f.location=new D.Location(P.URI.revive(r.uri),new D.Position(r.line,r.character))}d.push(a)}}}this.fireBreakpointChanges(i,o,d)}$provideDebugConfigurations(s,i,o){return(0,l.asPromise)(async()=>{const d=this.getConfigProviderByHandle(s);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const r=await this.getFolder(i);return d.provideDebugConfigurations(r,o)}).then(d=>{if(!d)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return d})}$resolveDebugConfiguration(s,i,o,d){return(0,l.asPromise)(async()=>{const r=this.getConfigProviderByHandle(s);if(!r)throw new Error("no DebugConfigurationProvider found");if(!r.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const a=await this.getFolder(i);return r.resolveDebugConfiguration(a,o,d)})}$resolveDebugConfigurationWithSubstitutedVariables(s,i,o,d){return(0,l.asPromise)(async()=>{const r=this.getConfigProviderByHandle(s);if(!r)throw new Error("no DebugConfigurationProvider found");if(!r.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const a=await this.getFolder(i);return r.resolveDebugConfigurationWithSubstitutedVariables(a,o,d)})}async $provideDebugAdapter(s,i){const o=this.getAdapterDescriptorFactoryByHandle(s);if(!o)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const d=await this.getSession(i);return this.getAdapterDescriptor(o,d).then(r=>{if(!r)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${d.type}'`);return this.convertToDto(r)})}async $acceptDebugSessionStarted(s){const i=await this.getSession(s);this._onDidStartDebugSession.fire(i)}async $acceptDebugSessionTerminated(s){const i=await this.getSession(s);i&&(this._onDidTerminateDebugSession.fire(i),this._debugSessions.delete(i.id))}async $acceptDebugSessionActiveChanged(s){this._activeDebugSession=s?await this.getSession(s):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(s,i){(await this.getSession(s))?._acceptNameChanged(i)}async $acceptDebugSessionCustomEvent(s,i){const d={session:await this.getSession(s),event:i.event,body:i.body};this._onDidReceiveDebugSessionCustomEvent.fire(d)}convertToDto(s){if(s instanceof D.DebugAdapterExecutable)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof D.DebugAdapterServer)return{type:"server",port:s.port,host:s.host};if(s instanceof D.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:s.path};if(s instanceof D.DebugAdapterInlineImplementation)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(s){const i=this._adapterFactories.filter(o=>o.type===s);if(i.length>0)return i[0].factory}getAdapterDescriptorFactoryByHandle(s){const i=this._adapterFactories.filter(o=>o.handle===s);if(i.length>0)return i[0].factory}getConfigProviderByHandle(s){const i=this._configProviders.filter(o=>o.handle===s);if(i.length>0)return i[0].provider}definesDebugType(s,i){if(s.contributes){const o=s.contributes.debuggers;if(o&&o.length>0){for(const d of o)if(d.label&&d.type&&d.type===i)return!0}}return!1}getDebugAdapterTrackers(s){const o=s.configuration.type,d=this._trackerFactories.filter(r=>r.type===o||r.type==="*").map(r=>(0,l.asPromise)(()=>r.factory.createDebugAdapterTracker(s)).then(a=>a,a=>null));return Promise.race([Promise.all(d).then(r=>{const a=r.filter(f=>!!f);if(a.length>0)return new c(a)}),new Promise((r,a)=>{const f=setTimeout(()=>{clearTimeout(f),a(new Error("timeout"))},1e3)})]).catch(r=>{})}async getAdapterDescriptor(s,i){const o=i.configuration.debugServer;if(typeof o=="number")return Promise.resolve(new D.DebugAdapterServer(o));if(s){const r=await this._extensionService.getExtensionRegistry();return(0,l.asPromise)(()=>s.createDebugAdapterDescriptor(i,this.daExecutableFromPackage(i,r))).then(a=>{if(a)return a})}const d=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(i,d))}daExecutableFromPackage(s,i){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(s,i,o){(s.length>0||i.length>0||o.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:s,removed:i,changed:o}))}async getSession(s){if(s)if(typeof s=="string"){const i=this._debugSessions.get(s);if(i)return i}else{let i=this._debugSessions.get(s.id);if(!i){const o=await this.getFolder(s.folderUri),d=s.parent?this._debugSessions.get(s.parent):void 0;i=new v(this._debugServiceProxy,s.id,s.type,s.name,o,s.configuration,d),this._debugSessions.set(i.id,i),this._debugServiceProxy.$sessionCached(i.id)}return i}throw new Error("cannot find session")}getFolder(s){if(s){const i=P.URI.revive(s);return this._workspaceService.resolveWorkspaceFolder(i)}return Promise.resolve(void 0)}};m=je([$e(0,L.IExtHostRpcService),$e(1,S.IExtHostWorkspace),$e(2,k.IExtHostExtensionService),$e(3,p.IExtHostConfiguration),$e(4,w.IExtHostEditorTabs),$e(5,b.IExtHostVariableResolverProvider)],m),e.ExtHostDebugServiceBase=m;class v{constructor(s,i,o,d,r,a,f){this._debugServiceProxy=s,this._id=i,this._type=o,this._name=d,this._workspaceFolder=r,this._configuration=a,this._parentSession=f}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(s){this._name=s,this._debugServiceProxy.$setDebugSessionName(this._id,s)}get parentSession(){return this._parentSession}_acceptNameChanged(s){this._name=s}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(s,i){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,s,i)}getDebugProtocolBreakpoint(s){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,s.id)}}e.ExtHostDebugSession=v;class h{constructor(s){this.value=Object.freeze({append(i){s.$appendDebugConsole(i)},appendLine(i){this.append(i+`
`)}})}}e.ExtHostDebugConsole=h;class c{constructor(s){this.trackers=s}onWillStartSession(){this.trackers.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.trackers.forEach(i=>i.onWillReceiveMessage?i.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.trackers.forEach(i=>i.onDidSendMessage?i.onDidSendMessage(s):void 0)}onWillStopSession(){this.trackers.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.trackers.forEach(i=>i.onError?i.onError(s):void 0)}onExit(s,i){this.trackers.forEach(o=>o.onExit?o.onExit(s,i):void 0)}}class g extends T.AbstractDebugAdapter{constructor(s){super(),this.implementation=s,s.onDidSendMessage(i=>{this.acceptMessage(i)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.implementation.handleMessage(s)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let n=class extends m{constructor(s,i,o,d,r,a){super(s,i,o,d,r,a)}};n=je([$e(0,L.IExtHostRpcService),$e(1,S.IExtHostWorkspace),$e(2,k.IExtHostExtensionService),$e(3,p.IExtHostConfiguration),$e(4,w.IExtHostEditorTabs),$e(5,b.IExtHostVariableResolverProvider)],n),e.WorkerExtHostDebugService=n}),define(De[282],Ie([1,0,10,71,2,5,274,13,82,84,25,193,14,54,40]),function(J,e,l,t,C,P,_,I,w,k,L,D,S,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class p{constructor(m,v,h,c,g){this._hostUtils=h,this._rpcProtocol=new _.RPCProtocol(m,null,c),v=p._transform(v,this._rpcProtocol);const n=new k.ServiceCollection(...(0,w.getSingletonServiceDescriptors)());n.set(L.IExtHostInitDataService,{_serviceBrand:void 0,...v,messagePorts:g}),n.set(S.IExtHostRpcService,new S.ExtHostRpcService(this._rpcProtocol)),n.set(T.IURITransformerService,new T.URITransformerService(c)),n.set(E.IHostUtils,h);const u=new D.InstantiationService(n,!0);this._logService=u.invokeFunction(d=>d.get(I.ILogService)),t.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",v),this._extensionService=u.invokeFunction(d=>d.get(E.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const s=new WeakMap;this._extensionService.getExtensionPathIndex().then(d=>{Error.prepareStackTrace=(r,a)=>{let f="",y,R;for(const N of a)f+=`
	at ${N.toString()}`,R=N.getFileName(),!y&&R&&(y=d.findSubstr(C.URI.file(R)));return s.set(r,y),`${r.name||"Error"}: ${r.message||""}${f}`}});const i=this._rpcProtocol.getProxy(P.MainContext.MainThreadExtensionService),o=this._rpcProtocol.getProxy(P.MainContext.MainThreadErrors);l.setUnexpectedErrorHandler(d=>{const r=l.transformErrorForSerialization(d),a=s.get(d);a?i.$onExtensionRuntimeError(a.identifier,r):o.$onUnexpectedError(r)})}async asBrowserUri(m){const v=this._rpcProtocol.getProxy(P.MainContext.MainThreadExtensionService);return C.URI.revive(await v.$asBrowserUri(m))}terminate(m){this._extensionService.terminate(m)}static _transform(m,v){m.allExtensions.forEach(c=>{c.extensionLocation=C.URI.revive(v.transformIncomingURIs(c.extensionLocation));const g={};c.browserNlsBundleUris&&(Object.keys(c.browserNlsBundleUris).forEach(n=>g[n]=C.URI.revive(v.transformIncomingURIs(c.browserNlsBundleUris[n]))),c.browserNlsBundleUris=g)}),m.environment.appRoot=C.URI.revive(v.transformIncomingURIs(m.environment.appRoot));const h=m.environment.extensionDevelopmentLocationURI;return h&&(m.environment.extensionDevelopmentLocationURI=h.map(c=>C.URI.revive(v.transformIncomingURIs(c)))),m.environment.extensionTestsLocationURI=C.URI.revive(v.transformIncomingURIs(m.environment.extensionTestsLocationURI)),m.environment.globalStorageHome=C.URI.revive(v.transformIncomingURIs(m.environment.globalStorageHome)),m.environment.workspaceStorageHome=C.URI.revive(v.transformIncomingURIs(m.environment.workspaceStorageHome)),m.nlsBaseUrl=C.URI.revive(v.transformIncomingURIs(m.nlsBaseUrl)),m.logsLocation=C.URI.revive(v.transformIncomingURIs(m.logsLocation)),m.logFile=C.URI.revive(v.transformIncomingURIs(m.logFile)),m.workspace=v.transformIncomingURIs(m.workspace),m}}e.ExtensionHostMain=p}),define(De[283],Ie([1,0,18,11,177,192,200,72,58,40,14,39,7,47,32,212,214,33]),function(J,e,l,t,C,P,_,I,w,k,L,D,S,T,E,p,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.runInExternalTerminal=e.ExtHostDebugService=void 0;let v=class extends I.ExtHostDebugServiceBase{constructor(u,s,i,o,d,r,a){super(u,s,i,o,r,a),this._terminalService=d,this._integratedTerminalInstances=new g}createDebugAdapter(u,s){switch(u.type){case"server":return new p.SocketDebugAdapter(u);case"pipeServer":return new p.NamedPipeDebugAdapter(u);case"executable":return new p.ExecutableDebugAdapter(u,s.type)}return super.createDebugAdapter(u,s)}daExecutableFromPackage(u,s){const i=p.ExecutableDebugAdapter.platformAdapterExecutable(s.getAllExtensionDescriptions(),u.type);if(i)return new S.DebugAdapterExecutable(i.command,i.args,i.options)}createSignService(){return new _.SignService}async $runInTerminal(u,s){if(u.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(z=>{this._integratedTerminalInstances.onTerminalClosed(z)}));const i=await this._configurationService.getConfigProvider(),o=this._terminalService.getDefaultShell(!0),d=this._terminalService.getDefaultShellArgs(!0),r=u.title||C.localize(0,null),a=JSON.stringify({shell:o,shellArgs:d});let f=await this._integratedTerminalInstances.checkout(a,r),y,R=!1;if(f)y=u.cwd;else{const z={shellPath:o,shellArgs:d,cwd:u.cwd,name:r,iconPath:new S.ThemeIcon("debug")};R=!0,f=this._terminalService.createTerminalFromOptions(z,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(f,a)}f.show(!0);const N=await f.processId;R?await new Promise(z=>setTimeout(z,1e3)):i.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(o.indexOf("powershell")>=0||o.indexOf("pwsh")>=0||o.indexOf("cmd.exe")>=0?f.sendText("cls"):o.indexOf("bash")>=0?f.sendText("clear"):t.isWindows?f.sendText("cls"):f.sendText("clear"));const M=(0,b.prepareCommand)(o,u.args,!!u.argsCanBeInterpretedByShell,y,u.env);f.sendText(M);const A=this.onDidTerminateDebugSession(z=>{z.id===s&&(this._integratedTerminalInstances.free(f),A.dispose())});return N}else if(u.kind==="external")return c(u,await this._configurationService.getConfigProvider());return super.$runInTerminal(u,s)}};v=je([$e(0,L.IExtHostRpcService),$e(1,E.IExtHostWorkspace),$e(2,k.IExtHostExtensionService),$e(3,m.IExtHostConfiguration),$e(4,D.IExtHostTerminalService),$e(5,w.IExtHostEditorTabs),$e(6,T.IExtHostVariableResolverProvider)],v),e.ExtHostDebugService=v;let h;function c(n,u){if(!h)if(t.isWindows)h=new P.WindowsExternalTerminalService;else if(t.isMacintosh)h=new P.MacExternalTerminalService;else if(t.isLinux)h=new P.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const s=u.getConfiguration("terminal");return h.runInTerminal(n.title,n.cwd,n.args,n.env||{},s.external||{})}e.runInExternalTerminal=c;class g{constructor(){this._terminalInstances=new Map}async checkout(u,s){const o=[...this._terminalInstances.entries()].map(([d,r])=>(0,l.createCancelablePromise)(async a=>{if(d.name!==s||r.lastUsedAt!==-1&&await(0,b.hasChildProcesses)(await d.processId))return null;const f=Date.now();return r.lastUsedAt+g.minUseDelay>f||a.isCancellationRequested||r.config!==u?null:(r.lastUsedAt=f,d)}));return await(0,l.firstParallel)(o,d=>!!d)}insert(u,s){this._terminalInstances.set(u,{lastUsedAt:Date.now(),config:s})}free(u){const s=this._terminalInstances.get(u);s&&(s.lastUsedAt=-1)}onTerminalClosed(u){this._terminalInstances.delete(u)}}g.minUseDelay=1e3}),define(De[284],Ie([1,0,9,2,110,32,57,33,45,39,14,25,70,12,13,65,22,81,47]),function(J,e,l,t,C,P,_,I,w,k,L,D,S,T,E,p,b,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let h=class extends S.ExtHostTaskBase{constructor(g,n,u,s,i,o,d,r,a){super(g,n,u,s,i,o,d,r),this.workspaceService=u,this.variableResolver=a,n.remote.isRemote&&n.remote.authority?this.registerTaskSystem(T.Schemas.vscodeRemote,{scheme:T.Schemas.vscodeRemote,authority:n.remote.authority,platform:process.platform}):this.registerTaskSystem(T.Schemas.file,{scheme:T.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(g,n){const u=n;if(!n.execution&&u._id===void 0)throw new Error("Tasks to execute must include an execution");if(u._id!==void 0){const s=S.TaskHandleDTO.from(u,this.workspaceService),i=await this._proxy.$getTaskExecution(s);if(i.task===void 0)throw new Error("Task from execution DTO is undefined");const o=await this.getTaskExecution(i,n);return this._proxy.$executeTask(s).catch(()=>{}),o}else{const s=S.TaskDTO.from(n,g);if(s===void 0)return Promise.reject(new Error("Task is not valid"));S.CustomExecutionDTO.is(s.execution)&&await this.addCustomExecution(s,n,!1);const i=await this.getTaskExecution(await this._proxy.$getTaskExecution(s),n);return this._proxy.$executeTask(s).catch(()=>{}),i}}provideTasksInternal(g,n,u,s){const i=[];if(s)for(const o of s){this.checkDeprecation(o,u),(!o.definition||!g[o.definition.type])&&this._logService.warn(`The task [${o.source}, ${o.name}] uses an undefined task type. The task will be ignored in the future.`);const d=S.TaskDTO.from(o,u.extension);d&&(i.push(d),S.CustomExecutionDTO.is(d.execution)&&n.push(this.addCustomExecution(d,o,!0)))}return{tasks:i,extension:u.extension}}async resolveTaskInternal(g){return g}async getAFolder(g){let n=g&&g.length>0?g[0]:void 0;if(!n){const u=t.URI.file((0,m.homedir)());n=new w.WorkspaceFolder({uri:u,name:b.basename(u),index:0})}return{uri:n.uri,name:n.name,index:n.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(g,n){const u=t.URI.revive(g),s={process:void 0,variables:Object.create(null)},i=await this._workspaceProvider.resolveWorkspaceFolder(u),o=await this._workspaceProvider.getWorkspaceFolders2()??[],d=await this.variableResolver.getResolver(),r=i?{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(o);for(const a of n.variables)s.variables[a]=await d.resolveAsync(r,a);if(n.process!==void 0){let a;if(n.process.path!==void 0){a=n.process.path.split(l.delimiter);for(let f=0;f<a.length;f++)a[f]=await d.resolveAsync(r,a[f])}s.process=await C.win32.findExecutable(await d.resolveAsync(r,n.process.name),n.process.cwd!==void 0?await d.resolveAsync(r,n.process.cwd):void 0,a)}return s}async $jsonTasksSupported(){return!0}async $findExecutable(g,n,u){return C.win32.findExecutable(g,n,u)}};h=je([$e(0,L.IExtHostRpcService),$e(1,D.IExtHostInitDataService),$e(2,P.IExtHostWorkspace),$e(3,_.IExtHostDocumentsAndEditors),$e(4,I.IExtHostConfiguration),$e(5,k.IExtHostTerminalService),$e(6,E.ILogService),$e(7,p.IExtHostApiDeprecationService),$e(8,v.IExtHostVariableResolverProvider)],h),e.ExtHostTask=h}),define(De[285],Ie([1,0,81,47]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class C extends t.ExtHostVariableResolverProviderService{homeDir(){return(0,l.homedir)()}}e.NodeExtHostVariableResolverProviderService=C}),define(De[141],Ie([1,0,17,18,21,50,12,9,22,2,30]),function(J,e,l,t,C,P,_,I,w,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class D{constructor(v,h,c,g){this.query=v,this.provider=h,this.fileUtils=c,this.processType=g,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(v,h){const c=this.query.folderQueries||[],g=new C.CancellationTokenSource;return h.onCancellationRequested(()=>g.cancel()),new Promise((n,u)=>{this.collector=new T(v);let s=!1;const i=(o,d)=>{if(!s&&!this.isLimitHit){const r=this.resultSize(o);p(o)&&typeof this.query.maxResults=="number"&&this.resultCount+r>this.query.maxResults&&(this.isLimitHit=!0,s=!0,g.cancel(),o=this.trimResultToSize(o,this.query.maxResults-this.resultCount));const a=this.resultSize(o);this.resultCount+=a,(a>0||!p(o))&&this.collector.add(o,d)}};Promise.all(c.map((o,d)=>this.searchInFolder(o,r=>i(r,d),g.token))).then(o=>{g.dispose(),this.collector.flush();const d=o.some(r=>!!r&&!!r.limitHit);n({limitHit:this.isLimitHit||d,messages:(0,l.flatten)(o.map(r=>r?.message?Array.isArray(r.message)?r.message:[r.message]:[])),stats:{type:this.processType}})},o=>{g.dispose();const d=(0,P.toErrorMessage)(o);u(new Error(d))})})}resultSize(v){return p(v)?Array.isArray(v.ranges)?v.ranges.length:1:0}trimResultToSize(v,h){const c=Array.isArray(v.ranges)?v.ranges:[v.ranges],g=Array.isArray(v.preview.matches)?v.preview.matches:[v.preview.matches];return{ranges:c.slice(0,h),preview:{matches:g.slice(0,h),text:v.preview.text},uri:v.uri}}async searchInFolder(v,h,c){const g=new L.QueryGlobTester(this.query,v),n=[],u={report:o=>{if(!this.validateProviderResult(o))return;const d=v.folder.scheme===_.Schemas.file?(0,L.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(w.dirname(o.uri))):void 0,r=w.relativePath(v.folder,o.uri);if(r){const a=g.includedInQuery(r,I.basename(r),d);(0,t.isThenable)(a)?n.push(a.then(f=>{f&&h(o)})):a&&h(o)}}},s=this.getSearchOptionsForFolder(v),i=await this.provider.provideTextSearchResults(S(this.query.contentPattern),s,u,c);return n.length&&await Promise.all(n),i}validateProviderResult(v){if(p(v)){if(Array.isArray(v.ranges)){if(!Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(v.preview.matches.length!==v.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(v){const h=(0,L.resolvePatternsForProvider)(this.query.includePattern,v.includePattern),c=(0,L.resolvePatternsForProvider)(this.query.excludePattern,v.excludePattern),g={folder:k.URI.from(v.folder),excludes:c,includes:h,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,encoding:v.fileEncoding&&this.fileUtils.toCanonicalName(v.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return g.usePCRE2=this.query.usePCRE2,g}}e.TextSearchManager=D;function S(m){return{isCaseSensitive:m.isCaseSensitive||!1,isRegExp:m.isRegExp||!1,isWordMatch:m.isWordMatch||!1,isMultiline:m.isMultiline||!1,pattern:m.pattern}}class T{constructor(v){this._onResult=v,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new b(512,h=>this.sendItems(h))}add(v,h){this._currentFileMatch&&(this._currentFolderIdx!==h||!w.isEqual(this._currentUri,v.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=h,this._currentFileMatch={resource:v.uri,results:[]}),this._currentFileMatch.results.push(E(v))}pushToCollector(){const v=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,v)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(v){this._onResult(v)}}e.TextSearchResultsCollector=T;function E(m){return p(m)?{preview:{matches:(0,l.mapArrayOrNot)(m.preview.matches,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character})),text:m.preview.text},ranges:(0,l.mapArrayOrNot)(m.ranges,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character}))}:{text:m.text,lineNumber:m.lineNumber}}function p(m){return!!m.preview}e.extensionResultIsMatch=p;class b{constructor(v,h){this.maxBatchSize=v,this.cb=h,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(v,h){!v||this.addItemToBatch(v,h)}addItems(v,h){!v||this.addItemsToBatch(v,h)}addItemToBatch(v,h){this.batch.push(v),this.batchSize+=h,this.onUpdate()}addItemsToBatch(v,h){this.batch=this.batch.concat(v),this.batchSize+=h,this.onUpdate()}onUpdate(){this.totalNumberCompleted<b.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},b.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=b,b.TIMEOUT=4e3,b.START_BATCH_AFTER_COUNT=50}),define(De[73],Ie([1,0,6,5,3,278,14,54,13,2,141]),function(J,e,l,t,C,P,_,I,w,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,C.createDecorator)("IExtHostSearch");let D=class{constructor(p,b,m){this.extHostRpc=p,this._uriTransformer=b,this._logService=m,this._proxy=this.extHostRpc.getProxy(t.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new P.FileSearchManager}_transformScheme(p){return this._uriTransformer.transformOutgoingScheme(p)}registerTextSearchProvider(p,b){if(this._textSearchUsedSchemes.has(p))throw new Error(`a text search provider for the scheme '${p}' is already registered`);this._textSearchUsedSchemes.add(p);const m=this._handlePool++;return this._textSearchProvider.set(m,b),this._proxy.$registerTextSearchProvider(m,this._transformScheme(p)),(0,l.toDisposable)(()=>{this._textSearchUsedSchemes.delete(p),this._textSearchProvider.delete(m),this._proxy.$unregisterProvider(m)})}registerFileSearchProvider(p,b){if(this._fileSearchUsedSchemes.has(p))throw new Error(`a file search provider for the scheme '${p}' is already registered`);this._fileSearchUsedSchemes.add(p);const m=this._handlePool++;return this._fileSearchProvider.set(m,b),this._proxy.$registerFileSearchProvider(m,this._transformScheme(p)),(0,l.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(p),this._fileSearchProvider.delete(m),this._proxy.$unregisterProvider(m)})}$provideFileSearchResults(p,b,m,v){const h=S(m),c=this._fileSearchProvider.get(p);if(c)return this._fileSearchManager.fileSearch(h,c,g=>{this._proxy.$handleFileMatch(p,b,g.map(n=>n.resource))},v);throw new Error("unknown provider: "+p)}$clearCache(p){return this._fileSearchManager.clearCache(p),Promise.resolve(void 0)}$provideTextSearchResults(p,b,m,v){const h=this._textSearchProvider.get(p);if(!h||!h.provideTextSearchResults)throw new Error(`Unknown provider ${p}`);const c=S(m);return this.createTextSearchManager(c,h).search(n=>this._proxy.$handleTextMatch(p,b,n),v)}$enableExtensionHostSearch(){}createTextSearchManager(p,b){return new L.TextSearchManager(p,b,{readdir:m=>Promise.resolve([]),toCanonicalName:m=>m},"textSearchProvider")}};D=je([$e(0,_.IExtHostRpcService),$e(1,I.IURITransformerService),$e(2,w.ILogService)],D),e.ExtHostSearch=D;function S(E){return{...E,folderQueries:E.folderQueries&&E.folderQueries.map(T),extraFileResources:E.extraFileResources&&E.extraFileResources.map(p=>k.URI.revive(p))}}e.reviveQuery=S;function T(E){return{...E,folder:k.URI.revive(E.folder)}}}),define(De[286],Ie([1,0,82,140,32,136,33,38,57,39,70,72,73,92,53,65,139,66,46,91,126,58,137,13,224,47,138,90]),function(J,e,l,t,C,P,_,I,w,k,L,D,S,T,E,p,b,m,v,h,c,g,n,u,s,i,o,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,l.registerSingleton)(d.IExtHostLocalizationService,d.ExtHostLocalizationService,1),(0,l.registerSingleton)(u.ILoggerService,n.ExtHostLoggerService,1),(0,l.registerSingleton)(u.ILogService,s.ExtHostLogService,1),(0,l.registerSingleton)(p.IExtHostApiDeprecationService,p.ExtHostApiDeprecationService,!1),(0,l.registerSingleton)(I.IExtHostCommands,I.ExtHostCommands,!1),(0,l.registerSingleton)(_.IExtHostConfiguration,_.ExtHostConfiguration,!1),(0,l.registerSingleton)(m.IExtHostConsumerFileSystem,m.ExtHostConsumerFileSystem,!1),(0,l.registerSingleton)(D.IExtHostDebugService,D.WorkerExtHostDebugService,!1),(0,l.registerSingleton)(P.IExtHostDecorations,P.ExtHostDecorations,!1),(0,l.registerSingleton)(w.IExtHostDocumentsAndEditors,w.ExtHostDocumentsAndEditors,!1),(0,l.registerSingleton)(v.IExtHostFileSystemInfo,v.ExtHostFileSystemInfo,!1),(0,l.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService,1),(0,l.registerSingleton)(S.IExtHostSearch,S.ExtHostSearch,!1),(0,l.registerSingleton)(T.IExtHostStorage,T.ExtHostStorage,!1),(0,l.registerSingleton)(L.IExtHostTask,L.WorkerExtHostTask,!1),(0,l.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService,!1),(0,l.registerSingleton)(E.IExtHostTunnelService,E.ExtHostTunnelService,!1),(0,l.registerSingleton)(b.IExtHostWindow,b.ExtHostWindow,!1),(0,l.registerSingleton)(C.IExtHostWorkspace,C.ExtHostWorkspace,!1),(0,l.registerSingleton)(h.IExtHostSecretState,h.ExtHostSecretState,!1),(0,l.registerSingleton)(c.IExtHostTelemetry,c.ExtHostTelemetry,!1),(0,l.registerSingleton)(o.IExtHostTelemetryLogService,o.ExtHostTelemetryLogService,!1),(0,l.registerSingleton)(g.IExtHostEditorTabs,g.ExtHostEditorTabs,!1),(0,l.registerSingleton)(i.IExtHostVariableResolverProvider,i.ExtHostVariableResolverProviderService,!1)}),define(De[93],Ie([1,0,17,13,30,69]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function _(D){return D.startsWith("**")||D.startsWith("/")?D:`/${D}`}e.anchorGlob=_;function I(D,S,T,E){const p=(0,l.mapArrayOrNot)(T,w),b=new C.TextSearchMatch(S,p,E),m=b.preview.matches;return{ranges:(0,l.mapArrayOrNot)(p,k),uri:D,preview:{text:b.preview.text,matches:(0,l.mapArrayOrNot)(m,k)}}}e.createTextSearchResult=I;function w(D){return new C.SearchRange(D.start.line,D.start.character,D.end.line,D.end.character)}function k(D){return new P.Range(D.startLineNumber,D.startColumn,D.endLineNumber,D.endColumn)}let L=class{constructor(S,T){this.prefix=S,this.logService=T}appendLine(S){this.logService.debug(`${this.prefix}#search`,S)}};L=je([$e(1,t.ILogService)],L),e.OutputChannel=L}),define(De[287],Ie([1,0,44,9,79,31,11,8,93,288]),function(J,e,l,t,C,P,_,I,w,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const L=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function D(h,c,g,n){const u=S(h,c,g,n),s=c.folder.fsPath;return{cmd:l.spawn(L,u.args,{cwd:s}),rgDiskPath:L,siblingClauses:u.siblingClauses,rgArgs:u,cwd:s}}e.spawnRipgrepCmd=D;function S(h,c,g,n){const u=["--files","--hidden","--case-sensitive"];E([c],g,!1).forEach(i=>{const o=(0,w.anchorGlob)(i);if(u.push("-g",o),_.isMacintosh){const d=(0,C.normalizeNFD)(o);d!==o&&u.push("-g",d)}});const s=T([c],n,void 0,!1);return s.globArgs.forEach(i=>{const o=`!${(0,w.anchorGlob)(i)}`;if(u.push("-g",o),_.isMacintosh){const d=(0,C.normalizeNFD)(o);d!==o&&u.push("-g",d)}}),c.disregardIgnoreFiles!==!1?u.push("--no-ignore"):c.disregardParentIgnoreFiles!==!1&&u.push("--no-ignore-parent"),c.ignoreSymlinks||u.push("--follow"),h.exists&&u.push("--quiet"),u.push("--no-config"),c.disregardGlobalIgnoreFiles&&u.push("--no-ignore-global"),{args:u,siblingClauses:s.siblingClauses}}function T(h,c,g,n=!0){const u=[];let s={};return h.forEach(i=>{const o=Object.assign({},i.excludePattern||{},c||{}),d=p(o,n?i.folder.fsPath:void 0,g);u.push(...d.globArgs),d.siblingClauses&&(s=Object.assign(s,d.siblingClauses))}),{globArgs:u,siblingClauses:s}}e.foldersToRgExcludeGlobs=T;function E(h,c,g=!0){const n=[];return h.forEach(u=>{const s=Object.assign({},c||{},u.includePattern||{}),i=p(s,g?u.folder.fsPath:void 0);n.push(...i.globArgs)}),n}e.foldersToIncludeGlobs=E;function p(h,c,g){const n=[],u={};return Object.keys(h).forEach(s=>{if(g&&g.has(s)||!s)return;const i=h[s];s=m(c?b(c,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof i=="boolean"&&i?(s.startsWith("\\\\")&&(s+="**"),n.push(v(s))):i&&i.when&&(u[s]=i)}),{globArgs:n,siblingClauses:u}}function b(h,c){return t.isAbsolute(c)?c:t.join(h,c)}e.getAbsoluteGlob=b;function m(h){return h=I.rtrim(h,"\\"),I.rtrim(h,"/")}function v(h){return P.getRoot(h).toLowerCase()==="c:/"?h.replace(/^c:[/\\]/i,"/"):h}e.fixDriveC=v}),define(De[289],Ie([1,0,44,62,9,290,17,50,36,79,31,11,51,8,16,29,30,287,105]),function(J,e,l,t,C,P,_,I,w,k,L,D,S,T,E,p,b,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const h=new Set;process.on("exit",()=>{h.forEach(s=>s())});class c{constructor(i){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=i,this.filePattern=i.filePattern||"",this.includePattern=i.includePattern&&w.parse(i.includePattern),this.maxResults=i.maxResults||null,this.exists=!!i.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,v.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=i.excludePattern&&w.parse(i.excludePattern),this.folderExcludePatterns=new Map,i.folderQueries.forEach(o=>{const d=Object.assign({},o.excludePattern||{},this.config.excludePattern||{}),r=o.folder.fsPath;i.folderQueries.map(a=>a.folder.fsPath).filter(a=>a!==r).forEach(a=>{(0,L.isEqualOrParent)(a,r)&&(d[C.relative(r,a)]=!0)}),this.folderExcludePatterns.set(r,new n(d,r))})}cancel(){this.isCanceled=!0,h.forEach(i=>i())}walk(i,o,d,r,a){if(this.fileWalkSW=S.StopWatch.create(!1),this.isCanceled)return a(null,this.isLimitHit);o.forEach(f=>{const y=C.basename(f.fsPath);this.globalExcludePattern&&this.globalExcludePattern(f.fsPath,y)||this.matchFile(d,{relativePath:f.fsPath,searchPath:void 0})}),this.cmdSW=S.StopWatch.create(!1),this.parallel(i,(f,y)=>{this.call(this.cmdTraversal,this,f,d,r,R=>{if(R){const N=(0,I.toErrorMessage)(R);console.error(N),this.errors.push(N),y(R,void 0)}else y(null,void 0)})},(f,y)=>{this.fileWalkSW.stop();const R=f?_.coalesce(f)[0]:null;a(R,this.isLimitHit)})}parallel(i,o,d){const r=new Array(i.length),a=new Array(i.length);let f=!1,y=0;if(i.length===0)return d(null,[]);i.forEach((R,N)=>{o(R,(M,A)=>{if(M?(f=!0,r[N]=null,a[N]=M):(r[N]=A,a[N]=null),++y===i.length)return d(f?a:null,r)})})}call(i,o,...d){try{i.apply(o,d)}catch(r){d[d.length-1](r)}}cmdTraversal(i,o,d,r){const a=i.folder.fsPath,f=D.isMacintosh,y=()=>z&&z.kill();h.add(y);let R=B=>{h.delete(y),R=()=>{},r(B)},N="";const M=this.initDirectoryTree(),A=(0,m.spawnRipgrepCmd)(this.config,i,this.config.includePattern,this.folderExcludePatterns.get(i.folder.fsPath).expression),z=A.cmd,H=!Object.keys(A.siblingClauses).length,F=A.rgArgs.args.map(B=>B.match(/^-/)?B:`'${B}'`).join(" ");let G=`${A.rgDiskPath} ${F}
 - cwd: ${A.cwd}`;A.rgArgs.siblingClauses&&(G+=`
 - Sibling clauses: ${JSON.stringify(A.rgArgs.siblingClauses)}`),d({message:G}),this.cmdResultCount=0,this.collectStdout(z,"utf8",d,(B,U,x)=>{if(B){R(B);return}if(this.isLimitHit){R();return}const Q=(N+(f?k.normalizeNFC(U||""):U)).split(`
`);if(x){const K=Q.length;Q[K-1]=Q[K-1].trim(),Q[K-1]||Q.pop()}else N=Q.pop()||"";if(Q.length&&Q[0].indexOf(`
`)!==-1){R(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=Q.length,H){for(const K of Q)if(this.matchFile(o,{base:a,relativePath:K,searchPath:this.getSearchPath(i,K)}),this.isLimitHit){y();break}(x||this.isLimitHit)&&R();return}this.addDirectoryEntries(i,M,a,Q,o),x&&(this.matchDirectoryTree(M,a,o),R())})}spawnFindCmd(i){const o=this.folderExcludePatterns.get(i.folder.fsPath),d=o.getBasenameTerms(),r=o.getPathTerms(),a=["-L","."];if(d.length||r.length){a.push("-not","(","(");for(const f of d)a.push("-name",f),a.push("-o");for(const f of r)a.push("-path",f),a.push("-o");a.pop(),a.push(")","-prune",")")}return a.push("-type","f"),l.spawn("find",a,{cwd:i.folder.fsPath})}readStdout(i,o,d){let r="";this.collectStdout(i,o,()=>{},(a,f,y)=>{if(a){d(a);return}r+=f,y&&d(null,r)})}collectStdout(i,o,d,r){let a=(R,N,M)=>{(R||M)&&(a=()=>{},this.cmdSW?.stop()),r(R,N,M)},f=!1;i.stdout?(this.forwardData(i.stdout,o,a),i.stdout.once("data",()=>f=!0)):d({message:"stdout is null"});let y;i.stderr?y=this.collectData(i.stderr):d({message:"stderr is null"}),i.on("error",R=>{a(R)}),i.on("close",R=>{let N;!f&&(N=this.decodeData(y,o))&&u(N)?a(new Error(`command failed with error code ${R}: ${this.decodeData(y,o)}`)):(this.exists&&R===0&&(this.isLimitHit=!0),a(null,"",!0))})}forwardData(i,o,d){const r=new P.StringDecoder(o);return i.on("data",a=>{d(null,r.write(a))}),r}collectData(i){const o=[];return i.on("data",d=>{o.push(d)}),o}decodeData(i,o){const d=new P.StringDecoder(o);return i.map(r=>d.write(r)).join("")}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries(i,{pathToEntries:o},d,r,a){r.indexOf(this.filePattern)!==-1&&this.matchFile(a,{base:d,relativePath:this.filePattern,searchPath:this.getSearchPath(i,this.filePattern)});const f=y=>{const R=C.basename(y),N=C.dirname(y);let M=o[N];M||(M=o[N]=[],f(N)),M.push({base:d,relativePath:y,basename:R,searchPath:this.getSearchPath(i,y)})};r.forEach(f)}matchDirectoryTree({rootEntries:i,pathToEntries:o},d,r){const a=this,f=this.folderExcludePatterns.get(d),y=this.filePattern;function R(N){a.directoriesWalked++;const M=(0,b.hasSiblingFn)(()=>N.map(A=>A.basename));for(let A=0,z=N.length;A<z;A++){const H=N[A],{relativePath:F,basename:G}=H;if(f.test(F,G,y!==G?M:void 0))continue;const B=o[F];if(B)R(B);else{if(a.filesWalked++,F===y)continue;a.matchFile(r,H)}if(a.isLimitHit)break}}R(i)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(i,o,d,r,a){const f=i.folder,y=(0,b.hasSiblingFn)(()=>d);this.parallel(d,(R,N)=>{if(this.isCanceled||this.isLimitHit)return N(null);const M=o?[o,R].join(C.sep):R;if(this.folderExcludePatterns.get(i.folder.fsPath).test(M,R,this.config.filePattern!==R?y:void 0))return N(null);const A=[f.fsPath,M].join(C.sep);t.lstat(A,(z,H)=>{if(z||this.isCanceled||this.isLimitHit)return N(null);this.statLinkIfNeeded(A,H,(F,G)=>F||this.isCanceled||this.isLimitHit?N(null):G.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(A,H,(B,U)=>B||this.isCanceled||this.isLimitHit||(U=U||"",this.walkedPaths[U])?N(null):(this.walkedPaths[U]=!0,p.Promises.readdir(A).then(x=>{if(this.isCanceled||this.isLimitHit)return N(null);this.doWalk(i,M,x,r,$=>N($||null))},x=>{N(null)})))):(this.filesWalked++,M===this.filePattern||this.maxFilesize&&E.isNumber(G.size)&&G.size>this.maxFilesize||this.matchFile(r,{base:f.fsPath,relativePath:M,searchPath:this.getSearchPath(i,M)}),N(null,void 0)))})},R=>{const N=R&&_.coalesce(R);return a(N&&N.length>0?N[0]:void 0)})}matchFile(i,o){this.isFileMatch(o)&&(!this.includePattern||this.includePattern(o.relativePath,C.basename(o.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||i(o))}isFileMatch(i){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,b.isFilePatternMatch)(i,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(i,o,d){return o.isSymbolicLink()?t.stat(i,d):d(null,o)}realPathIfNeeded(i,o,d){return o.isSymbolicLink()?t.realpath(i,(r,a)=>r?d(r):d(null,a)):d(null,i)}getSearchPath(i,o){return i.folderName?C.join(i.folderName,o):o}}e.FileWalker=c;class g{constructor(i){this.folderQueries=i.folderQueries,this.extraFiles=i.extraFileResources||[],this.walker=new c(i)}search(i,o,d){this.walker.walk(this.folderQueries,this.extraFiles,i,o,(r,a)=>{d(r,{limitHit:a,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=g;class n{constructor(i,o){this.expression=i,this.root=o,this.init(i)}init(i){let o,d;Object.keys(i).filter(r=>i[r]).forEach(r=>{C.isAbsolute(r)?(o=o||w.getEmptyExpression(),o[r]=i[r]):(d=d||w.getEmptyExpression(),d[r]=i[r])}),this.absoluteParsedExpr=o&&w.parse(o,{trimForExclusions:!0}),this.relativeParsedExpr=d&&w.parse(d,{trimForExclusions:!0})}test(i,o,d){return this.relativeParsedExpr&&this.relativeParsedExpr(i,o,d)||this.absoluteParsedExpr&&this.absoluteParsedExpr(C.join(this.root,i),o,d)}getBasenameTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...w.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...w.getBasenameTerms(this.relativeParsedExpr)),i}getPathTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...w.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...w.getPathTerms(this.relativeParsedExpr)),i}}function u(s){const i=s.trim().split(`
`),o=i[0].trim();if(o.startsWith("Error parsing regex"))return o;if(o.startsWith("regex parse error"))return T.uppercaseFirstLetter(i[i.length-1].trim());if(o.startsWith("error parsing glob")||o.startsWith("unsupported encoding"))return o.charAt(0).toUpperCase()+o.substr(1);if(o==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(o.startsWith("Literal "))return o}e.rgErrorMsgForDisplay=u}),define(De[291],Ie([1,0,96,23]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function C(s){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(i=>i===s)}e.isUTFEncoding=C,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const P=512,_=512,I=512*8,w=512*128;var k;(function(s){s[s.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(k=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class L extends Error{constructor(i,o){super(i),this.decodeStreamErrorKind=o}}e.DecodeStreamError=L;class D{static async create(i){let o;if(i!==e.UTF8)o=(await new Promise((r,a)=>{J(["@vscode/iconv-lite-umd"],r,a)})).getDecoder(p(i));else{const d=new TextDecoder;o={write(r){return d.decode(r,{stream:!0})},end(){return d.decode()}}}return new D(o)}constructor(i){this.iconvLiteDecoder=i}write(i){return this.iconvLiteDecoder.write(i)}end(){return this.iconvLiteDecoder.end()}}function S(s,i){const o=i.minBytesRequiredForDetection??i.guessEncoding?I:_;return new Promise((d,r)=>{const a=(0,l.newWriteableStream)(A=>A.join("")),f=[];let y=0,R,N;const M=async()=>{try{const A=await u({buffer:t.VSBuffer.concat(f),bytesRead:y},i.guessEncoding);if(A.seemsBinary&&i.acceptTextOnly)throw new L("Stream is binary but only text is accepted for decoding",1);A.encoding=await i.overwriteEncoding(A.encoding),R=await D.create(A.encoding);const z=R.write(t.VSBuffer.concat(f).buffer);a.write(z),f.length=0,y=0,d({stream:a,detected:A})}catch(A){N?.dispose(),a.destroy(),r(A)}};N=(0,l.listenStream)(s,{onData:async A=>{R?a.write(R.write(A.buffer)):(f.push(A),y+=A.byteLength,y>=o&&(s.pause(),await M(),setTimeout(()=>s.resume())))},onError:A=>a.error(A),onEnd:async()=>{R||await M(),a.end(R?.end())}})})}e.toDecodeStream=S;async function T(s,i,o){const r=(await new Promise((y,R)=>{J(["@vscode/iconv-lite-umd"],y,R)})).getEncoder(p(i),o);let a=!1,f=!1;return{read(){if(f)return null;const y=s.read();if(typeof y!="string"){if(f=!0,!a&&o?.addBOM)switch(i){case e.UTF8:case e.UTF8_with_bom:return t.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const R=r.end();return R&&R.length>0?(a=!0,t.VSBuffer.wrap(R)):null}return a=!0,t.VSBuffer.wrap(r.write(y))}}}e.toEncodeReadable=T;async function E(s){return(await new Promise((o,d)=>{J(["@vscode/iconv-lite-umd"],o,d)})).encodingExists(p(s))}e.encodingExists=E;function p(s){return s===e.UTF8_with_bom||s===null?e.UTF8:s}e.toNodeEncoding=p;function b(s,i){if(!s||i<e.UTF16be_BOM.length)return null;const o=s.readUInt8(0),d=s.readUInt8(1);if(o===e.UTF16be_BOM[0]&&d===e.UTF16be_BOM[1])return e.UTF16be;if(o===e.UTF16le_BOM[0]&&d===e.UTF16le_BOM[1])return e.UTF16le;if(i<e.UTF8_BOM.length)return null;const r=s.readUInt8(2);return o===e.UTF8_BOM[0]&&d===e.UTF8_BOM[1]&&r===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=b;const m=["ascii","utf-16","utf-32"];async function v(s){const i=await new Promise((f,y)=>{J(["jschardet"],f,y)}),o=s.slice(0,w),d=g(o.buffer),r=i.detect(d);if(!r||!r.encoding)return null;const a=r.encoding.toLowerCase();return 0<=m.indexOf(a)?null:c(r.encoding)}const h={ibm866:"cp866",big5:"cp950"};function c(s){const i=s.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return h[i]||i}function g(s){let i="";for(let o=0;o<s.length;o++)i+=String.fromCharCode(s[o]);return i}function n(s){switch(s){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const i=s.match(/windows(\d+)/);return i?"windows-"+i[1]:s}}}e.toCanonicalName=n;function u({buffer:s,bytesRead:i},o){let d=b(s,i),r=!1;if(d!==e.UTF16be&&d!==e.UTF16le&&s){let a=!0,f=!0,y=!1;for(let R=0;R<i&&R<P;R++){const N=R%2===1,M=s.readUInt8(R)===0;if(M&&(y=!0),a&&(N&&!M||!N&&M)&&(a=!1),f&&(N&&M||!N&&!M)&&(f=!1),M&&!a&&!f)break}y&&(a?d=e.UTF16le:f?d=e.UTF16be:r=!0)}return o&&!r&&!d&&s?v(s.slice(0,i)).then(a=>({seemsBinary:!1,encoding:a})):{seemsBinary:r,encoding:d}}e.detectEncodingFromBuffer=u,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(De[142],Ie([1,0,291,29,141]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class P extends C.TextSearchManager{constructor(I,w,k=t,L="searchProcess"){super(I,w,{readdir:D=>k.Promises.readdir(D.fsPath),toCanonicalName:D=>(0,l.toCanonicalName)(D)},L)}}e.NativeTextSearchManager=P}),define(De[292],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class l{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(C){if(C&&this._dragOperations.has(C)){const P=this._dragOperations.get(C);return this._dragOperations.delete(C),P}}addDragOperationTransfer(C,P){this._dragOperations.set(C,P)}getRenderedTreeElement(C){if(this._renderedElements.has(C))return this._renderedElements.get(C)}addRenderedTreeItemElement(C,P){this._renderedElements.set(C,P)}removeRenderedTreeItemElement(C){this._renderedElements.has(C)&&this._renderedElements.delete(C)}}e.TreeviewsService=l}),define(De[293],Ie([1,0,175,7,22,2,4,6,18,7,16,17,15,21,292,28]),function(J,e,l,t,C,P,_,I,w,k,L,D,S,T,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function b(h,c){if((0,L.isString)(h))return{label:h};if(h&&typeof h=="object"&&typeof h.label=="string"){let g;return Array.isArray(h.highlights)&&(g=h.highlights.filter(n=>n.length===2&&typeof n[0]=="number"&&typeof n[1]=="number"),g=g.length?g:void 0),{label:h.label,highlights:g}}}class m{constructor(c,g,n){this._proxy=c,this.commands=g,this.logService=n,this.treeViews=new Map,this.treeDragAndDropService=new E.TreeviewsService;function u(s){return s&&s.$treeViewId&&(s.$treeItemHandle||s.$selectedTreeItems||s.$focusedTreeItem)}g.registerArgumentProcessor({processArgument:s=>u(s)?this.convertArgument(s):Array.isArray(s)&&s.length>0?s.map(i=>u(i)?this.convertArgument(i):i):s})}registerTreeDataProvider(c,g,n){const u=this.createTreeView(c,{treeDataProvider:g},n);return{dispose:()=>u.dispose()}}createTreeView(c,g,n){if(!g||!g.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=g.dragAndDropController?.dropMimeTypes??[],s=g.dragAndDropController?.dragMimeTypes??[],i=!!g.dragAndDropController?.handleDrag,o=!!g.dragAndDropController?.handleDrop,d=this.createExtHostTreeView(c,g,n),r=this._proxy.$registerTreeViewDataProvider(c,{showCollapseAll:!!g.showCollapseAll,canSelectMany:!!g.canSelectMany,dropMimeTypes:u,dragMimeTypes:s,hasHandleDrag:i,hasHandleDrop:o});return{get onDidCollapseElement(){return d.onDidCollapseElement},get onDidExpandElement(){return d.onDidExpandElement},get selection(){return d.selectedElements},get onDidChangeSelection(){return d.onDidChangeSelection},get visible(){return d.visible},get onDidChangeVisibility(){return d.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,p.checkProposedApiEnabled)(n,"treeItemCheckbox"),d.onDidChangeCheckboxState},get message(){return d.message},set message(a){d.message=a},get title(){return d.title},set title(a){d.title=a},get description(){return d.description},set description(a){d.description=a},get badge(){return d.badge},set badge(a){k.ViewBadge.isViewBadge(a)&&(d.badge={value:Math.floor(Math.abs(a.value)),tooltip:a.tooltip})},reveal:(a,f)=>d.reveal(a,f),dispose:async()=>{await r,this.treeViews.delete(c),d.dispose()}}}$getChildren(c,g){const n=this.treeViews.get(c);return n?n.getChildren(g):Promise.reject(new Error((0,l.localize)(0,null,c)))}async $handleDrop(c,g,n,u,s,i,o,d){const r=this.treeViews.get(c);if(!r)return Promise.reject(new Error((0,l.localize)(1,null,c)));const a=S.DataTransfer.toDataTransfer(n,async f=>(await this._proxy.$resolveDropFileData(c,g,f)).buffer);return o===c&&d&&await this.addAdditionalTransferItems(a,r,d,s,i),r.onDrop(a,u,s)}async addAdditionalTransferItems(c,g,n,u,s){const i=this.treeDragAndDropService.removeDragOperationTransfer(s);if(i)(await i)?.forEach((o,d)=>{o&&c.set(d,o)});else if(s&&g.handleDrag){const o=g.handleDrag(n,c,u);this.treeDragAndDropService.addDragOperationTransfer(s,o),await o}return c}async $handleDrag(c,g,n,u){const s=this.treeViews.get(c);if(!s)return Promise.reject(new Error((0,l.localize)(2,null,c)));const i=await this.addAdditionalTransferItems(new t.DataTransfer,s,g,u,n);if(!!i)return S.DataTransfer.toDataTransferDTO(i)}async $hasResolve(c){const g=this.treeViews.get(c);if(!g)throw new Error((0,l.localize)(3,null,c));return g.hasResolve}$resolve(c,g,n){const u=this.treeViews.get(c);if(!u)throw new Error((0,l.localize)(4,null,c));return u.resolveTreeItem(g,n)}$setExpanded(c,g,n){const u=this.treeViews.get(c);if(!u)throw new Error((0,l.localize)(5,null,c));u.setExpanded(g,n)}$setSelection(c,g){const n=this.treeViews.get(c);if(!n)throw new Error((0,l.localize)(6,null,c));n.setSelection(g)}$setFocus(c,g){const n=this.treeViews.get(c);if(!n)throw new Error((0,l.localize)(7,null,c));n.setFocus(g)}$setVisible(c,g){const n=this.treeViews.get(c);if(!n)throw new Error((0,l.localize)(8,null,c));n.setVisible(g)}$changeCheckboxState(c,g){const n=this.treeViews.get(c);if(!n)throw new Error((0,l.localize)(9,null,c));n.setCheckboxState(g)}createExtHostTreeView(c,g,n){const u=new v(c,g,this._proxy,this.commands.converter,this.logService,n);return this.treeViews.set(c,u),u}convertArgument(c){const g=this.treeViews.get(c.$treeViewId);return g&&"$treeItemHandle"in c?g.getExtensionElement(c.$treeItemHandle):g&&"$focusedTreeItem"in c&&c.$focusedTreeItem?g.focusedElement:null}}e.ExtHostTreeViews=m;class v extends I.Disposable{get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(c=>this.getExtensionElement(c)).filter(c=>!(0,L.isUndefinedOrNull)(c))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(c,g,n,u,s,i){if(super(),this.viewId=c,this.proxy=n,this.commands=u,this.logService=s,this.extension=i,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new _.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new _.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new _.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new _.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new _.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new _.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new T.CancellationTokenSource,i.contributes&&i.contributes.views)for(const r in i.contributes.views)for(const a of i.contributes.views[r])a.id===c&&(this._title=a.name);this.dataProvider=g.treeDataProvider,this.dndController=g.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(r=>this._onDidChangeData.fire({message:!1,element:r})));let o,d;this._register(_.Event.debounce(this._onDidChangeData.event,(r,a)=>(r||(r={message:!1,elements:[]}),a.element!==!1&&(o||(o=new Promise(f=>d=f),this.refreshPromise=this.refreshPromise.then(()=>o)),Array.isArray(a.element)?r.elements.push(...a.element):r.elements.push(a.element)),a.message&&(r.message=!0),r),200,!0)(({message:r,elements:a})=>{a.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const f=d;return o=null,this.refresh(a).then(()=>f())})),r&&this.proxy.$setMessage(this.viewId,this._message)}))}async getChildren(c){const g=c?this.getExtensionElement(c):void 0;if(c&&!g)return this.logService.error(`No tree item with id '${c}' found.`),Promise.resolve([]);let n=this.getChildrenNodes(c);return n||(n=await this.fetchChildrenNodes(g)),n?n.map(u=>u.item):void 0}getExtensionElement(c){return this.elements.get(c)}reveal(c,g){g=g||{select:!0,focus:!1};const n=(0,L.isUndefinedOrNull)(g.select)?!0:g.select,u=(0,L.isUndefinedOrNull)(g.focus)?!1:g.focus,s=(0,L.isUndefinedOrNull)(g.expand)?!1:g.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):c?this.refreshPromise.then(()=>this.resolveUnknownParentChain(c)).then(i=>this.resolveTreeNode(c,i[i.length-1]).then(o=>this.proxy.$reveal(this.viewId,{item:o.item,parentChain:i.map(d=>d.item)},{select:n,focus:u,expand:s})),i=>this.logService.error(i)):this.proxy.$reveal(this.viewId,void 0,{select:n,focus:u,expand:s})}get message(){return this._message}set message(c){this._message=c,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(c){this._title=c,this.proxy.$setTitle(this.viewId,c,this._description)}get description(){return this._description}set description(c){this._description=c,this.proxy.$setTitle(this.viewId,this._title,c)}get badge(){return this._badge}set badge(c){this._badge?.value===c?.value&&this._badge?.tooltip===c?.tooltip||(this._badge=S.ViewBadge.from(c),this.proxy.$setBadge(this.viewId,c))}setExpanded(c,g){const n=this.getExtensionElement(c);n&&(g?this._onDidExpandElement.fire(Object.freeze({element:n})):this._onDidCollapseElement.fire(Object.freeze({element:n})))}setSelection(c){(0,D.equals)(this._selectedHandles,c)||(this._selectedHandles=c,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setFocus(c){this._focusedHandle=c}setVisible(c){c!==this._visible&&(this._visible=c,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(c){const g=(await Promise.all(c.map(async n=>{const u=this.getExtensionElement(n.treeItemHandle);return u?{extensionItem:u,treeItem:await this.dataProvider.getTreeItem(u),newState:n.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(n=>n!==void 0);g.forEach(n=>{n.treeItem.checkboxState=n.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:g.map(n=>[n.extensionItem,n.newState])})}async handleDrag(c,g,n){const u=[];for(const s of c){const i=this.getExtensionElement(s);i&&u.push(i)}if(!(!this.dndController?.handleDrag||u.length===0))return await this.dndController.handleDrag(u,g,n),g}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(c,g,n){const u=g?this.getExtensionElement(g):void 0;if(!(!u&&g||!this.dndController?.handleDrop))return(0,w.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(u,c,n):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(c,g){if(!this.dataProvider.resolveTreeItem)return;const n=this.elements.get(c);if(n){const u=this.nodes.get(n);if(u){const s=await this.dataProvider.resolveTreeItem(u.extensionItem,n,g)??u.extensionItem;return this.validateTreeItem(s),u.item.tooltip=this.getTooltip(s.tooltip),u.item.command=this.getCommand(u.disposableStore,s.command),u.item}}}resolveUnknownParentChain(c){return this.resolveParent(c).then(g=>g?this.resolveUnknownParentChain(g).then(n=>this.resolveTreeNode(g,n[n.length-1]).then(u=>(n.push(u),n))):Promise.resolve([]))}resolveParent(c){const g=this.nodes.get(c);return g?Promise.resolve(g.parent?this.elements.get(g.parent.item.handle):void 0):(0,w.asPromise)(()=>this.dataProvider.getParent(c))}resolveTreeNode(c,g){const n=this.nodes.get(c);return n?Promise.resolve(n):(0,w.asPromise)(()=>this.dataProvider.getTreeItem(c)).then(u=>this.createHandle(c,u,g,!0)).then(u=>this.getChildren(g?g.item.handle:void 0).then(()=>{const s=this.getExtensionElement(u);if(s){const i=this.nodes.get(s);if(i)return Promise.resolve(i)}throw new Error(`Cannot resolve tree item for element ${u}`)}))}getChildrenNodes(c){if(c){let g;if(typeof c=="string"){const n=this.getExtensionElement(c);g=n?this.nodes.get(n):void 0}else g=c;return g&&g.children||void 0}return this.roots}async fetchChildrenNodes(c){this.clearChildren(c);const g=new T.CancellationTokenSource(this._refreshCancellationSource.token);try{const n=c?this.nodes.get(c):void 0,u=await this.dataProvider.getChildren(c);if(g.token.isCancellationRequested)return;const s=await Promise.all((0,D.coalesce)(u||[]).map(async i=>{const o=await this.dataProvider.getTreeItem(i);return o&&!g.token.isCancellationRequested?this.createAndRegisterTreeNode(i,o,n):null}));return g.token.isCancellationRequested?void 0:(0,D.coalesce)(s)}finally{g.dispose()}}refresh(c){if(c.some(n=>!n))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new T.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const n=this.getHandlesToRefresh(c);if(n.length)return this.refreshHandles(n)}return Promise.resolve(void 0)}getHandlesToRefresh(c){const g=new Set,n=c.map(s=>this.nodes.get(s));for(const s of n)if(s&&!g.has(s.item.handle)){let i=s;for(;i&&i.parent&&n.findIndex(o=>i&&i.parent&&o&&o.item.handle===i.parent.item.handle)===-1;){const o=this.elements.get(i.parent.item.handle);i=o?this.nodes.get(o):void 0}i&&!i.parent&&g.add(s.item.handle)}const u=[];return g.forEach(s=>{const i=this.elements.get(s);if(i){const o=this.nodes.get(i);o&&(!o.parent||!g.has(o.parent.item.handle))&&u.push(s)}}),u}refreshHandles(c){const g={};return Promise.all(c.map(n=>this.refreshNode(n).then(u=>{u&&(g[n]=u.item)}))).then(()=>Object.keys(g).length?this.proxy.$refresh(this.viewId,g):void 0)}refreshNode(c){const g=this.getExtensionElement(c);if(g){const n=this.nodes.get(g);if(n)return this.clearChildren(g),(0,w.asPromise)(()=>this.dataProvider.getTreeItem(g)).then(u=>{if(u){const s=this.createTreeNode(g,u,n.parent);return this.updateNodeCache(g,s,n,n.parent),n.dispose(),s}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(c,g,n){const u=this.createTreeNode(c,g,n);if(g.id&&this.elements.has(u.item.handle))throw new Error((0,l.localize)(10,null,g.id));return this.addNodeToCache(c,u),this.addNodeToParentCache(u,n),u}getTooltip(c){return k.MarkdownString.isMarkdownString(c)?S.MarkdownString.from(c):c}getCommand(c,g){return g?{...this.commands.toInternal(g,c),originalId:g.command}:void 0}getCheckbox(c){if(!c.checkboxState)return;let g,n;return typeof c.checkboxState=="number"?g=c.checkboxState:(g=c.checkboxState.state,n=c.checkboxState.tooltip),{isChecked:g===k.TreeItemCheckboxState.Checked,tooltip:n}}validateTreeItem(c){if(!k.TreeItem.isTreeItem(c,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(c,g,n){this.validateTreeItem(g);const u=new I.DisposableStore,s=this.createHandle(c,g,n),i=this.getLightIconPath(g);return{item:{handle:s,parentHandle:n?n.item.handle:void 0,label:b(g.label,this.extension),description:g.description,resourceUri:g.resourceUri,tooltip:this.getTooltip(g.tooltip),command:this.getCommand(u,g.command),contextValue:g.contextValue,icon:i,iconDark:this.getDarkIconPath(g)||i,themeIcon:this.getThemeIcon(g),collapsibleState:(0,L.isUndefinedOrNull)(g.collapsibleState)?k.TreeItemCollapsibleState.None:g.collapsibleState,accessibilityInformation:g.accessibilityInformation,checkbox:this.getCheckbox(g)},extensionItem:g,parent:n,children:void 0,disposableStore:u,dispose(){u.dispose()}}}getThemeIcon(c){return c.iconPath instanceof k.ThemeIcon?c.iconPath:void 0}createHandle(c,{id:g,label:n,resourceUri:u},s,i){if(g)return`${v.ID_HANDLE_PREFIX}/${g}`;const o=b(n,this.extension),d=s?s.item.handle:v.LABEL_HANDLE_PREFIX;let r=o?o.label:u?(0,C.basename)(u):"";r=r.indexOf("/")!==-1?r.replace("/","//"):r;const a=this.nodes.has(c)?this.nodes.get(c).item.handle:void 0,f=this.getChildrenNodes(s)||[];let y,R=0;do{if(y=`${d}/${R}:${r}`,i||!this.elements.has(y)||a===y)break;R++}while(R<=f.length);return y}getLightIconPath(c){if(c.iconPath&&!(c.iconPath instanceof k.ThemeIcon))return typeof c.iconPath=="string"||P.URI.isUri(c.iconPath)?this.getIconPath(c.iconPath):this.getIconPath(c.iconPath.light)}getDarkIconPath(c){if(c.iconPath&&!(c.iconPath instanceof k.ThemeIcon)&&c.iconPath.dark)return this.getIconPath(c.iconPath.dark)}getIconPath(c){return P.URI.isUri(c)?c:P.URI.file(c)}addNodeToCache(c,g){this.elements.set(g.item.handle,c),this.nodes.set(c,g)}updateNodeCache(c,g,n,u){this.elements.delete(g.item.handle),this.nodes.delete(c),g.item.handle!==n.item.handle&&this.elements.delete(n.item.handle),this.addNodeToCache(c,g);const s=this.getChildrenNodes(u)||[],i=s.filter(o=>o.item.handle===n.item.handle)[0];i&&s.splice(s.indexOf(i),1,g)}addNodeToParentCache(c,g){g?(g.children||(g.children=[]),g.children.push(c)):(this.roots||(this.roots=[]),this.roots.push(c))}clearChildren(c){if(c){const g=this.nodes.get(c);if(g){if(g.children)for(const n of g.children){const u=this.elements.get(n.item.handle);u&&this.clear(u)}g.children=void 0}}else this.clearAll()}clear(c){const g=this.nodes.get(c);if(g){if(g.children)for(const n of g.children){const u=this.elements.get(n.item.handle);u&&this.clear(u)}this.nodes.delete(c),this.elements.delete(g.item.handle),g.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(c=>c.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}v.LABEL_HANDLE_PREFIX="0",v.ID_HANDLE_PREFIX="1"}),define(De[294],Ie([1,0,21,10,4,42,2,115,100,149,158,37,5,131,238,237,38,239,33,241,242,243,226,244,57,40,245,246,249,250,251,140,229,255,256,257,92,39,259,293,15,7,262,68,139,32,209,248,124,136,70,72,73,13,54,14,25,252,225,53,65,235,260,67,66,265,263,264,236,46,258,261,91,58,126,253,69,254,12,119,228,205,247,6,28,210,138,90]),function(J,e,l,t,C,P,_,I,w,k,L,D,S,T,E,p,b,m,v,h,c,g,n,u,s,i,o,d,r,a,f,y,R,N,M,A,z,H,F,G,B,U,x,$,Q,K,de,te,he,Y,ve,be,ke,Re,ze,oe,le,me,Z,ae,ne,ie,O,V,q,X,ge,we,ce,Ce,ye,We,qe,Ze,Ye,Oe,ot,re,se,Ee,xe,fe,Ae,Le,Me,Ge,Je,st){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function vt(nt){const it=nt.get(le.IExtHostInitDataService),wt=nt.get(Ce.IExtHostFileSystemInfo),Ct=nt.get(q.IExtHostConsumerFileSystem),Dt=nt.get(i.IExtHostExtensionService),ht=nt.get(K.IExtHostWorkspace),Tt=nt.get(Ye.IExtHostTelemetry),Ut=nt.get(v.IExtHostConfiguration),Wt=nt.get(ze.IURITransformerService),Qe=nt.get(oe.IExtHostRpcService),Ft=nt.get(z.IExtHostStorage),Pt=nt.get(V.IExtensionStoragePaths),Nt=nt.get(Re.ILoggerService),gt=nt.get(Re.ILogService),Pe=nt.get(ae.IExtHostTunnelService),Fe=nt.get(Je.IExtHostTelemetryLogService),_e=nt.get(ne.IExtHostApiDeprecationService),ee=nt.get(Q.IExtHostWindow),Ne=nt.get(qe.IExtHostSecretState),Ve=nt.get(Ze.IExtHostEditorTabs);Qe.set(S.ExtHostContext.ExtHostFileSystemInfo,wt),Qe.set(S.ExtHostContext.ExtHostLogLevelServiceShape,Nt),Qe.set(S.ExtHostContext.ExtHostWorkspace,ht),Qe.set(S.ExtHostContext.ExtHostConfiguration,Ut),Qe.set(S.ExtHostContext.ExtHostExtensionService,Dt),Qe.set(S.ExtHostContext.ExtHostStorage,Ft),Qe.set(S.ExtHostContext.ExtHostTunnelService,Pe),Qe.set(S.ExtHostContext.ExtHostWindow,ee),Qe.set(S.ExtHostContext.ExtHostSecretState,Ne),Qe.set(S.ExtHostContext.ExtHostTelemetry,Tt),Qe.set(S.ExtHostContext.ExtHostEditorTabs,Ve);const at=Qe.set(S.ExtHostContext.ExtHostDecorations,nt.get(Y.IExtHostDecorations)),Ke=Qe.set(S.ExtHostContext.ExtHostDocumentsAndEditors,nt.get(s.IExtHostDocumentsAndEditors)),rt=Qe.set(S.ExtHostContext.ExtHostCommands,nt.get(b.IExtHostCommands)),dt=Qe.set(S.ExtHostContext.ExtHostTerminalService,nt.get(H.IExtHostTerminalService)),mt=Qe.set(S.ExtHostContext.ExtHostDebugService,nt.get(be.IExtHostDebugService)),It=Qe.set(S.ExtHostContext.ExtHostSearch,nt.get(ke.IExtHostSearch)),Et=Qe.set(S.ExtHostContext.ExtHostTask,nt.get(ve.IExtHostTask)),_t=Qe.set(S.ExtHostContext.ExtHostOutputService,nt.get(y.IExtHostOutputService)),At=Qe.set(S.ExtHostContext.ExtHostLocalization,nt.get(st.IExtHostLocalizationService)),St=Qe.set(S.ExtHostContext.ExtHostUrls,new x.ExtHostUrls(Qe)),kt=Qe.set(S.ExtHostContext.ExtHostDocuments,new u.ExtHostDocuments(Qe,Ke)),tn=Qe.set(S.ExtHostContext.ExtHostDocumentContentProviders,new g.ExtHostDocumentContentProvider(Qe,Ke,gt)),Xt=Qe.set(S.ExtHostContext.ExtHostDocumentSaveParticipant,new n.ExtHostDocumentSaveParticipant(gt,kt,Qe.getProxy(S.MainContext.MainThreadBulkEdits))),bt=Qe.set(S.ExtHostContext.ExtHostNotebook,new me.ExtHostNotebookController(Qe,rt,Ke,kt)),nn=Qe.set(S.ExtHostContext.ExtHostNotebookDocuments,new fe.ExtHostNotebookDocuments(bt)),rn=Qe.set(S.ExtHostContext.ExtHostNotebookEditors,new xe.ExtHostNotebookEditors(gt,bt)),sn=Qe.set(S.ExtHostContext.ExtHostNotebookKernels,new Oe.ExtHostNotebookKernels(Qe,it,bt,rt,gt)),vn=Qe.set(S.ExtHostContext.ExtHostNotebookRenderers,new re.ExtHostNotebookRenderers(Qe,bt)),Rt=Qe.set(S.ExtHostContext.ExtHostEditors,new F.ExtHostEditors(Qe,Ke)),Ht=Qe.set(S.ExtHostContext.ExtHostTreeViews,new G.ExtHostTreeViews(Qe.getProxy(S.MainContext.MainThreadTreeViews),rt,gt)),bn=Qe.set(S.ExtHostContext.ExtHostEditorInsets,new de.ExtHostEditorInsets(Qe.getProxy(S.MainContext.MainThreadEditorInsets),Rt,it.remote)),on=Qe.set(S.ExtHostContext.ExtHostDiagnostics,new h.ExtHostDiagnostics(Qe,gt,wt)),Qt=Qe.set(S.ExtHostContext.ExtHostLanguages,new a.ExtHostLanguages(Qe,kt,rt.converter,Wt)),lt=Qe.set(S.ExtHostContext.ExtHostLanguageFeatures,new r.ExtHostLanguageFeatures(Qe,Wt,kt,rt,on,gt,_e)),wn=Qe.set(S.ExtHostContext.ExtHostFileSystem,new o.ExtHostFileSystem(Qe,lt)),$t=Qe.set(S.ExtHostContext.ExtHostFileSystemEventService,new d.ExtHostFileSystemEventService(Qe,gt,Ke)),qt=Qe.set(S.ExtHostContext.ExtHostQuickOpen,(0,N.createExtHostQuickOpen)(Qe,ht,rt)),an=Qe.set(S.ExtHostContext.ExtHostSCM,new M.ExtHostSCM(Qe,rt,gt)),En=Qe.set(S.ExtHostContext.ExtHostComments,(0,m.createExtHostComments)(Qe,rt,kt)),cn=Qe.set(S.ExtHostContext.ExtHostProgress,new R.ExtHostProgress(Qe.getProxy(S.MainContext.MainThreadProgress))),Sn=Qe.set(S.ExtHostContext.ExtHosLabelService,new te.ExtHostLabelService(Qe)),ln=Qe.set(S.ExtHostContext.ExtHostTheming,new Z.ExtHostTheming(Qe)),un=Qe.set(S.ExtHostContext.ExtHostAuthentication,new ie.ExtHostAuthentication(Qe)),Nn=Qe.set(S.ExtHostContext.ExtHostTimeline,new O.ExtHostTimeline(Qe,rt)),Yt=Qe.set(S.ExtHostContext.ExtHostWebviews,new $.ExtHostWebviews(Qe,it.remote,ht,gt,_e)),Jt=Qe.set(S.ExtHostContext.ExtHostWebviewPanels,new we.ExtHostWebviewPanels(Qe,Yt,ht)),_n=Qe.set(S.ExtHostContext.ExtHostCustomEditors,new ge.ExtHostCustomEditors(Qe,kt,Pt,Yt,Jt)),yn=Qe.set(S.ExtHostContext.ExtHostWebviewViews,new X.ExtHostWebviewViews(Qe,Yt)),Zt=Qe.set(S.ExtHostContext.ExtHostTesting,new ye.ExtHostTesting(Qe,rt,Ke)),Cn=Qe.set(S.ExtHostContext.ExtHostUriOpeners,new We.ExtHostUriOpeners(Qe));Qe.set(S.ExtHostContext.ExtHostInteractive,new Ae.ExtHostInteractive(Qe,bt,Ke,rt,gt));const Dn=Object.values(S.ExtHostContext);Qe.assertRegistered(Dn);const Mn=new ce.ExtHostBulkEdits(Qe,Ke),Un=new p.ExtHostClipboard(Qe),In=new f.ExtHostMessageService(Qe,gt),An=new c.ExtHostDialogs(Qe),Rn=new A.ExtHostStatusBar(Qe,rt.converter);return E.ExtHostApiCommands.register(rt),function(He,Bt,dn){const pt=function(){let pe=!He.isUnderDevelopment;function Se(){pe||(gt.info(`Extension '${He.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),pe=!0)}return function Ue(ct){if(Array.isArray(ct))ct.forEach(Ue);else if(typeof ct=="string")Se();else{const yt=ct;typeof yt.scheme>"u"&&Se(),typeof yt.exclusive=="boolean"&&(0,Me.checkProposedApiEnabled)(He,"documentFiltersExclusive")}return ct}}(),Bn={getSession(pe,Se,Ue){return un.getSession(He,pe,Se,Ue)},async hasSession(pe,Se){return(0,Me.checkProposedApiEnabled)(He,"authSession"),!!await un.getSession(He,pe,Se,{silent:!0})},get onDidChangeSessions(){return un.onDidChangeSessions},registerAuthenticationProvider(pe,Se,Ue,ct){return un.registerAuthenticationProvider(pe,Se,Ue,ct)}},zn={registerCommand(pe,Se,Ue){return rt.registerCommand(!0,pe,Se,Ue,void 0,He)},registerTextEditorCommand(pe,Se,Ue){return rt.registerCommand(!0,pe,(...ct)=>{const yt=Rt.getActiveTextEditor();if(!yt){gt.warn("Cannot execute "+pe+" because there is no active text editor.");return}return yt.edit(Lt=>{Se.apply(Ue,[yt,Lt,...ct])}).then(Lt=>{Lt||gt.warn("Edits from command "+pe+" were not applied.")},Lt=>{gt.warn("An error occurred while running command "+pe,Lt)})},void 0,void 0,He)},registerDiffInformationCommand:(pe,Se,Ue)=>((0,Me.checkProposedApiEnabled)(He,"diffCommand"),rt.registerCommand(!0,pe,async(...ct)=>{const yt=Ke.activeEditor(!0);if(!yt){gt.warn("Cannot execute "+pe+" because there is no active text editor.");return}const Lt=await Rt.getDiffInformation(yt.id);Se.apply(Ue,[Lt,...ct])},void 0,void 0,He)),executeCommand(pe,...Se){return rt.executeCommand(pe,...Se)},getCommands(pe=!1){return rt.getCommands(pe)}},en={get machineId(){return it.telemetryInfo.machineId},get sessionId(){return it.telemetryInfo.sessionId},get language(){return it.environment.appLanguage},get appName(){return it.environment.appName},get appRoot(){return it.environment.appRoot?.fsPath??""},get appHost(){return it.environment.appHost},get uriScheme(){return it.environment.appUriScheme},get clipboard(){return Un.value},get shell(){return dt.getDefaultShell(!1)},get onDidChangeShell(){return(0,Me.checkProposedApiEnabled)(He,"envShellEvent"),dt.onDidChangeShell},get isTelemetryEnabled(){return Tt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Tt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Me.checkProposedApiEnabled)(He,"telemetry"),Tt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Me.checkProposedApiEnabled)(He,"telemetry"),Tt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const pe=Date.now()-new Date(it.telemetryInfo.firstSessionDate).getTime();return isNaN(pe)?!1:pe<1e3*60*60*24},openExternal(pe,Se){return ee.openUri(pe,{allowTunneling:!!it.remote.authority,allowContributedOpeners:Se?.allowContributedOpeners})},async asExternalUri(pe){if(pe.scheme===it.environment.appUriScheme)return St.createAppUri(pe);try{return await ee.asExternalUri(pe,{allowTunneling:!!it.remote.authority})}catch(Se){if((0,Ee.matchesScheme)(pe,se.Schemas.http)||(0,Ee.matchesScheme)(pe,se.Schemas.https))return pe;throw Se}},get remoteName(){return(0,he.getRemoteName)(it.remote.authority)},get remoteAuthority(){return(0,Me.checkProposedApiEnabled)(He,"resolvers"),it.remote.authority},get uiKind(){return it.uiKind}};it.environment.extensionTestsLocationURI||Object.freeze(en);const Wn={createTestController(pe,Se,Ue){return Zt.createTestController(pe,Se,Ue)},createTestObserver(){return(0,Me.checkProposedApiEnabled)(He,"testObserver"),Zt.createTestObserver()},runTests(pe){return(0,Me.checkProposedApiEnabled)(He,"testObserver"),Zt.runTests(pe)},get onDidChangeTestResults(){return(0,Me.checkProposedApiEnabled)(He,"testObserver"),Zt.onResultsChanged},get testResults(){return(0,Me.checkProposedApiEnabled)(He,"testObserver"),Zt.results}},hn=it.remote.isRemote?U.ExtensionKind.Workspace:U.ExtensionKind.UI,Hn={getExtension(pe,Se){(0,Me.isProposedApiEnabled)(He,"extensionsAny")||(Se=!1);const Ue=Bt.mine.getExtensionDescription(pe);if(Ue)return new i.Extension(Dt,He.identifier,Ue,hn,!1);if(Se){const ct=Bt.all.getExtensionDescription(pe);if(ct)return new i.Extension(Dt,He.identifier,ct,hn,!0)}},get all(){const pe=[];for(const Se of Bt.mine.getAllExtensionDescriptions())pe.push(new i.Extension(Dt,He.identifier,Se,hn,!1));return pe},get allAcrossExtensionHosts(){(0,Me.checkProposedApiEnabled)(He,"extensionsAny");const pe=new Me.ExtensionIdentifierSet(Bt.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),Se=[];for(const Ue of Bt.all.getAllExtensionDescriptions()){const ct=!pe.has(Ue.identifier);Se.push(new i.Extension(Dt,He.identifier,Ue,hn,ct))}return Se},get onDidChange(){return(0,Me.isProposedApiEnabled)(He,"extensionsAny")?C.Event.any(Bt.mine.onDidChange,Bt.all.onDidChange):Bt.mine.onDidChange}},$n={createDiagnosticCollection(pe){return on.createDiagnosticCollection(He.identifier,pe)},get onDidChangeDiagnostics(){return on.onDidChangeDiagnostics},getDiagnostics:pe=>on.getDiagnostics(pe),getLanguages(){return Qt.getLanguages()},setTextDocumentLanguage(pe,Se){return Qt.changeLanguage(pe.uri,Se)},match(pe,Se){const Ue=kt.getDocumentData(Se.uri)?.notebook;return(0,L.score)(B.LanguageSelector.from(pe),Se.uri,Se.languageId,!0,Ue?.uri,Ue?.notebookType)},registerCodeActionsProvider(pe,Se,Ue){return lt.registerCodeActionProvider(He,pt(pe),Se,Ue)},registerDocumentPasteEditProvider(pe,Se,Ue){return(0,Me.checkProposedApiEnabled)(He,"documentPaste"),lt.registerDocumentPasteEditProvider(He,pt(pe),Se,Ue)},registerCodeLensProvider(pe,Se){return lt.registerCodeLensProvider(He,pt(pe),Se)},registerDefinitionProvider(pe,Se){return lt.registerDefinitionProvider(He,pt(pe),Se)},registerDeclarationProvider(pe,Se){return lt.registerDeclarationProvider(He,pt(pe),Se)},registerImplementationProvider(pe,Se){return lt.registerImplementationProvider(He,pt(pe),Se)},registerTypeDefinitionProvider(pe,Se){return lt.registerTypeDefinitionProvider(He,pt(pe),Se)},registerHoverProvider(pe,Se){return lt.registerHoverProvider(He,pt(pe),Se,He.identifier)},registerEvaluatableExpressionProvider(pe,Se){return lt.registerEvaluatableExpressionProvider(He,pt(pe),Se,He.identifier)},registerInlineValuesProvider(pe,Se){return lt.registerInlineValuesProvider(He,pt(pe),Se,He.identifier)},registerDocumentHighlightProvider(pe,Se){return lt.registerDocumentHighlightProvider(He,pt(pe),Se)},registerLinkedEditingRangeProvider(pe,Se){return lt.registerLinkedEditingRangeProvider(He,pt(pe),Se)},registerReferenceProvider(pe,Se){return lt.registerReferenceProvider(He,pt(pe),Se)},registerRenameProvider(pe,Se){return lt.registerRenameProvider(He,pt(pe),Se)},registerDocumentSymbolProvider(pe,Se,Ue){return lt.registerDocumentSymbolProvider(He,pt(pe),Se,Ue)},registerWorkspaceSymbolProvider(pe){return lt.registerWorkspaceSymbolProvider(He,pe)},registerDocumentFormattingEditProvider(pe,Se){return lt.registerDocumentFormattingEditProvider(He,pt(pe),Se)},registerDocumentRangeFormattingEditProvider(pe,Se){return lt.registerDocumentRangeFormattingEditProvider(He,pt(pe),Se)},registerOnTypeFormattingEditProvider(pe,Se,Ue,...ct){return lt.registerOnTypeFormattingEditProvider(He,pt(pe),Se,[Ue].concat(ct))},registerDocumentSemanticTokensProvider(pe,Se,Ue){return lt.registerDocumentSemanticTokensProvider(He,pt(pe),Se,Ue)},registerDocumentRangeSemanticTokensProvider(pe,Se,Ue){return lt.registerDocumentRangeSemanticTokensProvider(He,pt(pe),Se,Ue)},registerSignatureHelpProvider(pe,Se,Ue,...ct){return typeof Ue=="object"?lt.registerSignatureHelpProvider(He,pt(pe),Se,Ue):lt.registerSignatureHelpProvider(He,pt(pe),Se,typeof Ue>"u"?[]:[Ue,...ct])},registerCompletionItemProvider(pe,Se,...Ue){return lt.registerCompletionItemProvider(He,pt(pe),Se,Ue)},registerInlineCompletionItemProvider(pe,Se){return Se.handleDidShowCompletionItem&&(0,Me.checkProposedApiEnabled)(He,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(He,pt(pe),Se)},registerInlineCompletionItemProviderNew(pe,Se){if((0,Me.checkProposedApiEnabled)(He,"inlineCompletionsNew"),Se.handleDidShowCompletionItem&&!(0,Me.isProposedApiEnabled)(He,"inlineCompletionsAdditions"))throw new Error(`When the method "handleDidShowCompletionItem" is implemented on a provider, the usage of the proposed api 'inlineCompletionsAdditions' must be declared!`);return lt.registerInlineCompletionsProviderNew(He,pt(pe),Se)},registerDocumentLinkProvider(pe,Se){return lt.registerDocumentLinkProvider(He,pt(pe),Se)},registerColorProvider(pe,Se){return lt.registerColorProvider(He,pt(pe),Se)},registerFoldingRangeProvider(pe,Se){return lt.registerFoldingRangeProvider(He,pt(pe),Se)},registerSelectionRangeProvider(pe,Se){return lt.registerSelectionRangeProvider(He,pe,Se)},registerCallHierarchyProvider(pe,Se){return lt.registerCallHierarchyProvider(He,pe,Se)},registerTypeHierarchyProvider(pe,Se){return lt.registerTypeHierarchyProvider(He,pe,Se)},setLanguageConfiguration:(pe,Se)=>lt.setLanguageConfiguration(He,pe,Se),getTokenInformationAtPosition(pe,Se){return(0,Me.checkProposedApiEnabled)(He,"tokenInformation"),Qt.tokenAtPosition(pe,Se)},registerInlayHintsProvider(pe,Se){return lt.registerInlayHintsProvider(He,pe,Se)},createLanguageStatusItem(pe,Se){return Qt.createLanguageStatusItem(He,pe,Se)},registerDocumentDropEditProvider(pe,Se){return lt.registerDocumentOnDropEditProvider(He,pe,Se)}},kn={get activeTextEditor(){return Rt.getActiveTextEditor()},get visibleTextEditors(){return Rt.getVisibleTextEditors()},get activeTerminal(){return dt.activeTerminal},get terminals(){return dt.terminals},async showTextDocument(pe,Se,Ue){const ct=await(_.URI.isUri(pe)?Promise.resolve(Ln.openTextDocument(pe)):Promise.resolve(pe));return Rt.showTextDocument(ct,Se,Ue)},createTextEditorDecorationType(pe){return Rt.createTextEditorDecorationType(He,pe)},onDidChangeActiveTextEditor(pe,Se,Ue){return Rt.onDidChangeActiveTextEditor(pe,Se,Ue)},onDidChangeVisibleTextEditors(pe,Se,Ue){return Rt.onDidChangeVisibleTextEditors(pe,Se,Ue)},onDidChangeTextEditorSelection(pe,Se,Ue){return Rt.onDidChangeTextEditorSelection(pe,Se,Ue)},onDidChangeTextEditorOptions(pe,Se,Ue){return Rt.onDidChangeTextEditorOptions(pe,Se,Ue)},onDidChangeTextEditorVisibleRanges(pe,Se,Ue){return Rt.onDidChangeTextEditorVisibleRanges(pe,Se,Ue)},onDidChangeTextEditorViewColumn(pe,Se,Ue){return Rt.onDidChangeTextEditorViewColumn(pe,Se,Ue)},onDidCloseTerminal(pe,Se,Ue){return dt.onDidCloseTerminal(pe,Se,Ue)},onDidOpenTerminal(pe,Se,Ue){return dt.onDidOpenTerminal(pe,Se,Ue)},onDidChangeActiveTerminal(pe,Se,Ue){return dt.onDidChangeActiveTerminal(pe,Se,Ue)},onDidChangeTerminalDimensions(pe,Se,Ue){return(0,Me.checkProposedApiEnabled)(He,"terminalDimensions"),dt.onDidChangeTerminalDimensions(pe,Se,Ue)},onDidChangeTerminalState(pe,Se,Ue){return dt.onDidChangeTerminalState(pe,Se,Ue)},onDidWriteTerminalData(pe,Se,Ue){return(0,Me.checkProposedApiEnabled)(He,"terminalDataWriteEvent"),dt.onDidWriteTerminalData(pe,Se,Ue)},get state(){return ee.state},onDidChangeWindowState(pe,Se,Ue){return ee.onDidChangeWindowState(pe,Se,Ue)},showInformationMessage(pe,...Se){return In.showMessage(He,P.default.Info,pe,Se[0],Se.slice(1))},showWarningMessage(pe,...Se){return In.showMessage(He,P.default.Warning,pe,Se[0],Se.slice(1))},showErrorMessage(pe,...Se){return In.showMessage(He,P.default.Error,pe,Se[0],Se.slice(1))},showQuickPick(pe,Se,Ue){return qt.showQuickPick(pe,Se,Ue)},showWorkspaceFolderPick(pe){return qt.showWorkspaceFolderPick(pe)},showInputBox(pe,Se){return qt.showInput(pe,Se)},showOpenDialog(pe){return An.showOpenDialog(pe)},showSaveDialog(pe){return An.showSaveDialog(pe)},createStatusBarItem(pe,Se,Ue){let ct,yt,Lt;return typeof pe=="string"?(ct=pe,yt=Se,Lt=Ue):(yt=pe,Lt=Se),Rn.createStatusBarEntry(He,ct,yt,Lt)},setStatusBarMessage(pe,Se){return Rn.setStatusBarMessage(pe,Se)},withScmProgress(pe){return _e.report("window.withScmProgress",He,"Use 'withProgress' instead."),cn.withProgress(He,{location:U.ProgressLocation.SourceControl},(Se,Ue)=>pe({report(ct){}}))},withProgress(pe,Se){return cn.withProgress(He,pe,Se)},createOutputChannel(pe,Se){return _t.createOutputChannel(pe,Se,He)},createWebviewPanel(pe,Se,Ue,ct){return Jt.createWebviewPanel(He,pe,Se,Ue,ct)},createWebviewTextEditorInset(pe,Se,Ue,ct){return(0,Me.checkProposedApiEnabled)(He,"editorInsets"),bn.createWebviewEditorInset(pe,Se,Ue,ct,He)},createTerminal(pe,Se,Ue){return typeof pe=="object"?"pty"in pe?dt.createExtensionTerminal(pe):dt.createTerminalFromOptions(pe):dt.createTerminal(pe,Se,Ue)},registerTerminalLinkProvider(pe){return dt.registerLinkProvider(pe)},registerTerminalProfileProvider(pe,Se){return dt.registerProfileProvider(He,pe,Se)},registerTreeDataProvider(pe,Se){return Ht.registerTreeDataProvider(pe,Se,He)},createTreeView(pe,Se){return Ht.createTreeView(pe,Se,He)},registerWebviewPanelSerializer:(pe,Se)=>Jt.registerWebviewPanelSerializer(He,pe,Se),registerCustomEditorProvider:(pe,Se,Ue={})=>_n.registerCustomEditorProvider(He,pe,Se,Ue),registerFileDecorationProvider(pe){return at.registerFileDecorationProvider(pe,He.identifier)},registerUriHandler(pe){return St.registerUriHandler(He.identifier,pe)},createQuickPick(){return qt.createQuickPick(He)},createInputBox(){return qt.createInputBox(He)},get activeColorTheme(){return ln.activeColorTheme},onDidChangeActiveColorTheme(pe,Se,Ue){return ln.onDidChangeActiveColorTheme(pe,Se,Ue)},registerWebviewViewProvider(pe,Se,Ue){return yn.registerWebviewViewProvider(He,pe,Se,Ue?.webviewOptions)},get activeNotebookEditor(){return bt.activeNotebookEditor},onDidChangeActiveNotebookEditor(pe,Se,Ue){return bt.onDidChangeActiveNotebookEditor(pe,Se,Ue)},get visibleNotebookEditors(){return bt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return bt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(pe,Se,Ue){return rn.onDidChangeNotebookEditorSelection(pe,Se,Ue)},onDidChangeNotebookEditorVisibleRanges(pe,Se,Ue){return rn.onDidChangeNotebookEditorVisibleRanges(pe,Se,Ue)},showNotebookDocument(pe,Se){return _.URI.isUri(pe)&&_e.report("window.showNotebookDocument(uri)",He,"Please use 'workspace.openNotebookDocument' and 'window.showNotebookDocument'"),bt.showNotebookDocument(pe,Se)},registerExternalUriOpener(pe,Se,Ue){return(0,Me.checkProposedApiEnabled)(He,"externalUriOpener"),Cn.registerExternalUriOpener(He.identifier,pe,Se,Ue)},get tabGroups(){return Ve.tabGroups},logTelemetryToOutputChannel(pe,Se){(0,Me.checkProposedApiEnabled)(He,"telemetryLog"),Fe.logToTelemetryOutputChannel(He,pe,Se)}},Ln={get rootPath(){return _e.report("workspace.rootPath",He,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ht.getPath()},set rootPath(pe){throw t.readonly()},getWorkspaceFolder(pe){return ht.getWorkspaceFolder(pe)},get workspaceFolders(){return ht.getWorkspaceFolders()},get name(){return ht.name},set name(pe){throw t.readonly()},get workspaceFile(){return ht.workspaceFile},set workspaceFile(pe){throw t.readonly()},updateWorkspaceFolders:(pe,Se,...Ue)=>ht.updateWorkspaceFolders(He,pe,Se||0,...Ue),onDidChangeWorkspaceFolders:function(pe,Se,Ue){return ht.onDidChangeWorkspace(pe,Se,Ue)},asRelativePath:(pe,Se)=>ht.getRelativePath(pe,Se),findFiles:(pe,Se,Ue,ct)=>ht.findFiles(pe,Se,Ue,He.identifier,ct),findTextInFiles:(pe,Se,Ue,ct)=>{(0,Me.checkProposedApiEnabled)(He,"findTextInFiles");let yt,Lt;return typeof Se=="object"?(yt=Se,Lt=Ue):(yt={},Lt=Se,ct=Ue),ht.findTextInFiles(pe,yt||{},Lt,He.identifier,ct)},saveAll:pe=>ht.saveAll(pe),applyEdit(pe,Se){return Mn.applyWorkspaceEdit(pe,He,Se)},createFileSystemWatcher:(pe,Se,Ue,ct)=>$t.createFileSystemWatcher(ht,He,pe,Se,Ue,ct),get textDocuments(){return kt.getAllDocumentData().map(pe=>pe.document)},set textDocuments(pe){throw t.readonly()},openTextDocument(pe){let Se;const Ue=pe;if(typeof pe=="string")Se=Promise.resolve(_.URI.file(pe));else if(_.URI.isUri(pe))Se=Promise.resolve(pe);else if(!Ue||typeof Ue=="object")Se=kt.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Se.then(ct=>kt.ensureDocumentData(ct).then(yt=>yt.document))},onDidOpenTextDocument:(pe,Se,Ue)=>kt.onDidAddDocument(pe,Se,Ue),onDidCloseTextDocument:(pe,Se,Ue)=>kt.onDidRemoveDocument(pe,Se,Ue),onDidChangeTextDocument:(pe,Se,Ue)=>kt.onDidChangeDocument(pe,Se,Ue),onDidSaveTextDocument:(pe,Se,Ue)=>kt.onDidSaveDocument(pe,Se,Ue),onWillSaveTextDocument:(pe,Se,Ue)=>Xt.getOnWillSaveTextDocumentEvent(He)(pe,Se,Ue),get notebookDocuments(){return bt.notebookDocuments.map(pe=>pe.apiNotebook)},async openNotebookDocument(pe,Se){let Ue;if(_.URI.isUri(pe))Ue=pe,await bt.openNotebookDocument(pe);else if(typeof pe=="string")Ue=_.URI.revive(await bt.createNotebookDocument({viewType:pe,content:Se}));else throw new Error("Invalid arguments");return bt.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(pe,Se,Ue){return nn.onDidSaveNotebookDocument(pe,Se,Ue)},onDidChangeNotebookDocument(pe,Se,Ue){return nn.onDidChangeNotebookDocument(pe,Se,Ue)},get onDidOpenNotebookDocument(){return bt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return bt.onDidCloseNotebookDocument},registerNotebookSerializer(pe,Se,Ue,ct){return bt.registerNotebookSerializer(He,pe,Se,Ue,(0,Me.isProposedApiEnabled)(He,"notebookLiveShare")?ct:void 0)},registerNotebookContentProvider:(pe,Se,Ue,ct)=>((0,Me.checkProposedApiEnabled)(He,"notebookContentProvider"),_e.report("workspace.registerNotebookContentProvider",He,"The notebookContentProvider API is not on track for finalization and will be removed."),bt.registerNotebookContentProvider(He,pe,Se,Ue,(0,Me.isProposedApiEnabled)(He,"notebookLiveShare")?ct:void 0)),onDidChangeConfiguration:(pe,Se,Ue)=>dn.onDidChangeConfiguration(pe,Se,Ue),getConfiguration(pe,Se){return Se=arguments.length===1?void 0:Se,dn.getConfiguration(pe,Se,He)},registerTextDocumentContentProvider(pe,Se){return tn.registerTextDocumentContentProvider(pe,Se)},registerTaskProvider:(pe,Se)=>(_e.report("window.registerTaskProvider",He,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(He,pe,Se)),registerFileSystemProvider(pe,Se,Ue){return(0,Le.combinedDisposable)(wn.registerFileSystemProvider(He,pe,Se,Ue),Ct.addFileSystemProvider(pe,Se))},get fs(){return Ct.value},registerFileSearchProvider:(pe,Se)=>((0,Me.checkProposedApiEnabled)(He,"fileSearchProvider"),It.registerFileSearchProvider(pe,Se)),registerTextSearchProvider:(pe,Se)=>((0,Me.checkProposedApiEnabled)(He,"textSearchProvider"),It.registerTextSearchProvider(pe,Se)),registerRemoteAuthorityResolver:(pe,Se)=>((0,Me.checkProposedApiEnabled)(He,"resolvers"),Dt.registerRemoteAuthorityResolver(pe,Se)),registerResourceLabelFormatter:pe=>((0,Me.checkProposedApiEnabled)(He,"resolvers"),Sn.$registerResourceLabelFormatter(pe)),onDidCreateFiles:(pe,Se,Ue)=>$t.onDidCreateFile(pe,Se,Ue),onDidDeleteFiles:(pe,Se,Ue)=>$t.onDidDeleteFile(pe,Se,Ue),onDidRenameFiles:(pe,Se,Ue)=>$t.onDidRenameFile(pe,Se,Ue),onWillCreateFiles:(pe,Se,Ue)=>$t.getOnWillCreateFileEvent(He)(pe,Se,Ue),onWillDeleteFiles:(pe,Se,Ue)=>$t.getOnWillDeleteFileEvent(He)(pe,Se,Ue),onWillRenameFiles:(pe,Se,Ue)=>$t.getOnWillRenameFileEvent(He)(pe,Se,Ue),openTunnel:pe=>((0,Me.checkProposedApiEnabled)(He,"resolvers"),Pe.openTunnel(He,pe).then(Se=>{if(!Se)throw new Error("cannot open tunnel");return Se})),get tunnels(){return(0,Me.checkProposedApiEnabled)(He,"resolvers"),Pe.getTunnels()},onDidChangeTunnels:(pe,Se,Ue)=>((0,Me.checkProposedApiEnabled)(He,"resolvers"),Pe.onDidChangeTunnels(pe,Se,Ue)),registerPortAttributesProvider:(pe,Se)=>((0,Me.checkProposedApiEnabled)(He,"portsAttributes"),Pe.registerPortsAttributesProvider(pe,Se)),registerTimelineProvider:(pe,Se)=>((0,Me.checkProposedApiEnabled)(He,"timeline"),Nn.registerTimelineProvider(pe,Se,He.identifier,rt.converter)),get isTrusted(){return ht.trusted},requestWorkspaceTrust:pe=>((0,Me.checkProposedApiEnabled)(He,"workspaceTrust"),ht.requestWorkspaceTrust(pe)),onDidGrantWorkspaceTrust:(pe,Se,Ue)=>ht.onDidGrantWorkspaceTrust(pe,Se,Ue),registerEditSessionIdentityProvider:(pe,Se)=>((0,Me.checkProposedApiEnabled)(He,"editSessionIdentityProvider"),ht.registerEditSessionIdentityProvider(pe,Se))},Vt={get inputBox(){return _e.report("scm.inputBox",He,"Use 'SourceControl.inputBox' instead"),an.getLastInputBox(He)},createSourceControl(pe,Se,Ue){return an.createSourceControl(He,pe,Se,Ue)}},fn={createCommentController(pe,Se){return En.createCommentController(He,pe,Se)}},xn={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},onDidStartDebugSession(pe,Se,Ue){return mt.onDidStartDebugSession(pe,Se,Ue)},onDidTerminateDebugSession(pe,Se,Ue){return mt.onDidTerminateDebugSession(pe,Se,Ue)},onDidChangeActiveDebugSession(pe,Se,Ue){return mt.onDidChangeActiveDebugSession(pe,Se,Ue)},onDidReceiveDebugSessionCustomEvent(pe,Se,Ue){return mt.onDidReceiveDebugSessionCustomEvent(pe,Se,Ue)},onDidChangeBreakpoints(pe,Se,Ue){return mt.onDidChangeBreakpoints(pe,Se,Ue)},registerDebugConfigurationProvider(pe,Se,Ue){return mt.registerDebugConfigurationProvider(pe,Se,Ue||Ge.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(pe,Se){return mt.registerDebugAdapterDescriptorFactory(He,pe,Se)},registerDebugAdapterTrackerFactory(pe,Se){return mt.registerDebugAdapterTrackerFactory(pe,Se)},startDebugging(pe,Se,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?mt.startDebugging(pe,Se,{parentSession:Ue}):mt.startDebugging(pe,Se,Ue||{})},stopDebugging(pe){return mt.stopDebugging(pe)},addBreakpoints(pe){return mt.addBreakpoints(pe)},removeBreakpoints(pe){return mt.removeBreakpoints(pe)},asDebugSourceUri(pe,Se){return mt.asDebugSourceUri(pe,Se)}},Mt={registerTaskProvider:(pe,Se)=>Et.registerTaskProvider(He,pe,Se),fetchTasks:pe=>Et.fetchTasks(pe),executeTask:pe=>Et.executeTask(He,pe),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(pe,Se,Ue)=>Et.onDidStartTask(pe,Se,Ue),onDidEndTask:(pe,Se,Ue)=>Et.onDidEndTask(pe,Se,Ue),onDidStartTaskProcess:(pe,Se,Ue)=>Et.onDidStartTaskProcess(pe,Se,Ue),onDidEndTaskProcess:(pe,Se,Ue)=>Et.onDidEndTaskProcess(pe,Se,Ue)},mn={createNotebookController(pe,Se,Ue,ct,yt){return sn.createNotebookController(He,pe,Se,Ue,ct,(0,Me.isProposedApiEnabled)(He,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(pe,Se)=>bt.registerNotebookCellStatusBarItemProvider(He,pe,Se),createRendererMessaging(pe){return vn.createRendererMessaging(He,pe)},onDidChangeNotebookCellExecutionState(pe,Se,Ue){return(0,Me.checkProposedApiEnabled)(He,"notebookCellExecutionState"),sn.onDidChangeNotebookCellExecutionState(pe,Se,Ue)}},Vn={t(...pe){if((0,Me.checkProposedApiEnabled)(He,"localization"),typeof pe[0]=="string"){const Se=pe.shift(),Ue=!pe||typeof pe[0]!="object"?pe:pe[0];return At.getMessage(He.identifier.value,{message:Se,args:Ue})}return At.getMessage(He.identifier.value,pe[0])},get bundle(){return(0,Me.checkProposedApiEnabled)(He,"localization"),At.getBundle(He.identifier.value)},get uri(){return(0,Me.checkProposedApiEnabled)(He,"localization"),At.getBundleUri(He.identifier.value)}};return{version:it.version,authentication:Bn,commands:zn,comments:fn,debug:xn,env:en,extensions:Hn,l10n:Vn,languages:$n,notebooks:mn,scm:Vt,tasks:Mt,tests:Wn,window:kn,workspace:Ln,Breakpoint:U.Breakpoint,CallHierarchyIncomingCall:U.CallHierarchyIncomingCall,CallHierarchyItem:U.CallHierarchyItem,CallHierarchyOutgoingCall:U.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:l.CancellationTokenSource,CandidatePortSource:S.CandidatePortSource,CodeAction:U.CodeAction,CodeActionKind:U.CodeActionKind,CodeActionTriggerKind:U.CodeActionTriggerKind,CodeLens:U.CodeLens,Color:U.Color,ColorInformation:U.ColorInformation,ColorPresentation:U.ColorPresentation,ColorThemeKind:U.ColorThemeKind,CommentMode:U.CommentMode,CommentThreadCollapsibleState:U.CommentThreadCollapsibleState,CommentThreadState:U.CommentThreadState,CompletionItem:U.CompletionItem,CompletionItemKind:U.CompletionItemKind,CompletionItemTag:U.CompletionItemTag,CompletionList:U.CompletionList,CompletionTriggerKind:U.CompletionTriggerKind,ConfigurationTarget:U.ConfigurationTarget,CustomExecution:U.CustomExecution,DebugAdapterExecutable:U.DebugAdapterExecutable,DebugAdapterInlineImplementation:U.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:U.DebugAdapterNamedPipeServer,DebugAdapterServer:U.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Ge.DebugConfigurationProviderTriggerKind,DebugConsoleMode:U.DebugConsoleMode,DecorationRangeBehavior:U.DecorationRangeBehavior,Diagnostic:U.Diagnostic,DiagnosticRelatedInformation:U.DiagnosticRelatedInformation,DiagnosticSeverity:U.DiagnosticSeverity,DiagnosticTag:U.DiagnosticTag,Disposable:U.Disposable,DocumentHighlight:U.DocumentHighlight,DocumentHighlightKind:U.DocumentHighlightKind,DocumentLink:U.DocumentLink,DocumentSymbol:U.DocumentSymbol,EndOfLine:U.EndOfLine,EnvironmentVariableMutatorType:U.EnvironmentVariableMutatorType,EvaluatableExpression:U.EvaluatableExpression,InlineValueText:U.InlineValueText,InlineValueVariableLookup:U.InlineValueVariableLookup,InlineValueEvaluatableExpression:U.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:U.InlineCompletionTriggerKind,InlineCompletionTriggerKindNew:U.InlineCompletionTriggerKindNew,EventEmitter:C.Emitter,ExtensionKind:U.ExtensionKind,ExtensionMode:U.ExtensionMode,ExternalUriOpenerPriority:U.ExternalUriOpenerPriority,FileChangeType:U.FileChangeType,FileDecoration:U.FileDecoration,FileSystemError:U.FileSystemError,FileType:D.FileType,FilePermission:D.FilePermission,FoldingRange:U.FoldingRange,FoldingRangeKind:U.FoldingRangeKind,FunctionBreakpoint:U.FunctionBreakpoint,InlineCompletionItem:U.InlineSuggestion,InlineCompletionItemNew:U.InlineSuggestionNew,InlineCompletionList:U.InlineSuggestionList,InlineCompletionListNew:U.InlineSuggestionsNew,Hover:U.Hover,IndentAction:k.IndentAction,Location:U.Location,MarkdownString:U.MarkdownString,OverviewRulerLane:w.OverviewRulerLane,ParameterInformation:U.ParameterInformation,PortAutoForwardAction:U.PortAutoForwardAction,Position:U.Position,ProcessExecution:U.ProcessExecution,ProgressLocation:U.ProgressLocation,QuickInputButtons:U.QuickInputButtons,Range:U.Range,RelativePattern:U.RelativePattern,Selection:U.Selection,SelectionRange:U.SelectionRange,SemanticTokens:U.SemanticTokens,SemanticTokensBuilder:U.SemanticTokensBuilder,SemanticTokensEdit:U.SemanticTokensEdit,SemanticTokensEdits:U.SemanticTokensEdits,SemanticTokensLegend:U.SemanticTokensLegend,ShellExecution:U.ShellExecution,ShellQuoting:U.ShellQuoting,SignatureHelp:U.SignatureHelp,SignatureHelpTriggerKind:U.SignatureHelpTriggerKind,SignatureInformation:U.SignatureInformation,SnippetString:U.SnippetString,SourceBreakpoint:U.SourceBreakpoint,StandardTokenType:U.StandardTokenType,StatusBarAlignment:U.StatusBarAlignment,SymbolInformation:U.SymbolInformation,SymbolKind:U.SymbolKind,SymbolTag:U.SymbolTag,Task:U.Task,TaskGroup:U.TaskGroup,TaskPanelKind:U.TaskPanelKind,TaskRevealKind:U.TaskRevealKind,TaskScope:U.TaskScope,TerminalLink:U.TerminalLink,TerminalLocation:U.TerminalLocation,TerminalProfile:U.TerminalProfile,TextDocumentSaveReason:U.TextDocumentSaveReason,TextEdit:U.TextEdit,SnippetTextEdit:U.SnippetTextEdit,TextEditorCursorStyle:I.TextEditorCursorStyle,TextEditorLineNumbersStyle:U.TextEditorLineNumbersStyle,TextEditorRevealType:U.TextEditorRevealType,TextEditorSelectionChangeKind:U.TextEditorSelectionChangeKind,TextDocumentChangeReason:U.TextDocumentChangeReason,ThemeColor:U.ThemeColor,ThemeIcon:U.ThemeIcon,TreeItem:U.TreeItem,TreeItem2:U.TreeItem,TreeItemCheckboxState:U.TreeItemCheckboxState,TreeItemCollapsibleState:U.TreeItemCollapsibleState,TypeHierarchyItem:U.TypeHierarchyItem,UIKind:T.UIKind,Uri:_.URI,ViewColumn:U.ViewColumn,WorkspaceEdit:U.WorkspaceEdit,DocumentDropEdit:U.DocumentDropEdit,DocumentPasteEdit:U.DocumentPasteEdit,InlayHint:U.InlayHint,InlayHintLabelPart:U.InlayHintLabelPart,InlayHintKind:U.InlayHintKind,RemoteAuthorityResolverError:U.RemoteAuthorityResolverError,ResolvedAuthority:U.ResolvedAuthority,SourceControlInputBoxValidationType:U.SourceControlInputBoxValidationType,ExtensionRuntime:U.ExtensionRuntime,TimelineItem:U.TimelineItem,NotebookRange:U.NotebookRange,NotebookCellKind:U.NotebookCellKind,NotebookCellExecutionState:U.NotebookCellExecutionState,NotebookCellData:U.NotebookCellData,NotebookData:U.NotebookData,NotebookRendererScript:U.NotebookRendererScript,NotebookCellStatusBarAlignment:U.NotebookCellStatusBarAlignment,NotebookEditorRevealType:U.NotebookEditorRevealType,NotebookCellOutput:U.NotebookCellOutput,NotebookCellOutputItem:U.NotebookCellOutputItem,NotebookCellStatusBarItem:U.NotebookCellStatusBarItem,NotebookControllerAffinity:U.NotebookControllerAffinity,NotebookControllerAffinity2:U.NotebookControllerAffinity2,NotebookEdit:U.NotebookEdit,PortAttributes:U.PortAttributes,LinkedEditingRanges:U.LinkedEditingRanges,TestResultState:U.TestResultState,TestRunRequest:U.TestRunRequest,TestMessage:U.TestMessage,TestTag:U.TestTag,TestRunProfileKind:U.TestRunProfileKind,TextSearchCompleteMessageType:ot.TextSearchCompleteMessageType,DataTransfer:U.DataTransfer,DataTransferItem:U.DataTransferItem,CoveredCount:U.CoveredCount,FileCoverage:U.FileCoverage,StatementCoverage:U.StatementCoverage,BranchCoverage:U.BranchCoverage,FunctionCoverage:U.FunctionCoverage,WorkspaceTrustState:U.WorkspaceTrustState,LanguageStatusSeverity:U.LanguageStatusSeverity,QuickPickItemKind:U.QuickPickItemKind,InputBoxValidationSeverity:U.InputBoxValidationSeverity,TabInputText:U.TextTabInput,TabInputTextDiff:U.TextDiffTabInput,TabInputTextMerge:U.TextMergeTabInput,TabInputCustom:U.CustomEditorTabInput,TabInputNotebook:U.NotebookEditorTabInput,TabInputNotebookDiff:U.NotebookDiffEditorTabInput,TabInputWebview:U.WebviewEditorTabInput,TabInputTerminal:U.TerminalEditorTabInput,TabInputInteractiveWindow:U.InteractiveWindowInput,TerminalExitReason:U.TerminalExitReason}}}e.createApiFactoryAndRegisterActors=vt}),define(De[295],Ie([1,0,267,304,305,2,306]),function(J,e,l,t,C,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function I(D,S,T,E,p,b){const m=b.environment.useHostProxy,v=typeof m=="boolean"?m:!b.remote.isRemote,h=(0,_.createProxyResolver)({resolveProxy:g=>D.resolveProxy(g),getHttpProxySetting:()=>S.getConfiguration("http").get("proxy"),log:(g,n,...u)=>{switch(g){case _.LogLevel.Trace:E.trace(n,...u);break;case _.LogLevel.Debug:E.debug(n,...u);break;case _.LogLevel.Info:E.info(n,...u);break;case _.LogLevel.Warning:E.warn(n,...u);break;case _.LogLevel.Error:E.error(n,...u);break;case _.LogLevel.Critical:E.critical(n,...u);break;case _.LogLevel.Off:break;default:s(g,n,u);break}function s(i,o,...d){E.error("Unknown log level",i),E.error(o,...d)}},getLogLevel:()=>E.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:v,env:process.env}),c=w(S,h);return L(T,c)}e.connectProxyResolver=I;function w(D,S){const T={config:D.getConfiguration("http").get("proxySupport")||"off"};D.onDidChangeConfiguration(p=>{T.config=D.getConfiguration("http").get("proxySupport")||"off"});const E={config:!!D.getConfiguration("http").get("systemCertificates")};return D.onDidChangeConfiguration(p=>{E.config=!!D.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},l,(0,_.createHttpPatch)(l,S,{config:"off"},E,!0)),on:Object.assign({},l,(0,_.createHttpPatch)(l,S,{config:"on"},E,!0)),override:Object.assign({},l,(0,_.createHttpPatch)(l,S,{config:"override"},E,!0)),onRequest:Object.assign({},l,(0,_.createHttpPatch)(l,S,T,E,!0)),default:Object.assign(l,(0,_.createHttpPatch)(l,S,T,E,!1))},https:{off:Object.assign({},t,(0,_.createHttpPatch)(t,S,{config:"off"},E,!0)),on:Object.assign({},t,(0,_.createHttpPatch)(t,S,{config:"on"},E,!0)),override:Object.assign({},t,(0,_.createHttpPatch)(t,S,{config:"override"},E,!0)),onRequest:Object.assign({},t,(0,_.createHttpPatch)(t,S,T,E,!0)),default:Object.assign(t,(0,_.createHttpPatch)(t,S,T,E,!1))},tls:Object.assign(C,(0,_.createTlsPatch)(C))}}const k=new Map;function L(D,S){return D.getExtensionPathIndex().then(T=>{const E=J.__$__nodeRequire("module"),p=E._load;E._load=function(m,v,h){if(m==="tls")return S.tls;if(m!=="http"&&m!=="https")return p.apply(this,arguments);const c=S[m],g=T.findSubstr(P.URI.file(v.filename));let n=k.get(g);if(n||k.set(g,n={}),!n[m]){const u=c.default;n[m]={...u}}return n[m]}})}}),define(De[296],Ie([1,0,71,294,281,295,40,269,2,12,7,266,109,268]),function(J,e,l,t,C,P,_,I,w,k,L,D,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class E extends C.RequireInterceptor{_installInterceptor(){const m=this,v=J.__$__nodeRequire("module"),h=v._load;v._load=function(u,s,i){return u=g(u),m._factories.has(u)?m._factories.get(u).load(u,w.URI.file((0,S.realpathSync)(s.filename)),o=>h.apply(this,[o,s,i])):h.apply(this,arguments)};const c=v._resolveLookupPaths;v._resolveLookupPaths=(n,u)=>c.call(this,g(n),u);const g=n=>{for(const u of m._alternatives){const s=u(n);if(s){n=s;break}}return n}}}class p extends _.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=L.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(T.ExtHostConsoleForwarder);const m=this._instaService.invokeFunction(t.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(I.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const c=this._instaService.createInstance(D.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=c.ipcHandlePath}await this._instaService.createInstance(E,m,{mine:this._myRegistry,all:this._globalRegistry}).install(),l.mark("code/extHost/didInitAPI");const h=await this._extHostConfiguration.getConfigProvider();await(0,P.connectProxyResolver)(this._extHostWorkspace,h,this,this._logService,this._mainThreadTelemetryProxy,this._initData),l.mark("code/extHost/didInitProxyResolver")}_getEntryPoint(m){return m.main}async _loadCommonJSModule(m,v,h){if(v.scheme!==k.Schemas.file)throw new Error(`Cannot load URI: '${v}', must be of file-scheme`);let c=null;h.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${v.toString(!0)}`),this._logService.flush();const g=m?.identifier.value;m&&await this._extHostLocalizationService.initializeLocalizedMessages(m);try{g&&l.mark(`code/extHost/willLoadExtensionCode/${g}`),c=J.__$__nodeRequire(v.fsPath)}finally{g&&l.mark(`code/extHost/didLoadExtensionCode/${g}`),h.codeLoadingStop()}return c}async $setRemoteEnvironment(m){if(!!this._initData.remote.isRemote)for(const v in m){const h=m[v];h===null?delete process.env[v]:process.env[v]=h}}}e.ExtHostExtensionService=p}),define(De[143],Ie([1,0,44,307,290,17,75,36,9,8,2,30,69,308,288,93]),function(J,e,l,t,C,P,_,I,w,k,L,D,S,T,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const b=E.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class m{constructor(f){this.outputChannel=f}provideTextSearchResults(f,y,R,N){return this.outputChannel.appendLine(`provideTextSearchResults ${f.pattern}, ${JSON.stringify({...y,folder:y.folder.toString()})}`),new Promise((M,A)=>{N.onCancellationRequested(()=>$());const z=u(f,y),H=y.folder.fsPath,F=z.map(he=>he.match(/^-/)?he:`'${he}'`).join(" ");this.outputChannel.appendLine(`${b} ${F}
 - cwd: ${H}`);let G=l.spawn(b,z,{cwd:H});G.on("error",he=>{console.error(he),this.outputChannel.appendLine("Error: "+(he&&he.message)),A((0,D.serializeSearchError)(new D.SearchError(he&&he.message,D.SearchErrorCode.rgProcessError)))});let B=!1;const U=new c(y.maxResults,H,y.previewOptions);U.on("result",he=>{B=!0,K="",R.report(he)});let x=!1;const $=()=>{x=!0,G?.kill(),U?.cancel()};let Q=!1;U.on("hitLimit",()=>{Q=!0,$()});let K="";G.stdout.on("data",he=>{U.handleData(he),B||(K+=he)});let de=!1;G.stdout.once("data",()=>de=!0);let te="";G.stderr.on("data",he=>{const Y=he.toString();this.outputChannel.appendLine(Y),te.length+Y.length<1e6&&(te+=Y)}),G.on("close",()=>{if(this.outputChannel.appendLine(de?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(B?"Got result from parser":"No result from parser"),K&&this.outputChannel.appendLine(`Got data without result: ${K}`),this.outputChannel.appendLine(""),x)M({limitHit:Q});else{U.flush(),G=null;let he;te&&!de&&(he=v(te))?A((0,D.serializeSearchError)(new D.SearchError(he.message,he.code))):M({limitHit:Q})}})})}}e.RipgrepTextSearchEngine=m;function v(a){const f=a.split(`
`),y=f[0].trim();if(f.some(N=>N.startsWith("regex parse error")))return new D.SearchError(h(f),D.SearchErrorCode.regexParseError);const R=y.match(/grep config error: unknown encoding: (.*)/);if(R)return new D.SearchError(`Unknown encoding: ${R[1]}`,D.SearchErrorCode.unknownEncoding);if(y.startsWith("error parsing glob"))return new D.SearchError(y.charAt(0).toUpperCase()+y.substr(1),D.SearchErrorCode.globParseError);if(y.startsWith("the literal"))return new D.SearchError(y.charAt(0).toUpperCase()+y.substr(1),D.SearchErrorCode.invalidLiteral);if(y.startsWith("PCRE2: error compiling pattern"))return new D.SearchError(y,D.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=v;function h(a){const f=["Regex parse error"],y=a.filter(R=>R.startsWith("PCRE2:"));if(y.length>=1){const R=y[0].replace("PCRE2:","");if(R.indexOf(":")!==-1&&R.split(":").length>=2){const N=R.split(":")[1];f.push(":"+N)}}return f.join("")}e.buildRegexParseError=h;class c extends t.EventEmitter{constructor(f,y,R){super(),this.maxResults=f,this.rootFolder=y,this.previewOptions=R,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new C.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(f,y){return super.on(f,y),this}handleData(f){if(this.isDone)return;const y=typeof f=="string"?f:this.stringDecoder.write(f);this.handleDecodedData(y)}handleDecodedData(f){let y=f.indexOf(`
`);const R=this.remainder+f;if(y>=0)y+=this.remainder.length;else{this.remainder=R;return}let N=0;for(;y>=0;)this.handleLine(R.substring(N,y).trim()),N=y+1,y=R.indexOf(`
`,N);this.remainder=R.substring(N)}handleLine(f){if(this.isDone||!f)return;let y;try{y=JSON.parse(f)}catch{throw new Error(`malformed line from rg: ${f}`)}if(y.type==="match"){const R=g(y.data.path),N=L.URI.file(w.join(this.rootFolder,R)),M=this.createTextSearchMatch(y.data,N);this.onResult(M),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(y.type==="context"){const R=g(y.data.path),N=L.URI.file(w.join(this.rootFolder,R));this.createTextSearchContext(y.data,N).forEach(A=>this.onResult(A))}}createTextSearchMatch(f,y){const R=f.line_number-1,N=g(f.lines),M=Buffer.from(N);let A=0,z=0,H=R;f.submatches.length===0&&f.submatches.push(N.length?{start:0,end:1,match:{text:N[0]}}:{start:0,end:0,match:{text:""}});const F=(0,P.coalesce)(f.submatches.map((G,B)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const U=g(G.match),x=M.slice(A,G.start).toString(),$=n(x),Q=$.numLines>0?$.lastLineLength:$.lastLineLength+z,K=n(U),de=$.numLines+H,te=K.numLines+de,he=K.numLines>0?K.lastLineLength:K.lastLineLength+Q;return A=G.end,z=he,H=te,new S.Range(de,Q,te,he)}));return(0,p.createTextSearchResult)(y,N,F,this.previewOptions)}createTextSearchContext(f,y){const R=g(f.lines),N=f.line_number;return R.replace(/\r?\n$/,"").split(`
`).map((M,A)=>({text:M,uri:y,lineNumber:N+A}))}onResult(f){this.emit("result",f)}}e.RipgrepParser=c;function g(a){return a.bytes?Buffer.from(a.bytes,"base64").toString():a.text}function n(a){const f=/\n/g;let y=0,R=-1,N;for(;N=f.exec(a);)y++,R=N.index;const M=R>=0?a.length-R-1:a.length;return{numLines:y,lastLineLength:M}}function u(a,f){const y=["--hidden"];y.push(a.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:R,otherIncludes:N}=(0,_.groupBy)(f.includes,A=>A.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(N&&N.length){const A=new Set;N.forEach(z=>{A.add(z)}),y.push("-g","!*"),A.forEach(z=>{s(z).map(p.anchorGlob).forEach(H=>{y.push("-g",H)})})}R&&R.length&&R.forEach(A=>{y.push("-g",A)}),f.excludes.map(p.anchorGlob).forEach(A=>y.push("-g",`!${A}`)),f.maxFileSize&&y.push("--max-filesize",f.maxFileSize+""),f.useIgnoreFiles?f.useParentIgnoreFiles||y.push("--no-ignore-parent"):y.push("--no-ignore"),f.followSymlinks&&y.push("--follow"),f.encoding&&f.encoding!=="utf8"&&y.push("--encoding",f.encoding),a.pattern==="--"&&(a.isRegExp=!0,a.pattern="\\-\\-"),a.isMultiline&&!a.isRegExp&&(a.pattern=(0,k.escapeRegExpCharacters)(a.pattern),a.isRegExp=!0),f.usePCRE2&&y.push("--pcre2"),y.push("--crlf"),a.isRegExp&&(a.pattern=i(a.pattern),y.push("--engine","auto"));let M;if(a.isWordMatch){const z=(0,k.createRegExp)(a.pattern,!!a.isRegExp,{wholeWord:a.isWordMatch}).source.replace(/\\\//g,"/");y.push("--regexp",z)}else if(a.isRegExp){let A=d(a.pattern);A=r(A),y.push("--regexp",A)}else M=a.pattern,y.push("--fixed-strings");return y.push("--no-config"),f.useGlobalIgnoreFiles||y.push("--no-ignore-global"),y.push("--json"),a.isMultiline&&y.push("--multiline"),f.beforeContext&&y.push("--before-context",f.beforeContext+""),f.afterContext&&y.push("--after-context",f.afterContext+""),y.push("--"),M&&y.push(M),y.push("."),y}function s(a){const f=(0,I.splitGlobAware)(a,"/");return f.map((y,R)=>f.slice(0,R+1).join("/"))}e.spreadGlobComponents=s;function i(a){const f=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;a.match(f);)a=a.replace(f,"$1\\x{$2}");const y=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;a.match(y);)a=a.replace(y,"$1\\x{$2}");return a}e.unicodeEscapesToPCRE2=i;const o=a=>a.type==="Assertion"&&a.kind==="lookbehind";function d(a){let f;try{f=new T.RegExpParser().parsePattern(a)}catch{return a}let y="",R=0;const N=(z,H,F)=>{y+=a.slice(R,z)+F,R=H},M=[];return new T.RegExpVisitor({onCharacterEnter(z){if(z.raw!=="\\n")return;const H=M[0];if(!H)N(z.start,z.end,"\\r?\\n");else if(!M.some(o))if(H.type==="CharacterClass")if(H.negate){const F=a.slice(H.start+2,z.start)+a.slice(z.end,H.end-1);H.parent?.type==="Quantifier"?N(H.start,H.end,F?`[^${F}]`:"."):N(H.start,H.end,"(?!\\r?\\n"+(F?`|[${F}]`:"")+")")}else{const F=a.slice(H.start+1,z.start)+a.slice(z.end,H.end-1);N(H.start,H.end,F===""?"\\r?\\n":`(?:[${F}]|\\r?\\n)`)}else H.type==="Quantifier"&&N(z.start,z.end,"(?:\\r?\\n)")},onQuantifierEnter(z){M.unshift(z)},onQuantifierLeave(){M.shift()},onCharacterClassRangeEnter(z){M.unshift(z)},onCharacterClassRangeLeave(){M.shift()},onCharacterClassEnter(z){M.unshift(z)},onCharacterClassLeave(){M.shift()},onAssertionEnter(z){o(z)&&M.push(z)},onAssertionLeave(z){M[0]===z&&M.shift()}}).visit(f),y+=a.slice(R),y}e.fixRegexNewline=d;function r(a){return a.replace(/\n/g,"\\r?\\n")}e.fixNewline=r}),define(De[297],Ie([1,0,21,143,120,12]),function(J,e,l,t,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class _{constructor(k){this.outputChannel=k,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(k,L,D,S){const T=new t.RipgrepTextSearchEngine(this.outputChannel);if(L.folder.scheme===P.Schemas.vscodeUserData){const E={...L,folder:L.folder.with({scheme:P.Schemas.file})},p=new C.Progress(b=>D.report({...b,uri:b.uri.with({scheme:L.folder.scheme})}));return this.withToken(S,b=>T.provideTextSearchResults(k,E,p,b))}else return this.withToken(S,E=>T.provideTextSearchResults(k,L,D,E))}async withToken(k,L){const D=I(k);this.inProgress.add(D);const S=await L(D.token);return this.inProgress.delete(D),S}dispose(){this.inProgress.forEach(k=>k.cancel())}}e.RipgrepSearchProvider=_;function I(w){const k=new l.CancellationTokenSource;return w.onCancellationRequested(()=>k.cancel()),k}}),define(De[298],Ie([1,0,29,143,142]),function(J,e,l,t,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class P{constructor(w){this.query=w}search(w,k,L){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const D={appendLine(T){L({message:T})}},S=new C.NativeTextSearchManager(this.query,new t.RipgrepTextSearchEngine(D),l);return new Promise((T,E)=>S.search(p=>{k(p.map(_))},w).then(p=>T({limitHit:p.limitHit,type:"success",stats:p.stats}),E))}}e.TextSearchEngineAdapter=P;function _(I){return{path:I.resource&&I.resource.fsPath,results:I.results,numMatches:(I.results||[]).reduce((w,k)=>{if(k.ranges){const L=k;return w+(Array.isArray(L.ranges)?L.ranges.length:1)}else return w+1},0)}}}),define(De[299],Ie([1,0,17,18,10,4,105,9,51,2,37,30,289,298]),function(J,e,l,t,C,P,_,I,w,k,L,D,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class E{constructor(c="searchProcess"){this.processType=c,this.caches=Object.create(null)}fileSearch(c){let g;const n=m(c),u=new P.Emitter({onFirstListenerDidAdd:()=>{g=(0,t.createCancelablePromise)(s=>this.doFileSearchWithEngine(S.Engine,n,i=>u.fire(i),s)),g.then(s=>u.fire(s),s=>u.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onLastListenerRemove:()=>{g.cancel()}});return u.event}textSearch(c){let g;const n=m(c),u=new P.Emitter({onFirstListenerDidAdd:()=>{g=(0,t.createCancelablePromise)(s=>this.ripgrepTextSearch(n,i=>u.fire(i),s)),g.then(s=>u.fire(s),s=>u.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onLastListenerRemove:()=>{g.cancel()}});return u.event}ripgrepTextSearch(c,g,n){return c.maxFileSize=(0,L.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new T.TextSearchEngineAdapter(c).search(n,g,g)}doFileSearch(c,g,n){return this.doFileSearchWithEngine(S.Engine,c,g,n)}doFileSearchWithEngine(c,g,n,u,s=E.BATCH_SIZE){let i=0;const o=r=>{Array.isArray(r)?(i+=r.length,n(r.map(a=>this.rawMatchToSearchItem(a)))):r.relativePath?(i++,n(this.rawMatchToSearchItem(r))):n(r)};if(g.sortByScore){let r=this.trySortedSearchFromCache(g,o,u);if(!r){const a=g.maxResults?Object.assign({},g,{maxResults:null}):g,f=new c(a);r=this.doSortedSearch(f,g,n,o,u)}return new Promise((a,f)=>{r.then(([y,R])=>{const N=R.map(M=>this.rawMatchToSearchItem(M));this.sendProgress(N,n,s),a(y)},f)})}const d=new c(g);return this.doSearch(d,o,s,u).then(r=>({limitHit:r.limitHit,type:"success",stats:{detailStats:r.stats,type:this.processType,fromCache:!1,resultCount:i,sortingTime:void 0}}))}rawMatchToSearchItem(c){return{path:c.base?(0,I.join)(c.base,c.relativePath):c.relativePath}}doSortedSearch(c,g,n,u,s){const i=new P.Emitter;let o=(0,t.createCancelablePromise)(r=>{let a=[];const f=y=>{Array.isArray(y)?a=y:(u(y),i.fire(y))};return this.doSearch(c,f,-1,r).then(y=>[y,a])}),d;if(g.cacheKey){d=this.getOrCreateCache(g.cacheKey);const r={promise:o,event:i.event,resolved:!1};d.resultsToSearchCache[g.filePattern||""]=r,o.then(()=>{r.resolved=!0},a=>{delete d.resultsToSearchCache[g.filePattern||""]}),o=this.preventCancellation(o)}return o.then(([r,a])=>{const f=d?d.scorerCache:Object.create(null),y=(typeof g.maxResults!="number"||g.maxResults>0)&&w.StopWatch.create(!1);return this.sortResults(g,a,f,s).then(R=>{const N=y?y.elapsed():-1;return[{type:"success",stats:{detailStats:r.stats,sortingTime:N,fromCache:!1,type:this.processType,workspaceFolderCount:g.folderQueries.length,resultCount:R.length},messages:r.messages,limitHit:r.limitHit||typeof g.maxResults=="number"&&a.length>g.maxResults},R]})})}getOrCreateCache(c){const g=this.caches[c];return g||(this.caches[c]=new p)}trySortedSearchFromCache(c,g,n){const u=c.cacheKey&&this.caches[c.cacheKey];if(!u)return;const s=this.getResultsFromCache(u,c.filePattern||"",g,n);if(s)return s.then(([i,o,d])=>{const r=w.StopWatch.create(!1);return this.sortResults(c,o,u.scorerCache,n).then(a=>{const f=r.elapsed(),y={fromCache:!0,detailStats:d,type:this.processType,resultCount:o.length,sortingTime:f};return[{type:"success",limitHit:i.limitHit||typeof c.maxResults=="number"&&o.length>c.maxResults,stats:y},a]})})}sortResults(c,g,n,u){const s=(0,_.prepareQuery)(c.filePattern||""),i=(d,r)=>(0,_.compareItemsByFuzzyScore)(d,r,s,!0,b,n),o=typeof c.maxResults=="number"?c.maxResults:Number.MAX_VALUE;return l.topAsync(g,i,o,1e4,u)}sendProgress(c,g,n){if(n&&n>0)for(let u=0;u<c.length;u+=n)g(c.slice(u,u+n));else g(c)}getResultsFromCache(c,g,n,u){const s=w.StopWatch.create(!1),i=g.indexOf(I.sep)>=0;let o;for(const f in c.resultsToSearchCache)if(g.startsWith(f)){if(i&&f.indexOf(I.sep)<0&&f!=="")continue;const y=c.resultsToSearchCache[f];o={promise:this.preventCancellation(y.promise),event:y.event,resolved:y.resolved};break}if(!o)return null;const d=s.elapsed(),r=w.StopWatch.create(!1),a=o.event(n);return u&&u.onCancellationRequested(()=>{a.dispose()}),o.promise.then(([f,y])=>{if(u&&u.isCancellationRequested)throw(0,C.canceled)();const R=[],N=(0,_.prepareQuery)(g).normalizedLowercase;for(const M of y)!(0,D.isFilePatternMatch)(M,N)||R.push(M);return[f,R,{cacheWasResolved:o.resolved,cacheLookupTime:d,cacheFilterTime:r.elapsed(),cacheEntryCount:y.length}]})}doSearch(c,g,n,u){return new Promise((s,i)=>{let o=[];u?.onCancellationRequested(()=>c.cancel()),c.search(d=>{d&&(n?(o.push(d),n>0&&o.length>=n&&(g(o),o=[])):g(d))},d=>{g(d)},(d,r)=>{o.length&&g(o),d?i(d):s(r)})})}clearCache(c){return delete this.caches[c],Promise.resolve(void 0)}preventCancellation(c){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(g,n){return c.then(g,n)}catch(g){return this.then(void 0,g)}finally(g){return c.finally(g)}}}}e.SearchService=E,E.BATCH_SIZE=512;class p{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const b=new class{getItemLabel(h){return(0,I.basename)(h.relativePath)}getItemDescription(h){return(0,I.dirname)(h.relativePath)}getItemPath(h){return h.relativePath}};function m(h){return{...h,folderQueries:h.folderQueries&&h.folderQueries.map(v),extraFileResources:h.extraFileResources&&h.extraFileResources.map(c=>k.URI.revive(c))}}function v(h){return{...h,folder:k.URI.revive(h.folder)}}}),define(De[300],Ie([1,0,6,12,2,29,13,25,14,73,54,30,299,297,93,142]),function(J,e,l,t,C,P,_,I,w,k,L,D,S,T,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let b=class extends k.ExtHostSearch{constructor(v,h,c,g){super(v,c,g),this._pfs=P,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const n=new E.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(t.Schemas.vscodeUserData,new T.RipgrepSearchProvider(n)),h.remote.isRemote&&h.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const v=new E.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(t.Schemas.file,new T.RipgrepSearchProvider(v)),this.registerInternalFileSearchProvider(t.Schemas.file,new S.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(v,h){const c=this._handlePool++;return this._internalFileSearchProvider=h,this._internalFileSearchHandle=c,this._proxy.$registerFileSearchProvider(c,this._transformScheme(v)),(0,l.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(c)})}$provideFileSearchResults(v,h,c,g){const n=(0,k.reviveQuery)(c);return v===this._internalFileSearchHandle?this.doInternalFileSearch(v,h,n,g):super.$provideFileSearchResults(v,h,c,g)}doInternalFileSearch(v,h,c,g){const n=u=>{if((0,D.isSerializedFileMatch)(u)&&(u=[u]),Array.isArray(u)){this._proxy.$handleFileMatch(v,h,u.map(s=>C.URI.file(s.path)));return}u.message&&this._logService.debug("ExtHostSearch",u.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(c,n,g)}$clearCache(v){return this._internalFileSearchProvider?.clearCache(v),super.$clearCache(v)}createTextSearchManager(v,h){return new p.NativeTextSearchManager(v,h,void 0,"textSearchProvider")}};b=je([$e(0,w.IExtHostRpcService),$e(1,I.IExtHostInitDataService),$e(2,L.IURITransformerService),$e(3,_.ILogService)],b),e.NativeExtHostSearch=b}),define(De[301],Ie([1,0,82,272,284,283,300,296,273,72,40,73,70,39,53,67,271,270,13,285,47]),function(J,e,l,t,C,P,_,I,w,k,L,D,S,T,E,p,b,m,v,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,l.registerSingleton)(L.IExtHostExtensionService,I.ExtHostExtensionService,!1),(0,l.registerSingleton)(v.ILoggerService,m.ExtHostLoggerService,1),(0,l.registerSingleton)(p.IExtensionStoragePaths,b.ExtensionStoragePaths,!1),(0,l.registerSingleton)(k.IExtHostDebugService,P.ExtHostDebugService,!1),(0,l.registerSingleton)(D.IExtHostSearch,_.NativeExtHostSearch,!1),(0,l.registerSingleton)(S.IExtHostTask,C.ExtHostTask,!1),(0,l.registerSingleton)(T.IExtHostTerminalService,t.ExtHostTerminalService,!1),(0,l.registerSingleton)(E.IExtHostTunnelService,w.ExtHostTunnelService,!1),(0,l.registerSingleton)(c.IExtHostVariableResolverProvider,h.NodeExtHostVariableResolverProviderService,!1)}),define(De[309],Ie([1,0,213,310,71,10,112,113,196,131,282,23,29,109,18,115,208,222,286,301]),function(J,e,l,t,C,P,_,I,w,k,L,D,S,T,E,p,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let d=0;d<process.execArgv.length;d++)process.execArgv[d]==="--inspect-port=0"&&(process.execArgv.splice(d,1),d--)}();const v=t(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const o=J.__$__nodeRequire("module"),d=o._load;o._load=function(r){if(r==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return d.apply(this,arguments)}})();const h=process.exit.bind(process);function c(o){process.exit=function(d){if(o)h(d);else{const r=new Error("An extension called process.exit() and this was prevented.");console.warn(r.stack)}},process.crash=function(){const d=new Error("An extension called process.crash() and this was prevented.");console.warn(d.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let g=function(o){h()};function n(){const o=(0,m.readExtHostConnection)(process.env);if(o.type===3)return new Promise((d,r)=>{const a=f=>{const y=f[0],R=new _.BufferedEmitter;y.on("message",N=>R.fire(D.VSBuffer.wrap(N.data))),y.on("close",()=>{g("renderer closed the MessagePort")}),y.start(),d({onMessage:R.event,send:N=>y.postMessage(N.buffer)})};if(global.vscodePorts){const f=global.vscodePorts;delete global.vscodePorts,a(f)}else global.vscodePortsCallback=a});if(o.type===2)return new Promise((d,r)=>{let a=null;const f=setTimeout(()=>{g("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),y=108e5,R=3e5,N=new E.ProcessTimeRunOnceScheduler(()=>g("renderer disconnected for too long (1)"),y),M=new E.ProcessTimeRunOnceScheduler(()=>g("renderer disconnected for too long (2)"),R);process.on("message",(z,H)=>{if(z&&z.type==="VSCODE_EXTHOST_IPC_SOCKET"){H.setNoDelay(!0);const F=D.VSBuffer.wrap(Buffer.from(z.initialDataChunk,"base64"));let G;if(z.skipWebSocketFrames)G=new I.NodeSocket(H,"extHost-socket");else{const B=D.VSBuffer.wrap(Buffer.from(z.inflateBytes,"base64"));G=new I.WebSocketNodeSocket(new I.NodeSocket(H,"extHost-socket"),z.permessageDeflate,B,!1)}a?(N.cancel(),M.cancel(),a.beginAcceptReconnection(G,F),a.endAcceptReconnection(),a.sendResume()):(clearTimeout(f),a=new _.PersistentProtocol(G,F),a.sendResume(),a.onDidDispose(()=>g("renderer disconnected")),d(a),a.onSocketClose(()=>{N.schedule()}))}if(z&&z.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(M.isScheduled())return;N.isScheduled()&&M.schedule()}});const A={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(A)});{const d=o.pipeName;return new Promise((r,a)=>{const f=l.createConnection(d,()=>{f.removeListener("error",a);const y=new _.PersistentProtocol(new I.NodeSocket(f,"extHost-renderer"));y.sendResume(),r(y)});f.once("error",a),f.on("close",()=>{g("renderer closed the socket")})})}}async function u(){const o=await n();return new class{constructor(){this._onMessage=new _.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,o.onMessage(d=>{(0,k.isMessageOfType)(d,2)?(this._terminating=!0,g("received terminate message from renderer")):this._onMessage.fire(d)})}send(d){this._terminating||o.send(d)}async drain(){if(o.drain)return o.drain()}}}function s(o){return new Promise(d=>{const r=o.onMessage(a=>{r.dispose();const f=JSON.parse(a.toString()),y=f.commit,R=w.default.commit;if(y&&R&&y!==R&&h(55),f.parentPid){let N=0;setInterval(function(){try{process.kill(f.parentPid,0),N=0}catch(A){A&&A.code==="EPERM"?(N++,N>=3&&g(`parent process ${f.parentPid} does not exist anymore (3 x EPERM): ${A.message} (code: ${A.code}) (errno: ${A.errno})`)):g(`parent process ${f.parentPid} does not exist anymore: ${A.message} (code: ${A.code}) (errno: ${A.errno})`)}},1e3);let M;try{M=J.__$__nodeRequire("native-watchdog"),M.start(f.parentPid)}catch(A){(0,P.onUnexpectedError)(A)}}o.send((0,k.createMessageOfType)(0)),d({protocol:o,initData:f})});o.send((0,k.createMessageOfType)(1))})}async function i(){const o=[];process.on("unhandledRejection",(N,M)=>{o.push(M),setTimeout(()=>{const A=o.indexOf(M);A>=0&&M.catch(z=>{o.splice(A,1),(0,P.isCancellationError)(z)||(console.warn(`rejected promise not handled within 1 second: ${z}`),z&&z.stack&&console.warn(`stack trace: ${z.stack}`),N&&(0,P.onUnexpectedError)(N))})},1e3)}),process.on("rejectionHandled",N=>{const M=o.indexOf(N);M>=0&&o.splice(M,1)}),process.on("uncaughtException",function(N){(0,P.onUnexpectedError)(N)}),C.mark("code/extHost/willConnectToRenderer");const d=await u();C.mark("code/extHost/didConnectToRenderer");const r=await s(d);C.mark("code/extHost/didWaitForInitData");const{initData:a}=r;c(!!a.environment.extensionTestsLocationURI),a.environment.useHostProxy=v.useHostProxy!==void 0?v.useHostProxy!=="false":void 0,a.environment.skipWorkspaceStorageLock=(0,p.boolean)(v.skipWorkspaceStorageLock,!1);const f=new class{constructor(){this.pid=process.pid}exit(M){h(M)}exists(M){return S.Promises.exists(M)}realpath(M){return(0,T.realpath)(M)}};let y=null;a.remote.authority&&v.transformURIs&&(y=(0,b.createURITransformer)(a.remote.authority));const R=new L.ExtensionHostMain(r.protocol,a,f,y);g=N=>R.terminate(N)}e.startExtensionHostProcess=i,i().catch(o=>console.log(o))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/fad3a77833b9249158dfd88477114a06435e46a2/core/vs/workbench/api/node/extensionHostProcess.js.map
