/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ce=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/errors","vs/base/common/network","vs/platform/log/common/log","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/arrays","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/resources","vs/base/common/buffer","vs/base/common/map","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/platform/contextkey/common/contextkey","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/assert","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configuration","vs/platform/instantiation/common/serviceCollection","vs/base/common/process","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/common/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/idGenerator","vs/base/common/mime","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostTelemetryLogService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/codicons","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/lazy","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/base/common/hash","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/base/common/linkedList","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Ie=function(ie){for(var e=[],r=0,C=ie.length;r<C;r++)e[r]=Ce[ie[r]];return e};define(Ce[73],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function r(_,A){const E=Object.create(null);for(const P of _){const O=A(P);let w=E[O];w||(w=E[O]=[]),w.push(P)}return E}e.groupBy=r;function C(_,A){const E=[],P=[];for(const O of _)A.has(O)||E.push(O);for(const O of A)_.has(O)||P.push(O);return{removed:E,added:P}}e.diffSets=C;function S(_,A){const E=[],P=[];for(const[O,w]of _)A.has(O)||E.push(w);for(const[O,w]of A)_.has(O)||P.push(w);return{removed:E,added:P}}e.diffMaps=S;class N{constructor(){this.map=new Map}add(A,E){let P=this.map.get(A);P||(P=new Set,this.map.set(A,P)),P.add(E)}delete(A,E){const P=this.map.get(A);!P||(P.delete(E),P.size===0&&this.map.delete(A))}forEach(A,E){const P=this.map.get(A);!P||P.forEach(E)}}e.SetMap=N}),define(Ce[55],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function r(_){return(A,E,P)=>{let O=null,w=null;if(typeof P.value=="function"?(O="value",w=P.value):typeof P.get=="function"&&(O="get",w=P.get),!w)throw new Error("not supported");P[O]=_(w,E)}}e.createDecorator=r;function C(_,A,E){let P=null,O=null;if(typeof E.value=="function"?(P="value",O=E.value,O.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(P="get",O=E.get),!O)throw new Error("not supported");const w=`$memoize$${A}`;E[P]=function(...g){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:O.apply(this,g)}),this[w]}}e.memoize=C;function S(_,A,E){return r((P,O)=>{const w=`$debounce$${O}`,g=`$debounce$result$${O}`;return function(...k){this[g]||(this[g]=E?E():void 0),clearTimeout(this[w]),A&&(this[g]=A(this[g],...k),k=[this[g]]),this[w]=setTimeout(()=>{P.apply(this,k),this[g]=E?E():void 0},_)}})}e.debounce=S;function N(_,A,E){return r((P,O)=>{const w=`$throttle$timer$${O}`,g=`$throttle$result$${O}`,k=`$throttle$lastRun$${O}`,m=`$throttle$pending$${O}`;return function(...a){if(this[g]||(this[g]=E?E():void 0),(this[k]===null||this[k]===void 0)&&(this[k]=-Number.MAX_VALUE),A&&(this[g]=A(this[g],...a)),this[m])return;const u=this[k]+_;u<=Date.now()?(this[k]=Date.now(),P.apply(this,[this[g]]),this[g]=E?E():void 0):(this[m]=!0,this[w]=setTimeout(()=>{this[m]=!1,this[k]=Date.now(),P.apply(this,[this[g]]),this[g]=E?E():void 0},u-Date.now()))}})}e.throttle=N}),define(Ce[74],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class r{constructor(S){this._prefix=S,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=r,e.defaultGenerator=new r("id#")}),define(Ce[106],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var r;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(r=e.ScanError||(e.ScanError={}));var C;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(C=e.SyntaxKind||(e.SyntaxKind={}));var S;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(S=e.ParseErrorCode||(e.ParseErrorCode={}));var N;(function(t){t.DEFAULT={allowTrailingComma:!0}})(N=e.ParseOptions||(e.ParseOptions={}));function _(t,l=!1){let i=0;const n=t.length;let o="",f=0,s=16,h=0;function p(L){let R=0,K=0;for(;R<L;){const W=t.charCodeAt(i);if(W>=48&&W<=57)K=K*16+W-48;else if(W>=65&&W<=70)K=K*16+W-65+10;else if(W>=97&&W<=102)K=K*16+W-97+10;else break;i++,R++}return R<L&&(K=-1),K}function T(L){i=L,o="",f=0,s=16,h=0}function M(){const L=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&P(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&P(t.charCodeAt(i)))for(i++;i<t.length&&P(t.charCodeAt(i));)i++;else return h=3,t.substring(L,i);let R=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&P(t.charCodeAt(i))){for(i++;i<t.length&&P(t.charCodeAt(i));)i++;R=i}else h=3;return t.substring(L,R)}function V(){let L="",R=i;for(;;){if(i>=n){L+=t.substring(R,i),h=2;break}const K=t.charCodeAt(i);if(K===34){L+=t.substring(R,i),i++;break}if(K===92){if(L+=t.substring(R,i),i++,i>=n){h=2;break}switch(t.charCodeAt(i++)){case 34:L+='"';break;case 92:L+="\\";break;case 47:L+="/";break;case 98:L+="\b";break;case 102:L+="\f";break;case 110:L+=`
`;break;case 114:L+="\r";break;case 116:L+="	";break;case 117:{const $=p(4);$>=0?L+=String.fromCharCode($):h=4;break}default:h=5}R=i;continue}if(K>=0&&K<=31)if(E(K)){L+=t.substring(R,i),h=2;break}else h=6;i++}return L}function U(){if(o="",h=0,f=i,i>=n)return f=n,s=17;let L=t.charCodeAt(i);if(A(L)){do i++,o+=String.fromCharCode(L),L=t.charCodeAt(i);while(A(L));return s=15}if(E(L))return i++,o+=String.fromCharCode(L),L===13&&t.charCodeAt(i)===10&&(i++,o+=`
`),s=14;switch(L){case 123:return i++,s=1;case 125:return i++,s=2;case 91:return i++,s=3;case 93:return i++,s=4;case 58:return i++,s=6;case 44:return i++,s=5;case 34:return i++,o=V(),s=10;case 47:{const R=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<n&&!E(t.charCodeAt(i));)i++;return o=t.substring(R,i),s=12}if(t.charCodeAt(i+1)===42){i+=2;const K=n-1;let W=!1;for(;i<K;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,W=!0;break}i++}return W||(i++,h=1),o=t.substring(R,i),s=13}return o+=String.fromCharCode(L),i++,s=16}case 45:if(o+=String.fromCharCode(L),i++,i===n||!P(t.charCodeAt(i)))return s=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=M(),s=11;default:for(;i<n&&y(L);)i++,L=t.charCodeAt(i);if(f!==i){switch(o=t.substring(f,i),o){case"true":return s=8;case"false":return s=9;case"null":return s=7}return s=16}return o+=String.fromCharCode(L),i++,s=16}}function y(L){if(A(L)||E(L))return!1;switch(L){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function x(){let L;do L=U();while(L>=12&&L<=15);return L}return{setPosition:T,getPosition:()=>i,scan:l?x:U,getToken:()=>s,getTokenValue:()=>o,getTokenOffset:()=>f,getTokenLength:()=>i-f,getTokenError:()=>h}}e.createScanner=_;function A(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function E(t){return t===10||t===13||t===8232||t===8233}function P(t){return t>=48&&t<=57}var O;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(O||(O={}));function w(t,l){const i=[],n=new Object;let o;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let s=!1;function h(p,T,M,V){f.value=p,f.offset=T,f.length=M,f.type=V,f.colonOffset=void 0,o=f}try{D(t,{onObjectBegin:(p,T)=>{if(l<=p)throw n;o=void 0,s=l>p,i.push("")},onObjectProperty:(p,T,M)=>{if(l<T||(h(p,T,M,"property"),i[i.length-1]=p,l<=T+M))throw n},onObjectEnd:(p,T)=>{if(l<=p)throw n;o=void 0,i.pop()},onArrayBegin:(p,T)=>{if(l<=p)throw n;o=void 0,i.push(0)},onArrayEnd:(p,T)=>{if(l<=p)throw n;o=void 0,i.pop()},onLiteralValue:(p,T,M)=>{if(l<T||(h(p,T,M,b(p)),l<=T+M))throw n},onSeparator:(p,T,M)=>{if(l<=T)throw n;if(p===":"&&o&&o.type==="property")o.colonOffset=T,s=!1,o=void 0;else if(p===","){const V=i[i.length-1];typeof V=="number"?i[i.length-1]=V+1:(s=!0,i[i.length-1]=""),o=void 0}}})}catch(p){if(p!==n)throw p}return{path:i,previousNode:o,isAtPropertyKey:s,matches:p=>{let T=0;for(let M=0;T<p.length&&M<i.length;M++)if(p[T]===i[M]||p[T]==="*")T++;else if(p[T]!=="**")return!1;return T===p.length}}}e.getLocation=w;function g(t,l=[],i=N.DEFAULT){let n=null,o=[];const f=[];function s(p){Array.isArray(o)?o.push(p):n!==null&&(o[n]=p)}return D(t,{onObjectBegin:()=>{const p={};s(p),f.push(o),o=p,n=null},onObjectProperty:p=>{n=p},onObjectEnd:()=>{o=f.pop()},onArrayBegin:()=>{const p=[];s(p),f.push(o),o=p,n=null},onArrayEnd:()=>{o=f.pop()},onLiteralValue:s,onError:(p,T,M)=>{l.push({error:p,offset:T,length:M})}},i),o[0]}e.parse=g;function k(t,l=[],i=N.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(p){n.type==="property"&&(n.length=p-n.offset,n=n.parent)}function f(p){return n.children.push(p),p}D(t,{onObjectBegin:p=>{n=f({type:"object",offset:p,length:-1,parent:n,children:[]})},onObjectProperty:(p,T,M)=>{n=f({type:"property",offset:T,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:p,offset:T,length:M,parent:n})},onObjectEnd:(p,T)=>{n.length=p+T-n.offset,n=n.parent,o(p+T)},onArrayBegin:(p,T)=>{n=f({type:"array",offset:p,length:-1,parent:n,children:[]})},onArrayEnd:(p,T)=>{n.length=p+T-n.offset,n=n.parent,o(p+T)},onLiteralValue:(p,T,M)=>{f({type:b(p),offset:T,length:M,parent:n,value:p}),o(T+M)},onSeparator:(p,T,M)=>{n.type==="property"&&(p===":"?n.colonOffset=T:p===","&&o(T))},onError:(p,T,M)=>{l.push({error:p,offset:T,length:M})}},i);const h=n.children[0];return h&&delete h.parent,h}e.parseTree=k;function m(t,l){if(!t)return;let i=t;for(const n of l)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let o=!1;for(const f of i.children)if(Array.isArray(f.children)&&f.children[0].value===n){i=f.children[1],o=!0;break}if(!o)return}else{const o=n;if(i.type!=="array"||o<0||!Array.isArray(i.children)||o>=i.children.length)return;i=i.children[o]}return i}e.findNodeAtLocation=m;function a(t){if(!t.parent||!t.parent.children)return[];const l=a(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;l.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&l.push(i)}return l}e.getNodePath=a;function u(t){switch(t.type){case"array":return t.children.map(u);case"object":{const l=Object.create(null);for(const i of t.children){const n=i.children[1];n&&(l[i.children[0].value]=u(n))}return l}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=u;function d(t,l,i=!1){return l>=t.offset&&l<t.offset+t.length||i&&l===t.offset+t.length}e.contains=d;function v(t,l,i=!1){if(d(t,l,i)){const n=t.children;if(Array.isArray(n))for(let o=0;o<n.length&&n[o].offset<=l;o++){const f=v(n[o],l,i);if(f)return f}return t}}e.findNodeAtOffset=v;function D(t,l,i=N.DEFAULT){const n=_(t,!1);function o(ce){return ce?()=>ce(n.getTokenOffset(),n.getTokenLength()):()=>!0}function f(ce){return ce?me=>ce(me,n.getTokenOffset(),n.getTokenLength()):()=>!0}const s=o(l.onObjectBegin),h=f(l.onObjectProperty),p=o(l.onObjectEnd),T=o(l.onArrayBegin),M=o(l.onArrayEnd),V=f(l.onLiteralValue),U=f(l.onSeparator),y=o(l.onComment),x=f(l.onError),L=i&&i.disallowComments,R=i&&i.allowTrailingComma;function K(){for(;;){const ce=n.scan();switch(n.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:L||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(ce){case 12:case 13:L?W(10):y();break;case 16:W(1);break;case 15:case 14:break;default:return ce}}}function W(ce,me=[],ee=[]){if(x(ce),me.length+ee.length>0){let be=n.getToken();for(;be!==17;){if(me.indexOf(be)!==-1){K();break}else if(ee.indexOf(be)!==-1)break;be=K()}}}function $(ce){const me=n.getTokenValue();return ce?V(me):h(me),K(),!0}function G(){switch(n.getToken()){case 11:{let ce=0;try{ce=JSON.parse(n.getTokenValue()),typeof ce!="number"&&(W(2),ce=0)}catch{W(2)}V(ce);break}case 7:V(null);break;case 8:V(!0);break;case 9:V(!1);break;default:return!1}return K(),!0}function re(){return n.getToken()!==10?(W(3,[],[2,5]),!1):($(!1),n.getToken()===6?(U(":"),K(),Ee()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function ge(){s(),K();let ce=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(ce||W(4,[],[]),U(","),K(),n.getToken()===2&&R)break}else ce&&W(6,[],[]);re()||W(4,[],[2,5]),ce=!0}return p(),n.getToken()!==2?W(7,[2],[]):K(),!0}function oe(){T(),K();let ce=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(ce||W(4,[],[]),U(","),K(),n.getToken()===4&&R)break}else ce&&W(6,[],[]);Ee()||W(4,[],[4,5]),ce=!0}return M(),n.getToken()!==4?W(8,[4],[]):K(),!0}function Ee(){switch(n.getToken()){case 3:return oe();case 1:return ge();case 10:return $(!0);default:return G()}}return K(),n.getToken()===17?i.allowEmptyContent?!0:(W(4,[],[]),!1):Ee()?(n.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.visit=D;function c(t,l){const i=_(t),n=[];let o,f=0,s;do switch(s=i.getPosition(),o=i.scan(),o){case 12:case 13:case 17:f!==s&&n.push(t.substring(f,s)),l!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,l)),f=i.getPosition();break}while(o!==17);return n.join("")}e.stripComments=c;function b(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=b}),function(ie,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Ce[107],Ie([0]),e):(ie=typeof globalThis<"u"?globalThis:ie||self,e(ie.marked={}))}(this,function(ie){"use strict";function e(ke,ye){for(var De=0;De<ye.length;De++){var ae=ye[De];ae.enumerable=ae.enumerable||!1,ae.configurable=!0,"value"in ae&&(ae.writable=!0),Object.defineProperty(ke,ae.key,ae)}}function r(ke,ye,De){return ye&&e(ke.prototype,ye),De&&e(ke,De),Object.defineProperty(ke,"prototype",{writable:!1}),ke}function C(ke,ye){if(!!ke){if(typeof ke=="string")return S(ke,ye);var De=Object.prototype.toString.call(ke).slice(8,-1);if(De==="Object"&&ke.constructor&&(De=ke.constructor.name),De==="Map"||De==="Set")return Array.from(ke);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return S(ke,ye)}}function S(ke,ye){(ye==null||ye>ke.length)&&(ye=ke.length);for(var De=0,ae=new Array(ye);De<ye;De++)ae[De]=ke[De];return ae}function N(ke,ye){var De=typeof Symbol<"u"&&ke[Symbol.iterator]||ke["@@iterator"];if(De)return(De=De.call(ke)).next.bind(De);if(Array.isArray(ke)||(De=C(ke))||ye&&ke&&typeof ke.length=="number"){De&&(ke=De);var ae=0;return function(){return ae>=ke.length?{done:!0}:{done:!1,value:ke[ae++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function _(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ie.defaults=_();function A(ke){ie.defaults=ke}var E=/[&<>"']/,P=/[&<>"']/g,O=/[<>"']|&(?!#?\w+;)/,w=/[<>"']|&(?!#?\w+;)/g,g={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},k=function(ye){return g[ye]};function m(ke,ye){if(ye){if(E.test(ke))return ke.replace(P,k)}else if(O.test(ke))return ke.replace(w,k);return ke}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function u(ke){return ke.replace(a,function(ye,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var d=/(^|[^\[])\^/g;function v(ke,ye){ke=typeof ke=="string"?ke:ke.source,ye=ye||"";var De={replace:function(ue,Z){return Z=Z.source||Z,Z=Z.replace(d,"$1"),ke=ke.replace(ue,Z),De},getRegex:function(){return new RegExp(ke,ye)}};return De}var D=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function b(ke,ye,De){if(ke){var ae;try{ae=decodeURIComponent(u(De)).replace(D,"").toLowerCase()}catch{return null}if(ae.indexOf("javascript:")===0||ae.indexOf("vbscript:")===0||ae.indexOf("data:")===0)return null}ye&&!c.test(De)&&(De=o(ye,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch{return null}return De}var t={},l=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,n=/^([^:]+:\/*[^/]*)[\s\S]*$/;function o(ke,ye){t[" "+ke]||(l.test(ke)?t[" "+ke]=ke+"/":t[" "+ke]=p(ke,"/",!0)),ke=t[" "+ke];var De=ke.indexOf(":")===-1;return ye.substring(0,2)==="//"?De?ye:ke.replace(i,"$1")+ye:ye.charAt(0)==="/"?De?ye:ke.replace(n,"$1")+ye:ke+ye}var f={exec:function(){}};function s(ke){for(var ye=1,De,ae;ye<arguments.length;ye++){De=arguments[ye];for(ae in De)Object.prototype.hasOwnProperty.call(De,ae)&&(ke[ae]=De[ae])}return ke}function h(ke,ye){var De=ke.replace(/\|/g,function(Z,J,I){for(var B=!1,H=J;--H>=0&&I[H]==="\\";)B=!B;return B?"|":" |"}),ae=De.split(/ \|/),ue=0;if(ae[0].trim()||ae.shift(),ae.length>0&&!ae[ae.length-1].trim()&&ae.pop(),ae.length>ye)ae.splice(ye);else for(;ae.length<ye;)ae.push("");for(;ue<ae.length;ue++)ae[ue]=ae[ue].trim().replace(/\\\|/g,"|");return ae}function p(ke,ye,De){var ae=ke.length;if(ae===0)return"";for(var ue=0;ue<ae;){var Z=ke.charAt(ae-ue-1);if(Z===ye&&!De)ue++;else if(Z!==ye&&De)ue++;else break}return ke.slice(0,ae-ue)}function T(ke,ye){if(ke.indexOf(ye[1])===-1)return-1;for(var De=ke.length,ae=0,ue=0;ue<De;ue++)if(ke[ue]==="\\")ue++;else if(ke[ue]===ye[0])ae++;else if(ke[ue]===ye[1]&&(ae--,ae<0))return ue;return-1}function M(ke){ke&&ke.sanitize&&!ke.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function V(ke,ye){if(ye<1)return"";for(var De="";ye>1;)ye&1&&(De+=ke),ye>>=1,ke+=ke;return De+ke}function U(ke,ye,De,ae){var ue=ye.href,Z=ye.title?m(ye.title):null,J=ke[1].replace(/\\([\[\]])/g,"$1");if(ke[0].charAt(0)!=="!"){ae.state.inLink=!0;var I={type:"link",raw:De,href:ue,title:Z,text:J,tokens:ae.inlineTokens(J)};return ae.state.inLink=!1,I}return{type:"image",raw:De,href:ue,title:Z,text:m(J)}}function y(ke,ye){var De=ke.match(/^(\s+)(?:```)/);if(De===null)return ye;var ae=De[1];return ye.split(`
`).map(function(ue){var Z=ue.match(/^\s+/);if(Z===null)return ue;var J=Z[0];return J.length>=ae.length?ue.slice(ae.length):ue}).join(`
`)}var x=function(){function ke(De){this.options=De||ie.defaults}var ye=ke.prototype;return ye.space=function(ae){var ue=this.rules.block.newline.exec(ae);if(ue&&ue[0].length>0)return{type:"space",raw:ue[0]}},ye.code=function(ae){var ue=this.rules.block.code.exec(ae);if(ue){var Z=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?Z:p(Z,`
`)}}},ye.fences=function(ae){var ue=this.rules.block.fences.exec(ae);if(ue){var Z=ue[0],J=y(Z,ue[3]||"");return{type:"code",raw:Z,lang:ue[2]?ue[2].trim():ue[2],text:J}}},ye.heading=function(ae){var ue=this.rules.block.heading.exec(ae);if(ue){var Z=ue[2].trim();if(/#$/.test(Z)){var J=p(Z,"#");(this.options.pedantic||!J||/ $/.test(J))&&(Z=J.trim())}return{type:"heading",raw:ue[0],depth:ue[1].length,text:Z,tokens:this.lexer.inline(Z)}}},ye.hr=function(ae){var ue=this.rules.block.hr.exec(ae);if(ue)return{type:"hr",raw:ue[0]}},ye.blockquote=function(ae){var ue=this.rules.block.blockquote.exec(ae);if(ue){var Z=ue[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(Z,[]),text:Z}}},ye.list=function(ae){var ue=this.rules.block.list.exec(ae);if(ue){var Z,J,I,B,H,j,se,le,Y,ve,pe,Ne,xe=ue[1].trim(),Ye=xe.length>1,Ge={type:"list",raw:"",ordered:Ye,start:Ye?+xe.slice(0,-1):"",loose:!1,items:[]};xe=Ye?"\\d{1,9}\\"+xe.slice(-1):"\\"+xe,this.options.pedantic&&(xe=Ye?xe:"[*+-]");for(var Te=new RegExp("^( {0,3}"+xe+")((?:[	 ][^\\n]*)?(?:\\n|$))");ae&&(Ne=!1,!(!(ue=Te.exec(ae))||this.rules.block.hr.test(ae)));){if(Z=ue[0],ae=ae.substring(Z.length),le=ue[2].split(`
`,1)[0],Y=ae.split(`
`,1)[0],this.options.pedantic?(B=2,pe=le.trimLeft()):(B=ue[2].search(/[^ ]/),B=B>4?1:B,pe=le.slice(B),B+=ue[1].length),j=!1,!le&&/^ *$/.test(Y)&&(Z+=Y+`
`,ae=ae.substring(Y.length+1),Ne=!0),!Ne)for(var rt=new RegExp("^ {0,"+Math.min(3,B-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),X=new RegExp("^ {0,"+Math.min(3,B-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Q=new RegExp("^ {0,"+Math.min(3,B-1)+"}(?:```|~~~)"),he=new RegExp("^ {0,"+Math.min(3,B-1)+"}#");ae&&(ve=ae.split(`
`,1)[0],le=ve,this.options.pedantic&&(le=le.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Q.test(le)||he.test(le)||rt.test(le)||X.test(ae)));){if(le.search(/[^ ]/)>=B||!le.trim())pe+=`
`+le.slice(B);else if(!j)pe+=`
`+le;else break;!j&&!le.trim()&&(j=!0),Z+=ve+`
`,ae=ae.substring(ve.length+1)}Ge.loose||(se?Ge.loose=!0:/\n *\n *$/.test(Z)&&(se=!0)),this.options.gfm&&(J=/^\[[ xX]\] /.exec(pe),J&&(I=J[0]!=="[ ] ",pe=pe.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:Z,task:!!J,checked:I,loose:!1,text:pe}),Ge.raw+=Z}Ge.items[Ge.items.length-1].raw=Z.trimRight(),Ge.items[Ge.items.length-1].text=pe.trimRight(),Ge.raw=Ge.raw.trimRight();var Ue=Ge.items.length;for(H=0;H<Ue;H++){this.lexer.state.top=!1,Ge.items[H].tokens=this.lexer.blockTokens(Ge.items[H].text,[]);var je=Ge.items[H].tokens.filter(function(Ke){return Ke.type==="space"}),Ze=je.every(function(Ke){for(var Ve=Ke.raw.split(""),it=0,st=N(Ve),dt;!(dt=st()).done;){var _t=dt.value;if(_t===`
`&&(it+=1),it>1)return!0}return!1});!Ge.loose&&je.length&&Ze&&(Ge.loose=!0,Ge.items[H].loose=!0)}return Ge}},ye.html=function(ae){var ue=this.rules.block.html.exec(ae);if(ue){var Z={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};if(this.options.sanitize){var J=this.options.sanitizer?this.options.sanitizer(ue[0]):m(ue[0]);Z.type="paragraph",Z.text=J,Z.tokens=this.lexer.inline(J)}return Z}},ye.def=function(ae){var ue=this.rules.block.def.exec(ae);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var Z=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:Z,raw:ue[0],href:ue[2],title:ue[3]}}},ye.table=function(ae){var ue=this.rules.block.table.exec(ae);if(ue){var Z={type:"table",header:h(ue[1]).map(function(se){return{text:se}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]&&ue[3].trim()?ue[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(Z.header.length===Z.align.length){Z.raw=ue[0];var J=Z.align.length,I,B,H,j;for(I=0;I<J;I++)/^ *-+: *$/.test(Z.align[I])?Z.align[I]="right":/^ *:-+: *$/.test(Z.align[I])?Z.align[I]="center":/^ *:-+ *$/.test(Z.align[I])?Z.align[I]="left":Z.align[I]=null;for(J=Z.rows.length,I=0;I<J;I++)Z.rows[I]=h(Z.rows[I],Z.header.length).map(function(se){return{text:se}});for(J=Z.header.length,B=0;B<J;B++)Z.header[B].tokens=this.lexer.inline(Z.header[B].text);for(J=Z.rows.length,B=0;B<J;B++)for(j=Z.rows[B],H=0;H<j.length;H++)j[H].tokens=this.lexer.inline(j[H].text);return Z}}},ye.lheading=function(ae){var ue=this.rules.block.lheading.exec(ae);if(ue)return{type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:this.lexer.inline(ue[1])}},ye.paragraph=function(ae){var ue=this.rules.block.paragraph.exec(ae);if(ue){var Z=ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1];return{type:"paragraph",raw:ue[0],text:Z,tokens:this.lexer.inline(Z)}}},ye.text=function(ae){var ue=this.rules.block.text.exec(ae);if(ue)return{type:"text",raw:ue[0],text:ue[0],tokens:this.lexer.inline(ue[0])}},ye.escape=function(ae){var ue=this.rules.inline.escape.exec(ae);if(ue)return{type:"escape",raw:ue[0],text:m(ue[1])}},ye.tag=function(ae){var ue=this.rules.inline.tag.exec(ae);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):m(ue[0]):ue[0]}},ye.link=function(ae){var ue=this.rules.inline.link.exec(ae);if(ue){var Z=ue[2].trim();if(!this.options.pedantic&&/^</.test(Z)){if(!/>$/.test(Z))return;var J=p(Z.slice(0,-1),"\\");if((Z.length-J.length)%2===0)return}else{var I=T(ue[2],"()");if(I>-1){var B=ue[0].indexOf("!")===0?5:4,H=B+ue[1].length+I;ue[2]=ue[2].substring(0,I),ue[0]=ue[0].substring(0,H).trim(),ue[3]=""}}var j=ue[2],se="";if(this.options.pedantic){var le=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(j);le&&(j=le[1],se=le[3])}else se=ue[3]?ue[3].slice(1,-1):"";return j=j.trim(),/^</.test(j)&&(this.options.pedantic&&!/>$/.test(Z)?j=j.slice(1):j=j.slice(1,-1)),U(ue,{href:j&&j.replace(this.rules.inline._escapes,"$1"),title:se&&se.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},ye.reflink=function(ae,ue){var Z;if((Z=this.rules.inline.reflink.exec(ae))||(Z=this.rules.inline.nolink.exec(ae))){var J=(Z[2]||Z[1]).replace(/\s+/g," ");if(J=ue[J.toLowerCase()],!J||!J.href){var I=Z[0].charAt(0);return{type:"text",raw:I,text:I}}return U(Z,J,Z[0],this.lexer)}},ye.emStrong=function(ae,ue,Z){Z===void 0&&(Z="");var J=this.rules.inline.emStrong.lDelim.exec(ae);if(!!J&&!(J[3]&&Z.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var I=J[1]||J[2]||"";if(!I||I&&(Z===""||this.rules.inline.punctuation.exec(Z))){var B=J[0].length-1,H,j,se=B,le=0,Y=J[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Y.lastIndex=0,ue=ue.slice(-1*ae.length+B);(J=Y.exec(ue))!=null;)if(H=J[1]||J[2]||J[3]||J[4]||J[5]||J[6],!!H){if(j=H.length,J[3]||J[4]){se+=j;continue}else if((J[5]||J[6])&&B%3&&!((B+j)%3)){le+=j;continue}if(se-=j,!(se>0)){if(j=Math.min(j,j+se+le),Math.min(B,j)%2){var ve=ae.slice(1,B+J.index+j);return{type:"em",raw:ae.slice(0,B+J.index+j+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}var pe=ae.slice(2,B+J.index+j-1);return{type:"strong",raw:ae.slice(0,B+J.index+j+1),text:pe,tokens:this.lexer.inlineTokens(pe)}}}}}},ye.codespan=function(ae){var ue=this.rules.inline.code.exec(ae);if(ue){var Z=ue[2].replace(/\n/g," "),J=/[^ ]/.test(Z),I=/^ /.test(Z)&&/ $/.test(Z);return J&&I&&(Z=Z.substring(1,Z.length-1)),Z=m(Z,!0),{type:"codespan",raw:ue[0],text:Z}}},ye.br=function(ae){var ue=this.rules.inline.br.exec(ae);if(ue)return{type:"br",raw:ue[0]}},ye.del=function(ae){var ue=this.rules.inline.del.exec(ae);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2])}},ye.autolink=function(ae,ue){var Z=this.rules.inline.autolink.exec(ae);if(Z){var J,I;return Z[2]==="@"?(J=m(this.options.mangle?ue(Z[1]):Z[1]),I="mailto:"+J):(J=m(Z[1]),I=J),{type:"link",raw:Z[0],text:J,href:I,tokens:[{type:"text",raw:J,text:J}]}}},ye.url=function(ae,ue){var Z;if(Z=this.rules.inline.url.exec(ae)){var J,I;if(Z[2]==="@")J=m(this.options.mangle?ue(Z[0]):Z[0]),I="mailto:"+J;else{var B;do B=Z[0],Z[0]=this.rules.inline._backpedal.exec(Z[0])[0];while(B!==Z[0]);J=m(Z[0]),Z[1]==="www."?I="http://"+J:I=J}return{type:"link",raw:Z[0],text:J,href:I,tokens:[{type:"text",raw:J,text:J}]}}},ye.inlineText=function(ae,ue){var Z=this.rules.inline.text.exec(ae);if(Z){var J;return this.lexer.state.inRawBlock?J=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Z[0]):m(Z[0]):Z[0]:J=m(this.options.smartypants?ue(Z[0]):Z[0]),{type:"text",raw:Z[0],text:J}}},ke}(),L={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:f,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};L._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,L._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,L.def=v(L.def).replace("label",L._label).replace("title",L._title).getRegex(),L.bullet=/(?:[*+-]|\d{1,9}[.)])/,L.listItemStart=v(/^( *)(bull) */).replace("bull",L.bullet).getRegex(),L.list=v(L.list).replace(/bull/g,L.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+L.def.source+")").getRegex(),L._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",L._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,L.html=v(L.html,"i").replace("comment",L._comment).replace("tag",L._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),L.paragraph=v(L._paragraph).replace("hr",L.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",L._tag).getRegex(),L.blockquote=v(L.blockquote).replace("paragraph",L.paragraph).getRegex(),L.normal=s({},L),L.gfm=s({},L.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),L.gfm.table=v(L.gfm.table).replace("hr",L.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",L._tag).getRegex(),L.gfm.paragraph=v(L._paragraph).replace("hr",L.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",L.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",L._tag).getRegex(),L.pedantic=s({},L.normal,{html:v(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",L._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:f,paragraph:v(L.normal._paragraph).replace("hr",L.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",L.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var R={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:f,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:f,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};R._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",R.punctuation=v(R.punctuation).replace(/punctuation/g,R._punctuation).getRegex(),R.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,R.escapedEmSt=/\\\*|\\_/g,R._comment=v(L._comment).replace("(?:-->|$)","-->").getRegex(),R.emStrong.lDelim=v(R.emStrong.lDelim).replace(/punct/g,R._punctuation).getRegex(),R.emStrong.rDelimAst=v(R.emStrong.rDelimAst,"g").replace(/punct/g,R._punctuation).getRegex(),R.emStrong.rDelimUnd=v(R.emStrong.rDelimUnd,"g").replace(/punct/g,R._punctuation).getRegex(),R._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,R._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,R._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,R.autolink=v(R.autolink).replace("scheme",R._scheme).replace("email",R._email).getRegex(),R._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,R.tag=v(R.tag).replace("comment",R._comment).replace("attribute",R._attribute).getRegex(),R._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,R._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,R._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,R.link=v(R.link).replace("label",R._label).replace("href",R._href).replace("title",R._title).getRegex(),R.reflink=v(R.reflink).replace("label",R._label).replace("ref",L._label).getRegex(),R.nolink=v(R.nolink).replace("ref",L._label).getRegex(),R.reflinkSearch=v(R.reflinkSearch,"g").replace("reflink",R.reflink).replace("nolink",R.nolink).getRegex(),R.normal=s({},R),R.pedantic=s({},R.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:v(/^!?\[(label)\]\((.*?)\)/).replace("label",R._label).getRegex(),reflink:v(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",R._label).getRegex()}),R.gfm=s({},R.normal,{escape:v(R.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),R.gfm.url=v(R.gfm.url,"i").replace("email",R.gfm._extended_email).getRegex(),R.breaks=s({},R.gfm,{br:v(R.br).replace("{2,}","*").getRegex(),text:v(R.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function K(ke){return ke.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function W(ke){var ye="",De,ae,ue=ke.length;for(De=0;De<ue;De++)ae=ke.charCodeAt(De),Math.random()>.5&&(ae="x"+ae.toString(16)),ye+="&#"+ae+";";return ye}var $=function(){function ke(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||ie.defaults,this.options.tokenizer=this.options.tokenizer||new x,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ae={block:L.normal,inline:R.normal};this.options.pedantic?(ae.block=L.pedantic,ae.inline=R.pedantic):this.options.gfm&&(ae.block=L.gfm,this.options.breaks?ae.inline=R.breaks:ae.inline=R.gfm),this.tokenizer.rules=ae}ke.lex=function(ae,ue){var Z=new ke(ue);return Z.lex(ae)},ke.lexInline=function(ae,ue){var Z=new ke(ue);return Z.inlineTokens(ae)};var ye=ke.prototype;return ye.lex=function(ae){ae=ae.replace(/\r\n|\r/g,`
`),this.blockTokens(ae,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},ye.blockTokens=function(ae,ue){var Z=this;ue===void 0&&(ue=[]),this.options.pedantic?ae=ae.replace(/\t/g,"    ").replace(/^ +$/gm,""):ae=ae.replace(/^( *)(\t+)/gm,function(se,le,Y){return le+"    ".repeat(Y.length)});for(var J,I,B,H;ae;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(se){return(J=se.call({lexer:Z},ae,ue))?(ae=ae.substring(J.raw.length),ue.push(J),!0):!1}))){if(J=this.tokenizer.space(ae)){ae=ae.substring(J.raw.length),J.raw.length===1&&ue.length>0?ue[ue.length-1].raw+=`
`:ue.push(J);continue}if(J=this.tokenizer.code(ae)){ae=ae.substring(J.raw.length),I=ue[ue.length-1],I&&(I.type==="paragraph"||I.type==="text")?(I.raw+=`
`+J.raw,I.text+=`
`+J.text,this.inlineQueue[this.inlineQueue.length-1].src=I.text):ue.push(J);continue}if(J=this.tokenizer.fences(ae)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.heading(ae)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.hr(ae)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.blockquote(ae)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.list(ae)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.html(ae)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.def(ae)){ae=ae.substring(J.raw.length),I=ue[ue.length-1],I&&(I.type==="paragraph"||I.type==="text")?(I.raw+=`
`+J.raw,I.text+=`
`+J.raw,this.inlineQueue[this.inlineQueue.length-1].src=I.text):this.tokens.links[J.tag]||(this.tokens.links[J.tag]={href:J.href,title:J.title});continue}if(J=this.tokenizer.table(ae)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.lheading(ae)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(B=ae,this.options.extensions&&this.options.extensions.startBlock&&function(){var se=1/0,le=ae.slice(1),Y=void 0;Z.options.extensions.startBlock.forEach(function(ve){Y=ve.call({lexer:this},le),typeof Y=="number"&&Y>=0&&(se=Math.min(se,Y))}),se<1/0&&se>=0&&(B=ae.substring(0,se+1))}(),this.state.top&&(J=this.tokenizer.paragraph(B))){I=ue[ue.length-1],H&&I.type==="paragraph"?(I.raw+=`
`+J.raw,I.text+=`
`+J.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=I.text):ue.push(J),H=B.length!==ae.length,ae=ae.substring(J.raw.length);continue}if(J=this.tokenizer.text(ae)){ae=ae.substring(J.raw.length),I=ue[ue.length-1],I&&I.type==="text"?(I.raw+=`
`+J.raw,I.text+=`
`+J.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=I.text):ue.push(J);continue}if(ae){var j="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(j);break}else throw new Error(j)}}return this.state.top=!0,ue},ye.inline=function(ae,ue){return ue===void 0&&(ue=[]),this.inlineQueue.push({src:ae,tokens:ue}),ue},ye.inlineTokens=function(ae,ue){var Z=this;ue===void 0&&(ue=[]);var J,I,B,H=ae,j,se,le;if(this.tokens.links){var Y=Object.keys(this.tokens.links);if(Y.length>0)for(;(j=this.tokenizer.rules.inline.reflinkSearch.exec(H))!=null;)Y.includes(j[0].slice(j[0].lastIndexOf("[")+1,-1))&&(H=H.slice(0,j.index)+"["+V("a",j[0].length-2)+"]"+H.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(j=this.tokenizer.rules.inline.blockSkip.exec(H))!=null;)H=H.slice(0,j.index)+"["+V("a",j[0].length-2)+"]"+H.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(j=this.tokenizer.rules.inline.escapedEmSt.exec(H))!=null;)H=H.slice(0,j.index)+"++"+H.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ae;)if(se||(le=""),se=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(pe){return(J=pe.call({lexer:Z},ae,ue))?(ae=ae.substring(J.raw.length),ue.push(J),!0):!1}))){if(J=this.tokenizer.escape(ae)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.tag(ae)){ae=ae.substring(J.raw.length),I=ue[ue.length-1],I&&J.type==="text"&&I.type==="text"?(I.raw+=J.raw,I.text+=J.text):ue.push(J);continue}if(J=this.tokenizer.link(ae)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.reflink(ae,this.tokens.links)){ae=ae.substring(J.raw.length),I=ue[ue.length-1],I&&J.type==="text"&&I.type==="text"?(I.raw+=J.raw,I.text+=J.text):ue.push(J);continue}if(J=this.tokenizer.emStrong(ae,H,le)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.codespan(ae)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.br(ae)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.del(ae)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.autolink(ae,W)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(!this.state.inLink&&(J=this.tokenizer.url(ae,W))){ae=ae.substring(J.raw.length),ue.push(J);continue}if(B=ae,this.options.extensions&&this.options.extensions.startInline&&function(){var pe=1/0,Ne=ae.slice(1),xe=void 0;Z.options.extensions.startInline.forEach(function(Ye){xe=Ye.call({lexer:this},Ne),typeof xe=="number"&&xe>=0&&(pe=Math.min(pe,xe))}),pe<1/0&&pe>=0&&(B=ae.substring(0,pe+1))}(),J=this.tokenizer.inlineText(B,K)){ae=ae.substring(J.raw.length),J.raw.slice(-1)!=="_"&&(le=J.raw.slice(-1)),se=!0,I=ue[ue.length-1],I&&I.type==="text"?(I.raw+=J.raw,I.text+=J.text):ue.push(J);continue}if(ae){var ve="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(ve);break}else throw new Error(ve)}}return ue},r(ke,null,[{key:"rules",get:function(){return{block:L,inline:R}}}]),ke}(),G=function(){function ke(De){this.options=De||ie.defaults}var ye=ke.prototype;return ye.code=function(ae,ue,Z){var J=(ue||"").match(/\S*/)[0];if(this.options.highlight){var I=this.options.highlight(ae,J);I!=null&&I!==ae&&(Z=!0,ae=I)}return ae=ae.replace(/\n$/,"")+`
`,J?'<pre><code class="'+this.options.langPrefix+m(J,!0)+'">'+(Z?ae:m(ae,!0))+`</code></pre>
`:"<pre><code>"+(Z?ae:m(ae,!0))+`</code></pre>
`},ye.blockquote=function(ae){return`<blockquote>
`+ae+`</blockquote>
`},ye.html=function(ae){return ae},ye.heading=function(ae,ue,Z,J){if(this.options.headerIds){var I=this.options.headerPrefix+J.slug(Z);return"<h"+ue+' id="'+I+'">'+ae+"</h"+ue+`>
`}return"<h"+ue+">"+ae+"</h"+ue+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(ae,ue,Z){var J=ue?"ol":"ul",I=ue&&Z!==1?' start="'+Z+'"':"";return"<"+J+I+`>
`+ae+"</"+J+`>
`},ye.listitem=function(ae){return"<li>"+ae+`</li>
`},ye.checkbox=function(ae){return"<input "+(ae?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(ae){return"<p>"+ae+`</p>
`},ye.table=function(ae,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+ae+`</thead>
`+ue+`</table>
`},ye.tablerow=function(ae){return`<tr>
`+ae+`</tr>
`},ye.tablecell=function(ae,ue){var Z=ue.header?"th":"td",J=ue.align?"<"+Z+' align="'+ue.align+'">':"<"+Z+">";return J+ae+("</"+Z+`>
`)},ye.strong=function(ae){return"<strong>"+ae+"</strong>"},ye.em=function(ae){return"<em>"+ae+"</em>"},ye.codespan=function(ae){return"<code>"+ae+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(ae){return"<del>"+ae+"</del>"},ye.link=function(ae,ue,Z){if(ae=b(this.options.sanitize,this.options.baseUrl,ae),ae===null)return Z;var J='<a href="'+m(ae)+'"';return ue&&(J+=' title="'+ue+'"'),J+=">"+Z+"</a>",J},ye.image=function(ae,ue,Z){if(ae=b(this.options.sanitize,this.options.baseUrl,ae),ae===null)return Z;var J='<img src="'+ae+'" alt="'+Z+'"';return ue&&(J+=' title="'+ue+'"'),J+=this.options.xhtml?"/>":">",J},ye.text=function(ae){return ae},ke}(),re=function(){function ke(){}var ye=ke.prototype;return ye.strong=function(ae){return ae},ye.em=function(ae){return ae},ye.codespan=function(ae){return ae},ye.del=function(ae){return ae},ye.html=function(ae){return ae},ye.text=function(ae){return ae},ye.link=function(ae,ue,Z){return""+Z},ye.image=function(ae,ue,Z){return""+Z},ye.br=function(){return""},ke}(),ge=function(){function ke(){this.seen={}}var ye=ke.prototype;return ye.serialize=function(ae){return ae.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(ae,ue){var Z=ae,J=0;if(this.seen.hasOwnProperty(Z)){J=this.seen[ae];do J++,Z=ae+"-"+J;while(this.seen.hasOwnProperty(Z))}return ue||(this.seen[ae]=J,this.seen[Z]=0),Z},ye.slug=function(ae,ue){ue===void 0&&(ue={});var Z=this.serialize(ae);return this.getNextSafeSlug(Z,ue.dryrun)},ke}(),oe=function(){function ke(De){this.options=De||ie.defaults,this.options.renderer=this.options.renderer||new G,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new re,this.slugger=new ge}ke.parse=function(ae,ue){var Z=new ke(ue);return Z.parse(ae)},ke.parseInline=function(ae,ue){var Z=new ke(ue);return Z.parseInline(ae)};var ye=ke.prototype;return ye.parse=function(ae,ue){ue===void 0&&(ue=!0);var Z="",J,I,B,H,j,se,le,Y,ve,pe,Ne,xe,Ye,Ge,Te,rt,X,Q,he,Ue=ae.length;for(J=0;J<Ue;J++){if(pe=ae[J],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[pe.type]&&(he=this.options.extensions.renderers[pe.type].call({parser:this},pe),he!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(pe.type))){Z+=he||"";continue}switch(pe.type){case"space":continue;case"hr":{Z+=this.renderer.hr();continue}case"heading":{Z+=this.renderer.heading(this.parseInline(pe.tokens),pe.depth,u(this.parseInline(pe.tokens,this.textRenderer)),this.slugger);continue}case"code":{Z+=this.renderer.code(pe.text,pe.lang,pe.escaped);continue}case"table":{for(Y="",le="",H=pe.header.length,I=0;I<H;I++)le+=this.renderer.tablecell(this.parseInline(pe.header[I].tokens),{header:!0,align:pe.align[I]});for(Y+=this.renderer.tablerow(le),ve="",H=pe.rows.length,I=0;I<H;I++){for(se=pe.rows[I],le="",j=se.length,B=0;B<j;B++)le+=this.renderer.tablecell(this.parseInline(se[B].tokens),{header:!1,align:pe.align[B]});ve+=this.renderer.tablerow(le)}Z+=this.renderer.table(Y,ve);continue}case"blockquote":{ve=this.parse(pe.tokens),Z+=this.renderer.blockquote(ve);continue}case"list":{for(Ne=pe.ordered,xe=pe.start,Ye=pe.loose,H=pe.items.length,ve="",I=0;I<H;I++)Te=pe.items[I],rt=Te.checked,X=Te.task,Ge="",Te.task&&(Q=this.renderer.checkbox(rt),Ye?Te.tokens.length>0&&Te.tokens[0].type==="paragraph"?(Te.tokens[0].text=Q+" "+Te.tokens[0].text,Te.tokens[0].tokens&&Te.tokens[0].tokens.length>0&&Te.tokens[0].tokens[0].type==="text"&&(Te.tokens[0].tokens[0].text=Q+" "+Te.tokens[0].tokens[0].text)):Te.tokens.unshift({type:"text",text:Q}):Ge+=Q),Ge+=this.parse(Te.tokens,Ye),ve+=this.renderer.listitem(Ge,X,rt);Z+=this.renderer.list(ve,Ne,xe);continue}case"html":{Z+=this.renderer.html(pe.text);continue}case"paragraph":{Z+=this.renderer.paragraph(this.parseInline(pe.tokens));continue}case"text":{for(ve=pe.tokens?this.parseInline(pe.tokens):pe.text;J+1<Ue&&ae[J+1].type==="text";)pe=ae[++J],ve+=`
`+(pe.tokens?this.parseInline(pe.tokens):pe.text);Z+=ue?this.renderer.paragraph(ve):ve;continue}default:{var je='Token with "'+pe.type+'" type was not found.';if(this.options.silent){console.error(je);return}else throw new Error(je)}}}return Z},ye.parseInline=function(ae,ue){ue=ue||this.renderer;var Z="",J,I,B,H=ae.length;for(J=0;J<H;J++){if(I=ae[J],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[I.type]&&(B=this.options.extensions.renderers[I.type].call({parser:this},I),B!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(I.type))){Z+=B||"";continue}switch(I.type){case"escape":{Z+=ue.text(I.text);break}case"html":{Z+=ue.html(I.text);break}case"link":{Z+=ue.link(I.href,I.title,this.parseInline(I.tokens,ue));break}case"image":{Z+=ue.image(I.href,I.title,I.text);break}case"strong":{Z+=ue.strong(this.parseInline(I.tokens,ue));break}case"em":{Z+=ue.em(this.parseInline(I.tokens,ue));break}case"codespan":{Z+=ue.codespan(I.text);break}case"br":{Z+=ue.br();break}case"del":{Z+=ue.del(this.parseInline(I.tokens,ue));break}case"text":{Z+=ue.text(I.text);break}default:{var j='Token with "'+I.type+'" type was not found.';if(this.options.silent){console.error(j);return}else throw new Error(j)}}}return Z},ke}();function Ee(ke,ye,De){if(typeof ke>"u"||ke===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");if(typeof ye=="function"&&(De=ye,ye=null),ye=s({},Ee.defaults,ye||{}),M(ye),De){var ae=ye.highlight,ue;try{ue=$.lex(ke,ye)}catch(H){return De(H)}var Z=function(j){var se;if(!j)try{ye.walkTokens&&Ee.walkTokens(ue,ye.walkTokens),se=oe.parse(ue,ye)}catch(le){j=le}return ye.highlight=ae,j?De(j):De(null,se)};if(!ae||ae.length<3||(delete ye.highlight,!ue.length))return Z();var J=0;Ee.walkTokens(ue,function(H){H.type==="code"&&(J++,setTimeout(function(){ae(H.text,H.lang,function(j,se){if(j)return Z(j);se!=null&&se!==H.text&&(H.text=se,H.escaped=!0),J--,J===0&&Z()})},0))}),J===0&&Z();return}function I(H){if(H.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+m(H.message+"",!0)+"</pre>";throw H}try{var B=$.lex(ke,ye);if(ye.walkTokens){if(ye.async)return Promise.all(Ee.walkTokens(B,ye.walkTokens)).then(function(){return oe.parse(B,ye)}).catch(I);Ee.walkTokens(B,ye.walkTokens)}return oe.parse(B,ye)}catch(H){I(H)}}Ee.options=Ee.setOptions=function(ke){return s(Ee.defaults,ke),A(Ee.defaults),Ee},Ee.getDefaults=_,Ee.defaults=ie.defaults,Ee.use=function(){for(var ke=arguments.length,ye=new Array(ke),De=0;De<ke;De++)ye[De]=arguments[De];var ae=s.apply(void 0,[{}].concat(ye)),ue=Ee.defaults.extensions||{renderers:{},childTokens:{}},Z;ye.forEach(function(J){if(J.extensions&&(Z=!0,J.extensions.forEach(function(B){if(!B.name)throw new Error("extension name required");if(B.renderer){var H=ue.renderers?ue.renderers[B.name]:null;H?ue.renderers[B.name]=function(){for(var j=arguments.length,se=new Array(j),le=0;le<j;le++)se[le]=arguments[le];var Y=B.renderer.apply(this,se);return Y===!1&&(Y=H.apply(this,se)),Y}:ue.renderers[B.name]=B.renderer}if(B.tokenizer){if(!B.level||B.level!=="block"&&B.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ue[B.level]?ue[B.level].unshift(B.tokenizer):ue[B.level]=[B.tokenizer],B.start&&(B.level==="block"?ue.startBlock?ue.startBlock.push(B.start):ue.startBlock=[B.start]:B.level==="inline"&&(ue.startInline?ue.startInline.push(B.start):ue.startInline=[B.start]))}B.childTokens&&(ue.childTokens[B.name]=B.childTokens)})),J.renderer&&function(){var B=Ee.defaults.renderer||new G,H=function(le){var Y=B[le];B[le]=function(){for(var ve=arguments.length,pe=new Array(ve),Ne=0;Ne<ve;Ne++)pe[Ne]=arguments[Ne];var xe=J.renderer[le].apply(B,pe);return xe===!1&&(xe=Y.apply(B,pe)),xe}};for(var j in J.renderer)H(j);ae.renderer=B}(),J.tokenizer&&function(){var B=Ee.defaults.tokenizer||new x,H=function(le){var Y=B[le];B[le]=function(){for(var ve=arguments.length,pe=new Array(ve),Ne=0;Ne<ve;Ne++)pe[Ne]=arguments[Ne];var xe=J.tokenizer[le].apply(B,pe);return xe===!1&&(xe=Y.apply(B,pe)),xe}};for(var j in J.tokenizer)H(j);ae.tokenizer=B}(),J.walkTokens){var I=Ee.defaults.walkTokens;ae.walkTokens=function(B){var H=[];return H.push(J.walkTokens.call(this,B)),I&&(H=H.concat(I.call(this,B))),H}}Z&&(ae.extensions=ue),Ee.setOptions(ae)})},Ee.walkTokens=function(ke,ye){for(var De=[],ae=function(){var I=Z.value;switch(De=De.concat(ye.call(Ee,I)),I.type){case"table":{for(var B=N(I.header),H;!(H=B()).done;){var j=H.value;De=De.concat(Ee.walkTokens(j.tokens,ye))}for(var se=N(I.rows),le;!(le=se()).done;)for(var Y=le.value,ve=N(Y),pe;!(pe=ve()).done;){var Ne=pe.value;De=De.concat(Ee.walkTokens(Ne.tokens,ye))}break}case"list":{De=De.concat(Ee.walkTokens(I.items,ye));break}default:Ee.defaults.extensions&&Ee.defaults.extensions.childTokens&&Ee.defaults.extensions.childTokens[I.type]?Ee.defaults.extensions.childTokens[I.type].forEach(function(xe){De=De.concat(Ee.walkTokens(I[xe],ye))}):I.tokens&&(De=De.concat(Ee.walkTokens(I.tokens,ye)))}},ue=N(ke),Z;!(Z=ue()).done;)ae();return De},Ee.parseInline=function(ke,ye){if(typeof ke>"u"||ke===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");ye=s({},Ee.defaults,ye||{}),M(ye);try{var De=$.lexInline(ke,ye);return ye.walkTokens&&Ee.walkTokens(De,ye.walkTokens),oe.parseInline(De,ye)}catch(ae){if(ae.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+m(ae.message+"",!0)+"</pre>";throw ae}},Ee.Parser=oe,Ee.parser=oe.parse,Ee.Renderer=G,Ee.TextRenderer=re,Ee.Lexer=$,Ee.lexer=$.lex,Ee.Tokenizer=x,Ee.Slugger=ge,Ee.parse=Ee;var ce=Ee.options,me=Ee.setOptions,ee=Ee.use,be=Ee.walkTokens,_e=Ee.parseInline,Fe=Ee,Be=oe.parse,Xe=$.lex;ie.Lexer=$,ie.Parser=oe,ie.Renderer=G,ie.Slugger=ge,ie.TextRenderer=re,ie.Tokenizer=x,ie.getDefaults=_,ie.lexer=Xe,ie.marked=Ee,ie.options=ce,ie.parse=Fe,ie.parseInline=_e,ie.parser=Be,ie.setOptions=me,ie.use=ee,ie.walkTokens=be,Object.defineProperty(ie,"__esModule",{value:!0})}),define(Ce[108],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function r(A,E,P){return Math.min(Math.max(A,E),P)}e.clamp=r;function C(A,E){return(E+A%E)%E}e.rot=C;class S{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=S;class N{constructor(){this._n=1,this._val=0}update(E){return this._val=this._val+(E-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=N;class _{constructor(E){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(E),this._values.fill(0,0,E)}update(E){const P=this._values[this._index];return this._values[this._index]=E,this._index=(this._index+1)%this._values.length,this._sum-=P,this._sum+=E,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=_}),function(){function ie(S){const N=[];typeof S=="number"&&N.push("code/timeOrigin",S);function _(E){N.push(E,Date.now())}function A(){const E=[];for(let P=0;P<N.length;P+=2)E.push({name:N[P],startTime:N[P+1]});return E}return{mark:_,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const _ of performance.getEntriesByType("mark"))N.push({name:_.name,startTime:Math.round(S+_.startTime)});return N}};if(typeof process=="object"){const S=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function r(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return r(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=r(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=r(C))}(),function(ie,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var r=e();for(var C in r)(typeof exports=="object"?exports:ie)[C]=r[C]}}(typeof self<"u"?self:this,function(){return function(ie){var e={};function r(C){if(e[C])return e[C].exports;var S=e[C]={i:C,l:!1,exports:{}};return ie[C].call(S.exports,S,S.exports,r),S.l=!0,S.exports}return r.m=ie,r.c=e,r.d=function(C,S,N){r.o(C,S)||Object.defineProperty(C,S,{enumerable:!0,get:N})},r.r=function(C){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},r.t=function(C,S){if(1&S&&(C=r(C)),8&S||4&S&&typeof C=="object"&&C&&C.__esModule)return C;var N=Object.create(null);if(r.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:C}),2&S&&typeof C!="string")for(var _ in C)r.d(N,_,function(A){return C[A]}.bind(null,_));return N},r.n=function(C){var S=C&&C.__esModule?function(){return C.default}:function(){return C};return r.d(S,"a",S),S},r.o=function(C,S){return Object.prototype.hasOwnProperty.call(C,S)},r.p="",r(r.s=0)}([function(ie,e,r){(function(C){var S;e=ie.exports=ee,S=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var Y=Array.prototype.slice.call(arguments,0);Y.unshift("SEMVER"),console.log.apply(console,Y)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,_=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],E=e.src=[],P=0,O=P++;E[O]="0|[1-9]\\d*";var w=P++;E[w]="[0-9]+";var g=P++;E[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var k=P++;E[k]="("+E[O]+")\\.("+E[O]+")\\.("+E[O]+")";var m=P++;E[m]="("+E[w]+")\\.("+E[w]+")\\.("+E[w]+")";var a=P++;E[a]="(?:"+E[O]+"|"+E[g]+")";var u=P++;E[u]="(?:"+E[w]+"|"+E[g]+")";var d=P++;E[d]="(?:-("+E[a]+"(?:\\."+E[a]+")*))";var v=P++;E[v]="(?:-?("+E[u]+"(?:\\."+E[u]+")*))";var D=P++;E[D]="[0-9A-Za-z-]+";var c=P++;E[c]="(?:\\+("+E[D]+"(?:\\."+E[D]+")*))";var b=P++,t="v?"+E[k]+E[d]+"?"+E[c]+"?";E[b]="^"+t+"$";var l="[v=\\s]*"+E[m]+E[v]+"?"+E[c]+"?",i=P++;E[i]="^"+l+"$";var n=P++;E[n]="((?:<|>)?=?)";var o=P++;E[o]=E[w]+"|x|X|\\*";var f=P++;E[f]=E[O]+"|x|X|\\*";var s=P++;E[s]="[v=\\s]*("+E[f]+")(?:\\.("+E[f]+")(?:\\.("+E[f]+")(?:"+E[d]+")?"+E[c]+"?)?)?";var h=P++;E[h]="[v=\\s]*("+E[o]+")(?:\\.("+E[o]+")(?:\\.("+E[o]+")(?:"+E[v]+")?"+E[c]+"?)?)?";var p=P++;E[p]="^"+E[n]+"\\s*"+E[s]+"$";var T=P++;E[T]="^"+E[n]+"\\s*"+E[h]+"$";var M=P++;E[M]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var V=P++;E[V]="(?:~>?)";var U=P++;E[U]="(\\s*)"+E[V]+"\\s+",A[U]=new RegExp(E[U],"g");var y=P++;E[y]="^"+E[V]+E[s]+"$";var x=P++;E[x]="^"+E[V]+E[h]+"$";var L=P++;E[L]="(?:\\^)";var R=P++;E[R]="(\\s*)"+E[L]+"\\s+",A[R]=new RegExp(E[R],"g");var K=P++;E[K]="^"+E[L]+E[s]+"$";var W=P++;E[W]="^"+E[L]+E[h]+"$";var $=P++;E[$]="^"+E[n]+"\\s*("+l+")$|^$";var G=P++;E[G]="^"+E[n]+"\\s*("+t+")$|^$";var re=P++;E[re]="(\\s*)"+E[n]+"\\s*("+l+"|"+E[s]+")",A[re]=new RegExp(E[re],"g");var ge=P++;E[ge]="^\\s*("+E[s]+")\\s+-\\s+("+E[s]+")\\s*$";var oe=P++;E[oe]="^\\s*("+E[h]+")\\s+-\\s+("+E[h]+")\\s*$";var Ee=P++;E[Ee]="(<|>)?=?\\s*\\*";for(var ce=0;ce<35;ce++)S(ce,E[ce]),A[ce]||(A[ce]=new RegExp(E[ce]));function me(Y,ve){if(Y instanceof ee)return Y;if(typeof Y!="string"||Y.length>N||!(ve?A[i]:A[b]).test(Y))return null;try{return new ee(Y,ve)}catch{return null}}function ee(Y,ve){if(Y instanceof ee){if(Y.loose===ve)return Y;Y=Y.version}else if(typeof Y!="string")throw new TypeError("Invalid Version: "+Y);if(Y.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof ee))return new ee(Y,ve);S("SemVer",Y,ve),this.loose=ve;var pe=Y.trim().match(ve?A[i]:A[b]);if(!pe)throw new TypeError("Invalid Version: "+Y);if(this.raw=Y,this.major=+pe[1],this.minor=+pe[2],this.patch=+pe[3],this.major>_||this.major<0)throw new TypeError("Invalid major version");if(this.minor>_||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>_||this.patch<0)throw new TypeError("Invalid patch version");pe[4]?this.prerelease=pe[4].split(".").map(function(Ne){if(/^[0-9]+$/.test(Ne)){var xe=+Ne;if(xe>=0&&xe<_)return xe}return Ne}):this.prerelease=[],this.build=pe[5]?pe[5].split("."):[],this.format()}e.parse=me,e.valid=function(Y,ve){var pe=me(Y,ve);return pe?pe.version:null},e.clean=function(Y,ve){var pe=me(Y.trim().replace(/^[=v]+/,""),ve);return pe?pe.version:null},e.SemVer=ee,ee.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ee.prototype.toString=function(){return this.version},ee.prototype.compare=function(Y){return S("SemVer.compare",this.version,this.loose,Y),Y instanceof ee||(Y=new ee(Y,this.loose)),this.compareMain(Y)||this.comparePre(Y)},ee.prototype.compareMain=function(Y){return Y instanceof ee||(Y=new ee(Y,this.loose)),_e(this.major,Y.major)||_e(this.minor,Y.minor)||_e(this.patch,Y.patch)},ee.prototype.comparePre=function(Y){if(Y instanceof ee||(Y=new ee(Y,this.loose)),this.prerelease.length&&!Y.prerelease.length)return-1;if(!this.prerelease.length&&Y.prerelease.length)return 1;if(!this.prerelease.length&&!Y.prerelease.length)return 0;var ve=0;do{var pe=this.prerelease[ve],Ne=Y.prerelease[ve];if(S("prerelease compare",ve,pe,Ne),pe===void 0&&Ne===void 0)return 0;if(Ne===void 0)return 1;if(pe===void 0)return-1;if(pe!==Ne)return _e(pe,Ne)}while(++ve)},ee.prototype.inc=function(Y,ve){switch(Y){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ve);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ve);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ve),this.inc("pre",ve);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ve),this.inc("pre",ve);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var pe=this.prerelease.length;--pe>=0;)typeof this.prerelease[pe]=="number"&&(this.prerelease[pe]++,pe=-2);pe===-1&&this.prerelease.push(0)}ve&&(this.prerelease[0]===ve?isNaN(this.prerelease[1])&&(this.prerelease=[ve,0]):this.prerelease=[ve,0]);break;default:throw new Error("invalid increment argument: "+Y)}return this.format(),this.raw=this.version,this},e.inc=function(Y,ve,pe,Ne){typeof pe=="string"&&(Ne=pe,pe=void 0);try{return new ee(Y,pe).inc(ve,Ne).version}catch{return null}},e.diff=function(Y,ve){if(ke(Y,ve))return null;var pe=me(Y),Ne=me(ve);if(pe.prerelease.length||Ne.prerelease.length){for(var xe in pe)if((xe==="major"||xe==="minor"||xe==="patch")&&pe[xe]!==Ne[xe])return"pre"+xe;return"prerelease"}for(var xe in pe)if((xe==="major"||xe==="minor"||xe==="patch")&&pe[xe]!==Ne[xe])return xe},e.compareIdentifiers=_e;var be=/^[0-9]+$/;function _e(Y,ve){var pe=be.test(Y),Ne=be.test(ve);return pe&&Ne&&(Y=+Y,ve=+ve),pe&&!Ne?-1:Ne&&!pe?1:Y<ve?-1:Y>ve?1:0}function Fe(Y,ve,pe){return new ee(Y,pe).compare(new ee(ve,pe))}function Be(Y,ve,pe){return Fe(Y,ve,pe)>0}function Xe(Y,ve,pe){return Fe(Y,ve,pe)<0}function ke(Y,ve,pe){return Fe(Y,ve,pe)===0}function ye(Y,ve,pe){return Fe(Y,ve,pe)!==0}function De(Y,ve,pe){return Fe(Y,ve,pe)>=0}function ae(Y,ve,pe){return Fe(Y,ve,pe)<=0}function ue(Y,ve,pe,Ne){var xe;switch(ve){case"===":typeof Y=="object"&&(Y=Y.version),typeof pe=="object"&&(pe=pe.version),xe=Y===pe;break;case"!==":typeof Y=="object"&&(Y=Y.version),typeof pe=="object"&&(pe=pe.version),xe=Y!==pe;break;case"":case"=":case"==":xe=ke(Y,pe,Ne);break;case"!=":xe=ye(Y,pe,Ne);break;case">":xe=Be(Y,pe,Ne);break;case">=":xe=De(Y,pe,Ne);break;case"<":xe=Xe(Y,pe,Ne);break;case"<=":xe=ae(Y,pe,Ne);break;default:throw new TypeError("Invalid operator: "+ve)}return xe}function Z(Y,ve){if(Y instanceof Z){if(Y.loose===ve)return Y;Y=Y.value}if(!(this instanceof Z))return new Z(Y,ve);S("comparator",Y,ve),this.loose=ve,this.parse(Y),this.semver===J?this.value="":this.value=this.operator+this.semver.version,S("comp",this)}e.rcompareIdentifiers=function(Y,ve){return _e(ve,Y)},e.major=function(Y,ve){return new ee(Y,ve).major},e.minor=function(Y,ve){return new ee(Y,ve).minor},e.patch=function(Y,ve){return new ee(Y,ve).patch},e.compare=Fe,e.compareLoose=function(Y,ve){return Fe(Y,ve,!0)},e.rcompare=function(Y,ve,pe){return Fe(ve,Y,pe)},e.sort=function(Y,ve){return Y.sort(function(pe,Ne){return e.compare(pe,Ne,ve)})},e.rsort=function(Y,ve){return Y.sort(function(pe,Ne){return e.rcompare(pe,Ne,ve)})},e.gt=Be,e.lt=Xe,e.eq=ke,e.neq=ye,e.gte=De,e.lte=ae,e.cmp=ue,e.Comparator=Z;var J={};function I(Y,ve){if(Y instanceof I)return Y.loose===ve?Y:new I(Y.raw,ve);if(Y instanceof Z)return new I(Y.value,ve);if(!(this instanceof I))return new I(Y,ve);if(this.loose=ve,this.raw=Y,this.set=Y.split(/\s*\|\|\s*/).map(function(pe){return this.parseRange(pe.trim())},this).filter(function(pe){return pe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Y);this.format()}function B(Y){return!Y||Y.toLowerCase()==="x"||Y==="*"}function H(Y,ve,pe,Ne,xe,Ye,Ge,Te,rt,X,Q,he,Ue){return((ve=B(pe)?"":B(Ne)?">="+pe+".0.0":B(xe)?">="+pe+"."+Ne+".0":">="+ve)+" "+(Te=B(rt)?"":B(X)?"<"+(+rt+1)+".0.0":B(Q)?"<"+rt+"."+(+X+1)+".0":he?"<="+rt+"."+X+"."+Q+"-"+he:"<="+Te)).trim()}function j(Y,ve){for(var pe=0;pe<Y.length;pe++)if(!Y[pe].test(ve))return!1;if(ve.prerelease.length){for(pe=0;pe<Y.length;pe++)if(S(Y[pe].semver),Y[pe].semver!==J&&Y[pe].semver.prerelease.length>0){var Ne=Y[pe].semver;if(Ne.major===ve.major&&Ne.minor===ve.minor&&Ne.patch===ve.patch)return!0}return!1}return!0}function se(Y,ve,pe){try{ve=new I(ve,pe)}catch{return!1}return ve.test(Y)}function le(Y,ve,pe,Ne){var xe,Ye,Ge,Te,rt;switch(Y=new ee(Y,Ne),ve=new I(ve,Ne),pe){case">":xe=Be,Ye=ae,Ge=Xe,Te=">",rt=">=";break;case"<":xe=Xe,Ye=De,Ge=Be,Te="<",rt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(se(Y,ve,Ne))return!1;for(var X=0;X<ve.set.length;++X){var Q=ve.set[X],he=null,Ue=null;if(Q.forEach(function(je){je.semver===J&&(je=new Z(">=0.0.0")),he=he||je,Ue=Ue||je,xe(je.semver,he.semver,Ne)?he=je:Ge(je.semver,Ue.semver,Ne)&&(Ue=je)}),he.operator===Te||he.operator===rt||(!Ue.operator||Ue.operator===Te)&&Ye(Y,Ue.semver)||Ue.operator===rt&&Ge(Y,Ue.semver))return!1}return!0}Z.prototype.parse=function(Y){var ve=this.loose?A[$]:A[G],pe=Y.match(ve);if(!pe)throw new TypeError("Invalid comparator: "+Y);this.operator=pe[1],this.operator==="="&&(this.operator=""),pe[2]?this.semver=new ee(pe[2],this.loose):this.semver=J},Z.prototype.toString=function(){return this.value},Z.prototype.test=function(Y){return S("Comparator.test",Y,this.loose),this.semver===J||(typeof Y=="string"&&(Y=new ee(Y,this.loose)),ue(Y,this.operator,this.semver,this.loose))},Z.prototype.intersects=function(Y,ve){if(!(Y instanceof Z))throw new TypeError("a Comparator is required");var pe;if(this.operator==="")return pe=new I(Y.value,ve),se(this.value,pe,ve);if(Y.operator==="")return pe=new I(this.value,ve),se(Y.semver,pe,ve);var Ne=!(this.operator!==">="&&this.operator!==">"||Y.operator!==">="&&Y.operator!==">"),xe=!(this.operator!=="<="&&this.operator!=="<"||Y.operator!=="<="&&Y.operator!=="<"),Ye=this.semver.version===Y.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||Y.operator!==">="&&Y.operator!=="<="),Te=ue(this.semver,"<",Y.semver,ve)&&(this.operator===">="||this.operator===">")&&(Y.operator==="<="||Y.operator==="<"),rt=ue(this.semver,">",Y.semver,ve)&&(this.operator==="<="||this.operator==="<")&&(Y.operator===">="||Y.operator===">");return Ne||xe||Ye&&Ge||Te||rt},e.Range=I,I.prototype.format=function(){return this.range=this.set.map(function(Y){return Y.join(" ").trim()}).join("||").trim(),this.range},I.prototype.toString=function(){return this.range},I.prototype.parseRange=function(Y){var ve=this.loose;Y=Y.trim(),S("range",Y,ve);var pe=ve?A[oe]:A[ge];Y=Y.replace(pe,H),S("hyphen replace",Y),Y=Y.replace(A[re],"$1$2$3"),S("comparator trim",Y,A[re]),Y=(Y=(Y=Y.replace(A[U],"$1~")).replace(A[R],"$1^")).split(/\s+/).join(" ");var Ne=ve?A[$]:A[G],xe=Y.split(" ").map(function(Ye){return function(Ge,Te){return S("comp",Ge),Ge=function(rt,X){return rt.trim().split(/\s+/).map(function(Q){return function(he,Ue){S("caret",he,Ue);var je=Ue?A[W]:A[K];return he.replace(je,function(Ze,Ke,Ve,it,st){var dt;return S("caret",he,Ze,Ke,Ve,it,st),B(Ke)?dt="":B(Ve)?dt=">="+Ke+".0.0 <"+(+Ke+1)+".0.0":B(it)?dt=Ke==="0"?">="+Ke+"."+Ve+".0 <"+Ke+"."+(+Ve+1)+".0":">="+Ke+"."+Ve+".0 <"+(+Ke+1)+".0.0":st?(S("replaceCaret pr",st),st.charAt(0)!=="-"&&(st="-"+st),dt=Ke==="0"?Ve==="0"?">="+Ke+"."+Ve+"."+it+st+" <"+Ke+"."+Ve+"."+(+it+1):">="+Ke+"."+Ve+"."+it+st+" <"+Ke+"."+(+Ve+1)+".0":">="+Ke+"."+Ve+"."+it+st+" <"+(+Ke+1)+".0.0"):(S("no pr"),dt=Ke==="0"?Ve==="0"?">="+Ke+"."+Ve+"."+it+" <"+Ke+"."+Ve+"."+(+it+1):">="+Ke+"."+Ve+"."+it+" <"+Ke+"."+(+Ve+1)+".0":">="+Ke+"."+Ve+"."+it+" <"+(+Ke+1)+".0.0"),S("caret return",dt),dt})}(Q,X)}).join(" ")}(Ge,Te),S("caret",Ge),Ge=function(rt,X){return rt.trim().split(/\s+/).map(function(Q){return function(he,Ue){var je=Ue?A[x]:A[y];return he.replace(je,function(Ze,Ke,Ve,it,st){var dt;return S("tilde",he,Ze,Ke,Ve,it,st),B(Ke)?dt="":B(Ve)?dt=">="+Ke+".0.0 <"+(+Ke+1)+".0.0":B(it)?dt=">="+Ke+"."+Ve+".0 <"+Ke+"."+(+Ve+1)+".0":st?(S("replaceTilde pr",st),st.charAt(0)!=="-"&&(st="-"+st),dt=">="+Ke+"."+Ve+"."+it+st+" <"+Ke+"."+(+Ve+1)+".0"):dt=">="+Ke+"."+Ve+"."+it+" <"+Ke+"."+(+Ve+1)+".0",S("tilde return",dt),dt})}(Q,X)}).join(" ")}(Ge,Te),S("tildes",Ge),Ge=function(rt,X){return S("replaceXRanges",rt,X),rt.split(/\s+/).map(function(Q){return function(he,Ue){he=he.trim();var je=Ue?A[T]:A[p];return he.replace(je,function(Ze,Ke,Ve,it,st,dt){S("xRange",he,Ze,Ke,Ve,it,st,dt);var _t=B(Ve),tt=_t||B(it),ut=tt||B(st);return Ke==="="&&ut&&(Ke=""),_t?Ze=Ke===">"||Ke==="<"?"<0.0.0":"*":Ke&&ut?(tt&&(it=0),ut&&(st=0),Ke===">"?(Ke=">=",tt?(Ve=+Ve+1,it=0,st=0):ut&&(it=+it+1,st=0)):Ke==="<="&&(Ke="<",tt?Ve=+Ve+1:it=+it+1),Ze=Ke+Ve+"."+it+"."+st):tt?Ze=">="+Ve+".0.0 <"+(+Ve+1)+".0.0":ut&&(Ze=">="+Ve+"."+it+".0 <"+Ve+"."+(+it+1)+".0"),S("xRange return",Ze),Ze})}(Q,X)}).join(" ")}(Ge,Te),S("xrange",Ge),Ge=function(rt,X){return S("replaceStars",rt,X),rt.trim().replace(A[Ee],"")}(Ge,Te),S("stars",Ge),Ge}(Ye,ve)}).join(" ").split(/\s+/);return this.loose&&(xe=xe.filter(function(Ye){return!!Ye.match(Ne)})),xe=xe.map(function(Ye){return new Z(Ye,ve)})},I.prototype.intersects=function(Y,ve){if(!(Y instanceof I))throw new TypeError("a Range is required");return this.set.some(function(pe){return pe.every(function(Ne){return Y.set.some(function(xe){return xe.every(function(Ye){return Ne.intersects(Ye,ve)})})})})},e.toComparators=function(Y,ve){return new I(Y,ve).set.map(function(pe){return pe.map(function(Ne){return Ne.value}).join(" ").trim().split(" ")})},I.prototype.test=function(Y){if(!Y)return!1;typeof Y=="string"&&(Y=new ee(Y,this.loose));for(var ve=0;ve<this.set.length;ve++)if(j(this.set[ve],Y))return!0;return!1},e.satisfies=se,e.maxSatisfying=function(Y,ve,pe){var Ne=null,xe=null;try{var Ye=new I(ve,pe)}catch{return null}return Y.forEach(function(Ge){Ye.test(Ge)&&(Ne&&xe.compare(Ge)!==-1||(xe=new ee(Ne=Ge,pe)))}),Ne},e.minSatisfying=function(Y,ve,pe){var Ne=null,xe=null;try{var Ye=new I(ve,pe)}catch{return null}return Y.forEach(function(Ge){Ye.test(Ge)&&(Ne&&xe.compare(Ge)!==1||(xe=new ee(Ne=Ge,pe)))}),Ne},e.validRange=function(Y,ve){try{return new I(Y,ve).range||"*"}catch{return null}},e.ltr=function(Y,ve,pe){return le(Y,ve,"<",pe)},e.gtr=function(Y,ve,pe){return le(Y,ve,">",pe)},e.outside=le,e.prerelease=function(Y,ve){var pe=me(Y,ve);return pe&&pe.prerelease.length?pe.prerelease:null},e.intersects=function(Y,ve,pe){return Y=new I(Y,pe),ve=new I(ve,pe),Y.intersects(ve)},e.coerce=function(Y){if(Y instanceof ee)return Y;if(typeof Y!="string")return null;var ve=Y.match(A[M]);return ve==null?null:me((ve[1]||"0")+"."+(ve[2]||"0")+"."+(ve[3]||"0"))}}).call(this,r(1))},function(ie,e){var r,C,S=ie.exports={};function N(){throw new Error("setTimeout has not been defined")}function _(){throw new Error("clearTimeout has not been defined")}function A(u){if(r===setTimeout)return setTimeout(u,0);if((r===N||!r)&&setTimeout)return r=setTimeout,setTimeout(u,0);try{return r(u,0)}catch{try{return r.call(null,u,0)}catch{return r.call(this,u,0)}}}(function(){try{r=typeof setTimeout=="function"?setTimeout:N}catch{r=N}try{C=typeof clearTimeout=="function"?clearTimeout:_}catch{C=_}})();var E,P=[],O=!1,w=-1;function g(){O&&E&&(O=!1,E.length?P=E.concat(P):w=-1,P.length&&k())}function k(){if(!O){var u=A(g);O=!0;for(var d=P.length;d;){for(E=P,P=[];++w<d;)E&&E[w].run();w=-1,d=P.length}E=null,O=!1,function(v){if(C===clearTimeout)return clearTimeout(v);if((C===_||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(v);try{C(v)}catch{try{return C.call(null,v)}catch{return C.call(this,v)}}}(u)}}function m(u,d){this.fun=u,this.array=d}function a(){}S.nextTick=function(u){var d=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)d[v-1]=arguments[v];P.push(new m(u,d)),P.length!==1||O||A(k)},m.prototype.run=function(){this.fun.apply(null,this.array)},S.title="browser",S.browser=!0,S.env={},S.argv=[],S.version="",S.versions={},S.on=a,S.addListener=a,S.once=a,S.off=a,S.removeListener=a,S.removeAllListeners=a,S.emit=a,S.prependListener=a,S.prependOnceListener=a,S.listeners=function(u){return[]},S.binding=function(u){throw new Error("process.binding is not supported")},S.cwd=function(){return"/"},S.chdir=function(u){throw new Error("process.chdir is not supported")},S.umask=function(){return 0}}])}),define(Ce[109],Ie([1,0,12,7]),function(ie,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function S(c){const b=c;return b?typeof b.read=="function":!1}e.isReadable=S;function N(c){const b=c;return b?[b.on,b.pause,b.resume,b.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=N;function _(c){const b=c;return b?N(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean":!1}e.isReadableBufferedStream=_;function A(c,b){return new E(c,b)}e.newWriteableStream=A;class E{constructor(b,t){this.reducer=b,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(b){if(!this.state.destroyed){if(this.state.flowing)this.emitData(b);else if(this.buffer.data.push(b),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(b){this.state.destroyed||(this.state.flowing?this.emitError(b):this.buffer.error.push(b))}end(b){this.state.destroyed||(typeof b<"u"&&this.write(b),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(b){this.listeners.data.slice(0).forEach(t=>t(b))}emitError(b){this.listeners.error.length===0?(0,r.onUnexpectedError)(b):this.listeners.error.slice(0).forEach(t=>t(b))}emitEnd(){this.listeners.end.slice(0).forEach(b=>b())}on(b,t){if(!this.state.destroyed)switch(b){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(b,t){if(this.state.destroyed)return;let l;switch(b){case"data":l=this.listeners.data;break;case"end":l=this.listeners.end;break;case"error":l=this.listeners.error;break}if(l){const i=l.indexOf(t);i>=0&&l.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const b=this.reducer(this.buffer.data);this.emitData(b),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(l=>l())}}flowErrors(){if(this.listeners.error.length>0){for(const b of this.buffer.error)this.emitError(b);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function P(c,b){const t=[];let l;for(;(l=c.read())!==null;)t.push(l);return b(t)}e.consumeReadable=P;function O(c,b,t){const l=[];let i;for(;(i=c.read())!==null&&l.length<t;)l.push(i);return i===null&&l.length>0?b(l):{read:()=>{if(l.length>0)return l.shift();if(typeof i<"u"){const n=i;return i=void 0,n}return c.read()}}}e.peekReadable=O;function w(c,b){return new Promise((t,l)=>{const i=[];g(c,{onData:n=>{b&&i.push(n)},onError:n=>{b?l(n):t(void 0)},onEnd:()=>{t(b?b(i):void 0)}})})}e.consumeStream=w;function g(c,b){let t=!1;return c.on("error",l=>{t||b.onError(l)}),c.on("end",()=>{t||b.onEnd()}),c.on("data",l=>{t||b.onData(l)}),(0,C.toDisposable)(()=>t=!0)}e.listenStream=g;function k(c,b){return new Promise((t,l)=>{const i=new C.DisposableStore,n=[],o=h=>{if(n.push(h),n.length>b)return i.dispose(),c.pause(),t({stream:c,buffer:n,ended:!1})},f=h=>l(h),s=()=>t({stream:c,buffer:n,ended:!0});i.add((0,C.toDisposable)(()=>c.removeListener("error",f))),c.on("error",f),i.add((0,C.toDisposable)(()=>c.removeListener("end",s))),c.on("end",s),i.add((0,C.toDisposable)(()=>c.removeListener("data",o))),c.on("data",o)})}e.peekStream=k;function m(c,b){const t=A(b);return t.end(c),t}e.toStream=m;function a(){const c=A(()=>{throw new Error("not supported")});return c.end(),c}e.emptyStream=a;function u(c){let b=!1;return{read:()=>b?null:(b=!0,c)}}e.toReadable=u;function d(c,b,t){const l=A(t);return g(c,{onData:i=>l.write(b.data(i)),onError:i=>l.error(b.error?b.error(i):i),onEnd:()=>l.end()}),l}e.transform=d;function v(c,b,t){let l=!1;return{read:()=>{const i=b.read();return l?i:(l=!0,i!==null?t([c,i]):c)}}}e.prefixedReadable=v;function D(c,b,t){let l=!1;const i=A(t);return g(b,{onData:n=>l?i.write(n):(l=!0,i.write(t([c,n]))),onError:n=>i.error(n),onEnd:()=>{l||(l=!0,i.write(c)),i.end()}}),i}e.prefixedStream=D}),define(Ce[23],Ie([1,0,109]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const C=typeof Buffer<"u";let S,N;class _{static alloc(h){return C?new _(Buffer.allocUnsafe(h)):new _(new Uint8Array(h))}static wrap(h){return C&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new _(h)}static fromString(h,p){return!(p?.dontUseNodeBuffer||!1)&&C?new _(Buffer.from(h)):(S||(S=new TextEncoder),new _(S.encode(h)))}static fromByteArray(h){const p=_.alloc(h.length);for(let T=0,M=h.length;T<M;T++)p.buffer[T]=h[T];return p}static concat(h,p){if(typeof p>"u"){p=0;for(let V=0,U=h.length;V<U;V++)p+=h[V].byteLength}const T=_.alloc(p);let M=0;for(let V=0,U=h.length;V<U;V++){const y=h[V];T.set(y,M),M+=y.byteLength}return T}constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}clone(){const h=_.alloc(this.byteLength);return h.set(this),h}toString(){return C?this.buffer.toString():(N||(N=new TextDecoder),N.decode(this.buffer))}slice(h,p){return new _(this.buffer.subarray(h,p))}set(h,p){if(h instanceof _)this.buffer.set(h.buffer,p);else if(h instanceof Uint8Array)this.buffer.set(h,p);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),p);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),p);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return P(this.buffer,h)}writeUInt32BE(h,p){O(this.buffer,h,p)}readUInt32LE(h){return w(this.buffer,h)}writeUInt32LE(h,p){g(this.buffer,h,p)}readUInt8(h){return k(this.buffer,h)}writeUInt8(h,p){m(this.buffer,h,p)}}e.VSBuffer=_;function A(s,h){return s[h+0]<<0>>>0|s[h+1]<<8>>>0}e.readUInt16LE=A;function E(s,h,p){s[p+0]=h&255,h=h>>>8,s[p+1]=h&255}e.writeUInt16LE=E;function P(s,h){return s[h]*2**24+s[h+1]*2**16+s[h+2]*2**8+s[h+3]}e.readUInt32BE=P;function O(s,h,p){s[p+3]=h,h=h>>>8,s[p+2]=h,h=h>>>8,s[p+1]=h,h=h>>>8,s[p]=h}e.writeUInt32BE=O;function w(s,h){return s[h+0]<<0>>>0|s[h+1]<<8>>>0|s[h+2]<<16>>>0|s[h+3]<<24>>>0}e.readUInt32LE=w;function g(s,h,p){s[p+0]=h&255,h=h>>>8,s[p+1]=h&255,h=h>>>8,s[p+2]=h&255,h=h>>>8,s[p+3]=h&255}e.writeUInt32LE=g;function k(s,h){return s[h]}e.readUInt8=k;function m(s,h,p){s[p]=h}e.writeUInt8=m;function a(s){return r.consumeReadable(s,h=>_.concat(h))}e.readableToBuffer=a;function u(s){return r.toReadable(s)}e.bufferToReadable=u;function d(s){return r.consumeStream(s,h=>_.concat(h))}e.streamToBuffer=d;async function v(s){return s.ended?_.concat(s.buffer):_.concat([...s.buffer,await d(s.stream)])}e.bufferedStreamToBuffer=v;function D(s){return r.toStream(s,h=>_.concat(h))}e.bufferToStream=D;function c(s){return r.transform(s,{data:h=>typeof h=="string"?_.fromString(h):_.wrap(h)},h=>_.concat(h))}e.streamToBufferReadableStream=c;function b(s){return r.newWriteableStream(h=>_.concat(h),s)}e.newWriteableBufferStream=b;function t(s,h){return r.prefixedReadable(s,h,p=>_.concat(p))}e.prefixedBufferReadable=t;function l(s,h){return r.prefixedStream(s,h,p=>_.concat(p))}e.prefixedBufferStream=l;function i(s){let h=0,p=0,T=0;const M=new Uint8Array(Math.floor(s.length/4*3)),V=y=>{switch(p){case 3:M[T++]=h|y,p=0;break;case 2:M[T++]=h|y>>>2,h=y<<6,p=3;break;case 1:M[T++]=h|y>>>4,h=y<<4,p=2;break;default:h=y<<2,p=1}};for(let y=0;y<s.length;y++){const x=s.charCodeAt(y);if(x>=65&&x<=90)V(x-65);else if(x>=97&&x<=122)V(x-97+26);else if(x>=48&&x<=57)V(x-48+52);else if(x===43||x===45)V(62);else if(x===47||x===95)V(63);else{if(x===61)break;throw new SyntaxError(`Unexpected base64 character ${s[y]}`)}}const U=T;for(;p>0;)V(0);return _.wrap(M).slice(0,U)}e.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function f({buffer:s},h=!0,p=!1){const T=p?o:n;let M="";const V=s.byteLength%3;let U=0;for(;U<s.byteLength-V;U+=3){const y=s[U+0],x=s[U+1],L=s[U+2];M+=T[y>>>2],M+=T[(y<<4|x>>>4)&63],M+=T[(x<<2|L>>>6)&63],M+=T[L&63]}if(V===1){const y=s[U+0];M+=T[y>>>2],M+=T[y<<4&63],h&&(M+="==")}else if(V===2){const y=s[U+0],x=s[U+1];M+=T[y>>>2],M+=T[(y<<4|x>>>4)&63],M+=T[x<<2&63],h&&(M+="=")}return M}e.encodeBase64=f}),define(Ce[43],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const r=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function C(S){return r.test(S)}e.isUUID=C,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(A){for(let E=0;E<A.length;E++)A[E]=Math.floor(Math.random()*256);return A};const N=new Uint8Array(16),_=[];for(let A=0;A<256;A++)_.push(A.toString(16).padStart(2,"0"));return function(){S(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let E=0,P="";return P+=_[N[E++]],P+=_[N[E++]],P+=_[N[E++]],P+=_[N[E++]],P+="-",P+=_[N[E++]],P+=_[N[E++]],P+="-",P+=_[N[E++]],P+=_[N[E++]],P+="-",P+=_[N[E++]],P+=_[N[E++]],P+="-",P+=_[N[E++]],P+=_[N[E++]],P+=_[N[E++]],P+=_[N[E++]],P+=_[N[E++]],P+=_[N[E++]],P}}()}),define(Ce[110],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ce[111],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var r;(function(_){_[_.None=0]="None",_[_.Indent=1]="Indent",_[_.IndentOutdent=2]="IndentOutdent",_[_.Outdent=3]="Outdent"})(r=e.IndentAction||(e.IndentAction={}));class C{constructor(A){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=A.open,this.close=A.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(A.notIn))for(let E=0,P=A.notIn.length;E<P;E++)switch(A.notIn[E]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(A){switch(A){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(A,E){if(A.getTokenCount()===0)return!0;const P=A.findTokenIndexAtOffset(E-2),O=A.getStandardTokenType(P);return this.isOK(O)}_findNeutralCharacterInRange(A,E){for(let P=A;P<=E;P++){const O=String.fromCharCode(P);if(!this.open.includes(O)&&!this.close.includes(O))return O}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=C;class S{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of A)N(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),N(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),N(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),N(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&N(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.AutoClosingPairs=S;function N(_,A,E){_.has(A)?_.get(A).push(E):_.set(A,[E])}}),define(Ce[112],Ie([16,17]),function(ie,e){return ie.create("vs/base/common/date",e)}),define(Ce[113],Ie([1,0,112]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const C=60,S=C*60,N=S*24,_=N*7,A=N*30,E=N*365;function P(w,g,k){typeof w!="number"&&(w=w.getTime());const m=Math.round((new Date().getTime()-w)/1e3);if(m<-30)return(0,r.localize)(0,null,P(new Date().getTime()+m*1e3,!1));if(m<30)return(0,r.localize)(1,null);let a;return m<C?(a=m,g?a===1?k?(0,r.localize)(2,null,a):(0,r.localize)(3,null,a):k?(0,r.localize)(4,null,a):(0,r.localize)(5,null,a):a===1?k?(0,r.localize)(6,null,a):(0,r.localize)(7,null,a):k?(0,r.localize)(8,null,a):(0,r.localize)(9,null,a)):m<S?(a=Math.floor(m/C),g?a===1?k?(0,r.localize)(10,null,a):(0,r.localize)(11,null,a):k?(0,r.localize)(12,null,a):(0,r.localize)(13,null,a):a===1?k?(0,r.localize)(14,null,a):(0,r.localize)(15,null,a):k?(0,r.localize)(16,null,a):(0,r.localize)(17,null,a)):m<N?(a=Math.floor(m/S),g?a===1?k?(0,r.localize)(18,null,a):(0,r.localize)(19,null,a):k?(0,r.localize)(20,null,a):(0,r.localize)(21,null,a):a===1?k?(0,r.localize)(22,null,a):(0,r.localize)(23,null,a):k?(0,r.localize)(24,null,a):(0,r.localize)(25,null,a)):m<_?(a=Math.floor(m/N),g?a===1?(0,r.localize)(26,null,a):(0,r.localize)(27,null,a):a===1?(0,r.localize)(28,null,a):(0,r.localize)(29,null,a)):m<A?(a=Math.floor(m/_),g?a===1?k?(0,r.localize)(30,null,a):(0,r.localize)(31,null,a):k?(0,r.localize)(32,null,a):(0,r.localize)(33,null,a):a===1?k?(0,r.localize)(34,null,a):(0,r.localize)(35,null,a):k?(0,r.localize)(36,null,a):(0,r.localize)(37,null,a)):m<E?(a=Math.floor(m/A),g?a===1?k?(0,r.localize)(38,null,a):(0,r.localize)(39,null,a):k?(0,r.localize)(40,null,a):(0,r.localize)(41,null,a):a===1?k?(0,r.localize)(42,null,a):(0,r.localize)(43,null,a):k?(0,r.localize)(44,null,a):(0,r.localize)(45,null,a)):(a=Math.floor(m/E),g?a===1?k?(0,r.localize)(46,null,a):(0,r.localize)(47,null,a):k?(0,r.localize)(48,null,a):(0,r.localize)(49,null,a):a===1?k?(0,r.localize)(50,null,a):(0,r.localize)(51,null,a):k?(0,r.localize)(52,null,a):(0,r.localize)(53,null,a))}e.fromNow=P;function O(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=O}),define(Ce[114],Ie([16,17]),function(ie,e){return ie.create("vs/base/common/errorMessage",e)}),define(Ce[44],Ie([1,0,18,10,114]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function N(w,g){return g&&(w.stack||w.stacktrace)?S.localize(0,null,A(w),_(w.stack)||_(w.stacktrace)):A(w)}function _(w){return Array.isArray(w)?w.join(`
`):w}function A(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?S.localize(1,null,w.message):w.message||S.localize(2,null)}function E(w=null,g=!1){if(!w)return S.localize(3,null);if(Array.isArray(w)){const k=r.coalesce(w),m=E(k[0],g);return k.length>1?S.localize(4,null,m,k.length):m}if(C.isString(w))return w;if(w.detail){const k=w.detail;if(k.error)return N(k.error,g);if(k.exception)return N(k.exception,g)}return w.stack?N(w,g):w.message?w.message:S.localize(5,null)}e.toErrorMessage=E;function P(w){const g=w;return g instanceof Error&&Array.isArray(g.actions)}e.isErrorWithActions=P;function O(w,g){let k;return typeof w=="string"?k=new Error(w):k=w,k.actions=g,k}e.createErrorWithActions=O}),define(Ce[75],Ie([1,0,19]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const C={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},S={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function N(O){const w=(0,r.extname)(O),g=C[w.toLowerCase()];return g!==void 0?g:_(O)}e.getMediaOrTextMime=N;function _(O){const w=(0,r.extname)(O);return S[w.toLowerCase()]}e.getMediaMime=_;function A(O){for(const w in S)if(S[w]===O)return w}e.getExtensionForMimeType=A;const E=/^(.+)\/(.+?)(;.+)?$/;function P(O,w){const g=E.exec(O);return g?`${g[1].toLowerCase()}/${g[2].toLowerCase()}${g[3]??""}`:w?void 0:O}e.normalizeMimeType=P}),define(Ce[38],Ie([1,0,19,21,9,10]),function(ie,e,r,C,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function _(o){return o===47||o===92}e.isPathSeparator=_;function A(o){return o.replace(/[\\/]/g,r.posix.sep)}e.toSlashes=A;function E(o){return o.indexOf("/")===-1&&(o=A(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=E;function P(o,f=r.posix.sep){if(!o)return"";const s=o.length,h=o.charCodeAt(0);if(_(h)){if(_(o.charCodeAt(1))&&!_(o.charCodeAt(2))){let T=3;const M=T;for(;T<s&&!_(o.charCodeAt(T));T++);if(M!==T&&!_(o.charCodeAt(T+1))){for(T+=1;T<s;T++)if(_(o.charCodeAt(T)))return o.slice(0,T+1).replace(/[\\/]/g,f)}}return f}else if(d(h)&&o.charCodeAt(1)===58)return _(o.charCodeAt(2))?o.slice(0,2)+f:o.slice(0,2);let p=o.indexOf("://");if(p!==-1){for(p+=3;p<s;p++)if(_(o.charCodeAt(p)))return o.slice(0,p+1)}return""}e.getRoot=P;function O(o){if(!C.isWindows||!o||o.length<5)return!1;let f=o.charCodeAt(0);if(f!==92||(f=o.charCodeAt(1),f!==92))return!1;let s=2;const h=s;for(;s<o.length&&(f=o.charCodeAt(s),f!==92);s++);return!(h===s||(f=o.charCodeAt(s+1),isNaN(f)||f===92))}e.isUNC=O;const w=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,k=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(o,f=C.isWindows){const s=f?w:g;return!(!o||o.length===0||/^\s+$/.test(o)||(s.lastIndex=0,s.test(o))||f&&k.test(o)||o==="."||o===".."||f&&o[o.length-1]==="."||f&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=m;function a(o,f,s){const h=o===f;return!s||h?h:!o||!f?!1:(0,S.equalsIgnoreCase)(o,f)}e.isEqual=a;function u(o,f,s,h=r.sep){if(o===f)return!0;if(!o||!f||f.length>o.length)return!1;if(s){if(!(0,S.startsWithIgnoreCase)(o,f))return!1;if(f.length===o.length)return!0;let T=f.length;return f.charAt(f.length-1)===h&&T--,o.charAt(T)===h}return f.charAt(f.length-1)!==h&&(f+=h),o.indexOf(f)===0}e.isEqualOrParent=u;function d(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=d;function v(o,f){return C.isWindows&&o.endsWith(":")&&(o+=r.sep),(0,r.isAbsolute)(o)||(o=(0,r.join)(f,o)),o=(0,r.normalize)(o),C.isWindows?(o=(0,S.rtrim)(o,r.sep),o.endsWith(":")&&(o+=r.sep)):(o=(0,S.rtrim)(o,r.sep),o||(o=r.sep)),o}e.sanitizeFilePath=v;function D(o){const f=(0,r.normalize)(o);return C.isWindows?o.length>3?!1:c(f)&&(o.length===2||f.charCodeAt(2)===92):f===r.posix.sep}e.isRootOrDriveLetter=D;function c(o,f=C.isWindows){return f?d(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function b(o){return c(o)?o[0]:void 0}e.getDriveLetter=b;function t(o,f,s){return f.length>o.length?-1:o===f?0:(s&&(o=o.toLowerCase(),f=f.toLowerCase()),o.indexOf(f))}e.indexOfPath=t;function l(o){const f=o.split(":");let s,h,p;for(const T of f){const M=Number(T);(0,N.isNumber)(M)?h===void 0?h=M:p===void 0&&(p=M):s=s?[s,T].join(":"):T}if(!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:h!==void 0?h:void 0,column:p!==void 0?p:h!==void 0?1:void 0}}e.parseLineAndColumnAware=l;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(o,f,s=8){let h="";for(let T=0;T<s;T++)h+=i.charAt(Math.floor(Math.random()*i.length));let p;return f?p=`${f}-${h}`:p=h,o?(0,r.join)(o,p):p}e.randomPath=n}),define(Ce[24],Ie([1,0,18,9]),function(ie,e,r,C){"use strict";var S,N,_;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function A(i,n,o){let f=i.get(n);return f===void 0&&(f=o,i.set(n,f)),f}e.getOrSet=A;function E(i){const n=[];return i.forEach((o,f)=>{n.push(`${f} => ${o}`)}),`Map(${i.size}) {${n.join(", ")}}`}e.mapToString=E;function P(i){const n=[];return i.forEach(o=>{n.push(o)}),`Set(${i.size}) {${n.join(", ")}}`}e.setToString=P;class O{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const o=n.charCodeAt(0),f=this._value.charCodeAt(this._pos);return o-f}value(){return this._value[this._pos]}}e.StringIterator=O;class w{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,C.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,C.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=w;class g{constructor(n=!0,o=!0){this._splitOnBackslash=n,this._caseSensitive=o}reset(n){this._from=0,this._to=0,this._value=n,this._valueLen=n.length;for(let o=n.length-1;o>=0;o--,this._valueLen--){const f=this._value.charCodeAt(o);if(!(f===47||this._splitOnBackslash&&f===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let n=!0;for(;this._to<this._valueLen;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,C.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,C.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=g;var k;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(k||(k={}));class m{constructor(n,o){this._ignorePathCasing=n,this._ignoreQueryAndFragment=o,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new g(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(n)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,C.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,C.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,C.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,C.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=m;class a{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var u;(function(i){i[i.Left=-1]="Left",i[i.Mid=0]="Mid",i[i.Right=1]="Right"})(u||(u={}));class d{static forUris(n=()=>!1,o=()=>!1){return new d(new m(n,o))}static forPaths(n=!1){return new d(new g(void 0,!n))}static forStrings(){return new d(new O)}static forConfigKeys(){return new d(new w)}constructor(n){this._iter=n}clear(){this._root=void 0}fill(n,o){if(o){const f=o.slice(0);(0,r.shuffle)(f);for(const s of f)this.set(s,n)}else{const f=n.slice(0);(0,r.shuffle)(f);for(const s of f)this.set(s[0],s[1])}}set(n,o){const f=this._iter.reset(n);let s;this._root||(this._root=new a,this._root.segment=f.value());const h=[];for(s=this._root;;){const T=f.cmp(s.segment);if(T>0)s.left||(s.left=new a,s.left.segment=f.value()),h.push([-1,s]),s=s.left;else if(T<0)s.right||(s.right=new a,s.right.segment=f.value()),h.push([1,s]),s=s.right;else if(f.hasNext())f.next(),s.mid||(s.mid=new a,s.mid.segment=f.value()),h.push([0,s]),s=s.mid;else break}const p=s.value;s.value=o,s.key=n;for(let T=h.length-1;T>=0;T--){const M=h[T][1];M.updateHeight();const V=M.balanceFactor();if(V<-1||V>1){const U=h[T][0],y=h[T+1][0];if(U===1&&y===1)h[T][1]=M.rotateLeft();else if(U===-1&&y===-1)h[T][1]=M.rotateRight();else if(U===1&&y===-1)M.right=h[T+1][1]=h[T+1][1].rotateRight(),h[T][1]=M.rotateLeft();else if(U===-1&&y===1)M.left=h[T+1][1]=h[T+1][1].rotateLeft(),h[T][1]=M.rotateRight();else throw new Error;if(T>0)switch(h[T-1][0]){case-1:h[T-1][1].left=h[T][1];break;case 1:h[T-1][1].right=h[T][1];break;case 0:h[T-1][1].mid=h[T][1];break}else this._root=h[0][1]}}return p}get(n){return this._getNode(n)?.value}_getNode(n){const o=this._iter.reset(n);let f=this._root;for(;f;){const s=o.cmp(f.segment);if(s>0)f=f.left;else if(s<0)f=f.right;else if(o.hasNext())o.next(),f=f.mid;else break}return f}has(n){const o=this._getNode(n);return!(o?.value===void 0&&o?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,o){const f=this._iter.reset(n),s=[];let h=this._root;for(;h;){const p=f.cmp(h.segment);if(p>0)s.push([-1,h]),h=h.left;else if(p<0)s.push([1,h]),h=h.right;else if(f.hasNext())f.next(),s.push([0,h]),h=h.mid;else break}if(!!h){if(o?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const p=this._min(h.right);if(p.key){const{key:T,value:M,segment:V}=p;this._delete(p.key,!1),h.key=T,h.value=M,h.segment=V}}else{const p=h.left??h.right;if(s.length>0){const[T,M]=s[s.length-1];switch(T){case-1:M.left=p;break;case 0:M.mid=p;break;case 1:M.right=p;break}}else this._root=p}for(let p=s.length-1;p>=0;p--){const T=s[p][1];T.updateHeight();const M=T.balanceFactor();if(M>1?(T.right.balanceFactor()>=0||(T.right=T.right.rotateRight()),s[p][1]=T.rotateLeft()):M<-1&&(T.left.balanceFactor()<=0||(T.left=T.left.rotateLeft()),s[p][1]=T.rotateRight()),p>0)switch(s[p-1][0]){case-1:s[p-1][1].left=s[p][1];break;case 1:s[p-1][1].right=s[p][1];break;case 0:s[p-1][1].mid=s[p][1];break}else this._root=s[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const o=this._iter.reset(n);let f=this._root,s;for(;f;){const h=o.cmp(f.segment);if(h>0)f=f.left;else if(h<0)f=f.right;else if(o.hasNext())o.next(),s=f.value||s,f=f.mid;else break}return f&&f.value||s}findSuperstr(n){const o=this._iter.reset(n);let f=this._root;for(;f;){const s=o.cmp(f.segment);if(s>0)f=f.left;else if(s<0)f=f.right;else if(o.hasNext())o.next(),f=f.mid;else return f.mid?this._entries(f.mid):void 0}}forEach(n){for(const[o,f]of this)n(f,o)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(n){const o=[];return this._dfsEntries(n,o),o[Symbol.iterator]()}_dfsEntries(n,o){!n||(n.left&&this._dfsEntries(n.left,o),n.value&&o.push([n.key,n.value]),n.mid&&this._dfsEntries(n.mid,o),n.right&&this._dfsEntries(n.right,o))}_isBalanced(){const n=o=>{if(!o)return!0;const f=o.balanceFactor();return f<-1||f>1?!1:n(o.left)&&n(o.right)};return n(this._root)}}e.TernarySearchTree=d;class v{constructor(n,o){this.uri=n,this.value=o}}class D{constructor(n,o){this[S]="ResourceMap",n instanceof D?(this.map=new Map(n.map),this.toKey=o??D.defaultToKey):(this.map=new Map,this.toKey=n??D.defaultToKey)}set(n,o){return this.map.set(this.toKey(n),new v(n,o)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,o){typeof o<"u"&&(n=n.bind(o));for(const[f,s]of this.map)n(s.value,s.uri,this)}*values(){for(const n of this.map.values())yield n.value}*keys(){for(const n of this.map.values())yield n.uri}*entries(){for(const n of this.map.values())yield[n.uri,n.value]}*[(S=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=D,D.defaultToKey=i=>i.toString();class c{constructor(n,o){this[N]="ResourceSet",!n||typeof n=="function"?this._map=new D(n):(this._map=new D(o),n.forEach(this.add,this))}get size(){return this._map.size}add(n){return this._map.set(n,n),this}clear(){this._map.clear()}delete(n){return this._map.delete(n)}forEach(n,o){this._map.forEach((f,s)=>n.call(o,s,s,this))}has(n){return this._map.has(n)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=c;var b;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(b=e.Touch||(e.Touch={}));class t{constructor(){this[_]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,o=0){const f=this._map.get(n);if(!!f)return o!==0&&this.touch(f,o),f.value}set(n,o,f=0){let s=this._map.get(n);if(s)s.value=o,f!==0&&this.touch(s,f);else{switch(s={key:n,value:o,next:void 0,previous:void 0},f){case 0:this.addItemLast(s);break;case 1:this.addItemFirst(s);break;case 2:this.addItemLast(s);break;default:this.addItemLast(s);break}this._map.set(n,s),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const o=this._map.get(n);if(!!o)return this._map.delete(n),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,o){const f=this._state;let s=this._head;for(;s;){if(o?n.bind(o)(s.value,s.key,this):n(s.value,s.key,this),this._state!==f)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const n=this,o=this._state;let f=this._head;const s={[Symbol.iterator](){return s},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(f){const h={value:f.key,done:!1};return f=f.next,h}else return{value:void 0,done:!0}}};return s}values(){const n=this,o=this._state;let f=this._head;const s={[Symbol.iterator](){return s},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(f){const h={value:f.value,done:!1};return f=f.next,h}else return{value:void 0,done:!0}}};return s}entries(){const n=this,o=this._state;let f=this._head;const s={[Symbol.iterator](){return s},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(f){const h={value:[f.key,f.value],done:!1};return f=f.next,h}else return{value:void 0,done:!0}}};return s}[(_=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let o=this._head,f=this.size;for(;o&&f>n;)this._map.delete(o.key),o=o.next,f--;this._head=o,this._size=f,o&&(o.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const o=n.next,f=n.previous;if(!o||!f)throw new Error("Invalid list");o.previous=f,f.next=o}n.next=void 0,n.previous=void 0,this._state++}touch(n,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(n===this._head)return;const f=n.next,s=n.previous;n===this._tail?(s.next=void 0,this._tail=s):(f.previous=s,s.next=f),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(o===2){if(n===this._tail)return;const f=n.next,s=n.previous;n===this._head?(f.previous=void 0,this._head=f):(f.previous=s,s.next=f),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((o,f)=>{n.push([f,o])}),n}fromJSON(n){this.clear();for(const[o,f]of n)this.set(o,f)}}e.LinkedMap=t;class l extends t{constructor(n,o=1){super(),this._limit=n,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,o=2){return super.get(n,o)}peek(n){return super.get(n,0)}set(n,o){return super.set(n,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=l}),define(Ce[115],Ie([1,0,24,9]),function(ie,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function S(...Z){return function(J,I){for(let B=0,H=Z.length;B<H;B++){const j=Z[B](J,I);if(j)return j}return null}}e.or=S,e.matchesStrictPrefix=N.bind(void 0,!1),e.matchesPrefix=N.bind(void 0,!0);function N(Z,J,I){if(!I||I.length<J.length)return null;let B;return Z?B=C.startsWithIgnoreCase(I,J):B=I.indexOf(J)===0,B?J.length>0?[{start:0,end:J.length}]:[]:null}function _(Z,J){const I=J.toLowerCase().indexOf(Z.toLowerCase());return I===-1?null:[{start:I,end:I+Z.length}]}e.matchesContiguousSubString=_;function A(Z,J){return E(Z.toLowerCase(),J.toLowerCase(),0,0)}e.matchesSubString=A;function E(Z,J,I,B){if(I===Z.length)return[];if(B===J.length)return null;if(Z[I]===J[B]){let H=null;return(H=E(Z,J,I+1,B+1))?d({start:B,end:B+1},H):null}return E(Z,J,I,B+1)}function P(Z){return 97<=Z&&Z<=122}function O(Z){return 65<=Z&&Z<=90}e.isUpper=O;function w(Z){return 48<=Z&&Z<=57}function g(Z){return Z===32||Z===9||Z===10||Z===13}const k=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Z=>k.add(Z.charCodeAt(0)));function m(Z){return g(Z)||k.has(Z)}function a(Z,J){return Z===J||m(Z)&&m(J)}function u(Z){return P(Z)||O(Z)||w(Z)}function d(Z,J){return J.length===0?J=[Z]:Z.end===J[0].start?J[0].start=Z.start:J.unshift(Z),J}function v(Z,J){for(let I=J;I<Z.length;I++){const B=Z.charCodeAt(I);if(O(B)||w(B)||I>0&&!u(Z.charCodeAt(I-1)))return I}return Z.length}function D(Z,J,I,B){if(I===Z.length)return[];if(B===J.length)return null;if(Z[I]!==J[B].toLowerCase())return null;{let H=null,j=B+1;for(H=D(Z,J,I+1,B+1);!H&&(j=v(J,j))<J.length;)H=D(Z,J,I+1,j),j++;return H===null?null:d({start:B,end:B+1},H)}}function c(Z){let J=0,I=0,B=0,H=0,j=0;for(let pe=0;pe<Z.length;pe++)j=Z.charCodeAt(pe),O(j)&&J++,P(j)&&I++,u(j)&&B++,w(j)&&H++;const se=J/Z.length,le=I/Z.length,Y=B/Z.length,ve=H/Z.length;return{upperPercent:se,lowerPercent:le,alphaPercent:Y,numericPercent:ve}}function b(Z){const{upperPercent:J,lowerPercent:I}=Z;return I===0&&J>.6}function t(Z){const{upperPercent:J,lowerPercent:I,alphaPercent:B,numericPercent:H}=Z;return I>.2&&J<.8&&B>.6&&H<.2}function l(Z){let J=0,I=0,B=0,H=0;for(let j=0;j<Z.length;j++)B=Z.charCodeAt(j),O(B)&&J++,P(B)&&I++,g(B)&&H++;return(J===0||I===0)&&H===0?Z.length<=30:J<=5}function i(Z,J){if(!J||(J=J.trim(),J.length===0)||!l(Z)||J.length>60)return null;const I=c(J);if(!t(I)){if(!b(I))return null;J=J.toLowerCase()}let B=null,H=0;for(Z=Z.toLowerCase();H<J.length&&(B=D(Z,J,0,H))===null;)H=v(J,H+1);return B}e.matchesCamelCase=i;function n(Z,J,I=!1){if(!J||J.length===0)return null;let B=null,H=0;for(Z=Z.toLowerCase(),J=J.toLowerCase();H<J.length&&(B=o(Z,J,0,H,I))===null;)H=f(J,H+1);return B}e.matchesWords=n;function o(Z,J,I,B,H){if(I===Z.length)return[];if(B===J.length)return null;if(a(Z.charCodeAt(I),J.charCodeAt(B))){let j=null,se=B+1;if(j=o(Z,J,I+1,B+1,H),!H)for(;!j&&(se=f(J,se))<J.length;)j=o(Z,J,I+1,se,H),se++;return j?Z.charCodeAt(I)!==J.charCodeAt(B)?j:d({start:B,end:B+1},j):null}else return null}function f(Z,J){for(let I=J;I<Z.length;I++)if(m(Z.charCodeAt(I))||I>0&&m(Z.charCodeAt(I-1)))return I;return Z.length}const s=S(e.matchesPrefix,i,_),h=S(e.matchesPrefix,i,A),p=new r.LRUCache(1e4);function T(Z,J,I=!1){if(typeof Z!="string"||typeof J!="string")return null;let B=p.get(Z);B||(B=new RegExp(C.convertSimple2RegExpPattern(Z),"i"),p.set(Z,B));const H=B.exec(J);return H?[{start:H.index,end:H.index+H[0].length}]:I?h(Z,J):s(Z,J)}e.matchesFuzzy=T;function M(Z,J){const I=Be(Z,Z.toLowerCase(),0,J,J.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return I?U(I):null}e.matchesFuzzy2=M;function V(Z,J,I,B,H,j){const se=Math.min(13,Z.length);for(;I<se;I++){const le=Be(Z,J,I,B,H,j,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(le)return le}return[0,j]}e.anyScore=V;function U(Z){if(typeof Z>"u")return[];const J=[],I=Z[1];for(let B=Z.length-1;B>1;B--){const H=Z[B]+I,j=J[J.length-1];j&&j.end===H?j.end=H+1:J.push({start:H,end:H+1})}return J}e.createMatches=U;const y=128;function x(){const Z=[],J=[];for(let I=0;I<=y;I++)J[I]=0;for(let I=0;I<=y;I++)Z.push(J.slice(0));return Z}function L(Z){const J=[];for(let I=0;I<=Z;I++)J[I]=0;return J}const R=L(2*y),K=L(2*y),W=x(),$=x(),G=x(),re=!1;function ge(Z,J,I,B,H){function j(le,Y,ve=" "){for(;le.length<Y;)le=ve+le;return le}let se=` |   |${B.split("").map(le=>j(le,3)).join("|")}
`;for(let le=0;le<=I;le++)le===0?se+=" |":se+=`${J[le-1]}|`,se+=Z[le].slice(0,H+1).map(Y=>j(Y.toString(),3)).join("|")+`
`;return se}function oe(Z,J,I,B){Z=Z.substr(J),I=I.substr(B),console.log(ge($,Z,Z.length,I,I.length)),console.log(ge(G,Z,Z.length,I,I.length)),console.log(ge(W,Z,Z.length,I,I.length))}function Ee(Z,J){if(J<0||J>=Z.length)return!1;const I=Z.codePointAt(J);switch(I){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!C.isEmojiImprecise(I)}}function ce(Z,J){if(J<0||J>=Z.length)return!1;switch(Z.charCodeAt(J)){case 32:case 9:return!0;default:return!1}}function me(Z,J,I){return J[Z]!==I[Z]}function ee(Z,J,I,B,H,j,se=!1){for(;J<I&&H<j;)Z[J]===B[H]&&(se&&(R[J]=H),J+=1),H+=1;return J===I}e.isPatternInWord=ee;var be;(function(Z){Z[Z.Diag=1]="Diag",Z[Z.Left=2]="Left",Z[Z.LeftLeft=3]="LeftLeft"})(be||(be={}));var _e;(function(Z){Z.Default=[-100,0];function J(I){return!I||I.length===2&&I[0]===-100&&I[1]===0}Z.isDefault=J})(_e=e.FuzzyScore||(e.FuzzyScore={}));class Fe{constructor(J,I){this.firstMatchCanBeWeak=J,this.boostFullMatch=I}}e.FuzzyScoreOptions=Fe,Fe.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Be(Z,J,I,B,H,j,se=Fe.default){const le=Z.length>y?y:Z.length,Y=B.length>y?y:B.length;if(I>=le||j>=Y||le-I>Y-j||!ee(J,I,le,H,j,Y,!0))return;Xe(le,Y,I,j,J,H);let ve=1,pe=1,Ne=I,xe=j;const Ye=[!1];for(ve=1,Ne=I;Ne<le;ve++,Ne++){const Q=R[Ne],he=K[Ne],Ue=Ne+1<le?K[Ne+1]:Y;for(pe=Q-j+1,xe=Q;xe<Ue;pe++,xe++){let je=Number.MIN_SAFE_INTEGER,Ze=!1;xe<=he&&(je=ke(Z,J,Ne,I,B,H,xe,Y,j,W[ve-1][pe-1]===0,Ye));let Ke=0;je!==Number.MAX_SAFE_INTEGER&&(Ze=!0,Ke=je+$[ve-1][pe-1]);const Ve=xe>Q,it=Ve?$[ve][pe-1]+(W[ve][pe-1]>0?-5:0):0,st=xe>Q+1&&W[ve][pe-1]>0,dt=st?$[ve][pe-2]+(W[ve][pe-2]>0?-5:0):0;if(st&&(!Ve||dt>=it)&&(!Ze||dt>=Ke))$[ve][pe]=dt,G[ve][pe]=3,W[ve][pe]=0;else if(Ve&&(!Ze||it>=Ke))$[ve][pe]=it,G[ve][pe]=2,W[ve][pe]=0;else if(Ze)$[ve][pe]=Ke,G[ve][pe]=1,W[ve][pe]=W[ve-1][pe-1]+1;else throw new Error("not possible")}}if(re&&oe(Z,I,B,j),!Ye[0]&&!se.firstMatchCanBeWeak)return;ve--,pe--;const Ge=[$[ve][pe],j];let Te=0,rt=0;for(;ve>=1;){let Q=pe;do{const he=G[ve][Q];if(he===3)Q=Q-2;else if(he===2)Q=Q-1;else break}while(Q>=1);Te>1&&J[I+ve-1]===H[j+pe-1]&&!me(Q+j-1,B,H)&&Te+1>W[ve][Q]&&(Q=pe),Q===pe?Te++:Te=1,rt||(rt=Q),ve--,pe=Q-1,Ge.push(pe)}Y===le&&se.boostFullMatch&&(Ge[0]+=2);const X=rt-le;return Ge[0]-=X,Ge}e.fuzzyScore=Be;function Xe(Z,J,I,B,H,j){let se=Z-1,le=J-1;for(;se>=I&&le>=B;)H[se]===j[le]&&(K[se]=le,se--),le--}function ke(Z,J,I,B,H,j,se,le,Y,ve,pe){if(J[I]!==j[se])return Number.MIN_SAFE_INTEGER;let Ne=1,xe=!1;return se===I-B?Ne=Z[I]===H[se]?7:5:me(se,H,j)&&(se===0||!me(se-1,H,j))?(Ne=Z[I]===H[se]?7:5,xe=!0):Ee(j,se)&&(se===0||!Ee(j,se-1))?Ne=5:(Ee(j,se-1)||ce(j,se-1))&&(Ne=5,xe=!0),Ne>1&&I===B&&(pe[0]=!0),xe||(xe=me(se,H,j)||Ee(j,se-1)||ce(j,se-1)),I===B?se>Y&&(Ne-=xe?3:5):ve?Ne+=xe?2:0:Ne+=xe?0:1,se+1===le&&(Ne-=xe?3:5),Ne}function ye(Z,J,I,B,H,j,se){return ae(Z,J,I,B,H,j,!0,se)}e.fuzzyScoreGracefulAggressive=ye;function De(Z,J,I,B,H,j,se){return ae(Z,J,I,B,H,j,!1,se)}e.fuzzyScoreGraceful=De;function ae(Z,J,I,B,H,j,se,le){let Y=Be(Z,J,I,B,H,j,le);if(Y&&!se)return Y;if(Z.length>=3){const ve=Math.min(7,Z.length-1);for(let pe=I+1;pe<ve;pe++){const Ne=ue(Z,pe);if(Ne){const xe=Be(Ne,Ne.toLowerCase(),I,B,H,j,le);xe&&(xe[0]-=3,(!Y||xe[0]>Y[0])&&(Y=xe))}}}return Y}function ue(Z,J){if(J+1>=Z.length)return;const I=Z[J],B=Z[J+1];if(I!==B)return Z.slice(0,J)+B+I+Z.slice(J+2)}}),define(Ce[116],Ie([1,0,117,115,9]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const N=new RegExp(`\\$\\(${r.CSSIcon.iconNameExpression}(?:${r.CSSIcon.iconModifierExpression})?\\)`,"g"),_=new RegExp(r.CSSIcon.iconNameCharacter),A=new RegExp(`(\\\\)?${N.source}`,"g");function E(u){return u.replace(A,(d,v)=>v?d:`\\${d}`)}e.escapeIcons=E;const P=new RegExp(`\\\\${N.source}`,"g");function O(u){return u.replace(P,d=>`\\${d}`)}e.markdownEscapeEscapedIcons=O;const w=new RegExp(`(\\s)?(\\\\)?${N.source}(\\s)?`,"g");function g(u){return u.indexOf(e.iconStartMarker)===-1?u:u.replace(w,(d,v,D,c)=>D?d:v||c||"")}e.stripIcons=g;function k(u){const d=u.indexOf(e.iconStartMarker);return d===-1?{text:u}:m(u,d)}e.parseLabelWithIcons=k;function m(u,d){const v=[];let D="";function c(s){if(s){D+=s;for(const h of s)v.push(l)}}let b=-1,t="",l=0,i,n,o=d;const f=u.length;for(c(u.substr(0,d));o<f;)i=u[o],n=u[o+1],i===e.iconStartMarker[0]&&n===e.iconStartMarker[1]?(b=o,c(t),t=e.iconStartMarker,o++):i===")"&&b!==-1?(l+=o-b+1,b=-1,t=""):b!==-1?_.test(i)?t+=i:(c(t),b=-1,t=""):c(i),o++;return c(t),{text:D,iconOffsets:v}}function a(u,d,v=!1){const{text:D,iconOffsets:c}=d;if(!c||c.length===0)return(0,C.matchesFuzzy)(u,D,v);const b=(0,S.ltrim)(D," "),t=D.length-b.length,l=(0,C.matchesFuzzy)(u,b,v);if(l)for(const i of l){const n=c[i.start+t]+t;i.start+=n,i.end+=n}return l}e.matchesFuzzyIconAware=a}),define(Ce[29],Ie([1,0,9]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var C;(function(S){S[S.Ignore=0]="Ignore",S[S.Info=1]="Info",S[S.Warning=2]="Warning",S[S.Error=3]="Error"})(C||(C={})),function(S){const N="error",_="warning",A="warn",E="info",P="ignore";function O(g){return g?r.equalsIgnoreCase(N,g)?S.Error:r.equalsIgnoreCase(_,g)||r.equalsIgnoreCase(A,g)?S.Warning:r.equalsIgnoreCase(E,g)?S.Info:S.Ignore:S.Ignore}S.fromValue=O;function w(g){switch(g){case S.Error:return N;case S.Warning:return _;case S.Info:return E;default:return P}}S.toString=w}(C||(C={})),e.default=C}),define(Ce[76],Ie([1,0,23,9,2]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function N(P){return JSON.stringify(P,A)}e.stringify=N;function _(P){let O=JSON.parse(P);return O=E(O),O}e.parse=_;function A(P,O){return O instanceof RegExp?{$mid:2,source:O.source,flags:(0,C.regExpFlags)(O)}:O}function E(P,O=0){if(!P||O>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return S.URI.revive(P);case 2:return new RegExp(P.source,P.flags);case 14:return new Date(P.source)}if(P instanceof r.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let w=0;w<P.length;++w)P[w]=E(P[w],O+1);else for(const w in P)Object.hasOwnProperty.call(P,w)&&(P[w]=E(P[w],O+1))}return P}e.revive=E}),define(Ce[13],Ie([1,0,21,2]),function(ie,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var S;(function(E){E.inMemory="inmemory",E.vscode="vscode",E.internal="private",E.walkThrough="walkThrough",E.walkThroughSnippet="walkThroughSnippet",E.http="http",E.https="https",E.file="file",E.mailto="mailto",E.untitled="untitled",E.data="data",E.command="command",E.vscodeRemote="vscode-remote",E.vscodeRemoteResource="vscode-remote-resource",E.vscodeUserData="vscode-userdata",E.vscodeCustomEditor="vscode-custom-editor",E.vscodeNotebook="vscode-notebook",E.vscodeNotebookCell="vscode-notebook-cell",E.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",E.vscodeNotebookCellOutput="vscode-notebook-cell-output",E.vscodeInteractive="vscode-interactive",E.vscodeInteractiveInput="vscode-interactive-input",E.vscodeSettings="vscode-settings",E.vscodeWorkspaceTrust="vscode-workspace-trust",E.vscodeTerminal="vscode-terminal",E.webviewPanel="webview-panel",E.vscodeWebview="vscode-webview",E.extension="extension",E.vscodeFileResource="vscode-file",E.tmp="tmp",E.vsls="vsls",E.vscodeSourceControl="vscode-scm"})(S=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class N{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${S.vscodeRemoteResource}`}setPreferredWebSchema(P){this._preferredWebSchema=P}setDelegate(P){this._delegate=P}setServerRootPath(P){this._remoteResourcesPath=`${P}/${S.vscodeRemoteResource}`}set(P,O,w){this._hosts[P]=O,this._ports[P]=w}setConnectionToken(P,O){this._connectionTokens[P]=O}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(P){if(this._delegate)return this._delegate(P);const O=P.authority;let w=this._hosts[O];w&&w.indexOf(":")!==-1&&w.indexOf("[")===-1&&(w=`[${w}]`);const g=this._ports[O],k=this._connectionTokens[O];let m=`path=${encodeURIComponent(P.path)}`;return typeof k=="string"&&(m+=`&${e.connectionTokenQueryName}=${encodeURIComponent(k)}`),C.URI.from({scheme:r.isWeb?this._preferredWebSchema:S.vscodeRemoteResource,authority:`${w}:${g}`,path:this._remoteResourcesPath,query:m})}}e.RemoteAuthorities=new N;class _{asBrowserUri(P,O){const w=this.toUri(P,O);return w.scheme===S.vscodeRemote?e.RemoteAuthorities.rewrite(w):w.scheme===S.file&&(r.isNative||r.isWebWorker&&r.globals.origin===`${S.vscodeFileResource}://${_.FALLBACK_AUTHORITY}`)?w.with({scheme:S.vscodeFileResource,authority:w.authority||_.FALLBACK_AUTHORITY,query:null,fragment:null}):w}asFileUri(P,O){const w=this.toUri(P,O);return w.scheme===S.vscodeFileResource?w.with({scheme:S.file,authority:w.authority!==_.FALLBACK_AUTHORITY?w.authority:null,query:null,fragment:null}):w}toUri(P,O){return C.URI.isUri(P)?P:C.URI.parse(O.toUrl(P))}}_.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new _;var A;(function(E){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);E.CoopAndCoep=Object.freeze(P.get("3"));const O="vscode-coi";function w(k){let m;typeof k=="string"?m=new URL(k).searchParams:k instanceof URL?m=k.searchParams:C.URI.isUri(k)&&(m=new URL(k.toString(!0)).searchParams);const a=m?.get(O);if(!!a)return P.get(a)}E.getHeadersFromQuery=w;function g(k,m,a){if(!globalThis.crossOriginIsolated)return;const u=m&&a?"3":a?"2":"1";k instanceof URLSearchParams?k.set(O,u):k[O]=u}E.addSearchParam=g})(A=e.COI||(e.COI={}))}),define(Ce[22],Ie([1,0,38,13,19,21,9,2]),function(ie,e,r,C,S,N,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function E(k){return(0,A.uriToFsPath)(k,!0)}e.originalFSPath=E;class P{constructor(m){this._ignorePathCasing=m}compare(m,a,u=!1){return m===a?0:(0,_.compare)(this.getComparisonKey(m,u),this.getComparisonKey(a,u))}isEqual(m,a,u=!1){return m===a?!0:!m||!a?!1:this.getComparisonKey(m,u)===this.getComparisonKey(a,u)}getComparisonKey(m,a=!1){return m.with({path:this._ignorePathCasing(m)?m.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(m){return this._ignorePathCasing(m)}isEqualOrParent(m,a,u=!1){if(m.scheme===a.scheme){if(m.scheme===C.Schemas.file)return r.isEqualOrParent(E(m),E(a),this._ignorePathCasing(m))&&m.query===a.query&&(u||m.fragment===a.fragment);if((0,e.isEqualAuthority)(m.authority,a.authority))return r.isEqualOrParent(m.path,a.path,this._ignorePathCasing(m),"/")&&m.query===a.query&&(u||m.fragment===a.fragment)}return!1}joinPath(m,...a){return A.URI.joinPath(m,...a)}basenameOrAuthority(m){return(0,e.basename)(m)||m.authority}basename(m){return S.posix.basename(m.path)}extname(m){return S.posix.extname(m.path)}dirname(m){if(m.path.length===0)return m;let a;return m.scheme===C.Schemas.file?a=A.URI.file(S.dirname(E(m))).path:(a=S.posix.dirname(m.path),m.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),a="/")),m.with({path:a})}normalizePath(m){if(!m.path.length)return m;let a;return m.scheme===C.Schemas.file?a=A.URI.file(S.normalize(E(m))).path:a=S.posix.normalize(m.path),m.with({path:a})}relativePath(m,a){if(m.scheme!==a.scheme||!(0,e.isEqualAuthority)(m.authority,a.authority))return;if(m.scheme===C.Schemas.file){const v=S.relative(E(m),E(a));return N.isWindows?r.toSlashes(v):v}let u=m.path||"/";const d=a.path||"/";if(this._ignorePathCasing(m)){let v=0;for(const D=Math.min(u.length,d.length);v<D&&!(u.charCodeAt(v)!==d.charCodeAt(v)&&u.charAt(v).toLowerCase()!==d.charAt(v).toLowerCase());v++);u=d.substr(0,v)+u.substr(v)}return S.posix.relative(u,d)}resolvePath(m,a){if(m.scheme===C.Schemas.file){const u=A.URI.file(S.resolve(E(m),a));return m.with({authority:u.authority,path:u.path})}return a=r.toPosixPath(a),m.with({path:S.posix.resolve(m.path,a)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,a){return m===a||m!==void 0&&a!==void 0&&(0,_.equalsIgnoreCase)(m,a)}hasTrailingPathSeparator(m,a=S.sep){if(m.scheme===C.Schemas.file){const u=E(m);return u.length>r.getRoot(u).length&&u[u.length-1]===a}else{const u=m.path;return u.length>1&&u.charCodeAt(u.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,a=S.sep){return(0,e.hasTrailingPathSeparator)(m,a)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,a=S.sep){let u=!1;if(m.scheme===C.Schemas.file){const d=E(m);u=d!==void 0&&d.length===r.getRoot(d).length&&d[d.length-1]===a}else{a="/";const d=m.path;u=d.length===1&&d.charCodeAt(d.length-1)===47}return!u&&!(0,e.hasTrailingPathSeparator)(m,a)?m.with({path:m.path+"/"}):m}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(k=>k.scheme===C.Schemas.file?!N.isLinux:!0),e.extUriIgnorePathCase=new P(k=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function O(k,m){const a=[];for(let u=0;u<k.length;u++){const d=m(k[u]);k.some((v,D)=>D===u?!1:(0,e.isEqualOrParent)(d,m(v)))||a.push(k[u])}return a}e.distinctParents=O;var w;(function(k){k.META_DATA_LABEL="label",k.META_DATA_DESCRIPTION="description",k.META_DATA_SIZE="size",k.META_DATA_MIME="mime";function m(a){const u=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(D=>{const[c,b]=D.split(":");c&&b&&u.set(c,b)});const v=a.path.substring(0,a.path.indexOf(";"));return v&&u.set(k.META_DATA_MIME,v),u}k.parseMetaData=m})(w=e.DataUri||(e.DataUri={}));function g(k,m,a){if(m){let u=k.path;return u&&u[0]!==S.posix.sep&&(u=S.posix.sep+u),k.with({scheme:a,authority:m,path:u})}return k.with({scheme:a})}e.toLocalResource=g}),define(Ce[15],Ie([1,0,20,12,5,7,22,21]),function(ie,e,r,C,S,N,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(me){return!!me&&typeof me.then=="function"}e.isThenable=E;function P(me){const ee=new r.CancellationTokenSource,be=me(ee.token),_e=new Promise((Fe,Be)=>{const Xe=ee.token.onCancellationRequested(()=>{Xe.dispose(),ee.dispose(),Be(new C.CancellationError)});Promise.resolve(be).then(ke=>{Xe.dispose(),ee.dispose(),Fe(ke)},ke=>{Xe.dispose(),ee.dispose(),Be(ke)})});return new class{cancel(){ee.cancel()}then(Fe,Be){return _e.then(Fe,Be)}catch(Fe){return this.then(void 0,Fe)}finally(Fe){return _e.finally(Fe)}}}e.createCancelablePromise=P;function O(me,ee,be){return new Promise((_e,Fe)=>{const Be=ee.onCancellationRequested(()=>{Be.dispose(),_e(be)});me.then(_e,Fe).finally(()=>Be.dispose())})}e.raceCancellation=O;function w(me,ee){return new Promise((be,_e)=>{const Fe=ee.onCancellationRequested(()=>{Fe.dispose(),_e(new C.CancellationError)});me.then(be,_e).finally(()=>Fe.dispose())})}e.raceCancellationError=w;async function g(me){let ee=-1;const be=me.map((Fe,Be)=>Fe.then(Xe=>(ee=Be,Xe))),_e=await Promise.race(be);return me.forEach((Fe,Be)=>{Be!==ee&&Fe.cancel()}),_e}e.raceCancellablePromises=g;function k(me,ee,be){let _e;const Fe=setTimeout(()=>{_e?.(void 0),be?.()},ee);return Promise.race([me.finally(()=>clearTimeout(Fe)),new Promise(Be=>_e=Be)])}e.raceTimeout=k;function m(me){return new Promise((ee,be)=>{const _e=me();E(_e)?_e.then(ee,be):ee(_e)})}e.asPromise=m;class a{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(ee){if(this.activePromise){if(this.queuedPromiseFactory=ee,!this.queuedPromise){const be=()=>{this.queuedPromise=null;const _e=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,_e};this.queuedPromise=new Promise(_e=>{this.activePromise.then(be,be).then(_e)})}return new Promise((be,_e)=>{this.queuedPromise.then(be,_e)})}return this.activePromise=ee(),new Promise((be,_e)=>{this.activePromise.then(Fe=>{this.activePromise=null,be(Fe)},Fe=>{this.activePromise=null,_e(Fe)})})}}e.Throttler=a;class u{constructor(){this.current=Promise.resolve(null)}queue(ee){return this.current=this.current.then(()=>ee(),()=>ee())}}e.Sequencer=u;class d{constructor(){this.promiseMap=new Map}queue(ee,be){const Fe=(this.promiseMap.get(ee)??Promise.resolve()).catch(()=>{}).then(be).finally(()=>{this.promiseMap.get(ee)===Fe&&this.promiseMap.delete(ee)});return this.promiseMap.set(ee,Fe),Fe}}e.SequencerByKey=d;const v=(me,ee)=>{let be=!0;const _e=setTimeout(()=>{be=!1,ee()},me);return{isTriggered:()=>be,dispose:()=>{clearTimeout(_e),be=!1}}},D=me=>{let ee=!0;return queueMicrotask(()=>{ee&&(ee=!1,me())}),{isTriggered:()=>ee,dispose:()=>{ee=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class c{constructor(ee){this.defaultDelay=ee,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(ee,be=this.defaultDelay){this.task=ee,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Fe,Be)=>{this.doResolve=Fe,this.doReject=Be}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Fe=this.task;return this.task=null,Fe()}}));const _e=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=be===e.MicrotaskDelay?D(_e):v(be,_e),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new C.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=c;class b{constructor(ee){this.delayer=new c(ee),this.throttler=new a}trigger(ee,be){return this.delayer.trigger(()=>this.throttler.queue(ee),be)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class t{constructor(){this._isOpen=!1,this._promise=new Promise((ee,be)=>{this._completePromise=ee})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=t;class l extends t{constructor(ee){super(),this._timeout=setTimeout(()=>this.open(),ee)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function i(me,ee){return ee?new Promise((be,_e)=>{const Fe=setTimeout(()=>{Be.dispose(),be()},me),Be=ee.onCancellationRequested(()=>{clearTimeout(Fe),Be.dispose(),_e(new C.CancellationError)})}):P(be=>i(me,be))}e.timeout=i;function n(me,ee=0){const be=setTimeout(me,ee);return(0,N.toDisposable)(()=>clearTimeout(be))}e.disposableTimeout=n;function o(me){const ee=[];let be=0;const _e=me.length;function Fe(){return be<_e?me[be++]():null}function Be(Xe){Xe!=null&&ee.push(Xe);const ke=Fe();return ke?ke.then(Be):Promise.resolve(ee)}return Promise.resolve(null).then(Be)}e.sequence=o;function f(me,ee=_e=>!!_e,be=null){let _e=0;const Fe=me.length,Be=()=>{if(_e>=Fe)return Promise.resolve(be);const Xe=me[_e++];return Promise.resolve(Xe()).then(ye=>ee(ye)?Promise.resolve(ye):Be())};return Be()}e.first=f;function s(me,ee=_e=>!!_e,be=null){if(me.length===0)return Promise.resolve(be);let _e=me.length;const Fe=()=>{_e=-1;for(const Be of me)Be.cancel?.()};return new Promise((Be,Xe)=>{for(const ke of me)ke.then(ye=>{--_e>=0&&ee(ye)?(Fe(),Be(ye)):_e===0&&Be(be)}).catch(ye=>{--_e>=0&&(Fe(),Xe(ye))})})}e.firstParallel=s;class h{constructor(ee){this._size=0,this.maxDegreeOfParalellism=ee,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new S.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(ee){return this._size++,new Promise((be,_e)=>{this.outstandingPromises.push({factory:ee,c:be,e:_e}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const ee=this.outstandingPromises.shift();this.runningPromises++;const be=ee.factory();be.then(ee.c,ee.e),be.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=h;class p extends h{constructor(){super(1)}}e.Queue=p;class T{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const ee=new G;return this.drainers.add(ee),ee.p}isDrained(){for(const[,ee]of this.queues)if(ee.size>0)return!1;return!0}queueFor(ee,be=_.extUri){const _e=be.getComparisonKey(ee);let Fe=this.queues.get(_e);return Fe||(Fe=new p,S.Event.once(Fe.onDrained)(()=>{Fe?.dispose(),this.queues.delete(_e),this.onDidQueueDrain()}),this.queues.set(_e,Fe)),Fe}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const ee of this.drainers)ee.complete();this.drainers.clear()}dispose(){for(const[,ee]of this.queues)ee.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=T;class M{constructor(ee,be){this._token=-1,typeof ee=="function"&&typeof be=="number"&&this.setIfNotSet(ee,be)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(ee,be){this.cancel(),this._token=setTimeout(()=>{this._token=-1,ee()},be)}setIfNotSet(ee,be){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,ee()},be))}}e.TimeoutTimer=M;class V{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(ee,be){this.cancel(),this._token=setInterval(()=>{ee()},be)}}e.IntervalTimer=V;class U{constructor(ee,be){this.timeoutToken=-1,this.runner=ee,this.timeout=be,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(ee=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,ee)}get delay(){return this.timeout}set delay(ee){this.timeout=ee}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=U;class y{constructor(ee,be){be%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${be}ms is not a multiple of 1000ms.`),this.runner=ee,this.timeout=be,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(ee=this.timeout){ee%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(ee/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=y;class x extends U{constructor(ee,be){super(ee,be),this.units=[]}work(ee){this.units.push(ee),this.isScheduled()||this.schedule()}doRun(){const ee=this.units;this.units=[],this.runner?.(ee)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=x;class L extends N.Disposable{constructor(ee,be){super(),this.options=ee,this.handler=be,this.pendingWork=[],this.throttler=this._register(new N.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(ee){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+ee.length>this.options.maxBufferedWork)return!1}else if(this.pending+ee.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...ee),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new U(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=L,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=me=>{(0,A.setTimeout0)(()=>{if(ee)return;const be=Date.now()+15;me(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,be-Date.now())}}))});let ee=!1;return{dispose(){ee||(ee=!0)}}}:e.runWhenIdle=(me,ee)=>{const be=requestIdleCallback(me,typeof ee=="number"?{timeout:ee}:void 0);let _e=!1;return{dispose(){_e||(_e=!0,cancelIdleCallback(be))}}}}();class R{constructor(ee){this._didRun=!1,this._executor=()=>{try{this._value=ee()}catch(be){this._error=be}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=R;async function K(me,ee,be){let _e;for(let Fe=0;Fe<be;Fe++)try{return await me()}catch(Be){_e=Be,await i(ee)}throw _e}e.retry=K;class W{hasPending(ee){return this._pending?typeof ee=="number"?this._pending.taskId===ee:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(ee,be,_e){return this._pending={taskId:ee,cancel:()=>_e?.(),promise:be},be.then(()=>this.donePending(ee),()=>this.donePending(ee)),be}donePending(ee){this._pending&&ee===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const ee=this._next;this._next=void 0,ee.run().then(ee.promiseResolve,ee.promiseReject)}}setNext(ee){if(this._next)this._next.run=ee;else{let be,_e;const Fe=new Promise((Be,Xe)=>{be=Be,_e=Xe});this._next={run:ee,promise:Fe,promiseResolve:be,promiseReject:_e}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=W;class ${constructor(ee,be=()=>Date.now()){this.interval=ee,this.nowFn=be,this.lastIncrementTime=0,this.value=0}increment(){const ee=this.nowFn();return ee-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=ee,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class G{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((ee,be)=>{this.completeCallback=ee,this.errorCallback=be})}complete(ee){return new Promise(be=>{this.completeCallback(ee),this.resolved=!0,be()})}error(ee){return new Promise(be=>{this.errorCallback(ee),this.rejected=!0,be()})}cancel(){new Promise(ee=>{this.errorCallback(new C.CancellationError),this.rejected=!0,ee()})}}e.DeferredPromise=G;var re;(function(me){async function ee(_e){let Fe;const Be=await Promise.all(_e.map(Xe=>Xe.then(ke=>ke,ke=>{Fe||(Fe=ke)})));if(typeof Fe<"u")throw Fe;return Be}me.settled=ee;function be(_e){return new Promise(async(Fe,Be)=>{try{await _e(Fe,Be)}catch(Xe){Be(Xe)}})}me.withAsyncBody=be})(re=e.Promises||(e.Promises={}));var ge;(function(me){me[me.Initial=0]="Initial",me[me.DoneOK=1]="DoneOK",me[me.DoneError=2]="DoneError"})(ge||(ge={}));class oe{static fromArray(ee){return new oe(be=>{be.emitMany(ee)})}static fromPromise(ee){return new oe(async be=>{be.emitMany(await ee)})}static fromPromises(ee){return new oe(async be=>{await Promise.all(ee.map(async _e=>be.emitOne(await _e)))})}static merge(ee){return new oe(async be=>{await Promise.all(ee.map(async _e=>{for await(const Fe of _e)be.emitOne(Fe)}))})}constructor(ee){this._state=0,this._results=[],this._error=null,this._onStateChanged=new S.Emitter,queueMicrotask(async()=>{const be={emitOne:_e=>this.emitOne(_e),emitMany:_e=>this.emitMany(_e),reject:_e=>this.reject(_e)};try{await Promise.resolve(ee(be)),this.resolve()}catch(_e){this.reject(_e)}finally{be.emitOne=void 0,be.emitMany=void 0,be.reject=void 0}})}[Symbol.asyncIterator](){let ee=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(ee<this._results.length)return{done:!1,value:this._results[ee++]};if(this._state===1)return{done:!0,value:void 0};await S.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(ee,be){return new oe(async _e=>{for await(const Fe of ee)_e.emitOne(be(Fe))})}map(ee){return oe.map(this,ee)}static filter(ee,be){return new oe(async _e=>{for await(const Fe of ee)be(Fe)&&_e.emitOne(Fe)})}filter(ee){return oe.filter(this,ee)}static coalesce(ee){return oe.filter(ee,be=>!!be)}coalesce(){return oe.coalesce(this)}static async toPromise(ee){const be=[];for await(const _e of ee)be.push(_e);return be}toPromise(){return oe.toPromise(this)}emitOne(ee){this._state===0&&(this._results.push(ee),this._onStateChanged.fire())}emitMany(ee){this._state===0&&(this._results=this._results.concat(ee),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(ee){this._state===0&&(this._state=2,this._error=ee,this._onStateChanged.fire())}}e.AsyncIterableObject=oe,oe.EMPTY=oe.fromArray([]);class Ee extends oe{constructor(ee,be){super(be),this._source=ee}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Ee;function ce(me){const ee=new r.CancellationTokenSource,be=me(ee.token);return new Ee(ee,async _e=>{const Fe=ee.token.onCancellationRequested(()=>{Fe.dispose(),ee.dispose(),_e.reject(new C.CancellationError)});try{for await(const Be of be){if(ee.token.isCancellationRequested)return;_e.emitOne(Be)}Fe.dispose(),ee.dispose()}catch(Be){Fe.dispose(),ee.dispose(),_e.reject(Be)}})}e.createCancelableAsyncIterable=ce}),define(Ce[118],Ie([1,0,15,19]),function(ie,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const S=new r.IdleValue(()=>{const p=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:p,collatorIsNumeric:p.resolvedOptions().numeric}}),N=new r.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),_=new r.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(p,T,M=!1){const V=p||"",U=T||"",y=S.value.collator.compare(V,U);return S.value.collatorIsNumeric&&y===0&&V!==U?V<U?-1:1:y}e.compareFileNames=A;function E(p,T){const M=N.value.collator;return p=p||"",T=T||"",b(M,p,T)}e.compareFileNamesDefault=E;function P(p,T){const M=N.value.collator;return p=p||"",T=T||"",n(p,T)||b(M,p,T)}e.compareFileNamesUpper=P;function O(p,T){const M=N.value.collator;return p=p||"",T=T||"",i(p,T)||b(M,p,T)}e.compareFileNamesLower=O;function w(p,T){return p=p||"",T=T||"",p===T?0:p<T?-1:1}e.compareFileNamesUnicode=w;function g(p,T,M=!1){M||(p=p&&p.toLowerCase(),T=T&&T.toLowerCase());const[V,U]=D(p),[y,x]=D(T);return V!==y?V<y?-1:1:U===x?0:U<x?-1:1}e.noIntlCompareFileNames=g;function k(p,T){const[M,V]=D(p),[U,y]=D(T);let x=S.value.collator.compare(V,y);if(x===0){if(S.value.collatorIsNumeric&&V!==y)return V<y?-1:1;if(x=S.value.collator.compare(M,U),S.value.collatorIsNumeric&&x===0&&M!==U)return M<U?-1:1}return x}e.compareFileExtensions=k;function m(p,T){p=p||"",T=T||"";const M=c(p),V=c(T),U=N.value.collator,y=_.value.collator;return b(y,M,V)||b(U,p,T)}e.compareFileExtensionsDefault=m;function a(p,T){p=p||"",T=T||"";const M=c(p),V=c(T),U=N.value.collator,y=_.value.collator;return b(y,M,V)||n(p,T)||b(U,p,T)}e.compareFileExtensionsUpper=a;function u(p,T){p=p||"",T=T||"";const M=c(p),V=c(T),U=N.value.collator,y=_.value.collator;return b(y,M,V)||i(p,T)||b(U,p,T)}e.compareFileExtensionsLower=u;function d(p,T){p=p||"",T=T||"";const M=c(p).toLowerCase(),V=c(T).toLowerCase();return M!==V?M<V?-1:1:p!==T?p<T?-1:1:0}e.compareFileExtensionsUnicode=d;const v=/^(.*?)(\.([^.]*))?$/;function D(p,T=!1){const M=p?v.exec(p):[];let V=[M&&M[1]||"",M&&M[3]||""];return T&&(!V[0]&&V[1]||V[0]&&V[0].charAt(0)===".")&&(V=[V[0]+"."+V[1],""]),V}function c(p){const T=p?v.exec(p):[];return T&&T[1]&&T[1].charAt(0)!=="."&&T[3]||""}function b(p,T,M){const V=p.compare(T,M);return V!==0?V:T.length!==M.length?T.length<M.length?-1:1:0}function t(p){const T=p.charAt(0);return T.toLocaleUpperCase()!==T}function l(p){const T=p.charAt(0);return T.toLocaleLowerCase()!==T}function i(p,T){return t(p)&&l(T)?-1:l(p)&&t(T)?1:0}function n(p,T){return l(p)&&t(T)?-1:t(p)&&l(T)?1:0}function o(p,T,M=!1){return M||(p=p&&p.toLowerCase(),T=T&&T.toLowerCase()),p===T?0:p<T?-1:1}function f(p,T,M=!1){const V=p.split(C.sep),U=T.split(C.sep),y=V.length-1,x=U.length-1;let L,R;for(let K=0;;K++){if(L=y===K,R=x===K,L&&R)return A(V[K],U[K],M);if(L)return-1;if(R)return 1;const W=o(V[K],U[K],M);if(W!==0)return W}}e.comparePaths=f;function s(p,T,M){const V=p.toLowerCase(),U=T.toLowerCase(),y=h(p,T,M);if(y)return y;const x=V.endsWith(M),L=U.endsWith(M);if(x!==L)return x?-1:1;const R=A(V,U);return R!==0?R:V.localeCompare(U)}e.compareAnything=s;function h(p,T,M){const V=p.toLowerCase(),U=T.toLowerCase(),y=V.startsWith(M),x=U.startsWith(M);if(y!==x)return y?-1:1;if(y&&x){if(V.length<U.length)return-1;if(V.length>U.length)return 1}return 0}e.compareByPrefix=h}),define(Ce[34],Ie([1,0,18,15,38,24,19,21,9]),function(ie,e,r,C,S,N,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const O="[/\\\\]",w="[^/\\\\]",g=/\//g;function k(G,re){switch(G){case 0:return"";case 1:return`${w}*?`;default:return`(?:${O}|${w}+${O}${re?`|${O}${w}+`:""})*?`}}function m(G,re){if(!G)return[];const ge=[];let oe=!1,Ee=!1,ce="";for(const me of G){switch(me){case re:if(!oe&&!Ee){ge.push(ce),ce="";continue}break;case"{":oe=!0;break;case"}":oe=!1;break;case"[":Ee=!0;break;case"]":Ee=!1;break}ce+=me}return ce&&ge.push(ce),ge}e.splitGlobAware=m;function a(G){if(!G)return"";let re="";const ge=m(G,e.GLOB_SPLIT);if(ge.every(oe=>oe===e.GLOBSTAR))re=".*";else{let oe=!1;ge.forEach((Ee,ce)=>{if(Ee===e.GLOBSTAR){if(oe)return;re+=k(2,ce===ge.length-1)}else{let me=!1,ee="",be=!1,_e="";for(const Fe of Ee){if(Fe!=="}"&&me){ee+=Fe;continue}if(be&&(Fe!=="]"||!_e)){let Be;Fe==="-"?Be=Fe:(Fe==="^"||Fe==="!")&&!_e?Be="^":Fe===e.GLOB_SPLIT?Be="":Be=(0,E.escapeRegExpCharacters)(Fe),_e+=Be;continue}switch(Fe){case"{":me=!0;continue;case"[":be=!0;continue;case"}":{re+=`(?:${m(ee,",").map(ke=>a(ke)).join("|")})`,me=!1,ee="";break}case"]":{re+="["+_e+"]",be=!1,_e="";break}case"?":re+=w;continue;case"*":re+=k(1);continue;default:re+=(0,E.escapeRegExpCharacters)(Fe)}}ce<ge.length-1&&(ge[ce+1]!==e.GLOBSTAR||ce+2<ge.length)&&(re+=O)}oe=Ee===e.GLOBSTAR})}return re}const u=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,D=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,b=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new N.LRUCache(1e4),l=function(){return!1},i=function(){return null};function n(G,re){if(!G)return i;let ge;typeof G!="string"?ge=G.pattern:ge=G,ge=ge.trim();const oe=`${ge}_${!!re.trimForExclusions}`;let Ee=t.get(oe);if(Ee)return o(Ee,G);let ce;return u.test(ge)?Ee=s(ge.substr(4),ge):(ce=d.exec(f(ge,re)))?Ee=h(ce[1],ge):(re.trimForExclusions?D:v).test(ge)?Ee=p(ge,re):(ce=c.exec(f(ge,re)))?Ee=T(ce[1].substr(1),ge,!0):(ce=b.exec(f(ge,re)))?Ee=T(ce[1],ge,!1):Ee=M(ge),t.set(oe,Ee),o(Ee,G)}function o(G,re){if(typeof re=="string")return G;const ge=function(oe,Ee){return(0,S.isEqualOrParent)(oe,re.base,!A.isLinux)?G(oe.substr(re.base.length+1),Ee):null};return ge.allBasenames=G.allBasenames,ge.allPaths=G.allPaths,ge.basenames=G.basenames,ge.patterns=G.patterns,ge}function f(G,re){return re.trimForExclusions&&G.endsWith("/**")?G.substr(0,G.length-2):G}function s(G,re){return function(ge,oe){return typeof ge=="string"&&ge.endsWith(G)?re:null}}function h(G,re){const ge=`/${G}`,oe=`\\${G}`,Ee=function(me,ee){return typeof me!="string"?null:ee?ee===G?re:null:me===G||me.endsWith(ge)||me.endsWith(oe)?re:null},ce=[G];return Ee.basenames=ce,Ee.patterns=[re],Ee.allBasenames=ce,Ee}function p(G,re){const ge=W(G.slice(1,-1).split(",").map(ee=>n(ee,re)).filter(ee=>ee!==i),G),oe=ge.length;if(!oe)return i;if(oe===1)return ge[0];const Ee=function(ee,be){for(let _e=0,Fe=ge.length;_e<Fe;_e++)if(ge[_e](ee,be))return G;return null},ce=ge.find(ee=>!!ee.allBasenames);ce&&(Ee.allBasenames=ce.allBasenames);const me=ge.reduce((ee,be)=>be.allPaths?ee.concat(be.allPaths):ee,[]);return me.length&&(Ee.allPaths=me),Ee}function T(G,re,ge){const oe=_.sep===_.posix.sep,Ee=oe?G:G.replace(g,_.sep),ce=_.sep+Ee,me=_.posix.sep+G;let ee;return ge?ee=function(be,_e){return typeof be=="string"&&(be===Ee||be.endsWith(ce)||!oe&&(be===G||be.endsWith(me)))?re:null}:ee=function(be,_e){return typeof be=="string"&&(be===Ee||!oe&&be===G)?re:null},ee.allPaths=[(ge?"*/":"./")+G],ee}function M(G){try{const re=new RegExp(`^${a(G)}$`);return function(ge){return re.lastIndex=0,typeof ge=="string"&&re.test(ge)?G:null}}catch{return i}}function V(G,re,ge){return!G||typeof re!="string"?!1:U(G)(re,void 0,ge)}e.match=V;function U(G,re={}){if(!G)return l;if(typeof G=="string"||y(G)){const ge=n(G,re);if(ge===i)return l;const oe=function(Ee,ce){return!!ge(Ee,ce)};return ge.allBasenames&&(oe.allBasenames=ge.allBasenames),ge.allPaths&&(oe.allPaths=ge.allPaths),oe}return R(G,re)}e.parse=U;function y(G){const re=G;return re?typeof re.base=="string"&&typeof re.pattern=="string":!1}e.isRelativePattern=y;function x(G){return G.allBasenames||[]}e.getBasenameTerms=x;function L(G){return G.allPaths||[]}e.getPathTerms=L;function R(G,re){const ge=W(Object.getOwnPropertyNames(G).map(ee=>K(ee,G[ee],re)).filter(ee=>ee!==i)),oe=ge.length;if(!oe)return i;if(!ge.some(ee=>!!ee.requiresSiblings)){if(oe===1)return ge[0];const ee=function(Fe,Be){let Xe;for(let ke=0,ye=ge.length;ke<ye;ke++){const De=ge[ke](Fe,Be);if(typeof De=="string")return De;(0,C.isThenable)(De)&&(Xe||(Xe=[]),Xe.push(De))}return Xe?(async()=>{for(const ke of Xe){const ye=await ke;if(typeof ye=="string")return ye}return null})():null},be=ge.find(Fe=>!!Fe.allBasenames);be&&(ee.allBasenames=be.allBasenames);const _e=ge.reduce((Fe,Be)=>Be.allPaths?Fe.concat(Be.allPaths):Fe,[]);return _e.length&&(ee.allPaths=_e),ee}const Ee=function(ee,be,_e){let Fe,Be;for(let Xe=0,ke=ge.length;Xe<ke;Xe++){const ye=ge[Xe];ye.requiresSiblings&&_e&&(be||(be=(0,_.basename)(ee)),Fe||(Fe=be.substr(0,be.length-(0,_.extname)(ee).length)));const De=ye(ee,be,Fe,_e);if(typeof De=="string")return De;(0,C.isThenable)(De)&&(Be||(Be=[]),Be.push(De))}return Be?(async()=>{for(const Xe of Be){const ke=await Xe;if(typeof ke=="string")return ke}return null})():null},ce=ge.find(ee=>!!ee.allBasenames);ce&&(Ee.allBasenames=ce.allBasenames);const me=ge.reduce((ee,be)=>be.allPaths?ee.concat(be.allPaths):ee,[]);return me.length&&(Ee.allPaths=me),Ee}function K(G,re,ge){if(re===!1)return i;const oe=n(G,ge);if(oe===i)return i;if(typeof re=="boolean")return oe;if(re){const Ee=re.when;if(typeof Ee=="string"){const ce=(me,ee,be,_e)=>{if(!_e||!oe(me,ee))return null;const Fe=Ee.replace("$(basename)",be),Be=_e(Fe);return(0,C.isThenable)(Be)?Be.then(Xe=>Xe?G:null):Be?G:null};return ce.requiresSiblings=!0,ce}}return oe}function W(G,re){const ge=G.filter(ee=>!!ee.basenames);if(ge.length<2)return G;const oe=ge.reduce((ee,be)=>{const _e=be.basenames;return _e?ee.concat(_e):ee},[]);let Ee;if(re){Ee=[];for(let ee=0,be=oe.length;ee<be;ee++)Ee.push(re)}else Ee=ge.reduce((ee,be)=>{const _e=be.patterns;return _e?ee.concat(_e):ee},[]);const ce=function(ee,be){if(typeof ee!="string")return null;if(!be){let Fe;for(Fe=ee.length;Fe>0;Fe--){const Be=ee.charCodeAt(Fe-1);if(Be===47||Be===92)break}be=ee.substr(Fe)}const _e=oe.indexOf(be);return _e!==-1?Ee[_e]:null};ce.basenames=oe,ce.patterns=Ee,ce.allBasenames=oe;const me=G.filter(ee=>!ee.basenames);return me.push(ce),me}function $(G,re){return(0,r.equals)(G,re,(ge,oe)=>typeof ge=="string"&&typeof oe=="string"?ge===oe:typeof ge!="string"&&typeof oe!="string"?ge.base===oe.base&&ge.pattern===oe.pattern:!1)}e.patternsEquals=$}),define(Ce[77],Ie([1,0,12,116,22,9,2]),function(ie,e,r,C,S,N,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(u){u[u.Paragraph=0]="Paragraph",u[u.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class E{constructor(d="",v=!1){if(this.value=d,typeof this.value!="string")throw(0,r.illegalArgument)("value");typeof v=="boolean"?(this.isTrusted=v,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=v.isTrusted??void 0,this.supportThemeIcons=v.supportThemeIcons??!1,this.supportHtml=v.supportHtml??!1)}appendText(d,v=0){return this.value+=g(this.supportThemeIcons?(0,C.escapeIcons)(d):d).replace(/([ \t]+)/g,(D,c)=>"&nbsp;".repeat(c.length)).replace(/\>/gm,"\\>").replace(/\n/g,v===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,v){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=v,this.value+="\n```\n",this}appendLink(d,v,D){return this.value+="[",this.value+=this._escape(v,"]"),this.value+="](",this.value+=this._escape(String(d),")"),D&&(this.value+=` "${this._escape(this._escape(D,'"'),")")}"`),this.value+=")",this}_escape(d,v){const D=new RegExp((0,N.escapeRegExpCharacters)(v),"g");return d.replace(D,(c,b)=>d.charAt(b-1)!=="\\"?`\\${c}`:c)}}e.MarkdownString=E;function P(u){return O(u)?!u.value:Array.isArray(u)?u.every(P):!0}e.isEmptyMarkdownString=P;function O(u){return u instanceof E?!0:u&&typeof u=="object"?typeof u.value=="string"&&(typeof u.isTrusted=="boolean"||u.isTrusted===void 0)&&(typeof u.supportThemeIcons=="boolean"||u.supportThemeIcons===void 0):!1}e.isMarkdownString=O;function w(u,d){return u===d?!0:!u||!d?!1:u.value===d.value&&u.isTrusted===d.isTrusted&&u.supportThemeIcons===d.supportThemeIcons&&u.supportHtml===d.supportHtml&&(u.baseUri===d.baseUri||!!u.baseUri&&!!d.baseUri&&(0,S.isEqual)(_.URI.from(u.baseUri),_.URI.from(d.baseUri)))}e.markdownStringEqual=w;function g(u){return u.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=g;function k(u){return u.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=k;function m(u){return u&&u.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=m;function a(u){const d=[],v=u.split("|").map(c=>c.trim());u=v[0];const D=v[1];if(D){const c=/height=(\d+)/.exec(D),b=/width=(\d+)/.exec(D),t=c?c[1]:"",l=b?b[1]:"",i=isFinite(parseInt(l)),n=isFinite(parseInt(t));i&&d.push(`width="${l}"`),n&&d.push(`height="${t}"`)}return{href:u,dimensions:d}}e.parseHrefAndDimensions=a}),define(Ce[78],Ie([1,0,18,38,19,21,22,9]),function(ie,e,r,C,S,N,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function E(i,n){const{os:o,tildify:f,relative:s}=n;if(s){const T=P(i,s,o);if(typeof T=="string")return T}let h=i.fsPath;if(o===1&&!N.isWindows?h=h.replace(/\//g,"\\"):o!==1&&N.isWindows&&(h=h.replace(/\\/g,"/")),o!==1&&f?.userHome){const T=f.userHome.fsPath;let M;i.scheme!==f.userHome.scheme&&i.path.startsWith(S.posix.sep)?M=f.userHome.with({path:i.path}).fsPath:M=i.fsPath,h=g(M,T,o)}return(o===1?S.win32:S.posix).normalize(O(h,o===1))}e.getPathLabel=E;function P(i,n,o){const f=o===1?S.win32:S.posix,s=o===3?_.extUri:_.extUriIgnorePathCase,h=n.getWorkspace(),p=(0,r.firstOrDefault)(h.folders);if(!p)return;i.scheme!==p.uri.scheme&&i.path.startsWith(S.posix.sep)&&(i=p.uri.with({path:i.path}));const T=n.getWorkspaceFolder(i);if(!T)return;let M;if(s.isEqual(T.uri,i)?M="":M=s.relativePath(T.uri,i)??"",M&&(M=f.normalize(M)),h.folders.length>1&&!n.noPrefix){const V=T.name?T.name:s.basenameOrAuthority(T.uri);M=M?`${V} \u2022 ${M}`:V}return M}function O(i,n=N.isWindows){return(0,C.hasDriveLetter)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=O;let w=Object.create(null);function g(i,n,o=N.OS){if(o===1||!i||!n)return i;let f=w.original===n?w.normalized:void 0;f||(f=n,N.isWindows&&(f=(0,C.toSlashes)(f)),f=`${(0,A.rtrim)(f,S.posix.sep)}${S.posix.sep}`,w={original:n,normalized:f});let s=i;return N.isWindows&&(s=(0,C.toSlashes)(s)),(o===3?s.startsWith(f):(0,A.startsWithIgnoreCase)(s,f))?`~/${s.substr(f.length)}`:i}e.tildify=g;function k(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.untildify=k;const m="\u2026",a="\\\\",u="~";function d(i,n=S.sep){const o=new Array(i.length);let f=!1;for(let s=0;s<i.length;s++){const h=i[s];if(h===""){o[s]=`.${n}`;continue}if(!h){o[s]=h;continue}f=!0;let p="",T=h;T.indexOf(a)===0?(p=T.substr(0,T.indexOf(a)+a.length),T=T.substr(T.indexOf(a)+a.length)):T.indexOf(n)===0?(p=T.substr(0,T.indexOf(n)+n.length),T=T.substr(T.indexOf(n)+n.length)):T.indexOf(u)===0&&(p=T.substr(0,T.indexOf(u)+u.length),T=T.substr(T.indexOf(u)+u.length));const M=T.split(n);for(let V=1;f&&V<=M.length;V++)for(let U=M.length-V;f&&U>=0;U--){f=!1;let y=M.slice(U,U+V).join(n);for(let x=0;!f&&x<i.length;x++)if(x!==s&&i[x]&&i[x].indexOf(y)>-1){const L=U+V===M.length,R=U>0&&i[x].indexOf(n)>-1?n+y:y,K=i[x].endsWith(R);f=!L||K}if(!f){let x="";(M[0].endsWith(":")||p!=="")&&(U===1&&(U=0,V++,y=M[0]+n+y),U>0&&(x=M[0]+n),x=p+x),U>0&&(x=x+m+n),x=x+y,U+V<M.length&&(x=x+n+m),o[s]=x}}f&&(o[s]=h)}return o}e.shorten=d;var v;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function D(i,n=Object.create(null)){const o=[];let f=!1,s="";for(const h of i)if(h==="$"||f&&h==="{")s&&o.push({value:s,type:v.TEXT}),s="",f=!0;else if(h==="}"&&f){const p=n[s];if(typeof p=="string")p.length&&o.push({value:p,type:v.VARIABLE});else if(p){const T=o[o.length-1];(!T||T.type!==v.SEPARATOR)&&o.push({value:p.label,type:v.SEPARATOR})}s="",f=!1}else s+=h;return s&&!f&&o.push({value:s,type:v.TEXT}),o.filter((h,p)=>{if(h.type===v.SEPARATOR){const T=o[p-1],M=o[p+1];return[T,M].every(V=>V&&(V.type===v.VARIABLE||V.type===v.TEXT)&&V.value.length>0)}return!0}).map(h=>h.value).join("")}e.template=D;function c(i,n){return N.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,N.isMacintosh?"&":"&&"):i.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function b(i,n){return N.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,""):N.isWindows?i.replace(/&&|&/g,o=>o==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=b;function t(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=t;function l(i){const n=i.indexOf("/")!==-1?S.posix:S.win32,o=n.basename(i),f=n.dirname(i);return o.length?{name:o,parentPath:f}:{name:f,parentPath:""}}e.splitName=l}),define(Ce[119],Ie([1,0,2]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function C(O){return O.toJSON()}class S{constructor(w){this._uriTransformer=w}transformIncoming(w){const g=this._uriTransformer.transformIncoming(w);return g===w?w:C(r.URI.from(g))}transformOutgoing(w){const g=this._uriTransformer.transformOutgoing(w);return g===w?w:C(r.URI.from(g))}transformOutgoingURI(w){const g=this._uriTransformer.transformOutgoing(w);return g===w?w:r.URI.from(g)}transformOutgoingScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}}e.URITransformer=S,e.DefaultURITransformer=new class{transformIncoming(O){return O}transformOutgoing(O){return O}transformOutgoingURI(O){return O}transformOutgoingScheme(O){return O}};function N(O,w,g){if(!O||g>200)return null;if(typeof O=="object"){if(O instanceof r.URI)return w.transformOutgoing(O);for(const k in O)if(Object.hasOwnProperty.call(O,k)){const m=N(O[k],w,g+1);m!==null&&(O[k]=m)}}return null}function _(O,w){const g=N(O,w,0);return g===null?O:g}e.transformOutgoingURIs=_;function A(O,w,g,k){if(!O||k>200)return null;if(typeof O=="object"){if(O.$mid===1)return g?r.URI.revive(w.transformIncoming(O)):w.transformIncoming(O);for(const m in O)if(Object.hasOwnProperty.call(O,m)){const a=A(O[m],w,g,k+1);a!==null&&(O[m]=a)}}return null}function E(O,w){const g=A(O,w,!1,0);return g===null?O:g}e.transformIncomingURIs=E;function P(O,w){const g=A(O,w,!0,0);return g===null?O:g}e.transformAndReviveIncomingURIs=P}),define(Ce[120],Ie([1,0,34,19]),function(ie,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function S(N,_,A,E,P,O){if(Array.isArray(N)){let w=0;for(const g of N){const k=S(g,_,A,E,P,O);if(k===10)return k;k>w&&(w=k)}return w}else{if(typeof N=="string")return E?N==="*"?5:N===A?10:0:0;if(N){const{language:w,pattern:g,scheme:k,hasAccessToAllModels:m,notebookType:a}=N;if(!E&&!m)return 0;a&&P&&(_=P);let u=0;if(k)if(k===_.scheme)u=10;else if(k==="*")u=5;else return 0;if(w)if(w===A)u=10;else if(w==="*")u=Math.max(u,5);else return 0;if(a)if(a===O)u=10;else if(a==="*"&&O!==void 0)u=Math.max(u,5);else return 0;if(g){let d;if(typeof g=="string"?d=g:d={...g,base:(0,C.normalize)(g.base)},d===_.fsPath||(0,r.match)(d,_.fsPath))u=10;else return 0}return u}else return 0}}e.score=S}),define(Ce[79],Ie([1,0,23,21]),function(ie,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var S;(function(w){w[w.Full=1]="Full",w[w.Delta=2]="Delta"})(S||(S={}));function N(w){for(let g=0,k=w.length;g<k;g+=4){const m=w[g+0],a=w[g+1],u=w[g+2],d=w[g+3];w[g+0]=d,w[g+1]=u,w[g+2]=a,w[g+3]=m}}function _(w){const g=new Uint8Array(w.buffer,w.byteOffset,w.length*4);return C.isLittleEndian()||N(g),r.VSBuffer.wrap(g)}function A(w){const g=w.buffer;if(C.isLittleEndian()||N(g),g.byteOffset%4===0)return new Uint32Array(g.buffer,g.byteOffset,g.length/4);{const k=new Uint8Array(g.byteLength);return k.set(g),new Uint32Array(k.buffer,k.byteOffset,k.length/4)}}function E(w){const g=new Uint32Array(P(w));let k=0;if(g[k++]=w.id,w.type==="full")g[k++]=1,g[k++]=w.data.length,g.set(w.data,k),k+=w.data.length;else{g[k++]=2,g[k++]=w.deltas.length;for(const m of w.deltas)g[k++]=m.start,g[k++]=m.deleteCount,m.data?(g[k++]=m.data.length,g.set(m.data,k),k+=m.data.length):g[k++]=0}return _(g)}e.encodeSemanticTokensDto=E;function P(w){let g=0;if(g+=1+1,w.type==="full")g+=1+w.data.length;else{g+=1,g+=(1+1+1)*w.deltas.length;for(const k of w.deltas)k.data&&(g+=k.data.length)}return g}function O(w){const g=A(w);let k=0;const m=g[k++];if(g[k++]===1){const v=g[k++],D=g.subarray(k,k+v);return k+=v,{id:m,type:"full",data:D}}const u=g[k++],d=[];for(let v=0;v<u;v++){const D=g[k++],c=g[k++],b=g[k++];let t;b>0&&(t=g.subarray(k,k+b),k+=b),d[v]={start:D,deleteCount:c,data:t}}return{id:m,type:"delta",deltas:d}}e.decodeSemanticTokensDto=O}),define(Ce[121],Ie([16,17]),function(ie,e){return ie.create("vs/editor/common/config/editorOptions",e)}),define(Ce[122],Ie([1,0,121,21,123,18,25,110]),function(ie,e,r,C,S,N,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(E=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class P{constructor(Q){this._values=Q}hasChanged(Q){return this._values[Q]}}e.ConfigurationChangedEvent=P;class O{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=O;class w{constructor(Q,he,Ue,je){this.id=Q,this.name=he,this.defaultValue=Ue,this.schema=je}applyUpdate(Q,he){return k(Q,he)}compute(Q,he,Ue){return Ue}}class g{constructor(Q,he){this.newValue=Q,this.didChange=he}}e.ApplyUpdateResult=g;function k(X,Q){if(typeof X!="object"||typeof Q!="object"||!X||!Q)return new g(Q,X!==Q);if(Array.isArray(X)||Array.isArray(Q)){const Ue=Array.isArray(X)&&Array.isArray(Q)&&N.equals(X,Q);return new g(Q,!Ue)}let he=!1;for(const Ue in Q)if(Q.hasOwnProperty(Ue)){const je=k(X[Ue],Q[Ue]);je.didChange&&(X[Ue]=je.newValue,he=!0)}return new g(X,he)}class m{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,he){return k(Q,he)}validate(Q){return this.defaultValue}}class a{constructor(Q,he,Ue,je){this.id=Q,this.name=he,this.defaultValue=Ue,this.schema=je}applyUpdate(Q,he){return k(Q,he)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,he,Ue){return Ue}}function u(X,Q){return typeof X>"u"?Q:X==="false"?!1:Boolean(X)}e.boolean=u;class d extends a{constructor(Q,he,Ue,je=void 0){typeof je<"u"&&(je.type="boolean",je.default=Ue),super(Q,he,Ue,je)}validate(Q){return u(Q,this.defaultValue)}}function v(X,Q,he,Ue){if(typeof X>"u")return Q;let je=parseInt(X,10);return isNaN(je)?Q:(je=Math.max(he,je),je=Math.min(Ue,je),je|0)}e.clampedInt=v;class D extends a{static clampedInt(Q,he,Ue,je){return v(Q,he,Ue,je)}constructor(Q,he,Ue,je,Ze,Ke=void 0){typeof Ke<"u"&&(Ke.type="integer",Ke.default=Ue,Ke.minimum=je,Ke.maximum=Ze),super(Q,he,Ue,Ke),this.minimum=je,this.maximum=Ze}validate(Q){return D.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}class c extends a{static clamp(Q,he,Ue){return Q<he?he:Q>Ue?Ue:Q}static float(Q,he){if(typeof Q=="number")return Q;if(typeof Q>"u")return he;const Ue=parseFloat(Q);return isNaN(Ue)?he:Ue}constructor(Q,he,Ue,je,Ze){typeof Ze<"u"&&(Ze.type="number",Ze.default=Ue),super(Q,he,Ue,Ze),this.validationFn=je}validate(Q){return this.validationFn(c.float(Q,this.defaultValue))}}class b extends a{static string(Q,he){return typeof Q!="string"?he:Q}constructor(Q,he,Ue,je=void 0){typeof je<"u"&&(je.type="string",je.default=Ue),super(Q,he,Ue,je)}validate(Q){return b.string(Q,this.defaultValue)}}function t(X,Q,he){return typeof X!="string"||he.indexOf(X)===-1?Q:X}e.stringSet=t;class l extends a{constructor(Q,he,Ue,je,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=je,Ze.default=Ue),super(Q,he,Ue,Ze),this._allowedValues=je}validate(Q){return t(Q,this.defaultValue,this._allowedValues)}}class i extends w{constructor(Q,he,Ue,je,Ze,Ke,Ve=void 0){typeof Ve<"u"&&(Ve.type="string",Ve.enum=Ze,Ve.default=je),super(Q,he,Ue,Ve),this._allowedValues=Ze,this._convert=Ke}validate(Q){return typeof Q!="string"?this.defaultValue:this._allowedValues.indexOf(Q)===-1?this.defaultValue:this._convert(Q)}}function n(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class o extends w{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[r.localize(0,null),r.localize(1,null),r.localize(2,null)],default:"auto",description:r.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,he,Ue){return Ue===0?Q.accessibilitySupport:Ue}}class f extends w{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:r.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:r.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{insertSpace:u(he.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:u(he.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var s;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(s=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function h(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var p;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(p=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function T(X){switch(X){case p.Line:return"line";case p.Block:return"block";case p.Underline:return"underline";case p.LineThin:return"line-thin";case p.BlockOutline:return"block-outline";case p.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=T;function M(X){switch(X){case"line":return p.Line;case"block":return p.Block;case"underline":return p.Underline;case"line-thin":return p.LineThin;case"block-outline":return p.BlockOutline;case"underline-thin":return p.UnderlineThin}}class V extends m{constructor(){super(130)}compute(Q,he,Ue){const je=["monaco-editor"];return he.get(34)&&je.push(he.get(34)),Q.extraEditorClassName&&je.push(Q.extraEditorClassName),he.get(67)==="default"?je.push("mouse-default"):he.get(67)==="copy"&&je.push("mouse-copy"),he.get(101)&&je.push("showUnused"),he.get(128)&&je.push("showDeprecated"),je.join(" ")}}class U extends d{constructor(){super(33,"emptySelectionClipboard",!0,{description:r.localize(6,null)})}compute(Q,he,Ue){return Ue&&Q.emptySelectionClipboard}}class y extends w{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:r.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[r.localize(8,null),r.localize(9,null),r.localize(10,null)],description:r.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[r.localize(12,null),r.localize(13,null),r.localize(14,null)],description:r.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:r.localize(16,null),included:C.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:r.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:r.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{cursorMoveOnType:u(he.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":t(he.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":t(he.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:u(he.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:u(he.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:u(he.loop,this.defaultValue.loop)}}}class x extends w{constructor(){super(46,"fontLigatures",x.OFF,{anyOf:[{type:"boolean",description:r.localize(19,null)},{type:"string",description:r.localize(20,null)}],description:r.localize(21,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?x.OFF:Q==="true"?x.ON:Q:Boolean(Q)?x.ON:x.OFF}}e.EditorFontLigatures=x,x.OFF='"liga" off, "calt" off',x.ON='"liga" on, "calt" on';class L extends m{constructor(){super(45)}compute(Q,he,Ue){return Q.fontInfo}}class R extends a{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:r.localize(22,null)})}validate(Q){const he=c.float(Q,this.defaultValue);return he===0?e.EDITOR_FONT_DEFAULTS.fontSize:c.clamp(he,6,100)}compute(Q,he,Ue){return Q.fontInfo.fontSize}}class K extends w{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:K.MINIMUM_VALUE,maximum:K.MAXIMUM_VALUE,errorMessage:r.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:K.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:r.localize(24,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(D.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,K.MINIMUM_VALUE,K.MAXIMUM_VALUE))}}K.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],K.MINIMUM_VALUE=1,K.MAXIMUM_VALUE=1e3;class W extends w{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},he={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[r.localize(25,null),r.localize(26,null),r.localize(27,null)]},Ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(52,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:r.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:r.localize(29,null),...he},"editor.gotoLocation.multipleTypeDefinitions":{description:r.localize(30,null),...he},"editor.gotoLocation.multipleDeclarations":{description:r.localize(31,null),...he},"editor.gotoLocation.multipleImplementations":{description:r.localize(32,null),...he},"editor.gotoLocation.multipleReferences":{description:r.localize(33,null),...he},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Ue,description:r.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Ue,description:r.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Ue,description:r.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Ue,description:r.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Ue,description:r.localize(38,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{multiple:t(he.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:he.multipleDefinitions??t(he.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:he.multipleTypeDefinitions??t(he.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:he.multipleDeclarations??t(he.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:he.multipleImplementations??t(he.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:he.multipleReferences??t(he.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:b.string(he.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:b.string(he.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:b.string(he.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:b.string(he.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:b.string(he.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class $ extends w{constructor(){const Q={enabled:!0,delay:300,sticky:!0,above:!0};super(54,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:r.localize(39,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:r.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:r.localize(41,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:r.localize(42,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:u(he.enabled,this.defaultValue.enabled),delay:D.clampedInt(he.delay,this.defaultValue.delay,0,1e4),sticky:u(he.sticky,this.defaultValue.sticky),above:u(he.above,this.defaultValue.above)}}}var G;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(G=e.RenderMinimap||(e.RenderMinimap={}));class re extends m{constructor(){super(133)}compute(Q,he,Ue){return re.computeLayout(he,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio})}static computeContainedMinimapLineCount(Q){const he=Q.height/Q.lineHeight,Ue=Q.scrollBeyondLastLine?he-1:0,je=(Q.viewLineCount+Ue)/(Q.pixelRatio*Q.height),Ze=Math.floor(Q.viewLineCount/je);return{typicalViewportLineCount:he,extraLinesBeyondLastLine:Ue,desiredRatio:je,minimapLineCount:Ze}}static _computeMinimapLayout(Q,he){const Ue=Q.outerWidth,je=Q.outerHeight,Ze=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ze*je),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:je};const Ke=he.stableMinimapLayoutInput,Ve=Ke&&Q.outerHeight===Ke.outerHeight&&Q.lineHeight===Ke.lineHeight&&Q.typicalHalfwidthCharacterWidth===Ke.typicalHalfwidthCharacterWidth&&Q.pixelRatio===Ke.pixelRatio&&Q.scrollBeyondLastLine===Ke.scrollBeyondLastLine&&Q.minimap.enabled===Ke.minimap.enabled&&Q.minimap.side===Ke.minimap.side&&Q.minimap.size===Ke.minimap.size&&Q.minimap.showSlider===Ke.minimap.showSlider&&Q.minimap.renderCharacters===Ke.minimap.renderCharacters&&Q.minimap.maxColumn===Ke.minimap.maxColumn&&Q.minimap.scale===Ke.minimap.scale&&Q.verticalScrollbarWidth===Ke.verticalScrollbarWidth&&Q.isViewportWrapping===Ke.isViewportWrapping,it=Q.lineHeight,st=Q.typicalHalfwidthCharacterWidth,dt=Q.scrollBeyondLastLine,_t=Q.minimap.renderCharacters;let tt=Ze>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const ut=Q.minimap.maxColumn,Ot=Q.minimap.size,Ht=Q.minimap.side,At=Q.verticalScrollbarWidth,ft=Q.viewLineCount,Ct=Q.remainingWidth,Lt=Q.isViewportWrapping,xt=_t?2:3;let qe=Math.floor(Ze*je);const Ft=qe/Ze;let It=!1,Mt=!1,gt=xt*tt,Se=tt/Ze,Pe=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:et,extraLinesBeyondLastLine:lt,desiredRatio:mt,minimapLineCount:yt}=re.computeContainedMinimapLineCount({viewLineCount:ft,scrollBeyondLastLine:dt,height:je,lineHeight:it,pixelRatio:Ze});if(ft/yt>1)It=!0,Mt=!0,tt=1,gt=1,Se=tt/Ze;else{let wt=!1,kt=tt+1;if(Ot==="fit"){const bt=Math.ceil((ft+lt)*gt);Lt&&Ve&&Ct<=he.stableFitRemainingWidth?(wt=!0,kt=he.stableFitMaxMinimapScale):wt=bt>qe}if(Ot==="fill"||wt){It=!0;const bt=tt;gt=Math.min(it*Ze,Math.max(1,Math.floor(1/mt))),Lt&&Ve&&Ct<=he.stableFitRemainingWidth&&(kt=he.stableFitMaxMinimapScale),tt=Math.min(kt,Math.max(1,Math.floor(gt/xt))),tt>bt&&(Pe=Math.min(2,tt/bt)),Se=tt/Ze/Pe,qe=Math.ceil(Math.max(et,ft+lt)*gt),Lt?(he.stableMinimapLayoutInput=Q,he.stableFitRemainingWidth=Ct,he.stableFitMaxMinimapScale=tt):(he.stableMinimapLayoutInput=null,he.stableFitRemainingWidth=0)}}}const fe=Math.floor(ut*Se),q=Math.min(fe,Math.max(0,Math.floor((Ct-At-2)*Se/(st+Se)))+e.MINIMAP_GUTTER_WIDTH);let Ae=Math.floor(Ze*q);const Le=Ae/Ze;Ae=Math.floor(Ae*Pe);const nt=_t?1:2,We=Ht==="left"?0:Ue-q-At;return{renderMinimap:nt,minimapLeft:We,minimapWidth:q,minimapHeightIsEditorHeight:It,minimapIsSampling:Mt,minimapScale:tt,minimapLineHeight:gt,minimapCanvasInnerWidth:Ae,minimapCanvasInnerHeight:qe,minimapCanvasOuterWidth:Le,minimapCanvasOuterHeight:Ft}}static computeLayout(Q,he){const Ue=he.outerWidth|0,je=he.outerHeight|0,Ze=he.lineHeight|0,Ke=he.lineNumbersDigitCount|0,Ve=he.typicalHalfwidthCharacterWidth,it=he.maxDigitWidth,st=he.pixelRatio,dt=he.viewLineCount,_t=Q.get(125),tt=_t==="inherit"?Q.get(124):_t,ut=tt==="inherit"?Q.get(120):tt,Ot=Q.get(123),Ht=Q.get(2),At=he.isDominatedByLongLines,ft=Q.get(51),Ct=Q.get(61).renderType!==0,Lt=Q.get(62),xt=Q.get(95),qe=Q.get(66),Ft=Q.get(93),It=Ft.verticalScrollbarSize,Mt=Ft.verticalHasArrows,gt=Ft.arrowSize,Se=Ft.horizontalScrollbarSize,Pe=Q.get(59),fe=Q.get(38),q=Q.get(100)!=="never";let Ae;if(typeof Pe=="string"&&/^\d+(\.\d+)?ch$/.test(Pe)){const vt=parseFloat(Pe.substr(0,Pe.length-2));Ae=D.clampedInt(vt*Ve,0,0,1e3)}else Ae=D.clampedInt(Pe,0,0,1e3);fe&&q&&(Ae+=16);let Le=0;if(Ct){const vt=Math.max(Ke,Lt);Le=Math.round(vt*it)}let nt=0;ft&&(nt=Ze);let We=0,et=We+nt,lt=et+Le,mt=lt+Ae;const yt=Ue-nt-Le-Ae;let Et=!1,wt=!1,kt=-1;Ht!==2&&(tt==="inherit"&&At?(Et=!0,wt=!0):ut==="on"||ut==="bounded"?wt=!0:ut==="wordWrapColumn"&&(kt=Ot));const bt=re._computeMinimapLayout({outerWidth:Ue,outerHeight:je,lineHeight:Ze,typicalHalfwidthCharacterWidth:Ve,pixelRatio:st,scrollBeyondLastLine:xt,minimap:qe,verticalScrollbarWidth:It,viewLineCount:dt,remainingWidth:yt,isViewportWrapping:wt},he.memory||new O);bt.renderMinimap!==0&&bt.minimapLeft===0&&(We+=bt.minimapWidth,et+=bt.minimapWidth,lt+=bt.minimapWidth,mt+=bt.minimapWidth);const Dt=yt-bt.minimapWidth,ti=Math.max(1,Math.floor((Dt-It-2)/Ve)),Xt=Mt?gt:0;return wt&&(kt=Math.max(1,ti),ut==="bounded"&&(kt=Math.min(kt,Ot))),{width:Ue,height:je,glyphMarginLeft:We,glyphMarginWidth:nt,lineNumbersLeft:et,lineNumbersWidth:Le,decorationsLeft:lt,decorationsWidth:Ae,contentLeft:mt,contentWidth:Dt,minimap:bt,viewportColumn:ti,isWordWrapMinified:Et,isViewportWrapping:wt,wrappingColumn:kt,verticalScrollbarWidth:It,horizontalScrollbarHeight:Se,overviewRuler:{top:Xt,width:It,height:je-2*Xt,right:0}}}}e.EditorLayoutInfoComputer=re;class ge extends w{constructor(){const Q={enabled:!0};super(58,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:r.localize(43,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:u(Q.enabled,this.defaultValue.enabled)}}}class oe extends w{constructor(){const Q={enabled:!1,maxLineCount:5};super(105,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:r.localize(44,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:10,description:r.localize(45,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:u(he.enabled,this.defaultValue.enabled),maxLineCount:D.clampedInt(he.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class Ee extends w{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(129,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:r.localize(46,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[r.localize(47,null),r.localize(48,null,C.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),r.localize(49,null,C.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),r.localize(50,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:r.localize(51,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:r.localize(52,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:r.localize(53,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return typeof he.enabled=="boolean"&&(he.enabled=he.enabled?"on":"off"),{enabled:t(he.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:D.clampedInt(he.fontSize,this.defaultValue.fontSize,0,100),fontFamily:b.string(he.fontFamily,this.defaultValue.fontFamily),padding:u(he.padding,this.defaultValue.padding)}}}class ce extends c{constructor(){super(60,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>c.clamp(Q,0,150),{markdownDescription:r.localize(54,null)})}compute(Q,he,Ue){return Q.fontInfo.lineHeight}}class me extends w{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(66,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:r.localize(55,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:r.localize(56,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[r.localize(57,null),r.localize(58,null),r.localize(59,null)],default:Q.size,description:r.localize(60,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:r.localize(61,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:r.localize(62,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:r.localize(63,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:r.localize(64,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:r.localize(65,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:u(he.enabled,this.defaultValue.enabled),autohide:u(he.autohide,this.defaultValue.autohide),size:t(he.size,this.defaultValue.size,["proportional","fill","fit"]),side:t(he.side,this.defaultValue.side,["right","left"]),showSlider:t(he.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:u(he.renderCharacters,this.defaultValue.renderCharacters),scale:D.clampedInt(he.scale,1,1,3),maxColumn:D.clampedInt(he.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ee(X){return X==="ctrlCmd"?C.isMacintosh?"metaKey":"ctrlKey":"altKey"}class be extends w{constructor(){super(76,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:r.localize(66,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:r.localize(67,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{top:D.clampedInt(he.top,0,0,1e3),bottom:D.clampedInt(he.bottom,0,0,1e3)}}}class _e extends w{constructor(){const Q={enabled:!0,cycle:!1};super(77,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:r.localize(68,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:r.localize(69,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:u(he.enabled,this.defaultValue.enabled),cycle:u(he.cycle,this.defaultValue.cycle)}}}class Fe extends m{constructor(){super(131)}compute(Q,he,Ue){return Q.pixelRatio}}class Be extends w{constructor(){const Q={other:"on",comments:"off",strings:"off"},he=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[r.localize(70,null),r.localize(71,null),r.localize(72,null)]}];super(80,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:he,default:Q.strings,description:r.localize(73,null)},comments:{anyOf:he,default:Q.comments,description:r.localize(74,null)},other:{anyOf:he,default:Q.other,description:r.localize(75,null)}},default:Q,markdownDescription:r.localize(76,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const st=Q?"on":"off";return{comments:st,strings:st,other:st}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:he,comments:Ue,strings:je}=Q,Ze=["on","inline","off"];let Ke,Ve,it;return typeof he=="boolean"?Ke=he?"on":"off":Ke=t(he,this.defaultValue.other,Ze),typeof Ue=="boolean"?Ve=Ue?"on":"off":Ve=t(Ue,this.defaultValue.comments,Ze),typeof je=="boolean"?it=je?"on":"off":it=t(je,this.defaultValue.strings,Ze),{other:Ke,comments:Ve,strings:it}}}var Xe;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(Xe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ke extends w{constructor(){super(61,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[r.localize(77,null),r.localize(78,null),r.localize(79,null),r.localize(80,null)],default:"on",description:r.localize(81,null)})}validate(Q){let he=this.defaultValue.renderType,Ue=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?(he=4,Ue=Q):Q==="interval"?he=3:Q==="relative"?he=2:Q==="on"?he=1:he=0),{renderType:he,renderFn:Ue}}}function ye(X){const Q=X.get(88);return Q==="editable"?X.get(82):Q!=="on"}e.filterValidationDecorations=ye;class De extends w{constructor(){const Q=[],he={type:"number",description:r.localize(82,null)};super(92,"rulers",Q,{type:"array",items:{anyOf:[he,{type:["object"],properties:{column:he,color:{type:"string",description:r.localize(83,null),format:"color-hex"}}}]},default:Q,description:r.localize(84,null)})}validate(Q){if(Array.isArray(Q)){const he=[];for(const Ue of Q)if(typeof Ue=="number")he.push({column:D.clampedInt(Ue,0,0,1e4),color:null});else if(Ue&&typeof Ue=="object"){const je=Ue;he.push({column:D.clampedInt(je.column,0,0,1e4),color:je.color})}return he.sort((Ue,je)=>Ue.column-je.column),he}return this.defaultValue}}function ae(X,Q){if(typeof X!="string")return Q;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class ue extends w{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(93,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[r.localize(85,null),r.localize(86,null),r.localize(87,null)],default:"auto",description:r.localize(88,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[r.localize(89,null),r.localize(90,null),r.localize(91,null)],default:"auto",description:r.localize(92,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:r.localize(93,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:r.localize(94,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:r.localize(95,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q,Ue=D.clampedInt(he.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),je=D.clampedInt(he.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:D.clampedInt(he.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:ae(he.vertical,this.defaultValue.vertical),horizontal:ae(he.horizontal,this.defaultValue.horizontal),useShadows:u(he.useShadows,this.defaultValue.useShadows),verticalHasArrows:u(he.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:u(he.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:u(he.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:u(he.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ue,horizontalSliderSize:D.clampedInt(he.horizontalSliderSize,Ue,0,1e3),verticalScrollbarSize:je,verticalSliderSize:D.clampedInt(he.verticalSliderSize,je,0,1e3),scrollByPage:u(he.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Z extends w{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(115,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:r.localize(96,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:r.localize(97,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:r.localize(98,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:r.localize(99,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:r.localize(100,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:r.localize(101,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:r.localize(102,null)}})}applyUpdate(Q,he){let Ue=!1;he.allowedCharacters&&Q&&(_.equals(Q.allowedCharacters,he.allowedCharacters)||(Q={...Q,allowedCharacters:he.allowedCharacters},Ue=!0)),he.allowedLocales&&Q&&(_.equals(Q.allowedLocales,he.allowedLocales)||(Q={...Q,allowedLocales:he.allowedLocales},Ue=!0));const je=super.applyUpdate(Q,he);return Ue?new g(je.newValue,!0):je}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{nonBasicASCII:H(he.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:u(he.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:u(he.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:H(he.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:H(he.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(Q.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(Q,he){if(typeof Q!="object"||!Q)return he;const Ue={};for(const[je,Ze]of Object.entries(Q))Ze===!0&&(Ue[je]=!0);return Ue}}class J extends w{constructor(){const Q={enabled:!0,mode:"subwordSmart"};super(56,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:r.localize(103,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:u(he.enabled,this.defaultValue.enabled),mode:t(he.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class I extends w{constructor(){const Q={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:r.localize(104,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:r.localize(105,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:u(he.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:u(he.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class B extends w{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[r.localize(106,null),r.localize(107,null),r.localize(108,null)],default:Q.bracketPairs,description:r.localize(109,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[r.localize(110,null),r.localize(111,null),r.localize(112,null)],default:Q.bracketPairsHorizontal,description:r.localize(113,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:r.localize(114,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:r.localize(115,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[r.localize(116,null),r.localize(117,null),r.localize(118,null)],default:Q.highlightActiveIndentation,description:r.localize(119,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{bracketPairs:H(he.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:H(he.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:u(he.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:u(he.indentation,this.defaultValue.indentation),highlightActiveIndentation:H(he.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function H(X,Q,he){const Ue=he.indexOf(X);return Ue===-1?Q:he[Ue]}class j extends w{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(108,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[r.localize(120,null),r.localize(121,null)],default:Q.insertMode,description:r.localize(122,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:r.localize(123,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:r.localize(124,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:r.localize(125,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:r.localize(126,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:r.localize(127,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:r.localize(128,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:r.localize(129,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:r.localize(130,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:r.localize(131,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:r.localize(132,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:r.localize(133,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:r.localize(134,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:r.localize(135,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:r.localize(136,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:r.localize(137,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:r.localize(138,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:r.localize(139,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:r.localize(140,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:r.localize(141,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:r.localize(142,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:r.localize(143,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:r.localize(144,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:r.localize(145,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:r.localize(146,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:r.localize(147,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:r.localize(148,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:r.localize(149,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:r.localize(150,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:r.localize(151,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:r.localize(152,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:r.localize(153,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:r.localize(154,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:r.localize(155,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:r.localize(156,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:r.localize(157,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:r.localize(158,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:r.localize(159,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:r.localize(160,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:r.localize(161,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:r.localize(162,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{insertMode:t(he.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:u(he.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:u(he.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:u(he.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:u(he.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:u(he.showIcons,this.defaultValue.showIcons),showStatusBar:u(he.showStatusBar,this.defaultValue.showStatusBar),preview:u(he.preview,this.defaultValue.preview),previewMode:t(he.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:u(he.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:u(he.showMethods,this.defaultValue.showMethods),showFunctions:u(he.showFunctions,this.defaultValue.showFunctions),showConstructors:u(he.showConstructors,this.defaultValue.showConstructors),showDeprecated:u(he.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:u(he.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:u(he.showFields,this.defaultValue.showFields),showVariables:u(he.showVariables,this.defaultValue.showVariables),showClasses:u(he.showClasses,this.defaultValue.showClasses),showStructs:u(he.showStructs,this.defaultValue.showStructs),showInterfaces:u(he.showInterfaces,this.defaultValue.showInterfaces),showModules:u(he.showModules,this.defaultValue.showModules),showProperties:u(he.showProperties,this.defaultValue.showProperties),showEvents:u(he.showEvents,this.defaultValue.showEvents),showOperators:u(he.showOperators,this.defaultValue.showOperators),showUnits:u(he.showUnits,this.defaultValue.showUnits),showValues:u(he.showValues,this.defaultValue.showValues),showConstants:u(he.showConstants,this.defaultValue.showConstants),showEnums:u(he.showEnums,this.defaultValue.showEnums),showEnumMembers:u(he.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:u(he.showKeywords,this.defaultValue.showKeywords),showWords:u(he.showWords,this.defaultValue.showWords),showColors:u(he.showColors,this.defaultValue.showColors),showFiles:u(he.showFiles,this.defaultValue.showFiles),showReferences:u(he.showReferences,this.defaultValue.showReferences),showFolders:u(he.showFolders,this.defaultValue.showFolders),showTypeParameters:u(he.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:u(he.showSnippets,this.defaultValue.showSnippets),showUsers:u(he.showUsers,this.defaultValue.showUsers),showIssues:u(he.showIssues,this.defaultValue.showIssues)}}}class se extends w{constructor(){super(103,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:r.localize(163,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:u(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class le extends m{constructor(){super(132)}compute(Q,he,Ue){return he.get(82)?!0:Q.tabFocusMode}}var Y;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(Y=e.WrappingIndent||(e.WrappingIndent={}));function ve(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class pe extends m{constructor(){super(134)}compute(Q,he,Ue){const je=he.get(133);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:je.isWordWrapMinified,isViewportWrapping:je.isViewportWrapping,wrappingColumn:je.wrappingColumn}}}class Ne extends w{constructor(){const Q={enabled:!0};super(32,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:r.localize(164,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:u(Q.enabled,this.defaultValue.enabled)}}}const xe="Consolas, 'Courier New', monospace",Ye="Menlo, Monaco, 'Courier New', monospace",Ge="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.isMacintosh?Ye:C.isLinux?Ge:xe,fontWeight:"normal",fontSize:C.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Te(X){return e.editorOptionsRegistry[X.id]=X,X}var rt;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.autoClosingBrackets=5]="autoClosingBrackets",X[X.autoClosingDelete=6]="autoClosingDelete",X[X.autoClosingOvertype=7]="autoClosingOvertype",X[X.autoClosingQuotes=8]="autoClosingQuotes",X[X.autoIndent=9]="autoIndent",X[X.automaticLayout=10]="automaticLayout",X[X.autoSurround=11]="autoSurround",X[X.bracketPairColorization=12]="bracketPairColorization",X[X.guides=13]="guides",X[X.codeLens=14]="codeLens",X[X.codeLensFontFamily=15]="codeLensFontFamily",X[X.codeLensFontSize=16]="codeLensFontSize",X[X.colorDecorators=17]="colorDecorators",X[X.columnSelection=18]="columnSelection",X[X.comments=19]="comments",X[X.contextmenu=20]="contextmenu",X[X.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",X[X.cursorBlinking=22]="cursorBlinking",X[X.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",X[X.cursorStyle=24]="cursorStyle",X[X.cursorSurroundingLines=25]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",X[X.cursorWidth=27]="cursorWidth",X[X.disableLayerHinting=28]="disableLayerHinting",X[X.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",X[X.domReadOnly=30]="domReadOnly",X[X.dragAndDrop=31]="dragAndDrop",X[X.dropIntoEditor=32]="dropIntoEditor",X[X.emptySelectionClipboard=33]="emptySelectionClipboard",X[X.extraEditorClassName=34]="extraEditorClassName",X[X.fastScrollSensitivity=35]="fastScrollSensitivity",X[X.find=36]="find",X[X.fixedOverflowWidgets=37]="fixedOverflowWidgets",X[X.folding=38]="folding",X[X.foldingStrategy=39]="foldingStrategy",X[X.foldingHighlight=40]="foldingHighlight",X[X.foldingImportsByDefault=41]="foldingImportsByDefault",X[X.foldingMaximumRegions=42]="foldingMaximumRegions",X[X.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=44]="fontFamily",X[X.fontInfo=45]="fontInfo",X[X.fontLigatures=46]="fontLigatures",X[X.fontSize=47]="fontSize",X[X.fontWeight=48]="fontWeight",X[X.formatOnPaste=49]="formatOnPaste",X[X.formatOnType=50]="formatOnType",X[X.glyphMargin=51]="glyphMargin",X[X.gotoLocation=52]="gotoLocation",X[X.hideCursorInOverviewRuler=53]="hideCursorInOverviewRuler",X[X.hover=54]="hover",X[X.inDiffEditor=55]="inDiffEditor",X[X.inlineSuggest=56]="inlineSuggest",X[X.letterSpacing=57]="letterSpacing",X[X.lightbulb=58]="lightbulb",X[X.lineDecorationsWidth=59]="lineDecorationsWidth",X[X.lineHeight=60]="lineHeight",X[X.lineNumbers=61]="lineNumbers",X[X.lineNumbersMinChars=62]="lineNumbersMinChars",X[X.linkedEditing=63]="linkedEditing",X[X.links=64]="links",X[X.matchBrackets=65]="matchBrackets",X[X.minimap=66]="minimap",X[X.mouseStyle=67]="mouseStyle",X[X.mouseWheelScrollSensitivity=68]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=69]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=70]="multiCursorMergeOverlapping",X[X.multiCursorModifier=71]="multiCursorModifier",X[X.multiCursorPaste=72]="multiCursorPaste",X[X.occurrencesHighlight=73]="occurrencesHighlight",X[X.overviewRulerBorder=74]="overviewRulerBorder",X[X.overviewRulerLanes=75]="overviewRulerLanes",X[X.padding=76]="padding",X[X.parameterHints=77]="parameterHints",X[X.peekWidgetDefaultFocus=78]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=79]="definitionLinkOpensInPeek",X[X.quickSuggestions=80]="quickSuggestions",X[X.quickSuggestionsDelay=81]="quickSuggestionsDelay",X[X.readOnly=82]="readOnly",X[X.renameOnType=83]="renameOnType",X[X.renderControlCharacters=84]="renderControlCharacters",X[X.renderFinalNewline=85]="renderFinalNewline",X[X.renderLineHighlight=86]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=87]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=88]="renderValidationDecorations",X[X.renderWhitespace=89]="renderWhitespace",X[X.revealHorizontalRightPadding=90]="revealHorizontalRightPadding",X[X.roundedSelection=91]="roundedSelection",X[X.rulers=92]="rulers",X[X.scrollbar=93]="scrollbar",X[X.scrollBeyondLastColumn=94]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=95]="scrollBeyondLastLine",X[X.scrollPredominantAxis=96]="scrollPredominantAxis",X[X.selectionClipboard=97]="selectionClipboard",X[X.selectionHighlight=98]="selectionHighlight",X[X.selectOnLineNumbers=99]="selectOnLineNumbers",X[X.showFoldingControls=100]="showFoldingControls",X[X.showUnused=101]="showUnused",X[X.snippetSuggestions=102]="snippetSuggestions",X[X.smartSelect=103]="smartSelect",X[X.smoothScrolling=104]="smoothScrolling",X[X.stickyScroll=105]="stickyScroll",X[X.stickyTabStops=106]="stickyTabStops",X[X.stopRenderingLineAfter=107]="stopRenderingLineAfter",X[X.suggest=108]="suggest",X[X.suggestFontSize=109]="suggestFontSize",X[X.suggestLineHeight=110]="suggestLineHeight",X[X.suggestOnTriggerCharacters=111]="suggestOnTriggerCharacters",X[X.suggestSelection=112]="suggestSelection",X[X.tabCompletion=113]="tabCompletion",X[X.tabIndex=114]="tabIndex",X[X.unicodeHighlighting=115]="unicodeHighlighting",X[X.unusualLineTerminators=116]="unusualLineTerminators",X[X.useShadowDOM=117]="useShadowDOM",X[X.useTabStops=118]="useTabStops",X[X.wordSeparators=119]="wordSeparators",X[X.wordWrap=120]="wordWrap",X[X.wordWrapBreakAfterCharacters=121]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=122]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=123]="wordWrapColumn",X[X.wordWrapOverride1=124]="wordWrapOverride1",X[X.wordWrapOverride2=125]="wordWrapOverride2",X[X.wrappingIndent=126]="wrappingIndent",X[X.wrappingStrategy=127]="wrappingStrategy",X[X.showDeprecated=128]="showDeprecated",X[X.inlayHints=129]="inlayHints",X[X.editorClassName=130]="editorClassName",X[X.pixelRatio=131]="pixelRatio",X[X.tabFocusMode=132]="tabFocusMode",X[X.layoutInfo=133]="layoutInfo",X[X.wrappingInfo=134]="wrappingInfo"})(rt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Te(new d(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:r.localize(165,null)})),acceptSuggestionOnEnter:Te(new l(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",r.localize(166,null),""],markdownDescription:r.localize(167,null)})),accessibilitySupport:Te(new o),accessibilityPageSize:Te(new D(3,"accessibilityPageSize",10,1,1073741824,{description:r.localize(168,null)})),ariaLabel:Te(new b(4,"ariaLabel",r.localize(169,null))),autoClosingBrackets:Te(new l(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",r.localize(170,null),r.localize(171,null),""],description:r.localize(172,null)})),autoClosingDelete:Te(new l(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",r.localize(173,null),""],description:r.localize(174,null)})),autoClosingOvertype:Te(new l(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",r.localize(175,null),""],description:r.localize(176,null)})),autoClosingQuotes:Te(new l(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",r.localize(177,null),r.localize(178,null),""],description:r.localize(179,null)})),autoIndent:Te(new i(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],n,{enumDescriptions:[r.localize(180,null),r.localize(181,null),r.localize(182,null),r.localize(183,null),r.localize(184,null)],description:r.localize(185,null)})),automaticLayout:Te(new d(10,"automaticLayout",!1)),autoSurround:Te(new l(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[r.localize(186,null),r.localize(187,null),r.localize(188,null),""],description:r.localize(189,null)})),bracketPairColorization:Te(new I),bracketPairGuides:Te(new B),stickyTabStops:Te(new d(106,"stickyTabStops",!1,{description:r.localize(190,null)})),codeLens:Te(new d(14,"codeLens",!0,{description:r.localize(191,null)})),codeLensFontFamily:Te(new b(15,"codeLensFontFamily","",{description:r.localize(192,null)})),codeLensFontSize:Te(new D(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:r.localize(193,null)})),colorDecorators:Te(new d(17,"colorDecorators",!0,{description:r.localize(194,null)})),columnSelection:Te(new d(18,"columnSelection",!1,{description:r.localize(195,null)})),comments:Te(new f),contextmenu:Te(new d(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Te(new d(21,"copyWithSyntaxHighlighting",!0,{description:r.localize(196,null)})),cursorBlinking:Te(new i(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],h,{description:r.localize(197,null)})),cursorSmoothCaretAnimation:Te(new d(23,"cursorSmoothCaretAnimation",!1,{description:r.localize(198,null)})),cursorStyle:Te(new i(24,"cursorStyle",p.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],M,{description:r.localize(199,null)})),cursorSurroundingLines:Te(new D(25,"cursorSurroundingLines",0,0,1073741824,{description:r.localize(200,null)})),cursorSurroundingLinesStyle:Te(new l(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[r.localize(201,null),r.localize(202,null)],description:r.localize(203,null)})),cursorWidth:Te(new D(27,"cursorWidth",0,0,1073741824,{markdownDescription:r.localize(204,null)})),disableLayerHinting:Te(new d(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Te(new d(29,"disableMonospaceOptimizations",!1)),domReadOnly:Te(new d(30,"domReadOnly",!1)),dragAndDrop:Te(new d(31,"dragAndDrop",!0,{description:r.localize(205,null)})),emptySelectionClipboard:Te(new U),dropIntoEditor:Te(new Ne),stickyScroll:Te(new oe),extraEditorClassName:Te(new b(34,"extraEditorClassName","")),fastScrollSensitivity:Te(new c(35,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:r.localize(206,null)})),find:Te(new y),fixedOverflowWidgets:Te(new d(37,"fixedOverflowWidgets",!1)),folding:Te(new d(38,"folding",!0,{description:r.localize(207,null)})),foldingStrategy:Te(new l(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[r.localize(208,null),r.localize(209,null)],description:r.localize(210,null)})),foldingHighlight:Te(new d(40,"foldingHighlight",!0,{description:r.localize(211,null)})),foldingImportsByDefault:Te(new d(41,"foldingImportsByDefault",!1,{description:r.localize(212,null)})),foldingMaximumRegions:Te(new D(42,"foldingMaximumRegions",5e3,10,65e3,{description:r.localize(213,null)})),unfoldOnClickAfterEndOfLine:Te(new d(43,"unfoldOnClickAfterEndOfLine",!1,{description:r.localize(214,null)})),fontFamily:Te(new b(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:r.localize(215,null)})),fontInfo:Te(new L),fontLigatures2:Te(new x),fontSize:Te(new R),fontWeight:Te(new K),formatOnPaste:Te(new d(49,"formatOnPaste",!1,{description:r.localize(216,null)})),formatOnType:Te(new d(50,"formatOnType",!1,{description:r.localize(217,null)})),glyphMargin:Te(new d(51,"glyphMargin",!0,{description:r.localize(218,null)})),gotoLocation:Te(new W),hideCursorInOverviewRuler:Te(new d(53,"hideCursorInOverviewRuler",!1,{description:r.localize(219,null)})),hover:Te(new $),inDiffEditor:Te(new d(55,"inDiffEditor",!1)),letterSpacing:Te(new c(57,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>c.clamp(X,-5,20),{description:r.localize(220,null)})),lightbulb:Te(new ge),lineDecorationsWidth:Te(new a(59,"lineDecorationsWidth",10)),lineHeight:Te(new ce),lineNumbers:Te(new ke),lineNumbersMinChars:Te(new D(62,"lineNumbersMinChars",5,1,300)),linkedEditing:Te(new d(63,"linkedEditing",!1,{description:r.localize(221,null)})),links:Te(new d(64,"links",!0,{description:r.localize(222,null)})),matchBrackets:Te(new l(65,"matchBrackets","always",["always","near","never"],{description:r.localize(223,null)})),minimap:Te(new me),mouseStyle:Te(new l(67,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Te(new c(68,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:r.localize(224,null)})),mouseWheelZoom:Te(new d(69,"mouseWheelZoom",!1,{markdownDescription:r.localize(225,null)})),multiCursorMergeOverlapping:Te(new d(70,"multiCursorMergeOverlapping",!0,{description:r.localize(226,null)})),multiCursorModifier:Te(new i(71,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ee,{markdownEnumDescriptions:[r.localize(227,null),r.localize(228,null)],markdownDescription:r.localize(229,null)})),multiCursorPaste:Te(new l(72,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[r.localize(230,null),r.localize(231,null)],markdownDescription:r.localize(232,null)})),occurrencesHighlight:Te(new d(73,"occurrencesHighlight",!0,{description:r.localize(233,null)})),overviewRulerBorder:Te(new d(74,"overviewRulerBorder",!0,{description:r.localize(234,null)})),overviewRulerLanes:Te(new D(75,"overviewRulerLanes",3,0,3)),padding:Te(new be),parameterHints:Te(new _e),peekWidgetDefaultFocus:Te(new l(78,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[r.localize(235,null),r.localize(236,null)],description:r.localize(237,null)})),definitionLinkOpensInPeek:Te(new d(79,"definitionLinkOpensInPeek",!1,{description:r.localize(238,null)})),quickSuggestions:Te(new Be),quickSuggestionsDelay:Te(new D(81,"quickSuggestionsDelay",10,0,1073741824,{description:r.localize(239,null)})),readOnly:Te(new d(82,"readOnly",!1)),renameOnType:Te(new d(83,"renameOnType",!1,{description:r.localize(240,null),markdownDeprecationMessage:r.localize(241,null)})),renderControlCharacters:Te(new d(84,"renderControlCharacters",!0,{description:r.localize(242,null),restricted:!0})),renderFinalNewline:Te(new d(85,"renderFinalNewline",!0,{description:r.localize(243,null)})),renderLineHighlight:Te(new l(86,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",r.localize(244,null)],description:r.localize(245,null)})),renderLineHighlightOnlyWhenFocus:Te(new d(87,"renderLineHighlightOnlyWhenFocus",!1,{description:r.localize(246,null)})),renderValidationDecorations:Te(new l(88,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Te(new l(89,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",r.localize(247,null),r.localize(248,null),r.localize(249,null),""],description:r.localize(250,null)})),revealHorizontalRightPadding:Te(new D(90,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Te(new d(91,"roundedSelection",!0,{description:r.localize(251,null)})),rulers:Te(new De),scrollbar:Te(new ue),scrollBeyondLastColumn:Te(new D(94,"scrollBeyondLastColumn",4,0,1073741824,{description:r.localize(252,null)})),scrollBeyondLastLine:Te(new d(95,"scrollBeyondLastLine",!0,{description:r.localize(253,null)})),scrollPredominantAxis:Te(new d(96,"scrollPredominantAxis",!0,{description:r.localize(254,null)})),selectionClipboard:Te(new d(97,"selectionClipboard",!0,{description:r.localize(255,null),included:C.isLinux})),selectionHighlight:Te(new d(98,"selectionHighlight",!0,{description:r.localize(256,null)})),selectOnLineNumbers:Te(new d(99,"selectOnLineNumbers",!0)),showFoldingControls:Te(new l(100,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[r.localize(257,null),r.localize(258,null),r.localize(259,null)],description:r.localize(260,null)})),showUnused:Te(new d(101,"showUnused",!0,{description:r.localize(261,null)})),showDeprecated:Te(new d(128,"showDeprecated",!0,{description:r.localize(262,null)})),inlayHints:Te(new Ee),snippetSuggestions:Te(new l(102,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[r.localize(263,null),r.localize(264,null),r.localize(265,null),r.localize(266,null)],description:r.localize(267,null)})),smartSelect:Te(new se),smoothScrolling:Te(new d(104,"smoothScrolling",!1,{description:r.localize(268,null)})),stopRenderingLineAfter:Te(new D(107,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Te(new j),inlineSuggest:Te(new J),suggestFontSize:Te(new D(109,"suggestFontSize",0,0,1e3,{markdownDescription:r.localize(269,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Te(new D(110,"suggestLineHeight",0,0,1e3,{markdownDescription:r.localize(270,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Te(new d(111,"suggestOnTriggerCharacters",!0,{description:r.localize(271,null)})),suggestSelection:Te(new l(112,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[r.localize(272,null),r.localize(273,null),r.localize(274,null)],description:r.localize(275,null)})),tabCompletion:Te(new l(113,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[r.localize(276,null),r.localize(277,null),r.localize(278,null)],description:r.localize(279,null)})),tabIndex:Te(new D(114,"tabIndex",0,-1,1073741824)),unicodeHighlight:Te(new Z),unusualLineTerminators:Te(new l(116,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[r.localize(280,null),r.localize(281,null),r.localize(282,null)],description:r.localize(283,null)})),useShadowDOM:Te(new d(117,"useShadowDOM",!0)),useTabStops:Te(new d(118,"useTabStops",!0,{description:r.localize(284,null)})),wordSeparators:Te(new b(119,"wordSeparators",S.USUAL_WORD_SEPARATORS,{description:r.localize(285,null)})),wordWrap:Te(new l(120,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[r.localize(286,null),r.localize(287,null),r.localize(288,null),r.localize(289,null)],description:r.localize(290,null)})),wordWrapBreakAfterCharacters:Te(new b(121,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Te(new b(122,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Te(new D(123,"wordWrapColumn",80,1,1073741824,{markdownDescription:r.localize(291,null)})),wordWrapOverride1:Te(new l(124,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Te(new l(125,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Te(new i(126,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],ve,{enumDescriptions:[r.localize(292,null),r.localize(293,null),r.localize(294,null),r.localize(295,null)],description:r.localize(296,null)})),wrappingStrategy:Te(new l(127,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[r.localize(297,null),r.localize(298,null)],description:r.localize(299,null)})),editorClassName:Te(new V),pixelRatio:Te(new Fe),tabFocusMode:Te(new le),layoutInfo:Te(new re),wrappingInfo:Te(new pe)}}),define(Ce[124],Ie([16,17]),function(ie,e){return ie.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ce[125],Ie([16,17]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ce[126],Ie([16,17]),function(ie,e){return ie.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ce[127],Ie([16,17]),function(ie,e){return ie.create("vs/platform/files/common/files",e)}),define(Ce[128],Ie([16,17]),function(ie,e){return ie.create("vs/platform/markers/common/markers",e)}),define(Ce[129],Ie([16,17]),function(ie,e){return ie.create("vs/platform/workspace/common/workspace",e)}),define(Ce[130],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ce[131],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ce[132],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostProgress",e)}),define(Ce[133],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ce[134],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ce[135],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ce[136],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ce[137],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/common/editor",e)}),define(Ce[138],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ce[139],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ce[140],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ce[141],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ce[142],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ce[143],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ce[144],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ce[145],Ie([1,0,22,29,126,240]),function(ie,e,r,C,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const _=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function E(d){return d=d.trim(),d==="*"||_.test(d)}e.isValidVersionStr=E;function P(d){if(!E(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=d.match(_);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=P;function O(d){if(!d)return null;const v=d.majorBase,D=d.majorMustEqual,c=d.minorBase;let b=d.minorMustEqual;const t=d.patchBase;let l=d.patchMustEqual;d.hasCaret&&(v===0||(b=!1),l=!1);let i=0;if(d.preRelease){const n=A.exec(d.preRelease);if(n){const[,o,f,s]=n;i=Date.UTC(Number(o),Number(f)-1,Number(s))}}return{majorBase:v,majorMustEqual:D,minorBase:c,minorMustEqual:b,patchBase:t,patchMustEqual:l,isMinimum:d.hasGreaterEquals,notBefore:i}}e.normalizeVersion=O;function w(d,v,D){let c;typeof d=="string"?c=O(P(d)):c=d;let b;v instanceof Date?b=v.getTime():typeof v=="string"&&(b=new Date(v).getTime());let t;if(typeof D=="string"?t=O(P(D)):t=D,!c||!t)return!1;const l=c.majorBase,i=c.minorBase,n=c.patchBase;let o=t.majorBase,f=t.minorBase,s=t.patchBase;const h=t.notBefore;let p=t.majorMustEqual,T=t.minorMustEqual,M=t.patchMustEqual;return t.isMinimum?l>o?!0:l<o?!1:i>f?!0:i<f||b&&b<h?!1:n>=s:(l===1&&o===0&&(!p||!T||!M)&&(o=1,f=0,s=0,p=!0,T=!1,M=!1),l<o?!1:l>o?!p:i<f?!1:i>f?!T:n<s?!1:n>s?!M:!(b&&b<h))}e.isValidVersion=w;function g(d,v,D,c,b){const t=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return t.push([C.default.Error,S.localize(0,null)]),t;if(typeof c.name!="string")return t.push([C.default.Error,S.localize(1,null,"name")]),t;if(typeof c.version!="string")return t.push([C.default.Error,S.localize(2,null,"version")]),t;if(!c.engines)return t.push([C.default.Error,S.localize(3,null,"engines")]),t;if(typeof c.engines.vscode!="string")return t.push([C.default.Error,S.localize(4,null,"engines.vscode")]),t;if(typeof c.extensionDependencies<"u"&&!u(c.extensionDependencies))return t.push([C.default.Error,S.localize(5,null,"extensionDependencies")]),t;if(typeof c.activationEvents<"u"){if(!u(c.activationEvents))return t.push([C.default.Error,S.localize(6,null,"activationEvents")]),t;if(typeof c.main>"u"&&typeof c.browser>"u")return t.push([C.default.Error,S.localize(7,null,"activationEvents","main")]),t}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&t.push([C.default.Warning,S.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return t.push([C.default.Error,S.localize(9,null,"main")]),t;{const n=(0,r.joinPath)(D,c.main);(0,r.isEqualOrParent)(n,D)||t.push([C.default.Warning,S.localize(10,null,n.path,D.path)])}if(typeof c.activationEvents>"u")return t.push([C.default.Error,S.localize(11,null,"activationEvents","main")]),t}if(typeof c.browser<"u"){if(typeof c.browser!="string")return t.push([C.default.Error,S.localize(12,null,"browser")]),t;{const n=(0,r.joinPath)(D,c.browser);(0,r.isEqualOrParent)(n,D)||t.push([C.default.Warning,S.localize(13,null,n.path,D.path)])}if(typeof c.activationEvents>"u")return t.push([C.default.Error,S.localize(14,null,"activationEvents","browser")]),t}if(!N.valid(c.version))return t.push([C.default.Error,S.localize(15,null)]),t;const l=[];if(!k(d,v,c,b,l))for(const n of l)t.push([C.default.Error,n]);return t}e.validateExtensionManifest=g;function k(d,v,D,c,b){return c||typeof D.main>"u"&&typeof D.browser>"u"?!0:a(d,v,D.engines.vscode,b)}e.isValidExtensionVersion=k;function m(d,v,D){return d==="*"||a(v,D,d)}e.isEngineValid=m;function a(d,v,D,c=[]){const b=O(P(D));if(!b)return c.push(S.localize(16,null,D)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return c.push(S.localize(17,null,D)),!1}else if(!b.majorMustEqual)return c.push(S.localize(18,null,D)),!1;return w(d,v,b)?!0:(c.push(S.localize(19,null,d,D)),!1)}function u(d){if(!Array.isArray(d))return!1;for(let v=0,D=d.length;v<D;v++)if(typeof d[v]!="string")return!1;return!0}}),define(Ce[80],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class r{constructor(S,N=[],_=!1){this.ctor=S,this.staticArguments=N,this.supportsDelayedInstantiation=_}}e.SyncDescriptor=r}),define(Ce[56],Ie([1,0,80]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const C=[];var S;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(S=e.InstantiationType||(e.InstantiationType={}));function N(A,E,P){E instanceof r.SyncDescriptor||(E=new r.SyncDescriptor(E,[],Boolean(P))),C.push([A,E])}e.registerSingleton=N;function _(){return C}e.getSingletonServiceDescriptors=_}),define(Ce[146],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class r{constructor(N,_){this.key=N,this.data=_,this.incoming=new Map,this.outgoing=new Map}}e.Node=r;class C{constructor(N){this._hashFn=N,this._nodes=new Map}roots(){const N=[];for(const _ of this._nodes.values())_.outgoing.size===0&&N.push(_);return N}insertEdge(N,_){const A=this.lookupOrInsertNode(N),E=this.lookupOrInsertNode(_);A.outgoing.set(E.key,E),E.incoming.set(A.key,A)}removeNode(N){const _=this._hashFn(N);this._nodes.delete(_);for(const A of this._nodes.values())A.outgoing.delete(_),A.incoming.delete(_)}lookupOrInsertNode(N){const _=this._hashFn(N);let A=this._nodes.get(_);return A||(A=new r(_,N),this._nodes.set(_,A)),A}lookup(N){return this._nodes.get(this._hashFn(N))}isEmpty(){return this._nodes.size===0}toString(){const N=[];for(const[_,A]of this._nodes)N.push(`${_}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,_]of this._nodes){const A=new Set([N]),E=this._findCycle(_,A);if(E)return E}}_findCycle(N,_){for(const[A,E]of N.outgoing){if(_.has(A))return[..._,A].join(" -> ");_.add(A);const P=this._findCycle(E,_);if(P)return P;_.delete(A)}}}e.Graph=C}),define(Ce[3],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var r;(function(_){_.serviceIds=new Map,_.DI_TARGET="$di$target",_.DI_DEPENDENCIES="$di$dependencies";function A(E){return E[_.DI_DEPENDENCIES]||[]}_.getServiceDependencies=A})(r=e._util||(e._util={})),e.IInstantiationService=S("instantiationService");function C(_,A,E){A[r.DI_TARGET]===A?A[r.DI_DEPENDENCIES].push({id:_,index:E}):(A[r.DI_DEPENDENCIES]=[{id:_,index:E}],A[r.DI_TARGET]=A)}function S(_){if(r.serviceIds.has(_))return r.serviceIds.get(_);const A=function(E,P,O){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(A,E,O)};return A.toString=()=>_,r.serviceIds.set(_,A),A}e.createDecorator=S;function N(_){return _}e.refineServiceDecorator=N}),define(Ce[57],Ie([1,0,10,2,3]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,S.createDecorator)("configurationService");function N(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof C.URI)}e.isConfigurationOverrides=N;function _(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof C.URI)}e.isConfigurationUpdateOverrides=_;var A;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function E(d){switch(d){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=E;function P(d,v){const D=Object.create(null);for(const c in d)O(D,c,d[c],v);return D}e.toValuesTree=P;function O(d,v,D,c){const b=v.split("."),t=b.pop();let l=d;for(let i=0;i<b.length;i++){const n=b[i];let o=l[n];switch(typeof o){case"undefined":o=l[n]=Object.create(null);break;case"object":break;default:c(`Ignoring ${v} as ${b.slice(0,i+1).join(".")} is ${JSON.stringify(o)}`);return}l=o}if(typeof l=="object"&&l!==null)try{l[t]=D}catch{c(`Ignoring ${v} as ${b.join(".")} is ${JSON.stringify(l)}`)}else c(`Ignoring ${v} as ${b.join(".")} is ${JSON.stringify(l)}`)}e.addToValueTree=O;function w(d,v){const D=v.split(".");g(d,D)}e.removeFromValueTree=w;function g(d,v){const D=v.shift();if(v.length===0){delete d[D];return}if(Object.keys(d).indexOf(D)!==-1){const c=d[D];typeof c=="object"&&!Array.isArray(c)&&(g(c,v),Object.keys(c).length===0&&delete d[D])}}function k(d,v,D){function c(l,i){let n=l;for(const o of i){if(typeof n!="object"||n===null)return;n=n[o]}return n}const b=v.split("."),t=c(d,b);return typeof t>"u"?D:t}e.getConfigurationValue=k;function m(d,v,D){Object.keys(v).forEach(c=>{c!=="__proto__"&&(c in d?r.isObject(d[c])&&r.isObject(v[c])?m(d[c],v[c],D):D&&(d[c]=v[c]):d[c]=v[c])})}e.merge=m;function a(d,v,D){const c=d.inspect(v),b=d.inspect(D);return typeof c.userValue<"u"||typeof c.workspaceValue<"u"||typeof c.workspaceFolderValue<"u"?c.value:typeof b.userValue<"u"||typeof b.workspaceValue<"u"||typeof b.workspaceFolderValue<"u"?b.value:c.defaultValue}e.getMigratedSettingValue=a;function u(d){return d.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=u}),define(Ce[39],Ie([1,0,21,9,3]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const N=new Map;N.set("false",!1),N.set("true",!0),N.set("isMac",r.isMacintosh),N.set("isLinux",r.isLinux),N.set("isWindows",r.isWindows),N.set("isWeb",r.isWeb),N.set("isMacNative",r.isMacintosh&&!r.isWeb),N.set("isEdge",r.isEdge),N.set("isFirefox",r.isFirefox),N.set("isChrome",r.isChrome),N.set("isSafari",r.isSafari);const _=Object.prototype.hasOwnProperty;var A;(function(U){U[U.False=0]="False",U[U.True=1]="True",U[U.Defined=2]="Defined",U[U.Not=3]="Not",U[U.Equals=4]="Equals",U[U.NotEquals=5]="NotEquals",U[U.And=6]="And",U[U.Regex=7]="Regex",U[U.NotRegex=8]="NotRegex",U[U.Or=9]="Or",U[U.In=10]="In",U[U.NotIn=11]="NotIn",U[U.Greater=12]="Greater",U[U.GreaterEquals=13]="GreaterEquals",U[U.Smaller=14]="Smaller",U[U.SmallerEquals=15]="SmallerEquals"})(A=e.ContextKeyExprType||(e.ContextKeyExprType={}));class E{static false(){return w.INSTANCE}static true(){return g.INSTANCE}static has(y){return k.create(y)}static equals(y,x){return m.create(y,x)}static notEquals(y,x){return d.create(y,x)}static regex(y,x){return i.create(y,x)}static in(y,x){return a.create(y,x)}static notIn(y,x){return u.create(y,x)}static not(y){return v.create(y)}static and(...y){return f.create(y,null)}static or(...y){return s.create(y,null,!0)}static greater(y,x){return c.create(y,x)}static greaterEquals(y,x){return b.create(y,x)}static smaller(y,x){return t.create(y,x)}static smallerEquals(y,x){return l.create(y,x)}static deserialize(y,x=!1){if(!!y)return this._deserializeOrExpression(y,x)}static _deserializeOrExpression(y,x){const L=y.split("||");return s.create(L.map(R=>this._deserializeAndExpression(R,x)),null,!0)}static _deserializeAndExpression(y,x){const L=y.split("&&");return f.create(L.map(R=>this._deserializeOne(R,x)),null)}static _deserializeOne(y,x){if(y=y.trim(),y.indexOf("!=")>=0){const L=y.split("!=");return d.create(L[0].trim(),this._deserializeValue(L[1],x))}if(y.indexOf("==")>=0){const L=y.split("==");return m.create(L[0].trim(),this._deserializeValue(L[1],x))}if(y.indexOf("=~")>=0){const L=y.split("=~");return i.create(L[0].trim(),this._deserializeRegexValue(L[1],x))}if(y.indexOf(" not in ")>=0){const L=y.split(" not in ");return u.create(L[0].trim(),L[1].trim())}if(y.indexOf(" in ")>=0){const L=y.split(" in ");return a.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(y)){const L=y.split(">=");return b.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(y)){const L=y.split(">");return c.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(y)){const L=y.split("<=");return l.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(y)){const L=y.split("<");return t.create(L[0].trim(),L[1].trim())}return/^\!\s*/.test(y)?v.create(y.substr(1).trim()):k.create(y)}static _deserializeValue(y,x){if(y=y.trim(),y==="true")return!0;if(y==="false")return!1;const L=/^'([^']*)'$/.exec(y);return L?L[1].trim():y}static _deserializeRegexValue(y,x){if((0,C.isFalsyOrWhitespace)(y)){if(x)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const L=y.indexOf("/"),R=y.lastIndexOf("/");if(L===R||L<0){if(x)throw new Error(`bad regexp-value '${y}', missing /-enclosure`);return console.warn(`bad regexp-value '${y}', missing /-enclosure`),null}const K=y.slice(L+1,R),W=y[R+1]==="i"?"i":"";try{return new RegExp(K,W)}catch($){if(x)throw new Error(`bad regexp-value '${y}', parse error: ${$}`);return console.warn(`bad regexp-value '${y}', parse error: ${$}`),null}}}e.ContextKeyExpr=E;function P(U,y){const x=U?U.substituteConstants():void 0,L=y?y.substituteConstants():void 0;return!x&&!L?!0:!x||!L?!1:x.equals(L)}e.expressionsAreEqualWithConstantSubstitution=P;function O(U,y){return U.cmp(y)}class w{constructor(){this.type=0}cmp(y){return this.type-y.type}equals(y){return y.type===this.type}substituteConstants(){return this}evaluate(y){return!1}serialize(){return"false"}keys(){return[]}map(y){return this}negate(){return g.INSTANCE}}e.ContextKeyFalseExpr=w,w.INSTANCE=new w;class g{constructor(){this.type=1}cmp(y){return this.type-y.type}equals(y){return y.type===this.type}substituteConstants(){return this}evaluate(y){return!0}serialize(){return"true"}keys(){return[]}map(y){return this}negate(){return w.INSTANCE}}e.ContextKeyTrueExpr=g,g.INSTANCE=new g;class k{static create(y,x=null){const L=N.get(y);return typeof L=="boolean"?L?g.INSTANCE:w.INSTANCE:new k(y,x)}constructor(y,x){this.key=y,this.negated=x,this.type=2}cmp(y){return y.type!==this.type?this.type-y.type:p(this.key,y.key)}equals(y){return y.type===this.type?this.key===y.key:!1}substituteConstants(){const y=N.get(this.key);return typeof y=="boolean"?y?g.INSTANCE:w.INSTANCE:this}evaluate(y){return!!y.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(y){return y.mapDefined(this.key)}negate(){return this.negated||(this.negated=v.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=k;class m{static create(y,x,L=null){if(typeof x=="boolean")return x?k.create(y,L):v.create(y,L);const R=N.get(y);return typeof R=="boolean"?x===(R?"true":"false")?g.INSTANCE:w.INSTANCE:new m(y,x,L)}constructor(y,x,L){this.key=y,this.value=x,this.negated=L,this.type=4}cmp(y){return y.type!==this.type?this.type-y.type:T(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){const y=N.get(this.key);if(typeof y=="boolean"){const x=y?"true":"false";return this.value===x?g.INSTANCE:w.INSTANCE}return this}evaluate(y){return y.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(y){return y.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=m;class a{static create(y,x){return new a(y,x)}constructor(y,x){this.key=y,this.valueKey=x,this.type=10,this.negated=null}cmp(y){return y.type!==this.type?this.type-y.type:T(this.key,this.valueKey,y.key,y.valueKey)}equals(y){return y.type===this.type?this.key===y.key&&this.valueKey===y.valueKey:!1}substituteConstants(){return this}evaluate(y){const x=y.getValue(this.valueKey),L=y.getValue(this.key);return Array.isArray(x)?x.includes(L):typeof L=="string"&&typeof x=="object"&&x!==null?_.call(x,L):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(y){return y.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=u.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=a;class u{static create(y,x){return new u(y,x)}constructor(y,x){this.key=y,this.valueKey=x,this.type=11,this._negated=a.create(y,x)}cmp(y){return y.type!==this.type?this.type-y.type:this._negated.cmp(y._negated)}equals(y){return y.type===this.type?this._negated.equals(y._negated):!1}substituteConstants(){return this}evaluate(y){return!this._negated.evaluate(y)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(y){return y.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=u;class d{static create(y,x,L=null){if(typeof x=="boolean")return x?v.create(y,L):k.create(y,L);const R=N.get(y);return typeof R=="boolean"?x===(R?"true":"false")?w.INSTANCE:g.INSTANCE:new d(y,x,L)}constructor(y,x,L){this.key=y,this.value=x,this.negated=L,this.type=5}cmp(y){return y.type!==this.type?this.type-y.type:T(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){const y=N.get(this.key);if(typeof y=="boolean"){const x=y?"true":"false";return this.value===x?w.INSTANCE:g.INSTANCE}return this}evaluate(y){return y.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(y){return y.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=d;class v{static create(y,x=null){const L=N.get(y);return typeof L=="boolean"?L?w.INSTANCE:g.INSTANCE:new v(y,x)}constructor(y,x){this.key=y,this.negated=x,this.type=3}cmp(y){return y.type!==this.type?this.type-y.type:p(this.key,y.key)}equals(y){return y.type===this.type?this.key===y.key:!1}substituteConstants(){const y=N.get(this.key);return typeof y=="boolean"?y?w.INSTANCE:g.INSTANCE:this}evaluate(y){return!y.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(y){return y.mapNot(this.key)}negate(){return this.negated||(this.negated=k.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=v;function D(U,y){if(typeof U=="string"){const x=parseFloat(U);isNaN(x)||(U=x)}return typeof U=="string"||typeof U=="number"?y(U):w.INSTANCE}class c{static create(y,x,L=null){return D(x,R=>new c(y,R,L))}constructor(y,x,L){this.key=y,this.value=x,this.negated=L,this.type=12}cmp(y){return y.type!==this.type?this.type-y.type:T(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(y){return y.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=c;class b{static create(y,x,L=null){return D(x,R=>new b(y,R,L))}constructor(y,x,L){this.key=y,this.value=x,this.negated=L,this.type=13}cmp(y){return y.type!==this.type?this.type-y.type:T(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(y){return y.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=t.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=b;class t{static create(y,x,L=null){return D(x,R=>new t(y,R,L))}constructor(y,x,L){this.key=y,this.value=x,this.negated=L,this.type=14}cmp(y){return y.type!==this.type?this.type-y.type:T(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(y){return y.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=t;class l{static create(y,x,L=null){return D(x,R=>new l(y,R,L))}constructor(y,x,L){this.key=y,this.value=x,this.negated=L,this.type=15}cmp(y){return y.type!==this.type?this.type-y.type:T(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(y){return y.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=l;class i{static create(y,x){return new i(y,x)}constructor(y,x){this.key=y,this.regexp=x,this.type=7,this.negated=null}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.key<y.key)return-1;if(this.key>y.key)return 1;const x=this.regexp?this.regexp.source:"",L=y.regexp?y.regexp.source:"";return x<L?-1:x>L?1:0}equals(y){if(y.type===this.type){const x=this.regexp?this.regexp.source:"",L=y.regexp?y.regexp.source:"";return this.key===y.key&&x===L}return!1}substituteConstants(){return this}evaluate(y){const x=y.getValue(this.key);return this.regexp?this.regexp.test(x):!1}serialize(){const y=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${y}`}keys(){return[this.key]}map(y){return y.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=n.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class n{static create(y){return new n(y)}constructor(y){this._actual=y,this.type=8}cmp(y){return y.type!==this.type?this.type-y.type:this._actual.cmp(y._actual)}equals(y){return y.type===this.type?this._actual.equals(y._actual):!1}substituteConstants(){return this}evaluate(y){return!this._actual.evaluate(y)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(y){return new n(this._actual.map(y))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;function o(U){let y=null;for(let x=0,L=U.length;x<L;x++){const R=U[x].substituteConstants();if(U[x]!==R&&y===null){y=[];for(let K=0;K<x;K++)y[K]=U[K]}y!==null&&(y[x]=R)}return y===null?U:y}class f{static create(y,x){return f._normalizeArr(y,x)}constructor(y,x){this.expr=y,this.negated=x,this.type=6}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.expr.length<y.expr.length)return-1;if(this.expr.length>y.expr.length)return 1;for(let x=0,L=this.expr.length;x<L;x++){const R=O(this.expr[x],y.expr[x]);if(R!==0)return R}return 0}equals(y){if(y.type===this.type){if(this.expr.length!==y.expr.length)return!1;for(let x=0,L=this.expr.length;x<L;x++)if(!this.expr[x].equals(y.expr[x]))return!1;return!0}return!1}substituteConstants(){const y=o(this.expr);return y===this.expr?this:f.create(y,this.negated)}evaluate(y){for(let x=0,L=this.expr.length;x<L;x++)if(!this.expr[x].evaluate(y))return!1;return!0}static _normalizeArr(y,x){const L=[];let R=!1;for(const K of y)if(!!K){if(K.type===1){R=!0;continue}if(K.type===0)return w.INSTANCE;if(K.type===6){L.push(...K.expr);continue}L.push(K)}if(L.length===0&&R)return g.INSTANCE;if(L.length!==0){if(L.length===1)return L[0];L.sort(O);for(let K=1;K<L.length;K++)L[K-1].equals(L[K])&&(L.splice(K,1),K--);if(L.length===1)return L[0];for(;L.length>1;){const K=L[L.length-1];if(K.type!==9)break;L.pop();const W=L.pop(),$=L.length===0,G=s.create(K.expr.map(re=>f.create([re,W],null)),null,$);G&&(L.push(G),L.sort(O))}return L.length===1?L[0]:new f(L,x)}}serialize(){return this.expr.map(y=>y.serialize()).join(" && ")}keys(){const y=[];for(const x of this.expr)y.push(...x.keys());return y}map(y){return new f(this.expr.map(x=>x.map(y)),null)}negate(){if(!this.negated){const y=[];for(const x of this.expr)y.push(x.negate());this.negated=s.create(y,this,!0)}return this.negated}}class s{static create(y,x,L){return s._normalizeArr(y,x,L)}constructor(y,x){this.expr=y,this.negated=x,this.type=9}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.expr.length<y.expr.length)return-1;if(this.expr.length>y.expr.length)return 1;for(let x=0,L=this.expr.length;x<L;x++){const R=O(this.expr[x],y.expr[x]);if(R!==0)return R}return 0}equals(y){if(y.type===this.type){if(this.expr.length!==y.expr.length)return!1;for(let x=0,L=this.expr.length;x<L;x++)if(!this.expr[x].equals(y.expr[x]))return!1;return!0}return!1}substituteConstants(){const y=o(this.expr);return y===this.expr?this:s.create(y,this.negated,!1)}evaluate(y){for(let x=0,L=this.expr.length;x<L;x++)if(this.expr[x].evaluate(y))return!0;return!1}static _normalizeArr(y,x,L){let R=[],K=!1;if(y){for(let W=0,$=y.length;W<$;W++){const G=y[W];if(!!G){if(G.type===0){K=!0;continue}if(G.type===1)return g.INSTANCE;if(G.type===9){R=R.concat(G.expr);continue}R.push(G)}}if(R.length===0&&K)return w.INSTANCE;R.sort(O)}if(R.length!==0){if(R.length===1)return R[0];for(let W=1;W<R.length;W++)R[W-1].equals(R[W])&&(R.splice(W,1),W--);if(R.length===1)return R[0];if(L){for(let W=0;W<R.length;W++)for(let $=W+1;$<R.length;$++)M(R[W],R[$])&&(R.splice($,1),$--);if(R.length===1)return R[0]}return new s(R,x)}}serialize(){return this.expr.map(y=>y.serialize()).join(" || ")}keys(){const y=[];for(const x of this.expr)y.push(...x.keys());return y}map(y){return new s(this.expr.map(x=>x.map(y)),null)}negate(){if(!this.negated){const y=[];for(const x of this.expr)y.push(x.negate());for(;y.length>1;){const x=y.shift(),L=y.shift(),R=[];for(const W of V(x))for(const $ of V(L))R.push(f.create([W,$],null));const K=y.length===0;y.unshift(s.create(R,null,K))}this.negated=y[0]}return this.negated}}class h extends k{static all(){return h._info.values()}constructor(y,x,L){super(y,null),this._defaultValue=x,typeof L=="object"?h._info.push({...L,key:y}):L!==!0&&h._info.push({key:y,description:L,type:x!=null?typeof x:void 0})}bindTo(y){return y.createKey(this.key,this._defaultValue)}getValue(y){return y.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(y){return m.create(this.key,y)}notEqualsTo(y){return d.create(this.key,y)}}e.RawContextKey=h,h._info=[],e.IContextKeyService=(0,S.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function p(U,y){return U<y?-1:U>y?1:0}function T(U,y,x,L){return U<x?-1:U>x?1:y<L?-1:y>L?1:0}function M(U,y){if(y.type===6&&U.type!==9&&U.type!==6){for(const R of y.expr)if(U.equals(R))return!0}const x=U.negate(),L=V(x).concat(V(y));L.sort(O);for(let R=0;R<L.length;R++){const W=L[R].negate();for(let $=R+1;$<L.length;$++){const G=L[$];if(W.equals(G))return!0}}return!1}e.implies=M;function V(U){return U.type===9?U.expr:[U]}}),define(Ce[147],Ie([1,0,3]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,r.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,r.refineServiceDecorator)(e.IEnvironmentService)}),define(Ce[81],Ie([1,0,125,3]),function(ie,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function S(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=S;function N(d){switch(d){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=N;function _(d,v){switch(d){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=_;function A(d,v){return v==="web"&&!d.includes("web")}e.isNotWebExtensionInWebTargetPlatform=A;function E(d,v,D){return A(v,D)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===D?!0:P(D).includes(d)}e.isTargetPlatformCompatible=E;function P(d){switch(d){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=P;function O(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=O;var w;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(w=e.SortBy||(e.SortBy={}));var g;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(g=e.SortOrder||(e.SortOrder={}));var k;(function(d){d.Install="install",d.Uninstall="uninstall"})(k=e.StatisticType||(e.StatisticType={}));var m;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(m=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,C.createDecorator)("extensionGalleryService");var a;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatiblePreRelease="IncompatiblePreRelease",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.Extract="Extract",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Internal="Internal"})(a=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class u extends Error{constructor(v,D){super(v),this.code=D,this.name=D}}e.ExtensionManagementError=u,e.IExtensionManagementService=(0,C.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,C.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,C.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,r.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,r.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Ce[35],Ie([1,0,24,19,9,10,2,127,3]),function(ie,e,r,C,S,N,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,E.createDecorator)("fileService");function P(W){return W.create===!0}e.isFileOpenForWriteOptions=P;var O;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(O=e.FileType||(e.FileType={}));var w;(function(W){W[W.Readonly=1]="Readonly"})(w=e.FilePermission||(e.FilePermission={}));var g;(function(W){W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead",W[W.FileClone=32768]="FileClone"})(g=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function k(W){return!!(W.capabilities&2)}e.hasReadWriteCapability=k;function m(W){return!!(W.capabilities&8)}e.hasFileFolderCopyCapability=m;function a(W){return!!(W.capabilities&32768)}e.hasFileCloneCapability=a;function u(W){return!!(W.capabilities&4)}e.hasOpenReadWriteCloseCapability=u;function d(W){return!!(W.capabilities&16)}e.hasFileReadStreamCapability=d;function v(W){return k(W)?!!(W.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var D;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(D=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class c extends Error{constructor($,G){super($),this.code=G}}e.FileSystemProviderError=c;function b(W,$){const G=new c(W.toString(),$);return l(G,$),G}e.createFileSystemProviderError=b;function t(W){return W||b((0,A.localize)(0,null),D.Unknown)}e.ensureFileSystemProviderError=t;function l(W,$){return W.name=$?`${$} (FileSystemError)`:"FileSystemError",W}e.markAsFileSystemProviderError=l;function i(W){if(!W)return D.Unknown;if(W instanceof c)return W.code;const $=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!$)return D.Unknown;switch($[1]){case D.FileExists:return D.FileExists;case D.FileIsADirectory:return D.FileIsADirectory;case D.FileNotADirectory:return D.FileNotADirectory;case D.FileNotFound:return D.FileNotFound;case D.FileExceedsMemoryLimit:return D.FileExceedsMemoryLimit;case D.FileTooLarge:return D.FileTooLarge;case D.FileWriteLocked:return D.FileWriteLocked;case D.NoPermissions:return D.NoPermissions;case D.Unavailable:return D.Unavailable}return D.Unknown}e.toFileSystemProviderErrorCode=i;function n(W){if(W instanceof T)return W.fileOperationResult;switch(i(W)){case D.FileNotFound:return 1;case D.FileIsADirectory:return 0;case D.FileNotADirectory:return 10;case D.FileWriteLocked:return 5;case D.NoPermissions:return 6;case D.FileExists:return 4;case D.FileExceedsMemoryLimit:return 9;case D.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var o;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(o=e.FileOperation||(e.FileOperation={}));class f{constructor($,G,re){this.resource=$,this.operation=G,this.target=re}isOperation($){return this.operation===$}}e.FileOperationEvent=f;var s;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(s=e.FileChangeType||(e.FileChangeType={}));class h{constructor($,G){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=$;const re=new Map;for(const ge of $){const oe=re.get(ge.type);switch(oe?oe.push([ge.resource,ge]):re.set(ge.type,[[ge.resource,ge]]),ge.type){case 1:this.rawAdded.push(ge.resource);break;case 0:this.rawUpdated.push(ge.resource);break;case 2:this.rawDeleted.push(ge.resource);break}}for(const[ge,oe]of re)switch(ge){case 1:this.added=r.TernarySearchTree.forUris(()=>G),this.added.fill(oe);break;case 0:this.updated=r.TernarySearchTree.forUris(()=>G),this.updated.fill(oe);break;case 2:this.deleted=r.TernarySearchTree.forUris(()=>G),this.deleted.fill(oe);break}}contains($,...G){return this.doContains($,{includeChildren:!1},...G)}affects($,...G){return this.doContains($,{includeChildren:!0},...G)}doContains($,G,...re){if(!$)return!1;const ge=re.length>0;return!!((!ge||re.includes(1))&&(this.added?.get($)||G.includeChildren&&this.added?.findSuperstr($))||(!ge||re.includes(0))&&(this.updated?.get($)||G.includeChildren&&this.updated?.findSuperstr($))||(!ge||re.includes(2))&&(this.deleted?.findSubstr($)||G.includeChildren&&this.deleted?.findSuperstr($)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=h;function p(W,$,G){return!W||!$||W===$||$.length>W.length?!1:($.charAt($.length-1)!==C.sep&&($+=C.sep),G?(0,S.startsWithIgnoreCase)(W,$):W.indexOf($)===0)}e.isParent=p;class T extends Error{constructor($,G,re){super($),this.fileOperationResult=G,this.options=re}}e.FileOperationError=T;class M extends T{constructor($,G,re){super($,2,re),this.stat=G}}e.NotModifiedSinceFileOperationError=M;var V;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",W[W.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(V=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var U;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(U=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function y(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.etag=y;async function x(W,$){if(!$.hasProvider(_.URI.from({scheme:W.scheme})))return new Promise(G=>{const re=$.onDidChangeFileSystemProviderRegistrations(ge=>{ge.scheme===W.scheme&&ge.added&&(re.dispose(),G())})})}e.whenProviderRegistered=x,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class L{static formatSize($){return(0,N.isNumber)($)||($=0),$<L.KB?(0,A.localize)(1,null,$.toFixed(0)):$<L.MB?(0,A.localize)(2,null,($/L.KB).toFixed(2)):$<L.GB?(0,A.localize)(3,null,($/L.MB).toFixed(2)):$<L.TB?(0,A.localize)(4,null,($/L.GB).toFixed(2)):(0,A.localize)(5,null,($/L.TB).toFixed(2))}}e.ByteSize=L,L.KB=1024,L.MB=L.KB*L.KB,L.GB=L.MB*L.KB,L.TB=L.GB*L.KB;var R;(function(W){W[W.IA32=0]="IA32",W[W.OTHER=1]="OTHER"})(R=e.Arch||(e.Arch={}));function K(W){return{maxFileSize:W===0?300*L.MB:16*L.GB,maxHeapSize:W===0?700*L.MB:2*700*L.MB}}e.getPlatformLimits=K}),define(Ce[58],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class r{constructor(...S){this._entries=new Map;for(const[N,_]of S)this.set(N,_)}set(S,N){const _=this._entries.get(S);return this._entries.set(S,N),_}has(S){return this._entries.has(S)}get(S){return this._entries.get(S)}}e.ServiceCollection=r}),define(Ce[148],Ie([1,0,15,12,80,146,3,58]),function(ie,e,r,C,S,N,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const E=!1;class P extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class O{constructor(m=new A.ServiceCollection,a=!1,u,d=E){this._services=m,this._strict=a,this._parent=u,this._enableTracing=d,this._activeInstantiations=new Set,this._services.set(_.IInstantiationService,this),this._globalGraph=d?u?._globalGraph??new N.Graph(v=>v):void 0}createChild(m){return new O(m,this._strict,this,this._enableTracing)}invokeFunction(m,...a){const u=g.traceInvocation(this._enableTracing,m);let d=!1;try{return m({get:D=>{if(d)throw(0,C.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(D,u);if(!c)throw new Error(`[invokeFunction] unknown service '${D}'`);return c}},...a)}finally{d=!0,u.stop()}}createInstance(m,...a){let u,d;return m instanceof S.SyncDescriptor?(u=g.traceCreation(this._enableTracing,m.ctor),d=this._createInstance(m.ctor,m.staticArguments.concat(a),u)):(u=g.traceCreation(this._enableTracing,m),d=this._createInstance(m,a,u)),u.stop(),d}_createInstance(m,a=[],u){const d=_._util.getServiceDependencies(m).sort((c,b)=>c.index-b.index),v=[];for(const c of d){const b=this._getOrCreateServiceInstance(c.id,u);b||this._throwIfStrict(`[createInstance] ${m.name} depends on UNKNOWN service ${c.id}.`,!1),v.push(b)}const D=d.length>0?d[0].index:a.length;if(a.length!==D){console.trace(`[createInstance] First service dependency of ${m.name} at position ${D+1} conflicts with ${a.length} static arguments`);const c=D-a.length;c>0?a=a.concat(new Array(c)):a=a.slice(0,D)}return Reflect.construct(m,a.concat(v))}_setServiceInstance(m,a){if(this._services.get(m)instanceof S.SyncDescriptor)this._services.set(m,a);else if(this._parent)this._parent._setServiceInstance(m,a);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(m){const a=this._services.get(m);return!a&&this._parent?this._parent._getServiceInstanceOrDescriptor(m):a}_getOrCreateServiceInstance(m,a){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(m));const u=this._getServiceInstanceOrDescriptor(m);return u instanceof S.SyncDescriptor?this._safeCreateAndCacheServiceInstance(m,u,a.branch(m,!0)):(a.branch(m,!1),u)}_safeCreateAndCacheServiceInstance(m,a,u){if(this._activeInstantiations.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this._activeInstantiations.add(m);try{return this._createAndCacheServiceInstance(m,a,u)}finally{this._activeInstantiations.delete(m)}}_createAndCacheServiceInstance(m,a,u){const d=new N.Graph(c=>c.id.toString());let v=0;const D=[{id:m,desc:a,_trace:u}];for(;D.length;){const c=D.pop();if(d.lookupOrInsertNode(c),v++>1e3)throw new P(d);for(const b of _._util.getServiceDependencies(c.desc.ctor)){const t=this._getServiceInstanceOrDescriptor(b.id);if(t||this._throwIfStrict(`[createInstance] ${m} depends on ${b.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(c.id),String(b.id)),t instanceof S.SyncDescriptor){const l={id:b.id,desc:t,_trace:c._trace.branch(b.id,!0)};d.insertEdge(c,l),D.push(l)}}}for(;;){const c=d.roots();if(c.length===0){if(!d.isEmpty())throw new P(d);break}for(const{data:b}of c){if(this._getServiceInstanceOrDescriptor(b.id)instanceof S.SyncDescriptor){const l=this._createServiceInstanceWithOwner(b.id,b.desc.ctor,b.desc.staticArguments,b.desc.supportsDelayedInstantiation,b._trace);this._setServiceInstance(b.id,l)}d.removeNode(b)}}return this._getServiceInstanceOrDescriptor(m)}_createServiceInstanceWithOwner(m,a,u=[],d,v){if(this._services.get(m)instanceof S.SyncDescriptor)return this._createServiceInstance(m,a,u,d,v);if(this._parent)return this._parent._createServiceInstanceWithOwner(m,a,u,d,v);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}_createServiceInstance(m,a,u=[],d,v){if(d){const D=new O(void 0,this._strict,this,this._enableTracing);D._globalGraphImplicitDependency=String(m);const c=new r.IdleValue(()=>D._createInstance(a,u,v));return new Proxy(Object.create(null),{get(b,t){if(t in b)return b[t];const l=c.value;let i=l[t];return typeof i!="function"||(i=i.bind(l),b[t]=i),i},set(b,t,l){return c.value[t]=l,!0}})}else return this._createInstance(a,u,v)}_throwIfStrict(m,a){if(a&&console.warn(m),this._strict)throw new Error(m)}}e.InstantiationService=O;var w;(function(k){k[k.Creation=0]="Creation",k[k.Invocation=1]="Invocation",k[k.Branch=2]="Branch"})(w||(w={}));class g{static traceInvocation(m,a){return m?new g(1,a.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g._None}static traceCreation(m,a){return m?new g(0,a.name):g._None}constructor(m,a){this.type=m,this.name=a,this._start=Date.now(),this._dep=[]}branch(m,a){const u=new g(2,m.toString());return this._dep.push([m,a,u]),u}stop(){const m=Date.now()-this._start;g._totals+=m;let a=!1;function u(v,D){const c=[],b=new Array(v+1).join("	");for(const[t,l,i]of D._dep)if(l&&i){a=!0,c.push(`${b}CREATES -> ${t}`);const n=u(v+1,i);n&&c.push(n)}else c.push(`${b}uses -> ${t}`);return c.join(`
`)}const d=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(m>2||a)&&g.all.add(d.join(`
`))}}e.Trace=g,g.all=new Set,g._None=new class extends g{constructor(){super(-1,null)}stop(){}branch(){return this}},g._totals=0}),define(Ce[14],Ie([1,0,44,5,7,21,3]),function(ie,e,r,C,S,N,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,_.createDecorator)("logService"),e.ILoggerService=(0,_.createDecorator)("loggerService");function A(){return new Date().toISOString()}var E;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;function P(l,i,n){switch(i){case E.Trace:l.trace(n);break;case E.Debug:l.debug(n);break;case E.Info:l.info(n);break;case E.Warning:l.warn(n);break;case E.Error:l.error(n);break;case E.Critical:l.critical(n);break;default:throw new Error("Invalid log level")}}e.log=P;function O(l){let i="";for(let n=0;n<l.length;n++){let o=l[n];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}i+=(n>0?" ":"")+o}return i}e.format=O;class w extends S.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new C.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=w;class g extends w{constructor(i){super(),this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...n){this.checkLogLevel(E.Trace)&&this.log(E.Trace,O([i,...n]))}debug(i,...n){this.checkLogLevel(E.Debug)&&this.log(E.Debug,O([i,...n]))}info(i,...n){this.checkLogLevel(E.Info)&&this.log(E.Info,O([i,...n]))}warn(i,...n){this.checkLogLevel(E.Warning)&&this.log(E.Warning,O([i,...n]))}error(i,...n){if(this.checkLogLevel(E.Error))if(i instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=i.stack,this.log(E.Error,O(o))}else this.log(E.Error,O([i,...n]))}critical(i,...n){this.checkLogLevel(E.Critical)&&this.log(E.Critical,O([i,...n]))}flush(){}}e.AbstractMessageLogger=g;class k extends w{constructor(i=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(i),this.useColors=!N.isWindows}trace(i,...n){this.getLevel()<=E.Trace&&(this.useColors?console.log(`\x1B[90m[main ${A()}]\x1B[0m`,i,...n):console.log(`[main ${A()}]`,i,...n))}debug(i,...n){this.getLevel()<=E.Debug&&(this.useColors?console.log(`\x1B[90m[main ${A()}]\x1B[0m`,i,...n):console.log(`[main ${A()}]`,i,...n))}info(i,...n){this.getLevel()<=E.Info&&(this.useColors?console.log(`\x1B[90m[main ${A()}]\x1B[0m`,i,...n):console.log(`[main ${A()}]`,i,...n))}warn(i,...n){this.getLevel()<=E.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${A()}]\x1B[0m`,i,...n):console.warn(`[main ${A()}]`,i,...n))}error(i,...n){this.getLevel()<=E.Error&&(this.useColors?console.error(`\x1B[91m[main ${A()}]\x1B[0m`,i,...n):console.error(`[main ${A()}]`,i,...n))}critical(i,...n){this.getLevel()<=E.Critical&&(this.useColors?console.error(`\x1B[90m[main ${A()}]\x1B[0m`,i,...n):console.error(`[main ${A()}]`,i,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=k;class m extends w{constructor(i=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(i)}trace(i,...n){this.getLevel()<=E.Trace&&console.log("%cTRACE","color: #888",i,...n)}debug(i,...n){this.getLevel()<=E.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...n)}info(i,...n){this.getLevel()<=E.Info&&console.log("%c INFO","color: #33f",i,...n)}warn(i,...n){this.getLevel()<=E.Warning&&console.log("%c WARN","color: #993",i,...n)}error(i,...n){this.getLevel()<=E.Error&&console.log("%c  ERR","color: #f33",i,...n)}critical(i,...n){this.getLevel()<=E.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...n)}dispose(){}flush(){}}e.ConsoleLogger=m;class a extends w{constructor(i,n=e.DEFAULT_LOG_LEVEL){super(),this.adapter=i,this.setLevel(n)}trace(i,...n){this.getLevel()<=E.Trace&&this.adapter.log(E.Trace,[this.extractMessage(i),...n])}debug(i,...n){this.getLevel()<=E.Debug&&this.adapter.log(E.Debug,[this.extractMessage(i),...n])}info(i,...n){this.getLevel()<=E.Info&&this.adapter.log(E.Info,[this.extractMessage(i),...n])}warn(i,...n){this.getLevel()<=E.Warning&&this.adapter.log(E.Warning,[this.extractMessage(i),...n])}error(i,...n){this.getLevel()<=E.Error&&this.adapter.log(E.Error,[this.extractMessage(i),...n])}critical(i,...n){this.getLevel()<=E.Critical&&this.adapter.log(E.Critical,[this.extractMessage(i),...n])}extractMessage(i){return typeof i=="string"?i:(0,r.toErrorMessage)(i,this.getLevel()<=E.Trace)}dispose(){}flush(){}}e.AdapterLogger=a;class u extends w{constructor(i){super(),this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const n of this.logServices)n.setLevel(i);super.setLevel(i)}trace(i,...n){for(const o of this.logServices)o.trace(i,...n)}debug(i,...n){for(const o of this.logServices)o.debug(i,...n)}info(i,...n){for(const o of this.logServices)o.info(i,...n)}warn(i,...n){for(const o of this.logServices)o.warn(i,...n)}error(i,...n){for(const o of this.logServices)o.error(i,...n)}critical(i,...n){for(const o of this.logServices)o.critical(i,...n)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=u;class d extends S.Disposable{constructor(i){super(),this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...n){this.logger.trace(i,...n)}debug(i,...n){this.logger.debug(i,...n)}info(i,...n){this.logger.info(i,...n)}warn(i,...n){this.logger.warn(i,...n)}error(i,...n){this.logger.error(i,...n)}critical(i,...n){this.logger.critical(i,...n)}flush(){this.logger.flush()}}e.LogService=d;class v extends S.Disposable{constructor(i,n){super(),this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(f=>f.setLevel(o))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,n){let o=this.loggers.get(i.toString());return o||(o=this.doCreateLogger(i,n?.always?E.Trace:this.logLevel,n),this.loggers.set(i.toString(),o),n?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=v;class D{constructor(){this.onDidChangeLogLevel=new C.Emitter().event}setLevel(i){}getLevel(){return E.Info}trace(i,...n){}debug(i,...n){}info(i,...n){}warn(i,...n){}error(i,...n){}critical(i,...n){}dispose(){}flush(){}}e.NullLogService=D;function c(l){if(l.verbose)return E.Trace;if(typeof l.logLevel=="string"){const i=b(l.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function b(l){switch(l){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Critical;case"off":return E.Off}}e.parseLogLevel=b;function t(l){switch(l){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Critical:return"critical";case E.Off:return"off"}}e.LogLevelToString=t}),define(Ce[82],Ie([1,0,29,128,3]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var N;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(N=e.MarkerTag||(e.MarkerTag={}));var _;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(_=e.MarkerSeverity||(e.MarkerSeverity={})),function(E){function P(m,a){return a-m}E.compare=P;const O=Object.create(null);O[E.Error]=(0,C.localize)(0,null),O[E.Warning]=(0,C.localize)(1,null),O[E.Info]=(0,C.localize)(2,null);function w(m){return O[m]||""}E.toString=w;function g(m){switch(m){case r.default.Error:return E.Error;case r.default.Warning:return E.Warning;case r.default.Info:return E.Info;case r.default.Ignore:return E.Hint}}E.fromSeverity=g;function k(m){switch(m){case E.Error:return r.default.Error;case E.Warning:return r.default.Warning;case E.Info:return r.default.Info;case E.Hint:return r.default.Ignore}}E.toSeverity=k}(_=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(E){const P="";function O(g){return w(g,!0)}E.makeKey=O;function w(g,k){const m=[P];return g.source?m.push(g.source.replace("\xA6","\\\xA6")):m.push(P),g.code?typeof g.code=="string"?m.push(g.code.replace("\xA6","\\\xA6")):m.push(g.code.value.replace("\xA6","\\\xA6")):m.push(P),g.severity!==void 0&&g.severity!==null?m.push(_.toString(g.severity)):m.push(P),g.message&&k?m.push(g.message.replace("\xA6","\\\xA6")):m.push(P),g.startLineNumber!==void 0&&g.startLineNumber!==null?m.push(g.startLineNumber.toString()):m.push(P),g.startColumn!==void 0&&g.startColumn!==null?m.push(g.startColumn.toString()):m.push(P),g.endLineNumber!==void 0&&g.endLineNumber!==null?m.push(g.endLineNumber.toString()):m.push(P),g.endColumn!==void 0&&g.endColumn!==null?m.push(g.endColumn.toString()):m.push(P),m.push(P),m.join("\xA6")}E.makeKeyOptionalMessage=w})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,S.createDecorator)("markerService")}),define(Ce[149],Ie([1,0,5,29,3]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=C.default,e.INotificationService=(0,S.createDecorator)("notificationService");var N;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(N=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var _;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(_=e.NotificationsFilter||(e.NotificationsFilter={}));class A{constructor(){this.progress=new E,this.onDidClose=r.Event.None,this.onDidChangeVisibility=r.Event.None}updateSeverity(O){}updateMessage(O){}updateActions(O){}close(){}}e.NoOpNotification=A;class E{infinite(){}done(){}total(O){}worked(O){}}e.NoOpProgress=E}),define(Ce[83],Ie([1,0,7,9,2,3]),function(ie,e,r,C,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,N.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return r.Disposable.None},registerValidator(){return r.Disposable.None},registerExternalUriResolver(){return r.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return r.Disposable.None},async open(){return!1},async resolveExternalUri(O){return{resolved:O,dispose(){}}}});function _(O,w){return S.URI.isUri(O)?(0,C.equalsIgnoreCase)(O.scheme,w):(0,C.startsWithIgnoreCase)(O,w+":")}e.matchesScheme=_;function A(O,...w){return w.some(g=>_(O,g))}e.matchesSomeScheme=A;function E(O,w){return O.with({fragment:`${w.startLineNumber},${w.startColumn}${w.endLineNumber?`-${w.endLineNumber}${w.endColumn?`,${w.endColumn}`:""}`:""}`})}e.withSelection=E;function P(O){let w;const g=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(O.fragment);return g&&(w={startLineNumber:parseInt(g[1]),startColumn:g[2]?parseInt(g[2]):1,endLineNumber:g[4]?parseInt(g[4]):void 0,endColumn:g[4]?g[5]?parseInt(g[5]):1:void 0},O=O.with({fragment:""})),{selection:w,uri:O}}e.extractSelection=P}),define(Ce[150],Ie([1,0,3]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,r.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var ze=this&&this.__decorate||function(ie,e,r,C){var S=arguments.length,N=S<3?e:C===null?C=Object.getOwnPropertyDescriptor(e,r):C,_;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate(ie,e,r,C);else for(var A=ie.length-1;A>=0;A--)(_=ie[A])&&(N=(S<3?_(N):S>3?_(e,r,N):_(e,r))||N);return S>3&&N&&Object.defineProperty(e,r,N),N},$e=this&&this.__param||function(ie,e){return function(r,C){e(r,C,ie)}};define(Ce[151],Ie([1,0,15,20,7,3]),function(ie,e,r,C,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,N.createDecorator)("progressService");var _;(function(O){O[O.Explorer=1]="Explorer",O[O.Scm=3]="Scm",O[O.Extensions=5]="Extensions",O[O.Window=10]="Window",O[O.Notification=15]="Notification",O[O.Dialog=20]="Dialog"})(_=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{get value(){return this._value}constructor(w){this.callback=w}report(w){this._value=w,this.callback(this._value)}}e.Progress=A,A.None=Object.freeze({report(){}});let E=class extends S.Disposable{constructor(w,g){super(),this.deferred=new r.DeferredPromise,g.withProgress(w,k=>(this.reporter=k,this.lastStep&&k.report(this.lastStep),this.deferred.p)),this._register((0,S.toDisposable)(()=>this.deferred.complete()))}report(w){this.reporter?this.reporter.report(w):this.lastStep=w}};E=ze([$e(1,e.IProgressService)],E),e.UnmanagedProgress=E;class P extends S.Disposable{constructor(w){super(),this.progressIndicator=w,this.currentOperationId=0,this.currentOperationDisposables=this._register(new S.DisposableStore)}start(w){this.stop();const g=++this.currentOperationId,k=new C.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{g===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},w),this.currentOperationDisposables.add((0,S.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,S.toDisposable)(()=>k.cancel())),this.currentOperationDisposables.add((0,S.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:g,token:k.token,stop:()=>this.doStop(g),isCurrent:()=>this.currentOperationId===g}}stop(){this.doStop(this.currentOperationId)}doStop(w){this.currentOperationId===w&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,N.createDecorator)("editorProgressService")}),define(Ce[30],Ie([1,0,45,10]),function(ie,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class S{constructor(){this.data=new Map}add(_,A){r.ok(C.isString(_)),r.ok(C.isObject(A)),r.ok(!this.data.has(_),"There is already an extension with this id"),this.data.set(_,A)}knows(_){return this.data.has(_)}as(_){return this.data.get(_)||null}}e.Registry=new S}),define(Ce[84],Ie([1,0,5,30]),function(ie,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function S(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class N{constructor(){this._onDidChangeSchema=new r.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(E,P){this.schemasById[S(E)]=P,this._onDidChangeSchema.fire(E)}notifySchemaChanged(E){this._onDidChangeSchema.fire(E)}getSchemaContributions(){return{schemas:this.schemasById}}}const _=new N;C.Registry.add(e.Extensions.JSONContribution,_)}),define(Ce[85],Ie([1,0,18,5,10,124,57,84,30]),function(ie,e,r,C,S,N,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var P;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(P=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var O;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(O=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=E.Registry.as(A.Extensions.JSONContribution);class g{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new C.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new C.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:N.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,l=!0){this.registerConfigurations([t],l)}registerConfigurations(t,l=!0){const i=this.doRegisterConfigurations(t,l);w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(t){const l=this.doDeregisterConfigurations(t);w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l})}updateConfigurations({add:t,remove:l}){const i=[];i.push(...this.doDeregisterConfigurations(l)),i.push(...this.doRegisterConfigurations(t,!1)),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,r.distinct)(i)})}registerDefaultConfigurations(t){const l=[],i=[];for(const{overrides:n,source:o}of t)for(const f in n)if(l.push(f),e.OVERRIDE_PROPERTY_REGEX.test(f)){const s=this.configurationDefaultsOverrides.get(f),h=s?.valuesSources??new Map;if(o)for(const V of Object.keys(n[f]))h.set(V,o);const p={...s?.value||{},...n[f]};this.configurationDefaultsOverrides.set(f,{source:o,value:p,valuesSources:h});const T=(0,_.getLanguageTagSettingPlainKey)(f),M={type:"object",default:p,description:N.localize(1,null,T),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:p,source:S.isString(o)?void 0:o,defaultValueSource:o};i.push(...a(f)),this.configurationProperties[f]=M,this.defaultLanguageConfigurationOverridesNode.properties[f]=M}else{this.configurationDefaultsOverrides.set(f,{value:n[f],source:o});const s=this.configurationProperties[f];s&&(this.updatePropertyDefaultValue(f,s),this.updateSchema(f,s))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}deregisterDefaultConfigurations(t){const l=[];for(const{overrides:i,source:n}of t)for(const o in i){const f=this.configurationDefaultsOverrides.get(o),s=S.isString(n)?n:n?.id,h=S.isString(f?.source)?f?.source:f?.source?.id;if(s===h)if(l.push(o),this.configurationDefaultsOverrides.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const p=this.configurationProperties[o];p&&(this.updatePropertyDefaultValue(o,p),this.updateSchema(o,p))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){for(const l of t)this.overrideIdentifiers.add(l);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,l){const i=[];return t.forEach(n=>{i.push(...this.validateAndRegisterProperties(n,l,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),i}doDeregisterConfigurations(t){const l=[],i=n=>{if(n.properties)for(const o in n.properties){l.push(o);const f=this.configurationProperties[o];f?.policy?.name&&this.policyConfigurations.delete(f.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,n.properties[o])}n.allOf?.forEach(o=>i(o))};for(const n of t){i(n);const o=this.configurationContributors.indexOf(n);o!==-1&&this.configurationContributors.splice(o,1)}return l}validateAndRegisterProperties(t,l=!0,i,n,o=3){o=S.isUndefinedOrNull(t.scope)?o:t.scope;const f=[],s=t.properties;if(s)for(const p in s){const T=s[p];if(l&&D(p,T)){delete s[p];continue}if(T.source=i,T.defaultDefaultValue=s[p].default,this.updatePropertyDefaultValue(p,T),e.OVERRIDE_PROPERTY_REGEX.test(p)?T.scope=void 0:(T.scope=S.isUndefinedOrNull(T.scope)?o:T.scope,T.restricted=S.isUndefinedOrNull(T.restricted)?!!n?.includes(p):T.restricted),s[p].hasOwnProperty("included")&&!s[p].included){this.excludedConfigurationProperties[p]=s[p],delete s[p];continue}else this.configurationProperties[p]=s[p],s[p].policy?.name&&this.policyConfigurations.set(s[p].policy.name,p);!s[p].deprecationMessage&&s[p].markdownDeprecationMessage&&(s[p].deprecationMessage=s[p].markdownDeprecationMessage),f.push(p)}const h=t.allOf;if(h)for(const p of h)f.push(...this.validateAndRegisterProperties(p,l,i,n,o));return f}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const l=i=>{const n=i.properties;if(n)for(const f in n)this.updateSchema(f,n[f]);i.allOf?.forEach(l)};l(t)}updateSchema(t,l){switch(e.allSettings.properties[t]=l,l.scope){case 1:e.applicationSettings.properties[t]=l;break;case 2:e.machineSettings.properties[t]=l;break;case 6:e.machineOverridableSettings.properties[t]=l;break;case 3:e.windowSettings.properties[t]=l;break;case 4:e.resourceSettings.properties[t]=l;break;case 5:e.resourceSettings.properties[t]=l,this.resourceLanguageSettingsSchema.properties[t]=l;break}}removeFromSchema(t,l){switch(delete e.allSettings.properties[t],l.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const l=`[${t}]`,i={type:"object",description:N.localize(2,null),errorMessage:N.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(l,i),e.allSettings.properties[l]=i,e.applicationSettings.properties[l]=i,e.machineSettings.properties[l]=i,e.machineOverridableSettings.properties[l]=i,e.windowSettings.properties[l]=i,e.resourceSettings.properties[l]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const t={type:"object",description:N.localize(4,null),errorMessage:N.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,l){const i=this.configurationDefaultsOverrides.get(t);let n=i?.value,o=i?.source;S.isUndefined(n)&&(n=l.defaultDefaultValue,o=void 0),S.isUndefined(n)&&(n=d(l.type)),l.default=n,l.defaultValueSource=o}}const k="\\[([^\\]]+)\\]",m=new RegExp(k,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${k})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function a(b){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(b)){let l=m.exec(b);for(;l?.length;){const i=l[1].trim();i&&t.push(i),l=m.exec(b)}}return(0,r.distinct)(t)}e.overrideIdentifiersFromKey=a;function u(b){return b.reduce((t,l)=>`${t}[${l}]`,"")}e.keyFromOverrideIdentifiers=u;function d(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const v=new g;E.Registry.add(e.Extensions.Configuration,v);function D(b,t){return b.trim()?e.OVERRIDE_PROPERTY_REGEX.test(b)?N.localize(7,null,b):v.getConfigurationProperties()[b]!==void 0?N.localize(8,null,b):t.policy?.name&&v.getPolicyConfigurations().get(t.policy?.name)!==void 0?N.localize(9,null,b,t.policy?.name,v.getPolicyConfigurations().get(t.policy?.name)):null:N.localize(6,null)}e.validateProperty=D;function c(){const b=[],t=v.getConfigurationProperties();for(const l of Object.keys(t))b.push([l,t[l].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=c}),define(Ce[152],Ie([1,0,18,5,106,7,24,25,10,2,57,85,30]),function(ie,e,r,C,S,N,_,A,E,P,O,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class k{constructor(t={},l=[],i=[],n){this._contents=t,this._keys=l,this._overrides=i,this.raw=n,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const t=this.raw.map(l=>{if(l instanceof k)return l;const i=new m("");return i.parseRaw(l),i.configurationModel});this._rawConfiguration=t.reduce((l,i)=>i===l?i:l.merge(i),t[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(t){return t?(0,O.getConfigurationValue)(this.contents,t):this.contents}inspect(t,l){const i=this.rawConfiguration.getValue(t),n=l?this.rawConfiguration.getOverrideValue(t,l):void 0,o=l?this.rawConfiguration.override(l).getValue(t):i;return{value:i,override:n,merged:o}}getOverrideValue(t,l){const i=this.getContentsForOverrideIdentifer(l);return i?t?(0,O.getConfigurationValue)(i,t):i:void 0}getKeysForOverrideIdentifier(t){const l=[];for(const i of this.overrides)i.identifiers.includes(t)&&l.push(...i.keys);return r.distinct(l)}getAllOverrideIdentifiers(){const t=[];for(const l of this.overrides)t.push(...l.identifiers);return r.distinct(t)}override(t){let l=this.overrideConfigurations.get(t);return l||(l=this.createOverrideConfigurationModel(t),this.overrideConfigurations.set(t,l)),l}merge(...t){const l=A.deepClone(this.contents),i=A.deepClone(this.overrides),n=[...this.keys],o=this.raw?.length?[...this.raw]:[this];for(const f of t)if(o.push(...f.raw?.length?f.raw:[f]),!f.isEmpty()){this.mergeContents(l,f.contents);for(const s of f.overrides){const[h]=i.filter(p=>r.equals(p.identifiers,s.identifiers));h?(this.mergeContents(h.contents,s.contents),h.keys.push(...s.keys),h.keys=r.distinct(h.keys)):i.push(A.deepClone(s))}for(const s of f.keys)n.indexOf(s)===-1&&n.push(s)}return new k(l,n,i,o.every(f=>f instanceof k)?void 0:o)}freeze(){return this.frozen=!0,this}clone(){return new k(A.deepClone(this.contents),[...this.keys],A.deepClone(this.overrides))}createOverrideConfigurationModel(t){const l=this.getContentsForOverrideIdentifer(t);if(!l||typeof l!="object"||!Object.keys(l).length)return this;const i={};for(const n of r.distinct([...Object.keys(this.contents),...Object.keys(l)])){let o=this.contents[n];const f=l[n];f&&(typeof o=="object"&&typeof f=="object"?(o=A.deepClone(o),this.mergeContents(o,f)):o=f),i[n]=o}return new k(i,this.keys,this.overrides)}mergeContents(t,l){for(const i of Object.keys(l)){if(i in t&&E.isObject(t[i])&&E.isObject(l[i])){this.mergeContents(t[i],l[i]);continue}t[i]=A.deepClone(l[i])}}checkAndFreeze(t){return this.frozen&&!Object.isFrozen(t)?A.deepFreeze(t):t}getContentsForOverrideIdentifer(t){let l=null,i=null;const n=o=>{o&&(i?this.mergeContents(i,o):i=A.deepClone(o))};for(const o of this.overrides)r.equals(o.identifiers,[t])?l=o.contents:o.identifiers.includes(t)&&n(o.contents);return n(l),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,l){this.addKey(t),(0,O.addToValueTree)(this.contents,t,l,i=>{throw new Error(i)})}removeValue(t){this.removeKey(t)&&(0,O.removeFromValueTree)(this.contents,t)}addKey(t){let l=this.keys.length;for(let i=0;i<l;i++)t.indexOf(this.keys[i])===0&&(l=i);this.keys.splice(l,1,t)}removeKey(t){const l=this.keys.indexOf(t);return l!==-1?(this.keys.splice(l,1),!0):!1}}e.ConfigurationModel=k;class m{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new k}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,l){if(!E.isUndefinedOrNull(t)){const i=this.doParseContent(t);this.parseRaw(i,l)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,l){this._raw=t;const{contents:i,keys:n,overrides:o,restricted:f,hasExcludedProperties:s}=this.doParseRaw(t,l);this._configurationModel=new k(i,n,o,s?[t]:void 0),this._restrictedConfigurations=f||[]}doParseContent(t){let l={},i=null,n=[];const o=[],f=[];function s(p){Array.isArray(n)?n.push(p):i!==null&&(n[i]=p)}const h={onObjectBegin:()=>{const p={};s(p),o.push(n),n=p,i=null},onObjectProperty:p=>{i=p},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{const p=[];s(p),o.push(n),n=p,i=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:s,onError:(p,T,M)=>{f.push({error:p,offset:T,length:M})}};if(t)try{S.visit(t,h),l=n[0]||{}}catch(p){console.error(`Error while parsing settings file ${this._name}: ${p}`),this._parseErrors=[p]}return l}doParseRaw(t,l){const i=g.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),n=this.filter(t,i,!0,l);t=n.raw;const o=(0,O.toValuesTree)(t,h=>console.error(`Conflict in settings file ${this._name}: ${h}`)),f=Object.keys(t),s=this.toOverrides(t,h=>console.error(`Conflict in settings file ${this._name}: ${h}`));return{contents:o,keys:f,overrides:s,restricted:n.restricted,hasExcludedProperties:n.hasExcludedProperties}}filter(t,l,i,n){let o=!1;if(!n?.scopes&&!n?.skipRestricted)return{raw:t,restricted:[],hasExcludedProperties:o};const f={},s=[];for(const h in t)if(w.OVERRIDE_PROPERTY_REGEX.test(h)&&i){const p=this.filter(t[h],l,!1,n);f[h]=p.raw,o=o||p.hasExcludedProperties,s.push(...p.restricted)}else{const p=l[h],T=p?typeof p.scope<"u"?p.scope:3:void 0;p?.restricted&&s.push(h),(T===void 0||n.scopes===void 0||n.scopes.includes(T))&&!(n.skipRestricted&&p?.restricted)?f[h]=t[h]:o=!0}return{raw:f,restricted:s,hasExcludedProperties:o}}toOverrides(t,l){const i=[];for(const n of Object.keys(t))if(w.OVERRIDE_PROPERTY_REGEX.test(n)){const o={};for(const f in t[n])o[f]=t[n][f];i.push({identifiers:(0,w.overrideIdentifiersFromKey)(n),keys:Object.keys(o),contents:(0,O.toValuesTree)(o,l)})}return i}}e.ConfigurationModelParser=m;class a extends N.Disposable{constructor(t,l,i,n){super(),this.userSettingsResource=t,this.scopes=l,this.fileService=n,this._onDidChange=this._register(new C.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(C.Event.any(C.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource)),C.Event.filter(this.fileService.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&i.isEqual(o.resource,t)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new k}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=a;class u{constructor(t,l,i,n,o=new k,f=new k,s=new _.ResourceMap,h=new k,p=new _.ResourceMap,T=!0){this._defaultConfiguration=t,this._policyConfiguration=l,this._applicationConfiguration=i,this._localUserConfiguration=n,this._remoteUserConfiguration=o,this._workspaceConfiguration=f,this._folderConfigurations=s,this._memoryConfiguration=h,this._memoryConfigurationByResource=p,this._freeze=T,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new _.ResourceMap,this._userConfiguration=null}getValue(t,l,i){return this.getConsolidatedConfigurationModel(t,l,i).getValue(t)}updateValue(t,l,i={}){let n;i.resource?(n=this._memoryConfigurationByResource.get(i.resource),n||(n=new k,this._memoryConfigurationByResource.set(i.resource,n))):n=this._memoryConfiguration,l===void 0?n.removeValue(t):n.setValue(t,l),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,l,i){const n=this.getConsolidatedConfigurationModel(t,l,i),o=this.getFolderConfigurationModelForResource(l.resource,i),f=l.resource?this._memoryConfigurationByResource.get(l.resource)||this._memoryConfiguration:this._memoryConfiguration,s=this._defaultConfiguration.inspect(t,l.overrideIdentifier),h=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().inspect(t),p=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().inspect(t),T=this.userConfiguration.freeze().inspect(t,l.overrideIdentifier),M=this.localUserConfiguration.freeze().inspect(t,l.overrideIdentifier),V=this.remoteUserConfiguration.freeze().inspect(t,l.overrideIdentifier),U=i?this._workspaceConfiguration.freeze().inspect(t,l.overrideIdentifier):void 0,y=o?o.freeze().inspect(t,l.overrideIdentifier):void 0,x=f.inspect(t,l.overrideIdentifier),L=n.getValue(t),R=r.distinct(n.overrides.map(K=>K.identifiers).flat()).filter(K=>n.getOverrideValue(t,K)!==void 0);return{defaultValue:s?s.merged:void 0,policyValue:h?h.merged:void 0,applicationValue:p?p.merged:void 0,userValue:T?T.merged:void 0,userLocalValue:M?M.merged:void 0,userRemoteValue:V?V.merged:void 0,workspaceValue:U?U.merged:void 0,workspaceFolderValue:y?y.merged:void 0,memoryValue:x?x.merged:void 0,value:L,default:s.value!==void 0||s.override!==void 0?{value:s.value,override:s.override}:void 0,policy:h?.value!==void 0?{value:h.value}:void 0,application:p?.value!==void 0||p?.override!==void 0?{value:p.value,override:p.override}:void 0,user:T.value!==void 0||T.override!==void 0?{value:T.value,override:T.override}:void 0,userLocal:M.value!==void 0||M.override!==void 0?{value:M.value,override:M.override}:void 0,userRemote:V.value!==void 0||V.override!==void 0?{value:V.value,override:V.override}:void 0,workspace:U?.value!==void 0||U?.override!==void 0?{value:U.value,override:U.override}:void 0,workspaceFolder:y?.value!==void 0||y?.override!==void 0?{value:y.value,override:y.override}:void 0,memory:x.value!==void 0||x.override!==void 0?{value:x.value,override:x.override}:void 0,overrideIdentifiers:R.length?R:void 0}}keys(t){const l=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:l?l.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(t){this._policyConfiguration=t}updateApplicationConfiguration(t){this._applicationConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,l){this._folderConfigurations.set(t,l),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,l){const i=[];if(!l){const{added:n,updated:o,removed:f}=D(this._defaultConfiguration,t);l=[...n,...o,...f]}for(const n of l)for(const o of(0,w.overrideIdentifiersFromKey)(n)){const f=this._defaultConfiguration.getKeysForOverrideIdentifier(o),s=t.getKeysForOverrideIdentifier(o),h=[...s.filter(p=>f.indexOf(p)===-1),...f.filter(p=>s.indexOf(p)===-1),...f.filter(p=>!A.equals(this._defaultConfiguration.override(o).getValue(p),t.override(o).getValue(p)))];i.push([o,h])}return this.updateDefaultConfiguration(t),{keys:l,overrides:i}}compareAndUpdatePolicyConfiguration(t){const{added:l,updated:i,removed:n}=D(this._policyConfiguration,t),o=[...l,...i,...n];return o.length&&this.updatePolicyConfiguration(t),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:l,updated:i,removed:n,overrides:o}=D(this.applicationConfiguration,t),f=[...l,...i,...n];return f.length&&this.updateApplicationConfiguration(t),{keys:f,overrides:o}}compareAndUpdateLocalUserConfiguration(t){const{added:l,updated:i,removed:n,overrides:o}=D(this.localUserConfiguration,t),f=[...l,...i,...n];return f.length&&this.updateLocalUserConfiguration(t),{keys:f,overrides:o}}compareAndUpdateRemoteUserConfiguration(t){const{added:l,updated:i,removed:n,overrides:o}=D(this.remoteUserConfiguration,t),f=[...l,...i,...n];return f.length&&this.updateRemoteUserConfiguration(t),{keys:f,overrides:o}}compareAndUpdateWorkspaceConfiguration(t){const{added:l,updated:i,removed:n,overrides:o}=D(this.workspaceConfiguration,t),f=[...l,...i,...n];return f.length&&this.updateWorkspaceConfiguration(t),{keys:f,overrides:o}}compareAndUpdateFolderConfiguration(t,l){const i=this.folderConfigurations.get(t),{added:n,updated:o,removed:f,overrides:s}=D(i,l),h=[...n,...o,...f];return(h.length||!i)&&this.updateFolderConfiguration(t,l),{keys:h,overrides:s}}compareAndDeleteFolderConfiguration(t){const l=this.folderConfigurations.get(t);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:i,updated:n,removed:o,overrides:f}=D(l,void 0);return{keys:[...i,...n,...o],overrides:f}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(t,l,i){let n=this.getConsolidatedConfigurationModelForResource(l,i);return l.overrideIdentifier&&(n=n.override(l.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(t)!==void 0&&(n=n.merge(this._policyConfiguration)),n}getConsolidatedConfigurationModelForResource({resource:t},l){let i=this.getWorkspaceConsolidatedConfiguration();if(l&&t){const n=l.getFolder(t);n&&(i=this.getFolderConsolidatedConfiguration(n.uri)||i);const o=this._memoryConfigurationByResource.get(t);o&&(i=i.merge(o))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let l=this._foldersConsolidatedConfigurations.get(t);if(!l){const i=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(t);n?(l=i.merge(n),this._freeze&&(l=l.freeze()),this._foldersConsolidatedConfigurations.set(t,l)):l=i}return l}getFolderConfigurationModelForResource(t,l){if(l&&t){const i=l.getFolder(t);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,l)=>{const{contents:i,overrides:n,keys:o}=this._folderConfigurations.get(l);return t.push([l,{contents:i,overrides:n,keys:o}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(l=>t.add(l)),this.userConfiguration.freeze().keys.forEach(l=>t.add(l)),this._workspaceConfiguration.freeze().keys.forEach(l=>t.add(l)),this._folderConfigurations.forEach(l=>l.freeze().keys.forEach(i=>t.add(i))),[...t.values()]}allOverrideIdentifiers(){const t=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(l=>t.add(l)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(l=>t.add(l)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(l=>t.add(l)),this._folderConfigurations.forEach(l=>l.freeze().getAllOverrideIdentifiers().forEach(i=>t.add(i))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const l=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>l.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>l.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>l.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(t).forEach(n=>l.add(n))),[...l.values()]}static parse(t){const l=this.parseConfigurationModel(t.defaults),i=this.parseConfigurationModel(t.policy),n=this.parseConfigurationModel(t.application),o=this.parseConfigurationModel(t.user),f=this.parseConfigurationModel(t.workspace),s=t.folders.reduce((h,p)=>(h.set(P.URI.revive(p[0]),this.parseConfigurationModel(p[1])),h),new _.ResourceMap);return new u(l,i,n,o,new k,f,s,new k,new _.ResourceMap,!1)}static parseConfigurationModel(t){return new k(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=u;function d(...b){if(b.length===0)return{keys:[],overrides:[]};if(b.length===1)return b[0];const t=new Set,l=new Map;for(const n of b)n.keys.forEach(o=>t.add(o)),n.overrides.forEach(([o,f])=>{const s=(0,_.getOrSet)(l,o,new Set);f.forEach(h=>s.add(h))});const i=[];return l.forEach((n,o)=>i.push([o,[...n.values()]])),{keys:[...t.values()],overrides:i}}e.mergeChanges=d;class v{constructor(t,l,i,n){this.change=t,this.previous=l,this.currentConfiguraiton=i,this.currentWorkspace=n,this._previousConfiguration=void 0;const o=new Set;t.keys.forEach(s=>o.add(s)),t.overrides.forEach(([,s])=>s.forEach(h=>o.add(h))),this.affectedKeys=[...o.values()];const f=new k;this.affectedKeys.forEach(s=>f.setValue(s,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=u.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,l){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(l){const i=this.previousConfiguration?this.previousConfiguration.getValue(t,l,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(t,l,this.currentWorkspace);return!A.equals(i,n)}return!0}return!1}doesAffectedKeysTreeContains(t,l){let i=(0,O.toValuesTree)({[l]:!0},()=>{}),n;for(;typeof i=="object"&&(n=Object.keys(i)[0]);){if(t=t[n],!t)return!1;i=i[n]}return!0}}e.ConfigurationChangeEvent=v;function D(b,t){const{added:l,removed:i,updated:n}=c(t,b),o=[],f=b?.getAllOverrideIdentifiers()||[],s=t?.getAllOverrideIdentifiers()||[];if(t){const h=s.filter(p=>!f.includes(p));for(const p of h)o.push([p,t.getKeysForOverrideIdentifier(p)])}if(b){const h=f.filter(p=>!s.includes(p));for(const p of h)o.push([p,b.getKeysForOverrideIdentifier(p)])}if(t&&b){for(const h of f)if(s.includes(h)){const p=c({contents:b.getOverrideValue(void 0,h)||{},keys:b.getKeysForOverrideIdentifier(h)},{contents:t.getOverrideValue(void 0,h)||{},keys:t.getKeysForOverrideIdentifier(h)});o.push([h,[...p.added,...p.removed,...p.updated]])}}return{added:l,removed:i,updated:n,overrides:o}}function c(b,t){const l=b?t?b.keys.filter(o=>t.keys.indexOf(o)===-1):[...b.keys]:[],i=t?b?t.keys.filter(o=>b.keys.indexOf(o)===-1):[...t.keys]:[],n=[];if(b&&t){for(const o of t.keys)if(b.keys.indexOf(o)!==-1){const f=(0,O.getConfigurationValue)(t.contents,o),s=(0,O.getConfigurationValue)(b.contents,o);A.equals(f,s)||n.push(o)}}return{added:l,removed:i,updated:n}}}),define(Ce[86],Ie([1,0,12,3]),function(ie,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,C.createDecorator)("remoteAuthorityResolverService");var S;(function(_){_.Unknown="Unknown",_.NotAvailable="NotAvailable",_.TemporarilyNotAvailable="TemporarilyNotAvailable",_.NoResolverFound="NoResolverFound"})(S=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class N extends r.ErrorNoTelemetry{static isTemporarilyNotAvailable(A){return A instanceof N&&A._code===S.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof N&&A._code===S.NoResolverFound}static isHandled(A){return A instanceof N&&A.isHandled}constructor(A,E=S.Unknown,P){super(A),this._message=A,this._code=E,this._detail=P,this.isHandled=E===S.NotAvailable&&P===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,N.prototype)}}e.RemoteAuthorityResolverError=N}),define(Ce[87],Ie([1,0,13]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function C(P){return P.scheme===r.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=C;function S(P){if(!P)return;const O=P.indexOf("+");return O<0?P:P.substr(0,O)}e.getRemoteName=S;function N(P){return`/${P.quality??"oss"}-${P.commit??"dev"}`}e.getRemoteServerRootPath=N;function _(P){const{host:O,port:w}=E(P);if(typeof w>"u")throw new Error("Remote authority doesn't contain a port!");return{host:O,port:w}}e.parseAuthorityWithPort=_;function A(P,O){let{host:w,port:g}=E(P);return typeof g>"u"&&(g=O),{host:w,port:g}}e.parseAuthorityWithOptionalPort=A;function E(P){const O=P.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(O)return{host:O[1],port:parseInt(O[2],10)};const w=P.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const g=P.match(/(.*):(\d+)$/);return g?{host:g[1],port:parseInt(g[2],10)}:{host:P,port:void 0}}}),define(Ce[26],Ie([1,0,9,3,87]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function N(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.getWorkspaceSupportTypeMessage=N;function _(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=_,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));var E;(function(m){m.WIN32_X64="win32-x64",m.WIN32_IA32="win32-ia32",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(E=e.TargetPlatform||(e.TargetPlatform={}));class P{constructor(a){this.value=a,this._lower=a.toLowerCase()}static equals(a,u){if(typeof a>"u"||a===null)return typeof u>"u"||u===null;if(typeof u>"u"||u===null)return!1;if(typeof a=="string"||typeof u=="string"){const d=typeof a=="string"?a:a.value,v=typeof u=="string"?u:u.value;return r.equalsIgnoreCase(d,v)}return a._lower===u._lower}static toKey(a){return typeof a=="string"?a.toLowerCase():a._lower}}e.ExtensionIdentifier=P;function O(m){return w(m)}e.isApplicationScopedExtension=O;function w(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.isLanguagePackExtension=w;function g(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=g;function k(m,a){if(a){const u=`onResolveRemoteAuthority:${(0,S.getRemoteName)(a)}`;return m.activationEvents?.indexOf(u)!==-1}return!1}e.isResolverExtension=k,e.IBuiltinExtensionsScannerService=(0,C.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ce[153],Ie([1,0,9,81,26,21,2,12,59]),function(ie,e,r,C,S,N,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function P(l,i){return l.uuid&&i.uuid?l.uuid===i.uuid:l.id===i.id?!0:(0,r.compareIgnoreCase)(l.id,i.id)===0}e.areSameExtensions=P;const O=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(i){const n=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new w(i.identifier,n,o)}static parse(i){const n=O.exec(i);return n&&n[1]&&n[2]?new w({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,o="undefined"){this.version=n,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof w?P(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=w;const g=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function k(l){const i=g.exec(l);return i&&i[1]?[a(i[1]),i[2]]:[a(l),void 0]}e.getIdAndVersion=k;function m(l,i){return`${l}.${i}`}e.getExtensionId=m;function a(l){return l.toLocaleLowerCase()}e.adoptToGalleryExtensionId=a;function u(l,i){return a(m(l,i))}e.getGalleryExtensionId=u;function d(l,i){const n=[],o=f=>{for(const s of n)if(s.some(h=>P(i(h),i(f))))return s;return null};for(const f of l){const s=o(f);s?s.push(f):n.push([f])}return n}e.groupByExtension=d;function v(l){return{id:l.identifier.id,name:l.manifest.name,galleryId:null,publisherId:l.publisherId,publisherName:l.manifest.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:l.manifest.extensionDependencies&&l.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=v;function D(l){return{id:l.identifier.id,name:l.name,galleryId:l.identifier.uuid,publisherId:l.publisherId,publisherName:l.publisher,publisherDisplayName:l.publisherDisplayName,isPreReleaseVersion:l.properties.isPreReleaseVersion,dependencies:!!(l.properties.dependencies&&l.properties.dependencies.length>0),...l.telemetryData}}e.getGalleryExtensionTelemetryData=D,e.BetterMergeId=new S.ExtensionIdentifier("pprice.better-merge");function c(l,i){const n=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const f=o.shift();if(f&&n.every(s=>!P(s.identifier,{id:f}))){const s=l.filter(h=>P(h.identifier,{id:f}));s.length===1&&(n.push(s[0]),o.push(...s[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.getExtensionDependencies=c;async function b(l,i){if(!N.isLinux)return!1;let n;try{n=(await l.readFile(_.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await l.readFile(_.URI.file("/usr/lib/os-release"))).value.toString()}catch(f){i.debug("Error while getting the os-release file.",(0,A.getErrorMessage)(f))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=b;async function t(l,i){const n=await b(l,i),o=(0,C.getTargetPlatform)(n?"alpine":N.platform,E.arch);return i.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=t}),define(Ce[154],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class r{constructor(S){this._callback=S,this._terminalBufferMap=new Map}dispose(){for(const S of this._terminalBufferMap.values())S.dispose()}startBuffering(S,N,_=5){const A=N(E=>{const P=typeof E=="string"?E:E.data;let O=this._terminalBufferMap.get(S);if(O){O.data.push(P);return}const w=setTimeout(()=>this.flushBuffer(S),_);O={data:[P],timeoutId:w,dispose:()=>{clearTimeout(w),this.flushBuffer(S),A.dispose()}},this._terminalBufferMap.set(S,O)});return A}stopBuffering(S){this._terminalBufferMap.get(S)?.dispose()}flushBuffer(S){const N=this._terminalBufferMap.get(S);N&&(this._terminalBufferMap.delete(S),this._callback(S,N.data.join("")))}}e.TerminalDataBufferer=r}),define(Ce[155],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var r;(function(N){N.DARK="dark",N.LIGHT="light",N.HIGH_CONTRAST_DARK="hcDark",N.HIGH_CONTRAST_LIGHT="hcLight"})(r=e.ColorScheme||(e.ColorScheme={}));function C(N){return N===r.HIGH_CONTRAST_DARK||N===r.HIGH_CONTRAST_LIGHT}e.isHighContrast=C;function S(N){return N===r.DARK||N===r.HIGH_CONTRAST_DARK}e.isDark=S}),define(Ce[60],Ie([1,0,117,5,7,3,30,155]),function(ie,e,r,C,S,N,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,N.createDecorator)("themeService");var E;(function(u){function d(v){return v&&typeof v=="object"&&typeof v.id=="string"}u.isThemeColor=d})(E=e.ThemeColor||(e.ThemeColor={}));function P(u){return{id:u}}e.themeColorFromId=P;var O;(function(u){function d(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||E.isThemeColor(n.color))}u.isThemeIcon=d;const v=new RegExp(`^\\$\\((${r.CSSIcon.iconNameExpression}(?:${r.CSSIcon.iconModifierExpression})?)\\)$`);function D(n){const o=v.exec(n);if(!o)return;const[,f]=o;return{id:f}}u.fromString=D;function c(n){return{id:n}}u.fromId=c;function b(n,o){let f=n.id;const s=f.lastIndexOf("~");return s!==-1&&(f=f.substring(0,s)),o&&(f=`${f}~${o}`),{id:f}}u.modify=b;function t(n){const o=n.id.lastIndexOf("~");if(o!==-1)return n.id.substring(o+1)}u.getModifier=t;function l(n,o){return n.id===o.id&&n.color?.id===o.color?.id}u.isEqual=l;function i(n,o){return{id:n.id,color:o?P(o):void 0}}u.asThemeIcon=i,u.asClassNameArray=r.CSSIcon.asClassNameArray,u.asClassName=r.CSSIcon.asClassName,u.asCSSSelector=r.CSSIcon.asCSSSelector})(O=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=r.Codicon.file,e.FolderThemeIcon=r.Codicon.folder;function w(u){switch(u){case A.ColorScheme.DARK:return"vs-dark";case A.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case A.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=w,e.Extensions={ThemingContribution:"base.contributions.theming"};class g{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new C.Emitter}onColorThemeChange(d){return this.themingParticipants.push(d),this.onThemingParticipantAddedEmitter.fire(d),(0,S.toDisposable)(()=>{const v=this.themingParticipants.indexOf(d);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const k=new g;_.Registry.add(e.Extensions.ThemingContribution,k);function m(u){return k.onColorThemeChange(u)}e.registerThemingParticipant=m;class a extends S.Disposable{constructor(d){super(),this.themeService=d,this.theme=d.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(d){this.theme=d,this.updateStyles()}updateStyles(){}getColor(d,v){let D=this.theme.getColor(d);return D&&v&&(D=v(D,this.theme)),D?D.toString():null}}e.Themable=a}),define(Ce[156],Ie([1,0,5,21,3,14]),function(ie,e,r,C,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,S.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,S.createDecorator)("sharedTunnelsService");var _;(function(a){a.Http="http",a.Https="https"})(_=e.TunnelProtocol||(e.TunnelProtocol={}));var A;(function(a){a.ConstantPrivate="constantPrivate",a.Private="private",a.Public="public"})(A=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var E;(function(a){a[a.Notify=1]="Notify",a[a.OpenBrowser=2]="OpenBrowser",a[a.OpenPreview=3]="OpenPreview",a[a.Silent=4]="Silent",a[a.Ignore=5]="Ignore",a[a.OpenBrowserOnce=6]="OpenBrowserOnce"})(E=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function P(a){if(a.scheme!=="http"&&a.scheme!=="https")return;const u=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(a.authority);if(!!u)return{address:u[1],port:+u[2]}}e.extractLocalHostUriMetaDataForPortMapping=P,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function O(a){return e.LOCALHOST_ADDRESSES.indexOf(a)>=0}e.isLocalhost=O,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(a){return e.ALL_INTERFACES_ADDRESSES.indexOf(a)>=0}e.isAllInterfaces=w;function g(a,u){return u?u!==1&&a<1024:!C.isWindows&&a<1024}e.isPortPrivileged=g;class k{constructor(u,d,v){this.remoteAddress=u,this.localAddress=d,this._dispose=v,this._onDispose=new r.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=k;let m=class{constructor(u){this.logService=u,this._onTunnelOpened=new r.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new r.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new r.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(u){return this._tunnelProvider=u,u?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(u){this._canElevate=u.elevation,this._privacyOptions=u.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const u=[],d=Array.from(this._tunnels.values());for(const v of d){const D=Array.from(v.values());for(const c of D){const b=await c.value;b&&u.push(b)}}return u}async dispose(){for(const u of this._tunnels.values()){for(const{value:d}of u.values())await d.then(v=>v?.dispose());u.clear()}this._tunnels.clear()}setEnvironmentTunnel(u,d,v,D,c){this.addTunnelToMap(u,d,Promise.resolve({tunnelRemoteHost:u,tunnelRemotePort:d,localAddress:v,privacy:D,protocol:c,dispose:()=>Promise.resolve()}))}openTunnel(u,d,v,D,c=!1,b,t){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${v} on local port ${D}.`),!u)return;if(d||(d="localhost"),this._tunnelProvider&&this._factoryInProgress.has(v)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const l=this.retainOrCreateTunnel(u,d,v,D,c,b,t);return l?l.then(i=>{if(!i){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(d,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(i);return(i.tunnelRemoteHost!==d||i.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}makeTunnel(u){return{tunnelRemotePort:u.tunnelRemotePort,tunnelRemoteHost:u.tunnelRemoteHost,tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress,privacy:u.privacy,protocol:u.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${u.tunnelRemoteHost}:${u.tunnelRemotePort} `);const d=this._tunnels.get(u.tunnelRemoteHost);if(d){const v=d.get(u.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(u.tunnelRemoteHost,u.tunnelRemotePort,v))}}}}async tryDisposeTunnel(u,d,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${u}:${d}.`);const D=v.value.then(async c=>{c&&(await c.dispose(!0),this._onTunnelClosed.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this._tunnels.has(u)&&this._tunnels.get(u).delete(d),D}}async closeTunnel(u,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${u}:${d} `);const v=this._tunnels.get(u);if(v&&v.has(d)){const D=v.get(d);D.refcount=0,await this.tryDisposeTunnel(u,d,D)}}addTunnelToMap(u,d,v){this._tunnels.has(u)||this._tunnels.set(u,new Map),this._tunnels.get(u).set(d,{refcount:1,value:v})}async removeEmptyTunnelFromMap(u,d){const v=this._tunnels.get(u);v&&(await v.get(d)||v.delete(d),v.size===0&&this._tunnels.delete(u))}getTunnelFromMap(u,d){const v=[u];O(u)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):w(u)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const D=v.map(c=>this._tunnels.get(c));for(const c of D){const b=c?.get(d);if(b)return b}}canTunnel(u){return!!P(u)}doIsPortPrivileged(u,d,v,D){if(d)return!1;if(v){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(D);if(c?.length===4){const b=parseInt(c[1]),t=parseInt(c[2]);if(b>10||b===10&&t>=14)return!1}}return u<1024}createWithProvider(u,d,v,D,c,b,t){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${v} on local port ${D}.`);const l=v;this._factoryInProgress.add(l);const i=D===void 0?v:D,n={elevationRequired:c?this.isPortPrivileged(i):!1},o={remoteAddress:{host:d,port:v},localAddressPort:D,privacy:b,public:b?b!==A.Private:void 0,protocol:t},f=u.forwardPort(o,n);return f?(this.addTunnelToMap(d,v,f),f.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(l)})):this._factoryInProgress.delete(l),f}};m=ze([$e(0,N.ILogService)],m),e.AbstractTunnelService=m}),define(Ce[157],Ie([1,0,13]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function C(E){return E.scheme!==r.Schemas.file&&E.scheme!==r.Schemas.vscodeRemote}e.isVirtualResource=C;function S(E){if(E.folders.length)return E.folders.every(P=>C(P.uri))?E.folders[0].uri:void 0;if(E.configuration&&C(E.configuration))return E.configuration}e.getVirtualWorkspaceLocation=S;function N(E){return S(E)?.scheme}e.getVirtualWorkspaceScheme=N;function _(E){return S(E)?.authority}e.getVirtualWorkspaceAuthority=_;function A(E){return S(E)!==void 0}e.isVirtualWorkspace=A}),define(Ce[46],Ie([1,0,129,19,24,22,2,3,13]),function(ie,e,r,C,S,N,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function P(l){const i=l;return typeof i?.id=="string"&&_.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=P,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function O(l,i){if(typeof l=="string"||typeof l>"u")return typeof l=="string"?{id:(0,C.basename)(l)}:i?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const n=l;if(n.configuration)return{id:n.id,configPath:n.configuration};if(n.folders.length===1)return{id:n.id,uri:n.folders[0].uri}}e.toWorkspaceIdentifier=O;function w(l){const i=l;return typeof i?.id=="string"&&_.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=w;function g(l){const i=l;if(i?.uri)return{id:i.id,uri:_.URI.revive(i.uri)};const n=l;if(n?.configPath)return{id:n.id,configPath:_.URI.revive(n.configPath)};if(l?.id)return{id:l.id}}e.reviveIdentifier=g;var k;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(k=e.WorkbenchState||(e.WorkbenchState={}));function m(l){const i=l;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=m;function a(l){const i=l;return!!(i&&typeof i=="object"&&_.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=a;class u{constructor(i,n,o,f,s){this._id=i,this._transient=o,this._configuration=f,this._ignorePathCasing=s,this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=n}update(i){this._id=i.id,this._configuration=i.configuration,this._transient=i.transient,this._ignorePathCasing=i._ignorePathCasing,this.folders=i.folders}get folders(){return this._folders}set folders(i){this._folders=i,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(i){this._configuration=i}getFolder(i){return i&&this._foldersMap.findSubstr(i)||null}updateFoldersMap(){this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const i of this.folders)this._foldersMap.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=u;class d{constructor(i,n){this.raw=n,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,N.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=d;function v(l){return new d({uri:l,index:0,name:(0,N.basenameOrAuthority)(l)},{uri:l.toString()})}e.toWorkspaceFolder=v,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,r.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function D(l,i){return N.extUriBiasedIgnorePathCase.isEqualOrParent(l,i.untitledWorkspacesHome)}e.isUntitledWorkspace=D;function c(l){let i;return _.URI.isUri(l)?i=l:i=l.configuration,i?.scheme===E.Schemas.tmp}e.isTemporaryWorkspace=c;function b(l,i){return!D(l,i)&&!c(l)}e.isSavedWorkspace=b;function t(l){return(typeof l=="string"?(0,C.extname)(l):(0,N.extname)(l))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=t}),define(Ce[61],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class r{constructor(S){this.id=S,this._data=new Map,this._idPool=1}add(S){const N=this._idPool++;return this._data.set(N,S),this.logDebugInfo(),N}get(S,N){return this._data.has(S)?this._data.get(S)[N]:void 0}delete(S){this._data.delete(S),this.logDebugInfo()}logDebugInfo(){!r.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=r,r.enableDebugLogging=!1}),define(Ce[36],Ie([1,0,13,22,3]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class N{constructor(){this._systemSchemes=new Set(Object.keys(r.Schemas)),this._providerInfo=new Map,this.extUri=new C.ExtUri(A=>{const E=this._providerInfo.get(A.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos(A,E){E===null?this._providerInfo.delete(A.scheme):this._providerInfo.set(A.scheme,E)}isFreeScheme(A){return!this._providerInfo.has(A)&&!this._systemSchemes.has(A)}getCapabilities(A){return this._providerInfo.get(A)}}e.ExtHostFileSystemInfo=N,e.IExtHostFileSystemInfo=(0,S.createDecorator)("IExtHostFileSystemInfo")}),define(Ce[27],Ie([1,0,3]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,r.createDecorator)("IExtHostInitDataService")}),define(Ce[158],Ie([1,0,15]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class C{constructor(_,A,E){this._deferredPromises=new Map,this._id=_,this._shared=A,this._storage=E,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new r.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const O of P.values())O.complete()}catch(O){for(const w of P.values())w.error(O)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,_])=>_!==void 0).map(([_])=>_)}get whenReady(){return this._init}get(_,A){let E=this._value[_];return typeof E>"u"&&(E=A),E}update(_,A){this._value[_]=A;const E=this._deferredPromises.get(_);if(E!==void 0)return E.p;const P=new r.DeferredPromise;return this._deferredPromises.set(_,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=C;class S extends C{setKeysForSync(_){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},_)}constructor(_,A){super(_.identifier.value,!0,A),this._extension=_}}e.ExtensionGlobalMemento=S}),define(Ce[159],Ie([1,0,5,2]),function(ie,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class S{constructor(_){this._notebooksAndEditors=_,this._onDidSaveNotebookDocument=new r.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new r.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(_,A,E,P){const w=this._notebooksAndEditors.getNotebookDocument(C.URI.revive(_)).acceptModelChanged(A.value,E,P);this._onDidChangeNotebookDocument.fire(w)}$acceptDirtyStateChanged(_,A){this._notebooksAndEditors.getNotebookDocument(C.URI.revive(_)).acceptDirty(A)}$acceptModelSaved(_){const A=this._notebooksAndEditors.getNotebookDocument(C.URI.revive(_));this._onDidSaveNotebookDocument.fire(A.apiNotebook)}}e.ExtHostNotebookDocuments=S}),define(Ce[11],Ie([1,0,3]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,r.createDecorator)("IExtHostRpcService");class C{constructor(N){this.getProxy=N.getProxy.bind(N),this.set=N.set.bind(N),this.dispose=N.dispose.bind(N),this.assertRegistered=N.assertRegistered.bind(N),this.drain=N.drain.bind(N)}}e.ExtHostRpcService=C});var Je=this&&this.__classPrivateFieldSet||function(ie,e,r,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ie,r):S?S.value=r:e.set(ie,r),r},Oe=this&&this.__classPrivateFieldGet||function(ie,e,r,C){if(r==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!C:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?C:r==="a"?C.call(ie):C?C.value:e.get(ie)};define(Ce[160],Ie([1,0,26,5]),function(ie,e,r,C){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class N{constructor(A,E){S.set(this,void 0),this._onDidChange=new C.Emitter,this.onDidChange=this._onDidChange.event,this._id=r.ExtensionIdentifier.toKey(A.identifier),Je(this,S,E,"f"),Oe(this,S,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(A){return Oe(this,S,"f").get(this._id,A)}store(A,E){return Oe(this,S,"f").store(this._id,A,E)}delete(A){return Oe(this,S,"f").delete(this._id,A)}}e.ExtensionSecrets=N,S=new WeakMap}),define(Ce[88],Ie([1,0,3,5]),function(ie,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class S{constructor(){this._onDidChangeTelemetryEnabled=new C.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new C.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}$initializeTelemetryLevel(_,A){this._level=_,this._productConfig=A||{usage:!0,error:!0}}$onDidChangeTelemetryLevel(_){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=_,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=S,e.IExtHostTelemetry=(0,r.createDecorator)("IExtHostTelemetry")}),define(Ce[62],Ie([1,0,3,156,5,11]),function(ie,e,r,C,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var _;(function(E){function P(w){return{remoteAddress:w.remoteAddress,localAddress:w.localAddress,public:!!w.public,privacy:w.privacy??(w.public?C.TunnelPrivacyId.Public:C.TunnelPrivacyId.Private),protocol:w.protocol}}E.fromApiTunnel=P;function O(w){return{remoteAddress:{host:w.tunnelRemoteHost,port:w.tunnelRemotePort},localAddress:w.localAddress,public:w.privacy!==C.TunnelPrivacyId.ConstantPrivate&&w.privacy!==C.TunnelPrivacyId.ConstantPrivate,privacy:w.privacy,protocol:w.protocol}}E.fromServiceTunnel=O})(_=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,r.createDecorator)("IExtHostTunnelService");let A=class{constructor(P){this.onDidChangeTunnels=new S.Emitter().event}async $applyCandidateFilter(P){return P}async openTunnel(P,O){}async getTunnels(){return[]}async setTunnelFactory(P){return{dispose:()=>{}}}registerPortsAttributesProvider(P,O){return{dispose:()=>{}}}async $providePortAttributes(P,O,w,g,k){return[]}async $forwardPort(P,O){}async $closeTunnel(P){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=ze([$e(0,N.IExtHostRpcService)],A),e.ExtHostTunnelService=A}),define(Ce[47],Ie([1,0,3]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,r.createDecorator)("IURITransformerService");class C{constructor(N){N?(this.transformIncoming=N.transformIncoming.bind(N),this.transformOutgoing=N.transformOutgoing.bind(N),this.transformOutgoingURI=N.transformOutgoingURI.bind(N),this.transformOutgoingScheme=N.transformOutgoingScheme.bind(N)):(this.transformIncoming=_=>_,this.transformOutgoing=_=>_,this.transformOutgoingURI=_=>_,this.transformOutgoingScheme=_=>_)}}e.URITransformerService=C}),define(Ce[161],Ie([1,0,23]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class C{constructor(){this.buffers=[]}add(E){let P=this.buffers.indexOf(E);return P<0&&(P=this.buffers.length,this.buffers.push(E)),P}}function S(A,E){if(E.serializeBuffersForPostMessage){const P=new C,O=(k,m)=>{if(m instanceof ArrayBuffer){const a=P.add(m);return{$$vscode_array_buffer_reference$$:!0,index:a}}else if(ArrayBuffer.isView(m)){const a=N(m);if(a){const u=P.add(m.buffer);return{$$vscode_array_buffer_reference$$:!0,index:u,view:{type:a,byteLength:m.byteLength,byteOffset:m.byteOffset}}}}return m},w=JSON.stringify(A,O),g=P.buffers.map(k=>{const m=new Uint8Array(k);return r.VSBuffer.wrap(m)});return{message:w,buffers:g}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=S;function N(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function _(A,E){const P=E.map(g=>{const k=new ArrayBuffer(g.byteLength);return new Uint8Array(k).set(g.buffer),k}),O=E.length?(g,k)=>{if(k&&typeof k=="object"&&k.$$vscode_array_buffer_reference$$){const m=k,{index:a}=m,u=P[a];if(m.view)switch(m.view.type){case 1:return new Int8Array(u,m.view.byteOffset,m.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(u,m.view.byteOffset,m.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(u,m.view.byteOffset,m.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(u,m.view.byteOffset,m.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(u,m.view.byteOffset,m.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(u,m.view.byteOffset,m.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(u,m.view.byteOffset,m.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(u,m.view.byteOffset,m.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(u,m.view.byteOffset,m.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(u,m.view.byteOffset,m.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(u,m.view.byteOffset,m.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return u}return k}:void 0;return{message:JSON.parse(A,O),arrayBuffers:P}}e.deserializeWebviewMessage=_}),define(Ce[89],Ie([1,0,137,10,2,7,3,30,35,13]),function(ie,e,r,C,S,N,_,A,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,r.localize)(0,null),providerDisplayName:(0,r.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var O;(function(G){G[G.PROGRAMMATIC=1]="PROGRAMMATIC",G[G.USER=2]="USER",G[G.EDIT=3]="EDIT",G[G.NAVIGATION=4]="NAVIGATION",G[G.JUMP=5]="JUMP"})(O=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var w;(function(G){G[G.IDENTICAL=1]="IDENTICAL",G[G.SIMILAR=2]="SIMILAR",G[G.DIFFERENT=3]="DIFFERENT"})(w=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function g(G){const re=G;return!!re&&typeof re.getSelection=="function"&&!!re.onDidChangeSelection}e.isEditorPaneWithSelection=g;function k(G,re,ge){for(const oe of ge.visibleEditorPanes)if(oe.group.id===re&&G.matches(oe.input))return oe.getViewState()}e.findViewStateForEditor=k;function m(G){if(o(G))return!1;const re=G;return S.URI.isUri(re?.resource)}e.isResourceEditorInput=m;function a(G){if(o(G))return!1;const re=G;return re?.original!==void 0&&re.modified!==void 0}e.isResourceDiffEditorInput=a;function u(G){if(o(G)||a(G))return!1;const re=G;return re?.primary!==void 0&&re.secondary!==void 0}e.isResourceSideBySideEditorInput=u;function d(G){if(o(G))return!1;const re=G;return re?re.resource===void 0||re.resource.scheme===P.Schemas.untitled||re.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=d;const v=/Untitled-\d+/;function D(G){return G.scheme===P.Schemas.untitled&&G.path.length>1&&!v.test(G.path)}e.isUntitledWithAssociatedResource=D;function c(G){if(o(G))return!1;const re=G;return S.URI.isUri(re?.base?.resource)&&S.URI.isUri(re?.input1?.resource)&&S.URI.isUri(re?.input2?.resource)&&S.URI.isUri(re?.result?.resource)}e.isResourceMergeEditorInput=c;var b;(function(G){G[G.SHORT=0]="SHORT",G[G.MEDIUM=1]="MEDIUM",G[G.LONG=2]="LONG"})(b=e.Verbosity||(e.Verbosity={}));var t;(function(G){G[G.EXPLICIT=1]="EXPLICIT",G[G.AUTO=2]="AUTO",G[G.FOCUS_CHANGE=3]="FOCUS_CHANGE",G[G.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(t=e.SaveReason||(e.SaveReason={}));class l{constructor(){this.mapIdToSaveSource=new Map}registerSource(re,ge){let oe=this.mapIdToSaveSource.get(re);return oe||(oe={source:re,label:ge},this.mapIdToSaveSource.set(re,oe)),oe.source}getSourceLabel(re){return this.mapIdToSaveSource.get(re)?.label??re}}e.SaveSourceRegistry=new l;var i;(function(G){G[G.None=0]="None",G[G.Readonly=2]="Readonly",G[G.Untitled=4]="Untitled",G[G.Singleton=8]="Singleton",G[G.RequiresTrust=16]="RequiresTrust",G[G.CanSplitInGroup=32]="CanSplitInGroup",G[G.ForceDescription=64]="ForceDescription",G[G.CanDropIntoEditor=128]="CanDropIntoEditor",G[G.MultipleEditors=256]="MultipleEditors"})(i=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class n extends N.Disposable{}e.AbstractEditorInput=n;function o(G){return G instanceof n}e.isEditorInput=o;function f(G){const re=G;return S.URI.isUri(re?.preferredResource)}function s(G){const re=G;return o(re?.primary)&&o(re?.secondary)}e.isSideBySideEditorInput=s;function h(G){const re=G;return o(re?.modified)&&o(re?.original)}e.isDiffEditorInput=h;function p(G){return o(G?.editor)}e.isEditorInputWithOptions=p;function T(G){const re=G;return p(G)&&re?.group!==void 0}e.isEditorInputWithOptionsAndGroup=T;function M(G){const re=G;return typeof re?.groupId=="number"&&o(re.editor)}e.isEditorIdentifier=M;var V;(function(G){G[G.UNKNOWN=0]="UNKNOWN",G[G.REPLACE=1]="REPLACE",G[G.MOVE=2]="MOVE",G[G.UNPIN=3]="UNPIN"})(V=e.EditorCloseContext||(e.EditorCloseContext={}));var U;(function(G){G[G.GROUP_ACTIVE=0]="GROUP_ACTIVE",G[G.GROUP_INDEX=1]="GROUP_INDEX",G[G.GROUP_LOCKED=2]="GROUP_LOCKED",G[G.EDITOR_OPEN=3]="EDITOR_OPEN",G[G.EDITOR_CLOSE=4]="EDITOR_CLOSE",G[G.EDITOR_MOVE=5]="EDITOR_MOVE",G[G.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",G[G.EDITOR_LABEL=7]="EDITOR_LABEL",G[G.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",G[G.EDITOR_PIN=9]="EDITOR_PIN",G[G.EDITOR_STICKY=10]="EDITOR_STICKY",G[G.EDITOR_DIRTY=11]="EDITOR_DIRTY",G[G.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(U=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var y;(function(G){G[G.PRIMARY=1]="PRIMARY",G[G.SECONDARY=2]="SECONDARY",G[G.BOTH=3]="BOTH",G[G.ANY=4]="ANY"})(y=e.SideBySideEditor||(e.SideBySideEditor={}));class x{getOriginalUri(re,ge){if(!re)return;if(c(re))return e.EditorResourceAccessor.getOriginalUri(re.result,ge);if(ge?.supportSideBySide){const{primary:Ee,secondary:ce}=this.getSideEditors(re);if(Ee&&ce){if(ge?.supportSideBySide===y.BOTH)return{primary:this.getOriginalUri(Ee,{filterByScheme:ge.filterByScheme}),secondary:this.getOriginalUri(ce,{filterByScheme:ge.filterByScheme})};if(ge?.supportSideBySide===y.ANY)return this.getOriginalUri(Ee,{filterByScheme:ge.filterByScheme})??this.getOriginalUri(ce,{filterByScheme:ge.filterByScheme});re=ge.supportSideBySide===y.PRIMARY?Ee:ce}}if(a(re)||u(re)||c(re))return;const oe=f(re)?re.preferredResource:re.resource;return!oe||!ge||!ge.filterByScheme?oe:this.filterUri(oe,ge.filterByScheme)}getSideEditors(re){return s(re)||u(re)?{primary:re.primary,secondary:re.secondary}:h(re)||a(re)?{primary:re.modified,secondary:re.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(re,ge){if(!re)return;if(c(re))return e.EditorResourceAccessor.getCanonicalUri(re.result,ge);if(ge?.supportSideBySide){const{primary:Ee,secondary:ce}=this.getSideEditors(re);if(Ee&&ce){if(ge?.supportSideBySide===y.BOTH)return{primary:this.getCanonicalUri(Ee,{filterByScheme:ge.filterByScheme}),secondary:this.getCanonicalUri(ce,{filterByScheme:ge.filterByScheme})};if(ge?.supportSideBySide===y.ANY)return this.getCanonicalUri(Ee,{filterByScheme:ge.filterByScheme})??this.getCanonicalUri(ce,{filterByScheme:ge.filterByScheme});re=ge.supportSideBySide===y.PRIMARY?Ee:ce}}if(a(re)||u(re)||c(re))return;const oe=re.resource;return!oe||!ge||!ge.filterByScheme?oe:this.filterUri(oe,ge.filterByScheme)}filterUri(re,ge){if(Array.isArray(ge)){if(ge.some(oe=>re.scheme===oe))return re}else if(ge===re.scheme)return re}}e.EditorResourceAccessor=new x;var L;(function(G){G[G.LEFT=0]="LEFT",G[G.RIGHT=1]="RIGHT"})(L=e.CloseDirection||(e.CloseDirection={}));class R{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(re){const ge=this.instantiationService=re.get(_.IInstantiationService);for(const[oe,Ee]of this.editorSerializerConstructors)this.createEditorSerializer(oe,Ee,ge);this.editorSerializerConstructors.clear()}createEditorSerializer(re,ge,oe){const Ee=oe.createInstance(ge);this.editorSerializerInstances.set(re,Ee)}registerFileEditorFactory(re){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=re}getFileEditorFactory(){return(0,C.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(re,ge){if(this.editorSerializerConstructors.has(re)||this.editorSerializerInstances.has(re))throw new Error(`A editor serializer with type ID '${re}' was already registered.`);return this.instantiationService?this.createEditorSerializer(re,ge,this.instantiationService):this.editorSerializerConstructors.set(re,ge),(0,N.toDisposable)(()=>{this.editorSerializerConstructors.delete(re),this.editorSerializerInstances.delete(re)})}getEditorSerializer(re){return this.editorSerializerInstances.get(typeof re=="string"?re:re.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new R);async function K(G,re){return!G||!G.length?[]:await Promise.all(G.map(async ge=>{const oe=S.URI.revive(ge.fileUri);if(!oe||!await re.canHandleResource(oe))return;let ce=ge.exists,me=ge.type;if(typeof ce!="boolean"||typeof me!="number")try{me=(await re.stat(oe)).isDirectory?E.FileType.Directory:E.FileType.Unknown,ce=!0}catch{ce=!1}if(!ce&&ge.openOnlyIfExists||me===E.FileType.Directory)return;const ee={...ge.options,pinned:!0};return ce?{resource:oe,options:ee}:{resource:oe,options:ee,forceUntitled:!0}}))}e.pathsToEditors=K;var W;(function(G){G[G.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",G[G.SEQUENTIAL=1]="SEQUENTIAL"})(W=e.EditorsOrder||(e.EditorsOrder={}));function $(G){const re=G;if(!re)return!1;const ge=re;if(ge.modified)return $(ge.modified);const oe=re;return!!(oe.contributionsState&&oe.viewState&&Array.isArray(oe.cursorState))}e.isTextEditorViewState=$}),define(Ce[63],Ie([1,0,13,2]),function(ie,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function S(A,E){return A.scheme===r.Schemas.http||A.scheme===r.Schemas.https?A:(E&&E.authority&&E.isRemote&&A.scheme===r.Schemas.file&&(A=C.URI.from({scheme:r.Schemas.vscodeRemote,authority:E.authority,path:A.path})),C.URI.from({scheme:r.Schemas.https,authority:`${A.scheme}+${N(A.authority)}.${e.webviewRootResourceAuthority}`,path:A.path,fragment:A.fragment,query:A.query}))}e.asWebviewUri=S;function N(A){return A.replace(/./g,E=>{const P=E.charCodeAt(0);return P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57?E:"-"+P.toString(16).padStart(4,"0")})}function _(A){return A.replace(/-([0-9a-f]{4})/g,(E,P)=>String.fromCharCode(parseInt(P,16)))}e.decodeAuthority=_}),define(Ce[162],Ie([1,0,5,7,63]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class N{constructor(A,E,P){this._proxy=A,this._editors=E,this._remoteInfo=P,this._handlePool=0,this._disposables=new C.DisposableStore,this._insets=new Map,this._disposables.add(E.onDidChangeVisibleTextEditors(()=>{const O=E.getVisibleTextEditors();for(const w of this._insets.values())O.indexOf(w.editor)<0&&w.inset.dispose()}))}dispose(){this._insets.forEach(A=>A.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(A,E,P,O,w){let g;for(const D of this._editors.getVisibleTextEditors(!0))if(D.value===A){g=D;break}if(!g)throw new Error("not a visible editor");const k=this,m=this._handlePool++,a=new r.Emitter,u=new r.Emitter,d=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(D){return(0,S.asWebviewUri)(D,k._remoteInfo)}get cspSource(){return S.webviewGenericCspSource}set options(D){this._options=D,k._proxy.$setOptions(m,D)}get options(){return this._options}set html(D){this._html=D,k._proxy.$setHtml(m,D)}get html(){return this._html}get onDidReceiveMessage(){return a.event}postMessage(D){return k._proxy.$postMessage(m,D)}},v=new class{constructor(){this.editor=A,this.line=E,this.height=P,this.webview=d,this.onDidDispose=u.event}dispose(){k._insets.has(m)&&(k._insets.delete(m),k._proxy.$disposeEditorInset(m),u.fire(),u.dispose(),a.dispose())}};return this._proxy.$createEditorInset(m,g.id,g.value.document.uri,E+1,P,O||{},w.identifier,w.extensionLocation),this._insets.set(m,{editor:A,inset:v,onDidReceiveMessage:a}),v}$onDidDispose(A){const E=this._insets.get(A);E&&E.inset.dispose()}$onDidReceiveMessage(A,E){this._insets.get(A)?.onDidReceiveMessage.fire(E)}}e.ExtHostEditorInsets=N}),define(Ce[163],Ie([1,0,5,15,138]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class N{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new r.Emitter,this._onExit=new r.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(A){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=A}onEvent(A){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=A}onRequest(A){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=A}sendResponse(A){A.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.internalSend("response",A)}sendRequest(A,E,P,O){const w={command:A};if(E&&Object.keys(E).length>0&&(w.arguments=E),this.internalSend("request",w),typeof O=="number"){const g=setTimeout(()=>{clearTimeout(g);const k=this.pendingRequests.get(w.seq);if(k){this.pendingRequests.delete(w.seq);const m={type:"response",seq:0,request_seq:w.seq,success:!1,command:A,message:(0,S.localize)(0,null,O,A)};k(m)}},O)}return P&&this.pendingRequests.set(w.seq,P),w.seq}acceptMessage(A){this.messageCallback?this.messageCallback(A):(this.queue.push(A),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(A,E){return A.type!=="event"||E.type!=="event"}async processQueue(){let A;for(;this.queue.length;){if((!A||this.needsTaskBoundaryBetween(this.queue[0],A))&&await(0,C.timeout)(0),A=this.queue.shift(),!A)return;switch(A.type){case"event":this.eventCallback?.(A);break;case"request":this.requestCallback?.(A);break;case"response":{const E=A,P=this.pendingRequests.get(E.request_seq);P&&(this.pendingRequests.delete(E.request_seq),P(E));break}}}}internalSend(A,E){E.type=A,E.seq=this.sequence++,this.sendMessage(E)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const A=new Map;this.pendingRequests.forEach((E,P)=>A.set(P,E)),await(0,C.timeout)(500),A.forEach((E,P)=>{E({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=N}),define(Ce[164],Ie([1,0,139,39,3]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new C.RawContextKey("debugType",void 0,{type:"string",description:r.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new C.RawContextKey("debugConfigurationType",void 0,{type:"string",description:r.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new C.RawContextKey("debugState","inactive",{type:"string",description:r.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new C.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:r.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new C.RawContextKey("inDebugMode",!1,{type:"boolean",description:r.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new C.RawContextKey("inDebugRepl",!1,{type:"boolean",description:r.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new C.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:r.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new C.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:r.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new C.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:r.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new C.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:r.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new C.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:r.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new C.RawContextKey("variablesFocused",!0,{type:"boolean",description:r.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new C.RawContextKey("expressionSelected",!1,{type:"boolean",description:r.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new C.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:r.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new C.RawContextKey("callStackItemType",void 0,{type:"string",description:r.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new C.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:r.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new C.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:r.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new C.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:r.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new C.RawContextKey("watchItemType",void 0,{type:"string",description:r.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new C.RawContextKey("canViewMemory",void 0,{type:"boolean",description:r.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new C.RawContextKey("breakpointItemType",void 0,{type:"string",description:r.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new C.RawContextKey("breakpointAccessType",void 0,{type:"string",description:r.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new C.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:r.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new C.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:r.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new C.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:r.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new C.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:r.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new C.RawContextKey("stepBackSupported",!1,{type:"boolean",description:r.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new C.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:r.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new C.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:r.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new C.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:r.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new C.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:r.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new C.RawContextKey("breakpointsExist",!1,{type:"boolean",description:r.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new C.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:r.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new C.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:r.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new C.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:r.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new C.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:r.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new C.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:r.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new C.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:r.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new C.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:r.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new C.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:r.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new C.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:r.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new C.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:r.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new C.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:r.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new C.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:r.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new C.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:r.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new C.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:r.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new C.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:r.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new C.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:r.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new C.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:r.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new C.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:r.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new C.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:r.localize(50,null)});const N=g=>r.localize(51,null,g);e.debuggerDisabledMessage=N,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:r.localize(52,null)};var _;(function(g){g[g.Inactive=0]="Inactive",g[g.Initializing=1]="Initializing",g[g.Stopped=2]="Stopped",g[g.Running=3]="Running"})(_=e.State||(e.State={}));function A(g){switch(g){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=A;var E;(function(g){g[g.Valid=0]="Valid",g[g.Unreadable=1]="Unreadable",g[g.Error=2]="Error"})(E=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var P;(function(g){g[g.Initial=1]="Initial",g[g.Dynamic=2]="Dynamic"})(P=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var O;(function(g){g.UnverifiedBreakpoints="unverifiedBreakpoints"})(O=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,S.createDecorator)(e.DEBUG_SERVICE_ID);var w;(function(g){g[g.CONDITION=0]="CONDITION",g[g.HIT_COUNT=1]="HIT_COUNT",g[g.LOG_MESSAGE=2]="LOG_MESSAGE"})(w=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ce[165],Ie([1,0,9,2,19,25,13]),function(ie,e,r,C,S,N,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const A=/{([^}]+)}/g;function E(i,n,o){return i.replace(A,function(f,s){return n&&s.length>0&&s[0]!=="_"?f:o&&o.hasOwnProperty(s)?o[s]:f})}e.formatPII=E;function P(i){const n={};for(const o of Object.keys(i))o.startsWith("!")||(n[o]=i[o]);return n}e.filterExceptionsFromTelemetry=P;function O(i){return i.configuration.request==="attach"&&!w(i)&&(!i.parentSession||O(i.parentSession))}e.isSessionAttach=O;function w(i){let n=i.configuration.type;if(!!n)return n==="vslsShare"&&(n=i.configuration.adapterProxy.configuration.type),(0,r.equalsIgnoreCase)(n,"extensionhost")||(0,r.equalsIgnoreCase)(n,"pwa-extensionhost")?i:i.parentSession?w(i.parentSession):void 0}e.getExtensionHostDebugSession=w;function g(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=g;function k(i,n,o){let f,s=0;const h=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let p=null;for(;p=h.exec(i);){const T=p.index+1,M=T+p[0].length;if(T<=n&&M>=o){f=p[0],s=T;break}}if(f){const T=/\w+/g;let M=null;for(;(M=T.exec(f))&&!(M.index+1+s+M[0].length>=o););M&&(f=f.substring(0,T.lastIndex))}return f?{start:s,end:s+f.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=k;const m=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function a(i){return!!(i&&i.match(m))}e.isUri=a;function u(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(a(i.path))return C.URI.parse(i.path);if((0,S.isAbsolute)(i.path))return C.URI.file(i.path)}return i.path}function d(i){if(typeof i.path=="object"){const n=C.URI.revive(i.path);if(n)return n.scheme===_.Schemas.file?n.fsPath:n.toString()}return i.path}function v(i,n){const o=n?u:d,f=(0,N.deepClone)(i);return c(f,(s,h)=>{s&&h&&(h.path=o(h))}),f}e.convertToDAPaths=v;function D(i,n){const o=n?u:d,f=(0,N.deepClone)(i);return c(f,(s,h)=>{!s&&h&&(h.path=o(h))}),f}e.convertToVSCPaths=D;function c(i,n){switch(i.type){case"event":{const o=i;switch(o.event){case"output":n(!1,o.body.source);break;case"loadedSource":n(!1,o.body.source);break;case"breakpoint":n(!1,o.body.breakpoint.source);break;default:break}break}case"request":{const o=i;switch(o.command){case"setBreakpoints":n(!0,o.arguments.source);break;case"breakpointLocations":n(!0,o.arguments.source);break;case"source":n(!0,o.arguments.source);break;case"gotoTargets":n(!0,o.arguments.source);break;case"launchVSCode":o.arguments.args.forEach(f=>n(!1,f));break;default:break}break}case"response":{const o=i;if(o.success&&o.body)switch(o.command){case"stackTrace":o.body.stackFrames.forEach(f=>n(!1,f.source));break;case"loadedSources":o.body.sources.forEach(f=>n(!1,f));break;case"scopes":o.body.scopes.forEach(f=>n(!1,f.source));break;case"setFunctionBreakpoints":o.body.breakpoints.forEach(f=>n(!1,f.source));break;case"setBreakpoints":o.body.breakpoints.forEach(f=>n(!1,f.source));break;case"disassemble":o.body?.instructions.forEach(s=>n(!1,s.location));break;default:break}break}}}function b(i){return i.filter(n=>!n.presentation?.hidden).sort((n,o)=>n.presentation?o.presentation?n.presentation.group?o.presentation.group?n.presentation.group!==o.presentation.group?n.presentation.group.localeCompare(o.presentation.group):t(n.presentation.order,o.presentation.order):-1:o.presentation.group?1:t(n.presentation.order,o.presentation.order):-1:o.presentation?1:0)}e.getVisibleAndSorted=b;function t(i,n){return typeof i!="number"?typeof n!="number"?0:1:typeof n!="number"?-1:i-n}async function l(i,n){const o=i.getValue("debug.saveBeforeStart",{overrideIdentifier:n.activeTextEditorLanguageId});if(o!=="none"&&(await n.saveAll(),o==="allEditorsInActiveGroup")){const f=n.activeEditorPane;f&&f.input.resource?.scheme===_.Schemas.untitled&&await n.save({editor:f.input,groupId:f.group.id})}await i.reloadConfiguration()}e.saveAllBeforeDebugStart=l}),define(Ce[64],Ie([1,0,23,34,166,75,13,19,21,39]),function(ie,e,r,C,S,N,_,A,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var O;(function(s){s[s.Markup=1]="Markup",s[s.Code=2]="Code"})(O=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",N.Mimes.latex,N.Mimes.markdown,"image/png","image/jpeg",N.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[N.Mimes.latex,N.Mimes.markdown,"application/json",N.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var w;(function(s){s[s.Running=1]="Running",s[s.Idle=2]="Idle"})(w=e.NotebookRunState||(e.NotebookRunState={}));var g;(function(s){s[s.Unconfirmed=1]="Unconfirmed",s[s.Pending=2]="Pending",s[s.Executing=3]="Executing"})(g=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var k;(function(s){s[s.WithHardKernelDependency=0]="WithHardKernelDependency",s[s.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",s[s.Pure=2]="Pure",s[s.Never=3]="Never"})(k=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var m;(function(s){s.Always="always",s.Never="never",s.Optional="optional"})(m=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var a;(function(s){s[s.ModelChange=1]="ModelChange",s[s.Move=2]="Move",s[s.ChangeCellLanguage=5]="ChangeCellLanguage",s[s.Initialize=6]="Initialize",s[s.ChangeCellMetadata=7]="ChangeCellMetadata",s[s.Output=8]="Output",s[s.OutputItem=9]="OutputItem",s[s.ChangeCellContent=10]="ChangeCellContent",s[s.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",s[s.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",s[s.ChangeCellMime=13]="ChangeCellMime",s[s.Unknown=100]="Unknown"})(a=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var u;(function(s){s[s.Handle=0]="Handle",s[s.Index=1]="Index"})(u=e.SelectionStateType||(e.SelectionStateType={}));var d;(function(s){s[s.Replace=1]="Replace",s[s.Output=2]="Output",s[s.Metadata=3]="Metadata",s[s.CellLanguage=4]="CellLanguage",s[s.DocumentMetadata=5]="DocumentMetadata",s[s.Move=6]="Move",s[s.OutputItems=7]="OutputItems",s[s.PartialMetadata=8]="PartialMetadata",s[s.PartialInternalMetadata=9]="PartialInternalMetadata"})(d=e.CellEditType||(e.CellEditType={}));var v;(function(s){s.scheme=_.Schemas.vscodeNotebookCell;const h=["W","X","Y","Z","a","b","c","d","e","f"],p=new RegExp(`^[${h.join("")}]+`),T=7;function M(R,K){const W=K.toString(T),G=`${W.length<h.length?h[W.length-1]:"z"}${W}s${(0,r.encodeBase64)(r.VSBuffer.fromString(R.scheme),!0,!0)}`;return R.with({scheme:s.scheme,fragment:G})}s.generate=M;function V(R){if(R.scheme!==s.scheme)return;const K=R.fragment.indexOf("s");if(K<0)return;const W=parseInt(R.fragment.substring(0,K).replace(p,""),T),$=(0,r.decodeBase64)(R.fragment.substring(K+1)).toString();if(!isNaN(W))return{handle:W,notebook:R.with({scheme:$,fragment:null})}}s.parse=V;function U(R,K){return R.with({scheme:_.Schemas.vscodeNotebookCellOutput,fragment:`op${K??""},${R.scheme!==_.Schemas.file?R.scheme:""}`})}s.generateCellOutputUri=U;function y(R){if(R.scheme!==_.Schemas.vscodeNotebookCellOutput)return;const K=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(R.fragment);if(!K)return;const W=K[1]&&K[1]!==""?K[1]:void 0,$=K[2];return{outputId:W,notebook:R.with({scheme:$||_.Schemas.file,fragment:null})}}s.parseCellOutputUri=y;function x(R,K,W){return s.generate(R,K).with({scheme:W})}s.generateCellPropertyUri=x;function L(R,K){if(R.scheme===K)return s.parse(R.with({scheme:s.scheme}))}s.parseCellPropertyUri=L})(v=e.CellUri||(e.CellUri={}));const D=s=>E.isWindows?s.replace(/\//g,"\\"):s;class c{constructor(h=[],p=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=p,this.order=[...new Set(h)].map(T=>({pattern:T,matches:C.parse(D(T))}))}sort(h){const p=new Map(S.Iterable.map(h,M=>[M,D(M)]));let T=[];for(const{matches:M}of this.order)for(const[V,U]of p)if(M(U)){T.push(V),p.delete(V);break}return p.size&&(T=T.concat([...p.keys()].sort((M,V)=>this.defaultOrder.indexOf(M)-this.defaultOrder.indexOf(V)))),T}prioritize(h,p){const T=this.findIndex(h);if(T===-1){this.order.unshift({pattern:h,matches:C.parse(D(h))});return}const M=new Set(p.map(U=>this.findIndex(U,T)));M.delete(-1);const V=Array.from(M).sort();this.order.splice(T+1,0,...V.map(U=>this.order[U]));for(let U=V.length-1;U>=0;U--)this.order.splice(V[U],1)}toArray(){return this.order.map(h=>h.pattern)}findIndex(h,p=this.order.length){const T=D(h);for(let M=0;M<p;M++)if(this.order[M].matches(T))return M;return-1}}e.MimeTypeDisplayOrder=c;function b(s,h,p,T=(M,V)=>M===V){const M=[];function V(x,L,R){if(L===0&&R.length===0)return;const K=M[M.length-1];K&&K.start+K.deleteCount===x?(K.deleteCount+=L,K.toInsert.push(...R)):M.push({start:x,deleteCount:L,toInsert:R})}let U=0,y=0;for(;;){if(U===s.length){V(U,0,h.slice(y));break}if(y===h.length){V(U,s.length-U,[]);break}const x=s[U],L=h[y];if(T(x,L)){U+=1,y+=1;continue}p(L)?(V(U,1,[]),U+=1):(V(U,0,[L]),y+=1)}return M}e.diff=b,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new P.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(s){s.default="default",s.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function l(s){const h=s;return!!((typeof h.include=="string"||C.isRelativePattern(h.include))&&(typeof h.exclude=="string"||C.isRelativePattern(h.exclude)))}e.isDocumentExcludePattern=l;function i(s,h,p){if(Array.isArray(s.viewType)&&s.viewType.indexOf(h)>=0||s.viewType===h)return!0;if(s.filenamePattern){const T=l(s.filenamePattern)?s.filenamePattern.include:s.filenamePattern,M=l(s.filenamePattern)?s.filenamePattern.exclude:void 0;if(C.match(T,(0,A.basename)(p.fsPath).toLowerCase()))return!(M&&C.match(M,(0,A.basename)(p.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=i,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var n;(function(s){s[s.Left=1]="Left",s[s.Right=2]="Right"})(n=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class o{static create(h){return`${o._prefix}${h}`}static parse(h){if(h.startsWith(o._prefix))return h.substring(o._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=o,o._prefix="notebook/";function f(s){return["application/vnd.code.notebook.stdout","application/x.notebook.stdout","application/x.notebook.stream","application/vnd.code.notebook.stderr","application/x.notebook.stderr"].includes(s)}e.isTextStreamMime=f}),define(Ce[167],Ie([1,0,3]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var C;(function(S){S[S.Output=1]="Output",S[S.OutputItems=2]="OutputItems",S[S.ExecutionState=3]="ExecutionState"})(C=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,r.createDecorator)("INotebookExecutionService")}),define(Ce[168],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function r(_){return[..._.entries()]}e.serializeEnvironmentVariableCollection=r;function C(_){return new Map(_)}e.deserializeEnvironmentVariableCollection=C;function S(_){return Array.from(_.entries()).map(A=>[A[0],r(A[1].map)])}e.serializeEnvironmentVariableCollections=S;function N(_){return new Map(_.map(A=>[A[0],{map:C(A[1])}]))}e.deserializeEnvironmentVariableCollections=N}),define(Ce[40],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var r;(function(N){N.Delimiter="\0"})(r=e.TestIdPathParts||(e.TestIdPathParts={}));var C;(function(N){N[N.IsSame=0]="IsSame",N[N.Disconnected=1]="Disconnected",N[N.IsChild=2]="IsChild",N[N.IsParent=3]="IsParent"})(C=e.TestPosition||(e.TestPosition={}));class S{static fromExtHostTestItem(_,A,E=_.parent){if(_._isRoot)return new S([A]);const P=[_.id];for(let O=E;O&&O.id!==A;O=O.parent)P.push(O.id);return P.push(A),new S(P.reverse())}static isRoot(_){return!_.includes("\0")}static root(_){const A=_.indexOf("\0");return A===-1?_:_.slice(0,A)}static fromString(_){return new S(_.split("\0"))}static join(_,A){return new S([..._.path,A])}static joinToString(_,A){return _.toString()+"\0"+A}static parentId(_){const A=_.lastIndexOf("\0");return A===-1?void 0:_.slice(0,A)}static compare(_,A){return _===A?0:A.startsWith(_+"\0")?2:_.startsWith(A+"\0")?3:1}constructor(_,A=_.length){if(this.path=_,this.viewEnd=A,_.length===0||A<1)throw new Error("cannot create test with empty path")}get parentId(){return this.viewEnd>1?new S(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let _=1;_<=this.viewEnd;_++)yield new S(this.path,_)}*idsToRoot(){for(let _=this.viewEnd;_>0;_--)yield new S(this.path,_)}compare(_){if(typeof _=="string")return S.compare(this.toString(),_);for(let A=0;A<_.viewEnd&&A<this.viewEnd;A++)if(_.path[A]!==this.path[A])return 1;return _.viewEnd>this.viewEnd?2:_.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let _=1;_<this.viewEnd;_++)this.stringifed+="\0",this.stringifed+=this.path[_]}return this.stringifed}}e.TestId=S}),define(Ce[48],Ie([1,0,2,49,40]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var N;(function(s){s[s.Unset=0]="Unset",s[s.Queued=1]="Queued",s[s.Running=2]="Running",s[s.Passed=3]="Passed",s[s.Failed=4]="Failed",s[s.Skipped=5]="Skipped",s[s.Errored=6]="Errored"})(N=e.TestResultState||(e.TestResultState={}));var _;(function(s){s[s.Run=2]="Run",s[s.Debug=4]="Debug",s[s.Coverage=8]="Coverage",s[s.HasNonDefaultProfile=16]="HasNonDefaultProfile",s[s.HasConfigurable=32]="HasConfigurable"})(_=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var A;(function(s){s.serialize=h=>({range:h.range.toJSON(),uri:h.uri.toJSON()}),s.deserialize=h=>({range:C.Range.lift(h.range),uri:r.URI.revive(h.uri)})})(A=e.IRichLocation||(e.IRichLocation={}));var E;(function(s){s[s.Error=0]="Error",s[s.Output=1]="Output"})(E=e.TestMessageType||(e.TestMessageType={}));var P;(function(s){s.serialize=h=>({message:h.message,type:0,expected:h.expected,actual:h.actual,location:h.location&&A.serialize(h.location)}),s.deserialize=h=>({message:h.message,type:0,expected:h.expected,actual:h.actual,location:h.location&&A.deserialize(h.location)})})(P=e.ITestErrorMessage||(e.ITestErrorMessage={}));const O=(s,h)=>`${h?"s":"e"}${s}`;e.getMarkId=O;var w;(function(s){s.serialize=h=>({message:h.message,type:1,offset:h.offset,length:h.length,location:h.location&&A.serialize(h.location)}),s.deserialize=h=>({message:h.message,type:1,offset:h.offset,length:h.length,location:h.location&&A.deserialize(h.location)})})(w=e.ITestOutputMessage||(e.ITestOutputMessage={}));var g;(function(s){s.serialize=h=>h.type===0?P.serialize(h):w.serialize(h),s.deserialize=h=>h.type===0?P.deserialize(h):w.deserialize(h)})(g=e.ITestMessage||(e.ITestMessage={}));var k;(function(s){s.serializeWithoutMessages=h=>({state:h.state,duration:h.duration,messages:[]}),s.serialize=h=>({state:h.state,duration:h.duration,messages:h.messages.map(g.serialize)}),s.deserialize=h=>({state:h.state,duration:h.duration,messages:h.messages.map(g.deserialize)})})(k=e.ITestTaskState||(e.ITestTaskState={}));const m="\0",a=(s,h)=>s+m+h;e.namespaceTestTag=a;const u=s=>{const h=s.indexOf(m);return{ctrlId:s.slice(0,h),tagId:s.slice(h+1)}};e.denamespaceTestTag=u;var d;(function(s){s.serialize=h=>({extId:h.extId,label:h.label,tags:h.tags,busy:h.busy,children:void 0,uri:h.uri?.toJSON(),range:h.range?.toJSON()||null,description:h.description,error:h.error,sortText:h.sortText}),s.deserialize=h=>({extId:h.extId,label:h.label,tags:h.tags,busy:h.busy,children:void 0,uri:h.uri?r.URI.revive(h.uri):void 0,range:h.range?C.Range.lift(h.range):null,description:h.description,error:h.error,sortText:h.sortText})})(d=e.ITestItem||(e.ITestItem={}));var v;(function(s){s[s.NotExpandable=0]="NotExpandable",s[s.Expandable=1]="Expandable",s[s.BusyExpanding=2]="BusyExpanding",s[s.Expanded=3]="Expanded"})(v=e.TestItemExpandState||(e.TestItemExpandState={}));var D;(function(s){s.serialize=h=>({expand:h.expand,item:d.serialize(h.item)}),s.deserialize=h=>({controllerId:S.TestId.root(h.item.extId),expand:h.expand,item:d.deserialize(h.item)})})(D=e.InternalTestItem||(e.InternalTestItem={}));var c;(function(s){s.serialize=h=>{let p;return h.item&&(p={},h.item.label!==void 0&&(p.label=h.item.label),h.item.tags!==void 0&&(p.tags=h.item.tags),h.item.busy!==void 0&&(p.busy=h.item.busy),h.item.uri!==void 0&&(p.uri=h.item.uri?.toJSON()),h.item.range!==void 0&&(p.range=h.item.range?.toJSON()),h.item.description!==void 0&&(p.description=h.item.description),h.item.error!==void 0&&(p.error=h.item.error),h.item.sortText!==void 0&&(p.sortText=h.item.sortText)),{extId:h.extId,expand:h.expand,item:p}},s.deserialize=h=>{let p;return h.item&&(p={},h.item.label!==void 0&&(p.label=h.item.label),h.item.tags!==void 0&&(p.tags=h.item.tags),h.item.busy!==void 0&&(p.busy=h.item.busy),h.item.range!==void 0&&(p.range=h.item.range?C.Range.lift(h.item.range):null),h.item.description!==void 0&&(p.description=h.item.description),h.item.error!==void 0&&(p.error=h.item.error),h.item.sortText!==void 0&&(p.sortText=h.item.sortText)),{extId:h.extId,expand:h.expand,item:p}}})(c=e.ITestItemUpdate||(e.ITestItemUpdate={}));const b=(s,h)=>{h.expand!==void 0&&(s.expand=h.expand),h.item!==void 0&&(s.item=s.item?Object.assign(s.item,h.item):h.item)};e.applyTestItemUpdate=b;var t;(function(s){s.serializeWithoutMessages=h=>({...D.serialize(h),ownComputedState:h.ownComputedState,computedState:h.computedState,tasks:h.tasks.map(k.serializeWithoutMessages),retired:h.retired}),s.serialize=h=>({...D.serialize(h),ownComputedState:h.ownComputedState,computedState:h.computedState,tasks:h.tasks.map(k.serialize),retired:h.retired}),s.deserialize=h=>({...D.deserialize(h),ownComputedState:h.ownComputedState,computedState:h.computedState,tasks:h.tasks.map(k.deserialize),retired:!0})})(t=e.TestResultItem||(e.TestResultItem={}));var l;(function(s){s[s.Function=0]="Function",s[s.Statement=1]="Statement"})(l=e.DetailType||(e.DetailType={}));var i;(function(s){s[s.Add=0]="Add",s[s.Update=1]="Update",s[s.DocumentSynced=2]="DocumentSynced",s[s.Remove=3]="Remove",s[s.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",s[s.Retire=5]="Retire",s[s.AddTag=6]="AddTag",s[s.RemoveTag=7]="RemoveTag"})(i=e.TestDiffOpType||(e.TestDiffOpType={}));var n;(function(s){s.deserialize=h=>h.op===0?{op:h.op,item:D.deserialize(h.item)}:h.op===1?{op:h.op,item:c.deserialize(h.item)}:h.op===2?{op:h.op,uri:r.URI.revive(h.uri),docv:h.docv}:h,s.serialize=h=>h.op===0?{op:h.op,item:D.serialize(h.item)}:h.op===1?{op:h.op,item:c.serialize(h.item)}:h})(n=e.TestsDiffOp||(e.TestsDiffOp={}));class o{add(h){}update(h){}remove(h,p){}complete(){}}e.IncrementalChangeCollector=o;class f{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(h){const p=this.createChangeCollector();for(const T of h)switch(T.op){case 0:{const M=D.deserialize(T.item),V=S.TestId.parentId(M.item.extId)?.toString();if(V){if(this.items.has(V)){const U=this.items.get(V);U.children.add(M.item.extId);const y=this.createItem(M,U);this.items.set(M.item.extId,y),p.add(y)}}else{const U=this.createItem(M);this.roots.add(U),this.items.set(M.item.extId,U),p.add(U)}M.expand===2&&this.busyControllerCount++;break}case 1:{const M=c.deserialize(T.item),V=this.items.get(M.extId);if(!V)break;M.expand!==void 0&&(V.expand===2&&this.busyControllerCount--,M.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(V,M),p.update(V);break}case 3:{const M=this.items.get(T.itemId);if(!M)break;const V=S.TestId.parentId(M.item.extId)?.toString();V?this.items.get(V).children.delete(M.item.extId):this.roots.delete(M);const U=[[T.itemId]];for(;U.length;)for(const y of U.pop()){const x=this.items.get(y);x&&(U.push(x.children),this.items.delete(y),p.remove(x,x!==M),x.expand===2&&this.busyControllerCount--)}break}case 5:this.retireTest(T.itemId);break;case 4:this.updatePendingRoots(T.amount);break;case 6:this._tags.set(T.tag.id,T.tag);break;case 7:this._tags.delete(T.id);break}p.complete()}retireTest(h){}updatePendingRoots(h){this.pendingRootCount+=h}createChangeCollector(){return new o}}e.AbstractIncrementalTestCollection=f}),define(Ce[65],Ie([1,0,15,5,7,45,48,40]),function(ie,e,r,C,S,N,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var E;(function(d){d[d.Upsert=0]="Upsert",d[d.SetTags=1]="SetTags",d[d.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",d[d.RemoveChild=3]="RemoveChild",d[d.SetProp=4]="SetProp",d[d.Bulk=5]="Bulk",d[d.DocumentSynced=6]="DocumentSynced"})(E=e.TestItemEventOp||(e.TestItemEventOp={}));const P=(d,v)=>d===v,O={range:(d,v)=>d===v?!0:!d||!v?!1:d.equalsRange(v),busy:P,label:P,description:P,error:P,tags:(d,v)=>!(d.length!==v.length||d.some(D=>!v.includes(D)))},w=(d,v)=>{let D;for(const[c,b]of Object.entries(O))b(d[c],v[c])||(D?D[c]=v[c]:D={[c]:v[c]});return D};class g extends S.Disposable{get root(){return this.options.root}constructor(v){super(),this.options=v,this.debounceSendDiff=this._register(new r.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new C.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(v){this._resolveHandler=v;for(const D of this.tree.values())this.updateExpandability(D)}collectDiff(){const v=this.diff;return this.diff=[],v}pushDiff(v){switch(v.op){case 2:{for(const D of this.diff)if(D.op===2&&D.uri===v.uri){D.docv=v.docv;return}break}case 1:{const D=this.diff[this.diff.length-1];if(D){if(D.op===1&&D.item.extId===v.item.extId){(0,_.applyTestItemUpdate)(D.item,v.item);return}if(D.op===0&&D.item.item.extId===v.item.extId){(0,_.applyTestItemUpdate)(D.item,v.item);return}}break}}this.diff.push(v),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(v,D){const c=this.tree.get(v);if(!!c){if((c.expandLevels===void 0||D>c.expandLevels)&&(c.expandLevels=D),c.expand===1){const b=this.resolveChildren(c);return b.isOpen()?this.expandChildren(c,D-1):b.wait().then(()=>this.expandChildren(c,D-1))}else if(c.expand===3)return c.resolveBarrier?.isOpen()===!1?c.resolveBarrier.wait().then(()=>this.expandChildren(c,D-1)):this.expandChildren(c,D-1)}}dispose(){for(const v of this.tree.values())this.options.getApiFor(v.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(v,D){switch(D.op){case 3:this.removeItem(A.TestId.joinToString(v.fullId,D.id));break;case 0:this.upsertItem(D.item,v);break;case 5:for(const c of D.ops)this.onTestItemEvent(v,c);break;case 1:this.diffTagRefs(D.new,D.old,v.fullId.toString());break;case 2:this.updateExpandability(v);break;case 4:this.pushDiff({op:1,item:{extId:v.fullId.toString(),item:D.update}});break;case 6:this.documentSynced(v.actual.uri);break;default:(0,N.assertNever)(D)}}documentSynced(v){v&&this.pushDiff({op:2,uri:v,docv:this.options.getDocumentVersion(v)})}upsertItem(v,D){const c=A.TestId.fromExtHostTestItem(v,this.root.id,D?.actual),b=this.options.getApiFor(v);b.parent&&b.parent!==D?.actual&&this.options.getChildren(b.parent).delete(v.id);let t=this.tree.get(c.toString());if(!t){t={fullId:c,actual:v,expandLevels:D?.expandLevels?D.expandLevels-1:void 0,expand:0},v.tags.forEach(this.incrementTagRefs,this),this.tree.set(t.fullId.toString(),t),this.setItemParent(v,D),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:t.expand,item:this.options.toITestItem(v)}}),this.connectItemAndChildren(v,t,D);return}if(t.actual===v){this.connectItem(v,t,D);return}const l=this.options.getChildren(t.actual),i=t.actual,n=w(this.options.toITestItem(i),this.options.toITestItem(v));this.options.getApiFor(i).listener=void 0,t.actual=v,t.expand=0,n&&(n.hasOwnProperty("tags")&&(this.diffTagRefs(v.tags,i.tags,c.toString()),delete n.tags),this.onTestItemEvent(t,{op:4,update:n})),this.connectItemAndChildren(v,t,D);for(const[o,f]of l)this.options.getChildren(v).get(f.id)||this.removeItem(A.TestId.joinToString(c,f.id));this.documentSynced(t.actual.uri)}diffTagRefs(v,D,c){const b=new Set(D.map(t=>t.id));for(const t of v)b.delete(t.id)||this.incrementTagRefs(t);this.pushDiff({op:1,item:{extId:c,item:{tags:v.map(t=>(0,_.namespaceTestTag)(this.options.controllerId,t.id))}}}),b.forEach(this.decrementTagRefs,this)}incrementTagRefs(v){const D=this.tags.get(v.id);D?D.refCount++:(this.tags.set(v.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,_.namespaceTestTag)(this.options.controllerId,v.id)}}))}decrementTagRefs(v){const D=this.tags.get(v);D&&!--D.refCount&&(this.tags.delete(v),this.pushDiff({op:7,id:(0,_.namespaceTestTag)(this.options.controllerId,v)}))}setItemParent(v,D){this.options.getApiFor(v).parent=D&&D.actual!==this.root?D.actual:void 0}connectItem(v,D,c){this.setItemParent(v,c);const b=this.options.getApiFor(v);b.parent=c?.actual,b.listener=t=>this.onTestItemEvent(D,t),this.updateExpandability(D)}connectItemAndChildren(v,D,c){this.connectItem(v,D,c);for(const[b,t]of this.options.getChildren(v))this.upsertItem(t,D)}updateExpandability(v){let D;this._resolveHandler?v.resolveBarrier?D=v.resolveBarrier.isOpen()?3:2:D=v.actual.canResolveChildren?1:0:D=0,D!==v.expand&&(v.expand=D,this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:D}}),D===1&&v.expandLevels!==void 0&&this.resolveChildren(v))}expandChildren(v,D){if(D<0)return;const c=[];for(const[b,t]of this.options.getChildren(v.actual)){const l=this.expand(A.TestId.joinToString(v.fullId,t.id),D);(0,r.isThenable)(l)&&c.push(l)}if(c.length)return Promise.all(c).then(()=>{})}resolveChildren(v){if(v.resolveBarrier)return v.resolveBarrier;if(!this._resolveHandler){const t=new r.Barrier;return t.open(),t}v.expand=2,this.pushExpandStateUpdate(v);const D=v.resolveBarrier=new r.Barrier,c=t=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,t)};let b;try{b=this._resolveHandler(v.actual===this.root?void 0:v.actual)}catch(t){c(t)}return(0,r.isThenable)(b)?b.catch(c).then(()=>{D.open(),this.updateExpandability(v)}):(D.open(),this.updateExpandability(v)),v.resolveBarrier}pushExpandStateUpdate(v){this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:v.expand}})}removeItem(v){const D=this.tree.get(v);if(!D)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:v});const c=[D];for(;c.length;){const b=c.pop();if(!!b){this.options.getApiFor(b.actual).listener=void 0;for(const t of b.actual.tags)this.decrementTagRefs(t.id);this.tree.delete(b.fullId.toString());for(const[t,l]of this.options.getChildren(b.actual))c.push(this.tree.get(A.TestId.joinToString(b.fullId,l.id)))}}}flushDiff(){const v=this.collectDiff();v.length&&this.diffOpEmitter.fire(v)}}e.TestItemCollection=g;class k extends Error{constructor(v){super(`Attempted to insert a duplicate test item ID ${v}`)}}e.DuplicateTestItemError=k;class m extends Error{constructor(v){super(`TestItem with ID "${v}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=m;class a extends Error{constructor(v,D,c){super(`TestItem with ID "${v}" is from controller "${D}" and cannot be added as a child of an item from controller "${c}".`)}}e.MixedTestItemController=a;const u=(d,v,D)=>{let c=new Map;return{get size(){return c.size},forEach(b,t){for(const l of c.values())b.call(t,l,this)},[Symbol.iterator](){return c.entries()},replace(b){const t=new Map,l=new Set(c.keys()),i={op:5,ops:[]};for(const n of b){if(!(n instanceof D))throw new m(n.id);const o=v(n).controllerId;if(o!==d.controllerId)throw new a(n.id,o,d.controllerId);if(t.has(n.id))throw new k(n.id);t.set(n.id,n),l.delete(n.id),i.ops.push({op:0,item:n})}for(const n of l.keys())i.ops.push({op:3,id:n});d.listener?.(i),c=t},add(b){if(!(b instanceof D))throw new m(b.id);c.set(b.id,b),d.listener?.({op:0,item:b})},delete(b){c.delete(b)&&d.listener?.({op:3,id:b})},get(b){return c.get(b)},toJSON(){return Array.from(c.values())}}};e.createTestItemChildren=u}),define(Ce[90],Ie([1,0,65]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const C=new WeakMap,S=(_,A)=>{const E={controllerId:A};return C.set(_,E),E};e.createPrivateApiFor=S;const N=_=>{const A=C.get(_);if(!A)throw new r.InvalidTestItemError(_?.id||"<unknown>");return A};e.getPrivateApiFor=N}),define(Ce[169],Ie([1,0,3]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,r.createDecorator)("configurationResolverService");var C;(function(N){N.Unknown="unknown",N.Env="env",N.Config="config",N.Command="command",N.Input="input",N.ExtensionInstallFolder="extensionInstallFolder",N.WorkspaceFolder="workspaceFolder",N.Cwd="cwd",N.WorkspaceFolderBasename="workspaceFolderBasename",N.UserHome="userHome",N.LineNumber="lineNumber",N.SelectedText="selectedText",N.File="file",N.FileWorkspaceFolder="fileWorkspaceFolder",N.RelativeFile="relativeFile",N.RelativeFileDirname="relativeFileDirname",N.FileDirname="fileDirname",N.FileExtname="fileExtname",N.FileBasename="fileBasename",N.FileBasenameNoExtension="fileBasenameNoExtension",N.FileDirnameBasename="fileDirnameBasename",N.ExecPath="execPath",N.ExecInstallFolder="execInstallFolder",N.PathSeparator="pathSeparator"})(C=e.VariableKind||(e.VariableKind={}));class S extends Error{constructor(_,A){super(A),this.variable=_}}e.VariableError=S}),define(Ce[170],Ie([1,0,19,59,10,25,21,78,142,169,9]),function(ie,e,r,C,S,N,_,A,E,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class w{constructor(k,m,a,u){this._contributedVariables=new Map,this._context=k,this._labelService=m,this._userHomePromise=a,u&&(this._envVariablesPromise=u.then(d=>this.prepareEnv(d)))}prepareEnv(k){if(_.isWindows){const m=Object.create(null);return Object.keys(k).forEach(a=>{m[a.toLowerCase()]=k[a]}),m}return k}resolveWithEnvironment(k,m,a){return this.recursiveResolve({env:this.prepareEnv(k),userHome:void 0},m?m.uri:void 0,a)}async resolveAsync(k,m){const a={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(a,k?k.uri:void 0,m)}async resolveAnyBase(k,m,a,u){const d=N.deepClone(m);_.isWindows&&d.windows?Object.keys(d.windows).forEach(D=>d[D]=d.windows[D]):_.isMacintosh&&d.osx?Object.keys(d.osx).forEach(D=>d[D]=d.osx[D]):_.isLinux&&d.linux&&Object.keys(d.linux).forEach(D=>d[D]=d.linux[D]),delete d.windows,delete d.osx,delete d.linux;const v={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(v,k?k.uri:void 0,d,a,u)}async resolveAnyAsync(k,m,a){return this.resolveAnyBase(k,m,a)}async resolveAnyMap(k,m,a){const u=new Map;return{newConfig:await this.resolveAnyBase(k,m,a,u),resolvedVariables:u}}resolveWithInteractionReplace(k,m,a,u){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,m,a,u){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,m){if(this._contributedVariables.has(k))throw new Error("Variable "+k+" is contributed twice.");this._contributedVariables.set(k,m)}async recursiveResolve(k,m,a,u,d){if(S.isString(a))return this.resolveString(k,m,a,u,d);if(Array.isArray(a))return Promise.all(a.map(v=>this.recursiveResolve(k,m,v,u,d)));if(S.isObject(a)){const v=Object.create(null),D=await Promise.all(Object.keys(a).map(async c=>[await this.resolveString(k,m,c,u,d),await this.recursiveResolve(k,m,a[c],u,d)]));for(const[c,b]of D)v[c]=b;return v}return a}resolveString(k,m,a,u,d){return(0,O.replaceAsync)(a,w.VARIABLE_REGEXP,async(v,D)=>{if(D.includes(w.VARIABLE_LHS))return v;let c=await this.evaluateSingleVariable(k,v,D,m,u);return d?.set(D,c),c!==v&&S.isString(c)&&c.match(w.VARIABLE_REGEXP)&&(c=await this.resolveString(k,m,c,u,d)),c})}fsPath(k){return this._labelService?this._labelService.getUriLabel(k,{noPrefix:!0}):k.fsPath}async evaluateSingleVariable(k,m,a,u,d){let v;const D=a.split(":");D.length>1&&(a=D[0],v=D[1]);const c=l=>{const i=this._context.getFilePath();if(i)return i;throw new P.VariableError(l,(0,E.localize)(0,null,m))},b=l=>{const i=c(l);if(this._context.getWorkspaceFolderPathForFile){const n=this._context.getWorkspaceFolderPathForFile();if(n)return n}throw new P.VariableError(l,(0,E.localize)(1,null,m,r.basename(i)))},t=l=>{if(v){const i=this._context.getFolderUri(v);if(i)return i;throw new P.VariableError(l,(0,E.localize)(2,null,m,v))}if(u)return u;throw this._context.getWorkspaceFolderCount()>1?new P.VariableError(l,(0,E.localize)(3,null,m)):new P.VariableError(l,(0,E.localize)(4,null,m))};switch(a){case"env":if(v){if(k.env){const l=k.env[_.isWindows?v.toLowerCase():v];if(S.isString(l))return l}return""}throw new P.VariableError(P.VariableKind.Env,(0,E.localize)(5,null,m));case"config":if(v){const l=this._context.getConfigurationValue(u,v);if(S.isUndefinedOrNull(l))throw new P.VariableError(P.VariableKind.Config,(0,E.localize)(6,null,m,v));if(S.isObject(l))throw new P.VariableError(P.VariableKind.Config,(0,E.localize)(7,null,m,v));return l}throw new P.VariableError(P.VariableKind.Config,(0,E.localize)(8,null,m));case"command":return this.resolveFromMap(P.VariableKind.Command,m,v,d,"command");case"input":return this.resolveFromMap(P.VariableKind.Input,m,v,d,"input");case"extensionInstallFolder":if(v){const l=await this._context.getExtension(v);if(!l)throw new P.VariableError(P.VariableKind.ExtensionInstallFolder,(0,E.localize)(9,null,m,v));return this.fsPath(l.extensionLocation)}throw new P.VariableError(P.VariableKind.ExtensionInstallFolder,(0,E.localize)(10,null,m));default:switch(a){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.fsPath(t(P.VariableKind.WorkspaceFolder)));case"cwd":return u||v?(0,A.normalizeDriveLetter)(this.fsPath(t(P.VariableKind.Cwd))):C.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return r.basename(this.fsPath(t(P.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(k.userHome)return k.userHome;throw new P.VariableError(P.VariableKind.UserHome,(0,E.localize)(11,null,m))}case"lineNumber":{const l=this._context.getLineNumber();if(l)return l;throw new P.VariableError(P.VariableKind.LineNumber,(0,E.localize)(12,null,m))}case"selectedText":{const l=this._context.getSelectedText();if(l)return l;throw new P.VariableError(P.VariableKind.SelectedText,(0,E.localize)(13,null,m))}case"file":return c(P.VariableKind.File);case"fileWorkspaceFolder":return b(P.VariableKind.FileWorkspaceFolder);case"relativeFile":return u||v?r.relative(this.fsPath(t(P.VariableKind.RelativeFile)),c(P.VariableKind.RelativeFile)):c(P.VariableKind.RelativeFile);case"relativeFileDirname":{const l=r.dirname(c(P.VariableKind.RelativeFileDirname));if(u||v){const i=r.relative(this.fsPath(t(P.VariableKind.RelativeFileDirname)),l);return i.length===0?".":i}return l}case"fileDirname":return r.dirname(c(P.VariableKind.FileDirname));case"fileExtname":return r.extname(c(P.VariableKind.FileExtname));case"fileBasename":return r.basename(c(P.VariableKind.FileBasename));case"fileBasenameNoExtension":{const l=r.basename(c(P.VariableKind.FileBasenameNoExtension));return l.slice(0,l.length-r.extname(l).length)}case"fileDirnameBasename":return r.basename(r.dirname(c(P.VariableKind.FileDirnameBasename)));case"execPath":{const l=this._context.getExecPath();return l||m}case"execInstallFolder":{const l=this._context.getAppRoot();return l||m}case"pathSeparator":return r.sep;default:try{const l=v?`${a}:${v}`:a;return this.resolveFromMap(P.VariableKind.Unknown,m,l,d,void 0)}catch{return m}}}}resolveFromMap(k,m,a,u,d){if(a&&u){const v=d===void 0?u[a]:u[d+":"+a];if(typeof v=="string")return v;throw new P.VariableError(k,(0,E.localize)(14,null,m))}return m}}e.AbstractVariableResolverService=w,w.VARIABLE_LHS="${",w.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ce[91],Ie([1,0,3,89]),function(ie,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,r.createDecorator)("editorGroupsService");var S;(function(m){m[m.UP=0]="UP",m[m.DOWN=1]="DOWN",m[m.LEFT=2]="LEFT",m[m.RIGHT=3]="RIGHT"})(S=e.GroupDirection||(e.GroupDirection={}));var N;(function(m){m[m.HORIZONTAL=0]="HORIZONTAL",m[m.VERTICAL=1]="VERTICAL"})(N=e.GroupOrientation||(e.GroupOrientation={}));var _;(function(m){m[m.FIRST=0]="FIRST",m[m.LAST=1]="LAST",m[m.NEXT=2]="NEXT",m[m.PREVIOUS=3]="PREVIOUS"})(_=e.GroupLocation||(e.GroupLocation={}));var A;(function(m){m[m.MAXIMIZE=0]="MAXIMIZE",m[m.EVEN=1]="EVEN",m[m.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var E;(function(m){m[m.COPY_EDITORS=0]="COPY_EDITORS",m[m.MOVE_EDITORS=1]="MOVE_EDITORS"})(E=e.MergeGroupMode||(e.MergeGroupMode={}));function P(m){const a=m;return(0,C.isEditorInput)(a?.editor)&&(0,C.isEditorInput)(a?.replacement)}e.isEditorReplacement=P;var O;(function(m){m[m.CREATION_TIME=0]="CREATION_TIME",m[m.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",m[m.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(O=e.GroupsOrder||(e.GroupsOrder={}));var w;(function(m){m[m.NEW_EDITOR=1]="NEW_EDITOR",m[m.MOVE_EDITOR=2]="MOVE_EDITOR",m[m.COPY_EDITOR=3]="COPY_EDITOR"})(w=e.OpenEditorContext||(e.OpenEditorContext={}));function g(m){const a=m;return!!a&&typeof a.id=="number"&&Array.isArray(a.editors)}e.isEditorGroup=g;function k(m){return m.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=k}),define(Ce[171],Ie([1,0,3,91]),function(ie,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,r.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function S(N){const _=N;return typeof N=="number"||(0,C.isEditorGroup)(_)}e.isPreferredGroup=S}),define(Ce[172],Ie([1,0,3,147]),function(ie,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,r.refineServiceDecorator)(C.IEnvironmentService)}),define(Ce[173],Ie([1,0,26,5,19]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class N{constructor(w){this.removedDueToLooping=w}}e.DeltaExtensionsResult=N;class _{constructor(w){this._onDidChange=new C.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=w,this._initialize()}_initialize(){this._extensionDescriptions.sort(E),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const w of this._extensionDescriptions){if(this._extensionsMap.has(r.ExtensionIdentifier.toKey(w.identifier))){console.error("Extension `"+w.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(r.ExtensionIdentifier.toKey(w.identifier),w),this._extensionsArr.push(w),Array.isArray(w.activationEvents))for(let g of w.activationEvents)g==="onUri"&&(g=`onUri:${r.ExtensionIdentifier.toKey(w.identifier)}`),this._activationMap.has(g)||this._activationMap.set(g,[]),this._activationMap.get(g).push(w)}}set(w){this._extensionDescriptions=w,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(w,g){this._extensionDescriptions=P(this._extensionDescriptions,g),this._extensionDescriptions=this._extensionDescriptions.concat(w);const k=_._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=P(this._extensionDescriptions,k.map(m=>m.identifier)),this._initialize(),this._onDidChange.fire(void 0),new N(k)}static _findLoopingExtensions(w){const g=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(d){this._nodesSet.has(d)||(this._nodesSet.add(d),this._nodesArr.push(d))}addArc(d,v){this.addNode(d),this.addNode(v),this._arcs.has(d)?this._arcs.get(d).push(v):this._arcs.set(d,[v])}getArcs(d){return this._arcs.has(d)?this._arcs.get(d):[]}hasOnlyGoodArcs(d,v){const D=g.getArcs(d);for(let c=0;c<D.length;c++)if(!v.has(D[c]))return!1;return!0}getNodes(){return this._nodesArr}},k=new Map;for(const d of w){const v=r.ExtensionIdentifier.toKey(d.identifier);if(k.set(v,d),d.extensionDependencies)for(const D of d.extensionDependencies){const c=r.ExtensionIdentifier.toKey(D);g.addArc(v,c)}}const m=new Set;g.getNodes().filter(d=>g.getArcs(d).length===0).forEach(d=>m.add(d));const a=g.getNodes().filter(d=>!m.has(d));let u;do{u=!1;for(let d=0;d<a.length;d++){const v=a[d];g.hasOnlyGoodArcs(v,m)&&(a.splice(d,1),d--,m.add(v),u=!0)}}while(u);return a.map(d=>k.get(d))}containsActivationEvent(w){return this._activationMap.has(w)}containsExtension(w){return this._extensionsMap.has(r.ExtensionIdentifier.toKey(w))}getExtensionDescriptionsForActivationEvent(w){const g=this._activationMap.get(w);return g?g.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(w){const g=this._extensionsMap.get(r.ExtensionIdentifier.toKey(w));return g||void 0}getExtensionDescriptionByUUID(w){for(const g of this._extensionsArr)if(g.uuid===w)return g}getExtensionDescriptionByIdOrUUID(w,g){return this.getExtensionDescription(w)??(g?this.getExtensionDescriptionByUUID(g):void 0)}}e.ExtensionDescriptionRegistry=_;var A;(function(O){O[O.Builtin=0]="Builtin",O[O.User=1]="User",O[O.Dev=2]="Dev"})(A||(A={}));function E(O,w){const g=O.isBuiltin?0:O.isUnderDevelopment?2:1,k=w.isBuiltin?0:w.isUnderDevelopment?2:1;if(g!==k)return g-k;const m=S.posix.basename(O.extensionLocation.path),a=S.posix.basename(w.extensionLocation.path);return m<a?-1:m>a?1:0}function P(O,w){const g=new Set;return w.forEach(k=>g.add(r.ExtensionIdentifier.toKey(k))),O.filter(k=>!g.has(r.ExtensionIdentifier.toKey(k.identifier)))}}),define(Ce[92],Ie([1,0,23]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var C;(function(P){P[P.Desktop=1]="Desktop",P[P.Web=2]="Web"})(C=e.UIKind||(e.UIKind={}));var S;(function(P){P[P.VersionMismatch=55]="VersionMismatch",P[P.UnexpectedError=81]="UnexpectedError"})(S=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var N;(function(P){P[P.Initialized=0]="Initialized",P[P.Ready=1]="Ready",P[P.Terminate=2]="Terminate"})(N=e.MessageType||(e.MessageType={}));function _(P){const O=r.VSBuffer.alloc(1);switch(P){case 0:O.writeUInt8(1,0);break;case 1:O.writeUInt8(2,0);break;case 2:O.writeUInt8(3,0);break}return O}e.createMessageOfType=_;function A(P,O){if(P.byteLength!==1)return!1;switch(P.readUInt8(0)){case 1:return O===0;case 2:return O===1;case 3:return O===2;default:return!1}}e.isMessageOfType=A;var E;(function(P){P.Start="START_NATIVE_LOG",P.End="END_NATIVE_LOG"})(E=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Ce[28],Ie([1,0,5,2,3,26,153]),function(ie,e,r,C,S,N,_){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new N.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:C.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,S.createDecorator)("extensionService");class E{constructor(f){this.affinity=f,this.kind=1}equals(f){return this.kind===f.kind&&this.affinity===f.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=E;class P{constructor(){this.kind=2,this.affinity=0}equals(f){return this.kind===f.kind}asString(){return"LocalWebWorker"}}e.LocalWebWorkerRunningLocation=P;class O{constructor(){this.kind=3,this.affinity=0}equals(f){return this.kind===f.kind}asString(){return"Remote"}}e.RemoteRunningLocation=O;class w{constructor(f){this.dependency=f}}e.MissingExtensionDependency=w;var g;(function(o){o[o.LocalProcess=1]="LocalProcess",o[o.LocalWebWorker=2]="LocalWebWorker",o[o.Remote=3]="Remote"})(g=e.ExtensionHostKind||(e.ExtensionHostKind={}));function k(o){if(o===null)return"None";switch(o){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=k;class m{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(f,s){const h=[],p=[],T=[],M=[],V=d(this._allExtensions),U=d(f),y=(K,W)=>K.extensionLocation.toString()===W.extensionLocation.toString()||K.isBuiltin===W.isBuiltin||K.isUserBuiltin===W.isUserBuiltin||K.isUnderDevelopment===W.isUnderDevelopment;for(const K of this._allExtensions){const W=U.get(N.ExtensionIdentifier.toKey(K.identifier));if(!W){h.push(K.identifier),V.delete(N.ExtensionIdentifier.toKey(K.identifier));continue}if(!y(K,W)){h.push(K.identifier),V.delete(N.ExtensionIdentifier.toKey(K.identifier));continue}}for(const K of f){const W=V.get(N.ExtensionIdentifier.toKey(K.identifier));if(!W){p.push(K);continue}if(!y(W,K)){h.push(W.identifier),V.delete(N.ExtensionIdentifier.toKey(W.identifier));continue}}const x=u(this._myExtensions),L=u(s);for(const K of this._myExtensions)L.has(N.ExtensionIdentifier.toKey(K))||T.push(K);for(const K of s)x.has(N.ExtensionIdentifier.toKey(K))||M.push(K);const R={toRemove:h,toAdd:p,myToRemove:T,myToAdd:M};return this.delta(R),R}delta(f){const{toRemove:s,toAdd:h,myToRemove:p,myToAdd:T}=f,M=u(s),V=u(p);for(let U=0;U<this._allExtensions.length;U++)M.has(N.ExtensionIdentifier.toKey(this._allExtensions[U].identifier))&&(this._allExtensions.splice(U,1),U--);for(let U=0;U<this._myExtensions.length;U++)V.has(N.ExtensionIdentifier.toKey(this._myExtensions[U]))&&(this._myExtensions.splice(U,1),U--);for(const U of h)this._allExtensions.push(U);for(const U of T)this._myExtensions.push(U)}containsExtension(f){for(const s of this._myExtensions)if(N.ExtensionIdentifier.equals(s,f))return!0;return!1}}e.ExtensionHostExtensions=m;class a{constructor(f){if(this[A]="ExtensionIdentifierSet",this._map=new Map,this._toKey=N.ExtensionIdentifier.toKey,f)for(const s of f)this.add(s)}get size(){return this._map.size}add(f){return this._map.set(this._toKey(f),f),this}clear(){this._map.clear()}delete(f){return this._map.delete(this._toKey(f))}has(f){return this._map.has(this._toKey(f))}forEach(f,s){this._map.forEach(h=>f.call(s,h,h,this))}*entries(){for(const[f,s]of this._map)yield[s,s]}keys(){return this._map.values()}values(){return this._map.values()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=a;function u(o){const f=new Set;for(const s of o)f.add(N.ExtensionIdentifier.toKey(s));return f}e.extensionIdentifiersArrayToSet=u;function d(o){const f=new Map;for(const s of o)f.set(N.ExtensionIdentifier.toKey(s.identifier),s);return f}function v(o,f){return o.enabledApiProposals?o.enabledApiProposals.includes(f):!1}e.isProposedApiEnabled=v;function D(o,f){if(!v(o,f))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${f}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${f}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.checkProposedApiEnabled=D;class c{constructor(f,s,h,p){this.codeLoadingTime=f,this.activateCallTime=s,this.activateResolvedTime=h,this.activationReason=p}}e.ActivationTimes=c;class b{constructor(f,s){this.description=f,this.value=s}}e.ExtensionPointContribution=b,e.ExtensionHostLogFileName="exthost";var t;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(t=e.ActivationKind||(e.ActivationKind={}));function l(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,_.getGalleryExtensionId)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}e.toExtension=l;function i(o,f){return{identifier:new N.ExtensionIdentifier((0,_.getExtensionId)(o.manifest.publisher,o.manifest.name)),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!f,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform,browserNlsBundleUris:o.browserNlsBundleUris}}e.toExtensionDescription=i;class n{constructor(){this.onDidRegisterExtensions=r.Event.None,this.onDidChangeExtensionsStatus=r.Event.None,this.onDidChangeExtensions=r.Event.None,this.onWillActivateByEvent=r.Event.None,this.onDidChangeResponsiveChange=r.Event.None,this.extensions=[]}activateByEvent(f){return Promise.resolve(void 0)}activationEventIsDone(f){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(f){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(f,s){return Promise.resolve(0)}getInspectPorts(f,s){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(f){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(f,s){return Promise.resolve()}}e.NullExtensionService=n}),define(Ce[174],Ie([1,0,12,26,28,14,15]),function(ie,e,r,C,S,N,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class A{constructor(u,d,v,D){this.startup=u,this.codeLoadingTime=d,this.activateCallTime=v,this.activateResolvedTime=D}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class E{constructor(u){this._startup=u,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(u,d){return u===-1||d===-1?-1:d-u}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=E;class P{constructor(u,d,v,D,c,b){this.activationFailed=u,this.activationFailedError=d,this.activationTimes=v,this.module=D,this.exports=c,this.subscriptions=b}}e.ActivatedExtension=P;class O extends P{constructor(u){super(!1,null,u,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=O;class w extends P{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=w;class g extends P{constructor(u){super(!0,u,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=g;let k=class{constructor(u,d,v,D,c){this._logService=c,this._registry=u,this._resolvedExtensionsSet=new Set,d.forEach(b=>this._resolvedExtensionsSet.add(C.ExtensionIdentifier.toKey(b))),this._externalExtensionsMap=new Map,v.forEach(b=>this._externalExtensionsMap.set(C.ExtensionIdentifier.toKey(b),b)),this._host=D,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[u,d]of this._operations)d.dispose()}isActivated(u){const d=this._operations.get(C.ExtensionIdentifier.toKey(u));return Boolean(d&&d.value)}getActivatedExtension(u){const d=this._operations.get(C.ExtensionIdentifier.toKey(u));if(!d||!d.value)throw new Error(`Extension '${u.value}' is not known or not activated`);return d.value}async activateByEvent(u,d){if(this._alreadyActivatedEvents[u])return;const v=this._registry.getExtensionDescriptionsForActivationEvent(u);await this._activateExtensions(v.map(D=>({id:D.identifier,reason:{startup:d,extensionId:D.identifier,activationEvent:u}}))),this._alreadyActivatedEvents[u]=!0}activateById(u,d){const v=this._registry.getExtensionDescription(u);if(!v)throw new Error(`Extension '${u}' is not known`);return this._activateExtensions([{id:v.identifier,reason:d}])}async _activateExtensions(u){const d=u.filter(v=>!this.isActivated(v.id)).map(v=>this._handleActivationRequest(v));await Promise.all(d.map(v=>v.wait()))}_handleActivationRequest(u){if(this._operations.has(C.ExtensionIdentifier.toKey(u.id)))return this._operations.get(C.ExtensionIdentifier.toKey(u.id));if(this._externalExtensionsMap.has(C.ExtensionIdentifier.toKey(u.id)))return this._createAndSaveOperation(u,null,[],null);const d=this._registry.getExtensionDescription(u.id);if(!d){const c=new Error(`Cannot activate unknown extension '${u.id.value}'`),b=this._createAndSaveOperation(u,null,[],new g(c));return this._host.onExtensionActivationError(u.id,c,new S.MissingExtensionDependency(u.id.value)),b}const v=[],D=typeof d.extensionDependencies>"u"?[]:d.extensionDependencies;for(const c of D){if(this._resolvedExtensionsSet.has(C.ExtensionIdentifier.toKey(c)))continue;const b=this._operations.get(C.ExtensionIdentifier.toKey(c));if(b){v.push(b);continue}if(this._externalExtensionsMap.has(C.ExtensionIdentifier.toKey(c))){v.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(C.ExtensionIdentifier.toKey(c)),reason:u.reason}));continue}const t=this._registry.getExtensionDescription(c);if(t){if(!t.main&&!t.browser)continue;v.push(this._handleActivationRequest({id:t.identifier,reason:u.reason}));continue}const l=d.displayName||d.identifier.value,i=new Error(`Cannot activate the '${l}' extension because it depends on unknown extension '${c}'`),n=this._createAndSaveOperation(u,d.displayName,[],new g(i));return this._host.onExtensionActivationError(d.identifier,i,new S.MissingExtensionDependency(c)),n}return this._createAndSaveOperation(u,d.displayName,v,null)}_createAndSaveOperation(u,d,v,D){const c=new m(u.id,d,u.reason,v,D,this._host,this._logService);return this._operations.set(C.ExtensionIdentifier.toKey(u.id),c),c}};k=ze([$e(4,N.ILogService)],k),e.ExtensionsActivator=k;let m=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(u,d,v,D,c,b,t){this._id=u,this._displayName=d,this._reason=v,this._deps=D,this._value=c,this._host=b,this._logService=t,this._barrier=new _.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let u=0;u<this._deps.length;u++){const d=this._deps[u];if(d.value&&!d.value.activationFailed){this._deps.splice(u,1),u--;continue}if(d.value&&d.value.activationFailed){const v=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${d.friendlyName}' failed to activate`);v.detail=d.value.activationFailedError,this._value=new g(v),this._host.onExtensionActivationError(this._id,v,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(u=>u.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(u){const d=new Error;if(u&&u.name&&(d.name=u.name),u&&u.message?d.message=`Activating extension '${this._id.value}' failed: ${u.message}.`:d.message=`Activating extension '${this._id.value}' failed: ${u}.`,u&&u.stack&&(d.stack=u.stack),this._value=new g(d),this._isDisposed&&r.isCancellationError(u))return;this._host.onExtensionActivationError(this._id,d,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(u)}}};m=ze([$e(6,N.ILogService)],m)}),define(Ce[175],Ie([1,0,14,27,28]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let N=class extends r.LogService{constructor(A,E){super(A.createLogger(E.logFile,{name:S.ExtensionHostLogFileName}))}};N=ze([$e(0,r.ILoggerService),$e(1,C.IExtHostInitDataService)],N),e.ExtHostLogService=N});var Je=this&&this.__classPrivateFieldSet||function(ie,e,r,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ie,r):S?S.value=r:e.set(ie,r),r},Oe=this&&this.__classPrivateFieldGet||function(ie,e,r,C){if(r==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!C:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?C:r==="a"?C.call(ie):C?C.value:e.get(ie)};define(Ce[6],Ie([1,0,18,12,77,24,75,9,10,2,43,35,86,64,28]),function(ie,e,r,C,S,N,_,A,E,P,O,w,g,k,m){"use strict";var a,u,d,v,D,c,b,t,l,i,n,o,f,s,h,p,T,M,V,U,y,x,L;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function R(z){return Object.assign(z,{apply:function(){const te=arguments.length===1?[]:arguments[1];return Reflect.construct(z,te,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(z,[]);{const[te,...we]=arguments;return Reflect.construct(z,we,te.constructor)}}})}let K=c=class{static from(...F){let te=F;return new c(function(){if(te){for(const we of te)we&&typeof we.dispose=="function"&&we.dispose();te=void 0}})}constructor(F){a.set(this,void 0),Je(this,a,F,"f")}dispose(){typeof Oe(this,a,"f")=="function"&&(Oe(this,a,"f").call(this),Je(this,a,void 0,"f"))}};a=new WeakMap,K=c=ze([R],K),e.Disposable=K;let W=b=class{static Min(...F){if(F.length===0)throw new TypeError;let te=F[0];for(let we=1;we<F.length;we++){const He=F[we];He.isBefore(te)&&(te=He)}return te}static Max(...F){if(F.length===0)throw new TypeError;let te=F[0];for(let we=1;we<F.length;we++){const He=F[we];He.isAfter(te)&&(te=He)}return te}static isPosition(F){if(!F)return!1;if(F instanceof b)return!0;const{line:te,character:we}=F;return typeof te=="number"&&typeof we=="number"}static of(F){if(F instanceof b)return F;if(this.isPosition(F))return new b(F.line,F.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(F,te){if(F<0)throw(0,C.illegalArgument)("line must be non-negative");if(te<0)throw(0,C.illegalArgument)("character must be non-negative");this._line=F,this._character=te}isBefore(F){return this._line<F._line?!0:F._line<this._line?!1:this._character<F._character}isBeforeOrEqual(F){return this._line<F._line?!0:F._line<this._line?!1:this._character<=F._character}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this._line===F._line&&this._character===F._character}compareTo(F){return this._line<F._line?-1:this._line>F.line?1:this._character<F._character?-1:this._character>F._character?1:0}translate(F,te=0){if(F===null||te===null)throw(0,C.illegalArgument)();let we;return typeof F>"u"?we=0:typeof F=="number"?we=F:(we=typeof F.lineDelta=="number"?F.lineDelta:0,te=typeof F.characterDelta=="number"?F.characterDelta:0),we===0&&te===0?this:new b(this.line+we,this.character+te)}with(F,te=this.character){if(F===null||te===null)throw(0,C.illegalArgument)();let we;return typeof F>"u"?we=this.line:typeof F=="number"?we=F:(we=typeof F.line=="number"?F.line:this.line,te=typeof F.character=="number"?F.character:this.character),we===this.line&&te===this.character?this:new b(we,te)}toJSON(){return{line:this.line,character:this.character}}};W=b=ze([R],W),e.Position=W;let $=t=class{static isRange(F){return F instanceof t?!0:F?W.isPosition(F.start)&&W.isPosition(F.end):!1}static of(F){if(F instanceof t)return F;if(this.isRange(F))return new t(F.start,F.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(F,te,we,He){let Qe,ct;if(typeof F=="number"&&typeof te=="number"&&typeof we=="number"&&typeof He=="number"?(Qe=new W(F,te),ct=new W(we,He)):W.isPosition(F)&&W.isPosition(te)&&(Qe=W.of(F),ct=W.of(te)),!Qe||!ct)throw new Error("Invalid arguments");Qe.isBefore(ct)?(this._start=Qe,this._end=ct):(this._start=ct,this._end=Qe)}contains(F){return t.isRange(F)?this.contains(F.start)&&this.contains(F.end):W.isPosition(F)?!(W.of(F).isBefore(this._start)||this._end.isBefore(F)):!1}isEqual(F){return this._start.isEqual(F._start)&&this._end.isEqual(F._end)}intersection(F){const te=W.Max(F.start,this._start),we=W.Min(F.end,this._end);if(!te.isAfter(we))return new t(te,we)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const te=W.Min(F.start,this._start),we=W.Max(F.end,this.end);return new t(te,we)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(F,te=this.end){if(F===null||te===null)throw(0,C.illegalArgument)();let we;return F?W.isPosition(F)?we=F:(we=F.start||this.start,te=F.end||this.end):we=this.start,we.isEqual(this._start)&&te.isEqual(this.end)?this:new t(we,te)}toJSON(){return[this.start,this.end]}};$=t=ze([R],$),e.Range=$;let G=l=class extends ${static isSelection(F){return F instanceof l?!0:F?$.isRange(F)&&W.isPosition(F.anchor)&&W.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(F,te,we,He){let Qe,ct;if(typeof F=="number"&&typeof te=="number"&&typeof we=="number"&&typeof He=="number"?(Qe=new W(F,te),ct=new W(we,He)):W.isPosition(F)&&W.isPosition(te)&&(Qe=W.of(F),ct=W.of(te)),!Qe||!ct)throw new Error("Invalid arguments");super(Qe,ct),this._anchor=Qe,this._active=ct}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};G=l=ze([R],G),e.Selection=G;class re{constructor(F,te,we){if(typeof F!="string"||F.length===0)throw(0,C.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,C.illegalArgument)("port");if(typeof we<"u"&&(typeof we!="string"||we.length===0||!/^[0-9A-Za-z\-]+$/.test(we)))throw(0,C.illegalArgument)("connectionToken");this.host=F,this.port=Math.round(te),this.connectionToken=we}}e.ResolvedAuthority=re;class ge extends Error{static NotAvailable(F,te){return new ge(F,g.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(F){return new ge(F,g.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(F,te=g.RemoteAuthorityResolverErrorCode.Unknown,we){super(F),this._message=F,this._code=te,this._detail=we,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,ge.prototype)}}e.RemoteAuthorityResolverError=ge;var oe;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(oe=e.EndOfLine||(e.EndOfLine={}));var Ee;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(Ee=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ce=i=class{static isTextEdit(F){return F instanceof i?!0:F?$.isRange(F)&&typeof F.newText=="string":!1}static replace(F,te){return new i(F,te)}static insert(F,te){return i.replace(new $(F,F),te)}static delete(F){return i.replace(F,"")}static setEndOfLine(F){const te=new i(new $(new W(0,0),new W(0,0)),"");return te.newEol=F,te}get range(){return this._range}set range(F){if(F&&!$.isRange(F))throw(0,C.illegalArgument)("range");this._range=F}get newText(){return this._newText||""}set newText(F){if(F&&typeof F!="string")throw(0,C.illegalArgument)("newText");this._newText=F}get newEol(){return this._newEol}set newEol(F){if(F&&typeof F!="number")throw(0,C.illegalArgument)("newEol");this._newEol=F}constructor(F,te){this._range=F,this._newText=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ce=i=ze([R],ce),e.TextEdit=ce;let me=n=class{static isNotebookCellEdit(F){return F instanceof n?!0:F?Vt.isNotebookRange(F)&&Array.isArray(F.newCells):!1}static replaceCells(F,te){return new n(F,te)}static insertCells(F,te){return new n(new Vt(F,F),te)}static deleteCells(F){return new n(F,[])}static updateCellMetadata(F,te){const we=new n(new Vt(F,F),[]);return we.newCellMetadata=te,we}static updateNotebookMetadata(F){const te=new n(new Vt(0,0),[]);return te.newNotebookMetadata=F,te}constructor(F,te){this.range=F,this.newCells=te}};me=n=ze([R],me),e.NotebookEdit=me;class ee{static isSnippetTextEdit(F){return F instanceof ee?!0:F?$.isRange(F.range)&&Fe.isSnippetString(F.snippet):!1}static replace(F,te){return new ee(F,te)}static insert(F,te){return ee.replace(new $(F,F),te)}constructor(F,te){this.range=F,this.snippet=te}}e.SnippetTextEdit=ee;var be;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellReplace=5]="CellReplace",z[z.Snippet=6]="Snippet"})(be=e.FileEditType||(e.FileEditType={}));let _e=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(F,te,we,He){this._edits.push({_type:1,from:F,to:te,options:we,metadata:He})}createFile(F,te,we){this._edits.push({_type:1,from:void 0,to:F,options:te,metadata:we})}deleteFile(F,te,we){this._edits.push({_type:1,from:F,to:void 0,options:te,metadata:we})}replaceNotebookMetadata(F,te,we){this._edits.push({_type:3,metadata:we,uri:F,edit:{editType:5,metadata:te},notebookMetadata:te})}replaceNotebookCells(F,te,we,He){const Qe=te.start,ct=te.end;(Qe!==ct||we.length>0)&&this._edits.push({_type:5,uri:F,index:Qe,count:ct-Qe,cells:we,metadata:He})}replaceNotebookCellMetadata(F,te,we,He){this._edits.push({_type:3,metadata:He,uri:F,edit:{editType:8,index:te,metadata:we}})}replace(F,te,we,He){this._edits.push({_type:2,uri:F,edit:new ce(te,we),metadata:He})}insert(F,te,we,He){this.replace(F,new $(te,te),we,He)}delete(F,te,we){this.replace(F,te,"",we)}has(F){return this._edits.some(te=>te._type===2&&te.uri.toString()===F.toString())}set(F,te){if(te)for(const we of te){if(!we)continue;let He,Qe;Array.isArray(we)?(He=we[0],Qe=we[1]):He=we,me.isNotebookCellEdit(He)?He.newCellMetadata?this.replaceNotebookCellMetadata(F,He.range.start,He.newCellMetadata,Qe):He.newNotebookMetadata?this.replaceNotebookMetadata(F,He.newNotebookMetadata,Qe):this.replaceNotebookCells(F,He.range,He.newCells,Qe):ee.isSnippetTextEdit(He)?this._edits.push({_type:6,uri:F,range:He.range,edit:He.snippet,metadata:Qe}):this._edits.push({_type:2,uri:F,edit:He,metadata:Qe})}else{for(let we=0;we<this._edits.length;we++){const He=this._edits[we];switch(He._type){case 2:case 6:case 3:case 5:He.uri.toString()===F.toString()&&(this._edits[we]=void 0);break}}(0,r.coalesceInPlace)(this._edits)}}get(F){const te=[];for(const we of this._edits)we._type===2&&we.uri.toString()===F.toString()&&te.push(we.edit);return te}entries(){const F=new N.ResourceMap;for(const te of this._edits)if(te._type===2){let we=F.get(te.uri);we||(we=[te.uri,[]],F.set(te.uri,we)),we[1].push(te.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};_e=ze([R],_e),e.WorkspaceEdit=_e;let Fe=o=class{static isSnippetString(F){return F instanceof o?!0:F?typeof F.value=="string":!1}static _escape(F){return F.replace(/\$|}|\\/g,"\\$&")}constructor(F){this._tabstop=1,this.value=F||""}appendText(F){return this.value+=o._escape(F),this}appendTabstop(F=this._tabstop++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,te=this._tabstop++){if(typeof F=="function"){const we=new o;we._tabstop=this._tabstop,F(we),this._tabstop=we._tabstop,F=we.value}else F=o._escape(F);return this.value+="${",this.value+=te,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,te=this._tabstop++){const we=F.map(He=>He.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=we,this.value+="|}",this}appendVariable(F,te){if(typeof te=="function"){const we=new o;we._tabstop=this._tabstop,te(we),this._tabstop=we._tabstop,te=we.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,te&&(this.value+=":",this.value+=te),this.value+="}",this}};Fe=o=ze([R],Fe),e.SnippetString=Fe;var Be;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(Be=e.DiagnosticTag||(e.DiagnosticTag={}));var Xe;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(Xe=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ke=f=class{static isLocation(F){return F instanceof f?!0:F?$.isRange(F.range)&&P.URI.isUri(F.uri):!1}constructor(F,te){if(this.uri=F,te)if($.isRange(te))this.range=$.of(te);else if(W.isPosition(te))this.range=new $(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};ke=f=ze([R],ke),e.Location=ke;let ye=class{static is(F){return F?typeof F.message=="string"&&F.location&&$.isRange(F.location.range)&&P.URI.isUri(F.location.uri):!1}constructor(F,te){this.location=F,this.message=te}static isEqual(F,te){return F===te?!0:!F||!te?!1:F.message===te.message&&F.location.range.isEqual(te.location.range)&&F.location.uri.toString()===te.location.uri.toString()}};ye=ze([R],ye),e.DiagnosticRelatedInformation=ye;let De=class{constructor(F,te,we=Xe.Error){if(!$.isRange(F))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=F,this.message=te,this.severity=we}toJSON(){return{severity:Xe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,te){return F===te?!0:!F||!te?!1:F.message===te.message&&F.severity===te.severity&&F.code===te.code&&F.severity===te.severity&&F.source===te.source&&F.range.isEqual(te.range)&&(0,r.equals)(F.tags,te.tags)&&(0,r.equals)(F.relatedInformation,te.relatedInformation,ye.isEqual)}};De=ze([R],De),e.Diagnostic=De;let ae=class{constructor(F,te){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=te}};ae=ze([R],ae),e.Hover=ae;var ue;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(ue=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Z=class{constructor(F,te=ue.Text){this.range=F,this.kind=te}toJSON(){return{range:this.range,kind:ue[this.kind]}}};Z=ze([R],Z),e.DocumentHighlight=Z;var J;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(J=e.SymbolKind||(e.SymbolKind={}));var I;(function(z){z[z.Deprecated=1]="Deprecated"})(I=e.SymbolTag||(e.SymbolTag={}));let B=s=class{static validate(F){if(!F.name)throw new Error("name must not be falsy")}constructor(F,te,we,He,Qe){this.name=F,this.kind=te,this.containerName=Qe,typeof we=="string"&&(this.containerName=we),He instanceof ke?this.location=He:we instanceof $&&(this.location=new ke(He,we)),s.validate(this)}toJSON(){return{name:this.name,kind:J[this.kind],location:this.location,containerName:this.containerName}}};B=s=ze([R],B),e.SymbolInformation=B;let H=h=class{static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children?.forEach(h.validate)}constructor(F,te,we,He,Qe){this.name=F,this.detail=te,this.kind=we,this.range=He,this.selectionRange=Qe,this.children=[],h.validate(this)}};H=h=ze([R],H),e.DocumentSymbol=H;var j;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(j=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let se=class{constructor(F,te){this.title=F,this.kind=te}};se=ze([R],se),e.CodeAction=se;let le=p=class{constructor(F){this.value=F}append(F){return new p(this.value?this.value+p.sep+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+p.sep)}};le.sep=".",le=p=ze([R],le),e.CodeActionKind=le,le.Empty=new le(""),le.QuickFix=le.Empty.append("quickfix"),le.Refactor=le.Empty.append("refactor"),le.RefactorExtract=le.Refactor.append("extract"),le.RefactorInline=le.Refactor.append("inline"),le.RefactorMove=le.Refactor.append("move"),le.RefactorRewrite=le.Refactor.append("rewrite"),le.Source=le.Empty.append("source"),le.SourceOrganizeImports=le.Source.append("organizeImports"),le.SourceFixAll=le.Source.append("fixAll");let Y=class{constructor(F,te){if(this.range=F,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Y=ze([R],Y),e.SelectionRange=Y;class ve{constructor(F,te,we,He,Qe,ct){this.kind=F,this.name=te,this.detail=we,this.uri=He,this.range=Qe,this.selectionRange=ct}}e.CallHierarchyItem=ve;class pe{constructor(F,te){this.fromRanges=te,this.from=F}}e.CallHierarchyIncomingCall=pe;class Ne{constructor(F,te){this.fromRanges=te,this.to=F}}e.CallHierarchyOutgoingCall=Ne;var xe;(function(z){z[z.Information=0]="Information",z[z.Warning=1]="Warning",z[z.Error=2]="Error"})(xe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Ye=class{constructor(F,te){this.range=F,this.command=te}get isResolved(){return!!this.command}};Ye=ze([R],Ye),e.CodeLens=Ye;let Ge=T=class{static isMarkdownString(F){return F instanceof T?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}constructor(F,te=!1){u.set(this,void 0),Je(this,u,new S.MarkdownString(F,{supportThemeIcons:te}),"f")}get value(){return Oe(this,u,"f").value}set value(F){Oe(this,u,"f").value=F}get isTrusted(){return Oe(this,u,"f").isTrusted}set isTrusted(F){Oe(this,u,"f").isTrusted=F}get supportThemeIcons(){return Oe(this,u,"f").supportThemeIcons}set supportThemeIcons(F){Oe(this,u,"f").supportThemeIcons=F}get supportHtml(){return Oe(this,u,"f").supportHtml}set supportHtml(F){Oe(this,u,"f").supportHtml=F}get baseUri(){return Oe(this,u,"f").baseUri}set baseUri(F){Oe(this,u,"f").baseUri=F}appendText(F){return Oe(this,u,"f").appendText(F),this}appendMarkdown(F){return Oe(this,u,"f").appendMarkdown(F),this}appendCodeblock(F,te){return Oe(this,u,"f").appendCodeblock(te??"",F),this}};u=new WeakMap,Ge=T=ze([R],Ge),e.MarkdownString=Ge;let Te=class{constructor(F,te){this.label=F,this.documentation=te}};Te=ze([R],Te),e.ParameterInformation=Te;let rt=class{constructor(F,te){this.label=F,this.documentation=te,this.parameters=[]}};rt=ze([R],rt),e.SignatureInformation=rt;let X=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};X=ze([R],X),e.SignatureHelp=X;var Q;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(Q=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var he;(function(z){z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(he=e.InlayHintKind||(e.InlayHintKind={}));let Ue=class{constructor(F){this.value=F}};Ue=ze([R],Ue),e.InlayHintLabelPart=Ue;let je=class{constructor(F,te,we){this.position=F,this.label=te,this.kind=we}};je=ze([R],je),e.InlayHint=je;var Ze;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ze=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ke;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(Ke=e.CompletionItemKind||(e.CompletionItemKind={}));var Ve;(function(z){z[z.Deprecated=1]="Deprecated"})(Ve=e.CompletionItemTag||(e.CompletionItemTag={}));let it=class{constructor(F,te){this.label=F,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&Ke[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};it=ze([R],it),e.CompletionItem=it;let st=class{constructor(F=[],te=!1){this.items=F,this.isIncomplete=te}};st=ze([R],st),e.CompletionList=st;let dt=class{constructor(F,te,we){this.insertText=F,this.range=te,this.command=we}};dt=ze([R],dt),e.InlineSuggestion=dt;let _t=class{constructor(F){this.commands=void 0,this.items=F}};_t=ze([R],_t),e.InlineSuggestionList=_t;let tt=class{constructor(F,te,we){this.insertText=F,this.range=te,this.command=we}};tt=ze([R],tt),e.InlineSuggestionNew=tt;let ut=class{constructor(F,te){this.items=F,this.commands=te}};ut=ze([R],ut),e.InlineSuggestionsNew=ut;var Ot;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(Ot=e.ViewColumn||(e.ViewColumn={}));var Ht;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(Ht=e.StatusBarAlignment||(e.StatusBarAlignment={}));var At;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative"})(At=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ft;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(ft=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ct;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(Ct=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Lt;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(Lt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var xt;(function(z){z[z.Undo=1]="Undo",z[z.Redo=2]="Redo"})(xt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var qe;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(qe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(z){function F(te){switch(te){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=F}(Lt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ft=class{constructor(F,te){if(te&&!P.URI.isUri(te))throw(0,C.illegalArgument)("target");if(!$.isRange(F)||F.isEmpty)throw(0,C.illegalArgument)("range");this.range=F,this.target=te}};Ft=ze([R],Ft),e.DocumentLink=Ft;let It=class{constructor(F,te,we,He){this.red=F,this.green=te,this.blue=we,this.alpha=He}};It=ze([R],It),e.Color=It;let Mt=class{constructor(F,te){if(te&&!(te instanceof It))throw(0,C.illegalArgument)("color");if(!$.isRange(F)||F.isEmpty)throw(0,C.illegalArgument)("range");this.range=F,this.color=te}};Mt=ze([R],Mt),e.ColorInformation=Mt;let gt=class{constructor(F){if(!F||typeof F!="string")throw(0,C.illegalArgument)("label");this.label=F}};gt=ze([R],gt),e.ColorPresentation=gt;var Se;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(Se=e.ColorFormat||(e.ColorFormat={}));var Pe;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(Pe=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var fe;(function(z){z[z.Unknown=0]="Unknown",z[z.Shutdown=1]="Shutdown",z[z.Process=2]="Process",z[z.User=3]="User",z[z.Extension=4]="Extension"})(fe=e.TerminalExitReason||(e.TerminalExitReason={}));class q{constructor(F,te,we){if(this.startIndex=F,this.length=te,this.tooltip=we,typeof F!="number"||F<0)throw(0,C.illegalArgument)("startIndex");if(typeof te!="number"||te<1)throw(0,C.illegalArgument)("length");if(we!==void 0&&typeof we!="string")throw(0,C.illegalArgument)("tooltip")}}e.TerminalLink=q;var Ae;(function(z){z[z.Panel=1]="Panel",z[z.Editor=2]="Editor"})(Ae=e.TerminalLocation||(e.TerminalLocation={}));class Le{constructor(F){if(this.options=F,typeof F!="object")throw(0,C.illegalArgument)("options")}}e.TerminalProfile=Le;var nt;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(nt=e.TaskRevealKind||(e.TaskRevealKind={}));var We;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(We=e.TaskPanelKind||(e.TaskPanelKind={}));let et=M=class{static from(F){switch(F){case"clean":return M.Clean;case"build":return M.Build;case"rebuild":return M.Rebuild;case"test":return M.Test;default:return}}constructor(F,te){if(this.label=te,typeof F!="string"||typeof te!="string")throw(0,C.illegalArgument)("name");this._id=F}get id(){return this._id}};et.Clean=new M("clean","Clean"),et.Build=new M("build","Build"),et.Rebuild=new M("rebuild","Rebuild"),et.Test=new M("test","Test"),et=M=ze([R],et),e.TaskGroup=et;function lt(z){let F="";for(let te=0;te<z.length;te++)F+=z[te].replace(/,/g,",,")+",";return F}let mt=class{constructor(F,te,we){if(typeof F!="string")throw(0,C.illegalArgument)("process");this._args=[],this._process=F,te!==void 0&&(Array.isArray(te)?(this._args=te,this._options=we):this._options=te)}get process(){return this._process}set process(F){if(typeof F!="string")throw(0,C.illegalArgument)("process");this._process=F}get args(){return this._args}set args(F){Array.isArray(F)||(F=[]),this._args=F}get options(){return this._options}set options(F){this._options=F}computeId(){const F=[];if(F.push("process"),this._process!==void 0&&F.push(this._process),this._args&&this._args.length>0)for(const te of this._args)F.push(te);return lt(F)}};mt=ze([R],mt),e.ProcessExecution=mt;let yt=class{constructor(F,te,we){if(this._args=[],Array.isArray(te)){if(!F)throw(0,C.illegalArgument)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,C.illegalArgument)("command");this._command=F,this._args=te,this._options=we}else{if(typeof F!="string")throw(0,C.illegalArgument)("commandLine");this._commandLine=F,this._options=te}}get commandLine(){return this._commandLine}set commandLine(F){if(typeof F!="string")throw(0,C.illegalArgument)("commandLine");this._commandLine=F}get command(){return this._command?this._command:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,C.illegalArgument)("command");this._command=F}get args(){return this._args}set args(F){this._args=F||[]}get options(){return this._options}set options(F){this._options=F}computeId(){const F=[];if(F.push("shell"),this._commandLine!==void 0&&F.push(this._commandLine),this._command!==void 0&&F.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const te of this._args)F.push(typeof te=="string"?te:te.value);return lt(F)}};yt=ze([R],yt),e.ShellExecution=yt;var Et;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(Et=e.ShellQuoting||(e.ShellQuoting={}));var wt;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(wt=e.TaskScope||(e.TaskScope={}));class kt{constructor(F){this._callback=F}computeId(){return"customExecution"+(0,O.generateUuid)()}set callback(F){this._callback=F}get callback(){return this._callback}}e.CustomExecution=kt;let bt=V=class{constructor(F,te,we,He,Qe,ct){this.__deprecated=!1,this._definition=this.definition=F;let ht;typeof te=="string"?(this._name=this.name=te,this._source=this.source=we,this.execution=He,ht=Qe,this.__deprecated=!0):te===wt.Global||te===wt.Workspace?(this.target=te,this._name=this.name=we,this._source=this.source=He,this.execution=Qe,ht=ct):(this.target=te,this._name=this.name=we,this._source=this.source=He,this.execution=Qe,ht=ct),typeof ht=="string"?(this._problemMatchers=[ht],this._hasDefinedMatchers=!0):Array.isArray(ht)?(this._problemMatchers=ht,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(F){this.__id=F}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof mt?this._definition={type:V.ProcessType,id:this._execution.computeId()}:this._execution instanceof yt?this._definition={type:V.ShellType,id:this._execution.computeId()}:this._execution instanceof kt?this._definition={type:V.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:V.EmptyType,id:(0,O.generateUuid)()}}get definition(){return this._definition}set definition(F){if(F==null)throw(0,C.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=F}get scope(){return this._scope}set target(F){this.clear(),this._scope=F}get name(){return this._name}set name(F){if(typeof F!="string")throw(0,C.illegalArgument)("name");this.clear(),this._name=F}get execution(){return this._execution}set execution(F){F===null&&(F=void 0),this.clear(),this._execution=F;const te=this._definition.type;(V.EmptyType===te||V.ProcessType===te||V.ShellType===te||V.ExtensionCallbackType===te)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(F){if(Array.isArray(F))this.clear(),this._problemMatchers=F,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.clear(),this._isBackground=F}get source(){return this._source}set source(F){if(typeof F!="string"||F.length===0)throw(0,C.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=F}get group(){return this._group}set group(F){F===null&&(F=void 0),this.clear(),this._group=F}get detail(){return this._detail}set detail(F){F===null&&(F=void 0),this._detail=F}get presentationOptions(){return this._presentationOptions}set presentationOptions(F){F==null&&(F=Object.create(null)),this.clear(),this._presentationOptions=F}get runOptions(){return this._runOptions}set runOptions(F){F==null&&(F=Object.create(null)),this.clear(),this._runOptions=F}};bt.ExtensionCallbackType="customExecution",bt.ProcessType="process",bt.ShellType="shell",bt.EmptyType="$empty",bt=V=ze([R],bt),e.Task=bt;var Dt;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(Dt=e.ProgressLocation||(e.ProgressLocation={}));var ti;(function(z){function F(te){const we=te;return(0,E.isNumber)(we.value)?we.tooltip&&!(0,E.isString)(we.tooltip)?(console.log("INVALID view badge, invalid tooltip",we.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",we.value),!1)}z.isViewBadge=F})(ti=e.ViewBadge||(e.ViewBadge={}));let Xt=U=class{static isTreeItem(F,te){if(F instanceof U)return!0;const we=F;if(we.label!==void 0&&!(0,E.isString)(we.label)&&!we.label?.label)return console.log("INVALID tree item, invalid label",we.label),!1;if(we.id!==void 0&&!(0,E.isString)(we.id))return console.log("INVALID tree item, invalid id",we.id),!1;if(we.iconPath!==void 0&&!(0,E.isString)(we.iconPath)&&!P.URI.isUri(we.iconPath)&&(!we.iconPath||!(0,E.isString)(we.iconPath.id))){const He=we.iconPath;if(!He||!(0,E.isString)(He.light)&&!P.URI.isUri(He.light)&&!(0,E.isString)(He.dark)&&!P.URI.isUri(He.dark))return console.log("INVALID tree item, invalid iconPath",we.iconPath),!1}if(we.description!==void 0&&!(0,E.isString)(we.description)&&typeof we.description!="boolean")return console.log("INVALID tree item, invalid description",we.description),!1;if(we.resourceUri!==void 0&&!P.URI.isUri(we.resourceUri))return console.log("INVALID tree item, invalid resourceUri",we.resourceUri),!1;if(we.tooltip!==void 0&&!(0,E.isString)(we.tooltip)&&!(we.tooltip instanceof Ge))return console.log("INVALID tree item, invalid tooltip",we.tooltip),!1;if(we.command!==void 0&&!we.command.command)return console.log("INVALID tree item, invalid command",we.command),!1;if(we.collapsibleState!==void 0&&we.collapsibleState<vt.None&&we.collapsibleState>vt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",we.collapsibleState),!1;if(we.contextValue!==void 0&&!(0,E.isString)(we.contextValue))return console.log("INVALID tree item, invalid contextValue",we.contextValue),!1;if(we.accessibilityInformation!==void 0&&!we.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",we.accessibilityInformation),!1;if(we.checkboxState!==void 0){(0,m.checkProposedApiEnabled)(te,"treeItemCheckbox");const He=(0,E.isNumber)(we.checkboxState)?we.checkboxState:(0,E.isObject)(we.checkboxState)&&(0,E.isNumber)(we.checkboxState.state)?we.checkboxState.state:void 0,Qe=!(0,E.isNumber)(we.checkboxState)&&(0,E.isObject)(we.checkboxState)?we.checkboxState.tooltip:void 0;if(He===void 0||He!==ii.Checked&&He!==ii.Unchecked||Qe!==void 0&&!(0,E.isString)(Qe))return console.log("INVALID tree item, invalid checkboxState",we.checkboxState),!1}return!0}constructor(F,te=vt.None){this.collapsibleState=te,P.URI.isUri(F)?this.resourceUri=F:this.label=F}};Xt=U=ze([R],Xt),e.TreeItem=Xt;var vt;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(vt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var ii;(function(z){z[z.Unchecked=0]="Unchecked",z[z.Checked=1]="Checked"})(ii=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let ni=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(F,te){this.value=F,this.id=te??(0,O.generateUuid)()}};ni=ze([R],ni),e.DataTransferItem=ni;let ri=class{constructor(F){d.set(this,new Map);for(const[te,we]of F??[]){const He=Oe(this,d,"f").get(te);He?He.push(we):Oe(this,d,"f").set(te,[we])}}get(F){return Oe(this,d,"f").get(F)?.[0]}set(F,te){Oe(this,d,"f").set(F,[te])}forEach(F,te){for(const[we,He]of Oe(this,d,"f"))for(const Qe of He)F.call(te,Qe,we,this)}*[(d=new WeakMap,Symbol.iterator)](){for(const[F,te]of Oe(this,d,"f"))for(const we of te)yield[F,we]}};ri=ze([R],ri),e.DataTransfer=ri;let pi=class{constructor(F){this.insertText=F}};pi=ze([R],pi),e.DocumentDropEdit=pi;let Tt=class{constructor(F){this.insertText=F}};Tt=ze([R],Tt),e.DocumentPasteEdit=Tt;let zt=class{constructor(F,te){this.id=F,this.color=te}};zt=ze([R],zt),e.ThemeIcon=zt,zt.File=new zt("file"),zt.Folder=new zt("folder");let vi=class{constructor(F){this.id=F}};vi=ze([R],vi),e.ThemeColor=vi;var si;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(si=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Qt=class{get base(){return this._base}set base(F){this._base=F,this._baseUri=P.URI.file(F)}get baseUri(){return this._baseUri}set baseUri(F){this._baseUri=F,this._base=F.fsPath}constructor(F,te){if(typeof F!="string"&&(!F||!P.URI.isUri(F)&&!P.URI.isUri(F.uri)))throw(0,C.illegalArgument)("base");if(typeof te!="string")throw(0,C.illegalArgument)("pattern");typeof F=="string"?this.baseUri=P.URI.file(F):P.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Qt=ze([R],Qt),e.RelativePattern=Qt;let at=class{constructor(F,te,we,He){this.enabled=typeof F=="boolean"?F:!0,typeof te=="string"&&(this.condition=te),typeof we=="string"&&(this.hitCondition=we),typeof He=="string"&&(this.logMessage=He)}get id(){return this._id||(this._id=(0,O.generateUuid)()),this._id}};at=ze([R],at),e.Breakpoint=at;let Ei=class extends at{constructor(F,te,we,He,Qe){if(super(te,we,He,Qe),F===null)throw(0,C.illegalArgument)("location");this.location=F}};Ei=ze([R],Ei),e.SourceBreakpoint=Ei;let $t=class extends at{constructor(F,te,we,He,Qe){super(te,we,He,Qe),this.functionName=F}};$t=ze([R],$t),e.FunctionBreakpoint=$t;let qt=class extends at{constructor(F,te,we,He,Qe,ct,ht){if(super(He,Qe,ct,ht),!te)throw(0,C.illegalArgument)("dataId");this.label=F,this.dataId=te,this.canPersist=we}};qt=ze([R],qt),e.DataBreakpoint=qt;let oi=class{constructor(F,te,we){this.command=F,this.args=te||[],this.options=we}};oi=ze([R],oi),e.DebugAdapterExecutable=oi;let bi=class{constructor(F,te){this.port=F,this.host=te}};bi=ze([R],bi),e.DebugAdapterServer=bi;let ai=class{constructor(F){this.path=F}};ai=ze([R],ai),e.DebugAdapterNamedPipeServer=ai;let wi=class{constructor(F){this.implementation=F}};wi=ze([R],wi),e.DebugAdapterInlineImplementation=wi;let ci=class{constructor(F,te){this.range=F,this.expression=te}};ci=ze([R],ci),e.EvaluatableExpression=ci;var li;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(li=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var Mi;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(Mi=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let Yt=class{constructor(F,te){this.range=F,this.text=te}};Yt=ze([R],Yt),e.InlineValueText=Yt;let Jt=class{constructor(F,te,we=!0){this.range=F,this.variableName=te,this.caseSensitiveLookup=we}};Jt=ze([R],Jt),e.InlineValueVariableLookup=Jt;let Si=class{constructor(F,te){this.range=F,this.expression=te}};Si=ze([R],Si),e.InlineValueEvaluatableExpression=Si;let _i=class{constructor(F,te){this.frameId=F,this.stoppedLocation=te}};_i=ze([R],_i),e.InlineValueContext=_i;var Zt;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(Zt=e.FileChangeType||(e.FileChangeType={}));let yi=y=class extends Error{static FileExists(F){return new y(F,w.FileSystemProviderErrorCode.FileExists,y.FileExists)}static FileNotFound(F){return new y(F,w.FileSystemProviderErrorCode.FileNotFound,y.FileNotFound)}static FileNotADirectory(F){return new y(F,w.FileSystemProviderErrorCode.FileNotADirectory,y.FileNotADirectory)}static FileIsADirectory(F){return new y(F,w.FileSystemProviderErrorCode.FileIsADirectory,y.FileIsADirectory)}static NoPermissions(F){return new y(F,w.FileSystemProviderErrorCode.NoPermissions,y.NoPermissions)}static Unavailable(F){return new y(F,w.FileSystemProviderErrorCode.Unavailable,y.Unavailable)}constructor(F,te=w.FileSystemProviderErrorCode.Unknown,we){super(P.URI.isUri(F)?F.toString(!0):F),this.code=we?.name??"Unknown",(0,w.markAsFileSystemProviderError)(this,te),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,y.prototype),typeof Error.captureStackTrace=="function"&&typeof we=="function"&&Error.captureStackTrace(this,we)}};yi=y=ze([R],yi),e.FileSystemError=yi;let Di=class{constructor(F,te,we){this.start=F,this.end=te,this.kind=we}};Di=ze([R],Di),e.FoldingRange=Di;var Ni;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(Ni=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Li;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(Li=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Ci;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(Ci=e.CommentMode||(e.CommentMode={}));var Pi;(function(z){z[z.Unresolved=0]="Unresolved",z[z.Resolved=1]="Resolved"})(Pi=e.CommentThreadState||(e.CommentThreadState={}));class Ai{constructor(F,te=[]){this.tokenTypes=F,this.tokenModifiers=te}}e.SemanticTokensLegend=Ai;function Me(z){return typeof z>"u"||(0,E.isStringArray)(z)}class Ut{constructor(F){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,F){this._hasLegend=!0;for(let te=0,we=F.tokenTypes.length;te<we;te++)this._tokenTypeStrToInt.set(F.tokenTypes[te],te);for(let te=0,we=F.tokenModifiers.length;te<we;te++)this._tokenModifierStrToInt.set(F.tokenModifiers[te],te)}}push(F,te,we,He,Qe){if(typeof F=="number"&&typeof te=="number"&&typeof we=="number"&&typeof He=="number"&&(typeof Qe=="number"||typeof Qe>"u"))return typeof Qe>"u"&&(Qe=0),this._pushEncoded(F,te,we,He,Qe);if($.isRange(F)&&typeof te=="string"&&Me(we))return this._push(F,te,we);throw(0,C.illegalArgument)()}_push(F,te,we){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(te))throw new Error("`tokenType` is not in the provided legend");const He=F.start.line,Qe=F.start.character,ct=F.end.character-F.start.character,ht=this._tokenTypeStrToInt.get(te);let Rt=0;if(we)for(const Bt of we){if(!this._tokenModifierStrToInt.has(Bt))throw new Error("`tokenModifier` is not in the provided legend");const Wt=this._tokenModifierStrToInt.get(Bt);Rt|=1<<Wt>>>0}this._pushEncoded(He,Qe,ct,ht,Rt)}_pushEncoded(F,te,we,He,Qe){if(this._dataIsSortedAndDeltaEncoded&&(F<this._prevLine||F===this._prevLine&&te<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Rt=this._data.length/5|0;let Bt=0,Wt=0;for(let jt=0;jt<Rt;jt++){let Kt=this._data[5*jt],ki=this._data[5*jt+1];Kt===0?(Kt=Bt,ki+=Wt):Kt+=Bt,this._data[5*jt]=Kt,this._data[5*jt+1]=ki,Bt=Kt,Wt=ki}}let ct=F,ht=te;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ct-=this._prevLine,ct===0&&(ht-=this._prevChar)),this._data[this._dataLen++]=ct,this._data[this._dataLen++]=ht,this._data[this._dataLen++]=we,this._data[this._dataLen++]=He,this._data[this._dataLen++]=Qe,this._prevLine=F,this._prevChar=te}static _sortAndDeltaEncode(F){const te=[],we=F.length/5|0;for(let ht=0;ht<we;ht++)te[ht]=ht;te.sort((ht,Rt)=>{const Bt=F[5*ht],Wt=F[5*Rt];if(Bt===Wt){const jt=F[5*ht+1],Kt=F[5*Rt+1];return jt-Kt}return Bt-Wt});const He=new Uint32Array(F.length);let Qe=0,ct=0;for(let ht=0;ht<we;ht++){const Rt=5*te[ht],Bt=F[Rt+0],Wt=F[Rt+1],jt=F[Rt+2],Kt=F[Rt+3],ki=F[Rt+4],Zi=Bt-Qe,Cn=Zi===0?Wt-ct:Wt,Ti=5*ht;He[Ti+0]=Zi,He[Ti+1]=Cn,He[Ti+2]=jt,He[Ti+3]=Kt,He[Ti+4]=ki,Qe=Bt,ct=Wt}return He}build(F){return this._dataIsSortedAndDeltaEncoded?new ui(new Uint32Array(this._data),F):new ui(Ut._sortAndDeltaEncode(this._data),F)}}e.SemanticTokensBuilder=Ut;class ui{constructor(F,te){this.resultId=te,this.data=F}}e.SemanticTokens=ui;class pt{constructor(F,te,we){this.start=F,this.deleteCount=te,this.data=we}}e.SemanticTokensEdit=pt;class Ui{constructor(F,te){this.resultId=te,this.edits=F}}e.SemanticTokensEdits=Ui;var Bi;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(Bi=e.DebugConsoleMode||(e.DebugConsoleMode={}));let ei=class{constructor(){}};ei.Back={iconPath:new zt("arrow-left")},ei=ze([R],ei),e.QuickInputButtons=ei;var xi;(function(z){z[z.Separator=-1]="Separator",z[z.Default=0]="Default"})(xi=e.QuickPickItemKind||(e.QuickPickItemKind={}));var di;(function(z){z[z.Info=1]="Info",z[z.Warning=2]="Warning",z[z.Error=3]="Error"})(di=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var zi;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(zi=e.ExtensionKind||(e.ExtensionKind={}));class $i{static validate(F){if(F.badge){let te=(0,A.nextCharLength)(F.badge,0);if(te<F.badge.length&&(te+=(0,A.nextCharLength)(F.badge,te)),F.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}constructor(F,te,we){this.badge=F,this.tooltip=te,this.color=we}}e.FileDecoration=$i;let Ii=class{constructor(F){this.kind=F}};Ii=ze([R],Ii),e.ColorTheme=Ii;var Ri;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast",z[z.HighContrastLight=4]="HighContrastLight"})(Ri=e.ColorThemeKind||(e.ColorThemeKind={}));class Vt{static isNotebookRange(F){return F instanceof Vt?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(F,te){if(F<0)throw(0,C.illegalArgument)("start must be positive");if(te<0)throw(0,C.illegalArgument)("end must be positive");F<=te?(this._start=F,this._end=te):(this._start=te,this._end=F)}with(F){let te=this._start,we=this._end;return F.start!==void 0&&(te=F.start),F.end!==void 0&&(we=F.end),te===this._start&&we===this._end?this:new Vt(te,we)}}e.NotebookRange=Vt;class hi{static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(te=>hi.isNotebookCellData(te))}static isNotebookCellData(F){return!0}constructor(F,te,we,He,Qe,ct,ht){this.kind=F,this.value=te,this.languageId=we,this.mime=He,this.outputs=Qe??[],this.metadata=ct,this.executionSummary=ht,hi.validate(this)}}e.NotebookCellData=hi;class Wi{constructor(F){this.cells=F}}e.NotebookData=Wi;class Nt{static isNotebookCellOutputItem(F){return F instanceof Nt?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const te={name:F.name,message:F.message,stack:F.stack};return Nt.json(te,"application/vnd.code.notebook.error")}static stdout(F){return Nt.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return Nt.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,te="application/octet-stream"){return new Nt(F,te)}static text(F,te=_.Mimes.text){const we=Oe(Nt,v,"f",D).encode(String(F));return new Nt(we,te)}static json(F,te="text/x-json"){const we=JSON.stringify(F,void 0,"	");return Nt.text(we,te)}constructor(F,te){this.data=F,this.mime=te;const we=(0,_.normalizeMimeType)(te,!0);if(!we)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=we}}e.NotebookCellOutputItem=Nt,v=Nt,D={value:new TextEncoder};class fi{static isNotebookCellOutput(F){return F instanceof fi?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&Array.isArray(F.items)}static ensureUniqueMimeTypes(F,te=!1){const we=new Set,He=new Set;for(let Qe=0;Qe<F.length;Qe++){const ct=F[Qe],ht=(0,_.normalizeMimeType)(ct.mime);if(!we.has(ht)||(0,k.isTextStreamMime)(ht)){we.add(ht);continue}He.add(Qe),te&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return He.size===0?F:F.filter((Qe,ct)=>!He.has(ct))}constructor(F,te,we){this.items=fi.ensureUniqueMimeTypes(F,!0),typeof te=="string"?(this.id=te,this.metadata=we):(this.id=(0,O.generateUuid)(),this.metadata=te??we)}}e.NotebookCellOutput=fi;var Hi;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(Hi=e.NotebookCellKind||(e.NotebookCellKind={}));var ne;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(ne=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var de;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(de=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Re;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(Re=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class ot{constructor(F,te){this.text=F,this.alignment=te}}e.NotebookCellStatusBarItem=ot;var St;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(St=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var Pt;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred",z[z.Hidden=-1]="Hidden"})(Pt=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class rn{constructor(F,te=[]){this.uri=F,this.provides=(0,r.asArray)(te)}}e.NotebookRendererScript=rn;let Vi=class{constructor(F,te){this.label=F,this.timestamp=te}};Vi=ze([R],Vi),e.TimelineItem=Vi;var sn;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(sn=e.ExtensionMode||(e.ExtensionMode={}));var on;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(on=e.ExtensionRuntime||(e.ExtensionRuntime={}));var an;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(an=e.StandardTokenType||(e.StandardTokenType={}));class cn{constructor(F,te){this.ranges=F,this.wordPattern=te}}e.LinkedEditingRanges=cn;class ln{constructor(F,te){this._port=F,this._autoForwardAction=te}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=ln;var un;(function(z){z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(un=e.TestResultState||(e.TestResultState={}));var dn;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(dn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let ji=class{constructor(F=void 0,te=void 0,we=void 0){this.include=F,this.exclude=te,this.profile=we}};ji=ze([R],ji),e.TestRunRequest=ji;let qi=x=class{static diff(F,te,we){const He=new x(F);return He.expectedOutput=te,He.actualOutput=we,He}constructor(F){this.message=F}};qi=x=ze([R],qi),e.TestMessage=qi;let Ki=class{constructor(F){this.id=F}};Ki=ze([R],Ki),e.TestTag=Ki;let mi=class{constructor(F,te){this.covered=F,this.total=te}};mi=ze([R],mi),e.CoveredCount=mi;let Gi=L=class{static fromDetails(F,te){const we=new mi(0,0),He=new mi(0,0),Qe=new mi(0,0);for(const ht of te)if("branches"in ht){we.total+=1,we.covered+=ht.executionCount>0?1:0;for(const Rt of ht.branches)He.total+=1,He.covered+=Rt.executionCount>0?1:0}else Qe.total+=1,Qe.covered+=ht.executionCount>0?1:0;const ct=new L(F,we,He.total>0?He:void 0,Qe.total>0?Qe:void 0);return ct.detailedCoverage=te,ct}constructor(F,te,we,He){this.uri=F,this.statementCoverage=te,this.branchCoverage=we,this.functionCoverage=He}};Gi=L=ze([R],Gi),e.FileCoverage=Gi;let Xi=class{constructor(F,te,we=[]){this.executionCount=F,this.location=te,this.branches=we}};Xi=ze([R],Xi),e.StatementCoverage=Xi;let Qi=class{constructor(F,te){this.executionCount=F,this.location=te}};Qi=ze([R],Qi),e.BranchCoverage=Qi;let Yi=class{constructor(F,te){this.executionCount=F,this.location=te}};Yi=ze([R],Yi),e.FunctionCoverage=Yi;var hn;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(hn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var fn;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(fn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var mn;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore",z[z.OpenBrowserOnce=6]="OpenBrowserOnce"})(mn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class gn{constructor(F,te,we,He,Qe,ct){this.kind=F,this.name=te,this.detail=we,this.uri=He,this.range=Qe,this.selectionRange=ct}}e.TypeHierarchyItem=gn;class pn{constructor(F){this.uri=F}}e.TextTabInput=pn;class vn{constructor(F,te){this.original=F,this.modified=te}}e.TextDiffTabInput=vn;class En{constructor(F,te,we,He){this.base=F,this.input1=te,this.input2=we,this.result=He}}e.TextMergeTabInput=En;class bn{constructor(F,te){this.uri=F,this.viewType=te}}e.CustomEditorTabInput=bn;class wn{constructor(F){this.viewType=F}}e.WebviewEditorTabInput=wn;class Sn{constructor(F,te){this.uri=F,this.notebookType=te}}e.NotebookEditorTabInput=Sn;class _n{constructor(F,te,we){this.original=F,this.modified=te,this.notebookType=we}}e.NotebookDiffEditorTabInput=_n;class yn{constructor(){}}e.TerminalEditorTabInput=yn;class Dn{constructor(F,te){this.uri=F,this.inputBoxUri=te}}e.InteractiveWindowInput=Dn}),define(Ce[93],Ie([1,0,45,13,9,241,123,6,18]),function(ie,e,r,C,S,N,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function O(m,a){a?P.set(m,a):P.delete(m)}e.setWordDefinitionFor=O;function w(m){return P.get(m)}e.getWordDefinitionFor=w;class g extends N.MirrorTextModel{constructor(a,u,d,v,D,c,b,t){super(u,d,v,D),this._proxy=a,this._languageId=c,this._isDirty=b,this.notebook=t,this._isDisposed=!1}dispose(){(0,r.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(a){return(0,E.equals)(this._lines,a)}get document(){if(!this._document){const a=this;this._document={get uri(){return a._uri},get fileName(){return a._uri.fsPath},get isUntitled(){return a._uri.scheme===C.Schemas.untitled},get languageId(){return a._languageId},get version(){return a._versionId},get isClosed(){return a._isDisposed},get isDirty(){return a._isDirty},save(){return a._save()},getText(u){return u?a._getTextInRange(u):a.getText()},get eol(){return a._eol===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return a._lines.length},lineAt(u){return a._lineAt(u)},offsetAt(u){return a._offsetAt(u)},positionAt(u){return a._positionAt(u)},validateRange(u){return a._validateRange(u)},validatePosition(u){return a._validatePosition(u)},getWordRangeAtPosition(u,d){return a._getWordRangeAtPosition(u,d)}}}return Object.freeze(this._document)}_acceptLanguageId(a){(0,r.ok)(!this._isDisposed),this._languageId=a}_acceptIsDirty(a){(0,r.ok)(!this._isDisposed),this._isDirty=a}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(a){const u=this._validateRange(a);if(u.isEmpty)return"";if(u.isSingleLine)return this._lines[u.start.line].substring(u.start.character,u.end.character);const d=this._eol,v=u.start.line,D=u.end.line,c=[];c.push(this._lines[v].substring(u.start.character));for(let b=v+1;b<D;b++)c.push(this._lines[b]);return c.push(this._lines[D].substring(0,u.end.character)),c.join(d)}_lineAt(a){let u;if(a instanceof A.Position?u=a.line:typeof a=="number"&&(u=a),typeof u!="number"||u<0||u>=this._lines.length||Math.floor(u)!==u)throw new Error("Illegal value for `line`");return new k(u,this._lines[u],u===this._lines.length-1)}_offsetAt(a){return a=this._validatePosition(a),this._ensureLineStarts(),this._lineStarts.getPrefixSum(a.line-1)+a.character}_positionAt(a){a=Math.floor(a),a=Math.max(0,a),this._ensureLineStarts();const u=this._lineStarts.getIndexOf(a),d=this._lines[u.index].length;return new A.Position(u.index,Math.min(u.remainder,d))}_validateRange(a){if(!(a instanceof A.Range))throw new Error("Invalid argument");const u=this._validatePosition(a.start),d=this._validatePosition(a.end);return u===a.start&&d===a.end?a:new A.Range(u.line,u.character,d.line,d.character)}_validatePosition(a){if(!(a instanceof A.Position))throw new Error("Invalid argument");if(this._lines.length===0)return a.with(0,0);let{line:u,character:d}=a,v=!1;if(u<0)u=0,d=0,v=!0;else if(u>=this._lines.length)u=this._lines.length-1,d=this._lines[u].length,v=!0;else{const D=this._lines[u].length;d<0?(d=0,v=!0):d>D&&(d=D,v=!0)}return v?new A.Position(u,d):a}_getWordRangeAtPosition(a,u){const d=this._validatePosition(a);if(!u)u=w(this._languageId);else if((0,S.regExpLeadsToEndlessLoop)(u))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${u.source}' because it matches the empty string.`);const v=(0,_.getWordAtText)(d.character+1,(0,_.ensureValidWordDefinition)(u),this._lines[d.line],0);if(v)return new A.Range(d.line,v.startColumn-1,d.line,v.endColumn-1)}}e.ExtHostDocumentData=g;class k{constructor(a,u,d){this._line=a,this._text=u,this._isLastLine=d}get lineNumber(){return this._line}get text(){return this._text}get range(){return new A.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new A.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=k}),define(Ce[176],Ie([1,0,6,11,5]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let N=class{constructor(A){this._actual=new r.ColorTheme(r.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new S.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(A){let E;switch(A){case"light":E=r.ColorThemeKind.Light;break;case"hcDark":E=r.ColorThemeKind.HighContrast;break;case"hcLight":E=r.ColorThemeKind.HighContrastLight;break;default:E=r.ColorThemeKind.Dark}this._actual=new r.ColorTheme(E),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};N=ze([$e(0,C.IExtHostRpcService)],N),e.ExtHostTheming=N}),define(Ce[8],Ie([1,0,18,23,77,24,107,76,25,10,2,49,66,82,90,89,64,40,48,171,6,177]),function(ie,e,r,C,S,N,_,A,E,P,O,w,g,k,m,a,u,d,v,D,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var t;(function(Se){function Pe(q){const{selectionStartLineNumber:Ae,selectionStartColumn:Le,positionLineNumber:nt,positionColumn:We}=q,et=new c.Position(Ae-1,Le-1),lt=new c.Position(nt-1,We-1);return new c.Selection(et,lt)}Se.to=Pe;function fe(q){const{anchor:Ae,active:Le}=q;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}Se.from=fe})(t=e.Selection||(e.Selection={}));var l;(function(Se){function Pe(q){if(!q)return;const{start:Ae,end:Le}=q;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}Se.from=Pe;function fe(q){if(!q)return;const{startLineNumber:Ae,startColumn:Le,endLineNumber:nt,endColumn:We}=q;return new c.Range(Ae-1,Le-1,nt-1,We-1)}Se.to=fe})(l=e.Range||(e.Range={}));var i;(function(Se){function Pe(fe){switch(fe){case 1:return c.StandardTokenType.Comment;case 0:return c.StandardTokenType.Other;case 3:return c.StandardTokenType.RegEx;case 2:return c.StandardTokenType.String}}Se.to=Pe})(i=e.TokenType||(e.TokenType={}));var n;(function(Se){function Pe(q){return new c.Position(q.lineNumber-1,q.column-1)}Se.to=Pe;function fe(q){return{lineNumber:q.line+1,column:q.character+1}}Se.from=fe})(n=e.Position||(e.Position={}));var o;(function(Se){function Pe(Ae,Le){return(0,r.coalesce)((0,r.asArray)(Ae).map(nt=>fe(nt,Le)))}Se.from=Pe;function fe(Ae,Le){if(typeof Ae=="string")return{$serialized:!0,language:Ae};if(Ae)return{$serialized:!0,language:Ae.language,scheme:q(Ae.scheme,Le),pattern:he.from(Ae.pattern)??void 0,exclusive:Ae.exclusive,notebookType:Ae.notebookType}}function q(Ae,Le){return Le&&typeof Ae=="string"?Le.transformOutgoingScheme(Ae):Ae}})(o=e.DocumentSelector||(e.DocumentSelector={}));var f;(function(Se){function Pe(q){switch(q){case c.DiagnosticTag.Unnecessary:return 1;case c.DiagnosticTag.Deprecated:return 2}}Se.from=Pe;function fe(q){switch(q){case 1:return c.DiagnosticTag.Unnecessary;case 2:return c.DiagnosticTag.Deprecated;default:return}}Se.to=fe})(f=e.DiagnosticTag||(e.DiagnosticTag={}));var s;(function(Se){function Pe(q){let Ae;return q.code&&((0,P.isString)(q.code)||(0,P.isNumber)(q.code)?Ae=String(q.code):Ae={value:String(q.code.value),target:q.code.target}),{...l.from(q.range),message:q.message,source:q.source,code:Ae,severity:p.from(q.severity),relatedInformation:q.relatedInformation&&q.relatedInformation.map(h.from),tags:Array.isArray(q.tags)?(0,r.coalesce)(q.tags.map(f.from)):void 0}}Se.from=Pe;function fe(q){const Ae=new c.Diagnostic(l.to(q),q.message,p.to(q.severity));return Ae.source=q.source,Ae.code=(0,P.isString)(q.code)?q.code:q.code?.value,Ae.relatedInformation=q.relatedInformation&&q.relatedInformation.map(h.to),Ae.tags=q.tags&&(0,r.coalesce)(q.tags.map(f.to)),Ae}Se.to=fe})(s=e.Diagnostic||(e.Diagnostic={}));var h;(function(Se){function Pe(q){return{...l.from(q.location.range),message:q.message,resource:q.location.uri}}Se.from=Pe;function fe(q){return new c.DiagnosticRelatedInformation(new c.Location(q.resource,l.to(q)),q.message)}Se.to=fe})(h=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var p;(function(Se){function Pe(q){switch(q){case c.DiagnosticSeverity.Error:return k.MarkerSeverity.Error;case c.DiagnosticSeverity.Warning:return k.MarkerSeverity.Warning;case c.DiagnosticSeverity.Information:return k.MarkerSeverity.Info;case c.DiagnosticSeverity.Hint:return k.MarkerSeverity.Hint}return k.MarkerSeverity.Error}Se.from=Pe;function fe(q){switch(q){case k.MarkerSeverity.Info:return c.DiagnosticSeverity.Information;case k.MarkerSeverity.Warning:return c.DiagnosticSeverity.Warning;case k.MarkerSeverity.Error:return c.DiagnosticSeverity.Error;case k.MarkerSeverity.Hint:return c.DiagnosticSeverity.Hint;default:return c.DiagnosticSeverity.Error}}Se.to=fe})(p=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var T;(function(Se){function Pe(q){return typeof q=="number"&&q>=c.ViewColumn.One?q-1:q===c.ViewColumn.Beside?D.SIDE_GROUP:D.ACTIVE_GROUP}Se.from=Pe;function fe(q){if(typeof q=="number"&&q>=0)return q+1;throw new Error("invalid 'EditorGroupColumn'")}Se.to=fe})(T=e.ViewColumn||(e.ViewColumn={}));function M(Se){return typeof Se.range<"u"}function V(Se){return Se.length===0?!0:!!M(Se[0])}e.isDecorationOptionsArr=V;var U;(function(Se){function Pe(We){return We.map(Se.from)}Se.fromMany=Pe;function fe(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function q(We){let et;if(fe(We)){const{language:Et,value:wt}=We;et={value:"```"+Et+`
`+wt+"\n```\n"}}else c.MarkdownString.isMarkdownString(We)?et={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml,baseUri:We.baseUri}:typeof We=="string"?et={value:We}:et={value:""};const lt=Object.create(null);et.uris=lt;const mt=Et=>{try{let wt=O.URI.parse(Et,!0);wt=wt.with({query:Ae(wt.query,lt)}),lt[Et]=wt}catch{}return""},yt=new _.marked.Renderer;return yt.link=mt,yt.image=Et=>typeof Et=="string"?mt(S.parseHrefAndDimensions(Et).href):"",(0,_.marked)(et.value,{renderer:yt}),et}Se.from=q;function Ae(We,et){if(!We)return We;let lt;try{lt=(0,A.parse)(We)}catch{}if(!lt)return We;let mt=!1;return lt=(0,E.cloneAndChange)(lt,yt=>{if(O.URI.isUri(yt)){const Et=`__uri_${Math.random().toString(16).slice(2,8)}`;return et[Et]=yt,mt=!0,Et}else return}),mt?JSON.stringify(lt):We}function Le(We){const et=new c.MarkdownString(We.value,We.supportThemeIcons);return et.isTrusted=We.isTrusted,et.supportHtml=We.supportHtml,et.baseUri=We.baseUri?O.URI.from(We.baseUri):void 0,et}Se.to=Le;function nt(We){if(!!We)return typeof We=="string"?We:Se.from(We)}Se.fromStrict=nt})(U=e.MarkdownString||(e.MarkdownString={}));function y(Se){return V(Se)?Se.map(Pe=>({range:l.from(Pe.range),hoverMessage:Array.isArray(Pe.hoverMessage)?U.fromMany(Pe.hoverMessage):Pe.hoverMessage?U.from(Pe.hoverMessage):void 0,renderOptions:Pe.renderOptions})):Se.map(Pe=>({range:l.from(Pe)}))}e.fromRangeOrRangeWithMessage=y;function x(Se){return typeof Se>"u"?Se:typeof Se=="string"?O.URI.file(Se):Se}e.pathOrURIToURI=x;var L;(function(Se){function Pe(fe){return typeof fe>"u"?fe:{contentText:fe.contentText,contentIconPath:fe.contentIconPath?x(fe.contentIconPath):void 0,border:fe.border,borderColor:fe.borderColor,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,color:fe.color,backgroundColor:fe.backgroundColor,margin:fe.margin,width:fe.width,height:fe.height}}Se.from=Pe})(L=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var R;(function(Se){function Pe(fe){return typeof fe>"u"?fe:{backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?x(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?L.from(fe.before):void 0,after:fe.after?L.from(fe.after):void 0}}Se.from=Pe})(R=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var K;(function(Se){function Pe(fe){if(typeof fe>"u")return fe;switch(fe){case c.DecorationRangeBehavior.OpenOpen:return 0;case c.DecorationRangeBehavior.ClosedClosed:return 1;case c.DecorationRangeBehavior.OpenClosed:return 2;case c.DecorationRangeBehavior.ClosedOpen:return 3}}Se.from=Pe})(K=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var W;(function(Se){function Pe(fe){return{isWholeLine:fe.isWholeLine,rangeBehavior:fe.rangeBehavior?K.from(fe.rangeBehavior):void 0,overviewRulerLane:fe.overviewRulerLane,light:fe.light?R.from(fe.light):void 0,dark:fe.dark?R.from(fe.dark):void 0,backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?x(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?L.from(fe.before):void 0,after:fe.after?L.from(fe.after):void 0}}Se.from=Pe})(W=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var $;(function(Se){function Pe(q){return{text:q.newText,eol:q.newEol&&Ge.from(q.newEol),range:l.from(q.range)}}Se.from=Pe;function fe(q){const Ae=new c.TextEdit(l.to(q.range),q.text);return Ae.newEol=typeof q.eol>"u"?void 0:Ge.to(q.eol),Ae}Se.to=fe})($=e.TextEdit||(e.TextEdit={}));var G;(function(Se){function Pe(q,Ae){const Le={edits:[]};if(q instanceof c.WorkspaceEdit){const nt=new N.ResourceSet;for(const We of q._allEntries())We._type===1&&O.URI.isUri(We.to)&&We.from===void 0&&nt.add(We.to);for(const We of q._allEntries())We._type===1?Le.edits.push({oldResource:We.from,newResource:We.to,options:{...We.options,contentsBase64:We.options?.contents&&(0,C.encodeBase64)(C.VSBuffer.wrap(We.options.contents))},metadata:We.metadata}):We._type===2?Le.edits.push({resource:We.uri,textEdit:$.from(We.edit),versionId:nt.has(We.uri)?void 0:Ae?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===6?Le.edits.push({resource:We.uri,textEdit:{range:l.from(We.range),text:We.edit.value,insertAsSnippet:!0},versionId:nt.has(We.uri)?void 0:Ae?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===3?Le.edits.push({metadata:We.metadata,resource:We.uri,cellEdit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Ae?.getNotebookDocumentVersion(We.uri)}):We._type===5&&Le.edits.push({metadata:We.metadata,resource:We.uri,notebookVersionId:Ae?.getNotebookDocumentVersion(We.uri),cellEdit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(st.from)}})}return Le}Se.from=Pe;function fe(q){const Ae=new c.WorkspaceEdit;for(const Le of q.edits)Le.textEdit?Ae.replace(O.URI.revive(Le.resource),l.to(Le.textEdit.range),Le.textEdit.text):Ae.renameFile(O.URI.revive(Le.oldResource),O.URI.revive(Le.newResource),Le.options);return Ae}Se.to=fe})(G=e.WorkspaceEdit||(e.WorkspaceEdit={}));var re;(function(Se){const Pe=Object.create(null);Pe[c.SymbolKind.File]=0,Pe[c.SymbolKind.Module]=1,Pe[c.SymbolKind.Namespace]=2,Pe[c.SymbolKind.Package]=3,Pe[c.SymbolKind.Class]=4,Pe[c.SymbolKind.Method]=5,Pe[c.SymbolKind.Property]=6,Pe[c.SymbolKind.Field]=7,Pe[c.SymbolKind.Constructor]=8,Pe[c.SymbolKind.Enum]=9,Pe[c.SymbolKind.Interface]=10,Pe[c.SymbolKind.Function]=11,Pe[c.SymbolKind.Variable]=12,Pe[c.SymbolKind.Constant]=13,Pe[c.SymbolKind.String]=14,Pe[c.SymbolKind.Number]=15,Pe[c.SymbolKind.Boolean]=16,Pe[c.SymbolKind.Array]=17,Pe[c.SymbolKind.Object]=18,Pe[c.SymbolKind.Key]=19,Pe[c.SymbolKind.Null]=20,Pe[c.SymbolKind.EnumMember]=21,Pe[c.SymbolKind.Struct]=22,Pe[c.SymbolKind.Event]=23,Pe[c.SymbolKind.Operator]=24,Pe[c.SymbolKind.TypeParameter]=25;function fe(Ae){return typeof Pe[Ae]=="number"?Pe[Ae]:6}Se.from=fe;function q(Ae){for(const Le in Pe)if(Pe[Le]===Ae)return Number(Le);return c.SymbolKind.Property}Se.to=q})(re=e.SymbolKind||(e.SymbolKind={}));var ge;(function(Se){function Pe(q){switch(q){case c.SymbolTag.Deprecated:return 1}}Se.from=Pe;function fe(q){switch(q){case 1:return c.SymbolTag.Deprecated}}Se.to=fe})(ge=e.SymbolTag||(e.SymbolTag={}));var oe;(function(Se){function Pe(q){return{name:q.name,kind:re.from(q.kind),tags:q.tags&&q.tags.map(ge.from),containerName:q.containerName,location:be.from(q.location)}}Se.from=Pe;function fe(q){const Ae=new c.SymbolInformation(q.name,re.to(q.kind),q.containerName,be.to(q.location));return Ae.tags=q.tags&&q.tags.map(ge.to),Ae}Se.to=fe})(oe=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var Ee;(function(Se){function Pe(q){const Ae={name:q.name||"!!MISSING: name!!",detail:q.detail,range:l.from(q.range),selectionRange:l.from(q.selectionRange),kind:re.from(q.kind),tags:q.tags?.map(ge.from)??[]};return q.children&&(Ae.children=q.children.map(Pe)),Ae}Se.from=Pe;function fe(q){const Ae=new c.DocumentSymbol(q.name,q.detail,re.to(q.kind),l.to(q.range),l.to(q.selectionRange));return(0,r.isNonEmptyArray)(q.tags)&&(Ae.tags=q.tags.map(ge.to)),q.children&&(Ae.children=q.children.map(fe)),Ae}Se.to=fe})(Ee=e.DocumentSymbol||(e.DocumentSymbol={}));var ce;(function(Se){function Pe(q){const Ae=new c.CallHierarchyItem(re.to(q.kind),q.name,q.detail||"",O.URI.revive(q.uri),l.to(q.range),l.to(q.selectionRange));return Ae._sessionId=q._sessionId,Ae._itemId=q._itemId,Ae}Se.to=Pe;function fe(q,Ae,Le){if(Ae=Ae??q._sessionId,Le=Le??q._itemId,Ae===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Le,name:q.name,detail:q.detail,kind:re.from(q.kind),uri:q.uri,range:l.from(q.range),selectionRange:l.from(q.selectionRange),tags:q.tags?.map(ge.from)}}Se.from=fe})(ce=e.CallHierarchyItem||(e.CallHierarchyItem={}));var me;(function(Se){function Pe(fe){return new c.CallHierarchyIncomingCall(ce.to(fe.from),fe.fromRanges.map(q=>l.to(q)))}Se.to=Pe})(me=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ee;(function(Se){function Pe(fe){return new c.CallHierarchyOutgoingCall(ce.to(fe.to),fe.fromRanges.map(q=>l.to(q)))}Se.to=Pe})(ee=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var be;(function(Se){function Pe(q){return{range:q.range&&l.from(q.range),uri:q.uri}}Se.from=Pe;function fe(q){return new c.Location(O.URI.revive(q.uri),l.to(q.range))}Se.to=fe})(be=e.location||(e.location={}));var _e;(function(Se){function Pe(q){const Ae=q,Le=q;return{originSelectionRange:Ae.originSelectionRange?l.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:Le.uri,range:l.from(Ae.targetRange?Ae.targetRange:Le.range),targetSelectionRange:Ae.targetSelectionRange?l.from(Ae.targetSelectionRange):void 0}}Se.from=Pe;function fe(q){return{targetUri:O.URI.revive(q.uri),targetRange:l.to(q.range),targetSelectionRange:q.targetSelectionRange?l.to(q.targetSelectionRange):void 0,originSelectionRange:q.originSelectionRange?l.to(q.originSelectionRange):void 0}}Se.to=fe})(_e=e.DefinitionLink||(e.DefinitionLink={}));var Fe;(function(Se){function Pe(q){return{range:l.from(q.range),contents:U.fromMany(q.contents)}}Se.from=Pe;function fe(q){return new c.Hover(q.contents.map(U.to),l.to(q.range))}Se.to=fe})(Fe=e.Hover||(e.Hover={}));var Be;(function(Se){function Pe(q){return{range:l.from(q.range),expression:q.expression}}Se.from=Pe;function fe(q){return new c.EvaluatableExpression(l.to(q.range),q.expression)}Se.to=fe})(Be=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Xe;(function(Se){function Pe(q){if(q instanceof c.InlineValueText)return{type:"text",range:l.from(q.range),text:q.text};if(q instanceof c.InlineValueVariableLookup)return{type:"variable",range:l.from(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};if(q instanceof c.InlineValueEvaluatableExpression)return{type:"expression",range:l.from(q.range),expression:q.expression};throw new Error("Unknown 'InlineValue' type")}Se.from=Pe;function fe(q){switch(q.type){case"text":return{range:l.to(q.range),text:q.text};case"variable":return{range:l.to(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};case"expression":return{range:l.to(q.range),expression:q.expression}}}Se.to=fe})(Xe=e.InlineValue||(e.InlineValue={}));var ke;(function(Se){function Pe(q){return{frameId:q.frameId,stoppedLocation:l.from(q.stoppedLocation)}}Se.from=Pe;function fe(q){return new c.InlineValueContext(q.frameId,l.to(q.stoppedLocation))}Se.to=fe})(ke=e.InlineValueContext||(e.InlineValueContext={}));var ye;(function(Se){function Pe(q){return{range:l.from(q.range),kind:q.kind}}Se.from=Pe;function fe(q){return new c.DocumentHighlight(l.to(q.range),q.kind)}Se.to=fe})(ye=e.DocumentHighlight||(e.DocumentHighlight={}));var De;(function(Se){function Pe(fe){switch(fe){case 1:return c.CompletionTriggerKind.TriggerCharacter;case 2:return c.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return c.CompletionTriggerKind.Invoke}}Se.to=Pe})(De=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ae;(function(Se){function Pe(fe){return{triggerKind:De.to(fe.triggerKind),triggerCharacter:fe.triggerCharacter}}Se.to=Pe})(ae=e.CompletionContext||(e.CompletionContext={}));var ue;(function(Se){function Pe(q){switch(q){case c.CompletionItemTag.Deprecated:return 1}}Se.from=Pe;function fe(q){switch(q){case 1:return c.CompletionItemTag.Deprecated}}Se.to=fe})(ue=e.CompletionItemTag||(e.CompletionItemTag={}));var Z;(function(Se){const Pe=new Map([[c.CompletionItemKind.Method,0],[c.CompletionItemKind.Function,1],[c.CompletionItemKind.Constructor,2],[c.CompletionItemKind.Field,3],[c.CompletionItemKind.Variable,4],[c.CompletionItemKind.Class,5],[c.CompletionItemKind.Interface,7],[c.CompletionItemKind.Struct,6],[c.CompletionItemKind.Module,8],[c.CompletionItemKind.Property,9],[c.CompletionItemKind.Unit,12],[c.CompletionItemKind.Value,13],[c.CompletionItemKind.Constant,14],[c.CompletionItemKind.Enum,15],[c.CompletionItemKind.EnumMember,16],[c.CompletionItemKind.Keyword,17],[c.CompletionItemKind.Snippet,27],[c.CompletionItemKind.Text,18],[c.CompletionItemKind.Color,19],[c.CompletionItemKind.File,20],[c.CompletionItemKind.Reference,21],[c.CompletionItemKind.Folder,23],[c.CompletionItemKind.Event,10],[c.CompletionItemKind.Operator,11],[c.CompletionItemKind.TypeParameter,24],[c.CompletionItemKind.Issue,26],[c.CompletionItemKind.User,25]]);function fe(Le){return Pe.get(Le)??9}Se.from=fe;const q=new Map([[0,c.CompletionItemKind.Method],[1,c.CompletionItemKind.Function],[2,c.CompletionItemKind.Constructor],[3,c.CompletionItemKind.Field],[4,c.CompletionItemKind.Variable],[5,c.CompletionItemKind.Class],[7,c.CompletionItemKind.Interface],[6,c.CompletionItemKind.Struct],[8,c.CompletionItemKind.Module],[9,c.CompletionItemKind.Property],[12,c.CompletionItemKind.Unit],[13,c.CompletionItemKind.Value],[14,c.CompletionItemKind.Constant],[15,c.CompletionItemKind.Enum],[16,c.CompletionItemKind.EnumMember],[17,c.CompletionItemKind.Keyword],[27,c.CompletionItemKind.Snippet],[18,c.CompletionItemKind.Text],[19,c.CompletionItemKind.Color],[20,c.CompletionItemKind.File],[21,c.CompletionItemKind.Reference],[23,c.CompletionItemKind.Folder],[10,c.CompletionItemKind.Event],[11,c.CompletionItemKind.Operator],[24,c.CompletionItemKind.TypeParameter],[25,c.CompletionItemKind.User],[26,c.CompletionItemKind.Issue]]);function Ae(Le){return q.get(Le)??c.CompletionItemKind.Property}Se.to=Ae})(Z=e.CompletionItemKind||(e.CompletionItemKind={}));var J;(function(Se){function Pe(fe,q){const Ae=new c.CompletionItem(fe.label);return Ae.insertText=fe.insertText,Ae.kind=Z.to(fe.kind),Ae.tags=fe.tags?.map(ue.to),Ae.detail=fe.detail,Ae.documentation=S.isMarkdownString(fe.documentation)?U.to(fe.documentation):fe.documentation,Ae.sortText=fe.sortText,Ae.filterText=fe.filterText,Ae.preselect=fe.preselect,Ae.commitCharacters=fe.commitCharacters,w.Range.isIRange(fe.range)?Ae.range=l.to(fe.range):typeof fe.range=="object"&&(Ae.range={inserting:l.to(fe.range.insert),replacing:l.to(fe.range.replace)}),Ae.keepWhitespace=typeof fe.insertTextRules>"u"?!1:Boolean(fe.insertTextRules&1),typeof fe.insertTextRules<"u"&&fe.insertTextRules&4?Ae.insertText=new c.SnippetString(fe.insertText):(Ae.insertText=fe.insertText,Ae.textEdit=Ae.range instanceof c.Range?new c.TextEdit(Ae.range,Ae.insertText):void 0),fe.additionalTextEdits&&fe.additionalTextEdits.length>0&&(Ae.additionalTextEdits=fe.additionalTextEdits.map(Le=>$.to(Le))),Ae.command=q&&fe.command?q.fromInternal(fe.command):void 0,Ae}Se.to=Pe})(J=e.CompletionItem||(e.CompletionItem={}));var I;(function(Se){function Pe(q){if(typeof q.label!="string"&&!Array.isArray(q.label))throw new TypeError("Invalid label");return{label:q.label,documentation:U.fromStrict(q.documentation)}}Se.from=Pe;function fe(q){return{label:q.label,documentation:S.isMarkdownString(q.documentation)?U.to(q.documentation):q.documentation}}Se.to=fe})(I=e.ParameterInformation||(e.ParameterInformation={}));var B;(function(Se){function Pe(q){return{label:q.label,documentation:U.fromStrict(q.documentation),parameters:Array.isArray(q.parameters)?q.parameters.map(I.from):[],activeParameter:q.activeParameter}}Se.from=Pe;function fe(q){return{label:q.label,documentation:S.isMarkdownString(q.documentation)?U.to(q.documentation):q.documentation,parameters:Array.isArray(q.parameters)?q.parameters.map(I.to):[],activeParameter:q.activeParameter}}Se.to=fe})(B=e.SignatureInformation||(e.SignatureInformation={}));var H;(function(Se){function Pe(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(B.from):[]}}Se.from=Pe;function fe(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(B.to):[]}}Se.to=fe})(H=e.SignatureHelp||(e.SignatureHelp={}));var j;(function(Se){function Pe(fe,q){const Ae=new c.InlayHint(n.to(q.position),typeof q.label=="string"?q.label:q.label.map(se.to.bind(void 0,fe)),q.kind&&le.to(q.kind));return Ae.textEdits=q.textEdits&&q.textEdits.map($.to),Ae.tooltip=S.isMarkdownString(q.tooltip)?U.to(q.tooltip):q.tooltip,Ae.paddingLeft=q.paddingLeft,Ae.paddingRight=q.paddingRight,Ae}Se.to=Pe})(j=e.InlayHint||(e.InlayHint={}));var se;(function(Se){function Pe(fe,q){const Ae=new c.InlayHintLabelPart(q.label);return Ae.tooltip=S.isMarkdownString(q.tooltip)?U.to(q.tooltip):q.tooltip,g.Command.is(q.command)&&(Ae.command=fe.fromInternal(q.command)),q.location&&(Ae.location=be.to(q.location)),Ae}Se.to=Pe})(se=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var le;(function(Se){function Pe(q){return q}Se.from=Pe;function fe(q){return q}Se.to=fe})(le=e.InlayHintKind||(e.InlayHintKind={}));var Y;(function(Se){function Pe(q){return{range:l.from(q.range),url:q.target,tooltip:q.tooltip}}Se.from=Pe;function fe(q){let Ae;if(q.url)try{Ae=typeof q.url=="string"?O.URI.parse(q.url,!0):O.URI.revive(q.url)}catch{}return new c.DocumentLink(l.to(q.range),Ae)}Se.to=fe})(Y=e.DocumentLink||(e.DocumentLink={}));var ve;(function(Se){function Pe(q){const Ae=new c.ColorPresentation(q.label);return q.textEdit&&(Ae.textEdit=$.to(q.textEdit)),q.additionalTextEdits&&(Ae.additionalTextEdits=q.additionalTextEdits.map(Le=>$.to(Le))),Ae}Se.to=Pe;function fe(q){return{label:q.label,textEdit:q.textEdit?$.from(q.textEdit):void 0,additionalTextEdits:q.additionalTextEdits?q.additionalTextEdits.map(Ae=>$.from(Ae)):void 0}}Se.from=fe})(ve=e.ColorPresentation||(e.ColorPresentation={}));var pe;(function(Se){function Pe(q){return new c.Color(q[0],q[1],q[2],q[3])}Se.to=Pe;function fe(q){return[q.red,q.green,q.blue,q.alpha]}Se.from=fe})(pe=e.Color||(e.Color={}));var Ne;(function(Se){function Pe(q){return{range:l.from(q.range)}}Se.from=Pe;function fe(q){return new c.SelectionRange(l.to(q.range))}Se.to=fe})(Ne=e.SelectionRange||(e.SelectionRange={}));var xe;(function(Se){function Pe(fe){switch(fe){case 2:return c.TextDocumentSaveReason.AfterDelay;case 1:return c.TextDocumentSaveReason.Manual;case 3:case 4:return c.TextDocumentSaveReason.FocusOut}}Se.to=Pe})(xe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ye;(function(Se){function Pe(q){switch(q){case c.TextEditorLineNumbersStyle.Off:return 0;case c.TextEditorLineNumbersStyle.Relative:return 2;case c.TextEditorLineNumbersStyle.On:default:return 1}}Se.from=Pe;function fe(q){switch(q){case 0:return c.TextEditorLineNumbersStyle.Off;case 2:return c.TextEditorLineNumbersStyle.Relative;case 1:default:return c.TextEditorLineNumbersStyle.On}}Se.to=fe})(Ye=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ge;(function(Se){function Pe(q){if(q===c.EndOfLine.CRLF)return 1;if(q===c.EndOfLine.LF)return 0}Se.from=Pe;function fe(q){if(q===1)return c.EndOfLine.CRLF;if(q===0)return c.EndOfLine.LF}Se.to=fe})(Ge=e.EndOfLine||(e.EndOfLine={}));var Te;(function(Se){function Pe(fe){if(typeof fe=="object")return fe.viewId;switch(fe){case c.ProgressLocation.SourceControl:return 3;case c.ProgressLocation.Window:return 10;case c.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Se.from=Pe})(Te=e.ProgressLocation||(e.ProgressLocation={}));var rt;(function(Se){function Pe(fe){const q={start:fe.start+1,end:fe.end+1};return fe.kind&&(q.kind=X.from(fe.kind)),q}Se.from=Pe})(rt=e.FoldingRange||(e.FoldingRange={}));var X;(function(Se){function Pe(fe){if(fe)switch(fe){case c.FoldingRangeKind.Comment:return g.FoldingRangeKind.Comment;case c.FoldingRangeKind.Imports:return g.FoldingRangeKind.Imports;case c.FoldingRangeKind.Region:return g.FoldingRangeKind.Region}}Se.from=Pe})(X=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Q;(function(Se){function Pe(fe){if(fe)return{pinned:typeof fe.preview=="boolean"?!fe.preview:void 0,inactive:fe.background,preserveFocus:fe.preserveFocus,selection:typeof fe.selection=="object"?l.from(fe.selection):void 0,override:typeof fe.override=="boolean"?a.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Se.from=Pe})(Q=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var he;(function(Se){function Pe(Le){return Le instanceof c.RelativePattern?Le.toJSON():typeof Le=="string"?Le:fe(Le)||q(Le)?new c.RelativePattern(Le.baseUri??Le.base,Le.pattern).toJSON():Le}Se.from=Pe;function fe(Le){const nt=Le;return nt?O.URI.isUri(nt.baseUri)&&typeof nt.pattern=="string":!1}function q(Le){const nt=Le;return nt?typeof nt.base=="string"&&typeof nt.pattern=="string":!1}function Ae(Le){return typeof Le=="string"?Le:new c.RelativePattern(O.URI.revive(Le.baseUri),Le.pattern)}Se.to=Ae})(he=e.GlobPattern||(e.GlobPattern={}));var Ue;(function(Se){function Pe(fe){if(fe){if(Array.isArray(fe))return fe.map(Pe);if(typeof fe=="string")return fe;{const q=fe;return{language:q.language,scheme:q.scheme,pattern:he.from(q.pattern),exclusive:q.exclusive,notebookType:q.notebookType}}}else return}Se.from=Pe})(Ue=e.LanguageSelector||(e.LanguageSelector={}));var je;(function(Se){function Pe(q){return{start:q.start,end:q.end}}Se.from=Pe;function fe(q){return new c.NotebookRange(q.start,q.end)}Se.to=fe})(je=e.NotebookRange||(e.NotebookRange={}));var Ze;(function(Se){function Pe(q){return{timing:typeof q.runStartTime=="number"&&typeof q.runEndTime=="number"?{startTime:q.runStartTime,endTime:q.runEndTime}:void 0,executionOrder:q.executionOrder,success:q.lastRunSuccess}}Se.to=Pe;function fe(q){return{lastRunSuccess:q.success,runStartTime:q.timing?.startTime,runEndTime:q.timing?.endTime,executionOrder:q.executionOrder}}Se.from=fe})(Ze=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ke;(function(Se){function Pe(fe){if(fe===u.NotebookCellExecutionState.Unconfirmed)return c.NotebookCellExecutionState.Pending;if(fe===u.NotebookCellExecutionState.Pending)return;if(fe===u.NotebookCellExecutionState.Executing)return c.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${fe}`)}Se.to=Pe})(Ke=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ve;(function(Se){function Pe(q){switch(q){case c.NotebookCellKind.Markup:return u.CellKind.Markup;case c.NotebookCellKind.Code:default:return u.CellKind.Code}}Se.from=Pe;function fe(q){switch(q){case u.CellKind.Markup:return c.NotebookCellKind.Markup;case u.CellKind.Code:default:return c.NotebookCellKind.Code}}Se.to=fe})(Ve=e.NotebookCellKind||(e.NotebookCellKind={}));var it;(function(Se){function Pe(q){const Ae={metadata:q.metadata??Object.create(null),cells:[]};for(const Le of q.cells)c.NotebookCellData.validate(Le),Ae.cells.push(st.from(Le));return Ae}Se.from=Pe;function fe(q){const Ae=new c.NotebookData(q.cells.map(st.to));return(0,P.isEmptyObject)(q.metadata)||(Ae.metadata=q.metadata),Ae}Se.to=fe})(it=e.NotebookData||(e.NotebookData={}));var st;(function(Se){function Pe(q){return{cellKind:Ve.from(q.kind),language:q.languageId,mime:q.mime,source:q.value,metadata:q.metadata,internalMetadata:Ze.from(q.executionSummary??{}),outputs:q.outputs?q.outputs.map(_t.from):[]}}Se.from=Pe;function fe(q){return new c.NotebookCellData(Ve.to(q.cellKind),q.source,q.language,q.mime,q.outputs?q.outputs.map(_t.to):void 0,q.metadata,q.internalMetadata?Ze.to(q.internalMetadata):void 0)}Se.to=fe})(st=e.NotebookCellData||(e.NotebookCellData={}));var dt;(function(Se){function Pe(q){return{mime:q.mime,valueBytes:C.VSBuffer.wrap(q.data)}}Se.from=Pe;function fe(q){return new c.NotebookCellOutputItem(q.valueBytes.buffer,q.mime)}Se.to=fe})(dt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var _t;(function(Se){function Pe(q){return{outputId:q.id,items:q.items.map(dt.from),metadata:q.metadata}}Se.from=Pe;function fe(q){const Ae=q.items.map(dt.to);return new c.NotebookCellOutput(Ae,q.outputId,q.metadata)}Se.to=fe})(_t=e.NotebookCellOutput||(e.NotebookCellOutput={}));var tt;(function(Se){function Pe(Ae){return q(Ae)?{include:(0,P.withNullAsUndefined)(he.from(Ae.include)),exclude:(0,P.withNullAsUndefined)(he.from(Ae.exclude))}:(0,P.withNullAsUndefined)(he.from(Ae))}Se.from=Pe;function fe(Ae){return q(Ae)?{include:he.to(Ae.include),exclude:he.to(Ae.exclude)}:he.to(Ae)}Se.to=fe;function q(Ae){const Le=Ae;return Le?!(0,P.isUndefinedOrNull)(Le.include)&&!(0,P.isUndefinedOrNull)(Le.exclude):!1}})(tt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ut;(function(Se){function Pe(fe,q,Ae){const Le=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{alignment:fe.alignment===c.NotebookCellStatusBarAlignment.Left?1:2,command:q.toInternal(Le,Ae),text:fe.text,tooltip:fe.tooltip,accessibilityInformation:fe.accessibilityInformation,priority:fe.priority}}Se.from=Pe})(ut=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Ot;(function(Se){function Pe(fe){return{transientOutputs:fe?.transientOutputs??!1,transientCellMetadata:fe?.transientCellMetadata??{},transientDocumentMetadata:fe?.transientDocumentMetadata??{},cellContentMetadata:fe?.cellContentMetadata??{}}}Se.from=Pe})(Ot=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ht;(function(Se){function Pe(q){return{uri:q.uri,provides:q.provides}}Se.from=Pe;function fe(q){return new c.NotebookRendererScript(O.URI.revive(q.uri),q.provides)}Se.to=fe})(Ht=e.NotebookRendererScript||(e.NotebookRendererScript={}));var At;(function(Se){function Pe(q){return{message:U.fromStrict(q.message)||"",type:0,expected:q.expectedOutput,actual:q.actualOutput,location:q.location&&{range:l.from(q.location.range),uri:q.location.uri}}}Se.from=Pe;function fe(q){const Ae=new c.TestMessage(typeof q.message=="string"?q.message:U.to(q.message));return Ae.actualOutput=q.actual,Ae.expectedOutput=q.expected,Ae.location=q.location?be.to(q.location):void 0,Ae}Se.to=fe})(At=e.TestMessage||(e.TestMessage={}));var ft;(function(Se){Se.namespace=v.namespaceTestTag,Se.denamespace=v.denamespaceTestTag})(ft=e.TestTag||(e.TestTag={}));var Ct;(function(Se){function Pe(q){const Ae=(0,m.getPrivateApiFor)(q).controllerId;return{extId:d.TestId.fromExtHostTestItem(q,Ae).toString(),label:q.label,uri:O.URI.revive(q.uri),busy:q.busy,tags:q.tags.map(Le=>ft.namespace(Ae,Le.id)),range:w.Range.lift(l.from(q.range)),description:q.description||null,sortText:q.sortText||null,error:q.error&&U.fromStrict(q.error)||null}}Se.from=Pe;function fe(q){return{parent:void 0,error:void 0,id:d.TestId.fromString(q.extId).localId,label:q.label,uri:O.URI.revive(q.uri),tags:(q.tags||[]).map(Ae=>{const{tagId:Le}=ft.denamespace(Ae);return new c.TestTag(Le)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:l.to(q.range||void 0),canResolveChildren:!1,busy:q.busy,description:q.description||void 0,sortText:q.sortText||void 0}}Se.toPlain=fe})(Ct=e.TestItem||(e.TestItem={})),function(Se){function Pe(q){return{id:q.id}}Se.from=Pe;function fe(q){return new c.TestTag(q.id)}Se.to=fe}(ft=e.TestTag||(e.TestTag={}));var Lt;(function(Se){const Pe=(q,Ae)=>{const Le=[];for(const[We,et]of Ae)d.TestId.compare(et.item.extId,We)===2&&(Ae.delete(We),Le.push(et));const nt={...Ct.toPlain(q.item),parent:void 0,taskStates:q.tasks.map(We=>({state:We.state,duration:We.duration,messages:We.messages.filter(et=>et.type===0).map(At.to)})),children:Le.map(We=>Pe(We,Ae))};for(const We of nt.children)We.parent=nt;return nt};function fe(q){const Ae=[],Le=new Map;for(const nt of q.items){Le.set(nt.item.extId,nt);const We=d.TestId.root(nt.item.extId);q.request.targets.some(et=>et.controllerId===We&&et.testIds.includes(nt.item.extId))&&Ae.push(nt)}return{completedAt:q.completedAt,results:Ae.map(nt=>Pe(nt,Le))}}Se.to=fe})(Lt=e.TestResults||(e.TestResults={}));var xt;(function(Se){function Pe(Le){return{covered:Le.covered,total:Le.covered}}function fe(Le){return"line"in Le?n.from(Le):l.from(Le)}function q(Le){return"branches"in Le?{count:Le.executionCount,location:fe(Le.location),type:1,branches:Le.branches.length?Le.branches.map(nt=>({count:nt.executionCount,location:nt.location&&fe(nt.location)})):void 0}:{type:0,count:Le.executionCount,location:fe(Le.location)}}Se.fromDetailed=q;function Ae(Le){return{uri:Le.uri,statement:Pe(Le.statementCoverage),branch:Le.branchCoverage&&Pe(Le.branchCoverage),function:Le.functionCoverage&&Pe(Le.functionCoverage),details:Le.detailedCoverage?.map(q)}}Se.fromFile=Ae})(xt=e.TestCoverage||(e.TestCoverage={}));var qe;(function(Se){function Pe(fe){switch(fe){case 1:return c.CodeActionTriggerKind.Invoke;case 2:return c.CodeActionTriggerKind.Automatic}}Se.to=Pe})(qe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ft;(function(Se){function Pe(q){const Ae=new c.TypeHierarchyItem(re.to(q.kind),q.name,q.detail||"",O.URI.revive(q.uri),l.to(q.range),l.to(q.selectionRange));return Ae._sessionId=q._sessionId,Ae._itemId=q._itemId,Ae}Se.to=Pe;function fe(q,Ae,Le){if(Ae=Ae??q._sessionId,Le=Le??q._itemId,Ae===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Le,kind:re.from(q.kind),name:q.name,detail:q.detail??"",uri:q.uri,range:l.from(q.range),selectionRange:l.from(q.selectionRange),tags:q.tags?.map(ge.from)}}Se.from=fe})(Ft=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var It;(function(Se){function Pe(fe){if(!!fe)return{value:fe.value,tooltip:fe.tooltip}}Se.from=Pe})(It=e.ViewBadge||(e.ViewBadge={}));var Mt;(function(Se){function Pe(fe,q){const Ae=fe.fileData;return Ae?new class extends c.DataTransferItem{asFile(){return{name:Ae.name,uri:O.URI.revive(Ae.uri),data:(0,b.once)(()=>q())}}}("",fe.id):new c.DataTransferItem(fe.asString)}Se.toDataTransferItem=Pe})(Mt=e.DataTransferItem||(e.DataTransferItem={}));var gt;(function(Se){function Pe(q,Ae){const Le=q.items.map(([nt,We])=>[nt,Mt.toDataTransferItem(We,()=>Ae(We.id))]);return new c.DataTransfer(Le)}Se.toDataTransfer=Pe;async function fe(q){const Ae={items:[]},Le=[];return q.forEach((nt,We)=>{Le.push((async()=>{const et=await nt.asString(),lt=nt.asFile();Ae.items.push([We,{id:nt.id,asString:et,fileData:lt?{name:lt.name,uri:lt.uri}:void 0}])})())}),await Promise.all(Le),Ae}Se.toDataTransferDTO=fe})(gt=e.DataTransfer||(e.DataTransfer={}))}),define(Ce[178],Ie([1,0,2,12,6,8,242]),function(ie,e,r,C,S,N,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(P,O,w,g={timeout:1500,errors:3}){this._logService=P,this._documents=O,this._mainThreadBulkEdits=w,this._thresholds=g,this._callbacks=new _.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(O,w,g)=>{const m={dispose:this._callbacks.push([O,w,P])};return Array.isArray(g)&&g.push(m),m}}async $participateInSave(P,O){const w=r.URI.revive(P);let g=!1;const k=setTimeout(()=>g=!0,this._thresholds.timeout),m=[];try{for(const a of[...this._callbacks]){if(g)break;const u=this._documents.getDocument(w),d=await this._deliverEventAsyncAndBlameBadListeners(a,{document:u,reason:N.TextDocumentSaveReason.to(O)});m.push(d)}}finally{clearTimeout(k)}return m}_deliverEventAsyncAndBlameBadListeners([P,O,w],g){const k=this._badListeners.get(P);return typeof k=="number"&&k>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(w,P,O,g).then(()=>!0,m=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' threw ERROR`),this._logService.error(m),!(m instanceof Error)||m.message!=="concurrent_edits"){const a=this._badListeners.get(P);this._badListeners.set(P,a?a+1:1),typeof a=="number"&&a>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,O,w,g){const k=[],m=Date.now(),{document:a,reason:u}=g,{version:d}=a,v=Object.freeze({document:a,reason:u,waitUntil(D){if(Object.isFrozen(k))throw(0,C.illegalState)("waitUntil can not be called async");k.push(Promise.resolve(D))}});try{O.apply(w,[v])}catch(D){return Promise.reject(D)}return Object.freeze(k),new Promise((D,c)=>{const b=setTimeout(()=>c(new Error("timeout")),this._thresholds.timeout);return Promise.all(k).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-m}ms`),clearTimeout(b),D(t)}).catch(t=>{clearTimeout(b),c(t)})}).then(D=>{const c={edits:[]};for(const b of D)if(Array.isArray(b)&&b.every(t=>t instanceof S.TextEdit))for(const{newText:t,newEol:l,range:i}of b)c.edits.push({resource:a.uri,versionId:void 0,textEdit:{range:i&&N.Range.from(i),text:t,eol:l&&N.EndOfLine.from(l)}});if(c.edits.length!==0)return d===a.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(Ce[179],Ie([1,0,13,2,8,6,64]),function(ie,e,r,C,S,N,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class A{constructor(w,g,k,m){this.start=w,this.deletedCount=g,this.deletedItems=k,this.items=m}asApiEvent(){return{range:new N.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(w=>w.apiCell),removedCells:this.deletedItems}}}class E{static asModelAddData(w,g){return{EOL:g.eol,lines:g.source,languageId:g.language,uri:g.uri,isDirty:!1,versionId:1,notebook:w}}constructor(w,g,k){this.notebook=w,this._extHostDocument=g,this._cellData=k,this.handle=k.handle,this.uri=C.URI.revive(k.uri),this.cellKind=k.cellKind,this._outputs=k.outputs.map(S.NotebookCellOutput.to),this._internalMetadata=k.internalMetadata??{},this._metadata=Object.freeze(k.metadata??{}),this._previousResult=Object.freeze(S.NotebookCellExecutionSummary.to(k.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const w=this,g=this._extHostDocument.getDocument(this.uri);if(!g)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const k={get index(){return w.notebook.getCellIndex(w)},notebook:w.notebook.apiNotebook,kind:S.NotebookCellKind.to(this._cellData.cellKind),document:g.document,get mime(){return w._mime},set mime(m){w._mime=m},get outputs(){return w._outputs.slice(0)},get metadata(){return w._metadata},get executionSummary(){return w._previousResult}};this._apiCell=Object.freeze(k)}return this._apiCell}setOutputs(w){this._outputs=w.map(S.NotebookCellOutput.to)}setOutputItems(w,g,k){const m=k.map(S.NotebookCellOutputItem.to),a=this._outputs.find(u=>u.id===w);a&&(g||(a.items.length=0),a.items.push(...m))}setMetadata(w){this._metadata=Object.freeze(w)}setInternalMetadata(w){this._internalMetadata=w,this._previousResult=Object.freeze(S.NotebookCellExecutionSummary.to(w))}setMime(w){}}e.ExtHostCell=E;class P{constructor(w,g,k,m,a){this._proxy=w,this._textDocumentsAndEditors=g,this._textDocuments=k,this.uri=m,this.handle=P._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=a.viewType,this._metadata=Object.freeze(a.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,a.cells]],!0,void 0),this._versionId=a.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const w=this,g={get uri(){return w.uri},get version(){return w._versionId},get notebookType(){return w._notebookType},get isDirty(){return w._isDirty},get isUntitled(){return w.uri.scheme===r.Schemas.untitled},get isClosed(){return w._disposed},get metadata(){return w._metadata},get cellCount(){return w._cells.length},cellAt(k){return k=w._validateIndex(k),w._cells[k].apiCell},getCells(k){return(k?w._getCells(k):w._cells).map(a=>a.apiCell)},save(){return w._save()}};this._notebook=Object.freeze(g)}return this._notebook}acceptDocumentPropertiesChanged(w){w.metadata&&(this._metadata=Object.freeze({...this._metadata,...w.metadata}))}acceptDirty(w){this._isDirty=w}acceptModelChanged(w,g,k){this._versionId=w.versionId,this._isDirty=g,this.acceptDocumentPropertiesChanged({metadata:k});const m={notebook:this.apiNotebook,metadata:k,cellChanges:[],contentChanges:[]},a=[];for(const d of w.rawEvents)d.kind===_.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(d.changes,!1,m.contentChanges):d.kind===_.NotebookCellsChangeType.Move?this._moveCell(d.index,d.newIdx,m.contentChanges):d.kind===_.NotebookCellsChangeType.Output?(this._setCellOutputs(d.index,d.outputs),a.push({cell:this._cells[d.index].apiCell,outputs:this._cells[d.index].apiCell.outputs})):d.kind===_.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(d.index,d.outputId,d.append,d.outputItems),a.push({cell:this._cells[d.index].apiCell,outputs:this._cells[d.index].apiCell.outputs})):d.kind===_.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(d.index,d.language),a.push({cell:this._cells[d.index].apiCell,document:this._cells[d.index].apiCell.document})):d.kind===_.NotebookCellsChangeType.ChangeCellContent?a.push({cell:this._cells[d.index].apiCell,document:this._cells[d.index].apiCell.document}):d.kind===_.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(d.index,d.mime):d.kind===_.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(d.index,d.metadata),a.push({cell:this._cells[d.index].apiCell,metadata:this._cells[d.index].apiCell.metadata})):d.kind===_.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(d.index,d.internalMetadata),a.push({cell:this._cells[d.index].apiCell,executionSummary:this._cells[d.index].apiCell.executionSummary}));const u=new Map;for(let d=0;d<a.length;d++){const v=a[d],D=u.get(v.cell);if(D===void 0){const c=m.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...v});u.set(v.cell,c-1)}else m.cellChanges[D]={...m.cellChanges[D],...v}}return Object.freeze(m),Object.freeze(m.cellChanges),Object.freeze(m.contentChanges),m}_validateIndex(w){return w=w|0,w<0?0:w>=this._cells.length?this._cells.length-1:w}_validateRange(w){let g=w.start|0,k=w.end|0;return g<0&&(g=0),k>this._cells.length&&(k=this._cells.length),w.with({start:g,end:k})}_getCells(w){w=this._validateRange(w);const g=[];for(let k=w.start;k<w.end;k++)g.push(this._cells[k]);return g}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(w,g,k){if(this._disposed)return;const m=[],a=[],u=[];if(w.reverse().forEach(d=>{const D=d[2].map(t=>{const l=new E(this,this._textDocumentsAndEditors,t);return g||a.push(E.asModelAddData(this.apiNotebook,t)),l}),c=new A(d[0],d[1],[],D),b=this._cells.splice(d[0],d[1],...D);for(const t of b)u.push(t.uri),c.deletedItems.push(t.apiCell);m.push(c)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:u}),k)for(const d of m)k.push(d.asApiEvent())}_moveCell(w,g,k){const m=this._cells.splice(w,1);this._cells.splice(g,0,...m);const a=[new A(w,1,m.map(u=>u.apiCell),[]),new A(g,0,[],m)];for(const u of a)k.push(u.asApiEvent())}_setCellOutputs(w,g){this._cells[w].setOutputs(g)}_setCellOutputItems(w,g,k,m){this._cells[w].setOutputItems(g,k,m)}_changeCellLanguage(w,g){const k=this._cells[w];k.apiCell.document.languageId!==g&&this._textDocuments.$acceptModelLanguageChanged(k.uri,g)}_changeCellMime(w,g){const k=this._cells[w];k.apiCell.mime=g}_changeCellMetadata(w,g){this._cells[w].setMetadata(g)}_changeCellInternalMetadata(w,g){this._cells[w].setInternalMetadata(g)}getCellFromApiCell(w){return this._cells.find(g=>g.apiCell===w)}getCellFromIndex(w){return this._cells[w]}getCell(w){return this._cells.find(g=>g.handle===w)}getCellIndex(w){return this._cells.indexOf(w)}}e.ExtHostNotebookDocument=P,P._handlePool=0}),define(Ce[94],Ie([1,0,12,8,6]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class N{constructor(A,E,P,O,w,g){this.id=A,this._proxy=E,this.notebookData=P,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=w,this._visibleRanges=O,this._viewColumn=g}get apiEditor(){if(!this._editor){const A=this;this._editor={get document(){return A.notebookData.apiNotebook},get notebook(){return A.notebookData.apiNotebook},get selection(){return A._selections[0]},set selection(E){this.selections=[E]},get selections(){return A._selections},set selections(E){if(!Array.isArray(E)||!E.every(S.NotebookRange.isNotebookRange))throw(0,r.illegalArgument)("selections");A._selections=E,A._trySetSelections(E)},get visibleRanges(){return A._visibleRanges},revealRange(E,P){A._proxy.$tryRevealRange(A.id,C.NotebookRange.from(E),P??S.NotebookEditorRevealType.Default)},get viewColumn(){return A._viewColumn}},N.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(A){this._visible=A}_acceptVisibleRanges(A){this._visibleRanges=A}_acceptSelections(A){this._selections=A}_trySetSelections(A){this._proxy.$trySetSelections(this.id,A.map(C.NotebookRange.from))}_acceptViewColumn(A){this._viewColumn=A}}e.ExtHostNotebookEditor=N,N.apiEditorsToExtHost=new WeakMap}),define(Ce[180],Ie([1,0,5,14,8]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let N=class{constructor(A,E){this._logService=A,this._notebooksAndEditors=E,this._onDidChangeNotebookEditorSelection=new r.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new r.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(A,E){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",A,E);const P=this._notebooksAndEditors.getEditorById(A);E.visibleRanges&&P._acceptVisibleRanges(E.visibleRanges.ranges.map(S.NotebookRange.to)),E.selections&&P._acceptSelections(E.selections.selections.map(S.NotebookRange.to)),E.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:P.apiEditor,visibleRanges:P.apiEditor.visibleRanges}),E.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:P.apiEditor,selections:P.apiEditor.selections}))}$acceptEditorViewColumns(A){for(const E in A)this._notebooksAndEditors.getEditorById(E)._acceptViewColumn(S.ViewColumn.to(A[E]))}};N=ze([$e(0,C.ILogService)],N),e.ExtHostNotebookEditors=N}),define(Ce[181],Ie([1,0,8,151,132,20,55,12]),function(ie,e,r,C,S,N,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class E{constructor(g){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=g}async withProgress(g,k,m){const a=this._handles++,{title:u,location:d,cancellable:v}=k,D={label:(0,S.localize)(0,null,g.displayName||g.name),id:g.identifier.value};return this._proxy.$startProgress(a,{location:r.ProgressLocation.from(d),title:u,source:D,cancellable:v},g.isUnderDevelopment?void 0:g.identifier.value).catch(A.onUnexpectedExternalError),this._withProgress(a,m,!!v)}_withProgress(g,k,m){let a;m&&(a=new N.CancellationTokenSource,this._mapHandleToCancellationSource.set(g,a));const u=v=>{this._proxy.$progressEnd(v),this._mapHandleToCancellationSource.delete(v),a?.dispose()};let d;try{d=k(new O(this._proxy,g),m&&a?a.token:N.CancellationToken.None)}catch(v){throw u(g),v}return d.then(v=>u(g),v=>u(g)),d}$acceptProgressCanceled(g){const k=this._mapHandleToCancellationSource.get(g);k&&(k.cancel(),this._mapHandleToCancellationSource.delete(g))}}e.ExtHostProgress=E;function P(w,g){return w.message=g.message,typeof g.increment=="number"&&(typeof w.increment=="number"?w.increment+=g.increment:w.increment=g.increment),w}class O extends C.Progress{constructor(g,k){super(m=>this.throttledReport(m)),this._proxy=g,this._handle=k}throttledReport(g){this._proxy.$progressReport(this._handle,g)}}ze([(0,_.throttle)(100,(w,g)=>P(w,g),()=>Object.create(null))],O.prototype,"throttledReport",null)}),define(Ce[95],Ie([1,0,49,90,40,65,48,8,2]),function(ie,e,r,C,S,N,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const P=(D,c,b,t)=>{let l=c;return{enumerable:!0,configurable:!1,get(){return l},set(i){if(!b(l,i)){const n=l;l=i,D.listener?.(t(i,n))}}}},O=(D,c)=>D===c,w={range:(D,c)=>D===c?!0:!D||!c?!1:D.isEqual(c),label:O,description:O,sortText:O,busy:O,error:O,canResolveChildren:O,tags:(D,c)=>!(D.length!==c.length||D.some(b=>!c.find(t=>b.id===t.id)))},g=D=>c=>({op:4,update:D(c)}),k=(D,c)=>({range:(()=>{let b;const t=g(l=>({range:r.Range.lift(A.Range.from(l))}));return{enumerable:!0,configurable:!1,get(){return b},set(l){D.listener?.({op:6}),w.range(b,l)||(b=l,D.listener?.(t(l)))}}})(),label:P(D,c,w.label,g(b=>({label:b}))),description:P(D,void 0,w.description,g(b=>({description:b}))),sortText:P(D,void 0,w.sortText,g(b=>({sortText:b}))),canResolveChildren:P(D,!1,w.canResolveChildren,b=>({op:2,state:b})),busy:P(D,!1,w.busy,g(b=>({busy:b}))),error:P(D,void 0,w.error,g(b=>({error:A.MarkdownString.fromStrict(b)||null}))),tags:P(D,[],w.tags,(b,t)=>({op:1,new:b.map(A.TestTag.from),old:t.map(A.TestTag.from)}))}),m=D=>{const c=S.TestId.fromString(D.extId),b=new u(c.controllerId,c.localId,D.label,E.URI.revive(D.uri)||void 0);return b.range=A.Range.to(D.range||void 0),b.description=D.description||void 0,b.sortText=D.sortText||void 0,b.tags=D.tags.map(t=>A.TestTag.to({id:(0,_.denamespaceTestTag)(t).tagId})),b},a=D=>{let c;for(const b of D.tests){const t=m(b.item);(0,C.getPrivateApiFor)(t).parent=c,c=t}return c};e.toItemFromContext=a;class u{constructor(c,b,t,l){if(b.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(b)} symbol`);const i=(0,C.createPrivateApiFor)(this,c);Object.defineProperties(this,{id:{value:b,enumerable:!0,writable:!1},uri:{value:l,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return i.parent instanceof d?void 0:i.parent}},children:{value:(0,N.createTestItemChildren)(i,C.getPrivateApiFor,u),enumerable:!0,writable:!1},...k(i,t)})}}e.TestItemImpl=u;class d extends u{constructor(c,b){super(c,c,b,void 0),this._isRoot=!0}}e.TestItemRootImpl=d;class v extends N.TestItemCollection{constructor(c,b,t){super({controllerId:c,getDocumentVersion:l=>l&&t.getDocument(l)?.version,getApiFor:C.getPrivateApiFor,getChildren:l=>l.children,root:new d(c,b),toITestItem:A.TestItem.from})}}e.ExtHostTestItemCollection=v}),define(Ce[96],Ie([1,0,45,12,74,8,6]),function(ie,e,r,C,S,N,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class A{constructor(g,k,m){const a=A._Keys.nextId();g.$registerTextEditorDecorationType(k.identifier,a,N.DecorationRenderOptions.from(m)),this.value=Object.freeze({key:a,dispose(){g.$removeTextEditorDecorationType(a)}})}}e.TextEditorDecorationType=A,A._Keys=new S.IdGenerator("TextEditorDecorationType");class E{constructor(g,k){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=g,this._documentVersionId=g.version,this._undoStopBefore=k.undoStopBefore,this._undoStopAfter=k.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(g,k){this._throwIfFinalized();let m=null;if(g instanceof _.Position)m=new _.Range(g,g);else if(g instanceof _.Range)m=g;else throw new Error("Unrecognized location");this._pushEdit(m,k,!1)}insert(g,k){this._throwIfFinalized(),this._pushEdit(new _.Range(g,g),k,!0)}delete(g){this._throwIfFinalized();let k=null;if(g instanceof _.Range)k=g;else throw new Error("Unrecognized location");this._pushEdit(k,null,!0)}_pushEdit(g,k,m){const a=this._document.validateRange(g);this._collectedEdits.push({range:a,text:k,forceMoveMarkers:m})}setEndOfLine(g){if(this._throwIfFinalized(),g!==_.EndOfLine.LF&&g!==_.EndOfLine.CRLF)throw(0,C.illegalArgument)("endOfLine");this._setEndOfLine=g}}e.TextEditorEdit=E;class P{constructor(g,k,m,a){this._proxy=g,this._id=k,this._accept(m),this._logService=a;const u=this;this.value={get tabSize(){return u._tabSize},set tabSize(d){u._setTabSize(d)},get insertSpaces(){return u._insertSpaces},set insertSpaces(d){u._setInsertSpaces(d)},get cursorStyle(){return u._cursorStyle},set cursorStyle(d){u._setCursorStyle(d)},get lineNumbers(){return u._lineNumbers},set lineNumbers(d){u._setLineNumbers(d)}}}_accept(g){this._tabSize=g.tabSize,this._insertSpaces=g.insertSpaces,this._cursorStyle=g.cursorStyle,this._lineNumbers=N.TextEditorLineNumbersStyle.to(g.lineNumbers)}_validateTabSize(g){if(g==="auto")return"auto";if(typeof g=="number"){const k=Math.floor(g);return k>0?k:null}if(typeof g=="string"){const k=parseInt(g,10);return isNaN(k)?null:k>0?k:null}return null}_setTabSize(g){const k=this._validateTabSize(g);if(k!==null){if(typeof k=="number"){if(this._tabSize===k)return;this._tabSize=k}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:k}))}}_validateInsertSpaces(g){return g==="auto"?"auto":g==="false"?!1:Boolean(g)}_setInsertSpaces(g){const k=this._validateInsertSpaces(g);if(typeof k=="boolean"){if(this._insertSpaces===k)return;this._insertSpaces=k}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:k}))}_setCursorStyle(g){this._cursorStyle!==g&&(this._cursorStyle=g,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:g})))}_setLineNumbers(g){this._lineNumbers!==g&&(this._lineNumbers=g,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:N.TextEditorLineNumbersStyle.from(g)})))}assign(g){const k={};let m=!1;if(typeof g.tabSize<"u"){const a=this._validateTabSize(g.tabSize);a==="auto"?(m=!0,k.tabSize=a):typeof a=="number"&&this._tabSize!==a&&(this._tabSize=a,m=!0,k.tabSize=a)}if(typeof g.insertSpaces<"u"){const a=this._validateInsertSpaces(g.insertSpaces);a==="auto"?(m=!0,k.insertSpaces=a):this._insertSpaces!==a&&(this._insertSpaces=a,m=!0,k.insertSpaces=a)}typeof g.cursorStyle<"u"&&this._cursorStyle!==g.cursorStyle&&(this._cursorStyle=g.cursorStyle,m=!0,k.cursorStyle=g.cursorStyle),typeof g.lineNumbers<"u"&&this._lineNumbers!==g.lineNumbers&&(this._lineNumbers=g.lineNumbers,m=!0,k.lineNumbers=N.TextEditorLineNumbersStyle.from(g.lineNumbers)),m&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,k))}_warnOnError(g,k){k.catch(m=>{this._logService.warn(`ExtHostTextEditorOptions '${g}' failed:'`),this._logService.warn(m)})}}e.ExtHostTextEditorOptions=P;class O{constructor(g,k,m,a,u,d,v,D){this.id=g,this._proxy=k,this._logService=m,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=u,this._options=new P(this._proxy,this.id,d,m),this._visibleRanges=v,this._viewColumn=D;const c=this;this.value=Object.freeze({get document(){return a.getValue()},set document(b){throw(0,C.readonly)("document")},get selection(){return c._selections&&c._selections[0]},set selection(b){if(!(b instanceof _.Selection))throw(0,C.illegalArgument)("selection");c._selections=[b],c._trySetSelection()},get selections(){return c._selections},set selections(b){if(!Array.isArray(b)||b.some(t=>!(t instanceof _.Selection)))throw(0,C.illegalArgument)("selections");c._selections=b,c._trySetSelection()},get visibleRanges(){return c._visibleRanges},set visibleRanges(b){throw(0,C.readonly)("visibleRanges")},get options(){return c._options.value},set options(b){c._disposed||c._options.assign(b)},get viewColumn(){return c._viewColumn},set viewColumn(b){throw(0,C.readonly)("viewColumn")},edit(b,t={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const l=new E(a.getValue(),t);return b(l),c._applyEdit(l)},insertSnippet(b,t,l={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let i;if(!t||Array.isArray(t)&&t.length===0)i=c._selections.map(n=>N.Range.from(n));else if(t instanceof _.Position){const{lineNumber:n,column:o}=N.Position.from(t);i=[{startLineNumber:n,startColumn:o,endLineNumber:n,endColumn:o}]}else if(t instanceof _.Range)i=[N.Range.from(t)];else{i=[];for(const n of t)if(n instanceof _.Range)i.push(N.Range.from(n));else{const{lineNumber:o,column:f}=N.Position.from(n);i.push({startLineNumber:o,startColumn:f,endLineNumber:o,endColumn:f})}}return k.$tryInsertSnippet(g,a.getValue().version,b.value,i,l)},setDecorations(b,t){const l=t.length===0;l&&!c._hasDecorationsForKey.has(b.key)||(l?c._hasDecorationsForKey.delete(b.key):c._hasDecorationsForKey.add(b.key),c._runOnProxy(()=>{if(N.isDecorationOptionsArr(t))return k.$trySetDecorations(g,b.key,N.fromRangeOrRangeWithMessage(t));{const i=new Array(4*t.length);for(let n=0,o=t.length;n<o;n++){const f=t[n];i[4*n]=f.start.line+1,i[4*n+1]=f.start.character+1,i[4*n+2]=f.end.line+1,i[4*n+3]=f.end.character+1}return k.$trySetDecorationsFast(g,b.key,i)}}))},revealRange(b,t){c._runOnProxy(()=>k.$tryRevealRange(g,N.Range.from(b),t||_.TextEditorRevealType.Default))},show(b){k.$tryShowEditor(g,N.ViewColumn.from(b))},hide(){k.$tryHideEditor(g)}})}dispose(){(0,r.ok)(!this._disposed),this._disposed=!0}_acceptOptions(g){(0,r.ok)(!this._disposed),this._options._accept(g)}_acceptVisibleRanges(g){(0,r.ok)(!this._disposed),this._visibleRanges=g}_acceptViewColumn(g){(0,r.ok)(!this._disposed),this._viewColumn=g}_acceptSelections(g){(0,r.ok)(!this._disposed),this._selections=g}async _trySetSelection(){const g=this._selections.map(N.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,g)),this.value}_applyEdit(g){const k=g.finalize();if(k.edits.length===0&&!k.setEndOfLine)return Promise.resolve(!0);const m=k.edits.map(u=>u.range);m.sort((u,d)=>u.end.line===d.end.line?u.end.character===d.end.character?u.start.line===d.start.line?u.start.character-d.start.character:u.start.line-d.start.line:u.end.character-d.end.character:u.end.line-d.end.line);for(let u=0,d=m.length-1;u<d;u++){const v=m[u].end;if(m[u+1].start.isBefore(v))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=k.edits.map(u=>({range:N.Range.from(u.range),text:u.text,forceMoveMarkers:u.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,k.documentVersionId,a,{setEndOfLine:typeof k.setEndOfLine=="number"?N.EndOfLine.from(k.setEndOfLine):void 0,undoStopBefore:k.undoStopBefore,undoStopAfter:k.undoStopAfter})}_runOnProxy(g){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):g().then(()=>this,k=>(k instanceof Error&&k.name==="DISPOSED"||this._logService.warn(k),null))}}e.ExtHostTextEditor=O}),define(Ce[182],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionLog:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionLog.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineCompletionsNew:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsNew.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",localization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.localization.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookContentProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookContentProvider.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDebugOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDebugOptions.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditor.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLog:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLog.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ce[183],Ie([1,0,143,12,29,81,84,30,26,182,150]),function(ie,e,r,C,S,N,_,A,E,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const w=A.Registry.as(_.Extensions.JSONContribution);class g{constructor(c,b,t){this._messageHandler=c,this._extension=b,this._extensionPointId=t}_msg(c,b){this._messageHandler({type:c,message:b,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(c){this._msg(S.default.Error,c)}warn(c){this._msg(S.default.Warning,c)}info(c){this._msg(S.default.Info,c)}}e.ExtensionMessageCollector=g;class k{static _toSet(c){const b=new Set;for(let t=0,l=c.length;t<l;t++)b.add(E.ExtensionIdentifier.toKey(c[t].description.identifier));return b}static compute(c,b){if(!c||!c.length)return new k(b,[]);if(!b||!b.length)return new k([],c);const t=this._toSet(c),l=this._toSet(b),i=b.filter(o=>!t.has(E.ExtensionIdentifier.toKey(o.description.identifier))),n=c.filter(o=>!l.has(E.ExtensionIdentifier.toKey(o.description.identifier)));return new k(i,n)}constructor(c,b){this.added=c,this.removed=b}}e.ExtensionPointUserDelta=k;class m{constructor(c,b){this.name=c,this.defaultExtensionKind=b,this._handler=null,this._users=null,this._delta=null}setHandler(c){if(this._handler!==null)throw new Error("Handler already set!");this._handler=c,this._handle()}acceptUsers(c){this._delta=k.compute(this._users,c),this._users=c,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(c){(0,C.onUnexpectedError)(c)}}}e.ExtensionPoint=m;const a={type:"string",enum:["ui","workspace"],enumDescriptions:[r.localize(0,null),r.localize(1,null)]},u="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:r.localize(2,null),properties:{vscode:{type:"string",description:r.localize(3,null),default:"^1.22.0"}}},publisher:{description:r.localize(4,null),type:"string"},displayName:{description:r.localize(5,null),type:"string"},categories:{description:r.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:E.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:r.localize(7,null)}]}},galleryBanner:{type:"object",description:r.localize(8,null),properties:{color:{description:r.localize(9,null),type:"string"},theme:{description:r.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:r.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:r.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:r.localize(13,null)},enabledApiProposals:{markdownDescription:r.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(P.allApiProposals),markdownEnumDescriptions:Object.values(P.allApiProposals)}},activationEvents:{description:r.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:r.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:r.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:r.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:r.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:r.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:r.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:r.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:r.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:r.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:r.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:r.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:r.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:r.localize(28,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:r.localize(29,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:r.localize(30,null)},{label:"onIdentity",body:"onIdentity:${8:identity}",description:r.localize(31,null)},{label:"onUri",body:"onUri",description:r.localize(32,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:r.localize(33,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:r.localize(34,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:r.localize(35,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:r.localize(36,null)},{label:"onRenderer",description:r.localize(37,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:r.localize(38,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:r.localize(39,null)},{label:"*",description:r.localize(40,null),body:"*"}]}},badges:{type:"array",description:r.localize(41,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:r.localize(42,null)},href:{type:"string",description:r.localize(43,null)},description:{type:"string",description:r.localize(44,null)}}}},markdown:{type:"string",description:r.localize(45,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:r.localize(46,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:r.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:r.localize(48,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:r.localize(49,null),type:"array",items:a,default:["workspace"],defaultSnippets:[{body:["ui"],description:r.localize(50,null)},{body:["workspace"],description:r.localize(51,null)},{body:["ui","workspace"],description:r.localize(52,null)},{body:["workspace","ui"],description:r.localize(53,null)},{body:[],description:r.localize(54,null)}]},capabilities:{description:r.localize(55,null),type:"object",properties:{virtualWorkspaces:{description:r.localize(56,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:r.localize(57,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(58,null),r.localize(59,null),r.localize(60,null)]},description:{type:"string",markdownDescription:r.localize(61,null)}}},untrustedWorkspaces:{description:r.localize(62,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:r.localize(63,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(64,null),r.localize(65,null),r.localize(66,null)]},restrictedConfigurations:{description:r.localize(67,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:r.localize(68,null)}}}}},sponsor:{description:r.localize(69,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:r.localize(70,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:r.localize(71,null),type:"string"},"vscode:uninstall":{description:r.localize(72,null),type:"string"}}},icon:{type:"string",description:r.localize(73,null)},l10n:{type:"string",description:r.localize(74,null)}}};class d{constructor(){this._extensionPoints=new Map}registerExtensionPoint(c){if(this._extensionPoints.has(c.extensionPoint))throw new Error("Duplicate extension point: "+c.extensionPoint);const b=new m(c.extensionPoint,c.defaultExtensionKind);return this._extensionPoints.set(c.extensionPoint,b),e.schema.properties.contributes.properties[c.extensionPoint]=c.jsonSchema,w.registerSchema(u,e.schema),b}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=d;const v={ExtensionsRegistry:"ExtensionsRegistry"};A.Registry.add(v.ExtensionsRegistry,new d),e.ExtensionsRegistry=A.Registry.as(v.ExtensionsRegistry),w.registerSchema(u,e.schema),w.registerSchema(O.productSchemaId,{properties:{extensionEnabledApiProposals:{description:r.localize(75,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(P.allApiProposals),markdownEnumDescriptions:Object.values(P.allApiProposals)}}]}}}})}),define(Ce[184],Ie([1,0,140,10,25,183,39,5]),function(ie,e,r,C,S,N,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=e.TaskDefinitionRegistryImpl=void 0;const E={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:r.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:r.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:r.localize(2,null),default:""}}};var P;(function(g){function k(m,a,u){if(!m)return;const d=C.isString(m.type)?m.type:void 0;if(!d||d.length===0){u.error(r.localize(3,null));return}const v=[];if(Array.isArray(m.required))for(const D of m.required)C.isString(D)&&v.push(D);return{extensionId:a.value,taskType:d,required:v,properties:m.properties?S.deepClone(m.properties):{},when:m.when?_.ContextKeyExpr.deserialize(m.when):void 0}}g.from=k})(P||(P={}));const O=N.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:r.localize(4,null),type:"array",items:E}});class w{constructor(){this._onDefinitionsChanged=new A.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((k,m)=>{O.setHandler((a,u)=>{this._schema=void 0;try{for(const d of u.removed){const v=d.value;for(const D of v)this.taskTypes&&D.type&&this.taskTypes[D.type]&&delete this.taskTypes[D.type]}for(const d of u.added){const v=d.value;for(const D of v){const c=P.from(D,d.description.identifier,d.collector);c&&(this.taskTypes[c.taskType]=c)}}(u.removed.length>0||u.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}k(void 0)})})}onReady(){return this.readyPromise}get(k){return this.taskTypes[k]}all(){return Object.keys(this.taskTypes).map(k=>this.taskTypes[k])}getJsonSchema(){if(this._schema===void 0){const k=[];for(const m of this.all()){const a={type:"object",additionalProperties:!1};m.required.length>0&&(a.required=m.required.slice(0)),m.properties!==void 0?a.properties=S.deepClone(m.properties):a.properties=Object.create(null),a.properties.type={type:"string",enum:[m.taskType]},k.push(a)}this._schema={oneOf:k}}return this._schema}}e.TaskDefinitionRegistryImpl=w,e.TaskDefinitionRegistry=new w}),define(Ce[185],Ie([1,0,141,10,22,25,39,184]),function(ie,e,r,C,S,N,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new _.RawContextKey("taskRunning",!1,r.localize(0,null)),e.TASKS_CATEGORY={value:r.localize(1,null),original:"Tasks"};var E;(function(R){R[R.Escape=1]="Escape",R[R.Strong=2]="Strong",R[R.Weak=3]="Weak"})(E=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(R){function K(W){if(!W)return R.Strong;switch(W.toLowerCase()){case"escape":return R.Escape;case"strong":return R.Strong;case"weak":return R.Weak;default:return R.Strong}}R.from=K}(E=e.ShellQuoting||(e.ShellQuoting={}));var P;(function(R){R.defaults={cwd:"${workspaceFolder}"}})(P=e.CommandOptions||(e.CommandOptions={}));var O;(function(R){R[R.Always=1]="Always",R[R.Silent=2]="Silent",R[R.Never=3]="Never"})(O=e.RevealKind||(e.RevealKind={})),function(R){function K(W){switch(W.toLowerCase()){case"always":return R.Always;case"silent":return R.Silent;case"never":return R.Never;default:return R.Always}}R.fromString=K}(O=e.RevealKind||(e.RevealKind={}));var w;(function(R){R[R.Never=1]="Never",R[R.OnProblem=2]="OnProblem",R[R.Always=3]="Always"})(w=e.RevealProblemKind||(e.RevealProblemKind={})),function(R){function K(W){switch(W.toLowerCase()){case"always":return R.Always;case"never":return R.Never;case"onproblem":return R.OnProblem;default:return R.OnProblem}}R.fromString=K}(w=e.RevealProblemKind||(e.RevealProblemKind={}));var g;(function(R){R[R.Shared=1]="Shared",R[R.Dedicated=2]="Dedicated",R[R.New=3]="New"})(g=e.PanelKind||(e.PanelKind={})),function(R){function K(W){switch(W.toLowerCase()){case"shared":return R.Shared;case"dedicated":return R.Dedicated;case"new":return R.New;default:return R.Shared}}R.fromString=K}(g=e.PanelKind||(e.PanelKind={}));var k;(function(R){R.defaults={echo:!0,reveal:O.Always,revealProblems:w.Never,focus:!1,panel:g.Shared,showReuseMessage:!0,clear:!1}})(k=e.PresentationOptions||(e.PresentationOptions={}));var m;(function(R){R[R.Shell=1]="Shell",R[R.Process=2]="Process",R[R.CustomExecution=3]="CustomExecution"})(m=e.RuntimeType||(e.RuntimeType={})),function(R){function K($){switch($.toLowerCase()){case"shell":return R.Shell;case"process":return R.Process;case"customExecution":return R.CustomExecution;default:return R.Process}}R.fromString=K;function W($){switch($){case R.Shell:return"shell";case R.Process:return"process";case R.CustomExecution:return"customExecution";default:return"process"}}R.toString=W}(m=e.RuntimeType||(e.RuntimeType={}));var a;(function(R){function K(W){return C.isString(W)?W:W.value}R.value=K})(a=e.CommandString||(e.CommandString={}));var u;(function(R){R.Clean={_id:"clean",isDefault:!1},R.Build={_id:"build",isDefault:!1},R.Rebuild={_id:"rebuild",isDefault:!1},R.Test={_id:"test",isDefault:!1};function K($){return $===R.Clean._id||$===R.Build._id||$===R.Rebuild._id||$===R.Test._id}R.is=K;function W($){if($!==void 0)return C.isString($)?K($)?{_id:$,isDefault:!1}:void 0:$}R.from=W})(u=e.TaskGroup||(e.TaskGroup={}));var d;(function(R){R[R.Global=1]="Global",R[R.Workspace=2]="Workspace",R[R.Folder=3]="Folder"})(d=e.TaskScope||(e.TaskScope={}));var v;(function(R){R.Workspace="workspace",R.Extension="extension",R.InMemory="inMemory",R.WorkspaceFile="workspaceFile",R.User="user";function K(W){switch(W){case R.User:return 2;case R.WorkspaceFile:return 5;default:return 6}}R.toConfigurationTarget=K})(v=e.TaskSourceKind||(e.TaskSourceKind={}));var D;(function(R){R.parallel="parallel",R.sequence="sequence"})(D=e.DependsOrder||(e.DependsOrder={}));var c;(function(R){R[R.default=1]="default",R[R.folderOpen=2]="folderOpen"})(c=e.RunOnOptions||(e.RunOnOptions={}));var b;(function(R){R.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(b=e.RunOptions||(e.RunOptions={}));class t{constructor(K,W,$,G,re,ge){this._label="",this._id=K,W&&(this._label=W),$&&(this.type=$),this.runOptions=G,this.configurationProperties=re,this._source=ge}getDefinition(K){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const K={folder:this.getFolderId(),id:this._id};return JSON.stringify(K)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(K,W=!1){if(K===void 0)return!1;if(C.isString(K))return K===this._label||K===this.configurationProperties.identifier||W&&K===this._id;const $=this.getDefinition(!0);return $!==void 0&&$._key===K._key}getQualifiedLabel(){const K=this.getWorkspaceFolder();return K?`${this._label} (${K.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(K){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),K&&(this._taskLoadMessages=this._taskLoadMessages.concat(K))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=t;class l extends t{constructor(K,W,$,G,re,ge,oe,Ee){super(K,$,void 0,oe,Ee,W),this.command={},this._source=W,this.hasDefinedMatchers=ge,re&&(this.command=re)}clone(){return new l(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(K=!1){if(K&&this._source.customizes!==void 0)return this._source.customizes;{let W;switch(this.command?this.command.runtime:void 0){case m.Shell:W="shell";break;case m.Process:W="process";break;case m.CustomExecution:W="customExecution";break;case void 0:W="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:W,_key:this._id,id:this._id}}}static is(K){return K instanceof l}getMapKey(){const K=this._source.config.workspaceFolder;return K?`${K.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const K=this.getFolderId();if(!K)return;let W=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&(W+=this._source.kind);const $={type:e.CUSTOMIZED_TASK_TYPE,folder:K,id:W};return JSON.stringify($)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?S.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(K){return new l(K._id,K._source,K._label,K.type,K.command,K.hasDefinedMatchers,K.runOptions,K.configurationProperties)}}e.CustomTask=l;class i extends t{constructor(K,W,$,G,re,ge,oe){super(K,$,G,ge,oe,W),this._source=W,this.configures=re}static is(K){return K instanceof i}fromObject(K){return K}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?S.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const K=this.getFolderId();if(!K)return;let W=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&(W+=this._source.kind);const $={type:e.CUSTOMIZED_TASK_TYPE,folder:K,id:W};return JSON.stringify($)}}e.ConfiguringTask=i;class n extends t{constructor(K,W,$,G,re,ge,oe,Ee,ce){super(K,$,G,Ee,ce,W),this.defines=re,this.hasDefinedMatchers=oe,this.command=ge,this.icon=ce.icon,this.hide=ce.hide}clone(){return new n(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(K){return K instanceof n}getMapKey(){const K=this._source.workspaceFolder;return K?`${this._source.scope.toString()}|${K.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const K={type:"contributed",scope:this._source.scope,id:this._id};return K.folder=this.getFolderId(),JSON.stringify(K)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(K){return new n(K._id,K._source,K._label,K.type,K.defines,K.command,K.hasDefinedMatchers,K.runOptions,K.configurationProperties)}}e.ContributedTask=n;class o extends t{constructor(K,W,$,G,re,ge){super(K,$,G,re,ge,W),this._source=W}clone(){return new o(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(K){return K instanceof o}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(K){return new o(K._id,K._source,K._label,K.type,K.runOptions,K.configurationProperties)}}e.InMemoryTask=o;var f;(function(R){R[R.Process=1]="Process",R[R.Terminal=2]="Terminal"})(f=e.ExecutionEngine||(e.ExecutionEngine={})),function(R){R._default=R.Terminal}(f=e.ExecutionEngine||(e.ExecutionEngine={}));var s;(function(R){R[R.V0_1_0=1]="V0_1_0",R[R.V2_0_0=2]="V2_0_0"})(s=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class h{constructor(K){this._order=new Map;for(let W=0;W<K.length;W++)this._order.set(K[W].uri.toString(),W)}compare(K,W){const $=K.getWorkspaceFolder(),G=W.getWorkspaceFolder();if($&&G){let re=this._order.get($.uri.toString());re=re===void 0?0:re+1;let ge=this._order.get(G.uri.toString());return ge=ge===void 0?0:ge+1,re===ge?K._label.localeCompare(W._label):re-ge}else return!$&&G?-1:$&&!G?1:0}}e.TaskSorter=h;var p;(function(R){R.DependsOnStarted="dependsOnStarted",R.AcquiredInput="acquiredInput",R.Start="start",R.ProcessStarted="processStarted",R.Active="active",R.Inactive="inactive",R.Changed="changed",R.Terminated="terminated",R.ProcessEnded="processEnded",R.End="end"})(p=e.TaskEventKind||(e.TaskEventKind={}));var T;(function(R){R.SingleRun="singleRun",R.Background="background"})(T=e.TaskRunType||(e.TaskRunType={}));var M;(function(R){R[R.System=0]="System",R[R.User=1]="User",R[R.FolderOpen=2]="FolderOpen",R[R.ConfigurationChange=3]="ConfigurationChange",R[R.Reconnect=4]="Reconnect"})(M=e.TaskRunSource||(e.TaskRunSource={}));var V;(function(R){function K(W,$,G,re,ge){if($){const oe={kind:W,taskId:$._id,taskName:$.configurationProperties.name,runType:$.configurationProperties.isBackground?"background":"singleRun",group:$.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:void 0,__task:$};return W==="start"?(oe.terminalId=G,oe.resolvedVariables=re):W==="processStarted"?oe.processId=G:W==="processEnded"&&(oe.exitCode=G),Object.freeze(oe)}else return Object.freeze({kind:"changed"})}R.create=K})(V=e.TaskEvent||(e.TaskEvent={}));var U;(function(R){function K($){const G=Object.keys($).sort();let re="";for(const ge of G){let oe=$[ge];oe instanceof Object?oe=K(oe):typeof oe=="string"&&(oe=oe.replace(/,/g,",,")),re+=ge+","+oe+","}return re}function W($){const re={_key:K($),type:$.taskType};return Object.assign(re,$),re}R.create=W})(U=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var y;(function(R){R.AutoDetect="task.autoDetect",R.SaveBeforeRun="task.saveBeforeRun",R.ShowDecorations="task.showDecorations",R.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",R.SlowProviderWarning="task.slowProviderWarning",R.QuickOpenHistory="task.quickOpen.history",R.QuickOpenDetail="task.quickOpen.detail",R.QuickOpenSkip="task.quickOpen.skip",R.QuickOpenShowAll="task.quickOpen.showAll",R.AllowAutomaticTasks="task.allowAutomaticTasks",R.Reconnection="task.reconnection"})(y=e.TaskSettingId||(e.TaskSettingId={}));var x;(function(R){R.Tasks="tasks",R.SuppressTaskName="tasks.suppressTaskName",R.Windows="tasks.windows",R.Osx="tasks.osx",R.Linux="tasks.linux",R.ShowOutput="tasks.showOutput",R.IsShellCommand="tasks.isShellCommand",R.ServiceTestSetting="tasks.service.testSetting"})(x=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var L;(function(R){function K(W,$){const G=A.TaskDefinitionRegistry.get(W.type);if(G===void 0){const Ee=N.deepClone(W);return delete Ee._key,U.create(Ee)}const re=Object.create(null);re.type=G.taskType;const ge=new Set;G.required.forEach(Ee=>ge.add(Ee));const oe=G.properties;for(const Ee of Object.keys(oe)){const ce=W[Ee];if(ce!=null)re[Ee]=ce;else if(ge.has(Ee)){const me=oe[Ee];if(me.default!==void 0)re[Ee]=N.deepClone(me.default);else switch(me.type){case"boolean":re[Ee]=!1;break;case"number":case"integer":re[Ee]=0;break;case"string":re[Ee]="";break;default:$.error(r.localize(2,null,JSON.stringify(W,void 0,0),Ee));return}}}return U.create(re)}R.createTaskIdentifier=K})(L=e.TaskDefinition||(e.TaskDefinition={}))}),define(Ce[186],Ie([1,0,12]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class C{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((_,A)=>{this._actualOk=_,this._actualErr=A,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(_){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=_,this._actual&&this._actualOk(_))}resolveErr(_){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=_,this._actual?this._actualErr(_):(0,r.onUnexpectedError)(_))}then(_,A){return this._ensureActual().then(_,A)}catch(_){return this._ensureActual().then(void 0,_)}finally(_){return this._ensureActual().finally(_)}}e.LazyPromise=C;class S extends C{constructor(){super(),this._hasErr=!0,this._err=new r.CancellationError}}e.CanceledLazyPromise=S}),define(Ce[41],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class r{constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++r.count}}e.ProxyIdentifier=r,r.count=0;const C=[];function S(A){const E=new r(A);return C[E.nid]=E,E}e.createProxyIdentifier=S;function N(A){return C[A].sid}e.getStringIdentifierForProxy=N;class _{constructor(E){this.value=E}}e.SerializableObjectWithBuffers=_}),define(Ce[4],Ie([1,0,41]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var C;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(C=e.TextEditorRevealType||(e.TextEditorRevealType={}));var S;(function(a){a[a.UnknownInput=0]="UnknownInput",a[a.TextInput=1]="TextInput",a[a.TextDiffInput=2]="TextDiffInput",a[a.TextMergeInput=3]="TextMergeInput",a[a.NotebookInput=4]="NotebookInput",a[a.NotebookDiffInput=5]="NotebookDiffInput",a[a.CustomEditorInput=6]="CustomEditorInput",a[a.WebviewEditorInput=7]="WebviewEditorInput",a[a.TerminalEditorInput=8]="TerminalEditorInput",a[a.InteractiveEditorInput=9]="InteractiveEditorInput"})(S=e.TabInputKind||(e.TabInputKind={}));var N;(function(a){a[a.TAB_OPEN=0]="TAB_OPEN",a[a.TAB_CLOSE=1]="TAB_CLOSE",a[a.TAB_UPDATE=2]="TAB_UPDATE",a[a.TAB_MOVE=3]="TAB_MOVE"})(N=e.TabModelOperationKind||(e.TabModelOperationKind={}));var _;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(_=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var A;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(A=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var E;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(E=e.CellOutputKind||(e.CellOutputKind={}));var P;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(P=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var O;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(O=e.CandidatePortSource||(e.CandidatePortSource={}));class w{static mixin(u){return u._id=w._n++,u}}e.IdObject=w,w._n=0;var g;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.command="m",a.kindModifier="n"})(g=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var k;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(k=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var m;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(m=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,r.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,r.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,r.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,r.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,r.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,r.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,r.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,r.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,r.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,r.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,r.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,r.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,r.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,r.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,r.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,r.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,r.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,r.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,r.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,r.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,r.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,r.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,r.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,r.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,r.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,r.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,r.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,r.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,r.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,r.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,r.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,r.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,r.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,r.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,r.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,r.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,r.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,r.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,r.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,r.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,r.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,r.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,r.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,r.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,r.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,r.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,r.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,r.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,r.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,r.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,r.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,r.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,r.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,r.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,r.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,r.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,r.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,r.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,r.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,r.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,r.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,r.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,r.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,r.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,r.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,r.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,r.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,r.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,r.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,r.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,r.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,r.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,r.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,r.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,r.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,r.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,r.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,r.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,r.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,r.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,r.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,r.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,r.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,r.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,r.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,r.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,r.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,r.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,r.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,r.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,r.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,r.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,r.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,r.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,r.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,r.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,r.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,r.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,r.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,r.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,r.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,r.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,r.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,r.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,r.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,r.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,r.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,r.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,r.createProxyIdentifier)("ExtHostLocalization")}}),define(Ce[67],Ie([1,0,3,14,4,11]),function(ie,e,r,C,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,r.createDecorator)("IExtHostApiDeprecationService");let _=class{constructor(E,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=E.getProxy(S.MainContext.MainThreadTelemetry)}report(E,P,O){const w=this.getUsageKey(E,P);this._reportedUsages.has(w)||(this._reportedUsages.add(w),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${E}' is deprecated. ${O}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:E}))}getUsageKey(E,P){return`${E}-${P.identifier.value}`}};_=ze([$e(0,N.IExtHostRpcService),$e(1,C.ILogService)],_),e.ExtHostApiDeprecationService=_,e.NullApiDeprecationService=Object.freeze(new class{report(A,E,P){}})}),define(Ce[187],Ie([1,0,5,4,6,26]),function(ie,e,r,C,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class _{constructor(E){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new r.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=E.getProxy(C.MainContext.MainThreadAuthentication)}$setProviders(E){return this._providers=E,Promise.resolve()}async getSession(E,P,O,w={}){const g=N.ExtensionIdentifier.toKey(E.identifier),k=this._inFlightRequests.get(g)||[],m=[...O].sort().join(" ");let a=k.find(u=>u.providerId===P&&u.scopes===m);if(a)return a.result;{const u=this._getSession(E,g,P,O,w);a={providerId:P,scopes:m,result:u},k.push(a),this._inFlightRequests.set(g,k);try{await u}finally{const d=k.findIndex(v=>v.providerId===P&&v.scopes===m);d>-1&&(k.splice(d),this._inFlightRequests.set(g,k))}return u}}async _getSession(E,P,O,w,g={}){await this._proxy.$ensureProvider(O);const k=E.displayName||E.name;return this._proxy.$getSession(O,w,P,k,g)}async removeSession(E,P){const O=this._authenticationProviders.get(E);return O?O.provider.removeSession(P):this._proxy.$removeSession(E,P)}registerAuthenticationProvider(E,P,O,w){if(this._authenticationProviders.get(E))throw new Error(`An authentication provider with id '${E}' is already registered.`);this._authenticationProviders.set(E,{label:P,provider:O,options:w??{supportsMultipleAccounts:!1}}),this._providers.find(k=>k.id===E)||this._providers.push({id:E,label:P});const g=O.onDidChangeSessions(k=>{this._proxy.$sendDidChangeSessions(E,{added:k.added??[],changed:k.changed??[],removed:k.removed??[]})});return this._proxy.$registerAuthenticationProvider(E,P,w?.supportsMultipleAccounts??!1),new S.Disposable(()=>{g.dispose(),this._authenticationProviders.delete(E);const k=this._providers.findIndex(m=>m.id===E);k>-1&&this._providers.splice(k),this._proxy.$unregisterAuthenticationProvider(E)})}$createSession(E,P){const O=this._authenticationProviders.get(E);if(O)return Promise.resolve(O.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$removeSession(E,P){const O=this._authenticationProviders.get(E);if(O)return Promise.resolve(O.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$getSessions(E,P){const O=this._authenticationProviders.get(E);if(O)return Promise.resolve(O.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$onDidChangeAuthenticationSessions(E,P){return this._onDidChangeSessions.fire({provider:{id:E,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=_}),define(Ce[188],Ie([1,0,4,11,8]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let N=class{constructor(A,E){this._proxy=A.getProxy(r.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:P=>E.getDocument(P)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(A,E,P){const O=S.WorkspaceEdit.from(A,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(O,void 0,P?.isRefactoring??!1)}};N=ze([$e(0,C.IExtHostRpcService)],N),e.ExtHostBulkEdits=N}),define(Ce[189],Ie([1,0,4]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class C{constructor(N){const _=N.getProxy(r.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return _.$readText()},writeText(A){return _.$writeText(A)}})}}e.ExtHostClipboard=C});var Je=this&&this.__classPrivateFieldSet||function(ie,e,r,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ie,r):S?S.value=r:e.set(ie,r),r},Oe=this&&this.__classPrivateFieldGet||function(ie,e,r,C){if(r==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!C:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?C:r==="a"?C.call(ie):C?C.value:e.get(ie)};define(Ce[37],Ie([1,0,10,6,8,25,4,18,14,76,49,243,2,7,3,11,95,23,41,44]),function(ie,e,r,C,S,N,_,A,E,P,O,w,g,k,m,a,u,d,v,D){"use strict";var c,b;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let t=class{constructor(s,h){c.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,b.set(this,void 0),Je(this,c,s.getProxy(_.MainContext.MainThreadCommands),"f"),this._logService=h,Je(this,b,s.getProxy(_.MainContext.MainThreadTelemetry),"f"),this.converter=new l(this,p=>{const T=this._apiCommands.get(p);return T?.result===n.Void?T:void 0},h),this._argumentProcessors=[{processArgument(p){return(0,P.revive)(p)}},{processArgument(p){return(0,N.cloneAndChange)(p,function(T){if(O.Range.isIRange(T))return S.Range.to(T);if(w.Position.isIPosition(T))return S.Position.to(T);if(O.Range.isIRange(T.range)&&g.URI.isUri(T.uri))return S.location.to(T);if(T instanceof d.VSBuffer)return T.buffer.buffer;if(!Array.isArray(T))return T})}}]}registerArgumentProcessor(s){this._argumentProcessors.push(s)}registerApiCommand(s){const h=this.registerCommand(!1,s.id,async(...p)=>{const T=s.args.map((V,U)=>{if(!V.validate(p[U]))throw new Error(`Invalid argument '${V.name}' when running '${s.id}', received: ${p[U]}`);return V.convert(p[U])}),M=await this.executeCommand(s.internalId,...T);return s.result.convert(M,p,this.converter)},void 0,{description:s.description,args:s.args,returns:s.result.description});return this._apiCommands.set(s.id,s),new C.Disposable(()=>{h.dispose(),this._apiCommands.delete(s.id)})}registerCommand(s,h,p,T,M,V){if(this._logService.trace("ExtHostCommands#registerCommand",h),!h.trim().length)throw new Error("invalid id");if(this._commands.has(h))throw new Error(`command '${h}' already exists`);return this._commands.set(h,{callback:p,thisArg:T,description:M,extension:V}),s&&Oe(this,c,"f").$registerCommand(h),new C.Disposable(()=>{this._commands.delete(h)&&s&&Oe(this,c,"f").$unregisterCommand(h)})}executeCommand(s,...h){return this._logService.trace("ExtHostCommands#executeCommand",s),this._doExecuteCommand(s,h,!0)}async _doExecuteCommand(s,h,p){if(this._commands.has(s))return Oe(this,c,"f").$fireCommandActivationEvent(s),this._executeContributedCommand(s,h,!1);{let T=!1;const M=(0,N.cloneAndChange)(h,function(V){if(V instanceof C.Position)return S.Position.from(V);if(V instanceof C.Range)return S.Range.from(V);if(V instanceof C.Location)return S.location.from(V);if(C.NotebookRange.isNotebookRange(V))return S.NotebookRange.from(V);if(V instanceof ArrayBuffer)return T=!0,d.VSBuffer.wrap(new Uint8Array(V));if(V instanceof Uint8Array)return T=!0,d.VSBuffer.wrap(V);if(V instanceof d.VSBuffer)return T=!0,V;if(!Array.isArray(V))return V});try{const V=await Oe(this,c,"f").$executeCommand(s,T?new v.SerializableObjectWithBuffers(M):M,p);return(0,P.revive)(V)}catch(V){if(V instanceof Error&&V.message==="$executeCommand:retry")return this._doExecuteCommand(s,h,!1);throw V}}}async _executeContributedCommand(s,h,p){const T=this._commands.get(s);if(!T)throw new Error("Unknown command");this._reportTelemetry(T,s);const{callback:M,thisArg:V,description:U}=T;if(U)for(let y=0;y<U.args.length;y++)try{(0,r.validateConstraint)(h[y],U.args[y].constraint)}catch{throw new Error(`Running the contributed command: '${s}' failed. Illegal argument '${U.args[y].name}' - ${U.args[y].description}`)}try{return await M.apply(V,h)}catch(y){if(s===this.converter.delegatingCommandId){const x=this.converter.getActualCommand(...h);x&&(s=x.command)}throw this._logService.error(y,s,T.extension?.identifier),p?new class extends Error{constructor(){super((0,D.toErrorMessage)(y)),this.id=s,this.source=T.extension?.displayName??T.extension?.name}}:y}}_reportTelemetry(s,h){!s.extension||s.extension.isBuiltin||Oe(this,b,"f").$publicLog2("Extension:ActionExecuted",{extensionId:s.extension.identifier.value,id:h})}$executeContributedCommand(s,...h){return this._logService.trace("ExtHostCommands#$executeContributedCommand",s),this._commands.has(s)?(h=h.map(p=>this._argumentProcessors.reduce((T,M)=>M.processArgument(T),p)),this._executeContributedCommand(s,h,!0)):Promise.reject(new Error(`Contributed command '${s}' does not exist.`))}getCommands(s=!1){return this._logService.trace("ExtHostCommands#getCommands",s),Oe(this,c,"f").$getCommands().then(h=>(s&&(h=h.filter(p=>p[0]!=="_")),h))}$getContributedCommandHandlerDescriptions(){const s=Object.create(null);for(const[h,p]of this._commands){const{description:T}=p;T&&(s[h]=T)}return Promise.resolve(s)}};c=new WeakMap,b=new WeakMap,t=ze([$e(0,a.IExtHostRpcService),$e(1,E.ILogService)],t),e.ExtHostCommands=t,e.IExtHostCommands=(0,m.createDecorator)("IExtHostCommands");class l{constructor(s,h,p){this._commands=s,this._lookupApiCommand=h,this._logService=p,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(s,h){if(!s)return;const p={$ident:void 0,id:s.command,title:s.title,tooltip:s.tooltip};if(!s.command)return p;const T=this._lookupApiCommand(s.command);if(T)p.id=T.internalId,p.arguments=T.args.map((M,V)=>M.convert(s.arguments&&s.arguments[V]));else if((0,A.isNonEmptyArray)(s.arguments)){const M=++this._cachIdPool;this._cache.set(M,s),h.add((0,k.toDisposable)(()=>{this._cache.delete(M),this._logService.trace("CommandsConverter#DISPOSE",M)})),p.$ident=M,p.id=this.delegatingCommandId,p.arguments=[M],this._logService.trace("CommandsConverter#CREATE",s.command,M)}return p}fromInternal(s){return typeof s.$ident=="number"?this._cache.get(s.$ident):{command:s.id,title:s.title,arguments:s.arguments}}getActualCommand(...s){return this._cache.get(s[0])}_executeConvertedCommand(...s){const h=this.getActualCommand(...s);return this._logService.trace("CommandsConverter#EXECUTE",s[0],h?h.command:"MISSING"),h?this._commands.executeCommand(h.command,...h.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=l;class i{constructor(s,h,p,T){this.name=s,this.description=h,this.validate=p,this.convert=T}optional(){return new i(this.name,`(optional) ${this.description}`,s=>s==null||this.validate(s),s=>s===void 0?void 0:s===null?null:this.convert(s))}with(s,h){return new i(s??this.name,h??this.description,this.validate,this.convert)}}e.ApiCommandArgument=i,i.Uri=new i("uri","Uri of a text document",f=>g.URI.isUri(f),f=>f),i.Position=new i("position","A position in a text document",f=>C.Position.isPosition(f),S.Position.from),i.Range=new i("range","A range in a text document",f=>C.Range.isRange(f),S.Range.from),i.Selection=new i("selection","A selection in a text document",f=>C.Selection.isSelection(f),S.Selection.from),i.Number=new i("number","",f=>typeof f=="number",f=>f),i.String=new i("string","",f=>typeof f=="string",f=>f),i.CallHierarchyItem=new i("item","A call hierarchy item",f=>f instanceof C.CallHierarchyItem,S.CallHierarchyItem.from),i.TypeHierarchyItem=new i("item","A type hierarchy item",f=>f instanceof C.TypeHierarchyItem,S.TypeHierarchyItem.from),i.TestItem=new i("testItem","A VS Code TestItem",f=>f instanceof u.TestItemImpl,S.TestItem.from);class n{constructor(s,h){this.description=s,this.convert=h}}e.ApiCommandResult=n,n.Void=new n("no result",f=>f);class o{constructor(s,h,p,T,M){this.id=s,this.internalId=h,this.description=p,this.args=T,this.result=M}}e.ApiCommand=o}),define(Ce[190],Ie([1,0,2,8,6,66,37,18,79,83,13]),function(ie,e,r,C,S,N,_,A,E,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const w=[new _.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",k(C.DocumentHighlight.to))),new _.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,u)=>{if((0,A.isFalsyOrEmpty)(a))return;class d extends S.SymbolInformation{static to(D){const c=new d(D.name,C.SymbolKind.to(D.kind),D.containerName||"",new S.Location(u[0],C.Range.to(D.range)));return c.detail=D.detail,c.range=c.location.range,c.selectionRange=C.Range.to(D.selectionRange),c.children=D.children?D.children.map(d.to):[],c}}return a.map(d.to)})),new _.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",k(C.TextEdit.to))),new _.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range,new _.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",k(C.TextEdit.to))),new _.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,new _.ApiCommandArgument("ch","Trigger character",a=>typeof a=="string",a=>a),new _.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",k(C.TextEdit.to))),new _.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new _.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new _.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new _.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new _.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location-instances.",k(C.location.to))),new _.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Hover-instances.",k(C.Hover.to))),new _.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("position","A position in a text document",a=>Array.isArray(a)&&a.every(u=>S.Position.isPosition(u)),a=>a.map(C.Position.from))],new _.ApiCommandResult("A promise that resolves to an array of ranges.",a=>a.map(u=>{let d;for(const v of u.reverse())d=new S.SelectionRange(C.Range.to(v),d);return d}))),new _.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[_.ApiCommandArgument.String.with("query","Search string")],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",a=>a.map(C.WorkspaceSymbol.to))),new _.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(C.CallHierarchyItem.to))),new _.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(C.CallHierarchyIncomingCall.to))),new _.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(C.CallHierarchyOutgoingCall.to))),new _.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to a range and placeholder text.",a=>{if(!!a)return{range:C.Range.to(a.range),placeholder:a.text}})),new _.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("newName","The new symbol name")],new _.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",a=>{if(!!a){if(a.rejectReason)throw new Error(a.rejectReason);return C.WorkspaceEdit.to(a)}})),new _.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new _.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(C.DocumentLink.to))),new _.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new S.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const u=(0,E.decodeSemanticTokensDto)(a);if(u.type==="full")return new S.SemanticTokens(u.data,void 0)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range.optional()],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new S.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const u=(0,E.decodeSemanticTokensDto)(a);if(u.type==="full")return new S.SemanticTokens(u.data,void 0)})),new _.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new _.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(a,u,d)=>{if(!a)return new S.CompletionList([]);const v=a.suggestions.map(D=>C.CompletionItem.to(D,d));return new S.CompletionList(v,a.incomplete)})),new _.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new _.ApiCommandResult("A promise that resolves to SignatureHelp.",a=>{if(a)return C.SignatureHelp.to(a)})),new _.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new _.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(a,u,d)=>k(v=>new S.CodeLens(C.Range.to(v.range),v.command&&d.fromInternal(v.command)))(a))),new _.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>S.Range.isRange(a),a=>S.Selection.isSelection(a)?C.Selection.from(a):C.Range.from(a)),_.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new _.ApiCommandResult("A promise that resolves to an array of Command-instances.",(a,u,d)=>k(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return d.fromInternal(v.command)}else{const D=new S.CodeAction(v.title,v.kind?new S.CodeActionKind(v.kind):void 0);return v.edit&&(D.edit=C.WorkspaceEdit.to(v.edit)),v.command&&(D.command=d.fromInternal(v.command)),D.isPreferred=v.isPreferred,D}})(a))),new _.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(u=>new S.ColorInformation(C.Range.to(u.range),C.Color.to(u.color))):[])),new _.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new _.ApiCommandArgument("color","The color to show and insert",a=>a instanceof S.Color,C.Color.from),new _.ApiCommandArgument("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:C.Range.from(a.range)}))],new _.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(C.ColorPresentation.to):[])),new _.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of Inlay objects",(a,u,d)=>a.map(C.InlayHint.to.bind(void 0,d)))),new _.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new _.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",k(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(u=>C.NotebookExclusiveDocumentPattern.to(u))})))),new _.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of InlineValue objects",a=>a.map(C.InlineValue.to))),new _.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new _.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",a=>r.URI.isUri(a)||typeof a=="string"&&(0,P.matchesSomeScheme)(a,O.Schemas.http,O.Schemas.https),a=>a),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[C.ViewColumn.from(a),void 0]:[C.ViewColumn.from(a.viewColumn),C.TextEditorOpenOptions.from(a)])).optional(),_.ApiCommandArgument.String.with("label","").optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[_.ApiCommandArgument.Uri.with("resource","Resource to open"),_.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[C.ViewColumn.from(a),void 0]:[C.ViewColumn.from(a.viewColumn),C.TextEditorOpenOptions.from(a)])).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[_.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),_.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),_.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[C.ViewColumn.from(a.viewColumn),C.TextEditorOpenOptions.from(a)]).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A TypeHierarchyItem or undefined",a=>a.map(C.TypeHierarchyItem.to))),new _.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[_.ApiCommandArgument.TypeHierarchyItem],new _.ApiCommandResult("A TypeHierarchyItem or undefined",a=>a.map(C.TypeHierarchyItem.to))),new _.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[_.ApiCommandArgument.TypeHierarchyItem],new _.ApiCommandResult("A TypeHierarchyItem or undefined",a=>a.map(C.TypeHierarchyItem.to))),new _.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[_.ApiCommandArgument.TestItem],_.ApiCommandResult.Void),new _.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[_.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],_.ApiCommandResult.Void)];class g{static register(u){w.forEach(u.registerApiCommand,u)}}e.ExtHostApiCommands=g;function k(a){return u=>{if(Array.isArray(u))return u.map(a)}}function m(a){if(!Array.isArray(a))return;const u=[];for(const d of a)N.isLocationLink(d)?u.push(C.DefinitionLink.to(d)):u.push(C.location.to(d));return u}}),define(Ce[191],Ie([1,0,15,55,5,7,2,66,26,8,6,28,4]),function(ie,e,r,C,S,N,_,A,E,P,O,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function k(m,a,u){const d=m.getProxy(g.MainContext.MainThreadComments);class v{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,a.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===6){const s=this._commentControllers.get(f.handle);return s?s.value:f}else if(f&&f.$mid===7){const s=this._commentControllers.get(f.commentControlHandle);if(!s)return f;const h=s.getCommentThread(f.commentThreadHandle);return h?h.value:f}else if(f&&f.$mid===8){const s=this._commentControllers.get(f.thread.commentControlHandle);if(!s)return f;const h=s.getCommentThread(f.thread.commentThreadHandle);return h?{thread:h.value,text:f.text}:f}else if(f&&f.$mid===9){const s=this._commentControllers.get(f.thread.commentControlHandle);if(!s)return f;const h=s.getCommentThread(f.thread.commentThreadHandle);if(!h)return f;const p=f.commentUniqueId,T=h.getCommentByUniqueId(p);return T||f}else if(f&&f.$mid===10){const s=this._commentControllers.get(f.thread.commentControlHandle);if(!s)return f;const h=s.getCommentThread(f.thread.commentThreadHandle);if(!h)return f;const p=f.text,T=f.commentUniqueId,M=h.getCommentByUniqueId(T);return M?(typeof M.body=="string"?M.body=p:M.body.value=p,M):f}return f}})}createCommentController(f,s,h){const p=v.handlePool++,T=new c(f,p,s,h);this._commentControllers.set(T.handle,T);const M=this._commentControllersByExtension.get(E.ExtensionIdentifier.toKey(f.identifier))||[];return M.push(T),this._commentControllersByExtension.set(E.ExtensionIdentifier.toKey(f.identifier),M),T.value}$createCommentThreadTemplate(f,s,h){const p=this._commentControllers.get(f);!p||p.$createCommentThreadTemplate(s,h)}async $updateCommentThreadTemplate(f,s,h){const p=this._commentControllers.get(f);!p||p.$updateCommentThreadTemplate(s,h)}$deleteCommentThread(f,s){this._commentControllers.get(f)?.$deleteCommentThread(s)}$provideCommentingRanges(f,s,h){const p=this._commentControllers.get(f);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const T=u.getDocument(_.URI.revive(s));return(0,r.asPromise)(()=>p.commentingRangeProvider.provideCommentingRanges(T,h)).then(M=>M?M.map(V=>P.Range.from(V)):void 0)}$toggleReaction(f,s,h,p,T){const M=this._commentControllers.get(f);return!M||!M.reactionHandler?Promise.resolve(void 0):(0,r.asPromise)(()=>{const V=M.getCommentThread(s);if(V){const U=V.getCommentByUniqueId(p.uniqueIdInThread);if(M!==void 0&&U&&M.reactionHandler)return M.reactionHandler(U,l(T))}return Promise.resolve(void 0)})}dispose(){}}v.handlePool=0;class D{set threadId(f){this._id=f}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(f){f.isEqual(this._range)||(this._range=f,this.modifications.range=f,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(f){this._canReply!==f&&(this._canReply=f,this.modifications.canReply=f,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(f){this._label=f,this.modifications.label=f,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(f){this._contextValue=f,this.modifications.contextValue=f,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(f){this._comments=f,this.modifications.comments=f,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(f){this._collapseState=f,this.modifications.collapsibleState=f,this._onDidUpdateCommentThread.fire()}get state(){return(0,w.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(f){(0,w.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=f,this.modifications.state=f,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(f,s,h,p,T,M,V,U){this._commentControllerHandle=s,this._id=h,this._uri=p,this._range=T,this._comments=M,this.extensionDescription=V,this._isTemplate=U,this.handle=D._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new S.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new N.MutableDisposable,this._acceptInputDisposables.value=new N.DisposableStore,this._id===void 0&&(this._id=`${f}.${this.handle}`),d.$createCommentThread(s,this.handle,this._id,this._uri,P.Range.from(this._range),V.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=M,this._localDisposables.push({dispose:()=>{d.$deleteCommentThread(s,this.handle)}});const y=this;this.value={get uri(){return y.uri},get range(){return y.range},set range(x){y.range=x},get comments(){return y.comments},set comments(x){y.comments=x},get collapsibleState(){return y.collapsibleState},set collapsibleState(x){y.collapsibleState=x},get canReply(){return y.canReply},set canReply(x){y.canReply=x},get contextValue(){return y.contextValue},set contextValue(x){y.contextValue=x},get label(){return y.label},set label(x){y.label=x},get state(){return y.state},set state(x){y.state=x},dispose:()=>{y.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new N.DisposableStore);const f=h=>Object.prototype.hasOwnProperty.call(this.modifications,h),s={};f("range")&&(s.range=P.Range.from(this._range)),f("label")&&(s.label=this.label),f("contextValue")&&(s.contextValue=this.contextValue??null),f("comments")&&(s.comments=this._comments.map(h=>b(this,h,this._commentsMap))),f("collapsibleState")&&(s.collapseState=i(this._collapseState)),f("canReply")&&(s.canReply=this.canReply),f("state")&&(s.state=n(this._state)),f("isTemplate")&&(s.isTemplate=this._isTemplate),this.modifications={},d.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,s)}getCommentByUniqueId(f){for(const s of this._commentsMap){const h=s[0],p=s[1];if(f===p)return h}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(f=>f.dispose())}}D._handlePool=0,ze([(0,C.debounce)(100)],D.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(f){this._commentingRangeProvider=f,d.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(f){this._reactionHandler=f,d.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!f})}get options(){return this._options}set options(f){this._options=f,d.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(f,s,h,p){this._extension=f,this._handle=s,this._id=h,this._label=p,this._threads=new Map,d.$registerCommentController(this.handle,h,p);const T=this;this.value=Object.freeze({id:T.id,label:T.label,get options(){return T.options},set options(M){T.options=M},get commentingRangeProvider(){return T.commentingRangeProvider},set commentingRangeProvider(M){T.commentingRangeProvider=M},get reactionHandler(){return T.reactionHandler},set reactionHandler(M){T.reactionHandler=M},createCommentThread(M,V,U){return T.createCommentThread(M,V,U).value},dispose:()=>{T.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{d.$unregisterCommentController(this.handle)}})}createCommentThread(f,s,h,p){if(typeof f=="string"){const T=new D(this.id,this.handle,f,s,h,p,this._extension,!1);return this._threads.set(T.handle,T),T}else{const T=new D(this.id,this.handle,void 0,f,s,h,this._extension,!1);return this._threads.set(T.handle,T),T}}$createCommentThreadTemplate(f,s){const h=new D(this.id,this.handle,void 0,_.URI.revive(f),P.Range.to(s),[],this._extension,!0);return h.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this._threads.set(h.handle,h),h}$updateCommentThreadTemplate(f,s){const h=this._threads.get(f);h&&(h.range=P.Range.to(s))}$deleteCommentThread(f){this._threads.get(f)?.dispose(),this._threads.delete(f)}getCommentThread(f){return this._threads.get(f)}dispose(){this._threads.forEach(f=>{f.dispose()}),this._localDisposables.forEach(f=>f.dispose())}}function b(o,f,s){let h=s.get(f);h||(h=++o.commentHandle,s.set(f,h));const p=f.author&&f.author.iconPath?f.author.iconPath.toString():void 0;return{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:h,body:typeof f.body=="string"?f.body:P.MarkdownString.from(f.body),userName:f.author.name,userIconPath:p,label:f.label,commentReactions:f.reactions?f.reactions.map(T=>t(T)):void 0,timestamp:f.timestamp?.toJSON()}}function t(o){return{label:o.label,iconPath:o.iconPath?P.pathOrURIToURI(o.iconPath):void 0,count:o.count,hasReacted:o.authorHasReacted}}function l(o){return{label:o.label||"",count:o.count||0,iconPath:o.iconPath?_.URI.revive(o.iconPath):"",authorHasReacted:o.hasReacted||!1}}function i(o){if(o!==void 0)switch(o){case O.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case O.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}function n(o){if(o!==void 0)switch(o){case O.CommentThreadState.Unresolved:return A.CommentThreadState.Unresolved;case O.CommentThreadState.Resolved:return A.CommentThreadState.Resolved}return A.CommentThreadState.Unresolved}return new v}e.createExtHostComments=k}),define(Ce[192],Ie([1,0,25,4,27,11]),function(ie,e,r,C,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let _=class{constructor(O,w){this._mainThreadConsole=O.getProxy(C.MainContext.MainThreadConsole),this._includeStack=w.consoleForward.includeStack,this._logNative=w.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(O,w){const g=this,k=console[O];Object.defineProperty(console,O,{set:()=>{},get:()=>function(){g._handleConsoleCall(O,w,k,arguments)}})}_handleConsoleCall(O,w,g,k){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:w,arguments:E(k,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(O,g,k)}};_=ze([$e(0,N.IExtHostRpcService),$e(1,S.IExtHostInitDataService)],_),e.AbstractExtHostConsoleForwarder=_;const A=1e5;function E(P,O){const w=[];if(P.length)for(let g=0;g<P.length;g++){let k=P[g];if(typeof k>"u")k="undefined";else if(k instanceof Error){const m=k;m.stack?k=m.stack:k=m.toString()}w.push(k)}if(O){const g=new Error().stack;g&&w.push({__$stack:g.split(`
`).slice(3).join(`
`)})}try{const g=(0,r.safeStringify)(w);return g.length>A?"Output omitted for a large object that exceeds the limits":g}catch(g){return`Output omitted for an object that cannot be inspected ('${g.toString()}')`}}}),define(Ce[97],Ie([1,0,2,4,6,3,11,14,18,9,19]),function(ie,e,r,C,S,N,_,A,E,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let w=class Oi{constructor(k,m){this._logService=m,this._provider=new Map,this._proxy=k.getProxy(C.MainContext.MainThreadDecorations)}registerFileDecorationProvider(k,m){const a=Oi._handlePool++;this._provider.set(a,{provider:k,extensionId:m}),this._proxy.$registerDecorationProvider(a,m.value);const u=k.onDidChangeFileDecorations&&k.onDidChangeFileDecorations(d=>{if(!d){this._proxy.$onDidChange(a,null);return}const v=(0,E.asArray)(d);if(v.length<=Oi._maxEventSize){this._proxy.$onDidChange(a,v);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",m.value,v.length);const D=v.map(t=>({uri:t,rank:(0,P.count)(t.path,"/")})),c=(0,E.groupBy)(D,(t,l)=>t.rank-l.rank||(0,P.compare)(t.uri.path,l.uri.path)),b=[];e:for(const t of c){let l;for(const i of t){const n=(0,O.dirname)(i.uri.path);if(l!==n&&(l=n,b.push(i.uri)>=Oi._maxEventSize))break e}}this._proxy.$onDidChange(a,b)});return new S.Disposable(()=>{u?.dispose(),this._proxy.$unregisterDecorationProvider(a),this._provider.delete(a)})}async $provideDecorations(k,m,a){if(!this._provider.has(k))return Object.create(null);const u=Object.create(null),{provider:d,extensionId:v}=this._provider.get(k);return await Promise.all(m.map(async D=>{try{const{uri:c,id:b}=D,t=await Promise.resolve(d.provideFileDecoration(r.URI.revive(c),a));if(!t)return;try{S.FileDecoration.validate(t),u[b]=[t.propagate,t.tooltip,t.badge,t.color]}catch(l){this._logService.warn(`INVALID decoration from extension '${v.value}': ${l}`)}}catch(c){this._logService.error(c)}})),u}};w._handlePool=0,w._maxEventSize=250,w=ze([$e(0,_.IExtHostRpcService),$e(1,A.ILogService)],w),e.ExtHostDecorations=w,e.IExtHostDecorations=(0,N.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(ie,e,r,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ie,r):S?S.value=r:e.set(ie,r),r},Oe=this&&this.__classPrivateFieldGet||function(ie,e,r,C){if(r==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!C:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?C:r==="a"?C.call(ie):C?C.value:e.get(ie)};define(Ce[193],Ie([1,0,130,82,2,4,6,8,5,14,24,36]),function(ie,e,r,C,S,N,_,A,E,P,O,w){"use strict";var g,k,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class a{constructor(v,D,c,b,t,l){this._name=v,this._owner=D,this._maxDiagnosticsPerFile=c,g.set(this,void 0),k.set(this,void 0),m.set(this,void 0),this._isDisposed=!1,Je(this,m,new O.ResourceMap(i=>b.getComparisonKey(i)),"f"),Je(this,g,t,"f"),Je(this,k,l,"f")}dispose(){this._isDisposed||(Oe(this,k,"f").fire([...Oe(this,m,"f").keys()]),Oe(this,g,"f")?.$clear(this._owner),Oe(this,m,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(v,D){if(!v){this.clear();return}this._checkDisposed();let c=[];if(S.URI.isUri(v)){if(!D){this.delete(v);return}Oe(this,m,"f").set(v,D.slice()),c=[v]}else if(Array.isArray(v)){c=[];let t;v=[...v].sort(a._compareIndexedTuplesByUri);for(const l of v){const[i,n]=l;if((!t||i.toString()!==t.toString())&&(t&&Oe(this,m,"f").get(t).length===0&&Oe(this,m,"f").delete(t),t=i,c.push(i),Oe(this,m,"f").set(i,[])),n)Oe(this,m,"f").get(i)?.push(...n);else{const o=Oe(this,m,"f").get(i);o&&(o.length=0)}}}if(Oe(this,k,"f").fire(c),!Oe(this,g,"f"))return;const b=[];for(const t of c){let l=[];const i=Oe(this,m,"f").get(t);if(i)if(i.length>this._maxDiagnosticsPerFile){l=[];const n=[_.DiagnosticSeverity.Error,_.DiagnosticSeverity.Warning,_.DiagnosticSeverity.Information,_.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const f of i)if(f.severity===n[o]&&l.push(A.Diagnostic.from(f))===this._maxDiagnosticsPerFile)break e;l.push({severity:C.MarkerSeverity.Info,message:(0,r.localize)(0,null,i.length-this._maxDiagnosticsPerFile),startLineNumber:l[l.length-1].startLineNumber,startColumn:l[l.length-1].startColumn,endLineNumber:l[l.length-1].endLineNumber,endColumn:l[l.length-1].endColumn})}else l=i.map(n=>A.Diagnostic.from(n));b.push([t,l])}Oe(this,g,"f").$changeMany(this._owner,b)}delete(v){this._checkDisposed(),Oe(this,k,"f").fire([v]),Oe(this,m,"f").delete(v),Oe(this,g,"f")?.$changeMany(this._owner,[[v,void 0]])}clear(){this._checkDisposed(),Oe(this,k,"f").fire([...Oe(this,m,"f").keys()]),Oe(this,m,"f").clear(),Oe(this,g,"f")?.$clear(this._owner)}forEach(v,D){this._checkDisposed();for(const[c,b]of this)v.call(D,c,b,this)}*[(g=new WeakMap,k=new WeakMap,m=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const v of Oe(this,m,"f").keys())yield[v,this.get(v)]}get(v){this._checkDisposed();const D=Oe(this,m,"f").get(v);return Array.isArray(D)?Object.freeze(D.slice(0)):[]}has(v){return this._checkDisposed(),Array.isArray(Oe(this,m,"f").get(v))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(v,D){return v[0].toString()<D[0].toString()?-1:v[0].toString()>D[0].toString()?1:0}}e.DiagnosticCollection=a;let u=class gi{static _mapper(v){const D=new O.ResourceMap;for(const c of v)D.set(c,c);return{uris:Object.freeze(Array.from(D.values()))}}constructor(v,D,c){this._logService=D,this._fileSystemInfoService=c,this._collections=new Map,this._onDidChangeDiagnostics=new E.DebounceEmitter({merge:b=>b.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this._onDidChangeDiagnostics.event,gi._mapper),this._proxy=v.getProxy(N.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(v,D){const{_collections:c,_proxy:b,_onDidChangeDiagnostics:t,_logService:l,_fileSystemInfoService:i}=this,n=new class{$changeMany(s,h){b.$changeMany(s,h),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",v.value,s,h.length===0?"CLEARING":h)}$clear(s){b.$clear(s),l.trace("[DiagnosticCollection] remove all (extension, owner)",v.value,s)}dispose(){b.dispose()}};let o;if(!D)D="_generated_diagnostic_collection_name_#"+gi._idPool++,o=D;else if(!c.has(D))o=D;else{this._logService.warn(`DiagnosticCollection with name '${D}' does already exist.`);do o=D+gi._idPool++;while(c.has(o))}return new class extends a{constructor(){super(D,o,gi._maxDiagnosticsPerFile,i.extUri,n,t),c.set(o,this)}dispose(){super.dispose(),c.delete(o)}}}getDiagnostics(v){if(v)return this._getDiagnostics(v);{const D=new Map,c=[];for(const b of this._collections.values())b.forEach((t,l)=>{let i=D.get(t.toString());typeof i>"u"&&(i=c.length,D.set(t.toString(),i),c.push([t,[]])),c[i][1]=c[i][1].concat(...l)});return c}}_getDiagnostics(v){let D=[];for(const c of this._collections.values())c.has(v)&&(D=D.concat(c.get(v)));return D}$acceptMarkersChange(v){if(!this._mirrorCollection){const D="_generated_mirror",c=new a(D,D,gi._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(D,c),this._mirrorCollection=c}for(const[D,c]of v)this._mirrorCollection.set(S.URI.revive(D),c.map(A.Diagnostic.to))}};u._idPool=0,u._maxDiagnosticsPerFile=1e3,u=ze([$e(1,P.ILogService),$e(2,w.IExtHostFileSystemInfo)],u),e.ExtHostDiagnostics=u}),define(Ce[194],Ie([1,0,2,4]),function(ie,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class S{constructor(_){this._proxy=_.getProxy(C.MainContext.MainThreadDialogs)}showOpenDialog(_){return this._proxy.$showOpenDialog(_).then(A=>A?A.map(E=>r.URI.revive(E)):void 0)}showSaveDialog(_){return this._proxy.$showSaveDialog(_).then(A=>A?r.URI.revive(A):void 0)}}e.ExtHostDialogs=S}),define(Ce[195],Ie([1,0,12,2,6,4,13,20,9]),function(ie,e,r,C,S,N,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(w,g,k){this._documentsAndEditors=g,this._logService=k,this._documentContentProviders=new Map,this._proxy=w.getProxy(N.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(w,g){if(Object.keys(_.Schemas).indexOf(w)>=0)throw new Error(`scheme '${w}' already registered`);const k=P._handlePool++;this._documentContentProviders.set(k,g),this._proxy.$registerTextContentProvider(k,w);let m;return typeof g.onDidChange=="function"&&(m=g.onDidChange(a=>{if(a.scheme!==w){this._logService.warn(`Provider for scheme '${w}' is firing event for schema '${a.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(a)&&this.$provideTextDocumentContent(k,a).then(u=>{if(!u&&typeof u!="string")return;const d=this._documentsAndEditors.getDocument(a);if(!d)return;const v=(0,E.splitLines)(u);if(!d.equalLines(v))return this._proxy.$onVirtualDocumentChange(a,u)},r.onUnexpectedError)})),new S.Disposable(()=>{this._documentContentProviders.delete(k)&&this._proxy.$unregisterTextContentProvider(k),m&&(m.dispose(),m=void 0)})}$provideTextDocumentContent(w,g){const k=this._documentContentProviders.get(w);return k?Promise.resolve(k.provideTextDocumentContent(C.URI.revive(g),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${g.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(Ce[196],Ie([1,0,5,7,2,4,93,8,10,25,6]),function(ie,e,r,C,S,N,_,A,E,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class w{constructor(k,m){this._onDidAddDocument=new r.Emitter,this._onDidRemoveDocument=new r.Emitter,this._onDidChangeDocument=new r.Emitter,this._onDidSaveDocument=new r.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new C.DisposableStore,this._documentLoader=new Map,this._proxy=k.getProxy(N.MainContext.MainThreadDocuments),this._documentsAndEditors=m,this._documentsAndEditors.onDidRemoveDocuments(a=>{for(const u of a)this._onDidRemoveDocument.fire(u.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(a=>{for(const u of a)this._onDidAddDocument.fire(u.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(k){if(!k)return;const m=this._documentsAndEditors.getDocument(k);if(m)return m}getDocument(k){const m=this.getDocumentData(k);if(!m?.document)throw new Error(`Unable to retrieve document from URI '${k}'`);return m.document}ensureDocumentData(k){const m=this._documentsAndEditors.getDocument(k);if(m)return Promise.resolve(m);let a=this._documentLoader.get(k.toString());return a||(a=this._proxy.$tryOpenDocument(k).then(u=>{this._documentLoader.delete(k.toString());const d=S.URI.revive(u);return(0,E.assertIsDefined)(this._documentsAndEditors.getDocument(d))},u=>(this._documentLoader.delete(k.toString()),Promise.reject(u))),this._documentLoader.set(k.toString(),a)),a}createDocumentData(k){return this._proxy.$tryCreateDocument(k).then(m=>S.URI.revive(m))}$acceptModelLanguageChanged(k,m){const a=S.URI.revive(k),u=this._documentsAndEditors.getDocument(a);if(!u)throw new Error("unknown document");this._onDidRemoveDocument.fire(u.document),u._acceptLanguageId(m),this._onDidAddDocument.fire(u.document)}$acceptModelSaved(k){const m=S.URI.revive(k),a=this._documentsAndEditors.getDocument(m);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(k,!1),this._onDidSaveDocument.fire(a.document)}$acceptDirtyStateChanged(k,m){const a=S.URI.revive(k),u=this._documentsAndEditors.getDocument(a);if(!u)throw new Error("unknown document");u._acceptIsDirty(m),this._onDidChangeDocument.fire({document:u.document,contentChanges:[],reason:void 0})}$acceptModelChanged(k,m,a){const u=S.URI.revive(k),d=this._documentsAndEditors.getDocument(u);if(!d)throw new Error("unknown document");d._acceptIsDirty(a),d.onEvents(m);let v;m.isUndoing?v=O.TextDocumentChangeReason.Undo:m.isRedoing&&(v=O.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:d.document,contentChanges:m.changes.map(D=>({range:A.Range.to(D.range),rangeOffset:D.rangeOffset,rangeLength:D.rangeLength,text:D.text})),reason:v}))}setWordDefinitionFor(k,m){(0,_.setWordDefinitionFor)(k,m)}}e.ExtHostDocuments=w}),define(Ce[50],Ie([1,0,45,5,7,2,3,4,93,11,96,8,14,24,13,166,197]),function(ie,e,r,C,S,N,_,A,E,P,O,w,g,k,m,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class d{constructor(c){this.value=c,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let v=class{constructor(c,b){this._extHostRpc=c,this._logService=b,this._activeEditorId=null,this._editors=new Map,this._documents=new k.ResourceMap,this._onDidAddDocuments=new C.Emitter,this._onDidRemoveDocuments=new C.Emitter,this._onDidChangeVisibleTextEditors=new C.Emitter,this._onDidChangeActiveTextEditor=new C.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const b=[],t=[],l=[];if(c.removedDocuments)for(const i of c.removedDocuments){const n=N.URI.revive(i),o=this._documents.get(n);o?.unref()&&(this._documents.delete(n),b.push(o.value))}if(c.addedDocuments)for(const i of c.addedDocuments){const n=N.URI.revive(i.uri);let o=this._documents.get(n);if(o&&n.scheme!==m.Schemas.vscodeNotebookCell&&n.scheme!==m.Schemas.vscodeInteractiveInput)throw new Error(`document '${n} already exists!'`);o||(o=new d(new E.ExtHostDocumentData(this._extHostRpc.getProxy(A.MainContext.MainThreadDocuments),n,i.lines,i.EOL,i.versionId,i.languageId,i.isDirty,i.notebook)),this._documents.set(n,o),t.push(o.value)),o.ref()}if(c.removedEditors)for(const i of c.removedEditors){const n=this._editors.get(i);this._editors.delete(i),n&&l.push(n)}if(c.addedEditors)for(const i of c.addedEditors){const n=N.URI.revive(i.documentUri);r.ok(this._documents.has(n),`document '${n}' does not exist`),r.ok(!this._editors.has(i.id),`editor '${i.id}' already exists!`);const o=this._documents.get(n).value,f=new O.ExtHostTextEditor(i.id,this._extHostRpc.getProxy(A.MainContext.MainThreadTextEditors),this._logService,new u.Lazy(()=>o.document),i.selections.map(w.Selection.to),i.options,i.visibleRanges.map(s=>w.Range.to(s)),typeof i.editorPosition=="number"?w.ViewColumn.to(i.editorPosition):void 0);this._editors.set(i.id,f)}c.newActiveEditor!==void 0&&(r.ok(c.newActiveEditor===null||this._editors.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this._activeEditorId=c.newActiveEditor),(0,S.dispose)(b),(0,S.dispose)(l),c.removedDocuments&&this._onDidRemoveDocuments.fire(b),c.addedDocuments&&this._onDidAddDocuments.fire(t),(c.removedEditors||c.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(i=>i.value)),c.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(c){return this._documents.get(c)?.value}allDocuments(){return a.Iterable.map(this._documents.values(),c=>c.value)}getEditor(c){return this._editors.get(c)}activeEditor(c){if(!this._activeEditorId)return;const b=this._editors.get(this._activeEditorId);return c?b:b?.value}allEditors(){return[...this._editors.values()]}};v=ze([$e(0,P.IExtHostRpcService),$e(1,g.ILogService)],v),e.ExtHostDocumentsAndEditors=v,e.IExtHostDocumentsAndEditors=(0,_.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ce[51],Ie([1,0,8,4,2,5,3,6,11,10,73]),function(ie,e,r,C,S,N,_,A,E,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,_.createDecorator)("IExtHostEditorTabs");class w{constructor(u,d,v){this._activeTabIdGetter=v,this._parentGroup=d,this.acceptDtoUpdate(u)}get apiObject(){if(!this._apiObject){const u=this,d={get isActive(){return u._dto.id===u._activeTabIdGetter()},get label(){return u._dto.label},get input(){return u._input},get isDirty(){return u._dto.isDirty},get isPinned(){return u._dto.isPinned},get isPreview(){return u._dto.isPreview},get group(){return u._parentGroup.apiObject}};this._apiObject=Object.freeze(d)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(u){this._dto=u,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new A.TextTabInput(S.URI.revive(this._dto.input.uri));case 2:return new A.TextDiffTabInput(S.URI.revive(this._dto.input.original),S.URI.revive(this._dto.input.modified));case 3:return new A.TextMergeTabInput(S.URI.revive(this._dto.input.base),S.URI.revive(this._dto.input.input1),S.URI.revive(this._dto.input.input2),S.URI.revive(this._dto.input.result));case 6:return new A.CustomEditorTabInput(S.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new A.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new A.NotebookEditorTabInput(S.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new A.NotebookDiffEditorTabInput(S.URI.revive(this._dto.input.original),S.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new A.TerminalEditorTabInput;case 9:return new A.InteractiveWindowInput(S.URI.revive(this._dto.input.uri),S.URI.revive(this._dto.input.inputBoxUri));default:return}}}class g{constructor(u,d){this._tabs=[],this._activeTabId="",this._dto=u,this._activeGroupIdGetter=d;for(const v of u.tabs)v.isActive&&(this._activeTabId=v.id),this._tabs.push(new w(v,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const u=this,d={get isActive(){return u._dto.groupId===u._activeGroupIdGetter()},get viewColumn(){return r.ViewColumn.to(u._dto.viewColumn)},get activeTab(){return u._tabs.find(v=>v.tabId===u._activeTabId)?.apiObject},get tabs(){return Object.freeze(u._tabs.map(v=>v.apiObject))}};this._apiObject=Object.freeze(d)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(u){this._dto=u}acceptTabOperation(u){if(u.kind===0){const v=new w(u.tabDto,this,()=>this.activeTabId());return this._tabs.splice(u.index,0,v),u.tabDto.isActive&&(this._activeTabId=v.tabId),v}else if(u.kind===1){const v=this._tabs.splice(u.index,1)[0];if(!v)throw new Error(`Tab close updated received for index ${u.index} which does not exist`);return v.tabId===this._activeTabId&&(this._activeTabId=""),v}else if(u.kind===3){if(u.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const v=this._tabs.splice(u.oldIndex,1)[0];if(!v)throw new Error(`Tab move updated received for index ${u.oldIndex} which does not exist`);return this._tabs.splice(u.index,0,v),v}const d=this._tabs.find(v=>v.tabId===u.tabDto.id);if(!d)throw new Error("INVALID tab");return u.tabDto.isActive?this._activeTabId=u.tabDto.id:this._activeTabId===u.tabDto.id&&!u.tabDto.isActive&&(this._activeTabId=""),d.acceptDtoUpdate(u.tabDto),d}activeTabId(){return this._activeTabId}}let k=class{constructor(u){this._onDidChangeTabs=new N.Emitter,this._onDidChangeTabGroups=new N.Emitter,this._extHostTabGroups=[],this._proxy=u.getProxy(C.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const u=this,d={onDidChangeTabGroups:u._onDidChangeTabGroups.event,onDidChangeTabs:u._onDidChangeTabs.event,get all(){return Object.freeze(u._extHostTabGroups.map(v=>v.apiObject))},get activeTabGroup(){const v=u._activeGroupId;return(0,P.assertIsDefined)(u._extHostTabGroups.find(c=>c.groupId===v)?.apiObject)},close:async(v,D)=>{const c=Array.isArray(v)?v:[v];return c.length?m(c[0])?this._closeGroups(c,D):this._closeTabs(c,D):!0}};this._apiObject=Object.freeze(d)}return this._apiObject}$acceptEditorTabModel(u){const d=new Set(this._extHostTabGroups.map(i=>i.groupId)),v=new Set(u.map(i=>i.groupId)),D=(0,O.diffSets)(d,v),c=this._extHostTabGroups.filter(i=>D.removed.includes(i.groupId)).map(i=>i.apiObject),b=[],t=[];this._extHostTabGroups=u.map(i=>{const n=new g(i,()=>this._activeGroupId);return D.added.includes(n.groupId)?b.push(n.apiObject):t.push(n.apiObject),n});const l=(0,P.assertIsDefined)(u.find(i=>i.isActive===!0)?.groupId);l!==void 0&&this._activeGroupId!==l&&(this._activeGroupId=l),this._onDidChangeTabGroups.fire(Object.freeze({opened:b,closed:c,changed:t}))}$acceptTabGroupUpdate(u){const d=this._extHostTabGroups.find(v=>v.groupId===u.groupId);if(!d)throw new Error("Update Group IPC call received before group creation.");d.acceptGroupDtoUpdate(u),u.isActive&&(this._activeGroupId=u.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[d.apiObject],opened:[],closed:[]}))}$acceptTabOperation(u){const d=this._extHostTabGroups.find(D=>D.groupId===u.groupId);if(!d)throw new Error("Update Tabs IPC call received before group creation.");const v=d.acceptTabOperation(u);switch(u.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[v.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[v.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[v.apiObject]}));return}}_findExtHostTabFromApi(u){for(const d of this._extHostTabGroups)for(const v of d.tabs)if(v.apiObject===u)return v}_findExtHostTabGroupFromApi(u){return this._extHostTabGroups.find(d=>d.apiObject===u)}async _closeTabs(u,d){const v=[];for(const D of u){const c=this._findExtHostTabFromApi(D);if(!c)throw new Error("Tab close: Invalid tab not found!");v.push(c.tabId)}return this._proxy.$closeTab(v,d)}async _closeGroups(u,d){const v=[];for(const D of u){const c=this._findExtHostTabGroupFromApi(D);if(!c)throw new Error("Group close: Invalid group not found!");v.push(c.groupId)}return this._proxy.$closeGroup(v,d)}};k=ze([$e(0,E.IExtHostRpcService)],k),e.ExtHostEditorTabs=k;function m(a){return a.tabs!==void 0}}),define(Ce[198],Ie([1,0,2,4,7,6,8,244,9,23,28]),function(ie,e,r,C,S,N,_,A,E,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class w{constructor(){this._schemes=[]}add(m){this._stateMachine=void 0,this._schemes.push(m)}delete(m){const a=this._schemes.indexOf(m);a>=0&&(this._schemes.splice(a,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const m=this._schemes.sort(),a=[];let u,d,v=14,D=14;for(const c of m){let b=u?(0,E.commonPrefixLength)(u,c):0;for(b===0?d=1:d=D;b<c.length;b++)b+1===c.length?(v=D,D=9):D+=1,a.push([d,c.toUpperCase().charCodeAt(b),D]),a.push([d,c.toLowerCase().charCodeAt(b),D]),d=D;u=c,D=v}a.push([9,58,10]),a.push([10,47,12]),this._stateMachine=new A.StateMachine(a)}}provideDocumentLinks(m){this._initStateMachine();const a=[],u=A.LinkComputer.computeLinks({getLineContent(d){return m.lineAt(d-1).text},getLineCount(){return m.lineCount}},this._stateMachine);for(const d of u){const v=_.DocumentLink.to(d);v.target&&a.push(v)}return a}}class g{constructor(m,a){this._extHostLanguageFeatures=a,this._linkProvider=new w,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=m.getProxy(C.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(m,a,u,d={}){if(this._registeredSchemes.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(m,"*",this._linkProvider));const v=this._handlePool++;this._linkProvider.add(a),this._registeredSchemes.add(a),this._fsProvider.set(v,u);let D=2;d.isCaseSensitive&&(D+=1024),d.isReadonly&&(D+=2048),typeof u.copy=="function"&&(D+=8),typeof u.open=="function"&&typeof u.close=="function"&&typeof u.read=="function"&&typeof u.write=="function"&&((0,O.checkProposedApiEnabled)(m,"fsChunks"),D+=4),this._proxy.$registerFileSystemProvider(v,a,D).catch(b=>{console.error(`FAILED to register filesystem provider of ${m.identifier.value}-extension for the scheme ${a}`),console.error(b)});const c=u.onDidChangeFile(b=>{const t=[];for(const l of b){const{uri:i,type:n}=l;if(i.scheme!==a)continue;let o;switch(n){case N.FileChangeType.Changed:o=0;break;case N.FileChangeType.Created:o=1;break;case N.FileChangeType.Deleted:o=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:i,type:o})}this._proxy.$onFileSystemChange(v,t)});return(0,S.toDisposable)(()=>{c.dispose(),this._linkProvider.delete(a),this._registeredSchemes.delete(a),this._fsProvider.delete(v),this._proxy.$unregisterProvider(v)})}static _asIStat(m){const{type:a,ctime:u,mtime:d,size:v,permissions:D}=m;return{type:a,ctime:u,mtime:d,size:v,permissions:D}}$stat(m,a){return Promise.resolve(this._getFsProvider(m).stat(r.URI.revive(a))).then(u=>g._asIStat(u))}$readdir(m,a){return Promise.resolve(this._getFsProvider(m).readDirectory(r.URI.revive(a)))}$readFile(m,a){return Promise.resolve(this._getFsProvider(m).readFile(r.URI.revive(a))).then(u=>P.VSBuffer.wrap(u))}$writeFile(m,a,u,d){return Promise.resolve(this._getFsProvider(m).writeFile(r.URI.revive(a),u.buffer,d))}$delete(m,a,u){return Promise.resolve(this._getFsProvider(m).delete(r.URI.revive(a),u))}$rename(m,a,u,d){return Promise.resolve(this._getFsProvider(m).rename(r.URI.revive(a),r.URI.revive(u),d))}$copy(m,a,u,d){const v=this._getFsProvider(m);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(r.URI.revive(a),r.URI.revive(u),d))}$mkdir(m,a){return Promise.resolve(this._getFsProvider(m).createDirectory(r.URI.revive(a)))}$watch(m,a,u,d){const v=this._getFsProvider(m).watch(r.URI.revive(u),d);this._watches.set(a,v)}$unwatch(m,a){const u=this._watches.get(a);u&&(u.dispose(),this._watches.delete(a))}$open(m,a,u){const d=this._getFsProvider(m);if(!d.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(d.open(r.URI.revive(a),u))}$close(m,a){const u=this._getFsProvider(m);if(!u.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(u.close(a))}$read(m,a,u,d){const v=this._getFsProvider(m);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const D=P.VSBuffer.alloc(d);return Promise.resolve(v.read(a,u,D.buffer,0,d)).then(c=>D.slice(0,c))}$write(m,a,u,d){const v=this._getFsProvider(m);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(a,u,d.buffer,0,d.byteLength))}_getFsProvider(m){const a=this._fsProvider.get(m);if(!a){const u=new Error;throw u.name="ENOPRO",u.message="no provider",u}return a}}e.ExtHostFileSystem=g}),define(Ce[52],Ie([1,0,4,35,6,23,3,11,36,7]),function(ie,e,r,C,S,N,_,A,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let O=class Gt{constructor(g,k){this._fileSystemProvider=new Map,this._proxy=g.getProxy(r.MainContext.MainThreadFileSystem);const m=this;this.value=Object.freeze({async stat(a){try{const u=m._fileSystemProvider.get(a.scheme);if(!u)return await m._proxy.$stat(a);await m._proxy.$ensureActivation(a.scheme);const d=await u.stat(a);return{type:d.type,ctime:d.ctime,mtime:d.mtime,size:d.size,permissions:d.permissions}}catch(u){Gt._handleError(u)}},async readDirectory(a){try{const u=m._fileSystemProvider.get(a.scheme);return u?(await m._proxy.$ensureActivation(a.scheme),(await u.readDirectory(a)).slice()):await m._proxy.$readdir(a)}catch(u){return Gt._handleError(u)}},async createDirectory(a){try{return await m._proxy.$mkdir(a)}catch(u){return Gt._handleError(u)}},async readFile(a){try{const u=m._fileSystemProvider.get(a.scheme);return u?(await m._proxy.$ensureActivation(a.scheme),(await u.readFile(a)).slice()):(await m._proxy.$readFile(a)).buffer}catch(u){return Gt._handleError(u)}},async writeFile(a,u){try{return await m._proxy.$writeFile(a,N.VSBuffer.wrap(u))}catch(d){return Gt._handleError(d)}},async delete(a,u){try{const d=m._fileSystemProvider.get(a.scheme);return d?(await m._proxy.$ensureActivation(a.scheme),await d.delete(a,{recursive:!1,...u})):await m._proxy.$delete(a,{recursive:!1,useTrash:!1,...u})}catch(d){return Gt._handleError(d)}},async rename(a,u,d){try{return await m._proxy.$rename(a,u,{overwrite:!1,...d})}catch(v){return Gt._handleError(v)}},async copy(a,u,d){try{return await m._proxy.$copy(a,u,{overwrite:!1,...d})}catch(v){return Gt._handleError(v)}},isWritableFileSystem(a){const u=k.getCapabilities(a);if(typeof u=="number")return!(u&2048)}})}static _handleError(g){if(g instanceof S.FileSystemError)throw g;if(!(g instanceof Error))throw new S.FileSystemError(String(g));if(g.name==="ENOPRO")throw S.FileSystemError.Unavailable(g.message);switch(g.name){case C.FileSystemProviderErrorCode.FileExists:throw S.FileSystemError.FileExists(g.message);case C.FileSystemProviderErrorCode.FileNotFound:throw S.FileSystemError.FileNotFound(g.message);case C.FileSystemProviderErrorCode.FileNotADirectory:throw S.FileSystemError.FileNotADirectory(g.message);case C.FileSystemProviderErrorCode.FileIsADirectory:throw S.FileSystemError.FileIsADirectory(g.message);case C.FileSystemProviderErrorCode.NoPermissions:throw S.FileSystemError.NoPermissions(g.message);case C.FileSystemProviderErrorCode.Unavailable:throw S.FileSystemError.Unavailable(g.message);default:throw new S.FileSystemError(g.message,g.name)}}addFileSystemProvider(g,k){return this._fileSystemProvider.set(g,k),(0,P.toDisposable)(()=>this._fileSystemProvider.delete(g))}};O=ze([$e(0,A.IExtHostRpcService),$e(1,E.IExtHostFileSystemInfo)],O),e.ExtHostConsumerFileSystem=O,e.IExtHostConsumerFileSystem=(0,_.createDecorator)("IExtHostConsumerFileSystem")}),define(Ce[199],Ie([1,0,5,34,2,4,8,6]),function(ie,e,r,C,S,N,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class E{get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}constructor(w,g,k,m,a,u,d,v){this._onDidCreate=new r.Emitter,this._onDidChange=new r.Emitter,this._onDidDelete=new r.Emitter;const D=this.ensureWatching(w,k,a);this._config=0,u&&(this._config+=1),d&&(this._config+=2),v&&(this._config+=4);const c=(0,C.parse)(a),b=typeof a=="string",t=m(l=>{if(!u)for(const i of l.created){const n=S.URI.revive(i);c(n.fsPath)&&(!b||g.getWorkspaceFolder(n))&&this._onDidCreate.fire(n)}if(!d)for(const i of l.changed){const n=S.URI.revive(i);c(n.fsPath)&&(!b||g.getWorkspaceFolder(n))&&this._onDidChange.fire(n)}if(!v)for(const i of l.deleted){const n=S.URI.revive(i);c(n.fsPath)&&(!b||g.getWorkspaceFolder(n))&&this._onDidDelete.fire(n)}});this._disposable=A.Disposable.from(D,this._onDidCreate,this._onDidChange,this._onDidDelete,t)}ensureWatching(w,g,k){const m=A.Disposable.from();if(typeof k=="string")return m;const a=w.getProxy(N.MainContext.MainThreadFileSystem);let u=!1;(k.pattern.includes(C.GLOBSTAR)||k.pattern.includes(C.GLOB_SPLIT))&&(u=!0);const d=Math.random();return a.$watch(g.identifier.value,d,k.baseUri,{recursive:u,excludes:[]}),A.Disposable.from({dispose:()=>a.$unwatch(d)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class P{constructor(w,g,k){this._mainContext=w,this._logService=g,this._extHostDocumentsAndEditors=k,this._onFileSystemEvent=new r.Emitter,this._onDidRenameFile=new r.Emitter,this._onDidCreateFile=new r.Emitter,this._onDidDeleteFile=new r.Emitter,this._onWillRenameFile=new r.AsyncEmitter,this._onWillCreateFile=new r.AsyncEmitter,this._onWillDeleteFile=new r.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(w,g,k,m,a,u){return new E(this._mainContext,w,g,this._onFileSystemEvent.event,_.GlobPattern.from(k),m,a,u)}$onFileEvent(w){this._onFileSystemEvent.fire(w)}$onDidRunFileOperation(w,g){switch(w){case 2:this._onDidRenameFile.fire(Object.freeze({files:g.map(k=>({oldUri:S.URI.revive(k.source),newUri:S.URI.revive(k.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:g.map(k=>S.URI.revive(k.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:g.map(k=>S.URI.revive(k.target))}));break;default:}}getOnWillRenameFileEvent(w){return this._createWillExecuteEvent(w,this._onWillRenameFile)}getOnWillCreateFileEvent(w){return this._createWillExecuteEvent(w,this._onWillCreateFile)}getOnWillDeleteFileEvent(w){return this._createWillExecuteEvent(w,this._onWillDeleteFile)}_createWillExecuteEvent(w,g){return(k,m,a)=>{const u=function(v){k.call(m,v)};return u.extension=w,g.event(u,void 0,a)}}async $onWillRunFileOperation(w,g,k,m){switch(w){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:g.map(a=>({oldUri:S.URI.revive(a.source),newUri:S.URI.revive(a.target)}))},k,m);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:g.map(a=>S.URI.revive(a.target))},k,m);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:g.map(a=>S.URI.revive(a.target))},k,m)}}async _fireWillEvent(w,g,k,m){const a=new Set,u=[];if(await w.fireAsync(g,m,async(v,D)=>{const c=Date.now(),b=await Promise.resolve(v);b instanceof A.WorkspaceEdit&&(u.push([D.extension,b]),a.add(D.extension.displayName??D.extension.identifier.value)),Date.now()-c>k&&this._logService.warn("SLOW file-participant",D.extension.identifier)}),m.isCancellationRequested||u.length===0)return;const d={edits:[]};for(const[,v]of u){const{edits:D}=_.WorkspaceEdit.from(v,{getTextDocumentVersion:c=>this._extHostDocumentsAndEditors.getDocument(c)?.version,getNotebookDocumentVersion:()=>{}});d.edits=d.edits.concat(D)}return{edit:d,extensionNames:Array.from(a)}}}e.ExtHostFileSystemEventService=P}),define(Ce[200],Ie([1,0,2,37]),function(ie,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class S{constructor(_,A,E,P,O){this._extHostNotebooks=A,this._textDocumentsAndEditors=E,this._commands=P;const w=new C.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new C.ApiCommandArgument("showOptions","Show Options",g=>!0,g=>g),new C.ApiCommandArgument("resource","Interactive resource Uri",g=>!0,g=>g),new C.ApiCommandArgument("controllerId","Notebook controller Id",g=>!0,g=>g),new C.ApiCommandArgument("title","Interactive editor title",g=>!0,g=>g)],new C.ApiCommandResult("Notebook and input URI",g=>{if(O.debug("[ExtHostInteractive] open iw with notebook editor id",g.notebookEditorId),g.notebookEditorId!==void 0){const k=this._extHostNotebooks.getEditorById(g.notebookEditorId);return O.debug("[ExtHostInteractive] notebook editor found",k.id),{notebookUri:r.URI.revive(g.notebookUri),inputUri:r.URI.revive(g.inputUri),notebookEditor:k.apiEditor}}return O.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",g.notebookUri,g.inputUri),{notebookUri:r.URI.revive(g.notebookUri),inputUri:r.URI.revive(g.inputUri)}}));this._commands.registerApiCommand(w)}$willAddInteractiveDocument(_,A,E,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:E,uri:_,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(r.URI.revive(P))?.apiNotebook}]})}$willRemoveInteractiveDocument(_,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[_]})}}e.ExtHostInteractive=S}),define(Ce[201],Ie([1,0,7,4]),function(ie,e,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class S{constructor(_){this._handlePool=0,this._proxy=_.getProxy(C.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(_){const A=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(A,_),(0,r.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=S}),define(Ce[202],Ie([1,0,2,25,8,6,66,4,9,49,18,10,245,20,7,79,74,61,203,12,15,28]),function(ie,e,r,C,S,N,_,A,E,P,O,w,g,k,m,a,u,d,v,D,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class t{constructor(I,B){this._documents=I,this._provider=B}async provideDocumentSymbols(I,B){const H=this._documents.getDocument(I),j=await this._provider.provideDocumentSymbols(H,B);if(!(0,O.isFalsyOrEmpty)(j))return j[0]instanceof N.DocumentSymbol?j.map(S.DocumentSymbol.from):t._asDocumentSymbolTree(j)}static _asDocumentSymbolTree(I){I=I.slice(0).sort((j,se)=>{let le=j.location.range.start.compareTo(se.location.range.start);return le===0&&(le=se.location.range.end.compareTo(j.location.range.end)),le});const B=[],H=[];for(const j of I){const se={name:j.name||"!!MISSING: name!!",kind:S.SymbolKind.from(j.kind),tags:j.tags?.map(S.SymbolTag.from)||[],detail:"",containerName:j.containerName,range:S.Range.from(j.location.range),selectionRange:S.Range.from(j.location.range),children:[]};for(;;){if(H.length===0){H.push(se),B.push(se);break}const le=H[H.length-1];if(P.Range.containsRange(le.range,se.range)&&!P.Range.equalsRange(le.range,se.range)){le.children?.push(se),H.push(se);break}H.pop()}}return B}}class l{constructor(I,B,H){this._documents=I,this._commands=B,this._provider=H,this._cache=new d.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(I,B){const H=this._documents.getDocument(I),j=await this._provider.provideCodeLenses(H,B);if(!j||B.isCancellationRequested)return;const se=this._cache.add(j),le=new m.DisposableStore;this._disposables.set(se,le);const Y={cacheId:se,lenses:[]};for(let ve=0;ve<j.length;ve++)Y.lenses.push({cacheId:[se,ve],range:S.Range.from(j[ve].range),command:this._commands.toInternal(j[ve].command,le)});return Y}async resolveCodeLens(I,B){const H=I.cacheId&&this._cache.get(...I.cacheId);if(!H)return;let j;if(typeof this._provider.resolveCodeLens!="function"||H.isResolved?j=H:j=await this._provider.resolveCodeLens(H,B),j||(j=H),B.isCancellationRequested)return;const se=I.cacheId&&this._disposables.get(I.cacheId[0]);if(!!se)return I.command=this._commands.toInternal(j.command??l._badCmd,se),I}releaseCodeLenses(I){this._disposables.get(I)?.dispose(),this._disposables.delete(I),this._cache.delete(I)}}l._badCmd={command:"missing",title:"!!MISSING: command!!"};function i(J){return Array.isArray(J)?J.map(S.DefinitionLink.from):J?[S.DefinitionLink.from(J)]:[]}class n{constructor(I,B){this._documents=I,this._provider=B}async provideDefinition(I,B,H){const j=this._documents.getDocument(I),se=S.Position.to(B),le=await this._provider.provideDefinition(j,se,H);return i(le)}}class o{constructor(I,B){this._documents=I,this._provider=B}async provideDeclaration(I,B,H){const j=this._documents.getDocument(I),se=S.Position.to(B),le=await this._provider.provideDeclaration(j,se,H);return i(le)}}class f{constructor(I,B){this._documents=I,this._provider=B}async provideImplementation(I,B,H){const j=this._documents.getDocument(I),se=S.Position.to(B),le=await this._provider.provideImplementation(j,se,H);return i(le)}}class s{constructor(I,B){this._documents=I,this._provider=B}async provideTypeDefinition(I,B,H){const j=this._documents.getDocument(I),se=S.Position.to(B),le=await this._provider.provideTypeDefinition(j,se,H);return i(le)}}class h{constructor(I,B){this._documents=I,this._provider=B}async provideHover(I,B,H){const j=this._documents.getDocument(I),se=S.Position.to(B),le=await this._provider.provideHover(j,se,H);if(!(!le||(0,O.isFalsyOrEmpty)(le.contents)))return le.range||(le.range=j.getWordRangeAtPosition(se)),le.range||(le.range=new N.Range(se,se)),S.Hover.from(le)}}class p{constructor(I,B){this._documents=I,this._provider=B}async provideEvaluatableExpression(I,B,H){const j=this._documents.getDocument(I),se=S.Position.to(B),le=await this._provider.provideEvaluatableExpression(j,se,H);if(le)return S.EvaluatableExpression.from(le)}}class T{constructor(I,B){this._documents=I,this._provider=B}async provideInlineValues(I,B,H,j){const se=this._documents.getDocument(I),le=await this._provider.provideInlineValues(se,S.Range.to(B),S.InlineValueContext.to(H),j);if(Array.isArray(le))return le.map(Y=>S.InlineValue.from(Y))}}class M{constructor(I,B){this._documents=I,this._provider=B}async provideDocumentHighlights(I,B,H){const j=this._documents.getDocument(I),se=S.Position.to(B),le=await this._provider.provideDocumentHighlights(j,se,H);if(Array.isArray(le))return le.map(S.DocumentHighlight.from)}}class V{constructor(I,B){this._documents=I,this._provider=B}async provideLinkedEditingRanges(I,B,H){const j=this._documents.getDocument(I),se=S.Position.to(B),le=await this._provider.provideLinkedEditingRanges(j,se,H);if(le&&Array.isArray(le.ranges))return{ranges:(0,O.coalesce)(le.ranges.map(S.Range.from)),wordPattern:le.wordPattern}}}class U{constructor(I,B){this._documents=I,this._provider=B}async provideReferences(I,B,H,j){const se=this._documents.getDocument(I),le=S.Position.to(B),Y=await this._provider.provideReferences(se,le,H,j);if(Array.isArray(Y))return Y.map(S.location.from)}}class y{constructor(I,B,H,j,se,le,Y){this._documents=I,this._commands=B,this._diagnostics=H,this._provider=j,this._logService=se,this._extension=le,this._apiDeprecation=Y,this._cache=new d.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(I,B,H,j){const se=this._documents.getDocument(I),le=g.Selection.isISelection(B)?S.Selection.to(B):S.Range.to(B),Y=[];for(const Ge of this._diagnostics.getDiagnostics(I))if(le.intersection(Ge.range)&&Y.push(Ge)>y._maxCodeActionsPerFile)break;const ve={diagnostics:Y,only:H.only?new N.CodeActionKind(H.only):void 0,triggerKind:S.CodeActionTriggerKind.to(H.trigger)},pe=await this._provider.provideCodeActions(se,le,ve,j);if(!(0,O.isNonEmptyArray)(pe)||j.isCancellationRequested)return;const Ne=this._cache.add(pe),xe=new m.DisposableStore;this._disposables.set(Ne,xe);const Ye=[];for(let Ge=0;Ge<pe.length;Ge++){const Te=pe[Ge];!Te||(y._isCommand(Te)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ye.push({_isSynthetic:!0,title:Te.title,command:this._commands.toInternal(Te,xe)})):(ve.only&&(Te.kind?ve.only.contains(Te.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ve.only.value} 'requested but returned code action is of kind '${Te.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ve.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ye.push({cacheId:[Ne,Ge],title:Te.title,command:Te.command&&this._commands.toInternal(Te.command,xe),diagnostics:Te.diagnostics&&Te.diagnostics.map(S.Diagnostic.from),edit:Te.edit&&S.WorkspaceEdit.from(Te.edit,void 0),kind:Te.kind&&Te.kind.value,isPreferred:Te.isPreferred,disabled:Te.disabled?.reason})))}return{cacheId:Ne,actions:Ye}}async resolveCodeAction(I,B){const[H,j]=I,se=this._cache.get(H,j);if(!se||y._isCommand(se)||!this._provider.resolveCodeAction)return;const le=await this._provider.resolveCodeAction(se,B)??se;return le?.edit?S.WorkspaceEdit.from(le.edit,void 0):void 0}releaseCodeActions(I){this._disposables.get(I)?.dispose(),this._disposables.delete(I),this._cache.delete(I)}static _isCommand(I){return typeof I.command=="string"&&typeof I.title=="string"}}y._maxCodeActionsPerFile=1e3;class x{constructor(I,B,H,j){this._proxy=I,this._documents=B,this._provider=H,this._handle=j}async prepareDocumentPaste(I,B,H,j){if(!this._provider.prepareDocumentPaste)return;const se=this._documents.getDocument(I),le=B.map(ve=>S.Range.to(ve)),Y=S.DataTransfer.toDataTransfer(H,()=>{throw new D.NotImplementedError});return await this._provider.prepareDocumentPaste(se,le,Y,j),S.DataTransfer.toDataTransferDTO(Y)}async providePasteEdits(I,B,H,j,se){const le=this._documents.getDocument(B),Y=H.map(Ne=>S.Range.to(Ne)),ve=S.DataTransfer.toDataTransfer(j,async Ne=>(await this._proxy.$resolvePasteFileData(this._handle,I,Ne)).buffer),pe=await this._provider.provideDocumentPasteEdits(le,Y,ve,se);if(!!pe)return{insertText:typeof pe.insertText=="string"?pe.insertText:{snippet:pe.insertText.value},additionalEdit:pe.additionalEdit?S.WorkspaceEdit.from(pe.additionalEdit,void 0):void 0}}}class L{constructor(I,B){this._documents=I,this._provider=B}async provideDocumentFormattingEdits(I,B,H){const j=this._documents.getDocument(I),se=await this._provider.provideDocumentFormattingEdits(j,B,H);if(Array.isArray(se))return se.map(S.TextEdit.from)}}class R{constructor(I,B){this._documents=I,this._provider=B}async provideDocumentRangeFormattingEdits(I,B,H,j){const se=this._documents.getDocument(I),le=S.Range.to(B),Y=await this._provider.provideDocumentRangeFormattingEdits(se,le,H,j);if(Array.isArray(Y))return Y.map(S.TextEdit.from)}}class K{constructor(I,B){this._documents=I,this._provider=B,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(I,B,H,j,se){const le=this._documents.getDocument(I),Y=S.Position.to(B),ve=await this._provider.provideOnTypeFormattingEdits(le,Y,H,j,se);if(Array.isArray(ve))return ve.map(S.TextEdit.from)}}class W{constructor(I,B){this._provider=I,this._logService=B,this._cache=new d.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(I,B){const H=await this._provider.provideWorkspaceSymbols(I,B);if(!(0,O.isNonEmptyArray)(H))return{symbols:[]};const j=this._cache.add(H),se={cacheId:j,symbols:[]};for(let le=0;le<H.length;le++){const Y=H[le];if(!Y||!Y.name){this._logService.warn("INVALID SymbolInformation",Y);continue}se.symbols.push({...S.WorkspaceSymbol.from(Y),cacheId:[j,le]})}return se}async resolveWorkspaceSymbol(I,B){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!I.cacheId)return I;const H=this._cache.get(...I.cacheId);if(H){const j=await this._provider.resolveWorkspaceSymbol(H,B);return j&&(0,C.mixin)(I,S.WorkspaceSymbol.from(j),!0)}}releaseWorkspaceSymbols(I){this._cache.delete(I)}}class ${static supportsResolving(I){return typeof I.prepareRename=="function"}constructor(I,B,H){this._documents=I,this._provider=B,this._logService=H}async provideRenameEdits(I,B,H,j){const se=this._documents.getDocument(I),le=S.Position.to(B);try{const Y=await this._provider.provideRenameEdits(se,le,H,j);return Y?S.WorkspaceEdit.from(Y):void 0}catch(Y){const ve=$._asMessage(Y);return ve?{rejectReason:ve,edits:void 0}:Promise.reject(Y)}}async resolveRenameLocation(I,B,H){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const j=this._documents.getDocument(I),se=S.Position.to(B);try{const le=await this._provider.prepareRename(j,se,H);let Y,ve;if(N.Range.isRange(le)?(Y=le,ve=j.getText(le)):(0,w.isObject)(le)&&(Y=le.range,ve=le.placeholder),!Y||!ve)return;if(Y.start.line>se.line||Y.end.line<se.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:S.Range.from(Y),text:ve}}catch(le){const Y=$._asMessage(le);return Y?{rejectReason:Y,range:void 0,text:void 0}:Promise.reject(le)}}static _asMessage(I){return typeof I=="string"?I:I instanceof Error&&typeof I.message=="string"?I.message:void 0}}class G{constructor(I,B){this.resultId=I,this.tokens=B}}class re{constructor(I,B){this._documents=I,this._provider=B,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(I,B,H){const j=this._documents.getDocument(I),se=B!==0?this._previousResults.get(B):null;let le=typeof se?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(j,se.resultId,H):await this._provider.provideDocumentSemanticTokens(j,H);return se&&this._previousResults.delete(B),le?(le=re._fixProvidedSemanticTokens(le),this._send(re._convertToEdits(se,le),le)):null}async releaseDocumentSemanticColoring(I){this._previousResults.delete(I)}static _fixProvidedSemanticTokens(I){return re._isSemanticTokens(I)?re._isCorrectSemanticTokens(I)?I:new N.SemanticTokens(new Uint32Array(I.data),I.resultId):re._isSemanticTokensEdits(I)?re._isCorrectSemanticTokensEdits(I)?I:new N.SemanticTokensEdits(I.edits.map(B=>new N.SemanticTokensEdit(B.start,B.deleteCount,B.data?new Uint32Array(B.data):B.data)),I.resultId):I}static _isSemanticTokens(I){return I&&!!I.data}static _isCorrectSemanticTokens(I){return I.data instanceof Uint32Array}static _isSemanticTokensEdits(I){return I&&Array.isArray(I.edits)}static _isCorrectSemanticTokensEdits(I){for(const B of I.edits)if(!(B.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(I,B){if(!re._isSemanticTokens(B)||!I||!I.tokens)return B;const H=I.tokens,j=H.length,se=B.data,le=se.length;let Y=0;const ve=Math.min(j,le);for(;Y<ve&&H[Y]===se[Y];)Y++;if(Y===j&&Y===le)return new N.SemanticTokensEdits([],B.resultId);let pe=0;const Ne=ve-Y;for(;pe<Ne&&H[j-pe-1]===se[le-pe-1];)pe++;return new N.SemanticTokensEdits([{start:Y,deleteCount:j-Y-pe,data:se.subarray(Y,le-pe)}],B.resultId)}_send(I,B){if(re._isSemanticTokens(I)){const H=this._nextResultId++;return this._previousResults.set(H,new G(I.resultId,I.data)),(0,a.encodeSemanticTokensDto)({id:H,type:"full",data:I.data})}if(re._isSemanticTokensEdits(I)){const H=this._nextResultId++;return re._isSemanticTokens(B)?this._previousResults.set(H,new G(B.resultId,B.data)):this._previousResults.set(H,new G(I.resultId)),(0,a.encodeSemanticTokensDto)({id:H,type:"delta",deltas:(I.edits||[]).map(j=>({start:j.start,deleteCount:j.deleteCount,data:j.data}))})}return null}}e.DocumentSemanticTokensAdapter=re;class ge{constructor(I,B){this._documents=I,this._provider=B}async provideDocumentRangeSemanticTokens(I,B,H){const j=this._documents.getDocument(I),se=await this._provider.provideDocumentRangeSemanticTokens(j,S.Range.to(B),H);return se?this._send(se):null}_send(I){return(0,a.encodeSemanticTokensDto)({id:0,type:"full",data:I.data})}}e.DocumentRangeSemanticTokensAdapter=ge;class oe{static supportsResolving(I){return typeof I.resolveCompletionItem=="function"}constructor(I,B,H,j,se){this._documents=I,this._commands=B,this._provider=H,this._apiDeprecation=j,this._extension=se,this._cache=new d.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(I,B,H,j){const se=this._documents.getDocument(I),le=S.Position.to(B),Y=se.getWordRangeAtPosition(le)||new N.Range(le,le),ve=Y.with({end:le}),pe=new v.StopWatch(!0),Ne=await this._provider.provideCompletionItems(se,le,j,S.CompletionContext.to(H));if(!Ne||j.isCancellationRequested)return;const xe=Array.isArray(Ne)?new N.CompletionList(Ne):Ne,Ye=oe.supportsResolving(this._provider)?this._cache.add(xe.items):this._cache.add([]),Ge=new m.DisposableStore;this._disposables.set(Ye,Ge);const Te=[],rt={x:Ye,b:Te,a:{replace:S.Range.from(Y),insert:S.Range.from(ve)},c:xe.isIncomplete||void 0,d:pe.elapsed()};for(let X=0;X<xe.items.length;X++){const Q=xe.items[X],he=this._convertCompletionItem(Q,[Ye,X],ve,Y);Te.push(he)}return rt}async resolveCompletionItem(I,B){if(typeof this._provider.resolveCompletionItem!="function")return;const H=this._cache.get(...I);if(!H)return;const j=await this._provider.resolveCompletionItem(H,B);if(!!j)return this._convertCompletionItem(j,I)}releaseCompletionItems(I){this._disposables.get(I)?.dispose(),this._disposables.delete(I),this._cache.delete(I)}_convertCompletionItem(I,B,H,j){const se=this._disposables.get(B[0]);if(!se)throw Error("DisposableStore is missing...");const le={x:B,a:I.label,b:I.kind!==void 0?S.CompletionItemKind.from(I.kind):void 0,n:I.tags&&I.tags.map(S.CompletionItemTag.from),c:I.detail,d:typeof I.documentation>"u"?void 0:S.MarkdownString.fromStrict(I.documentation),e:I.sortText!==I.label?I.sortText:void 0,f:I.filterText!==I.label?I.filterText:void 0,g:I.preselect||void 0,i:I.keepWhitespace?1:0,k:I.commitCharacters,l:I.additionalTextEdits&&I.additionalTextEdits.map(S.TextEdit.from),m:this._commands.toInternal(I.command,se)};I.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),le.h=I.textEdit.newText):typeof I.insertText=="string"?le.h=I.insertText:I.insertText instanceof N.SnippetString&&(le.h=I.insertText.value,le.i|=4);let Y;return I.textEdit?Y=I.textEdit.range:I.range&&(Y=I.range),N.Range.isRange(Y)?le.j=S.Range.from(Y):Y&&(!H?.isEqual(Y.inserting)||!j?.isEqual(Y.replacing))&&(le.j={insert:S.Range.from(Y.inserting),replace:S.Range.from(Y.replacing)}),le}}class Ee{async provideInlineCompletions(I,B,H,j){}disposeCompletions(I){}handleDidShowCompletionItem(I,B){}}class ce extends Ee{constructor(I,B,H,j){super(),this._extension=I,this._documents=B,this._provider=H,this._commands=j,this._references=new ee,this._isAdditionsProposedApiEnabled=(0,b.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[_.InlineCompletionTriggerKind.Automatic]:N.InlineCompletionTriggerKind.Automatic,[_.InlineCompletionTriggerKind.Explicit]:N.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,b.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&typeof this._provider.handleDidShowCompletionItem=="function"}async provideInlineCompletions(I,B,H,j){const se=this._documents.getDocument(I),le=S.Position.to(B),Y=await this._provider.provideInlineCompletionItems(se,le,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:S.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[H.triggerKind]},j);if(!Y||j.isCancellationRequested)return;const ve=Array.isArray(Y)?Y:Y.items,pe=this._isAdditionsProposedApiEnabled?Array.isArray(Y)?[]:Y.commands||[]:[];let Ne;return{pid:this._references.createReferenceId({dispose(){Ne?.dispose()},items:ve}),items:ve.map((Ye,Ge)=>{let Te;Ye.command&&(Ne||(Ne=new m.DisposableStore),Te=this._commands.toInternal(Ye.command,Ne));const rt=Ye.insertText;return{insertText:typeof rt=="string"?rt:{snippet:rt.value},filterText:Ye.filterText,range:Ye.range?S.Range.from(Ye.range):void 0,command:Te,idx:Ge,completeBracketPairs:this._isAdditionsProposedApiEnabled?Ye.completeBracketPairs:!1}}),commands:pe.map(Ye=>(Ne||(Ne=new m.DisposableStore),this._commands.toInternal(Ye,Ne)))}}disposeCompletions(I){this._references.disposeReferenceId(I)?.dispose()}handleDidShowCompletionItem(I,B){const H=this._references.get(I)?.items[B];H&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(H)}}class me extends Ee{constructor(I,B,H,j){super(),this.extension=I,this._documents=B,this._provider=H,this._commands=j,this._references=new ee,this.isAdditionProposedApiEnabled=(0,b.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[_.InlineCompletionTriggerKind.Automatic]:N.InlineCompletionTriggerKindNew.Automatic,[_.InlineCompletionTriggerKind.Explicit]:N.InlineCompletionTriggerKindNew.Invoke}}async provideInlineCompletions(I,B,H,j){const se=this._documents.getDocument(I),le=S.Position.to(B),Y=await this._provider.provideInlineCompletionItems(se,le,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:S.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[H.triggerKind]},j);if(!Y||j.isCancellationRequested)return;const ve=Array.isArray(Y)?Y:Y.items,pe=Array.isArray(Y)?[]:Y.commands||[];let Ne;return{pid:this._references.createReferenceId({dispose(){Ne?.dispose()},items:ve}),items:ve.map((Ye,Ge)=>{let Te;Ye.command&&(Ne||(Ne=new m.DisposableStore),Te=this._commands.toInternal(Ye.command,Ne));const rt=Ye.insertText;return{insertText:typeof rt=="string"?rt:{snippet:rt.value},filterText:Ye.filterText,range:Ye.range?S.Range.from(Ye.range):void 0,command:Te,idx:Ge,completeBracketPairs:this.isAdditionProposedApiEnabled?Ye.completeBracketPairs:!1}}),commands:pe.map(Ye=>(Ne||(Ne=new m.DisposableStore),this._commands.toInternal(Ye,Ne)))}}disposeCompletions(I){this._references.disposeReferenceId(I)?.dispose()}handleDidShowCompletionItem(I,B){const H=this._references.get(I)?.items[B];H&&this._provider.handleDidShowCompletionItem&&this.isAdditionProposedApiEnabled&&this._provider.handleDidShowCompletionItem(H)}}class ee{constructor(){this._references=new Map,this._idPool=1}createReferenceId(I){const B=this._idPool++;return this._references.set(B,I),B}disposeReferenceId(I){const B=this._references.get(I);return this._references.delete(I),B}get(I){return this._references.get(I)}}class be{constructor(I,B){this._documents=I,this._provider=B,this._cache=new d.Cache("SignatureHelp")}async provideSignatureHelp(I,B,H,j){const se=this._documents.getDocument(I),le=S.Position.to(B),Y=this.reviveContext(H),ve=await this._provider.provideSignatureHelp(se,le,j,Y);if(ve){const pe=this._cache.add([ve]);return{...S.SignatureHelp.from(ve),id:pe}}}reviveContext(I){let B;if(I.activeSignatureHelp){const H=S.SignatureHelp.to(I.activeSignatureHelp),j=this._cache.get(I.activeSignatureHelp.id,0);j?(B=j,B.activeSignature=H.activeSignature,B.activeParameter=H.activeParameter):B=H}return{...I,activeSignatureHelp:B}}releaseSignatureHelp(I){this._cache.delete(I)}}class _e{constructor(I,B,H,j,se){this._documents=I,this._commands=B,this._provider=H,this._logService=j,this._extension=se,this._cache=new d.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(I,B,H){const j=this._documents.getDocument(I),se=S.Range.to(B),le=await this._provider.provideInlayHints(j,se,H);if(!Array.isArray(le)||le.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${B}`);return}if(H.isCancellationRequested)return;const Y=this._cache.add(le);this._disposables.set(Y,new m.DisposableStore);const ve={hints:[],cacheId:Y};for(let pe=0;pe<le.length;pe++)this._isValidInlayHint(le[pe],se)&&ve.hints.push(this._convertInlayHint(le[pe],[Y,pe]));return this._logService.trace(`[InlayHints] ${ve.hints.length} inlay hints from '${this._extension.identifier.value}' for ${B}`),ve}async resolveInlayHint(I,B){if(typeof this._provider.resolveInlayHint!="function")return;const H=this._cache.get(...I);if(!H)return;const j=await this._provider.resolveInlayHint(H,B);if(!!j&&!!this._isValidInlayHint(j))return this._convertInlayHint(j,I)}releaseHints(I){this._disposables.get(I)?.dispose(),this._disposables.delete(I),this._cache.delete(I)}_isValidInlayHint(I,B){return I.label.length===0||Array.isArray(I.label)&&I.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",I),!1):!(B&&!B.contains(I.position))}_convertInlayHint(I,B){const H=this._disposables.get(B[0]);if(!H)throw Error("DisposableStore is missing...");const j={label:"",cacheId:B,tooltip:S.MarkdownString.fromStrict(I.tooltip),position:S.Position.from(I.position),textEdits:I.textEdits&&I.textEdits.map(S.TextEdit.from),kind:I.kind&&S.InlayHintKind.from(I.kind),paddingLeft:I.paddingLeft,paddingRight:I.paddingRight};return typeof I.label=="string"?j.label=I.label:j.label=I.label.map(se=>{const le={label:se.value};return le.tooltip=S.MarkdownString.fromStrict(se.tooltip),N.Location.isLocation(se.location)&&(le.location=S.location.from(se.location)),se.command&&(le.command=this._commands.toInternal(se.command,H)),le}),j}}class Fe{constructor(I,B){this._documents=I,this._provider=B,this._cache=new d.Cache("DocumentLink")}async provideLinks(I,B){const H=this._documents.getDocument(I),j=await this._provider.provideDocumentLinks(H,B);if(!(!Array.isArray(j)||j.length===0)&&!B.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:j.filter(Fe._validateLink).map(S.DocumentLink.from)};{const se=this._cache.add(j),le={links:[],cacheId:se};for(let Y=0;Y<j.length;Y++){if(!Fe._validateLink(j[Y]))continue;const ve=S.DocumentLink.from(j[Y]);ve.cacheId=[se,Y],le.links.push(ve)}return le}}}static _validateLink(I){return I.target&&I.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(I,B){if(typeof this._provider.resolveDocumentLink!="function")return;const H=this._cache.get(...I);if(!H)return;const j=await this._provider.resolveDocumentLink(H,B);if(!(!j||!Fe._validateLink(j)))return S.DocumentLink.from(j)}releaseLinks(I){this._cache.delete(I)}}class Be{constructor(I,B){this._documents=I,this._provider=B}async provideColors(I,B){const H=this._documents.getDocument(I),j=await this._provider.provideDocumentColors(H,B);return Array.isArray(j)?j.map(le=>({color:S.Color.from(le.color),range:S.Range.from(le.range)})):[]}async provideColorPresentations(I,B,H){const j=this._documents.getDocument(I),se=S.Range.to(B.range),le=S.Color.to(B.color),Y=await this._provider.provideColorPresentations(le,{document:j,range:se},H);if(!!Array.isArray(Y))return Y.map(S.ColorPresentation.from)}}class Xe{constructor(I,B){this._documents=I,this._provider=B}async provideFoldingRanges(I,B,H){const j=this._documents.getDocument(I),se=await this._provider.provideFoldingRanges(j,B,H);if(!!Array.isArray(se))return se.map(S.FoldingRange.from)}}class ke{constructor(I,B,H){this._documents=I,this._provider=B,this._logService=H}async provideSelectionRanges(I,B,H){const j=this._documents.getDocument(I),se=B.map(S.Position.to),le=await this._provider.provideSelectionRanges(j,se,H);if(!(0,O.isNonEmptyArray)(le))return[];if(le.length!==se.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Y=[];for(let ve=0;ve<se.length;ve++){const pe=[];Y.push(pe);let Ne=se[ve],xe=le[ve];for(;;){if(!xe.range.contains(Ne))throw new Error("INVALID selection range, must contain the previous range");if(pe.push(S.SelectionRange.from(xe)),!xe.parent)break;Ne=xe.range,xe=xe.parent}}return Y}}class ye{constructor(I,B){this._documents=I,this._provider=B,this._idPool=new u.IdGenerator(""),this._cache=new Map}async prepareSession(I,B,H){const j=this._documents.getDocument(I),se=S.Position.to(B),le=await this._provider.prepareCallHierarchy(j,se,H);if(!le)return;const Y=this._idPool.nextId();return this._cache.set(Y,new Map),Array.isArray(le)?le.map(ve=>this._cacheAndConvertItem(Y,ve)):[this._cacheAndConvertItem(Y,le)]}async provideCallsTo(I,B,H){const j=this._itemFromCache(I,B);if(!j)throw new Error("missing call hierarchy item");const se=await this._provider.provideCallHierarchyIncomingCalls(j,H);if(!!se)return se.map(le=>({from:this._cacheAndConvertItem(I,le.from),fromRanges:le.fromRanges.map(Y=>S.Range.from(Y))}))}async provideCallsFrom(I,B,H){const j=this._itemFromCache(I,B);if(!j)throw new Error("missing call hierarchy item");const se=await this._provider.provideCallHierarchyOutgoingCalls(j,H);if(!!se)return se.map(le=>({to:this._cacheAndConvertItem(I,le.to),fromRanges:le.fromRanges.map(Y=>S.Range.from(Y))}))}releaseSession(I){this._cache.delete(I)}_cacheAndConvertItem(I,B){const H=this._cache.get(I),j=S.CallHierarchyItem.from(B,I,H.size.toString(36));return H.set(j._itemId,B),j}_itemFromCache(I,B){return this._cache.get(I)?.get(B)}}class De{constructor(I,B){this._documents=I,this._provider=B,this._idPool=new u.IdGenerator(""),this._cache=new Map}async prepareSession(I,B,H){const j=this._documents.getDocument(I),se=S.Position.to(B),le=await this._provider.prepareTypeHierarchy(j,se,H);if(!le)return;const Y=this._idPool.nextId();return this._cache.set(Y,new Map),Array.isArray(le)?le.map(ve=>this._cacheAndConvertItem(Y,ve)):[this._cacheAndConvertItem(Y,le)]}async provideSupertypes(I,B,H){const j=this._itemFromCache(I,B);if(!j)throw new Error("missing type hierarchy item");const se=await this._provider.provideTypeHierarchySupertypes(j,H);if(!!se)return se.map(le=>this._cacheAndConvertItem(I,le))}async provideSubtypes(I,B,H){const j=this._itemFromCache(I,B);if(!j)throw new Error("missing type hierarchy item");const se=await this._provider.provideTypeHierarchySubtypes(j,H);if(!!se)return se.map(le=>this._cacheAndConvertItem(I,le))}releaseSession(I){this._cache.delete(I)}_cacheAndConvertItem(I,B){const H=this._cache.get(I),j=S.TypeHierarchyItem.from(B,I,H.size.toString(36));return H.set(j._itemId,B),j}_itemFromCache(I,B){return this._cache.get(I)?.get(B)}}class ae{constructor(I,B,H,j){this._proxy=I,this._documents=B,this._provider=H,this._handle=j}async provideDocumentOnDropEdits(I,B,H,j,se){const le=this._documents.getDocument(B),Y=S.Position.to(H),ve=S.DataTransfer.toDataTransfer(j,async Ne=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,I,Ne)).buffer),pe=await this._provider.provideDocumentDropEdits(le,Y,ve,se);if(!!pe)return{insertText:typeof pe.insertText=="string"?pe.insertText:{snippet:pe.insertText.value},additionalEdit:pe.additionalEdit?S.WorkspaceEdit.from(pe.additionalEdit,void 0):void 0}}}class ue{constructor(I,B){this.adapter=I,this.extension=B}}class Z{constructor(I,B,H,j,se,le,Y){this._adapter=new Map,this._uriTransformer=B,this._proxy=I.getProxy(A.MainContext.MainThreadLanguageFeatures),this._documents=H,this._commands=j,this._diagnostics=se,this._logService=le,this._apiDeprecation=Y}_transformDocumentSelector(I){return S.DocumentSelector.from(I,this._uriTransformer)}_createDisposable(I){return new N.Disposable(()=>{this._adapter.delete(I),this._proxy.$unregister(I)})}_nextHandle(){return Z._handlePool++}async _withAdapter(I,B,H,j,se,le=!1){const Y=this._adapter.get(I);if(!Y||!(Y.adapter instanceof B))return j;const ve=Date.now();le||this._logService.trace(`[${Y.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const pe=H(Y.adapter,Y.extension);return Promise.resolve(pe).catch(Ne=>{(0,D.isCancellationError)(Ne)||(this._logService.error(`[${Y.extension.identifier.value}] provider FAILED`),this._logService.error(Ne))}).finally(()=>{le||this._logService.trace(`[${Y.extension.identifier.value}] provider DONE after ${Date.now()-ve}ms`)}),k.CancellationToken.isCancellationToken(se)?(0,c.raceCancellationError)(pe,se):pe}_addNewAdapter(I,B){const H=this._nextHandle();return this._adapter.set(H,new ue(I,B)),H}static _extLabel(I){return I.displayName||I.name}registerDocumentSymbolProvider(I,B,H,j){const se=this._addNewAdapter(new t(this._documents,H),I),le=j&&j.label||Z._extLabel(I);return this._proxy.$registerDocumentSymbolProvider(se,this._transformDocumentSelector(B),le),this._createDisposable(se)}$provideDocumentSymbols(I,B,H){return this._withAdapter(I,t,j=>j.provideDocumentSymbols(r.URI.revive(B),H),void 0,H)}registerCodeLensProvider(I,B,H){const j=this._nextHandle(),se=typeof H.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(j,new ue(new l(this._documents,this._commands.converter,H),I)),this._proxy.$registerCodeLensSupport(j,this._transformDocumentSelector(B),se);let le=this._createDisposable(j);if(se!==void 0){const Y=H.onDidChangeCodeLenses(ve=>this._proxy.$emitCodeLensEvent(se));le=N.Disposable.from(le,Y)}return le}$provideCodeLenses(I,B,H){return this._withAdapter(I,l,j=>j.provideCodeLenses(r.URI.revive(B),H),void 0,H)}$resolveCodeLens(I,B,H){return this._withAdapter(I,l,j=>j.resolveCodeLens(B,H),void 0,void 0)}$releaseCodeLenses(I,B){this._withAdapter(I,l,H=>Promise.resolve(H.releaseCodeLenses(B)),void 0,void 0)}registerDefinitionProvider(I,B,H){const j=this._addNewAdapter(new n(this._documents,H),I);return this._proxy.$registerDefinitionSupport(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideDefinition(I,B,H,j){return this._withAdapter(I,n,se=>se.provideDefinition(r.URI.revive(B),H,j),[],j)}registerDeclarationProvider(I,B,H){const j=this._addNewAdapter(new o(this._documents,H),I);return this._proxy.$registerDeclarationSupport(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideDeclaration(I,B,H,j){return this._withAdapter(I,o,se=>se.provideDeclaration(r.URI.revive(B),H,j),[],j)}registerImplementationProvider(I,B,H){const j=this._addNewAdapter(new f(this._documents,H),I);return this._proxy.$registerImplementationSupport(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideImplementation(I,B,H,j){return this._withAdapter(I,f,se=>se.provideImplementation(r.URI.revive(B),H,j),[],j)}registerTypeDefinitionProvider(I,B,H){const j=this._addNewAdapter(new s(this._documents,H),I);return this._proxy.$registerTypeDefinitionSupport(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideTypeDefinition(I,B,H,j){return this._withAdapter(I,s,se=>se.provideTypeDefinition(r.URI.revive(B),H,j),[],j)}registerHoverProvider(I,B,H,j){const se=this._addNewAdapter(new h(this._documents,H),I);return this._proxy.$registerHoverProvider(se,this._transformDocumentSelector(B)),this._createDisposable(se)}$provideHover(I,B,H,j){return this._withAdapter(I,h,se=>se.provideHover(r.URI.revive(B),H,j),void 0,j)}registerEvaluatableExpressionProvider(I,B,H,j){const se=this._addNewAdapter(new p(this._documents,H),I);return this._proxy.$registerEvaluatableExpressionProvider(se,this._transformDocumentSelector(B)),this._createDisposable(se)}$provideEvaluatableExpression(I,B,H,j){return this._withAdapter(I,p,se=>se.provideEvaluatableExpression(r.URI.revive(B),H,j),void 0,j)}registerInlineValuesProvider(I,B,H,j){const se=typeof H.onDidChangeInlineValues=="function"?this._nextHandle():void 0,le=this._addNewAdapter(new T(this._documents,H),I);this._proxy.$registerInlineValuesProvider(le,this._transformDocumentSelector(B),se);let Y=this._createDisposable(le);if(se!==void 0){const ve=H.onDidChangeInlineValues(pe=>this._proxy.$emitInlineValuesEvent(se));Y=N.Disposable.from(Y,ve)}return Y}$provideInlineValues(I,B,H,j,se){return this._withAdapter(I,T,le=>le.provideInlineValues(r.URI.revive(B),H,j,se),void 0,se)}registerDocumentHighlightProvider(I,B,H){const j=this._addNewAdapter(new M(this._documents,H),I);return this._proxy.$registerDocumentHighlightProvider(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideDocumentHighlights(I,B,H,j){return this._withAdapter(I,M,se=>se.provideDocumentHighlights(r.URI.revive(B),H,j),void 0,j)}registerLinkedEditingRangeProvider(I,B,H){const j=this._addNewAdapter(new V(this._documents,H),I);return this._proxy.$registerLinkedEditingRangeProvider(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideLinkedEditingRanges(I,B,H,j){return this._withAdapter(I,V,async se=>{const le=await se.provideLinkedEditingRanges(r.URI.revive(B),H,j);if(le)return{ranges:le.ranges,wordPattern:le.wordPattern?Z._serializeRegExp(le.wordPattern):void 0}},void 0,j)}registerReferenceProvider(I,B,H){const j=this._addNewAdapter(new U(this._documents,H),I);return this._proxy.$registerReferenceSupport(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideReferences(I,B,H,j,se){return this._withAdapter(I,U,le=>le.provideReferences(r.URI.revive(B),H,j,se),void 0,se)}registerCodeActionProvider(I,B,H,j){const se=new m.DisposableStore,le=this._addNewAdapter(new y(this._documents,this._commands.converter,this._diagnostics,H,this._logService,I,this._apiDeprecation),I);return this._proxy.$registerQuickFixSupport(le,this._transformDocumentSelector(B),{providedKinds:j?.providedCodeActionKinds?.map(Y=>Y.value),documentation:j?.documentation?.map(Y=>({kind:Y.kind.value,command:this._commands.converter.toInternal(Y.command,se)}))},Z._extLabel(I),Boolean(H.resolveCodeAction)),se.add(this._createDisposable(le)),se}$provideCodeActions(I,B,H,j,se){return this._withAdapter(I,y,le=>le.provideCodeActions(r.URI.revive(B),H,j,se),void 0,se)}$resolveCodeAction(I,B,H){return this._withAdapter(I,y,j=>j.resolveCodeAction(B,H),void 0,void 0)}$releaseCodeActions(I,B){this._withAdapter(I,y,H=>Promise.resolve(H.releaseCodeActions(B)),void 0,void 0)}registerDocumentFormattingEditProvider(I,B,H){const j=this._addNewAdapter(new L(this._documents,H),I);return this._proxy.$registerDocumentFormattingSupport(j,this._transformDocumentSelector(B),I.identifier,I.displayName||I.name),this._createDisposable(j)}$provideDocumentFormattingEdits(I,B,H,j){return this._withAdapter(I,L,se=>se.provideDocumentFormattingEdits(r.URI.revive(B),H,j),void 0,j)}registerDocumentRangeFormattingEditProvider(I,B,H){const j=this._addNewAdapter(new R(this._documents,H),I);return this._proxy.$registerRangeFormattingSupport(j,this._transformDocumentSelector(B),I.identifier,I.displayName||I.name),this._createDisposable(j)}$provideDocumentRangeFormattingEdits(I,B,H,j,se){return this._withAdapter(I,R,le=>le.provideDocumentRangeFormattingEdits(r.URI.revive(B),H,j,se),void 0,se)}registerOnTypeFormattingEditProvider(I,B,H,j){const se=this._addNewAdapter(new K(this._documents,H),I);return this._proxy.$registerOnTypeFormattingSupport(se,this._transformDocumentSelector(B),j,I.identifier),this._createDisposable(se)}$provideOnTypeFormattingEdits(I,B,H,j,se,le){return this._withAdapter(I,K,Y=>Y.provideOnTypeFormattingEdits(r.URI.revive(B),H,j,se,le),void 0,le)}registerWorkspaceSymbolProvider(I,B){const H=this._addNewAdapter(new W(B,this._logService),I);return this._proxy.$registerNavigateTypeSupport(H,typeof B.resolveWorkspaceSymbol=="function"),this._createDisposable(H)}$provideWorkspaceSymbols(I,B,H){return this._withAdapter(I,W,j=>j.provideWorkspaceSymbols(B,H),{symbols:[]},H)}$resolveWorkspaceSymbol(I,B,H){return this._withAdapter(I,W,j=>j.resolveWorkspaceSymbol(B,H),void 0,void 0)}$releaseWorkspaceSymbols(I,B){this._withAdapter(I,W,H=>H.releaseWorkspaceSymbols(B),void 0,void 0)}registerRenameProvider(I,B,H){const j=this._addNewAdapter(new $(this._documents,H,this._logService),I);return this._proxy.$registerRenameSupport(j,this._transformDocumentSelector(B),$.supportsResolving(H)),this._createDisposable(j)}$provideRenameEdits(I,B,H,j,se){return this._withAdapter(I,$,le=>le.provideRenameEdits(r.URI.revive(B),H,j,se),void 0,se)}$resolveRenameLocation(I,B,H,j){return this._withAdapter(I,$,se=>se.resolveRenameLocation(r.URI.revive(B),H,j),void 0,j)}registerDocumentSemanticTokensProvider(I,B,H,j){const se=this._addNewAdapter(new re(this._documents,H),I),le=typeof H.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(se,this._transformDocumentSelector(B),j,le);let Y=this._createDisposable(se);if(le){const ve=H.onDidChangeSemanticTokens(pe=>this._proxy.$emitDocumentSemanticTokensEvent(le));Y=N.Disposable.from(Y,ve)}return Y}$provideDocumentSemanticTokens(I,B,H,j){return this._withAdapter(I,re,se=>se.provideDocumentSemanticTokens(r.URI.revive(B),H,j),null,j)}$releaseDocumentSemanticTokens(I,B){this._withAdapter(I,re,H=>H.releaseDocumentSemanticColoring(B),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(I,B,H,j){const se=this._addNewAdapter(new ge(this._documents,H),I);return this._proxy.$registerDocumentRangeSemanticTokensProvider(se,this._transformDocumentSelector(B),j),this._createDisposable(se)}$provideDocumentRangeSemanticTokens(I,B,H,j){return this._withAdapter(I,ge,se=>se.provideDocumentRangeSemanticTokens(r.URI.revive(B),H,j),null,j)}registerCompletionItemProvider(I,B,H,j){const se=this._addNewAdapter(new oe(this._documents,this._commands.converter,H,this._apiDeprecation,I),I);return this._proxy.$registerCompletionsProvider(se,this._transformDocumentSelector(B),j,oe.supportsResolving(H),`${I.identifier.value}(${j.join("")})`),this._createDisposable(se)}$provideCompletionItems(I,B,H,j,se){return this._withAdapter(I,oe,le=>le.provideCompletionItems(r.URI.revive(B),H,j,se),void 0,se)}$resolveCompletionItem(I,B,H){return this._withAdapter(I,oe,j=>j.resolveCompletionItem(B,H),void 0,H)}$releaseCompletionItems(I,B){this._withAdapter(I,oe,H=>H.releaseCompletionItems(B),void 0,void 0)}registerInlineCompletionsProvider(I,B,H){const j=new ce(I,this._documents,H,this._commands.converter),se=this._addNewAdapter(j,I);return this._proxy.$registerInlineCompletionsSupport(se,this._transformDocumentSelector(B),j.supportsHandleDidShowCompletionItem),this._createDisposable(se)}registerInlineCompletionsProviderNew(I,B,H){const j=this._addNewAdapter(new me(I,this._documents,H,this._commands.converter),I);return this._proxy.$registerInlineCompletionsSupport(j,this._transformDocumentSelector(B),!0),this._createDisposable(j)}$provideInlineCompletions(I,B,H,j,se){return this._withAdapter(I,Ee,le=>le.provideInlineCompletions(r.URI.revive(B),H,j,se),void 0,se)}$handleInlineCompletionDidShow(I,B,H){this._withAdapter(I,Ee,async j=>{j.handleDidShowCompletionItem(B,H)},void 0,void 0)}$freeInlineCompletionsList(I,B){this._withAdapter(I,Ee,async H=>{H.disposeCompletions(B)},void 0,void 0)}registerSignatureHelpProvider(I,B,H,j){const se=Array.isArray(j)?{triggerCharacters:j,retriggerCharacters:[]}:j,le=this._addNewAdapter(new be(this._documents,H),I);return this._proxy.$registerSignatureHelpProvider(le,this._transformDocumentSelector(B),se),this._createDisposable(le)}$provideSignatureHelp(I,B,H,j,se){return this._withAdapter(I,be,le=>le.provideSignatureHelp(r.URI.revive(B),H,j,se),void 0,se)}$releaseSignatureHelp(I,B){this._withAdapter(I,be,H=>H.releaseSignatureHelp(B),void 0,void 0)}registerInlayHintsProvider(I,B,H){const j=typeof H.onDidChangeInlayHints=="function"?this._nextHandle():void 0,se=this._addNewAdapter(new _e(this._documents,this._commands.converter,H,this._logService,I),I);this._proxy.$registerInlayHintsProvider(se,this._transformDocumentSelector(B),typeof H.resolveInlayHint=="function",j,Z._extLabel(I));let le=this._createDisposable(se);if(j!==void 0){const Y=H.onDidChangeInlayHints(ve=>this._proxy.$emitInlayHintsEvent(j));le=N.Disposable.from(le,Y)}return le}$provideInlayHints(I,B,H,j){return this._withAdapter(I,_e,se=>se.provideInlayHints(r.URI.revive(B),H,j),void 0,j)}$resolveInlayHint(I,B,H){return this._withAdapter(I,_e,j=>j.resolveInlayHint(B,H),void 0,H)}$releaseInlayHints(I,B){this._withAdapter(I,_e,H=>H.releaseHints(B),void 0,void 0)}registerDocumentLinkProvider(I,B,H){const j=this._addNewAdapter(new Fe(this._documents,H),I);return this._proxy.$registerDocumentLinkProvider(j,this._transformDocumentSelector(B),typeof H.resolveDocumentLink=="function"),this._createDisposable(j)}$provideDocumentLinks(I,B,H){return this._withAdapter(I,Fe,j=>j.provideLinks(r.URI.revive(B),H),void 0,H,B.scheme==="output")}$resolveDocumentLink(I,B,H){return this._withAdapter(I,Fe,j=>j.resolveLink(B,H),void 0,void 0,!0)}$releaseDocumentLinks(I,B){this._withAdapter(I,Fe,H=>H.releaseLinks(B),void 0,void 0,!0)}registerColorProvider(I,B,H){const j=this._addNewAdapter(new Be(this._documents,H),I);return this._proxy.$registerDocumentColorProvider(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideDocumentColors(I,B,H){return this._withAdapter(I,Be,j=>j.provideColors(r.URI.revive(B),H),[],H)}$provideColorPresentations(I,B,H,j){return this._withAdapter(I,Be,se=>se.provideColorPresentations(r.URI.revive(B),H,j),void 0,j)}registerFoldingRangeProvider(I,B,H){const j=this._nextHandle(),se=typeof H.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(j,new ue(new Xe(this._documents,H),I)),this._proxy.$registerFoldingRangeProvider(j,this._transformDocumentSelector(B),se);let le=this._createDisposable(j);if(se!==void 0){const Y=H.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(se));le=N.Disposable.from(le,Y)}return le}$provideFoldingRanges(I,B,H,j){return this._withAdapter(I,Xe,se=>se.provideFoldingRanges(r.URI.revive(B),H,j),void 0,j)}registerSelectionRangeProvider(I,B,H){const j=this._addNewAdapter(new ke(this._documents,H,this._logService),I);return this._proxy.$registerSelectionRangeProvider(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideSelectionRanges(I,B,H,j){return this._withAdapter(I,ke,se=>se.provideSelectionRanges(r.URI.revive(B),H,j),[],j)}registerCallHierarchyProvider(I,B,H){const j=this._addNewAdapter(new ye(this._documents,H),I);return this._proxy.$registerCallHierarchyProvider(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$prepareCallHierarchy(I,B,H,j){return this._withAdapter(I,ye,se=>Promise.resolve(se.prepareSession(r.URI.revive(B),H,j)),void 0,j)}$provideCallHierarchyIncomingCalls(I,B,H,j){return this._withAdapter(I,ye,se=>se.provideCallsTo(B,H,j),void 0,j)}$provideCallHierarchyOutgoingCalls(I,B,H,j){return this._withAdapter(I,ye,se=>se.provideCallsFrom(B,H,j),void 0,j)}$releaseCallHierarchy(I,B){this._withAdapter(I,ye,H=>Promise.resolve(H.releaseSession(B)),void 0,void 0)}registerTypeHierarchyProvider(I,B,H){const j=this._addNewAdapter(new De(this._documents,H),I);return this._proxy.$registerTypeHierarchyProvider(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$prepareTypeHierarchy(I,B,H,j){return this._withAdapter(I,De,se=>Promise.resolve(se.prepareSession(r.URI.revive(B),H,j)),void 0,j)}$provideTypeHierarchySupertypes(I,B,H,j){return this._withAdapter(I,De,se=>se.provideSupertypes(B,H,j),void 0,j)}$provideTypeHierarchySubtypes(I,B,H,j){return this._withAdapter(I,De,se=>se.provideSubtypes(B,H,j),void 0,j)}$releaseTypeHierarchy(I,B){this._withAdapter(I,De,H=>Promise.resolve(H.releaseSession(B)),void 0,void 0)}registerDocumentOnDropEditProvider(I,B,H){const j=this._nextHandle();return this._adapter.set(j,new ue(new ae(this._proxy,this._documents,H,j),I)),this._proxy.$registerDocumentOnDropEditProvider(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideDocumentOnDropEdits(I,B,H,j,se,le){return this._withAdapter(I,ae,Y=>Promise.resolve(Y.provideDocumentOnDropEdits(B,r.URI.revive(H),j,se,le)),void 0,void 0)}registerDocumentPasteEditProvider(I,B,H,j){const se=this._nextHandle();return this._adapter.set(se,new ue(new x(this._proxy,this._documents,H,se),I)),this._proxy.$registerPasteEditProvider(se,this._transformDocumentSelector(B),!!H.prepareDocumentPaste,j.pasteMimeTypes),this._createDisposable(se)}$prepareDocumentPaste(I,B,H,j,se){return this._withAdapter(I,x,le=>le.prepareDocumentPaste(r.URI.revive(B),H,j,se),void 0,se)}$providePasteEdits(I,B,H,j,se,le){return this._withAdapter(I,x,Y=>Y.providePasteEdits(B,r.URI.revive(H),j,se,le),void 0,le)}static _serializeRegExp(I){return{pattern:I.source,flags:(0,E.regExpFlags)(I)}}static _serializeIndentationRule(I){return{decreaseIndentPattern:Z._serializeRegExp(I.decreaseIndentPattern),increaseIndentPattern:Z._serializeRegExp(I.increaseIndentPattern),indentNextLinePattern:I.indentNextLinePattern?Z._serializeRegExp(I.indentNextLinePattern):void 0,unIndentedLinePattern:I.unIndentedLinePattern?Z._serializeRegExp(I.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(I){return{beforeText:Z._serializeRegExp(I.beforeText),afterText:I.afterText?Z._serializeRegExp(I.afterText):void 0,previousLineText:I.previousLineText?Z._serializeRegExp(I.previousLineText):void 0,action:I.action}}static _serializeOnEnterRules(I){return I.map(Z._serializeOnEnterRule)}setLanguageConfiguration(I,B,H){const{wordPattern:j}=H;if(j&&(0,E.regExpLeadsToEndlessLoop)(j))throw new Error(`Invalid language configuration: wordPattern '${j}' is not allowed to match the empty string.`);j?this._documents.setWordDefinitionFor(B,j):this._documents.setWordDefinitionFor(B,void 0),H.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",I,"Do not use."),H.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",I,"Do not use.");const se=this._nextHandle(),le={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?Z._serializeRegExp(H.wordPattern):void 0,indentationRules:H.indentationRules?Z._serializeIndentationRule(H.indentationRules):void 0,onEnterRules:H.onEnterRules?Z._serializeOnEnterRules(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport};return this._proxy.$setLanguageConfiguration(se,B,le),this._createDisposable(se)}$setWordDefinitions(I){for(const B of I)this._documents.setWordDefinitionFor(B.languageId,new RegExp(B.regexSource,B.regexFlags))}}e.ExtHostLanguageFeatures=Z,Z._handlePool=0}),define(Ce[204],Ie([1,0,4,8,6,29,15,7]),function(ie,e,r,C,S,N,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class E{constructor(O,w,g,k){this._documents=w,this._commands=g,this._uriTransformer=k,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=O.getProxy(r.MainContext.MainThreadLanguages)}$acceptLanguageIds(O){this._languageIds=O}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(O,w){await this._proxy.$changeLanguage(O,w);const g=this._documents.getDocumentData(O);if(!g)throw new Error(`document '${O.toString()}' NOT found`);return g.document}async tokenAtPosition(O,w){const g=O.version,k=C.Position.from(w),m=await this._proxy.$tokensAtPosition(O.uri,k),a={type:S.StandardTokenType.Other,range:O.getWordRangeAtPosition(w)??new S.Range(w.line,w.character,w.line,w.character)};if(!m)return a;const u={range:C.Range.to(m.range),type:C.TokenType.to(m.type)};return!u.range.contains(w)||g!==O.version?a:u}createLanguageStatusItem(O,w,g){const k=this._handlePool++,m=this._proxy,a=this._ids,u=`${O.identifier.value}/${w}`;if(a.has(u))throw new Error(`LanguageStatusItem with id '${w}' ALREADY exists`);a.add(u);const d={selector:g,id:w,name:O.displayName??O.name,severity:S.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let v;const D=new A.DisposableStore,c=()=>{v?.dispose(),v=(0,_.disposableTimeout)(()=>{D.clear(),this._proxy.$setLanguageStatus(k,{id:u,name:d.name??O.displayName??O.name,source:O.displayName??O.name,selector:C.DocumentSelector.from(d.selector,this._uriTransformer),label:d.text,detail:d.detail??"",severity:d.severity===S.LanguageStatusSeverity.Error?N.default.Error:d.severity===S.LanguageStatusSeverity.Warning?N.default.Warning:N.default.Info,command:d.command&&this._commands.toInternal(d.command,D),accessibilityInfo:d.accessibilityInformation,busy:d.busy})},0)},b={dispose(){D.dispose(),v?.dispose(),m.$removeLanguageStatus(k),a.delete(u)},get id(){return d.id},get name(){return d.name},set name(t){d.name=t,c()},get selector(){return d.selector},set selector(t){d.selector=t,c()},get text(){return d.text},set text(t){d.text=t,c()},get detail(){return d.detail},set detail(t){d.detail=t,c()},get severity(){return d.severity},set severity(t){d.severity=t,c()},get accessibilityInformation(){return d.accessibilityInformation},set accessibilityInformation(t){d.accessibilityInformation=t,c()},get command(){return d.command},set command(t){d.command=t,c()},get busy(){return d.busy},set busy(t){d.busy=t,c()}};return c(),b}}e.ExtHostLanguages=E}),define(Ce[68],Ie([1,0,21,9,2,3,14,4,27,11]),function(ie,e,r,C,S,N,_,A,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let O=class{constructor(g,k,m){this.logService=m,this.bundleCache=new Map,this._proxy=k.getProxy(A.MainContext.MainThreadLocalization),this.currentLanguage=g.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===r.LANGUAGE_DEFAULT}getMessage(g,k){const{message:m,args:a,comment:u}=k;if(this.isDefaultLanguage)return(0,C.format2)(m,a??{});let d=m;u&&u.length>0&&(d+=`/${u.join()}`);const v=this.bundleCache.get(g)?.contents[d];return v||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${d}`),(0,C.format2)(v??d,a??{})}getBundle(g){return this.bundleCache.get(g)?.contents}getBundleUri(g){return this.bundleCache.get(g)?.uri}async initializeLocalizedMessages(g){if(this.isDefaultLanguage||!g.l10n||this.bundleCache.has(g.identifier.value))return;let k;const m=this.getBundleLocation(g);if(!m){this.logService.error(`No bundle location found for extension ${g.identifier.value}`);return}const a=S.URI.joinPath(m,`bundle.l10n.${this.currentLanguage}.json`);try{const u=await this._proxy.$fetchBundleContents(a);k=JSON.parse(u)}catch(u){this.logService.error(`Failed to load translations for ${g.identifier.value} from ${a}: ${u.message}`);return}k&&this.bundleCache.set(g.identifier.value,{contents:k,uri:a})}getBundleLocation(g){return g.l10n?S.URI.joinPath(g.extensionLocation,g.l10n):void 0}};O=ze([$e(0,E.IExtHostInitDataService),$e(1,P.IExtHostRpcService),$e(2,_.ILogService)],O),e.ExtHostLocalizationService=O,e.IExtHostLocalizationService=(0,N.createDecorator)("IExtHostLocalizationService")}),define(Ce[205],Ie([1,0,14,4,27,11,5]),function(ie,e,r,C,S,N,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let A=class extends r.AbstractLoggerService{constructor(O,w){const g=new _.Emitter;super(w.logLevel,g.event),this._proxy=O.getProxy(C.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(g)}$setLevel(O){this._onDidChangeLogLevel.fire(O)}doCreateLogger(O,w,g){return new E(this._proxy,O,w,g)}};A=ze([$e(0,N.IExtHostRpcService),$e(1,S.IExtHostInitDataService)],A),e.ExtHostLoggerService=A;class E extends r.AbstractMessageLogger{constructor(O,w,g,k){super(k?.always),this.proxy=O,this.file=w,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(g),this.proxy.$createLogger(w,k).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(O,w){const g=[[O,w]];this.isLoggerCreated?this.doLog(g):this.buffer.push(...g)}doLog(O){this.proxy.$log(this.file,O)}}}),define(Ce[206],Ie([1,0,4,14,28]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function N(A){return A&&A.title}let _=class{constructor(E,P){this._logService=P,this._proxy=E.getProxy(r.MainContext.MainThreadMessageService)}showMessage(E,P,O,w,g){const k={source:{identifier:E.identifier,label:E.displayName||E.name}};let m;typeof w=="string"||N(w)?m=[w,...g]:(k.modal=w?.modal,k.useCustom=w?.useCustom,k.detail=w?.detail,m=g),k.useCustom&&(0,S.checkProposedApiEnabled)(E,"resolvers");const a=[];for(let u=0;u<m.length;u++){const d=m[u];if(typeof d=="string")a.push({title:d,handle:u,isCloseAffordance:!1});else if(typeof d=="object"){const{title:v,isCloseAffordance:D}=d;a.push({title:v,isCloseAffordance:!!D,handle:u})}else this._logService.warn("Invalid message item:",d)}return this._proxy.$showMessage(P,O,k,a).then(u=>{if(typeof u=="number")return m[u]})}};_=ze([$e(1,C.ILogService)],_),e.ExtHostMessageService=_}),define(Ce[207],Ie([1,0,23,5,7,24,9,10,2,61,4,37,8,6,41,179,94]),function(ie,e,r,C,S,N,_,A,E,P,O,w,g,k,m,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class d{get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(D=>D.apiEditor)}constructor(D,c,b,t){this._textDocumentsAndEditors=b,this._textDocuments=t,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new N.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new C.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new C.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new C.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new C.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new P.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=D.getProxy(O.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=D.getProxy(O.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=D.getProxy(O.MainContext.MainThreadNotebookEditors),this._commandsConverter=c.converter,c.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===12){const i=l.notebookEditor?.notebookUri,n=l.cell.handle,f=this._documents.get(i)?.getCell(n);if(f)return f.apiCell}return l}}),d._registerApiCommands(c)}getEditorById(D){const c=this._editors.get(D);if(!c)throw new Error(`unknown text editor: ${D}. known editors: ${[...this._editors.keys()]} `);return c}getIdByEditor(D){for(const[c,b]of this._editors)if(b.apiEditor===D)return c}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(D,c){const b=this._documents.get(D);if(!b&&!c)throw new Error(`NO notebook document for '${D}'`);return b}_getProviderData(D){const c=this._notebookContentProviders.get(D);if(!c)throw new Error(`NO provider for '${D}'`);return c}registerNotebookContentProvider(D,c,b,t,l){if((0,_.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(c))throw new Error(`Notebook provider for '${c}' already registered`);return this._notebookContentProviders.set(c,{extension:D,provider:b}),this._notebookProxy.$registerNotebookProvider({id:D.identifier,location:D.extensionLocation},c,g.NotebookDocumentContentOptions.from(t),d._convertNotebookRegistrationData(D,l)),new k.Disposable(()=>{this._notebookContentProviders.delete(c),this._notebookProxy.$unregisterNotebookProvider(c)})}static _convertNotebookRegistrationData(D,c){if(!c)return;const b=c.filenamePattern.map(t=>g.NotebookExclusiveDocumentPattern.from(t)).filter(t=>t!==void 0);if(c.filenamePattern&&!b){console.warn(`Notebook content provider view options file name pattern is invalid ${c.filenamePattern}`);return}return{extension:D.identifier,providerDisplayName:D.displayName||D.name,displayName:c.displayName,filenamePattern:b,exclusive:c.exclusive||!1}}registerNotebookCellStatusBarItemProvider(D,c,b){const t=d._notebookStatusBarItemProviderHandlePool++,l=typeof b.onDidChangeCellStatusBarItems=="function"?d._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(t,b),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(t,l,c);let i;return l!==void 0&&(i=b.onDidChangeCellStatusBarItems(n=>this._notebookProxy.$emitCellStatusBarEvent(l))),new k.Disposable(()=>{this._notebookStatusBarItemProviders.delete(t),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(t,l),i?.dispose()})}async createNotebookDocument(D){const c=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:D.viewType,content:D.content&&g.NotebookData.from(D.content)});return E.URI.revive(c)}async openNotebookDocument(D){const c=this._documents.get(D);if(c)return c.apiNotebook;const b=await this._notebookDocumentsProxy.$tryOpenNotebook(D),t=this._documents.get(E.URI.revive(b));return(0,A.assertIsDefined)(t?.apiNotebook)}async showNotebookDocument(D,c){E.URI.isUri(D)&&(D=await this.openNotebookDocument(D));let b;typeof c=="object"?b={position:g.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus,selections:c.selections&&c.selections.map(g.NotebookRange.from),pinned:typeof c.preview=="boolean"?!c.preview:void 0}:b={preserveFocus:!1};const t=await this._notebookEditorsProxy.$tryShowNotebookDocument(D.uri,D.notebookType,b),l=t&&this._editors.get(t)?.apiEditor;if(l)return l;throw t?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(D,c,b,t){const l=this._notebookStatusBarItemProviders.get(D),i=E.URI.revive(c),n=this._documents.get(i);if(!n||!l)return;const o=n.getCellFromIndex(b);if(!o)return;const f=await l.provideCellStatusBarItems(o.apiCell,t);if(!f)return;const s=new S.DisposableStore,h=this._statusBarCache.add([s]),T=(Array.isArray(f)?f:[f]).map(M=>g.NotebookStatusBarItem.from(M,this._commandsConverter,s));return{cacheId:h,items:T}}$releaseNotebookCellStatusBarItems(D){this._statusBarCache.delete(D)}registerNotebookSerializer(D,c,b,t,l){if((0,_.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");const i=this._handlePool++;return this._notebookSerializer.set(i,b),this._notebookProxy.$registerNotebookSerializer(i,{id:D.identifier,location:D.extensionLocation},c,g.NotebookDocumentContentOptions.from(t),d._convertNotebookRegistrationData(D,l)),(0,S.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(i)})}async $dataToNotebook(D,c,b){const t=this._notebookSerializer.get(D);if(!t)throw new Error("NO serializer found");const l=await t.deserializeNotebook(c.buffer,b);return new m.SerializableObjectWithBuffers(g.NotebookData.from(l))}async $notebookToData(D,c,b){const t=this._notebookSerializer.get(D);if(!t)throw new Error("NO serializer found");const l=await t.serializeNotebook(g.NotebookData.to(c.value),b);return r.VSBuffer.wrap(l)}async $openNotebook(D,c,b,t,l){const{provider:i}=this._getProviderData(D),n=await i.openNotebook(E.URI.revive(c),{backupId:b,untitledDocumentData:t?.buffer},l);return new m.SerializableObjectWithBuffers({metadata:n.metadata??Object.create(null),cells:n.cells.map(g.NotebookCellData.from)})}_createExtHostEditor(D,c,b){if(this._editors.has(c))throw new Error(`editor with id ALREADY EXSIST: ${c}`);const t=new u.ExtHostNotebookEditor(c,this._notebookEditorsProxy,D,b.visibleRanges.map(g.NotebookRange.to),b.selections.map(g.NotebookRange.to),typeof b.viewColumn=="number"?g.ViewColumn.to(b.viewColumn):void 0);this._editors.set(c,t)}$acceptDocumentAndEditorsDelta(D){if(D.value.removedDocuments)for(const b of D.value.removedDocuments){const t=E.URI.revive(b),l=this._documents.get(t);l&&(l.dispose(),this._documents.delete(t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:l.apiNotebook.getCells().map(i=>i.document.uri)}),this._onDidCloseNotebookDocument.fire(l.apiNotebook));for(const i of this._editors.values())i.notebookData.uri.toString()===t.toString()&&this._editors.delete(i.id)}if(D.value.addedDocuments){const b=[];for(const t of D.value.addedDocuments){const l=E.URI.revive(t.uri);if(this._documents.has(l))throw new Error(`adding EXISTING notebook ${l} `);const i=new a.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,l,t);b.push(...t.cells.map(n=>a.ExtHostCell.asModelAddData(i.apiNotebook,n))),this._documents.get(l)?.dispose(),this._documents.set(l,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:b}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(D.value.addedEditors)for(const b of D.value.addedEditors){if(this._editors.has(b.id))return;const t=E.URI.revive(b.documentUri),l=this._documents.get(t);l&&this._createExtHostEditor(l,b.id,b)}const c=[];if(D.value.removedEditors)for(const b of D.value.removedEditors){const t=this._editors.get(b);t&&(this._editors.delete(b),this._activeNotebookEditor?.id===t.id&&(this._activeNotebookEditor=void 0),c.push(t))}if(D.value.visibleEditors){this._visibleNotebookEditors=D.value.visibleEditors.map(t=>this._editors.get(t)).filter(t=>!!t);const b=new Set;this._visibleNotebookEditors.forEach(t=>b.add(t.id));for(const t of this._editors.values()){const l=b.has(t.id);t._acceptVisibility(l)}this._visibleNotebookEditors=[...this._editors.values()].map(t=>t).filter(t=>t.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}D.value.newActiveEditor===null?this._activeNotebookEditor=void 0:D.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(D.value.newActiveEditor)),D.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(D){const c=w.ApiCommandArgument.String.with("notebookType","A notebook type"),b=new w.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[c,new w.ApiCommandArgument("data","Bytes to convert to data",l=>l instanceof Uint8Array,l=>r.VSBuffer.wrap(l))],new w.ApiCommandResult("Notebook Data",l=>g.NotebookData.to(l.value))),t=new w.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[c,new w.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",l=>!0,l=>new m.SerializableObjectWithBuffers(g.NotebookData.from(l)))],new w.ApiCommandResult("Bytes",l=>l.buffer));D.registerApiCommand(b),D.registerApiCommand(t)}}e.ExtHostNotebookController=d,d._notebookStatusBarItemProviderHandlePool=0}),define(Ce[208],Ie([1,0,18,15,20,5,7,24,2,26,14,4,37,8,6,63,167,28,41]),function(ie,e,r,C,S,N,_,A,E,P,O,w,g,k,m,a,u,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let D=class{constructor(n,o,f,s,h){this._initData=o,this._extHostNotebook=f,this._commands=s,this._logService=h,this._activeExecutions=new A.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new N.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=n.getProxy(w.MainContext.MainThreadNotebookKernels);const p=new g.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new g.ApiCommandArgument("options","Select kernel options",T=>!0,T=>{if(T&&"notebookEditor"in T&&"id"in T){const M=this._extHostNotebook.getIdByEditor(T.notebookEditor);return{id:T.id,extension:T.extension,notebookEditorId:M}}else if(T&&"notebookEditor"in T){const M=this._extHostNotebook.getIdByEditor(T.notebookEditor);if(M===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${T.notebookEditor.document.uri.toString()}`);return{notebookEditorId:M}}return T})],g.ApiCommandResult.Void);this._commands.registerApiCommand(p)}createNotebookController(n,o,f,s,h,p){for(const oe of this._kernelData.values())if(oe.controller.id===o&&P.ExtensionIdentifier.equals(n.identifier,oe.extensionId))throw new Error(`notebook controller with id '${o}' ALREADY exist`);const T=this._handlePool++,M=this;this._logService.trace(`NotebookController[${T}], CREATED by ${n.identifier.value}, ${o}`);const V=()=>console.warn(`NO execute handler from notebook controller '${R.id}' of extension: '${n.identifier}'`);let U=!1;const y=new _.DisposableStore,x=new N.Emitter,L=new N.Emitter,R={id:l(n.identifier,o),notebookType:f,extensionId:n.identifier,extensionLocation:n.extensionLocation,label:s||n.identifier.value,preloads:p?p.map(k.NotebookRendererScript.from):[]};let K=h??V,W;this._proxy.$addKernel(T,R).catch(oe=>{console.log(oe),U=!0});let $=0;const G=()=>{if(U)return;const oe=++$;Promise.resolve().then(()=>{oe===$&&this._proxy.$updateKernel(T,R)})},re=new A.ResourceMap,ge={get id(){return o},get notebookType(){return R.notebookType},onDidChangeSelectedNotebooks:x.event,get label(){return R.label},set label(oe){R.label=oe??n.displayName??n.name,G()},get detail(){return R.detail??""},set detail(oe){R.detail=oe,G()},get description(){return R.description??""},set description(oe){R.description=oe,G()},get kind(){return(0,d.checkProposedApiEnabled)(n,"notebookControllerKind"),R.kind??""},set kind(oe){(0,d.checkProposedApiEnabled)(n,"notebookControllerKind"),R.kind=oe,G()},get supportedLanguages(){return R.supportedLanguages},set supportedLanguages(oe){R.supportedLanguages=oe,G()},get supportsExecutionOrder(){return R.supportsExecutionOrder??!1},set supportsExecutionOrder(oe){R.supportsExecutionOrder=oe,G()},get rendererScripts(){return R.preloads?R.preloads.map(k.NotebookRendererScript.to):[]},get executeHandler(){return K},set executeHandler(oe){K=oe??V},get interruptHandler(){return W},set interruptHandler(oe){W=oe,R.supportsInterrupt=Boolean(oe),G()},createNotebookCellExecution(oe){if(U)throw new Error("notebook controller is DISPOSED");if(!re.has(oe.notebook.uri))throw M._logService.trace(`NotebookController[${T}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(re.keys()).map(Ee=>Ee.toString())),new Error(`notebook controller is NOT associated to notebook: ${oe.notebook.uri.toString()}`);return M._createNotebookCellExecution(oe,l(n.identifier,this.id))},dispose:()=>{U||(this._logService.trace(`NotebookController[${T}], DISPOSED`),U=!0,this._kernelData.delete(T),y.dispose(),x.dispose(),L.dispose(),this._proxy.$removeKernel(T))},updateNotebookAffinity(oe,Ee){Ee===m.NotebookControllerAffinity2.Hidden&&(0,d.checkProposedApiEnabled)(n,"notebookControllerAffinityHidden"),M._proxy.$updateNotebookPriority(T,oe.uri,Ee)},onDidReceiveMessage:L.event,postMessage(oe,Ee){return(0,d.checkProposedApiEnabled)(n,"notebookMessaging"),M._proxy.$postMessage(T,Ee&&M._extHostNotebook.getIdByEditor(Ee),oe)},asWebviewUri(oe){return(0,d.checkProposedApiEnabled)(n,"notebookMessaging"),(0,a.asWebviewUri)(oe,M._initData.remote)}};return this._kernelData.set(T,{extensionId:n.identifier,controller:ge,onDidReceiveMessage:L,onDidChangeSelection:x,associatedNotebooks:re}),ge}getIdByController(n){for(const[o,f]of this._kernelData)if(f.controller===n)return l(f.extensionId,n.id);return null}$acceptNotebookAssociation(n,o,f){const s=this._kernelData.get(n);if(s){const h=this._extHostNotebook.getNotebookDocument(E.URI.revive(o));f?s.associatedNotebooks.set(h.uri,!0):s.associatedNotebooks.delete(h.uri),this._logService.trace(`NotebookController[${n}] ASSOCIATE notebook`,h.uri.toString(),f),s.onDidChangeSelection.fire({selected:f,notebook:h.apiNotebook})}}async $executeCells(n,o,f){const s=this._kernelData.get(n);if(!s)return;const h=this._extHostNotebook.getNotebookDocument(E.URI.revive(o)),p=[];for(const T of f){const M=h.getCell(T);M&&p.push(M.apiCell)}try{this._logService.trace(`NotebookController[${n}] EXECUTE cells`,h.uri.toString(),p.length),await s.controller.executeHandler.call(s.controller,p,h.apiNotebook,s.controller)}catch(T){this._logService.error(`NotebookController[${n}] execute cells FAILED`,T),console.error(T)}}async $cancelCells(n,o,f){const s=this._kernelData.get(n);if(!s)return;const h=this._extHostNotebook.getNotebookDocument(E.URI.revive(o));if(s.controller.interruptHandler)await s.controller.interruptHandler.call(s.controller,h.apiNotebook);else for(const p of f){const T=h.getCell(p);T&&this._activeExecutions.get(T.uri)?.cancel()}}$acceptKernelMessageFromRenderer(n,o,f){const s=this._kernelData.get(n);if(!s)return;const h=this._extHostNotebook.getEditorById(o);s.onDidReceiveMessage.fire(Object.freeze({editor:h.apiEditor,message:f}))}$cellExecutionChanged(n,o,f){const h=this._extHostNotebook.getNotebookDocument(E.URI.revive(n)).getCell(o);if(h){const p=f?k.NotebookCellExecutionState.to(f):m.NotebookCellExecutionState.Idle;p!==void 0&&this._onDidChangeCellExecutionState.fire({cell:h.apiCell,state:p})}}_createNotebookCellExecution(n,o){if(n.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const s=this._extHostNotebook.getNotebookDocument(n.notebook.uri).getCellFromApiCell(n);if(!s)throw new Error("invalid cell");if(this._activeExecutions.has(s.uri))throw new Error(`duplicate execution for ${s.uri}`);const h=new b(o,s,this._proxy);this._activeExecutions.set(s.uri,h);const p=h.onDidChangeState(()=>{h.state===c.Resolved&&(h.dispose(),p.dispose(),this._activeExecutions.delete(s.uri))});return h.asApiObject()}};D=ze([$e(4,O.ILogService)],D),e.ExtHostNotebookKernels=D;var c;(function(i){i[i.Init=0]="Init",i[i.Started=1]="Started",i[i.Resolved=2]="Resolved"})(c||(c={}));class b extends _.Disposable{get state(){return this._state}constructor(n,o,f){super(),this._cell=o,this._proxy=f,this._handle=b.HANDLE++,this._onDidChangeState=new N.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=c.Init,this._tokenSource=this._register(new S.CancellationTokenSource),this._collector=new t(10,s=>this.update(s)),this._executionOrder=o.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,n,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(n){await this._collector.addItem(n)}async update(n){const o=Array.isArray(n)?n:[n];return this._proxy.$updateExecution(this._handle,new v.SerializableObjectWithBuffers(o))}verifyStateForOutput(){if(this._state===c.Init)throw new Error("Must call start before modifying cell output");if(this._state===c.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(n){let o=this._cell;if(n&&(o=this._cell.notebook.getCellFromApiCell(n)),!o)throw new Error("INVALID cell");return o.handle}validateAndConvertOutputs(n){return n.map(o=>{const f=m.NotebookCellOutput.ensureUniqueMimeTypes(o.items,!0);return f===o.items?k.NotebookCellOutput.from(o):k.NotebookCellOutput.from({items:f,id:o.id,metadata:o.metadata})})}async updateOutputs(n,o,f){const s=this.cellIndexToHandle(o),h=this.validateAndConvertOutputs((0,r.asArray)(n));return this.updateSoon({editType:u.CellExecutionUpdateType.Output,cellHandle:s,append:f,outputs:h})}async updateOutputItems(n,o,f){return n=m.NotebookCellOutput.ensureUniqueMimeTypes((0,r.asArray)(n),!0),this.updateSoon({editType:u.CellExecutionUpdateType.OutputItems,items:n.map(k.NotebookCellOutputItem.from),outputId:o.id,append:f})}asApiObject(){const n=this;return Object.freeze({get token(){return n._tokenSource.token},get cell(){return n._cell.apiCell},get executionOrder(){return n._executionOrder},set executionOrder(f){n._executionOrder=f,n.update([{editType:u.CellExecutionUpdateType.ExecutionState,executionOrder:n._executionOrder}])},start(f){if(n._state===c.Resolved||n._state===c.Started)throw new Error("Cannot call start again");n._state=c.Started,n._onDidChangeState.fire(),n.update({editType:u.CellExecutionUpdateType.ExecutionState,runStartTime:f})},end(f,s){if(n._state===c.Resolved)throw new Error("Cannot call resolve twice");n._state=c.Resolved,n._onDidChangeState.fire(),n._collector.flush(),n._proxy.$completeExecution(n._handle,new v.SerializableObjectWithBuffers({runEndTime:s,lastRunSuccess:f}))},clearOutput(f){return n.verifyStateForOutput(),n.updateOutputs([],f,!1)},appendOutput(f,s){return n.verifyStateForOutput(),n.updateOutputs(f,s,!0)},replaceOutput(f,s){return n.verifyStateForOutput(),n.updateOutputs(f,s,!1)},appendOutputItems(f,s){return n.verifyStateForOutput(),n.updateOutputItems(f,s,!0)},replaceOutputItems(f,s){return n.verifyStateForOutput(),n.updateOutputItems(f,s,!1)}})}}b.HANDLE=0;class t{constructor(n,o){this.delay=n,this.callback=o,this.batch=[],this.startedTimer=Date.now()}addItem(n){return this.batch.push(n),this.currentDeferred||(this.currentDeferred=new C.DeferredPromise,this.startedTimer=Date.now(),(0,C.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const n=this.currentDeferred;this.currentDeferred=void 0;const o=this.batch;return this.batch=[],this.callback(o).finally(()=>n.complete())}}function l(i,n){return`${i.value}/${n}`}e.createKernelId=l}),define(Ce[209],Ie([1,0,5,4,94]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class N{constructor(A,E){this._extHostNotebook=E,this._rendererMessageEmitters=new Map,this.proxy=A.getProxy(C.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(A,E,P){const O=this._extHostNotebook.getEditorById(A);this._rendererMessageEmitters.get(E)?.fire({editor:O.apiEditor,message:P})}createRendererMessaging(A,E){if(!A.contributes?.notebookRenderer?.some(O=>O.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);return{onDidReceiveMessage:(O,w,g)=>this.getOrCreateEmitterFor(E).event(O,w,g),postMessage:(O,w)=>{S.ExtHostNotebookEditor.apiEditorsToExtHost.has(O)&&([O,w]=[w,O]);const g=w&&S.ExtHostNotebookEditor.apiEditorsToExtHost.get(w);return this.proxy.$postMessage(g?.id,E,O)}}}getOrCreateEmitterFor(A){let E=this._rendererMessageEmitters.get(A);return E||(E=new r.Emitter({onLastListenerRemove:()=>{E?.dispose(),this._rendererMessageEmitters.delete(A)}}),this._rendererMessageEmitters.set(A,E),E)}}e.ExtHostNotebookRenderers=N}),define(Ce[210],Ie([1,0,20,5,7,4,2,6,12,18,29,60]),function(ie,e,r,C,S,N,_,A,E,P,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function g(k,m,a){const u=k.getProxy(N.MainContext.MainThreadQuickOpen);class d{constructor(o,f){this._sessions=new Map,this._instances=0,this._workspace=o,this._commands=f}showQuickPick(o,f,s=r.CancellationToken.None){this._onDidSelectItem=void 0;const h=Promise.resolve(o),p=++this._instances,T=u.$show(p,{title:f?.title,placeHolder:f?.placeHolder,matchOnDescription:f?.matchOnDescription,matchOnDetail:f?.matchOnDetail,ignoreFocusLost:f?.ignoreFocusOut,canPickMany:f?.canPickMany},s),M={},V=T.then(()=>M);return Promise.race([V,h]).then(U=>{if(U!==M)return h.then(y=>{const x=[];for(let L=0;L<y.length;L++){const R=y[L];typeof R=="string"?x.push({label:R,handle:L}):R.kind===A.QuickPickItemKind.Separator?x.push({type:"separator",label:R.label}):x.push({label:R.label,description:R.description,detail:R.detail,picked:R.picked,alwaysShow:R.alwaysShow,handle:L})}return f&&typeof f.onDidSelectItem=="function"&&(this._onDidSelectItem=L=>{f.onDidSelectItem(y[L])}),u.$setItems(p,x),T.then(L=>{if(typeof L=="number")return y[L];if(Array.isArray(L))return L.map(R=>y[R])})})}).then(void 0,U=>{if(!(0,E.isCancellationError)(U))return u.$setError(p,U),Promise.reject(U)})}$onItemSelected(o){this._onDidSelectItem?.(o)}showInput(o,f=r.CancellationToken.None){return this._validateInput=o?.validateInput,u.$input(o,typeof this._validateInput=="function",f).then(void 0,s=>{if(!(0,E.isCancellationError)(s))return Promise.reject(s)})}async $validateInput(o){if(!this._validateInput)return;const f=await this._validateInput(o);if(!f||typeof f=="string")return f;let s;switch(f.severity){case A.InputBoxValidationSeverity.Info:s=O.default.Info;break;case A.InputBoxValidationSeverity.Warning:s=O.default.Warning;break;case A.InputBoxValidationSeverity.Error:s=O.default.Error;break;default:s=f.message?O.default.Error:O.default.Ignore;break}return{content:f.message,severity:s}}async showWorkspaceFolderPick(o,f=r.CancellationToken.None){const s=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[o]);if(!s)return;const h=await this._workspace.getWorkspaceFolders2();if(!!h)return h.find(p=>p.uri.toString()===s.uri.toString())}createQuickPick(o){const f=new l(o,()=>this._sessions.delete(f._id));return this._sessions.set(f._id,f),f}createInputBox(o){const f=new i(o,()=>this._sessions.delete(f._id));return this._sessions.set(f._id,f),f}$onDidChangeValue(o,f){this._sessions.get(o)?._fireDidChangeValue(f)}$onDidAccept(o){this._sessions.get(o)?._fireDidAccept()}$onDidChangeActive(o,f){const s=this._sessions.get(o);s instanceof l&&s._fireDidChangeActive(f)}$onDidChangeSelection(o,f){const s=this._sessions.get(o);s instanceof l&&s._fireDidChangeSelection(f)}$onDidTriggerButton(o,f){this._sessions.get(o)?._fireDidTriggerButton(f)}$onDidTriggerItemButton(o,f,s){const h=this._sessions.get(o);h instanceof l&&h._fireDidTriggerItemButton(f,s)}$onDidHide(o){this._sessions.get(o)?._fireDidHide()}}class v{constructor(o,f){this._extensionId=o,this._onDidDispose=f,this._id=l._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new C.Emitter,this._onDidChangeValueEmitter=new C.Emitter,this._onDidTriggerButtonEmitter=new C.Emitter,this._onDidHideEmitter=new C.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(o){this._title=o,this.update({title:o})}get step(){return this._steps}set step(o){this._steps=o,this.update({step:o})}get totalSteps(){return this._totalSteps}set totalSteps(o){this._totalSteps=o,this.update({totalSteps:o})}get enabled(){return this._enabled}set enabled(o){this._enabled=o,this.update({enabled:o})}get busy(){return this._busy}set busy(o){this._busy=o,this.update({busy:o})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(o){this._ignoreFocusOut=o,this.update({ignoreFocusOut:o})}get value(){return this._value}set value(o){this._value=o,this.update({value:o})}get placeholder(){return this._placeholder}set placeholder(o){this._placeholder=o,this.update({placeholder:o})}get buttons(){return this._buttons}set buttons(o){this._buttons=o.slice(),this._handlesToButtons.clear(),o.forEach((f,s)=>{const h=f===A.QuickInputButtons.Back?-1:s;this._handlesToButtons.set(h,f)}),this.update({buttons:o.map((f,s)=>({...t(f),tooltip:f.tooltip,handle:f===A.QuickInputButtons.Back?-1:s}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(o){this._value=o,this._onDidChangeValueEmitter.fire(o)}_fireDidTriggerButton(o){const f=this._handlesToButtons.get(o);f&&this._onDidTriggerButtonEmitter.fire(f)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,S.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),u.$dispose(this._id))}update(o){if(!this._disposed){for(const f of Object.keys(o)){const s=o[f];this._pendingUpdate[f]=s===void 0?null:s}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){u.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}v._nextId=1;function D(n){if(n instanceof A.ThemeIcon)return{id:n.id};const o=b(n),f=c(n);return{dark:typeof o=="string"?_.URI.file(o):o,light:typeof f=="string"?_.URI.file(f):f}}function c(n){return typeof n=="object"&&"light"in n?n.light:n}function b(n){return typeof n=="object"&&"dark"in n?n.dark:n}function t(n){const o=D(n.iconPath);let f,s;return"id"in o?s=w.ThemeIcon.asClassName(o):f=o,{iconPath:f,iconClass:s}}class l extends v{constructor(o,f){super(o.identifier,f),this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new C.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new C.Emitter,this._onDidTriggerItemButtonEmitter=new C.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(o){this._items=o.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),o.forEach((s,h)=>{this._handlesToItems.set(h,s),this._itemsToHandles.set(s,h)});const f=[];for(let s=0;s<o.length;s++){const h=o[s];h.kind===A.QuickPickItemKind.Separator?f.push({type:"separator",label:h.label}):f.push({handle:s,label:h.label,description:h.description,detail:h.detail,picked:h.picked,alwaysShow:h.alwaysShow,buttons:h.buttons?.map((p,T)=>({...t(p),tooltip:p.tooltip,handle:T}))})}this.update({items:f})}get canSelectMany(){return this._canSelectMany}set canSelectMany(o){this._canSelectMany=o,this.update({canSelectMany:o})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(o){this._matchOnDescription=o,this.update({matchOnDescription:o})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(o){this._matchOnDetail=o,this.update({matchOnDetail:o})}get sortByLabel(){return this._sortByLabel}set sortByLabel(o){this._sortByLabel=o,this.update({sortByLabel:o})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(o){this._keepScrollPosition=o,this.update({keepScrollPosition:o})}get activeItems(){return this._activeItems}set activeItems(o){this._activeItems=o.filter(f=>this._itemsToHandles.has(f)),this.update({activeItems:this._activeItems.map(f=>this._itemsToHandles.get(f))})}get selectedItems(){return this._selectedItems}set selectedItems(o){this._selectedItems=o.filter(f=>this._itemsToHandles.has(f)),this.update({selectedItems:this._selectedItems.map(f=>this._itemsToHandles.get(f))})}_fireDidChangeActive(o){const f=(0,P.coalesce)(o.map(s=>this._handlesToItems.get(s)));this._activeItems=f,this._onDidChangeActiveEmitter.fire(f)}_fireDidChangeSelection(o){const f=(0,P.coalesce)(o.map(s=>this._handlesToItems.get(s)));this._selectedItems=f,this._onDidChangeSelectionEmitter.fire(f)}_fireDidTriggerItemButton(o,f){const s=this._handlesToItems.get(o);if(!s||!s.buttons||!s.buttons.length)return;const h=s.buttons[f];h&&this._onDidTriggerItemButtonEmitter.fire({button:h,item:s})}}class i extends v{constructor(o,f){super(o.identifier,f),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(o){this._password=o,this.update({password:o})}get prompt(){return this._prompt}set prompt(o){this._prompt=o,this.update({prompt:o})}get validationMessage(){return this._validationMessage}set validationMessage(o){this._validationMessage=o,o?typeof o=="string"?this.update({validationMessage:o,severity:O.default.Error}):this.update({validationMessage:o.message,severity:o.severity??O.default.Error}):this.update({validationMessage:void 0,severity:O.default.Ignore})}}return new d(m,a)}e.createExtHostQuickOpen=g});var Oe=this&&this.__classPrivateFieldGet||function(ie,e,r,C){if(r==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!C:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?C:r==="a"?C.call(ie):C?C.value:e.get(ie)},Je=this&&this.__classPrivateFieldSet||function(ie,e,r,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ie,r):S?S.value=r:e.set(ie,r),r};define(Ce[211],Ie([1,0,2,5,55,7,15,4,18,118,14,26,60,8,28]),function(ie,e,r,C,S,N,_,A,E,P,O,w,g,k,m){"use strict";var a,u;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function d(h){if(h)return typeof h.iconPath=="string"?r.URI.file(h.iconPath):r.URI.isUri(h.iconPath)||g.ThemeIcon.isThemeIcon(h.iconPath)?h.iconPath:void 0}function v(h,p){if(!h.iconPath&&!p.iconPath)return 0;if(h.iconPath){if(!p.iconPath)return 1}else return-1;const T=typeof h.iconPath=="string"?h.iconPath:r.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id,M=typeof p.iconPath=="string"?p.iconPath:r.URI.isUri(p.iconPath)?p.iconPath.fsPath:p.iconPath.id;return(0,P.comparePaths)(T,M)}function D(h,p){let T=0;if(h.strikeThrough!==p.strikeThrough)return h.strikeThrough?1:-1;if(h.faded!==p.faded)return h.faded?1:-1;if(h.tooltip!==p.tooltip)return(h.tooltip||"").localeCompare(p.tooltip||"");if(T=v(h,p),T!==0)return T;if(h.light&&p.light)T=v(h.light,p.light);else{if(h.light)return 1;if(p.light)return-1}if(T!==0)return T;if(h.dark&&p.dark)T=v(h.dark,p.dark);else{if(h.dark)return 1;if(p.dark)return-1}return T}function c(h,p){if(h.command!==p.command)return h.command<p.command?-1:1;if(h.title!==p.title)return h.title<p.title?-1:1;if(h.tooltip!==p.tooltip){if(h.tooltip!==void 0&&p.tooltip!==void 0)return h.tooltip<p.tooltip?-1:1;if(h.tooltip!==void 0)return 1;if(p.tooltip!==void 0)return-1}if(h.arguments===p.arguments)return 0;if(h.arguments)if(p.arguments){if(h.arguments.length!==p.arguments.length)return h.arguments.length-p.arguments.length}else return 1;else return-1;for(let T=0;T<h.arguments.length;T++){const M=h.arguments[T],V=p.arguments[T];if(M!==V)return M<V?-1:1}return 0}function b(h,p){let T=(0,P.comparePaths)(h.resourceUri.fsPath,p.resourceUri.fsPath,!0);if(T!==0)return T;if(h.command&&p.command)T=c(h.command,p.command);else{if(h.command)return 1;if(p.command)return-1}if(T!==0)return T;if(h.decorations&&p.decorations)T=D(h.decorations,p.decorations);else{if(h.decorations)return 1;if(p.decorations)return-1}return T}function t(h,p){for(let T=0;T<h.length;T++)if(h[T]!==p[T])return!1;return!0}function l(h,p){return h.command===p.command&&h.title===p.title&&h.tooltip===p.tooltip&&(h.arguments&&p.arguments?t(h.arguments,p.arguments):h.arguments===p.arguments)}function i(h,p){return(0,E.equals)(h,p,l)}class n{get value(){return this._value}set value(p){p=p??"",Oe(this,a,"f").$setInputBoxValue(this._sourceControlHandle,p),this.updateValue(p)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(p){Oe(this,a,"f").$setInputBoxPlaceholder(this._sourceControlHandle,p),this._placeholder=p}get validateInput(){return(0,m.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(p){if((0,m.checkProposedApiEnabled)(this._extension,"scmValidation"),p&&typeof p!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=p,Oe(this,a,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!p)}get enabled(){return this._enabled}set enabled(p){p=!!p,this._enabled!==p&&(this._enabled=p,Oe(this,a,"f").$setInputBoxEnablement(this._sourceControlHandle,p))}get visible(){return this._visible}set visible(p){p=!!p,this._visible!==p&&(this._visible=p,Oe(this,a,"f").$setInputBoxVisibility(this._sourceControlHandle,p))}constructor(p,T,M){this._extension=p,this._sourceControlHandle=M,a.set(this,void 0),this._value="",this._onDidChange=new C.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,Je(this,a,T,"f")}showValidationMessage(p,T){(0,m.checkProposedApiEnabled)(this._extension,"scmValidation"),Oe(this,a,"f").$showValidationMessage(this._sourceControlHandle,p,T)}$onInputBoxValueChange(p){this.updateValue(p)}updateValue(p){this._value=p,this._onDidChange.fire(p)}}e.ExtHostSCMInputBox=n,a=new WeakMap;class o{get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(p){this._label=p,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,p)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(p){this._hideWhenEmpty=p,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(p){this._resourceStates=[...p],this._onDidUpdateResourceStates.fire()}constructor(p,T,M,V,U){this._proxy=p,this._commands=T,this._sourceControlHandle=M,this._id=V,this._label=U,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new C.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new C.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=o._handlePool++}getResourceState(p){return this._resourceStatesMap.get(p)}$executeResourceCommand(p,T){const M=this._resourceStatesCommandsMap.get(p);return M?(0,_.asPromise)(()=>this._commands.executeCommand(M.command,...M.arguments||[],T)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const p=[...this._resourceStates].sort(b),M=(0,E.sortedDiff)(this._resourceSnapshot,p,b).map(y=>{const x=y.toInsert.map(L=>{const R=this._resourceHandlePool++;this._resourceStatesMap.set(R,L);const K=L.resourceUri;let W;if(L.command)if(L.command.command==="vscode.open"||L.command.command==="vscode.diff"){const be=new N.DisposableStore;W=this._commands.converter.toInternal(L.command,be),this._resourceStatesDisposablesMap.set(R,be)}else this._resourceStatesCommandsMap.set(R,L.command);const $=d(L.decorations),G=L.decorations&&d(L.decorations.light)||$,re=L.decorations&&d(L.decorations.dark)||$,ge=[G,re],oe=L.decorations&&L.decorations.tooltip||"",Ee=L.decorations&&!!L.decorations.strikeThrough,ce=L.decorations&&!!L.decorations.faded,me=L.contextValue||"";return{rawResource:[R,K,ge,oe,Ee,ce,me,W],handle:R}});return{start:y.start,deleteCount:y.deleteCount,toInsert:x}}),V=M.map(({start:y,deleteCount:x,toInsert:L})=>[y,x,L.map(R=>R.rawResource)]),U=M.reverse();for(const{start:y,deleteCount:x,toInsert:L}of U){const R=L.map(W=>W.handle),K=this._handlesSnapshot.splice(y,x,...R);for(const W of K)this._resourceStatesMap.delete(W),this._resourceStatesCommandsMap.delete(W),this._resourceStatesDisposablesMap.get(W)?.dispose(),this._resourceStatesDisposablesMap.delete(W)}return this._resourceSnapshot=p,V}dispose(){this._disposed=!0,this._onDidDispose.fire()}}o._handlePool=0;class f{get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(p){this._count!==p&&(this._count=p,Oe(this,u,"f").$updateSourceControl(this.handle,{count:p}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(p){this._quickDiffProvider=p,Oe(this,u,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!p})}get commitTemplate(){return this._commitTemplate}set commitTemplate(p){p!==this._commitTemplate&&(this._commitTemplate=p,Oe(this,u,"f").$updateSourceControl(this.handle,{commitTemplate:p}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(p){this._acceptInputDisposables.value=new N.DisposableStore,this._acceptInputCommand=p;const T=this._commands.converter.toInternal(p,this._acceptInputDisposables.value);Oe(this,u,"f").$updateSourceControl(this.handle,{acceptInputCommand:T})}get actionButton(){return(0,m.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(p){(0,m.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new N.DisposableStore,this._actionButton=p;const T=p!==void 0?{command:this._commands.converter.toInternal(p.command,this._actionButtonDisposables.value),secondaryCommands:p.secondaryCommands?.map(M=>M.map(V=>this._commands.converter.toInternal(V,this._actionButtonDisposables.value))),description:p.description,enabled:p.enabled}:void 0;Oe(this,u,"f").$updateSourceControl(this.handle,{actionButton:T??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(p){if(this._statusBarCommands&&p&&i(this._statusBarCommands,p))return;this._statusBarDisposables.value=new N.DisposableStore,this._statusBarCommands=p;const T=(p||[]).map(M=>this._commands.converter.toInternal(M,this._statusBarDisposables.value));Oe(this,u,"f").$updateSourceControl(this.handle,{statusBarCommands:T})}get selected(){return this._selected}constructor(p,T,M,V,U,y){this._extension=p,this._commands=M,this._id=V,this._label=U,this._rootUri=y,u.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new N.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new N.MutableDisposable,this._statusBarDisposables=new N.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new C.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=f._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Je(this,u,T,"f"),this._inputBox=new n(p,Oe(this,u,"f"),this.handle),Oe(this,u,"f").$registerSourceControl(this.handle,V,U,y)}createResourceGroup(p,T){const M=new o(Oe(this,u,"f"),this._commands,this.handle,p,T),V=C.Event.once(M.onDidDispose)(()=>this.createdResourceGroups.delete(M));return this.createdResourceGroups.set(M,V),this.eventuallyAddResourceGroups(),M}eventuallyAddResourceGroups(){const p=[],T=[];for(const[M,V]of this.createdResourceGroups){V.dispose();const U=M.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(M),this.eventuallyUpdateResourceStates()});C.Event.once(M.onDidDispose)(()=>{this.updatedResourceGroups.delete(M),U.dispose(),this._groups.delete(M.handle),Oe(this,u,"f").$unregisterGroup(this.handle,M.handle)}),p.push([M.handle,M.id,M.label,M.features]);const y=M._takeResourceStateSnapshot();y.length>0&&T.push([M.handle,y]),this._groups.set(M.handle,M)}Oe(this,u,"f").$registerGroups(this.handle,p,T),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const p=[];this.updatedResourceGroups.forEach(T=>{const M=T._takeResourceStateSnapshot();M.length!==0&&p.push([T.handle,M])}),p.length>0&&Oe(this,u,"f").$spliceResourceStates(this.handle,p),this.updatedResourceGroups.clear()}getResourceGroup(p){return this._groups.get(p)}setSelectionState(p){this._selected=p,this._onDidChangeSelection.fire(p)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(p=>p.dispose()),Oe(this,u,"f").$unregisterSourceControl(this.handle)}}u=new WeakMap,f._handlePool=0,ze([(0,S.debounce)(100)],f.prototype,"eventuallyAddResourceGroups",null),ze([(0,S.debounce)(100)],f.prototype,"eventuallyUpdateResourceStates",null);let s=class en{get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(p,T,M){this._commands=T,this.logService=M,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new C.Emitter,this._proxy=p.getProxy(A.MainContext.MainThreadSCM),this._telemetry=p.getProxy(A.MainContext.MainThreadTelemetry),T.registerArgumentProcessor({processArgument:V=>{if(V&&V.$mid===3){const U=this._sourceControls.get(V.sourceControlHandle);if(!U)return V;const y=U.getResourceGroup(V.groupHandle);return y?y.getResourceState(V.handle):V}else if(V&&V.$mid===4){const U=this._sourceControls.get(V.sourceControlHandle);return U?U.getResourceGroup(V.groupHandle):V}else if(V&&V.$mid===5){const U=this._sourceControls.get(V.handle);return U||V}return V}})}createSourceControl(p,T,M,V){this.logService.trace("ExtHostSCM#createSourceControl",p.identifier.value,T,M,V),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:p.identifier.value});const U=en._handlePool++,y=new f(p,this._proxy,this._commands,T,M,V);this._sourceControls.set(U,y);const x=this._sourceControlsByExtension.get(w.ExtensionIdentifier.toKey(p.identifier))||[];return x.push(y),this._sourceControlsByExtension.set(w.ExtensionIdentifier.toKey(p.identifier),x),y}getLastInputBox(p){this.logService.trace("ExtHostSCM#getLastInputBox",p.identifier.value);const T=this._sourceControlsByExtension.get(w.ExtensionIdentifier.toKey(p.identifier)),M=T&&T[T.length-1];return M&&M.inputBox}$provideOriginalResource(p,T,M){const V=r.URI.revive(T);this.logService.trace("ExtHostSCM#$provideOriginalResource",p,V.toString());const U=this._sourceControls.get(p);return!U||!U.quickDiffProvider||!U.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,_.asPromise)(()=>U.quickDiffProvider.provideOriginalResource(V,M)).then(y=>y||null)}$onInputBoxValueChange(p,T){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",p);const M=this._sourceControls.get(p);return M&&M.inputBox.$onInputBoxValueChange(T),Promise.resolve(void 0)}$executeResourceCommand(p,T,M,V){this.logService.trace("ExtHostSCM#$executeResourceCommand",p,T,M);const U=this._sourceControls.get(p);if(!U)return Promise.resolve(void 0);const y=U.getResourceGroup(T);return y?y.$executeResourceCommand(M,V):Promise.resolve(void 0)}$validateInput(p,T,M){this.logService.trace("ExtHostSCM#$validateInput",p);const V=this._sourceControls.get(p);return!V||!V.inputBox.validateInput?Promise.resolve(void 0):(0,_.asPromise)(()=>V.inputBox.validateInput(T,M)).then(U=>{if(!U)return Promise.resolve(void 0);const y=k.MarkdownString.fromStrict(U.message);return y?Promise.resolve([y,U.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(p){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",p),p!==void 0&&this._sourceControls.get(p)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=p,Promise.resolve(void 0)}};s._handlePool=0,s=ze([$e(2,O.ILogService)],s),e.ExtHostSCM=s}),define(Ce[69],Ie([1,0,4,5,3]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class N{constructor(A){this._onDidChangePassword=new C.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=A.getProxy(r.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this._onDidChangePassword.fire(A)}get(A,E){return this._proxy.$getPassword(A,E)}store(A,E,P){return this._proxy.$setPassword(A,E,P)}delete(A,E){return this._proxy.$deletePassword(A,E)}}e.ExtHostSecretState=N,e.IExtHostSecretState=(0,S.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(ie,e,r,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ie,r):S?S.value=r:e.set(ie,r),r},Oe=this&&this.__classPrivateFieldGet||function(ie,e,r,C){if(r==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!C:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?C:r==="a"?C.call(ie):C?C.value:e.get(ie)};define(Ce[212],Ie([1,0,6,4,133,7,8,10]),function(ie,e,r,C,S,N,_,A){"use strict";var E,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class O{constructor(m,a,u,d,v=r.StatusBarAlignment.Left,D){E.set(this,void 0),P.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new N.DisposableStore,Je(this,E,m,"f"),Je(this,P,a,"f"),this._entryId=O.ID_GEN++,this._extension=u,this._id=d,this._alignment=v,this._priority=this.validatePriority(D)}validatePriority(m){if(!!(0,A.isNumber)(m))return m===Number.POSITIVE_INFINITY?Number.MAX_VALUE:m===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:m}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(m){this._text=m,this.update()}set name(m){this._name=m,this.update()}set tooltip(m){this._tooltip=m,this.update()}set color(m){this._color=m,this.update()}set backgroundColor(m){m&&!O.ALLOWED_BACKGROUND_COLORS.has(m.id)&&(m=void 0),this._backgroundColor=m,this.update()}set command(m){this._command?.fromApi!==m&&(this._internalCommandRegistration.clear(),typeof m=="string"?this._command={fromApi:m,internal:Oe(this,P,"f").toInternal({title:"",command:m},this._internalCommandRegistration)}:m?this._command={fromApi:m,internal:Oe(this,P,"f").toInternal(m,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(m){this._accessibilityInformation=m,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Oe(this,E,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let m;this._extension?this._id?m=`${this._extension.identifier.value}.${this._id}`:m=this._extension.identifier.value:m=this._id;let a;this._name?a=this._name:a=(0,S.localize)(0,null,this._extension.displayName||this._extension.name);let u=this._color;this._backgroundColor&&(u=O.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const d=_.MarkdownString.fromStrict(this._tooltip);Oe(this,E,"f").$setEntry(this._entryId,m,a,this._text,d,this._command?.internal,u,this._backgroundColor,this._alignment===r.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=O,E=new WeakMap,P=new WeakMap,O.ID_GEN=0,O.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new r.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new r.ThemeColor("statusBarItem.warningForeground")]]);class w{constructor(m){this._messages=[],this._item=m.createStatusBarEntry(void 0,"status.extensionMessage",r.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,S.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(m){const a={message:m};return this._messages.unshift(a),this._update(),new r.Disposable(()=>{const u=this._messages.indexOf(a);u>=0&&(this._messages.splice(u,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class g{constructor(m,a){this._proxy=m.getProxy(C.MainContext.MainThreadStatusBar),this._commands=a,this._statusMessage=new w(this)}createStatusBarEntry(m,a,u,d){return new O(this._proxy,this._commands,m,a,u,d)}setStatusBarMessage(m,a){const u=this._statusMessage.setMessage(m);let d;return typeof a=="number"?d=setTimeout(()=>u.dispose(),a):typeof a<"u"&&a.then(()=>u.dispose(),()=>u.dispose()),new r.Disposable(()=>{u.dispose(),clearTimeout(d)})}}e.ExtHostStatusBar=g}),define(Ce[70],Ie([1,0,4,5,3]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class N{constructor(A){this._onDidChangeStorage=new C.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=A.getProxy(r.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,E){this._proxy.$registerExtensionStorageKeysToSync(A,E)}initializeExtensionStorage(A,E,P){return this._proxy.$initializeExtensionStorage(A,E).then(O=>O||P)}setValue(A,E,P){return this._proxy.$setValue(A,E,P)}$acceptValue(A,E,P){this._onDidChangeStorage.fire({shared:A,key:E,value:P})}}e.ExtHostStorage=N,e.IExtHostStorage=(0,S.createDecorator)("IExtHostStorage")}),define(Ce[71],Ie([1,0,3,27,14,52,2]),function(ie,e,r,C,S,N,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,r.createDecorator)("IExtensionStoragePaths");let A=class{constructor(P,O,w){this._logService=O,this._extHostFileSystem=w,this._workspace=P.workspace??void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(g=>this._value=g)}async _getWorkspaceStorageURI(P){return _.URI.joinPath(this._environment.workspaceStorageHome,P)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const P=this._workspace.id,O=await this._getWorkspaceStorageURI(P);try{return await this._extHostFileSystem.value.stat(O),this._logService.trace("[ExtHostStorage] storage dir already exists",O),O}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",O),await this._extHostFileSystem.value.createDirectory(O),await this._extHostFileSystem.value.writeFile(_.URI.joinPath(O,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:_.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),O}catch(w){this._logService.error("[ExtHostStorage]",w);return}}workspaceValue(P){if(this._value)return _.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return _.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}onWillDeactivateAll(){}};A=ze([$e(0,C.IExtHostInitDataService),$e(1,S.ILogService),$e(2,N.IExtHostConsumerFileSystem)],A),e.ExtensionStoragePaths=A}),define(Ce[98],Ie([1,0,3,4,11]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTelemetryLogService=e.IExtHostTelemetryLogService=void 0,e.IExtHostTelemetryLogService=(0,r.createDecorator)("IExtHostTelemetryLogService");let N=class{constructor(A){this._telemetryShape=A.getProxy(C.MainContext.MainThreadTelemetry)}logToTelemetryOutputChannel(A,E,P){this._telemetryShape.$logTelemetryToOutputChannel(`${A.identifier.value}/${E}`,P)}};N=ze([$e(0,S.IExtHostRpcService)],N),e.ExtHostTelemetryLogService=N}),define(Ce[53],Ie([1,0,5,4,3,2,11,7,6,134,12,168,20,43,154,60,10,15,8]),function(ie,e,r,C,S,N,_,A,E,P,O,w,g,k,m,a,u,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,S.createDecorator)("IExtHostTerminalService");class D{constructor(s,h,p,T){this._proxy=s,this._id=h,this._creationOptions=p,this._name=T,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(V=>this._pidPromiseComplete=V);const M=this;this.value={get name(){return M._name||""},get processId(){return M._pidPromise},get creationOptions(){return M._creationOptions},get exitStatus(){return M._exitStatus},get state(){return M._state},sendText(V,U=!0){M._checkDisposed(),M._proxy.$sendText(M._id,V,U)},show(V){M._checkDisposed(),M._proxy.$show(M._id,V)},hide(){M._checkDisposed(),M._proxy.$hide(M._id)},dispose(){M._disposed||(M._disposed=!0,M._proxy.$dispose(M._id))},get dimensions(){if(!(M._cols===void 0||M._rows===void 0))return{columns:M._cols,rows:M._rows}}}}async create(s,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:s.name,shellPath:(0,u.withNullAsUndefined)(s.shellPath),shellArgs:(0,u.withNullAsUndefined)(s.shellArgs),cwd:(0,u.withNullAsUndefined)(s.cwd),env:(0,u.withNullAsUndefined)(s.env),icon:(0,u.withNullAsUndefined)(n(s.iconPath)),color:a.ThemeColor.isThemeColor(s.color)?s.color.id:void 0,initialText:(0,u.withNullAsUndefined)(s.message),strictEnv:(0,u.withNullAsUndefined)(s.strictEnv),hideFromUser:(0,u.withNullAsUndefined)(s.hideFromUser),isFeatureTerminal:(0,u.withNullAsUndefined)(h?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,u.withNullAsUndefined)(h?.useShellEnvironment),location:h?.location||this._serializeParentTerminal(s.location,h?.resolvedExtHostIdentifier),isTransient:(0,u.withNullAsUndefined)(s.isTransient)})}async createExtensionTerminal(s,h,p,T){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:p,color:a.ThemeColor.isThemeColor(T)?T.id:void 0,location:this._serializeParentTerminal(s,h),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(s,h){return typeof s=="object"?"parentTerminal"in s&&s.parentTerminal&&h?{parentTerminal:h}:"viewColumn"in s?{viewColumn:v.ViewColumn.from(s.viewColumn),preserveFocus:s.preserveFocus}:void 0:s}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(s){this._name=s}setExitStatus(s,h){this._exitStatus=Object.freeze({code:s,reason:h})}setDimensions(s,h){return s===this._cols&&h===this._rows||s===0||h===0?!1:(this._cols=s,this._rows=h,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(s){this._pidPromiseComplete?(this._pidPromiseComplete(s),this._pidPromiseComplete=void 0):this._pidPromise.then(h=>{h!==s&&(this._pidPromise=Promise.resolve(s))})}}e.ExtHostTerminal=D;class c{get onProcessReady(){return this._onProcessReady.event}constructor(s){this._pty=s,this.id=0,this.shouldPersist=!1,this._onProcessData=new r.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new r.Emitter,this._onDidChangeProperty=new r.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new r.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(s){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${s}`)}updateProperty(s,h){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${s}, value: ${h}`)}async start(){}shutdown(){this._pty.close()}input(s){this._pty.handleInput?.(s)}resize(s,h){this._pty.setDimensions?.({columns:s,rows:h})}async processBinary(s){}acknowledgeDataEvent(s){}async setUnicodeVersion(s){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(s){this._pty.onDidWrite(h=>this._onProcessData.fire(h)),this._pty.onDidClose?.((h=void 0)=>{this._onProcessExit.fire(h===void 0?void 0:h)}),this._pty.onDidOverrideDimensions?.(h=>{h&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:h.columns,rows:h.rows}})}),this._pty.onDidChangeName?.(h=>{this._onDidChangeProperty.fire({type:"title",value:h})}),this._pty.open(s||void 0),s&&this._pty.setDimensions?.(s),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=c;let b=1,t=class extends A.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(s=>s.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}constructor(s,h){super(),this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new r.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new r.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new r.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new r.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new r.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new r.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._proxy=h.getProxy(C.MainContext.MainThreadTerminalService),this._bufferer=new m.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new r.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(s),this._register({dispose:()=>{for(const[p,T]of this._terminalProcesses)T.shutdown(!0)}})}getDefaultShell(s){return(s?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(s){return(s?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(s,h){const p=new D(this._proxy,(0,k.generateUuid)(),s,s.name),T=new c(s.pty);return p.createExtensionTerminal(s.location,this._serializeParentTerminal(s,h).resolvedExtHostIdentifier,n(s.iconPath),o(s.color)).then(M=>{const V=this._setupExtHostProcessListeners(M,T);this._terminalProcessDisposables[M]=V}),this._terminals.push(p),p.value}_serializeParentTerminal(s,h){if(h=h||{},s.location&&typeof s.location=="object"&&"parentTerminal"in s.location){const p=s.location.parentTerminal;if(p){const T=this._terminals.find(M=>M.value===p);T&&(h.resolvedExtHostIdentifier=T._id)}}else s.location&&typeof s.location!="object"?h.location=s.location:h.location&&typeof h.location=="object"&&"splitActiveTerminal"in h.location&&(h.location={splitActiveTerminal:!0});return h}attachPtyToTerminal(s,h){if(!this._getTerminalById(s))throw new Error(`Cannot resolve terminal with id ${s} for virtual process`);const T=new c(h),M=this._setupExtHostProcessListeners(s,T);this._terminalProcessDisposables[s]=M}async $acceptActiveTerminalChanged(s){const h=this._activeTerminal;if(s===null){this._activeTerminal=void 0,h!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const p=this._getTerminalById(s);p&&(this._activeTerminal=p,h!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(s,h){const p=this._getTerminalById(s);p&&this._onDidWriteTerminalData.fire({terminal:p.value,data:h})}async $acceptTerminalDimensions(s,h,p){const T=this._getTerminalById(s);T&&T.setDimensions(h,p)&&this._onDidChangeTerminalDimensions.fire({terminal:T.value,dimensions:T.value.dimensions})}async $acceptTerminalMaximumDimensions(s,h,p){this._terminalProcesses.get(s)?.resize(h,p)}async $acceptTerminalTitleChange(s,h){const p=this._getTerminalById(s);p&&(p.name=h)}async $acceptTerminalClosed(s,h,p){const T=this._getTerminalObjectIndexById(this._terminals,s);if(T!==null){const M=this._terminals.splice(T,1)[0];M.setExitStatus(h,p),this._onDidCloseTerminal.fire(M.value)}}$acceptTerminalOpened(s,h,p,T){if(h){const U=this._getTerminalObjectIndexById(this._terminals,h);if(U!==null){this._terminals[U]._id=s,this._onDidOpenTerminal.fire(this.terminals[U]),this._terminals[U].isOpen=!0;return}}const M={name:T.name,shellPath:T.executable,shellArgs:T.args,cwd:typeof T.cwd=="string"?T.cwd:N.URI.revive(T.cwd),env:T.env,hideFromUser:T.hideFromUser},V=new D(this._proxy,s,M,p);this._terminals.push(V),this._onDidOpenTerminal.fire(V.value),V.isOpen=!0}async $acceptTerminalProcessId(s,h){this._getTerminalById(s)?._setProcessId(h)}async $startExtensionTerminal(s,h){const p=this._getTerminalById(s);if(!p)return{message:(0,P.localize)(0,null,s)};p.isOpen||await new Promise(M=>{const V=this.onDidOpenTerminal(async U=>{U===p.value&&(V.dispose(),M())})});const T=this._terminalProcesses.get(s);T?T.startSendingEvents(h):this._extensionTerminalAwaitingStart[s]={initialDimensions:h}}_setupExtHostProcessListeners(s,h){const p=new A.DisposableStore;p.add(h.onProcessReady(M=>this._proxy.$sendProcessReady(s,M.pid,M.cwd))),p.add(h.onDidChangeProperty(M=>this._proxy.$sendProcessProperty(s,M))),this._bufferer.startBuffering(s,h.onProcessData),p.add(h.onProcessExit(M=>this._onProcessExit(s,M))),this._terminalProcesses.set(s,h);const T=this._extensionTerminalAwaitingStart[s];return T&&h instanceof c&&(h.startSendingEvents(T.initialDimensions),delete this._extensionTerminalAwaitingStart[s]),p}$acceptProcessAckDataEvent(s,h){this._terminalProcesses.get(s)?.acknowledgeDataEvent(h)}$acceptProcessInput(s,h){this._terminalProcesses.get(s)?.input(h)}$acceptTerminalInteraction(s){const h=this._getTerminalById(s);h?.setInteractedWith()&&this._onDidChangeTerminalState.fire(h.value)}$acceptProcessResize(s,h,p){try{this._terminalProcesses.get(s)?.resize(h,p)}catch(T){if(T.code!=="EPIPE"&&T.code!=="ERR_IPC_CHANNEL_CLOSED")throw T}}$acceptProcessShutdown(s,h){this._terminalProcesses.get(s)?.shutdown(h)}$acceptProcessRequestInitialCwd(s){this._terminalProcesses.get(s)?.getInitialCwd().then(h=>this._proxy.$sendProcessProperty(s,{type:"initialCwd",value:h}))}$acceptProcessRequestCwd(s){this._terminalProcesses.get(s)?.getCwd().then(h=>this._proxy.$sendProcessProperty(s,{type:"cwd",value:h}))}$acceptProcessRequestLatency(s){return Promise.resolve(s)}registerLinkProvider(s){return this._linkProviders.add(s),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new E.Disposable(()=>{this._linkProviders.delete(s),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(s,h,p){if(this._profileProviders.has(h))throw new Error(`Terminal profile provider "${h}" already registered`);return this._profileProviders.set(h,p),this._proxy.$registerProfileProvider(h,s.identifier.value),new E.Disposable(()=>{this._profileProviders.delete(h),this._proxy.$unregisterProfileProvider(h)})}async $createContributedProfileTerminal(s,h){const p=new g.CancellationTokenSource().token;let T=await this._profileProviders.get(s)?.provideTerminalProfile(p);if(!p.isCancellationRequested){if(T&&!("options"in T)&&(T={options:T}),!T||!("options"in T))throw new Error(`No terminal profile options provided for id "${s}"`);if("pty"in T.options){this.createExtensionTerminal(T.options,h);return}this.createTerminalFromOptions(T.options,h)}}async $provideLinks(s,h){const p=this._getTerminalById(s);if(!p)return[];this._terminalLinkCache.delete(s),this._terminalLinkCancellationSource.get(s)?.dispose(!0);const M=new g.CancellationTokenSource;this._terminalLinkCancellationSource.set(s,M);const V=[],U={terminal:p.value,line:h},y=[];for(const R of this._linkProviders)y.push(d.Promises.withAsyncBody(async K=>{M.token.onCancellationRequested(()=>K({provider:R,links:[]}));const W=await R.provideTerminalLinks(U,M.token)||[];M.token.isCancellationRequested||K({provider:R,links:W})}));const x=await Promise.all(y);if(M.token.isCancellationRequested)return[];const L=new Map;for(const R of x)R&&R.links.length>0&&V.push(...R.links.map(K=>{const W={id:b++,startIndex:K.startIndex,length:K.length,label:K.tooltip};return L.set(W.id,{provider:R.provider,link:K}),W}));return this._terminalLinkCache.set(s,L),V}$activateLink(s,h){const p=this._terminalLinkCache.get(s)?.get(h);!p||p.provider.handleTerminalLink(p.link)}_onProcessExit(s,h){this._bufferer.stopBuffering(s),this._terminalProcesses.delete(s),delete this._extensionTerminalAwaitingStart[s];const p=this._terminalProcessDisposables[s];p&&(p.dispose(),delete this._terminalProcessDisposables[s]),this._proxy.$sendProcessExit(s,h)}_getTerminalById(s){return this._getTerminalObjectById(this._terminals,s)}_getTerminalObjectById(s,h){const p=this._getTerminalObjectIndexById(s,h);return p!==null?s[p]:null}_getTerminalObjectIndexById(s,h){let p=null;return s.some((T,M)=>T._id===h?(p=M,!0):!1),p}getEnvironmentVariableCollection(s){let h=this._environmentVariableCollections.get(s.identifier.value);return h||(h=new l,this._setEnvironmentVariableCollection(s.identifier.value,h)),h}_syncEnvironmentVariableCollection(s,h){const p=(0,w.serializeEnvironmentVariableCollection)(h.map);this._proxy.$setEnvironmentVariableCollection(s,h.persistent,p.length===0?void 0:p)}$initEnvironmentVariableCollections(s){s.forEach(h=>{const p=h[0],T=new l(h[1]);this._setEnvironmentVariableCollection(p,T)})}$acceptDefaultProfile(s,h){const p=this._defaultProfile;this._defaultProfile=s,this._defaultAutomationProfile=h,p?.path!==s.path&&this._onDidChangeShell.fire(s.path)}_setEnvironmentVariableCollection(s,h){this._environmentVariableCollections.set(s,h),h.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(s,h)})}};t=ze([$e(1,_.IExtHostRpcService)],t),e.BaseExtHostTerminalService=t;class l{get persistent(){return this._persistent}set persistent(s){this._persistent=s,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(s){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new r.Emitter,this.map=new Map(s)}get size(){return this.map.size}replace(s,h){this._setIfDiffers(s,{value:h,type:E.EnvironmentVariableMutatorType.Replace})}append(s,h){this._setIfDiffers(s,{value:h,type:E.EnvironmentVariableMutatorType.Append})}prepend(s,h){this._setIfDiffers(s,{value:h,type:E.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(s,h){const p=this.map.get(s);(!p||p.value!==h.value||p.type!==h.type)&&(this.map.set(s,h),this._onDidChangeCollection.fire())}get(s){return this.map.get(s)}forEach(s,h){this.map.forEach((p,T)=>s.call(h,T,p,this))}[Symbol.iterator](){return this.map.entries()}delete(s){this.map.delete(s),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=l;let i=class extends t{constructor(s){super(!1,s)}createTerminal(s,h,p){throw new O.NotSupportedError}createTerminalFromOptions(s,h){throw new O.NotSupportedError}};i=ze([$e(0,_.IExtHostRpcService)],i),e.WorkerExtHostTerminalService=i;function n(f){if(!(!f||typeof f=="string"))return"id"in f?{id:f.id,color:f.color}:f}function o(f){return a.ThemeColor.isThemeColor(f)?f:void 0}});var Oe=this&&this.__classPrivateFieldGet||function(ie,e,r,C){if(r==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!C:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?C:r==="a"?C.call(ie):C?C.value:e.get(ie)},Je=this&&this.__classPrivateFieldSet||function(ie,e,r,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ie,r):S?S.value=r:e.set(ie,r),r};define(Ce[213],Ie([1,0,18,23,20,5,177,214,7,25,10,43,4,11,95,8,6,40,65,48]),function(ie,e,r,C,S,N,_,A,E,P,O,w,g,k,m,a,u,d,v,D){"use strict";var c,b;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let t=class{constructor(U,y,x){this.editors=x,this.resultsChangedEmitter=new N.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=U.getProxy(g.MainContext.MainThreadTesting),this.observer=new p(this.proxy),this.runTracker=new i(this.proxy),y.registerArgumentProcessor({processArgument:L=>{if(L?.$mid!==13)return L;const R=L,K=R.tests[R.tests.length-1].item.extId;return this.controllers.get(d.TestId.root(K))?.collection.tree.get(K)?.actual??(0,m.toItemFromContext)(L)}})}createTestController(U,y,x){if(this.controllers.has(U))throw new Error(`Attempt to insert a duplicate controller with ID "${U}"`);const L=new E.DisposableStore,R=L.add(new m.ExtHostTestItemCollection(U,y,this.editors));R.root.label=y;const K=new Map,W=this.proxy,$={items:R.root.children,get label(){return y},set label(re){y=re,R.root.label=re,W.$updateController(U,{label:y})},get refreshHandler(){return x},set refreshHandler(re){x=re,W.$updateController(U,{canRefresh:!!re})},get id(){return U},createRunProfile:(re,ge,oe,Ee,ce)=>{let me=(0,A.hash)(re);for(;K.has(me);)me++;return new T(this.proxy,K,U,me,re,ge,oe,Ee,ce)},createTestItem(re,ge,oe){return new m.TestItemImpl(U,re,ge,oe)},createTestRun:(re,ge,oe=!0)=>this.runTracker.createTestRun(U,R,re,ge,oe),set resolveHandler(re){R.resolveHandler=re},get resolveHandler(){return R.resolveHandler},dispose:()=>{L.dispose()}};W.$registerTestController(U,y,!!x),L.add((0,E.toDisposable)(()=>W.$unregisterTestController(U)));const G={controller:$,collection:R,profiles:K};return this.controllers.set(U,G),L.add((0,E.toDisposable)(()=>this.controllers.delete(U))),L.add(R.onDidGenerateDiff(re=>W.$publishDiff(U,re.map(D.TestsDiffOp.serialize)))),$}createTestObserver(){return this.observer.checkout()}async runTests(U,y=S.CancellationToken.None){const x=n(U);if(!x)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const L=this.controllers.get(x.controllerId);if(!L)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(R=>d.TestId.fromExtHostTestItem(R,L.collection.root.id).toString())??[L.collection.root.id],profileGroup:M[x.kind],profileId:x.profileId,controllerId:x.controllerId}],exclude:U.exclude?.map(R=>R.id)},y)}$provideFileCoverage(U,y,x){return(0,r.mapFind)(this.runTracker.trackers,R=>R.id===U?R.getCoverage(y):void 0)?.provideFileCoverage(x)??Promise.resolve([])}$resolveFileCoverage(U,y,x,L){return(0,r.mapFind)(this.runTracker.trackers,K=>K.id===U?K.getCoverage(y):void 0)?.resolveFileCoverage(x,L)??Promise.resolve([])}$configureRunProfile(U,y){this.controllers.get(U)?.profiles.get(y)?.configureHandler?.()}async $refreshTests(U,y){await this.controllers.get(U)?.controller.refreshHandler?.(y)}$publishTestResults(U){this.results=Object.freeze(U.map(y=>(0,P.deepFreeze)(a.TestResults.to(y))).concat(this.results).sort((y,x)=>x.completedAt-y.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(U,y){const x=this.controllers.get(d.TestId.fromString(U).controllerId)?.collection;x&&(await x.expand(U,y<0?1/0:y),x.flushDiff())}$acceptDiff(U){this.observer.applyDiff(U.map(D.TestsDiffOp.deserialize))}async $runControllerTests(U,y){return Promise.all(U.map(x=>this.runControllerTestRequest(x,y)))}async runControllerTestRequest(U,y){const x=this.controllers.get(U.controllerId);if(!x)return{};const{collection:L,profiles:R}=x,K=R.get(U.profileId);if(!K)return{};const W=U.testIds.map(ge=>L.tree.get(ge)).filter(O.isDefined),$=U.excludeExtIds.map(ge=>x.collection.tree.get(ge)).filter(O.isDefined).filter(ge=>W.some(oe=>oe.fullId.compare(ge.fullId)===2));if(!W.length)return{};const G=new u.TestRunRequest(W.some(ge=>ge.actual instanceof m.TestItemRootImpl)?void 0:W.map(ge=>ge.actual),$.map(ge=>ge.actual),K),re=this.runTracker.prepareForMainThreadTestRun(G,o.fromInternal(U,x.collection),y);try{return await K.runHandler(G,y),{}}catch(ge){return{error:String(ge)}}finally{re.isRunning&&!y.isCancellationRequested&&await N.Event.toPromise(re.onEnd),re.dispose()}}$cancelExtensionTestRun(U){U===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(U)}};t=ze([$e(0,k.IExtHostRpcService)],t),e.ExtHostTesting=t;class l extends E.Disposable{get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}constructor(U,y,x){super(),this.dto=U,this.proxy=y,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new N.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new S.CancellationTokenSource(x)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:L}of this.tasks.values())L.end()}))}getCoverage(U){return this.tasks.get(U)?.coverage}createRun(U){const y=this.dto.id,x=this.dto.controllerId,L=(0,w.generateUuid)(),R=new f(this.proxy,y,L),K=re=>(ge,...oe)=>{if($){console.warn(`Setting the state of test "${ge.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(ge)||(this.ensureTestIsKnown(ge),re(ge,...oe))},W=(re,ge)=>{const oe=ge instanceof Array?ge.map(a.TestMessage.from):[a.TestMessage.from(ge)];if(re.uri&&re.range){const Ee={range:a.Range.from(re.range),uri:re.uri};for(const ce of oe)ce.location=ce.location||Ee}this.proxy.$appendTestMessagesInRun(y,L,d.TestId.fromExtHostTestItem(re,x).toString(),oe)};let $=!1;const G={isPersisted:this.dto.isPersisted,token:this.cts.token,name:U,get coverageProvider(){return R.coverageProvider},set coverageProvider(re){R.coverageProvider=re},enqueued:K(re=>{this.proxy.$updateTestStateInRun(y,L,d.TestId.fromExtHostTestItem(re,x).toString(),1)}),skipped:K(re=>{this.proxy.$updateTestStateInRun(y,L,d.TestId.fromExtHostTestItem(re,x).toString(),5)}),started:K(re=>{this.proxy.$updateTestStateInRun(y,L,d.TestId.fromExtHostTestItem(re,x).toString(),2)}),errored:K((re,ge,oe)=>{W(re,ge),this.proxy.$updateTestStateInRun(y,L,d.TestId.fromExtHostTestItem(re,x).toString(),6,oe)}),failed:K((re,ge,oe)=>{W(re,ge),this.proxy.$updateTestStateInRun(y,L,d.TestId.fromExtHostTestItem(re,x).toString(),4,oe)}),passed:K((re,ge)=>{this.proxy.$updateTestStateInRun(y,L,d.TestId.fromExtHostTestItem(re,this.dto.controllerId).toString(),3,ge)}),appendOutput:(re,ge,oe)=>{$||(oe&&(this.dto.isIncluded(oe)?this.ensureTestIsKnown(oe):oe=void 0),this.proxy.$appendOutputToRun(y,L,C.VSBuffer.fromString(re),ge&&a.location.from(ge),oe&&d.TestId.fromExtHostTestItem(oe,x).toString()))},end:()=>{$||($=!0,this.proxy.$finishedTestRunTask(y,L),this.tasks.delete(L),this.isRunning||this.dispose())}};return this.tasks.set(L,{run:G,coverage:R}),this.proxy.$startedTestRunTask(y,{id:L,name:U,running:!0}),G}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(U){if(!(U instanceof m.TestItemImpl))throw new v.InvalidTestItemError(U.id);if(this.sharedTestIds.has(d.TestId.fromExtHostTestItem(U,this.dto.controllerId).toString()))return;const y=[],x=this.dto.colllection.root;for(;;){const L=a.TestItem.from(U);if(y.unshift(L),this.sharedTestIds.has(L.extId)||(this.sharedTestIds.add(L.extId),U===x))break;U=U.parent||x}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,y)}}class i{get trackers(){return this.tracked.values()}constructor(U){this.proxy=U,this.tracked=new Map}prepareForMainThreadTestRun(U,y,x){return this.getTracker(U,y,x)}cancelRunById(U){for(const y of this.tracked.values())if(y.id===U){y.dispose();return}}cancelAllRuns(){for(const U of this.tracked.values())U.dispose()}createTestRun(U,y,x,L,R){const K=this.tracked.get(x);if(K)return K.createRun(L);const W=o.fromPublic(U,y,x,R),$=n(x);this.proxy.$startedExtensionTestRun({controllerId:U,profile:$&&{group:M[$.kind],id:$.profileId},exclude:x.exclude?.map(re=>d.TestId.fromExtHostTestItem(re,y.root.id).toString())??[],id:W.id,include:x.include?.map(re=>d.TestId.fromExtHostTestItem(re,y.root.id).toString())??[y.root.id],persist:R});const G=this.getTracker(x,W);return G.onEnd(()=>this.proxy.$finishedExtensionTestRun(W.id)),G.createRun(L)}getTracker(U,y,x){const L=new l(y,this.proxy,x);return this.tracked.set(U,L),L.onEnd(()=>this.tracked.delete(U)),L}}e.TestRunCoordinator=i;const n=V=>{if(!!V.profile){if(!(V.profile instanceof T))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return V.profile}};class o{static fromPublic(U,y,x,L){return new o(U,(0,w.generateUuid)(),x.include?.map(R=>d.TestId.fromExtHostTestItem(R,U).toString())??[U],x.exclude?.map(R=>d.TestId.fromExtHostTestItem(R,U).toString())??[],L,y)}static fromInternal(U,y){return new o(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,y)}constructor(U,y,x,L,R,K){this.controllerId=U,this.id=y,this.isPersisted=R,this.colllection=K,this.includePrefix=x.map(W=>W+"\0"),this.excludePrefix=L.map(W=>W+"\0")}isIncluded(U){const y=d.TestId.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const x of this.excludePrefix)if(y===x||y.startsWith(x))return!1;for(const x of this.includePrefix)if(y===x||y.startsWith(x))return!0;return!1}}e.TestRunDto=o;class f{set coverageProvider(U){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!U||(this._coverageProvider=U,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}constructor(U,y,x){this.proxy=U,this.runId=y,this.taskId=x}async provideFileCoverage(U){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(U))());try{return(await this.fileCoverage)?.map(a.TestCoverage.fromFile)??[]}catch(y){throw this.fileCoverage=void 0,y}}async resolveFileCoverage(U,y){const x=await this.fileCoverage;let L=x?.[U];return!this._coverageProvider||!x||!L?[]:(L.detailedCoverage||(L=x[U]=await this._coverageProvider.resolveFileCoverage?.(L,y)??L),L.detailedCoverage?.map(a.TestCoverage.fromDetailed)??[])}}class s extends D.IncrementalChangeCollector{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(U){super(),this.emitter=U,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(U){this.added.add(U)}update(U){Object.assign(U.revived,a.TestItem.toPlain(U.item)),this.added.has(U)||this.updated.add(U)}remove(U){if(this.added.has(U)){this.added.delete(U);return}this.updated.delete(U);const y=d.TestId.parentId(U.item.extId);if(y&&this.alreadyRemoved.has(y.toString())){this.alreadyRemoved.add(U.item.extId);return}this.removed.add(U)}getChangeEvent(){const{added:U,updated:y,removed:x}=this;return{get added(){return[...U].map(L=>L.revived)},get updated(){return[...y].map(L=>L.revived)},get removed(){return[...x].map(L=>L.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class h extends D.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new N.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(U){return this.items.get(U)}getMirroredTestDataByReference(U){return this.items.get(U.id)}createItem(U,y){return{...U,revived:a.TestItem.toPlain(U.item),depth:y?y.depth+1:0,children:new Set}}createChangeCollector(){return new s(this.changeEmitter)}}e.MirroredTestCollection=h;class p{constructor(U){this.proxy=U}checkout(){this.current||(this.current=this.createObserverData());const U=this.current;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(y=>y.revived)},dispose:(0,_.once)(()=>{--U.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(U){return this.current?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.current?.tests.apply(U)}createObserverData(){const U=new h;return this.proxy.$subscribeToDiffs(),{observers:0,tests:U}}}class T{get label(){return this._label}set label(U){U!==this._label&&(this._label=U,Oe(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:U}))}get isDefault(){return this._isDefault}set isDefault(U){U!==this._isDefault&&(this._isDefault=U,Oe(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,Oe(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:U?a.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(U){U!==this._configureHandler&&(this._configureHandler=U,Oe(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!U}))}constructor(U,y,x,L,R,K,W,$=!1,G=void 0){this.controllerId=x,this.profileId=L,this._label=R,this.kind=K,this.runHandler=W,this._isDefault=$,this._tag=G,c.set(this,void 0),b.set(this,void 0),Je(this,c,U,"f"),Je(this,b,y,"f"),y.set(L,this);const re=M[K];if(typeof re!="number")throw new Error(`Unknown TestRunProfile.group ${K}`);Oe(this,c,"f").$publishTestRunProfile({profileId:L,controllerId:x,tag:G?a.TestTag.namespace(this.controllerId,G.id):null,label:R,group:re,isDefault:$,hasConfigurationHandler:!1})}dispose(){Oe(this,b,"f")?.delete(this.profileId)&&(Je(this,b,void 0,"f"),Oe(this,c,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=T,c=new WeakMap,b=new WeakMap;const M={[u.TestRunProfileKind.Coverage]:8,[u.TestRunProfileKind.Debug]:4,[u.TestRunProfileKind.Run]:2}}),define(Ce[215],Ie([1,0,18,5,4,96,8,6]),function(ie,e,r,C,S,N,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class E{constructor(O,w){this._extHostDocumentsAndEditors=w,this._onDidChangeTextEditorSelection=new C.Emitter,this._onDidChangeTextEditorOptions=new C.Emitter,this._onDidChangeTextEditorVisibleRanges=new C.Emitter,this._onDidChangeTextEditorViewColumn=new C.Emitter,this._onDidChangeActiveTextEditor=new C.Emitter,this._onDidChangeVisibleTextEditors=new C.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=O.getProxy(S.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(g=>this._onDidChangeVisibleTextEditors.fire(g)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(g=>this._onDidChangeActiveTextEditor.fire(g))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(O){const w=this._extHostDocumentsAndEditors.allEditors();return O?w:w.map(g=>g.value)}async showTextDocument(O,w,g){let k;typeof w=="number"?k={position:_.ViewColumn.from(w),preserveFocus:g}:typeof w=="object"?k={position:_.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selection:typeof w.selection=="object"?_.Range.from(w.selection):void 0,pinned:typeof w.preview=="boolean"?!w.preview:void 0}:k={preserveFocus:!1};const m=await this._proxy.$tryShowTextDocument(O.uri,k),a=m&&this._extHostDocumentsAndEditors.getEditor(m);if(a)return a.value;throw m?new Error(`Could NOT open editor for "${O.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${O.uri.toString()}".`)}createTextEditorDecorationType(O,w){return new N.TextEditorDecorationType(this._proxy,O,w).value}$acceptEditorPropertiesChanged(O,w){const g=this._extHostDocumentsAndEditors.getEditor(O);if(!g)throw new Error("unknown text editor");if(w.options&&g._acceptOptions(w.options),w.selections){const k=w.selections.selections.map(_.Selection.to);g._acceptSelections(k)}if(w.visibleRanges){const k=r.coalesce(w.visibleRanges.map(_.Range.to));g._acceptVisibleRanges(k)}if(w.options&&this._onDidChangeTextEditorOptions.fire({textEditor:g.value,options:{...w.options,lineNumbers:_.TextEditorLineNumbersStyle.to(w.options.lineNumbers)}}),w.selections){const k=A.TextEditorSelectionChangeKind.fromValue(w.selections.source),m=w.selections.selections.map(_.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:g.value,selections:m,kind:k})}if(w.visibleRanges){const k=r.coalesce(w.visibleRanges.map(_.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:g.value,visibleRanges:k})}}$acceptEditorPositionData(O){for(const w in O){const g=this._extHostDocumentsAndEditors.getEditor(w);if(!g)throw new Error("Unknown text editor");const k=_.ViewColumn.to(O[w]);g.value.viewColumn!==k&&(g._acceptViewColumn(k),this._onDidChangeTextEditorViewColumn.fire({textEditor:g.value,viewColumn:k}))}}getDiffInformation(O){return Promise.resolve(this._proxy.$getDiffInformation(O))}}e.ExtHostEditors=E}),define(Ce[216],Ie([1,0,2,3,4,7,6,8,10]),function(ie,e,r,C,S,N,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,C.createDecorator)("IExtHostTimeline");class P{constructor(g,k){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=g.getProxy(S.MainContext.MainThreadTimeline),k.registerArgumentProcessor({processArgument:m=>{if(m&&m.$mid===11){const a=m.uri===void 0?void 0:r.URI.revive(m.uri);return this._itemsBySourceAndUriMap.get(m.source)?.get(O(a))?.get(m.handle)}return m}})}async $getTimeline(g,k,m,a){return this._providers.get(g)?.provideTimeline(r.URI.revive(k),m,a)}registerTimelineProvider(g,k,m,a){const u=new N.DisposableStore,d=this.convertTimelineItem(k.id,a,u).bind(this);let v;k.onDidChange&&(v=k.onDidChange(c=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...c,id:k.id}),this));const D=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...k,scheme:g,onDidChange:void 0,async provideTimeline(c,b,t){b?.resetCache&&(u.clear(),D.get(k.id)?.clear());const l=await k.provideTimeline(c,b,t);if(l==null)return;const i=d(c,b);return{...l,source:k.id,items:l.items.map(i)}},dispose(){for(const c of D.values())c.get(k.id)?.clear();v?.dispose(),u.dispose()}})}convertTimelineItem(g,k,m){return(a,u)=>{let d;if(u?.cacheResults){let v=this._itemsBySourceAndUriMap.get(g);v===void 0&&(v=new Map,this._itemsBySourceAndUriMap.set(g,v));const D=O(a);d=v.get(D),d===void 0&&(d=new Map,v.set(D,d))}return v=>{const{iconPath:D,...c}=v,b=`${g}|${v.id??v.timestamp}`;d?.set(b,v);let t,l,i;v.iconPath&&(D instanceof _.ThemeIcon?i={id:D.id,color:D.color}:r.URI.isUri(D)?(t=D,l=D):{light:t,dark:l}=D);let n;return _.MarkdownString.isMarkdownString(c.tooltip)?n=A.MarkdownString.from(c.tooltip):(0,E.isString)(c.tooltip)?n=c.tooltip:_.MarkdownString.isMarkdownString(c.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),n=A.MarkdownString.from(c.detail)):(0,E.isString)(c.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),n=c.detail),{...c,id:c.id??void 0,handle:b,source:g,command:v.command?k.toInternal(v.command,m):void 0,icon:t,iconDark:l,themeIcon:i,tooltip:n,accessibilityInformation:v.accessibilityInformation}}}}registerTimelineProviderCore(g){if(this._providers.get(g.id))throw new Error(`Timeline Provider ${g.id} already exists.`);return this._proxy.$registerTimelineProvider({id:g.id,label:g.label,scheme:g.scheme}),this._providers.set(g.id,g),(0,N.toDisposable)(()=>{for(const m of this._itemsBySourceAndUriMap.values())m.get(g.id)?.clear();this._providers.delete(g.id),this._proxy.$unregisterTimelineProvider(g.id),g.dispose()})}}e.ExtHostTimeline=P;function O(w){return w?.toString()}}),define(Ce[217],Ie([1,0,7,13,2,4]),function(ie,e,r,C,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class _{constructor(E){this._openers=new Map,this._proxy=E.getProxy(N.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(E,P,O,w){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const g=w.schemes.find(k=>!_.supportedSchemes.has(k));if(g)throw new Error(`Scheme '${g}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,O),this._proxy.$registerUriOpener(P,w.schemes,E,w.label),(0,r.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(E,P,O){const w=this._openers.get(E);if(!w)throw new Error(`Unknown opener with id: ${E}`);const g=S.URI.revive(P);return w.canOpenExternalUri(g,O)}async $openUri(E,P,O){const w=this._openers.get(E);if(!w)throw new Error(`Unknown opener id: '${E}'`);return w.openExternalUri(S.URI.revive(P.resolvedUri),{sourceUri:S.URI.revive(P.sourceUri)},O)}}e.ExtHostUriOpeners=_,_.supportedSchemes=new Set([C.Schemas.http,C.Schemas.https])}),define(Ce[218],Ie([1,0,4,2,7,12,26]),function(ie,e,r,C,S,N,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(r.MainContext.MainThreadUrls)}registerUriHandler(P,O){if(this.handles.has(_.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const w=A.HandlePool++;return this.handles.add(_.ExtensionIdentifier.toKey(P)),this.handlers.set(w,O),this._proxy.$registerUriHandler(w,P),(0,S.toDisposable)(()=>{this.handles.delete(_.ExtensionIdentifier.toKey(P)),this.handlers.delete(w),this._proxy.$unregisterUriHandler(w)})}$handleExternalUri(P,O){const w=this.handlers.get(P);if(!w)return Promise.resolve(void 0);try{w.handleUri(C.URI.revive(O))}catch(g){(0,N.onUnexpectedError)(g)}return Promise.resolve(void 0)}async createAppUri(P){return C.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=A,A.HandlePool=0});var Je=this&&this.__classPrivateFieldSet||function(ie,e,r,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ie,r):S?S.value=r:e.set(ie,r),r},Oe=this&&this.__classPrivateFieldGet||function(ie,e,r,C){if(r==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!C:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?C:r==="a"?C.call(ie):C?C.value:e.get(ie)};define(Ce[54],Ie([1,0,5,13,2,145,161,63,4]),function(ie,e,r,C,S,N,_,A,E){"use strict";var P,O,w,g,k,m,a,u,d,v,D,c;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class b{constructor(h,p,T,M,V,U,y){P.set(this,void 0),O.set(this,void 0),w.set(this,void 0),g.set(this,void 0),k.set(this,void 0),m.set(this,void 0),a.set(this,""),u.set(this,void 0),d.set(this,!1),v.set(this,!1),D.set(this,!1),this._onMessageEmitter=new r.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,c.set(this,new r.Emitter),this._onDidDispose=Oe(this,c,"f").event,Je(this,P,h,"f"),Je(this,O,p,"f"),Je(this,u,T,"f"),Je(this,g,M,"f"),Je(this,k,V,"f"),Je(this,m,U,"f"),Je(this,D,t(U),"f"),Je(this,w,y,"f")}dispose(){Je(this,d,!0,"f"),Oe(this,c,"f").fire(),Oe(this,c,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(h){return Je(this,v,!0,"f"),(0,A.asWebviewUri)(h,Oe(this,g,"f"))}get cspSource(){const h=Oe(this,m,"f").extensionLocation;if(h.scheme===C.Schemas.https||h.scheme===C.Schemas.http){let p=h.toString();return p.endsWith("/")||(p+="/"),p+" "+A.webviewGenericCspSource}return A.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Oe(this,a,"f")}set html(h){this.assertNotDisposed(),Oe(this,a,"f")!==h&&(Je(this,a,h,"f"),!Oe(this,v,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(h)&&(Je(this,v,!0,"f"),Oe(this,w,"f").report("Webview vscode-resource: uris",Oe(this,m,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,O,"f").$setHtml(Oe(this,P,"f"),h))}get options(){return this.assertNotDisposed(),Oe(this,u,"f")}set options(h){this.assertNotDisposed(),Oe(this,O,"f").$setOptions(Oe(this,P,"f"),n(Oe(this,m,"f"),Oe(this,k,"f"),h)),Je(this,u,h,"f")}async postMessage(h){if(Oe(this,d,"f"))return!1;const p=(0,_.serializeWebviewMessage)(h,{serializeBuffersForPostMessage:Oe(this,D,"f")});return Oe(this,O,"f").$postMessage(Oe(this,P,"f"),p.message,...p.buffers)}assertNotDisposed(){if(Oe(this,d,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=b,P=new WeakMap,O=new WeakMap,w=new WeakMap,g=new WeakMap,k=new WeakMap,m=new WeakMap,a=new WeakMap,u=new WeakMap,d=new WeakMap,v=new WeakMap,D=new WeakMap,c=new WeakMap;function t(s){try{const h=(0,N.normalizeVersion)((0,N.parseVersion)(s.engines.vscode));return!!h&&h.majorBase>=1&&h.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=t;class l{constructor(h,p,T,M,V){this.remoteInfo=p,this.workspace=T,this._logService=M,this._deprecationService=V,this._webviews=new Map,this._webviewProxy=h.getProxy(E.MainContext.MainThreadWebviews)}$onMessage(h,p,T){const M=this.getWebview(h);if(M){const{message:V}=(0,_.deserializeWebviewMessage)(p,T.value);M._onMessageEmitter.fire(V)}}$onMissingCsp(h,p){this._logService.warn(`${p} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(h,p,T){const M=new b(h,this._webviewProxy,o(p),this.remoteInfo,this.workspace,T,this._deprecationService);return this._webviews.set(h,M),M._onDidDispose(()=>{this._webviews.delete(h)}),M}deleteWebview(h){this._webviews.delete(h)}getWebview(h){return this._webviews.get(h)}}e.ExtHostWebviews=l;function i(s){return{id:s.identifier,location:s.extensionLocation}}e.toExtensionData=i;function n(s,h,p){return{enableCommandUris:p.enableCommandUris,enableScripts:p.enableScripts,enableForms:p.enableForms,portMapping:p.portMapping,localResourceRoots:p.localResourceRoots||f(s,h)}}e.serializeWebviewOptions=n;function o(s){return{enableCommandUris:s.enableCommandUris,enableScripts:s.enableScripts,enableForms:s.enableForms,portMapping:s.portMapping,localResourceRoots:s.localResourceRoots?.map(h=>S.URI.from(h))}}e.reviveOptions=o;function f(s,h){return[...(h?.getWorkspaceFolders()||[]).map(p=>p.uri),s.extensionLocation]}}),define(Ce[219],Ie([1,0,20,214,7,13,22,2,8,54,61,4,6]),function(ie,e,r,C,S,N,_,A,E,P,O,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class k{constructor(t,l){this.document=t,this._storagePath=l,this._backupCounter=1,this._edits=new O.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,l){await this.getEdit(t).undo(),l||this.disposeBackup()}async redo(t,l){await this.getEdit(t).redo(),l||this.disposeBackup()}disposeEdits(t){for(const l of t)this._edits.delete(l)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=c(this.document.uri)+this._backupCounter++;return(0,_.joinPath)(this._storagePath,t)}updateBackup(t){this._backup?.delete(),this._backup=t}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(t){const l=this._edits.get(t,0);if(!l)throw new Error("No edit found");return l}}class m{constructor(){this._documents=new Map}get(t,l){return this._documents.get(this.key(t,l))}add(t,l,i){const n=this.key(t,l.uri);if(this._documents.has(n))throw new Error(`Document already exists for viewType:${t} resource:${l.uri}`);const o=new k(l,i);return this._documents.set(n,o),o}delete(t,l){const i=this.key(t,l.uri);this._documents.delete(i)}key(t,l){return`${t}@@@${l}`}}var a;(function(b){b[b.Text=0]="Text",b[b.Custom=1]="Custom"})(a||(a={}));class u{constructor(){this._providers=new Map}addTextProvider(t,l,i){return this.add(0,t,l,i)}addCustomProvider(t,l,i){return this.add(1,t,l,i)}get(t){return this._providers.get(t)}add(t,l,i,n){if(this._providers.has(l))throw new Error(`Provider for viewType:${l} already registered`);return this._providers.set(l,{type:t,extension:i,provider:n}),new g.Disposable(()=>this._providers.delete(l))}}class d{constructor(t,l,i,n,o){this._extHostDocuments=l,this._extensionStoragePaths=i,this._extHostWebview=n,this._extHostWebviewPanels=o,this._editorProviders=new u,this._documents=new m,this._proxy=t.getProxy(w.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,l,i,n){const o=new S.DisposableStore;return v(i)?(o.add(this._editorProviders.addTextProvider(l,t,i)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(t),l,n.webviewOptions||{},{supportsMove:!!i.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(t))):(o.add(this._editorProviders.addCustomProvider(l,t,i)),this.supportEditing(i)&&o.add(i.onDidChangeCustomDocument(f=>{const s=this.getCustomDocumentEntry(l,f.document.uri);if(D(f)){const h=s.addEdit(f);this._proxy.$onDidEdit(f.document.uri,l,h,f.label)}else this._proxy.$onContentChange(f.document.uri,l)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(t),l,n.webviewOptions||{},!!n.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(t))),g.Disposable.from(o,new g.Disposable(()=>{this._proxy.$unregisterEditorProvider(l)}))}async $createCustomDocument(t,l,i,n,o){const f=this._editorProviders.get(l);if(!f)throw new Error(`No provider found for '${l}'`);if(f.type!==1)throw new Error(`Invalid provide type for '${l}'`);const s=A.URI.revive(t),h=await f.provider.openCustomDocument(s,{backupId:i,untitledDocumentData:n?.buffer},o);let p;return this.supportEditing(f.provider)&&this._extensionStoragePaths&&(p=this._extensionStoragePaths.workspaceValue(f.extension)??this._extensionStoragePaths.globalValue(f.extension)),this._documents.add(l,h,p),{editable:this.supportEditing(f.provider)}}async $disposeCustomDocument(t,l){const i=this._editorProviders.get(l);if(!i)throw new Error(`No provider found for '${l}'`);if(i.type!==1)throw new Error(`Invalid provider type for '${l}'`);const n=A.URI.revive(t),{document:o}=this.getCustomDocumentEntry(l,n);this._documents.delete(l,o),o.dispose()}async $resolveWebviewEditor(t,l,i,n,o,f){const s=this._editorProviders.get(i);if(!s)throw new Error(`No provider found for '${i}'`);const h=E.ViewColumn.to(o),p=this._extHostWebview.createNewWebview(l,n.webviewOptions,s.extension),T=this._extHostWebviewPanels.createNewWebviewPanel(l,i,n.title,h,n.panelOptions,p,!0),M=A.URI.revive(t);switch(s.type){case 1:{const{document:V}=this.getCustomDocumentEntry(i,M);return s.provider.resolveCustomEditor(V,T,f)}case 0:{const V=this._extHostDocuments.getDocument(M);return s.provider.resolveCustomTextEditor(V,T,f)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,l,i){this.getCustomDocumentEntry(l,t).disposeEdits(i)}async $onMoveCustomEditor(t,l,i){const n=this._editorProviders.get(i);if(!n)throw new Error(`No provider found for '${i}'`);if(!n.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${i}'`);const o=this._extHostWebviewPanels.getWebviewPanel(t);if(!o)throw new Error("No webview found");const f=A.URI.revive(l),s=this._extHostDocuments.getDocument(f);await n.provider.moveCustomTextEditor(s,o,r.CancellationToken.None)}async $undo(t,l,i,n){return this.getCustomDocumentEntry(l,t).undo(i,n)}async $redo(t,l,i,n){return this.getCustomDocumentEntry(l,t).redo(i,n)}async $revert(t,l,i){const n=this.getCustomDocumentEntry(l,t);await this.getCustomEditorProvider(l).revertCustomDocument(n.document,i),n.disposeBackup()}async $onSave(t,l,i){const n=this.getCustomDocumentEntry(l,t);await this.getCustomEditorProvider(l).saveCustomDocument(n.document,i),n.disposeBackup()}async $onSaveAs(t,l,i,n){const o=this.getCustomDocumentEntry(l,t);return this.getCustomEditorProvider(l).saveCustomDocumentAs(o.document,A.URI.revive(i),n)}async $backup(t,l,i){const n=this.getCustomDocumentEntry(l,t),f=await this.getCustomEditorProvider(l).backupCustomDocument(n.document,{destination:n.getNewBackupUri()},i);return n.updateBackup(f),f.id}getCustomDocumentEntry(t,l){const i=this._documents.get(t,A.URI.revive(l));if(!i)throw new Error("No custom document found");return i}getCustomEditorProvider(t){const i=this._editorProviders.get(t)?.provider;if(!i||!this.supportEditing(i))throw new Error("Custom document is not editable");return i}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=d;function v(b){return typeof b.resolveCustomTextEditor=="function"}function D(b){return typeof b.undo=="function"&&typeof b.redo=="function"}function c(b){const t=b.scheme===N.Schemas.file||b.scheme===N.Schemas.untitled?b.fsPath:b.toString();return(0,C.hash)(t)+""}});var Je=this&&this.__classPrivateFieldSet||function(ie,e,r,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ie,r):S?S.value=r:e.set(ie,r),r},Oe=this&&this.__classPrivateFieldGet||function(ie,e,r,C){if(r==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!C:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?C:r==="a"?C.call(ie):C?C.value:e.get(ie)};define(Ce[220],Ie([1,0,5,7,2,43,8,54,4,6]),function(ie,e,r,C,S,N,_,A,E,P){"use strict";var O,w,g,k,m,a,u,d,v,D,c,b,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class l extends C.Disposable{constructor(f,s,h,p){super(),O.set(this,void 0),w.set(this,void 0),g.set(this,void 0),k.set(this,void 0),m.set(this,void 0),a.set(this,void 0),u.set(this,void 0),d.set(this,void 0),v.set(this,!0),D.set(this,void 0),c.set(this,!1),b.set(this,this._register(new r.Emitter)),this.onDidDispose=Oe(this,b,"f").event,t.set(this,this._register(new r.Emitter)),this.onDidChangeViewState=Oe(this,t,"f").event,Je(this,O,f,"f"),Je(this,w,s,"f"),Je(this,k,h,"f"),Je(this,g,p.viewType,"f"),Je(this,m,p.panelOptions,"f"),Je(this,d,p.viewColumn,"f"),Je(this,a,p.title,"f"),Je(this,D,p.active,"f")}dispose(){Oe(this,c,"f")||(Je(this,c,!0,"f"),Oe(this,b,"f").fire(),Oe(this,w,"f").$disposeWebview(Oe(this,O,"f")),Oe(this,k,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Oe(this,k,"f")}get viewType(){return this.assertNotDisposed(),Oe(this,g,"f")}get title(){return this.assertNotDisposed(),Oe(this,a,"f")}set title(f){this.assertNotDisposed(),Oe(this,a,"f")!==f&&(Je(this,a,f,"f"),Oe(this,w,"f").$setTitle(Oe(this,O,"f"),f))}get iconPath(){return this.assertNotDisposed(),Oe(this,u,"f")}set iconPath(f){this.assertNotDisposed(),Oe(this,u,"f")!==f&&(Je(this,u,f,"f"),Oe(this,w,"f").$setIconPath(Oe(this,O,"f"),S.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return Oe(this,m,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Oe(this,d,"f")=="number"&&Oe(this,d,"f")<0))return Oe(this,d,"f")}get active(){return this.assertNotDisposed(),Oe(this,D,"f")}get visible(){return this.assertNotDisposed(),Oe(this,v,"f")}_updateViewState(f){Oe(this,c,"f")||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(Je(this,D,f.active,"f"),Je(this,v,f.visible,"f"),Je(this,d,f.viewColumn,"f"),Oe(this,t,"f").fire({webviewPanel:this}))}reveal(f,s){this.assertNotDisposed(),Oe(this,w,"f").$reveal(Oe(this,O,"f"),{viewColumn:typeof f>"u"?void 0:_.ViewColumn.from(f),preserveFocus:!!s})}assertNotDisposed(){if(Oe(this,c,"f"))throw new Error("Webview is disposed")}}O=new WeakMap,w=new WeakMap,g=new WeakMap,k=new WeakMap,m=new WeakMap,a=new WeakMap,u=new WeakMap,d=new WeakMap,v=new WeakMap,D=new WeakMap,c=new WeakMap,b=new WeakMap,t=new WeakMap;class i{static newHandle(){return(0,N.generateUuid)()}constructor(f,s,h){this.webviews=s,this.workspace=h,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=f.getProxy(E.MainContext.MainThreadWebviewPanels)}createWebviewPanel(f,s,h,p,T={}){const M=typeof p=="object"?p.viewColumn:p,V={viewColumn:_.ViewColumn.from(M),preserveFocus:typeof p=="object"&&!!p.preserveFocus},U=(0,A.shouldSerializeBuffersForPostMessage)(f),y=i.newHandle();this._proxy.$createWebviewPanel((0,A.toExtensionData)(f),y,s,{title:h,panelOptions:n(T),webviewOptions:(0,A.serializeWebviewOptions)(f,this.workspace,T),serializeBuffersForPostMessage:U},V);const x=this.webviews.createNewWebview(y,T,f);return this.createNewWebviewPanel(y,s,h,M,T,x,!0)}$onDidChangeWebviewPanelViewStates(f){const s=Object.keys(f);s.sort((h,p)=>{const T=f[h],M=f[p];return T.active?1:M.active?-1:+T.visible-+M.visible});for(const h of s){const p=this.getWebviewPanel(h);if(!p)continue;const T=f[h];p._updateViewState({active:T.active,visible:T.visible,viewColumn:_.ViewColumn.to(T.position)})}}async $onDidDisposeWebviewPanel(f){this.getWebviewPanel(f)?.dispose(),this._webviewPanels.delete(f),this.webviews.deleteWebview(f)}registerWebviewPanelSerializer(f,s,h){if(this._serializers.has(s))throw new Error(`Serializer for '${s}' already registered`);return this._serializers.set(s,{serializer:h,extension:f}),this._proxy.$registerSerializer(s,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(f)}),new P.Disposable(()=>{this._serializers.delete(s),this._proxy.$unregisterSerializer(s)})}async $deserializeWebviewPanel(f,s,h,p){const T=this._serializers.get(s);if(!T)throw new Error(`No serializer found for '${s}'`);const{serializer:M,extension:V}=T,U=this.webviews.createNewWebview(f,h.webviewOptions,V),y=this.createNewWebviewPanel(f,s,h.title,p,h.panelOptions,U,h.active);await M.deserializeWebviewPanel(y,h.state)}createNewWebviewPanel(f,s,h,p,T,M,V){const U=new l(f,this._proxy,M,{viewType:s,title:h,viewColumn:p,panelOptions:T,active:V});return this._webviewPanels.set(f,U),U}getWebviewPanel(f){return this._webviewPanels.get(f)}}e.ExtHostWebviewPanels=i;function n(o){return{enableFindWidget:o.enableFindWidget,retainContextWhenHidden:o.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(ie,e,r,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ie,r):S?S.value=r:e.set(ie,r),r},Oe=this&&this.__classPrivateFieldGet||function(ie,e,r,C){if(r==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!C:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?C:r==="a"?C.call(ie):C?C.value:e.get(ie)};define(Ce[221],Ie([1,0,5,7,54,8,4,6]),function(ie,e,r,C,S,N,_,A){"use strict";var E,P,O,w,g,k,m,a,u,d,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class D extends C.Disposable{constructor(t,l,i,n,o,f,s){super(),E.set(this,void 0),P.set(this,void 0),O.set(this,void 0),w.set(this,void 0),g.set(this,!1),k.set(this,void 0),m.set(this,void 0),a.set(this,void 0),u.set(this,void 0),d.set(this,this._register(new r.Emitter)),this.onDidChangeVisibility=Oe(this,d,"f").event,v.set(this,this._register(new r.Emitter)),this.onDidDispose=Oe(this,v,"f").event,Je(this,O,i,"f"),Je(this,m,n,"f"),Je(this,E,t,"f"),Je(this,P,l,"f"),Je(this,w,o,"f"),Je(this,k,s,"f")}dispose(){Oe(this,g,"f")||(Je(this,g,!0,"f"),Oe(this,v,"f").fire(),Oe(this,w,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Oe(this,m,"f")}set title(t){this.assertNotDisposed(),Oe(this,m,"f")!==t&&(Je(this,m,t,"f"),Oe(this,P,"f").$setWebviewViewTitle(Oe(this,E,"f"),t))}get description(){return this.assertNotDisposed(),Oe(this,a,"f")}set description(t){this.assertNotDisposed(),Oe(this,a,"f")!==t&&(Je(this,a,t,"f"),Oe(this,P,"f").$setWebviewViewDescription(Oe(this,E,"f"),t))}get visible(){return Oe(this,k,"f")}get webview(){return Oe(this,w,"f")}get viewType(){return Oe(this,O,"f")}_setVisible(t){t===Oe(this,k,"f")||Oe(this,g,"f")||(Je(this,k,t,"f"),Oe(this,d,"f").fire())}get badge(){return this.assertNotDisposed(),Oe(this,u,"f")}set badge(t){this.assertNotDisposed(),!(t?.value===Oe(this,u,"f")?.value&&t?.tooltip===Oe(this,u,"f")?.tooltip)&&(Je(this,u,N.ViewBadge.from(t),"f"),Oe(this,P,"f").$setWebviewViewBadge(Oe(this,E,"f"),t))}show(t){this.assertNotDisposed(),Oe(this,P,"f").$show(Oe(this,E,"f"),!!t)}assertNotDisposed(){if(Oe(this,g,"f"))throw new Error("Webview is disposed")}}E=new WeakMap,P=new WeakMap,O=new WeakMap,w=new WeakMap,g=new WeakMap,k=new WeakMap,m=new WeakMap,a=new WeakMap,u=new WeakMap,d=new WeakMap,v=new WeakMap;class c{constructor(t,l){this._extHostWebview=l,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=t.getProxy(_.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(t,l,i,n){if(this._viewProviders.has(l))throw new Error(`View provider for '${l}' already registered`);return this._viewProviders.set(l,{provider:i,extension:t}),this._proxy.$registerWebviewViewProvider((0,S.toExtensionData)(t),l,{retainContextWhenHidden:n?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,S.shouldSerializeBuffersForPostMessage)(t)}),new A.Disposable(()=>{this._viewProviders.delete(l),this._proxy.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(t,l,i,n,o){const f=this._viewProviders.get(l);if(!f)throw new Error(`No view provider found for '${l}'`);const{provider:s,extension:h}=f,p=this._extHostWebview.createNewWebview(t,{},h),T=new D(t,this._proxy,l,i,p,h,!0);this._webviewViews.set(t,T),await s.resolveWebviewView(T,{state:n},o)}async $onDidChangeWebviewViewVisibility(t,l){this.getWebviewView(t)._setVisible(l)}async $disposeWebviewView(t){const l=this.getWebviewView(t);this._webviewViews.delete(t),l.dispose(),this._extHostWebview.deleteWebview(t)}getWebviewView(t){const l=this._webviewViews.get(t);if(!l)throw new Error("No webview found");return l}}e.ExtHostWebviewViews=c}),define(Ce[99],Ie([1,0,5,4,2,13,9,3,11]),function(ie,e,r,C,S,N,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class tn{get state(){return this._state}constructor(w){this._onDidChangeWindowState=new r.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=tn.InitialState,this._proxy=w.getProxy(C.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(g=>this.$onDidChangeWindowFocus(g))}$onDidChangeWindowFocus(w){w!==this._state.focused&&(this._state={...this._state,focused:w},this._onDidChangeWindowState.fire(this._state))}openUri(w,g){let k;if(typeof w=="string"){k=w;try{w=S.URI.parse(w)}catch{return Promise.reject(`Invalid uri - '${w}'`)}}return(0,_.isFalsyOrWhitespace)(w.scheme)?Promise.reject("Invalid scheme - cannot be empty"):w.scheme===N.Schemas.command?Promise.reject(`Invalid scheme '${w.scheme}'`):this._proxy.$openUri(w,k,g)}async asExternalUri(w,g){if((0,_.isFalsyOrWhitespace)(w.scheme))return Promise.reject("Invalid scheme - cannot be empty");const k=await this._proxy.$asExternalUri(w,g);return S.URI.from(k)}};P.InitialState={focused:!0},P=ze([$e(0,E.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(Ce[222],Ie([1,0,192,27,11]),function(ie,e,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let N=class extends r.AbstractExtHostConsoleForwarder{constructor(A,E){super(A,E)}_nativeConsoleLogMessage(A,E,P){E.apply(console,P)}};N=ze([$e(0,S.IExtHostRpcService),$e(1,C.IExtHostInitDataService)],N),e.ExtHostConsoleForwarder=N}),define(Ce[223],Ie([1,0,15,23,20,12,5,7,119,186,41]),function(ie,e,r,C,S,N,_,A,E,P,O){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function g(T,M){try{return JSON.stringify(T,M)}catch{return"null"}}const k="$$ref$$",m={[k]:-1};class a{constructor(M,V){this.jsonString=M,this.referencedBuffers=V}}function u(T,M=null,V=!1){const U=[];return{jsonString:(V?g:JSON.stringify)(T,(x,L)=>{if(typeof L>"u")return m;if(typeof L=="object"){if(L instanceof C.VSBuffer){const R=U.push(L)-1;return{[k]:R}}if(M)return M(x,L)}return L}),referencedBuffers:U}}e.stringifyJsonWithBufferRefs=u;function d(T,M,V){return JSON.parse(T,(U,y)=>{if(y){const x=y[k];if(typeof x=="number")return M[x];if(V&&y.$mid===1)return V.transformIncoming(y)}return y})}e.parseJsonAndRestoreBufferRefs=d;function v(T,M){return JSON.stringify(T,M)}function D(T){return T?(M,V)=>V&&V.$mid===1?T.transformOutgoing(V):V:null}var c;(function(T){T[T.LocalSide=0]="LocalSide",T[T.OtherSide=1]="OtherSide"})(c=e.RequestInitiator||(e.RequestInitiator={}));var b;(function(T){T[T.Responsive=0]="Responsive",T[T.Unresponsive=1]="Unresponsive"})(b=e.ResponsiveState||(e.ResponsiveState={}));const t=()=>{},l=Symbol.for("rpcProtocol"),i=Symbol.for("rpcProxy");class n extends A.Disposable{constructor(M,V=null,U=null){super(),this[w]=!0,this._onDidChangeResponsiveState=this._register(new _.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=M,this._logger=V,this._uriTransformer=U,this._uriReplacer=D(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let y=0,x=O.ProxyIdentifier.count;y<x;y++)this._locals[y]=null,this._proxies[y]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new r.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(y=>this._receiveOneMessage(y))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(M=>{this._pendingRPCReplies[M].resolveErr(N.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(M){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+n.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(M){this._unresponsiveTime=Date.now()+n.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(M){this._responsiveState!==M&&(this._responsiveState=M,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(M){return this._uriTransformer?(0,E.transformIncomingURIs)(M,this._uriTransformer):M}getProxy(M){const{nid:V,sid:U}=M;return this._proxies[V]||(this._proxies[V]=this._createProxy(V,U)),this._proxies[V]}_createProxy(M,V){const U={get:(y,x)=>(typeof x=="string"&&!y[x]&&x.charCodeAt(0)===36&&(y[x]=(...L)=>this._remoteCall(M,x,L)),x===i?V:y[x])};return new Proxy(Object.create(null),U)}set(M,V){return this._locals[M.nid]=V,V}assertRegistered(M){for(let V=0,U=M.length;V<U;V++){const y=M[V];if(!this._locals[y.nid])throw new Error(`Missing proxy instance ${y.sid}`)}}_receiveOneMessage(M){if(this._isDisposed)return;const V=M.byteLength,U=o.read(M,0),y=U.readUInt8(),x=U.readUInt32();switch(y){case 1:case 2:{let{rpcId:L,method:R,args:K}=s.deserializeRequestJSONArgs(U);this._uriTransformer&&(K=(0,E.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest(V,x,L,R,K,y===2);break}case 3:case 4:{let{rpcId:L,method:R,args:K}=s.deserializeRequestMixedArgs(U);this._uriTransformer&&(K=(0,E.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest(V,x,L,R,K,y===4);break}case 5:{this._logger?.logIncoming(V,x,0,"ack"),this._onDidReceiveAcknowledge(x);break}case 6:{this._receiveCancel(V,x);break}case 7:{this._receiveReply(V,x,void 0);break}case 9:{let L=s.deserializeReplyOKJSON(U);this._uriTransformer&&(L=(0,E.transformIncomingURIs)(L,this._uriTransformer)),this._receiveReply(V,x,L);break}case 10:{const L=s.deserializeReplyOKJSONWithBuffers(U,this._uriTransformer);this._receiveReply(V,x,L);break}case 8:{const L=s.deserializeReplyOKVSBuffer(U);this._receiveReply(V,x,L);break}case 11:{let L=s.deserializeReplyErrError(U);this._uriTransformer&&(L=(0,E.transformIncomingURIs)(L,this._uriTransformer)),this._receiveReplyErr(V,x,L);break}case 12:{this._receiveReplyErr(V,x,void 0);break}default:console.error("received unexpected message"),console.error(M)}}_receiveRequest(M,V,U,y,x,L){this._logger?.logIncoming(M,V,1,`receiveRequest ${(0,O.getStringIdentifierForProxy)(U)}.${y}(`,x);const R=String(V);let K,W;if(L){const G=new S.CancellationTokenSource;x.push(G.token),K=this._invokeHandler(U,y,x),W=()=>G.cancel()}else K=this._invokeHandler(U,y,x),W=t;this._cancelInvokedHandlers[R]=W;const $=s.serializeAcknowledged(V);this._logger?.logOutgoing($.byteLength,V,1,"ack"),this._protocol.send($),K.then(G=>{delete this._cancelInvokedHandlers[R];const re=s.serializeReplyOK(V,G,this._uriReplacer);this._logger?.logOutgoing(re.byteLength,V,1,"reply:",G),this._protocol.send(re)},G=>{delete this._cancelInvokedHandlers[R];const re=s.serializeReplyErr(V,G);this._logger?.logOutgoing(re.byteLength,V,1,"replyErr:",G),this._protocol.send(re)})}_receiveCancel(M,V){this._logger?.logIncoming(M,V,1,"receiveCancel");const U=String(V);this._cancelInvokedHandlers[U]?.()}_receiveReply(M,V,U){this._logger?.logIncoming(M,V,0,"receiveReply:",U);const y=String(V);if(!this._pendingRPCReplies.hasOwnProperty(y))return;const x=this._pendingRPCReplies[y];delete this._pendingRPCReplies[y],x.resolveOk(U)}_receiveReplyErr(M,V,U){this._logger?.logIncoming(M,V,0,"receiveReplyErr:",U);const y=String(V);if(!this._pendingRPCReplies.hasOwnProperty(y))return;const x=this._pendingRPCReplies[y];delete this._pendingRPCReplies[y];let L;U&&(U.$isError?(L=new Error,L.name=U.name,L.message=U.message,L.stack=U.stack):L=U),x.resolveErr(L)}_invokeHandler(M,V,U){try{return Promise.resolve(this._doInvokeHandler(M,V,U))}catch(y){return Promise.reject(y)}}_doInvokeHandler(M,V,U){const y=this._locals[M];if(!y)throw new Error("Unknown actor "+(0,O.getStringIdentifierForProxy)(M));const x=y[V];if(typeof x!="function")throw new Error("Unknown method "+V+" on actor "+(0,O.getStringIdentifierForProxy)(M));return x.apply(y,U)}_remoteCall(M,V,U){if(this._isDisposed)return new P.CanceledLazyPromise;let y=null;if(U.length>0&&S.CancellationToken.isCancellationToken(U[U.length-1])&&(y=U.pop()),y&&y.isCancellationRequested)return Promise.reject(N.canceled());const x=s.serializeRequestArguments(U,this._uriReplacer),L=++this._lastMessageId,R=String(L),K=new P.LazyPromise;y&&y.onCancellationRequested(()=>{const $=s.serializeCancel(L);this._logger?.logOutgoing($.byteLength,L,0,"cancel"),this._protocol.send(s.serializeCancel(L))}),this._pendingRPCReplies[R]=K,this._onWillSendRequest(L);const W=s.serializeRequest(L,M,V,x,!!y);return this._logger?.logOutgoing(W.byteLength,L,0,`request: ${(0,O.getStringIdentifierForProxy)(M)}.${V}(`,U),this._protocol.send(W),K}}e.RPCProtocol=n,w=l,n.UNRESPONSIVE_TIME=3*1e3;class o{static alloc(M,V,U){const y=new o(C.VSBuffer.alloc(U+1+4),0);return y.writeUInt8(M),y.writeUInt32(V),y}static read(M,V){return new o(M,V)}get buffer(){return this._buff}constructor(M,V){this._buff=M,this._offset=V}static sizeUInt8(){return 1}writeUInt8(M){this._buff.writeUInt8(M,this._offset),this._offset+=1}readUInt8(){const M=this._buff.readUInt8(this._offset);return this._offset+=1,M}writeUInt32(M){this._buff.writeUInt32BE(M,this._offset),this._offset+=4}readUInt32(){const M=this._buff.readUInt32BE(this._offset);return this._offset+=4,M}static sizeShortString(M){return 1+M.byteLength}writeShortString(M){this._buff.writeUInt8(M.byteLength,this._offset),this._offset+=1,this._buff.set(M,this._offset),this._offset+=M.byteLength}readShortString(){const M=this._buff.readUInt8(this._offset);this._offset+=1;const U=this._buff.slice(this._offset,this._offset+M).toString();return this._offset+=M,U}static sizeLongString(M){return 4+M.byteLength}writeLongString(M){this._buff.writeUInt32BE(M.byteLength,this._offset),this._offset+=4,this._buff.set(M,this._offset),this._offset+=M.byteLength}readLongString(){const M=this._buff.readUInt32BE(this._offset);this._offset+=4;const U=this._buff.slice(this._offset,this._offset+M).toString();return this._offset+=M,U}writeBuffer(M){this._buff.writeUInt32BE(M.byteLength,this._offset),this._offset+=4,this._buff.set(M,this._offset),this._offset+=M.byteLength}static sizeVSBuffer(M){return 4+M.byteLength}writeVSBuffer(M){this._buff.writeUInt32BE(M.byteLength,this._offset),this._offset+=4,this._buff.set(M,this._offset),this._offset+=M.byteLength}readVSBuffer(){const M=this._buff.readUInt32BE(this._offset);this._offset+=4;const V=this._buff.slice(this._offset,this._offset+M);return this._offset+=M,V}static sizeMixedArray(M){let V=0;V+=1;for(let U=0,y=M.length;U<y;U++){const x=M[U];switch(V+=1,x.type){case 1:V+=this.sizeLongString(x.value);break;case 2:V+=this.sizeVSBuffer(x.value);break;case 3:V+=this.sizeUInt32,V+=this.sizeLongString(x.value);for(let L=0;L<x.buffers.length;++L)V+=this.sizeVSBuffer(x.buffers[L]);break;case 4:break}}return V}writeMixedArray(M){this._buff.writeUInt8(M.length,this._offset),this._offset+=1;for(let V=0,U=M.length;V<U;V++){const y=M[V];switch(y.type){case 1:this.writeUInt8(1),this.writeLongString(y.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(y.value);break;case 3:this.writeUInt8(3),this.writeUInt32(y.buffers.length),this.writeLongString(y.value);for(let x=0;x<y.buffers.length;++x)this.writeBuffer(y.buffers[x]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const M=this._buff.readUInt8(this._offset);this._offset+=1;const V=new Array(M);for(let U=0;U<M;U++)switch(this.readUInt8()){case 1:V[U]=this.readLongString();break;case 2:V[U]=this.readVSBuffer();break;case 3:{const x=this.readUInt32(),L=this.readLongString(),R=[];for(let K=0;K<x;++K)R.push(this.readVSBuffer());V[U]=new O.SerializableObjectWithBuffers(d(L,R,null));break}case 4:V[U]=void 0;break}return V}}o.sizeUInt32=4;var f;(function(T){T[T.Simple=0]="Simple",T[T.Mixed=1]="Mixed"})(f||(f={}));class s{static _useMixedArgSerialization(M){for(let V=0,U=M.length;V<U;V++)if(M[V]instanceof C.VSBuffer||M[V]instanceof O.SerializableObjectWithBuffers||typeof M[V]>"u")return!0;return!1}static serializeRequestArguments(M,V){if(this._useMixedArgSerialization(M)){const U=[];for(let y=0,x=M.length;y<x;y++){const L=M[y];if(L instanceof C.VSBuffer)U[y]={type:2,value:L};else if(typeof L>"u")U[y]={type:4};else if(L instanceof O.SerializableObjectWithBuffers){const{jsonString:R,referencedBuffers:K}=u(L.value,V);U[y]={type:3,value:C.VSBuffer.fromString(R),buffers:K}}else U[y]={type:1,value:C.VSBuffer.fromString(v(L,V))}}return{type:1,args:U}}return{type:0,args:v(M,V)}}static serializeRequest(M,V,U,y,x){switch(y.type){case 0:return this._requestJSONArgs(M,V,U,y.args,x);case 1:return this._requestMixedArgs(M,V,U,y.args,x)}}static _requestJSONArgs(M,V,U,y,x){const L=C.VSBuffer.fromString(U),R=C.VSBuffer.fromString(y);let K=0;K+=o.sizeUInt8(),K+=o.sizeShortString(L),K+=o.sizeLongString(R);const W=o.alloc(x?2:1,M,K);return W.writeUInt8(V),W.writeShortString(L),W.writeLongString(R),W.buffer}static deserializeRequestJSONArgs(M){const V=M.readUInt8(),U=M.readShortString(),y=M.readLongString();return{rpcId:V,method:U,args:JSON.parse(y)}}static _requestMixedArgs(M,V,U,y,x){const L=C.VSBuffer.fromString(U);let R=0;R+=o.sizeUInt8(),R+=o.sizeShortString(L),R+=o.sizeMixedArray(y);const K=o.alloc(x?4:3,M,R);return K.writeUInt8(V),K.writeShortString(L),K.writeMixedArray(y),K.buffer}static deserializeRequestMixedArgs(M){const V=M.readUInt8(),U=M.readShortString(),y=M.readMixedArray(),x=new Array(y.length);for(let L=0,R=y.length;L<R;L++){const K=y[L];typeof K=="string"?x[L]=JSON.parse(K):x[L]=K}return{rpcId:V,method:U,args:x}}static serializeAcknowledged(M){return o.alloc(5,M,0).buffer}static serializeCancel(M){return o.alloc(6,M,0).buffer}static serializeReplyOK(M,V,U){if(typeof V>"u")return this._serializeReplyOKEmpty(M);if(V instanceof C.VSBuffer)return this._serializeReplyOKVSBuffer(M,V);if(V instanceof O.SerializableObjectWithBuffers){const{jsonString:y,referencedBuffers:x}=u(V.value,U,!0);return this._serializeReplyOKJSONWithBuffers(M,y,x)}else return this._serializeReplyOKJSON(M,g(V,U))}static _serializeReplyOKEmpty(M){return o.alloc(7,M,0).buffer}static _serializeReplyOKVSBuffer(M,V){let U=0;U+=o.sizeVSBuffer(V);const y=o.alloc(8,M,U);return y.writeVSBuffer(V),y.buffer}static deserializeReplyOKVSBuffer(M){return M.readVSBuffer()}static _serializeReplyOKJSON(M,V){const U=C.VSBuffer.fromString(V);let y=0;y+=o.sizeLongString(U);const x=o.alloc(9,M,y);return x.writeLongString(U),x.buffer}static _serializeReplyOKJSONWithBuffers(M,V,U){const y=C.VSBuffer.fromString(V);let x=0;x+=o.sizeUInt32,x+=o.sizeLongString(y);for(const R of U)x+=o.sizeVSBuffer(R);const L=o.alloc(10,M,x);L.writeUInt32(U.length),L.writeLongString(y);for(const R of U)L.writeBuffer(R);return L.buffer}static deserializeReplyOKJSON(M){const V=M.readLongString();return JSON.parse(V)}static deserializeReplyOKJSONWithBuffers(M,V){const U=M.readUInt32(),y=M.readLongString(),x=[];for(let L=0;L<U;++L)x.push(M.readVSBuffer());return new O.SerializableObjectWithBuffers(d(y,x,V))}static serializeReplyErr(M,V){const U=V?g(N.transformErrorForSerialization(V),null):void 0;if(typeof U!="string")return this._serializeReplyErrEmpty(M);const y=C.VSBuffer.fromString(U);let x=0;x+=o.sizeLongString(y);const L=o.alloc(11,M,x);return L.writeLongString(y),L.buffer}static deserializeReplyErrError(M){const V=M.readLongString();return JSON.parse(V)}static _serializeReplyErrEmpty(M){return o.alloc(12,M,0).buffer}}var h;(function(T){T[T.RequestJSONArgs=1]="RequestJSONArgs",T[T.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",T[T.RequestMixedArgs=3]="RequestMixedArgs",T[T.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",T[T.Acknowledged=5]="Acknowledged",T[T.Cancel=6]="Cancel",T[T.ReplyOKEmpty=7]="ReplyOKEmpty",T[T.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",T[T.ReplyOKJSON=9]="ReplyOKJSON",T[T.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",T[T.ReplyErrError=11]="ReplyErrError",T[T.ReplyErrEmpty=12]="ReplyErrEmpty"})(h||(h={}));var p;(function(T){T[T.String=1]="String",T[T.VSBuffer=2]="VSBuffer",T[T.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",T[T.Undefined=4]="Undefined"})(p||(p={}))}),define(Ce[224],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const r=function(N){const _=A=>{self.removeEventListener("message",_);const E=A.data;Object.defineProperties(self,{postMessage:{value(P,O){E.postMessage(P,O)}},onmessage:{get(){return E.onmessage},set(P){E.onmessage=P}}}),E.addEventListener("message",P=>{self.dispatchEvent(new MessageEvent("message",{data:P.data}))}),E.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(N)};self.addEventListener("message",_)}.toString();class C extends EventTarget{constructor(N,_,A){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const E=`((${r})('${_}'))`,P=new Blob([E],{type:"application/javascript"}),O=URL.createObjectURL(P),w=new MessageChannel,g=O,k={type:"_newWorker",id:g,port:w.port2,url:O,options:A};N(k,[w.port2]),this.postMessage=w.port1.postMessage.bind(w.port1),this.terminate=()=>{N({type:"_terminateWorker",id:g}),URL.revokeObjectURL(O),w.port1.close(),w.port2.close()},Object.defineProperties(this,{onmessage:{get(){return w.port1.onmessage},set(m){w.port1.onmessage=m}},onmessageerror:{get(){return w.port1.onmessageerror},set(m){w.port1.onmessageerror=m}}}),w.port1.addEventListener("messageerror",m=>{const a=new MessageEvent("messageerror",{data:m.data});this.dispatchEvent(a)}),w.port1.addEventListener("message",m=>{const a=new MessageEvent("message",{data:m.data});this.dispatchEvent(a)}),w.port1.start()}}e.NestedWorker=C}),define(Ce[225],Ie([1,0,5,30,39,3,35,12,15]),function(ie,e,r,C,S,N,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new S.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new S.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new S.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,N.createDecorator)(e.OUTPUT_SERVICE_ID);var P;(function(k){k[k.Append=1]="Append",k[k.Replace=2]="Replace",k[k.Clear=3]="Clear"})(P=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class O{constructor(){this.channels=new Map,this._onDidRegisterChannel=new r.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new r.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(m){this.channels.has(m.id)||(this.channels.set(m.id,m),this._onDidRegisterChannel.fire(m.id))}getChannels(){const m=[];return this.channels.forEach(a=>m.push(a)),m}getChannel(m){return this.channels.get(m)}removeChannel(m){this.channels.delete(m),this._onDidRemoveChannel.fire(m)}}C.Registry.add(e.Extensions.OutputChannels,new O);function w(k,m,a,u,d){return(0,E.createCancelablePromise)(async v=>{await(0,_.whenProviderRegistered)(a,u);const D=C.Registry.as(e.Extensions.OutputChannels);try{await g(a,1,u,d,v),D.registerChannel({id:k,label:m,file:a,log:!0})}catch(c){(0,A.isCancellationError)(c)||d.error("Error while registering log channel",a.toString(),(0,A.getErrorMessage)(c))}})}e.registerLogChannel=w;async function g(k,m,a,u,d){if(!await a.exists(k)){if(d.isCancellationRequested)throw new A.CancellationError;if(m>10)throw new Error("Timed out while waiting for file to be created");u.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",k.toString()),await(0,E.timeout)(1e3,d),await g(k,m+1,a,u,d)}}}),define(Ce[100],Ie([1,0,4,3,11,14,225,52,27,36,113,23,10,35]),function(ie,e,r,C,S,N,_,A,E,P,O,w,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class m extends N.AbstractMessageLogger{get disposed(){return this._disposed}constructor(v,D,c,b,t){super(),this.id=v,this.name=D,this.logger=c,this.proxy=b,this.extension=t,this.offset=0,this._disposed=!1,this.visible=!1,this._register(c.onDidChangeLogLevel(l=>this.setLevel(l)))}appendLine(v){this.append(v+`
`)}append(v){this.info(v),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,_.OutputChannelUpdateMode.Append))}clear(){const v=this.offset;this.logger.flush(),this.proxy.$update(this.id,_.OutputChannelUpdateMode.Clear,v)}replace(v){const D=this.offset;this.info(v),this.proxy.$update(this.id,_.OutputChannelUpdateMode.Replace,D),this.visible&&this.logger.flush()}show(v,D){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof v=="boolean"?v:D))}hide(){this.proxy.$close(this.id)}log(v,D){this.offset+=w.VSBuffer.fromString(D).byteLength,(0,N.log)(this.logger,v,D)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class a extends m{appendLine(v){this.append(v)}}let u=class{constructor(v,D,c,b,t){this.initData=D,this.extHostFileSystem=c,this.extHostFileSystemInfo=b,this.loggerService=t,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=v.getProxy(r.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(D.logsLocation,`output_logging_${(0,O.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(v){this.visibleChannelId=v;for(const[D,c]of this.channels)c.visible=D===this.visibleChannelId}createOutputChannel(v,D,c){if(v=v.trim(),!v)throw new Error("illegal argument `name`. must not be falsy");const b=typeof D=="object"&&D.log,t=(0,g.isString)(D)?D:void 0;if((0,g.isString)(t)&&!t.trim())throw new Error("illegal argument `languageId`. must not be empty");const l=b?this.doCreateLogOutputChannel(v,c):this.doCreateOutputChannel(v,t,c);return l.then(i=>{this.channels.set(i.id,i),i.visible=i.id===this.visibleChannelId}),b?this.createExtHostLogOutputChannel(v,l):this.createExtHostOutputChannel(v,l)}async doCreateOutputChannel(v,D,c){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const b=await this.outputDirectoryPromise,t=this.extHostFileSystemInfo.extUri.joinPath(b,`${this.namePool++}-${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),l=this.loggerService.createLogger(t,{always:!0,donotRotate:!0,donotUseFormatters:!0}),i=await this.proxy.$register(v,t,!1,D,c.identifier.value);return new m(i,v,l,this.proxy,c)}async doCreateLogOutputChannel(v,D){const c=await this.createExtensionLogDirectory(D),b=this.extHostFileSystemInfo.extUri.joinPath(c,`${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),t=this.loggerService.createLogger(b,{name:v}),l=await this.proxy.$register(v,b,!0,void 0,D.identifier.value);return new a(l,v,t,this.proxy,D)}createExtensionLogDirectory(v){let D=this.extensionLogDirectoryPromise.get(v.identifier.value);if(!D){const c=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,v.identifier.value);this.extensionLogDirectoryPromise.set(v.identifier.value,D=(async()=>{try{await this.extHostFileSystem.value.createDirectory(c)}catch(b){if((0,k.toFileSystemProviderErrorCode)(b)!==k.FileSystemProviderErrorCode.FileExists)throw b}return c})())}return D}createExtHostOutputChannel(v,D){let c=!1;const b=()=>{if(c)throw new Error("Channel has been closed")};return{get name(){return v},append(t){b(),D.then(l=>l.append(t))},appendLine(t){b(),D.then(l=>l.appendLine(t))},clear(){b(),D.then(t=>t.clear())},replace(t){b(),D.then(l=>l.replace(t))},show(t,l){b(),D.then(i=>i.show(t,l))},hide(){b(),D.then(t=>t.hide())},dispose(){c=!0,D.then(t=>t.dispose())}}}createExtHostLogOutputChannel(v,D){let c=!1;const b=()=>{if(c)throw new Error("Channel has been closed")};return{...this.createExtHostOutputChannel(v,D),trace(t,...l){b(),D.then(i=>i.trace(t,...l))},debug(t,...l){b(),D.then(i=>i.debug(t,...l))},info(t,...l){b(),D.then(i=>i.info(t,...l))},warn(t,...l){b(),D.then(i=>i.warn(t,...l))},error(t,...l){b(),D.then(i=>i.error(t,...l))},dispose(){c=!0,D.then(t=>t.dispose())}}}};u=ze([$e(0,S.IExtHostRpcService),$e(1,E.IExtHostInitDataService),$e(2,A.IExtHostConsumerFileSystem),$e(3,P.IExtHostFileSystemInfo),$e(4,N.ILoggerService)],u),e.ExtHostOutputService=u,e.IExtHostOutputService=(0,C.createDecorator)("IExtHostOutputService")}),define(Ce[226],Ie([1,0,3]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,r.createDecorator)("remoteAgentService")}),define(Ce[227],Ie([1,0,38,13,19,21,22,2,3,157,46,172,226]),function(ie,e,r,C,S,N,_,A,E,P,O,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,E.createDecorator)("pathService");let k=class nn{constructor(a,u,d,v){this.localUserHome=a,this.remoteAgentService=u,this.environmentService=d,this.contextService=v,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||N.OS)(),this.resolveUserHome=(async()=>{const D=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=D?.userHome??a})()}hasValidBasename(a,u,d){return typeof u=="string"||typeof u>"u"?this.resolveOS.then(v=>this.doHasValidBasename(a,v,u)):this.doHasValidBasename(a,u,d)}doHasValidBasename(a,u,d){return a.scheme===C.Schemas.file||a.scheme===C.Schemas.vscodeRemote?(0,r.isValidBasename)(d??(0,_.basename)(a),u===1):!0}get defaultUriScheme(){return nn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(a,u){if(a.remoteAuthority)return C.Schemas.vscodeRemote;const d=(0,P.getVirtualWorkspaceScheme)(u.getWorkspace());if(d)return d;const v=u.getWorkspace().folders[0];if(v)return v.uri.scheme;const D=u.getWorkspace().configuration;return D?D.scheme:C.Schemas.file}userHome(a){return a?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(a=>a===1?S.win32:S.posix)}async fileURI(a){let u="";if(await this.resolveOS===1&&(a=a.replace(/\\/g,"/")),a[0]==="/"&&a[1]==="/"){const v=a.indexOf("/",2);v===-1?(u=a.substring(2),a="/"):(u=a.substring(2,v),a=a.substring(v)||"/")}return A.URI.from({scheme:C.Schemas.file,authority:u,path:a,query:"",fragment:""})}};k=ze([$e(1,g.IRemoteAgentService),$e(2,w.IWorkbenchEnvironmentService),$e(3,O.IWorkspaceContextService)],k),e.AbstractPathService=k}),define(Ce[101],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class r{constructor(_,A){this.line=_,this.character=A}isBefore(_){return!1}isBeforeOrEqual(_){return!1}isAfter(_){return!1}isAfterOrEqual(_){return!1}isEqual(_){return!1}compareTo(_){return 0}translate(_,A){return new r(0,0)}with(_){return new r(0,0)}}e.Position=r;class C{constructor(_,A,E,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new r(_,A),this.end=new r(E,P)}contains(_){return!1}isEqual(_){return!1}intersection(_){}union(_){return new C(0,0,0,0)}with(_){return new C(0,0,0,0)}}e.Range=C;var S;(function(N){N[N.Information=1]="Information",N[N.Warning=2]="Warning"})(S=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ce[42],Ie([1,0,18,34,25,38,9,3,19,12,101,15]),function(ie,e,r,C,S,N,_,A,E,P,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return O.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const g="\u27EA ",k=" characters skipped \u27EB",m=(g.length+k.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var a;(function(oe){oe[oe.file=0]="file",oe[oe.text=1]="text"})(a=e.SearchProviderType||(e.SearchProviderType={}));var u;(function(oe){oe[oe.File=1]="File",oe[oe.Text=2]="Text"})(u=e.QueryType||(e.QueryType={}));function d(oe){return!!oe.preview}e.resultIsMatch=d;function v(oe){return!!oe.resource}e.isFileMatch=v;function D(oe){return!!oe.message}e.isProgressMessage=D;var c;(function(oe){oe[oe.Normal=0]="Normal",oe[oe.NewSearchStarted=1]="NewSearchStarted"})(c=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class b{constructor(Ee){this.resource=Ee,this.results=[]}}e.FileMatch=b;class t{constructor(Ee,ce,me){this.ranges=ce;const ee=Array.isArray(ce)?ce:[ce];if(me&&me.matchLines===1&&l(ee)){Ee=(0,_.getNLines)(Ee,me.matchLines);let be="",_e=0,Fe=0;const Be=Math.floor(me.charsPerLine/5),Xe=[];for(const ke of ee){const ye=Math.max(ke.startColumn-Be,0),De=ke.startColumn+me.charsPerLine;if(ye>Fe+Be+m){const ae=g+(ye-Fe)+k;be+=ae+Ee.slice(ye,De),_e+=ye-(Fe+ae.length)}else be+=Ee.slice(Fe,De);Xe.push(new n(0,ke.startColumn-_e,ke.endColumn-_e)),Fe=De}this.preview={text:be,matches:Array.isArray(this.ranges)?Xe:Xe[0]}}else{const be=Array.isArray(ce)?ce[0].startLineNumber:ce.startLineNumber;this.preview={text:Ee,matches:(0,r.mapArrayOrNot)(ce,_e=>new i(_e.startLineNumber-be,_e.startColumn,_e.endLineNumber-be,_e.endColumn))}}}}e.TextSearchMatch=t;function l(oe){const Ee=oe[0].startLineNumber;for(const ce of oe)if(ce.startLineNumber!==Ee||ce.endLineNumber!==Ee)return!1;return!0}class i{constructor(Ee,ce,me,ee){this.startLineNumber=Ee,this.startColumn=ce,this.endLineNumber=me,this.endColumn=ee}}e.SearchRange=i;class n extends i{constructor(Ee,ce,me){super(Ee,ce,Ee,me)}}e.OneLineRange=n;var o;(function(oe){oe.List="list",oe.Tree="tree"})(o=e.ViewMode||(e.ViewMode={}));var f;(function(oe){oe.Default="default",oe.FileNames="fileNames",oe.Type="type",oe.Modified="modified",oe.CountDescending="countDescending",oe.CountAscending="countAscending"})(f=e.SearchSortOrder||(e.SearchSortOrder={}));function s(oe,Ee=!0){const ce=oe&&oe.files&&oe.files.exclude,me=Ee&&oe&&oe.search&&oe.search.exclude;if(!ce&&!me)return;if(!ce||!me)return ce||me;let ee=Object.create(null);return ee=S.mixin(ee,S.deepClone(ce)),ee=S.mixin(ee,S.deepClone(me),!0),ee}e.getExcludes=s;function h(oe,Ee){return oe.excludePattern&&C.match(oe.excludePattern,Ee)?!1:oe.includePattern||oe.usingSearchPaths?oe.includePattern&&C.match(oe.includePattern,Ee)?!0:oe.usingSearchPaths?!!oe.folderQueries&&oe.folderQueries.some(ce=>{const me=ce.folder.fsPath;if(N.isEqualOrParent(Ee,me)){const ee=E.relative(me,Ee);return!ce.includePattern||!!C.match(ce.includePattern,ee)}else return!1}):!1:!0}e.pathIncludedInQuery=h;var p;(function(oe){oe[oe.unknownEncoding=1]="unknownEncoding",oe[oe.regexParseError=2]="regexParseError",oe[oe.globParseError=3]="globParseError",oe[oe.invalidLiteral=4]="invalidLiteral",oe[oe.rgProcessError=5]="rgProcessError",oe[oe.other=6]="other",oe[oe.canceled=7]="canceled"})(p=e.SearchErrorCode||(e.SearchErrorCode={}));class T extends Error{constructor(Ee,ce){super(Ee),this.code=ce}}e.SearchError=T;function M(oe){const Ee=oe.message;if((0,P.isCancellationError)(oe))return new T(Ee,p.canceled);try{const ce=JSON.parse(Ee);return new T(ce.message,ce.code)}catch{return new T(Ee,p.other)}}e.deserializeSearchError=M;function V(oe){const Ee={message:oe.message,code:oe.code};return new Error(JSON.stringify(Ee))}e.serializeSearchError=V;function U(oe){return oe.type==="error"?!0:oe.type==="success"}e.isSerializedSearchComplete=U;function y(oe){return oe.type==="success"}e.isSerializedSearchSuccess=y;function x(oe){return!!oe.path}e.isSerializedFileMatch=x;function L(oe,Ee){const ce=oe.searchPath?oe.searchPath:oe.relativePath;return(0,_.fuzzyContains)(ce,Ee)}e.isFilePatternMatch=L;class R{constructor(Ee){this.path=Ee,this.results=[]}addMatch(Ee){this.results.push(Ee)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=R;function K(oe,Ee){const ce={...oe||{},...Ee||{}};return Object.keys(ce).filter(me=>{const ee=ce[me];return typeof ee=="boolean"&&ee})}e.resolvePatternsForProvider=K;class W{constructor(Ee,ce){this._parsedIncludeExpression=null,this._excludeExpression={...Ee.excludePattern||{},...ce.excludePattern||{}},this._parsedExcludeExpression=C.parse(this._excludeExpression);let me=Ee.includePattern;ce.includePattern&&(me?me={...me,...ce.includePattern}:me=ce.includePattern),me&&(this._parsedIncludeExpression=C.parse(me))}matchesExcludesSync(Ee,ce,me){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(Ee,ce,me))}includedInQuerySync(Ee,ce,me){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(Ee,ce,me)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(Ee,ce,me))}includedInQuery(Ee,ce,me){const ee=this._parsedExcludeExpression(Ee,ce,me),be=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(Ee,ce,me):!0;return(0,w.isThenable)(ee)?ee.then(_e=>_e?!1:be()):be()}hasSiblingExcludeClauses(){return $(this._excludeExpression)}}e.QueryGlobTester=W;function $(oe){for(const Ee in oe)if(typeof oe[Ee]!="boolean")return!0;return!1}function G(oe){if(!oe)return;let Ee;return ce=>(Ee||(Ee=(oe()||Promise.resolve([])).then(me=>me?ge(me):{})),Ee.then(me=>!!me[ce]))}e.hasSiblingPromiseFn=G;function re(oe){if(!oe)return;let Ee;return ce=>{if(!Ee){const me=oe();Ee=me?ge(me):{}}return!!Ee[ce]}}e.hasSiblingFn=re;function ge(oe){const Ee={};for(const ce of oe)Ee[ce]=!0;return Ee}}),define(Ce[31],Ie([1,0,18,15,20,5,7,24,13,108,22,9,10,2,136,3,14,149,46,36,27,11,8,6,47,42,4]),function(ie,e,r,C,S,N,_,A,E,P,O,w,g,k,m,a,u,d,v,D,c,b,t,l,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function f(y,x,L){return new O.ExtUri(R=>T(R,L)).isEqual(y,x)}function s(y,x,L){return f(y.uri,x.uri,L)?0:(0,w.compare)(y.uri.toString(),x.uri.toString())}function h(y,x,L){return y.index!==x.index?y.index<x.index?-1:1:f(y.uri,x.uri,L)?(0,w.compare)(y.name,x.name):(0,w.compare)(y.uri.toString(),x.uri.toString())}function p(y,x,L,R){const K=y.slice(0).sort(($,G)=>L($,G,R)),W=x.slice(0).sort(($,G)=>L($,G,R));return(0,r.delta)(K,W,($,G)=>L($,G,R))}function T(y,x){const L=x.getCapabilities(y.scheme);return!(L&&L&1024)}class M extends v.Workspace{static toExtHostWorkspace(x,L,R,K){if(!x)return{workspace:null,added:[],removed:[]};const{id:W,name:$,folders:G,configuration:re,transient:ge,isUntitled:oe}=x,Ee=[],ce=L;L?G.forEach((_e,Fe)=>{const Be=k.URI.revive(_e.uri),Xe=M._findFolder(R||L,Be,K);Xe?(Xe.name=_e.name,Xe.index=_e.index,Ee.push(Xe)):Ee.push({uri:Be,name:_e.name,index:Fe})}):Ee.push(...G.map(({uri:_e,name:Fe,index:Be})=>({uri:k.URI.revive(_e),name:Fe,index:Be}))),Ee.sort((_e,Fe)=>_e.index<Fe.index?-1:1);const me=new M(W,$,Ee,!!ge,re?k.URI.revive(re):null,!!oe,_e=>T(_e,K)),{added:ee,removed:be}=p(ce?ce.workspaceFolders:[],me.workspaceFolders,s,K);return{workspace:me,added:ee,removed:be}}static _findFolder(x,L,R){for(let K=0;K<x.folders.length;K++){const W=x.workspaceFolders[K];if(f(W.uri,L,R))return W}}constructor(x,L,R,K,W,$,G){super(x,R.map(re=>new v.WorkspaceFolder(re)),K,W,G),this._name=L,this._isUntitled=$,this._workspaceFolders=[],this._structure=A.TernarySearchTree.forUris(G),R.forEach(re=>{this._workspaceFolders.push(re),this._structure.set(re.uri,re)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(x,L){return L&&this._structure.get(x)&&(x=(0,O.dirname)(x)),this._structure.findSubstr(x)}resolveWorkspaceFolder(x){return this._structure.get(x)}}let V=class{constructor(x,L,R,K,W){this._onDidChangeWorkspace=new N.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new N.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._logService=K,this._extHostFileSystemInfo=R,this._uriTransformerService=W,this._requestIdProvider=new P.Counter,this._barrier=new C.Barrier,this._proxy=x.getProxy(o.MainContext.MainThreadWorkspace),this._messageService=x.getProxy(o.MainContext.MainThreadMessageService);const $=L.workspace;this._confirmedWorkspace=$?new M($.id,$.name,[],!!$.transient,$.configuration?k.URI.revive($.configuration):null,!!$.isUntitled,G=>T(G,R)):void 0}$initializeWorkspace(x,L){this._trusted=L,this.$acceptWorkspaceData(x),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?k.URI.from({scheme:E.Schemas.untitled,path:(0,O.basename)((0,O.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(x,L,R,...K){const W=[];if(Array.isArray(K)&&K.forEach(oe=>{k.URI.isUri(oe.uri)&&!W.some(Ee=>f(Ee.uri,oe.uri,this._extHostFileSystemInfo))&&W.push({uri:oe.uri,name:oe.name||(0,O.basenameOrAuthority)(oe.uri)})}),this._unconfirmedWorkspace||[L,R].some(oe=>typeof oe!="number"||oe<0)||R===0&&W.length===0)return!1;const $=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(L+R>$.length)return!1;const G=$.slice(0);G.splice(L,R,...W.map(oe=>({uri:oe.uri,name:oe.name||(0,O.basenameOrAuthority)(oe.uri),index:void 0})));for(let oe=0;oe<G.length;oe++){const Ee=G[oe];if(G.some((ce,me)=>me!==oe&&f(Ee.uri,ce.uri,this._extHostFileSystemInfo)))return!1}G.forEach((oe,Ee)=>oe.index=Ee);const{added:re,removed:ge}=p($,G,h,this._extHostFileSystemInfo);if(re.length===0&&ge.length===0)return!1;if(this._proxy){const oe=x.displayName||x.name;this._proxy.$updateWorkspaceFolders(oe,L,R,W).then(void 0,Ee=>{this._unconfirmedWorkspace=void 0;const ce={source:{identifier:x.identifier,label:x.displayName||x.name}};this._messageService.$showMessage(d.Severity.Error,(0,m.localize)(0,null,oe,Ee.toString()),ce,[])})}return this.trySetWorkspaceFolders(G),!0}getWorkspaceFolder(x,L){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(x,L)}async getWorkspaceFolder2(x,L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(x,L)}async resolveWorkspaceFolder(x){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(x)}getPath(){if(!this._actualWorkspace)return;const{folders:x}=this._actualWorkspace;if(x.length!==0)return x[0].uri.fsPath}getRelativePath(x,L){let R,K="";if(typeof x=="string"?(R=k.URI.file(x),K=x):typeof x<"u"&&(R=x,K=x.fsPath),!R)return K;const W=this.getWorkspaceFolder(R,!0);if(!W)return K;typeof L>"u"&&this._actualWorkspace&&(L=this._actualWorkspace.folders.length>1);let $=(0,O.relativePath)(W.uri,R);return L&&W.name&&($=`${W.name}/${$}`),$}trySetWorkspaceFolders(x){this._actualWorkspace&&(this._unconfirmedWorkspace=M.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:x,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(x){const{workspace:L,added:R,removed:K}=M.toExtHostWorkspace(x,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=L||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:R,removed:K}))}findFiles(x,L,R,K,W=S.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${K.value}, entryPoint: findFiles`);let $;if(L===null?$=!1:L&&(typeof L=="string"?$=L:$=L.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:G,folder:re}=U(t.GlobPattern.from(x));return this._proxy.$startFileSearch((0,g.withUndefinedAsNull)(G),(0,g.withUndefinedAsNull)(re),(0,g.withUndefinedAsNull)($),(0,g.withUndefinedAsNull)(R),W).then(ge=>Array.isArray(ge)?ge.map(oe=>k.URI.revive(oe)):[])}async findTextInFiles(x,L,R,K,W=S.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${K.value}, entryPoint: findTextInFiles`);const $=this._requestIdProvider.getNext(),G=typeof L.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:L.previewOptions,{includePattern:re,folder:ge}=U(t.GlobPattern.from(L.include)),oe=typeof L.exclude=="string"?L.exclude:L.exclude?L.exclude.pattern:void 0,Ee={ignoreSymlinks:typeof L.followSymlinks=="boolean"?!L.followSymlinks:void 0,disregardIgnoreFiles:typeof L.useIgnoreFiles=="boolean"?!L.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof L.useGlobalIgnoreFiles=="boolean"?!L.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof L.useParentIgnoreFiles=="boolean"?!L.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof L.useDefaultExcludes=="boolean"?!L.useDefaultExcludes:!0,fileEncoding:L.encoding,maxResults:L.maxResults,previewOptions:G,afterContext:L.afterContext,beforeContext:L.beforeContext,includePattern:re,excludePattern:oe},ce=!1;if(this._activeSearchCallbacks[$]=me=>{if(ce)return;const ee=k.URI.revive(me.resource);me.results.forEach(be=>{(0,n.resultIsMatch)(be)?R({uri:ee,preview:{text:be.preview.text,matches:(0,r.mapArrayOrNot)(be.preview.matches,_e=>new l.Range(_e.startLineNumber,_e.startColumn,_e.endLineNumber,_e.endColumn))},ranges:(0,r.mapArrayOrNot)(be.ranges,_e=>new l.Range(_e.startLineNumber,_e.startColumn,_e.endLineNumber,_e.endColumn))}):R({uri:ee,text:be.text,lineNumber:be.lineNumber})})},W.isCancellationRequested)return{};try{const me=await this._proxy.$startTextSearch(x,(0,g.withUndefinedAsNull)(ge),Ee,$,W);return delete this._activeSearchCallbacks[$],me||{}}catch(me){throw delete this._activeSearchCallbacks[$],me}}$handleTextSearchResult(x,L){this._activeSearchCallbacks[L]?.(x)}saveAll(x){return this._proxy.$saveAll(x)}resolveProxy(x){return this._proxy.$resolveProxy(x)}get trusted(){return this._trusted}requestWorkspaceTrust(x){return this._proxy.$requestWorkspaceTrust(x)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(x,L){if(this._editSessionIdentityProviders.has(x))throw new Error(`A provider has already been registered for scheme ${x}`);this._editSessionIdentityProviders.set(x,L);const R=this._uriTransformerService.transformOutgoingScheme(x),K=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(K,R),(0,_.toDisposable)(()=>{this._editSessionIdentityProviders.delete(x),this._proxy.$unregisterEditSessionIdentityProvider(K)})}async $getEditSessionIdentifier(x,L){this._logService.info("Getting edit session identifier for workspaceFolder",x);const R=await this.resolveWorkspaceFolder(k.URI.revive(x));if(!R){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",R);const K=this._editSessionIdentityProviders.get(R.uri.scheme);if(this._logService.info(`Provider for scheme ${R.uri.scheme} is defined: `,!!K),!K)return;const W=await K.provideEditSessionIdentity(R,L);if(this._logService.info("Provider returned edit session identifier: ",W),!!W)return W}};V=ze([$e(0,b.IExtHostRpcService),$e(1,c.IExtHostInitDataService),$e(2,D.IExtHostFileSystemInfo),$e(3,u.ILogService),$e(4,i.IURITransformerService)],V),e.ExtHostWorkspace=V,e.IExtHostWorkspace=(0,a.createDecorator)("IExtHostWorkspace");function U(y){let x,L;return y&&(typeof y=="string"?x=y:(x=y.pattern,L=k.URI.revive(y.baseUri))),{includePattern:x,folder:L}}}),define(Ce[32],Ie([1,0,25,5,31,4,6,152,85,10,15,3,11,14,2]),function(ie,e,r,C,S,N,_,A,E,P,O,w,g,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function a(l,i){if(i){const n=i.split(".");let o=l;for(let f=0;o&&f<n.length;f++)o=o[n[f]];return o}}function u(l){return l instanceof m.URI}function d(l){return l&&l.uri instanceof m.URI&&l.languageId&&typeof l.languageId=="string"}function v(l){return l&&!l.uri&&l.languageId&&typeof l.languageId=="string"}function D(l){return l&&l.uri instanceof m.URI&&(!l.name||typeof l.name=="string")&&(!l.index||typeof l.index=="number")}function c(l){if(u(l))return{resource:l};if(d(l))return{resource:l.uri,overrideIdentifier:l.languageId};if(v(l))return{overrideIdentifier:l.languageId};if(D(l))return{resource:l.uri};if(l===null)return{resource:null}}let b=class{constructor(i,n,o){this._proxy=i.getProxy(N.MainContext.MainThreadConfiguration),this._extHostWorkspace=n,this._logService=o,this._barrier=new O.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(i=>this._actual)}$initializeConfiguration(i){this._actual=new t(this._proxy,this._extHostWorkspace,i,this._logService),this._barrier.open()}$acceptConfigurationChanged(i,n){this.getConfigProvider().then(o=>o.$acceptConfigurationChanged(i,n))}};b=ze([$e(0,g.IExtHostRpcService),$e(1,S.IExtHostWorkspace),$e(2,k.ILogService)],b),e.ExtHostConfiguration=b;class t{constructor(i,n,o,f){this._onDidChangeConfiguration=new C.Emitter,this._proxy=i,this._logService=f,this._extHostWorkspace=n,this._configuration=A.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(i,n){const o={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=A.Configuration.parse(i),this._configurationScopes=this._toMap(i.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(n,o))}getConfiguration(i,n,o){const f=c(n)||{},s=this._toReadonlyValue(i?a(this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace),i):this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace));i&&this._validateConfigurationAccess(i,f,o?.identifier);function h(T){if(T==null)return null;if(typeof T=="boolean")return T?2:5;switch(T){case _.ConfigurationTarget.Global:return 2;case _.ConfigurationTarget.Workspace:return 5;case _.ConfigurationTarget.WorkspaceFolder:return 6}}const p={has(T){return typeof a(s,T)<"u"},get:(T,M)=>{this._validateConfigurationAccess(i?`${i}.${T}`:T,f,o?.identifier);let V=a(s,T);if(typeof V>"u")V=M;else{let U;const y=(x,L)=>{let R;const K=()=>{U=U||(0,r.deepClone)(s),R=R||a(U,L)};return(0,P.isObject)(x)?new Proxy(x,{get:(W,$)=>{if(typeof $=="string"&&$.toLowerCase()==="tojson")return K(),()=>R;if(U)return R=R||a(U,L),R[$];const G=W[$];return typeof $=="string"?y(G,`${L}.${$}`):G},set:(W,$,G)=>(K(),R&&(R[$]=G),!0),deleteProperty:(W,$)=>(K(),R&&delete R[$],!0),defineProperty:(W,$,G)=>(K(),R&&Object.defineProperty(R,$,G),!0)}):x};V=y(V,T)}return V},update:(T,M,V,U)=>{T=i?`${i}.${T}`:T;const y=h(V);return M!==void 0?this._proxy.$updateConfigurationOption(y,T,M,f,U):this._proxy.$removeConfigurationOption(y,T,f,U)},inspect:T=>{T=i?`${i}.${T}`:T;const M=(0,r.deepClone)(this._configuration.inspect(T,f,this._extHostWorkspace.workspace));if(M)return{key:T,defaultValue:M.policy?.value??M.default?.value,globalValue:M.user?.value??M.application?.value,workspaceValue:M.workspace?.value,workspaceFolderValue:M.workspaceFolder?.value,defaultLanguageValue:M.default?.override,globalLanguageValue:M.user?.override??M.application?.override,workspaceLanguageValue:M.workspace?.override,workspaceFolderLanguageValue:M.workspaceFolder?.override,languageIds:M.overrideIdentifiers}}};return typeof s=="object"&&(0,r.mixin)(p,s,!1),Object.freeze(p)}_toReadonlyValue(i){const n=o=>(0,P.isObject)(o)?new Proxy(o,{get:(f,s)=>n(f[s]),set:(f,s,h)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(s)}' of object`)},deleteProperty:(f,s)=>{throw new Error(`TypeError: Cannot delete read only property '${String(s)}' of object`)},defineProperty:(f,s)=>{throw new Error(`TypeError: Cannot define property '${String(s)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):o;return n(i)}_validateConfigurationAccess(i,n,o){const f=E.OVERRIDE_PROPERTY_REGEX.test(i)?4:this._configurationScopes.get(i),s=o?`[${o.value}] `:"";if(f===4){typeof n?.resource>"u"&&this._logService.warn(`${s}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${i}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){n?.resource&&this._logService.warn(`${s}Accessing a window scoped configuration for a resource is not expected. To associate '${i}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(i,n){const o=new A.ConfigurationChangeEvent(i,n,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(f,s)=>o.affectsConfiguration(f,c(s))})}_toMap(i){return i.reduce((n,o)=>(n.set(o[0],o[1]),n),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,w.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(ie,e,r,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ie,r):S?S.value=r:e.set(ie,r),r},Oe=this&&this.__classPrivateFieldGet||function(ie,e,r,C){if(r==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!C:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?C:r==="a"?C.call(ie):C?C.value:e.get(ie)};define(Ce[102],Ie([1,0,2,15,5,4,6,31,50,32,20,53,11,27,3,13,21,14,67,185,12]),function(ie,e,r,C,S,N,_,A,E,P,O,w,g,k,m,a,u,d,v,D,c){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(L){function R(W){if(W!=null)return W}L.from=R;function K(W){if(W!=null)return W}L.to=K})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var l;(function(L){function R(W){if(W!=null)return W}L.from=R;function K(W){if(W!=null)return W}L.to=K})(l=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var i;(function(L){function R(W){if(W!=null)return W}L.from=R;function K(W){if(W!=null)return W}L.to=K})(i=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var n;(function(L){function R($){if($){const G=$;return G&&!!G.process}else return!1}L.is=R;function K($){if($==null)return;const G={process:$.process,args:$.args};return $.options&&(G.options=i.from($.options)),G}L.from=K;function W($){if($!=null)return new _.ProcessExecution($.process,$.args,$.options)}L.to=W})(n=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var o;(function(L){function R(W){if(W!=null)return W}L.from=R;function K(W){if(W!=null)return W}L.to=K})(o=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var f;(function(L){function R($){if($){const G=$;return G&&(!!G.commandLine||!!G.command)}else return!1}L.is=R;function K($){if($==null)return;const G={};return $.commandLine!==void 0?G.commandLine=$.commandLine:(G.command=$.command,G.args=$.args),$.options&&(G.options=o.from($.options)),G}L.from=K;function W($){if(!($==null||$.command===void 0&&$.commandLine===void 0))return $.commandLine?new _.ShellExecution($.commandLine,$.options):new _.ShellExecution($.command,$.args?$.args:[],$.options)}L.to=W})(f=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var s;(function(L){function R($){if($){const G=$;return G&&G.customExecution==="customExecution"}else return!1}L.is=R;function K($){return{customExecution:"customExecution"}}L.from=K;function W($,G){return G.get($)}L.to=W})(s=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var h;(function(L){function R(K,W){let $;return K.scope!==void 0&&typeof K.scope!="number"?$=K.scope.uri:K.scope!==void 0&&typeof K.scope=="number"&&(K.scope===_.TaskScope.Workspace&&W&&W.workspaceFile?$=W.workspaceFile:$=D.USER_TASKS_GROUP_KEY),{id:K._id,workspaceFolder:$}}L.from=R})(h=e.TaskHandleDTO||(e.TaskHandleDTO={}));var p;(function(L){function R(K){if(K!=null)return{_id:K.id,isDefault:K.isDefault}}L.from=R})(p=e.TaskGroupDTO||(e.TaskGroupDTO={}));var T;(function(L){function R($,G){if($==null)return[];const re=[];for(const ge of $){const oe=K(ge,G);oe&&re.push(oe)}return re}L.fromMany=R;function K($,G){if($==null)return;let re;$.execution instanceof _.ProcessExecution?re=n.from($.execution):$.execution instanceof _.ShellExecution?re=f.from($.execution):$.execution&&$.execution instanceof _.CustomExecution&&(re=s.from($.execution));const ge=t.from($.definition);let oe;return $.scope?typeof $.scope=="number"?oe=$.scope:oe=$.scope.uri:oe=_.TaskScope.Workspace,!ge||!oe?void 0:{_id:$._id,definition:ge,name:$.name,source:{extensionId:G.identifier.value,label:$.source,scope:oe},execution:re,isBackground:$.isBackground,group:p.from($.group),presentationOptions:l.from($.presentationOptions),problemMatchers:$.problemMatchers,hasDefinedMatchers:$.hasDefinedMatchers,runOptions:$.runOptions?$.runOptions:{reevaluateOnRerun:!0},detail:$.detail}}L.from=K;async function W($,G,re){if($==null)return;let ge;n.is($.execution)?ge=n.to($.execution):f.is($.execution)?ge=f.to($.execution):s.is($.execution)&&(ge=s.to($._id,re));const oe=t.to($.definition);let Ee;if($.source&&($.source.scope!==void 0?typeof $.source.scope=="number"?Ee=$.source.scope:Ee=await G.resolveWorkspaceFolder(r.URI.revive($.source.scope)):Ee=_.TaskScope.Workspace),!oe||!Ee)return;const ce=new _.Task(oe,Ee,$.name,$.source.label,ge,$.problemMatchers);return $.isBackground!==void 0&&(ce.isBackground=$.isBackground),$.group!==void 0&&(ce.group=_.TaskGroup.from($.group._id),ce.group&&$.group.isDefault&&(ce.group=new _.TaskGroup(ce.group.id,ce.group.label),$.group.isDefault===!0&&(ce.group.isDefault=$.group.isDefault))),$.presentationOptions&&(ce.presentationOptions=l.to($.presentationOptions)),$._id&&(ce._id=$._id),$.detail&&(ce.detail=$.detail),ce}L.to=W})(T=e.TaskDTO||(e.TaskDTO={}));var M;(function(L){function R(W){return W}L.from=R;function K(W){if(!!W)return Object.assign(Object.create(null),W)}L.to=K})(M=e.TaskFilterDTO||(e.TaskFilterDTO={}));class V{constructor(R,K,W){this._id=K,this._task=W,b.set(this,void 0),Je(this,b,R,"f")}get task(){return this._task}terminate(){Oe(this,b,"f").terminateTask(this)}fireDidStartProcess(R){}fireDidEndProcess(R){}}b=new WeakMap;var U;(function(L){function R(K){return{id:K._id,task:void 0}}L.from=R})(U=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let y=class{constructor(R,K,W,$,G,re,ge,oe){this._onDidExecuteTask=new S.Emitter,this._onDidTerminateTask=new S.Emitter,this._onDidTaskProcessStarted=new S.Emitter,this._onDidTaskProcessEnded=new S.Emitter,this._proxy=R.getProxy(N.MainContext.MainThreadTask),this._workspaceProvider=W,this._editorService=$,this._configurationService=G,this._terminalService=re,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=ge,this._deprecationService=oe,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(R,K,W){if(!W)return new _.Disposable(()=>{});const $=this.nextHandle();return this._handlers.set($,{type:K,provider:W,extension:R}),this._proxy.$registerTaskProvider($,K),new _.Disposable(()=>{this._handlers.delete($),this._proxy.$unregisterTaskProvider($)})}registerTaskSystem(R,K){this._proxy.$registerTaskSystem(R,K)}fetchTasks(R){return this._proxy.$fetchTasks(M.from(R)).then(async K=>{const W=[];for(const $ of K){const G=await T.to($,this._workspaceProvider,this._providedCustomExecutions2);G&&W.push(G)}return W})}get taskExecutions(){const R=[];return this._taskExecutions.forEach(K=>R.push(K)),R}terminateTask(R){if(!(R instanceof V))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(R._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(R,K,W){const $=this._providedCustomExecutions2.get(R.id);$&&(this._activeCustomExecutions2.set(R.id,$),this._terminalService.attachPtyToTerminal(K,await $.callback(W))),this._lastStartedTask=R.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(R)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(R){const K=await this.getTaskExecution(R);this._taskExecutionPromises.delete(R.id),this._taskExecutions.delete(R.id),this.customExecutionComplete(R),this._onDidTerminateTask.fire({execution:K})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(R){const K=await this.getTaskExecution(R.id);this._onDidTaskProcessStarted.fire({execution:K,processId:R.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(R){const K=await this.getTaskExecution(R.id);this._onDidTaskProcessEnded.fire({execution:K,exitCode:R.exitCode})}$provideTasks(R,K){const W=this._handlers.get(R);if(!W)return Promise.reject(new Error("no handler found"));const $=[],G=(0,C.asPromise)(()=>W.provider.provideTasks(O.CancellationToken.None)).then(re=>this.provideTasksInternal(K,$,W,re));return new Promise(re=>{G.then(ge=>{Promise.all($).then(()=>{re(ge)})})})}async $resolveTask(R,K){const W=this._handlers.get(R);if(!W)return Promise.reject(new Error("no handler found"));if(K.definition.type!==W.type)throw new Error(`Unexpected: Task of type [${K.definition.type}] cannot be resolved by provider of type [${W.type}].`);const $=await T.to(K,this._workspaceProvider,this._providedCustomExecutions2);if(!$)throw new Error("Unexpected: Task cannot be resolved.");const G=await W.provider.resolveTask($,O.CancellationToken.None);if(!G)return;this.checkDeprecation(G,W);const re=T.from(G,W.extension);if(!re)throw new Error("Unexpected: Task cannot be resolved.");if(G.definition!==$.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return s.is(re.execution)&&await this.addCustomExecution(re,G,!0),await this.resolveTaskInternal(re)}nextHandle(){return this._handleCounter++}async addCustomExecution(R,K,W){const $=await this._proxy.$createTaskId(R);!W&&!this._providedCustomExecutions2.has($)&&(this._notProvidedCustomExecutions.add($),this._activeCustomExecutions2.set($,K.execution)),this._providedCustomExecutions2.set($,K.execution)}async getTaskExecution(R,K){if(typeof R=="string"){const G=this._taskExecutionPromises.get(R);if(!G)throw new c.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return G}const W=this._taskExecutionPromises.get(R.id);if(W)return W;const $=new Promise((G,re)=>{function ge(oe,Ee,ce){ce?G(new V(oe,Ee.id,ce)):re("Unexpected: Task does not exist.")}K?ge(this,R,K):T.to(R.task,this._workspaceProvider,this._providedCustomExecutions2).then(oe=>ge(this,R,oe))});return this._taskExecutionPromises.set(R.id,$),$.then(G=>(this._taskExecutions.set(R.id,G),G),G=>Promise.reject(G))}checkDeprecation(R,K){R._deprecated&&this._deprecationService.report("Task.constructor",K.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(R){this._activeCustomExecutions2.get(R.id)&&this._activeCustomExecutions2.delete(R.id),this._notProvidedCustomExecutions.has(R.id)&&this._lastStartedTask!==R.id&&(this._providedCustomExecutions2.delete(R.id),this._notProvidedCustomExecutions.delete(R.id));const W=this._notProvidedCustomExecutions.values();let $=W.next();for(;!$.done;)!this._activeCustomExecutions2.has($.value)&&this._lastStartedTask!==$.value&&(this._providedCustomExecutions2.delete($.value),this._notProvidedCustomExecutions.delete($.value)),$=W.next()}};y=ze([$e(0,g.IExtHostRpcService),$e(1,k.IExtHostInitDataService),$e(2,A.IExtHostWorkspace),$e(3,E.IExtHostDocumentsAndEditors),$e(4,P.IExtHostConfiguration),$e(5,w.IExtHostTerminalService),$e(6,d.ILogService),$e(7,v.IExtHostApiDeprecationService)],y),e.ExtHostTaskBase=y;let x=class extends y{constructor(R,K,W,$,G,re,ge,oe){super(R,K,W,$,G,re,ge,oe),this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:u.PlatformToString(0)})}async executeTask(R,K){if(!K.execution)throw new Error("Tasks to execute must include an execution");const W=T.from(K,R);if(W===void 0)throw new Error("Task is not valid");if(s.is(W.execution))await this.addCustomExecution(W,K,!1);else throw new c.NotSupportedError;const $=await this.getTaskExecution(await this._proxy.$getTaskExecution(W),K);return this._proxy.$executeTask(W).catch(G=>{throw new Error(G)}),$}provideTasksInternal(R,K,W,$){const G=[];if($)for(const re of $){this.checkDeprecation(re,W),(!re.definition||!R[re.definition.type])&&this._logService.warn(`The task [${re.source}, ${re.name}] uses an undefined task type. The task will be ignored in the future.`);const ge=T.from(re,W.extension);ge&&s.is(ge.execution)?(G.push(ge),K.push(this.addCustomExecution(ge,re,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:G,extension:W.extension}}async resolveTaskInternal(R){if(s.is(R.execution))return R;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(R,K){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(R,K,W){}};x=ze([$e(0,g.IExtHostRpcService),$e(1,k.IExtHostInitDataService),$e(2,A.IExtHostWorkspace),$e(3,E.IExtHostDocumentsAndEditors),$e(4,P.IExtHostConfiguration),$e(5,w.IExtHostTerminalService),$e(6,d.ILogService),$e(7,v.IExtHostApiDeprecationService)],x),e.WorkerExtHostTask=x,e.IExtHostTask=(0,m.createDecorator)("IExtHostTask")}),define(Ce[228],Ie([1,0,19,20,44,34,22,203,42]),function(ie,e,r,C,S,N,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(g,k,m){this.config=g,this.provider=k,this.sessionToken=m,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=g.filePattern,this.includePattern=g.includePattern&&N.parse(g.includePattern),this.maxResults=g.maxResults||void 0,this.exists=g.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=g.excludePattern&&N.parse(g.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(g=>g.cancel()),this.activeCancellationTokens=new Set}search(g){const k=this.config.folderQueries||[];return new Promise((m,a)=>{const u=d=>{this.resultCount++,g(d)};if(this.isCanceled)return m({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(d=>{const v=d.toString(),D=r.basename(v);this.globalExcludePattern&&this.globalExcludePattern(v,D)||this.matchFile(u,{base:d,basename:D})}),Promise.all(k.map(d=>this.searchInFolder(d,u))).then(d=>{m({limitHit:this.isLimitHit,stats:d[0]||void 0})},d=>{a(new Error((0,S.toErrorMessage)(d)))})})}async searchInFolder(g,k){const m=new C.CancellationTokenSource,a=this.getSearchOptionsForFolder(g),u=this.initDirectoryTree(),d=new E.QueryGlobTester(this.config,g),v=!d.hasSiblingExcludeClauses();let D;try{this.activeCancellationTokens.add(m),D=A.StopWatch.create();const c=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},a,m.token),b=D.elapsed(),t=A.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(c&&c.forEach(l=>{const i=r.posix.relative(g.folder.path,l.path);if(v){const n=r.basename(l.path);this.matchFile(k,{base:g.folder,relativePath:i,basename:n});return}this.addDirectoryEntries(u,g.folder,i,k)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(u,d,k),{providerTime:b,postProcessTime:t.elapsed()})}finally{m.dispose(),this.activeCancellationTokens.delete(m)}}getSearchOptionsForFolder(g){const k=(0,E.resolvePatternsForProvider)(this.config.includePattern,g.includePattern),m=(0,E.resolvePatternsForProvider)(this.config.excludePattern,g.excludePattern);return{folder:g.folder,excludes:m,includes:k,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!g.disregardParentIgnoreFiles,followSymlinks:!g.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const g={rootEntries:[],pathToEntries:Object.create(null)};return g.pathToEntries["."]=g.rootEntries,g}addDirectoryEntries({pathToEntries:g},k,m,a){if(m===this.filePattern){const d=r.basename(this.filePattern);this.matchFile(a,{base:k,relativePath:this.filePattern,basename:d})}function u(d){const v=r.basename(d),D=r.dirname(d);let c=g[D];c||(c=g[D]=[],u(D)),c.push({base:k,relativePath:d,basename:v})}u(m)}matchDirectoryTree({rootEntries:g,pathToEntries:k},m,a){const u=this,d=this.filePattern;function v(D){const c=(0,E.hasSiblingFn)(()=>D.map(b=>b.basename));for(let b=0,t=D.length;b<t;b++){const l=D[b],{relativePath:i,basename:n}=l;if(m.matchesExcludesSync(i,n,d!==n?c:void 0))continue;const o=k[i];if(o)v(o);else{if(i===d)continue;u.matchFile(a,l)}if(u.isLimitHit)break}}v(g)}matchFile(g,k){(!this.includePattern||k.relativePath&&this.includePattern(k.relativePath,k.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||g(k))}}class O{constructor(){this.sessions=new Map}fileSearch(g,k,m,a){const u=this.getSessionTokenSource(g.cacheKey),d=new P(g,k,u&&u.token);let v=0;const D=c=>{v+=c.length,m(c.map(b=>this.rawMatchToSearchItem(b)))};return this.doSearch(d,O.BATCH_SIZE,D,a).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:v,detailStats:c.stats}}))}clearCache(g){this.getSessionTokenSource(g)?.cancel()}getSessionTokenSource(g){if(!!g)return this.sessions.has(g)||this.sessions.set(g,new C.CancellationTokenSource),this.sessions.get(g)}rawMatchToSearchItem(g){return g.relativePath?{resource:_.joinPath(g.base,g.relativePath)}:{resource:g.base}}doSearch(g,k,m,a){a.onCancellationRequested(()=>{g.cancel()});const u=v=>{v&&(d.push(v),k>0&&d.length>=k&&(m(d),d=[]))};let d=[];return g.search(u).then(v=>(d.length&&m(d),v),v=>(d.length&&m(d),Promise.reject(v)))}}e.FileSearchManager=O,O.BATCH_SIZE=512}),define(Ce[229],Ie([1,0,18,73,34,78,24,13,19,22,9,10,2,246,144,57,14,46,91,227,42]),function(ie,e,r,C,S,N,_,A,E,P,O,w,g,k,m,a,u,d,v,D,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let b=class{constructor(p,T,M,V,U){this.configurationService=p,this.workspaceContextService=T,this.editorGroupsService=M,this.logService=V,this.pathService=U}text(p,T,M={}){p=this.getContentPattern(p,M);const V=this.configurationService.getValue(),U=T&&T.some(x=>!this.configurationService.getValue({resource:x}).search.useRipgrep);return{...this.commonQuery(T?.map(d.toWorkspaceFolder),M),type:2,contentPattern:p,previewOptions:M.previewOptions,maxFileSize:M.maxFileSize,usePCRE2:V.search.usePCRE2||U||!1,beforeContext:M.beforeContext,afterContext:M.afterContext,userDisabledExcludesAndIgnoreFiles:M.disregardExcludeSettings&&M.disregardIgnoreFiles}}getContentPattern(p,T){const M=this.configurationService.getValue();p.isRegExp&&(p.pattern=p.pattern.replace(/\r?\n/g,"\\n"));const V={...p,wordSeparators:M.editor.wordSeparators};return this.isCaseSensitive(p,T)&&(V.isCaseSensitive=!0),this.isMultiline(p)&&(V.isMultiline=!0),V}file(p,T={}){return{...this.commonQuery(p,T),type:1,filePattern:T.filePattern?T.filePattern.trim():T.filePattern,exists:T.exists,sortByScore:T.sortByScore,cacheKey:T.cacheKey}}handleIncludeExclude(p,T){return p?(p=Array.isArray(p)?p.map(o):o(p),T?this.parseSearchPaths(p):{pattern:l(...Array.isArray(p)?p:[p])}):{}}commonQuery(p=[],T={}){const M=this.handleIncludeExclude(T.includePattern,T.expandPatterns),V=this.handleIncludeExclude(T.excludePattern,T.expandPatterns),U=p.length>1,y=(M.searchPaths&&M.searchPaths.length?M.searchPaths.map(R=>this.getFolderQueryForSearchPath(R,T,V)):p.map(R=>this.getFolderQueryForRoot(R,T,V,U))).filter(R=>!!R),x={_reason:T._reason,folderQueries:y,usingSearchPaths:!!(M.searchPaths&&M.searchPaths.length),extraFileResources:T.extraFileResources,excludePattern:V.pattern,includePattern:M.pattern,onlyOpenEditors:T.onlyOpenEditors,maxResults:T.maxResults};if(T.onlyOpenEditors){const R=r.coalesce(r.flatten(this.editorGroupsService.groups.map($=>$.editors.map(G=>G.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(R));const K=R.filter($=>(0,c.pathIncludedInQuery)(x,$.fsPath)),W=this.commonQueryFromFileList(K);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(W)),{...x,...W}}const L=T.extraFileResources&&T.extraFileResources.filter(R=>(0,c.pathIncludedInQuery)(x,R.fsPath));return x.extraFileResources=L&&L.length?L:void 0,x}commonQueryFromFileList(p){const T=[],M=new _.ResourceMap,V={};let U=!1;return p.forEach(y=>{if(y.scheme===A.Schemas.walkThrough)return;if((0,P.isAbsolutePath)(y)){const L=this.workspaceContextService.getWorkspaceFolder(y)?.uri??y.with({path:E.dirname(y.fsPath)});let R=M.get(L);R||(U=!0,R={folder:L,includePattern:{}},T.push(R),M.set(L,R));const K=E.relative(L.fsPath,y.fsPath);(0,w.assertIsDefined)(R.includePattern)[K.replace(/\\/g,"/")]=!0}else y.fsPath&&(U=!0,V[y.fsPath]=!0)}),{folderQueries:T,includePattern:V,usingSearchPaths:!0,excludePattern:U?void 0:{"**/*":!0}}}isCaseSensitive(p,T){if(T.isSmartCase){if(p.isRegExp){if(O.containsUppercaseCharacter(p.pattern,!0))return!0}else if(O.containsUppercaseCharacter(p.pattern))return!0}return!!p.isCaseSensitive}isMultiline(p){return p.isMultiline||p.isRegExp&&(0,k.isMultilineRegexSource)(p.pattern)||p.pattern.indexOf(`
`)>=0?!0:!!p.isMultiline}parseSearchPaths(p){const T=W=>E.isAbsolute(W)||/^\.\.?([\/\\]|$)/.test(W),V=(Array.isArray(p)?p:i(p)).map(W=>{const $=this.pathService.resolvedUserHome;return $?(0,N.untildify)(W,$.scheme===A.Schemas.file?$.fsPath:$.path):W}),U=C.groupBy(V,W=>T(W)?"searchPaths":"exprSegments"),y=(U.exprSegments||[]).map(W=>O.rtrim(W,"/")).map(W=>O.rtrim(W,"\\")).map(W=>(W[0]==="."&&(W="*"+W),n(W))),x={},L=this.expandSearchPathPatterns(U.searchPaths||[]);L&&L.length&&(x.searchPaths=L);const R=r.flatten(y),K=l(...R);return K&&(x.pattern=K),x}getExcludesForFolder(p,T){return T.disregardExcludeSettings?void 0:(0,c.getExcludes)(p,!T.disregardSearchExcludeSettings)}expandSearchPathPatterns(p){if(!p||!p.length)return[];const T=r.flatten(p.map(V=>{let{pathPortion:U,globPortion:y}=t(V);y&&(y=f(y));const x=this.expandOneSearchPath(U);return r.flatten(x.map(L=>this.resolveOneSearchPathPattern(L,y)))})),M=new Map;return T.forEach(V=>{const U=V.searchPath.toString(),y=M.get(U);y?V.pattern&&(y.pattern=y.pattern||{},y.pattern[V.pattern]=!0):M.set(U,{searchPath:V.searchPath,pattern:V.pattern?l(V.pattern):void 0})}),Array.from(M.values())}expandOneSearchPath(p){if(E.isAbsolute(p)){const T=this.workspaceContextService.getWorkspace().folders;return T[0]&&T[0].uri.scheme!==A.Schemas.file?[{searchPath:T[0].uri.with({path:p})}]:[{searchPath:g.URI.file(E.normalize(p))}]}if(this.workspaceContextService.getWorkbenchState()===2){const T=this.workspaceContextService.getWorkspace().folders[0].uri;if(p=o(p),p.startsWith("../")||p===".."){const V=E.posix.resolve(T.path,p);return[{searchPath:T.with({path:V})}]}const M=f(p);return[{searchPath:T,pattern:M}]}else{if(p==="./"||p===".\\")return[];{const T=p.replace(/^\.[\/\\]/,""),V=this.workspaceContextService.getWorkspace().folders.map(U=>{const y=T.match(new RegExp(`^${O.escapeRegExpCharacters(U.name)}(?:/(.*)|$)`));return y?{match:y,folder:U}:null}).filter(w.isDefined);if(V.length)return V.map(U=>{const y=U.match[1];return{searchPath:U.folder.uri,pattern:y&&f(y)}});{const U=p.match(/\.[\/\\](.+)[\/\\]?/),y=U?U[1]:p,x=m.localize(0,null,y);throw new Error(x)}}}}resolveOneSearchPathPattern(p,T){const M=p.pattern&&T?`${p.pattern}/${T}`:p.pattern||T,V=[{searchPath:p.searchPath,pattern:M}];return M&&!M.endsWith("**")&&V.push({searchPath:p.searchPath,pattern:M+"/**"}),V}getFolderQueryForSearchPath(p,T,M){const V=this.getFolderQueryForRoot((0,d.toWorkspaceFolder)(p.searchPath),T,M,!1);return V?{...V,includePattern:p.pattern}:null}getFolderQueryForRoot(p,T,M,V){let U;const y=g.URI.isUri(p)?p:p.uri;if(M.searchPaths){const W=M.searchPaths.filter($=>(0,P.isEqual)($.searchPath,y))[0];if(W&&!W.pattern)return null;W&&(U=W.pattern)}const x=this.configurationService.getValue({resource:y}),R={...this.getExcludesForFolder(x,T)||{},...U||{}},K=g.URI.isUri(p)?(0,P.basename)(p):p.name;return{folder:y,folderName:V?K:void 0,excludePattern:Object.keys(R).length>0?R:void 0,fileEncoding:x.files&&x.files.encoding,disregardIgnoreFiles:typeof T.disregardIgnoreFiles=="boolean"?T.disregardIgnoreFiles:!x.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof T.disregardGlobalIgnoreFiles=="boolean"?T.disregardGlobalIgnoreFiles:!x.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof T.disregardParentIgnoreFiles=="boolean"?T.disregardParentIgnoreFiles:!x.search.useParentIgnoreFiles,ignoreSymlinks:typeof T.ignoreSymlinks=="boolean"?T.ignoreSymlinks:!x.search.followSymlinks}}};b=ze([$e(0,a.IConfigurationService),$e(1,d.IWorkspaceContextService),$e(2,v.IEditorGroupsService),$e(3,u.ILogService),$e(4,D.IPathService)],b),e.QueryBuilder=b;function t(h){const p=h.match(/[\*\{\}\(\)\[\]\?]/);if(p){const T=p.index,M=h.substr(0,T).match(/[/|\\][^/\\]*$/);if(M){let V=h.substr(0,M.index);return V.match(/[/\\]/)||(V+="/"),{pathPortion:V,globPortion:h.substr((M.index||0)+1)}}}return{pathPortion:h}}function l(...h){return h.length?h.reduce((p,T)=>(p[T]=!0,p),Object.create(null)):void 0}function i(h){return S.splitGlobAware(h,",").map(p=>p.trim()).filter(p=>!!p.length)}function n(h){return[`**/${h}/**`,`**/${h}`].map(T=>T.replace(/\*\*\/\*\*/g,"**"))}function o(h){return h.replace(/\\/g,"/")}function f(h){return o(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function s(h,p){h=r.distinct(h,V=>V.toString());const T=[],M=p.getWorkspace();return h&&h.forEach(V=>{let U;if(p.getWorkbenchState()===2)U=(0,P.relativePath)(M.folders[0].uri,V),U&&U!=="."&&(U="./"+U);else{const y=p.getWorkspaceFolder(V);if(y){const x=y.name;if(M.folders.filter(R=>R.name===x).length===1){const R=(0,P.relativePath)(y.uri,V);R===""?U=`./${y.name}`:U=`./${y.name}/${R}`}else U=V.fsPath}}U&&T.push(U)}),T}e.resolveResourcesForSearchIncludes=s}),define(Ce[230],Ie([1,0,22,2,20,12,3,229,42,46]),function(ie,e,r,C,S,N,_,A,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const O=7e3;function w(a,u){const d=u.activationEvents;if(!d)return Promise.resolve(void 0);const v=[],D=[];for(const n of d)if(/^workspaceContains:/.test(n)){const o=n.substr(18);o.indexOf("*")>=0||o.indexOf("?")>=0||a.forceUsingSearch?D.push(o):v.push(o)}if(v.length===0&&D.length===0)return Promise.resolve(void 0);let c;const b=new Promise((n,o)=>{c=n}),t=n=>c({activationEvent:n}),l=Promise.all(v.map(n=>g(a,n,t))).then(()=>{}),i=k(a,u.identifier,D,t);return Promise.all([l,i]).then(()=>{c(void 0)}),b}e.checkActivateWorkspaceContainsExtension=w;async function g(a,u,d){for(const v of a.folders)if(await a.exists(r.joinPath(C.URI.revive(v),u))){d(`workspaceContains:${u}`);return}}async function k(a,u,d,v){if(d.length===0)return Promise.resolve(void 0);const D=new S.CancellationTokenSource,c=a.checkExists(a.folders,d,D.token),b=setTimeout(async()=>{D.cancel(),a.logService.info(`Not activating extension '${u.value}': Timed out while searching for 'workspaceContains' pattern ${d.join(",")}`)},O);let t=!1;try{t=await c}catch(l){N.isCancellationError(l)||N.onUnexpectedError(l)}D.dispose(),clearTimeout(b),t&&v(`workspaceContains:${d.join(",")}`)}function m(a,u,d,v){const D=a.get(_.IInstantiationService),c=a.get(E.ISearchService),t=D.createInstance(A.QueryBuilder).file(u.map(l=>(0,P.toWorkspaceFolder)(C.URI.revive(l))),{_reason:"checkExists",includePattern:d,exists:!0});return c.fileSearch(t,v).then(l=>!!l.limitHit,l=>N.isCancellationError(l)?!1:Promise.reject(l))}e.checkGlobFileExists=m});var Je=this&&this.__classPrivateFieldSet||function(ie,e,r,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ie,r):S?S.value=r:e.set(ie,r),r},Oe=this&&this.__classPrivateFieldGet||function(ie,e,r,C){if(r==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!C:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?C:r==="a"?C.call(ie):C?C.value:e.get(ie)};define(Ce[33],Ie([1,0,131,19,72,22,15,7,24,2,14,4,32,174,70,31,28,173,12,26,23,158,6,86,3,27,71,11,58,62,53,5,230,69,160,13,68]),function(ie,e,r,C,S,N,_,A,E,P,O,w,g,k,m,a,u,d,v,D,c,b,t,l,i,n,o,f,s,h,p,T,M,V,U,y,x){"use strict";var L,R,K;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,i.createDecorator)("IHostUtils");let W=class Fi extends A.Disposable{constructor(ce,me,ee,be,_e,Fe,Be,Xe,ke,ye,De){super(),this._onDidChangeRemoteConnectionData=this._register(new T.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=me,this._extHostContext=ee,this._initData=Be,this._extHostWorkspace=be,this._extHostConfiguration=_e,this._logService=Fe,this._extHostTunnelService=ke,this._extHostTerminalService=ye,this._extHostLocalizationService=De,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(w.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(w.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(w.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new _.Barrier,this._readyToStartExtensionHost=new _.Barrier,this._readyToRunExtensions=new _.Barrier,this._eagerExtensionsActivated=new _.Barrier,this._globalRegistry=new d.ExtensionDescriptionRegistry(this._initData.allExtensions);const ae=(0,u.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new d.ExtensionDescriptionRegistry(re(this._globalRegistry,ae)),this._storage=new m.ExtHostStorage(this._extHostContext),this._secretState=new V.ExtHostSecretState(this._extHostContext),this._storagePath=Xe,this._instaService=ce.createChild(new s.ServiceCollection([m.IExtHostStorage,this._storage],[V.IExtHostSecretState,this._secretState]));let ue=[],Z=[];this._initData.remote.isRemote&&(ue=this._initData.allExtensions.filter(I=>!I.main&&!I.browser).map(I=>I.identifier),Z=this._initData.allExtensions.filter(I=>!ae.has(D.ExtensionIdentifier.toKey(I.identifier.value))).filter(I=>(I.main||I.browser)&&I.api==="none").map(I=>I.identifier));const J=(0,u.extensionIdentifiersArrayToSet)(Z);this._activator=this._register(new k.ExtensionsActivator(this._myRegistry,ue,Z,{onExtensionActivationError:(I,B,H)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(I,v.transformErrorForSerialization(B),H)},actualActivateExtension:async(I,B)=>{if(J.has(D.ExtensionIdentifier.toKey(I)))return await this._mainThreadExtensionsProxy.$activateExtension(I,B),new k.HostExtension;const H=this._myRegistry.getExtensionDescription(I);return this._activateExtension(H,B)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),S.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(ce){v.onUnexpectedError(ce)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let ce=[];try{ce=this._myRegistry.getAllExtensionDescriptions().map(_e=>_e.identifier).filter(_e=>this.isActivated(_e)).map(_e=>this._deactivate(_e))}catch{}await Promise.all(ce)}terminate(ce,me=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${ce}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),v.setUnexpectedErrorHandler(be=>{this._logService.error(be)}),this._extHostContext.dispose();const ee=this._deactivateAll();Promise.race([(0,_.timeout)(5e3),ee]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${me}`):this._logService.info(`Extension host exiting with code ${me}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(me)})}isActivated(ce){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(ce):!1}async getExtension(ce){const me=await this._mainThreadExtensionsProxy.$getExtension(ce);let ee;if(me?.browserNlsBundleUris){ee={};for(const be of Object.keys(me.browserNlsBundleUris))ee[be]=P.URI.revive(me.browserNlsBundleUris[be])}return me&&{...me,identifier:new D.ExtensionIdentifier(me.identifier.value),extensionLocation:P.URI.revive(me.extensionLocation),browserNlsBundleUris:ee}}_activateByEvent(ce,me){return this._activator.activateByEvent(ce,me)}_activateById(ce,me){return this._activator.activateById(ce,me)}activateByIdWithErrors(ce,me){return this._activateById(ce,me).then(()=>{const ee=this._activator.getActivatedExtension(ce);if(ee.activationFailed)return Promise.reject(ee.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(ce=>this._myRegistry)}getExtensionExports(ce){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(ce).exports:null}async _realPathExtensionUri(ce){if(ce.scheme!==y.Schemas.file)return ce;const me=await this._hostUtils.realpath(ce.fsPath);return P.URI.file(me)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(ce=>new oe(ce))),this._extensionPathIndex}async _createExtensionPathIndex(ce){const me=E.TernarySearchTree.forUris(ee=>N.extUriBiasedIgnorePathCase.ignorePathCasing(ee));return await Promise.all(ce.map(async ee=>{if(this._getEntryPoint(ee)){const be=await this._realPathExtensionUri(ee.extensionLocation);me.set(be,ee)}})),me}_deactivate(ce){let me=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(ce))return me;const ee=this._activator.getActivatedExtension(ce);if(!ee)return me;try{typeof ee.module.deactivate=="function"&&(me=Promise.resolve(ee.module.deactivate()).then(void 0,be=>(this._logService.error(be),Promise.resolve(void 0))))}catch(be){this._logService.error(`An error occurred when deactivating the extension '${ce.value}':`),this._logService.error(be)}try{(0,A.dispose)(ee.subscriptions)}catch(be){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${ce.value}':`),this._logService.error(be)}return me}async _activateExtension(ce,me){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(ce.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(ce.identifier),this._doActivateExtension(ce,me).then(ee=>{const be=ee.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(ce.identifier,be.codeLoadingTime,be.activateCallTime,be.activateResolvedTime,me),this._logExtensionActivationTimes(ce,me,"success",be),ee},ee=>{throw this._logExtensionActivationTimes(ce,me,"failure"),ee})}_logExtensionActivationTimes(ce,me,ee,be){const _e=$(ce,me);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{..._e,...be||{},outcome:ee})}_doActivateExtension(ce,me){const ee=$(ce,me);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ee);const be=this._getEntryPoint(ce);if(!be)return Promise.resolve(new k.EmptyExtension(k.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${ce.identifier.value}, startup: ${me.startup}, activationEvent: '${me.activationEvent}'${ce.identifier.value!==me.extensionId.value?`, root cause: ${me.extensionId.value}`:""}`),this._logService.flush();const _e=new k.ExtensionActivationTimesBuilder(me.startup);return Promise.all([this._loadCommonJSModule(ce,(0,N.joinPath)(ce.extensionLocation,be),_e),this._loadExtensionContext(ce)]).then(Fe=>(S.mark(`code/extHost/willActivateExtension/${ce.identifier.value}`),Fi._callActivate(this._logService,ce.identifier,Fe[0],Fe[1],_e))).then(Fe=>(S.mark(`code/extHost/didActivateExtension/${ce.identifier.value}`),Fe))}_loadExtensionContext(ce){const me=new b.ExtensionGlobalMemento(ce,this._storage),ee=new b.ExtensionMemento(ce.identifier.value,!1,this._storage),be=new U.ExtensionSecrets(ce,this._secretState),_e=ce.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,Fe=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${ce.identifier.value}`),Promise.all([me.whenReady,ee.whenReady,this._storagePath.whenReady]).then(()=>{const Be=this;let Xe,ke;const ye=(0,u.isProposedApiEnabled)(ce,"ipc")?this._initData.messagePorts?.get(D.ExtensionIdentifier.toKey(ce.identifier)):void 0;return Object.freeze({globalState:me,workspaceState:ee,secrets:be,subscriptions:[],get extensionUri(){return ce.extensionLocation},get extensionPath(){return ce.extensionLocation.fsPath},asAbsolutePath(De){return C.join(ce.extensionLocation.fsPath,De)},get storagePath(){return Be._storagePath.workspaceValue(ce)?.fsPath},get globalStoragePath(){return Be._storagePath.globalValue(ce).fsPath},get logPath(){return C.join(Be._initData.logsLocation.fsPath,ce.identifier.value)},get logUri(){return P.URI.joinPath(Be._initData.logsLocation,ce.identifier.value)},get storageUri(){return Be._storagePath.workspaceValue(ce)},get globalStorageUri(){return Be._storagePath.globalValue(ce)},get extensionMode(){return _e},get extension(){return Xe===void 0&&(Xe=new G(Be,ce.identifier,ce,Fe,!1)),Xe},get extensionRuntime(){return(0,u.checkProposedApiEnabled)(ce,"extensionRuntime"),Be.extensionRuntime},get environmentVariableCollection(){return Be._extHostTerminalService.getEnvironmentVariableCollection(ce)},get messagePassingProtocol(){if(!ke){if(!ye)return;const De=T.Event.buffer(T.Event.fromDOMEventEmitter(ye,"message",ae=>ae.data));ye.start(),ke={onDidReceiveMessage:De,postMessage:ye.postMessage.bind(ye)}}return ke}})})}static _callActivate(ce,me,ee,be,_e){return ee=ee||{activate:void 0,deactivate:void 0},this._callActivateOptional(ce,me,ee,be,_e).then(Fe=>new k.ActivatedExtension(!1,null,_e.build(),ee,Fe,be.subscriptions))}static _callActivateOptional(ce,me,ee,be,_e){if(typeof ee.activate=="function")try{_e.activateCallStart(),ce.trace(`ExtensionService#_callActivateOptional ${me.value}`);const Fe=typeof global=="object"?global:self,Be=ee.activate.apply(Fe,[be]);return _e.activateCallStop(),_e.activateResolveStart(),Promise.resolve(Be).then(Xe=>(_e.activateResolveStop(),Xe))}catch(Fe){return Promise.reject(Fe)}else return Promise.resolve(ee)}_activateOneStartupFinished(ce,me){this._activateById(ce.identifier,{startup:!1,extensionId:ce.identifier,activationEvent:me}).then(void 0,ee=>{this._logService.error(ee)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(S.getMarks());for(const ce of this._myRegistry.getAllExtensionDescriptions())if(ce.activationEvents)for(const me of ce.activationEvents)me==="onStartupFinished"&&this._activateOneStartupFinished(ce,me)}_handleEagerExtensions(){const ce=this._activateByEvent("*",!0).then(void 0,_e=>{this._logService.error(_e)});this._register(this._extHostWorkspace.onDidChangeWorkspace(_e=>this._handleWorkspaceContainsEagerExtensions(_e.added)));const me=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ee=this._handleWorkspaceContainsEagerExtensions(me),be=Promise.all([ce,ee]).then(()=>{});return Promise.race([be,(0,_.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),be}_handleWorkspaceContainsEagerExtensions(ce){return ce.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(me=>this._handleWorkspaceContainsEagerExtension(ce,me))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(ce,me){if(this.isActivated(me.identifier))return;const ee=!this._initData.remote.isRemote&&!!this._initData.remote.authority,be={logService:this._logService,folders:ce.map(Fe=>Fe.uri),forceUsingSearch:ee,exists:Fe=>this._hostUtils.exists(Fe.fsPath),checkExists:(Fe,Be,Xe)=>this._mainThreadWorkspaceProxy.$checkExists(Fe,Be,Xe)},_e=await(0,M.checkActivateWorkspaceContainsExtension)(be,me);if(!!_e)return this._activateById(me.identifier,{startup:!0,extensionId:me.identifier,activationEvent:_e.activationEvent}).then(void 0,Fe=>this._logService.error(Fe))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(ce){throw console.error(ce),ce}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:ce,extensionTestsLocationURI:me}=this._initData.environment;if(!ce||!me)throw new Error(r.localize(0,null));const ee=await this._loadCommonJSModule(null,me,new k.ExtensionActivationTimesBuilder(!1));if(!ee||typeof ee.run!="function")throw new Error(r.localize(1,null,me.toString()));return new Promise((be,_e)=>{const Fe=(ke,ye)=>{ke?_e(ke):be(typeof ye=="number"&&ye>0?1:0)},Be=(0,N.originalFSPath)(me),Xe=ee.run(Be,Fe);Xe&&Xe.then&&Xe.then(()=>{be(0)}).catch(ke=>{_e(ke instanceof Error&&ke.stack?ke.stack:String(ke))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ce,me){return this._resolvers[ce]=me,(0,A.toDisposable)(()=>{delete this._resolvers[ce]})}async _activateAndGetResolver(ce){const me=ce.indexOf("+");if(me===-1)throw new Error("Not an authority that can be resolved!");const ee=ce.substr(0,me);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ee}`,!1),{authorityPrefix:ee,resolver:this._resolvers[ee]}}async $resolveAuthority(ce,me){this._logService.info(`$resolveAuthority invoked for authority (${ge(ce)})`);const{authorityPrefix:ee,resolver:be}=await this._activateAndGetResolver(ce);if(!be)return{type:"error",error:{code:l.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ee}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(be)),S.mark(`code/extHost/willResolveAuthority/${ee}`);const _e=await be.resolve(ce,{resolveAttempt:me});S.mark(`code/extHost/didResolveAuthorityOK/${ee}`);const Fe={authority:ce,host:_e.host,port:_e.port,connectionToken:_e.connectionToken},Be={extensionHostEnv:_e.extensionHostEnv,isTrusted:_e.isTrusted,authenticationSession:_e.authenticationSessionForInitializingExtensions?{id:_e.authenticationSessionForInitializingExtensions.id,providerId:_e.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Fe,options:Be,tunnelInformation:{environmentTunnels:_e.environmentTunnels,features:_e.tunnelFeatures}}}}catch(_e){if(S.mark(`code/extHost/didResolveAuthorityError/${ee}`),_e instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:_e._code,message:_e._message,detail:_e._detail}};throw _e}}async $getCanonicalURI(ce,me){this._logService.info(`$getCanonicalURI invoked for authority (${ge(ce)})`);const{resolver:ee}=await this._activateAndGetResolver(ce);if(!ee)return null;const be=P.URI.revive(me);if(typeof ee.getCanonicalURI>"u")return be;const _e=await(0,_.asPromise)(()=>ee.getCanonicalURI(be));return _e||be}static _applyExtensionsDelta(ce,me,ee){const be=new d.ExtensionDescriptionRegistry(ce.getAllExtensionDescriptions());be.deltaExtensions(ee.toAdd,ee.toRemove);const _e=(0,u.extensionIdentifiersArrayToSet)(me.getAllExtensionDescriptions().map(Be=>Be.identifier));for(const Be of ee.myToRemove)_e.delete(D.ExtensionIdentifier.toKey(Be));for(const Be of ee.myToAdd)_e.add(D.ExtensionIdentifier.toKey(Be));const Fe=re(be,_e);return{globalRegistry:be,myExtensions:Fe}}$startExtensionHost(ce){ce.toAdd.forEach(be=>be.extensionLocation=P.URI.revive(be.extensionLocation));const{globalRegistry:me,myExtensions:ee}=Fi._applyExtensionsDelta(this._globalRegistry,this._myRegistry,ce);return this._globalRegistry.set(me.getAllExtensionDescriptions()),this._myRegistry.set(ee),this._startExtensionHost()}$activateByEvent(ce,me){return me===1?this._activateByEvent(ce,!1):this._readyToRunExtensions.wait().then(ee=>this._activateByEvent(ce,!1))}async $activate(ce,me){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(ce)?(await this._activateById(ce,me),!0):!1}async $deltaExtensions(ce){ce.toAdd.forEach(Fe=>Fe.extensionLocation=P.URI.revive(Fe.extensionLocation));const{globalRegistry:me,myExtensions:ee}=Fi._applyExtensionsDelta(this._globalRegistry,this._myRegistry,ce),be=await this._createExtensionPathIndex(ee);return(await this.getExtensionPathIndex()).setSearchTree(be),this._globalRegistry.set(me.getAllExtensionDescriptions()),this._myRegistry.set(ee),Promise.resolve(void 0)}async $test_latency(ce){return ce}async $test_up(ce){return ce.byteLength}async $test_down(ce){const me=c.VSBuffer.alloc(ce),ee=Math.random()%256;for(let be=0;be<ce;be++)me.writeUInt8(ee,be);return me}async $updateRemoteConnectionData(ce){this._remoteConnectionData=ce,this._onDidChangeRemoteConnectionData.fire()}};W=ze([$e(0,i.IInstantiationService),$e(1,e.IHostUtils),$e(2,f.IExtHostRpcService),$e(3,a.IExtHostWorkspace),$e(4,g.IExtHostConfiguration),$e(5,O.ILogService),$e(6,n.IExtHostInitDataService),$e(7,o.IExtensionStoragePaths),$e(8,h.IExtHostTunnelService),$e(9,p.IExtHostTerminalService),$e(10,x.IExtHostLocalizationService)],W),e.AbstractExtHostExtensionService=W;function $(Ee,ce){return{id:Ee.identifier.value,name:Ee.name,extensionVersion:Ee.version,publisherDisplayName:Ee.publisher,activationEvents:Ee.activationEvents?Ee.activationEvents.join(","):null,isBuiltin:Ee.isBuiltin,reason:ce.activationEvent,reasonId:ce.extensionId.value}}e.IExtHostExtensionService=(0,i.createDecorator)("IExtHostExtensionService");class G{constructor(ce,me,ee,be,_e){L.set(this,void 0),R.set(this,void 0),K.set(this,void 0),Je(this,L,ce,"f"),Je(this,R,me,"f"),Je(this,K,ee.identifier,"f"),this.id=ee.identifier.value,this.extensionUri=ee.extensionLocation,this.extensionPath=C.normalize((0,N.originalFSPath)(ee.extensionLocation)),this.packageJSON=ee,this.extensionKind=be,this.isFromDifferentExtensionHost=_e}get isActive(){return Oe(this,L,"f").isActivated(Oe(this,K,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Oe(this,L,"f").getExtensionExports(Oe(this,K,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Oe(this,L,"f").activateByIdWithErrors(Oe(this,K,"f"),{startup:!1,extensionId:Oe(this,R,"f"),activationEvent:"api"}),this.exports}}e.Extension=G,L=new WeakMap,R=new WeakMap,K=new WeakMap;function re(Ee,ce){return Ee.getAllExtensionDescriptions().filter(me=>ce.has(D.ExtensionIdentifier.toKey(me.identifier)))}function ge(Ee){const ce=Ee.indexOf("+");return ce===-1?Ee:Ee.substring(0,ce)}class oe{constructor(ce){this._searchTree=ce}setSearchTree(ce){this._searchTree=ce}findSubstr(ce){return this._searchTree.findSubstr(ce)}forEach(ce){return this._searchTree.forEach(ce)}}e.ExtensionPaths=oe}),define(Ce[231],Ie([1,0,72,2,4,32,28,26,11,27,3,33,59,14,9]),function(ie,e,r,C,S,N,_,A,E,P,O,w,g,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let a=class{constructor(b,t,l,i,n,o,f){this._apiFactory=b,this._extensionRegistry=t,this._instaService=l,this._extHostConfiguration=i,this._extHostExtensionService=n,this._initData=o,this._logService=f,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),r.mark("code/extHost/willWaitForConfig");const b=await this._extHostConfiguration.getConfigProvider();r.mark("code/extHost/didWaitForConfig");const t=await this._extHostExtensionService.getExtensionPathIndex();this.register(new d(this._apiFactory,t,this._extensionRegistry,b,this._logService)),this.register(this._instaService.createInstance(v,t)),this.register(this._instaService.createInstance(u)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(D,t,this._initData.environment.appUriScheme))}register(b){if("nodeModuleName"in b)if(Array.isArray(b.nodeModuleName))for(const t of b.nodeModuleName)this._factories.set(t,b);else this._factories.set(b.nodeModuleName,b);typeof b.alternativeModuleName=="function"&&this._alternatives.push(t=>b.alternativeModuleName(t))}};a=ze([$e(2,O.IInstantiationService),$e(3,N.IExtHostConfiguration),$e(4,w.IExtHostExtensionService),$e(5,P.IExtHostInitDataService),$e(6,k.ILogService)],a),e.RequireInterceptor=a;let u=class Ji{constructor(b){if(b.environment.appRoot&&Ji.aliased.size){const t=(0,m.escapeRegExpCharacters)(this.forceForwardSlashes(b.environment.appRoot.fsPath)),l="[a-z0-9_.-]",i=`@${l}+\\/${l}+|${l}+`,n="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${t}/${n}\\/)(${i})(.*)$`,"i")}}alternativeModuleName(b){if(!this.re)return;const t=this.re.exec(this.forceForwardSlashes(b));if(!t)return;const[,l,i,n]=t,o=Ji.aliased.get(i);if(o!==void 0)return console.warn(`${i} as been renamed to ${o}, please update your imports`),l+o+n}forceForwardSlashes(b){return b.replace(/\\/g,"/")}};u.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),u=ze([$e(0,P.IExtHostInitDataService)],u);class d{constructor(b,t,l,i,n){this._apiFactory=b,this._extensionPaths=t,this._extensionRegistry=l,this._configProvider=i,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(b,t){const l=this._extensionPaths.findSubstr(t);if(l){let i=this._extApiImpl.get(A.ExtensionIdentifier.toKey(l.identifier));return i||(i=this._apiFactory(l,this._extensionRegistry,this._configProvider),this._extApiImpl.set(A.ExtensionIdentifier.toKey(l.identifier),i)),i}if(!this._defaultApiImpl){let i="";this._extensionPaths.forEach((n,o)=>i+=`	${o} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${i}`),this._defaultApiImpl=this._apiFactory(_.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let v=class{constructor(b,t,l){this._extensionPaths=b,this.nodeModuleName="keytar",this._mainThreadTelemetry=t.getProxy(S.MainContext.MainThreadTelemetry);const{environment:i}=l,n=t.getProxy(S.MainContext.MainThreadKeytar);if(i.appRoot){let o=i.appRoot.fsPath;g.platform==="win32"&&(o=o.replace(/\\/g,"/")),o[o.length-1]==="/"&&(o=o.substr(0,o.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${o}/node_modules.asar/keytar`),this.alternativeNames.add(`${o}/node_modules/keytar`)}this._impl={getPassword:(o,f)=>n.$getPassword(o,f),setPassword:(o,f,s)=>n.$setPassword(o,f,s),deletePassword:(o,f)=>n.$deletePassword(o,f),findPassword:o=>n.$findPassword(o),findCredentials(o){return n.$findCredentials(o)}}}load(b,t){const l=this._extensionPaths.findSubstr(t);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:l?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(b){const t=b.length;if(t<=7||!this.alternativeNames)return;const l=t-7;if((b.charAt(l)==="/"||b.charAt(l)==="\\")&&b.endsWith("keytar")&&(b=b.replace(/\\/g,"/"),this.alternativeNames.has(b)))return"keytar"}};v=ze([$e(1,E.IExtHostRpcService),$e(2,P.IExtHostInitDataService)],v);let D=class{constructor(b,t,l){this._extensionPaths=b,this._appUriScheme=t,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=l.getProxy(S.MainContext.MainThreadTelemetry);const i=l.getProxy(S.MainContext.MainThreadWindow);this._impl=(n,o)=>{const f=C.URI.parse(n);return o?this.callOriginal(n,o):f.scheme==="http"||f.scheme==="https"?i.$openUri(f,n,{allowTunneling:!0}):f.scheme==="mailto"||f.scheme===this._appUriScheme?i.$openUri(f,n,{}):this.callOriginal(n,o)}}load(b,t,l){const i=this._extensionPaths.findSubstr(t);return i&&(this._extensionId=i.identifier.value,this.sendShimmingTelemetry()),this._original=l(b),this._impl}callOriginal(b,t){return this.sendNoForwardTelemetry(),this._original(b,t)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};D=ze([$e(2,E.IExtHostRpcService)],D)}),define(Ce[103],Ie([1,0,197,7,19,59,3,50,51,33,6,31,170,32]),function(ie,e,r,C,S,N,_,A,E,P,O,w,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,_.createDecorator)("IExtHostVariableResolverProvider");class m extends g.AbstractVariableResolverService{constructor(d,v,D,c,b,t,l){function i(){if(D){const n=D.activeEditor();if(n)return n.document.uri;const o=c.tabGroups.all.find(f=>f.isActive)?.activeTab;if(o!==void 0){if(o.input instanceof O.TextDiffTabInput||o.input instanceof O.NotebookDiffEditorTabInput)return o.input.modified;if(o.input instanceof O.TextTabInput||o.input instanceof O.NotebookEditorTabInput||o.input instanceof O.CustomEditorTabInput)return o.input.uri}}}super({getFolderUri:n=>{const o=t.folders.filter(f=>f.name===n);if(o&&o.length>0)return o[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(n,o)=>b.getConfiguration(void 0,n).get(o),getAppRoot:()=>N.cwd(),getExecPath:()=>N.env.VSCODE_EXEC_PATH,getFilePath:()=>{const n=i();if(n)return S.normalize(n.fsPath)},getWorkspaceFolderPathForFile:()=>{if(v){const n=i();if(n){const o=v.getWorkspaceFolder(n);if(o)return S.normalize(o.uri.fsPath)}}},getSelectedText:()=>{if(D){const n=D.activeEditor();if(n&&!n.selection.isEmpty)return n.document.getText(n.selection)}},getLineNumber:()=>{if(D){const n=D.activeEditor();if(n)return String(n.selection.end.line+1)}},getExtension:n=>d.getExtension(n)},void 0,l?Promise.resolve(l):void 0,Promise.resolve(N.env))}}let a=class extends C.Disposable{constructor(d,v,D,c,b){super(),this.extensionService=d,this.workspaceService=v,this.editorService=D,this.configurationService=c,this.editorTabs=b,this._resolver=new r.Lazy(async()=>{const t=await this.configurationService.getConfigProvider(),i={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async n=>{i.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new m(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,t,i,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};a=ze([$e(0,P.IExtHostExtensionService),$e(1,w.IExtHostWorkspace),$e(2,A.IExtHostDocumentsAndEditors),$e(3,k.IExtHostConfiguration),$e(4,E.IExtHostEditorTabs)],a),e.ExtHostVariableResolverProviderService=a}),define(Ce[104],Ie([1,0,15,5,10,2,3,4,51,33,11,6,31,163,165,32,103]),function(ie,e,r,C,S,N,_,A,E,P,O,w,g,k,m,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,_.createDecorator)("IExtHostDebugService");let d=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(i,n,o,f,s,h){this._workspaceService=n,this._extensionService=o,this._configurationService=f,this._editorTabs=s,this._variableResolver=h,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new C.Emitter,this._onDidTerminateDebugSession=new C.Emitter,this._onDidChangeActiveDebugSession=new C.Emitter,this._onDidReceiveDebugSessionCustomEvent=new C.Emitter,this._debugServiceProxy=i.getProxy(A.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new C.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new D(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(p=>{p.onDidChange(T=>{this.registerAllDebugTypes(p)}),this.registerAllDebugTypes(p)})}asDebugSourceUri(i,n){const o=i;if(typeof o.sourceReference=="number"&&o.sourceReference>0){let f=`debug:${encodeURIComponent(o.path||"")}`,s="?";return n&&(f+=`${s}session=${encodeURIComponent(n.id)}`,s="&"),f+=`${s}ref=${o.sourceReference}`,N.URI.parse(f)}else{if(o.path)return N.URI.file(o.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(i){const n=[];for(const o of i.getAllExtensionDescriptions())if(o.contributes){const f=o.contributes.debuggers;if(f&&f.length>0)for(const s of f)(0,m.isDebuggerMainContribution)(s)&&n.push(s.type)}this._debugServiceProxy.$registerDebugTypes(n)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const i=[];return this._breakpoints.forEach(n=>i.push(n)),i}addBreakpoints(i){this.startBreakpoints();const n=i.filter(s=>{const h=s.id;return this._breakpoints.has(h)?!1:(this._breakpoints.set(h,s),!0)});this.fireBreakpointChanges(n,[],[]);const o=[],f=new Map;for(const s of n)if(s instanceof w.SourceBreakpoint){let h=f.get(s.location.uri.toString());h||(h={type:"sourceMulti",uri:s.location.uri,lines:[]},f.set(s.location.uri.toString(),h),o.push(h)),h.lines.push({id:s.id,enabled:s.enabled,condition:s.condition,hitCondition:s.hitCondition,logMessage:s.logMessage,line:s.location.range.start.line,character:s.location.range.start.character})}else s instanceof w.FunctionBreakpoint&&o.push({type:"function",id:s.id,enabled:s.enabled,hitCondition:s.hitCondition,logMessage:s.logMessage,condition:s.condition,functionName:s.functionName});return this._debugServiceProxy.$registerBreakpoints(o)}removeBreakpoints(i){this.startBreakpoints();const n=i.filter(h=>this._breakpoints.delete(h.id));this.fireBreakpointChanges([],n,[]);const o=n.filter(h=>h instanceof w.SourceBreakpoint).map(h=>h.id),f=n.filter(h=>h instanceof w.FunctionBreakpoint).map(h=>h.id),s=n.filter(h=>h instanceof w.DataBreakpoint).map(h=>h.id);return this._debugServiceProxy.$unregisterBreakpoints(o,f,s)}startDebugging(i,n,o){return this._debugServiceProxy.$startDebugging(i?i.uri:void 0,n,{parentSessionID:o.parentSession?o.parentSession.id:void 0,lifecycleManagedByParent:o.lifecycleManagedByParent,repl:o.consoleMode===w.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:o.noDebug,compact:o.compact,debugUI:o.debugUI,suppressSaveBeforeStart:o.suppressSaveBeforeStart})}stopDebugging(i){return this._debugServiceProxy.$stopDebugging(i?i.id:void 0)}registerDebugConfigurationProvider(i,n,o){if(!n)return new w.Disposable(()=>{});const f=this._configProviderHandleCounter++;return this._configProviders.push({type:i,handle:f,provider:n}),this._debugServiceProxy.$registerDebugConfigurationProvider(i,o,!!n.provideDebugConfigurations,!!n.resolveDebugConfiguration,!!n.resolveDebugConfigurationWithSubstitutedVariables,f),new w.Disposable(()=>{this._configProviders=this._configProviders.filter(s=>s.provider!==n),this._debugServiceProxy.$unregisterDebugConfigurationProvider(f)})}registerDebugAdapterDescriptorFactory(i,n,o){if(!o)return new w.Disposable(()=>{});if(!this.definesDebugType(i,n))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${n}' debugger.`);if(this.getAdapterDescriptorFactoryByType(n))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const f=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:n,handle:f,factory:o}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(n,f),new w.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(s=>s.factory!==o),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(f)})}registerDebugAdapterTrackerFactory(i,n){if(!n)return new w.Disposable(()=>{});const o=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:i,handle:o,factory:n}),new w.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(f=>f.factory!==n)})}async $runInTerminal(i,n){return Promise.resolve(void 0)}async $substituteVariables(i,n){let o;const f=await this.getFolder(i);return f&&(o={uri:f.uri,name:f.name,index:f.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(o,n)}createDebugAdapter(i,n){if(i.type==="implementation")return new b(i.implementation)}createSignService(){}async $startDASession(i,n){const o=this,f=await this.getSession(n);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(f.type),f).then(s=>{if(!s)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${f.type}' (extension might have failed to activate)`);const h=this.convertToDto(s),p=this.createDebugAdapter(h,f);if(!p)throw new Error(`Couldn't create a debug adapter for type '${f.type}'.`);const T=p;return this._debugAdapters.set(i,T),this.getDebugAdapterTrackers(f).then(M=>(M&&this._debugAdaptersTrackers.set(i,M),T.onMessage(async V=>{if(V.type==="request"&&V.command==="handshake"){const U=V,y={type:"response",seq:0,command:U.command,request_seq:U.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const x=await this._signService.sign(U.arguments.value);y.body={signature:x},T.sendResponse(y)}else throw new Error("no signer")}catch(x){y.success=!1,y.message=x.message,T.sendResponse(y)}}else M&&M.onDidSendMessage&&M.onDidSendMessage(V),V=(0,m.convertToVSCPaths)(V,!0),o._debugServiceProxy.$acceptDAMessage(i,V)}),T.onError(V=>{M&&M.onError&&M.onError(V),this._debugServiceProxy.$acceptDAError(i,V.name,V.message,V.stack)}),T.onExit(V=>{M&&M.onExit&&M.onExit((0,S.withNullAsUndefined)(V),void 0),this._debugServiceProxy.$acceptDAExit(i,(0,S.withNullAsUndefined)(V),void 0)}),M&&M.onWillStartSession&&M.onWillStartSession(),T.startSession()))})}$sendDAMessage(i,n){n=(0,m.convertToDAPaths)(n,!1);const o=this._debugAdaptersTrackers.get(i);o&&o.onWillReceiveMessage&&o.onWillReceiveMessage(n),this._debugAdapters.get(i)?.sendMessage(n)}$stopDASession(i){const n=this._debugAdaptersTrackers.get(i);this._debugAdaptersTrackers.delete(i),n&&n.onWillStopSession&&n.onWillStopSession();const o=this._debugAdapters.get(i);return this._debugAdapters.delete(i),o?o.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(i){const n=[],o=[],f=[];if(i.added)for(const s of i.added){const h=s.id;if(h&&!this._breakpoints.has(h)){let p;if(s.type==="function")p=new w.FunctionBreakpoint(s.functionName,s.enabled,s.condition,s.hitCondition,s.logMessage);else if(s.type==="data")p=new w.DataBreakpoint(s.label,s.dataId,s.canPersist,s.enabled,s.hitCondition,s.condition,s.logMessage);else{const T=N.URI.revive(s.uri);p=new w.SourceBreakpoint(new w.Location(T,new w.Position(s.line,s.character)),s.enabled,s.condition,s.hitCondition,s.logMessage)}p._id=h,this._breakpoints.set(h,p),n.push(p)}}if(i.removed)for(const s of i.removed){const h=this._breakpoints.get(s);h&&(this._breakpoints.delete(s),o.push(h))}if(i.changed){for(const s of i.changed)if(s.id){const h=this._breakpoints.get(s.id);if(h){if(h instanceof w.FunctionBreakpoint&&s.type==="function"){const p=h;p.enabled=s.enabled,p.condition=s.condition,p.hitCondition=s.hitCondition,p.logMessage=s.logMessage,p.functionName=s.functionName}else if(h instanceof w.SourceBreakpoint&&s.type==="source"){const p=h;p.enabled=s.enabled,p.condition=s.condition,p.hitCondition=s.hitCondition,p.logMessage=s.logMessage,p.location=new w.Location(N.URI.revive(s.uri),new w.Position(s.line,s.character))}f.push(h)}}}this.fireBreakpointChanges(n,o,f)}$provideDebugConfigurations(i,n,o){return(0,r.asPromise)(async()=>{const f=this.getConfigProviderByHandle(i);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const s=await this.getFolder(n);return f.provideDebugConfigurations(s,o)}).then(f=>{if(!f)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return f})}$resolveDebugConfiguration(i,n,o,f){return(0,r.asPromise)(async()=>{const s=this.getConfigProviderByHandle(i);if(!s)throw new Error("no DebugConfigurationProvider found");if(!s.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const h=await this.getFolder(n);return s.resolveDebugConfiguration(h,o,f)})}$resolveDebugConfigurationWithSubstitutedVariables(i,n,o,f){return(0,r.asPromise)(async()=>{const s=this.getConfigProviderByHandle(i);if(!s)throw new Error("no DebugConfigurationProvider found");if(!s.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const h=await this.getFolder(n);return s.resolveDebugConfigurationWithSubstitutedVariables(h,o,f)})}async $provideDebugAdapter(i,n){const o=this.getAdapterDescriptorFactoryByHandle(i);if(!o)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const f=await this.getSession(n);return this.getAdapterDescriptor(o,f).then(s=>{if(!s)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${f.type}'`);return this.convertToDto(s)})}async $acceptDebugSessionStarted(i){const n=await this.getSession(i);this._onDidStartDebugSession.fire(n)}async $acceptDebugSessionTerminated(i){const n=await this.getSession(i);n&&(this._onDidTerminateDebugSession.fire(n),this._debugSessions.delete(n.id))}async $acceptDebugSessionActiveChanged(i){this._activeDebugSession=i?await this.getSession(i):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(i,n){(await this.getSession(i))?._acceptNameChanged(n)}async $acceptDebugSessionCustomEvent(i,n){const f={session:await this.getSession(i),event:n.event,body:n.body};this._onDidReceiveDebugSessionCustomEvent.fire(f)}convertToDto(i){if(i instanceof w.DebugAdapterExecutable)return{type:"executable",command:i.command,args:i.args,options:i.options};if(i instanceof w.DebugAdapterServer)return{type:"server",port:i.port,host:i.host};if(i instanceof w.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:i.path};if(i instanceof w.DebugAdapterInlineImplementation)return{type:"implementation",implementation:i.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(i){const n=this._adapterFactories.filter(o=>o.type===i);if(n.length>0)return n[0].factory}getAdapterDescriptorFactoryByHandle(i){const n=this._adapterFactories.filter(o=>o.handle===i);if(n.length>0)return n[0].factory}getConfigProviderByHandle(i){const n=this._configProviders.filter(o=>o.handle===i);if(n.length>0)return n[0].provider}definesDebugType(i,n){if(i.contributes){const o=i.contributes.debuggers;if(o&&o.length>0){for(const f of o)if(f.label&&f.type&&f.type===n)return!0}}return!1}getDebugAdapterTrackers(i){const o=i.configuration.type,f=this._trackerFactories.filter(s=>s.type===o||s.type==="*").map(s=>(0,r.asPromise)(()=>s.factory.createDebugAdapterTracker(i)).then(h=>h,h=>null));return Promise.race([Promise.all(f).then(s=>{const h=s.filter(p=>!!p);if(h.length>0)return new c(h)}),new Promise((s,h)=>{const p=setTimeout(()=>{clearTimeout(p),h(new Error("timeout"))},1e3)})]).catch(s=>{})}async getAdapterDescriptor(i,n){const o=n.configuration.debugServer;if(typeof o=="number")return Promise.resolve(new w.DebugAdapterServer(o));if(i){const s=await this._extensionService.getExtensionRegistry();return(0,r.asPromise)(()=>i.createDebugAdapterDescriptor(n,this.daExecutableFromPackage(n,s))).then(h=>{if(h)return h})}const f=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(n,f))}daExecutableFromPackage(i,n){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(i,n,o){(i.length>0||n.length>0||o.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:i,removed:n,changed:o}))}async getSession(i){if(i)if(typeof i=="string"){const n=this._debugSessions.get(i);if(n)return n}else{let n=this._debugSessions.get(i.id);if(!n){const o=await this.getFolder(i.folderUri),f=i.parent?this._debugSessions.get(i.parent):void 0;n=new v(this._debugServiceProxy,i.id,i.type,i.name,o,i.configuration,f),this._debugSessions.set(n.id,n),this._debugServiceProxy.$sessionCached(n.id)}return n}throw new Error("cannot find session")}getFolder(i){if(i){const n=N.URI.revive(i);return this._workspaceService.resolveWorkspaceFolder(n)}return Promise.resolve(void 0)}};d=ze([$e(0,O.IExtHostRpcService),$e(1,g.IExtHostWorkspace),$e(2,P.IExtHostExtensionService),$e(3,a.IExtHostConfiguration),$e(4,E.IExtHostEditorTabs),$e(5,u.IExtHostVariableResolverProvider)],d),e.ExtHostDebugServiceBase=d;class v{constructor(i,n,o,f,s,h,p){this._debugServiceProxy=i,this._id=n,this._type=o,this._name=f,this._workspaceFolder=s,this._configuration=h,this._parentSession=p}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(i){this._name=i,this._debugServiceProxy.$setDebugSessionName(this._id,i)}get parentSession(){return this._parentSession}_acceptNameChanged(i){this._name=i}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(i,n){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,i,n)}getDebugProtocolBreakpoint(i){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,i.id)}}e.ExtHostDebugSession=v;class D{constructor(i){this.value=Object.freeze({append(n){i.$appendDebugConsole(n)},appendLine(n){this.append(n+`
`)}})}}e.ExtHostDebugConsole=D;class c{constructor(i){this.trackers=i}onWillStartSession(){this.trackers.forEach(i=>i.onWillStartSession?i.onWillStartSession():void 0)}onWillReceiveMessage(i){this.trackers.forEach(n=>n.onWillReceiveMessage?n.onWillReceiveMessage(i):void 0)}onDidSendMessage(i){this.trackers.forEach(n=>n.onDidSendMessage?n.onDidSendMessage(i):void 0)}onWillStopSession(){this.trackers.forEach(i=>i.onWillStopSession?i.onWillStopSession():void 0)}onError(i){this.trackers.forEach(n=>n.onError?n.onError(i):void 0)}onExit(i,n){this.trackers.forEach(o=>o.onExit?o.onExit(i,n):void 0)}}class b extends k.AbstractDebugAdapter{constructor(i){super(),this.implementation=i,i.onDidSendMessage(n=>{this.acceptMessage(n)})}startSession(){return Promise.resolve(void 0)}sendMessage(i){this.implementation.handleMessage(i)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let t=class extends d{constructor(i,n,o,f,s,h){super(i,n,o,f,s,h)}};t=ze([$e(0,O.IExtHostRpcService),$e(1,g.IExtHostWorkspace),$e(2,P.IExtHostExtensionService),$e(3,a.IExtHostConfiguration),$e(4,E.IExtHostEditorTabs),$e(5,u.IExtHostVariableResolverProvider)],t),e.WorkerExtHostDebugService=t}),define(Ce[232],Ie([1,0,12,72,2,4,223,14,56,58,27,148,11,47,33]),function(ie,e,r,C,S,N,_,A,E,P,O,w,g,k,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class a{constructor(d,v,D,c,b){this._hostUtils=D,this._rpcProtocol=new _.RPCProtocol(d,null,c),v=a._transform(v,this._rpcProtocol);const t=new P.ServiceCollection(...(0,E.getSingletonServiceDescriptors)());t.set(O.IExtHostInitDataService,{_serviceBrand:void 0,...v,messagePorts:b}),t.set(g.IExtHostRpcService,new g.ExtHostRpcService(this._rpcProtocol)),t.set(k.IURITransformerService,new k.URITransformerService(c)),t.set(m.IHostUtils,D);const l=new w.InstantiationService(t,!0);this._logService=l.invokeFunction(f=>f.get(A.ILogService)),C.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",v),this._extensionService=l.invokeFunction(f=>f.get(m.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const i=new WeakMap;this._extensionService.getExtensionPathIndex().then(f=>{Error.prepareStackTrace=(s,h)=>{let p="",T,M;for(const V of h)p+=`
	at ${V.toString()}`,M=V.getFileName(),!T&&M&&(T=f.findSubstr(S.URI.file(M)));return i.set(s,T),`${s.name||"Error"}: ${s.message||""}${p}`}});const n=this._rpcProtocol.getProxy(N.MainContext.MainThreadExtensionService),o=this._rpcProtocol.getProxy(N.MainContext.MainThreadErrors);r.setUnexpectedErrorHandler(f=>{const s=r.transformErrorForSerialization(f),h=i.get(f);h?n.$onExtensionRuntimeError(h.identifier,s):o.$onUnexpectedError(s)})}async asBrowserUri(d){const v=this._rpcProtocol.getProxy(N.MainContext.MainThreadExtensionService);return S.URI.revive(await v.$asBrowserUri(d))}terminate(d){this._extensionService.terminate(d)}static _transform(d,v){d.allExtensions.forEach(c=>{c.extensionLocation=S.URI.revive(v.transformIncomingURIs(c.extensionLocation));const b={};c.browserNlsBundleUris&&(Object.keys(c.browserNlsBundleUris).forEach(t=>b[t]=S.URI.revive(v.transformIncomingURIs(c.browserNlsBundleUris[t]))),c.browserNlsBundleUris=b)}),d.environment.appRoot=S.URI.revive(v.transformIncomingURIs(d.environment.appRoot));const D=d.environment.extensionDevelopmentLocationURI;return D&&(d.environment.extensionDevelopmentLocationURI=D.map(c=>S.URI.revive(v.transformIncomingURIs(c)))),d.environment.extensionTestsLocationURI=S.URI.revive(v.transformIncomingURIs(d.environment.extensionTestsLocationURI)),d.environment.globalStorageHome=S.URI.revive(v.transformIncomingURIs(d.environment.globalStorageHome)),d.environment.workspaceStorageHome=S.URI.revive(v.transformIncomingURIs(d.environment.workspaceStorageHome)),d.nlsBaseUrl=S.URI.revive(v.transformIncomingURIs(d.nlsBaseUrl)),d.logsLocation=S.URI.revive(v.transformIncomingURIs(d.logsLocation)),d.logFile=S.URI.revive(v.transformIncomingURIs(d.logFile)),d.workspace=v.transformIncomingURIs(d.workspace),d}}e.ExtensionHostMain=a}),define(Ce[233],Ie([1,0,18,15,20,44,13,19,22,2,42]),function(ie,e,r,C,S,N,_,A,E,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class w{constructor(v,D,c,b){this.query=v,this.provider=D,this.fileUtils=c,this.processType=b,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(v,D){const c=this.query.folderQueries||[],b=new S.CancellationTokenSource;return D.onCancellationRequested(()=>b.cancel()),new Promise((t,l)=>{this.collector=new k(v);let i=!1;const n=(o,f)=>{if(!i&&!this.isLimitHit){const s=this.resultSize(o);a(o)&&typeof this.query.maxResults=="number"&&this.resultCount+s>this.query.maxResults&&(this.isLimitHit=!0,i=!0,b.cancel(),o=this.trimResultToSize(o,this.query.maxResults-this.resultCount));const h=this.resultSize(o);this.resultCount+=h,(h>0||!a(o))&&this.collector.add(o,f)}};Promise.all(c.map((o,f)=>this.searchInFolder(o,s=>n(s,f),b.token))).then(o=>{b.dispose(),this.collector.flush();const f=o.some(s=>!!s&&!!s.limitHit);t({limitHit:this.isLimitHit||f,messages:(0,r.flatten)(o.map(s=>s?.message?Array.isArray(s.message)?s.message:[s.message]:[])),stats:{type:this.processType}})},o=>{b.dispose();const f=(0,N.toErrorMessage)(o);l(new Error(f))})})}resultSize(v){return a(v)?Array.isArray(v.ranges)?v.ranges.length:1:0}trimResultToSize(v,D){const c=Array.isArray(v.ranges)?v.ranges:[v.ranges],b=Array.isArray(v.preview.matches)?v.preview.matches:[v.preview.matches];return{ranges:c.slice(0,D),preview:{matches:b.slice(0,D),text:v.preview.text},uri:v.uri}}async searchInFolder(v,D,c){const b=new O.QueryGlobTester(this.query,v),t=[],l={report:o=>{if(!this.validateProviderResult(o))return;const f=v.folder.scheme===_.Schemas.file?(0,O.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(E.dirname(o.uri))):void 0,s=E.relativePath(v.folder,o.uri);if(s){const h=b.includedInQuery(s,A.basename(s),f);(0,C.isThenable)(h)?t.push(h.then(p=>{p&&D(o)})):h&&D(o)}}},i=this.getSearchOptionsForFolder(v),n=await this.provider.provideTextSearchResults(g(this.query.contentPattern),i,l,c);return t.length&&await Promise.all(t),n}validateProviderResult(v){if(a(v)){if(Array.isArray(v.ranges)){if(!Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(v.preview.matches.length!==v.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(v){const D=(0,O.resolvePatternsForProvider)(this.query.includePattern,v.includePattern),c=(0,O.resolvePatternsForProvider)(this.query.excludePattern,v.excludePattern),b={folder:P.URI.from(v.folder),excludes:c,includes:D,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,encoding:v.fileEncoding&&this.fileUtils.toCanonicalName(v.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return b.usePCRE2=this.query.usePCRE2,b}}e.TextSearchManager=w;function g(d){return{isCaseSensitive:d.isCaseSensitive||!1,isRegExp:d.isRegExp||!1,isWordMatch:d.isWordMatch||!1,isMultiline:d.isMultiline||!1,pattern:d.pattern}}class k{constructor(v){this._onResult=v,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new u(512,D=>this.sendItems(D))}add(v,D){this._currentFileMatch&&(this._currentFolderIdx!==D||!E.isEqual(this._currentUri,v.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=D,this._currentFileMatch={resource:v.uri,results:[]}),this._currentFileMatch.results.push(m(v))}pushToCollector(){const v=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,v)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(v){this._onResult(v)}}e.TextSearchResultsCollector=k;function m(d){return a(d)?{preview:{matches:(0,r.mapArrayOrNot)(d.preview.matches,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character})),text:d.preview.text},ranges:(0,r.mapArrayOrNot)(d.ranges,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character}))}:{text:d.text,lineNumber:d.lineNumber}}function a(d){return!!d.preview}e.extensionResultIsMatch=a;class u{constructor(v,D){this.maxBatchSize=v,this.cb=D,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(v,D){!v||this.addItemToBatch(v,D)}addItems(v,D){!v||this.addItemsToBatch(v,D)}addItemToBatch(v,D){this.batch.push(v),this.batchSize+=D,this.onUpdate()}addItemsToBatch(v,D){this.batch=this.batch.concat(v),this.batchSize+=D,this.onUpdate()}onUpdate(){this.totalNumberCompleted<u.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},u.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=u,u.TIMEOUT=4e3,u.START_BATCH_AFTER_COUNT=50}),define(Ce[105],Ie([1,0,7,4,3,228,11,47,14,2,233]),function(ie,e,r,C,S,N,_,A,E,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,S.createDecorator)("IExtHostSearch");let w=class{constructor(a,u,d){this.extHostRpc=a,this._uriTransformer=u,this._logService=d,this._proxy=this.extHostRpc.getProxy(C.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new N.FileSearchManager}_transformScheme(a){return this._uriTransformer.transformOutgoingScheme(a)}registerTextSearchProvider(a,u){if(this._textSearchUsedSchemes.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this._textSearchUsedSchemes.add(a);const d=this._handlePool++;return this._textSearchProvider.set(d,u),this._proxy.$registerTextSearchProvider(d,this._transformScheme(a)),(0,r.toDisposable)(()=>{this._textSearchUsedSchemes.delete(a),this._textSearchProvider.delete(d),this._proxy.$unregisterProvider(d)})}registerFileSearchProvider(a,u){if(this._fileSearchUsedSchemes.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this._fileSearchUsedSchemes.add(a);const d=this._handlePool++;return this._fileSearchProvider.set(d,u),this._proxy.$registerFileSearchProvider(d,this._transformScheme(a)),(0,r.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(a),this._fileSearchProvider.delete(d),this._proxy.$unregisterProvider(d)})}$provideFileSearchResults(a,u,d,v){const D=g(d),c=this._fileSearchProvider.get(a);if(c)return this._fileSearchManager.fileSearch(D,c,b=>{this._proxy.$handleFileMatch(a,u,b.map(t=>t.resource))},v);throw new Error("unknown provider: "+a)}$clearCache(a){return this._fileSearchManager.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,u,d,v){const D=this._textSearchProvider.get(a);if(!D||!D.provideTextSearchResults)throw new Error(`Unknown provider ${a}`);const c=g(d);return this.createTextSearchManager(c,D).search(t=>this._proxy.$handleTextMatch(a,u,t),v)}$enableExtensionHostSearch(){}createTextSearchManager(a,u){return new O.TextSearchManager(a,u,{readdir:d=>Promise.resolve([]),toCanonicalName:d=>d},"textSearchProvider")}};w=ze([$e(0,_.IExtHostRpcService),$e(1,A.IURITransformerService),$e(2,E.ILogService)],w),e.ExtHostSearch=w;function g(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(k),extraFileResources:m.extraFileResources&&m.extraFileResources.map(a=>P.URI.revive(a))}}e.reviveQuery=g;function k(m){return{...m,folder:P.URI.revive(m.folder)}}}),define(Ce[234],Ie([1,0,56,100,31,97,32,37,50,53,102,104,105,70,62,67,99,52,36,69,88,51,205,14,175,103,98,68]),function(ie,e,r,C,S,N,_,A,E,P,O,w,g,k,m,a,u,d,v,D,c,b,t,l,i,n,o,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.registerSingleton)(f.IExtHostLocalizationService,f.ExtHostLocalizationService,1),(0,r.registerSingleton)(l.ILoggerService,t.ExtHostLoggerService,1),(0,r.registerSingleton)(l.ILogService,i.ExtHostLogService,1),(0,r.registerSingleton)(a.IExtHostApiDeprecationService,a.ExtHostApiDeprecationService,!1),(0,r.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands,!1),(0,r.registerSingleton)(_.IExtHostConfiguration,_.ExtHostConfiguration,!1),(0,r.registerSingleton)(d.IExtHostConsumerFileSystem,d.ExtHostConsumerFileSystem,!1),(0,r.registerSingleton)(w.IExtHostDebugService,w.WorkerExtHostDebugService,!1),(0,r.registerSingleton)(N.IExtHostDecorations,N.ExtHostDecorations,!1),(0,r.registerSingleton)(E.IExtHostDocumentsAndEditors,E.ExtHostDocumentsAndEditors,!1),(0,r.registerSingleton)(v.IExtHostFileSystemInfo,v.ExtHostFileSystemInfo,!1),(0,r.registerSingleton)(C.IExtHostOutputService,C.ExtHostOutputService,1),(0,r.registerSingleton)(g.IExtHostSearch,g.ExtHostSearch,!1),(0,r.registerSingleton)(k.IExtHostStorage,k.ExtHostStorage,!1),(0,r.registerSingleton)(O.IExtHostTask,O.WorkerExtHostTask,!1),(0,r.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService,!1),(0,r.registerSingleton)(m.IExtHostTunnelService,m.ExtHostTunnelService,!1),(0,r.registerSingleton)(u.IExtHostWindow,u.ExtHostWindow,!1),(0,r.registerSingleton)(S.IExtHostWorkspace,S.ExtHostWorkspace,!1),(0,r.registerSingleton)(D.IExtHostSecretState,D.ExtHostSecretState,!1),(0,r.registerSingleton)(c.IExtHostTelemetry,c.ExtHostTelemetry,!1),(0,r.registerSingleton)(o.IExtHostTelemetryLogService,o.ExtHostTelemetryLogService,!1),(0,r.registerSingleton)(b.IExtHostEditorTabs,b.ExtHostEditorTabs,!1),(0,r.registerSingleton)(n.IExtHostVariableResolverProvider,n.ExtHostVariableResolverProviderService,!1)}),define(Ce[235],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class r{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(S){if(S&&this._dragOperations.has(S)){const N=this._dragOperations.get(S);return this._dragOperations.delete(S),N}}addDragOperationTransfer(S,N){this._dragOperations.set(S,N)}getRenderedTreeElement(S){if(this._renderedElements.has(S))return this._renderedElements.get(S)}addRenderedTreeItemElement(S,N){this._renderedElements.set(S,N)}removeRenderedTreeItemElement(S){this._renderedElements.has(S)&&this._renderedElements.delete(S)}}e.TreeviewsService=r}),define(Ce[236],Ie([1,0,135,6,22,2,5,7,15,6,10,18,8,20,235,28]),function(ie,e,r,C,S,N,_,A,E,P,O,w,g,k,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function u(D,c){if((0,O.isString)(D))return{label:D};if(D&&typeof D=="object"&&typeof D.label=="string"){let b;return Array.isArray(D.highlights)&&(b=D.highlights.filter(t=>t.length===2&&typeof t[0]=="number"&&typeof t[1]=="number"),b=b.length?b:void 0),{label:D.label,highlights:b}}}class d{constructor(c,b,t){this._proxy=c,this.commands=b,this.logService=t,this.treeViews=new Map,this.treeDragAndDropService=new m.TreeviewsService;function l(i){return i&&i.$treeViewId&&(i.$treeItemHandle||i.$selectedTreeItems||i.$focusedTreeItem)}b.registerArgumentProcessor({processArgument:i=>l(i)?this.convertArgument(i):Array.isArray(i)&&i.length>0?i.map(n=>l(n)?this.convertArgument(n):n):i})}registerTreeDataProvider(c,b,t){const l=this.createTreeView(c,{treeDataProvider:b},t);return{dispose:()=>l.dispose()}}createTreeView(c,b,t){if(!b||!b.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const l=b.dragAndDropController?.dropMimeTypes??[],i=b.dragAndDropController?.dragMimeTypes??[],n=!!b.dragAndDropController?.handleDrag,o=!!b.dragAndDropController?.handleDrop,f=this.createExtHostTreeView(c,b,t),s=this._proxy.$registerTreeViewDataProvider(c,{showCollapseAll:!!b.showCollapseAll,canSelectMany:!!b.canSelectMany,dropMimeTypes:l,dragMimeTypes:i,hasHandleDrag:n,hasHandleDrop:o});return{get onDidCollapseElement(){return f.onDidCollapseElement},get onDidExpandElement(){return f.onDidExpandElement},get selection(){return f.selectedElements},get onDidChangeSelection(){return f.onDidChangeSelection},get visible(){return f.visible},get onDidChangeVisibility(){return f.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,a.checkProposedApiEnabled)(t,"treeItemCheckbox"),f.onDidChangeCheckboxState},get message(){return f.message},set message(h){f.message=h},get title(){return f.title},set title(h){f.title=h},get description(){return f.description},set description(h){f.description=h},get badge(){return f.badge},set badge(h){P.ViewBadge.isViewBadge(h)&&(f.badge={value:Math.floor(Math.abs(h.value)),tooltip:h.tooltip})},reveal:(h,p)=>f.reveal(h,p),dispose:async()=>{await s,this.treeViews.delete(c),f.dispose()}}}$getChildren(c,b){const t=this.treeViews.get(c);return t?t.getChildren(b):Promise.reject(new Error((0,r.localize)(0,null,c)))}async $handleDrop(c,b,t,l,i,n,o,f){const s=this.treeViews.get(c);if(!s)return Promise.reject(new Error((0,r.localize)(1,null,c)));const h=g.DataTransfer.toDataTransfer(t,async p=>(await this._proxy.$resolveDropFileData(c,b,p)).buffer);return o===c&&f&&await this.addAdditionalTransferItems(h,s,f,i,n),s.onDrop(h,l,i)}async addAdditionalTransferItems(c,b,t,l,i){const n=this.treeDragAndDropService.removeDragOperationTransfer(i);if(n)(await n)?.forEach((o,f)=>{o&&c.set(f,o)});else if(i&&b.handleDrag){const o=b.handleDrag(t,c,l);this.treeDragAndDropService.addDragOperationTransfer(i,o),await o}return c}async $handleDrag(c,b,t,l){const i=this.treeViews.get(c);if(!i)return Promise.reject(new Error((0,r.localize)(2,null,c)));const n=await this.addAdditionalTransferItems(new C.DataTransfer,i,b,l,t);if(!!n)return g.DataTransfer.toDataTransferDTO(n)}async $hasResolve(c){const b=this.treeViews.get(c);if(!b)throw new Error((0,r.localize)(3,null,c));return b.hasResolve}$resolve(c,b,t){const l=this.treeViews.get(c);if(!l)throw new Error((0,r.localize)(4,null,c));return l.resolveTreeItem(b,t)}$setExpanded(c,b,t){const l=this.treeViews.get(c);if(!l)throw new Error((0,r.localize)(5,null,c));l.setExpanded(b,t)}$setSelection(c,b){const t=this.treeViews.get(c);if(!t)throw new Error((0,r.localize)(6,null,c));t.setSelection(b)}$setFocus(c,b){const t=this.treeViews.get(c);if(!t)throw new Error((0,r.localize)(7,null,c));t.setFocus(b)}$setVisible(c,b){const t=this.treeViews.get(c);if(!t)throw new Error((0,r.localize)(8,null,c));t.setVisible(b)}$changeCheckboxState(c,b){const t=this.treeViews.get(c);if(!t)throw new Error((0,r.localize)(9,null,c));t.setCheckboxState(b)}createExtHostTreeView(c,b,t){const l=new v(c,b,this._proxy,this.commands.converter,this.logService,t);return this.treeViews.set(c,l),l}convertArgument(c){const b=this.treeViews.get(c.$treeViewId);return b&&"$treeItemHandle"in c?b.getExtensionElement(c.$treeItemHandle):b&&"$focusedTreeItem"in c&&c.$focusedTreeItem?b.focusedElement:null}}e.ExtHostTreeViews=d;class v extends A.Disposable{get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(c=>this.getExtensionElement(c)).filter(c=>!(0,O.isUndefinedOrNull)(c))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(c,b,t,l,i,n){if(super(),this.viewId=c,this.proxy=t,this.commands=l,this.logService=i,this.extension=n,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new _.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new _.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new _.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new _.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new _.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new _.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new k.CancellationTokenSource,n.contributes&&n.contributes.views)for(const s in n.contributes.views)for(const h of n.contributes.views[s])h.id===c&&(this._title=h.name);this.dataProvider=b.treeDataProvider,this.dndController=b.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(s=>this._onDidChangeData.fire({message:!1,element:s})));let o,f;this._register(_.Event.debounce(this._onDidChangeData.event,(s,h)=>(s||(s={message:!1,elements:[]}),h.element!==!1&&(o||(o=new Promise(p=>f=p),this.refreshPromise=this.refreshPromise.then(()=>o)),Array.isArray(h.element)?s.elements.push(...h.element):s.elements.push(h.element)),h.message&&(s.message=!0),s),200,!0)(({message:s,elements:h})=>{h.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const p=f;return o=null,this.refresh(h).then(()=>p())})),s&&this.proxy.$setMessage(this.viewId,this._message)}))}async getChildren(c){const b=c?this.getExtensionElement(c):void 0;if(c&&!b)return this.logService.error(`No tree item with id '${c}' found.`),Promise.resolve([]);let t=this.getChildrenNodes(c);return t||(t=await this.fetchChildrenNodes(b)),t?t.map(l=>l.item):void 0}getExtensionElement(c){return this.elements.get(c)}reveal(c,b){b=b||{select:!0,focus:!1};const t=(0,O.isUndefinedOrNull)(b.select)?!0:b.select,l=(0,O.isUndefinedOrNull)(b.focus)?!1:b.focus,i=(0,O.isUndefinedOrNull)(b.expand)?!1:b.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):c?this.refreshPromise.then(()=>this.resolveUnknownParentChain(c)).then(n=>this.resolveTreeNode(c,n[n.length-1]).then(o=>this.proxy.$reveal(this.viewId,{item:o.item,parentChain:n.map(f=>f.item)},{select:t,focus:l,expand:i})),n=>this.logService.error(n)):this.proxy.$reveal(this.viewId,void 0,{select:t,focus:l,expand:i})}get message(){return this._message}set message(c){this._message=c,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(c){this._title=c,this.proxy.$setTitle(this.viewId,c,this._description)}get description(){return this._description}set description(c){this._description=c,this.proxy.$setTitle(this.viewId,this._title,c)}get badge(){return this._badge}set badge(c){this._badge?.value===c?.value&&this._badge?.tooltip===c?.tooltip||(this._badge=g.ViewBadge.from(c),this.proxy.$setBadge(this.viewId,c))}setExpanded(c,b){const t=this.getExtensionElement(c);t&&(b?this._onDidExpandElement.fire(Object.freeze({element:t})):this._onDidCollapseElement.fire(Object.freeze({element:t})))}setSelection(c){(0,w.equals)(this._selectedHandles,c)||(this._selectedHandles=c,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setFocus(c){this._focusedHandle=c}setVisible(c){c!==this._visible&&(this._visible=c,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(c){const b=(await Promise.all(c.map(async t=>{const l=this.getExtensionElement(t.treeItemHandle);return l?{extensionItem:l,treeItem:await this.dataProvider.getTreeItem(l),newState:t.newState?P.TreeItemCheckboxState.Checked:P.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(t=>t!==void 0);b.forEach(t=>{t.treeItem.checkboxState=t.newState?P.TreeItemCheckboxState.Checked:P.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:b.map(t=>[t.extensionItem,t.newState])})}async handleDrag(c,b,t){const l=[];for(const i of c){const n=this.getExtensionElement(i);n&&l.push(n)}if(!(!this.dndController?.handleDrag||l.length===0))return await this.dndController.handleDrag(l,b,t),b}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(c,b,t){const l=b?this.getExtensionElement(b):void 0;if(!(!l&&b||!this.dndController?.handleDrop))return(0,E.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(l,c,t):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(c,b){if(!this.dataProvider.resolveTreeItem)return;const t=this.elements.get(c);if(t){const l=this.nodes.get(t);if(l){const i=await this.dataProvider.resolveTreeItem(l.extensionItem,t,b)??l.extensionItem;return this.validateTreeItem(i),l.item.tooltip=this.getTooltip(i.tooltip),l.item.command=this.getCommand(l.disposableStore,i.command),l.item}}}resolveUnknownParentChain(c){return this.resolveParent(c).then(b=>b?this.resolveUnknownParentChain(b).then(t=>this.resolveTreeNode(b,t[t.length-1]).then(l=>(t.push(l),t))):Promise.resolve([]))}resolveParent(c){const b=this.nodes.get(c);return b?Promise.resolve(b.parent?this.elements.get(b.parent.item.handle):void 0):(0,E.asPromise)(()=>this.dataProvider.getParent(c))}resolveTreeNode(c,b){const t=this.nodes.get(c);return t?Promise.resolve(t):(0,E.asPromise)(()=>this.dataProvider.getTreeItem(c)).then(l=>this.createHandle(c,l,b,!0)).then(l=>this.getChildren(b?b.item.handle:void 0).then(()=>{const i=this.getExtensionElement(l);if(i){const n=this.nodes.get(i);if(n)return Promise.resolve(n)}throw new Error(`Cannot resolve tree item for element ${l}`)}))}getChildrenNodes(c){if(c){let b;if(typeof c=="string"){const t=this.getExtensionElement(c);b=t?this.nodes.get(t):void 0}else b=c;return b&&b.children||void 0}return this.roots}async fetchChildrenNodes(c){this.clearChildren(c);const b=new k.CancellationTokenSource(this._refreshCancellationSource.token);try{const t=c?this.nodes.get(c):void 0,l=await this.dataProvider.getChildren(c);if(b.token.isCancellationRequested)return;const i=await Promise.all((0,w.coalesce)(l||[]).map(async n=>{const o=await this.dataProvider.getTreeItem(n);return o&&!b.token.isCancellationRequested?this.createAndRegisterTreeNode(n,o,t):null}));return b.token.isCancellationRequested?void 0:(0,w.coalesce)(i)}finally{b.dispose()}}refresh(c){if(c.some(t=>!t))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new k.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const t=this.getHandlesToRefresh(c);if(t.length)return this.refreshHandles(t)}return Promise.resolve(void 0)}getHandlesToRefresh(c){const b=new Set,t=c.map(i=>this.nodes.get(i));for(const i of t)if(i&&!b.has(i.item.handle)){let n=i;for(;n&&n.parent&&t.findIndex(o=>n&&n.parent&&o&&o.item.handle===n.parent.item.handle)===-1;){const o=this.elements.get(n.parent.item.handle);n=o?this.nodes.get(o):void 0}n&&!n.parent&&b.add(i.item.handle)}const l=[];return b.forEach(i=>{const n=this.elements.get(i);if(n){const o=this.nodes.get(n);o&&(!o.parent||!b.has(o.parent.item.handle))&&l.push(i)}}),l}refreshHandles(c){const b={};return Promise.all(c.map(t=>this.refreshNode(t).then(l=>{l&&(b[t]=l.item)}))).then(()=>Object.keys(b).length?this.proxy.$refresh(this.viewId,b):void 0)}refreshNode(c){const b=this.getExtensionElement(c);if(b){const t=this.nodes.get(b);if(t)return this.clearChildren(b),(0,E.asPromise)(()=>this.dataProvider.getTreeItem(b)).then(l=>{if(l){const i=this.createTreeNode(b,l,t.parent);return this.updateNodeCache(b,i,t,t.parent),t.dispose(),i}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(c,b,t){const l=this.createTreeNode(c,b,t);if(b.id&&this.elements.has(l.item.handle))throw new Error((0,r.localize)(10,null,b.id));return this.addNodeToCache(c,l),this.addNodeToParentCache(l,t),l}getTooltip(c){return P.MarkdownString.isMarkdownString(c)?g.MarkdownString.from(c):c}getCommand(c,b){return b?{...this.commands.toInternal(b,c),originalId:b.command}:void 0}getCheckbox(c){if(!c.checkboxState)return;let b,t;return typeof c.checkboxState=="number"?b=c.checkboxState:(b=c.checkboxState.state,t=c.checkboxState.tooltip),{isChecked:b===P.TreeItemCheckboxState.Checked,tooltip:t}}validateTreeItem(c){if(!P.TreeItem.isTreeItem(c,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(c,b,t){this.validateTreeItem(b);const l=new A.DisposableStore,i=this.createHandle(c,b,t),n=this.getLightIconPath(b);return{item:{handle:i,parentHandle:t?t.item.handle:void 0,label:u(b.label,this.extension),description:b.description,resourceUri:b.resourceUri,tooltip:this.getTooltip(b.tooltip),command:this.getCommand(l,b.command),contextValue:b.contextValue,icon:n,iconDark:this.getDarkIconPath(b)||n,themeIcon:this.getThemeIcon(b),collapsibleState:(0,O.isUndefinedOrNull)(b.collapsibleState)?P.TreeItemCollapsibleState.None:b.collapsibleState,accessibilityInformation:b.accessibilityInformation,checkbox:this.getCheckbox(b)},extensionItem:b,parent:t,children:void 0,disposableStore:l,dispose(){l.dispose()}}}getThemeIcon(c){return c.iconPath instanceof P.ThemeIcon?c.iconPath:void 0}createHandle(c,{id:b,label:t,resourceUri:l},i,n){if(b)return`${v.ID_HANDLE_PREFIX}/${b}`;const o=u(t,this.extension),f=i?i.item.handle:v.LABEL_HANDLE_PREFIX;let s=o?o.label:l?(0,S.basename)(l):"";s=s.indexOf("/")!==-1?s.replace("/","//"):s;const h=this.nodes.has(c)?this.nodes.get(c).item.handle:void 0,p=this.getChildrenNodes(i)||[];let T,M=0;do{if(T=`${f}/${M}:${s}`,n||!this.elements.has(T)||h===T)break;M++}while(M<=p.length);return T}getLightIconPath(c){if(c.iconPath&&!(c.iconPath instanceof P.ThemeIcon))return typeof c.iconPath=="string"||N.URI.isUri(c.iconPath)?this.getIconPath(c.iconPath):this.getIconPath(c.iconPath.light)}getDarkIconPath(c){if(c.iconPath&&!(c.iconPath instanceof P.ThemeIcon)&&c.iconPath.dark)return this.getIconPath(c.iconPath.dark)}getIconPath(c){return N.URI.isUri(c)?c:N.URI.file(c)}addNodeToCache(c,b){this.elements.set(b.item.handle,c),this.nodes.set(c,b)}updateNodeCache(c,b,t,l){this.elements.delete(b.item.handle),this.nodes.delete(c),b.item.handle!==t.item.handle&&this.elements.delete(t.item.handle),this.addNodeToCache(c,b);const i=this.getChildrenNodes(l)||[],n=i.filter(o=>o.item.handle===t.item.handle)[0];n&&i.splice(i.indexOf(n),1,b)}addNodeToParentCache(c,b){b?(b.children||(b.children=[]),b.children.push(c)):(this.roots||(this.roots=[]),this.roots.push(c))}clearChildren(c){if(c){const b=this.nodes.get(c);if(b){if(b.children)for(const t of b.children){const l=this.elements.get(t.item.handle);l&&this.clear(l)}b.children=void 0}}else this.clearAll()}clear(c){const b=this.nodes.get(c);if(b){if(b.children)for(const t of b.children){const l=this.elements.get(t.item.handle);l&&this.clear(l)}this.nodes.delete(c),this.elements.delete(b.item.handle),b.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(c=>c.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}v.LABEL_HANDLE_PREFIX="0",v.ID_HANDLE_PREFIX="1"}),define(Ce[237],Ie([1,0,20,12,5,29,2,122,247,111,120,35,4,92,190,189,37,191,32,193,194,195,178,196,50,33,198,199,202,204,206,100,181,210,211,212,70,53,215,236,8,6,218,54,99,31,162,201,87,97,102,104,105,14,47,11,27,207,176,62,67,187,216,71,52,221,219,220,188,36,213,217,69,51,88,208,101,209,13,83,180,159,200,7,28,164,98,68]),function(ie,e,r,C,S,N,_,A,E,P,O,w,g,k,m,a,u,d,v,D,c,b,t,l,i,n,o,f,s,h,p,T,M,V,U,y,x,L,R,K,W,$,G,re,ge,oe,Ee,ce,me,ee,be,_e,Fe,Be,Xe,ke,ye,De,ae,ue,Z,J,I,B,H,j,se,le,Y,ve,pe,Ne,xe,Ye,Ge,Te,rt,X,Q,he,Ue,je,Ze,Ke,Ve,it,st,dt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function _t(tt){const ut=tt.get(ye.IExtHostInitDataService),Ot=tt.get(ve.IExtHostFileSystemInfo),Ht=tt.get(H.IExtHostConsumerFileSystem),At=tt.get(n.IExtHostExtensionService),ft=tt.get(oe.IExtHostWorkspace),Ct=tt.get(Ge.IExtHostTelemetry),Lt=tt.get(v.IExtHostConfiguration),xt=tt.get(Xe.IURITransformerService),qe=tt.get(ke.IExtHostRpcService),Ft=tt.get(x.IExtHostStorage),It=tt.get(B.IExtensionStoragePaths),Mt=tt.get(Be.ILoggerService),gt=tt.get(Be.ILogService),Se=tt.get(ue.IExtHostTunnelService),Pe=tt.get(st.IExtHostTelemetryLogService),fe=tt.get(Z.IExtHostApiDeprecationService),q=tt.get(ge.IExtHostWindow),Ae=tt.get(xe.IExtHostSecretState),Le=tt.get(Ye.IExtHostEditorTabs);qe.set(g.ExtHostContext.ExtHostFileSystemInfo,Ot),qe.set(g.ExtHostContext.ExtHostLogLevelServiceShape,Mt),qe.set(g.ExtHostContext.ExtHostWorkspace,ft),qe.set(g.ExtHostContext.ExtHostConfiguration,Lt),qe.set(g.ExtHostContext.ExtHostExtensionService,At),qe.set(g.ExtHostContext.ExtHostStorage,Ft),qe.set(g.ExtHostContext.ExtHostTunnelService,Se),qe.set(g.ExtHostContext.ExtHostWindow,q),qe.set(g.ExtHostContext.ExtHostSecretState,Ae),qe.set(g.ExtHostContext.ExtHostTelemetry,Ct),qe.set(g.ExtHostContext.ExtHostEditorTabs,Le);const nt=qe.set(g.ExtHostContext.ExtHostDecorations,tt.get(ee.IExtHostDecorations)),We=qe.set(g.ExtHostContext.ExtHostDocumentsAndEditors,tt.get(i.IExtHostDocumentsAndEditors)),et=qe.set(g.ExtHostContext.ExtHostCommands,tt.get(u.IExtHostCommands)),lt=qe.set(g.ExtHostContext.ExtHostTerminalService,tt.get(L.IExtHostTerminalService)),mt=qe.set(g.ExtHostContext.ExtHostDebugService,tt.get(_e.IExtHostDebugService)),yt=qe.set(g.ExtHostContext.ExtHostSearch,tt.get(Fe.IExtHostSearch)),Et=qe.set(g.ExtHostContext.ExtHostTask,tt.get(be.IExtHostTask)),wt=qe.set(g.ExtHostContext.ExtHostOutputService,tt.get(T.IExtHostOutputService)),kt=qe.set(g.ExtHostContext.ExtHostLocalization,tt.get(dt.IExtHostLocalizationService)),bt=qe.set(g.ExtHostContext.ExtHostUrls,new G.ExtHostUrls(qe)),Dt=qe.set(g.ExtHostContext.ExtHostDocuments,new l.ExtHostDocuments(qe,We)),ti=qe.set(g.ExtHostContext.ExtHostDocumentContentProviders,new b.ExtHostDocumentContentProvider(qe,We,gt)),Xt=qe.set(g.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(gt,Dt,qe.getProxy(g.MainContext.MainThreadBulkEdits))),vt=qe.set(g.ExtHostContext.ExtHostNotebook,new De.ExtHostNotebookController(qe,et,We,Dt)),ii=qe.set(g.ExtHostContext.ExtHostNotebookDocuments,new je.ExtHostNotebookDocuments(vt)),ni=qe.set(g.ExtHostContext.ExtHostNotebookEditors,new Ue.ExtHostNotebookEditors(gt,vt)),ri=qe.set(g.ExtHostContext.ExtHostNotebookKernels,new Te.ExtHostNotebookKernels(qe,ut,vt,et,gt)),pi=qe.set(g.ExtHostContext.ExtHostNotebookRenderers,new X.ExtHostNotebookRenderers(qe,vt)),Tt=qe.set(g.ExtHostContext.ExtHostEditors,new R.ExtHostEditors(qe,We)),zt=qe.set(g.ExtHostContext.ExtHostTreeViews,new K.ExtHostTreeViews(qe.getProxy(g.MainContext.MainThreadTreeViews),et,gt)),vi=qe.set(g.ExtHostContext.ExtHostEditorInsets,new Ee.ExtHostEditorInsets(qe.getProxy(g.MainContext.MainThreadEditorInsets),Tt,ut.remote)),si=qe.set(g.ExtHostContext.ExtHostDiagnostics,new D.ExtHostDiagnostics(qe,gt,Ot)),Qt=qe.set(g.ExtHostContext.ExtHostLanguages,new h.ExtHostLanguages(qe,Dt,et.converter,xt)),at=qe.set(g.ExtHostContext.ExtHostLanguageFeatures,new s.ExtHostLanguageFeatures(qe,xt,Dt,et,si,gt,fe)),Ei=qe.set(g.ExtHostContext.ExtHostFileSystem,new o.ExtHostFileSystem(qe,at)),$t=qe.set(g.ExtHostContext.ExtHostFileSystemEventService,new f.ExtHostFileSystemEventService(qe,gt,We)),qt=qe.set(g.ExtHostContext.ExtHostQuickOpen,(0,V.createExtHostQuickOpen)(qe,ft,et)),oi=qe.set(g.ExtHostContext.ExtHostSCM,new U.ExtHostSCM(qe,et,gt)),bi=qe.set(g.ExtHostContext.ExtHostComments,(0,d.createExtHostComments)(qe,et,Dt)),ai=qe.set(g.ExtHostContext.ExtHostProgress,new M.ExtHostProgress(qe.getProxy(g.MainContext.MainThreadProgress))),wi=qe.set(g.ExtHostContext.ExtHosLabelService,new ce.ExtHostLabelService(qe)),ci=qe.set(g.ExtHostContext.ExtHostTheming,new ae.ExtHostTheming(qe)),li=qe.set(g.ExtHostContext.ExtHostAuthentication,new J.ExtHostAuthentication(qe)),Mi=qe.set(g.ExtHostContext.ExtHostTimeline,new I.ExtHostTimeline(qe,et)),Yt=qe.set(g.ExtHostContext.ExtHostWebviews,new re.ExtHostWebviews(qe,ut.remote,ft,gt,fe)),Jt=qe.set(g.ExtHostContext.ExtHostWebviewPanels,new le.ExtHostWebviewPanels(qe,Yt,ft)),Si=qe.set(g.ExtHostContext.ExtHostCustomEditors,new se.ExtHostCustomEditors(qe,Dt,It,Yt,Jt)),_i=qe.set(g.ExtHostContext.ExtHostWebviewViews,new j.ExtHostWebviewViews(qe,Yt)),Zt=qe.set(g.ExtHostContext.ExtHostTesting,new pe.ExtHostTesting(qe,et,We)),yi=qe.set(g.ExtHostContext.ExtHostUriOpeners,new Ne.ExtHostUriOpeners(qe));qe.set(g.ExtHostContext.ExtHostInteractive,new Ze.ExtHostInteractive(qe,vt,We,et,gt));const Di=Object.values(g.ExtHostContext);qe.assertRegistered(Di);const Ni=new Y.ExtHostBulkEdits(qe,We),Li=new a.ExtHostClipboard(qe),Ci=new p.ExtHostMessageService(qe,gt),Pi=new c.ExtHostDialogs(qe),Ai=new y.ExtHostStatusBar(qe,et.converter);return m.ExtHostApiCommands.register(et),function(Me,Ut,ui){const pt=function(){let ne=!Me.isUnderDevelopment;function de(){ne||(gt.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ne=!0)}return function Re(ot){if(Array.isArray(ot))ot.forEach(Re);else if(typeof ot=="string")de();else{const St=ot;typeof St.scheme>"u"&&de(),typeof St.exclusive=="boolean"&&(0,Ve.checkProposedApiEnabled)(Me,"documentFiltersExclusive")}return ot}}(),Ui={getSession(ne,de,Re){return li.getSession(Me,ne,de,Re)},async hasSession(ne,de){return(0,Ve.checkProposedApiEnabled)(Me,"authSession"),!!await li.getSession(Me,ne,de,{silent:!0})},get onDidChangeSessions(){return li.onDidChangeSessions},registerAuthenticationProvider(ne,de,Re,ot){return li.registerAuthenticationProvider(ne,de,Re,ot)}},Bi={registerCommand(ne,de,Re){return et.registerCommand(!0,ne,de,Re,void 0,Me)},registerTextEditorCommand(ne,de,Re){return et.registerCommand(!0,ne,(...ot)=>{const St=Tt.getActiveTextEditor();if(!St){gt.warn("Cannot execute "+ne+" because there is no active text editor.");return}return St.edit(Pt=>{de.apply(Re,[St,Pt,...ot])}).then(Pt=>{Pt||gt.warn("Edits from command "+ne+" were not applied.")},Pt=>{gt.warn("An error occurred while running command "+ne,Pt)})},void 0,void 0,Me)},registerDiffInformationCommand:(ne,de,Re)=>((0,Ve.checkProposedApiEnabled)(Me,"diffCommand"),et.registerCommand(!0,ne,async(...ot)=>{const St=We.activeEditor(!0);if(!St){gt.warn("Cannot execute "+ne+" because there is no active text editor.");return}const Pt=await Tt.getDiffInformation(St.id);de.apply(Re,[Pt,...ot])},void 0,void 0,Me)),executeCommand(ne,...de){return et.executeCommand(ne,...de)},getCommands(ne=!1){return et.getCommands(ne)}},ei={get machineId(){return ut.telemetryInfo.machineId},get sessionId(){return ut.telemetryInfo.sessionId},get language(){return ut.environment.appLanguage},get appName(){return ut.environment.appName},get appRoot(){return ut.environment.appRoot?.fsPath??""},get appHost(){return ut.environment.appHost},get uriScheme(){return ut.environment.appUriScheme},get clipboard(){return Li.value},get shell(){return lt.getDefaultShell(!1)},get onDidChangeShell(){return(0,Ve.checkProposedApiEnabled)(Me,"envShellEvent"),lt.onDidChangeShell},get isTelemetryEnabled(){return Ct.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Ct.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)(Me,"telemetry"),Ct.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)(Me,"telemetry"),Ct.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const ne=Date.now()-new Date(ut.telemetryInfo.firstSessionDate).getTime();return isNaN(ne)?!1:ne<1e3*60*60*24},openExternal(ne,de){return q.openUri(ne,{allowTunneling:!!ut.remote.authority,allowContributedOpeners:de?.allowContributedOpeners})},async asExternalUri(ne){if(ne.scheme===ut.environment.appUriScheme)return bt.createAppUri(ne);try{return await q.asExternalUri(ne,{allowTunneling:!!ut.remote.authority})}catch(de){if((0,he.matchesScheme)(ne,Q.Schemas.http)||(0,he.matchesScheme)(ne,Q.Schemas.https))return ne;throw de}},get remoteName(){return(0,me.getRemoteName)(ut.remote.authority)},get remoteAuthority(){return(0,Ve.checkProposedApiEnabled)(Me,"resolvers"),ut.remote.authority},get uiKind(){return ut.uiKind}};ut.environment.extensionTestsLocationURI||Object.freeze(ei);const xi={createTestController(ne,de,Re){return Zt.createTestController(ne,de,Re)},createTestObserver(){return(0,Ve.checkProposedApiEnabled)(Me,"testObserver"),Zt.createTestObserver()},runTests(ne){return(0,Ve.checkProposedApiEnabled)(Me,"testObserver"),Zt.runTests(ne)},get onDidChangeTestResults(){return(0,Ve.checkProposedApiEnabled)(Me,"testObserver"),Zt.onResultsChanged},get testResults(){return(0,Ve.checkProposedApiEnabled)(Me,"testObserver"),Zt.results}},di=ut.remote.isRemote?$.ExtensionKind.Workspace:$.ExtensionKind.UI,zi={getExtension(ne,de){(0,Ve.isProposedApiEnabled)(Me,"extensionsAny")||(de=!1);const Re=Ut.mine.getExtensionDescription(ne);if(Re)return new n.Extension(At,Me.identifier,Re,di,!1);if(de){const ot=Ut.all.getExtensionDescription(ne);if(ot)return new n.Extension(At,Me.identifier,ot,di,!0)}},get all(){const ne=[];for(const de of Ut.mine.getAllExtensionDescriptions())ne.push(new n.Extension(At,Me.identifier,de,di,!1));return ne},get allAcrossExtensionHosts(){(0,Ve.checkProposedApiEnabled)(Me,"extensionsAny");const ne=new Ve.ExtensionIdentifierSet(Ut.mine.getAllExtensionDescriptions().map(Re=>Re.identifier)),de=[];for(const Re of Ut.all.getAllExtensionDescriptions()){const ot=!ne.has(Re.identifier);de.push(new n.Extension(At,Me.identifier,Re,di,ot))}return de},get onDidChange(){return(0,Ve.isProposedApiEnabled)(Me,"extensionsAny")?S.Event.any(Ut.mine.onDidChange,Ut.all.onDidChange):Ut.mine.onDidChange}},$i={createDiagnosticCollection(ne){return si.createDiagnosticCollection(Me.identifier,ne)},get onDidChangeDiagnostics(){return si.onDidChangeDiagnostics},getDiagnostics:ne=>si.getDiagnostics(ne),getLanguages(){return Qt.getLanguages()},setTextDocumentLanguage(ne,de){return Qt.changeLanguage(ne.uri,de)},match(ne,de){const Re=Dt.getDocumentData(de.uri)?.notebook;return(0,O.score)(W.LanguageSelector.from(ne),de.uri,de.languageId,!0,Re?.uri,Re?.notebookType)},registerCodeActionsProvider(ne,de,Re){return at.registerCodeActionProvider(Me,pt(ne),de,Re)},registerDocumentPasteEditProvider(ne,de,Re){return(0,Ve.checkProposedApiEnabled)(Me,"documentPaste"),at.registerDocumentPasteEditProvider(Me,pt(ne),de,Re)},registerCodeLensProvider(ne,de){return at.registerCodeLensProvider(Me,pt(ne),de)},registerDefinitionProvider(ne,de){return at.registerDefinitionProvider(Me,pt(ne),de)},registerDeclarationProvider(ne,de){return at.registerDeclarationProvider(Me,pt(ne),de)},registerImplementationProvider(ne,de){return at.registerImplementationProvider(Me,pt(ne),de)},registerTypeDefinitionProvider(ne,de){return at.registerTypeDefinitionProvider(Me,pt(ne),de)},registerHoverProvider(ne,de){return at.registerHoverProvider(Me,pt(ne),de,Me.identifier)},registerEvaluatableExpressionProvider(ne,de){return at.registerEvaluatableExpressionProvider(Me,pt(ne),de,Me.identifier)},registerInlineValuesProvider(ne,de){return at.registerInlineValuesProvider(Me,pt(ne),de,Me.identifier)},registerDocumentHighlightProvider(ne,de){return at.registerDocumentHighlightProvider(Me,pt(ne),de)},registerLinkedEditingRangeProvider(ne,de){return at.registerLinkedEditingRangeProvider(Me,pt(ne),de)},registerReferenceProvider(ne,de){return at.registerReferenceProvider(Me,pt(ne),de)},registerRenameProvider(ne,de){return at.registerRenameProvider(Me,pt(ne),de)},registerDocumentSymbolProvider(ne,de,Re){return at.registerDocumentSymbolProvider(Me,pt(ne),de,Re)},registerWorkspaceSymbolProvider(ne){return at.registerWorkspaceSymbolProvider(Me,ne)},registerDocumentFormattingEditProvider(ne,de){return at.registerDocumentFormattingEditProvider(Me,pt(ne),de)},registerDocumentRangeFormattingEditProvider(ne,de){return at.registerDocumentRangeFormattingEditProvider(Me,pt(ne),de)},registerOnTypeFormattingEditProvider(ne,de,Re,...ot){return at.registerOnTypeFormattingEditProvider(Me,pt(ne),de,[Re].concat(ot))},registerDocumentSemanticTokensProvider(ne,de,Re){return at.registerDocumentSemanticTokensProvider(Me,pt(ne),de,Re)},registerDocumentRangeSemanticTokensProvider(ne,de,Re){return at.registerDocumentRangeSemanticTokensProvider(Me,pt(ne),de,Re)},registerSignatureHelpProvider(ne,de,Re,...ot){return typeof Re=="object"?at.registerSignatureHelpProvider(Me,pt(ne),de,Re):at.registerSignatureHelpProvider(Me,pt(ne),de,typeof Re>"u"?[]:[Re,...ot])},registerCompletionItemProvider(ne,de,...Re){return at.registerCompletionItemProvider(Me,pt(ne),de,Re)},registerInlineCompletionItemProvider(ne,de){return de.handleDidShowCompletionItem&&(0,Ve.checkProposedApiEnabled)(Me,"inlineCompletionsAdditions"),at.registerInlineCompletionsProvider(Me,pt(ne),de)},registerInlineCompletionItemProviderNew(ne,de){if((0,Ve.checkProposedApiEnabled)(Me,"inlineCompletionsNew"),de.handleDidShowCompletionItem&&!(0,Ve.isProposedApiEnabled)(Me,"inlineCompletionsAdditions"))throw new Error(`When the method "handleDidShowCompletionItem" is implemented on a provider, the usage of the proposed api 'inlineCompletionsAdditions' must be declared!`);return at.registerInlineCompletionsProviderNew(Me,pt(ne),de)},registerDocumentLinkProvider(ne,de){return at.registerDocumentLinkProvider(Me,pt(ne),de)},registerColorProvider(ne,de){return at.registerColorProvider(Me,pt(ne),de)},registerFoldingRangeProvider(ne,de){return at.registerFoldingRangeProvider(Me,pt(ne),de)},registerSelectionRangeProvider(ne,de){return at.registerSelectionRangeProvider(Me,ne,de)},registerCallHierarchyProvider(ne,de){return at.registerCallHierarchyProvider(Me,ne,de)},registerTypeHierarchyProvider(ne,de){return at.registerTypeHierarchyProvider(Me,ne,de)},setLanguageConfiguration:(ne,de)=>at.setLanguageConfiguration(Me,ne,de),getTokenInformationAtPosition(ne,de){return(0,Ve.checkProposedApiEnabled)(Me,"tokenInformation"),Qt.tokenAtPosition(ne,de)},registerInlayHintsProvider(ne,de){return at.registerInlayHintsProvider(Me,ne,de)},createLanguageStatusItem(ne,de){return Qt.createLanguageStatusItem(Me,ne,de)},registerDocumentDropEditProvider(ne,de){return at.registerDocumentOnDropEditProvider(Me,ne,de)}},Ii={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return lt.activeTerminal},get terminals(){return lt.terminals},async showTextDocument(ne,de,Re){const ot=await(_.URI.isUri(ne)?Promise.resolve(Ri.openTextDocument(ne)):Promise.resolve(ne));return Tt.showTextDocument(ot,de,Re)},createTextEditorDecorationType(ne){return Tt.createTextEditorDecorationType(Me,ne)},onDidChangeActiveTextEditor(ne,de,Re){return Tt.onDidChangeActiveTextEditor(ne,de,Re)},onDidChangeVisibleTextEditors(ne,de,Re){return Tt.onDidChangeVisibleTextEditors(ne,de,Re)},onDidChangeTextEditorSelection(ne,de,Re){return Tt.onDidChangeTextEditorSelection(ne,de,Re)},onDidChangeTextEditorOptions(ne,de,Re){return Tt.onDidChangeTextEditorOptions(ne,de,Re)},onDidChangeTextEditorVisibleRanges(ne,de,Re){return Tt.onDidChangeTextEditorVisibleRanges(ne,de,Re)},onDidChangeTextEditorViewColumn(ne,de,Re){return Tt.onDidChangeTextEditorViewColumn(ne,de,Re)},onDidCloseTerminal(ne,de,Re){return lt.onDidCloseTerminal(ne,de,Re)},onDidOpenTerminal(ne,de,Re){return lt.onDidOpenTerminal(ne,de,Re)},onDidChangeActiveTerminal(ne,de,Re){return lt.onDidChangeActiveTerminal(ne,de,Re)},onDidChangeTerminalDimensions(ne,de,Re){return(0,Ve.checkProposedApiEnabled)(Me,"terminalDimensions"),lt.onDidChangeTerminalDimensions(ne,de,Re)},onDidChangeTerminalState(ne,de,Re){return lt.onDidChangeTerminalState(ne,de,Re)},onDidWriteTerminalData(ne,de,Re){return(0,Ve.checkProposedApiEnabled)(Me,"terminalDataWriteEvent"),lt.onDidWriteTerminalData(ne,de,Re)},get state(){return q.state},onDidChangeWindowState(ne,de,Re){return q.onDidChangeWindowState(ne,de,Re)},showInformationMessage(ne,...de){return Ci.showMessage(Me,N.default.Info,ne,de[0],de.slice(1))},showWarningMessage(ne,...de){return Ci.showMessage(Me,N.default.Warning,ne,de[0],de.slice(1))},showErrorMessage(ne,...de){return Ci.showMessage(Me,N.default.Error,ne,de[0],de.slice(1))},showQuickPick(ne,de,Re){return qt.showQuickPick(ne,de,Re)},showWorkspaceFolderPick(ne){return qt.showWorkspaceFolderPick(ne)},showInputBox(ne,de){return qt.showInput(ne,de)},showOpenDialog(ne){return Pi.showOpenDialog(ne)},showSaveDialog(ne){return Pi.showSaveDialog(ne)},createStatusBarItem(ne,de,Re){let ot,St,Pt;return typeof ne=="string"?(ot=ne,St=de,Pt=Re):(St=ne,Pt=de),Ai.createStatusBarEntry(Me,ot,St,Pt)},setStatusBarMessage(ne,de){return Ai.setStatusBarMessage(ne,de)},withScmProgress(ne){return fe.report("window.withScmProgress",Me,"Use 'withProgress' instead."),ai.withProgress(Me,{location:$.ProgressLocation.SourceControl},(de,Re)=>ne({report(ot){}}))},withProgress(ne,de){return ai.withProgress(Me,ne,de)},createOutputChannel(ne,de){return wt.createOutputChannel(ne,de,Me)},createWebviewPanel(ne,de,Re,ot){return Jt.createWebviewPanel(Me,ne,de,Re,ot)},createWebviewTextEditorInset(ne,de,Re,ot){return(0,Ve.checkProposedApiEnabled)(Me,"editorInsets"),vi.createWebviewEditorInset(ne,de,Re,ot,Me)},createTerminal(ne,de,Re){return typeof ne=="object"?"pty"in ne?lt.createExtensionTerminal(ne):lt.createTerminalFromOptions(ne):lt.createTerminal(ne,de,Re)},registerTerminalLinkProvider(ne){return lt.registerLinkProvider(ne)},registerTerminalProfileProvider(ne,de){return lt.registerProfileProvider(Me,ne,de)},registerTreeDataProvider(ne,de){return zt.registerTreeDataProvider(ne,de,Me)},createTreeView(ne,de){return zt.createTreeView(ne,de,Me)},registerWebviewPanelSerializer:(ne,de)=>Jt.registerWebviewPanelSerializer(Me,ne,de),registerCustomEditorProvider:(ne,de,Re={})=>Si.registerCustomEditorProvider(Me,ne,de,Re),registerFileDecorationProvider(ne){return nt.registerFileDecorationProvider(ne,Me.identifier)},registerUriHandler(ne){return bt.registerUriHandler(Me.identifier,ne)},createQuickPick(){return qt.createQuickPick(Me)},createInputBox(){return qt.createInputBox(Me)},get activeColorTheme(){return ci.activeColorTheme},onDidChangeActiveColorTheme(ne,de,Re){return ci.onDidChangeActiveColorTheme(ne,de,Re)},registerWebviewViewProvider(ne,de,Re){return _i.registerWebviewViewProvider(Me,ne,de,Re?.webviewOptions)},get activeNotebookEditor(){return vt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ne,de,Re){return vt.onDidChangeActiveNotebookEditor(ne,de,Re)},get visibleNotebookEditors(){return vt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return vt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ne,de,Re){return ni.onDidChangeNotebookEditorSelection(ne,de,Re)},onDidChangeNotebookEditorVisibleRanges(ne,de,Re){return ni.onDidChangeNotebookEditorVisibleRanges(ne,de,Re)},showNotebookDocument(ne,de){return _.URI.isUri(ne)&&fe.report("window.showNotebookDocument(uri)",Me,"Please use 'workspace.openNotebookDocument' and 'window.showNotebookDocument'"),vt.showNotebookDocument(ne,de)},registerExternalUriOpener(ne,de,Re){return(0,Ve.checkProposedApiEnabled)(Me,"externalUriOpener"),yi.registerExternalUriOpener(Me.identifier,ne,de,Re)},get tabGroups(){return Le.tabGroups},logTelemetryToOutputChannel(ne,de){(0,Ve.checkProposedApiEnabled)(Me,"telemetryLog"),Pe.logToTelemetryOutputChannel(Me,ne,de)}},Ri={get rootPath(){return fe.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(ne){throw C.readonly()},getWorkspaceFolder(ne){return ft.getWorkspaceFolder(ne)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(ne){throw C.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(ne){throw C.readonly()},updateWorkspaceFolders:(ne,de,...Re)=>ft.updateWorkspaceFolders(Me,ne,de||0,...Re),onDidChangeWorkspaceFolders:function(ne,de,Re){return ft.onDidChangeWorkspace(ne,de,Re)},asRelativePath:(ne,de)=>ft.getRelativePath(ne,de),findFiles:(ne,de,Re,ot)=>ft.findFiles(ne,de,Re,Me.identifier,ot),findTextInFiles:(ne,de,Re,ot)=>{(0,Ve.checkProposedApiEnabled)(Me,"findTextInFiles");let St,Pt;return typeof de=="object"?(St=de,Pt=Re):(St={},Pt=de,ot=Re),ft.findTextInFiles(ne,St||{},Pt,Me.identifier,ot)},saveAll:ne=>ft.saveAll(ne),applyEdit(ne,de){return Ni.applyWorkspaceEdit(ne,Me,de)},createFileSystemWatcher:(ne,de,Re,ot)=>$t.createFileSystemWatcher(ft,Me,ne,de,Re,ot),get textDocuments(){return Dt.getAllDocumentData().map(ne=>ne.document)},set textDocuments(ne){throw C.readonly()},openTextDocument(ne){let de;const Re=ne;if(typeof ne=="string")de=Promise.resolve(_.URI.file(ne));else if(_.URI.isUri(ne))de=Promise.resolve(ne);else if(!Re||typeof Re=="object")de=Dt.createDocumentData(Re);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(ot=>Dt.ensureDocumentData(ot).then(St=>St.document))},onDidOpenTextDocument:(ne,de,Re)=>Dt.onDidAddDocument(ne,de,Re),onDidCloseTextDocument:(ne,de,Re)=>Dt.onDidRemoveDocument(ne,de,Re),onDidChangeTextDocument:(ne,de,Re)=>Dt.onDidChangeDocument(ne,de,Re),onDidSaveTextDocument:(ne,de,Re)=>Dt.onDidSaveDocument(ne,de,Re),onWillSaveTextDocument:(ne,de,Re)=>Xt.getOnWillSaveTextDocumentEvent(Me)(ne,de,Re),get notebookDocuments(){return vt.notebookDocuments.map(ne=>ne.apiNotebook)},async openNotebookDocument(ne,de){let Re;if(_.URI.isUri(ne))Re=ne,await vt.openNotebookDocument(ne);else if(typeof ne=="string")Re=_.URI.revive(await vt.createNotebookDocument({viewType:ne,content:de}));else throw new Error("Invalid arguments");return vt.getNotebookDocument(Re).apiNotebook},onDidSaveNotebookDocument(ne,de,Re){return ii.onDidSaveNotebookDocument(ne,de,Re)},onDidChangeNotebookDocument(ne,de,Re){return ii.onDidChangeNotebookDocument(ne,de,Re)},get onDidOpenNotebookDocument(){return vt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return vt.onDidCloseNotebookDocument},registerNotebookSerializer(ne,de,Re,ot){return vt.registerNotebookSerializer(Me,ne,de,Re,(0,Ve.isProposedApiEnabled)(Me,"notebookLiveShare")?ot:void 0)},registerNotebookContentProvider:(ne,de,Re,ot)=>((0,Ve.checkProposedApiEnabled)(Me,"notebookContentProvider"),fe.report("workspace.registerNotebookContentProvider",Me,"The notebookContentProvider API is not on track for finalization and will be removed."),vt.registerNotebookContentProvider(Me,ne,de,Re,(0,Ve.isProposedApiEnabled)(Me,"notebookLiveShare")?ot:void 0)),onDidChangeConfiguration:(ne,de,Re)=>ui.onDidChangeConfiguration(ne,de,Re),getConfiguration(ne,de){return de=arguments.length===1?void 0:de,ui.getConfiguration(ne,de,Me)},registerTextDocumentContentProvider(ne,de){return ti.registerTextDocumentContentProvider(ne,de)},registerTaskProvider:(ne,de)=>(fe.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(Me,ne,de)),registerFileSystemProvider(ne,de,Re){return(0,Ke.combinedDisposable)(Ei.registerFileSystemProvider(Me,ne,de,Re),Ht.addFileSystemProvider(ne,de))},get fs(){return Ht.value},registerFileSearchProvider:(ne,de)=>((0,Ve.checkProposedApiEnabled)(Me,"fileSearchProvider"),yt.registerFileSearchProvider(ne,de)),registerTextSearchProvider:(ne,de)=>((0,Ve.checkProposedApiEnabled)(Me,"textSearchProvider"),yt.registerTextSearchProvider(ne,de)),registerRemoteAuthorityResolver:(ne,de)=>((0,Ve.checkProposedApiEnabled)(Me,"resolvers"),At.registerRemoteAuthorityResolver(ne,de)),registerResourceLabelFormatter:ne=>((0,Ve.checkProposedApiEnabled)(Me,"resolvers"),wi.$registerResourceLabelFormatter(ne)),onDidCreateFiles:(ne,de,Re)=>$t.onDidCreateFile(ne,de,Re),onDidDeleteFiles:(ne,de,Re)=>$t.onDidDeleteFile(ne,de,Re),onDidRenameFiles:(ne,de,Re)=>$t.onDidRenameFile(ne,de,Re),onWillCreateFiles:(ne,de,Re)=>$t.getOnWillCreateFileEvent(Me)(ne,de,Re),onWillDeleteFiles:(ne,de,Re)=>$t.getOnWillDeleteFileEvent(Me)(ne,de,Re),onWillRenameFiles:(ne,de,Re)=>$t.getOnWillRenameFileEvent(Me)(ne,de,Re),openTunnel:ne=>((0,Ve.checkProposedApiEnabled)(Me,"resolvers"),Se.openTunnel(Me,ne).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,Ve.checkProposedApiEnabled)(Me,"resolvers"),Se.getTunnels()},onDidChangeTunnels:(ne,de,Re)=>((0,Ve.checkProposedApiEnabled)(Me,"resolvers"),Se.onDidChangeTunnels(ne,de,Re)),registerPortAttributesProvider:(ne,de)=>((0,Ve.checkProposedApiEnabled)(Me,"portsAttributes"),Se.registerPortsAttributesProvider(ne,de)),registerTimelineProvider:(ne,de)=>((0,Ve.checkProposedApiEnabled)(Me,"timeline"),Mi.registerTimelineProvider(ne,de,Me.identifier,et.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:ne=>((0,Ve.checkProposedApiEnabled)(Me,"workspaceTrust"),ft.requestWorkspaceTrust(ne)),onDidGrantWorkspaceTrust:(ne,de,Re)=>ft.onDidGrantWorkspaceTrust(ne,de,Re),registerEditSessionIdentityProvider:(ne,de)=>((0,Ve.checkProposedApiEnabled)(Me,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(ne,de))},Vt={get inputBox(){return fe.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),oi.getLastInputBox(Me)},createSourceControl(ne,de,Re){return oi.createSourceControl(Me,ne,de,Re)}},hi={createCommentController(ne,de){return bi.createCommentController(Me,ne,de)}},Wi={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},onDidStartDebugSession(ne,de,Re){return mt.onDidStartDebugSession(ne,de,Re)},onDidTerminateDebugSession(ne,de,Re){return mt.onDidTerminateDebugSession(ne,de,Re)},onDidChangeActiveDebugSession(ne,de,Re){return mt.onDidChangeActiveDebugSession(ne,de,Re)},onDidReceiveDebugSessionCustomEvent(ne,de,Re){return mt.onDidReceiveDebugSessionCustomEvent(ne,de,Re)},onDidChangeBreakpoints(ne,de,Re){return mt.onDidChangeBreakpoints(ne,de,Re)},registerDebugConfigurationProvider(ne,de,Re){return mt.registerDebugConfigurationProvider(ne,de,Re||it.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ne,de){return mt.registerDebugAdapterDescriptorFactory(Me,ne,de)},registerDebugAdapterTrackerFactory(ne,de){return mt.registerDebugAdapterTrackerFactory(ne,de)},startDebugging(ne,de,Re){return!Re||typeof Re=="object"&&"configuration"in Re?mt.startDebugging(ne,de,{parentSession:Re}):mt.startDebugging(ne,de,Re||{})},stopDebugging(ne){return mt.stopDebugging(ne)},addBreakpoints(ne){return mt.addBreakpoints(ne)},removeBreakpoints(ne){return mt.removeBreakpoints(ne)},asDebugSourceUri(ne,de){return mt.asDebugSourceUri(ne,de)}},Nt={registerTaskProvider:(ne,de)=>Et.registerTaskProvider(Me,ne,de),fetchTasks:ne=>Et.fetchTasks(ne),executeTask:ne=>Et.executeTask(Me,ne),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(ne,de,Re)=>Et.onDidStartTask(ne,de,Re),onDidEndTask:(ne,de,Re)=>Et.onDidEndTask(ne,de,Re),onDidStartTaskProcess:(ne,de,Re)=>Et.onDidStartTaskProcess(ne,de,Re),onDidEndTaskProcess:(ne,de,Re)=>Et.onDidEndTaskProcess(ne,de,Re)},fi={createNotebookController(ne,de,Re,ot,St){return ri.createNotebookController(Me,ne,de,Re,ot,(0,Ve.isProposedApiEnabled)(Me,"notebookMessaging")?St:void 0)},registerNotebookCellStatusBarItemProvider:(ne,de)=>vt.registerNotebookCellStatusBarItemProvider(Me,ne,de),createRendererMessaging(ne){return pi.createRendererMessaging(Me,ne)},onDidChangeNotebookCellExecutionState(ne,de,Re){return(0,Ve.checkProposedApiEnabled)(Me,"notebookCellExecutionState"),ri.onDidChangeNotebookCellExecutionState(ne,de,Re)}},Hi={t(...ne){if((0,Ve.checkProposedApiEnabled)(Me,"localization"),typeof ne[0]=="string"){const de=ne.shift(),Re=!ne||typeof ne[0]!="object"?ne:ne[0];return kt.getMessage(Me.identifier.value,{message:de,args:Re})}return kt.getMessage(Me.identifier.value,ne[0])},get bundle(){return(0,Ve.checkProposedApiEnabled)(Me,"localization"),kt.getBundle(Me.identifier.value)},get uri(){return(0,Ve.checkProposedApiEnabled)(Me,"localization"),kt.getBundleUri(Me.identifier.value)}};return{version:ut.version,authentication:Ui,commands:Bi,comments:hi,debug:Wi,env:ei,extensions:zi,l10n:Hi,languages:$i,notebooks:fi,scm:Vt,tasks:Nt,tests:xi,window:Ii,workspace:Ri,Breakpoint:$.Breakpoint,CallHierarchyIncomingCall:$.CallHierarchyIncomingCall,CallHierarchyItem:$.CallHierarchyItem,CallHierarchyOutgoingCall:$.CallHierarchyOutgoingCall,CancellationError:C.CancellationError,CancellationTokenSource:r.CancellationTokenSource,CandidatePortSource:g.CandidatePortSource,CodeAction:$.CodeAction,CodeActionKind:$.CodeActionKind,CodeActionTriggerKind:$.CodeActionTriggerKind,CodeLens:$.CodeLens,Color:$.Color,ColorInformation:$.ColorInformation,ColorPresentation:$.ColorPresentation,ColorThemeKind:$.ColorThemeKind,CommentMode:$.CommentMode,CommentThreadCollapsibleState:$.CommentThreadCollapsibleState,CommentThreadState:$.CommentThreadState,CompletionItem:$.CompletionItem,CompletionItemKind:$.CompletionItemKind,CompletionItemTag:$.CompletionItemTag,CompletionList:$.CompletionList,CompletionTriggerKind:$.CompletionTriggerKind,ConfigurationTarget:$.ConfigurationTarget,CustomExecution:$.CustomExecution,DebugAdapterExecutable:$.DebugAdapterExecutable,DebugAdapterInlineImplementation:$.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:$.DebugAdapterNamedPipeServer,DebugAdapterServer:$.DebugAdapterServer,DebugConfigurationProviderTriggerKind:it.DebugConfigurationProviderTriggerKind,DebugConsoleMode:$.DebugConsoleMode,DecorationRangeBehavior:$.DecorationRangeBehavior,Diagnostic:$.Diagnostic,DiagnosticRelatedInformation:$.DiagnosticRelatedInformation,DiagnosticSeverity:$.DiagnosticSeverity,DiagnosticTag:$.DiagnosticTag,Disposable:$.Disposable,DocumentHighlight:$.DocumentHighlight,DocumentHighlightKind:$.DocumentHighlightKind,DocumentLink:$.DocumentLink,DocumentSymbol:$.DocumentSymbol,EndOfLine:$.EndOfLine,EnvironmentVariableMutatorType:$.EnvironmentVariableMutatorType,EvaluatableExpression:$.EvaluatableExpression,InlineValueText:$.InlineValueText,InlineValueVariableLookup:$.InlineValueVariableLookup,InlineValueEvaluatableExpression:$.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:$.InlineCompletionTriggerKind,InlineCompletionTriggerKindNew:$.InlineCompletionTriggerKindNew,EventEmitter:S.Emitter,ExtensionKind:$.ExtensionKind,ExtensionMode:$.ExtensionMode,ExternalUriOpenerPriority:$.ExternalUriOpenerPriority,FileChangeType:$.FileChangeType,FileDecoration:$.FileDecoration,FileSystemError:$.FileSystemError,FileType:w.FileType,FilePermission:w.FilePermission,FoldingRange:$.FoldingRange,FoldingRangeKind:$.FoldingRangeKind,FunctionBreakpoint:$.FunctionBreakpoint,InlineCompletionItem:$.InlineSuggestion,InlineCompletionItemNew:$.InlineSuggestionNew,InlineCompletionList:$.InlineSuggestionList,InlineCompletionListNew:$.InlineSuggestionsNew,Hover:$.Hover,IndentAction:P.IndentAction,Location:$.Location,MarkdownString:$.MarkdownString,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:$.ParameterInformation,PortAutoForwardAction:$.PortAutoForwardAction,Position:$.Position,ProcessExecution:$.ProcessExecution,ProgressLocation:$.ProgressLocation,QuickInputButtons:$.QuickInputButtons,Range:$.Range,RelativePattern:$.RelativePattern,Selection:$.Selection,SelectionRange:$.SelectionRange,SemanticTokens:$.SemanticTokens,SemanticTokensBuilder:$.SemanticTokensBuilder,SemanticTokensEdit:$.SemanticTokensEdit,SemanticTokensEdits:$.SemanticTokensEdits,SemanticTokensLegend:$.SemanticTokensLegend,ShellExecution:$.ShellExecution,ShellQuoting:$.ShellQuoting,SignatureHelp:$.SignatureHelp,SignatureHelpTriggerKind:$.SignatureHelpTriggerKind,SignatureInformation:$.SignatureInformation,SnippetString:$.SnippetString,SourceBreakpoint:$.SourceBreakpoint,StandardTokenType:$.StandardTokenType,StatusBarAlignment:$.StatusBarAlignment,SymbolInformation:$.SymbolInformation,SymbolKind:$.SymbolKind,SymbolTag:$.SymbolTag,Task:$.Task,TaskGroup:$.TaskGroup,TaskPanelKind:$.TaskPanelKind,TaskRevealKind:$.TaskRevealKind,TaskScope:$.TaskScope,TerminalLink:$.TerminalLink,TerminalLocation:$.TerminalLocation,TerminalProfile:$.TerminalProfile,TextDocumentSaveReason:$.TextDocumentSaveReason,TextEdit:$.TextEdit,SnippetTextEdit:$.SnippetTextEdit,TextEditorCursorStyle:A.TextEditorCursorStyle,TextEditorLineNumbersStyle:$.TextEditorLineNumbersStyle,TextEditorRevealType:$.TextEditorRevealType,TextEditorSelectionChangeKind:$.TextEditorSelectionChangeKind,TextDocumentChangeReason:$.TextDocumentChangeReason,ThemeColor:$.ThemeColor,ThemeIcon:$.ThemeIcon,TreeItem:$.TreeItem,TreeItem2:$.TreeItem,TreeItemCheckboxState:$.TreeItemCheckboxState,TreeItemCollapsibleState:$.TreeItemCollapsibleState,TypeHierarchyItem:$.TypeHierarchyItem,UIKind:k.UIKind,Uri:_.URI,ViewColumn:$.ViewColumn,WorkspaceEdit:$.WorkspaceEdit,DocumentDropEdit:$.DocumentDropEdit,DocumentPasteEdit:$.DocumentPasteEdit,InlayHint:$.InlayHint,InlayHintLabelPart:$.InlayHintLabelPart,InlayHintKind:$.InlayHintKind,RemoteAuthorityResolverError:$.RemoteAuthorityResolverError,ResolvedAuthority:$.ResolvedAuthority,SourceControlInputBoxValidationType:$.SourceControlInputBoxValidationType,ExtensionRuntime:$.ExtensionRuntime,TimelineItem:$.TimelineItem,NotebookRange:$.NotebookRange,NotebookCellKind:$.NotebookCellKind,NotebookCellExecutionState:$.NotebookCellExecutionState,NotebookCellData:$.NotebookCellData,NotebookData:$.NotebookData,NotebookRendererScript:$.NotebookRendererScript,NotebookCellStatusBarAlignment:$.NotebookCellStatusBarAlignment,NotebookEditorRevealType:$.NotebookEditorRevealType,NotebookCellOutput:$.NotebookCellOutput,NotebookCellOutputItem:$.NotebookCellOutputItem,NotebookCellStatusBarItem:$.NotebookCellStatusBarItem,NotebookControllerAffinity:$.NotebookControllerAffinity,NotebookControllerAffinity2:$.NotebookControllerAffinity2,NotebookEdit:$.NotebookEdit,PortAttributes:$.PortAttributes,LinkedEditingRanges:$.LinkedEditingRanges,TestResultState:$.TestResultState,TestRunRequest:$.TestRunRequest,TestMessage:$.TestMessage,TestTag:$.TestTag,TestRunProfileKind:$.TestRunProfileKind,TextSearchCompleteMessageType:rt.TextSearchCompleteMessageType,DataTransfer:$.DataTransfer,DataTransferItem:$.DataTransferItem,CoveredCount:$.CoveredCount,FileCoverage:$.FileCoverage,StatementCoverage:$.StatementCoverage,BranchCoverage:$.BranchCoverage,FunctionCoverage:$.FunctionCoverage,WorkspaceTrustState:$.WorkspaceTrustState,LanguageStatusSeverity:$.LanguageStatusSeverity,QuickPickItemKind:$.QuickPickItemKind,InputBoxValidationSeverity:$.InputBoxValidationSeverity,TabInputText:$.TextTabInput,TabInputTextDiff:$.TextDiffTabInput,TabInputTextMerge:$.TextMergeTabInput,TabInputCustom:$.CustomEditorTabInput,TabInputNotebook:$.NotebookEditorTabInput,TabInputNotebookDiff:$.NotebookDiffEditorTabInput,TabInputWebview:$.WebviewEditorTabInput,TabInputTerminal:$.TerminalEditorTabInput,TabInputInteractiveWindow:$.InteractiveWindowInput,TerminalExitReason:$.TerminalExitReason}}}e.createApiFactoryAndRegisterActors=_t}),define(Ce[238],Ie([1,0,237,33,2,231,6,15,222]),function(ie,e,r,C,S,N,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class P extends N.RequireInterceptor{_installInterceptor(){}getModule(k,m){for(const a of this._alternatives){const u=a(k);if(u){k=u;break}}if(this._factories.has(k))return this._factories.get(k).load(k,m,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class O extends C.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=_.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(E.ExtHostConsoleForwarder);const k=this._instaService.invokeFunction(r.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(P,k,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(k){return k.browser}async _loadCommonJSModule(k,m,a){m=m.with({path:w(m.path,".js")});const u=k?.identifier.value;u&&performance.mark(`code/extHost/willFetchExtensionCode/${u}`);const d=S.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(m)),v=await fetch(d.toString(!0));if(u&&performance.mark(`code/extHost/didFetchExtensionCode/${u}`),v.status!==200)throw new Error(v.statusText);const D=await v.text(),c=`${m.toString(!0)}#vscode-extension`,b=`${D}
//# sourceURL=${c}`;let t;try{t=new Function("module","exports","require",b)}catch(o){throw console.error(u?`Loading code for extension ${u} failed: ${o.message}`:`Loading code failed: ${o.message}`),console.error(`${m.toString(!0)}${typeof o.line=="number"?` line ${o.line}`:""}${typeof o.column=="number"?` column ${o.column}`:""}`),console.error(o),o}k&&await this._extHostLocalizationService.initializeLocalizedMessages(k);const l={},i={exports:l},n=o=>{const f=this._fakeModules.getModule(o,m);if(f===void 0)throw new Error(`Cannot load module '${o}'`);return f};try{return a.codeLoadingStart(),u&&performance.mark(`code/extHost/willLoadExtensionCode/${u}`),t(i,l,n),i.exports!==l?i.exports:l}finally{u&&performance.mark(`code/extHost/didLoadExtensionCode/${u}`),a.codeLoadingStop()}}async $setRemoteEnvironment(k){}async _waitForDebuggerAttachment(k=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const m=Date.now()+k;for(;Date.now()<m&&!("__jsDebugIsReady"in globalThis);)await(0,A.timeout)(10)}}e.ExtHostExtensionService=O;function w(g,k){return g.endsWith(k)?g:g+k}}),define(Ce[239],Ie([1,0,56,33,71,238]),function(ie,e,r,C,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.registerSingleton)(C.IExtHostExtensionService,N.ExtHostExtensionService,!1),(0,r.registerSingleton)(S.IExtensionStoragePaths,S.ExtensionStoragePaths,!1)}),define(Ce[248],Ie([1,0,23,5,92,232,224,19,72,13,2,234,239]),function(ie,e,r,C,S,N,_,A,E,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const w=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const g=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function k(t){return/^(file|vscode-remote):/i.test(t)}const m=fetch.bind(self);function a(t){self.fetch=async function(l,i){return l instanceof Request||k(String(l))&&(l=(await t(O.URI.parse(String(l)))).toString(!0)),m(l,i)},self.XMLHttpRequest=class extends XMLHttpRequest{open(l,i,n,o,f){(async()=>(k(i.toString())&&(i=(await t(O.URI.parse(i.toString()))).toString(!0)),super.open(l,i,n??!0,o,f)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(l,i){if(/^file:/i.test(l.toString()))l=P.FileAccess.asBrowserUri(O.URI.parse(l.toString())).toString(!0);else if(/^vscode-remote:/i.test(l.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const o=`(${function(p){function T(U){return typeof U=="string"||U instanceof URL?String(U).replace(/^file:\/\//i,"vscode-file://vscode-app"):U}const M=fetch.bind(self);self.fetch=function(U,y){return U instanceof Request?M(U,y):M(T(U),y)},self.XMLHttpRequest=class extends XMLHttpRequest{open(U,y,x,L,R){return super.open(U,T(y),x??!0,L,R)}};const V=importScripts.bind(self);self.importScripts=(...U)=>{V(...U.map(T))},V(p)}.toString()}('${l}'))`;i=i||{},i.name=i.name||A.basename(l.toString());const f=new Blob([o],{type:"application/javascript"}),s=URL.createObjectURL(f);return new t(s,i)}}else self.Worker=class extends _.NestedWorker{constructor(t,l){super(g,t,{name:A.basename(t.toString()),...l})}};const u=new class{constructor(){this.pid=void 0}exit(t){w()}async exists(t){return!0}async realpath(t){return t}};class d{constructor(){const l=new MessageChannel,i=new C.Emitter;let n=!1;g(l.port2,[l.port2]),l.port1.onmessage=o=>{const{data:f}=o;if(!(f instanceof ArrayBuffer)){console.warn("UNKNOWN data received",f);return}const s=r.VSBuffer.wrap(new Uint8Array(f,0,f.byteLength));if((0,S.isMessageOfType)(s,2)){n=!0,D("received terminate message from renderer");return}i.fire(s)},this.protocol={onMessage:i.event,send:o=>{if(!n){const f=o.buffer.buffer.slice(o.buffer.byteOffset,o.buffer.byteOffset+o.buffer.byteLength);l.port1.postMessage(f,[f])}}}}}function v(t){return new Promise(l=>{const i=t.onMessage(n=>{i.dispose();const o=JSON.parse(n.toString());t.send((0,S.createMessageOfType)(0)),l({protocol:t,initData:o})});t.send((0,S.createMessageOfType)(1))})}let D=t=>w();function c(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function b(){E.mark("code/extHost/willConnectToRenderer");const t=new d;return{onmessage(l){!c(l)||v(t.protocol).then(i=>{E.mark("code/extHost/didWaitForInitData");const n=new N.ExtensionHostMain(i.protocol,i.initData,u,null,l.data);a(o=>n.asBrowserUri(o)),D=o=>n.terminate(o)})}}}e.create=b})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/fad3a77833b9249158dfd88477114a06435e46a2/core/vs/workbench/api/worker/extensionHostWorker.js.map
